/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var te=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/base/common/async","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/path","vs/platform/environment/common/environment","vs/nls","vs/nls!vs/code/electron-browser/sharedProcess/sharedProcessMain","vs/platform/files/common/files","vs/base/common/network","vs/base/common/arrays","vs/base/common/types","vs/base/common/resources","vs/base/common/buffer","vs/base/node/pfs","vs/platform/configuration/common/configuration","vs/platform/telemetry/common/telemetry","vs/platform/storage/common/storage","vs/platform/userDataSync/common/userDataSync","vs/base/common/strings","vs/platform/product/common/productService","vs/base/common/cancellation","vs/base/common/objects","vs/base/common/uuid","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/process","vs/base/common/json","os","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/errorMessage","vs/platform/configuration/common/configurationRegistry","vs/base/common/jsonEdit","vs/base/common/map","vs/base/common/extpath","vs/platform/request/common/request","vs/platform/telemetry/common/telemetryUtils","child_process","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/common/jsonFormatter","vs/base/common/codicons","vs/base/common/stream","fs","vs/base/parts/ipc/node/ipc.cp","vs/platform/instantiation/common/descriptors","vs/platform/files/common/watcher","vs/platform/userDataSync/common/content","vs/base/common/iterator","net","vs/base/common/date","vs/platform/localizations/common/localizations","vs/platform/native/electron-sandbox/native","vs/base/common/semver/semver","vs/platform/remote/common/tunnel","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/node/zip","vs/base/common/collections","vs/base/common/decorators","vs/base/common/functional","vs/base/common/normalization","vs/base/node/powershell","vs/base/parts/ipc/common/ipc.net","electron","vs/base/parts/storage/common/storage","vs/base/node/processes","vs/platform/environment/common/environmentService","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/extensions","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionRecommendations/common/extensionRecommendations","crypto","vs/platform/files/common/io","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/userConfigurationFileService","vs/platform/log/common/logIpc","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensions","vs/platform/sharedProcess/common/sharedProcessWorkerService","vs/platform/sign/common/sign","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/terminal/common/terminal","vs/platform/theme/common/themeService","vs/platform/userDataSync/common/extensionsStorageSync","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/userDataSync/common/userDataAutoSyncService","vs/base/common/assert","vs/base/common/linkedList","vs/base/common/processes","vs/base/common/skipList","vs/base/common/stopwatch","vs/base/common/hash","vs/base/common/console","vs/base/common/marshalling","vs/base/common/glob","vs/base/common/mime","vs/base/common/uriIpc","vs/base/node/decoder","vs/base/node/macAddress","vs/base/node/id","vs/base/node/extpath","vs/base/node/ports","vs/base/node/ps","vs/base/node/watcher","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-browser/ipc.mp","vs/base/parts/request/browser/request","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/environment/node/shellEnv","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/platform/assignment/common/assignment","vs/platform/environment/node/argv","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/configRemotes","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/electron-sandbox/extensionRecommendationsIpc","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/contextkey/common/contextkey","vs/code/electron-browser/sharedProcess/contrib/deprecatedExtensionsCleaner","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/checksum/node/checksumService","vs/platform/environment/node/argvHelper","vs/platform/environment/node/shellEnv","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/parcel/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/ipc/electron-browser/mainProcessService","vs/platform/ipc/electron-sandbox/services","vs/code/electron-browser/sharedProcess/contrib/localizationsUpdater","vs/code/electron-browser/sharedProcess/contrib/logsDataCleaner","vs/code/electron-browser/sharedProcess/contrib/storageDataCleaner","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/code/electron-browser/sharedProcess/contrib/codeCacheCleaner","vs/code/electron-browser/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteHosts","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/localizations/node/localizations","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/remote/node/sharedProcessTunnelService","vs/platform/request/browser/requestService","vs/platform/download/common/downloadService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/sharedProcess/electron-browser/sharedProcessWorker","vs/platform/sharedProcess/electron-browser/sharedProcessWorkerService","vs/platform/sign/node/signService","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/storage/common/storageIpc","vs/platform/storage/electron-sandbox/storageService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/platform/assignment/common/assignmentService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/terminal/common/requestStore","vs/platform/terminal/electron-sandbox/terminal","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/userDataSyncBackupStoreService","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/userDataSync/common/userDataSyncResourceEnablementService","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/electron-sandbox/userDataAutoSyncService","vs/platform/windows/node/windowTracker","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","vs/base/parts/ipc/node/ipc.net","vs/platform/remote/node/nodeSocketFactory","vs/platform/remote/node/tunnelService","string_decoder","util","minimist","assert","graceful-fs","yauzl","yazl","zlib","vs/code/electron-browser/sharedProcess/sharedProcessMain"],ne=function(X){for(var e=[],R=0,L=X.length;R<L;R++)e[R]=te[X[R]];return e};define(te[100],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function R(L,D){if(!L)throw new Error(D?`Assertion failed (${D})`:"Assertion Failed")}e.ok=R}),define(te[66],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const R=Object.prototype.hasOwnProperty;function L(I){const E=[];for(let d in I)R.call(I,d)&&E.push(I[d]);return E}e.values=L;function D(I,E){for(let d in I)if(R.call(I,d)&&E({key:d,value:I[d]},function(){delete I[d]})===!1)return}e.forEach=D;function k(I,E){const d=Object.create(null);for(const p of I){const h=E(p);let w=d[h];w||(w=d[h]=[]),w.push(p)}return d}e.groupBy=k;function i(I){const E=Object.create(null);return I&&I.forEach((d,p)=>{E[p]=d}),E}e.fromMap=i;function P(I,E){const d=[],p=[];for(let h of I)E.has(h)||d.push(h);for(let h of E)I.has(h)||p.push(h);return{removed:d,added:p}}e.diffSets=P;function S(I,E){const d=[],p=[];for(let[h,w]of I)E.has(h)||d.push(w);for(let[h,w]of E)I.has(h)||p.push(w);return{removed:d,added:p}}e.diffMaps=S;class C{constructor(){this.map=new Map}add(E,d){let p=this.map.get(E);p||(p=new Set,this.map.set(E,p)),p.add(d)}delete(E,d){const p=this.map.get(E);!p||(p.delete(d),p.size===0&&this.map.delete(E))}forEach(E,d){const p=this.map.get(E);!p||p.forEach(d)}}e.SetMap=C}),define(te[67],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function R(i){return(P,S,C)=>{let I=null,E=null;if(typeof C.value=="function"?(I="value",E=C.value):typeof C.get=="function"&&(I="get",E=C.get),!E)throw new Error("not supported");C[I]=i(E,S)}}e.createDecorator=R;function L(i,P,S){let C=null,I=null;if(typeof S.value=="function"?(C="value",I=S.value,I.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof S.get=="function"&&(C="get",I=S.get),!I)throw new Error("not supported");const E=`$memoize$${P}`;S[C]=function(...d){return this.hasOwnProperty(E)||Object.defineProperty(this,E,{configurable:!1,enumerable:!1,writable:!1,value:I.apply(this,d)}),this[E]}}e.memoize=L;function D(i,P,S){return R((C,I)=>{const E=`$debounce$${I}`,d=`$debounce$result$${I}`;return function(...p){this[d]||(this[d]=S?S():void 0),clearTimeout(this[E]),P&&(this[d]=P(this[d],...p),p=[this[d]]),this[E]=setTimeout(()=>{C.apply(this,p),this[d]=S?S():void 0},i)}})}e.debounce=D;function k(i,P,S){return R((C,I)=>{const E=`$throttle$timer$${I}`,d=`$throttle$result$${I}`,p=`$throttle$lastRun$${I}`,h=`$throttle$pending$${I}`;return function(...w){if(this[d]||(this[d]=S?S():void 0),(this[p]===null||this[p]===void 0)&&(this[p]=-Number.MAX_VALUE),P&&(this[d]=P(this[d],...w)),this[h])return;const y=this[p]+i;y<=Date.now()?(this[p]=Date.now(),C.apply(this,[this[d]]),this[d]=S?S():void 0):(this[h]=!0,this[E]=setTimeout(()=>{this[h]=!1,this[p]=Date.now(),C.apply(this,[this[d]]),this[d]=S?S():void 0},y-Date.now()))}})}e.throttle=k}),define(te[9],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class R{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(r){setTimeout(()=>{throw r.stack?new Error(r.message+`

`+r.stack):r},0)}}addListener(r){return this.listeners.push(r),()=>{this._removeListener(r)}}emit(r){this.listeners.forEach(o=>{o(r)})}_removeListener(r){this.listeners.splice(this.listeners.indexOf(r),1)}setUnexpectedErrorHandler(r){this.unexpectedErrorHandler=r}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(r){this.unexpectedErrorHandler(r),this.emit(r)}onUnexpectedExternalError(r){this.unexpectedErrorHandler(r)}}e.ErrorHandler=R,e.errorHandler=new R;function L(l){e.errorHandler.setUnexpectedErrorHandler(l)}e.setUnexpectedErrorHandler=L;function D(l){S(l)||e.errorHandler.onUnexpectedError(l)}e.onUnexpectedError=D;function k(l){S(l)||e.errorHandler.onUnexpectedExternalError(l)}e.onUnexpectedExternalError=k;function i(l){if(l instanceof Error){let{name:r,message:o}=l;const n=l.stacktrace||l.stack;return{$isError:!0,name:r,message:o,stack:n}}return l}e.transformErrorForSerialization=i;const P="Canceled";function S(l){return l instanceof Error&&l.name===P&&l.message===P}e.isPromiseCanceledError=S;class C extends Error{constructor(){super(P);this.name=this.message}}e.CancellationError=C;function I(){const l=new Error(P);return l.name=l.message,l}e.canceled=I;function E(l){return l?new Error(`Illegal argument: ${l}`):new Error("Illegal argument")}e.illegalArgument=E;function d(l){return l?new Error(`Illegal state: ${l}`):new Error("Illegal state")}e.illegalState=d;function p(l){return l?new Error(`readonly property '${l} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=p;function h(l){const r=new Error(`${l} has been disposed`);return r.name="DISPOSED",r}e.disposed=h;function w(l){return l?l.message?l.message:l.stack?l.stack.split(`
`)[0]:String(l):"Error"}e.getErrorMessage=w;class y extends Error{constructor(r){super("NotImplemented");r&&(this.message=r)}}e.NotImplementedError=y;class m extends Error{constructor(r){super("NotSupported");r&&(this.message=r)}}e.NotSupportedError=m;class b extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=b;function g(l){const r=l;return r instanceof Error&&Array.isArray(r.actions)}e.isErrorWithActions=g;function a(l,r=Object.create(null)){const o=new Error(l);return r.actions&&(o.actions=r.actions),o}e.createErrorWithActions=a}),define(te[16],ne([0,1,9]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.maxIndex=e.minIndex=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function L(F,x=0){return F[F.length-(1+x)]}e.tail=L;function D(F){if(F.length===0)throw new Error("Invalid tail call");return[F.slice(0,F.length-1),F[F.length-1]]}e.tail2=D;function k(F,x,V=(Q,Z)=>Q===Z){if(F===x)return!0;if(!F||!x||F.length!==x.length)return!1;for(let Q=0,Z=F.length;Q<Z;Q++)if(!V(F[Q],x[Q]))return!1;return!0}e.equals=k;function i(F,x,V){let Q=0,Z=F.length-1;for(;Q<=Z;){const G=(Q+Z)/2|0,H=V(F[G],x);if(H<0)Q=G+1;else if(H>0)Z=G-1;else return G}return-(Q+1)}e.binarySearch=i;function P(F,x){let V=0,Q=F.length;if(Q===0)return 0;for(;V<Q;){const Z=Math.floor((V+Q)/2);x(F[Z])?Q=Z:V=Z+1}return V}e.findFirstInSorted=P;function S(F,x,V){if(F=F|0,F>=x.length)throw new TypeError("invalid index");let Q=x[Math.floor(x.length*Math.random())],Z=[],G=[],H=[];for(let re of x){const ie=V(re,Q);ie<0?Z.push(re):ie>0?G.push(re):H.push(re)}return F<Z.length?S(F,Z,V):F<Z.length+H.length?H[0]:S(F-(Z.length+H.length),G,V)}e.quickSelect=S;function C(F,x){const V=[];let Q;for(const Z of F.slice(0).sort(x))!Q||x(Q[0],Z)!==0?(Q=[Z],V.push(Q)):Q.push(Z);return V}e.groupBy=C;function I(F,x,V){const Q=[];function Z(re,ie,ce){if(ie===0&&ce.length===0)return;const le=Q[Q.length-1];le&&le.start+le.deleteCount===re?(le.deleteCount+=ie,le.toInsert.push(...ce)):Q.push({start:re,deleteCount:ie,toInsert:ce})}let G=0,H=0;for(;;){if(G===F.length){Z(G,0,x.slice(H));break}if(H===x.length){Z(G,F.length-G,[]);break}const re=F[G],ie=x[H],ce=V(re,ie);ce===0?(G+=1,H+=1):ce<0?(Z(G,1,[]),G+=1):ce>0&&(Z(G,0,[ie]),H+=1)}return Q}e.sortedDiff=I;function E(F,x,V){const Q=I(F,x,V),Z=[],G=[];for(const H of Q)Z.push(...F.slice(H.start,H.start+H.deleteCount)),G.push(...H.toInsert);return{removed:Z,added:G}}e.delta=E;function d(F,x,V){if(V===0)return[];const Q=F.slice(0,V).sort(x);return h(F,x,Q,V,F.length),Q}e.top=d;function p(F,x,V,Q,Z){return V===0?Promise.resolve([]):new Promise((G,H)=>{(async()=>{const re=F.length,ie=F.slice(0,V).sort(x);for(let ce=V,le=Math.min(V+Q,re);ce<re;ce=le,le=Math.min(le+Q,re)){if(ce>V&&await new Promise(de=>setTimeout(de)),Z&&Z.isCancellationRequested)throw(0,R.canceled)();h(F,x,ie,ce,le)}return ie})().then(G,H)})}e.topAsync=p;function h(F,x,V,Q,Z){for(const G=V.length;Q<Z;Q++){const H=F[Q];if(x(H,V[G-1])<0){V.pop();const re=P(V,ie=>x(H,ie)<0);V.splice(re,0,H)}}}function w(F){return F.filter(x=>!!x)}e.coalesce=w;function y(F){let x=0;for(let V=0;V<F.length;V++)F[V]&&(F[x]=F[V],x+=1);F.length=x}e.coalesceInPlace=y;function m(F,x,V){F.splice(V,0,F.splice(x,1)[0])}e.move=m;function b(F){return!Array.isArray(F)||F.length===0}e.isFalsyOrEmpty=b;function g(F){return Array.isArray(F)&&F.length>0}e.isNonEmptyArray=g;function a(F,x=V=>V){const V=new Set;return F.filter(Q=>{const Z=x(Q);return V.has(Z)?!1:(V.add(Z),!0)})}e.distinct=a;function l(F){const x=Object.create(null);return V=>{const Q=F(V);return x[Q]?!1:(x[Q]=!0,!0)}}e.uniqueFilter=l;function r(F,x){const V=o(F,x);if(V!==-1)return F[V]}e.findLast=r;function o(F,x){for(let V=F.length-1;V>=0;V--){const Q=F[V];if(x(Q))return V}return-1}e.lastIndex=o;function n(F,x){return F.length>0?F[0]:x}e.firstOrDefault=n;function t(F,x,V=(Q,Z)=>Q===Z){let Q=0;for(let Z=0,G=Math.min(F.length,x.length);Z<G&&V(F[Z],x[Z]);Z++)Q++;return Q}e.commonPrefixLength=t;function s(F){return[].concat(...F)}e.flatten=s;function c(F,x){let V=typeof x=="number"?F:0;typeof x=="number"?V=F:(V=0,x=F);const Q=[];if(V<=x)for(let Z=V;Z<x;Z++)Q.push(Z);else for(let Z=V;Z>x;Z--)Q.push(Z);return Q}e.range=c;function u(F,x,V){return F.reduce((Q,Z)=>(Q[x(Z)]=V?V(Z):Z,Q),Object.create(null))}e.index=u;function f(F,x){return F.push(x),()=>v(F,x)}e.insert=f;function v(F,x){const V=F.indexOf(x);if(V>-1)return F.splice(V,1),x}e.remove=v;function T(F,x,V){const Q=F.slice(0,x),Z=F.slice(x);return Q.concat(V,Z)}e.arrayInsert=T;function O(F,x){let V;if(typeof x=="number"){let Q=x;V=()=>{const Z=Math.sin(Q++)*179426549;return Z-Math.floor(Z)}}else V=Math.random;for(let Q=F.length-1;Q>0;Q-=1){const Z=Math.floor(V()*(Q+1)),G=F[Q];F[Q]=F[Z],F[Z]=G}}e.shuffle=O;function U(F,x){const V=F.indexOf(x);V>-1&&(F.splice(V,1),F.unshift(x))}e.pushToStart=U;function W(F,x){const V=F.indexOf(x);V>-1&&(F.splice(V,1),F.push(x))}e.pushToEnd=W;function N(F,x){return Array.isArray(F)?F.map(x):x(F)}e.mapArrayOrNot=N;function A(F){return Array.isArray(F)?F:[F]}e.asArray=A;function z(F){return F[Math.floor(Math.random()*F.length)]}e.getRandomElement=z;function _(F,x){for(const V of F){const Q=x(V);if(Q!==void 0)return Q}}e.mapFind=_;function M(F,x,V){const Q=B(F,x),Z=F.length,G=V.length;F.length=Z+G;for(let H=Z-1;H>=Q;H--)F[H+G]=F[H];for(let H=0;H<G;H++)F[H+Q]=V[H]}e.insertInto=M;function q(F,x,V,Q){const Z=B(F,x),G=F.splice(Z,V);return M(F,Z,Q),G}e.splice=q;function B(F,x){return x<0?Math.max(x+F.length,0):Math.min(x,F.length)}function j(F,x){let V=Number.MAX_SAFE_INTEGER,Q=0;return F.forEach((Z,G)=>{const H=x(Z);H<V&&(V=H,Q=G)}),Q}e.minIndex=j;function $(F,x){let V=Number.MIN_SAFE_INTEGER,Q=0;return F.forEach((Z,G)=>{const H=x(Z);H>V&&(V=H,Q=G)}),Q}e.maxIndex=$;class K{constructor(x){this.items=x,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(x){let V=this.firstIdx;for(;V<this.items.length&&x(this.items[V]);)V++;const Q=V===this.firstIdx?null:this.items.slice(this.firstIdx,V);return this.firstIdx=V,Q}takeFromEndWhile(x){let V=this.lastIdx;for(;V>=0&&x(this.items[V]);)V--;const Q=V===this.lastIdx?null:this.items.slice(V+1,this.lastIdx+1);return this.lastIdx=V,Q}peek(){return this.items[this.firstIdx]}dequeue(){const x=this.items[this.firstIdx];return this.firstIdx++,x}takeCount(x){const V=this.items.slice(this.firstIdx,this.firstIdx+x);return this.firstIdx+=x,V}}e.ArrayQueue=K}),define(te[68],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function R(L){const D=this;let k=!1,i;return function(){return k||(k=!0,i=L.apply(D,arguments)),i}}e.once=R}),define(te[56],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var R;(function(L){function D(l){return l&&typeof l=="object"&&typeof l[Symbol.iterator]=="function"}L.is=D;const k=Object.freeze([]);function i(){return k}L.empty=i;function*P(l){yield l}L.single=P;function S(l){return l||k}L.from=S;function C(l){return!l||l[Symbol.iterator]().next().done===!0}L.isEmpty=C;function I(l){return l[Symbol.iterator]().next().value}L.first=I;function E(l,r){for(const o of l)if(r(o))return!0;return!1}L.some=E;function d(l,r){for(const o of l)if(r(o))return o}L.find=d;function*p(l,r){for(const o of l)r(o)&&(yield o)}L.filter=p;function*h(l,r){let o=0;for(const n of l)yield r(n,o++)}L.map=h;function*w(...l){for(const r of l)for(const o of r)yield o}L.concat=w;function*y(l){for(const r of l)for(const o of r)yield o}L.concatNested=y;function m(l,r,o){let n=o;for(const t of l)n=r(n,t);return n}L.reduce=m;function*b(l,r,o=l.length){for(r<0&&(r+=l.length),o<0?o+=l.length:o>l.length&&(o=l.length);r<o;r++)yield l[r]}L.slice=b;function g(l,r=Number.POSITIVE_INFINITY){const o=[];if(r===0)return[o,l];const n=l[Symbol.iterator]();for(let t=0;t<r;t++){const s=n.next();if(s.done)return[o,L.empty()];o.push(s.value)}return[o,{[Symbol.iterator](){return n}}]}L.consume=g;function a(l,r,o=(n,t)=>n===t){const n=l[Symbol.iterator](),t=r[Symbol.iterator]();for(;;){const s=n.next(),c=t.next();if(s.done!==c.done)return!1;if(s.done)return!0;if(!o(s.value,c.value))return!1}}L.equals=a})(R=e.Iterable||(e.Iterable={}))}),define(te[32],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var R;(function(r){r[r.None=0]="None",r[r.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=2]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",r[r.InvalidUnicode=4]="InvalidUnicode",r[r.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",r[r.InvalidCharacter=6]="InvalidCharacter"})(R=e.ScanError||(e.ScanError={}));var L;(function(r){r[r.OpenBraceToken=1]="OpenBraceToken",r[r.CloseBraceToken=2]="CloseBraceToken",r[r.OpenBracketToken=3]="OpenBracketToken",r[r.CloseBracketToken=4]="CloseBracketToken",r[r.CommaToken=5]="CommaToken",r[r.ColonToken=6]="ColonToken",r[r.NullKeyword=7]="NullKeyword",r[r.TrueKeyword=8]="TrueKeyword",r[r.FalseKeyword=9]="FalseKeyword",r[r.StringLiteral=10]="StringLiteral",r[r.NumericLiteral=11]="NumericLiteral",r[r.LineCommentTrivia=12]="LineCommentTrivia",r[r.BlockCommentTrivia=13]="BlockCommentTrivia",r[r.LineBreakTrivia=14]="LineBreakTrivia",r[r.Trivia=15]="Trivia",r[r.Unknown=16]="Unknown",r[r.EOF=17]="EOF"})(L=e.SyntaxKind||(e.SyntaxKind={}));var D;(function(r){r[r.InvalidSymbol=1]="InvalidSymbol",r[r.InvalidNumberFormat=2]="InvalidNumberFormat",r[r.PropertyNameExpected=3]="PropertyNameExpected",r[r.ValueExpected=4]="ValueExpected",r[r.ColonExpected=5]="ColonExpected",r[r.CommaExpected=6]="CommaExpected",r[r.CloseBraceExpected=7]="CloseBraceExpected",r[r.CloseBracketExpected=8]="CloseBracketExpected",r[r.EndOfFileExpected=9]="EndOfFileExpected",r[r.InvalidCommentToken=10]="InvalidCommentToken",r[r.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=12]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",r[r.InvalidUnicode=14]="InvalidUnicode",r[r.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",r[r.InvalidCharacter=16]="InvalidCharacter"})(D=e.ParseErrorCode||(e.ParseErrorCode={}));var k;(function(r){r.DEFAULT={allowTrailingComma:!0}})(k=e.ParseOptions||(e.ParseOptions={}));function i(r,o=!1){let n=0,t=r.length,s="",c=0,u=16,f=0;function v(z){let _=0,M=0;for(;_<z;){const q=r.charCodeAt(n);if(q>=48&&q<=57)M=M*16+q-48;else if(q>=65&&q<=70)M=M*16+q-65+10;else if(q>=97&&q<=102)M=M*16+q-97+10;else break;n++,_++}return _<z&&(M=-1),M}function T(z){n=z,s="",c=0,u=16,f=0}function O(){const z=n;if(r.charCodeAt(n)===48)n++;else for(n++;n<r.length&&C(r.charCodeAt(n));)n++;if(n<r.length&&r.charCodeAt(n)===46)if(n++,n<r.length&&C(r.charCodeAt(n)))for(n++;n<r.length&&C(r.charCodeAt(n));)n++;else return f=3,r.substring(z,n);let _=n;if(n<r.length&&(r.charCodeAt(n)===69||r.charCodeAt(n)===101))if(n++,(n<r.length&&r.charCodeAt(n)===43||r.charCodeAt(n)===45)&&n++,n<r.length&&C(r.charCodeAt(n))){for(n++;n<r.length&&C(r.charCodeAt(n));)n++;_=n}else f=3;return r.substring(z,_)}function U(){let z="",_=n;for(;;){if(n>=t){z+=r.substring(_,n),f=2;break}const M=r.charCodeAt(n);if(M===34){z+=r.substring(_,n),n++;break}if(M===92){if(z+=r.substring(_,n),n++,n>=t){f=2;break}switch(r.charCodeAt(n++)){case 34:z+='"';break;case 92:z+="\\";break;case 47:z+="/";break;case 98:z+="\b";break;case 102:z+="\f";break;case 110:z+=`
`;break;case 114:z+="\r";break;case 116:z+="	";break;case 117:const B=v(4);B>=0?z+=String.fromCharCode(B):f=4;break;default:f=5}_=n;continue}if(M>=0&&M<=31)if(S(M)){z+=r.substring(_,n),f=2;break}else f=6;n++}return z}function W(){if(s="",f=0,c=n,n>=t)return c=t,u=17;let z=r.charCodeAt(n);if(P(z)){do n++,s+=String.fromCharCode(z),z=r.charCodeAt(n);while(P(z));return u=15}if(S(z))return n++,s+=String.fromCharCode(z),z===13&&r.charCodeAt(n)===10&&(n++,s+=`
`),u=14;switch(z){case 123:return n++,u=1;case 125:return n++,u=2;case 91:return n++,u=3;case 93:return n++,u=4;case 58:return n++,u=6;case 44:return n++,u=5;case 34:return n++,s=U(),u=10;case 47:const _=n-1;if(r.charCodeAt(n+1)===47){for(n+=2;n<t&&!S(r.charCodeAt(n));)n++;return s=r.substring(_,n),u=12}if(r.charCodeAt(n+1)===42){n+=2;const M=t-1;let q=!1;for(;n<M;){if(r.charCodeAt(n)===42&&r.charCodeAt(n+1)===47){n+=2,q=!0;break}n++}return q||(n++,f=1),s=r.substring(_,n),u=13}return s+=String.fromCharCode(z),n++,u=16;case 45:if(s+=String.fromCharCode(z),n++,n===t||!C(r.charCodeAt(n)))return u=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=O(),u=11;default:for(;n<t&&N(z);)n++,z=r.charCodeAt(n);if(c!==n){switch(s=r.substring(c,n),s){case"true":return u=8;case"false":return u=9;case"null":return u=7}return u=16}return s+=String.fromCharCode(z),n++,u=16}}function N(z){if(P(z)||S(z))return!1;switch(z){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function A(){let z;do z=W();while(z>=12&&z<=15);return z}return{setPosition:T,getPosition:()=>n,scan:o?A:W,getToken:()=>u,getTokenValue:()=>s,getTokenOffset:()=>c,getTokenLength:()=>n-c,getTokenError:()=>f}}e.createScanner=i;function P(r){return r===32||r===9||r===11||r===12||r===160||r===5760||r>=8192&&r<=8203||r===8239||r===8287||r===12288||r===65279}function S(r){return r===10||r===13||r===8232||r===8233}function C(r){return r>=48&&r<=57}var I;(function(r){r[r.nullCharacter=0]="nullCharacter",r[r.maxAsciiCharacter=127]="maxAsciiCharacter",r[r.lineFeed=10]="lineFeed",r[r.carriageReturn=13]="carriageReturn",r[r.lineSeparator=8232]="lineSeparator",r[r.paragraphSeparator=8233]="paragraphSeparator",r[r.nextLine=133]="nextLine",r[r.space=32]="space",r[r.nonBreakingSpace=160]="nonBreakingSpace",r[r.enQuad=8192]="enQuad",r[r.emQuad=8193]="emQuad",r[r.enSpace=8194]="enSpace",r[r.emSpace=8195]="emSpace",r[r.threePerEmSpace=8196]="threePerEmSpace",r[r.fourPerEmSpace=8197]="fourPerEmSpace",r[r.sixPerEmSpace=8198]="sixPerEmSpace",r[r.figureSpace=8199]="figureSpace",r[r.punctuationSpace=8200]="punctuationSpace",r[r.thinSpace=8201]="thinSpace",r[r.hairSpace=8202]="hairSpace",r[r.zeroWidthSpace=8203]="zeroWidthSpace",r[r.narrowNoBreakSpace=8239]="narrowNoBreakSpace",r[r.ideographicSpace=12288]="ideographicSpace",r[r.mathematicalSpace=8287]="mathematicalSpace",r[r.ogham=5760]="ogham",r[r._=95]="_",r[r.$=36]="$",r[r._0=48]="_0",r[r._1=49]="_1",r[r._2=50]="_2",r[r._3=51]="_3",r[r._4=52]="_4",r[r._5=53]="_5",r[r._6=54]="_6",r[r._7=55]="_7",r[r._8=56]="_8",r[r._9=57]="_9",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.ampersand=38]="ampersand",r[r.asterisk=42]="asterisk",r[r.at=64]="at",r[r.backslash=92]="backslash",r[r.bar=124]="bar",r[r.caret=94]="caret",r[r.closeBrace=125]="closeBrace",r[r.closeBracket=93]="closeBracket",r[r.closeParen=41]="closeParen",r[r.colon=58]="colon",r[r.comma=44]="comma",r[r.dot=46]="dot",r[r.doubleQuote=34]="doubleQuote",r[r.equals=61]="equals",r[r.exclamation=33]="exclamation",r[r.greaterThan=62]="greaterThan",r[r.lessThan=60]="lessThan",r[r.minus=45]="minus",r[r.openBrace=123]="openBrace",r[r.openBracket=91]="openBracket",r[r.openParen=40]="openParen",r[r.percent=37]="percent",r[r.plus=43]="plus",r[r.question=63]="question",r[r.semicolon=59]="semicolon",r[r.singleQuote=39]="singleQuote",r[r.slash=47]="slash",r[r.tilde=126]="tilde",r[r.backspace=8]="backspace",r[r.formFeed=12]="formFeed",r[r.byteOrderMark=65279]="byteOrderMark",r[r.tab=9]="tab",r[r.verticalTab=11]="verticalTab"})(I||(I={}));function E(r,o){const n=[],t=new Object;let s;const c={value:{},offset:0,length:0,type:"object",parent:void 0};let u=!1;function f(v,T,O,U){c.value=v,c.offset=T,c.length=O,c.type=U,c.colonOffset=void 0,s=c}try{g(r,{onObjectBegin:(v,T)=>{if(o<=v)throw t;s=void 0,u=o>v,n.push("")},onObjectProperty:(v,T,O)=>{if(o<T||(f(v,T,O,"property"),n[n.length-1]=v,o<=T+O))throw t},onObjectEnd:(v,T)=>{if(o<=v)throw t;s=void 0,n.pop()},onArrayBegin:(v,T)=>{if(o<=v)throw t;s=void 0,n.push(0)},onArrayEnd:(v,T)=>{if(o<=v)throw t;s=void 0,n.pop()},onLiteralValue:(v,T,O)=>{if(o<T||(f(v,T,O,l(v)),o<=T+O))throw t},onSeparator:(v,T,O)=>{if(o<=T)throw t;if(v===":"&&s&&s.type==="property")s.colonOffset=T,u=!1,s=void 0;else if(v===","){const U=n[n.length-1];typeof U=="number"?n[n.length-1]=U+1:(u=!0,n[n.length-1]=""),s=void 0}}})}catch(v){if(v!==t)throw v}return{path:n,previousNode:s,isAtPropertyKey:u,matches:v=>{let T=0;for(let O=0;T<v.length&&O<n.length;O++)if(v[T]===n[O]||v[T]==="*")T++;else if(v[T]!=="**")return!1;return T===v.length}}}e.getLocation=E;function d(r,o=[],n=k.DEFAULT){let t=null,s=[];const c=[];function u(v){Array.isArray(s)?s.push(v):t!==null&&(s[t]=v)}return g(r,{onObjectBegin:()=>{const v={};u(v),c.push(s),s=v,t=null},onObjectProperty:v=>{t=v},onObjectEnd:()=>{s=c.pop()},onArrayBegin:()=>{const v=[];u(v),c.push(s),s=v,t=null},onArrayEnd:()=>{s=c.pop()},onLiteralValue:u,onError:(v,T,O)=>{o.push({error:v,offset:T,length:O})}},n),s[0]}e.parse=d;function p(r,o=[],n=k.DEFAULT){let t={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(v){t.type==="property"&&(t.length=v-t.offset,t=t.parent)}function c(v){return t.children.push(v),v}g(r,{onObjectBegin:v=>{t=c({type:"object",offset:v,length:-1,parent:t,children:[]})},onObjectProperty:(v,T,O)=>{t=c({type:"property",offset:T,length:-1,parent:t,children:[]}),t.children.push({type:"string",value:v,offset:T,length:O,parent:t})},onObjectEnd:(v,T)=>{t.length=v+T-t.offset,t=t.parent,s(v+T)},onArrayBegin:(v,T)=>{t=c({type:"array",offset:v,length:-1,parent:t,children:[]})},onArrayEnd:(v,T)=>{t.length=v+T-t.offset,t=t.parent,s(v+T)},onLiteralValue:(v,T,O)=>{c({type:l(v),offset:T,length:O,parent:t,value:v}),s(T+O)},onSeparator:(v,T,O)=>{t.type==="property"&&(v===":"?t.colonOffset=T:v===","&&s(T))},onError:(v,T,O)=>{o.push({error:v,offset:T,length:O})}},n);const f=t.children[0];return f&&delete f.parent,f}e.parseTree=p;function h(r,o){if(!r)return;let n=r;for(let t of o)if(typeof t=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let s=!1;for(const c of n.children)if(Array.isArray(c.children)&&c.children[0].value===t){n=c.children[1],s=!0;break}if(!s)return}else{const s=t;if(n.type!=="array"||s<0||!Array.isArray(n.children)||s>=n.children.length)return;n=n.children[s]}return n}e.findNodeAtLocation=h;function w(r){if(!r.parent||!r.parent.children)return[];const o=w(r.parent);if(r.parent.type==="property"){const n=r.parent.children[0].value;o.push(n)}else if(r.parent.type==="array"){const n=r.parent.children.indexOf(r);n!==-1&&o.push(n)}return o}e.getNodePath=w;function y(r){switch(r.type){case"array":return r.children.map(y);case"object":const o=Object.create(null);for(let n of r.children){const t=n.children[1];t&&(o[n.children[0].value]=y(t))}return o;case"null":case"string":case"number":case"boolean":return r.value;default:return}}e.getNodeValue=y;function m(r,o,n=!1){return o>=r.offset&&o<r.offset+r.length||n&&o===r.offset+r.length}e.contains=m;function b(r,o,n=!1){if(m(r,o,n)){const t=r.children;if(Array.isArray(t))for(let s=0;s<t.length&&t[s].offset<=o;s++){const c=b(t[s],o,n);if(c)return c}return r}}e.findNodeAtOffset=b;function g(r,o,n=k.DEFAULT){const t=i(r,!1);function s(V){return V?()=>V(t.getTokenOffset(),t.getTokenLength()):()=>!0}function c(V){return V?Q=>V(Q,t.getTokenOffset(),t.getTokenLength()):()=>!0}const u=s(o.onObjectBegin),f=c(o.onObjectProperty),v=s(o.onObjectEnd),T=s(o.onArrayBegin),O=s(o.onArrayEnd),U=c(o.onLiteralValue),W=c(o.onSeparator),N=s(o.onComment),A=c(o.onError),z=n&&n.disallowComments,_=n&&n.allowTrailingComma;function M(){for(;;){const V=t.scan();switch(t.getTokenError()){case 4:q(14);break;case 5:q(15);break;case 3:q(13);break;case 1:z||q(11);break;case 2:q(12);break;case 6:q(16);break}switch(V){case 12:case 13:z?q(10):N();break;case 16:q(1);break;case 15:case 14:break;default:return V}}}function q(V,Q=[],Z=[]){if(A(V),Q.length+Z.length>0){let G=t.getToken();for(;G!==17;){if(Q.indexOf(G)!==-1){M();break}else if(Z.indexOf(G)!==-1)break;G=M()}}}function B(V){const Q=t.getTokenValue();return V?U(Q):f(Q),M(),!0}function j(){switch(t.getToken()){case 11:let V=0;try{V=JSON.parse(t.getTokenValue()),typeof V!="number"&&(q(2),V=0)}catch(Q){q(2)}U(V);break;case 7:U(null);break;case 8:U(!0);break;case 9:U(!1);break;default:return!1}return M(),!0}function $(){return t.getToken()!==10?(q(3,[],[2,5]),!1):(B(!1),t.getToken()===6?(W(":"),M(),x()||q(4,[],[2,5])):q(5,[],[2,5]),!0)}function K(){u(),M();let V=!1;for(;t.getToken()!==2&&t.getToken()!==17;){if(t.getToken()===5){if(V||q(4,[],[]),W(","),M(),t.getToken()===2&&_)break}else V&&q(6,[],[]);$()||q(4,[],[2,5]),V=!0}return v(),t.getToken()!==2?q(7,[2],[]):M(),!0}function F(){T(),M();let V=!1;for(;t.getToken()!==4&&t.getToken()!==17;){if(t.getToken()===5){if(V||q(4,[],[]),W(","),M(),t.getToken()===4&&_)break}else V&&q(6,[],[]);x()||q(4,[],[4,5]),V=!0}return O(),t.getToken()!==4?q(8,[4],[]):M(),!0}function x(){switch(t.getToken()){case 3:return F();case 1:return K();case 10:return B(!0);default:return j()}}return M(),t.getToken()===17?n.allowEmptyContent?!0:(q(4,[],[]),!1):x()?(t.getToken()!==17&&q(9,[],[]),!0):(q(4,[],[]),!1)}e.visit=g;function a(r,o){let n=i(r),t=[],s,c=0,u;do switch(u=n.getPosition(),s=n.scan(),s){case 12:case 13:case 17:c!==u&&t.push(r.substring(c,u)),o!==void 0&&t.push(n.getTokenValue().replace(/[^\r\n]/g,o)),c=n.getPosition();break}while(s!==17);return t.join("")}e.stripComments=a;function l(r){switch(typeof r){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(r){if(Array.isArray(r))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=l}),define(te[48],ne([0,1,32]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function L(S,C,I){let E,d,p,h,w;if(C){for(h=C.offset,w=h+C.length,p=h;p>0&&!P(S,p-1);)p--;let c=w;for(;c<S.length&&!P(S,c);)c++;d=S.substring(p,c),E=k(d,I)}else d=S,E=0,p=0,h=0,w=S.length;const y=i(I,S);let m=!1,b=0,g;I.insertSpaces?g=D(" ",I.tabSize||4):g="	";const a=(0,R.createScanner)(d,!1);let l=!1;function r(){return y+D(g,E+b)}function o(){let c=a.scan();for(m=!1;c===15||c===14;)m=m||c===14,c=a.scan();return l=c===16||a.getTokenError()!==0,c}const n=[];function t(c,u,f){!l&&u<w&&f>h&&S.substring(u,f)!==c&&n.push({offset:u,length:f-u,content:c})}let s=o();if(s!==17){const c=a.getTokenOffset()+p,u=D(g,E);t(u,p,c)}for(;s!==17;){let c=a.getTokenOffset()+a.getTokenLength()+p,u=o(),f="";for(;!m&&(u===12||u===13);){const T=a.getTokenOffset()+p;t(" ",c,T),c=a.getTokenOffset()+a.getTokenLength()+p,f=u===12?r():"",u=o()}if(u===2)s!==1&&(b--,f=r());else if(u===4)s!==3&&(b--,f=r());else{switch(s){case 3:case 1:b++,f=r();break;case 5:case 12:f=r();break;case 13:m?f=r():f=" ";break;case 6:f=" ";break;case 10:if(u===6){f="";break}case 7:case 8:case 9:case 11:case 2:case 4:u===12||u===13?f=" ":u!==5&&u!==17&&(l=!0);break;case 16:l=!0;break}m&&(u===12||u===13)&&(f=r())}const v=a.getTokenOffset()+p;t(f,c,v),s=u}return n}e.format=L;function D(S,C){let I="";for(let E=0;E<C;E++)I+=S;return I}function k(S,C){let I=0,E=0;const d=C.tabSize||4;for(;I<S.length;){const p=S.charAt(I);if(p===" ")E++;else if(p==="	")E+=d;else break;I++}return Math.floor(E/d)}function i(S,C){for(let I=0;I<C.length;I++){const E=C.charAt(I);if(E==="\r")return I+1<C.length&&C.charAt(I+1)===`
`?`\r
`:"\r";if(E===`
`)return`
`}return S&&S.eol||`
`}e.getEOL=i;function P(S,C){return`\r
`.indexOf(S.charAt(C))!==-1}e.isEOL=P}),define(te[40],ne([0,1,32,48]),function(X,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function D(C,I,E){return k(C,I,void 0,E)}e.removeProperty=D;function k(C,I,E,d,p){const h=I.slice(),w=[],y=(0,R.parseTree)(C,w);let m,b;for(;h.length>0&&(b=h.pop(),m=(0,R.findNodeAtLocation)(y,h),m===void 0&&E!==void 0);)typeof b=="string"?E={[b]:E}:E=[E];if(m)if(m.type==="object"&&typeof b=="string"&&Array.isArray(m.children)){const g=(0,R.findNodeAtLocation)(m,[b]);if(g!==void 0)if(E===void 0){if(!g.parent)throw new Error("Malformed AST");const a=m.children.indexOf(g.parent);let l,r=g.parent.offset+g.parent.length;if(a>0){const o=m.children[a-1];l=o.offset+o.length}else l=m.offset+1,m.children.length>1&&(r=m.children[1].offset);return i(C,{offset:l,length:r-l,content:""},d)}else return i(C,{offset:g.offset,length:g.length,content:JSON.stringify(E)},d);else{if(E===void 0)return[];const a=`${JSON.stringify(b)}: ${JSON.stringify(E)}`,l=p?p(m.children.map(o=>o.children[0].value)):m.children.length;let r;if(l>0){const o=m.children[l-1];r={offset:o.offset+o.length,length:0,content:","+a}}else m.children.length===0?r={offset:m.offset+1,length:0,content:a}:r={offset:m.offset+1,length:0,content:a+","};return i(C,r,d)}}else if(m.type==="array"&&typeof b=="number"&&Array.isArray(m.children))if(E!==void 0){const g=`${JSON.stringify(E)}`;let a;if(m.children.length===0||b===0)a={offset:m.offset+1,length:0,content:m.children.length===0?g:g+","};else{const l=b===-1||b>m.children.length?m.children.length:b,r=m.children[l-1];a={offset:r.offset+r.length,length:0,content:","+g}}return i(C,a,d)}else{const g=b,a=m.children[g];let l;if(m.children.length===1)l={offset:m.offset+1,length:m.length-2,content:""};else if(m.children.length-1===g){const r=m.children[g-1],o=r.offset+r.length,n=m.offset+m.length;l={offset:o,length:n-2-o,content:""}}else l={offset:a.offset,length:m.children[g+1].offset-a.offset,content:""};return i(C,l,d)}else throw new Error(`Can not add ${typeof b!="number"?"index":"property"} to parent of type ${m.type}`);else{if(E===void 0)throw new Error("Can not delete in empty document");return i(C,{offset:y?y.offset:0,length:y?y.length:0,content:JSON.stringify(E)},d)}}e.setProperty=k;function i(C,I,E){let d=P(C,I),p=I.offset,h=I.offset+I.content.length;if(I.length===0||I.content.length===0){for(;p>0&&!(0,L.isEOL)(d,p-1);)p--;for(;h<d.length&&!(0,L.isEOL)(d,h);)h++}const w=(0,L.format)(d,{offset:p,length:h-p},E);for(let m=w.length-1;m>=0;m--){const b=w[m];d=P(d,b),p=Math.min(p,b.offset),h=Math.max(h,b.offset+b.length),h+=b.content.length-b.length}const y=C.length-(d.length-h)-p;return[{offset:p,length:y,content:d.substring(p,h)}]}e.withFormatting=i;function P(C,I){return C.substring(0,I.offset)+I.content+C.substring(I.offset+I.length)}e.applyEdit=P;function S(C,I){let E=I.slice(0).sort((p,h)=>{const w=p.offset-h.offset;return w===0?p.length-h.length:w}),d=C.length;for(let p=E.length-1;p>=0;p--){let h=E[p];if(h.offset+h.length<=d)C=P(C,h);else throw new Error("Overlapping edit");d=h.offset}return C}e.applyEdits=S}),define(te[2],ne([0,1,68,56]),function(X,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const D=!1;let k=null;function i(t){k=t}if(e.setDisposableTracker=i,D){const t="__is_disposable_tracked__";i(new class{trackDisposable(s){const c=new Error("Potentially leaked disposable").stack;setTimeout(()=>{s[t]||console.log(c)},3e3)}setParent(s,c){if(s&&s!==b.None)try{s[t]=!0}catch{}}markAsDisposed(s){if(s&&s!==b.None)try{s[t]=!0}catch{}}markAsSingleton(s){}})}function P(t){return k?.trackDisposable(t),t}function S(t){k?.markAsDisposed(t)}function C(t,s){k?.setParent(t,s)}function I(t,s){if(!!k)for(const c of t)k.setParent(c,s)}function E(t){return k?.markAsSingleton(t),t}e.markAsSingleton=E;class d extends Error{constructor(s){super(`Encountered errors while disposing of store. Errors: [${s.join(", ")}]`);this.errors=s}}e.MultiDisposeError=d;function p(t){return typeof t.dispose=="function"&&t.dispose.length===0}e.isDisposable=p;function h(t){if(L.Iterable.is(t)){let s=[];for(const c of t)if(c)try{c.dispose()}catch(u){s.push(u)}if(s.length===1)throw s[0];if(s.length>1)throw new d(s);return Array.isArray(t)?[]:t}else if(t)return t.dispose(),t}e.dispose=h;function w(...t){const s=y(()=>h(t));return I(t,s),s}e.combinedDisposable=w;function y(t){const s=P({dispose:(0,R.once)(()=>{S(s),t()})});return s}e.toDisposable=y;class m{constructor(){this._toDispose=new Set,this._isDisposed=!1,P(this)}dispose(){this._isDisposed||(S(this),this._isDisposed=!0,this.clear())}clear(){try{h(this._toDispose.values())}finally{this._toDispose.clear()}}add(s){if(!s)return s;if(s===this)throw new Error("Cannot register a disposable on itself!");return C(s,this),this._isDisposed?m.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(s),s}}e.DisposableStore=m,m.DISABLE_DISPOSED_WARNING=!1;class b{constructor(){this._store=new m,P(this),C(this._store,this)}dispose(){S(this),this._store.dispose()}_register(s){if(s===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(s)}}e.Disposable=b,b.None=Object.freeze({dispose(){}});class g{constructor(){this._isDisposed=!1,P(this)}get value(){return this._isDisposed?void 0:this._value}set value(s){this._isDisposed||s===this._value||(this._value?.dispose(),s&&C(s,this),this._value=s)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,S(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const s=this._value;return this._value=void 0,s&&C(s,null),s}}e.MutableDisposable=g;class a{constructor(s){this._disposable=s,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=a;class l{constructor(){this.references=new Map}acquire(s,...c){let u=this.references.get(s);u||(u={counter:0,object:this.createReferencedObject(s,...c)},this.references.set(s,u));const{object:f}=u,v=(0,R.once)(()=>{--u.counter==0&&(this.destroyReferencedObject(s,u.object),this.references.delete(s))});return u.counter++,{object:f,dispose:v}}}e.ReferenceCollection=l;class r{constructor(s){this.referenceCollection=s}async acquire(s,...c){const u=this.referenceCollection.acquire(s,...c);try{return{object:await u.object,dispose:()=>u.dispose()}}catch(f){throw u.dispose(),f}}}e.AsyncReferenceCollection=r;class o{constructor(s){this.object=s}dispose(){}}e.ImmortalReference=o;function n(t){const s=new m;try{t(s)}finally{s.dispose()}}e.disposeOnReturn=n}),define(te[101],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class R{constructor(k){this.element=k,this.next=R.Undefined,this.prev=R.Undefined}}R.Undefined=new R(void 0);class L{constructor(){this._first=R.Undefined,this._last=R.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===R.Undefined}clear(){let k=this._first;for(;k!==R.Undefined;){const i=k.next;k.prev=R.Undefined,k.next=R.Undefined,k=i}this._first=R.Undefined,this._last=R.Undefined,this._size=0}unshift(k){return this._insert(k,!1)}push(k){return this._insert(k,!0)}_insert(k,i){const P=new R(k);if(this._first===R.Undefined)this._first=P,this._last=P;else if(i){const C=this._last;this._last=P,P.prev=C,C.next=P}else{const C=this._first;this._first=P,P.next=C,C.prev=P}this._size+=1;let S=!1;return()=>{S||(S=!0,this._remove(P))}}shift(){if(this._first!==R.Undefined){const k=this._first.element;return this._remove(this._first),k}}pop(){if(this._last!==R.Undefined){const k=this._last.element;return this._remove(this._last),k}}_remove(k){if(k.prev!==R.Undefined&&k.next!==R.Undefined){const i=k.prev;i.next=k.next,k.next.prev=i}else k.prev===R.Undefined&&k.next===R.Undefined?(this._first=R.Undefined,this._last=R.Undefined):k.next===R.Undefined?(this._last=this._last.prev,this._last.next=R.Undefined):k.prev===R.Undefined&&(this._first=this._first.next,this._first.prev=R.Undefined);this._size-=1}*[Symbol.iterator](){let k=this._first;for(;k!==R.Undefined;)yield k.element,k=k.next}}e.LinkedList=L}),function(){function X(D){const k=[];typeof D=="number"&&k.push("code/timeOrigin",D);function i(S){k.push(S,Date.now())}function P(){const S=[];for(let C=0;C<k.length;C+=2)S.push({name:k[C],startTime:k[C+1]});return S}return{mark:i,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?X():{mark(D){performance.mark(D)},getMarks(){let D=performance.timeOrigin;typeof D!="number"&&(D=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const k=[{name:"code/timeOrigin",startTime:Math.round(D)}];for(const i of performance.getEntriesByType("mark"))k.push({name:i.name,startTime:Math.round(D+i.startTime)});return k}};if(typeof process=="object"){const D=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return X(D)}else return console.trace("perf-util loaded in UNKNOWN environment"),X()}function R(D){return D.MonacoPerformanceMarks||(D.MonacoPerformanceMarks=e()),D.MonacoPerformanceMarks}var L;typeof global=="object"?L=global:typeof self=="object"?L=self:L={},typeof define=="function"?define("vs/base/common/performance",[],function(){return R(L)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=R(L):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),L.perf=R(L))}(),define(te[4],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const R="en";let L=!1,D=!1,k=!1,i=!1,P=!1,S=!1,C=!1,I,E=R,d,p;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let h;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?h=e.globals.vscode.process:typeof process!="undefined"&&(h=process);const w=typeof h?.versions?.electron=="string"&&h.type==="renderer";if(e.isElectronSandboxed=w&&h?.sandboxed,typeof navigator=="object"&&!w)p=navigator.userAgent,L=p.indexOf("Windows")>=0,D=p.indexOf("Macintosh")>=0,C=(p.indexOf("Macintosh")>=0||p.indexOf("iPad")>=0||p.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,k=p.indexOf("Linux")>=0,S=!0,I=navigator.language,E=I;else if(typeof h=="object"){L=h.platform==="win32",D=h.platform==="darwin",k=h.platform==="linux",i=k&&!!h.env.SNAP&&!!h.env.SNAP_REVISION,I=R,E=R;const n=h.env.VSCODE_NLS_CONFIG;if(n)try{const t=JSON.parse(n),s=t.availableLanguages["*"];I=t.locale,E=s||R,d=t._translationsConfigFile}catch(t){}P=!0}else console.error("Unable to resolve platform.");var y;(function(n){n[n.Web=0]="Web",n[n.Mac=1]="Mac",n[n.Linux=2]="Linux",n[n.Windows=3]="Windows"})(y=e.Platform||(e.Platform={}));function m(n){switch(n){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=m;let b=0;D?b=1:L?b=3:k&&(b=2),e.isWindows=L,e.isMacintosh=D,e.isLinux=k,e.isLinuxSnap=i,e.isNative=P,e.isWeb=S,e.isIOS=C,e.platform=b,e.userAgent=p,e.language=E;var g;(function(n){function t(){return e.language}n.value=t;function s(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}n.isDefaultVariant=s;function c(){return e.language==="en"}n.isDefault=c})(g=e.Language||(e.Language={})),e.locale=I,e.translationsConfigFile=d,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let s=[];e.globals.addEventListener("message",u=>{if(u.data&&u.data.vscodeSetImmediateId)for(let f=0,v=s.length;f<v;f++){const T=s[f];if(T.id===u.data.vscodeSetImmediateId){s.splice(f,1),T.callback();return}}});let c=0;return u=>{const f=++c;s.push({id:f,callback:u}),e.globals.postMessage({vscodeSetImmediateId:f},"*")}}if(typeof h?.nextTick=="function")return h.nextTick.bind(h);const t=Promise.resolve();return s=>t.then(s)}();var a;(function(n){n[n.Windows=1]="Windows",n[n.Macintosh=2]="Macintosh",n[n.Linux=3]="Linux"})(a=e.OperatingSystem||(e.OperatingSystem={})),e.OS=D||C?2:L?1:3;let l=!0,r=!1;function o(){if(!r){r=!0;const n=new Uint8Array(2);n[0]=1,n[1]=2,l=new Uint16Array(n.buffer)[0]===(2<<8)+1}return l}e.isLittleEndian=o}),define(te[31],ne([0,1,4]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.nextTick=e.platform=e.env=e.cwd=void 0;let L;if(typeof R.globals.vscode!="undefined"&&typeof R.globals.vscode.process!="undefined"){const D=R.globals.vscode.process;L={get platform(){return D.platform},get arch(){return D.arch},get env(){return D.env},cwd(){return D.cwd()},nextTick(k){return(0,R.setImmediate)(k)}}}else typeof process!="undefined"?L={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(D){return process.nextTick(D)}}:L={get platform(){return R.isWindows?"win32":R.isMacintosh?"darwin":"linux"},get arch(){},nextTick(D){return(0,R.setImmediate)(D)},get env(){return{}},cwd(){return"/"}};e.cwd=L.cwd,e.env=L.env,e.platform=L.platform,e.nextTick=L.nextTick,e.arch=L.arch}),define(te[10],ne([0,1,31]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const L=65,D=97,k=90,i=122,P=46,S=47,C=92,I=58,E=63;class d extends Error{constructor(a,l,r){let o;typeof l=="string"&&l.indexOf("not ")===0?(o="must not be",l=l.replace(/^not /,"")):o="must be";const n=a.indexOf(".")!==-1?"property":"argument";let t=`The "${a}" ${n} ${o} of type ${l}`;t+=`. Received type ${typeof r}`,super(t),this.code="ERR_INVALID_ARG_TYPE"}}function p(g,a){if(typeof g!="string")throw new d(a,"string",g)}function h(g){return g===S||g===C}function w(g){return g===S}function y(g){return g>=L&&g<=k||g>=D&&g<=i}function m(g,a,l,r){let o="",n=0,t=-1,s=0,c=0;for(let u=0;u<=g.length;++u){if(u<g.length)c=g.charCodeAt(u);else{if(r(c))break;c=S}if(r(c)){if(!(t===u-1||s===1))if(s===2){if(o.length<2||n!==2||o.charCodeAt(o.length-1)!==P||o.charCodeAt(o.length-2)!==P){if(o.length>2){const f=o.lastIndexOf(l);f===-1?(o="",n=0):(o=o.slice(0,f),n=o.length-1-o.lastIndexOf(l)),t=u,s=0;continue}else if(o.length!==0){o="",n=0,t=u,s=0;continue}}a&&(o+=o.length>0?`${l}..`:"..",n=2)}else o.length>0?o+=`${l}${g.slice(t+1,u)}`:o=g.slice(t+1,u),n=u-t-1;t=u,s=0}else c===P&&s!==-1?++s:s=-1}return o}function b(g,a){if(a===null||typeof a!="object")throw new d("pathObject","Object",a);const l=a.dir||a.root,r=a.base||`${a.name||""}${a.ext||""}`;return l?l===a.root?`${l}${r}`:`${l}${g}${r}`:r}e.win32={resolve(...g){let a="",l="",r=!1;for(let o=g.length-1;o>=-1;o--){let n;if(o>=0){if(n=g[o],p(n,"path"),n.length===0)continue}else a.length===0?n=R.cwd():(n=R.env[`=${a}`]||R.cwd(),(n===void 0||n.slice(0,2).toLowerCase()!==a.toLowerCase()&&n.charCodeAt(2)===C)&&(n=`${a}\\`));const t=n.length;let s=0,c="",u=!1;const f=n.charCodeAt(0);if(t===1)h(f)&&(s=1,u=!0);else if(h(f))if(u=!0,h(n.charCodeAt(1))){let v=2,T=v;for(;v<t&&!h(n.charCodeAt(v));)v++;if(v<t&&v!==T){const O=n.slice(T,v);for(T=v;v<t&&h(n.charCodeAt(v));)v++;if(v<t&&v!==T){for(T=v;v<t&&!h(n.charCodeAt(v));)v++;(v===t||v!==T)&&(c=`\\\\${O}\\${n.slice(T,v)}`,s=v)}}}else s=1;else y(f)&&n.charCodeAt(1)===I&&(c=n.slice(0,2),s=2,t>2&&h(n.charCodeAt(2))&&(u=!0,s=3));if(c.length>0)if(a.length>0){if(c.toLowerCase()!==a.toLowerCase())continue}else a=c;if(r){if(a.length>0)break}else if(l=`${n.slice(s)}\\${l}`,r=u,u&&a.length>0)break}return l=m(l,!r,"\\",h),r?`${a}\\${l}`:`${a}${l}`||"."},normalize(g){p(g,"path");const a=g.length;if(a===0)return".";let l=0,r,o=!1;const n=g.charCodeAt(0);if(a===1)return w(n)?"\\":g;if(h(n))if(o=!0,h(g.charCodeAt(1))){let s=2,c=s;for(;s<a&&!h(g.charCodeAt(s));)s++;if(s<a&&s!==c){const u=g.slice(c,s);for(c=s;s<a&&h(g.charCodeAt(s));)s++;if(s<a&&s!==c){for(c=s;s<a&&!h(g.charCodeAt(s));)s++;if(s===a)return`\\\\${u}\\${g.slice(c)}\\`;s!==c&&(r=`\\\\${u}\\${g.slice(c,s)}`,l=s)}}}else l=1;else y(n)&&g.charCodeAt(1)===I&&(r=g.slice(0,2),l=2,a>2&&h(g.charCodeAt(2))&&(o=!0,l=3));let t=l<a?m(g.slice(l),!o,"\\",h):"";return t.length===0&&!o&&(t="."),t.length>0&&h(g.charCodeAt(a-1))&&(t+="\\"),r===void 0?o?`\\${t}`:t:o?`${r}\\${t}`:`${r}${t}`},isAbsolute(g){p(g,"path");const a=g.length;if(a===0)return!1;const l=g.charCodeAt(0);return h(l)||a>2&&y(l)&&g.charCodeAt(1)===I&&h(g.charCodeAt(2))},join(...g){if(g.length===0)return".";let a,l;for(let n=0;n<g.length;++n){const t=g[n];p(t,"path"),t.length>0&&(a===void 0?a=l=t:a+=`\\${t}`)}if(a===void 0)return".";let r=!0,o=0;if(typeof l=="string"&&h(l.charCodeAt(0))){++o;const n=l.length;n>1&&h(l.charCodeAt(1))&&(++o,n>2&&(h(l.charCodeAt(2))?++o:r=!1))}if(r){for(;o<a.length&&h(a.charCodeAt(o));)o++;o>=2&&(a=`\\${a.slice(o)}`)}return e.win32.normalize(a)},relative(g,a){if(p(g,"from"),p(a,"to"),g===a)return"";const l=e.win32.resolve(g),r=e.win32.resolve(a);if(l===r||(g=l.toLowerCase(),a=r.toLowerCase(),g===a))return"";let o=0;for(;o<g.length&&g.charCodeAt(o)===C;)o++;let n=g.length;for(;n-1>o&&g.charCodeAt(n-1)===C;)n--;const t=n-o;let s=0;for(;s<a.length&&a.charCodeAt(s)===C;)s++;let c=a.length;for(;c-1>s&&a.charCodeAt(c-1)===C;)c--;const u=c-s,f=t<u?t:u;let v=-1,T=0;for(;T<f;T++){const U=g.charCodeAt(o+T);if(U!==a.charCodeAt(s+T))break;U===C&&(v=T)}if(T!==f){if(v===-1)return r}else{if(u>f){if(a.charCodeAt(s+T)===C)return r.slice(s+T+1);if(T===2)return r.slice(s+T)}t>f&&(g.charCodeAt(o+T)===C?v=T:T===2&&(v=3)),v===-1&&(v=0)}let O="";for(T=o+v+1;T<=n;++T)(T===n||g.charCodeAt(T)===C)&&(O+=O.length===0?"..":"\\..");return s+=v,O.length>0?`${O}${r.slice(s,c)}`:(r.charCodeAt(s)===C&&++s,r.slice(s,c))},toNamespacedPath(g){if(typeof g!="string")return g;if(g.length===0)return"";const a=e.win32.resolve(g);if(a.length<=2)return g;if(a.charCodeAt(0)===C){if(a.charCodeAt(1)===C){const l=a.charCodeAt(2);if(l!==E&&l!==P)return`\\\\?\\UNC\\${a.slice(2)}`}}else if(y(a.charCodeAt(0))&&a.charCodeAt(1)===I&&a.charCodeAt(2)===C)return`\\\\?\\${a}`;return g},dirname(g){p(g,"path");const a=g.length;if(a===0)return".";let l=-1,r=0;const o=g.charCodeAt(0);if(a===1)return h(o)?g:".";if(h(o)){if(l=r=1,h(g.charCodeAt(1))){let s=2,c=s;for(;s<a&&!h(g.charCodeAt(s));)s++;if(s<a&&s!==c){for(c=s;s<a&&h(g.charCodeAt(s));)s++;if(s<a&&s!==c){for(c=s;s<a&&!h(g.charCodeAt(s));)s++;if(s===a)return g;s!==c&&(l=r=s+1)}}}}else y(o)&&g.charCodeAt(1)===I&&(l=a>2&&h(g.charCodeAt(2))?3:2,r=l);let n=-1,t=!0;for(let s=a-1;s>=r;--s)if(h(g.charCodeAt(s))){if(!t){n=s;break}}else t=!1;if(n===-1){if(l===-1)return".";n=l}return g.slice(0,n)},basename(g,a){a!==void 0&&p(a,"ext"),p(g,"path");let l=0,r=-1,o=!0,n;if(g.length>=2&&y(g.charCodeAt(0))&&g.charCodeAt(1)===I&&(l=2),a!==void 0&&a.length>0&&a.length<=g.length){if(a===g)return"";let t=a.length-1,s=-1;for(n=g.length-1;n>=l;--n){const c=g.charCodeAt(n);if(h(c)){if(!o){l=n+1;break}}else s===-1&&(o=!1,s=n+1),t>=0&&(c===a.charCodeAt(t)?--t==-1&&(r=n):(t=-1,r=s))}return l===r?r=s:r===-1&&(r=g.length),g.slice(l,r)}for(n=g.length-1;n>=l;--n)if(h(g.charCodeAt(n))){if(!o){l=n+1;break}}else r===-1&&(o=!1,r=n+1);return r===-1?"":g.slice(l,r)},extname(g){p(g,"path");let a=0,l=-1,r=0,o=-1,n=!0,t=0;g.length>=2&&g.charCodeAt(1)===I&&y(g.charCodeAt(0))&&(a=r=2);for(let s=g.length-1;s>=a;--s){const c=g.charCodeAt(s);if(h(c)){if(!n){r=s+1;break}continue}o===-1&&(n=!1,o=s+1),c===P?l===-1?l=s:t!==1&&(t=1):l!==-1&&(t=-1)}return l===-1||o===-1||t===0||t===1&&l===o-1&&l===r+1?"":g.slice(l,o)},format:b.bind(null,"\\"),parse(g){p(g,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(g.length===0)return a;const l=g.length;let r=0,o=g.charCodeAt(0);if(l===1)return h(o)?(a.root=a.dir=g,a):(a.base=a.name=g,a);if(h(o)){if(r=1,h(g.charCodeAt(1))){let v=2,T=v;for(;v<l&&!h(g.charCodeAt(v));)v++;if(v<l&&v!==T){for(T=v;v<l&&h(g.charCodeAt(v));)v++;if(v<l&&v!==T){for(T=v;v<l&&!h(g.charCodeAt(v));)v++;v===l?r=v:v!==T&&(r=v+1)}}}}else if(y(o)&&g.charCodeAt(1)===I){if(l<=2)return a.root=a.dir=g,a;if(r=2,h(g.charCodeAt(2))){if(l===3)return a.root=a.dir=g,a;r=3}}r>0&&(a.root=g.slice(0,r));let n=-1,t=r,s=-1,c=!0,u=g.length-1,f=0;for(;u>=r;--u){if(o=g.charCodeAt(u),h(o)){if(!c){t=u+1;break}continue}s===-1&&(c=!1,s=u+1),o===P?n===-1?n=u:f!==1&&(f=1):n!==-1&&(f=-1)}return s!==-1&&(n===-1||f===0||f===1&&n===s-1&&n===t+1?a.base=a.name=g.slice(t,s):(a.name=g.slice(t,n),a.base=g.slice(t,s),a.ext=g.slice(n,s))),t>0&&t!==r?a.dir=g.slice(0,t-1):a.dir=a.root,a},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...g){let a="",l=!1;for(let r=g.length-1;r>=-1&&!l;r--){const o=r>=0?g[r]:R.cwd();p(o,"path"),o.length!==0&&(a=`${o}/${a}`,l=o.charCodeAt(0)===S)}return a=m(a,!l,"/",w),l?`/${a}`:a.length>0?a:"."},normalize(g){if(p(g,"path"),g.length===0)return".";const a=g.charCodeAt(0)===S,l=g.charCodeAt(g.length-1)===S;return g=m(g,!a,"/",w),g.length===0?a?"/":l?"./":".":(l&&(g+="/"),a?`/${g}`:g)},isAbsolute(g){return p(g,"path"),g.length>0&&g.charCodeAt(0)===S},join(...g){if(g.length===0)return".";let a;for(let l=0;l<g.length;++l){const r=g[l];p(r,"path"),r.length>0&&(a===void 0?a=r:a+=`/${r}`)}return a===void 0?".":e.posix.normalize(a)},relative(g,a){if(p(g,"from"),p(a,"to"),g===a||(g=e.posix.resolve(g),a=e.posix.resolve(a),g===a))return"";const l=1,r=g.length,o=r-l,n=1,t=a.length-n,s=o<t?o:t;let c=-1,u=0;for(;u<s;u++){const v=g.charCodeAt(l+u);if(v!==a.charCodeAt(n+u))break;v===S&&(c=u)}if(u===s)if(t>s){if(a.charCodeAt(n+u)===S)return a.slice(n+u+1);if(u===0)return a.slice(n+u)}else o>s&&(g.charCodeAt(l+u)===S?c=u:u===0&&(c=0));let f="";for(u=l+c+1;u<=r;++u)(u===r||g.charCodeAt(u)===S)&&(f+=f.length===0?"..":"/..");return`${f}${a.slice(n+c)}`},toNamespacedPath(g){return g},dirname(g){if(p(g,"path"),g.length===0)return".";const a=g.charCodeAt(0)===S;let l=-1,r=!0;for(let o=g.length-1;o>=1;--o)if(g.charCodeAt(o)===S){if(!r){l=o;break}}else r=!1;return l===-1?a?"/":".":a&&l===1?"//":g.slice(0,l)},basename(g,a){a!==void 0&&p(a,"ext"),p(g,"path");let l=0,r=-1,o=!0,n;if(a!==void 0&&a.length>0&&a.length<=g.length){if(a===g)return"";let t=a.length-1,s=-1;for(n=g.length-1;n>=0;--n){const c=g.charCodeAt(n);if(c===S){if(!o){l=n+1;break}}else s===-1&&(o=!1,s=n+1),t>=0&&(c===a.charCodeAt(t)?--t==-1&&(r=n):(t=-1,r=s))}return l===r?r=s:r===-1&&(r=g.length),g.slice(l,r)}for(n=g.length-1;n>=0;--n)if(g.charCodeAt(n)===S){if(!o){l=n+1;break}}else r===-1&&(o=!1,r=n+1);return r===-1?"":g.slice(l,r)},extname(g){p(g,"path");let a=-1,l=0,r=-1,o=!0,n=0;for(let t=g.length-1;t>=0;--t){const s=g.charCodeAt(t);if(s===S){if(!o){l=t+1;break}continue}r===-1&&(o=!1,r=t+1),s===P?a===-1?a=t:n!==1&&(n=1):a!==-1&&(n=-1)}return a===-1||r===-1||n===0||n===1&&a===r-1&&a===l+1?"":g.slice(a,r)},format:b.bind(null,"/"),parse(g){p(g,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(g.length===0)return a;const l=g.charCodeAt(0)===S;let r;l?(a.root="/",r=1):r=0;let o=-1,n=0,t=-1,s=!0,c=g.length-1,u=0;for(;c>=r;--c){const f=g.charCodeAt(c);if(f===S){if(!s){n=c+1;break}continue}t===-1&&(s=!1,t=c+1),f===P?o===-1?o=c:u!==1&&(u=1):o!==-1&&(u=-1)}if(t!==-1){const f=n===0&&l?1:n;o===-1||u===0||u===1&&o===t-1&&o===n+1?a.base=a.name=g.slice(f,t):(a.name=g.slice(f,o),a.base=g.slice(f,t),a.ext=g.slice(o,t))}return n>0?a.dir=g.slice(0,n-1):l&&(a.dir="/"),a},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=R.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=R.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=R.platform==="win32"?e.win32.join:e.posix.join,e.resolve=R.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=R.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=R.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=R.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=R.platform==="win32"?e.win32.extname:e.posix.extname,e.format=R.platform==="win32"?e.win32.format:e.posix.format,e.parse=R.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=R.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=R.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=R.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(te[102],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var R;(function(k){k[k.stdout=0]="stdout",k[k.stderr=1]="stderr"})(R=e.Source||(e.Source={}));var L;(function(k){k[k.Success=0]="Success",k[k.Unknown=1]="Unknown",k[k.AccessDenied=2]="AccessDenied",k[k.ProcessNotFound=3]="ProcessNotFound"})(L=e.TerminateResponseCode||(e.TerminateResponseCode={}));function D(k,...i){const P=i.reduce((I,E)=>(I[E]=!0,I),{}),S=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(k).filter(I=>!P[I]).forEach(I=>{for(let E=0;E<S.length;E++)if(I.search(S[E])!==-1){delete k[I];break}})}e.sanitizeProcessEnvironment=D}),function(X,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var R=e();for(var L in R)(typeof exports=="object"?exports:X)[L]=R[L]}}(typeof self!="undefined"?self:this,function(){return function(X){var e={};function R(L){if(e[L])return e[L].exports;var D=e[L]={i:L,l:!1,exports:{}};return X[L].call(D.exports,D,D.exports,R),D.l=!0,D.exports}return R.m=X,R.c=e,R.d=function(L,D,k){R.o(L,D)||Object.defineProperty(L,D,{enumerable:!0,get:k})},R.r=function(L){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(L,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(L,"__esModule",{value:!0})},R.t=function(L,D){if(1&D&&(L=R(L)),8&D||4&D&&typeof L=="object"&&L&&L.__esModule)return L;var k=Object.create(null);if(R.r(k),Object.defineProperty(k,"default",{enumerable:!0,value:L}),2&D&&typeof L!="string")for(var i in L)R.d(k,i,function(P){return L[P]}.bind(null,i));return k},R.n=function(L){var D=L&&L.__esModule?function(){return L.default}:function(){return L};return R.d(D,"a",D),D},R.o=function(L,D){return Object.prototype.hasOwnProperty.call(L,D)},R.p="",R(R.s=0)}([function(X,e,R){(function(L){var D;e=X.exports=Z,D=typeof L=="object"&&L.env&&L.env.NODE_DEBUG&&/\bsemver\b/i.test(L.env.NODE_DEBUG)?function(){var ee=Array.prototype.slice.call(arguments,0);ee.unshift("SEMVER"),console.log.apply(console,ee)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var k=256,i=Number.MAX_SAFE_INTEGER||9007199254740991,P=e.re=[],S=e.src=[],C=0,I=C++;S[I]="0|[1-9]\\d*";var E=C++;S[E]="[0-9]+";var d=C++;S[d]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var p=C++;S[p]="("+S[I]+")\\.("+S[I]+")\\.("+S[I]+")";var h=C++;S[h]="("+S[E]+")\\.("+S[E]+")\\.("+S[E]+")";var w=C++;S[w]="(?:"+S[I]+"|"+S[d]+")";var y=C++;S[y]="(?:"+S[E]+"|"+S[d]+")";var m=C++;S[m]="(?:-("+S[w]+"(?:\\."+S[w]+")*))";var b=C++;S[b]="(?:-?("+S[y]+"(?:\\."+S[y]+")*))";var g=C++;S[g]="[0-9A-Za-z-]+";var a=C++;S[a]="(?:\\+("+S[g]+"(?:\\."+S[g]+")*))";var l=C++,r="v?"+S[p]+S[m]+"?"+S[a]+"?";S[l]="^"+r+"$";var o="[v=\\s]*"+S[h]+S[b]+"?"+S[a]+"?",n=C++;S[n]="^"+o+"$";var t=C++;S[t]="((?:<|>)?=?)";var s=C++;S[s]=S[E]+"|x|X|\\*";var c=C++;S[c]=S[I]+"|x|X|\\*";var u=C++;S[u]="[v=\\s]*("+S[c]+")(?:\\.("+S[c]+")(?:\\.("+S[c]+")(?:"+S[m]+")?"+S[a]+"?)?)?";var f=C++;S[f]="[v=\\s]*("+S[s]+")(?:\\.("+S[s]+")(?:\\.("+S[s]+")(?:"+S[b]+")?"+S[a]+"?)?)?";var v=C++;S[v]="^"+S[t]+"\\s*"+S[u]+"$";var T=C++;S[T]="^"+S[t]+"\\s*"+S[f]+"$";var O=C++;S[O]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var U=C++;S[U]="(?:~>?)";var W=C++;S[W]="(\\s*)"+S[U]+"\\s+",P[W]=new RegExp(S[W],"g");var N=C++;S[N]="^"+S[U]+S[u]+"$";var A=C++;S[A]="^"+S[U]+S[f]+"$";var z=C++;S[z]="(?:\\^)";var _=C++;S[_]="(\\s*)"+S[z]+"\\s+",P[_]=new RegExp(S[_],"g");var M=C++;S[M]="^"+S[z]+S[u]+"$";var q=C++;S[q]="^"+S[z]+S[f]+"$";var B=C++;S[B]="^"+S[t]+"\\s*("+o+")$|^$";var j=C++;S[j]="^"+S[t]+"\\s*("+r+")$|^$";var $=C++;S[$]="(\\s*)"+S[t]+"\\s*("+o+"|"+S[u]+")",P[$]=new RegExp(S[$],"g");var K=C++;S[K]="^\\s*("+S[u]+")\\s+-\\s+("+S[u]+")\\s*$";var F=C++;S[F]="^\\s*("+S[f]+")\\s+-\\s+("+S[f]+")\\s*$";var x=C++;S[x]="(<|>)?=?\\s*\\*";for(var V=0;V<35;V++)D(V,S[V]),P[V]||(P[V]=new RegExp(S[V]));function Q(ee,oe){if(ee instanceof Z)return ee;if(typeof ee!="string"||ee.length>k||!(oe?P[n]:P[l]).test(ee))return null;try{return new Z(ee,oe)}catch(ae){return null}}function Z(ee,oe){if(ee instanceof Z){if(ee.loose===oe)return ee;ee=ee.version}else if(typeof ee!="string")throw new TypeError("Invalid Version: "+ee);if(ee.length>k)throw new TypeError("version is longer than "+k+" characters");if(!(this instanceof Z))return new Z(ee,oe);D("SemVer",ee,oe),this.loose=oe;var ae=ee.trim().match(oe?P[n]:P[l]);if(!ae)throw new TypeError("Invalid Version: "+ee);if(this.raw=ee,this.major=+ae[1],this.minor=+ae[2],this.patch=+ae[3],this.major>i||this.major<0)throw new TypeError("Invalid major version");if(this.minor>i||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>i||this.patch<0)throw new TypeError("Invalid patch version");ae[4]?this.prerelease=ae[4].split(".").map(function(ve){if(/^[0-9]+$/.test(ve)){var we=+ve;if(we>=0&&we<i)return we}return ve}):this.prerelease=[],this.build=ae[5]?ae[5].split("."):[],this.format()}e.parse=Q,e.valid=function(ee,oe){var ae=Q(ee,oe);return ae?ae.version:null},e.clean=function(ee,oe){var ae=Q(ee.trim().replace(/^[=v]+/,""),oe);return ae?ae.version:null},e.SemVer=Z,Z.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Z.prototype.toString=function(){return this.version},Z.prototype.compare=function(ee){return D("SemVer.compare",this.version,this.loose,ee),ee instanceof Z||(ee=new Z(ee,this.loose)),this.compareMain(ee)||this.comparePre(ee)},Z.prototype.compareMain=function(ee){return ee instanceof Z||(ee=new Z(ee,this.loose)),H(this.major,ee.major)||H(this.minor,ee.minor)||H(this.patch,ee.patch)},Z.prototype.comparePre=function(ee){if(ee instanceof Z||(ee=new Z(ee,this.loose)),this.prerelease.length&&!ee.prerelease.length)return-1;if(!this.prerelease.length&&ee.prerelease.length)return 1;if(!this.prerelease.length&&!ee.prerelease.length)return 0;var oe=0;do{var ae=this.prerelease[oe],ve=ee.prerelease[oe];if(D("prerelease compare",oe,ae,ve),ae===void 0&&ve===void 0)return 0;if(ve===void 0)return 1;if(ae===void 0)return-1;if(ae!==ve)return H(ae,ve)}while(++oe)},Z.prototype.inc=function(ee,oe){switch(ee){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",oe);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",oe);break;case"prepatch":this.prerelease.length=0,this.inc("patch",oe),this.inc("pre",oe);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",oe),this.inc("pre",oe);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ae=this.prerelease.length;--ae>=0;)typeof this.prerelease[ae]=="number"&&(this.prerelease[ae]++,ae=-2);ae===-1&&this.prerelease.push(0)}oe&&(this.prerelease[0]===oe?isNaN(this.prerelease[1])&&(this.prerelease=[oe,0]):this.prerelease=[oe,0]);break;default:throw new Error("invalid increment argument: "+ee)}return this.format(),this.raw=this.version,this},e.inc=function(ee,oe,ae,ve){typeof ae=="string"&&(ve=ae,ae=void 0);try{return new Z(ee,ae).inc(oe,ve).version}catch(we){return null}},e.diff=function(ee,oe){if(le(ee,oe))return null;var ae=Q(ee),ve=Q(oe);if(ae.prerelease.length||ve.prerelease.length){for(var we in ae)if((we==="major"||we==="minor"||we==="patch")&&ae[we]!==ve[we])return"pre"+we;return"prerelease"}for(var we in ae)if((we==="major"||we==="minor"||we==="patch")&&ae[we]!==ve[we])return we},e.compareIdentifiers=H;var G=/^[0-9]+$/;function H(ee,oe){var ae=G.test(ee),ve=G.test(oe);return ae&&ve&&(ee=+ee,oe=+oe),ae&&!ve?-1:ve&&!ae?1:ee<oe?-1:ee>oe?1:0}function re(ee,oe,ae){return new Z(ee,ae).compare(new Z(oe,ae))}function ie(ee,oe,ae){return re(ee,oe,ae)>0}function ce(ee,oe,ae){return re(ee,oe,ae)<0}function le(ee,oe,ae){return re(ee,oe,ae)===0}function de(ee,oe,ae){return re(ee,oe,ae)!==0}function pe(ee,oe,ae){return re(ee,oe,ae)>=0}function be(ee,oe,ae){return re(ee,oe,ae)<=0}function Ie(ee,oe,ae,ve){var we;switch(oe){case"===":typeof ee=="object"&&(ee=ee.version),typeof ae=="object"&&(ae=ae.version),we=ee===ae;break;case"!==":typeof ee=="object"&&(ee=ee.version),typeof ae=="object"&&(ae=ae.version),we=ee!==ae;break;case"":case"=":case"==":we=le(ee,ae,ve);break;case"!=":we=de(ee,ae,ve);break;case">":we=ie(ee,ae,ve);break;case">=":we=pe(ee,ae,ve);break;case"<":we=ce(ee,ae,ve);break;case"<=":we=be(ee,ae,ve);break;default:throw new TypeError("Invalid operator: "+oe)}return we}function Se(ee,oe){if(ee instanceof Se){if(ee.loose===oe)return ee;ee=ee.value}if(!(this instanceof Se))return new Se(ee,oe);D("comparator",ee,oe),this.loose=oe,this.parse(ee),this.semver===ke?this.value="":this.value=this.operator+this.semver.version,D("comp",this)}e.rcompareIdentifiers=function(ee,oe){return H(oe,ee)},e.major=function(ee,oe){return new Z(ee,oe).major},e.minor=function(ee,oe){return new Z(ee,oe).minor},e.patch=function(ee,oe){return new Z(ee,oe).patch},e.compare=re,e.compareLoose=function(ee,oe){return re(ee,oe,!0)},e.rcompare=function(ee,oe,ae){return re(oe,ee,ae)},e.sort=function(ee,oe){return ee.sort(function(ae,ve){return e.compare(ae,ve,oe)})},e.rsort=function(ee,oe){return ee.sort(function(ae,ve){return e.rcompare(ae,ve,oe)})},e.gt=ie,e.lt=ce,e.eq=le,e.neq=de,e.gte=pe,e.lte=be,e.cmp=Ie,e.Comparator=Se;var ke={};function Pe(ee,oe){if(ee instanceof Pe)return ee.loose===oe?ee:new Pe(ee.raw,oe);if(ee instanceof Se)return new Pe(ee.value,oe);if(!(this instanceof Pe))return new Pe(ee,oe);if(this.loose=oe,this.raw=ee,this.set=ee.split(/\s*\|\|\s*/).map(function(ae){return this.parseRange(ae.trim())},this).filter(function(ae){return ae.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ee);this.format()}function Ue(ee){return!ee||ee.toLowerCase()==="x"||ee==="*"}function qe(ee,oe,ae,ve,we,_e,Re,Y,se,ue,fe,ge,Ce){return((oe=Ue(ae)?"":Ue(ve)?">="+ae+".0.0":Ue(we)?">="+ae+"."+ve+".0":">="+oe)+" "+(Y=Ue(se)?"":Ue(ue)?"<"+(+se+1)+".0.0":Ue(fe)?"<"+se+"."+(+ue+1)+".0":ge?"<="+se+"."+ue+"."+fe+"-"+ge:"<="+Y)).trim()}function Fe(ee,oe){for(var ae=0;ae<ee.length;ae++)if(!ee[ae].test(oe))return!1;if(oe.prerelease.length){for(ae=0;ae<ee.length;ae++)if(D(ee[ae].semver),ee[ae].semver!==ke&&ee[ae].semver.prerelease.length>0){var ve=ee[ae].semver;if(ve.major===oe.major&&ve.minor===oe.minor&&ve.patch===oe.patch)return!0}return!1}return!0}function ze(ee,oe,ae){try{oe=new Pe(oe,ae)}catch(ve){return!1}return oe.test(ee)}function xe(ee,oe,ae,ve){var we,_e,Re,Y,se;switch(ee=new Z(ee,ve),oe=new Pe(oe,ve),ae){case">":we=ie,_e=be,Re=ce,Y=">",se=">=";break;case"<":we=ce,_e=pe,Re=ie,Y="<",se="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ze(ee,oe,ve))return!1;for(var ue=0;ue<oe.set.length;++ue){var fe=oe.set[ue],ge=null,Ce=null;if(fe.forEach(function(Te){Te.semver===ke&&(Te=new Se(">=0.0.0")),ge=ge||Te,Ce=Ce||Te,we(Te.semver,ge.semver,ve)?ge=Te:Re(Te.semver,Ce.semver,ve)&&(Ce=Te)}),ge.operator===Y||ge.operator===se||(!Ce.operator||Ce.operator===Y)&&_e(ee,Ce.semver)||Ce.operator===se&&Re(ee,Ce.semver))return!1}return!0}Se.prototype.parse=function(ee){var oe=this.loose?P[B]:P[j],ae=ee.match(oe);if(!ae)throw new TypeError("Invalid comparator: "+ee);this.operator=ae[1],this.operator==="="&&(this.operator=""),ae[2]?this.semver=new Z(ae[2],this.loose):this.semver=ke},Se.prototype.toString=function(){return this.value},Se.prototype.test=function(ee){return D("Comparator.test",ee,this.loose),this.semver===ke||(typeof ee=="string"&&(ee=new Z(ee,this.loose)),Ie(ee,this.operator,this.semver,this.loose))},Se.prototype.intersects=function(ee,oe){if(!(ee instanceof Se))throw new TypeError("a Comparator is required");var ae;if(this.operator==="")return ae=new Pe(ee.value,oe),ze(this.value,ae,oe);if(ee.operator==="")return ae=new Pe(this.value,oe),ze(ee.semver,ae,oe);var ve=!(this.operator!==">="&&this.operator!==">"||ee.operator!==">="&&ee.operator!==">"),we=!(this.operator!=="<="&&this.operator!=="<"||ee.operator!=="<="&&ee.operator!=="<"),_e=this.semver.version===ee.semver.version,Re=!(this.operator!==">="&&this.operator!=="<="||ee.operator!==">="&&ee.operator!=="<="),Y=Ie(this.semver,"<",ee.semver,oe)&&(this.operator===">="||this.operator===">")&&(ee.operator==="<="||ee.operator==="<"),se=Ie(this.semver,">",ee.semver,oe)&&(this.operator==="<="||this.operator==="<")&&(ee.operator===">="||ee.operator===">");return ve||we||_e&&Re||Y||se},e.Range=Pe,Pe.prototype.format=function(){return this.range=this.set.map(function(ee){return ee.join(" ").trim()}).join("||").trim(),this.range},Pe.prototype.toString=function(){return this.range},Pe.prototype.parseRange=function(ee){var oe=this.loose;ee=ee.trim(),D("range",ee,oe);var ae=oe?P[F]:P[K];ee=ee.replace(ae,qe),D("hyphen replace",ee),ee=ee.replace(P[$],"$1$2$3"),D("comparator trim",ee,P[$]),ee=(ee=(ee=ee.replace(P[W],"$1~")).replace(P[_],"$1^")).split(/\s+/).join(" ");var ve=oe?P[B]:P[j],we=ee.split(" ").map(function(_e){return function(Re,Y){return D("comp",Re),Re=function(se,ue){return se.trim().split(/\s+/).map(function(fe){return function(ge,Ce){D("caret",ge,Ce);var Te=Ce?P[q]:P[M];return ge.replace(Te,function(Le,ye,Ee,De,Ae){var Me;return D("caret",ge,Le,ye,Ee,De,Ae),Ue(ye)?Me="":Ue(Ee)?Me=">="+ye+".0.0 <"+(+ye+1)+".0.0":Ue(De)?Me=ye==="0"?">="+ye+"."+Ee+".0 <"+ye+"."+(+Ee+1)+".0":">="+ye+"."+Ee+".0 <"+(+ye+1)+".0.0":Ae?(D("replaceCaret pr",Ae),Ae.charAt(0)!=="-"&&(Ae="-"+Ae),Me=ye==="0"?Ee==="0"?">="+ye+"."+Ee+"."+De+Ae+" <"+ye+"."+Ee+"."+(+De+1):">="+ye+"."+Ee+"."+De+Ae+" <"+ye+"."+(+Ee+1)+".0":">="+ye+"."+Ee+"."+De+Ae+" <"+(+ye+1)+".0.0"):(D("no pr"),Me=ye==="0"?Ee==="0"?">="+ye+"."+Ee+"."+De+" <"+ye+"."+Ee+"."+(+De+1):">="+ye+"."+Ee+"."+De+" <"+ye+"."+(+Ee+1)+".0":">="+ye+"."+Ee+"."+De+" <"+(+ye+1)+".0.0"),D("caret return",Me),Me})}(fe,ue)}).join(" ")}(Re,Y),D("caret",Re),Re=function(se,ue){return se.trim().split(/\s+/).map(function(fe){return function(ge,Ce){var Te=Ce?P[A]:P[N];return ge.replace(Te,function(Le,ye,Ee,De,Ae){var Me;return D("tilde",ge,Le,ye,Ee,De,Ae),Ue(ye)?Me="":Ue(Ee)?Me=">="+ye+".0.0 <"+(+ye+1)+".0.0":Ue(De)?Me=">="+ye+"."+Ee+".0 <"+ye+"."+(+Ee+1)+".0":Ae?(D("replaceTilde pr",Ae),Ae.charAt(0)!=="-"&&(Ae="-"+Ae),Me=">="+ye+"."+Ee+"."+De+Ae+" <"+ye+"."+(+Ee+1)+".0"):Me=">="+ye+"."+Ee+"."+De+" <"+ye+"."+(+Ee+1)+".0",D("tilde return",Me),Me})}(fe,ue)}).join(" ")}(Re,Y),D("tildes",Re),Re=function(se,ue){return D("replaceXRanges",se,ue),se.split(/\s+/).map(function(fe){return function(ge,Ce){ge=ge.trim();var Te=Ce?P[T]:P[v];return ge.replace(Te,function(Le,ye,Ee,De,Ae,Me){D("xRange",ge,Le,ye,Ee,De,Ae,Me);var Xe=Ue(Ee),Ke=Xe||Ue(De),Ve=Ke||Ue(Ae);return ye==="="&&Ve&&(ye=""),Xe?Le=ye===">"||ye==="<"?"<0.0.0":"*":ye&&Ve?(Ke&&(De=0),Ve&&(Ae=0),ye===">"?(ye=">=",Ke?(Ee=+Ee+1,De=0,Ae=0):Ve&&(De=+De+1,Ae=0)):ye==="<="&&(ye="<",Ke?Ee=+Ee+1:De=+De+1),Le=ye+Ee+"."+De+"."+Ae):Ke?Le=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":Ve&&(Le=">="+Ee+"."+De+".0 <"+Ee+"."+(+De+1)+".0"),D("xRange return",Le),Le})}(fe,ue)}).join(" ")}(Re,Y),D("xrange",Re),Re=function(se,ue){return D("replaceStars",se,ue),se.trim().replace(P[x],"")}(Re,Y),D("stars",Re),Re}(_e,oe)}).join(" ").split(/\s+/);return this.loose&&(we=we.filter(function(_e){return!!_e.match(ve)})),we=we.map(function(_e){return new Se(_e,oe)})},Pe.prototype.intersects=function(ee,oe){if(!(ee instanceof Pe))throw new TypeError("a Range is required");return this.set.some(function(ae){return ae.every(function(ve){return ee.set.some(function(we){return we.every(function(_e){return ve.intersects(_e,oe)})})})})},e.toComparators=function(ee,oe){return new Pe(ee,oe).set.map(function(ae){return ae.map(function(ve){return ve.value}).join(" ").trim().split(" ")})},Pe.prototype.test=function(ee){if(!ee)return!1;typeof ee=="string"&&(ee=new Z(ee,this.loose));for(var oe=0;oe<this.set.length;oe++)if(Fe(this.set[oe],ee))return!0;return!1},e.satisfies=ze,e.maxSatisfying=function(ee,oe,ae){var ve=null,we=null;try{var _e=new Pe(oe,ae)}catch(Re){return null}return ee.forEach(function(Re){_e.test(Re)&&(ve&&we.compare(Re)!==-1||(we=new Z(ve=Re,ae)))}),ve},e.minSatisfying=function(ee,oe,ae){var ve=null,we=null;try{var _e=new Pe(oe,ae)}catch(Re){return null}return ee.forEach(function(Re){_e.test(Re)&&(ve&&we.compare(Re)!==1||(we=new Z(ve=Re,ae)))}),ve},e.validRange=function(ee,oe){try{return new Pe(ee,oe).range||"*"}catch(ae){return null}},e.ltr=function(ee,oe,ae){return xe(ee,oe,"<",ae)},e.gtr=function(ee,oe,ae){return xe(ee,oe,">",ae)},e.outside=xe,e.prerelease=function(ee,oe){var ae=Q(ee,oe);return ae&&ae.prerelease.length?ae.prerelease:null},e.intersects=function(ee,oe,ae){return ee=new Pe(ee,ae),oe=new Pe(oe,ae),ee.intersects(oe)},e.coerce=function(ee){if(ee instanceof Z)return ee;if(typeof ee!="string")return null;var oe=ee.match(P[O]);return oe==null?null:Q((oe[1]||"0")+"."+(oe[2]||"0")+"."+(oe[3]||"0"))}}).call(this,R(1))},function(X,e){var R,L,D=X.exports={};function k(){throw new Error("setTimeout has not been defined")}function i(){throw new Error("clearTimeout has not been defined")}function P(y){if(R===setTimeout)return setTimeout(y,0);if((R===k||!R)&&setTimeout)return R=setTimeout,setTimeout(y,0);try{return R(y,0)}catch(m){try{return R.call(null,y,0)}catch(b){return R.call(this,y,0)}}}(function(){try{R=typeof setTimeout=="function"?setTimeout:k}catch(y){R=k}try{L=typeof clearTimeout=="function"?clearTimeout:i}catch(y){L=i}})();var S,C=[],I=!1,E=-1;function d(){I&&S&&(I=!1,S.length?C=S.concat(C):E=-1,C.length&&p())}function p(){if(!I){var y=P(d);I=!0;for(var m=C.length;m;){for(S=C,C=[];++E<m;)S&&S[E].run();E=-1,m=C.length}S=null,I=!1,function(b){if(L===clearTimeout)return clearTimeout(b);if((L===i||!L)&&clearTimeout)return L=clearTimeout,clearTimeout(b);try{L(b)}catch(g){try{return L.call(null,b)}catch(a){return L.call(this,b)}}}(y)}}function h(y,m){this.fun=y,this.array=m}function w(){}D.nextTick=function(y){var m=new Array(arguments.length-1);if(arguments.length>1)for(var b=1;b<arguments.length;b++)m[b-1]=arguments[b];C.push(new h(y,m)),C.length!==1||I||P(p)},h.prototype.run=function(){this.fun.apply(null,this.array)},D.title="browser",D.browser=!0,D.env={},D.argv=[],D.version="",D.versions={},D.on=w,D.addListener=w,D.once=w,D.off=w,D.removeListener=w,D.removeAllListeners=w,D.emit=w,D.prependListener=w,D.prependOnceListener=w,D.listeners=function(y){return[]},D.binding=function(y){throw new Error("process.binding is not supported")},D.cwd=function(){return"/"},D.chdir=function(y){throw new Error("process.chdir is not supported")},D.umask=function(){return 0}}])}),define(te[103],ne([0,1]),function(X,e){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class L{constructor(P,S,C){this.level=P,this.key=S,this.value=C,this.forward=[]}}const D=void 0;class k{constructor(P,S=2**16){this.comparator=P,this[R]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(S)|0),this._header=new L(this._maxLevel,D,D)}get size(){return this._size}clear(){this._header=new L(this._maxLevel,D,D)}has(P){return Boolean(k._search(this,P,this.comparator))}get(P){return k._search(this,P,this.comparator)?.value}set(P,S){return k._insert(this,P,S,this.comparator)&&(this._size+=1),this}delete(P){const S=k._delete(this,P,this.comparator);return S&&(this._size-=1),S}forEach(P,S){let C=this._header.forward[0];for(;C;)P.call(S,C.value,C.key,this),C=C.forward[0]}[(R=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let P=this._header.forward[0];for(;P;)yield[P.key,P.value],P=P.forward[0]}*keys(){let P=this._header.forward[0];for(;P;)yield P.key,P=P.forward[0]}*values(){let P=this._header.forward[0];for(;P;)yield P.value,P=P.forward[0]}toString(){let P="[SkipList]:",S=this._header.forward[0];for(;S;)P+=`node(${S.key}, ${S.value}, lvl:${S.level})`,S=S.forward[0];return P}static _search(P,S,C){let I=P._header;for(let E=P._level-1;E>=0;E--)for(;I.forward[E]&&C(I.forward[E].key,S)<0;)I=I.forward[E];if(I=I.forward[0],I&&C(I.key,S)===0)return I}static _insert(P,S,C,I){let E=[],d=P._header;for(let p=P._level-1;p>=0;p--){for(;d.forward[p]&&I(d.forward[p].key,S)<0;)d=d.forward[p];E[p]=d}if(d=d.forward[0],d&&I(d.key,S)===0)return d.value=C,!1;{let p=k._randomLevel(P);if(p>P._level){for(let h=P._level;h<p;h++)E[h]=P._header;P._level=p}d=new L(p,S,C);for(let h=0;h<p;h++)d.forward[h]=E[h].forward[h],E[h].forward[h]=d;return!0}}static _randomLevel(P,S=.5){let C=1;for(;Math.random()<S&&C<P._maxLevel;)C+=1;return C}static _delete(P,S,C){let I=[],E=P._header;for(let d=P._level-1;d>=0;d--){for(;E.forward[d]&&C(E.forward[d].key,S)<0;)E=E.forward[d];I[d]=E}if(E=E.forward[0],!E||C(E.key,S)!==0)return!1;for(let d=0;d<P._level&&I[d].forward[d]===E;d++)I[d].forward[d]=E.forward[d];for(;P._level>0&&P._header.forward[P._level-1]===D;)P._level-=1;return!0}}e.SkipList=k}),define(te[104],ne([0,1,4]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const L=R.globals.performance&&typeof R.globals.performance.now=="function";class D{constructor(i){this._highResolution=L&&i,this._startTime=this._now(),this._stopTime=-1}static create(i=!0){return new D(i)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?R.globals.performance.now():Date.now()}}e.StopWatch=D}),define(te[3],ne([0,1,9,68,2,101,104]),function(X,e,R,L,D,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var P;(function(a){a.None=()=>D.Disposable.None;function l(_){return(M,q=null,B)=>{let j=!1,$;return $=_(K=>{if(!j)return $?$.dispose():j=!0,M.call(q,K)},null,B),j&&$.dispose(),$}}a.once=l;function r(_,M){return u((q,B=null,j)=>_($=>q.call(B,M($)),null,j))}a.map=r;function o(_,M){return u((q,B=null,j)=>_($=>{M($),q.call(B,$)},null,j))}a.forEach=o;function n(_,M){return u((q,B=null,j)=>_($=>M($)&&q.call(B,$),null,j))}a.filter=n;function t(_){return _}a.signal=t;function s(..._){return(M,q=null,B)=>(0,D.combinedDisposable)(..._.map(j=>j($=>M.call(q,$),null,B)))}a.any=s;function c(_,M,q){let B=q;return r(_,j=>(B=M(B,j),B))}a.reduce=c;function u(_){let M;const q=new d({onFirstListenerAdd(){M=_(q.fire,q)},onLastListenerRemove(){M.dispose()}});return q.event}function f(_,M,q=100,B=!1,j){let $,K,F,x=0;const V=new d({leakWarningThreshold:j,onFirstListenerAdd(){$=_(Q=>{x++,K=M(K,Q),B&&!F&&(V.fire(K),K=void 0),clearTimeout(F),F=setTimeout(()=>{const Z=K;K=void 0,F=void 0,(!B||x>1)&&V.fire(Z),x=0},q)})},onLastListenerRemove(){$.dispose()}});return V.event}a.debounce=f;function v(_,M=(q,B)=>q===B){let q=!0,B;return n(_,j=>{const $=q||!M(j,B);return q=!1,B=j,$})}a.latch=v;function T(_,M){return[a.filter(_,M),a.filter(_,q=>!M(q))]}a.split=T;function O(_,M=!1,q=[]){let B=q.slice(),j=_(F=>{B?B.push(F):K.fire(F)});const $=()=>{B&&B.forEach(F=>K.fire(F)),B=null},K=new d({onFirstListenerAdd(){j||(j=_(F=>K.fire(F)))},onFirstListenerDidAdd(){B&&(M?setTimeout($):$())},onLastListenerRemove(){j&&j.dispose(),j=null}});return K.event}a.buffer=O;class U{constructor(M){this.event=M}map(M){return new U(r(this.event,M))}forEach(M){return new U(o(this.event,M))}filter(M){return new U(n(this.event,M))}reduce(M,q){return new U(c(this.event,M,q))}latch(){return new U(v(this.event))}debounce(M,q=100,B=!1,j){return new U(f(this.event,M,q,B,j))}on(M,q,B){return this.event(M,q,B)}once(M,q,B){return l(this.event)(M,q,B)}}function W(_){return new U(_)}a.chain=W;function N(_,M,q=B=>B){const B=(...F)=>K.fire(q(...F)),j=()=>_.on(M,B),$=()=>_.removeListener(M,B),K=new d({onFirstListenerAdd:j,onLastListenerRemove:$});return K.event}a.fromNodeEventEmitter=N;function A(_,M,q=B=>B){const B=(...F)=>K.fire(q(...F)),j=()=>_.addEventListener(M,B),$=()=>_.removeEventListener(M,B),K=new d({onFirstListenerAdd:j,onLastListenerRemove:$});return K.event}a.fromDOMEventEmitter=A;function z(_){return new Promise(M=>l(_)(M))}a.toPromise=z})(P=e.Event||(e.Event={}));class S{constructor(l){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${l}_${S._idPool++}`}start(l){this._stopWatch=new i.StopWatch(!0),this._listenerCount=l}stop(){if(this._stopWatch){const l=this._stopWatch.elapsed();this._elapsedOverall+=l,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${l.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}S._idPool=0;let C=-1;function I(a){const l=C;return C=a,{dispose(){C=l}}}e.setGlobalLeakWarningThreshold=I;class E{constructor(l,r=Math.random().toString(18).slice(2,5)){this.customThreshold=l,this.name=r,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(l){let r=C;if(typeof this.customThreshold=="number"&&(r=this.customThreshold),r<=0||l<r)return;this._stacks||(this._stacks=new Map);const o=new Error().stack.split(`
`).slice(3).join(`
`),n=this._stacks.get(o)||0;if(this._stacks.set(o,n+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=r*.5;let t,s=0;for(const[c,u]of this._stacks)(!t||s<u)&&(t=c,s=u);console.warn(`[${this.name}] potential listener LEAK detected, having ${l} listeners already. MOST frequent listener (${s}):`),console.warn(t)}return()=>{const t=this._stacks.get(o)||0;this._stacks.set(o,t-1)}}}class d{constructor(l){this._disposed=!1,this._options=l,this._leakageMon=C>0?new E(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new S(this._options._profName):void 0}get event(){return this._event||(this._event=(l,r,o)=>{this._listeners||(this._listeners=new k.LinkedList);const n=this._listeners.isEmpty();n&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const t=this._listeners.push(r?[l,r]:l);n&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,l,r);const s=this._leakageMon?.check(this._listeners.size),c=(0,D.toDisposable)(()=>{s&&s(),this._disposed||(t(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return o instanceof D.DisposableStore?o.add(c):Array.isArray(o)&&o.push(c),c}),this._event}fire(l){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new k.LinkedList);for(let r of this._listeners)this._deliveryQueue.push([r,l]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[r,o]=this._deliveryQueue.shift();try{typeof r=="function"?r.call(void 0,o):r[0].call(r[1],o)}catch(n){(0,R.onUnexpectedError)(n)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=d;class p extends d{async fireAsync(l,r,o){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new k.LinkedList);for(const n of this._listeners)this._asyncDeliveryQueue.push([n,l]);for(;this._asyncDeliveryQueue.size>0&&!r.isCancellationRequested;){const[n,t]=this._asyncDeliveryQueue.shift(),s=[],c={...t,waitUntil:u=>{if(Object.isFrozen(s))throw new Error("waitUntil can NOT be called asynchronous");o&&(u=o(u,typeof n=="function"?n:n[0])),s.push(u)}};try{typeof n=="function"?n.call(void 0,c):n[0].call(n[1],c)}catch(u){(0,R.onUnexpectedError)(u);continue}Object.freeze(s),await Promise.allSettled(s).then(u=>{for(const f of u)f.status==="rejected"&&(0,R.onUnexpectedError)(f.reason)})}}}}e.AsyncEmitter=p;class h extends d{constructor(l){super(l);this._isPaused=0,this._eventQueue=new k.LinkedList,this._mergeFn=l?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const l=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(l))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(l){this._listeners&&(this._isPaused!==0?this._eventQueue.push(l):super.fire(l))}}e.PauseableEmitter=h;class w extends h{constructor(l){super(l);this._delay=l.delay??100}fire(l){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(l)}}e.DebounceEmitter=w;class y extends d{constructor(l){super(l);this._queuedEvents=[],this._mergeFn=l?.merge}fire(l){this._queuedEvents.push(l),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(r=>super.fire(r)),this._queuedEvents=[]})}}e.MicrotaskEmitter=y;class m{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new d({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(l){const r={event:l,listener:null};this.events.push(r),this.hasListeners&&this.hook(r);const o=()=>{this.hasListeners&&this.unhook(r);const n=this.events.indexOf(r);this.events.splice(n,1)};return(0,D.toDisposable)((0,L.once)(o))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(l=>this.hook(l))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(l=>this.unhook(l))}hook(l){l.listener=l.event(r=>this.emitter.fire(r))}unhook(l){l.listener&&l.listener.dispose(),l.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=m;class b{constructor(){this.buffers=[]}wrapEvent(l){return(r,o,n)=>l(t=>{const s=this.buffers[this.buffers.length-1];s?s.push(()=>r.call(o,t)):r.call(o,t)},void 0,n)}bufferEvents(l){const r=[];this.buffers.push(r);const o=l();return this.buffers.pop(),r.forEach(n=>n()),o}}e.EventBufferer=b;class g{constructor(){this.listening=!1,this.inputEvent=P.None,this.inputEventListener=D.Disposable.None,this.emitter=new d({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(l){this.inputEvent=l,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=l(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=g}),define(te[27],ne([0,1,3]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const L=Object.freeze(function(P,S){const C=setTimeout(P.bind(S),0);return{dispose(){clearTimeout(C)}}});var D;(function(P){function S(C){return C===P.None||C===P.Cancelled||C instanceof k?!0:!C||typeof C!="object"?!1:typeof C.isCancellationRequested=="boolean"&&typeof C.onCancellationRequested=="function"}P.isCancellationToken=S,P.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:R.Event.None}),P.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:L})})(D=e.CancellationToken||(e.CancellationToken={}));class k{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?L:(this._emitter||(this._emitter=new R.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class i{constructor(S){this._token=void 0,this._parentListener=void 0,this._parentListener=S&&S.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new k),this._token}cancel(){this._token?this._token instanceof k&&this._token.cancel():this._token=D.Cancelled}dispose(S=!1){S&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof k&&this._token.dispose():this._token=D.None}}e.CancellationTokenSource=i}),define(te[49],ne([0,1,3]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.iconRegistry=void 0;class L{constructor(){this._icons=new Map,this._onDidRegister=new R.Emitter}add(I){const E=this._icons.get(I.id);E?I.description?E.description=I.description:console.error(`Duplicate registration of codicon ${I.id}`):(this._icons.set(I.id,I),this._onDidRegister.fire(I))}get(I){return this._icons.get(I)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const D=new L;e.iconRegistry=D;function k(C){return C?C.replace(/\$\((.*?)\)/g,(I,E)=>` ${E} `).trim():""}e.getCodiconAriaLabel=k;class i{constructor(I,E,d){this.id=I,this.definition=E,this.description=d,D.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=i,i.add=new i("add",{fontCharacter:"\\ea60"}),i.plus=new i("plus",i.add.definition),i.gistNew=new i("gist-new",i.add.definition),i.repoCreate=new i("repo-create",i.add.definition),i.lightbulb=new i("lightbulb",{fontCharacter:"\\ea61"}),i.lightBulb=new i("light-bulb",{fontCharacter:"\\ea61"}),i.repo=new i("repo",{fontCharacter:"\\ea62"}),i.repoDelete=new i("repo-delete",{fontCharacter:"\\ea62"}),i.gistFork=new i("gist-fork",{fontCharacter:"\\ea63"}),i.repoForked=new i("repo-forked",{fontCharacter:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{fontCharacter:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),i.recordKeys=new i("record-keys",{fontCharacter:"\\ea65"}),i.keyboard=new i("keyboard",{fontCharacter:"\\ea65"}),i.tag=new i("tag",{fontCharacter:"\\ea66"}),i.tagAdd=new i("tag-add",{fontCharacter:"\\ea66"}),i.tagRemove=new i("tag-remove",{fontCharacter:"\\ea66"}),i.person=new i("person",{fontCharacter:"\\ea67"}),i.personFollow=new i("person-follow",{fontCharacter:"\\ea67"}),i.personOutline=new i("person-outline",{fontCharacter:"\\ea67"}),i.personFilled=new i("person-filled",{fontCharacter:"\\ea67"}),i.gitBranch=new i("git-branch",{fontCharacter:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{fontCharacter:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{fontCharacter:"\\ea68"}),i.sourceControl=new i("source-control",{fontCharacter:"\\ea68"}),i.mirror=new i("mirror",{fontCharacter:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{fontCharacter:"\\ea69"}),i.star=new i("star",{fontCharacter:"\\ea6a"}),i.starAdd=new i("star-add",{fontCharacter:"\\ea6a"}),i.starDelete=new i("star-delete",{fontCharacter:"\\ea6a"}),i.starEmpty=new i("star-empty",{fontCharacter:"\\ea6a"}),i.comment=new i("comment",{fontCharacter:"\\ea6b"}),i.commentAdd=new i("comment-add",{fontCharacter:"\\ea6b"}),i.alert=new i("alert",{fontCharacter:"\\ea6c"}),i.warning=new i("warning",{fontCharacter:"\\ea6c"}),i.search=new i("search",{fontCharacter:"\\ea6d"}),i.searchSave=new i("search-save",{fontCharacter:"\\ea6d"}),i.logOut=new i("log-out",{fontCharacter:"\\ea6e"}),i.signOut=new i("sign-out",{fontCharacter:"\\ea6e"}),i.logIn=new i("log-in",{fontCharacter:"\\ea6f"}),i.signIn=new i("sign-in",{fontCharacter:"\\ea6f"}),i.eye=new i("eye",{fontCharacter:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{fontCharacter:"\\ea70"}),i.eyeWatch=new i("eye-watch",{fontCharacter:"\\ea70"}),i.circleFilled=new i("circle-filled",{fontCharacter:"\\ea71"}),i.primitiveDot=new i("primitive-dot",{fontCharacter:"\\ea71"}),i.closeDirty=new i("close-dirty",{fontCharacter:"\\ea71"}),i.debugBreakpoint=new i("debug-breakpoint",{fontCharacter:"\\ea71"}),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),i.debugHint=new i("debug-hint",{fontCharacter:"\\ea71"}),i.primitiveSquare=new i("primitive-square",{fontCharacter:"\\ea72"}),i.edit=new i("edit",{fontCharacter:"\\ea73"}),i.pencil=new i("pencil",{fontCharacter:"\\ea73"}),i.info=new i("info",{fontCharacter:"\\ea74"}),i.issueOpened=new i("issue-opened",{fontCharacter:"\\ea74"}),i.gistPrivate=new i("gist-private",{fontCharacter:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{fontCharacter:"\\ea75"}),i.lock=new i("lock",{fontCharacter:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{fontCharacter:"\\ea75"}),i.close=new i("close",{fontCharacter:"\\ea76"}),i.removeClose=new i("remove-close",{fontCharacter:"\\ea76"}),i.x=new i("x",{fontCharacter:"\\ea76"}),i.repoSync=new i("repo-sync",{fontCharacter:"\\ea77"}),i.sync=new i("sync",{fontCharacter:"\\ea77"}),i.clone=new i("clone",{fontCharacter:"\\ea78"}),i.desktopDownload=new i("desktop-download",{fontCharacter:"\\ea78"}),i.beaker=new i("beaker",{fontCharacter:"\\ea79"}),i.microscope=new i("microscope",{fontCharacter:"\\ea79"}),i.vm=new i("vm",{fontCharacter:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{fontCharacter:"\\ea7a"}),i.file=new i("file",{fontCharacter:"\\ea7b"}),i.fileText=new i("file-text",{fontCharacter:"\\ea7b"}),i.more=new i("more",{fontCharacter:"\\ea7c"}),i.ellipsis=new i("ellipsis",{fontCharacter:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{fontCharacter:"\\ea7c"}),i.mailReply=new i("mail-reply",{fontCharacter:"\\ea7d"}),i.reply=new i("reply",{fontCharacter:"\\ea7d"}),i.organization=new i("organization",{fontCharacter:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{fontCharacter:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{fontCharacter:"\\ea7e"}),i.newFile=new i("new-file",{fontCharacter:"\\ea7f"}),i.fileAdd=new i("file-add",{fontCharacter:"\\ea7f"}),i.newFolder=new i("new-folder",{fontCharacter:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{fontCharacter:"\\ea80"}),i.trash=new i("trash",{fontCharacter:"\\ea81"}),i.trashcan=new i("trashcan",{fontCharacter:"\\ea81"}),i.history=new i("history",{fontCharacter:"\\ea82"}),i.clock=new i("clock",{fontCharacter:"\\ea82"}),i.folder=new i("folder",{fontCharacter:"\\ea83"}),i.fileDirectory=new i("file-directory",{fontCharacter:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{fontCharacter:"\\ea83"}),i.logoGithub=new i("logo-github",{fontCharacter:"\\ea84"}),i.markGithub=new i("mark-github",{fontCharacter:"\\ea84"}),i.github=new i("github",{fontCharacter:"\\ea84"}),i.terminal=new i("terminal",{fontCharacter:"\\ea85"}),i.console=new i("console",{fontCharacter:"\\ea85"}),i.repl=new i("repl",{fontCharacter:"\\ea85"}),i.zap=new i("zap",{fontCharacter:"\\ea86"}),i.symbolEvent=new i("symbol-event",{fontCharacter:"\\ea86"}),i.error=new i("error",{fontCharacter:"\\ea87"}),i.stop=new i("stop",{fontCharacter:"\\ea87"}),i.variable=new i("variable",{fontCharacter:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{fontCharacter:"\\ea88"}),i.array=new i("array",{fontCharacter:"\\ea8a"}),i.symbolArray=new i("symbol-array",{fontCharacter:"\\ea8a"}),i.symbolModule=new i("symbol-module",{fontCharacter:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{fontCharacter:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{fontCharacter:"\\ea8b"}),i.symbolObject=new i("symbol-object",{fontCharacter:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{fontCharacter:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{fontCharacter:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{fontCharacter:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{fontCharacter:"\\ea8f"}),i.symbolNull=new i("symbol-null",{fontCharacter:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{fontCharacter:"\\ea90"}),i.symbolNumber=new i("symbol-number",{fontCharacter:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{fontCharacter:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{fontCharacter:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{fontCharacter:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{fontCharacter:"\\ea92"}),i.symbolKey=new i("symbol-key",{fontCharacter:"\\ea93"}),i.symbolText=new i("symbol-text",{fontCharacter:"\\ea93"}),i.symbolReference=new i("symbol-reference",{fontCharacter:"\\ea94"}),i.goToFile=new i("go-to-file",{fontCharacter:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{fontCharacter:"\\ea95"}),i.symbolValue=new i("symbol-value",{fontCharacter:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{fontCharacter:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{fontCharacter:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{fontCharacter:"\\ea97"}),i.archive=new i("archive",{fontCharacter:"\\ea98"}),i.arrowBoth=new i("arrow-both",{fontCharacter:"\\ea99"}),i.arrowDown=new i("arrow-down",{fontCharacter:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{fontCharacter:"\\ea9b"}),i.arrowRight=new i("arrow-right",{fontCharacter:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{fontCharacter:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{fontCharacter:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{fontCharacter:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{fontCharacter:"\\eaa0"}),i.arrowUp=new i("arrow-up",{fontCharacter:"\\eaa1"}),i.bell=new i("bell",{fontCharacter:"\\eaa2"}),i.bold=new i("bold",{fontCharacter:"\\eaa3"}),i.book=new i("book",{fontCharacter:"\\eaa4"}),i.bookmark=new i("bookmark",{fontCharacter:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{fontCharacter:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),i.briefcase=new i("briefcase",{fontCharacter:"\\eaac"}),i.broadcast=new i("broadcast",{fontCharacter:"\\eaad"}),i.browser=new i("browser",{fontCharacter:"\\eaae"}),i.bug=new i("bug",{fontCharacter:"\\eaaf"}),i.calendar=new i("calendar",{fontCharacter:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{fontCharacter:"\\eab1"}),i.check=new i("check",{fontCharacter:"\\eab2"}),i.checklist=new i("checklist",{fontCharacter:"\\eab3"}),i.chevronDown=new i("chevron-down",{fontCharacter:"\\eab4"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition),i.chevronLeft=new i("chevron-left",{fontCharacter:"\\eab5"}),i.chevronRight=new i("chevron-right",{fontCharacter:"\\eab6"}),i.chevronUp=new i("chevron-up",{fontCharacter:"\\eab7"}),i.chromeClose=new i("chrome-close",{fontCharacter:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{fontCharacter:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{fontCharacter:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{fontCharacter:"\\eabb"}),i.circleOutline=new i("circle-outline",{fontCharacter:"\\eabc"}),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),i.circleSlash=new i("circle-slash",{fontCharacter:"\\eabd"}),i.circuitBoard=new i("circuit-board",{fontCharacter:"\\eabe"}),i.clearAll=new i("clear-all",{fontCharacter:"\\eabf"}),i.clippy=new i("clippy",{fontCharacter:"\\eac0"}),i.closeAll=new i("close-all",{fontCharacter:"\\eac1"}),i.cloudDownload=new i("cloud-download",{fontCharacter:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{fontCharacter:"\\eac3"}),i.code=new i("code",{fontCharacter:"\\eac4"}),i.collapseAll=new i("collapse-all",{fontCharacter:"\\eac5"}),i.colorMode=new i("color-mode",{fontCharacter:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{fontCharacter:"\\eac7"}),i.compareChanges=new i("compare-changes",{fontCharacter:"\\eafd"}),i.creditCard=new i("credit-card",{fontCharacter:"\\eac9"}),i.dash=new i("dash",{fontCharacter:"\\eacc"}),i.dashboard=new i("dashboard",{fontCharacter:"\\eacd"}),i.database=new i("database",{fontCharacter:"\\eace"}),i.debugContinue=new i("debug-continue",{fontCharacter:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{fontCharacter:"\\ead0"}),i.debugPause=new i("debug-pause",{fontCharacter:"\\ead1"}),i.debugRestart=new i("debug-restart",{fontCharacter:"\\ead2"}),i.debugStart=new i("debug-start",{fontCharacter:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{fontCharacter:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{fontCharacter:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{fontCharacter:"\\ead6"}),i.debugStop=new i("debug-stop",{fontCharacter:"\\ead7"}),i.debug=new i("debug",{fontCharacter:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{fontCharacter:"\\ead9"}),i.deviceCamera=new i("device-camera",{fontCharacter:"\\eada"}),i.deviceMobile=new i("device-mobile",{fontCharacter:"\\eadb"}),i.diffAdded=new i("diff-added",{fontCharacter:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{fontCharacter:"\\eadd"}),i.diffModified=new i("diff-modified",{fontCharacter:"\\eade"}),i.diffRemoved=new i("diff-removed",{fontCharacter:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{fontCharacter:"\\eae0"}),i.diff=new i("diff",{fontCharacter:"\\eae1"}),i.discard=new i("discard",{fontCharacter:"\\eae2"}),i.editorLayout=new i("editor-layout",{fontCharacter:"\\eae3"}),i.emptyWindow=new i("empty-window",{fontCharacter:"\\eae4"}),i.exclude=new i("exclude",{fontCharacter:"\\eae5"}),i.extensions=new i("extensions",{fontCharacter:"\\eae6"}),i.eyeClosed=new i("eye-closed",{fontCharacter:"\\eae7"}),i.fileBinary=new i("file-binary",{fontCharacter:"\\eae8"}),i.fileCode=new i("file-code",{fontCharacter:"\\eae9"}),i.fileMedia=new i("file-media",{fontCharacter:"\\eaea"}),i.filePdf=new i("file-pdf",{fontCharacter:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{fontCharacter:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{fontCharacter:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{fontCharacter:"\\eaee"}),i.fileZip=new i("file-zip",{fontCharacter:"\\eaef"}),i.files=new i("files",{fontCharacter:"\\eaf0"}),i.filter=new i("filter",{fontCharacter:"\\eaf1"}),i.flame=new i("flame",{fontCharacter:"\\eaf2"}),i.foldDown=new i("fold-down",{fontCharacter:"\\eaf3"}),i.foldUp=new i("fold-up",{fontCharacter:"\\eaf4"}),i.fold=new i("fold",{fontCharacter:"\\eaf5"}),i.folderActive=new i("folder-active",{fontCharacter:"\\eaf6"}),i.folderOpened=new i("folder-opened",{fontCharacter:"\\eaf7"}),i.gear=new i("gear",{fontCharacter:"\\eaf8"}),i.gift=new i("gift",{fontCharacter:"\\eaf9"}),i.gistSecret=new i("gist-secret",{fontCharacter:"\\eafa"}),i.gist=new i("gist",{fontCharacter:"\\eafb"}),i.gitCommit=new i("git-commit",{fontCharacter:"\\eafc"}),i.gitCompare=new i("git-compare",{fontCharacter:"\\eafd"}),i.gitMerge=new i("git-merge",{fontCharacter:"\\eafe"}),i.githubAction=new i("github-action",{fontCharacter:"\\eaff"}),i.githubAlt=new i("github-alt",{fontCharacter:"\\eb00"}),i.globe=new i("globe",{fontCharacter:"\\eb01"}),i.grabber=new i("grabber",{fontCharacter:"\\eb02"}),i.graph=new i("graph",{fontCharacter:"\\eb03"}),i.gripper=new i("gripper",{fontCharacter:"\\eb04"}),i.heart=new i("heart",{fontCharacter:"\\eb05"}),i.home=new i("home",{fontCharacter:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{fontCharacter:"\\eb07"}),i.hubot=new i("hubot",{fontCharacter:"\\eb08"}),i.inbox=new i("inbox",{fontCharacter:"\\eb09"}),i.issueClosed=new i("issue-closed",{fontCharacter:"\\eba4"}),i.issueReopened=new i("issue-reopened",{fontCharacter:"\\eb0b"}),i.issues=new i("issues",{fontCharacter:"\\eb0c"}),i.italic=new i("italic",{fontCharacter:"\\eb0d"}),i.jersey=new i("jersey",{fontCharacter:"\\eb0e"}),i.json=new i("json",{fontCharacter:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{fontCharacter:"\\eb10"}),i.key=new i("key",{fontCharacter:"\\eb11"}),i.law=new i("law",{fontCharacter:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{fontCharacter:"\\eb13"}),i.linkExternal=new i("link-external",{fontCharacter:"\\eb14"}),i.link=new i("link",{fontCharacter:"\\eb15"}),i.listOrdered=new i("list-ordered",{fontCharacter:"\\eb16"}),i.listUnordered=new i("list-unordered",{fontCharacter:"\\eb17"}),i.liveShare=new i("live-share",{fontCharacter:"\\eb18"}),i.loading=new i("loading",{fontCharacter:"\\eb19"}),i.location=new i("location",{fontCharacter:"\\eb1a"}),i.mailRead=new i("mail-read",{fontCharacter:"\\eb1b"}),i.mail=new i("mail",{fontCharacter:"\\eb1c"}),i.markdown=new i("markdown",{fontCharacter:"\\eb1d"}),i.megaphone=new i("megaphone",{fontCharacter:"\\eb1e"}),i.mention=new i("mention",{fontCharacter:"\\eb1f"}),i.milestone=new i("milestone",{fontCharacter:"\\eb20"}),i.mortarBoard=new i("mortar-board",{fontCharacter:"\\eb21"}),i.move=new i("move",{fontCharacter:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{fontCharacter:"\\eb23"}),i.mute=new i("mute",{fontCharacter:"\\eb24"}),i.noNewline=new i("no-newline",{fontCharacter:"\\eb25"}),i.note=new i("note",{fontCharacter:"\\eb26"}),i.octoface=new i("octoface",{fontCharacter:"\\eb27"}),i.openPreview=new i("open-preview",{fontCharacter:"\\eb28"}),i.package_=new i("package",{fontCharacter:"\\eb29"}),i.paintcan=new i("paintcan",{fontCharacter:"\\eb2a"}),i.pin=new i("pin",{fontCharacter:"\\eb2b"}),i.play=new i("play",{fontCharacter:"\\eb2c"}),i.run=new i("run",{fontCharacter:"\\eb2c"}),i.plug=new i("plug",{fontCharacter:"\\eb2d"}),i.preserveCase=new i("preserve-case",{fontCharacter:"\\eb2e"}),i.preview=new i("preview",{fontCharacter:"\\eb2f"}),i.project=new i("project",{fontCharacter:"\\eb30"}),i.pulse=new i("pulse",{fontCharacter:"\\eb31"}),i.question=new i("question",{fontCharacter:"\\eb32"}),i.quote=new i("quote",{fontCharacter:"\\eb33"}),i.radioTower=new i("radio-tower",{fontCharacter:"\\eb34"}),i.reactions=new i("reactions",{fontCharacter:"\\eb35"}),i.references=new i("references",{fontCharacter:"\\eb36"}),i.refresh=new i("refresh",{fontCharacter:"\\eb37"}),i.regex=new i("regex",{fontCharacter:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{fontCharacter:"\\eb39"}),i.remote=new i("remote",{fontCharacter:"\\eb3a"}),i.remove=new i("remove",{fontCharacter:"\\eb3b"}),i.replaceAll=new i("replace-all",{fontCharacter:"\\eb3c"}),i.replace=new i("replace",{fontCharacter:"\\eb3d"}),i.repoClone=new i("repo-clone",{fontCharacter:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{fontCharacter:"\\eb3f"}),i.repoPull=new i("repo-pull",{fontCharacter:"\\eb40"}),i.repoPush=new i("repo-push",{fontCharacter:"\\eb41"}),i.report=new i("report",{fontCharacter:"\\eb42"}),i.requestChanges=new i("request-changes",{fontCharacter:"\\eb43"}),i.rocket=new i("rocket",{fontCharacter:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{fontCharacter:"\\eb45"}),i.rootFolder=new i("root-folder",{fontCharacter:"\\eb46"}),i.rss=new i("rss",{fontCharacter:"\\eb47"}),i.ruby=new i("ruby",{fontCharacter:"\\eb48"}),i.saveAll=new i("save-all",{fontCharacter:"\\eb49"}),i.saveAs=new i("save-as",{fontCharacter:"\\eb4a"}),i.save=new i("save",{fontCharacter:"\\eb4b"}),i.screenFull=new i("screen-full",{fontCharacter:"\\eb4c"}),i.screenNormal=new i("screen-normal",{fontCharacter:"\\eb4d"}),i.searchStop=new i("search-stop",{fontCharacter:"\\eb4e"}),i.server=new i("server",{fontCharacter:"\\eb50"}),i.settingsGear=new i("settings-gear",{fontCharacter:"\\eb51"}),i.settings=new i("settings",{fontCharacter:"\\eb52"}),i.shield=new i("shield",{fontCharacter:"\\eb53"}),i.smiley=new i("smiley",{fontCharacter:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{fontCharacter:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{fontCharacter:"\\eb56"}),i.splitVertical=new i("split-vertical",{fontCharacter:"\\eb57"}),i.squirrel=new i("squirrel",{fontCharacter:"\\eb58"}),i.starFull=new i("star-full",{fontCharacter:"\\eb59"}),i.starHalf=new i("star-half",{fontCharacter:"\\eb5a"}),i.symbolClass=new i("symbol-class",{fontCharacter:"\\eb5b"}),i.symbolColor=new i("symbol-color",{fontCharacter:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{fontCharacter:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{fontCharacter:"\\eb5e"}),i.symbolField=new i("symbol-field",{fontCharacter:"\\eb5f"}),i.symbolFile=new i("symbol-file",{fontCharacter:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{fontCharacter:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{fontCharacter:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{fontCharacter:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{fontCharacter:"\\eb64"}),i.symbolProperty=new i("symbol-property",{fontCharacter:"\\eb65"}),i.wrench=new i("wrench",{fontCharacter:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{fontCharacter:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{fontCharacter:"\\eb66"}),i.tasklist=new i("tasklist",{fontCharacter:"\\eb67"}),i.telescope=new i("telescope",{fontCharacter:"\\eb68"}),i.textSize=new i("text-size",{fontCharacter:"\\eb69"}),i.threeBars=new i("three-bars",{fontCharacter:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{fontCharacter:"\\eb6b"}),i.thumbsup=new i("thumbsup",{fontCharacter:"\\eb6c"}),i.tools=new i("tools",{fontCharacter:"\\eb6d"}),i.triangleDown=new i("triangle-down",{fontCharacter:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{fontCharacter:"\\eb6f"}),i.triangleRight=new i("triangle-right",{fontCharacter:"\\eb70"}),i.triangleUp=new i("triangle-up",{fontCharacter:"\\eb71"}),i.twitter=new i("twitter",{fontCharacter:"\\eb72"}),i.unfold=new i("unfold",{fontCharacter:"\\eb73"}),i.unlock=new i("unlock",{fontCharacter:"\\eb74"}),i.unmute=new i("unmute",{fontCharacter:"\\eb75"}),i.unverified=new i("unverified",{fontCharacter:"\\eb76"}),i.verified=new i("verified",{fontCharacter:"\\eb77"}),i.versions=new i("versions",{fontCharacter:"\\eb78"}),i.vmActive=new i("vm-active",{fontCharacter:"\\eb79"}),i.vmOutline=new i("vm-outline",{fontCharacter:"\\eb7a"}),i.vmRunning=new i("vm-running",{fontCharacter:"\\eb7b"}),i.watch=new i("watch",{fontCharacter:"\\eb7c"}),i.whitespace=new i("whitespace",{fontCharacter:"\\eb7d"}),i.wholeWord=new i("whole-word",{fontCharacter:"\\eb7e"}),i.window=new i("window",{fontCharacter:"\\eb7f"}),i.wordWrap=new i("word-wrap",{fontCharacter:"\\eb80"}),i.zoomIn=new i("zoom-in",{fontCharacter:"\\eb81"}),i.zoomOut=new i("zoom-out",{fontCharacter:"\\eb82"}),i.listFilter=new i("list-filter",{fontCharacter:"\\eb83"}),i.listFlat=new i("list-flat",{fontCharacter:"\\eb84"}),i.listSelection=new i("list-selection",{fontCharacter:"\\eb85"}),i.selection=new i("selection",{fontCharacter:"\\eb85"}),i.listTree=new i("list-tree",{fontCharacter:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{fontCharacter:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{fontCharacter:"\\eb89"}),i.debugStackframeDot=new i("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),i.debugStackframe=new i("debug-stackframe",{fontCharacter:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),i.symbolString=new i("symbol-string",{fontCharacter:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{fontCharacter:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{fontCharacter:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{fontCharacter:"\\eb90"}),i.callIncoming=new i("call-incoming",{fontCharacter:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{fontCharacter:"\\eb93"}),i.menu=new i("menu",{fontCharacter:"\\eb94"}),i.expandAll=new i("expand-all",{fontCharacter:"\\eb95"}),i.feedback=new i("feedback",{fontCharacter:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{fontCharacter:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),i.account=new i("account",{fontCharacter:"\\eb99"}),i.bellDot=new i("bell-dot",{fontCharacter:"\\eb9a"}),i.debugConsole=new i("debug-console",{fontCharacter:"\\eb9b"}),i.library=new i("library",{fontCharacter:"\\eb9c"}),i.output=new i("output",{fontCharacter:"\\eb9d"}),i.runAll=new i("run-all",{fontCharacter:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{fontCharacter:"\\eb9f"}),i.pinned=new i("pinned",{fontCharacter:"\\eba0"}),i.githubInverted=new i("github-inverted",{fontCharacter:"\\eba1"}),i.debugAlt=new i("debug-alt",{fontCharacter:"\\eb91"}),i.serverProcess=new i("server-process",{fontCharacter:"\\eba2"}),i.serverEnvironment=new i("server-environment",{fontCharacter:"\\eba3"}),i.pass=new i("pass",{fontCharacter:"\\eba4"}),i.stopCircle=new i("stop-circle",{fontCharacter:"\\eba5"}),i.playCircle=new i("play-circle",{fontCharacter:"\\eba6"}),i.record=new i("record",{fontCharacter:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{fontCharacter:"\\eba8"}),i.vmConnect=new i("vm-connect",{fontCharacter:"\\eba9"}),i.cloud=new i("cloud",{fontCharacter:"\\ebaa"}),i.merge=new i("merge",{fontCharacter:"\\ebab"}),i.exportIcon=new i("export",{fontCharacter:"\\ebac"}),i.graphLeft=new i("graph-left",{fontCharacter:"\\ebad"}),i.magnet=new i("magnet",{fontCharacter:"\\ebae"}),i.notebook=new i("notebook",{fontCharacter:"\\ebaf"}),i.redo=new i("redo",{fontCharacter:"\\ebb0"}),i.checkAll=new i("check-all",{fontCharacter:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{fontCharacter:"\\ebb2"}),i.passFilled=new i("pass-filled",{fontCharacter:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{fontCharacter:"\\ebb4"}),i.circleLargeOutline=new i("circle-large-outline",{fontCharacter:"\\ebb5"}),i.combine=new i("combine",{fontCharacter:"\\ebb6"}),i.gather=new i("gather",{fontCharacter:"\\ebb6"}),i.table=new i("table",{fontCharacter:"\\ebb7"}),i.variableGroup=new i("variable-group",{fontCharacter:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{fontCharacter:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{fontCharacter:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{fontCharacter:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{fontCharacter:"\\ebbc"}),i.runAbove=new i("run-above",{fontCharacter:"\\ebbd"}),i.runBelow=new i("run-below",{fontCharacter:"\\ebbe"}),i.notebookTemplate=new i("notebook-template",{fontCharacter:"\\ebbf"}),i.debugRerun=new i("debug-rerun",{fontCharacter:"\\ebc0"}),i.workspaceTrusted=new i("workspace-trusted",{fontCharacter:"\\ebc1"}),i.workspaceUntrusted=new i("workspace-untrusted",{fontCharacter:"\\ebc2"}),i.workspaceUnspecified=new i("workspace-unspecified",{fontCharacter:"\\ebc3"}),i.terminalCmd=new i("terminal-cmd",{fontCharacter:"\\ebc4"}),i.terminalDebian=new i("terminal-debian",{fontCharacter:"\\ebc5"}),i.terminalLinux=new i("terminal-linux",{fontCharacter:"\\ebc6"}),i.terminalPowershell=new i("terminal-powershell",{fontCharacter:"\\ebc7"}),i.terminalTmux=new i("terminal-tmux",{fontCharacter:"\\ebc8"}),i.terminalUbuntu=new i("terminal-ubuntu",{fontCharacter:"\\ebc9"}),i.terminalBash=new i("terminal-bash",{fontCharacter:"\\ebca"}),i.arrowSwap=new i("arrow-swap",{fontCharacter:"\\ebcb"}),i.copy=new i("copy",{fontCharacter:"\\ebcc"}),i.personAdd=new i("person-add",{fontCharacter:"\\ebcd"}),i.filterFilled=new i("filter-filled",{fontCharacter:"\\ebce"}),i.wand=new i("wand",{fontCharacter:"\\ebcf"}),i.debugLineByLine=new i("debug-line-by-line",{fontCharacter:"\\ebd0"}),i.inspect=new i("inspect",{fontCharacter:"\\ebd1"}),i.layers=new i("layers",{fontCharacter:"\\ebd2"}),i.layersDot=new i("layers-dot",{fontCharacter:"\\ebd3"}),i.layersActive=new i("layers-active",{fontCharacter:"\\ebd4"}),i.compass=new i("compass",{fontCharacter:"\\ebd5"}),i.compassDot=new i("compass-dot",{fontCharacter:"\\ebd6"}),i.compassActive=new i("compass-active",{fontCharacter:"\\ebd7"}),i.azure=new i("azure",{fontCharacter:"\\ebd8"}),i.issueDraft=new i("issue-draft",{fontCharacter:"\\ebd9"}),i.gitPullRequestClosed=new i("git-pull-request-closed",{fontCharacter:"\\ebda"}),i.gitPullRequestDraft=new i("git-pull-request-draft",{fontCharacter:"\\ebdb"}),i.debugAll=new i("debug-all",{fontCharacter:"\\ebdc"}),i.debugCoverage=new i("debug-coverage",{fontCharacter:"\\ebdd"}),i.runErrors=new i("run-errors",{fontCharacter:"\\ebde"}),i.folderLibrary=new i("folder-library",{fontCharacter:"\\ebdf"}),i.debugContinueSmall=new i("debug-continue-small",{fontCharacter:"\\ebe0"}),i.beakerStop=new i("beaker-stop",{fontCharacter:"\\ebe1"}),i.graphLine=new i("graph-line",{fontCharacter:"\\ebe2"}),i.graphScatter=new i("graph-scatter",{fontCharacter:"\\ebe3"}),i.pieChart=new i("pie-chart",{fontCharacter:"\\ebe4"}),i.bracket=new i("bracket",i.json.definition),i.bracketDot=new i("bracket-dot",{fontCharacter:"\\ebe5"}),i.bracketError=new i("bracket-error",{fontCharacter:"\\ebe6"}),i.lockSmall=new i("lock-small",{fontCharacter:"\\ebe7"}),i.azureDevops=new i("azure-devops",{fontCharacter:"\\ebe8"}),i.verifiedFilled=new i("verified-filled",{fontCharacter:"\\ebe9"}),i.newLine=new i("newline",{fontCharacter:"\\ebea"}),i.dialogError=new i("dialog-error",i.error.definition),i.dialogWarning=new i("dialog-warning",i.warning.definition),i.dialogInfo=new i("dialog-info",i.info.definition),i.dialogClose=new i("dialog-close",i.close.definition),i.treeItemExpanded=new i("tree-item-expanded",i.chevronDown.definition),i.treeFilterOnTypeOn=new i("tree-filter-on-type-on",i.listFilter.definition),i.treeFilterOnTypeOff=new i("tree-filter-on-type-off",i.listSelection.definition),i.treeFilterClear=new i("tree-filter-clear",i.close.definition),i.treeItemLoading=new i("tree-item-loading",i.loading.definition),i.menuSelection=new i("menu-selection",i.check.definition),i.menuSubmenu=new i("menu-submenu",i.chevronRight.definition),i.menuBarMore=new i("menubar-more",i.more.definition),i.scrollbarButtonLeft=new i("scrollbar-button-left",i.triangleLeft.definition),i.scrollbarButtonRight=new i("scrollbar-button-right",i.triangleRight.definition),i.scrollbarButtonUp=new i("scrollbar-button-up",i.triangleUp.definition),i.scrollbarButtonDown=new i("scrollbar-button-down",i.triangleDown.definition),i.toolBarMore=new i("toolbar-more",i.more.definition),i.quickInputBack=new i("quick-input-back",i.arrowLeft.definition);function P(C,I){const E=["codicon","codicon-"+C];return I&&E.push("codicon-modifier-"+I),E}e.getClassNamesArray=P;var S;(function(C){C.iconNameSegment="[A-Za-z0-9]+",C.iconNameExpression="[A-Za-z0-9-]+",C.iconModifierExpression="~[A-Za-z]+",C.iconNameCharacter="[A-Za-z0-9~-]";const I=new RegExp(`^(${C.iconNameExpression})(${C.iconModifierExpression})?$`);function E(h){if(h instanceof i)return["codicon","codicon-"+h.id];const w=I.exec(h.id);if(!w)return E(i.error);let[,y,m]=w;const b=["codicon","codicon-"+y];return m&&b.push("codicon-modifier-"+m.substr(1)),b}C.asClassNameArray=E;function d(h){return E(h).join(" ")}C.asClassName=d;function p(h){return"."+E(h).join(".")}C.asCSSSelector=p})(S=e.CSSIcon||(e.CSSIcon={}))}),define(te[50],ne([0,1,9,2]),function(X,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function D(g){const a=g;return a?[a.on,a.pause,a.resume,a.destroy].every(l=>typeof l=="function"):!1}e.isReadableStream=D;function k(g){const a=g;return a?D(a.stream)&&Array.isArray(a.buffer)&&typeof a.ended=="boolean":!1}e.isReadableBufferedStream=k;function i(g,a){return new P(g,a)}e.newWriteableStream=i;class P{constructor(a,l){this.reducer=a,this.options=l,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(a){if(!this.state.destroyed){if(this.state.flowing)this.emitData(a);else if(this.buffer.data.push(a),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(l=>this.pendingWritePromises.push(l))}}error(a){this.state.destroyed||(this.state.flowing?this.emitError(a):this.buffer.error.push(a))}end(a){this.state.destroyed||(typeof a!="undefined"&&this.write(a),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(a){this.listeners.data.slice(0).forEach(l=>l(a))}emitError(a){this.listeners.error.length===0?(0,R.onUnexpectedError)(a):this.listeners.error.slice(0).forEach(l=>l(a))}emitEnd(){this.listeners.end.slice(0).forEach(a=>a())}on(a,l){if(!this.state.destroyed)switch(a){case"data":this.listeners.data.push(l),this.resume();break;case"end":this.listeners.end.push(l),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(l),this.state.flowing&&this.flowErrors();break}}removeListener(a,l){if(this.state.destroyed)return;let r;switch(a){case"data":r=this.listeners.data;break;case"end":r=this.listeners.end;break;case"error":r=this.listeners.error;break}if(r){const o=r.indexOf(l);o>=0&&r.splice(o,1)}}flowData(){if(this.buffer.data.length>0){const a=this.reducer(this.buffer.data);this.emitData(a),this.buffer.data.length=0;const l=[...this.pendingWritePromises];this.pendingWritePromises.length=0,l.forEach(r=>r())}}flowErrors(){if(this.listeners.error.length>0){for(const a of this.buffer.error)this.emitError(a);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function S(g,a){const l=[];let r;for(;(r=g.read())!==null;)l.push(r);return a(l)}e.consumeReadable=S;function C(g,a,l){const r=[];let o;for(;(o=g.read())!==null&&r.length<l;)r.push(o);return o===null&&r.length>0?a(r):{read:()=>{if(r.length>0)return r.shift();if(typeof o!="undefined"){const n=o;return o=void 0,n}return g.read()}}}e.peekReadable=C;function I(g,a){return new Promise((l,r)=>{const o=[];E(g,{onData:n=>{a&&o.push(n)},onError:n=>{a?r(n):l(void 0)},onEnd:()=>{l(a?a(o):void 0)}})})}e.consumeStream=I;function E(g,a){g.on("error",l=>a.onError(l)),g.on("end",()=>a.onEnd()),g.on("data",l=>a.onData(l))}e.listenStream=E;function d(g,a){return new Promise((l,r)=>{const o=new L.DisposableStore,n=[],t=u=>{if(n.push(u),n.length>a)return o.dispose(),g.pause(),l({stream:g,buffer:n,ended:!1})},s=u=>r(u),c=()=>l({stream:g,buffer:n,ended:!0});o.add((0,L.toDisposable)(()=>g.removeListener("error",s))),g.on("error",s),o.add((0,L.toDisposable)(()=>g.removeListener("end",c))),g.on("end",c),o.add((0,L.toDisposable)(()=>g.removeListener("data",t))),g.on("data",t)})}e.peekStream=d;function p(g,a){const l=i(a);return l.end(g),l}e.toStream=p;function h(){const g=i(()=>{throw new Error("not supported")});return g.end(),g}e.emptyStream=h;function w(g){let a=!1;return{read:()=>a?null:(a=!0,g)}}e.toReadable=w;function y(g,a,l){const r=i(l);return E(g,{onData:o=>r.write(a.data(o)),onError:o=>r.error(a.error?a.error(o):o),onEnd:()=>r.end()}),r}e.transform=y;function m(g,a,l){let r=!1;return{read:()=>{const o=a.read();return r?o:(r=!0,o!==null?l([g,o]):g)}}}e.prefixedReadable=m;function b(g,a,l){let r=!1;const o=i(l);return E(a,{onData:n=>r?o.write(n):(r=!0,o.write(l([g,n]))),onError:n=>o.error(n),onEnd:()=>{r||(r=!0,o.write(g)),o.end()}}),o}e.prefixedStream=b}),define(te[19],ne([0,1,50]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const L=typeof Buffer!="undefined";let D,k;class i{constructor(t){this.buffer=t,this.byteLength=this.buffer.byteLength}static alloc(t){return L?new i(Buffer.allocUnsafe(t)):new i(new Uint8Array(t))}static wrap(t){return L&&!Buffer.isBuffer(t)&&(t=Buffer.from(t.buffer,t.byteOffset,t.byteLength)),new i(t)}static fromString(t,s){return!(s?.dontUseNodeBuffer||!1)&&L?new i(Buffer.from(t)):(D||(D=new TextEncoder),new i(D.encode(t)))}static concat(t,s){if(typeof s=="undefined"){s=0;for(let f=0,v=t.length;f<v;f++)s+=t[f].byteLength}const c=i.alloc(s);let u=0;for(let f=0,v=t.length;f<v;f++){const T=t[f];c.set(T,u),u+=T.byteLength}return c}toString(){return L?this.buffer.toString():(k||(k=new TextDecoder),k.decode(this.buffer))}slice(t,s){return new i(this.buffer.subarray(t,s))}set(t,s){t instanceof i?this.buffer.set(t.buffer,s):this.buffer.set(t,s)}readUInt32BE(t){return C(this.buffer,t)}writeUInt32BE(t,s){I(this.buffer,t,s)}readUInt32LE(t){return E(this.buffer,t)}writeUInt32LE(t,s){d(this.buffer,t,s)}readUInt8(t){return p(this.buffer,t)}writeUInt8(t,s){h(this.buffer,t,s)}}e.VSBuffer=i;function P(n,t){return n[t+0]<<0>>>0|n[t+1]<<8>>>0}e.readUInt16LE=P;function S(n,t,s){n[s+0]=t&255,t=t>>>8,n[s+1]=t&255}e.writeUInt16LE=S;function C(n,t){return n[t]*2**24+n[t+1]*2**16+n[t+2]*2**8+n[t+3]}e.readUInt32BE=C;function I(n,t,s){n[s+3]=t,t=t>>>8,n[s+2]=t,t=t>>>8,n[s+1]=t,t=t>>>8,n[s]=t}e.writeUInt32BE=I;function E(n,t){return n[t+0]<<0>>>0|n[t+1]<<8>>>0|n[t+2]<<16>>>0|n[t+3]<<24>>>0}e.readUInt32LE=E;function d(n,t,s){n[s+0]=t&255,t=t>>>8,n[s+1]=t&255,t=t>>>8,n[s+2]=t&255,t=t>>>8,n[s+3]=t&255}e.writeUInt32LE=d;function p(n,t){return n[t]}e.readUInt8=p;function h(n,t,s){n[s]=t}e.writeUInt8=h;function w(n){return R.consumeReadable(n,t=>i.concat(t))}e.readableToBuffer=w;function y(n){return R.toReadable(n)}e.bufferToReadable=y;function m(n){return R.consumeStream(n,t=>i.concat(t))}e.streamToBuffer=m;async function b(n){return n.ended?i.concat(n.buffer):i.concat([...n.buffer,await m(n.stream)])}e.bufferedStreamToBuffer=b;function g(n){return R.toStream(n,t=>i.concat(t))}e.bufferToStream=g;function a(n){return R.transform(n,{data:t=>typeof t=="string"?i.fromString(t):i.wrap(t)},t=>i.concat(t))}e.streamToBufferReadableStream=a;function l(n){return R.newWriteableStream(t=>i.concat(t),n)}e.newWriteableBufferStream=l;function r(n,t){return R.prefixedReadable(n,t,s=>i.concat(s))}e.prefixedBufferReadable=r;function o(n,t){return R.prefixedStream(n,t,s=>i.concat(s))}e.prefixedBufferStream=o}),define(te[25],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function R(Y){return!Y||typeof Y!="string"?!0:Y.trim().length===0}e.isFalsyOrWhitespace=R;const L=/{(\d+)}/g;function D(Y,...se){return se.length===0?Y:Y.replace(L,function(ue,fe){const ge=parseInt(fe,10);return isNaN(ge)||ge<0||ge>=se.length?ue:se[ge]})}e.format=D;const k=/{([^}]+)}/g;function i(Y,se){return Y.replace(k,(ue,fe)=>se[fe]??ue)}e.format2=i;function P(Y){return Y.replace(/[<>&]/g,function(se){switch(se){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return se}})}e.escape=P;function S(Y){return Y.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=S;function C(Y,se){let ue=0;const fe=se.charCodeAt(0);for(let ge=Y.length-1;ge>=0;ge--)Y.charCodeAt(ge)===fe&&ue++;return ue}e.count=C;function I(Y,se,ue="\u2026"){return Y.length<=se?Y:`${Y.substr(0,se)}${ue}`}e.truncate=I;function E(Y,se=" "){const ue=d(Y,se);return p(ue,se)}e.trim=E;function d(Y,se){if(!Y||!se)return Y;const ue=se.length;if(ue===0||Y.length===0)return Y;let fe=0;for(;Y.indexOf(se,fe)===fe;)fe=fe+ue;return Y.substring(fe)}e.ltrim=d;function p(Y,se){if(!Y||!se)return Y;const ue=se.length,fe=Y.length;if(ue===0||fe===0)return Y;let ge=fe,Ce=-1;for(;Ce=Y.lastIndexOf(se,ge-1),!(Ce===-1||Ce+ue!==ge);){if(Ce===0)return"";ge=Ce}return Y.substring(0,ge)}e.rtrim=p;function h(Y){return Y.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=h;function w(Y){return Y.replace(/\*/g,"")}e.stripWildcards=w;function y(Y,se,ue={}){if(!Y)throw new Error("Cannot create regex from empty string");se||(Y=S(Y)),ue.wholeWord&&(/\B/.test(Y.charAt(0))||(Y="\\b"+Y),/\B/.test(Y.charAt(Y.length-1))||(Y=Y+"\\b"));let fe="";return ue.global&&(fe+="g"),ue.matchCase||(fe+="i"),ue.multiline&&(fe+="m"),ue.unicode&&(fe+="u"),new RegExp(Y,fe)}e.createRegExp=y;function m(Y){return Y.source==="^"||Y.source==="^$"||Y.source==="$"||Y.source==="^\\s*$"?!1:!!(Y.exec("")&&Y.lastIndex===0)}e.regExpLeadsToEndlessLoop=m;function b(Y){return!!Y.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=b;function g(Y){return(Y.global?"g":"")+(Y.ignoreCase?"i":"")+(Y.multiline?"m":"")+(Y.unicode?"u":"")}e.regExpFlags=g;function a(Y){return Y.split(/\r\n|\r|\n/)}e.splitLines=a;function l(Y){for(let se=0,ue=Y.length;se<ue;se++){const fe=Y.charCodeAt(se);if(fe!==32&&fe!==9)return se}return-1}e.firstNonWhitespaceIndex=l;function r(Y,se=0,ue=Y.length){for(let fe=se;fe<ue;fe++){const ge=Y.charCodeAt(fe);if(ge!==32&&ge!==9)return Y.substring(se,fe)}return Y.substring(se,ue)}e.getLeadingWhitespace=r;function o(Y,se=Y.length-1){for(let ue=se;ue>=0;ue--){const fe=Y.charCodeAt(ue);if(fe!==32&&fe!==9)return ue}return-1}e.lastNonWhitespaceIndex=o;function n(Y,se){return Y<se?-1:Y>se?1:0}e.compare=n;function t(Y,se,ue=0,fe=Y.length,ge=0,Ce=se.length){for(;ue<fe&&ge<Ce;ue++,ge++){let ye=Y.charCodeAt(ue),Ee=se.charCodeAt(ge);if(ye<Ee)return-1;if(ye>Ee)return 1}const Te=fe-ue,Le=Ce-ge;return Te<Le?-1:Te>Le?1:0}e.compareSubstring=t;function s(Y,se){return c(Y,se,0,Y.length,0,se.length)}e.compareIgnoreCase=s;function c(Y,se,ue=0,fe=Y.length,ge=0,Ce=se.length){for(;ue<fe&&ge<Ce;ue++,ge++){let ye=Y.charCodeAt(ue),Ee=se.charCodeAt(ge);if(ye===Ee)continue;if(ye>=128||Ee>=128)return t(Y.toLowerCase(),se.toLowerCase(),ue,fe,ge,Ce);u(ye)&&(ye-=32),u(Ee)&&(Ee-=32);const De=ye-Ee;if(De!==0)return De}const Te=fe-ue,Le=Ce-ge;return Te<Le?-1:Te>Le?1:0}e.compareSubstringIgnoreCase=c;function u(Y){return Y>=97&&Y<=122}e.isLowerAsciiLetter=u;function f(Y){return Y>=65&&Y<=90}e.isUpperAsciiLetter=f;function v(Y,se){return Y.length===se.length&&c(Y,se)===0}e.equalsIgnoreCase=v;function T(Y,se){const ue=se.length;return se.length>Y.length?!1:c(Y,se,0,ue)===0}e.startsWithIgnoreCase=T;function O(Y,se){let ue,fe=Math.min(Y.length,se.length);for(ue=0;ue<fe;ue++)if(Y.charCodeAt(ue)!==se.charCodeAt(ue))return ue;return fe}e.commonPrefixLength=O;function U(Y,se){let ue,fe=Math.min(Y.length,se.length);const ge=Y.length-1,Ce=se.length-1;for(ue=0;ue<fe;ue++)if(Y.charCodeAt(ge-ue)!==se.charCodeAt(Ce-ue))return ue;return fe}e.commonSuffixLength=U;function W(Y){return 55296<=Y&&Y<=56319}e.isHighSurrogate=W;function N(Y){return 56320<=Y&&Y<=57343}e.isLowSurrogate=N;function A(Y,se){return(Y-55296<<10)+(se-56320)+65536}e.computeCodePoint=A;function z(Y,se,ue){const fe=Y.charCodeAt(ue);if(W(fe)&&ue+1<se){const ge=Y.charCodeAt(ue+1);if(N(ge))return A(fe,ge)}return fe}e.getNextCodePoint=z;function _(Y,se){const ue=Y.charCodeAt(se-1);if(N(ue)&&se>1){const fe=Y.charCodeAt(se-2);if(W(fe))return A(fe,ue)}return ue}function M(Y,se){const ue=ee.getInstance(),fe=se,ge=Y.length,Ce=z(Y,ge,se);se+=Ce>=65536?2:1;let Te=ue.getGraphemeBreakType(Ce);for(;se<ge;){const Le=z(Y,ge,se),ye=ue.getGraphemeBreakType(Le);if(ze(Te,ye))break;se+=Le>=65536?2:1,Te=ye}return se-fe}e.nextCharLength=M;function q(Y,se){const ue=ee.getInstance(),fe=se,ge=_(Y,se);se-=ge>=65536?2:1;let Ce=ue.getGraphemeBreakType(ge);for(;se>0;){const Te=_(Y,se),Le=ue.getGraphemeBreakType(Te);if(ze(Le,Ce))break;se-=Te>=65536?2:1,Ce=Le}return fe-se}e.prevCharLength=q;function B(Y,se){const ue=ee.getInstance(),fe=Y.length,ge=se,Ce=z(Y,fe,se),Te=ue.getGraphemeBreakType(Ce);se+=Ce>=65536?2:1;let Le=Te;for(;se<fe;){const Ee=z(Y,fe,se),De=ue.getGraphemeBreakType(Ee);if(ze(Le,De))break;se+=Ee>=65536?2:1,Le=De}const ye=se;for(se=ge,Le=Te;se>0;){const Ee=_(Y,se),De=ue.getGraphemeBreakType(Ee);if(ze(De,Le))break;se-=Ee>=65536?2:1,Le=De}return[se,ye]}function j(Y,se){return se>0&&N(Y.charCodeAt(se))?B(Y,se-1):B(Y,se)}e.getCharContainingOffset=j;const $=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function K(Y){return $.test(Y)}e.containsRTL=K;const F=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFF0]|\uD83E[\uDD00-\uDDFF\uDE70-\uDEF6])/;function x(Y){return F.test(Y)}e.containsEmoji=x;const V=/^[\t\n\r\x20-\x7E]*$/;function Q(Y){return V.test(Y)}e.isBasicASCII=Q,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Z(Y){return e.UNUSUAL_LINE_TERMINATORS.test(Y)}e.containsUnusualLineTerminators=Z;function G(Y){for(let se=0,ue=Y.length;se<ue;se++)if(H(Y.charCodeAt(se)))return!0;return!1}e.containsFullWidthCharacter=G;function H(Y){return Y>=11904&&Y<=55215||Y>=63744&&Y<=64255||Y>=65281&&Y<=65374}e.isFullWidthCharacter=H;function re(Y){return Y>=127462&&Y<=127487||Y===8986||Y===8987||Y===9200||Y===9203||Y>=9728&&Y<=10175||Y===11088||Y===11093||Y>=127744&&Y<=128591||Y>=128640&&Y<=128764||Y>=128992&&Y<=129008||Y>=129280&&Y<=129535||Y>=129648&&Y<=129782}e.isEmojiImprecise=re;function ie(Y,se){if(Y.length<se)return Y;const ue=/\b/g;let fe=0;for(;ue.test(Y)&&!(Y.length-ue.lastIndex<se);)fe=ue.lastIndex,ue.lastIndex+=1;return Y.substring(fe).replace(/^\s/,"")}e.lcut=ie;const ce=/\x1B\x5B[12]?K/g,le=/\x1b\[\d+m/g,de=/\x1b\[0?m/g;function pe(Y){return Y&&(Y=Y.replace(ce,""),Y=Y.replace(le,""),Y=Y.replace(de,"")),Y}e.removeAnsiEscapeCodes=pe,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function be(Y){return!!(Y&&Y.length>0&&Y.charCodeAt(0)===65279)}e.startsWithUTF8BOM=be;function Ie(Y){return be(Y)?Y.substr(1):Y}e.stripUTF8BOM=Ie;function Se(Y,se){if(!Y||!se||Y.length<se.length)return!1;const ue=se.length,fe=Y.toLowerCase();let ge=0,Ce=-1;for(;ge<ue;){const Te=fe.indexOf(se[ge],Ce+1);if(Te<0)return!1;Ce=Te,ge++}return!0}e.fuzzyContains=Se;function ke(Y,se=!1){return Y?(se&&(Y=Y.replace(/\\./g,"")),Y.toLowerCase()!==Y):!1}e.containsUppercaseCharacter=ke;function Pe(Y){return Y.charAt(0).toUpperCase()+Y.slice(1)}e.uppercaseFirstLetter=Pe;function Ue(Y,se=1){if(se===0)return"";let ue=-1;do ue=Y.indexOf(`
`,ue+1),se--;while(se>0&&ue>=0);return ue===-1?Y:(Y[ue-1]==="\r"&&ue--,Y.substr(0,ue))}e.getNLines=Ue;function qe(Y){const se=90-65+1;return Y=Y%(2*se),Y<se?String.fromCharCode(97+Y):String.fromCharCode(65+Y-se)}e.singleLetterHash=qe;function Fe(Y){return ee.getInstance().getGraphemeBreakType(Y)}e.getGraphemeBreakType=Fe;function ze(Y,se){return Y===0?se!==5&&se!==7:Y===2&&se===3?!1:Y===4||Y===2||Y===3||se===4||se===2||se===3?!0:!(Y===8&&(se===8||se===9||se===11||se===12)||(Y===11||Y===9)&&(se===9||se===10)||(Y===12||Y===10)&&se===10||se===5||se===13||se===7||Y===1||Y===13&&se===14||Y===6&&se===6)}e.breakBetweenGraphemeBreakType=ze;var xe;(function(Y){Y[Y.Other=0]="Other",Y[Y.Prepend=1]="Prepend",Y[Y.CR=2]="CR",Y[Y.LF=3]="LF",Y[Y.Control=4]="Control",Y[Y.Extend=5]="Extend",Y[Y.Regional_Indicator=6]="Regional_Indicator",Y[Y.SpacingMark=7]="SpacingMark",Y[Y.L=8]="L",Y[Y.V=9]="V",Y[Y.T=10]="T",Y[Y.LV=11]="LV",Y[Y.LVT=12]="LVT",Y[Y.ZWJ=13]="ZWJ",Y[Y.Extended_Pictographic=14]="Extended_Pictographic"})(xe=e.GraphemeBreakType||(e.GraphemeBreakType={}));class ee{constructor(){this._data=oe()}static getInstance(){return ee._INSTANCE||(ee._INSTANCE=new ee),ee._INSTANCE}getGraphemeBreakType(se){if(se<32)return se===10?3:se===13?2:4;if(se<127)return 0;const ue=this._data,fe=ue.length/3;let ge=1;for(;ge<=fe;)if(se<ue[3*ge])ge=2*ge;else if(se>ue[3*ge+1])ge=2*ge+1;else return ue[3*ge+2];return 0}}ee._INSTANCE=null;function oe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function ae(Y,se){if(Y===0)return 0;const ue=ve(Y,se);if(ue!==void 0)return ue;const fe=_(se,Y);return Y-=we(fe),Y}e.getLeftDeleteOffset=ae;function ve(Y,se){let ue=_(se,Y);for(Y-=we(ue);_e(ue)||ue===65039||ue===8419;){if(Y===0)return;ue=_(se,Y),Y-=we(ue)}if(!!re(ue)){if(Y>=0){const fe=_(se,Y);fe===8205&&(Y-=we(fe))}return Y}}function we(Y){return Y>=65536?2:1}function _e(Y){return 127995<=Y&&Y<=127999}var Re;(function(Y){Y[Y.zwj=8205]="zwj",Y[Y.emojiVariantSelector=65039]="emojiVariantSelector",Y[Y.enclosingKeyCap=8419]="enclosingKeyCap"})(Re||(Re={})),e.noBreakWhitespace="\xA0"}),define(te[105],ne([0,1,25]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function L(m){return D(m,0)}e.hash=L;function D(m,b){switch(typeof m){case"object":return m===null?k(349,b):Array.isArray(m)?S(m,b):C(m,b);case"string":return P(m,b);case"boolean":return i(m,b);case"number":return k(m,b);case"undefined":return k(937,b);default:return k(617,b)}}e.doHash=D;function k(m,b){return(b<<5)-b+m|0}e.numberHash=k;function i(m,b){return k(m?433:863,b)}function P(m,b){b=k(149417,b);for(let g=0,a=m.length;g<a;g++)b=k(m.charCodeAt(g),b);return b}e.stringHash=P;function S(m,b){return b=k(104579,b),m.reduce((g,a)=>D(a,g),b)}function C(m,b){return b=k(181387,b),Object.keys(m).sort().reduce((g,a)=>(g=P(a,g),D(m[a],g)),b)}class I{constructor(){this._value=0}get value(){return this._value}hash(b){return this._value=D(b,this._value),this._value}}e.Hasher=I;var E;(function(m){m[m.BLOCK_SIZE=64]="BLOCK_SIZE",m[m.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(E||(E={}));function d(m,b,g=32){const a=g-b,l=~((1<<a)-1);return(m<<b|(l&m)>>>a)>>>0}function p(m,b=0,g=m.byteLength,a=0){for(let l=0;l<g;l++)m[b+l]=a}function h(m,b,g="0"){for(;m.length<b;)m=g+m;return m}function w(m,b=32){return m instanceof ArrayBuffer?Array.from(new Uint8Array(m)).map(g=>g.toString(16).padStart(2,"0")).join(""):h((m>>>0).toString(16),b/4)}e.toHexString=w;class y{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(b){const g=b.length;if(g===0)return;const a=this._buff;let l=this._buffLen,r=this._leftoverHighSurrogate,o,n;for(r!==0?(o=r,n=-1,r=0):(o=b.charCodeAt(0),n=0);;){let t=o;if(R.isHighSurrogate(o))if(n+1<g){const s=b.charCodeAt(n+1);R.isLowSurrogate(s)?(n++,t=R.computeCodePoint(o,s)):t=65533}else{r=o;break}else R.isLowSurrogate(o)&&(t=65533);if(l=this._push(a,l,t),n++,n<g)o=b.charCodeAt(n);else break}this._buffLen=l,this._leftoverHighSurrogate=r}_push(b,g,a){return a<128?b[g++]=a:a<2048?(b[g++]=192|(a&1984)>>>6,b[g++]=128|(a&63)>>>0):a<65536?(b[g++]=224|(a&61440)>>>12,b[g++]=128|(a&4032)>>>6,b[g++]=128|(a&63)>>>0):(b[g++]=240|(a&1835008)>>>18,b[g++]=128|(a&258048)>>>12,b[g++]=128|(a&4032)>>>6,b[g++]=128|(a&63)>>>0),g>=64&&(this._step(),g-=64,this._totalLen+=64,b[0]=b[64+0],b[1]=b[64+1],b[2]=b[64+2]),g}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),w(this._h0)+w(this._h1)+w(this._h2)+w(this._h3)+w(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,p(this._buff,this._buffLen),this._buffLen>56&&(this._step(),p(this._buff));const b=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(b/4294967296),!1),this._buffDV.setUint32(60,b%4294967296,!1),this._step()}_step(){const b=y._bigBlock32,g=this._buffDV;for(let u=0;u<64;u+=4)b.setUint32(u,g.getUint32(u,!1),!1);for(let u=64;u<320;u+=4)b.setUint32(u,d(b.getUint32(u-12,!1)^b.getUint32(u-32,!1)^b.getUint32(u-56,!1)^b.getUint32(u-64,!1),1),!1);let a=this._h0,l=this._h1,r=this._h2,o=this._h3,n=this._h4,t,s,c;for(let u=0;u<80;u++)u<20?(t=l&r|~l&o,s=1518500249):u<40?(t=l^r^o,s=1859775393):u<60?(t=l&r|l&o|r&o,s=2400959708):(t=l^r^o,s=3395469782),c=d(a,5)+t+n+s+b.getUint32(u*4,!1)&4294967295,n=o,o=r,r=d(l,30),l=a,a=c;this._h0=this._h0+a&4294967295,this._h1=this._h1+l&4294967295,this._h2=this._h2+r&4294967295,this._h3=this._h3+o&4294967295,this._h4=this._h4+n&4294967295}}e.StringSHA1=y,y._bigBlock32=new DataView(new ArrayBuffer(320))});var bt=this&&this.__classPrivateFieldSet||function(X,e,R,L,D){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!D:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?D.call(X,R):D?D.value=R:e.set(X,R),R},Be=this&&this.__classPrivateFieldGet||function(X,e,R,L){if(R==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!L:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return R==="m"?L:R==="a"?L.call(X):L?L.value:e.get(X)};define(te[41],ne([0,1,16,25]),function(X,e,R,L){"use strict";var D,k,i;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function P(n,t,s){let c=n.get(t);return c===void 0&&(c=s,n.set(t,c)),c}e.getOrSet=P;function S(n){const t=[];return n.forEach((s,c)=>{t.push(`${c} => ${s}`)}),`Map(${n.size}) {${t.join(", ")}}`}e.mapToString=S;function C(n){const t=[];return n.forEach(s=>{t.push(s)}),`Set(${n.size}) {${t.join(", ")}}`}e.setToString=C;class I{constructor(){this._value="",this._pos=0}reset(t){return this._value=t,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(t){const s=t.charCodeAt(0),c=this._value.charCodeAt(this._pos);return s-c}value(){return this._value[this._pos]}}e.StringIterator=I;class E{constructor(t=!0){this._caseSensitive=t}reset(t){return this._value=t,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let t=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(t)this._from++;else break;else t=!1;return this}cmp(t){return this._caseSensitive?(0,L.compareSubstring)(t,this._value,0,t.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(t,this._value,0,t.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=E;class d{constructor(t=!0,s=!0){this._splitOnBackslash=t,this._caseSensitive=s}reset(t){return this._value=t.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let t=!0;for(;this._to<this._value.length;this._to++){const s=this._value.charCodeAt(this._to);if(s===47||this._splitOnBackslash&&s===92)if(t)this._from++;else break;else t=!1}return this}cmp(t){return this._caseSensitive?(0,L.compareSubstring)(t,this._value,0,t.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(t,this._value,0,t.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=d;var p;(function(n){n[n.Scheme=1]="Scheme",n[n.Authority=2]="Authority",n[n.Path=3]="Path",n[n.Query=4]="Query",n[n.Fragment=5]="Fragment"})(p||(p={}));class h{constructor(t){this._ignorePathCasing=t,this._states=[],this._stateIdx=0}reset(t){return this._value=t,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new d(!1,!this._ignorePathCasing(t)),this._pathIterator.reset(t.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(t){if(this._states[this._stateIdx]===1)return(0,L.compareIgnoreCase)(t,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,L.compareIgnoreCase)(t,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(t);if(this._states[this._stateIdx]===4)return(0,L.compare)(t,this._value.query);if(this._states[this._stateIdx]===5)return(0,L.compare)(t,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=h;class w{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const t=this.right;return this.right=t.left,t.left=this,this.updateHeight(),t.updateHeight(),t}rotateRight(){const t=this.left;return this.left=t.right,t.right=this,this.updateHeight(),t.updateHeight(),t}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var y;(function(n){n[n.Left=-1]="Left",n[n.Mid=0]="Mid",n[n.Right=1]="Right"})(y||(y={}));class m{constructor(t){this._iter=t}static forUris(t=()=>!1){return new m(new h(t))}static forPaths(){return new m(new d)}static forStrings(){return new m(new I)}static forConfigKeys(){return new m(new E)}clear(){this._root=void 0}fill(t,s){if(s){const c=s.slice(0);(0,R.shuffle)(c);for(let u of c)this.set(u,t)}else{const c=t.slice(0);(0,R.shuffle)(c);for(let u of c)this.set(u[0],u[1])}}set(t,s){const c=this._iter.reset(t);let u;this._root||(this._root=new w,this._root.segment=c.value());const f=[];for(u=this._root;;){const T=c.cmp(u.segment);if(T>0)u.left||(u.left=new w,u.left.segment=c.value()),f.push([-1,u]),u=u.left;else if(T<0)u.right||(u.right=new w,u.right.segment=c.value()),f.push([1,u]),u=u.right;else if(c.hasNext())c.next(),u.mid||(u.mid=new w,u.mid.segment=c.value()),f.push([0,u]),u=u.mid;else break}const v=u.value;u.value=s,u.key=t;for(let T=f.length-1;T>=0;T--){const O=f[T][1];O.updateHeight();const U=O.balanceFactor();if(U<-1||U>1){const W=f[T][0],N=f[T+1][0];if(W===1&&N===1)f[T][1]=O.rotateLeft();else if(W===-1&&N===-1)f[T][1]=O.rotateRight();else if(W===1&&N===-1)O.right=f[T+1][1]=f[T+1][1].rotateRight(),f[T][1]=O.rotateLeft();else if(W===-1&&N===1)O.left=f[T+1][1]=f[T+1][1].rotateLeft(),f[T][1]=O.rotateRight();else throw new Error;if(T>0)switch(f[T-1][0]){case-1:f[T-1][1].left=f[T][1];break;case 1:f[T-1][1].right=f[T][1];break;case 0:f[T-1][1].mid=f[T][1];break}else this._root=f[0][1]}}return v}get(t){return this._getNode(t)?.value}_getNode(t){const s=this._iter.reset(t);let c=this._root;for(;c;){const u=s.cmp(c.segment);if(u>0)c=c.left;else if(u<0)c=c.right;else if(s.hasNext())s.next(),c=c.mid;else break}return c}has(t){const s=this._getNode(t);return!(s?.value===void 0&&s?.mid===void 0)}delete(t){return this._delete(t,!1)}deleteSuperstr(t){return this._delete(t,!0)}_delete(t,s){const c=this._iter.reset(t),u=[];let f=this._root;for(;f;){const v=c.cmp(f.segment);if(v>0)u.push([-1,f]),f=f.left;else if(v<0)u.push([1,f]),f=f.right;else if(c.hasNext())c.next(),u.push([0,f]),f=f.mid;else break}if(!!f){if(s?(f.left=void 0,f.mid=void 0,f.right=void 0,f.height=1):(f.key=void 0,f.value=void 0),!f.mid&&!f.value)if(f.left&&f.right){const v=this._min(f.right),{key:T,value:O,segment:U}=v;this._delete(v.key,!1),f.key=T,f.value=O,f.segment=U}else{const v=f.left??f.right;if(u.length>0){const[T,O]=u[u.length-1];switch(T){case-1:O.left=v;break;case 0:O.mid=v;break;case 1:O.right=v;break}}else this._root=v}for(let v=u.length-1;v>=0;v--){const T=u[v][1];T.updateHeight();const O=T.balanceFactor();if(O>1?(T.right.balanceFactor()>=0||(T.right=u[v+1][1]=u[v+1][1].rotateRight()),u[v][1]=T.rotateLeft()):O<-1&&(T.left.balanceFactor()<=0||(T.left=u[v+1][1]=u[v+1][1].rotateLeft()),u[v][1]=T.rotateRight()),v>0)switch(u[v-1][0]){case-1:u[v-1][1].left=u[v][1];break;case 1:u[v-1][1].right=u[v][1];break;case 0:u[v-1][1].mid=u[v][1];break}else this._root=u[0][1]}}}_min(t){for(;t.left;)t=t.left;return t}findSubstr(t){const s=this._iter.reset(t);let c=this._root,u;for(;c;){const f=s.cmp(c.segment);if(f>0)c=c.left;else if(f<0)c=c.right;else if(s.hasNext())s.next(),u=c.value||u,c=c.mid;else break}return c&&c.value||u}findSuperstr(t){const s=this._iter.reset(t);let c=this._root;for(;c;){const u=s.cmp(c.segment);if(u>0)c=c.left;else if(u<0)c=c.right;else if(s.hasNext())s.next(),c=c.mid;else return c.mid?this._entries(c.mid):void 0}}forEach(t){for(const[s,c]of this)t(c,s)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(t){!t||(t.left&&(yield*this._entries(t.left)),t.value&&(yield[t.key,t.value]),t.mid&&(yield*this._entries(t.mid)),t.right&&(yield*this._entries(t.right)))}_isBalanced(){const t=s=>{if(!s)return!0;const c=s.balanceFactor();return c<-1||c>1?!1:t(s.left)&&t(s.right)};return t(this._root)}}e.TernarySearchTree=m;class b{constructor(t,s){this.uri=t,this.value=s}}class g{constructor(t,s){this[D]="ResourceMap",t instanceof g?(this.map=new Map(t.map),this.toKey=s??g.defaultToKey):(this.map=new Map,this.toKey=t??g.defaultToKey)}set(t,s){return this.map.set(this.toKey(t),new b(t,s)),this}get(t){return this.map.get(this.toKey(t))?.value}has(t){return this.map.has(this.toKey(t))}get size(){return this.map.size}clear(){this.map.clear()}delete(t){return this.map.delete(this.toKey(t))}forEach(t,s){typeof s!="undefined"&&(t=t.bind(s));for(let[c,u]of this.map)t(u.value,u.uri,this)}*values(){for(let t of this.map.values())yield t.value}*keys(){for(let t of this.map.values())yield t.uri}*entries(){for(let t of this.map.values())yield[t.uri,t.value]}*[(D=Symbol.toStringTag,Symbol.iterator)](){for(let[,t]of this.map)yield[t.uri,t.value]}}e.ResourceMap=g,g.defaultToKey=n=>n.toString();var a;(function(n){n[n.None=0]="None",n[n.AsOld=1]="AsOld",n[n.AsNew=2]="AsNew"})(a=e.Touch||(e.Touch={}));class l{constructor(){this[k]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(t){return this._map.has(t)}get(t,s=0){const c=this._map.get(t);if(!!c)return s!==0&&this.touch(c,s),c.value}set(t,s,c=0){let u=this._map.get(t);if(u)u.value=s,c!==0&&this.touch(u,c);else{switch(u={key:t,value:s,next:void 0,previous:void 0},c){case 0:this.addItemLast(u);break;case 1:this.addItemFirst(u);break;case 2:this.addItemLast(u);break;default:this.addItemLast(u);break}this._map.set(t,u),this._size++}return this}delete(t){return!!this.remove(t)}remove(t){const s=this._map.get(t);if(!!s)return this._map.delete(t),this.removeItem(s),this._size--,s.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const t=this._head;return this._map.delete(t.key),this.removeItem(t),this._size--,t.value}forEach(t,s){const c=this._state;let u=this._head;for(;u;){if(s?t.bind(s)(u.value,u.key,this):t(u.value,u.key,this),this._state!==c)throw new Error("LinkedMap got modified during iteration.");u=u.next}}keys(){const t=this,s=this._state;let c=this._head;const u={[Symbol.iterator](){return u},next(){if(t._state!==s)throw new Error("LinkedMap got modified during iteration.");if(c){const f={value:c.key,done:!1};return c=c.next,f}else return{value:void 0,done:!0}}};return u}values(){const t=this,s=this._state;let c=this._head;const u={[Symbol.iterator](){return u},next(){if(t._state!==s)throw new Error("LinkedMap got modified during iteration.");if(c){const f={value:c.value,done:!1};return c=c.next,f}else return{value:void 0,done:!0}}};return u}entries(){const t=this,s=this._state;let c=this._head;const u={[Symbol.iterator](){return u},next(){if(t._state!==s)throw new Error("LinkedMap got modified during iteration.");if(c){const f={value:[c.key,c.value],done:!1};return c=c.next,f}else return{value:void 0,done:!0}}};return u}[(k=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(t){if(t>=this.size)return;if(t===0){this.clear();return}let s=this._head,c=this.size;for(;s&&c>t;)this._map.delete(s.key),s=s.next,c--;this._head=s,this._size=c,s&&(s.previous=void 0),this._state++}addItemFirst(t){if(!this._head&&!this._tail)this._tail=t;else if(this._head)t.next=this._head,this._head.previous=t;else throw new Error("Invalid list");this._head=t,this._state++}addItemLast(t){if(!this._head&&!this._tail)this._head=t;else if(this._tail)t.previous=this._tail,this._tail.next=t;else throw new Error("Invalid list");this._tail=t,this._state++}removeItem(t){if(t===this._head&&t===this._tail)this._head=void 0,this._tail=void 0;else if(t===this._head){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this._head=t.next}else if(t===this._tail){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this._tail=t.previous}else{const s=t.next,c=t.previous;if(!s||!c)throw new Error("Invalid list");s.previous=c,c.next=s}t.next=void 0,t.previous=void 0,this._state++}touch(t,s){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(t===this._head)return;const c=t.next,u=t.previous;t===this._tail?(u.next=void 0,this._tail=u):(c.previous=u,u.next=c),t.previous=void 0,t.next=this._head,this._head.previous=t,this._head=t,this._state++}else if(s===2){if(t===this._tail)return;const c=t.next,u=t.previous;t===this._head?(c.previous=void 0,this._head=c):(c.previous=u,u.next=c),t.next=void 0,t.previous=this._tail,this._tail.next=t,this._tail=t,this._state++}}}toJSON(){const t=[];return this.forEach((s,c)=>{t.push([c,s])}),t}fromJSON(t){this.clear();for(const[s,c]of t)this.set(s,c)}}e.LinkedMap=l;class r extends l{constructor(t,s=1){super();this._limit=t,this._ratio=Math.min(Math.max(0,s),1)}get limit(){return this._limit}set limit(t){this._limit=t,this.checkTrim()}get ratio(){return this._ratio}set ratio(t){this._ratio=Math.min(Math.max(0,t),1),this.checkTrim()}get(t,s=2){return super.get(t,s)}peek(t){return super.get(t,0)}set(t,s){return super.set(t,s,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=r;class o{constructor(t){i.set(this,void 0),bt(this,i,t,"f")}get size(){return Be(this,i,"f").size}forEach(t,s){Be(this,i,"f").forEach(t,s)}get(t){return Be(this,i,"f").get(t)}has(t){return Be(this,i,"f").has(t)}entries(){return Be(this,i,"f").entries()}keys(){return Be(this,i,"f").keys()}values(){return Be(this,i,"f").values()}[(i=new WeakMap,Symbol.iterator)](){return Be(this,i,"f").entries()}}e.ReadonlyMapView=o}),define(te[69],ne([0,1,41]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const L=new R.LRUCache(1e4);function D(C){return S(C,"NFC",L)}e.normalizeNFC=D;const k=new R.LRUCache(1e4);function i(C){return S(C,"NFD",k)}e.normalizeNFD=i;const P=/[^\u0000-\u0080]/;function S(C,I,E){if(!C)return C;const d=E.get(C);if(d)return d;let p;return P.test(C)?p=C.normalize(I):p=C,E.set(C,p),p}e.removeAccents=function(){const C=/[\u0300-\u036f]/g;return function(I){return i(I).replace(C,"")}}()}),define(te[17],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPromise=e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function R(f){return Array.isArray(f)}e.isArray=R;function L(f){return typeof f=="string"}e.isString=L;function D(f){return Array.isArray(f)&&f.every(v=>L(v))}e.isStringArray=D;function k(f){return typeof f=="object"&&f!==null&&!Array.isArray(f)&&!(f instanceof RegExp)&&!(f instanceof Date)}e.isObject=k;function i(f){return typeof f=="number"&&!isNaN(f)}e.isNumber=i;function P(f){return!!f&&typeof f[Symbol.iterator]=="function"}e.isIterable=P;function S(f){return f===!0||f===!1}e.isBoolean=S;function C(f){return typeof f=="undefined"}e.isUndefined=C;function I(f){return!E(f)}e.isDefined=I;function E(f){return C(f)||f===null}e.isUndefinedOrNull=E;function d(f,v){if(!f)throw new Error(v?`Unexpected type, expected '${v}'`:"Unexpected type")}e.assertType=d;function p(f){if(E(f))throw new Error("Assertion Failed: argument is undefined or null");return f}e.assertIsDefined=p;function h(...f){const v=[];for(let T=0;T<f.length;T++){const O=f[T];if(E(O))throw new Error(`Assertion Failed: argument at index ${T} is undefined or null`);v.push(O)}return v}e.assertAllDefined=h;const w=Object.prototype.hasOwnProperty;function y(f){if(!k(f))return!1;for(let v in f)if(w.call(f,v))return!1;return!0}e.isEmptyObject=y;function m(f){return typeof f=="function"}e.isFunction=m;function b(...f){return f.length>0&&f.every(m)}e.areFunctions=b;function g(f,v){const T=Math.min(f.length,v.length);for(let O=0;O<T;O++)a(f[O],v[O])}e.validateConstraints=g;function a(f,v){if(L(v)){if(typeof f!==v)throw new Error(`argument does not match constraint: typeof ${v}`)}else if(m(v)){try{if(f instanceof v)return}catch{}if(!E(f)&&f.constructor===v||v.length===1&&v.call(void 0,f)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=a;function l(f){let v=[],T=Object.getPrototypeOf(f);for(;Object.prototype!==T;)v=v.concat(Object.getOwnPropertyNames(T)),T=Object.getPrototypeOf(T);return v}e.getAllPropertyNames=l;function r(f){const v=[];for(const T of l(f))typeof f[T]=="function"&&v.push(T);return v}e.getAllMethodNames=r;function o(f,v){const T=U=>function(){const W=Array.prototype.slice.call(arguments,0);return v(U,W)};let O={};for(const U of f)O[U]=T(U);return O}e.createProxyObject=o;function n(f){return f===null?void 0:f}e.withNullAsUndefined=n;function t(f){return typeof f=="undefined"?null:f}e.withUndefinedAsNull=t;function s(f){return class{constructor(){return new Proxy({},{get(v,T){if(v[T])return v[T];throw new Error(`Not Implemented: ${f}->${String(T)}`)}})}}}e.NotImplementedProxy=s;function c(f,v="Unreachable"){throw new Error(v)}e.assertNever=c;function u(f){return!!f&&typeof f.then=="function"&&typeof f.catch=="function"}e.isPromise=u}),define(te[42],ne([0,1,10,4,25,17]),function(X,e,R,L,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function i(n){return n===47||n===92}e.isPathSeparator=i;function P(n){return n.replace(/[\\/]/g,R.posix.sep)}e.toSlashes=P;function S(n){return n.indexOf("/")===-1&&(n=P(n)),/^[a-zA-Z]:(\/|$)/.test(n)&&(n="/"+n),n}e.toPosixPath=S;function C(n,t=R.posix.sep){if(!n)return"";const s=n.length,c=n.charCodeAt(0);if(i(c)){if(i(n.charCodeAt(1))&&!i(n.charCodeAt(2))){let f=3;const v=f;for(;f<s&&!i(n.charCodeAt(f));f++);if(v!==f&&!i(n.charCodeAt(f+1))){for(f+=1;f<s;f++)if(i(n.charCodeAt(f)))return n.slice(0,f+1).replace(/[\\/]/g,t)}}return t}else if(m(c)&&n.charCodeAt(1)===58)return i(n.charCodeAt(2))?n.slice(0,2)+t:n.slice(0,2);let u=n.indexOf("://");if(u!==-1){for(u+=3;u<s;u++)if(i(n.charCodeAt(u)))return n.slice(0,u+1)}return""}e.getRoot=C;function I(n){if(!L.isWindows||!n||n.length<5)return!1;let t=n.charCodeAt(0);if(t!==92||(t=n.charCodeAt(1),t!==92))return!1;let s=2;const c=s;for(;s<n.length&&(t=n.charCodeAt(s),t!==92);s++);return!(c===s||(t=n.charCodeAt(s+1),isNaN(t)||t===92))}e.isUNC=I;const E=/[\\/:\*\?"<>\|]/g,d=/[\\/]/g,p=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function h(n,t=L.isWindows){const s=t?E:d;return!(!n||n.length===0||/^\s+$/.test(n)||(s.lastIndex=0,s.test(n))||t&&p.test(n)||n==="."||n===".."||t&&n[n.length-1]==="."||t&&n.length!==n.trim().length||n.length>255)}e.isValidBasename=h;function w(n,t,s){const c=n===t;return!s||c?c:!n||!t?!1:(0,D.equalsIgnoreCase)(n,t)}e.isEqual=w;function y(n,t,s,c=R.sep){if(n===t)return!0;if(!n||!t||t.length>n.length)return!1;if(s){if(!(0,D.startsWithIgnoreCase)(n,t))return!1;if(t.length===n.length)return!0;let f=t.length;return t.charAt(t.length-1)===c&&f--,n.charAt(f)===c}return t.charAt(t.length-1)!==c&&(t+=c),n.indexOf(t)===0}e.isEqualOrParent=y;function m(n){return n>=65&&n<=90||n>=97&&n<=122}e.isWindowsDriveLetter=m;function b(n,t){return L.isWindows&&n.endsWith(":")&&(n+=R.sep),(0,R.isAbsolute)(n)||(n=(0,R.join)(t,n)),n=(0,R.normalize)(n),L.isWindows?(n=(0,D.rtrim)(n,R.sep),n.endsWith(":")&&(n+=R.sep)):(n=(0,D.rtrim)(n,R.sep),n||(n=R.sep)),n}e.sanitizeFilePath=b;function g(n){const t=(0,R.normalize)(n);return L.isWindows?n.length>3?!1:a(t)&&(n.length===2||t.charCodeAt(2)===92):t===R.posix.sep}e.isRootOrDriveLetter=g;function a(n,t){return(t!==void 0?t:L.isWindows)?m(n.charCodeAt(0))&&n.charCodeAt(1)===58:!1}e.hasDriveLetter=a;function l(n){return a(n)?n[0]:void 0}e.getDriveLetter=l;function r(n,t,s){return t.length>n.length?-1:n===t?0:(s&&(n=n.toLowerCase(),t=t.toLowerCase()),n.indexOf(t))}e.indexOfPath=r;function o(n){const t=n.split(":");let s,c,u;if(t.forEach(f=>{const v=Number(f);(0,k.isNumber)(v)?c===void 0?c=v:u===void 0&&(u=v):s=s?[s,f].join(":"):f}),!s)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:s,line:c!==void 0?c:void 0,column:u!==void 0?u:c!==void 0?1:void 0}}e.parseLineAndColumnAware=o}),define(te[28],ne([0,1,17]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function L(w){if(!w||typeof w!="object"||w instanceof RegExp)return w;const y=Array.isArray(w)?[]:{};return Object.keys(w).forEach(m=>{w[m]&&typeof w[m]=="object"?y[m]=L(w[m]):y[m]=w[m]}),y}e.deepClone=L;function D(w){if(!w||typeof w!="object")return w;const y=[w];for(;y.length>0;){const m=y.shift();Object.freeze(m);for(const b in m)if(k.call(m,b)){const g=m[b];typeof g=="object"&&!Object.isFrozen(g)&&y.push(g)}}return w}e.deepFreeze=D;const k=Object.prototype.hasOwnProperty;function i(w,y){return P(w,y,new Set)}e.cloneAndChange=i;function P(w,y,m){if((0,R.isUndefinedOrNull)(w))return w;const b=y(w);if(typeof b!="undefined")return b;if((0,R.isArray)(w)){const g=[];for(const a of w)g.push(P(a,y,m));return g}if((0,R.isObject)(w)){if(m.has(w))throw new Error("Cannot clone recursive data-structure");m.add(w);const g={};for(let a in w)k.call(w,a)&&(g[a]=P(w[a],y,m));return m.delete(w),g}return w}function S(w,y,m=!0){return(0,R.isObject)(w)?((0,R.isObject)(y)&&Object.keys(y).forEach(b=>{b in w?m&&((0,R.isObject)(w[b])&&(0,R.isObject)(y[b])?S(w[b],y[b],m):w[b]=y[b]):w[b]=y[b]}),w):y}e.mixin=S;function C(w,y){if(w===y)return!0;if(w==null||y===null||y===void 0||typeof w!=typeof y||typeof w!="object"||Array.isArray(w)!==Array.isArray(y))return!1;let m,b;if(Array.isArray(w)){if(w.length!==y.length)return!1;for(m=0;m<w.length;m++)if(!C(w[m],y[m]))return!1}else{const g=[];for(b in w)g.push(b);g.sort();const a=[];for(b in y)a.push(b);if(a.sort(),!C(g,a))return!1;for(m=0;m<g.length;m++)if(!C(w[g[m]],y[g[m]]))return!1}return!0}e.equals=C;function I(w){const y=new Set;return JSON.stringify(w,(m,b)=>{if((0,R.isObject)(b)||Array.isArray(b)){if(y.has(b))return"[Circular]";y.add(b)}return b})}e.safeStringify=I;function E(w,y,m){const b=y(w);return typeof b=="undefined"?m:b}e.getOrDefault=E;function d(w,y){const m=Object.create(null);return!w||!y||Object.keys(y).forEach(g=>{const a=w[g],l=y[g];C(a,l)||(m[g]=l)}),m}e.distinct=d;function p(w,y){const m=y.toLowerCase(),b=Object.keys(w).find(g=>g.toLowerCase()===m);return b?w[b]:w[y]}e.getCaseInsensitive=p;function h(w,y){const m=Object.create(null);for(const[b,g]of Object.entries(w))y(b,g)&&(m[b]=g);return m}e.filter=h}),define(te[7],ne([0,1,10,4]),function(X,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const D=/^\w[\w\d+.-]*$/,k=/^\//,i=/^\/\//;function P(n,t){if(!n.scheme&&t)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${n.authority}", path: "${n.path}", query: "${n.query}", fragment: "${n.fragment}"}`);if(n.scheme&&!D.test(n.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(n.path){if(n.authority){if(!k.test(n.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(i.test(n.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function S(n,t){return!n&&!t?"file":n}function C(n,t){switch(n){case"https":case"http":case"file":t?t[0]!==E&&(t=E+t):t=E;break}return t}const I="",E="/",d=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class p{constructor(t,s,c,u,f,v=!1){typeof t=="object"?(this.scheme=t.scheme||I,this.authority=t.authority||I,this.path=t.path||I,this.query=t.query||I,this.fragment=t.fragment||I):(this.scheme=S(t,v),this.authority=s||I,this.path=C(this.scheme,c||I),this.query=u||I,this.fragment=f||I,P(this,v))}static isUri(t){return t instanceof p?!0:t?typeof t.authority=="string"&&typeof t.fragment=="string"&&typeof t.path=="string"&&typeof t.query=="string"&&typeof t.scheme=="string"&&typeof t.fsPath=="string"&&typeof t.with=="function"&&typeof t.toString=="function":!1}get fsPath(){return g(this,!1)}with(t){if(!t)return this;let{scheme:s,authority:c,path:u,query:f,fragment:v}=t;return s===void 0?s=this.scheme:s===null&&(s=I),c===void 0?c=this.authority:c===null&&(c=I),u===void 0?u=this.path:u===null&&(u=I),f===void 0?f=this.query:f===null&&(f=I),v===void 0?v=this.fragment:v===null&&(v=I),s===this.scheme&&c===this.authority&&u===this.path&&f===this.query&&v===this.fragment?this:new w(s,c,u,f,v)}static parse(t,s=!1){const c=d.exec(t);return c?new w(c[2]||I,o(c[4]||I),o(c[5]||I),o(c[7]||I),o(c[9]||I),s):new w(I,I,I,I,I)}static file(t){let s=I;if(L.isWindows&&(t=t.replace(/\\/g,E)),t[0]===E&&t[1]===E){const c=t.indexOf(E,2);c===-1?(s=t.substring(2),t=E):(s=t.substring(2,c),t=t.substring(c)||E)}return new w("file",s,t,I,I)}static from(t){const s=new w(t.scheme,t.authority,t.path,t.query,t.fragment);return P(s,!0),s}static joinPath(t,...s){if(!t.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let c;return L.isWindows&&t.scheme==="file"?c=p.file(R.win32.join(g(t,!0),...s)).path:c=R.posix.join(t.path,...s),t.with({path:c})}toString(t=!1){return a(this,t)}toJSON(){return this}static revive(t){if(t){if(t instanceof p)return t;{const s=new w(t);return s._formatted=t.external,s._fsPath=t._sep===h?t.fsPath:null,s}}else return t}}e.URI=p;const h=L.isWindows?1:void 0;class w extends p{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=g(this,!1)),this._fsPath}toString(t=!1){return t?a(this,!0):(this._formatted||(this._formatted=a(this,!1)),this._formatted)}toJSON(){const t={$mid:1};return this._fsPath&&(t.fsPath=this._fsPath,t._sep=h),this._formatted&&(t.external=this._formatted),this.path&&(t.path=this.path),this.scheme&&(t.scheme=this.scheme),this.authority&&(t.authority=this.authority),this.query&&(t.query=this.query),this.fragment&&(t.fragment=this.fragment),t}}const y={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function m(n,t){let s,c=-1;for(let u=0;u<n.length;u++){const f=n.charCodeAt(u);if(f>=97&&f<=122||f>=65&&f<=90||f>=48&&f<=57||f===45||f===46||f===95||f===126||t&&f===47)c!==-1&&(s+=encodeURIComponent(n.substring(c,u)),c=-1),s!==void 0&&(s+=n.charAt(u));else{s===void 0&&(s=n.substr(0,u));const v=y[f];v!==void 0?(c!==-1&&(s+=encodeURIComponent(n.substring(c,u)),c=-1),s+=v):c===-1&&(c=u)}}return c!==-1&&(s+=encodeURIComponent(n.substring(c))),s!==void 0?s:n}function b(n){let t;for(let s=0;s<n.length;s++){const c=n.charCodeAt(s);c===35||c===63?(t===void 0&&(t=n.substr(0,s)),t+=y[c]):t!==void 0&&(t+=n[s])}return t!==void 0?t:n}function g(n,t){let s;return n.authority&&n.path.length>1&&n.scheme==="file"?s=`//${n.authority}${n.path}`:n.path.charCodeAt(0)===47&&(n.path.charCodeAt(1)>=65&&n.path.charCodeAt(1)<=90||n.path.charCodeAt(1)>=97&&n.path.charCodeAt(1)<=122)&&n.path.charCodeAt(2)===58?t?s=n.path.substr(1):s=n.path[1].toLowerCase()+n.path.substr(2):s=n.path,L.isWindows&&(s=s.replace(/\//g,"\\")),s}e.uriToFsPath=g;function a(n,t){const s=t?b:m;let c="",{scheme:u,authority:f,path:v,query:T,fragment:O}=n;if(u&&(c+=u,c+=":"),(f||u==="file")&&(c+=E,c+=E),f){let U=f.indexOf("@");if(U!==-1){const W=f.substr(0,U);f=f.substr(U+1),U=W.indexOf(":"),U===-1?c+=s(W,!1):(c+=s(W.substr(0,U),!1),c+=":",c+=s(W.substr(U+1),!1)),c+="@"}f=f.toLowerCase(),U=f.indexOf(":"),U===-1?c+=s(f,!1):(c+=s(f.substr(0,U),!1),c+=f.substr(U))}if(v){if(v.length>=3&&v.charCodeAt(0)===47&&v.charCodeAt(2)===58){const U=v.charCodeAt(1);U>=65&&U<=90&&(v=`/${String.fromCharCode(U+32)}:${v.substr(3)}`)}else if(v.length>=2&&v.charCodeAt(1)===58){const U=v.charCodeAt(0);U>=65&&U<=90&&(v=`${String.fromCharCode(U+32)}:${v.substr(2)}`)}c+=s(v,!0)}return T&&(c+="?",c+=s(T,!1)),O&&(c+="#",c+=t?O:m(O,!1)),c}function l(n){try{return decodeURIComponent(n)}catch{return n.length>3?n.substr(0,3)+l(n.substr(3)):n}}const r=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function o(n){return n.match(r)?n.replace(r,t=>l(t)):n}}),define(te[106],ne([0,1,7]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function L(C){const I=C;return I&&typeof I.type=="string"&&typeof I.severity=="string"}e.isRemoteConsoleLog=L;function D(C){const I=[];let E;try{const d=JSON.parse(C.arguments),p=d[d.length-1];p&&p.__$stack&&(d.pop(),E=p.__$stack),I.push(...d)}catch(d){I.push("Unable to log remote console arguments",C.arguments)}return{args:I,stack:E}}e.parse=D;function k(C){if(typeof C!="string")return k(D(C).stack);const I=C;if(I){const E=i(I),d=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(E||"");if(d&&d.length===4)return{uri:R.URI.file(d[1]),line:Number(d[2]),column:Number(d[3])}}}e.getFirstFrame=k;function i(C){if(!C)return C;const I=C.indexOf(`
`);return I===-1?C:C.substring(0,I)}function P(C,I){const{args:E,stack:d}=D(C),p=typeof E[0]=="string"&&E.length===1;let h=i(d);h&&(h=`(${h.trim()})`);let w=[];if(typeof E[0]=="string"?h&&p?w=[`%c[${I}] %c${E[0]} %c${h}`,S("blue"),S(""),S("grey")]:w=[`%c[${I}] %c${E[0]}`,S("blue"),S(""),...E.slice(1)]:w=[`%c[${I}]%`,S("blue"),...E],h&&!p&&w.push(h),typeof console[C.severity]!="function")throw new Error("Unknown console method");console[C.severity].apply(console,w)}e.log=P;function S(C){return`color: ${C}`}}),define(te[107],ne([0,1,19,25,7]),function(X,e,R,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function k(I){return JSON.stringify(I,S)}e.stringify=k;function i(I){let E=JSON.parse(I);return E=C(E),E}e.parse=i;var P;(function(I){I[I.Uri=1]="Uri",I[I.Regexp=2]="Regexp",I[I.ScmResource=3]="ScmResource",I[I.ScmResourceGroup=4]="ScmResourceGroup",I[I.ScmProvider=5]="ScmProvider",I[I.CommentController=6]="CommentController",I[I.CommentThread=7]="CommentThread",I[I.CommentThreadReply=8]="CommentThreadReply",I[I.CommentNode=9]="CommentNode",I[I.CommentThreadNode=10]="CommentThreadNode",I[I.TimelineActionContext=11]="TimelineActionContext",I[I.NotebookCellActionContext=12]="NotebookCellActionContext",I[I.TestItemContext=13]="TestItemContext"})(P=e.MarshalledId||(e.MarshalledId={}));function S(I,E){return E instanceof RegExp?{$mid:2,source:E.source,flags:(0,L.regExpFlags)(E)}:E}function C(I,E=0){if(!I||E>200)return I;if(typeof I=="object"){switch(I.$mid){case 1:return D.URI.revive(I);case 2:return new RegExp(I.source,I.flags)}if(I instanceof R.VSBuffer||I instanceof Uint8Array)return I;if(Array.isArray(I))for(let d=0;d<I.length;++d)I[d]=C(I[d],E+1);else for(const d in I)Object.hasOwnProperty.call(I,d)&&(I[d]=C(I[d],E+1))}return I}e.revive=C}),define(te[15],ne([0,1,4,7]),function(X,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var D;(function(P){P.inMemory="inmemory",P.vscode="vscode",P.internal="private",P.walkThrough="walkThrough",P.walkThroughSnippet="walkThroughSnippet",P.http="http",P.https="https",P.file="file",P.mailto="mailto",P.untitled="untitled",P.data="data",P.command="command",P.vscodeRemote="vscode-remote",P.vscodeRemoteResource="vscode-remote-resource",P.userData="vscode-userdata",P.vscodeCustomEditor="vscode-custom-editor",P.vscodeNotebook="vscode-notebook",P.vscodeNotebookCell="vscode-notebook-cell",P.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",P.vscodeNotebookCellOutput="vscode-notebook-cell-output",P.vscodeInteractive="vscode-interactive",P.vscodeInteractiveInput="vscode-interactive-input",P.vscodeSettings="vscode-settings",P.vscodeWorkspaceTrust="vscode-workspace-trust",P.vscodeTerminal="vscode-terminal",P.webviewPanel="webview-panel",P.vscodeWebview="vscode-webview",P.extension="extension",P.vscodeFileResource="vscode-file",P.tmp="tmp",P.vsls="vsls"})(D=e.Schemas||(e.Schemas={}));class k{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(S){this._preferredWebSchema=S}setDelegate(S){this._delegate=S}set(S,C,I){this._hosts[S]=C,this._ports[S]=I}setConnectionToken(S,C){this._connectionTokens[S]=C}rewrite(S){if(this._delegate)return this._delegate(S);const C=S.authority;let I=this._hosts[C];I&&I.indexOf(":")!==-1&&(I=`[${I}]`);const E=this._ports[C],d=this._connectionTokens[C];let p=`path=${encodeURIComponent(S.path)}`;return typeof d=="string"&&(p+=`&tkn=${encodeURIComponent(d)}`),L.URI.from({scheme:R.isWeb?this._preferredWebSchema:D.vscodeRemoteResource,authority:`${I}:${E}`,path:"/vscode-remote-resource",query:p})}}e.RemoteAuthorities=new k;class i{asBrowserUri(S,C){const I=this.toUri(S,C);return I.scheme===D.vscodeRemote?e.RemoteAuthorities.rewrite(I):I.scheme===D.file&&(R.isNative||typeof R.globals.importScripts=="function"&&R.globals.origin===`${D.vscodeFileResource}://${i.FALLBACK_AUTHORITY}`)?I.with({scheme:D.vscodeFileResource,authority:I.authority||i.FALLBACK_AUTHORITY,query:null,fragment:null}):I}asFileUri(S,C){const I=this.toUri(S,C);return I.scheme===D.vscodeFileResource?I.with({scheme:D.file,authority:I.authority!==i.FALLBACK_AUTHORITY?I.authority:null,query:null,fragment:null}):I}toUri(S,C){return L.URI.isUri(S)?S:L.URI.parse(C.toUrl(S))}}i.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new i}),define(te[18],ne([0,1,42,15,10,4,25,7]),function(X,e,R,L,D,k,i,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function S(p){return(0,P.uriToFsPath)(p,!0)}e.originalFSPath=S;class C{constructor(h){this._ignorePathCasing=h}compare(h,w,y=!1){return h===w?0:(0,i.compare)(this.getComparisonKey(h,y),this.getComparisonKey(w,y))}isEqual(h,w,y=!1){return h===w?!0:!h||!w?!1:this.getComparisonKey(h,y)===this.getComparisonKey(w,y)}getComparisonKey(h,w=!1){return h.with({path:this._ignorePathCasing(h)?h.path.toLowerCase():void 0,fragment:w?null:void 0}).toString()}ignorePathCasing(h){return this._ignorePathCasing(h)}isEqualOrParent(h,w,y=!1){if(h.scheme===w.scheme){if(h.scheme===L.Schemas.file)return R.isEqualOrParent(S(h),S(w),this._ignorePathCasing(h))&&h.query===w.query&&(y||h.fragment===w.fragment);if((0,e.isEqualAuthority)(h.authority,w.authority))return R.isEqualOrParent(h.path,w.path,this._ignorePathCasing(h),"/")&&h.query===w.query&&(y||h.fragment===w.fragment)}return!1}joinPath(h,...w){return P.URI.joinPath(h,...w)}basenameOrAuthority(h){return(0,e.basename)(h)||h.authority}basename(h){return D.posix.basename(h.path)}extname(h){return D.posix.extname(h.path)}dirname(h){if(h.path.length===0)return h;let w;return h.scheme===L.Schemas.file?w=P.URI.file(D.dirname(S(h))).path:(w=D.posix.dirname(h.path),h.authority&&w.length&&w.charCodeAt(0)!==47&&(console.error(`dirname("${h.toString})) resulted in a relative path`),w="/")),h.with({path:w})}normalizePath(h){if(!h.path.length)return h;let w;return h.scheme===L.Schemas.file?w=P.URI.file(D.normalize(S(h))).path:w=D.posix.normalize(h.path),h.with({path:w})}relativePath(h,w){if(h.scheme!==w.scheme||!(0,e.isEqualAuthority)(h.authority,w.authority))return;if(h.scheme===L.Schemas.file){const b=D.relative(S(h),S(w));return k.isWindows?R.toSlashes(b):b}let y=h.path||"/",m=w.path||"/";if(this._ignorePathCasing(h)){let b=0;for(const g=Math.min(y.length,m.length);b<g&&!(y.charCodeAt(b)!==m.charCodeAt(b)&&y.charAt(b).toLowerCase()!==m.charAt(b).toLowerCase());b++);y=m.substr(0,b)+y.substr(b)}return D.posix.relative(y,m)}resolvePath(h,w){if(h.scheme===L.Schemas.file){const y=P.URI.file(D.resolve(S(h),w));return h.with({authority:y.authority,path:y.path})}return w=R.toPosixPath(w),h.with({path:D.posix.resolve(h.path,w)})}isAbsolutePath(h){return!!h.path&&h.path[0]==="/"}isEqualAuthority(h,w){return h===w||h!==void 0&&w!==void 0&&(0,i.equalsIgnoreCase)(h,w)}hasTrailingPathSeparator(h,w=D.sep){if(h.scheme===L.Schemas.file){const y=S(h);return y.length>R.getRoot(y).length&&y[y.length-1]===w}else{const y=h.path;return y.length>1&&y.charCodeAt(y.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(h.fsPath)}}removeTrailingPathSeparator(h,w=D.sep){return(0,e.hasTrailingPathSeparator)(h,w)?h.with({path:h.path.substr(0,h.path.length-1)}):h}addTrailingPathSeparator(h,w=D.sep){let y=!1;if(h.scheme===L.Schemas.file){const m=S(h);y=m!==void 0&&m.length===R.getRoot(m).length&&m[m.length-1]===w}else{w="/";const m=h.path;y=m.length===1&&m.charCodeAt(m.length-1)===47}return!y&&!(0,e.hasTrailingPathSeparator)(h,w)?h.with({path:h.path+"/"}):h}}e.ExtUri=C,e.extUri=new C(()=>!1),e.extUriBiasedIgnorePathCase=new C(p=>p.scheme===L.Schemas.file?!k.isLinux:!0),e.extUriIgnorePathCase=new C(p=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function I(p,h){const w=[];for(let y=0;y<p.length;y++){const m=h(p[y]);p.some((b,g)=>g===y?!1:(0,e.isEqualOrParent)(m,h(b)))||w.push(p[y])}return w}e.distinctParents=I;var E;(function(p){p.META_DATA_LABEL="label",p.META_DATA_DESCRIPTION="description",p.META_DATA_SIZE="size",p.META_DATA_MIME="mime";function h(w){const y=new Map;w.path.substring(w.path.indexOf(";")+1,w.path.lastIndexOf(";")).split(";").forEach(g=>{const[a,l]=g.split(":");a&&l&&y.set(a,l)});const b=w.path.substring(0,w.path.indexOf(";"));return b&&y.set(p.META_DATA_MIME,b),y}p.parseMetaData=h})(E=e.DataUri||(e.DataUri={}));function d(p,h,w){if(h){let y=p.path;return y&&y[0]!==D.posix.sep&&(y=D.posix.sep+y),p.with({scheme:w,authority:h,path:y})}return p.with({scheme:w})}e.toLocalResource=d}),define(te[5],ne([0,1,27,9,3,2,18]),function(X,e,R,L,D,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function P(q){return!!q&&typeof q.then=="function"}e.isThenable=P;function S(q){const B=new R.CancellationTokenSource,j=q(B.token),$=new Promise((K,F)=>{const x=B.token.onCancellationRequested(()=>{x.dispose(),B.dispose(),F((0,L.canceled)())});Promise.resolve(j).then(V=>{x.dispose(),B.dispose(),K(V)},V=>{x.dispose(),B.dispose(),F(V)})});return new class{cancel(){B.cancel()}then(K,F){return $.then(K,F)}catch(K){return this.then(void 0,K)}finally(K){return $.finally(K)}}}e.createCancelablePromise=S;function C(q,B,j){return Promise.race([q,new Promise($=>B.onCancellationRequested(()=>$(j)))])}e.raceCancellation=C;async function I(q){let B=-1;const j=q.map((K,F)=>K.then(x=>(B=F,x))),$=await Promise.race(j);return q.forEach((K,F)=>{F!==B&&K.cancel()}),$}e.raceCancellablePromises=I;function E(q,B,j){let $;const K=setTimeout(()=>{$?.(void 0),j?.()},B);return Promise.race([q.finally(()=>clearTimeout(K)),new Promise(F=>$=F)])}e.raceTimeout=E;function d(q){return new Promise((B,j)=>{const $=q();P($)?$.then(B,j):B($)})}e.asPromise=d;class p{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(B){if(this.activePromise){if(this.queuedPromiseFactory=B,!this.queuedPromise){const j=()=>{this.queuedPromise=null;const $=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,$};this.queuedPromise=new Promise($=>{this.activePromise.then(j,j).then($)})}return new Promise((j,$)=>{this.queuedPromise.then(j,$)})}return this.activePromise=B(),new Promise((j,$)=>{this.activePromise.then(K=>{this.activePromise=null,j(K)},K=>{this.activePromise=null,$(K)})})}}e.Throttler=p;class h{constructor(){this.current=Promise.resolve(null)}queue(B){return this.current=this.current.then(()=>B(),()=>B())}}e.Sequencer=h;class w{constructor(){this.promiseMap=new Map}queue(B,j){const K=(this.promiseMap.get(B)??Promise.resolve()).catch(()=>{}).then(j).finally(()=>{this.promiseMap.get(B)===K&&this.promiseMap.delete(B)});return this.promiseMap.set(B,K),K}}e.SequencerByKey=w;class y{constructor(B){this.defaultDelay=B,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(B,j=this.defaultDelay){return this.task=B,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise(($,K)=>{this.doResolve=$,this.doReject=K}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const $=this.task;return this.task=null,$()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},j),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,L.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=y;class m{constructor(B){this.delayer=new y(B),this.throttler=new p}trigger(B,j){return this.delayer.trigger(()=>this.throttler.queue(B),j)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=m;class b{constructor(){this._isOpen=!1,this._promise=new Promise((B,j)=>{this._completePromise=B})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=b;class g extends b{constructor(B){super();this._timeout=setTimeout(()=>this.open(),B)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=g;function a(q,B){return B?new Promise((j,$)=>{const K=setTimeout(()=>{F.dispose(),j()},q),F=B.onCancellationRequested(()=>{clearTimeout(K),F.dispose(),$((0,L.canceled)())})}):S(j=>a(q,j))}e.timeout=a;function l(q,B=0){const j=setTimeout(q,B);return(0,k.toDisposable)(()=>clearTimeout(j))}e.disposableTimeout=l;function r(q){const B=[];let j=0;const $=q.length;function K(){return j<$?q[j++]():null}function F(x){x!=null&&B.push(x);const V=K();return V?V.then(F):Promise.resolve(B)}return Promise.resolve(null).then(F)}e.sequence=r;function o(q,B=$=>!!$,j=null){let $=0;const K=q.length,F=()=>{if($>=K)return Promise.resolve(j);const x=q[$++];return Promise.resolve(x()).then(Q=>B(Q)?Promise.resolve(Q):F())};return F()}e.first=o;function n(q,B=$=>!!$,j=null){if(q.length===0)return Promise.resolve(j);let $=q.length;const K=()=>{$=-1;for(const F of q)F.cancel?.()};return new Promise((F,x)=>{for(const V of q)V.then(Q=>{--$>=0&&B(Q)?(K(),F(Q)):$===0&&F(j)}).catch(Q=>{--$>=0&&(K(),x(Q))})})}e.firstParallel=n;class t{constructor(B){this._size=0,this.maxDegreeOfParalellism=B,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new D.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(B){return this._size++,new Promise((j,$)=>{this.outstandingPromises.push({factory:B,c:j,e:$}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const B=this.outstandingPromises.shift();this.runningPromises++;const j=B.factory();j.then(B.c,B.e),j.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=t;class s extends t{constructor(){super(1)}}e.Queue=s;class c{constructor(){this.queues=new Map}queueFor(B,j=i.extUri){const $=j.getComparisonKey(B);let K=this.queues.get($);return K||(K=new s,D.Event.once(K.onFinished)(()=>{K?.dispose(),this.queues.delete($)}),this.queues.set($,K)),K}dispose(){this.queues.forEach(B=>B.dispose()),this.queues.clear()}}e.ResourceQueue=c;class u{constructor(B,j){this._token=-1,typeof B=="function"&&typeof j=="number"&&this.setIfNotSet(B,j)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(B,j){this.cancel(),this._token=setTimeout(()=>{this._token=-1,B()},j)}setIfNotSet(B,j){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,B()},j))}}e.TimeoutTimer=u;class f{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(B,j){this.cancel(),this._token=setInterval(()=>{B()},j)}}e.IntervalTimer=f;class v{constructor(B,j){this.timeoutToken=-1,this.runner=B,this.timeout=j,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(B=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,B)}get delay(){return this.timeout}set delay(B){this.timeout=B}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=v;class T{constructor(B,j){j%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${j}ms is not a multiple of 1000ms.`),this.runner=B,this.timeout=j,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(B=this.timeout){B%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${B}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(B/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=T;class O extends v{constructor(B,j){super(B,j);this.units=[]}work(B){this.units.push(B),this.isScheduled()||this.schedule()}doRun(){const B=this.units;this.units=[],this.runner&&this.runner(B)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=O;class U extends k.Disposable{constructor(B,j,$,K){super();this.maxWorkChunkSize=B,this.maxPendingWork=j,this.throttleDelay=$,this.handler=K,this.pendingWork=[],this.throttler=this._register(new k.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(B){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+B.length>this.maxPendingWork)return!1}else if(this.pending+B.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...B),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new v(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=U,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=q=>{const B=setTimeout(()=>{const $=Date.now()+15;q(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,$-Date.now())}}))});let j=!1;return{dispose(){j||(j=!0,clearTimeout(B))}}}:e.runWhenIdle=(q,B)=>{const j=requestIdleCallback(q,typeof B=="number"?{timeout:B}:void 0);let $=!1;return{dispose(){$||($=!0,cancelIdleCallback(j))}}}}();class W{constructor(B){this._didRun=!1,this._executor=()=>{try{this._value=B()}catch(j){this._error=j}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=W;async function N(q,B,j){let $;for(let K=0;K<j;K++)try{return await q()}catch(F){$=F,await a(B)}throw $}e.retry=N;class A{hasPending(B){return this._pending?typeof B=="number"?this._pending.taskId===B:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(B,j,$){return this._pending={taskId:B,cancel:()=>$?.(),promise:j},j.then(()=>this.donePending(B),()=>this.donePending(B)),j}donePending(B){this._pending&&B===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const B=this._next;this._next=void 0,B.run().then(B.promiseResolve,B.promiseReject)}}setNext(B){if(this._next)this._next.run=B;else{let j,$;const K=new Promise((F,x)=>{j=F,$=x});this._next={run:B,promise:K,promiseResolve:j,promiseReject:$}}return this._next.promise}}e.TaskSequentializer=A;class z{constructor(B){this.interval=B,this.lastIncrementTime=0,this.value=0}increment(){const B=Date.now();return B-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=B,this.value=0),this.value++,this.value}}e.IntervalCounter=z;class _{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((B,j)=>{this.completeCallback=B,this.errorCallback=j})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(B){return new Promise(j=>{this.completeCallback(B),this.resolved=!0,j()})}error(B){return new Promise(j=>{this.errorCallback(B),this.rejected=!0,j()})}cancel(){new Promise(B=>{this.errorCallback((0,L.canceled)()),this.rejected=!0,B()})}}e.DeferredPromise=_;var M;(function(q){async function B($){let K;const F=await Promise.all($.map(x=>x.then(V=>V,V=>{K||(K=V)})));if(typeof K!="undefined")throw K;return F}q.settled=B;function j($){return new Promise(async(K,F)=>{try{await $(K,F)}catch(x){F(x)}})}q.withAsyncBody=j})(M=e.Promises||(e.Promises={}))}),define(te[108],ne([0,1,5,42,41,10,25]),function(X,e,R,L,D,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function P(){return Object.create(null)}e.getEmptyExpression=P;const S="**",C="/",I="[/\\\\]",E="[^/\\\\]",d=/\//g;function p($){switch($){case 0:return"";case 1:return`${E}*?`;default:return`(?:${I}|${E}+${I}|${I}${E}+)*?`}}function h($,K){if(!$)return[];const F=[];let x=!1,V=!1,Q="";for(const Z of $){switch(Z){case K:if(!x&&!V){F.push(Q),Q="";continue}break;case"{":x=!0;break;case"}":x=!1;break;case"[":V=!0;break;case"]":V=!1;break}Q+=Z}return Q&&F.push(Q),F}e.splitGlobAware=h;function w($){if(!$)return"";let K="";const F=h($,C);if(F.every(x=>x===S))K=".*";else{let x=!1;F.forEach((V,Q)=>{if(V===S){x||(K+=p(2),x=!0);return}let Z=!1,G="",H=!1,re="";for(const ie of V){if(ie!=="}"&&Z){G+=ie;continue}if(H&&(ie!=="]"||!re)){let ce;ie==="-"?ce=ie:(ie==="^"||ie==="!")&&!re?ce="^":ie===C?ce="":ce=i.escapeRegExpCharacters(ie),re+=ce;continue}switch(ie){case"{":Z=!0;continue;case"[":H=!0;continue;case"}":K+=`(?:${h(G,",").map(de=>w(de)).join("|")})`,Z=!1,G="";break;case"]":K+="["+re+"]",H=!1,re="";break;case"?":K+=E;continue;case"*":K+=p(1);continue;default:K+=i.escapeRegExpCharacters(ie)}}Q<F.length-1&&(F[Q+1]!==S||Q+2<F.length)&&(K+=I),x=!1})}return K}const y=/^\*\*\/\*\.[\w\.-]+$/,m=/^\*\*\/([\w\.-]+)\/?$/,b=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,g=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,a=/^\*\*((\/[\w\.-]+)+)\/?$/,l=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,r=new D.LRUCache(1e4),o=function(){return!1},n=function(){return null};function t($,K){if(!$)return n;let F;typeof $!="string"?F=$.pattern:F=$,F=F.trim();const x=`${F}_${!!K.trimForExclusions}`;let V=r.get(x);if(V)return s(V,$);let Q;if(y.test(F)){const Z=F.substr(4);V=function(G,H){return typeof G=="string"&&G.endsWith(Z)?F:null}}else(Q=m.exec(c(F,K)))?V=u(Q[1],F):(K.trimForExclusions?g:b).test(F)?V=f(F,K):(Q=a.exec(c(F,K)))?V=v(Q[1].substr(1),F,!0):(Q=l.exec(c(F,K)))?V=v(Q[1],F,!1):V=T(F);return r.set(x,V),s(V,$)}function s($,K){return typeof K=="string"?$:function(F,x){return L.isEqualOrParent(F,K.base)?$(k.relative(K.base,F),x):null}}function c($,K){return K.trimForExclusions&&$.endsWith("/**")?$.substr(0,$.length-2):$}function u($,K){const F=`/${$}`,x=`\\${$}`,V=function(Z,G){return typeof Z!="string"?null:G?G===$?K:null:Z===$||Z.endsWith(F)||Z.endsWith(x)?K:null},Q=[$];return V.basenames=Q,V.patterns=[K],V.allBasenames=Q,V}function f($,K){const F=j($.slice(1,-1).split(",").map(G=>t(G,K)).filter(G=>G!==n),$),x=F.length;if(!x)return n;if(x===1)return F[0];const V=function(G,H){for(let re=0,ie=F.length;re<ie;re++)if(F[re](G,H))return $;return null},Q=F.find(G=>!!G.allBasenames);Q&&(V.allBasenames=Q.allBasenames);const Z=F.reduce((G,H)=>H.allPaths?G.concat(H.allPaths):G,[]);return Z.length&&(V.allPaths=Z),V}function v($,K,F){const x=k.sep===k.posix.sep,V=x?$:$.replace(d,k.sep),Q=k.sep+V,Z=k.posix.sep+$,G=F?function(H,re){return typeof H=="string"&&(H===V||H.endsWith(Q)||!x&&(H===$||H.endsWith(Z)))?K:null}:function(H,re){return typeof H=="string"&&(H===V||!x&&H===$)?K:null};return G.allPaths=[(F?"*/":"./")+$],G}function T($){try{const K=new RegExp(`^${w($)}$`);return function(F){return K.lastIndex=0,typeof F=="string"&&K.test(F)?$:null}}catch(K){return n}}function O($,K,F){return!$||typeof K!="string"?!1:U($)(K,void 0,F)}e.match=O;function U($,K={}){if(!$)return o;if(typeof $=="string"||z($)){const F=t($,K);if(F===n)return o;const x=function(V,Q){return!!F(V,Q)};return F.allBasenames&&(x.allBasenames=F.allBasenames),F.allPaths&&(x.allPaths=F.allPaths),x}return q($,K)}e.parse=U;function W($){if(!$)return;let K;return F=>(K||(K=($()||Promise.resolve([])).then(x=>x?A(x):{})),K.then(x=>!!x[F]))}e.hasSiblingPromiseFn=W;function N($){if(!$)return;let K;return F=>{if(!K){const x=$();K=x?A(x):{}}return!!K[F]}}e.hasSiblingFn=N;function A($){const K={};for(const F of $)K[F]=!0;return K}function z($){const K=$;return K&&typeof K.base=="string"&&typeof K.pattern=="string"}e.isRelativePattern=z;function _($){return $.allBasenames||[]}e.getBasenameTerms=_;function M($){return $.allPaths||[]}e.getPathTerms=M;function q($,K){const F=j(Object.getOwnPropertyNames($).map(G=>B(G,$[G],K)).filter(G=>G!==n)),x=F.length;if(!x)return n;if(!F.some(G=>!!G.requiresSiblings)){if(x===1)return F[0];const G=function(ie,ce){for(let le=0,de=F.length;le<de;le++){const pe=F[le](ie,ce);if(pe)return pe}return null},H=F.find(ie=>!!ie.allBasenames);H&&(G.allBasenames=H.allBasenames);const re=F.reduce((ie,ce)=>ce.allPaths?ie.concat(ce.allPaths):ie,[]);return re.length&&(G.allPaths=re),G}const V=function(G,H,re){let ie;for(let ce=0,le=F.length;ce<le;ce++){const de=F[ce];de.requiresSiblings&&re&&(H||(H=k.basename(G)),ie||(ie=H.substr(0,H.length-k.extname(G).length)));const pe=de(G,H,ie,re);if(pe)return pe}return null},Q=F.find(G=>!!G.allBasenames);Q&&(V.allBasenames=Q.allBasenames);const Z=F.reduce((G,H)=>H.allPaths?G.concat(H.allPaths):G,[]);return Z.length&&(V.allPaths=Z),V}function B($,K,F){if(K===!1)return n;const x=t($,F);if(x===n)return n;if(typeof K=="boolean")return x;if(K){const V=K.when;if(typeof V=="string"){const Q=(Z,G,H,re)=>{if(!re||!x(Z,G))return null;const ie=V.replace("$(basename)",H),ce=re(ie);return(0,R.isThenable)(ce)?ce.then(le=>le?$:null):ce?$:null};return Q.requiresSiblings=!0,Q}}return x}function j($,K){const F=$.filter(G=>!!G.basenames);if(F.length<2)return $;const x=F.reduce((G,H)=>{const re=H.basenames;return re?G.concat(re):G},[]);let V;if(K){V=[];for(let G=0,H=x.length;G<H;G++)V.push(K)}else V=F.reduce((G,H)=>{const re=H.patterns;return re?G.concat(re):G},[]);const Q=function(G,H){if(typeof G!="string")return null;if(!H){let ie;for(ie=G.length;ie>0;ie--){const ce=G.charCodeAt(ie-1);if(ce===47||ce===92)break}H=G.substr(ie)}const re=x.indexOf(H);return re!==-1?V[re]:null};Q.basenames=x,Q.patterns=V,Q.allBasenames=x;const Z=$.filter(G=>!G.basenames);return Z.push(Q),Z}}),define(te[109],ne([0,1,108,15,10,18,25]),function(X,e,R,L,D,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var P;(function(t){t.text="text/plain",t.binary="application/octet-stream",t.unknown="application/unknown",t.markdown="text/markdown",t.latex="text/latex"})(P=e.Mimes||(e.Mimes={}));let S=[],C=[],I=[];function E(t,s=!1){const c=d(t);S.push(c),c.userConfigured?I.push(c):C.push(c),s&&!c.userConfigured&&S.forEach(u=>{u.mime===c.mime||u.userConfigured||(c.extension&&u.extension===c.extension&&console.warn(`Overwriting extension <<${c.extension}>> to now point to mime <<${c.mime}>>`),c.filename&&u.filename===c.filename&&console.warn(`Overwriting filename <<${c.filename}>> to now point to mime <<${c.mime}>>`),c.filepattern&&u.filepattern===c.filepattern&&console.warn(`Overwriting filepattern <<${c.filepattern}>> to now point to mime <<${c.mime}>>`),c.firstline&&u.firstline===c.firstline&&console.warn(`Overwriting firstline <<${c.firstline}>> to now point to mime <<${c.mime}>>`))})}e.registerTextMime=E;function d(t){return{id:t.id,mime:t.mime,filename:t.filename,extension:t.extension,filepattern:t.filepattern,firstline:t.firstline,userConfigured:t.userConfigured,filenameLowercase:t.filename?t.filename.toLowerCase():void 0,extensionLowercase:t.extension?t.extension.toLowerCase():void 0,filepatternLowercase:t.filepattern?(0,R.parse)(t.filepattern.toLowerCase()):void 0,filepatternOnPath:t.filepattern?t.filepattern.indexOf(D.posix.sep)>=0:!1}}function p(t){t?(S=S.filter(s=>!s.userConfigured),I=[]):(S=[],C=[],I=[])}e.clearTextMimes=p;function h(t,s){let c;if(t)switch(t.scheme){case L.Schemas.file:c=t.fsPath;break;case L.Schemas.data:c=k.DataUri.parseMetaData(t).get(k.DataUri.META_DATA_LABEL);break;default:c=t.path}if(!c)return[P.unknown];c=c.toLowerCase();const u=(0,D.basename)(c),f=w(c,u,I);if(f)return[f,P.text];const v=w(c,u,C);if(v)return[v,P.text];if(s){const T=y(s);if(T)return[T,P.text]}return[P.unknown]}e.guessMimeTypes=h;function w(t,s,c){let u=null,f=null,v=null;for(let T=c.length-1;T>=0;T--){const O=c[T];if(s===O.filenameLowercase){u=O;break}if(O.filepattern&&(!f||O.filepattern.length>f.filepattern.length)){const U=O.filepatternOnPath?t:s;O.filepatternLowercase?.(U)&&(f=O)}O.extension&&(!v||O.extension.length>v.extension.length)&&s.endsWith(O.extensionLowercase)&&(v=O)}return u?u.mime:f?f.mime:v?v.mime:null}function y(t){if((0,i.startsWithUTF8BOM)(t)&&(t=t.substr(1)),t.length>0)for(let s=S.length-1;s>=0;s--){const c=S[s];if(!c.firstline)continue;const u=t.match(c.firstline);if(u&&u.length>0)return c.mime}return null}function m(t){return t?typeof t=="string"?t===P.binary||t===P.text||t===P.unknown:t.length===1&&m(t[0]):!0}e.isUnspecific=m;const b={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},g={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function a(t){const s=(0,D.extname)(t),c=b[s.toLowerCase()];return c!==void 0?c:l(t)}e.getMediaOrTextMime=a;function l(t){const s=(0,D.extname)(t);return g[s.toLowerCase()]}e.getMediaMime=l;function r(t){for(const s in g)if(g[s]===t)return s}e.getExtensionForMimeType=r;const o=/^(.+)\/(.+?)(;.+)?$/;function n(t,s){const c=o.exec(t);return c?`${c[1].toLowerCase()}/${c[2].toLowerCase()}${c[3]??""}`:s?void 0:t}e.normalizeMimeType=n}),define(te[110],ne([0,1,7]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function L(I){return I.toJSON()}class D{constructor(E){this._uriTransformer=E}transformIncoming(E){const d=this._uriTransformer.transformIncoming(E);return d===E?E:L(R.URI.from(d))}transformOutgoing(E){const d=this._uriTransformer.transformOutgoing(E);return d===E?E:L(R.URI.from(d))}transformOutgoingURI(E){const d=this._uriTransformer.transformOutgoing(E);return d===E?E:R.URI.from(d)}transformOutgoingScheme(E){return this._uriTransformer.transformOutgoingScheme(E)}}e.URITransformer=D,e.DefaultURITransformer=new class{transformIncoming(I){return I}transformOutgoing(I){return I}transformOutgoingURI(I){return I}transformOutgoingScheme(I){return I}};function k(I,E,d){if(!I||d>200)return null;if(typeof I=="object"){if(I instanceof R.URI)return E.transformOutgoing(I);for(let p in I)if(Object.hasOwnProperty.call(I,p)){const h=k(I[p],E,d+1);h!==null&&(I[p]=h)}}return null}function i(I,E){const d=k(I,E,0);return d===null?I:d}e.transformOutgoingURIs=i;function P(I,E,d,p){if(!I||p>200)return null;if(typeof I=="object"){if(I.$mid===1)return d?R.URI.revive(E.transformIncoming(I)):E.transformIncoming(I);for(let h in I)if(Object.hasOwnProperty.call(I,h)){const w=P(I[h],E,d,p+1);w!==null&&(I[h]=w)}}return null}function S(I,E){const d=P(I,E,!1,0);return d===null?I:d}e.transformIncomingURIs=S;function C(I,E){const d=P(I,E,!0,0);return d===null?I:d}e.transformAndReviveIncomingURIs=C}),define(te[29],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const R=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function L(S){return R.test(S)}e.isUUID=L;const D=new Uint8Array(16),k=[];for(let S=0;S<256;S++)k.push(S.toString(16).padStart(2,"0"));let i;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?i=crypto.getRandomValues.bind(crypto):i=function(S){for(let C=0;C<S.length;C++)S[C]=Math.floor(Math.random()*256);return S};function P(){i(D),D[6]=D[6]&15|64,D[8]=D[8]&63|128;let S=0,C="";return C+=k[D[S++]],C+=k[D[S++]],C+=k[D[S++]],C+=k[D[S++]],C+="-",C+=k[D[S++]],C+=k[D[S++]],C+="-",C+=k[D[S++]],C+=k[D[S++]],C+="-",C+=k[D[S++]],C+=k[D[S++]],C+="-",C+=k[D[S++]],C+=k[D[S++]],C+=k[D[S++]],C+=k[D[S++]],C+=k[D[S++]],C+=k[D[S++]],C}e.generateUuid=P}),define(te[111],ne([0,1,243]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class L{constructor(k="utf8"){this.stringDecoder=new R.StringDecoder(k),this.remaining=null}write(k){const i=[],P=this.remaining?this.remaining+this.stringDecoder.write(k):this.stringDecoder.write(k);if(P.length<1)return i;let S=0,C,I=S;for(;I<P.length;)if(C=P.charCodeAt(I),C===13||C===10){if(i.push(P.substring(S,I)),I++,I<P.length){const E=C;C=P.charCodeAt(I),(E===13&&C===10||E===10&&C===13)&&I++}S=I}else I++;return this.remaining=S<P.length?P.substr(S):null,i}end(){return this.remaining}}e.LineDecoder=L}),define(te[112],ne([0,1,33]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const L=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function D(i){const P=i.replace(/\-/g,":").toLowerCase();return!L.has(P)}function k(){const i=(0,R.networkInterfaces)();for(let P in i){const S=i[P];if(S){for(const{mac:C}of S)if(D(C))return C}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=k}),define(te[113],ne([0,1,33,9,41,29,112]),function(X,e,R,L,D,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(I){return this._virtualMachineOUIs||(this._virtualMachineOUIs=D.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(I)}value(){if(this._value===void 0){let I=0,E=0;const d=(0,R.networkInterfaces)();for(let p in d){const h=d[p];if(h)for(const{mac:w,internal:y}of h)y||(E+=1,this._isVirtualMachineMacAddress(w.toUpperCase())&&(I+=1))}this._value=E>0?I/E:0}return this._value}};let P;async function S(){return P||(P=(async()=>await C()||k.generateUuid())()),P}e.getMachineId=S;async function C(){try{const I=await new Promise((d,p)=>{X(["crypto"],d,p)}),E=(0,i.getMac)();return I.createHash("sha256").update(E,"utf8").digest("hex")}catch(I){L.onUnexpectedError(I);return}}}),define(te[20],ne([0,1,51,33,244,5,42,69,10,4,18,7,29]),function(X,e,R,L,D,k,i,P,S,C,I,E,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var p;(function(_){_[_.UNLINK=0]="UNLINK",_[_.MOVE=1]="MOVE"})(p=e.RimRafMode||(e.RimRafMode={}));async function h(_,M=p.UNLINK){if((0,i.isRootOrDriveLetter)(_))throw new Error("rimraf - will refuse to recursively delete root");return M===p.UNLINK?y(_):w(_)}async function w(_){try{const M=(0,S.join)((0,L.tmpdir)(),(0,d.generateUuid)());try{await e.Promises.rename(_,M)}catch(q){return y(_)}y(M).catch(q=>{})}catch(M){if(M.code!=="ENOENT")throw M}}async function y(_){return e.Promises.rmdir(_,{recursive:!0,maxRetries:3})}function m(_){if((0,i.isRootOrDriveLetter)(_))throw new Error("rimraf - will refuse to recursively delete root");R.rmdirSync(_,{recursive:!0})}e.rimrafSync=m;async function b(_,M){return l(await(M?g(_):(0,D.promisify)(R.readdir)(_)))}async function g(_){try{return await(0,D.promisify)(R.readdir)(_,{withFileTypes:!0})}catch(B){console.warn("[node.js fs] readdir with filetypes failed with error: ",B)}const M=[],q=await b(_);for(const B of q){let j=!1,$=!1,K=!1;try{const F=await e.Promises.lstat((0,S.join)(_,B));j=F.isFile(),$=F.isDirectory(),K=F.isSymbolicLink()}catch(F){console.warn("[node.js fs] unexpected error from lstat after readdir: ",F)}M.push({name:B,isFile:()=>j,isDirectory:()=>$,isSymbolicLink:()=>K})}return M}function a(_){return l(R.readdirSync(_))}e.readdirSync=a;function l(_){return _.map(M=>typeof M=="string"?C.isMacintosh?(0,P.normalizeNFC)(M):M:(M.name=C.isMacintosh?(0,P.normalizeNFC)(M.name):M.name,M))}async function r(_){const M=await b(_),q=[];for(const B of M)await n.existsDirectory((0,S.join)(_,B))&&q.push(B);return q}function o(_,M=1e3){return new Promise(q=>{let B=!1;const j=setInterval(()=>{B||(B=!0,R.access(_,$=>{B=!1,$&&(clearInterval(j),q(void 0))}))},M)})}e.whenDeleted=o;var n;(function(_){async function M(j){let $;try{if($=await e.Promises.lstat(j),!$.isSymbolicLink())return{stat:$}}catch(K){}try{return{stat:await e.Promises.stat(j),symbolicLink:$?.isSymbolicLink()?{dangling:!1}:void 0}}catch(K){if(K.code==="ENOENT"&&$)return{stat:$,symbolicLink:{dangling:!0}};if(C.isWindows&&K.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(j)),symbolicLink:{dangling:!1}}}catch(F){if(F.code==="ENOENT"&&$)return{stat:$,symbolicLink:{dangling:!0}};throw F}throw K}}_.stat=M;async function q(j){try{const{stat:$,symbolicLink:K}=await _.stat(j);return $.isFile()&&K?.dangling!==!0}catch($){}return!1}_.existsFile=q;async function B(j){try{const{stat:$,symbolicLink:K}=await _.stat(j);return $.isDirectory()&&K?.dangling!==!0}catch($){}return!1}_.existsDirectory=B})(n=e.SymlinkSupport||(e.SymlinkSupport={}));const t=new k.ResourceQueue;function s(_,M,q){return t.queueFor(E.URI.file(_),I.extUriBiasedIgnorePathCase).queue(()=>{const B=v(q);return new Promise((j,$)=>u(_,M,B,K=>K?$(K):j()))})}let c=!0;function u(_,M,q,B){if(!c)return R.writeFile(_,M,{mode:q.mode,flag:q.flag},B);R.open(_,q.flag,q.mode,(j,$)=>{if(j)return B(j);R.writeFile($,M,K=>{if(K)return R.close($,()=>B(K));R.fdatasync($,F=>(F&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",F),c=!1),R.close($,x=>B(x))))})})}function f(_,M,q){const B=v(q);if(!c)return R.writeFileSync(_,M,{mode:B.mode,flag:B.flag});const j=R.openSync(_,B.flag,B.mode);try{R.writeFileSync(j,M);try{R.fdatasyncSync(j)}catch($){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",$),c=!1}}finally{R.closeSync(j)}}e.writeFileSync=f;function v(_){return _?{mode:typeof _.mode=="number"?_.mode:438,flag:typeof _.flag=="string"?_.flag:"w"}:{mode:438,flag:"w"}}async function T(_,M){if(_===M)return;async function q(B){try{const j=await e.Promises.lstat(B);if(j.isDirectory()||j.isSymbolicLink())return;await e.Promises.utimes(B,j.atime,new Date)}catch(j){}}try{await e.Promises.rename(_,M),await q(M)}catch(B){if(_.toLowerCase()!==M.toLowerCase()&&B.code==="EXDEV"||_.endsWith("."))await O(_,M,{preserveSymlinks:!1}),await h(_,p.MOVE),await q(M);else throw B}}async function O(_,M,q){return W(_,M,{root:{source:_,target:M},options:q,handledSourcePaths:new Set})}const U=511;async function W(_,M,q){if(q.handledSourcePaths.has(_))return;q.handledSourcePaths.add(_);const{stat:B,symbolicLink:j}=await n.stat(_);if(j){if(q.options.preserveSymlinks)try{return await z(_,M,q)}catch($){console.warn("[node.js fs] copy of symlink failed: ",$)}if(j.dangling)return}return B.isDirectory()?N(_,M,B.mode&U,q):A(_,M,B.mode&U)}async function N(_,M,q,B){await e.Promises.mkdir(M,{recursive:!0,mode:q});const j=await b(_);for(const $ of j)await W((0,S.join)(_,$),(0,S.join)(M,$),B)}async function A(_,M,q){await e.Promises.copyFile(_,M),await e.Promises.chmod(M,q)}async function z(_,M,q){let B=await e.Promises.readlink(_);(0,i.isEqualOrParent)(B,q.root.source,!C.isLinux)&&(B=(0,S.join)(q.root.target,B.substr(q.root.source.length+1))),await e.Promises.symlink(B,M)}e.Promises=new class{get access(){return(0,D.promisify)(R.access)}get stat(){return(0,D.promisify)(R.stat)}get lstat(){return(0,D.promisify)(R.lstat)}get utimes(){return(0,D.promisify)(R.utimes)}get read(){return(0,D.promisify)(R.read)}get readFile(){return(0,D.promisify)(R.readFile)}get write(){return(0,D.promisify)(R.write)}get appendFile(){return(0,D.promisify)(R.appendFile)}get fdatasync(){return(0,D.promisify)(R.fdatasync)}get truncate(){return(0,D.promisify)(R.truncate)}get rename(){return(0,D.promisify)(R.rename)}get copyFile(){return(0,D.promisify)(R.copyFile)}get open(){return(0,D.promisify)(R.open)}get close(){return(0,D.promisify)(R.close)}get symlink(){return(0,D.promisify)(R.symlink)}get readlink(){return(0,D.promisify)(R.readlink)}get chmod(){return(0,D.promisify)(R.chmod)}get mkdir(){return(0,D.promisify)(R.mkdir)}get unlink(){return(0,D.promisify)(R.unlink)}get rmdir(){return(0,D.promisify)(R.rmdir)}get realpath(){return(0,D.promisify)(R.realpath)}async exists(_){try{return await e.Promises.access(_),!0}catch{return!1}}get readdir(){return b}get readDirsInDir(){return r}get writeFile(){return s}get rm(){return h}get move(){return T}get copy(){return O}}}),define(te[114],ne([0,1,51,10,25,20]),function(X,e,R,L,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function i(I){const E=(0,L.dirname)(I);if(I===E)return I;const d=((0,L.basename)(I)||I).toLowerCase();try{const h=(0,k.readdirSync)(E).filter(w=>w.toLowerCase()===d);if(h.length===1){const w=i(E);if(w)return(0,L.join)(w,h[0])}else if(h.length>1){const w=h.indexOf(d);if(w>=0){const y=i(E);if(y)return(0,L.join)(y,h[w])}}}catch(p){}return null}e.realcaseSync=i;async function P(I){try{return await k.Promises.realpath(I)}catch(E){const d=C(I);return await k.Promises.access(d,R.constants.R_OK),d}}e.realpath=P;function S(I){try{return R.realpathSync(I)}catch(E){const d=C(I);return R.accessSync(d,R.constants.R_OK),d}}e.realpathSync=S;function C(I){return(0,D.rtrim)((0,L.normalize)(I),L.sep)}}),define(te[115],ne([0,1,57]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function L(P,S,C,I=1){let E=!1;return new Promise(d=>{const p=setTimeout(()=>{if(!E)return E=!0,d(0)},C);D(P,S,I,h=>{if(!E)return E=!0,clearTimeout(p),d(h)})})}e.findFreePort=L;function D(P,S,C,I){if(S===0)return I(0);const E=new R.Socket;E.once("connect",()=>(i(E),D(P+C,S-1,C,I))),E.once("data",()=>{}),E.once("error",d=>(i(E),d.code!=="ECONNREFUSED"?D(P+C,S-1,C,I):I(P))),E.connect(P,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function k(P,S,C){let I=!1,E,d=1;const p=R.createServer({pauseOnConnect:!0});function h(w,y){I||(I=!0,p.removeAllListeners(),p.close(),E&&clearTimeout(E),y(w))}return new Promise(w=>{E=setTimeout(()=>{h(0,w)},C),p.on("listening",()=>{h(P,w)}),p.on("error",y=>{y&&(y.code==="EADDRINUSE"||y.code==="EACCES")&&d<S?(P++,d++,p.listen(P,"127.0.0.1")):h(0,w)}),p.on("close",()=>{h(0,w)}),p.listen(P,"127.0.0.1")})}e.findFreePortFaster=k;function i(P){try{P.removeAllListeners("connect"),P.removeAllListeners("error"),P.end(),P.destroy(),P.unref()}catch(S){console.error(S)}}}),define(te[70],ne([0,1,33,10,20]),function(X,e,R,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const k=/^\d+$/,i=/^Microsoft.PowerShell_.*/,P=/^Microsoft.PowerShellPreview_.*/;var S;(function(a){a[a.x64=0]="x64",a[a.x86=1]="x86",a[a.ARM=2]="ARM"})(S||(S={}));let C;switch(process.arch){case"ia32":case"x32":C=1;break;case"arm":case"arm64":C=2;break;default:C=0;break}let I;process.env.PROCESSOR_ARCHITEW6432?I=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?I=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?I=1:I=0;class E{constructor(l,r,o){this.exePath=l,this.displayName=r,this.knownToExist=o}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await D.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function d({useAlternateBitness:a=!1}={}){return a?C===0?process.env["ProgramFiles(x86)"]||null:I===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function p({useAlternateBitness:a=!1,findPreview:l=!1}={}){const r=d({useAlternateBitness:a});if(!r)return null;const o=L.join(r,"PowerShell");if(!await D.SymlinkSupport.existsDirectory(o))return null;let n=-1,t=null;for(const u of await D.Promises.readdir(o)){let f=-1;if(l){const T=u.indexOf("-");if(T<0)continue;const O=u.substring(0,T);if(!k.test(O)||u.substring(T+1)!=="preview")continue;f=parseInt(O,10)}else{if(!k.test(u))continue;f=parseInt(u,10)}if(f<=n)continue;const v=L.join(o,u,"pwsh.exe");!await D.SymlinkSupport.existsFile(v)||(t=v,n=f)}if(!t)return null;const s=r.includes("x86")?" (x86)":"",c=l?" Preview":"";return new E(t,`PowerShell${c}${s}`,!0)}async function h({findPreview:a}={}){if(!process.env.LOCALAPPDATA)return null;const l=L.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await D.SymlinkSupport.existsDirectory(l))return null;const{pwshMsixDirRegex:r,pwshMsixName:o}=a?{pwshMsixDirRegex:P,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:i,pwshMsixName:"PowerShell (Store)"};for(const n of await D.Promises.readdir(l))if(r.test(n)){const t=L.join(l,n,"pwsh.exe");return new E(t,o)}return null}function w(){const a=L.join(R.homedir(),".dotnet","tools","pwsh.exe");return new E(a,".NET Core PowerShell Global Tool")}function y(){const a=L.join(process.env.windir,C===1&&I!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new E(a,"Windows PowerShell",!0)}async function*m(){let a=await p();a&&(yield a),a=await p({useAlternateBitness:!0}),a&&(yield a),a=await h(),a&&(yield a),a=w(),a&&(yield a),a=await p({findPreview:!0}),a&&(yield a),a=await h({findPreview:!0}),a&&(yield a),a=await p({useAlternateBitness:!0,findPreview:!0}),a&&(yield a),a=y(),a&&(yield a)}async function*b(){for await(const a of m())await a.exists()&&(yield a)}e.enumeratePowerShellInstallations=b;async function g(){for await(const a of b())return a;return null}e.getFirstAvailablePowerShellInstallation=g}),define(te[116],ne([0,1,45,15]),function(X,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function D(i){return new Promise((P,S)=>{let C;const I=new Map;function E(p,h,w,y,m){const b=I.get(h);if(p===i||b){const g={name:d(w),cmd:w,pid:p,ppid:h,load:y,mem:m};I.set(p,g),p===i&&(C=g),b&&(b.children||(b.children=[]),b.children.push(g),b.children.length>1&&(b.children=b.children.sort((a,l)=>a.pid-l.pid)))}}function d(p){const h=/--vscode-window-kind=shared-process/,w=/--vscode-window-kind=issue-reporter/,y=/--vscode-window-kind=process-explorer/,m=/--utility-sub-type=network/,b=/--crashes-directory/,g=/\\pipe\\winpty-control/,a=/conhost\.exe/,l=/--type=([a-zA-Z-]+)/;if(b.exec(p))return"electron-crash-reporter";if(g.exec(p))return"winpty-process";if(a.exec(p))return"console-window-host (Windows internal process)";let r=l.exec(p);if(r&&r.length===2)return r[1]==="renderer"?h.exec(p)?"shared-process":w.exec(p)?"issue-reporter":y.exec(p)?"process-explorer":"window":r[1]==="utility"&&m.exec(p)?"utility-network-service":r[1];const o=/[a-zA-Z-]+\.js/g;let n="";do r=o.exec(p),r&&(n+=r+" ");while(r);return n&&p.indexOf("node ")<0&&p.indexOf("node.exe")<0?`electron_node ${n}`:p}if(process.platform==="win32"){const p=h=>h.indexOf("\\\\?\\")===0||h.indexOf("\\??\\")===0?h.substr(4):h.indexOf('"\\\\?\\')===0||h.indexOf('"\\??\\')===0?'"'+h.substr(5):h;new Promise((h,w)=>{X(["windows-process-tree"],h,w)}).then(h=>{h.getProcessList(i,w=>{h.getProcessCpuUsage(w,y=>{const m=new Map;y.forEach(b=>{const g=p(b.commandLine||"");m.set(b.pid,{name:d(g),cmd:g,pid:b.pid,ppid:b.ppid,load:b.cpu||0,mem:b.memory||0})}),C=m.get(i),C?(m.forEach(b=>{const g=m.get(b.ppid);g&&(g.children||(g.children=[]),g.children.push(b))}),m.forEach(b=>{b.children&&(b.children=b.children.sort((g,a)=>g.pid-a.pid))}),P(C)):S(new Error(`Root process ${i} not found`))})},h.ProcessDataFlag.CommandLine|h.ProcessDataFlag.Memory)})}else{let p=function(){let h=[C];const w=[];for(;h.length;){const m=h.shift();m&&(w.push(m.pid),m.children&&(h=h.concat(m.children)))}let y=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",X).fsPath);y+=" "+w.join(" "),(0,R.exec)(y,{},(m,b,g)=>{if(m||g)S(m||new Error(g.toString()));else{const a=b.toString().split(`
`);for(let l=0;l<w.length;l++){const r=I.get(w[l]);r.load=parseFloat(a[l])}if(!C){S(new Error(`Root process ${i} not found`));return}P(C)}})};(0,R.exec)("which ps",{},(h,w,y)=>{if(h||y)if(process.platform!=="linux")S(h||new Error(y.toString()));else{const m=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/ps.sh",X).fsPath);(0,R.exec)(m,{},(b,g,a)=>{b||a?S(b||new Error(a.toString())):(k(g,E),p())})}else{const m=w.toString().trim(),b="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,R.exec)(`${m} ${b}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(g,a,l)=>{g||l&&!l.includes("screen size is bogus")?S(g||new Error(l.toString())):(k(a,E),process.platform==="linux"?p():C?P(C):S(new Error(`Root process ${i} not found`)))})}})}})}e.listProcesses=D;function k(i,P){const S=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,C=i.toString().split(`
`);for(const I of C){const E=S.exec(I.trim());E&&E.length===6&&P(parseInt(E[1]),parseInt(E[2]),E[5],parseFloat(E[3]),parseFloat(E[4]))}}}),define(te[117],ne([0,1,51,27,42,2,69,10,4,20]),function(X,e,R,L,D,k,i,P,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.CHANGE_BUFFER_DELAY=e.watchFolder=e.watchFile=void 0;function I(h,w,y){return d({path:h,isDirectory:!1},w,y)}e.watchFile=I;function E(h,w,y){return d({path:h,isDirectory:!0},w,y)}e.watchFolder=E,e.CHANGE_BUFFER_DELAY=100;function d(h,w,y){if(S.isMacintosh&&(0,D.isEqualOrParent)(h.path,"/Volumes/"))return y(`Refusing to watch ${h.path} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),k.Disposable.None;const m=(0,P.basename)(h.path),b=new Map;let g=!1,a=[(0,k.toDisposable)(()=>{b.forEach(l=>(0,k.dispose)(l)),b.clear()})];try{const l=(0,R.watch)(h.path);a.push((0,k.toDisposable)(()=>{l.removeAllListeners(),l.close()}));const r=new Set;h.isDirectory&&C.Promises.readdir(h.path).then(o=>o.forEach(n=>r.add(n))),l.on("error",(o,n)=>{g||y(`Failed to watch ${h.path} for changes using fs.watch() (${o}, ${n})`)}),l.on("change",(o,n)=>{if(g)return;let t="";if(n&&(t=n.toString(),S.isMacintosh&&(t=(0,i.normalizeNFC)(t))),!t||o!=="change"&&o!=="rename")return;const s=h.isDirectory?(0,P.join)(h.path,t):h.path;if(h.isDirectory)if(o==="rename"){const c=b.get(s);c&&(0,k.dispose)(c);const u=setTimeout(async()=>{b.delete(s);const f=await C.Promises.exists(s);if(g)return;let v;f?r.has(t)?v="changed":(v="added",r.add(t)):(r.delete(t),v="deleted"),w(v,s)},e.CHANGE_BUFFER_DELAY);b.set(s,(0,k.toDisposable)(()=>clearTimeout(u)))}else{let c;r.has(t)?c="changed":(c="added",r.add(t)),w(c,s)}else if(o==="rename"||t!==m){const c=setTimeout(async()=>{const u=await C.Promises.exists(s);g||(u?(w("changed",s),a=[d(h,w,y)]):w("deleted",s))},e.CHANGE_BUFFER_DELAY);(0,k.dispose)(a),a=[(0,k.toDisposable)(()=>clearTimeout(c))]}else w("changed",s)})}catch(l){C.Promises.exists(h.path).then(r=>{r&&!g&&y(`Failed to watch ${h.path} for changes using fs.watch() (${l.toString()})`)})}return(0,k.toDisposable)(()=>{g=!0,a=(0,k.dispose)(a)})}async function p(h,w,y,m=512){const b=await C.Promises.open(h,"r"),g=Buffer.allocUnsafe(m),a=new L.CancellationTokenSource(y);let l,r=!1;const o=I(h,async n=>{if(n==="changed"){if(r)return;r=!0;try{for(;!a.token.isCancellationRequested;){const{bytesRead:t}=await C.Promises.read(b,g,0,m,null);if(!t||a.token.isCancellationRequested)break;w(g.slice(0,t))}}catch(t){l=new Error(t),a.dispose(!0)}finally{r=!1}}},n=>{l=new Error(n),a.dispose(!0)});return new Promise((n,t)=>{a.token.onCancellationRequested(async()=>{o.dispose(),await C.Promises.close(b),l?t(l):n()})})}e.watchFileContents=p});var he=this&&this.__decorate||function(X,e,R,L){var D=arguments.length,k=D<3?e:L===null?L=Object.getOwnPropertyDescriptor(e,R):L,i;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")k=Reflect.decorate(X,e,R,L);else for(var P=X.length-1;P>=0;P--)(i=X[P])&&(k=(D<3?i(k):D>3?i(e,R,k):i(e,R))||k);return D>3&&k&&Object.defineProperty(e,R,k),k};define(te[34],ne([0,1,16,5,19,27,67,9,3,2,107,25,17]),function(X,e,R,L,D,k,i,P,S,C,I,E,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var p;(function(j){j[j.Promise=100]="Promise",j[j.PromiseCancel=101]="PromiseCancel",j[j.EventListen=102]="EventListen",j[j.EventDispose=103]="EventDispose"})(p=e.RequestType||(e.RequestType={}));function h(j){switch(j){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var w;(function(j){j[j.Initialize=200]="Initialize",j[j.PromiseSuccess=201]="PromiseSuccess",j[j.PromiseError=202]="PromiseError",j[j.PromiseErrorObj=203]="PromiseErrorObj",j[j.EventFire=204]="EventFire"})(w=e.ResponseType||(e.ResponseType={}));function y(j){switch(j){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var m;(function(j){j[j.Uninitialized=0]="Uninitialized",j[j.Idle=1]="Idle"})(m||(m={}));class b{constructor($){this.buffer=$,this.pos=0}read($){const K=this.buffer.slice(this.pos,this.pos+$);return this.pos+=K.byteLength,K}}class g{constructor(){this.buffers=[]}get buffer(){return D.VSBuffer.concat(this.buffers)}write($){this.buffers.push($)}}var a;(function(j){j[j.Undefined=0]="Undefined",j[j.String=1]="String",j[j.Buffer=2]="Buffer",j[j.VSBuffer=3]="VSBuffer",j[j.Array=4]="Array",j[j.Object=5]="Object"})(a||(a={}));function l(j){const $=D.VSBuffer.alloc(4);return $.writeUInt32BE(j,0),$}function r(j){return j.read(4).readUInt32BE(0)}function o(j){const $=D.VSBuffer.alloc(1);return $.writeUInt8(j,0),$}const n={Undefined:o(a.Undefined),String:o(a.String),Buffer:o(a.Buffer),VSBuffer:o(a.VSBuffer),Array:o(a.Array),Object:o(a.Object)},t=typeof Buffer!="undefined";function s(j,$){if(typeof $=="undefined")j.write(n.Undefined);else if(typeof $=="string"){const K=D.VSBuffer.fromString($);j.write(n.String),j.write(l(K.byteLength)),j.write(K)}else if(t&&Buffer.isBuffer($)){const K=D.VSBuffer.wrap($);j.write(n.Buffer),j.write(l(K.byteLength)),j.write(K)}else if($ instanceof D.VSBuffer)j.write(n.VSBuffer),j.write(l($.byteLength)),j.write($);else if(Array.isArray($)){j.write(n.Array),j.write(l($.length));for(const K of $)s(j,K)}else{const K=D.VSBuffer.fromString(JSON.stringify($));j.write(n.Object),j.write(l(K.byteLength)),j.write(K)}}function c(j){switch(j.read(1).readUInt8(0)){case a.Undefined:return;case a.String:return j.read(r(j)).toString();case a.Buffer:return j.read(r(j)).buffer;case a.VSBuffer:return j.read(r(j));case a.Array:{const K=r(j),F=[];for(let x=0;x<K;x++)F.push(c(j));return F}case a.Object:return JSON.parse(j.read(r(j)).toString())}}class u{constructor($,K,F=null,x=1e3){this.protocol=$,this.ctx=K,this.logger=F,this.timeoutDelay=x,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(V=>this.onRawMessage(V)),this.sendResponse({type:200})}registerChannel($,K){this.channels.set($,K),setTimeout(()=>this.flushPendingRequests($),0)}sendResponse($){switch($.type){case 200:{const K=this.send([$.type]);this.logger&&this.logger.logOutgoing(K,0,1,y($.type));return}case 201:case 202:case 204:case 203:{const K=this.send([$.type,$.id],$.data);this.logger&&this.logger.logOutgoing(K,$.id,1,y($.type),$.data);return}}}send($,K=void 0){const F=new g;return s(F,$),s(F,K),this.sendBuffer(F.buffer)}sendBuffer($){try{return this.protocol.send($),$.byteLength}catch(K){return 0}}onRawMessage($){const K=new b($),F=c(K),x=c(K),V=F[0];switch(V){case 100:return this.logger&&this.logger.logIncoming($.byteLength,F[1],1,`${h(V)}: ${F[2]}.${F[3]}`,x),this.onPromise({type:V,id:F[1],channelName:F[2],name:F[3],arg:x});case 102:return this.logger&&this.logger.logIncoming($.byteLength,F[1],1,`${h(V)}: ${F[2]}.${F[3]}`,x),this.onEventListen({type:V,id:F[1],channelName:F[2],name:F[3],arg:x});case 101:return this.logger&&this.logger.logIncoming($.byteLength,F[1],1,`${h(V)}`),this.disposeActiveRequest({type:V,id:F[1]});case 103:return this.logger&&this.logger.logIncoming($.byteLength,F[1],1,`${h(V)}`),this.disposeActiveRequest({type:V,id:F[1]})}}onPromise($){const K=this.channels.get($.channelName);if(!K){this.collectPendingRequest($);return}const F=new k.CancellationTokenSource;let x;try{x=K.call(this.ctx,$.name,$.arg,F.token)}catch(Z){x=Promise.reject(Z)}const V=$.id;x.then(Z=>{this.sendResponse({id:V,data:Z,type:201}),this.activeRequests.delete($.id)},Z=>{Z instanceof Error?this.sendResponse({id:V,data:{message:Z.message,name:Z.name,stack:Z.stack?Z.stack.split?Z.stack.split(`
`):Z.stack:void 0},type:202}):this.sendResponse({id:V,data:Z,type:203}),this.activeRequests.delete($.id)});const Q=(0,C.toDisposable)(()=>F.cancel());this.activeRequests.set($.id,Q)}onEventListen($){const K=this.channels.get($.channelName);if(!K){this.collectPendingRequest($);return}const F=$.id,V=K.listen(this.ctx,$.name,$.arg)(Q=>this.sendResponse({id:F,data:Q,type:204}));this.activeRequests.set($.id,V)}disposeActiveRequest($){const K=this.activeRequests.get($.id);K&&(K.dispose(),this.activeRequests.delete($.id))}collectPendingRequest($){let K=this.pendingRequests.get($.channelName);K||(K=[],this.pendingRequests.set($.channelName,K));const F=setTimeout(()=>{console.error(`Unknown channel: ${$.channelName}`),$.type===100&&this.sendResponse({id:$.id,data:{name:"Unknown channel",message:`Channel name '${$.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);K.push({request:$,timeoutTimer:F})}flushPendingRequests($){const K=this.pendingRequests.get($);if(K){for(const F of K)switch(clearTimeout(F.timeoutTimer),F.request.type){case 100:this.onPromise(F.request);break;case 102:this.onEventListen(F.request);break}this.pendingRequests.delete($)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach($=>$.dispose()),this.activeRequests.clear()}}e.ChannelServer=u;var f;(function(j){j[j.LocalSide=0]="LocalSide",j[j.OtherSide=1]="OtherSide"})(f=e.RequestInitiator||(e.RequestInitiator={}));class v{constructor($,K=null){this.protocol=$,this.isDisposed=!1,this.state=m.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new S.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(F=>this.onBuffer(F)),this.logger=K}getChannel($){const K=this;return{call(F,x,V){return K.isDisposed?Promise.reject(P.canceled()):K.requestPromise($,F,x,V)},listen(F,x){return K.isDisposed?Promise.reject(P.canceled()):K.requestEvent($,F,x)}}}requestPromise($,K,F,x=k.CancellationToken.None){const V=this.lastRequestId++,Z={id:V,type:100,channelName:$,name:K,arg:F};if(x.isCancellationRequested)return Promise.reject(P.canceled());let G;return new Promise((re,ie)=>{if(x.isCancellationRequested)return ie(P.canceled());const ce=()=>{const be=Ie=>{switch(Ie.type){case 201:this.handlers.delete(V),re(Ie.data);break;case 202:this.handlers.delete(V);const Se=new Error(Ie.data.message);Se.stack=Ie.data.stack,Se.name=Ie.data.name,ie(Se);break;case 203:this.handlers.delete(V),ie(Ie.data);break}};this.handlers.set(V,be),this.sendRequest(Z)};let le=null;this.state===m.Idle?ce():(le=(0,L.createCancelablePromise)(be=>this.whenInitialized()),le.then(()=>{le=null,ce()}));const de=()=>{le?(le.cancel(),le=null):this.sendRequest({id:V,type:101}),ie(P.canceled())},pe=x.onCancellationRequested(de);G=(0,C.combinedDisposable)((0,C.toDisposable)(de),pe),this.activeRequests.add(G)}).finally(()=>{this.activeRequests.delete(G)})}requestEvent($,K,F){const x=this.lastRequestId++,Q={id:x,type:102,channelName:$,name:K,arg:F};let Z=null;const G=new S.Emitter({onFirstListenerAdd:()=>{Z=(0,L.createCancelablePromise)(re=>this.whenInitialized()),Z.then(()=>{Z=null,this.activeRequests.add(G),this.sendRequest(Q)})},onLastListenerRemove:()=>{Z?(Z.cancel(),Z=null):(this.activeRequests.delete(G),this.sendRequest({id:x,type:103}))}}),H=re=>G.fire(re.data);return this.handlers.set(x,H),G.event}sendRequest($){switch($.type){case 100:case 102:{const K=this.send([$.type,$.id,$.channelName,$.name],$.arg);this.logger&&this.logger.logOutgoing(K,$.id,0,`${h($.type)}: ${$.channelName}.${$.name}`,$.arg);return}case 101:case 103:{const K=this.send([$.type,$.id]);this.logger&&this.logger.logOutgoing(K,$.id,0,h($.type));return}}}send($,K=void 0){const F=new g;return s(F,$),s(F,K),this.sendBuffer(F.buffer)}sendBuffer($){try{return this.protocol.send($),$.byteLength}catch(K){return 0}}onBuffer($){const K=new b($),F=c(K),x=c(K),V=F[0];switch(V){case 200:return this.logger&&this.logger.logIncoming($.byteLength,0,0,y(V)),this.onResponse({type:F[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming($.byteLength,F[1],0,y(V),x),this.onResponse({type:F[0],id:F[1],data:x})}}onResponse($){if($.type===200){this.state=m.Idle,this._onDidInitialize.fire();return}const K=this.handlers.get($.id);K&&K($)}get onDidInitializePromise(){return S.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===m.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach($=>$.dispose()),this.activeRequests.clear()}}he([i.memoize],v.prototype,"onDidInitializePromise",null),e.ChannelClient=v;class T{constructor($){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new S.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new S.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,$(({protocol:K,onDidClientDisconnect:F})=>{S.Event.once(K.onMessage)(V=>{const Q=new b(V),Z=c(Q),G=new u(K,Z),H=new v(K);this.channels.forEach((ie,ce)=>G.registerChannel(ce,ie));const re={channelServer:G,channelClient:H,ctx:Z};this._connections.add(re),this._onDidAddConnection.fire(re),F(()=>{G.dispose(),H.dispose(),this._connections.delete(re),this._onDidRemoveConnection.fire(re)})})})}get connections(){const $=[];return this._connections.forEach(K=>$.push(K)),$}getChannel($,K){const F=this;return{call(x,V,Q){let Z;if((0,d.isFunction)(K)){let H=(0,R.getRandomElement)(F.connections.filter(K));Z=H?Promise.resolve(H):S.Event.toPromise(S.Event.filter(F.onDidAddConnection,K))}else Z=K.routeCall(F,x,V);const G=Z.then(H=>H.channelClient.getChannel($));return U(G).call(x,V,Q)},listen(x,V){if((0,d.isFunction)(K))return F.getMulticastEvent($,K,x,V);const Q=K.routeEvent(F,x,V).then(Z=>Z.channelClient.getChannel($));return U(Q).listen(x,V)}}}getMulticastEvent($,K,F,x){const V=this;let Q=new C.DisposableStore;const Z=new S.Emitter({onFirstListenerAdd:()=>{Q=new C.DisposableStore;const G=new S.EventMultiplexer,H=new Map,re=ce=>{const de=ce.channelClient.getChannel($).listen(F,x),pe=G.add(de);H.set(ce,pe)},ie=ce=>{const le=H.get(ce);!le||(le.dispose(),H.delete(ce))};V.connections.filter(K).forEach(re),S.Event.filter(V.onDidAddConnection,K)(re,void 0,Q),V.onDidRemoveConnection(ie,void 0,Q),G.event(Z.fire,Z,Q),Q.add(G)},onLastListenerRemove:()=>{Q.dispose()}});return Z.event}registerChannel($,K){this.channels.set($,K),this._connections.forEach(F=>{F.channelServer.registerChannel($,K)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=T;class O{constructor($,K,F=null){const x=new g;s(x,K),$.send(x.buffer),this.channelClient=new v($,F),this.channelServer=new u($,K,F)}getChannel($){return this.channelClient.getChannel($)}registerChannel($,K){this.channelServer.registerChannel($,K)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=O;function U(j){return{call($,K,F){return j.then(x=>x.call($,K,F))},listen($,K){const F=new S.Relay;return j.then(x=>F.input=x.listen($,K)),F.event}}}e.getDelayedChannel=U;function W(j){let $=!1;return{call(K,F,x){return $?j.call(K,F,x):(0,L.timeout)(0).then(()=>$=!0).then(()=>j.call(K,F,x))},listen(K,F){if($)return j.listen(K,F);const x=new S.Relay;return(0,L.timeout)(0).then(()=>$=!0).then(()=>x.input=j.listen(K,F)),x.event}}}e.getNextTickChannel=W;class N{constructor($){this.fn=$}routeCall($){return this.route($)}routeEvent($){return this.route($)}async route($){for(const K of $.connections)if(await Promise.resolve(this.fn(K.ctx)))return Promise.resolve(K);return await S.Event.toPromise($.onDidAddConnection),await this.route($)}}e.StaticRouter=N;var A;(function(j){function $(V,Q){const Z=V,G=Q&&Q.disableMarshalling,H=new Map;for(const re in Z)F(re)&&H.set(re,S.Event.buffer(Z[re],!0));return new class{listen(re,ie,ce){const le=H.get(ie);if(le)return le;if(x(ie)){const de=Z[ie];if(typeof de=="function")return de.call(Z,ce)}throw new Error(`Event not found: ${ie}`)}call(re,ie,ce){const le=Z[ie];if(typeof le=="function"){if(!G&&Array.isArray(ce))for(let de=0;de<ce.length;de++)ce[de]=(0,I.revive)(ce[de]);return le.apply(Z,ce)}throw new Error(`Method not found: ${ie}`)}}}j.fromService=$;function K(V,Q){const Z=Q&&Q.disableMarshalling;return new Proxy({},{get(G,H){if(typeof H=="string")return Q?.properties?.has(H)?Q.properties.get(H):x(H)?function(re){return V.listen(H,re)}:F(H)?V.listen(H):async function(...re){let ie;Q&&!(0,d.isUndefinedOrNull)(Q.context)?ie=[Q.context,...re]:ie=re;const ce=await V.call(H,ie);return Z?ce:(0,I.revive)(ce)};throw new Error(`Property not found: ${String(H)}`)}})}j.toService=K;function F(V){return V[0]==="o"&&V[1]==="n"&&E.isUpperAsciiLetter(V.charCodeAt(2))}function x(V){return/^onDynamic/.test(V)&&E.isUpperAsciiLetter(V.charCodeAt(9))}})(A=e.ProxyChannel||(e.ProxyChannel={}));const z=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function _(j){if(Array.isArray(j))return j;if(j&&typeof j=="object"&&typeof j.toString=="function"){let $=j.toString();if($!=="[object Object]")return $}return j}function M(j){return Array.isArray(j)?j.map(_):_(j)}function q(j,$,K,F,x,V,Q){Q=M(Q);const Z=z[x],G=Z[F%Z.length];let H=[`%c[${j}]%c[${String($).padStart(7," ")}]%c[len: ${String(K).padStart(5," ")}]%c${String(F).padStart(5," ")} - ${V}`,"color: darkgreen","color: grey","color: grey",`color: ${G}`];/\($/.test(V)?(H=H.concat(Q),H.push(")")):H.push(Q),console.log.apply(console,H)}e.logWithColors=q;class B{constructor($,K){this._outgoingPrefix=$,this._incomingPrefix=K,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing($,K,F,x,V){this._totalOutgoing+=$,q(this._outgoingPrefix,this._totalOutgoing,$,K,F,x,V)}logIncoming($,K,F,x,V){this._totalIncoming+=$,q(this._incomingPrefix,this._totalIncoming,$,K,F,x,V)}}e.IPCLogger=B}),define(te[118],ne([0,1,19,3,34]),function(X,e,R,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class k{constructor(S){this.port=S,this.onMessage=L.Event.fromDOMEventEmitter(this.port,"message",C=>R.VSBuffer.wrap(C.data)),S.start()}send(S){this.port.postMessage(S.buffer)}disconnect(){this.port.close()}}e.Protocol=k;class i extends D.IPCClient{constructor(S,C){const I=new k(S);super(I,C);this.protocol=I}dispose(){this.protocol.disconnect()}}e.Client=i}),define(te[71],ne([0,1,19,3,2,4,31,34]),function(X,e,R,L,D,k,i,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=void 0;var S;(function(n){n[n.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",n[n.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(S=e.SocketCloseEventType||(e.SocketCloseEventType={}));let C=null;function I(){return C||(C=R.VSBuffer.alloc(0)),C}class E{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(t){this._chunks.push(t),this._totalLength+=t.byteLength}read(t){return this._read(t,!0)}peek(t){return this._read(t,!1)}_read(t,s){if(t===0)return I();if(t>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===t){const v=this._chunks[0];return s&&(this._chunks.shift(),this._totalLength-=t),v}if(this._chunks[0].byteLength>t){const v=this._chunks[0].slice(0,t);return s&&(this._chunks[0]=this._chunks[0].slice(t),this._totalLength-=t),v}let c=R.VSBuffer.alloc(t),u=0,f=0;for(;t>0;){const v=this._chunks[f];if(v.byteLength>t){const T=v.slice(0,t);c.set(T,u),u+=t,s&&(this._chunks[f]=v.slice(t),this._totalLength-=t),t-=t}else c.set(v,u),u+=v.byteLength,s?(this._chunks.shift(),this._totalLength-=v.byteLength):f++,t-=v.byteLength}return c}}e.ChunkStream=E;var d;(function(n){n[n.None=0]="None",n[n.Regular=1]="Regular",n[n.Control=2]="Control",n[n.Ack=3]="Ack",n[n.KeepAlive=4]="KeepAlive",n[n.Disconnect=5]="Disconnect",n[n.ReplayRequest=6]="ReplayRequest"})(d||(d={}));var p;(function(n){n[n.HeaderLength=13]="HeaderLength",n[n.AcknowledgeTime=2e3]="AcknowledgeTime",n[n.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",n[n.KeepAliveTime=5e3]="KeepAliveTime",n[n.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",n[n.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",n[n.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(p=e.ProtocolConstants||(e.ProtocolConstants={}));class h{constructor(t,s,c,u){this.type=t,this.id=s,this.ack=c,this.data=u,this.writtenTime=0}get size(){return this.data.byteLength}}class w extends D.Disposable{constructor(t){super();this._onMessage=this._register(new L.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=t,this._isDisposed=!1,this._incomingData=new E,this._register(this._socket.onData(s=>this.acceptChunk(s))),this.lastReadTime=Date.now()}acceptChunk(t){if(!(!t||t.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(t);this._incomingData.byteLength>=this._state.readLen;){const s=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=s.readUInt32BE(9),this._state.messageType=s.readUInt8(0),this._state.id=s.readUInt32BE(1),this._state.ack=s.readUInt32BE(5);else{const c=this._state.messageType,u=this._state.id,f=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new h(c,u,f,s)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class y{constructor(t){this._isDisposed=!1,this._socket=t,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(t){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(t){if(this._isDisposed)return;t.writtenTime=Date.now(),this.lastWriteTime=Date.now();const s=R.VSBuffer.alloc(13);s.writeUInt8(t.type,0),s.writeUInt32BE(t.id,1),s.writeUInt32BE(t.ack,5),s.writeUInt32BE(t.data.byteLength,9),this._writeSoon(s,t.data)}_bufferAdd(t,s){const c=this._totalLength===0;return this._data.push(t,s),this._totalLength+=t.byteLength+s.byteLength,c}_bufferTake(){const t=R.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,t}_writeSoon(t,s){this._bufferAdd(t,s)&&k.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class m extends D.Disposable{constructor(t){super();this._onMessage=new L.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new L.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=t,this._socketWriter=this._register(new y(this._socket)),this._socketReader=this._register(new w(this._socket)),this._register(this._socketReader.onMessage(s=>{s.type===1&&this._onMessage.fire(s.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(t){this._socketWriter.write(new h(1,0,0,t))}}e.Protocol=m;class b extends P.IPCClient{constructor(t,s,c=null){super(t,s,c);this.protocol=t}static fromSocket(t,s){return new b(new m(t),s)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const t=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),t.end()}}e.Client=b;class g{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new L.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,i.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(t){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(t):this._emitter.fire(t):this._bufferedMessages.push(t)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=g;class a{constructor(t){this.data=t,this.next=null}}class l{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let t=[],s=0,c=this._first;for(;c;)t[s++]=c.data,c=c.next;return t}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(t){const s=new a(t);if(!this._first){this._first=s,this._last=s;return}this._last.next=s,this._last=s}}class r{constructor(){this.lastRuns=[];const t=Date.now();for(let s=0;s<r._HISTORY_LENGTH;s++)this.lastRuns[s]=t-1e3*s;setInterval(()=>{for(let s=r._HISTORY_LENGTH;s>=1;s--)this.lastRuns[s]=this.lastRuns[s-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return r._INSTANCE||(r._INSTANCE=new r),r._INSTANCE}load(){const t=Date.now(),s=(1+r._HISTORY_LENGTH)*1e3;let c=0;for(let u=0;u<r._HISTORY_LENGTH;u++)t-this.lastRuns[u]<=s&&c++;return 1-c/r._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}r._HISTORY_LENGTH=10,r._INSTANCE=null;class o{constructor(t,s=null,c=r.getInstance()){this._onControlMessage=new g,this.onControlMessage=this._onControlMessage.event,this._onMessage=new g,this.onMessage=this._onMessage.event,this._onDidDispose=new g,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new g,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new g,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=c,this._isReconnecting=!1,this._outgoingUnackMsg=new l,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=t,this._socketWriter=new y(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new w(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(u=>this._receiveMessage(u))),this._socketDisposables.push(this._socket.onClose(u=>this._onSocketClose.fire(u))),s&&this._socketReader.acceptChunk(s),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=(0,D.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const t=new h(5,0,0,I());this._socketWriter.write(t),this._socketWriter.flush()}_sendKeepAliveCheck(){if(this._outgoingKeepAliveTimeout)return;const t=Date.now()-this._socketWriter.lastWriteTime;if(t>=5e3){const s=new h(4,0,0,I());this._socketWriter.write(s),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-t+5)}_recvKeepAliveCheck(){if(this._incomingKeepAliveTimeout)return;const t=Date.now()-this._socketReader.lastReadTime;if(t>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-t,0)+5)}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(t,s){this._isReconnecting=!0,this._socketDisposables=(0,D.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=t,this._socketWriter=new y(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new w(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(c=>this._receiveMessage(c))),this._socketDisposables.push(this._socket.onClose(c=>this._onSocketClose.fire(c))),this._socketReader.acceptChunk(s)}endAcceptReconnection(){this._isReconnecting=!1;const t=this._outgoingUnackMsg.toArray();for(let s=0,c=t.length;s<c;s++)this._socketWriter.write(t[s]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(t){if(t.ack>this._outgoingAckId){this._outgoingAckId=t.ack;do{const s=this._outgoingUnackMsg.peek();if(s&&s.id<=t.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(t.type===1){if(t.id>this._incomingMsgId)if(t.id!==this._incomingMsgId+1){const s=Date.now();s-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=s,this._socketWriter.write(new h(6,0,0,I())))}else this._incomingMsgId=t.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(t.data)}else if(t.type===2)this._onControlMessage.fire(t.data);else if(t.type===5)this._onDidDispose.fire();else if(t.type===6){const s=this._outgoingUnackMsg.toArray();for(let c=0,u=s.length;c<u;c++)this._socketWriter.write(s[c]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(t){const s=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const c=new h(1,s,this._incomingAckId,t);this._outgoingUnackMsg.push(c),this._isReconnecting||(this._socketWriter.write(c),this._recvAckCheck())}sendControl(t){const s=new h(2,0,0,t);this._socketWriter.write(s)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const t=Date.now()-this._incomingMsgLastTime;if(t>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-t+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const t=this._outgoingUnackMsg.peek(),s=Date.now()-t.writtenTime;if(s>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-s,0)+5)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const t=new h(3,0,this._incomingAckId,I());this._socketWriter.write(t)}}e.PersistentProtocol=o}),define(te[119],ne([0,1,72,3,34,118]),function(X,e,R,L,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;class i extends D.IPCServer{static getOnDidClientConnect(){const S=L.Event.fromNodeEventEmitter(R.ipcRenderer,"vscode:createMessageChannel",(C,I)=>I);return L.Event.map(S,C=>{const{port1:I,port2:E}=new MessageChannel,p={protocol:new k.Protocol(I),onDidClientDisconnect:L.Event.fromDOMEventEmitter(I,"close")};return R.ipcRenderer.postMessage("vscode:createMessageChannelResult",C,[E]),p})}constructor(){super(i.getOnDidClientConnect())}}e.Server=i}),define(te[120],ne([0,1,19,9]),function(X,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.request=void 0;function D(P,S){P.proxyAuthorization&&(P.headers={...P.headers||{},"Proxy-Authorization":P.proxyAuthorization});const C=new XMLHttpRequest;return new Promise((I,E)=>{C.open(P.type||"GET",P.url||"",!0,P.user,P.password),k(C,P),C.responseType="arraybuffer",C.onerror=d=>E(new Error(C.statusText&&"XHR failed: "+C.statusText||"XHR failed")),C.onload=d=>{I({res:{statusCode:C.status,headers:i(C)},stream:(0,R.bufferToStream)(R.VSBuffer.wrap(new Uint8Array(C.response)))})},C.ontimeout=d=>E(new Error(`XHR timeout: ${P.timeout}ms`)),P.timeout&&(C.timeout=P.timeout),C.send(P.data),S.onCancellationRequested(()=>{C.abort(),E((0,L.canceled)())})})}e.request=D;function k(P,S){if(S.headers){e:for(let C in S.headers){switch(C){case"User-Agent":case"Accept-Encoding":case"Content-Length":continue e}P.setRequestHeader(C,S.headers[C])}}}function i(P){const S=Object.create(null);for(const C of P.getAllResponseHeaders().split(/\r\n|\n|\r/g))if(C){const I=C.indexOf(":");S[C.substr(0,I).trim().toLowerCase()]=C.substr(I+1).trim()}return S}}),define(te[73],ne([0,1,5,3,2,17]),function(X,e,R,L,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var i;(function(E){E[E.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(i=e.StorageHint||(e.StorageHint={}));function P(E){const d=E;return d?.changed instanceof Map||d?.deleted instanceof Set}e.isStorageItemsChangeEvent=P;var S;(function(E){E[E.None=0]="None",E[E.Initialized=1]="Initialized",E[E.Closed=2]="Closed"})(S||(S={}));class C extends D.Disposable{constructor(d,p=Object.create(null)){super();this.database=d,this.options=p,this._onDidChangeStorage=this._register(new L.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=S.None,this.cache=new Map,this.flushDelayer=new R.ThrottledDelayer(C.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(d=>this.onDidChangeItemsExternal(d)))}onDidChangeItemsExternal(d){d.changed?.forEach((p,h)=>this.accept(h,p)),d.deleted?.forEach(p=>this.accept(p,void 0))}accept(d,p){if(this.state===S.Closed)return;let h=!1;(0,k.isUndefinedOrNull)(p)?h=this.cache.delete(d):this.cache.get(d)!==p&&(this.cache.set(d,p),h=!0),h&&this._onDidChangeStorage.fire(d)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===S.None&&(this.state=S.Initialized,this.options.hint!==i.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(d,p){const h=this.cache.get(d);return(0,k.isUndefinedOrNull)(h)?p:h}getBoolean(d,p){const h=this.get(d);return(0,k.isUndefinedOrNull)(h)?p:h==="true"}getNumber(d,p){const h=this.get(d);return(0,k.isUndefinedOrNull)(h)?p:parseInt(h,10)}async set(d,p){if(this.state===S.Closed)return;if((0,k.isUndefinedOrNull)(p))return this.delete(d);const h=String(p);if(this.cache.get(d)!==h)return this.cache.set(d,h),this.pendingInserts.set(d,h),this.pendingDeletes.delete(d),this._onDidChangeStorage.fire(d),this.doFlush()}async delete(d){if(!(this.state===S.Closed||!this.cache.delete(d)))return this.pendingDeletes.has(d)||this.pendingDeletes.add(d),this.pendingInserts.delete(d),this._onDidChangeStorage.fire(d),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=S.Closed;try{await this.doFlush(0)}catch(d){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const d={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(d).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(d){if(!!this.hasPending)return this.doFlush(d)}async doFlush(d){return this.flushDelayer.trigger(()=>this.flushPending(),d)}async whenFlushed(){if(!!this.hasPending)return new Promise(d=>this.whenFlushedCallbacks.push(d))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=C,C.DEFAULT_FLUSH_DELAY=100;class I{constructor(){this.onDidChangeItemsExternal=L.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(d){d.insert&&d.insert.forEach((p,h)=>this.items.set(h,p)),d.delete&&d.delete.forEach(p=>this.items.delete(p))}async close(){}}e.InMemoryStorageDatabase=I}),define(te[121],ne([12,13]),function(X,e){return X.create("vs/base/common/date",e)}),define(te[58],ne([0,1,121]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const L=60,D=L*60,k=D*24,i=k*7,P=k*30,S=k*365;function C(E,d){typeof E!="number"&&(E=E.getTime());const p=Math.round((new Date().getTime()-E)/1e3);if(p<-30)return(0,R.localize)(0,null,C(new Date().getTime()+p*1e3,!1));if(p<30)return(0,R.localize)(1,null);let h;return p<L?(h=p,d?h===1?(0,R.localize)(2,null,h):(0,R.localize)(3,null,h):h===1?(0,R.localize)(4,null,h):(0,R.localize)(5,null,h)):p<D?(h=Math.floor(p/L),d?h===1?(0,R.localize)(6,null,h):(0,R.localize)(7,null,h):h===1?(0,R.localize)(8,null,h):(0,R.localize)(9,null,h)):p<k?(h=Math.floor(p/D),d?h===1?(0,R.localize)(10,null,h):(0,R.localize)(11,null,h):h===1?(0,R.localize)(12,null,h):(0,R.localize)(13,null,h)):p<i?(h=Math.floor(p/k),d?h===1?(0,R.localize)(14,null,h):(0,R.localize)(15,null,h):h===1?(0,R.localize)(16,null,h):(0,R.localize)(17,null,h)):p<P?(h=Math.floor(p/i),d?h===1?(0,R.localize)(18,null,h):(0,R.localize)(19,null,h):h===1?(0,R.localize)(20,null,h):(0,R.localize)(21,null,h)):p<S?(h=Math.floor(p/P),d?h===1?(0,R.localize)(22,null,h):(0,R.localize)(23,null,h):h===1?(0,R.localize)(24,null,h):(0,R.localize)(25,null,h)):(h=Math.floor(p/S),d?h===1?(0,R.localize)(26,null,h):(0,R.localize)(27,null,h):h===1?(0,R.localize)(28,null,h):(0,R.localize)(29,null,h))}e.fromNow=C;function I(E){return E.getFullYear()+"-"+String(E.getMonth()+1).padStart(2,"0")+"-"+String(E.getDate()).padStart(2,"0")+"T"+String(E.getHours()).padStart(2,"0")+":"+String(E.getMinutes()).padStart(2,"0")+":"+String(E.getSeconds()).padStart(2,"0")+"."+(E.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=I}),define(te[122],ne([12,13]),function(X,e){return X.create("vs/base/common/errorMessage",e)}),define(te[38],ne([0,1,16,17,122]),function(X,e,R,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function k(C,I){return I&&(C.stack||C.stacktrace)?D.localize(0,null,P(C),i(C.stack)||i(C.stacktrace)):P(C)}function i(C){return Array.isArray(C)?C.join(`
`):C}function P(C){return typeof C.code=="string"&&typeof C.errno=="number"&&typeof C.syscall=="string"?D.localize(1,null,C.message):C.message||D.localize(2,null)}function S(C=null,I=!1){if(!C)return D.localize(3,null);if(Array.isArray(C)){const E=R.coalesce(C),d=S(E[0],I);return E.length>1?D.localize(4,null,d,E.length):d}if(L.isString(C))return C;if(C.detail){const E=C.detail;if(E.error)return k(E.error,I);if(E.exception)return k(E.exception,I)}return C.stack?k(C,I):C.message?C.message:D.localize(5,null)}e.toErrorMessage=S}),define(te[123],ne([12,13]),function(X,e){return X.create("vs/base/node/processes",e)}),define(te[74],ne([0,1,45,42,15,28,10,4,31,102,17,111,20,123]),function(X,e,R,L,D,k,i,P,S,C,I,E,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.removeDangerousEnvVariables=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return C.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return C.TerminateResponseCode}});function h(r){switch(r){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function w(r,o){if(P.isWindows)try{const n={stdio:["pipe","pipe","ignore"]};o&&(n.cwd=o);const t=R.execFile("taskkill",["/T","/F","/PID",r.pid.toString()],n);return new Promise(s=>{t.once("error",c=>{s({success:!1,error:c})}),t.once("exit",(c,u)=>{s(c===0?{success:!0}:{success:!1,code:c!==null?c:1})})})}catch(n){return Promise.resolve({success:!1,error:n,code:n.status?h(n.status):1})}else if(P.isLinux||P.isMacintosh)try{const n=D.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",X).fsPath;return new Promise(t=>{R.execFile(n,[r.pid.toString()],{encoding:"utf8",shell:!0},(s,c,u)=>{t(s?{success:!1,error:s}:{success:!0})})})}catch(n){return Promise.resolve({success:!1,error:n})}else r.kill("SIGKILL");return Promise.resolve({success:!0})}function y(r){!r||(delete r.DEBUG,P.isMacintosh&&delete r.DYLD_LIBRARY_PATH,P.isLinux&&delete r.LD_PRELOAD)}e.removeDangerousEnvVariables=y;function m(r=S.env){return r.comspec||"cmd.exe"}e.getWindowsShell=m;class b{constructor(o,n,t,s){if(n!==void 0&&t!==void 0&&s!==void 0)this.cmd=o,this.args=n,this.shell=t,this.options=s;else{const c=o;this.cmd=c.command,this.shell=c.isShellCommand,this.args=c.args.slice(0),this.options=c.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const c=Object.create(null);Object.keys(S.env).forEach(u=>{c[u]=S.env[u]}),Object.keys(this.options.env).forEach(u=>{c[u]=this.options.env[u]}),this.options.env=c}}getSanitizedCommand(){let o=this.cmd.toLowerCase();const n=o.lastIndexOf(i.sep);return n!==-1&&(o=o.substring(n+1)),b.WellKnowCommands[o]?o:"other"}start(o){return P.isWindows&&(this.options&&this.options.cwd&&L.isUNC(this.options.cwd)||!this.options&&L.isUNC(S.cwd()))?Promise.reject(new Error(p.localize(0,null))):this.useExec().then(n=>{let t,s;const c=new Promise((u,f)=>{t=u,s=f});if(n){let u=this.cmd;this.args&&(u=u+" "+this.args.join(" ")),this.childProcess=R.exec(u,this.options,(f,v,T)=>{this.childProcess=null;const O=f;O&&O.killed?s({killed:this.terminateRequested,stdout:v.toString(),stderr:T.toString()}):this.handleExec(t,o,f,v,T)})}else{let u=null;const f=v=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(v,t,o,s);const T={terminated:this.terminateRequested};I.isNumber(v)&&(T.cmdCode=v),t(T)};if(this.shell&&P.isWindows){const v=k.deepClone(this.options);v.windowsVerbatimArguments=!0,v.detached=!1;let T=!1,O=!1;const U=[];let W=this.ensureQuotes(this.cmd);U.push(W.value),T=W.quoted,this.args&&this.args.forEach(A=>{W=this.ensureQuotes(A),U.push(W.value),O=O&&W.quoted});const N=["/s","/c"];T?O?N.push('"'+U.join(" ")+'"'):U.length>1?N.push('"'+U[0]+'" '+U.slice(1).join(" ")):N.push('"'+U[0]+'"'):N.push(U.join(" ")),u=R.spawn(m(),N,v)}else this.cmd&&(u=R.spawn(this.cmd,this.args,this.options));u&&(this.childProcess=u,this.childProcessPromise=Promise.resolve(u),this.pidResolve&&(this.pidResolve(I.isNumber(u.pid)?u.pid:-1),this.pidResolve=void 0),u.on("error",v=>{this.childProcess=null,s({terminated:this.terminateRequested,error:v})}),u.pid&&(this.childProcess.on("close",f),this.handleSpawn(u,t,o,s,!0)))}return c})}handleClose(o,n,t,s){}ensureQuotes(o){return b.regexp.test(o)?{value:'"'+o+'"',quoted:!0}:{value:o,quoted:o.length>0&&o[0]==='"'&&o[o.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(o=>o.pid,o=>-1):new Promise(o=>{this.pidResolve=o})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(o=>(this.terminateRequested=!0,w(o,this.options.cwd).then(n=>(n.success&&(this.childProcess=null),n))),o=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(o=>{if(!this.shell||!P.isWindows)return o(!1);const n=R.spawn(m(),["/s","/c"]);n.on("error",t=>o(!0)),n.on("exit",t=>o(!1))})}}e.AbstractProcess=b,b.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},b.regexp=/^[^"].* .*[^"]/;class g extends b{constructor(o,n,t,s){super(o,n,t,s);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(o,n,t,s,c){[s,c].forEach((u,f)=>{const v=new E.LineDecoder;v.write(u).forEach(U=>{n({line:U,source:f===0?0:1})});const O=v.end();O&&n({line:O,source:f===0?0:1})}),o({terminated:this.terminateRequested,error:t})}handleSpawn(o,n,t,s,c){const u=new E.LineDecoder,f=new E.LineDecoder;o.stdout.on("data",v=>{u.write(v).forEach(O=>t({line:O,source:0}))}),o.stderr.on("data",v=>{f.write(v).forEach(O=>t({line:O,source:1}))}),this.stdoutLineDecoder=u,this.stderrLineDecoder=f}handleClose(o,n,t,s){const c=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;c&&t({line:c,source:0});const u=this.stderrLineDecoder?this.stderrLineDecoder.end():null;u&&t({line:u,source:1})}}e.LineProcess=g;function a(r){let o=[],n=!1;const t=function(s){if(n){o.push(s);return}(!r.send(s,u=>{if(u&&console.error(u),n=!1,o.length>0){const f=o.slice(0);o=[],f.forEach(v=>t(v))}})||P.isWindows)&&(n=!0)};return{send:t}}e.createQueuedSender=a;var l;(function(r){async function o(n,t,s){if(i.isAbsolute(n))return n;if(t===void 0&&(t=S.cwd()),i.dirname(n)!=="."||(s===void 0&&I.isString(S.env.PATH)&&(s=S.env.PATH.split(i.delimiter)),s===void 0||s.length===0))return i.join(t,n);async function u(f){if(await d.Promises.exists(f)){let v;try{v=await d.Promises.stat(f)}catch(T){T.message.startsWith("EACCES")&&(v=await d.Promises.lstat(f))}return v?!v.isDirectory():!1}return!1}for(let f of s){let v;if(i.isAbsolute(f)?v=i.join(f,n):v=i.join(t,f,n),await u(v))return v;let T=v+".com";if(await u(T)||(T=v+".exe",await u(T)))return T}return i.join(t,n)}r.findExecutable=o})(l=e.win32||(e.win32={}))}),define(te[124],ne([0,1,33,4,70,74]),function(X,e,R,L,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function i(p,h){return p===1?L.isWindows?E():k.getWindowsShell(h):C(p,h)}e.getSystemShell=i;function P(p,h){return p===1?L.isWindows?d(h):k.getWindowsShell(h):C(p,h)}e.getSystemShellSync=P;let S=null;function C(p,h){if(L.isLinux&&p===2||L.isMacintosh&&p===3)return"/bin/bash";if(!S){let w;if(L.isWindows)w="/bin/bash";else{if(w=h.SHELL,!w)try{w=(0,R.userInfo)().shell}catch(y){}w||(w="sh"),w==="/bin/false"&&(w="/bin/bash")}S=w}return S}let I=null;async function E(){return I||(I=(await(0,D.getFirstAvailablePowerShellInstallation)()).exePath),I}function d(p){if(I)return I;const h=L.isWindows&&parseFloat((0,R.release)())>=10,w=p.hasOwnProperty("PROCESSOR_ARCHITEW6432"),y=`${p.windir}\\${w?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return h?y:k.getWindowsShell(p)}}),define(te[52],ne([0,1,45,5,19,27,106,9,3,2,28,74,34]),function(X,e,R,L,D,k,i,P,S,C,I,E,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class p extends d.ChannelServer{constructor(y){super({send:m=>{try{process.send&&process.send(m.buffer.toString("base64"))}catch(b){}},onMessage:S.Event.fromNodeEventEmitter(process,"message",m=>D.VSBuffer.wrap(Buffer.from(m,"base64")))},y);process.once("disconnect",()=>this.dispose())}}e.Server=p;class h{constructor(y,m){this.modulePath=y,this.options=m,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new S.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const b=m&&m.timeout?m.timeout:6e4;this.disposeDelayer=new L.Delayer(b),this.child=null,this._client=null}getChannel(y){const m=this;return{call(b,g,a){return m.requestPromise(y,b,g,a)},listen(b,g){return m.requestEvent(y,b,g)}}}requestPromise(y,m,b,g=k.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(g.isCancellationRequested)return Promise.reject(P.canceled());this.disposeDelayer.cancel();const a=this.getCachedChannel(y),l=(0,L.createCancelablePromise)(n=>a.call(m,b,n)),r=g.onCancellationRequested(()=>l.cancel()),o=(0,C.toDisposable)(()=>l.cancel());return this.activeRequests.add(o),l.finally(()=>{r.dispose(),this.activeRequests.delete(o),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),l}requestEvent(y,m,b){if(!this.disposeDelayer)return S.Event.None;this.disposeDelayer.cancel();let g;const a=new S.Emitter({onFirstListenerAdd:()=>{g=this.getCachedChannel(y).listen(m,b)(a.fire,a),this.activeRequests.add(g)},onLastListenerRemove:()=>{this.activeRequests.delete(g),g.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return a.event}get client(){if(!this._client){const y=this.options&&this.options.args?this.options.args:[],m=Object.create(null);m.env={...(0,I.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(m.env={...m.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(m.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(m.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(m.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),m.execArgv===void 0&&(m.execArgv=process.execArgv.filter(t=>!/^--inspect(-brk)?=/.test(t))),(0,E.removeDangerousEnvVariables)(m.env),this.child=(0,R.fork)(this.modulePath,y,m);const b=new S.Emitter;S.Event.fromNodeEventEmitter(this.child,"message",t=>t)(t=>{if((0,i.isRemoteConsoleLog)(t)){(0,i.log)(t,`IPC Library: ${this.options.serverName}`);return}b.fire(D.VSBuffer.wrap(Buffer.from(t,"base64")))});const a=this.options.useQueue?(0,E.createQueuedSender)(this.child):this.child,l=t=>this.child&&this.child.connected&&a.send(t.buffer.toString("base64")),r=b.event,o={send:l,onMessage:r};this._client=new d.ChannelClient(o);const n=()=>this.disposeClient();process.once("exit",n),this.child.on("error",t=>console.warn('IPC "'+this.options.serverName+'" errored with '+t)),this.child.on("exit",(t,s)=>{process.removeListener("exit",n),this.activeRequests.forEach(c=>(0,C.dispose)(c)),this.activeRequests.clear(),t!==0&&s!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+t+" and signal "+s),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:t,signal:s})})}return this._client}getCachedChannel(y){let m=this.channels.get(y);return m||(m=this.client.getChannel(y),this.channels.set(y,m)),m}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=h}),define(te[125],ne([12,13]),function(X,e){return X.create("vs/base/node/zip",e)}),define(te[126],ne([12,13]),function(X,e){return X.create("vs/platform/configuration/common/configurationRegistry",e)}),define(te[127],ne([12,13]),function(X,e){return X.create("vs/platform/environment/node/argv",e)}),define(te[128],ne([12,13]),function(X,e){return X.create("vs/platform/environment/node/argvHelper",e)}),define(te[129],ne([12,13]),function(X,e){return X.create("vs/platform/environment/node/shellEnv",e)}),define(te[130],ne([12,13]),function(X,e){return X.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(te[131],ne([12,13]),function(X,e){return X.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(te[132],ne([12,13]),function(X,e){return X.create("vs/platform/extensionManagement/electron-sandbox/extensionTipsService",e)}),define(te[133],ne([12,13]),function(X,e){return X.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(te[134],ne([12,13]),function(X,e){return X.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(te[135],ne([12,13]),function(X,e){return X.create("vs/platform/extensionManagement/node/extensionsScanner",e)}),define(te[136],ne([12,13]),function(X,e){return X.create("vs/platform/extensions/common/extensionValidator",e)}),define(te[137],ne([12,13]),function(X,e){return X.create("vs/platform/files/common/fileService",e)}),define(te[138],ne([12,13]),function(X,e){return X.create("vs/platform/files/common/files",e)}),define(te[139],ne([12,13]),function(X,e){return X.create("vs/platform/files/common/io",e)}),define(te[140],ne([12,13]),function(X,e){return X.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(te[141],ne([12,13]),function(X,e){return X.create("vs/platform/request/common/request",e)}),define(te[142],ne([12,13]),function(X,e){return X.create("vs/platform/telemetry/common/telemetryService",e)}),define(te[143],ne([12,13]),function(X,e){return X.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(te[144],ne([12,13]),function(X,e){return X.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(te[145],ne([12,13]),function(X,e){return X.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(te[146],ne([12,13]),function(X,e){return X.create("vs/platform/userDataSync/common/settingsSync",e)}),define(te[147],ne([12,13]),function(X,e){return X.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(te[148],ne([12,13]),function(X,e){return X.create("vs/platform/userDataSync/common/userDataSync",e)}),define(te[149],ne([12,13]),function(X,e){return X.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(te[150],ne([0,1,4]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AssignmentFilterProvider=e.Filters=e.TargetPopulation=e.ASSIGNMENT_REFETCH_INTERVAL=e.ASSIGNMENT_STORAGE_KEY=void 0,e.ASSIGNMENT_STORAGE_KEY="VSCode.ABExp.FeatureData",e.ASSIGNMENT_REFETCH_INTERVAL=0;var L;(function(i){i.Team="team",i.Internal="internal",i.Insiders="insider",i.Public="public"})(L=e.TargetPopulation||(e.TargetPopulation={}));var D;(function(i){i.Market="X-MSEdge-Market",i.CorpNet="X-FD-Corpnet",i.ApplicationVersion="X-VSCode-AppVersion",i.Build="X-VSCode-Build",i.ClientId="X-MSEdge-ClientId",i.ExtensionName="X-VSCode-ExtensionName",i.Language="X-VSCode-Language",i.TargetPopulation="X-VSCode-TargetPopulation"})(D=e.Filters||(e.Filters={}));class k{constructor(P,S,C,I){this.version=P,this.appName=S,this.machineId=C,this.targetPopulation=I}getFilterValue(P){switch(P){case D.ApplicationVersion:return this.version;case D.Build:return this.appName;case D.ClientId:return this.machineId;case D.Language:return R.language;case D.ExtensionName:return"vscode-core";case D.TargetPopulation:return this.targetPopulation;default:return""}}getFilters(){let P=new Map,S=Object.values(D);for(let C of S)P.set(C,this.getFilterValue(C));return P}}e.AssignmentFilterProvider=k}),define(te[75],ne([0,1,58,67,15,10,31,18,7]),function(X,e,R,L,D,k,i,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class C{constructor(w,y,m){this._args=w,this.paths=y,this.productService=m}get appRoot(){return(0,k.dirname)(D.FileAccess.asFileUri("",X).fsPath)}get userHome(){return S.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return S.URI.file((0,k.join)(this.userDataPath,"User"))}get tmpDir(){return S.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,P.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,P.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const w=(0,R.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,k.join)(this.userDataPath,"logs",w)}return this.args.logsPath}get userDataSyncLogResource(){return S.URI.file((0,k.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,P.joinPath)(S.URI.file((0,k.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return S.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return S.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,P.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,P.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const w=i.env.VSCODE_PORTABLE;return w?S.URI.file((0,k.join)(w,"argv.json")):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,P.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return S.URI.file((0,k.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,k.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const w=this.args["builtin-extensions-dir"];return w?(0,k.resolve)(w):(0,k.normalize)((0,k.join)(D.FileAccess.asFileUri("",X).fsPath,"..","extensions"))}get extensionsDownloadPath(){const w=this.args["extensions-download-dir"];return w?(0,k.resolve)(w):(0,k.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const w=this.args["extensions-dir"];if(w)return(0,k.resolve)(w);const y=i.env.VSCODE_EXTENSIONS;if(y)return y;const m=i.env.VSCODE_PORTABLE;return m?(0,k.join)(m,"extensions"):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const w=this.args.extensionDevelopmentPath;if(Array.isArray(w))return w.map(y=>/^[^:/?#]+?:\/\//.test(y)?S.URI.parse(y):S.URI.file((0,k.normalize)(y)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(w=>w==="ui"||w==="workspace"||w==="web"?w:"workspace")}get extensionTestsLocationURI(){const w=this.args.extensionTestsPath;if(w)return/^[^:/?#]+?:\/\//.test(w)?S.URI.parse(w):S.URI.file((0,k.normalize)(w))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const w=this.args["disable-extension"];if(w){if(typeof w=="string")return[w];if(Array.isArray(w)&&w.length>0)return w}return!1}get debugExtensionHost(){return I(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!i.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,P.joinPath)(S.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return S.URI.file((0,k.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}he([L.memoize],C.prototype,"appRoot",null),he([L.memoize],C.prototype,"userHome",null),he([L.memoize],C.prototype,"userDataPath",null),he([L.memoize],C.prototype,"appSettingsHome",null),he([L.memoize],C.prototype,"tmpDir",null),he([L.memoize],C.prototype,"userRoamingDataHome",null),he([L.memoize],C.prototype,"settingsResource",null),he([L.memoize],C.prototype,"userDataSyncHome",null),he([L.memoize],C.prototype,"userDataSyncLogResource",null),he([L.memoize],C.prototype,"sync",null),he([L.memoize],C.prototype,"machineSettingsResource",null),he([L.memoize],C.prototype,"globalStorageHome",null),he([L.memoize],C.prototype,"workspaceStorageHome",null),he([L.memoize],C.prototype,"keybindingsResource",null),he([L.memoize],C.prototype,"keyboardLayoutResource",null),he([L.memoize],C.prototype,"argvResource",null),he([L.memoize],C.prototype,"snippetsHome",null),he([L.memoize],C.prototype,"isExtensionDevelopment",null),he([L.memoize],C.prototype,"untitledWorkspacesHome",null),he([L.memoize],C.prototype,"installSourcePath",null),he([L.memoize],C.prototype,"builtinExtensionsPath",null),he([L.memoize],C.prototype,"extensionsPath",null),he([L.memoize],C.prototype,"extensionDevelopmentLocationURI",null),he([L.memoize],C.prototype,"extensionDevelopmentKind",null),he([L.memoize],C.prototype,"extensionTestsLocationURI",null),he([L.memoize],C.prototype,"debugExtensionHost",null),he([L.memoize],C.prototype,"serviceMachineIdResource",null),he([L.memoize],C.prototype,"telemetryLogResource",null),he([L.memoize],C.prototype,"disableWorkspaceTrust",null),e.AbstractNativeEnvironmentService=C;function I(h,w){return p(h["inspect-extensions"],h["inspect-brk-extensions"],5870,w,h.debugId,h.extensionEnvironment)}e.parseExtensionHostPort=I;function E(h,w){return p(h["inspect-search"],h["inspect-brk-search"],5876,w,h.extensionEnvironment)}e.parseSearchPort=E;function d(h,w){return p(h["inspect-ptyhost"],h["inspect-brk-ptyhost"],5877,w,h.extensionEnvironment)}e.parsePtyHostPort=d;function p(h,w,y,m,b,g){const l=Number(w||h)||(m?null:y),r=l?Boolean(!!w):!1;let o;if(g)try{o=JSON.parse(g)}catch{}return{port:l,break:r,debugId:b,env:o}}}),define(te[151],ne([0,1,245,4,127]),function(X,e,R,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const k={o:(0,D.localize)(0,null),e:(0,D.localize)(1,null),t:(0,D.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,D.localize)(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,D.localize)(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,D.localize)(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,D.localize)(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,D.localize)(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,D.localize)(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,D.localize)(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,D.localize)(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,D.localize)(11,null)},"extensions-dir":{type:"string",deprecates:"extensionHomePath",cat:"e",args:"dir",description:(0,D.localize)(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,D.localize)(13,null)},"show-versions":{type:"boolean",cat:"e",description:(0,D.localize)(14,null)},category:{type:"string",cat:"e",description:(0,D.localize)(15,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"extension-id[@version] | path-to-vsix",description:(0,D.localize)(16,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"extension-id",description:(0,D.localize)(17,null)},"enable-proposed-api":{type:"string[]",cat:"e",args:"extension-id",description:(0,D.localize)(18,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,D.localize)(19,null)},verbose:{type:"boolean",cat:"t",description:(0,D.localize)(20,null)},log:{type:"string",cat:"t",args:"level",description:(0,D.localize)(21,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,D.localize)(22,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,D.localize)(23,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:"disableExtensions",cat:"t",description:(0,D.localize)(24,null)},"disable-extension":{type:"string[]",cat:"t",args:"extension-id",description:(0,D.localize)(25,null)},sync:{type:"string",cat:"t",description:(0,D.localize)(26,null),args:["on","off"]},"inspect-extensions":{type:"string",deprecates:"debugPluginHost",args:"port",cat:"t",description:(0,D.localize)(27,null)},"inspect-brk-extensions":{type:"string",deprecates:"debugBrkPluginHost",args:"port",cat:"t",description:(0,D.localize)(28,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,D.localize)(29,null)},"ms-enable-electron-run-as-node":{type:"boolean"},"max-memory":{type:"string",cat:"t",description:(0,D.localize)(30,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,D.localize)(31,null)},remote:{type:"string"},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string"},"inspect-brk-ptyhost":{type:"string"},"inspect-search":{type:"string",deprecates:"debugSearch"},"inspect-brk-search":{type:"string",deprecates:"debugBrkSearch"},"export-default-configuration":{type:"string"},"install-source":{type:"string"},driver:{type:"string"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"driver-verbose":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string"},"inspect-brk":{type:"string"},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},_:{type:"string[]"}};const i={onUnknownOption:()=>{},onMultipleValues:()=>{}};function P(h,w,y=i){const m={},b=[],g=[];for(let o in w){const n=w[o];n.alias&&(m[o]=n.alias),n.type==="string"||n.type==="string[]"?(b.push(o),n.deprecates&&b.push(n.deprecates)):n.type==="boolean"&&(g.push(o),n.deprecates&&g.push(n.deprecates))}const a=R(h,{string:b,boolean:g,alias:m}),l={},r=a;l._=a._.map(o=>String(o)).filter(o=>o.length>0),delete r._;for(let o in w){const n=w[o];n.alias&&delete r[n.alias];let t=r[o];n.deprecates&&r.hasOwnProperty(n.deprecates)&&(t||(t=r[n.deprecates]),delete r[n.deprecates]),typeof t!="undefined"&&(n.type==="string[]"?t&&!Array.isArray(t)&&(t=[t]):n.type==="string"&&Array.isArray(t)&&(t=t.pop(),y.onMultipleValues(o,t)),l[o]=t),delete r[o]}for(let o in r)y.onUnknownOption(o);return l}e.parseArgs=P;function S(h,w){let y="";return w.args&&(Array.isArray(w.args)?y=` <${w.args.join("> <")}>`:y=` <${w.args}>`),w.alias?`-${w.alias} --${h}${y}`:`--${h}${y}`}function C(h,w){let y=0,m=[];for(const l in h){const r=h[l],o=S(l,r);y=Math.max(y,o.length),m.push([o,r.description])}let b=y+2+1;if(w-b<25)return m.reduce((l,r)=>l.concat([`  ${r[0]}`,`      ${r[1]}`]),[]);let g=w-b-1,a=[];for(const l of m){let r=l[0],o=E(l[1],g),n=I(b-r.length-2);a.push("  "+r+n+o[0]);for(let t=1;t<o.length;t++)a.push(I(b)+o[t])}return a}e.formatOptions=C;function I(h){return" ".repeat(h)}function E(h,w){let y=[];for(;h.length;){let m=h.length<w?h.length:h.lastIndexOf(" ",w),b=h.slice(0,m).trim();h=h.slice(m),y.push(b)}return y}function d(h,w,y,m,b=!0){const g=process.stdout.isTTY&&process.stdout.columns||80;let a=[`${h} ${y}`];a.push(""),a.push(`${(0,D.localize)(32,null)}: ${w} [${(0,D.localize)(33,null)}][${(0,D.localize)(34,null)}...]`),a.push(""),b&&(L.isWindows?a.push((0,D.localize)(35,null,w)):a.push((0,D.localize)(36,null,w)),a.push(""));const l={};for(const r in m){const o=m[r];if(o.description&&o.cat){let n=l[o.cat];n||(l[o.cat]=n={}),n[r]=o}}for(let r in l){const o=r;let n=l[o];n&&(a.push(k[o]),a.push(...C(n,g)),a.push(""))}return a.join(`
`)}e.buildHelpMessage=d;function p(h,w){return`${h||(0,D.localize)(37,null)}
${w||(0,D.localize)(38,null)}
${process.arch}`}e.buildVersionMessage=p}),function(){"use strict";function X(e,R,L,D){function k(P){const S=i(P),C=[S];return e.isAbsolute(S)||C.unshift(D),e.resolve(...C)}function i(P){const S=process.env.VSCODE_PORTABLE;if(S)return e.join(S,"user-data");let C=process.env.VSCODE_APPDATA;if(C)return e.join(C,L);const I=P["user-data-dir"];if(I)return I;switch(process.platform){case"win32":if(C=process.env.APPDATA,!C){const E=process.env.USERPROFILE;if(typeof E!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");C=e.join(E,"AppData","Roaming")}break;case"darwin":C=e.join(R.homedir(),"Library","Application Support");break;case"linux":C=process.env.XDG_CONFIG_HOME||e.join(R.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(C,L)}return{getUserDataPath:k}}if(typeof define=="function")define(te[152],ne([0,153,33,15,18,31]),function(e,R,L,D,k,i){const P=k.dirname(D.FileAccess.asFileUri("",e)),S=e.__$__nodeRequire(k.joinPath(P,"package.json").fsPath);return X(R,L,S.name,i.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),R=require("path"),L=require("os");module.exports=X(R,L,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(te[154],ne([0,1,33,75,152]),function(X,e,R,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class k extends L.AbstractNativeEnvironmentService{constructor(P,S){super(P,{homeDir:(0,R.homedir)(),tmpDir:(0,R.tmpdir)(),userDataDir:(0,D.getUserDataPath)(P)},S)}}e.NativeEnvironmentService=k}),define(te[155],ne([0,1,7]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemotes=e.getDomainsOfRemotes=e.AllowedSecondLevelDomains=void 0;const L=/^([^@:]+@)?([^:]+):/,D=/^([^@:]+@)?([^:]+):(.+)$/,k=/^([^@]+@)?([^:]+)(:\d+)?$/,i=/([^@:.]+\.[^@:.]+)(:\d+)?$/,P=/^\s*url\s*=\s*(.+\S)\s*$/mg,S=/[^.]/g;e.AllowedSecondLevelDomains=["github.com","bitbucket.org","visualstudio.com","gitlab.com","heroku.com","azurewebsites.net","ibm.com","amazon.com","amazonaws.com","cloudapp.net","rhcloud.com","google.com","azure.com"];function C(y){const m=y.match(i);return m?m[1]:null}function I(y){if(y.indexOf("://")===-1){const m=y.match(L);return m?C(m[2]):null}try{const m=R.URI.parse(y);if(m.authority)return C(m.authority)}catch(m){}return null}function E(y,m){const b=new Set;let g;for(;g=P.exec(y);){const l=I(g[1]);l&&b.add(l)}const a=new Set(m);return Array.from(b).map(l=>a.has(l)?l:l.replace(S,"a"))}e.getDomainsOfRemotes=E;function d(y){const m=y.match(k);return m?m[2]:null}function p(y,m,b){return y&&m?(b&&m.endsWith(".git")&&(m=m.substr(0,m.length-4)),m.indexOf("/")===0?`${y}${m}`:`${y}/${m}`):null}function h(y,m){if(y.indexOf("://")===-1){const b=y.match(D);if(b)return p(b[2],b[3],m)}try{const b=R.URI.parse(y);if(b.authority)return p(d(b.authority),b.path,m)}catch(b){}return null}function w(y,m=!1){const b=[];let g;for(;g=P.exec(y);){const a=h(g[1],m);a&&b.push(a)}return b}e.getRemotes=w}),define(te[156],ne([0,1,28]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;const L=/^%([\w\d.-]+)%$/i;function D(k,i){const P=S=>{if(typeof S!="string")return;const C=L.exec(S);if(!C)return;const I=i[C[1]]??S;return typeof I=="string"?I:typeof I.message=="string"?I.message:S};return(0,R.cloneAndChange)(k,P)}e.localizeManifest=D}),define(te[157],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class R{constructor(k){this.channel=k}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(k,i,P,S){return this.channel.call("promptImportantExtensionsInstallNotification",[k,i,P,S])}promptWorkspaceRecommendations(k){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=R;class L{constructor(k){this.service=k}listen(k,i){throw new Error(`Event not found: ${i}`)}call(k,i,P){switch(i){case"promptImportantExtensionsInstallNotification":return this.service.promptImportantExtensionsInstallNotification(P[0],P[1],P[2],P[3])}throw new Error(`Call not found: ${i}`)}}e.ExtensionRecommendationNotificationServiceChannel=L}),define(te[76],ne([0,1,136]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const L=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,D=/^-(\d{4})(\d{2})(\d{2})$/;function k(d){return d=d.trim(),d==="*"||L.test(d)}e.isValidVersionStr=k;function i(d){if(!k(d))return null;if(d=d.trim(),d==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let p=d.match(L);return p?{hasCaret:p[1]==="^",hasGreaterEquals:p[1]===">=",majorBase:p[2]==="x"?0:parseInt(p[2],10),majorMustEqual:p[2]!=="x",minorBase:p[4]==="x"?0:parseInt(p[4],10),minorMustEqual:p[4]!=="x",patchBase:p[6]==="x"?0:parseInt(p[6],10),patchMustEqual:p[6]!=="x",preRelease:p[8]||null}:null}e.parseVersion=i;function P(d){if(!d)return null;let p=d.majorBase,h=d.majorMustEqual,w=d.minorBase,y=d.minorMustEqual,m=d.patchBase,b=d.patchMustEqual;d.hasCaret&&(p===0||(y=!1),b=!1);let g=0;if(d.preRelease){const a=D.exec(d.preRelease);if(a){const[,l,r,o]=a;g=Date.UTC(Number(l),Number(r)-1,Number(o))}}return{majorBase:p,majorMustEqual:h,minorBase:w,minorMustEqual:y,patchBase:m,patchMustEqual:b,isMinimum:d.hasGreaterEquals,notBefore:g}}e.normalizeVersion=P;function S(d,p,h){let w;typeof d=="string"?w=P(i(d)):w=d;let y;p instanceof Date?y=p.getTime():typeof p=="string"&&(y=new Date(p).getTime());let m;if(typeof h=="string"?m=P(i(h)):m=h,!w||!m)return!1;let b=w.majorBase,g=w.minorBase,a=w.patchBase,l=m.majorBase,r=m.minorBase,o=m.patchBase,n=m.notBefore,t=m.majorMustEqual,s=m.minorMustEqual,c=m.patchMustEqual;return m.isMinimum?b>l?!0:b<l?!1:g>r?!0:g<r||y&&y<n?!1:a>=o:(b===1&&l===0&&(!t||!s||!c)&&(l=1,r=0,o=0,t=!0,s=!1,c=!1),b<l?!1:b>l?!t:g<r?!1:g>r?!s:a<o?!1:a>o?!c:!(y&&y<n))}e.isValidVersion=S;function C(d,p,h,w){return h.isBuiltin||typeof h.main=="undefined"?!0:E(d,p,h.engines.vscode,w)}e.isValidExtensionVersion=C;function I(d,p,h){return d==="*"||E(p,h,d)}e.isEngineValid=I;function E(d,p,h,w=[]){let y=P(i(h));if(!y)return w.push(R.localize(0,null,h)),!1;if(y.majorBase===0){if(!y.majorMustEqual||!y.minorMustEqual)return w.push(R.localize(1,null,h)),!1}else if(!y.majorMustEqual)return w.push(R.localize(2,null,h)),!1;return S(d,p,y)?!0:(w.push(R.localize(3,null,d,h)),!1)}}),define(te[53],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class R{constructor(D,k=[],i=!1){this.ctor=D,this.staticArguments=k,this.supportsDelayedInstantiation=i}}e.SyncDescriptor=R}),define(te[77],ne([0,1,53]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const L=[];function D(i,P,S){P instanceof R.SyncDescriptor||(P=new R.SyncDescriptor(P,[],S)),L.push([i,P])}e.registerSingleton=D;function k(){return L}e.getSingletonServiceDescriptors=k}),define(te[158],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class R{constructor(k){this.incoming=new Map,this.outgoing=new Map,this.data=k}}e.Node=R;class L{constructor(k){this._hashFn=k,this._nodes=new Map}roots(){const k=[];for(let i of this._nodes.values())i.outgoing.size===0&&k.push(i);return k}insertEdge(k,i){const P=this.lookupOrInsertNode(k),S=this.lookupOrInsertNode(i);P.outgoing.set(this._hashFn(i),S),S.incoming.set(this._hashFn(k),P)}removeNode(k){const i=this._hashFn(k);this._nodes.delete(i);for(let P of this._nodes.values())P.outgoing.delete(i),P.incoming.delete(i)}lookupOrInsertNode(k){const i=this._hashFn(k);let P=this._nodes.get(i);return P||(P=new R(k),this._nodes.set(i,P)),P}lookup(k){return this._nodes.get(this._hashFn(k))}isEmpty(){return this._nodes.size===0}toString(){let k=[];for(let[i,P]of this._nodes)k.push(`${i}, (incoming)[${[...P.incoming.keys()].join(", ")}], (outgoing)[${[...P.outgoing.keys()].join(",")}]`);return k.join(`
`)}findCycleSlow(){for(let[k,i]of this._nodes){const P=new Set([k]),S=this._findCycle(i,P);if(S)return S}}_findCycle(k,i){for(let[P,S]of k.outgoing){if(i.has(P))return[...i,P].join(" -> ");i.add(P);const C=this._findCycle(S,i);if(C)return C;i.delete(P)}}}e.Graph=L}),define(te[6],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var R;(function(i){i.serviceIds=new Map,i.DI_TARGET="$di$target",i.DI_DEPENDENCIES="$di$dependencies";function P(S){return S[i.DI_DEPENDENCIES]||[]}i.getServiceDependencies=P})(R=e._util||(e._util={})),e.IInstantiationService=D("instantiationService");function L(i,P,S,C){P[R.DI_TARGET]===P?P[R.DI_DEPENDENCIES].push({id:i,index:S,optional:C}):(P[R.DI_DEPENDENCIES]=[{id:i,index:S,optional:C}],P[R.DI_TARGET]=P)}function D(i){if(R.serviceIds.has(i))return R.serviceIds.get(i);const P=function(S,C,I){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");L(P,S,I,!1)};return P.toString=()=>i,R.serviceIds.set(i,P),P}e.createDecorator=D;function k(i){return i}e.refineServiceDecorator=k}),define(te[159],ne([0,1,6]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=(0,R.createDecorator)("checksumService")}),define(te[160],ne([0,1,4,25,6]),function(X,e,R,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let k=R.userAgent||"";const i=new Map;i.set("false",!1),i.set("true",!0),i.set("isMac",R.isMacintosh),i.set("isLinux",R.isLinux),i.set("isWindows",R.isWindows),i.set("isWeb",R.isWeb),i.set("isMacNative",R.isMacintosh&&!R.isWeb),i.set("isEdge",k.indexOf("Edg/")>=0),i.set("isFirefox",k.indexOf("Firefox")>=0),i.set("isChrome",k.indexOf("Chrome")>=0),i.set("isSafari",k.indexOf("Safari")>=0);const P=Object.prototype.hasOwnProperty;var S;(function(N){N[N.False=0]="False",N[N.True=1]="True",N[N.Defined=2]="Defined",N[N.Not=3]="Not",N[N.Equals=4]="Equals",N[N.NotEquals=5]="NotEquals",N[N.And=6]="And",N[N.Regex=7]="Regex",N[N.NotRegex=8]="NotRegex",N[N.Or=9]="Or",N[N.In=10]="In",N[N.NotIn=11]="NotIn",N[N.Greater=12]="Greater",N[N.GreaterEquals=13]="GreaterEquals",N[N.Smaller=14]="Smaller",N[N.SmallerEquals=15]="SmallerEquals"})(S=e.ContextKeyExprType||(e.ContextKeyExprType={}));class C{static false(){return d.INSTANCE}static true(){return p.INSTANCE}static has(A){return h.create(A)}static equals(A,z){return w.create(A,z)}static notEquals(A,z){return b.create(A,z)}static regex(A,z){return t.create(A,z)}static in(A,z){return y.create(A,z)}static not(A){return g.create(A)}static and(...A){return u.create(A,null)}static or(...A){return f.create(A,null,!0)}static greater(A,z){return l.create(A,z)}static greaterEquals(A,z){return r.create(A,z)}static smaller(A,z){return o.create(A,z)}static smallerEquals(A,z){return n.create(A,z)}static deserialize(A,z=!1){if(!!A)return this._deserializeOrExpression(A,z)}static _deserializeOrExpression(A,z){let _=A.split("||");return f.create(_.map(M=>this._deserializeAndExpression(M,z)),null,!0)}static _deserializeAndExpression(A,z){let _=A.split("&&");return u.create(_.map(M=>this._deserializeOne(M,z)),null)}static _deserializeOne(A,z){if(A=A.trim(),A.indexOf("!=")>=0){let _=A.split("!=");return b.create(_[0].trim(),this._deserializeValue(_[1],z))}if(A.indexOf("==")>=0){let _=A.split("==");return w.create(_[0].trim(),this._deserializeValue(_[1],z))}if(A.indexOf("=~")>=0){let _=A.split("=~");return t.create(_[0].trim(),this._deserializeRegexValue(_[1],z))}if(A.indexOf(" in ")>=0){let _=A.split(" in ");return y.create(_[0].trim(),_[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(A)){const _=A.split(">=");return r.create(_[0].trim(),_[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(A)){const _=A.split(">");return l.create(_[0].trim(),_[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(A)){const _=A.split("<=");return n.create(_[0].trim(),_[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(A)){const _=A.split("<");return o.create(_[0].trim(),_[1].trim())}return/^\!\s*/.test(A)?g.create(A.substr(1).trim()):h.create(A)}static _deserializeValue(A,z){if(A=A.trim(),A==="true")return!0;if(A==="false")return!1;let _=/^'([^']*)'$/.exec(A);return _?_[1].trim():A}static _deserializeRegexValue(A,z){if((0,L.isFalsyOrWhitespace)(A)){if(z)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let _=A.indexOf("/"),M=A.lastIndexOf("/");if(_===M||_<0){if(z)throw new Error(`bad regexp-value '${A}', missing /-enclosure`);return console.warn(`bad regexp-value '${A}', missing /-enclosure`),null}let q=A.slice(_+1,M),B=A[M+1]==="i"?"i":"";try{return new RegExp(q,B)}catch(j){if(z)throw new Error(`bad regexp-value '${A}', parse error: ${j}`);return console.warn(`bad regexp-value '${A}', parse error: ${j}`),null}}}e.ContextKeyExpr=C;function I(N,A){const z=N?N.substituteConstants():void 0,_=A?A.substituteConstants():void 0;return!z&&!_?!0:!z||!_?!1:z.equals(_)}e.expressionsAreEqualWithConstantSubstitution=I;function E(N,A){return N.cmp(A)}class d{constructor(){this.type=0}cmp(A){return this.type-A.type}equals(A){return A.type===this.type}substituteConstants(){return this}evaluate(A){return!1}serialize(){return"false"}keys(){return[]}map(A){return this}negate(){return p.INSTANCE}}e.ContextKeyFalseExpr=d,d.INSTANCE=new d;class p{constructor(){this.type=1}cmp(A){return this.type-A.type}equals(A){return A.type===this.type}substituteConstants(){return this}evaluate(A){return!0}serialize(){return"true"}keys(){return[]}map(A){return this}negate(){return d.INSTANCE}}e.ContextKeyTrueExpr=p,p.INSTANCE=new p;class h{constructor(A,z){this.key=A,this.negated=z,this.type=2}static create(A,z=null){const _=i.get(A);return typeof _=="boolean"?_?p.INSTANCE:d.INSTANCE:new h(A,z)}cmp(A){return A.type!==this.type?this.type-A.type:T(this.key,A.key)}equals(A){return A.type===this.type?this.key===A.key:!1}substituteConstants(){const A=i.get(this.key);return typeof A=="boolean"?A?p.INSTANCE:d.INSTANCE:this}evaluate(A){return!!A.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(A){return A.mapDefined(this.key)}negate(){return this.negated||(this.negated=g.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=h;class w{constructor(A,z,_){this.key=A,this.value=z,this.negated=_,this.type=4}static create(A,z,_=null){if(typeof z=="boolean")return z?h.create(A,_):g.create(A,_);const M=i.get(A);return typeof M=="boolean"?z===(M?"true":"false")?p.INSTANCE:d.INSTANCE:new w(A,z,_)}cmp(A){return A.type!==this.type?this.type-A.type:O(this.key,this.value,A.key,A.value)}equals(A){return A.type===this.type?this.key===A.key&&this.value===A.value:!1}substituteConstants(){const A=i.get(this.key);if(typeof A=="boolean"){const z=A?"true":"false";return this.value===z?p.INSTANCE:d.INSTANCE}return this}evaluate(A){return A.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(A){return A.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=b.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=w;class y{constructor(A,z){this.key=A,this.valueKey=z,this.type=10,this.negated=null}static create(A,z){return new y(A,z)}cmp(A){return A.type!==this.type?this.type-A.type:O(this.key,this.valueKey,A.key,A.valueKey)}equals(A){return A.type===this.type?this.key===A.key&&this.valueKey===A.valueKey:!1}substituteConstants(){return this}evaluate(A){const z=A.getValue(this.valueKey),_=A.getValue(this.key);return Array.isArray(z)?z.indexOf(_)>=0:typeof _=="string"&&typeof z=="object"&&z!==null?P.call(z,_):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(A){return A.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=m.create(this)),this.negated}}e.ContextKeyInExpr=y;class m{constructor(A){this._actual=A,this.type=11}static create(A){return new m(A)}cmp(A){return A.type!==this.type?this.type-A.type:this._actual.cmp(A._actual)}equals(A){return A.type===this.type?this._actual.equals(A._actual):!1}substituteConstants(){return this}evaluate(A){return!this._actual.evaluate(A)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(A){return new m(this._actual.map(A))}negate(){return this._actual}}e.ContextKeyNotInExpr=m;class b{constructor(A,z,_){this.key=A,this.value=z,this.negated=_,this.type=5}static create(A,z,_=null){if(typeof z=="boolean")return z?g.create(A,_):h.create(A,_);const M=i.get(A);return typeof M=="boolean"?z===(M?"true":"false")?d.INSTANCE:p.INSTANCE:new b(A,z,_)}cmp(A){return A.type!==this.type?this.type-A.type:O(this.key,this.value,A.key,A.value)}equals(A){return A.type===this.type?this.key===A.key&&this.value===A.value:!1}substituteConstants(){const A=i.get(this.key);if(typeof A=="boolean"){const z=A?"true":"false";return this.value===z?d.INSTANCE:p.INSTANCE}return this}evaluate(A){return A.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(A){return A.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=w.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=b;class g{constructor(A,z){this.key=A,this.negated=z,this.type=3}static create(A,z=null){const _=i.get(A);return typeof _=="boolean"?_?d.INSTANCE:p.INSTANCE:new g(A,z)}cmp(A){return A.type!==this.type?this.type-A.type:T(this.key,A.key)}equals(A){return A.type===this.type?this.key===A.key:!1}substituteConstants(){const A=i.get(this.key);return typeof A=="boolean"?A?d.INSTANCE:p.INSTANCE:this}evaluate(A){return!A.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(A){return A.mapNot(this.key)}negate(){return this.negated||(this.negated=h.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=g;function a(N,A){if(typeof N=="string"){const z=parseFloat(N);isNaN(z)||(N=z)}return typeof N=="string"||typeof N=="number"?A(N):d.INSTANCE}class l{constructor(A,z,_){this.key=A,this.value=z,this.negated=_,this.type=12}static create(A,z,_=null){return a(z,M=>new l(A,M,_))}cmp(A){return A.type!==this.type?this.type-A.type:O(this.key,this.value,A.key,A.value)}equals(A){return A.type===this.type?this.key===A.key&&this.value===A.value:!1}substituteConstants(){return this}evaluate(A){return typeof this.value=="string"?!1:parseFloat(A.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(A){return A.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=n.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=l;class r{constructor(A,z,_){this.key=A,this.value=z,this.negated=_,this.type=13}static create(A,z,_=null){return a(z,M=>new r(A,M,_))}cmp(A){return A.type!==this.type?this.type-A.type:O(this.key,this.value,A.key,A.value)}equals(A){return A.type===this.type?this.key===A.key&&this.value===A.value:!1}substituteConstants(){return this}evaluate(A){return typeof this.value=="string"?!1:parseFloat(A.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(A){return A.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=o.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=r;class o{constructor(A,z,_){this.key=A,this.value=z,this.negated=_,this.type=14}static create(A,z,_=null){return a(z,M=>new o(A,M,_))}cmp(A){return A.type!==this.type?this.type-A.type:O(this.key,this.value,A.key,A.value)}equals(A){return A.type===this.type?this.key===A.key&&this.value===A.value:!1}substituteConstants(){return this}evaluate(A){return typeof this.value=="string"?!1:parseFloat(A.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(A){return A.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=r.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=o;class n{constructor(A,z,_){this.key=A,this.value=z,this.negated=_,this.type=15}static create(A,z,_=null){return a(z,M=>new n(A,M,_))}cmp(A){return A.type!==this.type?this.type-A.type:O(this.key,this.value,A.key,A.value)}equals(A){return A.type===this.type?this.key===A.key&&this.value===A.value:!1}substituteConstants(){return this}evaluate(A){return typeof this.value=="string"?!1:parseFloat(A.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(A){return A.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=l.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=n;class t{constructor(A,z){this.key=A,this.regexp=z,this.type=7,this.negated=null}static create(A,z){return new t(A,z)}cmp(A){if(A.type!==this.type)return this.type-A.type;if(this.key<A.key)return-1;if(this.key>A.key)return 1;const z=this.regexp?this.regexp.source:"",_=A.regexp?A.regexp.source:"";return z<_?-1:z>_?1:0}equals(A){if(A.type===this.type){const z=this.regexp?this.regexp.source:"",_=A.regexp?A.regexp.source:"";return this.key===A.key&&z===_}return!1}substituteConstants(){return this}evaluate(A){let z=A.getValue(this.key);return this.regexp?this.regexp.test(z):!1}serialize(){const A=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${A}`}keys(){return[this.key]}map(A){return A.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=s.create(this)),this.negated}}e.ContextKeyRegexExpr=t;class s{constructor(A){this._actual=A,this.type=8}static create(A){return new s(A)}cmp(A){return A.type!==this.type?this.type-A.type:this._actual.cmp(A._actual)}equals(A){return A.type===this.type?this._actual.equals(A._actual):!1}substituteConstants(){return this}evaluate(A){return!this._actual.evaluate(A)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(A){return new s(this._actual.map(A))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=s;function c(N){let A=null;for(let z=0,_=N.length;z<_;z++){const M=N[z].substituteConstants();if(N[z]!==M&&A===null){A=[];for(let q=0;q<z;q++)A[q]=N[q]}A!==null&&(A[z]=M)}return A===null?N:A}class u{constructor(A,z){this.expr=A,this.negated=z,this.type=6}static create(A,z){return u._normalizeArr(A,z)}cmp(A){if(A.type!==this.type)return this.type-A.type;if(this.expr.length<A.expr.length)return-1;if(this.expr.length>A.expr.length)return 1;for(let z=0,_=this.expr.length;z<_;z++){const M=E(this.expr[z],A.expr[z]);if(M!==0)return M}return 0}equals(A){if(A.type===this.type){if(this.expr.length!==A.expr.length)return!1;for(let z=0,_=this.expr.length;z<_;z++)if(!this.expr[z].equals(A.expr[z]))return!1;return!0}return!1}substituteConstants(){const A=c(this.expr);return A===this.expr?this:u.create(A,this.negated)}evaluate(A){for(let z=0,_=this.expr.length;z<_;z++)if(!this.expr[z].evaluate(A))return!1;return!0}static _normalizeArr(A,z){const _=[];let M=!1;for(const q of A)if(!!q){if(q.type===1){M=!0;continue}if(q.type===0)return d.INSTANCE;if(q.type===6){_.push(...q.expr);continue}_.push(q)}if(_.length===0&&M)return p.INSTANCE;if(_.length!==0){if(_.length===1)return _[0];_.sort(E);for(let q=1;q<_.length;q++)_[q-1].equals(_[q])&&(_.splice(q,1),q--);if(_.length===1)return _[0];for(;_.length>1;){const q=_[_.length-1];if(q.type!==9)break;_.pop();const B=_.pop(),j=_.length===0,$=f.create(q.expr.map(K=>u.create([K,B],null)),null,j);$&&(_.push($),_.sort(E))}return _.length===1?_[0]:new u(_,z)}}serialize(){return this.expr.map(A=>A.serialize()).join(" && ")}keys(){const A=[];for(let z of this.expr)A.push(...z.keys());return A}map(A){return new u(this.expr.map(z=>z.map(A)),null)}negate(){if(!this.negated){const A=[];for(let z of this.expr)A.push(z.negate());this.negated=f.create(A,this,!0)}return this.negated}}class f{constructor(A,z){this.expr=A,this.negated=z,this.type=9}static create(A,z,_){return f._normalizeArr(A,z,_)}cmp(A){if(A.type!==this.type)return this.type-A.type;if(this.expr.length<A.expr.length)return-1;if(this.expr.length>A.expr.length)return 1;for(let z=0,_=this.expr.length;z<_;z++){const M=E(this.expr[z],A.expr[z]);if(M!==0)return M}return 0}equals(A){if(A.type===this.type){if(this.expr.length!==A.expr.length)return!1;for(let z=0,_=this.expr.length;z<_;z++)if(!this.expr[z].equals(A.expr[z]))return!1;return!0}return!1}substituteConstants(){const A=c(this.expr);return A===this.expr?this:f.create(A,this.negated,!1)}evaluate(A){for(let z=0,_=this.expr.length;z<_;z++)if(this.expr[z].evaluate(A))return!0;return!1}static _normalizeArr(A,z,_){let M=[],q=!1;if(A){for(let B=0,j=A.length;B<j;B++){const $=A[B];if(!!$){if($.type===0){q=!0;continue}if($.type===1)return p.INSTANCE;if($.type===9){M=M.concat($.expr);continue}M.push($)}}if(M.length===0&&q)return d.INSTANCE;M.sort(E)}if(M.length!==0){if(M.length===1)return M[0];for(let B=1;B<M.length;B++)M[B-1].equals(M[B])&&(M.splice(B,1),B--);if(M.length===1)return M[0];if(_){for(let B=0;B<M.length;B++)for(let j=B+1;j<M.length;j++)U(M[B],M[j])&&(M.splice(j,1),j--);if(M.length===1)return M[0]}return new f(M,z)}}serialize(){return this.expr.map(A=>A.serialize()).join(" || ")}keys(){const A=[];for(let z of this.expr)A.push(...z.keys());return A}map(A){return new f(this.expr.map(z=>z.map(A)),null)}negate(){if(!this.negated){let A=[];for(let z of this.expr)A.push(z.negate());for(;A.length>1;){const z=A.shift(),_=A.shift(),M=[];for(const B of W(z))for(const j of W(_))M.push(u.create([B,j],null));const q=A.length===0;A.unshift(f.create(M,null,q))}this.negated=A[0]}return this.negated}}class v extends h{constructor(A,z,_){super(A,null);this._defaultValue=z,typeof _=="object"?v._info.push({..._,key:A}):_!==!0&&v._info.push({key:A,description:_,type:z!=null?typeof z:void 0})}static all(){return v._info.values()}bindTo(A){return A.createKey(this.key,this._defaultValue)}getValue(A){return A.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(A){return w.create(this.key,A)}notEqualsTo(A){return b.create(this.key,A)}}e.RawContextKey=v,v._info=[],e.IContextKeyService=(0,D.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function T(N,A){return N<A?-1:N>A?1:0}function O(N,A,z,_){return N<z?-1:N>z?1:A<_?-1:A>_?1:0}function U(N,A){if(A.type===6&&N.type!==9&&N.type!==6){for(const M of A.expr)if(N.equals(M))return!0}const z=N.negate(),_=W(z).concat(W(A));_.sort(E);for(let M=0;M<_.length;M++){const B=_[M].negate();for(let j=M+1;j<_.length;j++){const $=_[j];if(B.equals($))return!0}}return!1}e.implies=U;function W(N){return N.type===9?N.expr:[N]}}),define(te[78],ne([0,1,6]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,R.createDecorator)(e.ID);function L(D){return!!D.hostName&&!!D.errorMessage}e.isRemoteDiagnosticError=L}),define(te[79],ne([0,1,6]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,R.createDecorator)("downloadService")}),define(te[11],ne([0,1,6]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,R.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,R.refineServiceDecorator)(e.IEnvironmentService)}),define(te[30],ne([0,1,15,131,6]),function(X,e,R,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.TargetPlatform=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";var k;(function(g){g.WIN32_X64="win32-x64",g.WIN32_IA32="win32-ia32",g.WIN32_ARM64="win32-arm64",g.LINUX_X64="linux-x64",g.LINUX_ARM64="linux-arm64",g.LINUX_ARMHF="linux-armhf",g.ALPINE_X64="alpine-x64",g.ALPINE_ARM64="alpine-arm64",g.DARWIN_X64="darwin-x64",g.DARWIN_ARM64="darwin-arm64",g.WEB="web",g.UNIVERSAL="universal",g.UNKNOWN="unknown",g.UNDEFINED="undefined"})(k=e.TargetPlatform||(e.TargetPlatform={}));function i(g){switch(g){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=i;function P(g){switch(g){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=P;function S(g,a){switch(g){case 3:return a==="x64"?"win32-x64":a==="ia32"?"win32-ia32":a==="arm64"?"win32-arm64":"unknown";case 2:return a==="x64"?"linux-x64":a==="arm64"?"linux-arm64":a==="arm"?"linux-armhf":"unknown";case"alpine":return a==="x64"?"alpine-x64":a==="arm64"?"alpine-arm64":"unknown";case 1:return a==="x64"?"darwin-x64":a==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=S;function C(g,a){return a==="web"&&!g.includes("web")}e.isNotWebExtensionInWebTargetPlatform=C;function I(g,a,l){return C(a,l)?!1:g==="undefined"||g==="universal"?!0:g==="unknown"?!1:g===l?!0:E(l).includes(g)}e.isTargetPlatformCompatible=I;function E(g){switch(g){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=E;function d(g){return g&&typeof g=="object"&&typeof g.id=="string"&&(!g.uuid||typeof g.uuid=="string")}e.isIExtensionIdentifier=d;var p;(function(g){g[g.NoneOrRelevance=0]="NoneOrRelevance",g[g.LastUpdatedDate=1]="LastUpdatedDate",g[g.Title=2]="Title",g[g.PublisherName=3]="PublisherName",g[g.InstallCount=4]="InstallCount",g[g.PublishedDate=10]="PublishedDate",g[g.AverageRating=6]="AverageRating",g[g.WeightedRating=12]="WeightedRating"})(p=e.SortBy||(e.SortBy={}));var h;(function(g){g[g.Default=0]="Default",g[g.Ascending=1]="Ascending",g[g.Descending=2]="Descending"})(h=e.SortOrder||(e.SortOrder={}));var w;(function(g){g.Install="install",g.Uninstall="uninstall"})(w=e.StatisticType||(e.StatisticType={}));var y;(function(g){g[g.None=0]="None",g[g.Install=1]="Install",g[g.Update=2]="Update"})(y=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,D.createDecorator)("extensionGalleryService");var m;(function(g){g.Unsupported="Unsupported",g.Malicious="Malicious",g.Incompatible="Incompatible",g.Invalid="Invalid",g.Download="Download",g.Extract="Extract",g.Delete="Delete",g.Rename="Rename",g.CorruptZip="CorruptZip",g.IncompleteZip="IncompleteZip",g.Internal="Internal"})(m=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class b extends Error{constructor(a,l){super(a);this.code=l,this.name=l}}e.ExtensionManagementError=b,e.IExtensionManagementService=(0,D.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,D.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,D.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=R.FileAccess.asBrowserUri("./media/defaultIcon.png",X).toString(!0),e.ExtensionsLabel=(0,L.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,L.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,D.createDecorator)("IExtensionManagementCLIService")});var J=this&&this.__param||function(X,e){return function(R,L){e(R,L,X)}};define(te[161],ne([0,1,2,30]),function(X,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DeprecatedExtensionsCleaner=void 0;let D=class extends R.Disposable{constructor(i){super();this.extensionManagementService=i,this._register(i),this.cleanUpDeprecatedExtensions()}cleanUpDeprecatedExtensions(){this.extensionManagementService.removeDeprecatedExtensions()}};D=he([J(0,L.IExtensionManagementService)],D),e.DeprecatedExtensionsCleaner=D}),define(te[162],ne([0,1,3,2,28,7,110,30]),function(X,e,R,L,D,k,i,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function S(w,y){return k.URI.revive(y?y.transformIncoming(w):w)}function C(w,y){return y?y.transformOutgoingURI(w):w}function I(w,y){y=y||i.DefaultURITransformer;const m=w.manifest;return{...(0,i.transformAndReviveIncomingURIs)({...w,manifest:void 0},y),manifest:m}}function E(w,y){return y?(0,D.cloneAndChange)(w,m=>m instanceof k.URI?y.transformOutgoingURI(m):void 0):w}class d{constructor(y,m){this.service=y,this.getUriTransformer=m,this.onInstallExtension=R.Event.buffer(y.onInstallExtension,!0),this.onDidInstallExtensions=R.Event.buffer(y.onDidInstallExtensions,!0),this.onUninstallExtension=R.Event.buffer(y.onUninstallExtension,!0),this.onDidUninstallExtension=R.Event.buffer(y.onDidUninstallExtension,!0)}listen(y,m){const b=this.getUriTransformer(y);switch(m){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtensions":return R.Event.map(this.onDidInstallExtensions,g=>g.map(a=>({...a,local:a.local?E(a.local,b):a.local})));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(y,m,b){const g=this.getUriTransformer(y);switch(m){case"zip":return this.service.zip(I(b[0],g)).then(a=>C(a,g));case"unzip":return this.service.unzip(S(b[0],g));case"install":return this.service.install(S(b[0],g),b[1]);case"getManifest":return this.service.getManifest(S(b[0],g));case"getTargetPlatform":return this.service.getTargetPlatform();case"canInstall":return this.service.canInstall(b[0]);case"installFromGallery":return this.service.installFromGallery(b[0],b[1]);case"uninstall":return this.service.uninstall(I(b[0],g),b[1]);case"reinstallFromGallery":return this.service.reinstallFromGallery(I(b[0],g));case"getInstalled":return this.service.getInstalled(b[0]).then(a=>a.map(l=>E(l,g)));case"updateMetadata":return this.service.updateMetadata(I(b[0],g),b[1]).then(a=>E(a,g));case"updateExtensionScope":return this.service.updateExtensionScope(I(b[0],g),b[1]).then(a=>E(a,g));case"getExtensionsReport":return this.service.getExtensionsReport()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=d;class p extends L.Disposable{constructor(y){super();this.channel=y,this._onInstallExtension=this._register(new R.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new R.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new R.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new R.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this._register(this.channel.listen("onInstallExtension")(m=>this._onInstallExtension.fire({identifier:m.identifier,source:this.isUriComponents(m.source)?k.URI.revive(m.source):m.source}))),this._register(this.channel.listen("onDidInstallExtensions")(m=>this._onDidInstallExtensions.fire(m.map(b=>({...b,local:b.local?I(b.local,null):b.local,source:this.isUriComponents(b.source)?k.URI.revive(b.source):b.source}))))),this._register(this.channel.listen("onUninstallExtension")(m=>this._onUninstallExtension.fire(m))),this._register(this.channel.listen("onDidUninstallExtension")(m=>this._onDidUninstallExtension.fire(m)))}isUriComponents(y){return y?typeof y.path=="string"&&typeof y.scheme=="string":!1}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=this.channel.call("getTargetPlatform")),this._targetPlatformPromise}async canInstall(y){const m=await this.getTargetPlatform();return y.allTargetPlatforms.some(b=>(0,P.isTargetPlatformCompatible)(b,y.allTargetPlatforms,m))}zip(y){return Promise.resolve(this.channel.call("zip",[y]).then(m=>k.URI.revive(m)))}unzip(y){return Promise.resolve(this.channel.call("unzip",[y]))}install(y,m){return Promise.resolve(this.channel.call("install",[y,m])).then(b=>I(b,null))}getManifest(y){return Promise.resolve(this.channel.call("getManifest",[y]))}installFromGallery(y,m){return Promise.resolve(this.channel.call("installFromGallery",[y,m])).then(b=>I(b,null))}uninstall(y,m){return Promise.resolve(this.channel.call("uninstall",[y,m]))}reinstallFromGallery(y){return Promise.resolve(this.channel.call("reinstallFromGallery",[y]))}getInstalled(y=null){return Promise.resolve(this.channel.call("getInstalled",[y])).then(m=>m.map(b=>I(b,null)))}updateMetadata(y,m){return Promise.resolve(this.channel.call("updateMetadata",[y,m])).then(b=>I(b,null))}updateExtensionScope(y,m){return Promise.resolve(this.channel.call("updateExtensionScope",[y,m])).then(b=>I(b,null))}getExtensionsReport(){return Promise.resolve(this.channel.call("getExtensionsReport"))}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=p;class h{constructor(y){this.service=y}listen(y,m){throw new Error("Invalid listen")}call(y,m,b){switch(m){case"getConfigBasedTips":return this.service.getConfigBasedTips(k.URI.revive(b[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips();case"getAllWorkspacesTips":return this.service.getAllWorkspacesTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=h}),define(te[80],ne([0,1,6]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSourceToString=e.RecommendationSource=void 0;var L;(function(i){i[i.FILE=1]="FILE",i[i.WORKSPACE=2]="WORKSPACE",i[i.EXE=3]="EXE"})(L=e.RecommendationSource||(e.RecommendationSource={}));function D(i){switch(i){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.RecommendationSourceToString=D;var k;(function(i){i.Ignored="ignored",i.Cancelled="cancelled",i.TooMany="toomany",i.IncompatibleWindow="incompatibleWindow",i.Accepted="reacted"})(k=e.RecommendationsNotificationResult||(e.RecommendationsNotificationResult={})),e.IExtensionRecommendationNotificationService=(0,R.createDecorator)("IExtensionRecommendationNotificationService")}),define(te[14],ne([0,1,41,10,25,17,7,138,6]),function(X,e,R,L,D,k,i,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,S.createDecorator)("fileService");function C(_){return _.create===!0}e.isFileOpenForWriteOptions=C;var I;(function(_){_[_.Unknown=0]="Unknown",_[_.File=1]="File",_[_.Directory=2]="Directory",_[_.SymbolicLink=64]="SymbolicLink"})(I=e.FileType||(e.FileType={}));var E;(function(_){_[_.Readonly=1]="Readonly"})(E=e.FilePermission||(e.FilePermission={}));var d;(function(_){_[_.FileReadWrite=2]="FileReadWrite",_[_.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",_[_.FileReadStream=16]="FileReadStream",_[_.FileFolderCopy=8]="FileFolderCopy",_[_.PathCaseSensitive=1024]="PathCaseSensitive",_[_.Readonly=2048]="Readonly",_[_.Trash=4096]="Trash",_[_.FileWriteUnlock=8192]="FileWriteUnlock"})(d=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function p(_){return!!(_.capabilities&2)}e.hasReadWriteCapability=p;function h(_){return!!(_.capabilities&8)}e.hasFileFolderCopyCapability=h;function w(_){return!!(_.capabilities&4)}e.hasOpenReadWriteCloseCapability=w;function y(_){return!!(_.capabilities&16)}e.hasFileReadStreamCapability=y;var m;(function(_){_.FileExists="EntryExists",_.FileNotFound="EntryNotFound",_.FileNotADirectory="EntryNotADirectory",_.FileIsADirectory="EntryIsADirectory",_.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",_.FileTooLarge="EntryTooLarge",_.FileWriteLocked="EntryWriteLocked",_.NoPermissions="NoPermissions",_.Unavailable="Unavailable",_.Unknown="Unknown"})(m=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class b extends Error{constructor(M,q){super(M);this.code=q}}e.FileSystemProviderError=b;function g(_,M){const q=new b(_.toString(),M);return l(q,M),q}e.createFileSystemProviderError=g;function a(_){return _||g((0,P.localize)(0,null),m.Unknown)}e.ensureFileSystemProviderError=a;function l(_,M){return _.name=M?`${M} (FileSystemError)`:"FileSystemError",_}e.markAsFileSystemProviderError=l;function r(_){if(!_)return m.Unknown;if(_ instanceof b)return _.code;const M=/^(.+) \(FileSystemError\)$/.exec(_.name);if(!M)return m.Unknown;switch(M[1]){case m.FileExists:return m.FileExists;case m.FileIsADirectory:return m.FileIsADirectory;case m.FileNotADirectory:return m.FileNotADirectory;case m.FileNotFound:return m.FileNotFound;case m.FileExceedsMemoryLimit:return m.FileExceedsMemoryLimit;case m.FileTooLarge:return m.FileTooLarge;case m.FileWriteLocked:return m.FileWriteLocked;case m.NoPermissions:return m.NoPermissions;case m.Unavailable:return m.Unavailable}return m.Unknown}e.toFileSystemProviderErrorCode=r;function o(_){if(_ instanceof f)return _.fileOperationResult;switch(r(_)){case m.FileNotFound:return 1;case m.FileIsADirectory:return 0;case m.FileNotADirectory:return 10;case m.FileWriteLocked:return 5;case m.NoPermissions:return 6;case m.FileExists:return 4;case m.FileExceedsMemoryLimit:return 9;case m.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=o;var n;(function(_){_[_.CREATE=0]="CREATE",_[_.DELETE=1]="DELETE",_[_.MOVE=2]="MOVE",_[_.COPY=3]="COPY"})(n=e.FileOperation||(e.FileOperation={}));class t{constructor(M,q,B){this.resource=M,this.operation=q,this.target=B}isOperation(M){return this.operation===M}}e.FileOperationEvent=t;var s;(function(_){_[_.UPDATED=0]="UPDATED",_[_.ADDED=1]="ADDED",_[_.DELETED=2]="DELETED"})(s=e.FileChangeType||(e.FileChangeType={}));class c{constructor(M,q){this.added=void 0,this.updated=void 0,this.deleted=void 0;const B=new Map;for(const j of M){const $=B.get(j.type);$?$.push([j.resource,j]):B.set(j.type,[[j.resource,j]])}for(const[j,$]of B)switch(j){case 1:this.added=R.TernarySearchTree.forUris(()=>q),this.added.fill($);break;case 0:this.updated=R.TernarySearchTree.forUris(()=>q),this.updated.fill($);break;case 2:this.deleted=R.TernarySearchTree.forUris(()=>q),this.deleted.fill($);break}}contains(M,...q){return this.doContains(M,{includeChildren:!1},...q)}affects(M,...q){return this.doContains(M,{includeChildren:!0},...q)}doContains(M,q,...B){if(!M)return!1;const j=B.length>0;return!!((!j||B.includes(1))&&(this.added?.get(M)||q.includeChildren&&this.added?.findSuperstr(M))||(!j||B.includes(0))&&(this.updated?.get(M)||q.includeChildren&&this.updated?.findSuperstr(M))||(!j||B.includes(2))&&(this.deleted?.findSubstr(M)||q.includeChildren&&this.deleted?.findSuperstr(M)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=c;function u(_,M,q){return!_||!M||_===M||M.length>_.length?!1:(M.charAt(M.length-1)!==L.sep&&(M+=L.sep),q?(0,D.startsWithIgnoreCase)(_,M):_.indexOf(M)===0)}e.isParent=u;class f extends Error{constructor(M,q,B){super(M);this.fileOperationResult=q,this.options=B}}e.FileOperationError=f;class v extends f{constructor(M,q,B){super(M,2,B);this.stat=q}}e.NotModifiedSinceFileOperationError=v;var T;(function(_){_[_.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",_[_.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",_[_.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",_[_.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",_[_.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",_[_.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",_[_.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",_[_.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",_[_.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",_[_.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",_[_.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",_[_.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(T=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var O;(function(_){_[_.FILE=0]="FILE",_[_.FOLDER=1]="FOLDER",_[_.ROOT_FOLDER=2]="ROOT_FOLDER"})(O=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function U(_){if(!(typeof _.size!="number"||typeof _.mtime!="number"))return _.mtime.toString(29)+_.size.toString(31)}e.etag=U;async function W(_,M){if(!M.hasProvider(i.URI.from({scheme:_.scheme})))return new Promise(q=>{const B=M.onDidChangeFileSystemProviderRegistrations(j=>{j.scheme===_.scheme&&j.added&&(B.dispose(),q())})})}e.whenProviderRegistered=W,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class N{static formatSize(M){return(0,k.isNumber)(M)||(M=0),M<N.KB?(0,P.localize)(1,null,M.toFixed(0)):M<N.MB?(0,P.localize)(2,null,(M/N.KB).toFixed(2)):M<N.GB?(0,P.localize)(3,null,(M/N.MB).toFixed(2)):M<N.TB?(0,P.localize)(4,null,(M/N.GB).toFixed(2)):(0,P.localize)(5,null,(M/N.TB).toFixed(2))}}e.ByteSize=N,N.KB=1024,N.MB=N.KB*N.KB,N.GB=N.MB*N.KB,N.TB=N.GB*N.KB;var A;(function(_){_[_.IA32=0]="IA32",_[_.OTHER=1]="OTHER"})(A=e.Arch||(e.Arch={}));function z(_){return{maxFileSize:_===0?300*N.MB:16*N.GB,maxHeapSize:_===0?700*N.MB:2*700*N.MB}}e.getPlatformLimits=z}),define(te[163],ne([0,1,81,50,14]),function(X,e,R,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let k=class{constructor(P){this.fileService=P}async checksum(P){const S=(await this.fileService.readFileStream(P)).value;return new Promise((C,I)=>{const E=(0,R.createHash)("md5");(0,L.listenStream)(S,{onData:d=>E.update(d.buffer),onError:d=>I(d),onEnd:()=>C(E.digest("base64").replace(/=+$/,""))})})}};k=he([J(0,D.IFileService)],k),e.ChecksumService=k}),define(te[164],ne([0,1,246,128,151,14]),function(X,e,R,L,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;function i(d,p){const h={onUnknownOption:y=>{console.warn((0,L.localize)(0,null,y))},onMultipleValues:(y,m)=>{console.warn((0,L.localize)(1,null,y,m))}},w=(0,D.parseArgs)(d,D.OPTIONS,p?h:void 0);return w.goto&&w._.forEach(y=>R(/^(\w:)?[^:]+(:\d*){0,2}$/.test(y),(0,L.localize)(2,null))),w["max-memory"]&&R(parseInt(w["max-memory"])>=k.MIN_MAX_MEMORY_SIZE_MB,`The max-memory argument cannot be specified lower than ${k.MIN_MAX_MEMORY_SIZE_MB} MB.`),w}function P(d){const p=d.findIndex(h=>!/^-/.test(h));if(p>-1)return[...d.slice(0,p),...d.slice(p+1)]}function S(d){let[,...p]=d;process.env.VSCODE_DEV&&(p=P(p)||[]);const h=!E(process.env);return i(p,h)}e.parseMainProcessArgv=S;function C(d){const[,,...p]=d;return i(p,!0)}e.parseCLIProcessArgv=C;function I(d,...p){const h=d.indexOf("--");return h===-1?d.push(...p):d.splice(h,0,...p),d}e.addArg=I;function E(d){return d.VSCODE_CLI==="1"}e.isLaunchedFromCli=E}),define(te[165],ne([0,1,45,10,129,27,38,9,4,29,124,164,5]),function(X,e,R,L,D,k,i,P,S,C,I,E,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveShellEnv=void 0;const p=1e4;let h;async function w(m,b,g){return b["force-disable-user-env"]?(m.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):S.isWindows?(m.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,E.isLaunchedFromCli)(g)&&!b["force-user-env"]?(m.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,E.isLaunchedFromCli)(g)?m.trace("resolveShellEnv(): running (--force-user-env)"):m.trace("resolveShellEnv(): running (macOS/Linux)"),h||(h=d.Promises.withAsyncBody(async(a,l)=>{const r=new k.CancellationTokenSource,o=setTimeout(()=>{r.dispose(!0),l(new Error((0,D.localize)(0,null)))},p);try{a(await y(m,r.token))}catch(n){!(0,P.isPromiseCanceledError)(n)&&!r.token.isCancellationRequested?l(new Error((0,D.localize)(1,null,(0,i.toErrorMessage)(n)))):a({})}finally{clearTimeout(o),r.dispose()}})),h)}e.resolveShellEnv=w;async function y(m,b){const g=process.env.ELECTRON_RUN_AS_NODE;m.trace("getUnixShellEnvironment#runAsNode",g);const a=process.env.ELECTRON_NO_ATTACH_CONSOLE;m.trace("getUnixShellEnvironment#noAttach",a);const l=(0,C.generateUuid)().replace(/-/g,"").substr(0,12),r=new RegExp(l+"(.*)"+l),o={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};m.trace("getUnixShellEnvironment#env",o);const n=await(0,I.getSystemShell)(S.OS,o);return m.trace("getUnixShellEnvironment#shell",n),new Promise((t,s)=>{if(b.isCancellationRequested)return s((0,P.canceled)());const c=(0,L.basename)(n);let u,f;const v=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(c)?(u=`& '${process.execPath}' ${v} -p '''${l}'' + JSON.stringify(process.env) + ''${l}'''`,f=["-Login","-Command"]):(u=`'${process.execPath}' ${v} -p '"${l}" + JSON.stringify(process.env) + "${l}"'`,c==="tcsh"?f=["-ic"]:f=["-ilc"]),m.trace("getUnixShellEnvironment#spawn",JSON.stringify(f),u);const T=(0,R.spawn)(n,[...f,u],{detached:!0,stdio:["ignore","pipe","pipe"],env:o});b.onCancellationRequested(()=>(T.kill(),s((0,P.canceled)()))),T.on("error",W=>{m.error("getUnixShellEnvironment#errorChildProcess",(0,i.toErrorMessage)(W)),s(W)});const O=[];T.stdout.on("data",W=>O.push(W));const U=[];T.stderr.on("data",W=>U.push(W)),T.on("close",(W,N)=>{const A=Buffer.concat(O).toString("utf8");m.trace("getUnixShellEnvironment#raw",A);const z=Buffer.concat(U).toString("utf8");if(z.trim()&&m.trace("getUnixShellEnvironment#stderr",z),W||N)return s(new Error((0,D.localize)(2,null,W,N)));const _=r.exec(A),M=_?_[1]:"{}";try{const q=JSON.parse(M);g?q.ELECTRON_RUN_AS_NODE=g:delete q.ELECTRON_RUN_AS_NODE,a?q.ELECTRON_NO_ATTACH_CONSOLE=a:delete q.ELECTRON_NO_ATTACH_CONSOLE,delete q.XDG_RUNTIME_DIR,m.trace("getUnixShellEnvironment#result",q),t(q)}catch(q){m.error("getUnixShellEnvironment#errorCaught",(0,i.toErrorMessage)(q)),s(q)}})})}}),define(te[82],ne([0,1,19,9,139,14]),function(X,e,R,L,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function i(I,E,d,p,h,w){let y;try{await P(I,E,d,p,h,w)}catch(m){y=m}finally{y&&h.errorTransformer&&(y=h.errorTransformer(y)),typeof y!="undefined"&&d.error(y),d.end()}}e.readFileIntoStream=i;async function P(I,E,d,p,h,w){S(w);const y=await I.open(E,{create:!1});try{S(w);let m=0,b=0,g=h&&typeof h.length=="number"?h.length:void 0,a=R.VSBuffer.alloc(Math.min(h.bufferSize,typeof g=="number"?g:h.bufferSize)),l=h&&typeof h.position=="number"?h.position:0,r=0;do b=await I.read(y,l,a.buffer,r,a.byteLength-r),l+=b,r+=b,m+=b,typeof g=="number"&&(g-=b),r===a.byteLength&&(await d.write(p(a)),a=R.VSBuffer.alloc(Math.min(h.bufferSize,typeof g=="number"?g:h.bufferSize)),r=0);while(b>0&&(typeof g!="number"||g>0)&&S(w)&&C(m,h));if(r>0){let o=r;typeof g=="number"&&(o=Math.min(r,g)),d.write(p(a.slice(0,o)))}}catch(m){throw(0,k.ensureFileSystemProviderError)(m)}finally{await I.close(y)}}function S(I){if(I.isCancellationRequested)throw(0,L.canceled)();return!0}function C(I,E){if(E?.limits){if(typeof E.limits.memory=="number"&&I>E.limits.memory)throw(0,k.createFileSystemProviderError)((0,D.localize)(0,null),k.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof E.limits.size=="number"&&I>E.limits.size)throw(0,k.createFileSystemProviderError)((0,D.localize)(1,null),k.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(te[54],ne([0,1,2,4,7,14]),function(X,e,R,L,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.coalesceEvents=e.toFileChanges=e.WatcherService=e.AbstractWatcherService=void 0;class i extends R.Disposable{constructor(d,p,h){super();this.onFileChanges=d,this.onLogMessage=p,this.verboseLogging=h,this.serviceDisposables=this._register(new R.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const d=new R.DisposableStore;this.serviceDisposables.value=d,this.service=this.createService(d),this.service.setVerboseLogging(this.verboseLogging),d.add(this.service.onDidChangeFile(p=>this.onFileChanges(p))),d.add(this.service.onDidLogMessage(p=>this.onLogMessage(p))),d.add(this.service.onDidError(p=>this.onError(p)))}onError(d){this.restartCounter<i.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${d}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${d}`)}restart(d){this.restartCounter++,this.init(),this.watch(d)}async watch(d){this.requests=d,await this.service?.watch(d)}async setVerboseLogging(d){this.verboseLogging=d,await this.service?.setVerboseLogging(d)}error(d){this.onLogMessage({type:"error",message:`[File Watcher (parcel)] ${d}`})}dispose(){return this.service=void 0,super.dispose()}}e.AbstractWatcherService=i,i.MAX_RESTARTS=5;class P extends R.Disposable{}e.WatcherService=P;function S(E){return E.map(d=>({type:d.type,resource:D.URI.file(d.path)}))}e.toFileChanges=S;function C(E){const d=new I;for(const p of E)d.processEvent(p);return d.coalesce()}e.coalesceEvents=C;class I{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(d){return L.isLinux?d.path:d.path.toLowerCase()}processEvent(d){const p=this.mapPathToChange.get(this.toKey(d));let h=!1;if(p){const w=p.type,y=d.type;p.path!==d.path&&d.type===2?h=!0:w===1&&y===2?(this.mapPathToChange.delete(this.toKey(d)),this.coalesced.delete(p)):w===2&&y===1?p.type=0:w===1&&y===0||(p.type=y)}else h=!0;h&&(this.coalesced.add(d),this.mapPathToChange.set(this.toKey(d),d))}coalesce(){const d=[],p=[];return Array.from(this.coalesced).filter(h=>h.type!==2?(d.push(h),!1):!0).sort((h,w)=>h.path.length-w.path.length).filter(h=>p.some(w=>(0,k.isParent)(h.path,w,!L.isLinux))?!1:(p.push(h.path),!0)).concat(d)}}}),define(te[166],ne([0,1,5,2,10,114,20,117,54]),function(X,e,R,L,D,k,i,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class C extends L.Disposable{constructor(E,d,p,h){super();this.path=E,this.onDidFilesChange=d,this.onLogMessage=p,this.verboseLogging=h,this.fileChangesDelayer=this._register(new R.ThrottledDelayer(P.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(E){this.verboseLogging=E}async startWatching(){try{const{stat:E,symbolicLink:d}=await i.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let p=this.path;if(d)try{p=await(0,k.realpath)(p)}catch(h){if(this.onError(h),d.dangling)return}E.isDirectory()?this._register((0,P.watchFolder)(p,(h,w)=>{this.onFileChange({type:h==="changed"?0:h==="added"?1:2,path:(0,D.join)(this.path,(0,D.basename)(w))})},h=>this.onError(h))):this._register((0,P.watchFile)(p,h=>{this.onFileChange({type:h==="changed"?0:2,path:this.path})},h=>this.onError(h)))}catch(E){E.code!=="ENOENT"&&this.onError(E)}}onFileChange(E){this.fileChangesBuffer.push(E),this.verboseLogging&&this.onVerbose(`${E.type===1?"[ADDED]":E.type===2?"[DELETED]":"[CHANGED]"} ${E.path}`),this.fileChangesDelayer.trigger(async()=>{const d=this.fileChangesBuffer;this.fileChangesBuffer=[];const p=(0,S.coalesceEvents)(d);if(this.verboseLogging)for(const h of p)this.onVerbose(`>> normalized ${h.type===1?"[ADDED]":h.type===2?"[DELETED]":"[CHANGED]"} ${h.path}`);p.length>0&&this.onDidFilesChange(p)})}onError(E){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${E}`})}onVerbose(E){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${E}`})}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=C}),define(te[167],ne([0,1,15,34,52,54]),function(X,e,R,L,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class i extends k.WatcherService{constructor(S,C,I){super();this.onDidFilesChange=S,this.onLogMessage=C,this.verboseLogging=I,this.isDisposed=!1,this.startWatching()}startWatching(){const S=this._register(new D.Client(R.FileAccess.asFileUri("bootstrap-fork",X).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherServiceNSFW"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this.service=L.ProxyChannel.toService((0,L.getNextTickChannel)(S.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(C=>!this.isDisposed&&this.onDidFilesChange(C))),this._register(this.service.onDidLogMessage(C=>this.onLogMessage(C)))}async setVerboseLogging(S){this.verboseLogging=S,this.isDisposed||await this.service?.setVerboseLogging(S)}error(S){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${S}`})}async watch(S){this.isDisposed||await this.service?.watch(S)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=i}),define(te[168],ne([0,1,15,34,52,54]),function(X,e,R,L,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class i extends k.AbstractWatcherService{constructor(S,C,I){super(S,C,I);this.init()}createService(S){const C=S.add(new D.Client(R.FileAccess.asFileUri("bootstrap-fork",X).fsPath,{serverName:"File Watcher (parcel, node.js)",args:["--type=watcherServiceParcel"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/parcel/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return S.add(C.onDidProcessExit(({code:I,signal:E})=>this.onError(`terminated by itself with code ${I}, signal: ${E}`))),L.ProxyChannel.toService((0,L.getNextTickChannel)(C.getChannel("watcher")))}}e.FileWatcher=i}),define(te[83],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class R{constructor(...D){this._entries=new Map;for(let[k,i]of D)this.set(k,i)}set(D,k){const i=this._entries.get(D);return this._entries.set(D,k),i}has(D){return this._entries.has(D)}get(D){return this._entries.get(D)}}e.ServiceCollection=R}),define(te[169],ne([0,1,5,9,53,158,6,83]),function(X,e,R,L,D,k,i,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const S=!1;class C extends Error{constructor(h){super("cyclic dependency between services");this.message=h.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${h.toString()}`}}class I{constructor(h=new P.ServiceCollection,w=!1,y){this._activeInstantiations=new Set,this._services=h,this._strict=w,this._parent=y,this._services.set(i.IInstantiationService,this)}createChild(h){return new I(h,this._strict,this)}invokeFunction(h,...w){let y=d.traceInvocation(h),m=!1;try{return h({get:g=>{if(m)throw(0,L.illegalState)("service accessor is only valid during the invocation of its target method");const a=this._getOrCreateServiceInstance(g,y);if(!a)throw new Error(`[invokeFunction] unknown service '${g}'`);return a}},...w)}finally{m=!0,y.stop()}}createInstance(h,...w){let y,m;return h instanceof D.SyncDescriptor?(y=d.traceCreation(h.ctor),m=this._createInstance(h.ctor,h.staticArguments.concat(w),y)):(y=d.traceCreation(h),m=this._createInstance(h,w,y)),y.stop(),m}_createInstance(h,w=[],y){let m=i._util.getServiceDependencies(h).sort((a,l)=>a.index-l.index),b=[];for(const a of m){let l=this._getOrCreateServiceInstance(a.id,y);if(!l&&this._strict&&!a.optional)throw new Error(`[createInstance] ${h.name} depends on UNKNOWN service ${a.id}.`);b.push(l)}let g=m.length>0?m[0].index:w.length;if(w.length!==g){console.warn(`[createInstance] First service dependency of ${h.name} at position ${g+1} conflicts with ${w.length} static arguments`);let a=g-w.length;a>0?w=w.concat(new Array(a)):w=w.slice(0,g)}return new h(...[...w,...b])}_setServiceInstance(h,w){if(this._services.get(h)instanceof D.SyncDescriptor)this._services.set(h,w);else if(this._parent)this._parent._setServiceInstance(h,w);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(h){let w=this._services.get(h);return!w&&this._parent?this._parent._getServiceInstanceOrDescriptor(h):w}_getOrCreateServiceInstance(h,w){let y=this._getServiceInstanceOrDescriptor(h);return y instanceof D.SyncDescriptor?this._safeCreateAndCacheServiceInstance(h,y,w.branch(h,!0)):(w.branch(h,!1),y)}_safeCreateAndCacheServiceInstance(h,w,y){if(this._activeInstantiations.has(h))throw new Error(`illegal state - RECURSIVELY instantiating service '${h}'`);this._activeInstantiations.add(h);try{return this._createAndCacheServiceInstance(h,w,y)}finally{this._activeInstantiations.delete(h)}}_createAndCacheServiceInstance(h,w,y){const m=new k.Graph(a=>a.id.toString());let b=0;const g=[{id:h,desc:w,_trace:y}];for(;g.length;){const a=g.pop();if(m.lookupOrInsertNode(a),b++>1e3)throw new C(m);for(let l of i._util.getServiceDependencies(a.desc.ctor)){let r=this._getServiceInstanceOrDescriptor(l.id);if(!r&&!l.optional&&console.warn(`[createInstance] ${h} depends on ${l.id} which is NOT registered.`),r instanceof D.SyncDescriptor){const o={id:l.id,desc:r,_trace:a._trace.branch(l.id,!0)};m.insertEdge(a,o),g.push(o)}}}for(;;){const a=m.roots();if(a.length===0){if(!m.isEmpty())throw new C(m);break}for(const{data:l}of a){if(this._getServiceInstanceOrDescriptor(l.id)instanceof D.SyncDescriptor){const o=this._createServiceInstanceWithOwner(l.id,l.desc.ctor,l.desc.staticArguments,l.desc.supportsDelayedInstantiation,l._trace);this._setServiceInstance(l.id,o)}m.removeNode(l)}}return this._getServiceInstanceOrDescriptor(h)}_createServiceInstanceWithOwner(h,w,y=[],m,b){if(this._services.get(h)instanceof D.SyncDescriptor)return this._createServiceInstance(w,y,m,b);if(this._parent)return this._parent._createServiceInstanceWithOwner(h,w,y,m,b);throw new Error(`illegalState - creating UNKNOWN service instance ${w.name}`)}_createServiceInstance(h,w=[],y,m){if(y){const b=new R.IdleValue(()=>this._createInstance(h,w,m));return new Proxy(Object.create(null),{get(g,a){if(a in g)return g[a];let l=b.value,r=l[a];return typeof r!="function"||(r=r.bind(l),g[a]=r),r},set(g,a,l){return b.value[a]=l,!0}})}else return this._createInstance(h,w,m)}}e.InstantiationService=I;var E;(function(p){p[p.Creation=0]="Creation",p[p.Invocation=1]="Invocation",p[p.Branch=2]="Branch"})(E||(E={}));class d{constructor(h,w){this.type=h,this.name=w,this._start=Date.now(),this._dep=[]}static traceInvocation(h){return S?new d(1,h.name||h.toString().substring(0,42).replace(/\n/g,"")):d._None}static traceCreation(h){return S?new d(0,h.name):d._None}branch(h,w){let y=new d(2,h.toString());return this._dep.push([h,w,y]),y}stop(){let h=Date.now()-this._start;d._totals+=h;let w=!1;function y(b,g){let a=[],l=new Array(b+1).join("	");for(const[r,o,n]of g._dep)if(o&&n){w=!0,a.push(`${l}CREATES -> ${r}`);let t=y(b+1,n);t&&a.push(t)}else a.push(`${l}uses -> ${r}`);return a.join(`
`)}let m=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${y(1,this)}`,`DONE, took ${h.toFixed(2)}ms (grand total ${d._totals.toFixed(2)}ms)`];(h>2||w)&&console.log(m.join(`
`))}}d._None=new class extends d{constructor(){super(-1,null)}stop(){}branch(){return this}},d._totals=0}),define(te[170],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MessagePortMainProcessService=void 0;class R{constructor(D,k){this.server=D,this.router=k}getChannel(D){return this.server.getChannel(D,this.router)}registerChannel(D,k){this.server.registerChannel(D,k)}}e.MessagePortMainProcessService=R}),define(te[171],ne([0,1,34,53,77,6]),function(X,e,R,L,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerSharedProcessRemoteService=e.ISharedProcessService=e.registerMainProcessRemoteService=e.IMainProcessService=void 0;class i{constructor(p,h,w){const y=w.getChannel(p);return P(h)?new h.channelClientCtor(y):R.ProxyChannel.toService(y,h?.proxyOptions)}}function P(d){return!!d?.channelClientCtor}e.IMainProcessService=(0,k.createDecorator)("mainProcessService");let S=class extends i{constructor(p,h,w){super(p,h,w)}};S=he([J(2,e.IMainProcessService)],S);function C(d,p,h){(0,D.registerSingleton)(d,new L.SyncDescriptor(S,[p,h],h?.supportsDelayedInstantiation))}e.registerMainProcessRemoteService=C,e.ISharedProcessService=(0,k.createDecorator)("sharedProcessService");let I=class extends i{constructor(p,h,w){super(p,h,w)}};I=he([J(2,e.ISharedProcessService)],I);function E(d,p,h){(0,D.registerSingleton)(d,new L.SyncDescriptor(I,[p,h],h?.supportsDelayedInstantiation))}e.registerSharedProcessRemoteService=E}),define(te[59],ne([0,1,6]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isValidLocalization=e.ILocalizationsService=void 0,e.ILocalizationsService=(0,R.createDecorator)("localizationsService");function L(D){if(typeof D.languageId!="string"||!Array.isArray(D.translations)||D.translations.length===0)return!1;for(const k of D.translations)if(typeof k.id!="string"||typeof k.path!="string")return!1;return!(D.languageName&&typeof D.languageName!="string"||D.localizedLanguageName&&typeof D.localizedLanguageName!="string")}e.isValidLocalization=L}),define(te[172],ne([0,1,2,59]),function(X,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let D=class extends R.Disposable{constructor(i){super();this.localizationsService=i,this.updateLocalizations()}updateLocalizations(){this.localizationsService.update()}};D=he([J(0,L.ILocalizationsService)],D),e.LocalizationsUpdater=D}),define(te[8],ne([0,1,38,3,2,4,6]),function(X,e,R,L,D,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,i.createDecorator)("logService"),e.ILoggerService=(0,i.createDecorator)("loggerService");function P(){return new Date().toISOString()}var S;(function(o){o[o.Trace=0]="Trace",o[o.Debug=1]="Debug",o[o.Info=2]="Info",o[o.Warning=3]="Warning",o[o.Error=4]="Error",o[o.Critical=5]="Critical",o[o.Off=6]="Off"})(S=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=S.Info;function C(o,n,t){switch(n){case S.Trace:o.trace(t);break;case S.Debug:o.debug(t);break;case S.Info:o.info(t);break;case S.Warning:o.warn(t);break;case S.Error:o.error(t);break;case S.Critical:o.critical(t);break;default:throw new Error("Invalid log level")}}e.log=C;function I(o){let n="";for(let t=0;t<o.length;t++){let s=o[t];if(typeof s=="object")try{s=JSON.stringify(s)}catch(c){}n+=(t>0?" ":"")+s}return n}e.format=I;class E extends D.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new L.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(n){this.level!==n&&(this.level=n,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=E;class d extends E{constructor(n){super();this.logAlways=n}checkLogLevel(n){return this.logAlways||this.getLevel()<=n}trace(n,...t){this.checkLogLevel(S.Trace)&&this.log(S.Trace,I([n,...t]))}debug(n,...t){this.checkLogLevel(S.Debug)&&this.log(S.Debug,I([n,...t]))}info(n,...t){this.checkLogLevel(S.Info)&&this.log(S.Info,I([n,...t]))}warn(n,...t){this.checkLogLevel(S.Warning)&&this.log(S.Warning,I([n,...t]))}error(n,...t){if(this.checkLogLevel(S.Error))if(n instanceof Error){const s=Array.prototype.slice.call(arguments);s[0]=n.stack,this.log(S.Error,I(s))}else this.log(S.Error,I([n,...t]))}critical(n,...t){this.checkLogLevel(S.Critical)&&this.log(S.Critical,I([n,...t]))}flush(){}}e.AbstractMessageLogger=d;class p extends E{constructor(n=e.DEFAULT_LOG_LEVEL){super();this.setLevel(n),this.useColors=!k.isWindows}trace(n,...t){this.getLevel()<=S.Trace&&(this.useColors?console.log(`[90m[main ${P()}][0m`,n,...t):console.log(`[main ${P()}]`,n,...t))}debug(n,...t){this.getLevel()<=S.Debug&&(this.useColors?console.log(`[90m[main ${P()}][0m`,n,...t):console.log(`[main ${P()}]`,n,...t))}info(n,...t){this.getLevel()<=S.Info&&(this.useColors?console.log(`[90m[main ${P()}][0m`,n,...t):console.log(`[main ${P()}]`,n,...t))}warn(n,...t){this.getLevel()<=S.Warning&&(this.useColors?console.warn(`[93m[main ${P()}][0m`,n,...t):console.warn(`[main ${P()}]`,n,...t))}error(n,...t){this.getLevel()<=S.Error&&(this.useColors?console.error(`[91m[main ${P()}][0m`,n,...t):console.error(`[main ${P()}]`,n,...t))}critical(n,...t){this.getLevel()<=S.Critical&&(this.useColors?console.error(`[90m[main ${P()}][0m`,n,...t):console.error(`[main ${P()}]`,n,...t))}dispose(){}flush(){}}e.ConsoleMainLogger=p;class h extends E{constructor(n=e.DEFAULT_LOG_LEVEL){super();this.setLevel(n)}trace(n,...t){this.getLevel()<=S.Trace&&console.log("%cTRACE","color: #888",n,...t)}debug(n,...t){this.getLevel()<=S.Debug&&console.log("%cDEBUG","background: #eee; color: #888",n,...t)}info(n,...t){this.getLevel()<=S.Info&&console.log("%c INFO","color: #33f",n,...t)}warn(n,...t){this.getLevel()<=S.Warning&&console.log("%c WARN","color: #993",n,...t)}error(n,...t){this.getLevel()<=S.Error&&console.log("%c  ERR","color: #f33",n,...t)}critical(n,...t){this.getLevel()<=S.Critical&&console.log("%cCRITI","background: #f33; color: white",n,...t)}dispose(){}flush(){}}e.ConsoleLogger=h;class w extends E{constructor(n,t=e.DEFAULT_LOG_LEVEL){super();this.adapter=n,this.setLevel(t)}trace(n,...t){this.getLevel()<=S.Trace&&this.adapter.log(S.Trace,[this.extractMessage(n),...t])}debug(n,...t){this.getLevel()<=S.Debug&&this.adapter.log(S.Debug,[this.extractMessage(n),...t])}info(n,...t){this.getLevel()<=S.Info&&this.adapter.log(S.Info,[this.extractMessage(n),...t])}warn(n,...t){this.getLevel()<=S.Warning&&this.adapter.log(S.Warning,[this.extractMessage(n),...t])}error(n,...t){this.getLevel()<=S.Error&&this.adapter.log(S.Error,[this.extractMessage(n),...t])}critical(n,...t){this.getLevel()<=S.Critical&&this.adapter.log(S.Critical,[this.extractMessage(n),...t])}extractMessage(n){return typeof n=="string"?n:(0,R.toErrorMessage)(n,this.getLevel()<=S.Trace)}dispose(){}flush(){}}e.AdapterLogger=w;class y extends E{constructor(n){super();this.logServices=n,n.length&&this.setLevel(n[0].getLevel())}setLevel(n){for(const t of this.logServices)t.setLevel(n);super.setLevel(n)}trace(n,...t){for(const s of this.logServices)s.trace(n,...t)}debug(n,...t){for(const s of this.logServices)s.debug(n,...t)}info(n,...t){for(const s of this.logServices)s.info(n,...t)}warn(n,...t){for(const s of this.logServices)s.warn(n,...t)}error(n,...t){for(const s of this.logServices)s.error(n,...t)}critical(n,...t){for(const s of this.logServices)s.critical(n,...t)}flush(){for(const n of this.logServices)n.flush()}dispose(){for(const n of this.logServices)n.dispose()}}e.MultiplexLogService=y;class m extends D.Disposable{constructor(n){super();this.logger=n,this._register(n)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(n){this.logger.setLevel(n)}getLevel(){return this.logger.getLevel()}trace(n,...t){this.logger.trace(n,...t)}debug(n,...t){this.logger.debug(n,...t)}info(n,...t){this.logger.info(n,...t)}warn(n,...t){this.logger.warn(n,...t)}error(n,...t){this.logger.error(n,...t)}critical(n,...t){this.logger.critical(n,...t)}flush(){this.logger.flush()}}e.LogService=m;class b extends D.Disposable{constructor(n,t){super();this.logLevel=n,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(t(s=>{this.logLevel=s,this.logLevelChangeableLoggers.forEach(c=>c.setLevel(s))}))}getLogger(n){return this.loggers.get(n.toString())}createLogger(n,t){let s=this.loggers.get(n.toString());return s||(s=this.doCreateLogger(n,t?.always?S.Trace:this.logLevel,t),this.loggers.set(n.toString(),s),t?.always||this.logLevelChangeableLoggers.push(s)),s}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(n=>n.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=b;class g{constructor(){this.onDidChangeLogLevel=new L.Emitter().event}setLevel(n){}getLevel(){return S.Info}trace(n,...t){}debug(n,...t){}info(n,...t){}warn(n,...t){}error(n,...t){}critical(n,...t){}dispose(){}flush(){}}e.NullLogService=g;function a(o){if(o.verbose)return S.Trace;if(typeof o.logLevel=="string"){const n=l(o.logLevel.toLowerCase());if(n!==void 0)return n}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=a;function l(o){switch(o){case"trace":return S.Trace;case"debug":return S.Debug;case"info":return S.Info;case"warn":return S.Warning;case"error":return S.Error;case"critical":return S.Critical;case"off":return S.Off}}e.parseLogLevel=l;function r(o){switch(o){case S.Trace:return"trace";case S.Debug:return"debug";case S.Info:return"info";case S.Warning:return"warn";case S.Error:return"error";case S.Critical:return"critical";case S.Off:return"off"}}e.LogLevelToString=r}),define(te[173],ne([0,1,5,9,2,10,20,11,8]),function(X,e,R,L,D,k,i,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let C=class extends D.Disposable{constructor(E,d){super();this.environmentService=E,this.logService=d,this._register(new R.RunOnceScheduler(()=>{this.cleanUpOldLogs()},10*1e3)).schedule()}async cleanUpOldLogs(){this.logService.trace("[logs cleanup]: Starting to clean up old logs.");try{const E=(0,k.basename)(this.environmentService.logsPath),d=(0,k.dirname)(this.environmentService.logsPath),w=(await i.Promises.readdir(d)).filter(m=>/^\d{8}T\d{6}$/.test(m)).sort().filter(m=>m!==E),y=w.slice(0,Math.max(0,w.length-9));y.length>0&&(this.logService.trace(`[logs cleanup]: Removing log folders '${y.join(", ")}'`),await Promise.all(y.map(m=>i.Promises.rm((0,k.join)(d,m)))))}catch(E){(0,L.onUnexpectedError)(E)}}};C=he([J(0,P.IEnvironmentService),J(1,S.ILogService)],C),e.LogsDataCleaner=C}),define(te[174],ne([0,1,5,9,2,10,20,11,8]),function(X,e,R,L,D,k,i,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDataCleaner=void 0;let C=class gt extends D.Disposable{constructor(E,d,p){super();this.backupWorkspacesPath=E,this.environmentService=d,this.logService=p,this._register(new R.RunOnceScheduler(()=>{this.cleanUpStorage()},30*1e3)).schedule()}async cleanUpStorage(){this.logService.trace("[storage cleanup]: Starting to clean up storage folders.");try{const E=await i.Promises.readFile(this.backupWorkspacesPath,"utf8"),p=JSON.parse(E).emptyWorkspaceInfos.map(w=>w.backupFolder),h=await i.Promises.readdir(this.environmentService.workspaceStorageHome.fsPath);await Promise.all(h.map(async w=>{w.length===gt.NON_EMPTY_WORKSPACE_ID_LENGTH||w===gt.EXTENSION_DEV_EMPTY_WINDOW_ID||p.indexOf(w)>=0||(this.logService.trace(`[storage cleanup]: Deleting workspace storage folder ${w}.`),await i.Promises.rm((0,k.join)(this.environmentService.workspaceStorageHome.fsPath,w)))}))}catch(E){(0,L.onUnexpectedError)(E)}}};C.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4,C.EXTENSION_DEV_EMPTY_WINDOW_ID="ext-dev",C=he([J(1,P.INativeEnvironmentService),J(2,S.ILogService)],C),e.StorageDataCleaner=C}),define(te[84],ne([0,1,5,19,32,40,11,14,6,8]),function(X,e,R,L,D,k,i,P,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserConfigurationFileService=e.IUserConfigurationFileService=e.UserConfigurationFileServiceId=e.UserConfigurationErrorCode=void 0;var I;(function(d){d.ERROR_INVALID_FILE="ERROR_INVALID_FILE",d.ERROR_FILE_MODIFIED_SINCE="ERROR_FILE_MODIFIED_SINCE"})(I=e.UserConfigurationErrorCode||(e.UserConfigurationErrorCode={})),e.UserConfigurationFileServiceId="IUserConfigurationFileService",e.IUserConfigurationFileService=(0,S.createDecorator)(e.UserConfigurationFileServiceId);let E=class{constructor(p,h,w){this.environmentService=p,this.fileService=h,this.logService=w,this.queue=new R.Queue}async updateSettings(p,h){return this.queue.queue(()=>this.doWrite(p,h))}async doWrite(p,h){this.logService.trace(`${e.UserConfigurationFileServiceId}#write`,this.environmentService.settingsResource.toString(),p);const{value:w,mtime:y,etag:m}=await this.fileService.readFile(this.environmentService.settingsResource,{atomic:!0});let b=w.toString();const g=[];if((0,D.parse)(b,g,{allowTrailingComma:!0,allowEmptyContent:!0}),g.length)throw new Error("ERROR_INVALID_FILE");const a=this.getEdits(p,b,h)[0];if(a){b=b.substring(0,a.offset)+a.content+b.substring(a.offset+a.length);try{await this.fileService.writeFile(this.environmentService.settingsResource,L.VSBuffer.fromString(b),{etag:m,mtime:y})}catch(l){if(l.fileOperationResult===3)throw new Error("ERROR_FILE_MODIFIED_SINCE")}}}async write(p,h){return this.queue.queue(async()=>{await this.fileService.writeFile(this.environmentService.settingsResource,p,h)})}getEdits({value:p,path:h},w,y){return h.length?(0,k.setProperty)(w,h,p,y):[{content:JSON.stringify(p,null,y.insertSpaces&&y.tabSize?" ".repeat(y.tabSize):"	"),length:w.length,offset:0}]}};E=he([J(0,i.IEnvironmentService),J(1,P.IFileService),J(2,C.ILogService)],E),e.UserConfigurationFileService=E}),define(te[175],ne([0,1,45,5,38,3,2,15,10,20,11,8]),function(X,e,R,L,D,k,i,P,S,C,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let d=class extends i.Disposable{constructor(h,w){super();this.environmentService=h,this.logService=w,this.processesLimiter=new L.Limiter(5)}async postUninstall(h){const w=this.parseScript(h,"uninstall");return w&&(this.logService.info(h.identifier.id,h.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(w.script,"uninstall",w.args,!0,h).then(()=>this.logService.info(h.identifier.id,h.manifest.version,"Finished running post uninstall script"),y=>this.logService.error(h.identifier.id,h.manifest.version,`Failed to run post uninstall script: ${y}`)))),C.Promises.rm(this.getExtensionStoragePath(h)).then(void 0,y=>this.logService.error("Error while removing extension storage path",y))}parseScript(h,w){const y=`vscode:${w}`;if(h.location.scheme===P.Schemas.file&&h.manifest&&h.manifest.scripts&&typeof h.manifest.scripts[y]=="string"){const m=h.manifest.scripts[y].split(" ");return m.length<2||m[0]!=="node"||!m[1]?(this.logService.warn(h.identifier.id,h.manifest.version,`${y} should be a node script`),null):{script:(0,S.join)(h.location.fsPath,m[1]),args:m.slice(2)||[]}}return null}runLifecycleHook(h,w,y,m,b){return new Promise((g,a)=>{const l=this.start(h,w,y,b);let r;const o=n=>{r&&(clearTimeout(r),r=null),n?a(n):g(void 0)};l.on("error",n=>{o((0,D.toErrorMessage)(n)||"Unknown")}),l.on("exit",(n,t)=>{o(n?`post-${w} process exited with code ${n}`:void 0)}),m&&(r=setTimeout(()=>{r=null,l.kill(),a("timed out")},5e3))})}start(h,w,y,m){const b={silent:!0,execArgv:void 0},g=(0,R.fork)(h,[`--type=extension-post-${w}`,...y],b);g.stdout.setEncoding("utf8"),g.stderr.setEncoding("utf8");const a=k.Event.fromNodeEventEmitter(g.stdout,"data"),l=k.Event.fromNodeEventEmitter(g.stderr,"data");a(n=>this.logService.info(m.identifier.id,m.manifest.version,`post-${w}`,n)),l(n=>this.logService.error(m.identifier.id,m.manifest.version,`post-${w}`,n));const r=k.Event.any(k.Event.map(a,n=>({data:`%c${n}`,format:[""]})),k.Event.map(l,n=>({data:`%c${n}`,format:["color: red"]})));return k.Event.debounce(r,(n,t)=>n?{data:n.data+t.data,format:[...n.format,...t.format]}:{data:t.data,format:t.format},100)(n=>{console.group(m.identifier.id),console.log(n.data,...n.format),console.groupEnd()}),g}getExtensionStoragePath(h){return(0,S.join)(this.environmentService.globalStorageHome.fsPath,h.identifier.id.toLowerCase())}};d=he([J(0,I.IEnvironmentService),J(1,E.ILogService)],d),e.ExtensionsLifecycle=d}),define(te[176],ne([0,1,16,5,9,3,2,10,54,8]),function(X,e,R,L,D,k,i,P,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class I extends i.Disposable{constructor(d){super();this.logService=d,this._onDidErrorOccur=this._register(new k.Emitter),this.onDidErrorOccur=this._onDidErrorOccur.event,this._onDidChangeFile=this._register(new k.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new L.ThrottledDelayer(0))}watch(d,p){return p.recursive?this.watchRecursive(d,p):this.watchNonRecursive(d)}watchRecursive(d,p){const h={path:this.toFilePath(d),excludes:p.excludes},w=(0,R.insert)(this.recursiveFoldersToWatch,h);return this.refreshRecursiveWatchers(),(0,i.toDisposable)(()=>{w(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(()=>this.doRefreshRecursiveWatchers()).catch(d=>(0,D.onUnexpectedError)(d))}doRefreshRecursiveWatchers(){return this.recursiveWatcher||(this.recursiveWatcher=this._register(this.createRecursiveWatcher(d=>this._onDidChangeFile.fire((0,S.toFileChanges)(d)),d=>this.onWatcherLogMessage(d),this.logService.getLevel()===C.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher?.setVerboseLogging(this.logService.getLevel()===C.LogLevel.Trace)}))),this.doWatch(this.recursiveWatcher,this.recursiveFoldersToWatch)}doWatch(d,p){return d.watch(p)}watchNonRecursive(d){const p=this.createNonRecursiveWatcher(this.toFilePath(d),w=>this._onDidChangeFile.fire((0,S.toFileChanges)(w)),w=>this.onWatcherLogMessage(w),this.logService.getLevel()===C.LogLevel.Trace),h=this.logService.onDidChangeLogLevel(()=>{p.setVerboseLogging(this.logService.getLevel()===C.LogLevel.Trace)});return(0,i.combinedDisposable)(p,h)}onWatcherLogMessage(d){d.type==="error"&&this._onDidErrorOccur.fire(d.message),this.logService[d.type](d.message)}toFilePath(d){return(0,P.normalize)(d.fsPath)}}e.AbstractDiskFileSystemProvider=I}),define(te[177],ne([0,1,16,5,19,27,3,56,2,41,15,178,18,50,137,14,82,8]),function(X,e,R,L,D,k,i,P,S,C,I,E,d,p,h,w,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let b=class Ge extends S.Disposable{constructor(a){super();this.logService=a,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new i.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new i.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new i.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new i.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new i.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new i.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidChangeFilesRaw=this._register(new i.Emitter),this.onDidChangeFilesRaw=this._onDidChangeFilesRaw.event,this.activeWatchers=new Map,this.caseSensitiveFileEventsWorker=this._register(new L.ThrottledWorker(Ge.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ge.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ge.FILE_EVENTS_THROTTLING.coolDownDelay,l=>this._onDidFilesChange.fire(new w.FileChangesEvent(l,!1)))),this.caseInsensitiveFileEventsWorker=this._register(new L.ThrottledWorker(Ge.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ge.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ge.FILE_EVENTS_THROTTLING.coolDownDelay,l=>this._onDidFilesChange.fire(new w.FileChangesEvent(l,!0)))),this.watchedResources=C.TernarySearchTree.forUris(l=>{const r=this.getProvider(l.scheme);return r?!this.isPathCaseSensitive(r):!1}),this.writeQueue=this._register(new L.ResourceQueue)}registerProvider(a,l){if(this.provider.has(a))throw new Error(`A filesystem provider for the scheme '${a}' is already registered.`);(0,E.mark)(`code/registerFilesystem/${a}`),this.provider.set(a,l),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:a,provider:l});const r=new S.DisposableStore;return r.add(l.onDidChangeFile(o=>this.onDidChangeFile(o,this.isPathCaseSensitive(l)))),r.add(l.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:l,scheme:a}))),typeof l.onDidErrorOccur=="function"&&r.add(l.onDidErrorOccur(o=>this._onError.fire(new Error(o)))),(0,S.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:a,provider:l}),this.provider.delete(a),(0,S.dispose)(r)})}getProvider(a){return this.provider.get(a)}async activateProvider(a){const l=[];this._onWillActivateFileSystemProvider.fire({scheme:a,join(r){l.push(r)}}),!this.provider.has(a)&&await L.Promises.settled(l)}async canHandleResource(a){return await this.activateProvider(a.scheme),this.hasProvider(a)}hasProvider(a){return this.provider.has(a.scheme)}hasCapability(a,l){const r=this.provider.get(a.scheme);return!!(r&&r.capabilities&l)}listCapabilities(){return P.Iterable.map(this.provider,([a,l])=>({scheme:a,capabilities:l.capabilities}))}async withProvider(a){if(!(0,d.isAbsolutePath)(a))throw new w.FileOperationError((0,h.localize)(0,null,this.resourceForError(a)),8);await this.activateProvider(a.scheme);const l=this.provider.get(a.scheme);if(!l){const r=new Error;throw r.name="ENOPRO",r.message=(0,h.localize)(1,null,a.toString()),r}return l}async withReadProvider(a){const l=await this.withProvider(a);if((0,w.hasOpenReadWriteCloseCapability)(l)||(0,w.hasReadWriteCapability)(l)||(0,w.hasFileReadStreamCapability)(l))return l;throw new Error(`Filesystem provider for scheme '${a.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(a){const l=await this.withProvider(a);if((0,w.hasOpenReadWriteCloseCapability)(l)||(0,w.hasReadWriteCapability)(l))return l;throw new Error(`Filesystem provider for scheme '${a.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(a,l){try{return await this.doResolveFile(a,l)}catch(r){throw(0,w.toFileSystemProviderErrorCode)(r)===w.FileSystemProviderErrorCode.FileNotFound?new w.FileOperationError((0,h.localize)(2,null,this.resourceForError(a)),1):(0,w.ensureFileSystemProviderError)(r)}}async doResolveFile(a,l){const r=await this.withProvider(a),o=this.isPathCaseSensitive(r),n=l?.resolveTo,t=l?.resolveSingleChildDescendants,s=l?.resolveMetadata,c=await r.stat(a);let u;return this.toFileStat(r,a,c,void 0,!!s,(f,v)=>(u||(u=C.TernarySearchTree.forUris(()=>!o),u.set(a,!0),n&&u.fill(!0,n)),u.get(f.resource)||u.findSuperstr(f.resource.with({query:null,fragment:null}))?!0:f.isDirectory&&t?v===1:!1))}async toFileStat(a,l,r,o,n,t){const{providerExtUri:s}=this.getExtUri(a),c={resource:l,name:s.basename(l),isFile:(r.type&w.FileType.File)!=0,isDirectory:(r.type&w.FileType.Directory)!=0,isSymbolicLink:(r.type&w.FileType.SymbolicLink)!=0,mtime:r.mtime,ctime:r.ctime,size:r.size,readonly:Boolean((r.permissions??0)&w.FilePermission.Readonly)||Boolean(a.capabilities&2048),etag:(0,w.etag)({mtime:r.mtime,size:r.size})};if(c.isDirectory&&t(c,o)){try{const u=await a.readdir(l),f=await L.Promises.settled(u.map(async([v,T])=>{try{const O=s.joinPath(l,v),U=n?await a.stat(O):{type:T};return await this.toFileStat(a,O,U,u.length,n,t)}catch(O){return this.logService.trace(O),null}}));c.children=(0,R.coalesce)(f)}catch(u){this.logService.trace(u),c.children=[]}return c}return c}async resolveAll(a){return L.Promises.settled(a.map(async l=>{try{return{stat:await this.doResolveFile(l.resource,l.options),success:!0}}catch(r){return this.logService.trace(r),{stat:void 0,success:!1}}}))}async exists(a){const l=await this.withProvider(a);try{return!!await l.stat(a)}catch(r){return!1}}async canCreateFile(a,l){try{await this.doValidateCreateFile(a,l)}catch(r){return r}return!0}async doValidateCreateFile(a,l){if(!l?.overwrite&&await this.exists(a))throw new w.FileOperationError((0,h.localize)(3,null,this.resourceForError(a)),3,l)}async createFile(a,l=D.VSBuffer.fromString(""),r){await this.doValidateCreateFile(a,r);const o=await this.writeFile(a,l);return this._onDidRunOperation.fire(new w.FileOperationEvent(a,0,o)),o}async writeFile(a,l,r){const o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),{providerExtUri:n}=this.getExtUri(o);try{await this.validateWriteFile(o,a,r)||await this.mkdirp(o,n.dirname(a));let s;if((0,w.hasReadWriteCapability)(o)&&!(l instanceof D.VSBuffer))if((0,p.isReadableStream)(l)){const c=await(0,p.peekStream)(l,3);c.ended?s=D.VSBuffer.concat(c.buffer):s=c}else s=(0,p.peekReadable)(l,c=>D.VSBuffer.concat(c),3);else s=l;!(0,w.hasOpenReadWriteCloseCapability)(o)||(0,w.hasReadWriteCapability)(o)&&s instanceof D.VSBuffer?await this.doWriteUnbuffered(o,a,r,s):await this.doWriteBuffered(o,a,r,s instanceof D.VSBuffer?(0,D.bufferToReadable)(s):s)}catch(t){throw new w.FileOperationError((0,h.localize)(4,null,this.resourceForError(a),(0,w.ensureFileSystemProviderError)(t).toString()),(0,w.toFileOperationResult)(t),r)}return this.resolve(a,{resolveMetadata:!0})}async validateWriteFile(a,l,r){if(!!r?.unlock&&!(a.capabilities&8192))throw new Error((0,h.localize)(5,null,this.resourceForError(l)));let n;try{n=await a.stat(l)}catch(t){return}if((n.type&w.FileType.Directory)!=0)throw new w.FileOperationError((0,h.localize)(6,null,this.resourceForError(l)),0,r);if(this.throwIfFileIsReadonly(l,n),typeof r?.mtime=="number"&&typeof r.etag=="string"&&r.etag!==w.ETAG_DISABLED&&typeof n.mtime=="number"&&typeof n.size=="number"&&r.mtime<n.mtime&&r.etag!==(0,w.etag)({mtime:r.mtime,size:n.size}))throw new w.FileOperationError((0,h.localize)(7,null),3,r);return n}async readFile(a,l){const r=await this.withReadProvider(a);return l?.atomic?this.doReadFileAtomic(r,a,l):this.doReadFile(r,a,l)}async doReadFileAtomic(a,l,r){return new Promise((o,n)=>{this.writeQueue.queueFor(l,this.getExtUri(a).providerExtUri).queue(async()=>{try{const t=await this.doReadFile(a,l,r);o(t)}catch(t){n(t)}})})}async doReadFile(a,l,r){const o=await this.doReadFileStream(a,l,{...r,preferUnbuffered:!0});return{...o,value:await(0,D.streamToBuffer)(o.value)}}async readFileStream(a,l){const r=await this.withReadProvider(a);return this.doReadFileStream(r,a,l)}async doReadFileStream(a,l,r){const o=new k.CancellationTokenSource,n=this.validateReadFile(l,r).then(s=>s,s=>{throw o.cancel(),s});let t;try{return typeof r?.etag=="string"&&r.etag!==w.ETAG_DISABLED&&await n,!((0,w.hasOpenReadWriteCloseCapability)(a)||(0,w.hasFileReadStreamCapability)(a))||(0,w.hasReadWriteCapability)(a)&&r?.preferUnbuffered?t=this.readFileUnbuffered(a,l,r):(0,w.hasFileReadStreamCapability)(a)?t=this.readFileStreamed(a,l,o.token,r):t=this.readFileBuffered(a,l,o.token,r),{...await n,value:t}}catch(s){t&&await(0,p.consumeStream)(t);const c=(0,h.localize)(8,null,this.resourceForError(l),(0,w.ensureFileSystemProviderError)(s).toString());throw s instanceof w.NotModifiedSinceFileOperationError?new w.NotModifiedSinceFileOperationError(c,s.stat,r):new w.FileOperationError(c,(0,w.toFileOperationResult)(s),r)}}readFileStreamed(a,l,r,o=Object.create(null)){const n=a.readFileStream(l,o,r);return(0,p.transform)(n,{data:t=>t instanceof D.VSBuffer?t:D.VSBuffer.wrap(t),error:t=>new w.FileOperationError((0,h.localize)(9,null,this.resourceForError(l),(0,w.ensureFileSystemProviderError)(t).toString()),(0,w.toFileOperationResult)(t),o)},t=>D.VSBuffer.concat(t))}readFileBuffered(a,l,r,o=Object.create(null)){const n=(0,D.newWriteableBufferStream)();return(0,y.readFileIntoStream)(a,l,n,t=>t,{...o,bufferSize:this.BUFFER_SIZE,errorTransformer:t=>new w.FileOperationError((0,h.localize)(10,null,this.resourceForError(l),(0,w.ensureFileSystemProviderError)(t).toString()),(0,w.toFileOperationResult)(t),o)},r),n}readFileUnbuffered(a,l,r){const o=(0,p.newWriteableStream)(n=>D.VSBuffer.concat(n));return(async()=>{try{let n=await a.readFile(l);typeof r?.position=="number"&&(n=n.slice(r.position)),typeof r?.length=="number"&&(n=n.slice(0,r.length)),this.validateReadFileLimits(l,n.byteLength,r),o.end(D.VSBuffer.wrap(n))}catch(n){o.error(n),o.end()}})(),o}async validateReadFile(a,l){const r=await this.resolve(a,{resolveMetadata:!0});if(r.isDirectory)throw new w.FileOperationError((0,h.localize)(11,null,this.resourceForError(a)),0,l);if(typeof l?.etag=="string"&&l.etag!==w.ETAG_DISABLED&&l.etag===r.etag)throw new w.NotModifiedSinceFileOperationError((0,h.localize)(12,null),r,l);return this.validateReadFileLimits(a,r.size,l),r}validateReadFileLimits(a,l,r){if(r?.limits){let o;if(typeof r.limits.memory=="number"&&l>r.limits.memory&&(o=9),typeof r.limits.size=="number"&&l>r.limits.size&&(o=7),typeof o=="number")throw new w.FileOperationError((0,h.localize)(13,null,this.resourceForError(a)),o)}}async canMove(a,l,r){return this.doCanMoveCopy(a,l,"move",r)}async canCopy(a,l,r){return this.doCanMoveCopy(a,l,"copy",r)}async doCanMoveCopy(a,l,r,o){if(a.toString()!==l.toString())try{const n=r==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a):await this.withReadProvider(a),t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l);await this.doValidateMoveCopy(n,a,t,l,r,o)}catch(n){return n}return!0}async move(a,l,r){const o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),t=await this.doMoveCopy(o,a,n,l,"move",!!r),s=await this.resolve(l,{resolveMetadata:!0});return this._onDidRunOperation.fire(new w.FileOperationEvent(a,t==="move"?2:3,s)),s}async copy(a,l,r){const o=await this.withReadProvider(a),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),t=await this.doMoveCopy(o,a,n,l,"copy",!!r),s=await this.resolve(l,{resolveMetadata:!0});return this._onDidRunOperation.fire(new w.FileOperationEvent(a,t==="copy"?3:2,s)),s}async doMoveCopy(a,l,r,o,n,t){if(l.toString()===o.toString())return n;const{exists:s,isSameResourceWithDifferentPathCase:c}=await this.doValidateMoveCopy(a,l,r,o,n,t);if(s&&!c&&t&&await this.del(o,{recursive:!0}),await this.mkdirp(r,this.getExtUri(r).providerExtUri.dirname(o)),n==="copy"){if(a===r&&(0,w.hasFileFolderCopyCapability)(a))await a.copy(l,o,{overwrite:t});else{const u=await this.resolve(l);u.isDirectory?await this.doCopyFolder(a,u,r,o):await this.doCopyFile(a,l,r,o)}return n}else return a===r?(await a.rename(l,o,{overwrite:t}),n):(await this.doMoveCopy(a,l,r,o,"copy",t),await this.del(l,{recursive:!0}),"copy")}async doCopyFile(a,l,r,o){if((0,w.hasOpenReadWriteCloseCapability)(a)&&(0,w.hasOpenReadWriteCloseCapability)(r))return this.doPipeBuffered(a,l,r,o);if((0,w.hasOpenReadWriteCloseCapability)(a)&&(0,w.hasReadWriteCapability)(r))return this.doPipeBufferedToUnbuffered(a,l,r,o);if((0,w.hasReadWriteCapability)(a)&&(0,w.hasOpenReadWriteCloseCapability)(r))return this.doPipeUnbufferedToBuffered(a,l,r,o);if((0,w.hasReadWriteCapability)(a)&&(0,w.hasReadWriteCapability)(r))return this.doPipeUnbuffered(a,l,r,o)}async doCopyFolder(a,l,r,o){await r.mkdir(o),Array.isArray(l.children)&&await L.Promises.settled(l.children.map(async n=>{const t=this.getExtUri(r).providerExtUri.joinPath(o,n.name);return n.isDirectory?this.doCopyFolder(a,await this.resolve(n.resource),r,t):this.doCopyFile(a,n.resource,r,t)}))}async doValidateMoveCopy(a,l,r,o,n,t){let s=!1;if(a===r){const{providerExtUri:u,isPathCaseSensitive:f}=this.getExtUri(a);if(f||(s=u.isEqual(l,o)),s&&n==="copy")throw new Error((0,h.localize)(14,null,this.resourceForError(l),this.resourceForError(o)));if(!s&&u.isEqualOrParent(o,l))throw new Error((0,h.localize)(15,null,this.resourceForError(l),this.resourceForError(o)))}const c=await this.exists(o);if(c&&!s){if(!t)throw new w.FileOperationError((0,h.localize)(16,null,this.resourceForError(l),this.resourceForError(o)),4);if(a===r){const{providerExtUri:u}=this.getExtUri(a);if(u.isEqualOrParent(l,o))throw new Error((0,h.localize)(17,null,this.resourceForError(l),this.resourceForError(o)))}}return{exists:c,isSameResourceWithDifferentPathCase:s}}getExtUri(a){const l=this.isPathCaseSensitive(a);return{providerExtUri:l?d.extUri:d.extUriIgnorePathCase,isPathCaseSensitive:l}}isPathCaseSensitive(a){return!!(a.capabilities&1024)}async createFolder(a){const l=this.throwIfFileSystemIsReadonly(await this.withProvider(a),a);await this.mkdirp(l,a);const r=await this.resolve(a,{resolveMetadata:!0});return this._onDidRunOperation.fire(new w.FileOperationEvent(a,0,r)),r}async mkdirp(a,l){const r=[],{providerExtUri:o}=this.getExtUri(a);for(;!o.isEqual(l,o.dirname(l));)try{if(((await a.stat(l)).type&w.FileType.Directory)==0)throw new Error((0,h.localize)(18,null,this.resourceForError(l)));break}catch(n){if((0,w.toFileSystemProviderErrorCode)(n)!==w.FileSystemProviderErrorCode.FileNotFound)throw n;r.push(o.basename(l)),l=o.dirname(l)}for(let n=r.length-1;n>=0;n--){l=o.joinPath(l,r[n]);try{await a.mkdir(l)}catch(t){if((0,w.toFileSystemProviderErrorCode)(t)!==w.FileSystemProviderErrorCode.FileExists)throw t}}}async canDelete(a,l){try{await this.doValidateDelete(a,l)}catch(r){return r}return!0}async doValidateDelete(a,l){const r=this.throwIfFileSystemIsReadonly(await this.withProvider(a),a);if(!!l?.useTrash&&!(r.capabilities&4096))throw new Error((0,h.localize)(19,null,this.resourceForError(a)));let n;try{n=await r.stat(a)}catch(s){}if(n)this.throwIfFileIsReadonly(a,n);else throw new w.FileOperationError((0,h.localize)(20,null,this.resourceForError(a)),1);if(!!!l?.recursive){const s=await this.resolve(a);if(s.isDirectory&&Array.isArray(s.children)&&s.children.length>0)throw new Error((0,h.localize)(21,null,this.resourceForError(a)))}return r}async del(a,l){const r=await this.doValidateDelete(a,l),o=!!l?.useTrash,n=!!l?.recursive;await r.delete(a,{recursive:n,useTrash:o}),this._onDidRunOperation.fire(new w.FileOperationEvent(a,1))}onDidChangeFile(a,l){this._onDidChangeFilesRaw.fire({changes:a});let r,o;{for(const n of a)this.watchedResources.has(n.resource)?(r||(r=[]),r.push(n)):(o||(o=[]),o.push(n));r&&this._onDidFilesChange.fire(new w.FileChangesEvent(r,!l))}if(o){const n=l?this.caseSensitiveFileEventsWorker:this.caseInsensitiveFileEventsWorker;!n.work(o)&&Ge.FILE_EVENTS_THROTTLING.warningscounter++<10&&this.logService.warn(`[File watcher]: started ignoring events due to too many file change events at once (incoming: ${o.length}, most recent change: ${o[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`),n.pending>0&&this.logService.trace(`[File watcher]: started throttling events due to large amount of file change events at once (pending: ${n.pending}, most recent change: ${o[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}watch(a,l={recursive:!1,excludes:[]}){const r=new S.DisposableStore;let o=!1,n=()=>{o=!0};return r.add((0,S.toDisposable)(()=>n())),this.doWatch(a,l).then(t=>{o?(0,S.dispose)(t):n=()=>(0,S.dispose)(t)},t=>this.logService.error(t)),l.recursive||(this.watchedResources.set(a,(this.watchedResources.get(a)??0)+1),r.add((0,S.toDisposable)(()=>{const t=this.watchedResources.get(a);typeof t=="number"&&(t<=1?this.watchedResources.delete(a):this.watchedResources.set(a,t-1))}))),r}async doWatch(a,l){const r=await this.withProvider(a),o=this.toWatchKey(r,a,l);let n=this.activeWatchers.get(o);return n||(n={count:0,disposable:r.watch(a,l)},this.activeWatchers.set(o,n)),n.count+=1,(0,S.toDisposable)(()=>{n&&(n.count--,n.count===0&&((0,S.dispose)(n.disposable),this.activeWatchers.delete(o)))})}toWatchKey(a,l,r){const{providerExtUri:o}=this.getExtUri(a);return[o.getComparisonKey(l),String(r.recursive),r.excludes.join()].join()}dispose(){super.dispose();for(const[,a]of this.activeWatchers)(0,S.dispose)(a.disposable);this.activeWatchers.clear()}async doWriteBuffered(a,l,r,o){return this.writeQueue.queueFor(l,this.getExtUri(a).providerExtUri).queue(async()=>{const n=await a.open(l,{create:!0,unlock:r?.unlock??!1});try{(0,p.isReadableStream)(o)||(0,p.isReadableBufferedStream)(o)?await this.doWriteStreamBufferedQueued(a,n,o):await this.doWriteReadableBufferedQueued(a,n,o)}catch(t){throw(0,w.ensureFileSystemProviderError)(t)}finally{await a.close(n)}})}async doWriteStreamBufferedQueued(a,l,r){let o=0,n;if((0,p.isReadableBufferedStream)(r)){if(r.buffer.length>0){const t=D.VSBuffer.concat(r.buffer);await this.doWriteBuffer(a,l,t,t.byteLength,o,0),o+=t.byteLength}if(r.ended)return;n=r.stream}else n=r;return new Promise((t,s)=>{(0,p.listenStream)(n,{onData:async c=>{n.pause();try{await this.doWriteBuffer(a,l,c,c.byteLength,o,0)}catch(u){return s(u)}o+=c.byteLength,setTimeout(()=>n.resume())},onError:c=>s(c),onEnd:()=>t()})})}async doWriteReadableBufferedQueued(a,l,r){let o=0,n;for(;(n=r.read())!==null;)await this.doWriteBuffer(a,l,n,n.byteLength,o,0),o+=n.byteLength}async doWriteBuffer(a,l,r,o,n,t){let s=0;for(;s<o;)s+=await a.write(l,n+s,r.buffer,t+s,o-s)}async doWriteUnbuffered(a,l,r,o){return this.writeQueue.queueFor(l,this.getExtUri(a).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(a,l,r,o))}async doWriteUnbufferedQueued(a,l,r,o){let n;o instanceof D.VSBuffer?n=o:(0,p.isReadableStream)(o)?n=await(0,D.streamToBuffer)(o):(0,p.isReadableBufferedStream)(o)?n=await(0,D.bufferedStreamToBuffer)(o):n=(0,D.readableToBuffer)(o),await a.writeFile(l,n.buffer,{create:!0,overwrite:!0,unlock:r?.unlock??!1})}async doPipeBuffered(a,l,r,o){return this.writeQueue.queueFor(o,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeBufferedQueued(a,l,r,o))}async doPipeBufferedQueued(a,l,r,o){let n,t;try{n=await a.open(l,{create:!1}),t=await r.open(o,{create:!0,unlock:!1});const s=D.VSBuffer.alloc(this.BUFFER_SIZE);let c=0,u=0,f=0;do f=await a.read(n,c,s.buffer,u,s.byteLength-u),await this.doWriteBuffer(r,t,s,f,c,u),c+=f,u+=f,u===s.byteLength&&(u=0);while(f>0)}catch(s){throw(0,w.ensureFileSystemProviderError)(s)}finally{await L.Promises.settled([typeof n=="number"?a.close(n):Promise.resolve(),typeof t=="number"?r.close(t):Promise.resolve()])}}async doPipeUnbuffered(a,l,r,o){return this.writeQueue.queueFor(o,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(a,l,r,o))}async doPipeUnbufferedQueued(a,l,r,o){return r.writeFile(o,await a.readFile(l),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(a,l,r,o){return this.writeQueue.queueFor(o,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(a,l,r,o))}async doPipeUnbufferedToBufferedQueued(a,l,r,o){const n=await r.open(o,{create:!0,unlock:!1});try{const t=await a.readFile(l);await this.doWriteBuffer(r,n,D.VSBuffer.wrap(t),t.byteLength,0,0)}catch(t){throw(0,w.ensureFileSystemProviderError)(t)}finally{await r.close(n)}}async doPipeBufferedToUnbuffered(a,l,r,o){const n=await(0,D.streamToBuffer)(this.readFileBuffered(a,l,k.CancellationToken.None));await this.doWriteUnbuffered(r,o,void 0,n)}throwIfFileSystemIsReadonly(a,l){if(a.capabilities&2048)throw new w.FileOperationError((0,h.localize)(22,null,this.resourceForError(l)),6);return a}throwIfFileIsReadonly(a,l){if((l.permissions??0)&w.FilePermission.Readonly)throw new w.FileOperationError((0,h.localize)(23,null,this.resourceForError(a)),6)}resourceForError(a){return a.scheme===I.Schemas.file?a.fsPath:a.toString(!0)}};b.FILE_EVENTS_THROTTLING={maxChangesChunkSize:500,maxChangesBufferSize:3e4,coolDownDelay:200,warningscounter:0},b=he([J(0,m.ILogService)],b),e.FileService=b}),define(te[179],ne([0,1,51,247,5,19,3,42,10,4,18,50,20,140,14,82,166,167,168,176,38]),function(X,e,R,L,D,k,i,P,S,C,I,E,d,p,h,w,y,m,b,g,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,L.gracefulify)(R)}catch(r){console.error(`Error enabling graceful-fs: ${(0,a.toErrorMessage)(r)}`)}})();class l extends g.AbstractDiskFileSystemProvider{constructor(o,n){super(o);this.options=n,this.onDidChangeCapabilities=i.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,C.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(o){try{const{stat:n,symbolicLink:t}=await d.SymlinkSupport.stat(this.toFilePath(o));return{type:this.toType(n,t),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size}}catch(n){throw this.toFileSystemProviderError(n)}}async readdir(o){try{const n=await d.Promises.readdir(this.toFilePath(o),{withFileTypes:!0}),t=[];return await Promise.all(n.map(async s=>{try{let c;s.isSymbolicLink()?c=(await this.stat((0,I.joinPath)(o,s.name))).type:c=this.toType(s),t.push([s.name,c])}catch(c){this.logService.trace(c)}})),t}catch(n){throw this.toFileSystemProviderError(n)}}toType(o,n){let t;return n?.dangling?t=h.FileType.Unknown:o.isFile()?t=h.FileType.File:o.isDirectory()?t=h.FileType.Directory:t=h.FileType.Unknown,n&&(t|=h.FileType.SymbolicLink),t}async readFile(o){try{const n=this.toFilePath(o);return await d.Promises.readFile(n)}catch(n){throw this.toFileSystemProviderError(n)}}readFileStream(o,n,t){const s=(0,E.newWriteableStream)(c=>k.VSBuffer.concat(c.map(u=>k.VSBuffer.wrap(u))).buffer);return(0,w.readFileIntoStream)(this,o,s,c=>c.buffer,{...n,bufferSize:256*1024},t),s}async writeFile(o,n,t){let s;try{const c=this.toFilePath(o);if(!t.create||!t.overwrite){if(await d.Promises.exists(c)){if(!t.overwrite)throw(0,h.createFileSystemProviderError)((0,p.localize)(0,null),h.FileSystemProviderErrorCode.FileExists)}else if(!t.create)throw(0,h.createFileSystemProviderError)((0,p.localize)(1,null),h.FileSystemProviderErrorCode.FileNotFound)}s=await this.open(o,{create:!0,unlock:t.unlock}),await this.write(s,0,n,0,n.byteLength)}catch(c){throw await this.toFileSystemProviderWriteError(o,c)}finally{typeof s=="number"&&await this.close(s)}}async open(o,n){try{const t=this.toFilePath(o);if((0,h.isFileOpenForWriteOptions)(n)&&n.unlock)try{const{stat:u}=await d.SymlinkSupport.stat(t);u.mode&128||await d.Promises.chmod(t,u.mode|128)}catch(u){this.logService.trace(u)}let s;if((0,h.isFileOpenForWriteOptions)(n)){if(C.isWindows)try{await d.Promises.truncate(t,0),s="r+"}catch(u){u.code!=="ENOENT"&&this.logService.trace(u)}s||(s="w")}else s="r";const c=await d.Promises.open(t,s);return this.mapHandleToPos.set(c,0),(0,h.isFileOpenForWriteOptions)(n)&&this.writeHandles.set(c,o),c}catch(t){throw(0,h.isFileOpenForWriteOptions)(n)?await this.toFileSystemProviderWriteError(o,t):this.toFileSystemProviderError(t)}}async close(o){try{if(this.mapHandleToPos.delete(o),this.writeHandles.delete(o)&&this.canFlush)try{await d.Promises.fdatasync(o)}catch(n){this.canFlush=!1,this.logService.error(n)}return await d.Promises.close(o)}catch(n){throw this.toFileSystemProviderError(n)}}async read(o,n,t,s,c){const u=this.normalizePos(o,n);let f=null;try{const v=await d.Promises.read(o,t,s,c,u);return typeof v=="number"?f=v:f=v.bytesRead,f}catch(v){throw this.toFileSystemProviderError(v)}finally{this.updatePos(o,u,f)}}normalizePos(o,n){return n===this.mapHandleToPos.get(o)?null:n}updatePos(o,n,t){const s=this.mapHandleToPos.get(o);typeof s=="number"&&(typeof n=="number"||(typeof t=="number"?this.mapHandleToPos.set(o,s+t):this.mapHandleToPos.delete(o)))}async write(o,n,t,s,c){return(0,D.retry)(()=>this.doWrite(o,n,t,s,c),100,3)}async doWrite(o,n,t,s,c){const u=this.normalizePos(o,n);let f=null;try{const v=await d.Promises.write(o,t,s,c,u);return typeof v=="number"?f=v:f=v.bytesWritten,f}catch(v){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(o),v)}finally{this.updatePos(o,u,f)}}async mkdir(o){try{await d.Promises.mkdir(this.toFilePath(o))}catch(n){throw this.toFileSystemProviderError(n)}}async delete(o,n){try{const t=this.toFilePath(o);await this.doDelete(t,n)}catch(t){throw this.toFileSystemProviderError(t)}}async doDelete(o,n){n.recursive?await d.Promises.rm(o,d.RimRafMode.MOVE):await d.Promises.unlink(o)}async rename(o,n,t){const s=this.toFilePath(o),c=this.toFilePath(n);if(s!==c)try{await this.validateTargetDeleted(o,n,"move",t.overwrite),await d.Promises.move(s,c)}catch(u){throw(u.code==="EINVAL"||u.code==="EBUSY"||u.code==="ENAMETOOLONG")&&(u=new Error((0,p.localize)(2,null,(0,S.basename)(s),(0,S.basename)((0,S.dirname)(c)),u.toString()))),this.toFileSystemProviderError(u)}}async copy(o,n,t){const s=this.toFilePath(o),c=this.toFilePath(n);if(s!==c)try{await this.validateTargetDeleted(o,n,"copy",t.overwrite),await d.Promises.copy(s,c,{preserveSymlinks:!0})}catch(u){throw(u.code==="EINVAL"||u.code==="EBUSY"||u.code==="ENAMETOOLONG")&&(u=new Error((0,p.localize)(3,null,(0,S.basename)(s),(0,S.basename)((0,S.dirname)(c)),u.toString()))),this.toFileSystemProviderError(u)}}async validateTargetDeleted(o,n,t,s){const c=this.toFilePath(o),u=this.toFilePath(n);let f=!1;if(!!(this.capabilities&1024)||(f=(0,P.isEqual)(c,u,!0)),f&&t==="copy")throw(0,h.createFileSystemProviderError)((0,p.localize)(4,null),h.FileSystemProviderErrorCode.FileExists);if(!f&&await d.Promises.exists(u)){if(!s)throw(0,h.createFileSystemProviderError)((0,p.localize)(5,null),h.FileSystemProviderErrorCode.FileExists);await this.delete(n,{recursive:!0,useTrash:!1})}}createRecursiveWatcher(o,n,t){let s,c=!1;return this.options?.watcher?.usePolling?c=!1:c=this.options?.legacyWatcher==="on",c?s=m.FileWatcher:s=b.FileWatcher,new s(u=>o(u),u=>n(u),t,this.options?.watcher)}doWatch(o,n){const t=this.options?.watcher?.usePolling;if(t===!0)for(const s of n)s.pollingInterval=this.options?.watcher?.pollingInterval??5e3;else if(Array.isArray(t))for(const s of n)t.includes(s.path)&&(s.pollingInterval=this.options?.watcher?.pollingInterval??5e3);return super.doWatch(o,n)}createNonRecursiveWatcher(o,n,t,s){return new y.FileWatcher(o,c=>n(c),c=>t(c),s)}toFileSystemProviderError(o){if(o instanceof h.FileSystemProviderError)return o;let n;switch(o.code){case"ENOENT":n=h.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=h.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=h.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=h.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=h.FileSystemProviderErrorCode.NoPermissions;break;default:n=h.FileSystemProviderErrorCode.Unknown}return(0,h.createFileSystemProviderError)(o,n)}async toFileSystemProviderWriteError(o,n){let t=this.toFileSystemProviderError(n);if(o&&t.code===h.FileSystemProviderErrorCode.NoPermissions)try{const{stat:s}=await d.SymlinkSupport.stat(this.toFilePath(o));s.mode&128||(t=(0,h.createFileSystemProviderError)(n,h.FileSystemProviderErrorCode.FileWriteLocked))}catch(s){this.logService.trace(s)}return t}}e.DiskFileSystemProvider=l}),define(te[85],ne([0,1,3,7,8]),function(X,e,R,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class k{constructor(d){this.service=d,this.onDidChangeLogLevel=R.Event.buffer(d.onDidChangeLogLevel,!0)}listen(d,p){switch(p){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${p}`)}async call(d,p,h){switch(p){case"setLevel":return this.service.setLevel(h)}throw new Error(`Call not found: ${p}`)}}e.LogLevelChannel=k;class i{constructor(d){this.channel=d}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(d){i.setLevel(this.channel,d)}static setLevel(d,p){return d.call("setLevel",p)}}e.LogLevelChannelClient=i;class P{constructor(d){this.loggerService=d,this.loggers=new Map}listen(d,p){throw new Error(`Event not found: ${p}`)}async call(d,p,h){switch(p){case"createLogger":this.createLogger(L.URI.revive(h[0]),h[1]);return;case"log":return this.log(L.URI.revive(h[0]),h[1]);case"consoleLog":return this.consoleLog(h[0],h[1])}throw new Error(`Call not found: ${p}`)}createLogger(d,p){this.loggers.set(d.toString(),this.loggerService.createLogger(d,p))}consoleLog(d,p){let h=console.log;switch(d){case D.LogLevel.Error:h=console.error;break;case D.LogLevel.Warning:h=console.warn;break;case D.LogLevel.Info:h=console.info;break}h.call(console,...p)}log(d,p){const h=this.loggers.get(d.toString());if(!h)throw new Error("Create the logger before logging");for(const[w,y]of p)(0,D.log)(h,w,y)}}e.LoggerChannel=P;class S extends D.AbstractLoggerService{constructor(d,p,h){super(d,p);this.channel=h}createConsoleMainLogger(){return new D.AdapterLogger({log:(d,p)=>{this.channel.call("consoleLog",[d,p])}})}doCreateLogger(d,p,h){return new C(this.channel,d,p,h)}}e.LoggerChannelClient=S;class C extends D.AbstractMessageLogger{constructor(d,p,h,w){super(w?.always);this.channel=d,this.file=p,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(h),this.channel.call("createLogger",[p,w]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(d,p){const h=[[d,p]];this.isLoggerCreated?this.doLog(h):this.buffer.push(...h)}doLog(d){this.channel.call("log",[this.file,d])}}class I extends D.LogService{constructor(d,p){super(p);this.parent=d,this._register(d.onDidChangeLogLevel(h=>p.setLevel(h)))}setLevel(d){super.setLevel(d),this.parent.setLevel(d)}}e.FollowerLogService=I}),define(te[60],ne([0,1,6]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=(0,R.createDecorator)("nativeHostService")}),define(te[86],ne([0,1,15,4,31,18]),function(X,e,R,L,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let i;if(typeof L.globals.vscode!="undefined"&&typeof L.globals.vscode.context!="undefined"){const P=L.globals.vscode.context.configuration();if(P)i=P.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof X?.__$__nodeRequire=="function"){const P=(0,k.dirname)(R.FileAccess.asFileUri("",X));i=X.__$__nodeRequire((0,k.joinPath)(P,"product.json").fsPath);const S=X.__$__nodeRequire((0,k.joinPath)(P,"package.json").fsPath);D.env.VSCODE_DEV&&Object.assign(i,{nameShort:`${i.nameShort} Dev`,nameLong:`${i.nameLong} Dev`,dataFolderName:`${i.dataFolderName}-dev`}),Object.assign(i,{version:S.version})}else i={},Object.keys(i).length===0&&Object.assign(i,{version:"1.63.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=i}),define(te[26],ne([0,1,6]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProductService=void 0,e.IProductService=(0,R.createDecorator)("productService")}),define(te[180],ne([0,1,5,9,2,10,20,8,26]),function(X,e,R,L,D,k,i,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeCacheCleaner=void 0;let C=class extends D.Disposable{constructor(E,d,p){super();this.productService=d,this.logService=p,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,E&&this._register(new R.RunOnceScheduler(()=>{this.cleanUpCodeCaches(E)},30*1e3)).schedule()}async cleanUpCodeCaches(E){this.logService.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const d=Date.now(),p=(0,k.dirname)(E),h=(0,k.basename)(E),w=await i.Promises.readdir(p);await Promise.all(w.map(async y=>{if(y===h)return;const m=(0,k.join)(p,y),b=await i.Promises.stat(m);if(b.isDirectory()&&d-b.mtime.getTime()>this._DataMaxAge)return this.logService.trace(`[code cache cleanup]: Removing code cache folder ${y}.`),i.Promises.rm(m)}))}catch(d){(0,L.onUnexpectedError)(d)}}};C=he([J(1,S.IProductService),J(2,P.ILogService)],C),e.CodeCacheCleaner=C}),define(te[181],ne([0,1,5,9,2,10,20,11,8,26]),function(X,e,R,L,D,k,i,P,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let I=class extends D.Disposable{constructor(d,p,h){super();this.environmentService=d,this.logService=p,this.productService=h,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.environmentService.isBuilt&&this._register(new R.RunOnceScheduler(()=>{this.cleanUpLanguagePackCache()},40*1e3)).schedule()}async cleanUpLanguagePackCache(){this.logService.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const d=Object.create(null),p=JSON.parse(await i.Promises.readFile((0,k.join)(this.environmentService.userDataPath,"languagepacks.json"),"utf8"));for(let b of Object.keys(p)){const g=p[b];d[`${g.hash}.${b}`]=!0}const h=(0,k.join)(this.environmentService.userDataPath,"clp");if(!await i.Promises.exists(h))return;const y=await i.Promises.readdir(h);for(const b of y){if(d[b]){this.logService.trace(`[language pack cache cleanup]: Skipping folder ${b}. Language pack still in use.`);continue}this.logService.trace(`[language pack cache cleanup]: Removing unused language pack: ${b}`),await i.Promises.rm((0,k.join)(h,b))}const m=Date.now();for(const b of Object.keys(d)){const g=(0,k.join)(h,b),a=await i.Promises.readdir(g);for(const l of a){if(l==="tcf.json")continue;const r=(0,k.join)(g,l),o=await i.Promises.stat(r);o.isDirectory()&&m-o.mtime.getTime()>this._DataMaxAge&&(this.logService.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,k.join)(b,l)}`),await i.Promises.rm(r))}}}catch(d){(0,L.onUnexpectedError)(d)}}};I=he([J(0,P.INativeEnvironmentService),J(1,S.ILogService),J(2,C.IProductService)],I),e.LanguagePackCachedDataCleaner=I}),define(te[35],ne([0,1,100,17]),function(X,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class D{constructor(){this.data=new Map}add(i,P){R.ok(L.isString(i)),R.ok(L.isObject(P)),R.ok(!this.data.has(i),"There is already an extension with this id"),this.data.set(i,P)}knows(i){return this.data.has(i)}as(i){return this.data.get(i)||null}}e.Registry=new D}),define(te[87],ne([0,1,3,35]),function(X,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function D(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class k{constructor(){this._onDidChangeSchema=new R.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(S,C){this.schemasById[D(S)]=C,this._onDidChangeSchema.fire(S)}notifySchemaChanged(S){this._onDidChangeSchema.fire(S)}getSchemaContributions(){return{schemas:this.schemasById}}}const i=new k;L.Registry.add(e.Extensions.JSONContribution,i)}),define(te[39],ne([0,1,16,3,17,126,87,35]),function(X,e,R,L,D,k,i,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var S;(function(a){a.Multiline="multilineText",a.Singleline="singlelineText"})(S=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var C;(function(a){a[a.APPLICATION=1]="APPLICATION",a[a.MACHINE=2]="MACHINE",a[a.WINDOW=3]="WINDOW",a[a.RESOURCE=4]="RESOURCE",a[a.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",a[a.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(C=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const I=P.Registry.as(i.Extensions.JSONContribution);class E{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new L.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new L.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:k.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(l,r=!0){this.registerConfigurations([l],r)}registerConfigurations(l,r=!0){const o=this.doRegisterConfigurations(l,r);I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}deregisterConfigurations(l){const r=this.doDeregisterConfigurations(l);I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(r)}updateConfigurations({add:l,remove:r}){const o=[];o.push(...this.doDeregisterConfigurations(r)),o.push(...this.doRegisterConfigurations(l,!1)),I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire((0,R.distinct)(o))}registerDefaultConfigurations(l){const r=[],o=[];for(const n of l)for(const t in n)if(r.push(t),e.OVERRIDE_PROPERTY_REGEX.test(t)){this.defaultValues[t]={...this.defaultValues[t]||{},...n[t]};const s={type:"object",default:this.defaultValues[t],description:k.localize(1,null,t),$ref:e.resourceLanguageSettingsSchemaId};o.push(...h(t)),this.configurationProperties[t]=s,this.defaultLanguageConfigurationOverridesNode.properties[t]=s}else{this.defaultValues[t]=n[t];const s=this.configurationProperties[t];s&&(this.updatePropertyDefaultValue(t,s),this.updateSchema(t,s))}this.registerOverrideIdentifiers(o),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(r)}deregisterDefaultConfigurations(l){const r=[];for(const o of l)for(const n in o)if(r.push(n),delete this.defaultValues[n],e.OVERRIDE_PROPERTY_REGEX.test(n))delete this.configurationProperties[n],delete this.defaultLanguageConfigurationOverridesNode.properties[n];else{const t=this.configurationProperties[n];t&&(this.updatePropertyDefaultValue(n,t),this.updateSchema(n,t))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(r)}notifyConfigurationSchemaUpdated(...l){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(l){for(const r of l)this.overrideIdentifiers.add(r);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(l,r){const o=[];return l.forEach(n=>{o.push(...this.validateAndRegisterProperties(n,r,n.extensionInfo)),this.configurationContributors.push(n),this.registerJSONConfiguration(n)}),o}doDeregisterConfigurations(l){const r=[],o=n=>{if(n.properties)for(const t in n.properties)r.push(t),delete this.configurationProperties[t],this.removeFromSchema(t,n.properties[t]);n.allOf&&n.allOf.forEach(t=>o(t))};for(const n of l){o(n);const t=this.configurationContributors.indexOf(n);t!==-1&&this.configurationContributors.splice(t,1)}return r}validateAndRegisterProperties(l,r=!0,o,n=3){n=D.isUndefinedOrNull(l.scope)?n:l.scope;let t=[],s=l.properties;if(s)for(let u in s){if(r&&b(u)){delete s[u];continue}const f=s[u];if(this.updatePropertyDefaultValue(u,f),e.OVERRIDE_PROPERTY_REGEX.test(u)?f.scope=void 0:(f.scope=D.isUndefinedOrNull(f.scope)?n:f.scope,f.restricted=D.isUndefinedOrNull(f.restricted)?!!o?.restrictedConfigurations?.includes(u):f.restricted),s[u].hasOwnProperty("included")&&!s[u].included){this.excludedConfigurationProperties[u]=s[u],delete s[u];continue}else this.configurationProperties[u]=s[u];!s[u].deprecationMessage&&s[u].markdownDeprecationMessage&&(s[u].deprecationMessage=s[u].markdownDeprecationMessage),t.push(u)}let c=l.allOf;if(c)for(let u of c)t.push(...this.validateAndRegisterProperties(u,r,o,n));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(l){const r=o=>{let n=o.properties;if(n)for(const s in n)this.updateSchema(s,n[s]);let t=o.allOf;t&&t.forEach(r)};r(l)}updateSchema(l,r){switch(e.allSettings.properties[l]=r,r.scope){case 1:e.applicationSettings.properties[l]=r;break;case 2:e.machineSettings.properties[l]=r;break;case 6:e.machineOverridableSettings.properties[l]=r;break;case 3:e.windowSettings.properties[l]=r;break;case 4:e.resourceSettings.properties[l]=r;break;case 5:e.resourceSettings.properties[l]=r,this.resourceLanguageSettingsSchema.properties[l]=r;break}}removeFromSchema(l,r){switch(delete e.allSettings.properties[l],r.scope){case 1:delete e.applicationSettings.properties[l];break;case 2:delete e.machineSettings.properties[l];break;case 6:delete e.machineOverridableSettings.properties[l];break;case 3:delete e.windowSettings.properties[l];break;case 4:case 5:delete e.resourceSettings.properties[l];break}}updateOverridePropertyPatternKey(){for(const l of this.overrideIdentifiers.values()){const r=`[${l}]`,o={type:"object",description:k.localize(2,null),errorMessage:k.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(r,o),e.allSettings.properties[r]=o,e.applicationSettings.properties[r]=o,e.machineSettings.properties[r]=o,e.machineOverridableSettings.properties[r]=o,e.windowSettings.properties[r]=o,e.resourceSettings.properties[r]=o}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const l={type:"object",description:k.localize(4,null),errorMessage:k.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(l,r){let o=this.defaultValues[l];D.isUndefined(o)&&(o=r.default),D.isUndefined(o)&&(o=y(r.type)),r.default=o}}const d="\\[([^\\]]+)\\]",p=new RegExp(d,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${d})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function h(a){const l=[];if(e.OVERRIDE_PROPERTY_REGEX.test(a)){let r=p.exec(a);for(;r?.length;){const o=r[1].trim();o&&l.push(o),r=p.exec(a)}}return(0,R.distinct)(l)}e.overrideIdentifiersFromKey=h;function w(a){return a.reduce((l,r)=>`${l}[${r}]`,"")}e.keyFromOverrideIdentifiers=w;function y(a){switch(Array.isArray(a)?a[0]:a){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=y;const m=new E;P.Registry.add(e.Extensions.Configuration,m);function b(a){return a.trim()?e.OVERRIDE_PROPERTY_REGEX.test(a)?k.localize(7,null,a):m.getConfigurationProperties()[a]!==void 0?k.localize(8,null,a):null:k.localize(6,null)}e.validateProperty=b;function g(){const a=[],l=m.getConfigurationProperties();for(const r of Object.keys(l))a.push([r,l[r].scope]);return a.push(["launch",4]),a.push(["task",4]),a}e.getScopes=g}),define(te[21],ne([0,1,17,7,39,6,35]),function(X,e,R,L,D,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,k.createDecorator)("configurationService");function P(a){return a&&typeof a=="object"&&(!a.overrideIdentifier||typeof a.overrideIdentifier=="string")&&(!a.resource||a.resource instanceof L.URI)}e.isConfigurationOverrides=P;function S(a){return a&&typeof a=="object"&&(!a.overrideIdentifiers||R.isArray(a.overrideIdentifiers))&&!a.overrideIdentifier&&(!a.resource||a.resource instanceof L.URI)}e.isConfigurationUpdateOverrides=S;var C;(function(a){a[a.USER=1]="USER",a[a.USER_LOCAL=2]="USER_LOCAL",a[a.USER_REMOTE=3]="USER_REMOTE",a[a.WORKSPACE=4]="WORKSPACE",a[a.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",a[a.DEFAULT=6]="DEFAULT",a[a.MEMORY=7]="MEMORY"})(C=e.ConfigurationTarget||(e.ConfigurationTarget={}));function I(a){switch(a){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=I;function E(a,l){const r=Object.create(null);for(let o in a)d(r,o,a[o],l);return r}e.toValuesTree=E;function d(a,l,r,o){const n=l.split("."),t=n.pop();let s=a;for(let c=0;c<n.length;c++){let u=n[c],f=s[u];switch(typeof f){case"undefined":f=s[u]=Object.create(null);break;case"object":break;default:o(`Ignoring ${l} as ${n.slice(0,c+1).join(".")} is ${JSON.stringify(f)}`);return}s=f}if(typeof s=="object"&&s!==null)try{s[t]=r}catch(c){o(`Ignoring ${l} as ${n.join(".")} is ${JSON.stringify(s)}`)}else o(`Ignoring ${l} as ${n.join(".")} is ${JSON.stringify(s)}`)}e.addToValueTree=d;function p(a,l){const r=l.split(".");h(a,r)}e.removeFromValueTree=p;function h(a,l){const r=l.shift();if(l.length===0){delete a[r];return}if(Object.keys(a).indexOf(r)!==-1){const o=a[r];typeof o=="object"&&!Array.isArray(o)&&(h(o,l),Object.keys(o).length===0&&delete a[r])}}function w(a,l,r){function o(s,c){let u=s;for(const f of c){if(typeof u!="object"||u===null)return;u=u[f]}return u}const n=l.split("."),t=o(a,n);return typeof t=="undefined"?r:t}e.getConfigurationValue=w;function y(a,l,r){Object.keys(l).forEach(o=>{o!=="__proto__"&&(o in a?R.isObject(a[o])&&R.isObject(l[o])?y(a[o],l[o],r):r&&(a[o]=l[o]):a[o]=l[o])})}e.merge=y;function m(){const a=i.Registry.as(D.Extensions.Configuration).getConfigurationProperties();return Object.keys(a)}e.getConfigurationKeys=m;function b(){const a=Object.create(null),l=i.Registry.as(D.Extensions.Configuration).getConfigurationProperties();for(let r in l){let o=l[r].default;d(a,r,o,n=>console.error(`Conflict in default settings: ${n}`))}return a}e.getDefaultValues=b;function g(a,l,r){const o=a.inspect(l),n=a.inspect(r);return typeof o.userValue!="undefined"||typeof o.workspaceValue!="undefined"||typeof o.workspaceFolderValue!="undefined"?o.value:typeof n.userValue!="undefined"||typeof n.workspaceValue!="undefined"||typeof n.workspaceFolderValue!="undefined"?n.value:o.defaultValue}e.getMigratedSettingValue=g}),define(te[88],ne([0,1,16,3,32,2,41,28,17,7,21,39,35]),function(X,e,R,L,D,k,i,P,S,C,I,E,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class p{constructor(n={},t=[],s=[]){this._contents=n,this._keys=t,this._overrides=s,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(n){return n?(0,I.getConfigurationValue)(this.contents,n):this.contents}getOverrideValue(n,t){const s=this.getContentsForOverrideIdentifer(t);return s?n?(0,I.getConfigurationValue)(s,n):s:void 0}getKeysForOverrideIdentifier(n){const t=[];for(const s of this.overrides)s.identifiers.includes(n)&&t.push(...s.keys);return R.distinct(t)}getAllOverrideIdentifiers(){const n=[];for(const t of this.overrides)n.push(...t.identifiers);return R.distinct(n)}override(n){let t=this.overrideConfigurations.get(n);return t||(t=this.createOverrideConfigurationModel(n),this.overrideConfigurations.set(n,t)),t}merge(...n){const t=P.deepClone(this.contents),s=P.deepClone(this.overrides),c=[...this.keys];for(const u of n){this.mergeContents(t,u.contents);for(const f of u.overrides){const[v]=s.filter(T=>R.equals(T.identifiers,f.identifiers));v?(this.mergeContents(v.contents,f.contents),v.keys.push(...f.keys),v.keys=R.distinct(v.keys)):s.push(P.deepClone(f))}for(const f of u.keys)c.indexOf(f)===-1&&c.push(f)}return new p(t,c,s)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(n){const t=this.getContentsForOverrideIdentifer(n);if(!t||typeof t!="object"||!Object.keys(t).length)return this;let s={};for(const c of R.distinct([...Object.keys(this.contents),...Object.keys(t)])){let u=this.contents[c],f=t[c];f&&(typeof u=="object"&&typeof f=="object"?(u=P.deepClone(u),this.mergeContents(u,f)):u=f),s[c]=u}return new p(s,this.keys,this.overrides)}mergeContents(n,t){for(const s of Object.keys(t)){if(s in n&&S.isObject(n[s])&&S.isObject(t[s])){this.mergeContents(n[s],t[s]);continue}n[s]=P.deepClone(t[s])}}checkAndFreeze(n){return this.isFrozen&&!Object.isFrozen(n)?P.deepFreeze(n):n}getContentsForOverrideIdentifer(n){let t=null,s=null;const c=u=>{u&&(s?this.mergeContents(s,u):s=P.deepClone(u))};for(const u of this.overrides)R.equals(u.identifiers,[n])?t=u.contents:u.identifiers.includes(n)&&c(u.contents);return c(t),s}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(n,t){this.addKey(n),(0,I.addToValueTree)(this.contents,n,t,s=>{throw new Error(s)})}removeValue(n){this.removeKey(n)&&(0,I.removeFromValueTree)(this.contents,n)}addKey(n){let t=this.keys.length;for(let s=0;s<t;s++)n.indexOf(this.keys[s])===0&&(t=s);this.keys.splice(t,1,n)}removeKey(n){let t=this.keys.indexOf(n);return t!==-1?(this.keys.splice(t,1),!0):!1}}e.ConfigurationModel=p;class h extends p{constructor(){const n=(0,I.getDefaultValues)(),t=(0,I.getConfigurationKeys)(),s=[];for(const c of Object.keys(n))E.OVERRIDE_PROPERTY_REGEX.test(c)&&s.push({identifiers:(0,E.overrideIdentifiersFromKey)(c),keys:Object.keys(n[c]),contents:(0,I.toValuesTree)(n[c],u=>console.error(`Conflict in default settings file: ${u}`))});super(n,t,s)}}e.DefaultConfigurationModel=h;class w{constructor(n){this._name=n,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new p}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(n,t){if(!S.isUndefinedOrNull(n)){const s=this.doParseContent(n);this.parseRaw(s,t)}}reparse(n){this._raw&&this.parseRaw(this._raw,n)}parseRaw(n,t){this._raw=n;const{contents:s,keys:c,overrides:u,restricted:f}=this.doParseRaw(n,t);this._configurationModel=new p(s,c,u),this._restrictedConfigurations=f||[]}doParseContent(n){let t={},s=null,c=[],u=[],f=[];function v(O){Array.isArray(c)?c.push(O):s!==null&&(c[s]=O)}let T={onObjectBegin:()=>{let O={};v(O),u.push(c),c=O,s=null},onObjectProperty:O=>{s=O},onObjectEnd:()=>{c=u.pop()},onArrayBegin:()=>{let O=[];v(O),u.push(c),c=O,s=null},onArrayEnd:()=>{c=u.pop()},onLiteralValue:v,onError:(O,U,W)=>{f.push({error:O,offset:U,length:W})}};if(n)try{D.visit(n,T),t=c[0]||{}}catch(O){console.error(`Error while parsing settings file ${this._name}: ${O}`),this._parseErrors=[O]}return t}doParseRaw(n,t){const s=d.Registry.as(E.Extensions.Configuration).getConfigurationProperties(),c=this.filter(n,s,!0,t);n=c.raw;const u=(0,I.toValuesTree)(n,T=>console.error(`Conflict in settings file ${this._name}: ${T}`)),f=Object.keys(n),v=this.toOverrides(n,T=>console.error(`Conflict in settings file ${this._name}: ${T}`));return{contents:u,keys:f,overrides:v,restricted:c.restricted}}filter(n,t,s,c){if(!c?.scopes&&!c?.skipRestricted)return{raw:n,restricted:[]};const u={},f=[];for(let v in n)if(E.OVERRIDE_PROPERTY_REGEX.test(v)&&s){const T=this.filter(n[v],t,!1,c);u[v]=T.raw,f.push(...T.restricted)}else{const T=t[v],O=T?typeof T.scope!="undefined"?T.scope:3:void 0;T?.restricted&&f.push(v),(O===void 0||c.scopes===void 0||c.scopes.includes(O))&&(c.skipRestricted&&T?.restricted||(u[v]=n[v]))}return{raw:u,restricted:f}}toOverrides(n,t){const s=[];for(const c of Object.keys(n))if(E.OVERRIDE_PROPERTY_REGEX.test(c)){const u={};for(const f in n[c])u[f]=n[c][f];s.push({identifiers:(0,E.overrideIdentifiersFromKey)(c),keys:Object.keys(u),contents:(0,I.toValuesTree)(u,t)})}return s}}e.ConfigurationModelParser=w;class y extends k.Disposable{constructor(n,t,s,c){super();this.userSettingsResource=n,this.scopes=t,this.fileService=c,this._onDidChange=this._register(new L.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new w(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(s.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(L.Event.filter(this.fileService.onDidFilesChange,u=>u.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const n=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(n.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(n){return new p}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=y;class m{constructor(n,t,s=new p,c=new p,u=new i.ResourceMap,f=new p,v=new i.ResourceMap,T=!0){this._defaultConfiguration=n,this._localUserConfiguration=t,this._remoteUserConfiguration=s,this._workspaceConfiguration=c,this._folderConfigurations=u,this._memoryConfiguration=f,this._memoryConfigurationByResource=v,this._freeze=T,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new i.ResourceMap,this._userConfiguration=null}getValue(n,t,s){return this.getConsolidateConfigurationModel(t,s).getValue(n)}updateValue(n,t,s={}){let c;s.resource?(c=this._memoryConfigurationByResource.get(s.resource),c||(c=new p,this._memoryConfigurationByResource.set(s.resource,c))):c=this._memoryConfiguration,t===void 0?c.removeValue(n):c.setValue(n,t),s.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(n,t,s){const c=this.getConsolidateConfigurationModel(t,s),u=this.getFolderConfigurationModelForResource(t.resource,s),f=t.resource?this._memoryConfigurationByResource.get(t.resource)||this._memoryConfiguration:this._memoryConfiguration,v=t.overrideIdentifier?this._defaultConfiguration.freeze().override(t.overrideIdentifier).getValue(n):this._defaultConfiguration.freeze().getValue(n),T=t.overrideIdentifier?this.userConfiguration.freeze().override(t.overrideIdentifier).getValue(n):this.userConfiguration.freeze().getValue(n),O=t.overrideIdentifier?this.localUserConfiguration.freeze().override(t.overrideIdentifier).getValue(n):this.localUserConfiguration.freeze().getValue(n),U=t.overrideIdentifier?this.remoteUserConfiguration.freeze().override(t.overrideIdentifier).getValue(n):this.remoteUserConfiguration.freeze().getValue(n),W=s?t.overrideIdentifier?this._workspaceConfiguration.freeze().override(t.overrideIdentifier).getValue(n):this._workspaceConfiguration.freeze().getValue(n):void 0,N=u?t.overrideIdentifier?u.freeze().override(t.overrideIdentifier).getValue(n):u.freeze().getValue(n):void 0,A=t.overrideIdentifier?f.override(t.overrideIdentifier).getValue(n):f.getValue(n),z=c.getValue(n),_=R.distinct(R.flatten(c.overrides.map(M=>M.identifiers))).filter(M=>c.getOverrideValue(n,M)!==void 0);return{defaultValue:v,userValue:T,userLocalValue:O,userRemoteValue:U,workspaceValue:W,workspaceFolderValue:N,memoryValue:A,value:z,default:v!==void 0?{value:this._defaultConfiguration.freeze().getValue(n),override:t.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,user:T!==void 0?{value:this.userConfiguration.freeze().getValue(n),override:t.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,userLocal:O!==void 0?{value:this.localUserConfiguration.freeze().getValue(n),override:t.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,userRemote:U!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(n),override:t.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,workspace:W!==void 0?{value:this._workspaceConfiguration.freeze().getValue(n),override:t.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,workspaceFolder:N!==void 0?{value:u?.freeze().getValue(n),override:t.overrideIdentifier?u?.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,memory:A!==void 0?{value:f.getValue(n),override:t.overrideIdentifier?f.getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,overrideIdentifiers:_.length?_:void 0}}keys(n){const t=this.getFolderConfigurationModelForResource(void 0,n);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:t?t.freeze().keys:[]}}updateDefaultConfiguration(n){this._defaultConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(n){this._localUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(n){this._remoteUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(n){this._workspaceConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(n,t){this._folderConfigurations.set(n,t),this._foldersConsolidatedConfigurations.delete(n)}deleteFolderConfiguration(n){this.folderConfigurations.delete(n),this._foldersConsolidatedConfigurations.delete(n)}compareAndUpdateDefaultConfiguration(n,t){const s=[];for(const c of t)for(const u of(0,E.overrideIdentifiersFromKey)(c)){const f=this._defaultConfiguration.getKeysForOverrideIdentifier(u),v=n.getKeysForOverrideIdentifier(u),T=[...v.filter(O=>f.indexOf(O)===-1),...f.filter(O=>v.indexOf(O)===-1),...f.filter(O=>!P.equals(this._defaultConfiguration.override(u).getValue(O),n.override(u).getValue(O)))];s.push([u,T])}return this.updateDefaultConfiguration(n),{keys:t,overrides:s}}compareAndUpdateLocalUserConfiguration(n){const{added:t,updated:s,removed:c,overrides:u}=l(this.localUserConfiguration,n),f=[...t,...s,...c];return f.length&&this.updateLocalUserConfiguration(n),{keys:f,overrides:u}}compareAndUpdateRemoteUserConfiguration(n){const{added:t,updated:s,removed:c,overrides:u}=l(this.remoteUserConfiguration,n);let f=[...t,...s,...c];return f.length&&this.updateRemoteUserConfiguration(n),{keys:f,overrides:u}}compareAndUpdateWorkspaceConfiguration(n){const{added:t,updated:s,removed:c,overrides:u}=l(this.workspaceConfiguration,n);let f=[...t,...s,...c];return f.length&&this.updateWorkspaceConfiguration(n),{keys:f,overrides:u}}compareAndUpdateFolderConfiguration(n,t){const s=this.folderConfigurations.get(n),{added:c,updated:u,removed:f,overrides:v}=l(s,t);let T=[...c,...u,...f];return(T.length||!s)&&this.updateFolderConfiguration(n,t),{keys:T,overrides:v}}compareAndDeleteFolderConfiguration(n){const t=this.folderConfigurations.get(n);if(!t)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:s,updated:c,removed:u,overrides:f}=l(t,void 0);return{keys:[...s,...c,...u],overrides:f}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(n,t){let s=this.getConsolidatedConfigurationModelForResource(n,t);return n.overrideIdentifier?s.override(n.overrideIdentifier):s}getConsolidatedConfigurationModelForResource({resource:n},t){let s=this.getWorkspaceConsolidatedConfiguration();if(t&&n){const c=t.getFolder(n);c&&(s=this.getFolderConsolidatedConfiguration(c.uri)||s);const u=this._memoryConfigurationByResource.get(n);u&&(s=s.merge(u))}return s}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(n){let t=this._foldersConsolidatedConfigurations.get(n);if(!t){const s=this.getWorkspaceConsolidatedConfiguration(),c=this._folderConfigurations.get(n);c?(t=s.merge(c),this._freeze&&(t=t.freeze()),this._foldersConsolidatedConfigurations.set(n,t)):t=s}return t}getFolderConfigurationModelForResource(n,t){if(t&&n){const s=t.getFolder(n);if(s)return this._folderConfigurations.get(s.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((n,t)=>{const{contents:s,overrides:c,keys:u}=this._folderConfigurations.get(t);return n.push([t,{contents:s,overrides:c,keys:u}]),n},[])}}allKeys(){const n=new Set;return this._defaultConfiguration.freeze().keys.forEach(t=>n.add(t)),this.userConfiguration.freeze().keys.forEach(t=>n.add(t)),this._workspaceConfiguration.freeze().keys.forEach(t=>n.add(t)),this._folderConfigurations.forEach(t=>t.freeze().keys.forEach(s=>n.add(s))),[...n.values()]}allOverrideIdentifiers(){const n=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>n.add(t)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>n.add(t)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>n.add(t)),this._folderConfigurations.forEach(t=>t.freeze().getAllOverrideIdentifiers().forEach(s=>n.add(s))),[...n.values()]}getAllKeysForOverrideIdentifier(n){const t=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(n).forEach(s=>t.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(s=>t.add(s)),this._workspaceConfiguration.getKeysForOverrideIdentifier(n).forEach(s=>t.add(s)),this._folderConfigurations.forEach(s=>s.getKeysForOverrideIdentifier(n).forEach(c=>t.add(c))),[...t.values()]}static parse(n){const t=this.parseConfigurationModel(n.defaults),s=this.parseConfigurationModel(n.user),c=this.parseConfigurationModel(n.workspace),u=n.folders.reduce((f,v)=>(f.set(C.URI.revive(v[0]),this.parseConfigurationModel(v[1])),f),new i.ResourceMap);return new m(t,s,new p,c,u,new p,new i.ResourceMap,!1)}static parseConfigurationModel(n){return new p(n.contents,n.keys,n.overrides).freeze()}}e.Configuration=m;function b(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const n=new Set,t=new Map;for(const c of o)c.keys.forEach(u=>n.add(u)),c.overrides.forEach(([u,f])=>{const v=(0,i.getOrSet)(t,u,new Set);f.forEach(T=>v.add(T))});const s=[];return t.forEach((c,u)=>s.push([u,[...c.values()]])),{keys:[...n.values()],overrides:s}}e.mergeChanges=b;class g{constructor(n,t,s,c){this.change=n,this.previous=t,this.currentConfiguraiton=s,this.currentWorkspace=c,this._previousConfiguration=void 0;const u=new Set;n.keys.forEach(v=>u.add(v)),n.overrides.forEach(([,v])=>v.forEach(T=>u.add(T))),this.affectedKeys=[...u.values()];const f=new p;this.affectedKeys.forEach(v=>f.setValue(v,{})),this.affectedKeysTree=f.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=m.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(n,t){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,n)){if(t){const s=this.previousConfiguration?this.previousConfiguration.getValue(n,t,this.previous?.workspace):void 0,c=this.currentConfiguraiton.getValue(n,t,this.currentWorkspace);return!P.equals(s,c)}return!0}return!1}doesAffectedKeysTreeContains(n,t){let s=(0,I.toValuesTree)({[t]:!0},()=>{}),c;for(;typeof s=="object"&&(c=Object.keys(s)[0]);){if(n=n[c],!n)return!1;s=s[c]}return!0}}e.ConfigurationChangeEvent=g;class a extends g{constructor(n,t,s,c){super({keys:n.allKeys(),overrides:[]},void 0,n,t);this.source=s,this.sourceConfig=c}}e.AllKeysConfigurationChangeEvent=a;function l(o,n){const{added:t,removed:s,updated:c}=r(n,o),u=[],f=o?.getAllOverrideIdentifiers()||[],v=n?.getAllOverrideIdentifiers()||[];if(n){const T=v.filter(O=>!f.includes(O));for(const O of T)u.push([O,n.getKeysForOverrideIdentifier(O)])}if(o){const T=f.filter(O=>!v.includes(O));for(const O of T)u.push([O,o.getKeysForOverrideIdentifier(O)])}if(n&&o){for(const T of f)if(v.includes(T)){const O=r({contents:o.getOverrideValue(void 0,T)||{},keys:o.getKeysForOverrideIdentifier(T)},{contents:n.getOverrideValue(void 0,T)||{},keys:n.getKeysForOverrideIdentifier(T)});u.push([T,[...O.added,...O.removed,...O.updated]])}}return{added:t,removed:s,updated:c,overrides:u}}function r(o,n){const t=o?n?o.keys.filter(u=>n.keys.indexOf(u)===-1):[...o.keys]:[],s=n?o?n.keys.filter(u=>o.keys.indexOf(u)===-1):[...n.keys]:[],c=[];if(o&&n){for(const u of n.keys)if(o.keys.indexOf(u)!==-1){const f=(0,I.getConfigurationValue)(n.contents,u),v=(0,I.getConfigurationValue)(o.contents,u);P.equals(f,v)||c.push(u)}}return{added:t,removed:s,updated:c}}}),define(te[182],ne([0,1,5,3,2,18,21,88,39,35]),function(X,e,R,L,D,k,i,P,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class I extends D.Disposable{constructor(d,p){super();this.settingsResource=d,this._onDidChangeConfiguration=this._register(new L.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new P.UserSettings(this.settingsResource,void 0,k.extUriBiasedIgnorePathCase,p)),this.configuration=new P.Configuration(new P.DefaultConfigurationModel,new P.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new R.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(C.Registry.as(S.Extensions.Configuration).onDidUpdateConfiguration(h=>this.onDidDefaultConfigurationChange(h))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const d=await this.userConfiguration.loadConfiguration();this.configuration=new P.Configuration(new P.DefaultConfigurationModel,d)}getConfigurationData(){return this.configuration.toData()}getValue(d,p){const h=typeof d=="string"?d:void 0,w=(0,i.isConfigurationOverrides)(d)?d:(0,i.isConfigurationOverrides)(p)?p:{};return this.configuration.getValue(h,w,void 0)}updateValue(d,p,h,w){return Promise.reject(new Error("not supported"))}inspect(d){return this.configuration.inspect(d,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const d=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(d)}onDidChangeUserConfiguration(d){const p=this.configuration.toData(),h=this.configuration.compareAndUpdateLocalUserConfiguration(d);this.trigger(h,p,1)}onDidDefaultConfigurationChange(d){const p=this.configuration.toData(),h=this.configuration.compareAndUpdateDefaultConfiguration(new P.DefaultConfigurationModel,d);this.trigger(h,p,6)}trigger(d,p,h){const w=new P.ConfigurationChangeEvent(d,{data:p},this.configuration);w.source=h,w.sourceConfig=this.getTargetConfiguration(h),this._onDidChangeConfiguration.fire(w)}getTargetConfiguration(d){switch(d){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=I}),define(te[183],ne([0,1,6]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,R.createDecorator)("remoteAuthorityResolverService");var L;(function(k){k.Unknown="Unknown",k.NotAvailable="NotAvailable",k.TemporarilyNotAvailable="TemporarilyNotAvailable",k.NoResolverFound="NoResolverFound"})(L=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class D extends Error{constructor(i,P=L.Unknown,S){super(i);this._message=i,this._code=P,this._detail=S,this.isHandled=P===L.NotAvailable&&S===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,D.prototype)}static isTemporarilyNotAvailable(i){return i instanceof D&&i._code===L.TemporarilyNotAvailable}static isNoResolverFound(i){return i instanceof D&&i._code===L.NoResolverFound}static isHandled(i){return i instanceof D&&i.isHandled}}e.RemoteAuthorityResolverError=D}),define(te[184],ne([0,1,5,19,27,9,3,2,29,71,183]),function(X,e,R,L,D,k,i,P,S,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const E=30*1e3;var d;(function(F){F[F.Management=1]="Management",F[F.ExtensionHost=2]="ExtensionHost",F[F.Tunnel=3]="Tunnel"})(d=e.ConnectionType||(e.ConnectionType={}));function p(F){switch(F){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function h(F){const x=new D.CancellationTokenSource;return setTimeout(()=>x.cancel(),F),x.token}function w(F,x){if(F.isCancellationRequested||x.isCancellationRequested)return D.CancellationToken.Cancelled;const V=new D.CancellationTokenSource;return F.onCancellationRequested(()=>V.cancel()),x.onCancellationRequested(()=>V.cancel()),V.token}class y{constructor(x){this._state="pending",this._disposables=new P.DisposableStore,this.promise=new Promise((V,Q)=>{this._resolvePromise=V,this._rejectPromise=Q}),x.isCancellationRequested?this._timeout():this._disposables.add(x.onCancellationRequested(()=>this._timeout()))}get didTimeout(){return this._state==="timedout"}registerDisposable(x){this._state==="pending"?this._disposables.add(x):x.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const x=new Error("Time limit reached");return x.code="ETIMEDOUT",x.syscall="connect",x}resolve(x){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(x))}reject(x){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(x))}}function m(F,x){const V=new y(x);return V.registerDisposable(F.onControlMessage(Q=>{const Z=JSON.parse(Q.toString()),G=q(Z);G?V.reject(G):V.resolve(Z)})),V.promise}function b(F,x,V,Q,Z,G){const H=new y(G);return x.connect(V,Q,Z,(re,ie)=>{H.didTimeout?(re&&F.error(re),ie?.dispose()):re||!ie?H.reject(re):H.resolve(ie)}),H.promise}function g(F,x){const V=new y(x);return F.then(Q=>{V.didTimeout||V.resolve(Q)},Q=>{V.didTimeout||V.reject(Q)}),V.promise}async function a(F,x,V,Q){const Z=$(F,x);F.logService.trace(`${Z} 1/6. invoking socketFactory.connect().`);let G;try{G=await b(F.logService,F.socketFactory,F.host,F.port,`reconnectionToken=${F.reconnectionToken}&reconnection=${F.reconnectionProtocol?"true":"false"}`,Q)}catch(le){throw F.logService.error(`${Z} socketFactory.connect() failed or timed out. Error:`),F.logService.error(le),le}F.logService.trace(`${Z} 2/6. socketFactory.connect() was successful.`);let H,re;F.reconnectionProtocol?(F.reconnectionProtocol.beginAcceptReconnection(G,null),H=F.reconnectionProtocol,re=!1):(H=new C.PersistentProtocol(G,null),re=!0),F.logService.trace(`${Z} 3/6. sending AuthRequest control message.`);const ie=await g(F.signService.createNewMessage((0,S.generateUuid)()),Q),ce={type:"auth",auth:F.connectionToken||"00000000000000000000",data:ie.data};H.sendControl(L.VSBuffer.fromString(JSON.stringify(ce)));try{const le=await m(H,w(Q,h(1e4)));if(le.type!=="sign"||typeof le.data!="string"){const Ie=new Error("Unexpected handshake message");throw Ie.code="VSCODE_CONNECTION_ERROR",Ie}if(F.logService.trace(`${Z} 4/6. received SignRequest control message.`),!await g(F.signService.validate(ie,le.signedData),Q)){const Ie=new Error("Refused to connect to unsupported server");throw Ie.code="VSCODE_CONNECTION_ERROR",Ie}const pe=await g(F.signService.sign(le.data),Q),be={type:"connectionType",commit:F.commit,signedData:pe,desiredConnectionType:x};return V&&(be.args=V),F.logService.trace(`${Z} 5/6. sending ConnectionTypeRequest control message.`),H.sendControl(L.VSBuffer.fromString(JSON.stringify(be))),{protocol:H,ownsProtocol:re}}catch(le){throw le&&le.code==="ETIMEDOUT"&&(F.logService.error(`${Z} the handshake timed out. Error:`),F.logService.error(le)),le&&le.code==="VSCODE_CONNECTION_ERROR"&&(F.logService.error(`${Z} received error control message when negotiating connection. Error:`),F.logService.error(le)),re&&M(H),le}}async function l(F,x,V,Q){const Z=Date.now(),G=$(F,x),{protocol:H,ownsProtocol:re}=await a(F,x,V,Q),ie=new y(Q);return ie.registerDisposable(H.onControlMessage(ce=>{const le=JSON.parse(ce.toString()),de=q(le);de?(F.logService.error(`${G} received error control message when negotiating connection. Error:`),F.logService.error(de),re&&M(H),ie.reject(de)):(F.reconnectionProtocol&&F.reconnectionProtocol.endAcceptReconnection(),F.logService.trace(`${G} 6/6. handshake finished, connection is up and running after ${K(Z)}!`),ie.resolve({protocol:H,firstMessage:le}))})),ie.promise}async function r(F,x){const{protocol:V}=await l(F,1,void 0,x);return{protocol:V}}async function o(F,x,V){const{protocol:Q,firstMessage:Z}=await l(F,2,x,V),G=Z&&Z.debugPort;return{protocol:Q,debugPort:G}}async function n(F,x,V){const Q=Date.now(),Z=$(F,3),{protocol:G}=await a(F,3,x,V);return F.logService.trace(`${Z} 6/6. handshake finished, connection is up and running after ${K(Q)}!`),G}async function t(F,x,V){const{host:Q,port:Z,connectionToken:G}=await F.addressProvider.getAddress();return{commit:F.commit,host:Q,port:Z,connectionToken:G,reconnectionToken:x,reconnectionProtocol:V,socketFactory:F.socketFactory,signService:F.signService,logService:F.logService}}async function s(F,x,V){try{const Q=(0,S.generateUuid)(),Z=await t(F,Q,null),{protocol:G}=await r(Z,D.CancellationToken.None);return new z(F,x,V,Q,G)}catch(Q){throw F.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),F.logService.error(Q),A.triggerPermanentFailure(0,0,I.RemoteAuthorityResolverError.isHandled(Q)),Q}}e.connectRemoteAgentManagement=s;async function c(F,x){try{const V=(0,S.generateUuid)(),Q=await t(F,V,null),{protocol:Z,debugPort:G}=await o(Q,x,D.CancellationToken.None);return new _(F,x,V,Z,G)}catch(V){throw F.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),F.logService.error(V),A.triggerPermanentFailure(0,0,I.RemoteAuthorityResolverError.isHandled(V)),V}}e.connectRemoteAgentExtensionHost=c;async function u(F,x,V){const Q=await t(F,(0,S.generateUuid)(),null);return await n(Q,{host:x,port:V},D.CancellationToken.None)}e.connectRemoteAgentTunnel=u;function f(F){return(0,R.createCancelablePromise)(x=>new Promise((V,Q)=>{const Z=setTimeout(V,F*1e3);x.onCancellationRequested(()=>{clearTimeout(Z),V()})}))}var v;(function(F){F[F.ConnectionLost=0]="ConnectionLost",F[F.ReconnectionWait=1]="ReconnectionWait",F[F.ReconnectionRunning=2]="ReconnectionRunning",F[F.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",F[F.ConnectionGain=4]="ConnectionGain"})(v=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class T{constructor(x,V){this.reconnectionToken=x,this.millisSinceLastIncomingData=V,this.type=0}}e.ConnectionLostEvent=T;class O{constructor(x,V,Q,Z){this.reconnectionToken=x,this.millisSinceLastIncomingData=V,this.durationSeconds=Q,this.cancellableTimer=Z,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=O;class U{constructor(x,V,Q){this.reconnectionToken=x,this.millisSinceLastIncomingData=V,this.attempt=Q,this.type=2}}e.ReconnectionRunningEvent=U;class W{constructor(x,V,Q){this.reconnectionToken=x,this.millisSinceLastIncomingData=V,this.attempt=Q,this.type=4}}e.ConnectionGainEvent=W;class N{constructor(x,V,Q,Z){this.reconnectionToken=x,this.millisSinceLastIncomingData=V,this.attempt=Q,this.handled=Z,this.type=3}}e.ReconnectionPermanentFailureEvent=N;class A extends P.Disposable{constructor(x,V,Q,Z){super();this._connectionType=x,this._onDidStateChange=this._register(new i.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._options=V,this.reconnectionToken=Q,this.protocol=Z,this._isReconnecting=!1,this._onDidStateChange.fire(new W(this.reconnectionToken,0,0)),this._register(Z.onSocketClose(G=>{const H=j(this._connectionType,this.reconnectionToken,!0);G?G.type===0?(this._options.logService.info(`${H} received socket close event (hadError: ${G.hadError}).`),G.error&&this._options.logService.error(G.error)):(this._options.logService.info(`${H} received socket close event (wasClean: ${G.wasClean}, code: ${G.code}, reason: ${G.reason}).`),G.event&&this._options.logService.error(G.event)):this._options.logService.info(`${H} received socket close event.`),this._beginReconnecting()})),this._register(Z.onSocketTimeout(()=>{const G=j(this._connectionType,this.reconnectionToken,!0);this._options.logService.trace(`${G} received socket timeout event.`),this._beginReconnecting()})),A._instances.push(this),A._permanentFailure&&this._gotoPermanentFailure(A._permanentFailureMillisSinceLastIncomingData,A._permanentFailureAttempt,A._permanentFailureHandled)}static triggerPermanentFailure(x,V,Q){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=x,this._permanentFailureAttempt=V,this._permanentFailureHandled=Q,this._instances.forEach(Z=>Z._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(A._permanentFailure)return;const x=j(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${x} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new T(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const V=[0,5,5,10,10,10,10,10,30];let Q=-1;do{Q++;const Z=Q<V.length?V[Q]:V[V.length-1];try{if(Z>0){const H=f(Z);this._onDidStateChange.fire(new O(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Z,H)),this._options.logService.info(`${x} waiting for ${Z} seconds before reconnecting...`);try{await H}catch{}}if(A._permanentFailure){this._options.logService.error(`${x} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new U(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Q+1)),this._options.logService.info(`${x} resolving connection...`);const G=await t(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${x} connecting to ${G.host}:${G.port}...`),await this._reconnect(G,h(E)),this._options.logService.info(`${x} reconnected!`),this._onDidStateChange.fire(new W(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Q+1));break}catch(G){if(G.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${x} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(G),A.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),Q+1,!1);break}if(Q>360){this._options.logService.error(`${x} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(G),A.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),Q+1,!1);break}if(I.RemoteAuthorityResolverError.isTemporarilyNotAvailable(G)){this._options.logService.info(`${x} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(G);continue}if((G.code==="ETIMEDOUT"||G.code==="ENETUNREACH"||G.code==="ECONNREFUSED"||G.code==="ECONNRESET")&&G.syscall==="connect"){this._options.logService.info(`${x} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(G);continue}if((0,k.isPromiseCanceledError)(G)){this._options.logService.info(`${x} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(G);continue}if(G instanceof I.RemoteAuthorityResolverError){this._options.logService.error(`${x} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(G),A.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),Q+1,I.RemoteAuthorityResolverError.isHandled(G));break}this._options.logService.error(`${x} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(G),A.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),Q+1,!1);break}}while(!A._permanentFailure)}_gotoPermanentFailure(x,V,Q){this._onDidStateChange.fire(new N(this.reconnectionToken,x,V,Q)),M(this.protocol)}}A._permanentFailure=!1,A._permanentFailureMillisSinceLastIncomingData=0,A._permanentFailureAttempt=0,A._permanentFailureHandled=!1,A._instances=[];class z extends A{constructor(x,V,Q,Z,G){super(1,x,Z,G);this.client=this._register(new C.Client(G,{remoteAuthority:V,clientId:Q},x.ipcLogger))}async _reconnect(x,V){await r(x,V)}}e.ManagementPersistentConnection=z;class _ extends A{constructor(x,V,Q,Z,G){super(2,x,Q,Z);this._startArguments=V,this.debugPort=G}async _reconnect(x,V){await o(x,this._startArguments,V)}}e.ExtensionHostPersistentConnection=_;function M(F){try{F.acceptDisconnect();const x=F.getSocket();F.dispose(),x.dispose()}catch(x){(0,k.onUnexpectedError)(x)}}function q(F){if(F&&F.type==="error"){const x=new Error(`Connection error: ${F.reason}`);return x.code="VSCODE_CONNECTION_ERROR",x}return null}function B(F,x){for(;F.length<x;)F+=" ";return F}function j(F,x,V){return`[remote-connection][${B(p(F),13)}][${x.substr(0,5)}\u2026][${V?"reconnect":"initial"}]`}function $(F,x){return`${j(x,F.reconnectionToken,!!F.reconnectionProtocol)}[${F.host}:${F.port}]`}function K(F){return`${Date.now()-F} ms`}}),define(te[185],ne([0,1,15]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function L(C){return C.scheme===R.Schemas.vscodeRemote?C.authority:void 0}e.getRemoteAuthority=L;function D(C){if(!C)return;const I=C.indexOf("+");return I<0?C:C.substr(0,I)}e.getRemoteName=D;function k(C){return C.scheme!==R.Schemas.file&&C.scheme!==R.Schemas.vscodeRemote}e.isVirtualResource=k;function i(C){if(C.folders.length)return C.folders.every(I=>k(I.uri))?C.folders[0].uri:void 0;if(C.configuration&&k(C.configuration))return C.configuration}e.getVirtualWorkspaceLocation=i;function P(C){return i(C)?.scheme}e.getVirtualWorkspaceScheme=P;function S(C){return i(C)!==void 0}e.isVirtualWorkspace=S}),define(te[89],ne([0,1,25,6,185]),function(X,e,R,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function k(d){if(typeof d=="object"&&d!==null&&d.supported!==!0)return d.description}e.getWorkspaceSupportTypeMessage=k;function i(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(!d.uuid||typeof d.uuid=="string")}e.isIExtensionIdentifier=i,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var P;(function(d){d[d.System=0]="System",d[d.User=1]="User"})(P=e.ExtensionType||(e.ExtensionType={}));class S{constructor(p){this.value=p,this._lower=p.toLowerCase()}static equals(p,h){if(typeof p=="undefined"||p===null)return typeof h=="undefined"||h===null;if(typeof h=="undefined"||h===null)return!1;if(typeof p=="string"||typeof h=="string"){let w=typeof p=="string"?p:p.value,y=typeof h=="string"?h:h.value;return R.equalsIgnoreCase(w,y)}return p._lower===h._lower}static toKey(p){return typeof p=="string"?p.toLowerCase():p._lower}}e.ExtensionIdentifier=S;function C(d){return d.contributes&&d.contributes.localizations?d.contributes.localizations.length>0:!1}e.isLanguagePackExtension=C;function I(d){return d.contributes&&d.contributes.authentication?d.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=I;function E(d,p){if(p){const h=`onResolveRemoteAuthority:${(0,D.getRemoteName)(p)}`;return d.activationEvents?.indexOf(h)!==-1}return!1}e.isResolverExtension=E,e.IBuiltinExtensionsScannerService=(0,L.createDecorator)("IBuiltinExtensionsScannerService")}),define(te[36],ne([0,1,25,89]),function(X,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function D(h,w){return h.uuid&&w.uuid?h.uuid===w.uuid:h.id===w.id?!0:(0,R.compareIgnoreCase)(h.id,w.id)===0}e.areSameExtensions=D;class k{constructor(w,y){this.version=y,this.id=w.id,this.uuid=w.uuid}key(){return`${this.id}-${this.version}`}equals(w){return w instanceof k?D(this,w)&&this.version===w.version:!1}}e.ExtensionIdentifierWithVersion=k;function i(h,w){return`${h}.${w}`}e.getExtensionId=i;function P(h){return h.toLocaleLowerCase()}e.adoptToGalleryExtensionId=P;function S(h,w){return P(i(h,w))}e.getGalleryExtensionId=S;function C(h,w){const y=[],m=b=>{for(const g of y)if(g.some(a=>D(w(a),w(b))))return g;return null};for(const b of h){const g=m(b);g?g.push(b):y.push([b])}return y}e.groupByExtension=C;function I(h){return{id:h.identifier.id,name:h.manifest.name,galleryId:null,publisherId:h.publisherId,publisherName:h.manifest.publisher,publisherDisplayName:h.publisherDisplayName,dependencies:h.manifest.extensionDependencies&&h.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=I;function E(h){return{id:h.identifier.id,name:h.name,galleryId:h.identifier.uuid,publisherId:h.publisherId,publisherName:h.publisher,publisherDisplayName:h.publisherDisplayName,dependencies:!!(h.properties.dependencies&&h.properties.dependencies.length>0),...h.telemetryData}}e.getGalleryExtensionTelemetryData=E,e.BetterMergeId=new L.ExtensionIdentifier("pprice.better-merge");function d(h){const w=new Set;for(const y of h)y.malicious&&w.add(y.id.id);return w}e.getMaliciousExtensionsSet=d;function p(h,w){const y=[],m=w.manifest.extensionDependencies?.slice(0)??[];for(;m.length;){const b=m.shift();if(b&&y.every(g=>!D(g.identifier,{id:b}))){const g=h.filter(a=>D(a.identifier,{id:b}));g.length===1&&(y.push(g[0]),m.push(...g[0].manifest.extensionDependencies?.slice(0)??[]))}}return y}e.getExtensionDependencies=p}),define(te[186],ne([0,1,5,9,2,4,18,61,7,29,20,11,30,36,14,8]),function(X,e,R,L,D,k,i,P,S,C,I,E,d,p,h,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;const y=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let m=class extends D.Disposable{constructor(g,a,l,r){super();this.fileService=a,this.extensionGalleryService=l,this.logService=r,this.extensionsDownloadDir=S.URI.file(g.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(g,a){await this.cleanUpPromise;const l=this.getName(g),r=(0,i.joinPath)(this.extensionsDownloadDir,l);if(!await this.fileService.exists(r)){const o=(0,i.joinPath)(this.extensionsDownloadDir,`.${(0,C.generateUuid)()}`);await this.fileService.exists(o)||await this.extensionGalleryService.download(g,o,a);try{await this.rename(o,r,Date.now()+2*60*1e3)}catch(n){try{await this.fileService.del(o)}catch(t){}if(n.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",g.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,L.getErrorMessage)(n)}. Deleted the vsix from downloaded location`,o.path),n}}return r}async delete(g){await this.cleanUpPromise,await this.fileService.del(g)}async rename(g,a,l){try{await I.Promises.rename(g.fsPath,a.fsPath)}catch(r){if(k.isWindows&&r&&r.code==="EPERM"&&Date.now()<l)return this.logService.info(`Failed renaming ${g} to ${a} with 'EPERM' error. Trying again...`),this.rename(g,a,l);throw r}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const g=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(g.children){const a=[],l=[];for(const n of g.children){const t=this.parse(n.name);t&&l.push([t,n])}const r=(0,p.groupByExtension)(l,([n])=>n),o=[];for(const n of r)n.sort((t,s)=>P.rcompare(t[0].version,s[0].version)),a.push(...n.slice(1).map(t=>t[1].resource)),o.push(n[0][1]);o.sort((n,t)=>n.mtime-t.mtime),a.push(...o.slice(0,Math.max(0,o.length-this.cache)).map(n=>n.resource)),await R.Promises.settled(a.map(n=>(this.logService.trace("Deleting vsix from cache",n.path),this.fileService.del(n))))}}catch(g){this.logService.error(g)}}getName(g){return this.cache?`${new p.ExtensionIdentifierWithVersion(g.identifier,g.version).key().toLowerCase()}${g.properties.targetPlatform!=="undefined"?`-${g.properties.targetPlatform}`:""}`:(0,C.generateUuid)()}parse(g){const a=y.exec(g);return a&&a[1]&&a[2]?new p.ExtensionIdentifierWithVersion({id:a[1]},a[2]):null}};m=he([J(0,E.INativeEnvironmentService),J(1,h.IFileService),J(2,d.IExtensionGalleryService),J(3,w.ILogService)],m),e.ExtensionsDownloader=m}),define(te[187],ne([0,1,2,10,20,89]),function(X,e,R,L,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class i extends R.Disposable{constructor(S,C){super();this.environmentService=S,this.extensionsManifestCache=(0,L.join)(this.environmentService.userDataPath,k.MANIFEST_CACHE_FOLDER,k.USER_MANIFEST_CACHE_FILE),this._register(C.onDidInstallExtensions(I=>this.onDidInstallExtensions(I))),this._register(C.onDidUninstallExtension(I=>this.onDidUnInstallExtension(I)))}onDidInstallExtensions(S){S.some(C=>!!C.local)&&this.invalidate()}onDidUnInstallExtension(S){S.error||this.invalidate()}invalidate(){D.Promises.rm(this.extensionsManifestCache,D.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=i}),define(te[188],ne([0,1,81,16,5,2,15,10,20,11,30,36,59,8]),function(X,e,R,L,D,k,i,P,S,C,I,E,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsService=void 0;let h=class extends k.Disposable{constructor(m,b,g){super();this.extensionManagementService=m,this.logService=g,this.cache=this._register(new w(b,g)),this.extensionManagementService.registerParticipant({postInstall:async a=>this.postInstallExtension(a),postUninstall:async a=>this.postUninstallExtension(a)})}async getLanguageIds(){const m=await this.cache.getLanguagePacks(),b=["en",...Object.keys(m)];return(0,L.distinct)(b)}async postInstallExtension(m){m&&m.manifest&&m.manifest.contributes&&m.manifest.contributes.localizations&&m.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",m.identifier.id),await this.update())}async postUninstallExtension(m){const b=await this.cache.getLanguagePacks();Object.keys(b).some(g=>b[g]&&b[g].extensions.some(a=>(0,E.areSameExtensions)(a.extensionIdentifier,m.identifier)))&&(this.logService.info("Removing language packs from the extension",m.identifier.id),await this.update())}async update(){const[m,b]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),g=await this.cache.update(b);return!(0,L.equals)(Object.keys(m),Object.keys(g))}};h=he([J(0,I.IExtensionManagementService),J(1,C.INativeEnvironmentService),J(2,p.ILogService)],h),e.LocalizationsService=h;let w=class extends k.Disposable{constructor(m,b){super();this.logService=b,this.languagePacks={},this.languagePacksFilePath=(0,P.join)(m.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new D.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(m){return this.withLanguagePacks(b=>{Object.keys(b).forEach(g=>delete b[g]),this.createLanguagePacksFromExtensions(b,...m)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(m,...b){for(const g of b)g&&g.manifest&&g.manifest.contributes&&g.manifest.contributes.localizations&&g.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(m,g);Object.keys(m).forEach(g=>this.updateHash(m[g]))}createLanguagePacksFromExtension(m,b){const g=b.identifier,a=b.manifest.contributes&&b.manifest.contributes.localizations?b.manifest.contributes.localizations:[];for(const l of a)if(b.location.scheme===i.Schemas.file&&(0,d.isValidLocalization)(l)){let r=m[l.languageId];r||(r={hash:"",extensions:[],translations:{}},m[l.languageId]=r);let o=r.extensions.filter(n=>(0,E.areSameExtensions)(n.extensionIdentifier,g))[0];o?o.version=b.manifest.version:r.extensions.push({extensionIdentifier:g,version:b.manifest.version});for(const n of l.translations)r.translations[n.id]=(0,P.join)(b.location.fsPath,n.path)}}updateHash(m){if(m){const b=(0,R.createHash)("md5");for(const g of m.extensions)b.update(g.extensionIdentifier.uuid||g.extensionIdentifier.id).update(g.version);m.hash=b.digest("hex")}}withLanguagePacks(m=()=>null){return this.languagePacksFileLimiter.queue(()=>{let b=null;return S.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,g=>g.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(g)).then(g=>{try{return JSON.parse(g)}catch(a){return{}}}).then(g=>(b=m(g),g)).then(g=>{for(const l of Object.keys(g))g[l]||delete g[l];this.languagePacks=g,this.initializedCache=!0;const a=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",a),S.Promises.writeFile(this.languagePacksFilePath,a)}).then(()=>b,g=>this.logService.error(g))})}};w=he([J(0,C.INativeEnvironmentService),J(1,p.ILogService)],w)}),define(te[189],ne([0,1,6]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessTunnelChannelName=e.ISharedProcessTunnelService=void 0,e.ISharedProcessTunnelService=(0,R.createDecorator)("sharedProcessTunnelService"),e.ipcSharedProcessTunnelChannelName="sharedProcessTunnel"}),define(te[62],ne([0,1,3,4,6,8]),function(X,e,R,L,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,D.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,D.createDecorator)("sharedTunnelsService");var i;(function(h){h.Http="http",h.Https="https"})(i=e.TunnelProtocol||(e.TunnelProtocol={}));var P;(function(h){h.ConstantPrivate="constantPrivate",h.Private="private",h.Public="public"})(P=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var S;(function(h){h[h.Notify=1]="Notify",h[h.OpenBrowser=2]="OpenBrowser",h[h.OpenPreview=3]="OpenPreview",h[h.Silent=4]="Silent",h[h.Ignore=5]="Ignore",h[h.OpenBrowserOnce=6]="OpenBrowserOnce"})(S=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function C(h){if(h.scheme!=="http"&&h.scheme!=="https")return;const w=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(h.authority);if(!!w)return{address:w[1],port:+w[2]}}e.extractLocalHostUriMetaDataForPortMapping=C,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function I(h){return e.LOCALHOST_ADDRESSES.indexOf(h)>=0}e.isLocalhost=I,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function E(h){return e.ALL_INTERFACES_ADDRESSES.indexOf(h)>=0}e.isAllInterfaces=E;function d(h,w){return w?w!==1&&h<1024:!L.isWindows&&h<1024}e.isPortPrivileged=d;let p=class{constructor(w){this.logService=w,this._onTunnelOpened=new R.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new R.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new R.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(w,y){return this._tunnelProvider=w,w?(this._canElevate=y.elevation,this._privacyOptions=y.privacyOptions,this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const w=[],y=Array.from(this._tunnels.values());for(let m of y){const b=Array.from(m.values());for(let g of b){const a=await g.value;a&&w.push(a)}}return w}async dispose(){for(const w of this._tunnels.values()){for(const{value:y}of w.values())await y.then(m=>m?.dispose());w.clear()}this._tunnels.clear()}openTunnel(w,y,m,b,g=!1,a=P.Private,l){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${y}:${m} on local port ${b}.`),!w)return;y||(y="localhost");const r=this.retainOrCreateTunnel(w,y,m,b,g,a,l);return r?r.then(o=>{if(!o){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(y,m);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const n=this.makeTunnel(o);return(o.tunnelRemoteHost!==y||o.tunnelRemotePort!==m)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(n),n}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),r)}makeTunnel(w){return{tunnelRemotePort:w.tunnelRemotePort,tunnelRemoteHost:w.tunnelRemoteHost,tunnelLocalPort:w.tunnelLocalPort,localAddress:w.localAddress,privacy:w.privacy,protocol:w.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${w.tunnelRemoteHost}:${w.tunnelRemotePort} `);const y=this._tunnels.get(w.tunnelRemoteHost);if(y){const m=y.get(w.tunnelRemotePort);m&&(m.refcount--,await this.tryDisposeTunnel(w.tunnelRemoteHost,w.tunnelRemotePort,m))}}}}async tryDisposeTunnel(w,y,m){if(m.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${w}:${y}.`);const b=m.value.then(async g=>{g&&(await g.dispose(!0),this._onTunnelClosed.fire({host:g.tunnelRemoteHost,port:g.tunnelRemotePort}))});return this._tunnels.has(w)&&this._tunnels.get(w).delete(y),b}}async closeTunnel(w,y){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${w}:${y} `);const m=this._tunnels.get(w);if(m&&m.has(y)){const b=m.get(y);b.refcount=0,await this.tryDisposeTunnel(w,y,b)}}addTunnelToMap(w,y,m){this._tunnels.has(w)||this._tunnels.set(w,new Map),this._tunnels.get(w).set(y,{refcount:1,value:m})}async removeEmptyTunnelFromMap(w,y){const m=this._tunnels.get(w);m&&(await m.get(y)||m.delete(y),m.size===0&&this._tunnels.delete(w))}getTunnelFromMap(w,y){let m=[w];I(w)?(m.push(...e.LOCALHOST_ADDRESSES),m.push(...e.ALL_INTERFACES_ADDRESSES)):E(w)&&m.push(...e.ALL_INTERFACES_ADDRESSES);const b=m.map(g=>this._tunnels.get(g));for(const g of b){const a=g?.get(y);if(a)return a}}canTunnel(w){return!!C(w)}createWithProvider(w,y,m,b,g,a,l){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${y}:${m} on local port ${b}.`);const o={elevationRequired:g?d(b===void 0?m:b):!1},n={remoteAddress:{host:y,port:m},localAddressPort:b,privacy:a,public:a!==P.Private,protocol:l},t=w.forwardPort(n,o);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),t&&this.addTunnelToMap(y,m,t),t}};p=he([J(0,k.ILogService)],p),e.AbstractTunnelService=p}),define(te[190],ne([0,1,8,62,2,9,5]),function(X,e,R,L,D,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessTunnelService=void 0;class P extends D.Disposable{constructor(){super();this._address=null,this._addressPromise=null}async getAddress(){return this._address?this._address:(this._addressPromise||(this._addressPromise=new i.DeferredPromise),this._addressPromise.p)}setAddress(I){this._address=I,this._addressPromise&&(this._addressPromise.complete(I),this._addressPromise=null)}setTunnel(I){this._register(I)}}let S=class Et extends D.Disposable{constructor(I,E){super();this._tunnelService=I,this._logService=E,this._tunnels=new Map,this._disposedTunnels=new Set}dispose(){super.dispose(),this._tunnels.forEach(I=>I.dispose())}async createTunnel(){return{id:String(++Et._lastId)}}async startTunnel(I,E,d,p,h,w){const y=new P,m=await Promise.resolve(this._tunnelService.openTunnel(I,y,d,p,h,w));if(!m)throw this._logService.info(`[SharedProcessTunnelService] Could not create a tunnel to ${d}:${p} (remote).`),y.dispose(),new Error("Could not create tunnel");if(this._disposedTunnels.has(E))throw this._disposedTunnels.delete(E),y.dispose(),await m.dispose(),(0,k.canceled)();return y.setTunnel(m),this._tunnels.set(E,y),this._logService.info(`[SharedProcessTunnelService] Created tunnel ${E}: ${m.localAddress} (local) to ${d}:${p} (remote).`),{tunnelLocalPort:m.tunnelLocalPort,localAddress:m.localAddress}}async setAddress(I,E){const d=this._tunnels.get(I);!d||d.setAddress(E)}async destroyTunnel(I){const E=this._tunnels.get(I);if(E){this._logService.info(`[SharedProcessTunnelService] Disposing tunnel ${I}.`),this._tunnels.delete(I),await E.dispose();return}this._disposedTunnels.add(I)}};S._lastId=0,S=he([J(0,L.ISharedTunnelsService),J(1,R.ILogService)],S),e.SharedProcessTunnelService=S}),define(te[191],ne([0,1,120,21,8]),function(X,e,R,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let k=class{constructor(P,S){this.configurationService=P,this.logService=S}request(P,S){return this.logService.trace("RequestService#request",P.url),P.proxyAuthorization||(P.proxyAuthorization=this.configurationService.getValue("http.proxyAuthorization")),(0,R.request)(P,S)}async resolveProxy(P){}};k=he([J(0,L.IConfigurationService),J(1,D.ILogService)],k),e.RequestService=k}),define(te[43],ne([0,1,19,141,39,6,35]),function(X,e,R,L,D,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,k.createDecorator)("requestService");function P(h){return h.res.statusCode&&h.res.statusCode>=200&&h.res.statusCode<300||h.res.statusCode===1223}e.isSuccess=P;function S(h){return h.res.statusCode===204}async function C(h){if(!P(h))throw new Error("Server returned "+h.res.statusCode);return S(h)?null:(await(0,R.streamToBuffer)(h.stream)).toString()}e.asText=C;async function I(h){if(!P(h))throw new Error("Server returned "+h.res.statusCode);if(S(h))return null;const y=(await(0,R.streamToBuffer)(h.stream)).toString();try{return JSON.parse(y)}catch(m){throw m.message+=`:
`+y,m}}e.asJson=I;function E(h){p(h)}e.updateProxyConfigurationsScope=E;let d;function p(h){const w=i.Registry.as(D.Extensions.Configuration),y=d;d={id:"http",order:15,title:(0,L.localize)(0,null),type:"object",scope:h,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,L.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,L.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,L.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,L.localize)(4,null),(0,L.localize)(5,null),(0,L.localize)(6,null),(0,L.localize)(7,null)],default:"override",description:(0,L.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,L.localize)(9,null),restricted:!0}}},w.updateConfigurations({add:[d],remove:y?[y]:[]})}p(2)}),define(te[192],ne([0,1,27,15,14,43]),function(X,e,R,L,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let i=class{constructor(S,C){this.requestService=S,this.fileService=C}async download(S,C,I=R.CancellationToken.None){if(S.scheme===L.Schemas.file||S.scheme===L.Schemas.vscodeRemote){await this.fileService.copy(S,C);return}const E={type:"GET",url:S.toString()},d=await this.requestService.request(E,I);if(d.res.statusCode===200)await this.fileService.writeFile(C,d.stream);else{const p=await(0,k.asText)(d);throw new Error(`Expected 200, got back ${d.res.statusCode} instead.

${p}`)}}};i=he([J(0,k.IRequestService),J(1,D.IFileService)],i),e.DownloadService=i}),define(te[193],ne([0,1,16,27,66,2,18,155,14,8,26,43]),function(X,e,R,L,D,k,i,P,S,C,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let d=class extends k.Disposable{constructor(h,w,y,m){super();this.fileService=h,this.productService=w,this.requestService=y,this.logService=m,this.allConfigBasedTips=new Map,this.productService.configBasedExtensionTips&&(0,D.forEach)(this.productService.configBasedExtensionTips,({value:b})=>this.allConfigBasedTips.set(b.configPath,b))}getConfigBasedTips(h){return this.getValidConfigBasedTips(h)}getAllWorkspacesTips(){return this.fetchWorkspacesTips()}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async getValidConfigBasedTips(h){const w=[];for(const[y,m]of this.allConfigBasedTips)if(!(m.configScheme&&m.configScheme!==h.scheme))try{const b=await this.fileService.readFile((0,i.joinPath)(h,y)),g=new Map;(0,D.forEach)(m.recommendations,({key:l,value:r})=>{if((0,R.isNonEmptyArray)(r.remotes))for(const o of r.remotes)g.set(o,{extensionId:l,extensionName:r.name,configName:m.configName,important:!!r.important,isExtensionPack:!!r.isExtensionPack});else w.push({extensionId:l,extensionName:r.name,configName:m.configName,important:!!r.important,isExtensionPack:!!r.isExtensionPack})});const a=(0,P.getDomainsOfRemotes)(b.value.toString(),[...g.keys()]);for(const l of a){const r=g.get(l);r&&w.push(r)}}catch(b){}return w}async fetchWorkspacesTips(){if(!this.productService.extensionsGallery?.recommendationsUrl)return[];try{const h=await this.requestService.request({type:"GET",url:this.productService.extensionsGallery?.recommendationsUrl},L.CancellationToken.None);if(h.res.statusCode!==200)return[];const w=await(0,E.asJson)(h);return w?w.workspaceRecommendations||[]:[]}catch(h){return this.logService.error(h),[]}}};d=he([J(0,S.IFileService),J(1,I.IProductService),J(2,E.IRequestService),J(3,C.ILogService)],d),e.ExtensionTipsService=d}),define(te[46],ne([0,1,19,29]),function(X,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function D(k,i,P){let S=P&&P.get("storage.serviceMachineId",0)||null;if(S)return S;try{const I=(await i.readFile(k.serviceMachineIdResource)).value.toString();S=(0,L.isUUID)(I)?I:null}catch(C){S=null}if(!S){S=(0,L.generateUuid)();try{await i.writeFile(k.serviceMachineIdResource,R.VSBuffer.fromString(S))}catch(C){}}return P&&P.store("storage.serviceMachineId",S,0,1),S}e.getServiceMachineId=D}),define(te[90],ne([0,1,105,6]),function(X,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessWorkerChannelName=e.ISharedProcessWorkerService=e.hash=void 0;function D(k){return(0,R.hash)({moduleId:k.process.moduleId,windowId:k.reply.windowId})}e.hash=D,e.ISharedProcessWorkerService=(0,L.createDecorator)("sharedProcessWorkerService"),e.ipcSharedProcessWorkerChannelName="sharedProcessWorker"}),define(te[194],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerMessages=void 0;var R;(function(L){L.Spawn="vscode:shared-process->shared-process-worker=spawn",L.Terminate="vscode:shared-process->shared-process-worker=terminate",L.SelfTerminated="vscode:shared-process-worker->shared-process=selfTerminated",L.Ready="vscode:shared-process-worker->shared-process=ready",L.Ack="vscode:shared-process-worker->shared-process=ack",L.Trace="vscode:shared-process-worker->shared-process=trace",L.Info="vscode:shared-process-worker->shared-process=info",L.Warn="vscode:shared-process-worker->shared-process=warn",L.Error="vscode:shared-process-worker->shared-process=error"})(R=e.SharedProcessWorkerMessages||(e.SharedProcessWorkerMessages={}))}),define(te[195],ne([0,1,72,153,5,27,3,2,15,4,29,11,8,26,90,194]),function(X,e,R,L,D,k,i,P,S,C,I,E,d,p,h,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerService=void 0;let y=class{constructor(g,a,l){this.logService=g,this.productService=a,this.environmentService=l,this.workers=new Map,this.processeDisposables=new Map,this.processResolvers=new Map}async createWorker(g){const a=`window: ${g.reply.windowId}, moduleId: ${g.process.moduleId}`;this.logService.trace(`SharedProcess: createWorker (${a})`);const l=(0,h.hash)(g);this.processeDisposables.has(l)&&(this.logService.warn(`SharedProcess: createWorker found an existing worker that will be terminated (${a})`),this.doDisposeWorker(g));const r=new k.CancellationTokenSource;let o,n,t;this.processeDisposables.set(l,f=>{r.dispose(!0),o?.terminate(g,k.CancellationToken.None),n?.close(),t?.close(),this.processeDisposables.delete(l);const v=this.processResolvers.get(l);v&&(this.processResolvers.delete(l),v({reason:f}))}),o=await this.getOrCreateWebWorker(g);const s=new Promise(f=>{this.processResolvers.set(l,f)});if(r.token.isCancellationRequested)return s;const{port1:c,port2:u}=new MessageChannel;return n=c,t=u,await o.spawn(g,t,r.token),r.token.isCancellationRequested||(this.logService.trace(`SharedProcess: createWorker sending message port back to window (${a})`),R.ipcRenderer.postMessage("vscode:relaySharedProcessWorkerMessageChannel",g,[n])),s}getOrCreateWebWorker(g){let a=this.workers.get(g.process.moduleId);if(!a){this.logService.trace(`SharedProcess: creating new web worker (${g.process.moduleId})`);const l=new m(g.process.type,this.logService,this.productService,this.environmentService);a=l.init(),l.onDidProcessSelfTerminate(({configuration:r,reason:o})=>{this.doDisposeWorker(r,o)}),this.workers.set(g.process.moduleId,a)}return a}async disposeWorker(g){return this.doDisposeWorker(g)}doDisposeWorker(g,a){const l=this.processeDisposables.get((0,h.hash)(g));l&&(this.logService.trace(`SharedProcess: disposeWorker (window: ${g.reply.windowId}, moduleId: ${g.process.moduleId})`),l(a))}};y=he([J(0,d.ILogService),J(1,p.IProductService),J(2,E.INativeEnvironmentService)],y),e.SharedProcessWorkerService=y;class m extends P.Disposable{constructor(g,a,l,r){super();this.type=g,this.logService=a,this.productService=l,this.environmentService=r,this._onDidProcessSelfTerminate=this._register(new i.Emitter),this.onDidProcessSelfTerminate=this._onDidProcessSelfTerminate.event,this.workerReady=this.doInit(),this.mapMessageNonceToPendingMessageResolve=new Map}async init(){return await this.workerReady,this}doInit(){const g=new D.DeferredPromise,a=new Worker("../../../base/worker/workerMain.js",{name:`Shared Process Worker (${this.type})`});return a.onerror=l=>{this.logService.error(`SharedProcess: worker error (${this.type})`,l.message)},a.onmessageerror=l=>{this.logService.error(`SharedProcess: worker message error (${this.type})`,l)},a.onmessage=l=>{const{id:r,message:o,configuration:n,nonce:t}=l.data;switch(r){case w.SharedProcessWorkerMessages.Ready:g.complete(a);break;case w.SharedProcessWorkerMessages.Ack:if(t){const s=this.mapMessageNonceToPendingMessageResolve.get(t);s&&(this.mapMessageNonceToPendingMessageResolve.delete(t),s())}break;case w.SharedProcessWorkerMessages.SelfTerminated:n&&o&&this._onDidProcessSelfTerminate.fire({configuration:n,reason:JSON.parse(o)});break;case w.SharedProcessWorkerMessages.Trace:this.logService.trace(`SharedProcess (worker, ${this.type}):`,o);break;case w.SharedProcessWorkerMessages.Info:o&&this.logService.info(o);break;case w.SharedProcessWorkerMessages.Warn:this.logService.warn(`SharedProcess (worker, ${this.type}):`,o);break;case w.SharedProcessWorkerMessages.Error:this.logService.error(`SharedProcess (worker, ${this.type}):`,o);break;default:this.logService.warn(`SharedProcess: unexpected worker message (${this.type})`,l)}},a.postMessage("vs/platform/sharedProcess/electron-browser/sharedProcessWorkerMain"),g.p}async send(g,a,l){const r=await this.workerReady;if(!a.isCancellationRequested)return new Promise(o=>{const n=(0,I.generateUuid)();this.mapMessageNonceToPendingMessageResolve.set(n,o);const t={...g,nonce:n};l?r.postMessage(t,[l]):r.postMessage(t),a.onCancellationRequested(()=>{this.mapMessageNonceToPendingMessageResolve.delete(n)&&o()})})}spawn(g,a,l){const r={id:w.SharedProcessWorkerMessages.Spawn,configuration:g,environment:this.getSharedProcessWorkerEnvironment()};return this.send(r,l,a)}getSharedProcessWorkerEnvironment(){const g={bootstrapPath:S.FileAccess.asFileUri("bootstrap-fork",X).fsPath,env:Object.create(null)};if(C.isLinux){const a={companyName:this.productService.crashReporter?.companyName||"Microsoft",productName:this.productService.crashReporter?.productName||this.productService.nameShort,submitURL:"",uploadToServer:!1},l=this.environmentService.args["crash-reporter-id"],r=this.productService.appCenter;if(!this.environmentService.args["crash-reporter-directory"]&&r&&l&&(0,I.isUUID)(l)){const t=r["linux-x64"];a.submitURL=t.concat("&uid=",l,"&iid=",l,"&sid=",l),a.uploadToServer=!0}const n=this.environmentService.args["crash-reporter-directory"]||this.environmentService.userDataPath;g.env.BREAKPAD_DUMP_LOCATION=(0,L.join)(n,this.type),g.env.VSCODE_CRASH_REPORTER_START_OPTIONS=JSON.stringify(a)}return g}terminate(g,a){const l={id:w.SharedProcessWorkerMessages.Terminate,configuration:g};return this.send(l,a)}}}),define(te[91],ne([0,1,6]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,R.createDecorator)(e.SIGN_SERVICE_ID)}),define(te[196],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class R{constructor(){this.validators=new Map}vsda(){return new Promise((D,k)=>X(["vsda"],D,k))}async createNewMessage(D){try{const k=await this.vsda(),i=new k.validator;if(i){const P=String(R._nextId++);return this.validators.set(P,i),{id:P,data:i.createNewMessage(D)}}}catch(k){}return{id:"",data:D}}async validate(D,k){if(!D.id)return!0;const i=this.validators.get(D.id);if(!i)return!1;this.validators.delete(D.id);try{return i.validate(k)==="ok"}catch(P){return!1}}async sign(D){try{const k=await this.vsda(),i=new k.signer;if(i)return i.sign(D)}catch(k){}return D}}e.SignService=R,R._nextId=1}),define(te[23],ne([0,1,5,3,2,178,17,73,6]),function(X,e,R,L,D,k,i,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const C="__$__targetStorageMarker";e.IStorageService=(0,S.createDecorator)("storageService");var I;(function(y){y[y.NONE=0]="NONE",y[y.SHUTDOWN=1]="SHUTDOWN"})(I=e.WillSaveStateReason||(e.WillSaveStateReason={}));var E;(function(y){y[y.GLOBAL=0]="GLOBAL",y[y.WORKSPACE=1]="WORKSPACE"})(E=e.StorageScope||(e.StorageScope={}));var d;(function(y){y[y.USER=0]="USER",y[y.MACHINE=1]="MACHINE"})(d=e.StorageTarget||(e.StorageTarget={}));class p extends D.Disposable{constructor(m={flushInterval:p.DEFAULT_FLUSH_INTERVAL}){super();this.options=m,this._onDidChangeValue=this._register(new L.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new L.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new L.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new R.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new D.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,R.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,D.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,k.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,k.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(m,b){b===C?(m===0?this._globalKeyTargets=void 0:m===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:m})):this._onDidChangeValue.fire({scope:m,key:b,target:this.getKeyTargets(m)[b]})}emitWillSaveState(m){this._onWillSaveState.fire({reason:m})}get(m,b,g){return this.getStorage(b)?.get(m,g)}getBoolean(m,b,g){return this.getStorage(b)?.getBoolean(m,g)}getNumber(m,b,g){return this.getStorage(b)?.getNumber(m,g)}store(m,b,g,a){if((0,i.isUndefinedOrNull)(b)){this.remove(m,g);return}this.withPausedEmitters(()=>{this.updateKeyTarget(m,g,a),this.getStorage(g)?.set(m,b)})}remove(m,b){this.withPausedEmitters(()=>{this.updateKeyTarget(m,b,void 0),this.getStorage(b)?.delete(m)})}withPausedEmitters(m){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{m()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(m,b){const g=[],a=this.getKeyTargets(m);for(const l of Object.keys(a))a[l]===b&&g.push(l);return g}updateKeyTarget(m,b,g){const a=this.getKeyTargets(b);typeof g=="number"?a[m]!==g&&(a[m]=g,this.getStorage(b)?.set(C,JSON.stringify(a))):typeof a[m]=="number"&&(delete a[m],this.getStorage(b)?.set(C,JSON.stringify(a)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(m){return m===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(m){const b=this.get(C,m);if(b)try{return JSON.parse(b)}catch(g){}return Object.create(null)}isNew(m){return this.getBoolean(e.IS_NEW_KEY,m)===!0}async flush(m=I.NONE){this._onWillSaveState.fire({reason:m});const b=this.getStorage(0),g=this.getStorage(1);switch(m){case I.NONE:await R.Promises.settled([b?.whenFlushed()??Promise.resolve(),g?.whenFlushed()??Promise.resolve()]);break;case I.SHUTDOWN:await R.Promises.settled([b?.flush(0)??Promise.resolve(),g?.flush(0)??Promise.resolve()]);break}}async logStorage(){const m=this.getStorage(0)?.items??new Map,b=this.getStorage(1)?.items??new Map;return w(m,b,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}e.AbstractStorageService=p,p.DEFAULT_FLUSH_INTERVAL=60*1e3;class h extends p{constructor(){super();this.globalStorage=this._register(new P.Storage(new P.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new P.Storage(new P.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(m=>this.emitDidChangeValue(1,m))),this._register(this.globalStorage.onDidChangeStorage(m=>this.emitDidChangeValue(0,m)))}getStorage(m){return m===0?this.globalStorage:this.workspaceStorage}getLogDetails(m){return m===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(m){}}e.InMemoryStorageService=h;async function w(y,m,b,g){const a=c=>{try{return JSON.parse(c)}catch(u){return c}},l=new Map,r=new Map;y.forEach((c,u)=>{l.set(u,c),r.set(u,a(c))});const o=new Map,n=new Map;m.forEach((c,u)=>{o.set(u,c),n.set(u,a(c))}),console.group(`Storage: Global (path: ${b})`);let t=[];l.forEach((c,u)=>{t.push({key:u,value:c})}),console.table(t),console.groupEnd(),console.log(r),console.group(`Storage: Workspace (path: ${g})`);let s=[];o.forEach((c,u)=>{s.push({key:u,value:c})}),console.table(s),console.groupEnd(),console.log(n)}e.logStorage=w}),define(te[197],ne([0,1,3,2,17,30,36,23]),function(X,e,R,L,D,k,i,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let S=class extends L.Disposable{constructor(E){super();this._onDidChangeEnablement=new R.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this.storageManger=this._register(new C(E)),this._register(this.storageManger.onDidChange(d=>this._onDidChangeEnablement.fire({extensions:d,source:"storage"})))}async enableExtension(E,d){return this._removeFromDisabledExtensions(E)?(this._onDidChangeEnablement.fire({extensions:[E],source:d}),!0):!1}async disableExtension(E,d){return this._addToDisabledExtensions(E)?(this._onDidChangeEnablement.fire({extensions:[E],source:d}),!0):!1}getDisabledExtensions(){return this._getExtensions(k.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}_addToDisabledExtensions(E){let d=this.getDisabledExtensions();return d.every(p=>!(0,i.areSameExtensions)(p,E))?(d.push(E),this._setDisabledExtensions(d),!0):!1}_removeFromDisabledExtensions(E){let d=this.getDisabledExtensions();for(let p=0;p<d.length;p++){const h=d[p];if((0,i.areSameExtensions)(h,E))return d.splice(p,1),this._setDisabledExtensions(d),!0}return!1}_setDisabledExtensions(E){this._setExtensions(k.DISABLED_EXTENSIONS_STORAGE_PATH,E)}_getExtensions(E){return this.storageManger.get(E,0)}_setExtensions(E,d){this.storageManger.set(E,d,0)}};S=he([J(0,P.IStorageService)],S),e.GlobalExtensionEnablementService=S;class C extends L.Disposable{constructor(E){super();this.storageService=E,this.storage=Object.create(null),this._onDidChange=this._register(new R.Emitter),this.onDidChange=this._onDidChange.event,this._register(E.onDidChangeValue(d=>this.onDidStorageChange(d)))}get(E,d){let p;return d===0?((0,D.isUndefinedOrNull)(this.storage[E])&&(this.storage[E]=this._get(E,d)),p=this.storage[E]):p=this._get(E,d),JSON.parse(p)}set(E,d,p){let h=JSON.stringify(d.map(({id:y,uuid:m})=>({id:y,uuid:m})));this._get(E,p)!==h&&(p===0&&(d.length?this.storage[E]=h:delete this.storage[E]),this._set(E,d.length?h:void 0,p))}onDidStorageChange(E){if(E.scope===0&&!(0,D.isUndefinedOrNull)(this.storage[E.key])&&this._get(E.key,E.scope)!==this.storage[E.key]){const p=this.get(E.key,E.scope);delete this.storage[E.key];const h=this.get(E.key,E.scope),w=p.filter(m=>!h.some(b=>(0,i.areSameExtensions)(m,b))),y=h.filter(m=>!p.some(b=>(0,i.areSameExtensions)(b,m)));(w.length||y.length)&&this._onDidChange.fire([...w,...y])}}_get(E,d){return this.storageService.get(E,d,"[]")}_set(E,d,p){d?this.storageService.store(E,d,p,1):this.storageService.remove(E,p)}}e.StorageManager=C}),define(te[198],ne([0,1,3,2]),function(X,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannelClient=void 0;class D extends L.Disposable{constructor(C,I){super();this.channel=C,this.workspace=I}async getItems(){const C={workspace:this.workspace},I=await this.channel.call("getItems",C);return new Map(I)}updateItems(C){const I={workspace:this.workspace};return C.insert&&(I.insert=Array.from(C.insert.entries())),C.delete&&(I.delete=Array.from(C.delete.values())),this.channel.call("updateItems",I)}}class k extends D{constructor(C){super(C,void 0);this._onDidChangeItemsExternal=this._register(new R.Emitter),this.onDidChangeItemsExternal=this._onDidChangeItemsExternal.event,this.registerListeners()}registerListeners(){this._register(this.channel.listen("onDidChangeGlobalStorage")(C=>this.onDidChangeGlobalStorage(C)))}onDidChangeGlobalStorage(C){(Array.isArray(C.changed)||Array.isArray(C.deleted))&&this._onDidChangeItemsExternal.fire({changed:C.changed?new Map(C.changed):void 0,deleted:C.deleted?new Set(C.deleted):void 0})}async close(){this.dispose()}}class i extends D{constructor(C,I){super(C,I);this.onDidChangeItemsExternal=R.Event.None}async close(){const C={workspace:this.workspace};return this.channel.call("close",C)}}class P extends L.Disposable{constructor(C,I){super();this.channel=C,this.workspace=I,this._globalStorage=void 0,this._workspaceStorage=void 0}get globalStorage(){return this._globalStorage||(this._globalStorage=new k(this.channel)),this._globalStorage}get workspaceStorage(){return!this._workspaceStorage&&this.workspace&&(this._workspaceStorage=new i(this.channel,this.workspace)),this._workspaceStorage}}e.StorageDatabaseChannelClient=P}),define(te[199],ne([0,1,5,2,18,73,23,198]),function(X,e,R,L,D,k,i,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeStorageService=void 0;class S extends i.AbstractStorageService{constructor(I,E,d){super();this.mainProcessService=E,this.environmentService=d,this.workspaceStorage=void 0,this.workspaceStorageId=void 0,this.workspaceStorageDisposable=this._register(new L.MutableDisposable),this.globalStorage=this.createGlobalStorage(),this.workspaceStorage=this.createWorkspaceStorage(I)}createGlobalStorage(){const I=new P.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),void 0),E=new k.Storage(I.globalStorage);return this._register(E.onDidChangeStorage(d=>this.emitDidChangeValue(0,d))),E}createWorkspaceStorage(I){const E=new P.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),I);if(E.workspaceStorage){const d=new k.Storage(E.workspaceStorage);return this.workspaceStorageDisposable.value=d.onDidChangeStorage(p=>this.emitDidChangeValue(1,p)),this.workspaceStorageId=I?.id,d}else{this.workspaceStorageDisposable.clear(),this.workspaceStorageId=void 0;return}}async doInitialize(){await R.Promises.settled([this.globalStorage.init(),this.workspaceStorage?.init()??Promise.resolve()])}getStorage(I){return I===0?this.globalStorage:this.workspaceStorage}getLogDetails(I){return I===0?this.environmentService.globalStorageHome.fsPath:this.workspaceStorageId?`${(0,D.joinPath)(this.environmentService.workspaceStorageHome,this.workspaceStorageId,"state.vscdb").fsPath}`:void 0}async close(){this.stopFlushWhenIdle(),this.emitWillSaveState(i.WillSaveStateReason.SHUTDOWN),await R.Promises.settled([this.globalStorage.close(),this.workspaceStorage?.close()??Promise.resolve()])}async migrate(I){const E=this.workspaceStorage,d=E?.items??new Map;E&&(await E.close(),E.dispose()),this.workspaceStorage=this.createWorkspaceStorage(I),await this.workspaceStorage.init();for(const[p,h]of d)this.workspaceStorage.set(p,h)}}e.NativeStorageService=S}),define(te[200],ne([0,1,4,31,7,29]),function(X,e,R,L,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function i(C){if(R.platform===2&&/^penguin(\.|$)/i.test(C))return"chromebook"}async function P(C,I,E,d,p,h,w,y,m,b){const g=Object.create(null);g["common.machineId"]=w,g.sessionID=(0,k.generateUuid)()+Date.now(),g.commitHash=p,g.version=h,g["common.platformVersion"]=(I||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),g["common.platform"]=(0,R.PlatformToString)(R.platform),g["common.nodePlatform"]=L.platform,g["common.nodeArch"]=d,g["common.product"]=b||"desktop";const a=S(y||[]);a&&(g["common.msftInternal"]=a);let l=0;const r=Date.now();Object.defineProperties(g,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-r,enumerable:!0},"common.sequence":{get:()=>l++,enumerable:!0}}),R.isLinuxSnap&&(g["common.snap"]="true");const o=i(E);o&&(g["common.platformDetail"]=o);try{const n=await C.readFile(D.URI.file(m));g["common.source"]=n.value.toString().slice(0,30)}catch(n){}return g}e.resolveCommonProperties=P;function S(C){const I=L.env.USERDNSDOMAIN;if(!I)return!1;const E=I.toLowerCase();return C.some(d=>E===d)}e.verifyMicrosoftInternalDomain=S}),define(te[22],ne([0,1,6]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,R.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,R.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var L;(function(k){k[k.NONE=0]="NONE",k[k.CRASH=1]="CRASH",k[k.ERROR=2]="ERROR",k[k.USAGE=3]="USAGE"})(L=e.TelemetryLevel||(e.TelemetryLevel={}));var D;(function(k){k.OFF="off",k.CRASH="crash",k.ERROR="error",k.ON="all"})(D=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(te[201],ne([0,1,33,56,5,32,15,10,4,7,113,20,116,78,14,26,22]),function(X,e,R,L,D,k,i,P,S,C,I,E,d,p,h,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function m(r,o){const n=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.yml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],t=new Map,s=new Map,c=2e4;function u(T,O,U,W){const N=O.substring(T.length+1);return D.Promises.withAsyncBody(async A=>{let z;try{z=await E.Promises.readdir(O,{withFileTypes:!0})}catch(q){A();return}if(W.count>=c){W.count+=z.length,W.maxReached=!0,A();return}let _=z.length;if(_===0){A();return}let M=z;W.count+z.length>c&&(W.maxReached=!0,_=c-W.count,M=z.slice(0,_)),W.count+=z.length;for(const q of M)if(q.isDirectory()){if(U.includes(q.name)||await u(T,(0,P.join)(O,q.name),U,W),--_==0){A();return}}else{const B=q.name.lastIndexOf(".");if(B>=0){const j=q.name.substring(B+1);j&&t.set(j,(t.get(j)??0)+1)}for(const j of n)j.relativePathPattern?.test(N)!==!1&&j.filePattern.test(q.name)&&s.set(j.tag,(s.get(j.tag)??0)+1);if(--_==0){A();return}}})}const f={count:0,maxReached:!1};await u(r,r,o,f);const v=await a(r);return{configFiles:b(s),fileTypes:b(t),fileCount:f.count,maxFilesReached:f.maxReached,launchConfigFiles:v}}e.collectWorkspaceStats=m;function b(r){return[...L.Iterable.map(r.entries(),([o,n])=>({name:o,count:n}))].sort((o,n)=>n.count-o.count)}function g(){const r={os:`${R.type()} ${R.arch()} ${R.release()}`,memory:`${(R.totalmem()/h.ByteSize.GB).toFixed(2)}GB (${(R.freemem()/h.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(I.virtualMachineHint.value()*100)}%`},o=R.cpus();return o&&o.length>0&&(r.cpus=`${o[0].model} (${o.length} x ${o[0].speed})`),r}e.getMachineInfo=g;async function a(r){try{const o=new Map,n=(0,P.join)(r,".vscode","launch.json"),t=await E.Promises.readFile(n),s=[],c=(0,k.parse)(t.toString(),s);if(s.length)return console.log(`Unable to parse ${n}`),[];if((0,k.getNodeType)(c)==="object"&&c.configurations)for(const u of c.configurations){const f=u.type;f&&(o.has(f)?o.set(f,o.get(f)+1):o.set(f,1))}return b(o)}catch(o){return[]}}e.collectLaunchConfigs=a;let l=class{constructor(o,n){this.telemetryService=o,this.productService=n}formatMachineInfo(o){const n=[];return n.push(`OS Version:       ${o.os}`),n.push(`CPUs:             ${o.cpus}`),n.push(`Memory (System):  ${o.memory}`),n.push(`VM:               ${o.vmHint}`),n.join(`
`)}formatEnvironment(o){const n=[];n.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),n.push(`OS Version:       ${R.type()} ${R.arch()} ${R.release()}`);const t=R.cpus();return t&&t.length>0&&n.push(`CPUs:             ${t[0].model} (${t.length} x ${t[0].speed})`),n.push(`Memory (System):  ${(R.totalmem()/h.ByteSize.GB).toFixed(2)}GB (${(R.freemem()/h.ByteSize.GB).toFixed(2)}GB free)`),S.isWindows||n.push(`Load (avg):       ${R.loadavg().map(s=>Math.round(s)).join(", ")}`),n.push(`VM:               ${Math.round(I.virtualMachineHint.value()*100)}%`),n.push(`Screen Reader:    ${o.screenReader?"yes":"no"}`),n.push(`Process Argv:     ${o.mainArguments.join(" ")}`),n.push(`GPU Status:       ${this.expandGPUFeatures(o.gpuFeatureStatus)}`),n.join(`
`)}async getPerformanceInfo(o,n){return Promise.all([(0,d.listProcesses)(o.mainPID),this.formatWorkspaceMetadata(o)]).then(async t=>{let[s,c]=t,u=this.formatProcessList(o,s);return n.forEach(f=>{if((0,p.isRemoteDiagnosticError)(f))u+=`
${f.errorMessage}`,c+=`
${f.errorMessage}`;else if(u+=`

Remote: ${f.hostName}`,f.processes&&(u+=`
${this.formatProcessList(o,f.processes)}`),f.workspaceMetadata){c+=`
|  Remote: ${f.hostName}`;for(const v of Object.keys(f.workspaceMetadata)){const T=f.workspaceMetadata[v];let O=`${T.fileCount} files`;T.maxFilesReached&&(O=`more than ${O}`),c+=`|    Folder (${v}): ${O}`,c+=this.formatWorkspaceStats(T)}}}),{processInfo:u,workspaceInfo:c}})}async getSystemInfo(o,n){const{memory:t,vmHint:s,os:c,cpus:u}=g(),f={os:c,memory:t,cpus:u,vmHint:s,processArgs:`${o.mainArguments.join(" ")}`,gpuStatus:o.gpuFeatureStatus,screenReader:`${o.screenReader?"yes":"no"}`,remoteData:n};return S.isWindows||(f.load=`${R.loadavg().map(v=>Math.round(v)).join(", ")}`),S.isLinux&&(f.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(f)}async getDiagnostics(o,n){const t=[];return(0,d.listProcesses)(o.mainPID).then(async s=>(t.push(""),t.push(this.formatEnvironment(o)),t.push(""),t.push(this.formatProcessList(o,s)),o.windows.some(c=>c.folderURIs&&c.folderURIs.length>0&&!c.remoteAuthority)&&(t.push(""),t.push("Workspace Stats: "),t.push(await this.formatWorkspaceMetadata(o))),n.forEach(c=>{if((0,p.isRemoteDiagnosticError)(c))t.push(`
${c.errorMessage}`);else if(t.push(`

`),t.push(`Remote:           ${c.hostName}`),t.push(this.formatMachineInfo(c.machineInfo)),c.processes&&t.push(this.formatProcessList(o,c.processes)),c.workspaceMetadata)for(const u of Object.keys(c.workspaceMetadata)){const f=c.workspaceMetadata[u];let v=`${f.fileCount} files`;f.maxFilesReached&&(v=`more than ${v}`),t.push(`Folder (${u}): ${v}`),t.push(this.formatWorkspaceStats(f))}}),t.push(""),t.push(""),t.join(`
`)))}formatWorkspaceStats(o){const n=[],t=60;let s=0;const c=(T,O)=>{const U=` ${T}(${O})`;s+U.length>t?(n.push(u),u="|                 ",s=u.length):s+=U.length,u+=U};let u="|      File types:";const f=10;let v=o.fileTypes.length>f?f:o.fileTypes.length;for(let T=0;T<v;T++){const O=o.fileTypes[T];c(O.name,O.count)}if(n.push(u),o.configFiles.length>=0&&(u="|      Conf files:",s=0,o.configFiles.forEach(T=>{c(T.name,T.count)}),n.push(u)),o.launchConfigFiles.length>0){let T="|      Launch Configs:";o.launchConfigFiles.forEach(O=>{T+=O.count>1?` ${O.name}(${O.count})`:` ${O.name}`}),n.push(T)}return n.join(`
`)}expandGPUFeatures(o){const n=Math.max(...Object.keys(o).map(t=>t.length));return Object.keys(o).map(t=>`${t}:  ${" ".repeat(n-t.length)}  ${o[t]}`).join(`
                  `)}formatWorkspaceMetadata(o){const n=[],t=[];return o.windows.forEach(s=>{s.folderURIs.length===0||!!s.remoteAuthority||(n.push(`|  Window (${s.title})`),s.folderURIs.forEach(c=>{const u=C.URI.revive(c);if(u.scheme===i.Schemas.file){const f=u.fsPath;t.push(m(f,["node_modules",".git"]).then(v=>{let T=`${v.fileCount} files`;v.maxFilesReached&&(T=`more than ${T}`),n.push(`|    Folder (${(0,P.basename)(f)}): ${T}`),n.push(this.formatWorkspaceStats(v))}).catch(v=>{n.push(`|      Error: Unable to collect workspace stats for folder ${f} (${v.toString()})`)}))}else n.push(`|    Folder (${u.toString()}): Workspace stats not available.`)}))}),Promise.all(t).then(s=>n.join(`
`)).catch(s=>`Unable to collect workspace stats: ${s}`)}formatProcessList(o,n){const t=new Map;o.windows.forEach(c=>t.set(c.pid,c.title));const s=[];return s.push("CPU %	Mem MB	   PID	Process"),n&&this.formatProcessItem(o.mainPID,t,s,n,0),s.join(`
`)}formatProcessItem(o,n,t,s,c){const u=c===0;let f;u?f=s.pid===o?`${this.productService.applicationName} main`:"remote agent":(f=`${"  ".repeat(c)} ${s.name}`,s.name==="window"&&(f=`${f} (${n.get(s.pid)})`));const v=process.platform==="win32"?s.mem:R.totalmem()*(s.mem/100);t.push(`${s.load.toFixed(0).padStart(5," ")}	${(v/h.ByteSize.MB).toFixed(0).padStart(6," ")}	${s.pid.toFixed(0).padStart(6," ")}	${f}`),Array.isArray(s.children)&&s.children.forEach(T=>this.formatProcessItem(o,n,t,T,c+1))}async reportWorkspaceStats(o){for(const{uri:n}of o.folders){const t=C.URI.revive(n);if(t.scheme!==i.Schemas.file)continue;const s=t.fsPath;try{const c=await m(s,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":o.telemetryId,rendererSessionId:o.rendererSessionId}),c.fileTypes.forEach(u=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:o.rendererSessionId,type:u.name,count:u.count})}),c.launchConfigFiles.forEach(u=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:o.rendererSessionId,type:u.name,count:u.count})}),c.configFiles.forEach(u=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:o.rendererSessionId,type:u.name,count:u.count})})}catch{}}}};l=he([J(0,y.ITelemetryService),J(1,w.IProductService)],l),e.DiagnosticsService=l}),define(te[202],ne([0,1,16,5,27,9,3,2,4,7,130,30,36,8,26,22]),function(X,e,R,L,D,k,i,P,S,C,I,E,d,p,h,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.reportTelemetry=e.joinErrors=e.AbstractExtensionManagementService=void 0;let y=class extends P.Disposable{constructor(r,o,n,t){super();this.galleryService=r,this.telemetryService=o,this.logService=n,this.productService=t,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new i.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new i.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new i.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new i.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,P.toDisposable)(()=>{this.installingExtensions.forEach(s=>s.cancel()),this.uninstallingExtensions.forEach(s=>s.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(r){const o=await this.getTargetPlatform();return r.allTargetPlatforms.some(n=>(0,E.isTargetPlatformCompatible)(n,r.allTargetPlatforms,o))}async installFromGallery(r,o={}){try{return await this.doInstallFromGallery(r,o)}catch(n){throw this.logService.error("Failed to install extension.",r.identifier.id),this.logService.error(n),b(n)}}async uninstall(r,o={}){return this.logService.trace("ExtensionManagementService#uninstall",r.identifier.id),this.unininstallExtension(r,o)}async reinstallFromGallery(r){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",r.identifier.id),!this.galleryService.isEnabled())throw new Error(I.localize(0,null));const o=await this.findGalleryExtension(r);if(!o)throw new Error(I.localize(1,null));await this.createUninstallExtensionTask(r,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(o)}getExtensionsReport(){const r=new Date().getTime();return(!this.reportedExtensions||r-this.lastReportTimestamp>1e3*60*5)&&(this.reportedExtensions=this.updateReportCache(),this.lastReportTimestamp=r),this.reportedExtensions}registerParticipant(r){this.participants.push(r)}async doInstallFromGallery(r,o={}){if(!this.galleryService.isEnabled())throw new E.ExtensionManagementError(I.localize(2,null),E.ExtensionManagementErrorCode.Internal);if(!await this.canInstall(r)){const t=await this.getTargetPlatform(),s=new E.ExtensionManagementError(I.localize(3,null,r.identifier.id,this.productService.nameLong,(0,E.TargetPlatformToString)(t)),E.ExtensionManagementErrorCode.Incompatible);throw g(this.telemetryService,"extensionGallery:install",(0,d.getGalleryExtensionTelemetryData)(r),void 0,s),s}try{r=await this.checkAndGetCompatibleVersion(r,!o.installGivenVersion)}catch(t){throw g(this.telemetryService,"extensionGallery:install",(0,d.getGalleryExtensionTelemetryData)(r),void 0,t),t}const n=await this.galleryService.getManifest(r,D.CancellationToken.None);if(n===null){const t=new E.ExtensionManagementError(`Missing manifest for extension ${r.identifier.id}`,E.ExtensionManagementErrorCode.Invalid);throw g(this.telemetryService,"extensionGallery:install",(0,d.getGalleryExtensionTelemetryData)(r),void 0,t),t}if(n.version!==r.version){const t=new E.ExtensionManagementError(`Cannot install '${r.identifier.id}' extension because of version mismatch in Marketplace`,E.ExtensionManagementErrorCode.Invalid);throw g(this.telemetryService,"extensionGallery:install",(0,d.getGalleryExtensionTelemetryData)(r),void 0,t),t}return this.installExtension(n,r,o)}async installExtension(r,o,n){if(!C.URI.isUri(o)){let f=this.installingExtensions.get(new d.ExtensionIdentifierWithVersion(o.identifier,o.version).key());if(f)return this.logService.info("Extensions is already requested to install",o.identifier.id),f.waitUntilTaskIsFinished();n={...n,installOnlyNewlyAddedFromExtensionPack:!0}}const t=[],s=[],c=this.createInstallExtensionTask(r,o,n);C.URI.isUri(o)||this.installingExtensions.set(new d.ExtensionIdentifierWithVersion(c.identifier,r.version).key(),c),this._onInstallExtension.fire({identifier:c.identifier,source:o}),this.logService.info("Installing extension:",c.identifier.id),t.push({task:c,manifest:r});let u=!1;try{if(n.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",c.identifier.id);else try{const v=await this.getAllDepsAndPackExtensionsToInstall(c.identifier,r,!!n.installOnlyNewlyAddedFromExtensionPack);for(const{gallery:T,manifest:O}of v)if(u=u||!!O.extensionDependencies?.some(U=>(0,d.areSameExtensions)({id:U},c.identifier)),this.installingExtensions.has(new d.ExtensionIdentifierWithVersion(T.identifier,T.version).key()))this.logService.info("Extension is already requested to install",T.identifier.id);else{const U=this.createInstallExtensionTask(O,T,{...n,donotIncludePackAndDependencies:!0});this.installingExtensions.set(new d.ExtensionIdentifierWithVersion(U.identifier,O.version).key(),U),this._onInstallExtension.fire({identifier:U.identifier,source:T}),this.logService.info("Installing extension:",U.identifier.id),t.push({task:U,manifest:O})}}catch(v){if(C.URI.isUri(c.source))(0,R.isNonEmptyArray)(r.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",c.identifier.id,v.message),(0,R.isNonEmptyArray)(r.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",c.identifier.id,v.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",c.identifier.id),v}const f=t.reduce((v,{task:T,manifest:O})=>(v.set(T.identifier.id.toLowerCase(),{task:T,manifest:O}),v),new Map);for(;f.size;){let v;const T=[...f.values()].filter(({manifest:O})=>!O.extensionDependencies?.some(U=>f.has(U.toLowerCase())));T.length?v=f.size===1?T:T.filter(({task:O})=>!(O===c&&!u)):(this.logService.info("Found extensions with circular dependencies",T.map(({task:O})=>O.identifier.id)),v=[...f.values()]),await this.joinAllSettled(v.map(async({task:O})=>{const U=new Date().getTime();try{const W=await O.run();if(await this.joinAllSettled(this.participants.map(N=>N.postInstall(W,O.source,n,D.CancellationToken.None))),!C.URI.isUri(O.source)&&(g(this.telemetryService,O.operation===2?"extensionGallery:update":"extensionGallery:install",(0,d.getGalleryExtensionTelemetryData)(O.source),new Date().getTime()-U,void 0),S.isWeb&&O.operation===1))try{await this.galleryService.reportStatistic(W.manifest.publisher,W.manifest.name,W.manifest.version,"install")}catch(N){}s.push({local:W,identifier:O.identifier,operation:O.operation,source:O.source})}catch(W){throw C.URI.isUri(O.source)||g(this.telemetryService,O.operation===2?"extensionGallery:update":"extensionGallery:install",(0,d.getGalleryExtensionTelemetryData)(O.source),new Date().getTime()-U,W),this.logService.error("Error while installing the extension:",O.identifier.id),W}finally{f.delete(O.identifier.id.toLowerCase())}}))}return s.forEach(({identifier:v})=>this.logService.info("Extension installed successfully:",v.id)),this._onDidInstallExtensions.fire(s),s.filter(({identifier:v})=>(0,d.areSameExtensions)(v,c.identifier))[0].local}catch(f){if(t.forEach(({task:v})=>v.cancel()),s.length)try{const v=await Promise.allSettled(s.map(({local:T})=>this.createUninstallExtensionTask(T,{versionOnly:!0}).run()));for(let T=0;T<v.length;T++){const O=v[T],{identifier:U}=s[T];O.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",U.id):this.logService.warn("Rollback: Error while uninstalling extension",U.id,(0,k.getErrorMessage)(O.reason))}}catch(v){this.logService.warn("Error while rolling back extensions",(0,k.getErrorMessage)(v),s.map(({identifier:T})=>T.id))}throw this._onDidInstallExtensions.fire(t.map(({task:v})=>({identifier:v.identifier,operation:1,source:v.source}))),f}finally{for(const{task:f,manifest:v}of t)if(!C.URI.isUri(f.source)){const T=new d.ExtensionIdentifierWithVersion(f.identifier,v.version).key();this.installingExtensions.delete(T)||this.logService.warn("Installation task is not found in the cache",T)}}}async joinAllSettled(r){const o=[],n=[],t=await Promise.allSettled(r);for(const s of t)s.status==="fulfilled"?o.push(s.value):n.push(s.reason);if(n.length)throw m(n);return o}async getAllDepsAndPackExtensionsToInstall(r,o,n){if(!this.galleryService.isEnabled())return[];let t=await this.getInstalled();const s=[r,...t.map(f=>f.identifier)],c=[],u=async(f,v)=>{const T=v.extensionDependencies||[],O=[...T];if(v.extensionPack){const U=n?t.find(W=>(0,d.areSameExtensions)(W.identifier,f)):void 0;for(const W of v.extensionPack)U&&U.manifest.extensionPack&&U.manifest.extensionPack.some(N=>(0,d.areSameExtensions)({id:N},{id:W}))||O.every(N=>!(0,d.areSameExtensions)({id:N},{id:W}))&&O.push(W)}if(O.length){const U=[...s,...c.map(N=>N.gallery.identifier)],W=O.filter(N=>U.every(A=>!(0,d.areSameExtensions)(A,{id:N})));if(W.length){const N=await this.galleryService.query({names:W,pageSize:O.length},D.CancellationToken.None);for(const A of N.firstPage){if(U.find(q=>(0,d.areSameExtensions)(q,A.identifier)))continue;if(!T.some(q=>(0,d.areSameExtensions)({id:q},A.identifier))&&!await this.canInstall(A)){this.logService.info("Skipping the packed extension as it cannot be installed",A.identifier.id);continue}const _=await this.checkAndGetCompatibleVersion(A,!0),M=await this.galleryService.getManifest(_,D.CancellationToken.None);if(M===null)throw new E.ExtensionManagementError(`Missing manifest for extension ${_.identifier.id}`,E.ExtensionManagementErrorCode.Invalid);c.push({gallery:_,manifest:M}),await u(_.identifier,M)}}}};return await u(r,o),t=await this.getInstalled(),c.filter(f=>!t.some(v=>(0,d.areSameExtensions)(v.identifier,f.gallery.identifier)))}async checkAndGetCompatibleVersion(r,o){if(await this.isMalicious(r))throw new E.ExtensionManagementError(I.localize(4,null,r.identifier.id),E.ExtensionManagementErrorCode.Malicious);const n=await this.getCompatibleVersion(r,o);if(!n)throw new E.ExtensionManagementError(I.localize(5,null,r.identifier.id,this.productService.nameLong,this.productService.version),E.ExtensionManagementErrorCode.Incompatible);return n}async getCompatibleVersion(r,o){const n=await this.getTargetPlatform();let t=null;return await this.galleryService.isExtensionCompatible(r,n)&&(t=r),!t&&o&&(t=await this.galleryService.getCompatibleExtension(r,n)),t}async isMalicious(r){const o=await this.getExtensionsReport();return(0,d.getMaliciousExtensionsSet)(o).has(r.identifier.id)}async unininstallExtension(r,o){const n=this.uninstallingExtensions.get(r.identifier.id.toLowerCase());if(n)return this.logService.info("Extensions is already requested to uninstall",r.identifier.id),n.waitUntilTaskIsFinished();const t=(f,v)=>{const T=this.createUninstallExtensionTask(f,v);return this.uninstallingExtensions.set(T.extension.identifier.id.toLowerCase(),T),this.logService.info("Uninstalling extension:",f.identifier.id),this._onUninstallExtension.fire(f.identifier),T},s=(f,v)=>{v?this.logService.error("Failed to uninstall extension:",f.identifier.id,v.message):this.logService.info("Successfully uninstalled extension:",f.identifier.id),g(this.telemetryService,"extensionGallery:uninstall",(0,d.getLocalExtensionTelemetryData)(f),void 0,v),this._onDidUninstallExtension.fire({identifier:f.identifier,error:v?.code})},c=[],u=[];try{c.push(t(r,{}));const f=await this.getInstalled(1);if(o.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",r.identifier.id);else{const v=this.getAllPackExtensionsToUninstall(r,f);for(const T of v)this.uninstallingExtensions.has(T.identifier.id.toLowerCase())?this.logService.info("Extensions is already requested to uninstall",T.identifier.id):c.push(t(T,{}))}o.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",r.identifier.id):this.checkForDependents(c.map(v=>v.extension),f,r),await this.joinAllSettled(c.map(async v=>{try{if(await v.run(),await this.joinAllSettled(this.participants.map(T=>T.postUninstall(v.extension,o,D.CancellationToken.None))),v.extension.identifier.uuid)try{await this.galleryService.reportStatistic(v.extension.manifest.publisher,v.extension.manifest.name,v.extension.manifest.version,"uninstall")}catch(T){}s(v.extension)}catch(T){const O=T instanceof E.ExtensionManagementError?T:new E.ExtensionManagementError((0,k.getErrorMessage)(T),E.ExtensionManagementErrorCode.Internal);throw s(v.extension,O),O}finally{u.push(v)}}))}catch(f){const v=f instanceof E.ExtensionManagementError?f:new E.ExtensionManagementError((0,k.getErrorMessage)(f),E.ExtensionManagementErrorCode.Internal);for(const T of c){try{T.cancel()}catch(O){}u.includes(T)||s(T.extension,v)}throw v}finally{for(const f of c)this.uninstallingExtensions.delete(f.extension.identifier.id.toLowerCase())||this.logService.warn("Uninstallation task is not found in the cache",f.extension.identifier.id)}}checkForDependents(r,o,n){for(const t of r){const s=this.getDependents(t,o);if(s.length){const c=s.filter(u=>!r.some(f=>(0,d.areSameExtensions)(f.identifier,u.identifier)));if(c.length)throw new Error(this.getDependentsErrorMessage(t,c,n))}}}getDependentsErrorMessage(r,o,n){return n===r?o.length===1?I.localize(6,null,n.manifest.displayName||n.manifest.name,o[0].manifest.displayName||o[0].manifest.name):o.length===2?I.localize(7,null,n.manifest.displayName||n.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):I.localize(8,null,n.manifest.displayName||n.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):o.length===1?I.localize(9,null,n.manifest.displayName||n.manifest.name,r.manifest.displayName||r.manifest.name,o[0].manifest.displayName||o[0].manifest.name):o.length===2?I.localize(10,null,n.manifest.displayName||n.manifest.name,r.manifest.displayName||r.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):I.localize(11,null,n.manifest.displayName||n.manifest.name,r.manifest.displayName||r.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name)}getAllPackExtensionsToUninstall(r,o,n=[]){if(n.indexOf(r)!==-1)return[];n.push(r);const t=r.manifest.extensionPack?r.manifest.extensionPack:[];if(t.length){const s=o.filter(u=>!u.isBuiltin&&t.some(f=>(0,d.areSameExtensions)({id:f},u.identifier))),c=[];for(const u of s)c.push(...this.getAllPackExtensionsToUninstall(u,o,n));return[...s,...c]}return[]}getDependents(r,o){return o.filter(n=>n.manifest.extensionDependencies&&n.manifest.extensionDependencies.some(t=>(0,d.areSameExtensions)({id:t},r.identifier)))}async findGalleryExtension(r){if(r.identifier.uuid){const o=await this.findGalleryExtensionById(r.identifier.uuid);return o||this.findGalleryExtensionByName(r.identifier.id)}return this.findGalleryExtensionByName(r.identifier.id)}async findGalleryExtensionById(r){return(await this.galleryService.query({ids:[r],pageSize:1},D.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(r){return(await this.galleryService.query({names:[r],pageSize:1},D.CancellationToken.None)).firstPage[0]}async updateReportCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const r=await this.galleryService.getExtensionsReport();return this.logService.trace(`ExtensionManagementService.refreshReportedCache - got ${r.length} reported extensions from service`),r}catch(r){return this.logService.trace("ExtensionManagementService.refreshReportedCache - failed to get extension report"),[]}}};y=he([J(0,E.IExtensionGalleryService),J(1,w.ITelemetryService),J(2,p.ILogService),J(3,h.IProductService)],y),e.AbstractExtensionManagementService=y;function m(l){const r=Array.isArray(l)?l:[l];return r.length===1?r[0]instanceof Error?r[0]:new Error(r[0]):r.reduce((o,n)=>new Error(`${o.message}${o.message?",":""}${n instanceof Error?n.message:n}`),new Error(""))}e.joinErrors=m;function b(l){if(l instanceof E.ExtensionManagementError)return l;const r=new E.ExtensionManagementError(l.message,E.ExtensionManagementErrorCode.Internal);return r.stack=l.stack,r}function g(l,r,o,n,t){const s=t?t instanceof E.ExtensionManagementError?t.code:E.ExtensionManagementErrorCode.Internal:void 0;l.publicLogError(r,{...o,success:!t,duration:n,errorcode:s})}e.reportTelemetry=g;class a{constructor(){this.barrier=new L.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,L.createCancelablePromise)(r=>this.doRun(r))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,L.createCancelablePromise)(r=>new Promise((o,n)=>{const t=r.onCancellationRequested(()=>{t.dispose(),n((0,k.canceled)())})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=a}),define(te[203],ne([0,1,16,5,66,3,10,4,31,7,132,11,30,193,80,14,8,60,26,43,23,22]),function(X,e,R,L,D,k,i,P,S,C,I,E,d,p,h,w,y,m,b,g,a,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;const r="extensionTips/promptedExecutableTips",o="extensionTips/lastPromptedMediumImpExeTime";let n=class extends p.ExtensionTipsService{constructor(s,c,u,f,v,T,O,U,W,N){super(O,U,W,N);this.environmentService=s,this.telemetryService=c,this.extensionManagementService=u,this.storageService=f,this.nativeHostService=v,this.extensionRecommendationNotificationService=T,this.highImportanceExecutableTips=new Map,this.mediumImportanceExecutableTips=new Map,this.allOtherExecutableTips=new Map,this.highImportanceTipsByExe=new Map,this.mediumImportanceTipsByExe=new Map,U.exeBasedExtensionTips&&(0,D.forEach)(U.exeBasedExtensionTips,({key:A,value:z})=>{const _=[],M=[],q=[];(0,D.forEach)(z.recommendations,({key:B,value:j})=>{j.important?z.important?_.push({extensionId:B,extensionName:j.name,isExtensionPack:!!j.isExtensionPack}):M.push({extensionId:B,extensionName:j.name,isExtensionPack:!!j.isExtensionPack}):q.push({extensionId:B,extensionName:j.name,isExtensionPack:!!j.isExtensionPack})}),_.length&&this.highImportanceExecutableTips.set(A,{exeFriendlyName:z.friendlyName,windowsPath:z.windowsPath,recommendations:_}),M.length&&this.mediumImportanceExecutableTips.set(A,{exeFriendlyName:z.friendlyName,windowsPath:z.windowsPath,recommendations:M}),q.length&&this.allOtherExecutableTips.set(A,{exeFriendlyName:z.friendlyName,windowsPath:z.windowsPath,recommendations:q})}),(0,L.timeout)(3e3).then(async()=>{await this.collectTips(),this.promptHighImportanceExeBasedTip(),this.promptMediumImportanceExeBasedTip()})}async getImportantExecutableBasedTips(){const s=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),c=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips);return[...s,...c]}getOtherExecutableBasedTips(){return this.getValidExecutableBasedExtensionTips(this.allOtherExecutableTips)}async collectTips(){const s=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),c=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips),u=await this.extensionManagementService.getInstalled();this.highImportanceTipsByExe=this.groupImportantTipsByExe(s,u),this.mediumImportanceTipsByExe=this.groupImportantTipsByExe(c,u)}groupImportantTipsByExe(s,c){const u=new Map;s.forEach(U=>u.set(U.extensionId.toLowerCase(),U));const{installed:f,uninstalled:v}=this.groupByInstalled([...u.keys()],c);for(const U of f){const W=u.get(U);W&&this.telemetryService.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:U,exeName:W.exeName})}for(const U of v){const W=u.get(U);W&&this.telemetryService.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:U,exeName:W.exeName})}const T=this.getPromptedExecutableTips(),O=new Map;for(const U of v){const W=u.get(U);if(W&&(!T[W.exeName]||!T[W.exeName].includes(W.extensionId))){let N=O.get(W.exeName);N||(N=[],O.set(W.exeName,N)),N.push(W)}}return O}promptHighImportanceExeBasedTip(){if(this.highImportanceTipsByExe.size===0)return;const[s,c]=[...this.highImportanceTipsByExe.entries()][0];this.promptExeRecommendations(c).then(u=>{switch(u){case"reacted":this.addToRecommendedExecutables(c[0].exeName,c);break;case"ignored":this.highImportanceTipsByExe.delete(s);break;case"incompatibleWindow":const f=k.Event.once(k.Event.latch(k.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(f(()=>this.promptHighImportanceExeBasedTip()));break;case"toomany":const v=this._register((0,L.disposableTimeout)(()=>{v.dispose(),this.promptHighImportanceExeBasedTip()},60*60*1e3));break}})}promptMediumImportanceExeBasedTip(){if(this.mediumImportanceTipsByExe.size===0)return;const s=this.getLastPromptedMediumExeTime(),c=Date.now()-s,u=7*24*60*60*1e3;if(c<u){const T=this._register((0,L.disposableTimeout)(()=>{T.dispose(),this.promptMediumImportanceExeBasedTip()},u-c));return}const[f,v]=[...this.mediumImportanceTipsByExe.entries()][0];this.promptExeRecommendations(v).then(T=>{switch(T){case"reacted":this.updateLastPromptedMediumExeTime(Date.now()),this.mediumImportanceTipsByExe.delete(f),this.addToRecommendedExecutables(v[0].exeName,v);const O=this._register((0,L.disposableTimeout)(()=>{O.dispose(),this.promptMediumImportanceExeBasedTip()},u));break;case"ignored":this.mediumImportanceTipsByExe.delete(f),this.promptMediumImportanceExeBasedTip();break;case"incompatibleWindow":const U=k.Event.once(k.Event.latch(k.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(U(()=>this.promptMediumImportanceExeBasedTip()));break;case"toomany":const W=this._register((0,L.disposableTimeout)(()=>{W.dispose(),this.promptMediumImportanceExeBasedTip()},60*60*1e3));break}})}promptExeRecommendations(s){const c=s.map(({extensionId:f})=>f.toLowerCase()),u=(0,I.localize)(0,null,s[0].exeFriendlyName);return this.extensionRecommendationNotificationService.promptImportantExtensionsInstallNotification(c,u,`@exe:"${s[0].exeName}"`,3)}getLastPromptedMediumExeTime(){let s=this.storageService.getNumber(o,0);return s||(s=Date.now(),this.updateLastPromptedMediumExeTime(s)),s}updateLastPromptedMediumExeTime(s){this.storageService.store(o,s,0,1)}getPromptedExecutableTips(){return JSON.parse(this.storageService.get(r,0,"{}"))}addToRecommendedExecutables(s,c){const u=this.getPromptedExecutableTips();u[s]=c.map(({extensionId:f})=>f.toLowerCase()),this.storageService.store(r,JSON.stringify(u),0,0)}groupByInstalled(s,c){const u=[],f=[],v=c.reduce((T,O)=>(T.add(O.identifier.id.toLowerCase()),T),new Set);return s.forEach(T=>{v.has(T.toLowerCase())?u.push(T):f.push(T)}),{installed:u,uninstalled:f}}async getValidExecutableBasedExtensionTips(s){const c=[],u=new Map;for(const f of s.keys()){const v=s.get(f);if(!v||!(0,R.isNonEmptyArray)(v.recommendations))continue;const T=[];P.isWindows?v.windowsPath&&T.push(v.windowsPath.replace("%USERPROFILE%",S.env.USERPROFILE).replace("%ProgramFiles(x86)%",S.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",S.env.ProgramFiles).replace("%APPDATA%",S.env.APPDATA).replace("%WINDIR%",S.env.WINDIR)):(T.push((0,i.join)("/usr/local/bin",f)),T.push((0,i.join)("/usr/bin",f)),T.push((0,i.join)(this.environmentService.userHome.fsPath,f)));for(const O of T){let U=u.get(O);if(U===void 0&&(U=await this.fileService.exists(C.URI.file(O)),u.set(O,U)),U)for(const{extensionId:W,extensionName:N,isExtensionPack:A}of v.recommendations)c.push({extensionId:W,extensionName:N,isExtensionPack:A,exeName:f,exeFriendlyName:v.exeFriendlyName,windowsPath:v.windowsPath})}}return c}};n=he([J(0,E.INativeEnvironmentService),J(1,l.ITelemetryService),J(2,d.IExtensionManagementService),J(3,a.IStorageService),J(4,m.INativeHostService),J(5,h.IExtensionRecommendationNotificationService),J(6,w.IFileService),J(7,b.IProductService),J(8,g.IRequestService),J(9,y.ILogService)],n),e.ExtensionTipsService=n}),define(te[92],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class R{constructor(k){this.appenders=k}listen(k,i){throw new Error(`Event not found: ${i}`)}call(k,i,{eventName:P,data:S}){return this.appenders.forEach(C=>C.log(P,S)),Promise.resolve(null)}}e.TelemetryAppenderChannel=R;class L{constructor(k){this.channel=k}log(k,i){return this.channel.call("log",{eventName:k,data:i}).then(void 0,P=>`Failed to log telemetry: ${console.warn(P)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=L}),define(te[44],ne([0,1,28,17,21,22]),function(X,e,R,L,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class i{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(m,b){return Promise.resolve(void 0)}publicLog2(m,b){return this.publicLog(m,b)}publicLogError(m,b){return Promise.resolve(void 0)}publicLogError2(m,b){return this.publicLogError(m,b)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=i,e.NullTelemetryService=new i;class P{async publicLog(m,b,g){}async publicLogError(m,b,g){}}e.NullEndpointTelemetryService=P,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function S(y,m){return m.onDidChangeConfiguration(b=>{b.source!==6&&y.publicLog2("updateConfiguration",{configurationSource:(0,D.ConfigurationTargetToString)(b.source),configurationKeys:h(b.sourceConfig)})})}e.configurationTelemetry=S;function C(y,m){return!(m.disableTelemetry||!y.enableTelemetry)}e.supportsTelemetry=C;function I(y){const m=y.getValue(k.TELEMETRY_SETTING_ID),b=y.getValue("telemetry.enableCrashReporter");if(y.getValue(k.TELEMETRY_OLD_SETTING_ID)===!1||b===!1)return 0;switch(m??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=I;function E(y){const m=Object.create(null),b=Object.create(null),g=Object.create(null);p(y,g);for(let a in g){a=a.length>150?a.substr(a.length-149):a;const l=g[a];typeof l=="number"?b[a]=l:typeof l=="boolean"?b[a]=l?1:0:typeof l=="string"?(l.length>8192&&console.warn(`Telemetry property: ${a} has been trimmed to 8192, the original length is ${l.length}`),m[a]=l.substring(0,8191)):typeof l!="undefined"&&l!==null&&(m[a]=l)}return{properties:m,measurements:b}}e.validateTelemetryData=E;function d(y){if(!y)return"none";let m="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(g=>{y.indexOf(`${g}+`)===0&&(m=g)}),m}e.cleanRemoteAuthority=d;function p(y,m,b=0,g){if(!!y)for(let a of Object.getOwnPropertyNames(y)){const l=y[a],r=g?g+a:a;Array.isArray(l)?m[r]=(0,R.safeStringify)(l):l instanceof Date?m[r]=l.toISOString():(0,L.isObject)(l)?b<2?p(l,m,b+1,r+"."):m[r]=(0,R.safeStringify)(l):m[r]=l}}function h(y){if(!y)return[];const m=[];return w(m,"",y),m}function w(y,m,b){b&&typeof b=="object"&&!Array.isArray(b)?Object.keys(b).forEach(g=>w(y,m?`${m}.${g}`:g,b[g])):y.push(m)}}),define(te[204],ne([0,1,44,150]),function(X,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AssignmentService=e.BaseAssignmentService=void 0;class D{constructor(){}setSharedProperty(S,C){}postEvent(S,C){}}class k{constructor(S,C,I,E,d){this.getMachineId=S,this.configurationService=C,this.productService=I,this.telemetry=E,this.keyValueStorage=d,this.networkInitialized=!1,I.tasConfig&&this.experimentsEnabled&&(0,R.getTelemetryLevel)(this.configurationService)===3&&(this.tasClient=this.setupTASClient());const p=this.configurationService.getValue("experiments.overrideDelay"),h=typeof p=="number"?p:0;this.overrideInitDelay=new Promise(w=>setTimeout(w,h))}get experimentsEnabled(){return!0}async getTreatment(S){await this.overrideInitDelay;const C=this.configurationService.getValue("experiments.override."+S);if(C!==void 0)return C;if(!this.tasClient||!this.experimentsEnabled)return;let I;const E=await this.tasClient;return this.networkInitialized?I=E.getTreatmentVariable("vscode",S):I=await E.getTreatmentVariableAsync("vscode",S,!0),I=E.getTreatmentVariable("vscode",S),I}async setupTASClient(){const S=this.productService.quality==="stable"?L.TargetPopulation.Public:L.TargetPopulation.Insiders,C=await this.getMachineId(),I=new L.AssignmentFilterProvider(this.productService.version,this.productService.nameLong,C,S),E=this.productService.tasConfig,d=new(await new Promise((p,h)=>{X(["tas-client-umd"],p,h)})).ExperimentationService({filterProviders:[I],telemetry:this.telemetry,storageKey:L.ASSIGNMENT_STORAGE_KEY,keyValueStorage:this.keyValueStorage,featuresTelemetryPropertyName:E.featuresTelemetryPropertyName,assignmentContextTelemetryPropertyName:E.assignmentContextTelemetryPropertyName,telemetryEventName:E.telemetryEventName,endpoint:E.endpoint,refetchInterval:L.ASSIGNMENT_REFETCH_INTERVAL});return await d.initializePromise,d.initialFetch.then(()=>this.networkInitialized=!0),d}}e.BaseAssignmentService=k;class i extends k{constructor(S,C,I){super(()=>Promise.resolve(S),C,I,new D)}}e.AssignmentService=i}),define(te[205],ne([0,1,16,27,9,28,4,31,7,21,11,30,36,76,14,8,26,43,46,23,22,44]),function(X,e,R,L,D,k,i,P,S,C,I,E,d,p,h,w,y,m,b,g,a,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const r=i.isWeb?"web":(0,E.getTargetPlatform)(i.platform,P.arch);var o;(function(G){G[G.None=0]="None",G[G.IncludeVersions=1]="IncludeVersions",G[G.IncludeFiles=2]="IncludeFiles",G[G.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",G[G.IncludeSharedAccounts=8]="IncludeSharedAccounts",G[G.IncludeVersionProperties=16]="IncludeVersionProperties",G[G.ExcludeNonValidated=32]="ExcludeNonValidated",G[G.IncludeInstallationTargets=64]="IncludeInstallationTargets",G[G.IncludeAssetUri=128]="IncludeAssetUri",G[G.IncludeStatistics=256]="IncludeStatistics",G[G.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",G[G.Unpublished=4096]="Unpublished"})(o||(o={}));function n(...G){return String(G.reduce((H,re)=>H|re,0))}var t;(function(G){G[G.Tag=1]="Tag",G[G.ExtensionId=4]="ExtensionId",G[G.Category=5]="Category",G[G.ExtensionName=7]="ExtensionName",G[G.Target=8]="Target",G[G.Featured=9]="Featured",G[G.SearchText=10]="SearchText",G[G.ExcludeWithFlags=12]="ExcludeWithFlags"})(t||(t={}));const s={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},c={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},f={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:o.None,criteria:[],assetTypes:[]};class v{constructor(H=f){this.state=H}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(H,re=this.state.pageSize){return new v({...this.state,pageNumber:H,pageSize:re})}withFilter(H,...re){const ie=[...this.state.criteria,...re.length?re.map(ce=>({filterType:H,value:ce})):[{filterType:H}]];return new v({...this.state,criteria:ie})}withSortBy(H){return new v({...this.state,sortBy:H})}withSortOrder(H){return new v({...this.state,sortOrder:H})}withFlags(...H){return new v({...this.state,flags:H.reduce((re,ie)=>re|ie,0)})}withAssetTypes(...H){return new v({...this.state,assetTypes:H})}get raw(){const{criteria:H,pageNumber:re,pageSize:ie,sortBy:ce,sortOrder:le,flags:de,assetTypes:pe}=this.state;return{filters:[{criteria:H,pageNumber:re,pageSize:ie,sortBy:ce,sortOrder:le}],assetTypes:pe,flags:de}}get searchText(){const H=this.state.criteria.filter(re=>re.filterType===t.SearchText)[0];return H&&H.value?H.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(H=>String(H.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function T(G,H){const re=(G||[]).filter(ie=>ie.statisticName===H)[0];return re?re.value:0}function O(G){const H="Microsoft.VisualStudio.Code.Translation.";return G.files.filter(ie=>ie.assetType.indexOf(H)===0).reduce((ie,ce)=>{const le=A(G,ce.assetType);return le&&ie.push([ce.assetType.substring(H.length),le]),ie},[])}function U(G){if(G.properties){const H=G.properties.filter(ce=>ce.key===s.Repository),re=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),ie=H.filter(ce=>re.test(ce.value))[0];return ie?{uri:ie.value,fallbackUri:ie.value}:null}return A(G,s.Repository)}function W(G){return{uri:`${G.fallbackAssetUri}/${s.VSIX}?redirect=true${G.targetPlatform?`&targetPlatform=${G.targetPlatform}`:""}`,fallbackUri:`${G.fallbackAssetUri}/${s.VSIX}${G.targetPlatform?`?targetPlatform=${G.targetPlatform}`:""}`}}function N(G){const H=A(G,s.Icon);if(H)return H;const re=E.DefaultIconPath;return{uri:re,fallbackUri:re}}function A(G,H){return G.files.filter(ie=>ie.assetType===H)[0]?{uri:`${G.assetUri}/${H}`,fallbackUri:`${G.fallbackAssetUri}/${H}`}:null}function z(G,H){const re=G.properties?G.properties.filter(ce=>ce.key===H):[],ie=re.length>0&&re[0].value;return ie?ie.split(",").map(ce=>(0,d.adoptToGalleryExtensionId)(ce)):[]}function _(G){const H=G.properties?G.properties.filter(re=>re.key===c.Engine):[];return H.length>0&&H[0].value||""}function M(G){const H=G.properties?G.properties.filter(ie=>ie.key===c.LocalizedLanguages):[],re=H.length>0&&H[0].value||"";return re?re.split(","):[]}function q(G){return G.indexOf("preview")!==-1}function B(G){return G.targetPlatform?(0,E.toTargetPlatform)(G.targetPlatform):"undefined"}function j(G){const H=(0,R.distinct)(G.versions.map(B)),re=!!G.tags?.includes(E.WEB_EXTENSION_TAG),ie=H.indexOf("web");return re?ie===-1&&H.push("web"):ie!==-1&&H.splice(ie,1),H}function $(G,H){const re=(0,E.getFallbackTargetPlarforms)(H);for(let ie=0;ie<G.length;ie++){const ce=G[ie];if(ce.version===G[ie-1]?.version){let le=ie;const de=B(ce);if(de===H)for(;le>0&&G[le-1].version===ce.version;)le--;else if(re.includes(de))for(;le>0&&G[le-1].version===ce.version&&B(G[le-1])!==H;)le--;le!==ie&&(G.splice(ie,1),G.splice(le,0,ce))}}return G}e.sortExtensionVersions=$;function K(G,H,re,ie,ce){const le=j(G);let de=G.versions[0];return de=G.versions.find(pe=>pe.version===de.version&&(0,E.isTargetPlatformCompatible)(B(pe),le,ce))||de,F(G,de,le,H,re,ie)}function F(G,H,re,ie,ce,le){const de={manifest:A(H,s.Manifest),readme:A(H,s.Details),changelog:A(H,s.Changelog),license:A(H,s.License),repository:U(H),download:W(H),icon:N(H),coreTranslations:O(H)};return{identifier:{id:(0,d.getGalleryExtensionId)(G.publisher.publisherName,G.extensionName),uuid:G.extensionId},name:G.extensionName,version:H.version,displayName:G.displayName,publisherId:G.publisher.publisherId,publisher:G.publisher.publisherName,publisherDisplayName:G.publisher.displayName,publisherDomain:G.publisher.domain?{link:G.publisher.domain,verified:!!G.publisher.isDomainVerified}:void 0,description:G.shortDescription||"",installCount:T(G.statistics,"install"),rating:T(G.statistics,"averagerating"),ratingCount:T(G.statistics,"ratingcount"),categories:G.categories||[],tags:G.tags||[],releaseDate:Date.parse(G.releaseDate),lastUpdated:Date.parse(G.lastUpdated),allTargetPlatforms:re,assets:de,properties:{dependencies:z(H,c.Dependency),extensionPack:z(H,c.ExtensionPack),engine:_(H),localizedLanguages:M(H),targetPlatform:B(H)},preview:q(G.flags),telemetryData:{index:(ce.pageNumber-1)*ce.pageSize+ie,querySource:le}}}let x=class{constructor(H,re,ie,ce,le,de,pe,be){this.requestService=re,this.logService=ie,this.environmentService=ce,this.telemetryService=le,this.fileService=de,this.productService=pe,this.configurationService=be;const Ie=pe.extensionsGallery;this.extensionsGalleryUrl=Ie&&Ie.serviceUrl,this.extensionsControlUrl=Ie&&Ie.controlUrl,this.commonHeadersPromise=Z(pe.version,pe,this.environmentService,this.configurationService,this.fileService,H)}api(H=""){return`${this.extensionsGalleryUrl}${H}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(H,re){const ie=[];let ce=new v().withFlags(o.IncludeAssetUri,o.IncludeStatistics,o.IncludeCategoryAndTags,o.IncludeFiles,o.IncludeVersionProperties).withPage(1,H.length).withFilter(t.Target,"Microsoft.VisualStudio.Code").withFilter(t.ExtensionName,...H.map(({id:de})=>de.toLowerCase()));H.every(de=>!de.version)&&(ce=ce.withFlags(o.IncludeAssetUri,o.IncludeStatistics,o.IncludeCategoryAndTags,o.IncludeFiles,o.IncludeVersionProperties,o.IncludeLatestVersionOnly));const{galleryExtensions:le}=await this.queryGallery(ce,r,L.CancellationToken.None);for(let de=0;de<le.length;de++){const pe=le[de];if(!pe.versions.length)continue;const be=(0,d.getGalleryExtensionId)(pe.publisher.publisherName,pe.extensionName),Ie=H.find(Se=>(0,d.areSameExtensions)(Se,{id:be}))?.version;if(Ie){const Se=pe.versions.find(ke=>ke.version===Ie);Se&&ie.push(F(pe,Se,j(pe),de,ce))}else ie.push(K(pe,de,ce,void 0,r))}return ie}async getCompatibleExtension(H,re){const ie=(0,E.isIExtensionIdentifier)(H)?null:H;if(ie){if((0,E.isNotWebExtensionInWebTargetPlatform)(ie.allTargetPlatforms,re))return null;if(await this.isExtensionCompatible(ie,re))return ie}const{id:ce,uuid:le}=ie?ie.identifier:H;let de=new v().withFlags(o.IncludeAssetUri,o.IncludeStatistics,o.IncludeCategoryAndTags,o.IncludeFiles,o.IncludeVersionProperties).withPage(1,1).withFilter(t.Target,"Microsoft.VisualStudio.Code");le?de=de.withFilter(t.ExtensionId,le):de=de.withFilter(t.ExtensionName,ce);const{galleryExtensions:pe}=await this.queryGallery(de,re,L.CancellationToken.None),[be]=pe;if(!be||!be.versions.length)return null;const Ie=j(be);if((0,E.isNotWebExtensionInWebTargetPlatform)(Ie,re))return null;for(let Se of be.versions){if(!_(Se)){const ke=await this.getEngine(Se);Se={...Se,properties:[...Se.properties||[],{key:c.Engine,value:ke}]}}if(await this.isRawExtensionVersionCompatible(Se,Ie,re))return F(be,Se,Ie,0,de)}return null}async isExtensionCompatible(H,re){if(!(0,E.isTargetPlatformCompatible)(H.properties.targetPlatform,H.allTargetPlatforms,re))return!1;let ie=H.properties.engine;if(!ie){const ce=await this.getManifest(H,L.CancellationToken.None);if(!ce)throw new Error("Manifest was not found");ie=ce.engines.vscode}return(0,p.isEngineValid)(ie,this.productService.version,this.productService.date)}async isRawExtensionVersionCompatible(H,re,ie){if(!(0,E.isTargetPlatformCompatible)(B(H),re,ie))return!1;const ce=await this.getEngine(H);return(0,p.isEngineValid)(ce,this.productService.version,this.productService.date)}async query(H,re){if(!this.isEnabled())throw new Error("No extension gallery service configured.");let ie=H.text||"";const ce=(0,k.getOrDefault)(H,Se=>Se.pageSize,50);let le=new v().withFlags(o.IncludeLatestVersionOnly,o.IncludeAssetUri,o.IncludeStatistics,o.IncludeCategoryAndTags,o.IncludeFiles,o.IncludeVersionProperties).withPage(1,ce).withFilter(t.Target,"Microsoft.VisualStudio.Code");ie?(ie=ie.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(Se,ke,Pe)=>(le=le.withFilter(t.Category,Pe||ke),"")),ie=ie.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(Se,ke,Pe)=>(le=le.withFilter(t.Tag,Pe||ke),"")),ie=ie.replace(/\bfeatured(\s+|\b|$)/g,()=>(le=le.withFilter(t.Featured),"")),ie=ie.trim(),ie&&(ie=ie.length<200?ie:ie.substring(0,200),le=le.withFilter(t.SearchText,ie)),le=le.withSortBy(0)):H.ids?le=le.withFilter(t.ExtensionId,...H.ids):H.names?le=le.withFilter(t.ExtensionName,...H.names):le=le.withSortBy(4),typeof H.sortBy=="number"&&(le=le.withSortBy(H.sortBy)),typeof H.sortOrder=="number"&&(le=le.withSortOrder(H.sortOrder));const{galleryExtensions:de,total:pe}=await this.queryGallery(le,r,re),be=de.map((Se,ke)=>K(Se,ke,le,H.source,r)),Ie=async(Se,ke)=>{if(ke.isCancellationRequested)throw(0,D.canceled)();const Pe=le.withPage(Se+1),{galleryExtensions:Ue}=await this.queryGallery(Pe,r,ke);return Ue.map((qe,Fe)=>K(qe,Fe,Pe,H.source,r))};return{firstPage:be,total:pe,pageSize:le.pageSize,getPage:Ie}}async queryGallery(H,re,ie){if(!this.isEnabled())throw new Error("No extension gallery service configured.");H=H.withFlags(H.flags,o.ExcludeNonValidated).withFilter(t.ExcludeWithFlags,n(o.Unpublished));const ce=await this.commonHeadersPromise,le=JSON.stringify(H.raw),de={...ce,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(le.length)},pe=new Date().getTime();let be,Ie,Se=0;try{if(be=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:le,headers:de},ie),be.res.statusCode&&be.res.statusCode>=400&&be.res.statusCode<500)return{galleryExtensions:[],total:Se};const ke=await(0,m.asJson)(be);if(ke){const Pe=ke.results[0],Ue=Pe.extensions;Ue.forEach(Fe=>$(Fe.versions,re));const qe=Pe.resultMetadata&&Pe.resultMetadata.filter(Fe=>Fe.metadataType==="ResultCount")[0];return Se=qe&&qe.metadataItems.filter(Fe=>Fe.name==="TotalCount")[0].count||0,{galleryExtensions:Ue,total:Se}}return{galleryExtensions:[],total:Se}}catch(ke){throw Ie=ke,ke}finally{this.telemetryService.publicLog2("galleryService:query",{...H.telemetryData,requestBodySize:String(le.length),duration:new Date().getTime()-pe,success:!!be&&(0,m.isSuccess)(be),responseBodySize:be?.res.headers["Content-Length"],statusCode:be?String(be.res.statusCode):void 0,errorCode:Ie?(0,D.isPromiseCanceledError)(Ie)?"canceled":(0,D.getErrorMessage)(Ie).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(Se)})}}async reportStatistic(H,re,ie,ce){if(!this.isEnabled())return;const le=i.isWeb?this.api(`/itemName/${H}.${re}/version/${ie}/statType/${ce==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${H}/extensions/${re}/${ie}/stats?statType=${ce}`),de=i.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",be={...await this.commonHeadersPromise,Accept:de};try{await this.requestService.request({type:"POST",url:le,headers:be},L.CancellationToken.None)}catch(Ie){}}async download(H,re,ie){this.logService.trace("ExtensionGalleryService#download",H.identifier.id);const ce=(0,d.getGalleryExtensionTelemetryData)(H),le=new Date().getTime(),de=Se=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...ce,duration:Se}),pe=ie===1?"install":ie===2?"update":"",be=pe?{uri:`${H.assets.download.uri}${S.URI.parse(H.assets.download.uri).query?"&":"?"}${pe}=true`,fallbackUri:`${H.assets.download.fallbackUri}${S.URI.parse(H.assets.download.fallbackUri).query?"&":"?"}${pe}=true`}:H.assets.download,Ie=await this.getAsset(be);await this.fileService.writeFile(re,Ie.stream),de(new Date().getTime()-le)}async getReadme(H,re){if(H.assets.readme){const ie=await this.getAsset(H.assets.readme,{},re);return await(0,m.asText)(ie)||""}return""}async getManifest(H,re){if(H.assets.manifest){const ie=await this.getAsset(H.assets.manifest,{},re),ce=await(0,m.asText)(ie);return ce?JSON.parse(ce):null}return null}async getManifestFromRawExtensionVersion(H,re){const ie=A(H,s.Manifest);if(!ie)throw new Error("Manifest was not found");const ce={"Accept-Encoding":"gzip"},le=await this.getAsset(ie,{headers:ce});return await(0,m.asJson)(le)}async getCoreTranslation(H,re){const ie=H.assets.coreTranslations.filter(ce=>ce[0]===re.toUpperCase())[0];if(ie){const ce=await this.getAsset(ie[1]),le=await(0,m.asText)(ce);return le?JSON.parse(le):null}return null}async getChangelog(H,re){if(H.assets.changelog){const ie=await this.getAsset(H.assets.changelog,{},re);return await(0,m.asText)(ie)||""}return""}async getAllCompatibleVersions(H,re){let ie=new v().withFlags(o.IncludeVersions,o.IncludeCategoryAndTags,o.IncludeFiles,o.IncludeVersionProperties).withPage(1,1).withFilter(t.Target,"Microsoft.VisualStudio.Code");H.identifier.uuid?ie=ie.withFilter(t.ExtensionId,H.identifier.uuid):ie=ie.withFilter(t.ExtensionName,H.identifier.id);const{galleryExtensions:ce}=await this.queryGallery(ie,re,L.CancellationToken.None);if(!ce.length)return[];const le=j(ce[0]);if((0,E.isNotWebExtensionInWebTargetPlatform)(le,re))return[];const de=[];for(const pe of ce[0].versions)try{de[de.length-1]?.version!==pe.version&&await this.isRawExtensionVersionCompatible(pe,le,re)&&de.push({version:pe.version,date:pe.lastUpdated})}catch(be){}return de}async getAsset(H,re={},ie=L.CancellationToken.None){const ce=await this.commonHeadersPromise,le={type:"GET"},de={...ce,...re.headers||{}};re={...re,...le,headers:de};const pe=H.uri,be=H.fallbackUri,Ie={...re,url:pe};try{const Se=await this.requestService.request(Ie,ie);if(Se.res.statusCode===200)return Se;const ke=await(0,m.asText)(Se);throw new Error(`Expected 200, got back ${Se.res.statusCode} instead.

${ke}`)}catch(Se){if((0,D.isPromiseCanceledError)(Se))throw Se;const ke=(0,D.getErrorMessage)(Se);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:pe,message:ke});const Pe={...re,url:be};return this.requestService.request(Pe,ie)}}async getEngine(H){let re=_(H);if(!re){const ie=await this.getManifestFromRawExtensionVersion(H,L.CancellationToken.None);if(!ie)throw new Error("Manifest was not found");re=ie.engines.vscode}return re}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const H=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},L.CancellationToken.None);if(H.res.statusCode!==200)throw new Error("Could not get extensions report.");const re=await(0,m.asJson)(H),ie=new Map;if(re)for(const ce of re.malicious){const le=ie.get(ce)||{id:{id:ce},malicious:!0,slow:!1};le.malicious=!0,ie.set(ce,le)}return[...ie.values()]}};x=he([J(1,m.IRequestService),J(2,w.ILogService),J(3,I.IEnvironmentService),J(4,a.ITelemetryService),J(5,h.IFileService),J(6,y.IProductService),J(7,C.IConfigurationService)],x);let V=class extends x{constructor(H,re,ie,ce,le,de,pe,be){super(H,re,ie,ce,le,de,pe,be)}};V=he([J(0,g.IStorageService),J(1,m.IRequestService),J(2,w.ILogService),J(3,I.IEnvironmentService),J(4,a.ITelemetryService),J(5,h.IFileService),J(6,y.IProductService),J(7,C.IConfigurationService)],V),e.ExtensionGalleryService=V;let Q=class extends x{constructor(H,re,ie,ce,le,de,pe){super(void 0,H,re,ie,ce,le,de,pe)}};Q=he([J(0,m.IRequestService),J(1,w.ILogService),J(2,I.IEnvironmentService),J(3,a.ITelemetryService),J(4,h.IFileService),J(5,y.IProductService),J(6,C.IConfigurationService)],Q),e.ExtensionGalleryServiceWithNoStorageService=Q;async function Z(G,H,re,ie,ce,le){const de={"X-Market-Client-Id":`VSCode ${G}`,"User-Agent":`VSCode ${G}`},pe=await(0,b.getServiceMachineId)(re,ce,le);return(0,l.supportsTelemetry)(H,re)&&(0,l.getTelemetryLevel)(ie)===3&&(de["X-Market-User-Id"]=pe),de}e.resolveMarketplaceHeaders=Z}),define(te[93],ne([0,1,2,11,8,44]),function(X,e,R,L,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let i=class extends R.Disposable{constructor(S,C,I=""){super();this.prefix=I;const E=S.getLogger(C.telemetryLogResource);E?this.logger=this._register(E):(this.logger=this._register(S.createLogger(C.telemetryLogResource)),this.logger.info("The below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.logger.info("==========================================================="))}flush(){return Promise.resolve(void 0)}log(S,C){this.logger.trace(`${this.prefix}telemetry/${S}`,(0,k.validateTelemetryData)(C))}};i=he([J(0,D.ILoggerService),J(1,L.IEnvironmentService)],i),e.TelemetryLogAppender=i}),define(te[94],ne([0,1,2,28,4,25,142,21,39,86,35,22,44]),function(X,e,R,L,D,k,i,P,S,C,I,E,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let p=class{constructor(y,m){this._configurationService=m,this._experimentProperties={},this._disposables=new R.DisposableStore,this._cleanupPatterns=[],this._appenders=y.appenders,this._commonProperties=y.commonProperties||Promise.resolve({}),this._piiPaths=y.piiPaths||[],this._telemetryLevel=3,this.sendErrorTelemetry=!!y.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let b of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,k.escapeRegExpCharacters)(b),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._telemetryLevel===3}),this._commonProperties.then(b=>{const g=/^[a-f0-9]+$/i.test(b["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!g})})}setExperimentProperty(y,m){this._experimentProperties[y]=m}_updateTelemetryLevel(){this._telemetryLevel=(0,d.getTelemetryLevel)(this._configurationService)}get telemetryLevel(){return this._telemetryLevel}async getTelemetryInfo(){const y=await this._commonProperties;let m=y.sessionID,b=y["common.machineId"],g=y["common.firstSessionDate"],a=y["common.msftInternal"];return{sessionId:m,machineId:b,firstSessionDate:g,msftInternal:a}}dispose(){this._disposables.dispose()}_log(y,m,b,g){return this.telemetryLevel<m?Promise.resolve(void 0):this._commonProperties.then(a=>{b=(0,L.mixin)(b,a),b=(0,L.mixin)(b,this._experimentProperties),b=(0,L.cloneAndChange)(b,l=>{if(typeof l=="string")return this._cleanupInfo(l,g)}),this._appenders.forEach(l=>l.log(y,b))},a=>{console.error(a)})}publicLog(y,m,b){return this._log(y,3,m,b)}publicLog2(y,m,b){return this.publicLog(y,m,b)}publicLogError(y,m){return this.sendErrorTelemetry?this._log(y,2,m,!0):Promise.resolve(void 0)}publicLogError2(y,m){return this.publicLogError(y,m)}_anonymizeFilePaths(y){let m=y;const b=[];for(let r of this._cleanupPatterns)for(;;){const o=r.exec(y);if(!o)break;b.push([o.index,r.lastIndex])}const g=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,a=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let l=0;for(m="";;){const r=a.exec(y);if(!r)break;!g.test(r[0])&&b.every(([o,n])=>r.index<o||r.index>=n)&&(m+=y.substring(l,r.index)+"<REDACTED: user-file-path>",l=a.lastIndex)}return l<y.length&&(m+=y.substr(l)),m}_removePropertiesWithPossibleUserInfo(y){if(!y)return y;const m=y.toLowerCase(),b=/@[a-zA-Z0-9-.]+/;return/\S*(key|token|sig|password|passwd|pwd)[="':\s]+\S*/.test(m)?"<REDACTED: secret>":b.test(m)?"<REDACTED: email>":y}_cleanupInfo(y,m){let b=y;m&&(b=this._anonymizeFilePaths(b));for(let g of this._cleanupPatterns)b=b.replace(g,"");return b=this._removePropertiesWithPossibleUserInfo(b),b}};p.IDLE_START_EVENT_NAME="UserIdleStart",p.IDLE_STOP_EVENT_NAME="UserIdleStop",p=he([J(1,P.IConfigurationService)],p),e.TelemetryService=p;function h(){const w=(0,i.localize)(0,null,C.default.nameLong),y=C.default.privacyStatementUrl?(0,i.localize)(2,null,"https://aka.ms/vscode-telemetry",C.default.privacyStatementUrl):(0,i.localize)(1,null,"https://aka.ms/vscode-telemetry"),m=D.isWeb?"":(0,i.localize)(3,null),b=(0,i.localize)(4,null),g=(0,i.localize)(5,null),a=(0,i.localize)(6,null),l=(0,i.localize)(7,null),r=`
|       | ${b} | ${g} | ${a} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,o=(0,i.localize)(8,null);return`
${w} ${y} ${m}

&nbsp;

${l}
${r}

&nbsp;

${o}
`}I.Registry.as(S.Extensions.Configuration).registerConfiguration({id:E.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,i.localize)(9,null),properties:{[E.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,i.localize)(10,null),(0,i.localize)(11,null),(0,i.localize)(12,null),(0,i.localize)(13,null)],markdownDescription:h(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),I.Registry.as(S.Extensions.Configuration).registerConfiguration({id:E.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,i.localize)(14,null),properties:{[E.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:C.default.privacyStatementUrl?(0,i.localize)(16,null,C.default.nameLong,C.default.privacyStatementUrl):(0,i.localize)(15,null,C.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,i.localize)(17,null,`\`#${E.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(te[206],ne([0,1,9,28,44]),function(X,e,R,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AppInsightsAppender=void 0;async function k(P,S){const C=await new Promise((E,d)=>{X(["applicationinsights"],E,d)});let I;return C.defaultClient?(I=new C.TelemetryClient(P),I.channel.setUseDiskRetryCaching(!0)):(C.setup(P).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),I=C.defaultClient),P.indexOf("AIF-")===0&&(I.config.endpointUrl=S?"https://mobile.events.data.microsoft.com/collect/v1":"https://vortex.data.microsoft.com/collect/v1"),I}class i{constructor(S,C,I,E,d){this._eventPrefix=S,this._defaultData=C,this.testCollector=E,this.mirrored=d,this._defaultData||(this._defaultData=Object.create(null)),typeof I=="function"?this._aiClient=I():this._aiClient=I,this._asyncAIClient=null}_withAIClient(S){if(!!this._aiClient){if(typeof this._aiClient!="string"){S(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=k(this._aiClient,this.testCollector??!1)),this._asyncAIClient.then(C=>{S(C)},C=>{(0,R.onUnexpectedError)(C),console.error(C)})}}log(S,C){!this._aiClient||(C=(0,L.mixin)(C,this._defaultData),C=(0,D.validateTelemetryData)(C),this.testCollector&&(C.properties["common.useragent"]=this.mirrored?"mirror-collector++":"collector++"),this._withAIClient(I=>I.trackEvent({name:this._eventPrefix+"/"+S,properties:C.properties,measurements:C.measurements})))}flush(){return this._aiClient?new Promise(S=>{this._withAIClient(C=>{C.flush({callback:()=>{this._aiClient=void 0,S(void 0)}})})}):Promise.resolve(void 0)}}e.AppInsightsAppender=i}),define(te[207],ne([0,1,15,52,21,11,8,22,92,93,94]),function(X,e,R,L,D,k,i,P,S,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let E=class{constructor(p,h,w,y){this.configurationService=p,this.telemetryService=h,this.loggerService=w,this.environmentService=y,this.customTelemetryServices=new Map}async getCustomTelemetryService(p){if(!this.customTelemetryServices.has(p.id)){const{machineId:h,sessionId:w}=await this.telemetryService.getTelemetryInfo(),y=Object.create(null);y["common.vscodemachineid"]=h,y["common.vscodesessionid"]=w;const m=[p.id,JSON.stringify(y),p.aiKey],g=new L.Client(R.FileAccess.asFileUri("bootstrap-fork",X).fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:m,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),a=[new S.TelemetryAppenderClient(g),new C.TelemetryLogAppender(this.loggerService,this.environmentService,`[${p.id}] `)];this.customTelemetryServices.set(p.id,new I.TelemetryService({appenders:a,sendErrorTelemetry:p.sendErrorTelemetry},this.configurationService))}return this.customTelemetryServices.get(p.id)}async publicLog(p,h,w){await(await this.getCustomTelemetryService(p)).publicLog(h,w)}async publicLogError(p,h,w){await(await this.getCustomTelemetryService(p)).publicLogError(h,w)}};E=he([J(0,D.IConfigurationService),J(1,P.ITelemetryService),J(2,i.ILoggerService),J(3,k.IEnvironmentService)],E),e.CustomEndpointTelemetryService=E}),define(te[208],ne([0,1,5,27,3,2,8]),function(X,e,R,L,D,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let P=class extends k.Disposable{constructor(C,I){super();this._logService=I,this._lastRequestId=0,this._pendingRequests=new Map,this._pendingRequestDisposables=new Map,this._onCreateRequest=this._register(new D.Emitter),this.onCreateRequest=this._onCreateRequest.event,this._timeout=C===void 0?15e3:C}createRequest(C){return new Promise((I,E)=>{const d=++this._lastRequestId;this._pendingRequests.set(d,I),this._onCreateRequest.fire({requestId:d,...C});const p=new L.CancellationTokenSource;(0,R.timeout)(this._timeout,p.token).then(()=>E(`Request ${d} timed out (${this._timeout}ms)`)),this._pendingRequestDisposables.set(d,[(0,k.toDisposable)(()=>p.cancel())])})}acceptReply(C,I){const E=this._pendingRequests.get(C);E?(this._pendingRequests.delete(C),(0,k.dispose)(this._pendingRequestDisposables.get(C)||[]),this._pendingRequestDisposables.delete(C),E(I)):this._logService.warn(`RequestStore#acceptReply was called without receiving a matching request ${C}`)}};P=he([J(1,i.ILogService)],P),e.RequestStore=P}),define(te[95],ne([0,1,6]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.ProcessCapability=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.ProcessPropertyType=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var L;(function(y){y.Shell="terminal.integrated.shell.",y.ShellArgs="terminal.integrated.shellArgs.",y.DefaultProfile="terminal.integrated.defaultProfile.",y.Profiles="terminal.integrated.profiles."})(L=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var D;(function(y){y.ShellLinux="terminal.integrated.shell.linux",y.ShellMacOs="terminal.integrated.shell.osx",y.ShellWindows="terminal.integrated.shell.windows",y.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",y.AutomationShellLinux="terminal.integrated.automationShell.linux",y.AutomationShellMacOs="terminal.integrated.automationShell.osx",y.AutomationShellWindows="terminal.integrated.automationShell.windows",y.AutomationProfileLinux="terminal.integrated.automationProfile.linux",y.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",y.AutomationProfileWindows="terminal.integrated.automationProfile.windows",y.ShellArgsLinux="terminal.integrated.shellArgs.linux",y.ShellArgsMacOs="terminal.integrated.shellArgs.osx",y.ShellArgsWindows="terminal.integrated.shellArgs.windows",y.ProfilesWindows="terminal.integrated.profiles.windows",y.ProfilesMacOs="terminal.integrated.profiles.osx",y.ProfilesLinux="terminal.integrated.profiles.linux",y.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",y.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",y.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",y.UseWslProfiles="terminal.integrated.useWslProfiles",y.TabsEnabled="terminal.integrated.tabs.enabled",y.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",y.TabsHideCondition="terminal.integrated.tabs.hideCondition",y.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",y.TabsShowActions="terminal.integrated.tabs.showActions",y.TabsLocation="terminal.integrated.tabs.location",y.TabsFocusMode="terminal.integrated.tabs.focusMode",y.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",y.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",y.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",y.CopyOnSelection="terminal.integrated.copyOnSelection",y.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",y.FontFamily="terminal.integrated.fontFamily",y.FontSize="terminal.integrated.fontSize",y.LetterSpacing="terminal.integrated.letterSpacing",y.LineHeight="terminal.integrated.lineHeight",y.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",y.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",y.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",y.BellDuration="terminal.integrated.bellDuration",y.FontWeight="terminal.integrated.fontWeight",y.FontWeightBold="terminal.integrated.fontWeightBold",y.CursorBlinking="terminal.integrated.cursorBlinking",y.CursorStyle="terminal.integrated.cursorStyle",y.CursorWidth="terminal.integrated.cursorWidth",y.Scrollback="terminal.integrated.scrollback",y.DetectLocale="terminal.integrated.detectLocale",y.DefaultLocation="terminal.integrated.defaultLocation",y.GpuAcceleration="terminal.integrated.gpuAcceleration",y.TerminalTitleSeparator="terminal.integrated.tabs.separator",y.TerminalTitle="terminal.integrated.tabs.title",y.TerminalDescription="terminal.integrated.tabs.description",y.RightClickBehavior="terminal.integrated.rightClickBehavior",y.Cwd="terminal.integrated.cwd",y.ConfirmOnExit="terminal.integrated.confirmOnExit",y.ConfirmOnKill="terminal.integrated.confirmOnKill",y.EnableBell="terminal.integrated.enableBell",y.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",y.AllowChords="terminal.integrated.allowChords",y.AllowMnemonics="terminal.integrated.allowMnemonics",y.EnvMacOs="terminal.integrated.env.osx",y.EnvLinux="terminal.integrated.env.linux",y.EnvWindows="terminal.integrated.env.windows",y.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",y.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",y.ShowExitAlert="terminal.integrated.showExitAlert",y.SplitCwd="terminal.integrated.splitCwd",y.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",y.WordSeparators="terminal.integrated.wordSeparators",y.EnableFileLinks="terminal.integrated.enableFileLinks",y.UnicodeVersion="terminal.integrated.unicodeVersion",y.ExperimentalLinkProvider="terminal.integrated.experimentalLinkProvider",y.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",y.LocalEchoEnabled="terminal.integrated.localEchoEnabled",y.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",y.LocalEchoStyle="terminal.integrated.localEchoStyle",y.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",y.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",y.CustomGlyphs="terminal.integrated.customGlyphs",y.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",y.InheritEnv="terminal.integrated.inheritEnv",y.ShowLinkHover="terminal.integrated.showLinkHover",y.IgnoreProcessNames="terminal.integrated.ignoreProcessNames"})(D=e.TerminalSettingId||(e.TerminalSettingId={}));var k;(function(y){y.CommandPrompt="cmd",y.PowerShell="pwsh",y.Wsl="wsl",y.GitBash="gitbash"})(k=e.WindowsShellType||(e.WindowsShellType={}));var i;(function(y){y[y.Api=0]="Api",y[y.Process=1]="Process",y[y.Sequence=2]="Sequence",y[y.Config=3]="Config"})(i=e.TitleEventSource||(e.TitleEventSource={}));var P;(function(y){y.LocalPty="localPty",y.PtyHost="ptyHost",y.Log="log",y.Heartbeat="heartbeat"})(P=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,R.createDecorator)("ptyService");var S;(function(y){y.Cwd="cwd",y.InitialCwd="initialCwd",y.FixedDimensions="fixedDimensions",y.Title="title",y.ShellType="shellType",y.HasChildProcesses="hasChildProcesses",y.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",y.OverrideDimensions="overrideDimensions"})(S=e.ProcessPropertyType||(e.ProcessPropertyType={}));var C;(function(y){y[y.BeatInterval=5e3]="BeatInterval",y[y.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",y[y.SecondWaitMultiplier=1]="SecondWaitMultiplier",y[y.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(C=e.HeartbeatConstants||(e.HeartbeatConstants={}));var I;(function(y){y[y.Panel=1]="Panel",y[y.Editor=2]="Editor"})(I=e.TerminalLocation||(e.TerminalLocation={}));var E;(function(y){y.TerminalView="view",y.Editor="editor"})(E=e.TerminalLocationString||(e.TerminalLocationString={}));var d;(function(y){y.CwdDetection="cwdDetection"})(d=e.ProcessCapability||(e.ProcessCapability={}));var p;(function(y){y[y.GraceTime=6e4]="GraceTime",y[y.ShortGraceTime=6e3]="ShortGraceTime"})(p=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var h;(function(y){y[y.HighWatermarkChars=1e5]="HighWatermarkChars",y[y.LowWatermarkChars=5e3]="LowWatermarkChars",y[y.CharCountAckSize=5e3]="CharCountAckSize"})(h=e.FlowControlConstants||(e.FlowControlConstants={}));var w;(function(y){y.GitBash="Git Bash",y.Pwsh="PowerShell"})(w=e.ProfileSource||(e.ProfileSource={}))}),define(te[209],ne([0,1,6]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILocalPtyService=void 0,e.ILocalPtyService=(0,R.createDecorator)("localPtyService")}),define(te[210],ne([0,1,33,28,10,4,31,17,20]),function(X,e,R,L,D,k,i,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findExecutable=e.getWindowsBuildNumber=void 0;function C(){const E=/(\d+)\.(\d+)\.(\d+)/g.exec(R.release());let d=0;return E&&E.length===4&&(d=parseInt(E[3])),d}e.getWindowsBuildNumber=C;async function I(E,d,p,h=i.env,w=S.Promises.exists){if(D.isAbsolute(E))return await w(E)?E:void 0;if(d===void 0&&(d=i.cwd()),D.dirname(E)!=="."){const g=D.join(d,E);return await w(g)?g:void 0}const m=(0,L.getCaseInsensitive)(h,"PATH");if(p===void 0&&(0,P.isString)(m)&&(p=m.split(D.delimiter)),p===void 0||p.length===0){const g=D.join(d,E);return await w(g)?g:void 0}for(let g of p){let a;if(D.isAbsolute(g)?a=D.join(g,E):a=D.join(d,g,E),await w(a))return a;if(k.isWindows){let l=a+".com";if(await w(l)||(l=a+".exe",await w(l)))return l}}const b=D.join(d,E);return await w(b)?b:void 0}e.findExecutable=I}),define(te[211],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var R;(function(L){L.DARK="dark",L.LIGHT="light",L.HIGH_CONTRAST="hc"})(R=e.ColorScheme||(e.ColorScheme={}))}),define(te[96],ne([0,1,49,3,2,6,35,211]),function(X,e,R,L,D,k,i,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,k.createDecorator)("themeService");var S;(function(y){function m(b){return b&&typeof b=="object"&&typeof b.id=="string"}y.isThemeColor=m})(S=e.ThemeColor||(e.ThemeColor={}));function C(y){return{id:y}}e.themeColorFromId=C;var I;(function(y){function m(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(typeof n.color=="undefined"||S.isThemeColor(n.color))}y.isThemeIcon=m;const b=new RegExp(`^\\$\\((${R.CSSIcon.iconNameExpression}(?:${R.CSSIcon.iconModifierExpression})?)\\)$`);function g(n){const t=b.exec(n);if(!t)return;let[,s]=t;return{id:s}}y.fromString=g;function a(n,t){let s=n.id;const c=s.lastIndexOf("~");return c!==-1&&(s=s.substring(0,c)),t&&(s=`${s}~${t}`),{id:s}}y.modify=a;function l(n){const t=n.id.lastIndexOf("~");if(t!==-1)return n.id.substring(t+1)}y.getModifier=l;function r(n,t){return n.id===t.id&&n.color?.id===t.color?.id}y.isEqual=r;function o(n,t){return{id:n.id,color:t?C(t):void 0}}y.asThemeIcon=o,y.asClassNameArray=R.CSSIcon.asClassNameArray,y.asClassName=R.CSSIcon.asClassName,y.asCSSSelector=R.CSSIcon.asCSSSelector})(I=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=R.Codicon.file,e.FolderThemeIcon=R.Codicon.folder;function E(y){switch(y){case P.ColorScheme.DARK:return"vs-dark";case P.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=E,e.Extensions={ThemingContribution:"base.contributions.theming"};class d{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new L.Emitter}onColorThemeChange(m){return this.themingParticipants.push(m),this.onThemingParticipantAddedEmitter.fire(m),(0,D.toDisposable)(()=>{const b=this.themingParticipants.indexOf(m);this.themingParticipants.splice(b,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let p=new d;i.Registry.add(e.Extensions.ThemingContribution,p);function h(y){return p.onColorThemeChange(y)}e.registerThemingParticipant=h;class w extends D.Disposable{constructor(m){super();this.themeService=m,this.theme=m.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(b=>this.onThemeChange(b)))}onThemeChange(m){this.theme=m,this.updateStyles()}updateStyles(){}getColor(m,b){let g=this.theme.getColor(m);return g&&b&&(g=b(g,this.theme)),g?g.toString():null}}e.Themable=w}),define(te[212],ne([0,1,49,7,96]),function(X,e,R,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUriComponents=e.terminalIconsEqual=e.terminalProfileArgsMatch=e.createProfileSchemaEnums=void 0;function k(E,d){const p=E.map(h=>({name:h.profileName,description:i(h)}));return d&&p.push(...d.map(h=>({name:h.title,description:P(h)}))),{values:p.map(h=>h.name),markdownDescriptions:p.map(h=>h.description)}}e.createProfileSchemaEnums=k;function i(E){let d=`$(${D.ThemeIcon.isThemeIcon(E.icon)?E.icon.id:E.icon?E.icon:R.Codicon.terminal.id}) ${E.profileName}
- path: ${E.path}`;return E.args&&(typeof E.args=="string"?d+=`
- args: "${E.args}"`:d+=`
- args: [${E.args.length===0?"":`'${E.args.join("','")}'`}]`),E.overrideName!==void 0&&(d+=`
- overrideName: ${E.overrideName}`),E.color&&(d+=`
- color: ${E.color}`),E.env&&(d+=`
- env: ${JSON.stringify(E.env)}`),d}function P(E){return`$(${D.ThemeIcon.isThemeIcon(E.icon)?E.icon.id:E.icon?E.icon:R.Codicon.terminal.id}) ${E.title}
- extensionIdenfifier: ${E.extensionIdentifier}`}function S(E,d){if(!E&&!d)return!0;if(typeof E=="string"&&typeof d=="string")return E===d;if(Array.isArray(E)&&Array.isArray(d)){if(E.length!==d.length)return!1;for(let p=0;p<E.length;p++)if(E[p]!==d[p])return!1;return!0}return!1}e.terminalProfileArgsMatch=S;function C(E,d){if(!E&&!d)return!0;if(!E||!d)return!1;if(D.ThemeIcon.isThemeIcon(E)&&D.ThemeIcon.isThemeIcon(d))return E.id===d.id&&E.color===d.color;if(typeof E=="object"&&E&&"light"in E&&"dark"in E&&typeof d=="object"&&d&&"light"in d&&"dark"in d){const p=E,h=d;if((L.URI.isUri(p.light)||I(p.light))&&(L.URI.isUri(p.dark)||I(p.dark))&&(L.URI.isUri(h.light)||I(h.light))&&(L.URI.isUri(h.dark)||I(h.dark)))return p.light.path===h.light.path&&p.dark.path===h.dark.path}if(L.URI.isUri(E)&&L.URI.isUri(d)||I(E)||I(d)){const p=E,h=d;return p.path===h.path&&p.scheme===h.scheme}return!1}e.terminalIconsEqual=C;function I(E){return E?typeof E.path=="string"&&typeof E.scheme=="string":!1}e.isUriComponents=I}),define(te[213],ne([0,1,49,143,39,35,212]),function(X,e,R,L,D,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=void 0;const P={args:{description:(0,L.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,L.localize)(1,null),type:"boolean"},icon:{description:(0,L.localize)(2,null),type:"string",enum:Array.from(R.iconRegistry.all,g=>g.id),markdownEnumDescriptions:Array.from(R.iconRegistry.all,g=>`$(${g.id})`)},color:{description:(0,L.localize)(3,null),type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},env:{markdownDescription:(0,L.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},S={type:"object",required:["path"],properties:{path:{description:(0,L.localize)(5,null),type:["string","array"],items:{type:"string"}},...P}},C=(0,L.localize)(6,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),I=(0,L.localize)(7,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),E=(0,L.localize)(8,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),d=(0,L.localize)(9,null,"`#terminal.integrated.automationProfile.linux#`"),p=(0,L.localize)(10,null,"`#terminal.integrated.automationProfile.osx#`"),h=(0,L.localize)(11,null,"`#terminal.integrated.automationProfile.windows#`"),w={id:"terminal",order:100,title:(0,L.localize)(12,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,L.localize)(13,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:d},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,L.localize)(14,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:p},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,L.localize)(15,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:h},["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,L.localize)(16,null,"#terminal.integrated.automationShell.linux#"),type:["object","null"],default:null,anyOf:[{type:"null"},S]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,description:(0,L.localize)(17,null,"#terminal.integrated.automationShell.osx#"),type:["object","null"],default:null,anyOf:[{type:"null"},S]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,description:(0,L.localize)(18,null,"#terminal.integrated.automationShell.windows#"),type:["object","null"],default:null,anyOf:[{type:"null"},S]},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,L.localize)(19,null),type:["string","null"],default:null,markdownDeprecationMessage:C},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,L.localize)(20,null),type:["string","null"],default:null,markdownDeprecationMessage:I},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,L.localize)(21,null),type:["string","null"],default:null,markdownDeprecationMessage:E},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,L.localize)(22,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:C},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,L.localize)(23,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:I},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,L.localize)(24,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,L.localize)(25,null)}},{type:"string",markdownDescription:(0,L.localize)(26,null)}],default:[],markdownDeprecationMessage:E},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:(0,L.localize)(27,null,"`source`","`path`","`args`","`null`",'`"Ubuntu-20.04 (WSL)": null`'),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,L.localize)(28,null),enum:["PowerShell","Git Bash"]},...P}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,L.localize)(29,null),type:"string"},id:{description:(0,L.localize)(30,null),type:"string"},title:{description:(0,L.localize)(31,null),type:"string"},...P}},{type:"null"},S]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:(0,L.localize)(32,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,L.localize)(33,null),type:"string"},id:{description:(0,L.localize)(34,null),type:"string"},title:{description:(0,L.localize)(35,null),type:"string"},...P}},{type:"null"},S]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:(0,L.localize)(36,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,L.localize)(37,null),type:"string"},id:{description:(0,L.localize)(38,null),type:"string"},title:{description:(0,L.localize)(39,null),type:"string"},...P}},{type:"null"},S]}},["terminal.integrated.useWslProfiles"]:{description:(0,L.localize)(40,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,L.localize)(41,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,L.localize)(42,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,L.localize)(43,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{description:(0,L.localize)(44,null),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function y(){k.Registry.as(D.Extensions.Configuration).registerConfiguration(w),b()}e.registerTerminalPlatformConfiguration=y;let m;function b(g,a){const l=k.Registry.as(D.Extensions.Configuration);let r;g&&(r=(0,i.createProfileSchemaEnums)(g?.profiles,a));const o=m;m={id:"terminal",order:100,title:(0,L.localize)(45,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,L.localize)(46,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:g?.os===3?r?.values:void 0,markdownEnumDescriptions:g?.os===3?r?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,L.localize)(47,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:g?.os===2?r?.values:void 0,markdownEnumDescriptions:g?.os===2?r?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,L.localize)(48,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:g?.os===1?r?.values:void 0,markdownEnumDescriptions:g?.os===1?r?.markdownDescriptions:void 0}}},l.updateConfigurations({add:[m],remove:o?[o]:[]})}e.registerTerminalDefaultProfileConfiguration=b}),define(te[214],ne([0,1,45,49,10,4,20,70,210,96]),function(X,e,R,L,D,k,i,P,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let I,E=!0;function d(o,n,t,s,c=process.env,u,f,v,T){return u=u||{existsFile:i.SymlinkSupport.existsFile,readFile:i.Promises.readFile},k.isWindows?p(t,u,c,f,s.getValue("terminal.integrated.useWslProfiles")!==!1,o&&typeof o=="object"?{...o}:s.getValue("terminal.integrated.profiles.windows"),typeof n=="string"?n:s.getValue("terminal.integrated.defaultProfile.windows"),T,v):a(u,f,t,o&&typeof o=="object"?{...o}:s.getValue(k.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof n=="string"?n:s.getValue(k.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),T,v,c)}e.detectAvailableProfiles=d;async function p(o,n,t,s,c,u,f,v,T){const O=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),U=`${process.env.windir}\\${O?"Sysnative":"System32"}`;let W=!1;(0,S.getWindowsBuildNumber)()>=16299&&(W=!0),await y(v);const N=new Map;o&&(N.set("PowerShell",{source:"PowerShell",icon:L.Codicon.terminalPowershell,isAutoDetected:!0}),N.set("Windows PowerShell",{path:`${U}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:L.Codicon.terminalPowershell,isAutoDetected:!0}),N.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),N.set("Cygwin",{path:[`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`],args:["--login"],isAutoDetected:!0}),N.set("Command Prompt",{path:`${U}\\cmd.exe`,icon:L.Codicon.terminalCmd,isAutoDetected:!0})),l(u,N);const A=await h(N.entries(),f,n,t,s,T);if(o||!o&&c)try{const z=await b(`${U}\\${W?"wsl":"bash"}.exe`,f);for(const _ of z)(!u||!(_.profileName in u))&&A.push(_)}catch(z){E&&(s?.info("WSL is not installed, so could not detect WSL profiles"),E=!1)}return A}async function h(o,n,t,s=process.env,c,u){const f=[];for(const[v,T]of o){if(T===null)continue;let O,U,W;if("source"in T){const z=I?.get(T.source);if(!z)continue;O=z.paths,U=T.args||z.args,T.icon?W=w(T.icon):z.icon&&(W=z.icon)}else O=Array.isArray(T.path)?T.path:[T.path],U=k.isWindows||Array.isArray(T.args)?T.args:void 0,W=w(T.icon)||void 0;const N=await u?.(O)||O.slice(),A=await r(v,n,N,t,s,U,T.env,T.overrideName,T.isAutoDetected,c);A?(A.isAutoDetected=T.isAutoDetected,A.icon=W,A.color=T.color,f.push(A)):c?.trace("profile not validated",v,O)}return f}function w(o){return typeof o=="string"?{id:o}:o}async function y(o){I&&!o||(I=new Map,I.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`,`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`,`${process.env.AllUsersProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`],args:["--login"]}),I.set("PowerShell",{profileName:"PowerShell",paths:o||await m(),icon:C.ThemeIcon.asThemeIcon(L.Codicon.terminalPowershell)}))}async function m(){const o=[];for await(const n of(0,P.enumeratePowerShellInstallations)())o.push(n.exePath);return o}async function b(o,n){const t=[],s=await new Promise((f,v)=>{R.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(T,O)=>{if(T)return v("Problem occurred when getting wsl distros");f(O)})});if(!s)return[];const c=new RegExp(/[\r?\n]/),u=s.split(c).filter(f=>f.trim().length>0&&f!=="");for(const f of u){if(f===""||f.startsWith("docker-desktop"))continue;const v=`${f} (WSL)`,T={profileName:v,path:o,args:["-d",`${f}`],isDefault:v===n,icon:g(f)};t.push(T)}return t}function g(o){return o.includes("Ubuntu")?C.ThemeIcon.asThemeIcon(L.Codicon.terminalUbuntu):o.includes("Debian")?C.ThemeIcon.asThemeIcon(L.Codicon.terminalDebian):C.ThemeIcon.asThemeIcon(L.Codicon.terminalLinux)}async function a(o,n,t,s,c,u,f,v){const T=new Map;if(t){const O=(await o.readFile("/etc/shells")).toString(),U=u||O.split(`
`).filter(N=>N.trim().indexOf("#")!==0&&N.trim().length>0),W=new Map;for(const N of U){let A=(0,D.basename)(N),z=W.get(A)||0;z++,z>1&&(A=`${A} (${z})`),W.set(A,z),T.set(A,{path:N,isAutoDetected:!0})}}return l(s,T),await h(T.entries(),c,o,v,n,f)}function l(o,n){if(!!o)for(const[t,s]of Object.entries(o))s===null||!("path"in s)&&!("source"in s)?n.delete(t):n.set(t,s)}async function r(o,n,t,s,c,u,f,v,T,O){if(t.length===0)return Promise.resolve(void 0);const U=t.shift();if(U==="")return r(o,n,t,s,c,u,f,v,T);const W={profileName:o,path:U,args:u,env:f,overrideName:v,isAutoDetected:T,isDefault:o===n};if((0,D.basename)(U)===U){const A=c.PATH?c.PATH.split(D.delimiter):void 0;return await(0,S.findExecutable)(U,void 0,A,void 0,s.existsFile)?W:r(o,n,t,s,c,u)}return await s.existsFile((0,D.normalize)(U))?W:r(o,n,t,s,c,u,f,v,T)}}),define(te[215],ne([0,1,3,2,15,4,34,52,21,11,75,165,8,85,22,208,95,213,214]),function(X,e,R,L,D,k,i,P,S,C,I,E,d,p,h,w,y,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var g;(function(r){r[r.MaxRestarts=5]="MaxRestarts"})(g||(g={}));let a=0,l=class extends L.Disposable{constructor(o,n,t,s,c){super();this._reconnectConstants=o,this._configurationService=n,this._environmentService=t,this._logService=s,this._telemetryService=c,this._restartCount=0,this._isResponsive=!0,this._isDisposed=!1,this._onPtyHostExit=this._register(new R.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new R.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new R.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new R.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onPtyHostRequestResolveVariables=this._register(new R.Emitter),this.onPtyHostRequestResolveVariables=this._onPtyHostRequestResolveVariables.event,this._onProcessData=this._register(new R.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessReady=this._register(new R.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new R.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessOrphanQuestion=this._register(new R.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._onDidRequestDetach=this._register(new R.Emitter),this.onDidRequestDetach=this._onDidRequestDetach.event,this._onDidChangeProperty=this._register(new R.Emitter),this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=this._register(new R.Emitter),this.onProcessExit=this._onProcessExit.event,(0,m.registerTerminalPlatformConfiguration)(),this._shellEnv=this._resolveShellEnv(),this._register((0,L.toDisposable)(()=>this._disposePtyHost())),this._resolveVariablesRequestStore=this._register(new w.RequestStore(void 0,this._logService)),this._resolveVariablesRequestStore.onCreateRequest(this._onPtyHostRequestResolveVariables.fire,this._onPtyHostRequestResolveVariables),[this._client,this._proxy]=this._startPtyHost(),this._register(this._configurationService.onDidChangeConfiguration(async u=>{u.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this._refreshIgnoreProcessNames()}))}async initialize(){await this._refreshIgnoreProcessNames()}get _ignoreProcessNames(){return this._configurationService.getValue("terminal.integrated.ignoreProcessNames")}async _refreshIgnoreProcessNames(){return this._proxy.refreshIgnoreProcessNames?.(this._ignoreProcessNames)}async _resolveShellEnv(){if(k.isWindows)return process.env;try{return await(0,E.resolveShellEnv)(this._logService,{_:[]},process.env)}catch(o){return this._logService.error("ptyHost was unable to resolve shell environment",o),{}}}_startPtyHost(){const o={serverName:"Pty Host",args:["--type=ptyHost"],env:{VSCODE_LAST_PTY_ID:a,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this._reconnectConstants.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this._reconnectConstants.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this._reconnectConstants.scrollback}},n=(0,I.parsePtyHostPort)(this._environmentService.args,this._environmentService.isBuilt);n&&(n.break&&n.port?o.debugBrk=n.port:!n.break&&n.port&&(o.debug=n.port));const t=new P.Client(D.FileAccess.asFileUri("bootstrap-fork",X).fsPath,o);this._onPtyHostStart.fire(),i.ProxyChannel.toService(t.getChannel(y.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(),this._register(t.onDidProcessExit(f=>{this._telemetryService.publicLog("ptyHost/exit"),this._onPtyHostExit.fire(f.code),this._isDisposed||(this._restartCount<=g.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${f.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${f.code}, giving up`))}));const c=t.getChannel(y.TerminalIpcChannels.Log);p.LogLevelChannelClient.setLevel(c,this._logService.getLevel()),this._register(this._logService.onDidChangeLogLevel(()=>{p.LogLevelChannelClient.setLevel(c,this._logService.getLevel())}));const u=i.ProxyChannel.toService(t.getChannel(y.TerminalIpcChannels.PtyHost));return this._register(u.onProcessData(f=>this._onProcessData.fire(f))),this._register(u.onProcessReady(f=>this._onProcessReady.fire(f))),this._register(u.onProcessExit(f=>this._onProcessExit.fire(f))),this._register(u.onDidChangeProperty(f=>this._onDidChangeProperty.fire(f))),this._register(u.onProcessReplay(f=>this._onProcessReplay.fire(f))),this._register(u.onProcessOrphanQuestion(f=>this._onProcessOrphanQuestion.fire(f))),this._register(u.onDidRequestDetach(f=>this._onDidRequestDetach.fire(f))),[t,u]}dispose(){this._isDisposed=!0,super.dispose()}async createProcess(o,n,t,s,c,u,f,v,T,O,U){const W=setTimeout(()=>this._handleUnresponsiveCreateProcess(),y.HeartbeatConstants.CreateProcessTimeout),N=await this._proxy.createProcess(o,n,t,s,c,u,f,v,T,O,U);return clearTimeout(W),a=Math.max(a,N),N}updateTitle(o,n,t){return this._proxy.updateTitle(o,n,t)}updateIcon(o,n,t){return this._proxy.updateIcon(o,n,t)}attachToProcess(o){return this._proxy.attachToProcess(o)}detachFromProcess(o){return this._proxy.detachFromProcess(o)}listProcesses(){return this._proxy.listProcesses()}reduceConnectionGraceTime(){return this._proxy.reduceConnectionGraceTime()}start(o){return this._proxy.start(o)}shutdown(o,n){return this._proxy.shutdown(o,n)}input(o,n){return this._proxy.input(o,n)}processBinary(o,n){return this._proxy.processBinary(o,n)}resize(o,n,t){return this._proxy.resize(o,n,t)}acknowledgeDataEvent(o,n){return this._proxy.acknowledgeDataEvent(o,n)}setUnicodeVersion(o,n){return this._proxy.setUnicodeVersion(o,n)}getInitialCwd(o){return this._proxy.getInitialCwd(o)}getCwd(o){return this._proxy.getCwd(o)}getLatency(o){return this._proxy.getLatency(o)}orphanQuestionReply(o){return this._proxy.orphanQuestionReply(o)}getDefaultSystemShell(o){return this._proxy.getDefaultSystemShell(o)}async getProfiles(o,n,t,s=!1){const c=await this._shellEnv;return(0,b.detectAvailableProfiles)(n,t,s,this._configurationService,c,void 0,this._logService,this._resolveVariables.bind(this,o))}getEnvironment(){return this._proxy.getEnvironment()}getWslPath(o){return this._proxy.getWslPath(o)}setTerminalLayoutInfo(o){return this._proxy.setTerminalLayoutInfo(o)}async getTerminalLayoutInfo(o){return await this._proxy.getTerminalLayoutInfo(o)}async requestDetachInstance(o,n){return this._proxy.requestDetachInstance(o,n)}async acceptDetachInstanceReply(o,n){return this._proxy.acceptDetachInstanceReply(o,n)}async serializeTerminalState(o){return this._proxy.serializeTerminalState(o)}async reviveTerminalProcesses(o){return this._proxy.reviveTerminalProcesses(o)}async refreshProperty(o,n){return this._proxy.refreshProperty(o,n)}async updateProperty(o,n,t){return this._proxy.updateProperty(o,n,t)}async restartPtyHost(){this._telemetryService.publicLog("ptyHost/restart"),this._isResponsive=!0,this._disposePtyHost(),[this._client,this._proxy]=this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll?.(),this._client.dispose()}_handleHeartbeat(){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.FirstWaitMultiplier),this._isResponsive||(this._telemetryService.publicLog("ptyHost/responsive"),this._isResponsive=!0),this._onPtyHostResponsive.fire()}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.FirstWaitMultiplier+y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._isResponsive&&(this._telemetryService.publicLog("ptyHost/unresponsive"),this._isResponsive=!1),this._onPtyHostUnresponsive.fire()}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${y.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._telemetryService.publicLog("ptyHost/responsive"),this._onPtyHostUnresponsive.fire()}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}_resolveVariables(o,n){return this._resolveVariablesRequestStore.createRequest({workspaceId:o,originalText:n})}async acceptPtyHostResolvedVariables(o,n){this._resolveVariablesRequestStore.acceptReply(o,n)}};l=he([J(1,S.IConfigurationService),J(2,C.IEnvironmentService),J(3,d.ILogService),J(4,h.ITelemetryService)],l),e.PtyHostService=l}),define(te[37],ne([0,1,6]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,R.createDecorator)("IUriIdentityService")}),define(te[216],ne([0,1,3,2,7,11,36,14,8,37]),function(X,e,R,L,D,k,i,P,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;let I=class extends L.Disposable{constructor(d,p,h,w,y){super();this.extensionsManagementService=d,this.logService=w,this.uriIdentityService=y,this._onDidChangeExtensionsByAnotherSource=this._register(new R.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(b=>{this.installedExtensions=b.map(g=>g.identifier),this.startTimestamp=Date.now()}),this._register(d.onInstallExtension(b=>this.onInstallExtension(b))),this._register(d.onDidInstallExtensions(b=>this.onDidInstallExtensions(b))),this._register(d.onDidUninstallExtension(b=>this.onDidUninstallExtension(b)));const m=D.URI.file(h.extensionsPath);this._register(p.watch(m)),this._register(R.Event.filter(p.onDidChangeFilesRaw,b=>b.changes.some(g=>this.doesChangeAffects(g,m)))(()=>this.onDidChange()))}doesChangeAffects(d,p){return this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(d.resource),p)?this.uriIdentityService.extUri.isEqual(d.resource,this.uriIdentityService.extUri.joinPath(p,".obsolete"))?!0:!(d.type!==1&&d.type!==2||this.uriIdentityService.extUri.basename(d.resource).startsWith(".")):!1}onInstallExtension(d){this.addInstallingExtension(d.identifier)}onDidInstallExtensions(d){for(const p of d)this.removeInstallingExtension(p.identifier),p.local&&this.addInstalledExtension(p.identifier)}onDidUninstallExtension(d){d.error||this.removeInstalledExtension(d.identifier)}addInstallingExtension(d){this.removeInstallingExtension(d),this.installingExtensions.push(d)}removeInstallingExtension(d){this.installingExtensions=this.installingExtensions.filter(p=>!(0,i.areSameExtensions)(p,d))}addInstalledExtension(d){this.installedExtensions&&(this.removeInstalledExtension(d),this.installedExtensions.push(d))}removeInstalledExtension(d){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(p=>!(0,i.areSameExtensions)(p,d)))}async onDidChange(){if(this.installedExtensions){const d=await this.extensionsManagementService.getInstalled(1),p=d.filter(w=>[...this.installingExtensions,...this.installedExtensions].some(y=>(0,i.areSameExtensions)(y,w.identifier))?!1:w.installedTimestamp&&w.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",w.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",w.identifier.id),!1)),h=this.installedExtensions.filter(w=>this.installingExtensions.some(y=>(0,i.areSameExtensions)(y,w))?!1:d.every(y=>!(0,i.areSameExtensions)(y.identifier,w))?(this.logService.info("Detected extension removed from another source",w.id),!0):!1);this.installedExtensions=d.map(w=>w.identifier),(p.length||h.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:p,removed:h})}}};I=he([J(1,P.IFileService),J(2,k.INativeEnvironmentService),J(3,S.ILogService),J(4,C.IUriIdentityService)],I),e.ExtensionsWatcher=I}),define(te[217],ne([0,1,37,77,14,18,103,3,2]),function(X,e,R,L,D,k,i,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class C{constructor(d){this.uri=d,this.time=C._clock++}touch(){return this.time=C._clock++,this}}C._clock=0;let I=class{constructor(d){this._fileService=d,this._dispooables=new S.DisposableStore,this._limit=2**16;const p=new Map,h=w=>{let y=p.get(w.scheme);return y===void 0&&(y=d.hasProvider(w)&&!this._fileService.hasCapability(w,1024),p.set(w.scheme,y)),y};this._dispooables.add(P.Event.any(d.onDidChangeFileSystemProviderRegistrations,d.onDidChangeFileSystemProviderCapabilities)(w=>{p.delete(w.scheme)})),this.extUri=new k.ExtUri(h),this._canonicalUris=new i.SkipList((w,y)=>this.extUri.compare(w,y,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(d){this._fileService.hasProvider(d)&&(d=(0,k.normalizePath)(d));let p=this._canonicalUris.get(d);return p?p.touch().uri.with({fragment:d.fragment}):(this._canonicalUris.set(d,new C(d)),this._checkTrim(),d)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const d=[...this._canonicalUris.entries()].sort((h,w)=>h[1].touch<w[1].touch?1:h[1].touch>w[1].touch?-1:0);C._clock=0,this._canonicalUris.clear();const p=this._limit*.5;for(let h=0;h<p;h++)this._canonicalUris.set(d[h][0],d[h][1].touch())}};I=he([J(0,D.IFileService)],I),e.UriIdentityService=I,(0,L.registerSingleton)(R.IUriIdentityService,I,!0)}),define(te[55],ne([0,1,40]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLineEndOffset=e.getLineStartOffset=e.edit=void 0;function L(i,P,S,C){const I=(0,R.setProperty)(i,P,S,C)[0];return I&&(i=i.substring(0,I.offset)+I.content+i.substring(I.offset+I.length)),i}e.edit=L;function D(i,P,S){let C=S;for(;C>=0;){if(i.charAt(C)===P.charAt(P.length-1)&&P.length===1)return C+1;if(C--,P.length===2&&C>=0&&i.charAt(C)===P.charAt(0))return C+2}return 0}e.getLineStartOffset=D;function k(i,P,S){let C=S;for(;C>=0;)if(i.charAt(C)===P.charAt(P.length-1)&&P.length===1||(C++,P.length===2&&C>=0&&i.charAt(C)===P.charAt(1)))return C;return i.length-1}e.getLineEndOffset=k}),define(te[218],ne([0,1,28,61]),function(X,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function D(E,d,p,h,w){const y=[],m=[],b=[];if(!d){const O=E.filter(({identifier:U})=>w.every(W=>W.toLowerCase()!==U.id.toLowerCase()));return{local:{added:y,removed:m,updated:b},remote:O.length>0?{added:O,updated:[],removed:[],all:O}:null}}E=E.map(C),d=d.map(C),p=p?p.map(C):null;const g=new Map,a=O=>{O.uuid&&g.set(O.id.toLowerCase(),O.uuid)};E.forEach(({identifier:O})=>a(O)),d.forEach(({identifier:O})=>a(O)),p&&p.forEach(({identifier:O})=>a(O));const l=O=>{const U=O.identifier.uuid||g.get(O.identifier.id.toLowerCase());return U?`uuid:${U}`:`id:${O.identifier.id.toLowerCase()}`},r=(O,U)=>(O.set(l(U),U),O),o=E.reduce(r,new Map),n=d.reduce(r,new Map),t=d.reduce((O,U)=>{const W=l(U);U=(0,R.deepClone)(U);const N=o.get(W);return N&&(N.installed&&(U.installed=!0),U.version||(U.version=N.version)),r(O,U)},new Map),s=p?p.reduce(r,new Map):null,c=h.reduce(r,new Map),u=w.reduce((O,U)=>{const W=g.get(U.toLowerCase());return O.add(W?`uuid:${W}`:`id:${U.toLowerCase()}`)},new Set),f=k(o,n,u);if(f.added.size>0||f.removed.size>0||f.updated.size>0){const O=k(s,o,u),U=k(s,n,u),W=(N,A)=>{const z=o.get(N);if(z){const _=n.get(N);return{...A?_:z,version:(_.version&&L.gt(_.version,z.version),z.version),state:i(z,_,s?.get(N))}}};for(const N of U.removed.values()){const A=o.get(N);A&&m.push(A.identifier)}for(const N of U.added.values())if(O.added.has(N)){if(f.updated.has(N)){const A=W(N,!0);A&&(b.push(I(A,N)),t.set(N,A))}}else{const A=n.get(N);A.installed&&y.push(I(A,N))}for(const N of U.updated.values()){const A=W(N,!0);A&&(b.push(I(A,N)),t.set(N,A))}for(const N of O.added.values())U.added.has(N)||t.set(N,o.get(N));for(const N of O.updated.values())if(!U.removed.has(N)&&!U.updated.has(N)){const A=W(N,!1);A&&(t.get(N)?.installed&&(A.installed=!0),t.set(N,A))}for(const N of O.removed.values())!c.has(N)&&!U.updated.has(N)&&s?.get(N)?.installed&&t.delete(N)}const v=[],T=k(n,t,new Set,{checkInstalledProperty:!0,checkVersionProperty:!0});return(T.added.size>0||T.updated.size>0||T.removed.size>0)&&t.forEach((O,U)=>v.push(I(O,U))),{local:{added:y,removed:m,updated:b},remote:v.length?{added:[...T.added].map(O=>t.get(O)),updated:[...T.updated].map(O=>t.get(O)),removed:[...T.removed].map(O=>n.get(O)),all:v}:null}}e.merge=D;function k(E,d,p,{checkInstalledProperty:h,checkVersionProperty:w}={checkInstalledProperty:!1,checkVersionProperty:!1}){const y=E?[...E.keys()].filter(l=>!p.has(l)):[],m=[...d.keys()].filter(l=>!p.has(l)),b=m.filter(l=>y.indexOf(l)===-1).reduce((l,r)=>(l.add(r),l),new Set),g=y.filter(l=>m.indexOf(l)===-1).reduce((l,r)=>(l.add(r),l),new Set),a=new Set;for(const l of y){if(g.has(l))continue;const r=E.get(l),o=d.get(l);(!o||r.disabled!==o.disabled||!S(r.state,o.state)||w&&r.version!==o.version||h&&r.installed!==o.installed)&&a.add(l)}return{added:b,removed:g,updated:a}}function i(E,d,p){const h=E.state,w=d.state,y=p?.state;if(!d.version||h&&L.gt(E.version,d.version))return h;if(w&&L.gt(d.version,E.version)||!h)return w;if(!w)return h;const m=(0,R.deepClone)(h),b=y?P(y,w):{added:Object.keys(w).reduce((a,l)=>(a.add(l),a),new Set),removed:new Set,updated:new Set},g=y?P(y,h):{added:Object.keys(h).reduce((a,l)=>(a.add(l),a),new Set),removed:new Set,updated:new Set};for(const a of[...b.added.values(),...b.updated.values()])m[a]=w[a];for(const a of b.removed.values())g.updated.has(a)||delete m[a];return m}function P(E,d){const p=Object.keys(E),h=Object.keys(d),w=h.filter(b=>p.indexOf(b)===-1).reduce((b,g)=>(b.add(g),b),new Set),y=p.filter(b=>h.indexOf(b)===-1).reduce((b,g)=>(b.add(g),b),new Set),m=new Set;for(const b of p){if(y.has(b))continue;const g=E[b],a=d[b];(0,R.equals)(g,a)||m.add(b)}return{added:w,removed:y,updated:m}}function S(E={},d={}){const{added:p,removed:h,updated:w}=P(E,d);return p.size===0&&h.size===0&&w.size===0}function C(E){return{...E,disabled:!!E.disabled,installed:!!E.installed}}function I(E,d){const p={identifier:{id:E.identifier.id,uuid:d.startsWith("uuid:")?d.substring("uuid:".length):void 0}};return E.version&&(p.version=E.version),E.disabled&&(p.disabled=!0),E.installed&&(p.installed=!0),E.state&&(p.state=E.state),p}}),define(te[97],ne([0,1,16,3,2,36,6,26,23]),function(X,e,R,L,D,k,i,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsStorageSyncService=e.IExtensionsStorageSyncService=void 0,e.IExtensionsStorageSyncService=(0,i.createDecorator)("IExtensionsStorageSyncService");const C=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let I=class it extends D.Disposable{constructor(d,p){super();this.storageService=d,this.productService=p,this._onDidChangeExtensionsStorage=this._register(new L.Emitter),this.onDidChangeExtensionsStorage=this._onDidChangeExtensionsStorage.event,this.extensionsWithKeysForSync=new Set,this.initialize(),this._register(this.storageService.onDidChangeValue(h=>this.onDidChangeStorageValue(h)))}static toKey(d){return`extensionKeys/${(0,k.adoptToGalleryExtensionId)(d.id)}@${d.version}`}static fromKey(d){const p=C.exec(d);if(p&&p[1])return{id:p[1],version:p[2]}}initialize(){const d=this.storageService.keys(0,1);for(const p of d){const h=it.fromKey(p);h&&this.extensionsWithKeysForSync.add(h.id.toLowerCase())}}onDidChangeStorageValue(d){if(d.scope!==0)return;if(this.extensionsWithKeysForSync.has(d.key.toLowerCase())){this._onDidChangeExtensionsStorage.fire();return}const p=it.fromKey(d.key);if(p){this.extensionsWithKeysForSync.add(p.id.toLowerCase()),this._onDidChangeExtensionsStorage.fire();return}}setKeysForSync(d,p){this.storageService.store(it.toKey(d),JSON.stringify(p),0,1)}getKeysForSync(d){const p=this.productService.extensionSyncedKeys?.[d.id.toLowerCase()],h=this.storageService.get(it.toKey(d),0),w=h?JSON.parse(h):void 0;return w&&p?(0,R.distinct)([...w,...p]):w||p}};I=he([J(0,S.IStorageService),J(1,P.IProductService)],I),e.ExtensionsStorageSyncService=I}),define(te[98],ne([0,1,16,21,6]),function(X,e,R,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=(0,D.createDecorator)("IIgnoredExtensionsManagementService");let k=class{constructor(P){this.configurationService=P}hasToNeverSyncExtension(P){return this.getConfiguredIgnoredExtensions().includes(P.toLowerCase())}hasToAlwaysSyncExtension(P){return this.getConfiguredIgnoredExtensions().includes(`-${P.toLowerCase()}`)}updateIgnoredExtensions(P,S){let C=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(I=>I.toLowerCase());return C=C.filter(I=>I!==P&&I!==`-${P}`),S&&C.push(P.toLowerCase()),this.configurationService.updateValue("settingsSync.ignoredExtensions",C.length?C:void 0,1)}updateSynchronizedExtensions(P,S){let C=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(I=>I.toLowerCase());return C=C.filter(I=>I!==P&&I!==`-${P}`),S&&C.push(`-${P.toLowerCase()}`),this.configurationService.updateValue("settingsSync.ignoredExtensions",C.length?C:void 0,1)}getIgnoredExtensions(P){const S=P.filter(d=>d.isMachineScoped).map(d=>d.identifier.id.toLowerCase()),C=this.getConfiguredIgnoredExtensions().map(d=>d.toLowerCase()),I=[],E=[];if(Array.isArray(C))for(const d of C)d.startsWith("-")?E.push(d.substring(1)):I.push(d);return(0,R.distinct)([...S,...I].filter(d=>E.indexOf(d)===-1))}getConfiguredIgnoredExtensions(){let P=this.configurationService.inspect("settingsSync.ignoredExtensions").userValue;return P!==void 0||(P=this.configurationService.inspect("sync.ignoredExtensions").userValue,P!==void 0)?P:(this.configurationService.getValue("settingsSync.ignoredExtensions")||[]).map(S=>S.toLowerCase())}};k=he([J(0,L.IConfigurationService)],k),e.IgnoredExtensionsManagementService=k}),define(te[219],ne([0,1,16,32,28,160,55]),function(X,e,R,L,D,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=e.parseKeybindings=void 0;function P(a){return(0,L.parse)(a)||[]}e.parseKeybindings=P;async function S(a,l,r,o,n){const t=P(a),s=P(l),c=r?P(r):null,u=[...t,...s,...c||[]].map(M=>M.key),f=await n.resolveUserBindings(u);let v=I(t,s,c,f);if(!v.hasLocalForwarded&&!v.hasRemoteForwarded)return{mergeContent:a,hasChanges:!1,hasConflicts:!1};if(!v.hasLocalForwarded&&v.hasRemoteForwarded)return{mergeContent:l,hasChanges:!0,hasConflicts:!1};if(v.hasLocalForwarded&&!v.hasRemoteForwarded)return{mergeContent:a,hasChanges:!0,hasConflicts:!1};const T=d(t),O=d(s),U=c?d(c):null,W=h(T,O,f),N=U?h(U,T,f):{added:[...T.keys()].reduce((M,q)=>(M.add(q),M),new Set),removed:new Set,updated:new Set},A=U?h(U,O,f):{added:[...O.keys()].reduce((M,q)=>(M.add(q),M),new Set),removed:new Set,updated:new Set},z=C(W,N,A);let _=a;for(const M of z.removed.values())z.conflicts.has(M)||(_=b(_,M,o));for(const M of z.added.values()){if(z.conflicts.has(M))continue;const q=O.get(M);if(q.some(B=>B.command!==`-${M}`&&v.conflicts.has(f[B.key]))){z.conflicts.add(M);continue}_=m(_,q,o)}for(const M of z.updated.values()){if(z.conflicts.has(M))continue;const q=O.get(M);if(q.some(B=>B.command!==`-${M}`&&v.conflicts.has(f[B.key]))){z.conflicts.add(M);continue}_=g(_,M,q,o)}return{mergeContent:_,hasChanges:!0,hasConflicts:z.conflicts.size>0}}e.merge=S;function C(a,l,r){const o=new Set,n=new Set,t=new Set,s=new Set;for(const c of l.removed.values())r.updated.has(c)&&s.add(c);for(const c of r.removed.values())s.has(c)||(l.updated.has(c)?s.add(c):n.add(c));for(const c of l.added.values())s.has(c)||r.added.has(c)&&a.updated.has(c)&&s.add(c);for(const c of r.added.values())s.has(c)||(l.added.has(c)?a.updated.has(c)&&s.add(c):o.add(c));for(const c of l.updated.values())s.has(c)||r.updated.has(c)&&a.updated.has(c)&&s.add(c);for(const c of r.updated.values())s.has(c)||(l.updated.has(c)?a.updated.has(c)&&s.add(c):t.add(c));return{added:o,removed:n,updated:t,conflicts:s}}function I(a,l,r,o){const n=new Set,t=E(a,o),s=E(l,o),c=r?E(r,o):null,u=p(t,s);if(u.added.size===0&&u.removed.size===0&&u.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const f=c?p(c,t):{added:[...t.keys()].reduce((N,A)=>(N.add(A),N),new Set),removed:new Set,updated:new Set};if(f.added.size===0&&f.removed.size===0&&f.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:n,removed:n,updated:n,conflicts:n};const v=c?p(c,s):{added:[...s.keys()].reduce((N,A)=>(N.add(A),N),new Set),removed:new Set,updated:new Set};if(v.added.size===0&&v.removed.size===0&&v.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const{added:T,removed:O,updated:U,conflicts:W}=C(u,f,v);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:T,removed:O,updated:U,conflicts:W}}function E(a,l){const r=new Map;for(const o of a){const n=l[o.key];let t=r.get(n);t||(t=[],r.set(n,t)),t.push(o)}return r}function d(a){const l=new Map;for(const r of a){const o=r.command[0]==="-"?r.command.substring(1):r.command;let n=l.get(o);n||(n=[],l.set(o,n)),n.push(r)}return l}function p(a,l){const r=[...a.keys()],o=[...l.keys()],n=o.filter(c=>r.indexOf(c)===-1).reduce((c,u)=>(c.add(u),c),new Set),t=r.filter(c=>o.indexOf(c)===-1).reduce((c,u)=>(c.add(u),c),new Set),s=new Set;for(const c of r){if(t.has(c))continue;const u=a.get(c).map(v=>({...v,key:c})),f=l.get(c).map(v=>({...v,key:c}));(0,R.equals)(u,f,(v,T)=>y(v,T))||s.add(c)}return{added:n,removed:t,updated:s}}function h(a,l,r){const o=[...a.keys()],n=[...l.keys()],t=n.filter(u=>o.indexOf(u)===-1).reduce((u,f)=>(u.add(f),u),new Set),s=o.filter(u=>n.indexOf(u)===-1).reduce((u,f)=>(u.add(f),u),new Set),c=new Set;for(const u of o){if(s.has(u))continue;const f=a.get(u).map(T=>({...T,key:r[T.key]})),v=l.get(u).map(T=>({...T,key:r[T.key]}));w(f,v)||c.add(u)}return{added:t,removed:s,updated:c}}function w(a,l){return!(!(0,R.equals)(a.filter(({command:r})=>r[0]!=="-"),l.filter(({command:r})=>r[0]!=="-"),(r,o)=>y(r,o))||!(0,R.equals)(a.filter(({command:r})=>r[0]==="-"),l.filter(({command:r})=>r[0]==="-"),(r,o)=>y(r,o)))}function y(a,l){if(a.command!==l.command||a.key!==l.key)return!1;const r=k.ContextKeyExpr.deserialize(a.when),o=k.ContextKeyExpr.deserialize(l.when);return!(r&&!o||!r&&o||r&&o&&!r.equals(o)||!D.equals(a.args,l.args))}function m(a,l,r){for(const o of l)a=i.edit(a,[-1],o,r);return a}function b(a,l,r){const o=P(a);for(let n=o.length-1;n>=0;n--)(o[n].command===l||o[n].command===`-${l}`)&&(a=i.edit(a,[n],void 0,r));return a}function g(a,l,r,o){const n=P(a),t=n.findIndex(s=>s.command===l||s.command===`-${l}`);for(let s=n.length-1;s>=0;s--)(n[s].command===l||n[s].command===`-${l}`)&&(a=i.edit(a,[s],void 0,o));for(let s=r.length-1;s>=0;s--)a=i.edit(a,[t],r[s],o);return a}}),define(te[220],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.areSame=e.merge=void 0;function R(k,i,P){const S={},C={},I=new Set;if(!i)return{local:{added:S,updated:C,removed:[...I.values()]},remote:{added:k,updated:{},removed:[]},conflicts:[]};const E=L(k,i);if(E.added.size===0&&E.removed.size===0&&E.updated.size===0)return{local:{added:S,updated:C,removed:[...I.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const d=L(P,k),p=L(P,i),h={},w={},y=new Set,m=new Set;for(const b of d.removed.values())p.updated.has(b)?S[b]=i[b]:y.add(b);for(const b of p.removed.values())m.has(b)||(d.updated.has(b)?m.add(b):I.add(b));for(const b of d.updated.values())m.has(b)||(p.updated.has(b)?E.updated.has(b)&&m.add(b):w[b]=k[b]);for(const b of p.updated.values())m.has(b)||(d.updated.has(b)?E.updated.has(b)&&m.add(b):k[b]!==void 0&&(C[b]=i[b]));for(const b of d.added.values())m.has(b)||(p.added.has(b)?E.updated.has(b)&&m.add(b):h[b]=k[b]);for(const b of p.added.values())m.has(b)||(d.added.has(b)?E.updated.has(b)&&m.add(b):S[b]=i[b]);return{local:{added:S,removed:[...I.values()],updated:C},remote:{added:h,removed:[...y.values()],updated:w},conflicts:[...m.values()]}}e.merge=R;function L(k,i){const P=k?Object.keys(k):[],S=i?Object.keys(i):[],C=S.filter(d=>P.indexOf(d)===-1).reduce((d,p)=>(d.add(p),d),new Set),I=P.filter(d=>S.indexOf(d)===-1).reduce((d,p)=>(d.add(p),d),new Set),E=new Set;for(const d of P){if(I.has(d))continue;const p=k[d],h=i[d];p!==h&&E.add(d)}return{added:C,removed:I,updated:E}}function D(k,i){const{added:P,removed:S,updated:C}=L(k,i);return P.size===0&&S.size===0&&C.size===0}e.areSame=D}),define(te[24],ne([0,1,16,18,17,148,39,30,6,87,35]),function(X,e,R,L,D,k,i,P,S,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSyncResourceFromLocalPreview=e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataAutoSyncEnablementService=e.IUserDataSyncService=e.IUserDataSyncResourceEnablementService=e.getEnablementKey=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.createSyncHeaders=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncBackupStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.getLastSyncResourceUri=e.ALL_SYNC_RESOURCES=e.SyncResource=e.isAuthenticationProvider=e.registerConfiguration=e.USER_DATA_SYNC_CONFIGURATION_SCOPE=e.getDefaultIgnoredSettings=e.getDisallowedIgnoredSettings=e.CONFIGURATION_SYNC_STORE_KEY=void 0,e.CONFIGURATION_SYNC_STORE_KEY="configurationSync.store";function E(){const c=I.Registry.as(i.Extensions.Configuration).getConfigurationProperties();return Object.keys(c).filter(u=>!!c[u].disallowSyncIgnore)}e.getDisallowedIgnoredSettings=E;function d(){const c=I.Registry.as(i.Extensions.Configuration).getConfigurationProperties(),u=Object.keys(c).filter(T=>!!c[T].ignoreSync),f=Object.keys(c).filter(T=>c[T].scope===2||c[T].scope===6),v=E();return(0,R.distinct)([e.CONFIGURATION_SYNC_STORE_KEY,...u,...f,...v])}e.getDefaultIgnoredSettings=d,e.USER_DATA_SYNC_CONFIGURATION_SCOPE="settingsSync";function p(){const c="vscode://schemas/ignoredSettings",u=I.Registry.as(i.Extensions.Configuration);u.registerConfiguration({id:"settingsSync",order:30,title:(0,k.localize)(0,null),type:"object",properties:{"settingsSync.keybindingsPerPlatform":{type:"boolean",description:(0,k.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,k.localize)(2,null),items:[{type:"string",pattern:P.EXTENSION_IDENTIFIER_PATTERN,errorMessage:(0,k.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,k.localize)(4,null),default:[],scope:1,$ref:c,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const f=I.Registry.as(C.Extensions.JSONContribution),v=()=>{const T=E(),O=d().filter(A=>A!==e.CONFIGURATION_SYNC_STORE_KEY),U=Object.keys(i.allSettings.properties).filter(A=>O.indexOf(A)===-1),W=O.filter(A=>T.indexOf(A)===-1),N={items:{type:"string",enum:[...U,...W.map(A=>`-${A}`)]}};f.registerSchema(c,N)};return u.onDidUpdateConfiguration(()=>v())}e.registerConfiguration=p;function h(c){return c&&(0,D.isObject)(c)&&(0,D.isString)(c.id)&&(0,D.isArray)(c.scopes)}e.isAuthenticationProvider=h;var w;(function(c){c.Settings="settings",c.Keybindings="keybindings",c.Snippets="snippets",c.Extensions="extensions",c.GlobalState="globalState"})(w=e.SyncResource||(e.SyncResource={})),e.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","extensions","globalState"];function y(c,u,f){return f.joinPath(u.userDataSyncHome,c,`lastSync${c}.json`)}e.getLastSyncResourceUri=y,e.IUserDataSyncStoreManagementService=(0,S.createDecorator)("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=(0,S.createDecorator)("IUserDataSyncStoreService"),e.IUserDataSyncBackupStoreService=(0,S.createDecorator)("IUserDataSyncBackupStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function m(c){const u={};return u[e.HEADER_EXECUTION_ID]=c,u}e.createSyncHeaders=m;var b;(function(c){c.Unauthorized="Unauthorized",c.Conflict="Conflict",c.Gone="Gone",c.PreconditionFailed="PreconditionFailed",c.TooLarge="TooLarge",c.UpgradeRequired="UpgradeRequired",c.PreconditionRequired="PreconditionRequired",c.TooManyRequests="RemoteTooManyRequests",c.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",c.RequestFailed="RequestFailed",c.RequestCanceled="RequestCanceled",c.RequestTimeout="RequestTimeout",c.RequestProtocolNotSupported="RequestProtocolNotSupported",c.RequestPathNotEscaped="RequestPathNotEscaped",c.RequestHeadersNotObject="RequestHeadersNotObject",c.NoRef="NoRef",c.EmptyResponse="EmptyResponse",c.TurnedOff="TurnedOff",c.SessionExpired="SessionExpired",c.ServiceChanged="ServiceChanged",c.DefaultServiceChanged="DefaultServiceChanged",c.LocalTooManyRequests="LocalTooManyRequests",c.LocalPreconditionFailed="LocalPreconditionFailed",c.LocalInvalidContent="LocalInvalidContent",c.LocalError="LocalError",c.IncompatibleLocalContent="IncompatibleLocalContent",c.IncompatibleRemoteContent="IncompatibleRemoteContent",c.UnresolvedConflicts="UnresolvedConflicts",c.Unknown="Unknown"})(b=e.UserDataSyncErrorCode||(e.UserDataSyncErrorCode={}));class g extends Error{constructor(u,f,v,T){super(u);this.code=f,this.resource=v,this.operationId=T,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=g;class a extends g{constructor(u,f,v,T,O){super(u,v,void 0,O);this.url=f,this.serverCode=T}}e.UserDataSyncStoreError=a;class l extends g{constructor(u,f){super(u,f)}}e.UserDataAutoSyncError=l,function(c){function u(f){if(f instanceof c)return f;const v=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(f.name);if(v&&v[1]){const T=v[2]==="unknown"?void 0:v[2],O=v[3]==="unknown"?void 0:v[3];return new c(f.message,v[1],T,O)}return new c(f.message,"Unknown")}c.toUserDataSyncError=u}(g=e.UserDataSyncError||(e.UserDataSyncError={}));var r;(function(c){c.Uninitialized="uninitialized",c.Idle="idle",c.Syncing="syncing",c.HasConflicts="hasConflicts"})(r=e.SyncStatus||(e.SyncStatus={}));var o;(function(c){c[c.None=0]="None",c[c.Added=1]="Added",c[c.Modified=2]="Modified",c[c.Deleted=3]="Deleted"})(o=e.Change||(e.Change={}));var n;(function(c){c.Preview="preview",c.Conflict="conflict",c.Accepted="accepted"})(n=e.MergeState||(e.MergeState={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function t(c){return`sync.enable.${c}`}e.getEnablementKey=t,e.IUserDataSyncResourceEnablementService=(0,S.createDecorator)("IUserDataSyncResourceEnablementService"),e.IUserDataSyncService=(0,S.createDecorator)("IUserDataSyncService"),e.IUserDataAutoSyncEnablementService=(0,S.createDecorator)("IUserDataAutoSyncEnablementService"),e.IUserDataAutoSyncService=(0,S.createDecorator)("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=(0,S.createDecorator)("IUserDataSyncUtilService"),e.IUserDataSyncLogService=(0,S.createDecorator)("IUserDataSyncLogService"),e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview";function s(c,u){if(c.scheme!==e.USER_DATA_SYNC_SCHEME)return c=c.with({scheme:u.userDataSyncHome.scheme}),e.ALL_SYNC_RESOURCES.filter(f=>(0,L.isEqualOrParent)(c,(0,L.joinPath)(u.userDataSyncHome,f,e.PREVIEW_DIR_NAME)))[0]}e.getSyncResourceFromLocalPreview=s}),define(te[47],ne([0,1,16,5,19,27,3,32,2,25,17,7,144,21,11,14,8,46,23,22,37,24]),function(X,e,R,L,D,k,i,P,S,C,I,E,d,p,h,w,y,m,b,g,a,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=e.isSyncData=void 0;function r(c){return!!(c&&c.version!==void 0&&typeof c.version=="number"&&c.content!==void 0&&typeof c.content=="string"&&(Object.keys(c).length===2||Object.keys(c).length===3&&c.machineId!==void 0&&typeof c.machineId=="string"))}e.isSyncData=r;let o=class extends S.Disposable{constructor(u,f,v,T,O,U,W,N,A,z,_){super();this.resource=u,this.fileService=f,this.environmentService=v,this.userDataSyncStoreService=O,this.userDataSyncBackupStoreService=U,this.userDataSyncResourceEnablementService=W,this.telemetryService=N,this.logService=A,this.configurationService=z,this.syncPreviewPromise=null,this._status="idle",this._onDidChangStatus=this._register(new i.Emitter),this.onDidChangeStatus=this._onDidChangStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new i.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this.localChangeTriggerScheduler=new L.RunOnceScheduler(()=>this.doTriggerLocalChange(),50),this._onDidChangeLocal=this._register(new i.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this.hasSyncResourceStateVersionChanged=!1,this.syncHeaders={},this.syncResourceLogLabel=(0,C.uppercaseFirstLetter)(this.resource),this.extUri=_.extUri,this.syncFolder=this.extUri.joinPath(v.userDataSyncHome,u),this.syncPreviewFolder=this.extUri.joinPath(this.syncFolder,l.PREVIEW_DIR_NAME),this.lastSyncResource=(0,l.getLastSyncResourceUri)(u,v,this.extUri),this.currentMachineIdPromise=(0,m.getServiceMachineId)(v,f,T)}get status(){return this._status}get conflicts(){return this._conflicts}isEnabled(){return this.userDataSyncResourceEnablementService.isResourceEnabled(this.resource)}async triggerLocalChange(){this.isEnabled()&&this.localChangeTriggerScheduler.schedule()}async doTriggerLocalChange(){if(this.status==="hasConflicts"){this.logService.info(`${this.syncResourceLogLabel}: In conflicts state and local change detected. Syncing again...`);const u=await this.syncPreviewPromise;this.syncPreviewPromise=null;const f=await this.performSync(u.remoteUserData,u.lastSyncUserData,!0,this.getUserDataSyncConfiguration());this.setStatus(f)}else{this.logService.trace(`${this.syncResourceLogLabel}: Checking for local changes...`);const u=await this.getLastSyncUserData();(u?(await this.doGenerateSyncResourcePreview(u,u,!0,this.getUserDataSyncConfiguration(),k.CancellationToken.None)).resourcePreviews.some(({remoteChange:v})=>v!==0):!0)&&this._onDidChangeLocal.fire()}}setStatus(u){if(this._status!==u){const f=this._status;u==="hasConflicts"&&this.telemetryService.publicLog2("sync/conflictsDetected",{source:this.resource}),f==="hasConflicts"&&u==="idle"&&this.telemetryService.publicLog2("sync/conflictsResolved",{source:this.resource}),this._status=u,this._onDidChangStatus.fire(u)}}async sync(u,f={}){await this._sync(u,!0,this.getUserDataSyncConfiguration(),f)}async preview(u,f,v={}){return this._sync(u,!1,f,v)}async apply(u,f={}){try{this.syncHeaders={...f};const v=await this.doApply(u);return this.setStatus(v),this.syncPreviewPromise}finally{this.syncHeaders={}}}async _sync(u,f,v,T){try{if(this.syncHeaders={...T},!this.isEnabled())return this.status!=="idle"&&await this.stop(),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is disabled.`),null;if(this.status==="hasConflicts")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.syncPreviewPromise;if(this.status==="syncing")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.syncPreviewPromise;this.logService.trace(`${this.syncResourceLogLabel}: Started synchronizing ${this.resource.toLowerCase()}...`),this.setStatus("syncing");let O="idle";try{const U=await this.getLastSyncUserData(),W=await this.getLatestRemoteUserData(u,U);return O=await this.performSync(W,U,f,v),O==="hasConflicts"?this.logService.info(`${this.syncResourceLogLabel}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):O==="idle"&&this.logService.trace(`${this.syncResourceLogLabel}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise||null}finally{this.setStatus(O)}}finally{this.syncHeaders={}}}async replace(u){const f=await this.resolveContent(u);if(!f)return!1;const v=this.parseSyncData(f);if(!v)return!1;await this.stop();try{this.logService.trace(`${this.syncResourceLogLabel}: Started resetting ${this.resource.toLowerCase()}...`),this.setStatus("syncing");const T=await this.getLastSyncUserData(),O=await this.getLatestRemoteUserData(null,T),U=await this.isRemoteDataFromCurrentMachine(O),W=await this.generateSyncPreview({ref:O.ref,syncData:v},T,U,this.getUserDataSyncConfiguration(),k.CancellationToken.None),N=[];for(const A of W){const z=await this.getAcceptResult(A,A.remoteResource,void 0,k.CancellationToken.None),{remoteChange:_}=await this.getAcceptResult(A,A.previewResource,A.remoteContent,k.CancellationToken.None);N.push([A,{...z,remoteChange:_!==0?_:2}])}await this.applyResult(O,T,N,!1),this.logService.info(`${this.syncResourceLogLabel}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.setStatus("idle")}return!0}async isRemoteDataFromCurrentMachine(u){const f=await this.currentMachineIdPromise;return!!u.syncData?.machineId&&u.syncData.machineId===f}async getLatestRemoteUserData(u,f){if(f){const v=u&&u.latest?u.latest[this.resource]:void 0;if(f.ref===v||v===void 0&&f.syncData===null)return f}return this.getRemoteUserData(f)}async performSync(u,f,v,T){if(u.syncData&&u.syncData.version>this.version)throw this.telemetryService.publicLog2("sync/incompatible",{source:this.resource}),new l.UserDataSyncError((0,d.localize)(0,null,this.resource,this.version,u.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.doSync(u,f,v,T)}catch(O){if(O instanceof l.UserDataSyncError)switch(O.code){case"LocalPreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize ${this.syncResourceLogLabel} as there is a new local version available. Synchronizing again...`),this.performSync(u,f,v,T);case"Conflict":case"PreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),u=await this.getRemoteUserData(null),f=await this.getLastSyncUserData(),this.performSync(u,f,v,T)}throw O}}async doSync(u,f,v,T){try{this.syncPreviewPromise||(this.syncPreviewPromise=(0,L.createCancelablePromise)(U=>this.doGenerateSyncResourcePreview(u,f,v,T,U)));const O=await this.syncPreviewPromise;return this.updateConflicts(O.resourcePreviews),O.resourcePreviews.some(({mergeState:U})=>U==="conflict")?"hasConflicts":v?await this.doApply(!1):"syncing"}catch(O){throw this.syncPreviewPromise=null,O}}async merge(u){return await this.updateSyncResourcePreview(u,async f=>{const v=await this.getMergeResult(f,k.CancellationToken.None);await this.fileService.writeFile(f.previewResource,D.VSBuffer.fromString(v?.content||""));const T=v&&!v.hasConflicts?await this.getAcceptResult(f,f.previewResource,void 0,k.CancellationToken.None):void 0;return f.acceptResult=T,f.mergeState=v.hasConflicts?"conflict":T?"accepted":"preview",f.localChange=T?T.localChange:v.localChange,f.remoteChange=T?T.remoteChange:v.remoteChange,f}),this.syncPreviewPromise}async accept(u,f){return await this.updateSyncResourcePreview(u,async v=>{const T=await this.getAcceptResult(v,u,f,k.CancellationToken.None);return v.acceptResult=T,v.mergeState="accepted",v.localChange=T.localChange,v.remoteChange=T.remoteChange,v}),this.syncPreviewPromise}async discard(u){return await this.updateSyncResourcePreview(u,async f=>{const v=await this.getMergeResult(f,k.CancellationToken.None);return await this.fileService.writeFile(f.previewResource,D.VSBuffer.fromString(v.content||"")),f.acceptResult=void 0,f.mergeState="preview",f.localChange=v.localChange,f.remoteChange=v.remoteChange,f}),this.syncPreviewPromise}async updateSyncResourcePreview(u,f){if(!this.syncPreviewPromise)return;let v=await this.syncPreviewPromise;const T=v.resourcePreviews.findIndex(({localResource:O,remoteResource:U,previewResource:W})=>this.extUri.isEqual(O,u)||this.extUri.isEqual(U,u)||this.extUri.isEqual(W,u));T!==-1&&(this.syncPreviewPromise=(0,L.createCancelablePromise)(async O=>{const U=[...v.resourcePreviews];return U[T]=await f(U[T]),{...v,resourcePreviews:U}}),v=await this.syncPreviewPromise,this.updateConflicts(v.resourcePreviews),v.resourcePreviews.some(({mergeState:O})=>O==="conflict")?this.setStatus("hasConflicts"):this.setStatus("syncing"))}async doApply(u){if(!this.syncPreviewPromise)return"idle";const f=await this.syncPreviewPromise;return f.resourcePreviews.some(({mergeState:v})=>v==="conflict")?"hasConflicts":f.resourcePreviews.some(({mergeState:v})=>v!=="accepted")?"syncing":(await this.applyResult(f.remoteUserData,f.lastSyncUserData,f.resourcePreviews.map(v=>[v,v.acceptResult]),u),this.syncPreviewPromise=null,await this.clearPreviewFolder(),"idle")}async clearPreviewFolder(){try{await this.fileService.del(this.syncPreviewFolder,{recursive:!0})}catch(u){}}updateConflicts(u){const f=u.filter(({mergeState:v})=>v==="conflict");(0,R.equals)(this._conflicts,f,(v,T)=>this.extUri.isEqual(v.previewResource,T.previewResource))||(this._conflicts=f,this._onDidChangeConflicts.fire(f))}async hasPreviouslySynced(){return!!await this.getLastSyncUserData()}async getRemoteSyncResourceHandles(){return(await this.userDataSyncStoreService.getAllRefs(this.resource)).map(({created:f,ref:v})=>({created:f,uri:this.toRemoteBackupResource(v)}))}async getLocalSyncResourceHandles(){return(await this.userDataSyncBackupStoreService.getAllRefs(this.resource)).map(({created:f,ref:v})=>({created:f,uri:this.toLocalBackupResource(v)}))}toRemoteBackupResource(u){return E.URI.from({scheme:l.USER_DATA_SYNC_SCHEME,authority:"remote-backup",path:`/${this.resource}/${u}`})}toLocalBackupResource(u){return E.URI.from({scheme:l.USER_DATA_SYNC_SCHEME,authority:"local-backup",path:`/${this.resource}/${u}`})}async getMachineId({uri:u}){const f=this.extUri.basename(u);if(this.extUri.isEqual(u,this.toRemoteBackupResource(f))){const{content:v}=await this.getUserData(f);if(v)return this.parseSyncData(v)?.machineId}}async resolveContent(u){const f=this.extUri.basename(u);if(this.extUri.isEqual(u,this.toRemoteBackupResource(f))){const{content:v}=await this.getUserData(f);return v}return this.extUri.isEqual(u,this.toLocalBackupResource(f))?this.userDataSyncBackupStoreService.resolveContent(this.resource,f):null}async resolvePreviewContent(u){const f=this.syncPreviewPromise?await this.syncPreviewPromise:null;if(f)for(const v of f.resourcePreviews){if(this.extUri.isEqual(v.acceptedResource,u))return v.acceptResult?v.acceptResult.content:null;if(this.extUri.isEqual(v.remoteResource,u))return v.remoteContent;if(this.extUri.isEqual(v.localResource,u))return v.localContent}return null}async resetLocal(){try{await this.fileService.del(this.lastSyncResource)}catch(u){}}async doGenerateSyncResourcePreview(u,f,v,T,O){const U=await this.isRemoteDataFromCurrentMachine(u),W=await this.generateSyncPreview(u,f,U,T,O),N=[];for(const A of W){const z=A.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"accepted"});if(A.localChange===0&&A.remoteChange===0)N.push({...A,acceptedResource:z,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const _=v?await this.getMergeResult(A,O):void 0;if(O.isCancellationRequested)break;await this.fileService.writeFile(A.previewResource,D.VSBuffer.fromString(_?.content||""));const M=_&&!_.hasConflicts?await this.getAcceptResult(A,A.previewResource,void 0,O):void 0;N.push({...A,acceptResult:M,mergeState:_?.hasConflicts?"conflict":M?"accepted":"preview",localChange:M?M.localChange:_?_.localChange:A.localChange,remoteChange:M?M.remoteChange:_?_.remoteChange:A.remoteChange})}}return{remoteUserData:u,lastSyncUserData:f,resourcePreviews:N,isLastSyncFromCurrentMachine:U}}async getLastSyncUserData(){try{const u=await this.fileService.readFile(this.lastSyncResource),f=JSON.parse(u.value.toString()),v=this.userDataSyncResourceEnablementService.getResourceSyncStateVersion(this.resource);if(this.hasSyncResourceStateVersionChanged=f.version&&v&&f.version!==v,this.hasSyncResourceStateVersionChanged)return this.logService.info(`${this.syncResourceLogLabel}: Reset last sync state because last sync state version ${f.version} is not compatible with current sync state version ${v}.`),await this.resetLocal(),null;const T=f;if(T.content===null)return{ref:f.ref,syncData:null};const O=JSON.parse(T.content);if(r(O))return{...f,syncData:O,content:void 0}}catch(u){u instanceof w.FileOperationError&&u.fileOperationResult===1||this.logService.error(u)}return null}async updateLastSyncUserData(u,f={}){if(f.ref||f.content||f.version)throw new Error("Cannot have core properties as additional");const v=this.userDataSyncResourceEnablementService.getResourceSyncStateVersion(this.resource),T={ref:u.ref,content:u.syncData?JSON.stringify(u.syncData):null,version:v,...f};await this.fileService.writeFile(this.lastSyncResource,D.VSBuffer.fromString(JSON.stringify(T)))}async getRemoteUserData(u){const{ref:f,content:v}=await this.getUserData(u);let T=null;return v!==null&&(T=this.parseSyncData(v)),{ref:f,syncData:T}}parseSyncData(u){try{const f=JSON.parse(u);if(r(f))return f}catch(f){this.logService.error(f)}throw new l.UserDataSyncError((0,d.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async getUserData(u){if((0,I.isString)(u)){const f=await this.userDataSyncStoreService.resolveContent(this.resource,u);return{ref:u,content:f}}else{const f=u?{ref:u.ref,content:u.syncData?JSON.stringify(u.syncData):null}:null;return this.userDataSyncStoreService.read(this.resource,f,this.syncHeaders)}}async updateRemoteUserData(u,f){const v=await this.currentMachineIdPromise,T={version:this.version,machineId:v,content:u};return f=await this.userDataSyncStoreService.write(this.resource,JSON.stringify(T),f,this.syncHeaders),{ref:f,syncData:T}}async backupLocal(u){const f={version:this.version,content:u};return this.userDataSyncBackupStoreService.backup(this.resource,JSON.stringify(f))}async stop(){this.status!=="idle"&&(this.logService.trace(`${this.syncResourceLogLabel}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise&&(this.syncPreviewPromise.cancel(),this.syncPreviewPromise=null),this.updateConflicts([]),await this.clearPreviewFolder(),this.setStatus("idle"),this.logService.info(`${this.syncResourceLogLabel}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}getUserDataSyncConfiguration(){return this.configurationService.getValue(l.USER_DATA_SYNC_CONFIGURATION_SCOPE)}};o=he([J(1,w.IFileService),J(2,h.IEnvironmentService),J(3,b.IStorageService),J(4,l.IUserDataSyncStoreService),J(5,l.IUserDataSyncBackupStoreService),J(6,l.IUserDataSyncResourceEnablementService),J(7,g.ITelemetryService),J(8,l.IUserDataSyncLogService),J(9,p.IConfigurationService),J(10,a.IUriIdentityService)],o),e.AbstractSynchroniser=o;let n=class extends o{constructor(u,f,v,T,O,U,W,N,A,z,_,M){super(f,v,T,O,U,W,N,A,z,_,M);this.file=u,this._register(this.fileService.watch(this.extUri.dirname(u))),this._register(this.fileService.onDidFilesChange(q=>this.onFileChanges(q)))}async getLocalFileContent(){try{return await this.fileService.readFile(this.file)}catch(u){return null}}async updateLocalFileContent(u,f,v){try{f?await this.writeFileContent(u,f,v):await this.fileService.createFile(this.file,D.VSBuffer.fromString(u),{overwrite:v})}catch(T){throw T instanceof w.FileOperationError&&T.fileOperationResult===1||T instanceof w.FileOperationError&&T.fileOperationResult===3?new l.UserDataSyncError(T.message,"LocalPreconditionFailed"):T}}async writeFileContent(u,f,v){await this.fileService.writeFile(this.file,D.VSBuffer.fromString(u),v?void 0:f)}onFileChanges(u){!u.contains(this.file)||this.triggerLocalChange()}};n=he([J(2,w.IFileService),J(3,h.IEnvironmentService),J(4,b.IStorageService),J(5,l.IUserDataSyncStoreService),J(6,l.IUserDataSyncBackupStoreService),J(7,l.IUserDataSyncResourceEnablementService),J(8,g.ITelemetryService),J(9,l.IUserDataSyncLogService),J(10,p.IConfigurationService),J(11,a.IUriIdentityService)],n),e.AbstractFileSynchroniser=n;let t=class extends n{constructor(u,f,v,T,O,U,W,N,A,z,_,M,q){super(u,f,v,T,O,U,W,N,A,z,M,q);this.userDataSyncUtilService=_,this._formattingOptions=void 0}hasErrors(u){const f=[];return(0,P.parse)(u,f,{allowEmptyContent:!0,allowTrailingComma:!0}),f.length>0}getFormattingOptions(){return this._formattingOptions||(this._formattingOptions=this.userDataSyncUtilService.resolveFormattingOptions(this.file)),this._formattingOptions}};t=he([J(2,w.IFileService),J(3,h.IEnvironmentService),J(4,b.IStorageService),J(5,l.IUserDataSyncStoreService),J(6,l.IUserDataSyncBackupStoreService),J(7,l.IUserDataSyncResourceEnablementService),J(8,g.ITelemetryService),J(9,l.IUserDataSyncLogService),J(10,l.IUserDataSyncUtilService),J(11,p.IConfigurationService),J(12,a.IUriIdentityService)],t),e.AbstractJsonFileSynchroniser=t;let s=class{constructor(u,f,v,T,O){this.resource=u,this.environmentService=f,this.logService=v,this.fileService=T,this.extUri=O.extUri,this.lastSyncResource=(0,l.getLastSyncResourceUri)(this.resource,f,this.extUri)}async initialize({ref:u,content:f}){if(!f){this.logService.info("Remote content does not exist.",this.resource);return}const v=this.parseSyncData(f);if(!!v)try{await this.doInitialize({ref:u,syncData:v})}catch(T){this.logService.error(T)}}parseSyncData(u){try{const f=JSON.parse(u);if(r(f))return f}catch(f){this.logService.error(f)}this.logService.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async updateLastSyncUserData(u,f={}){const v={ref:u.ref,content:u.syncData?JSON.stringify(u.syncData):null,...f};await this.fileService.writeFile(this.lastSyncResource,D.VSBuffer.fromString(JSON.stringify(v)))}};s=he([J(1,h.IEnvironmentService),J(2,y.ILogService),J(3,w.IFileService),J(4,a.IUriIdentityService)],s),e.AbstractInitializer=s}),define(te[221],ne([0,1,5,27,9,3,40,48,25,7,21,11,30,36,14,8,23,22,37,47,218,97,98,24]),function(X,e,R,L,D,k,i,P,S,C,I,E,d,p,h,w,y,m,b,g,a,l,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsInitializer=e.ExtensionsSynchroniser=e.storeExtensionStorageState=e.getExtensionStorageState=void 0;async function n(f,v){const T=JSON.parse(f.content);if(f.version===1||f.version===2){const O=(await v.getInstalled(0)).filter(U=>U.isBuiltin);for(const U of T)f.version===1&&(U.enabled===!1&&(U.disabled=!0),delete U.enabled),f.version===2&&O.every(W=>!(0,p.areSameExtensions)(W.identifier,U.identifier))&&(U.installed=!0)}return T}function t(f,v,T){const O=T.get((0,p.getExtensionId)(f,v),0)||"{}";return JSON.parse(O)}e.getExtensionStorageState=t;function s(f,v,T,O){O.store((0,p.getExtensionId)(f,v),JSON.stringify(T),0,1)}e.storeExtensionStorageState=s;let c=class mt extends g.AbstractSynchroniser{constructor(v,T,O,U,W,N,A,z,_,M,q,B,j,$,K){super("extensions",T,v,O,U,W,B,j,_,q,K);this.storageService=O,this.extensionManagementService=N,this.extensionEnablementService=A,this.ignoredExtensionsManagementService=z,this.extensionGalleryService=M,this.extensionsStorageSyncService=$,this.version=5,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"extensions.json"),this.localResource=this.previewResource.with({scheme:o.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:o.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:o.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(k.Event.debounce(k.Event.any(k.Event.filter(this.extensionManagementService.onDidInstallExtensions,F=>F.some(({local:x})=>!!x)),k.Event.filter(this.extensionManagementService.onDidUninstallExtension,F=>!F.error),this.extensionEnablementService.onDidChangeEnablement,this.extensionsStorageSyncService.onDidChangeExtensionsStorage),()=>{},500)(()=>this.triggerLocalChange()))}isEnabled(){return super.isEnabled()&&this.extensionGalleryService.isEnabled()}async generateSyncPreview(v,T){const O=v.syncData?await n(v.syncData,this.extensionManagementService):null,U=T?.skippedExtensions||[],W=T?.syncData?await n(T.syncData,this.extensionManagementService):null,N=await this.extensionManagementService.getInstalled(void 0,!0),A=this.getLocalExtensions(N),z=this.ignoredExtensionsManagementService.getIgnoredExtensions(N);O?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote extensions with local extensions...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:_,remote:M}=(0,a.merge)(A,O,W,U,z),q={local:_,remote:M,content:this.getPreviewContent(A,_.added,_.updated,_.removed),localChange:_.added.length>0||_.removed.length>0||_.updated.length>0?2:0,remoteChange:M!==null?2:0};return[{skippedExtensions:U,localResource:this.localResource,localContent:this.format(A),localExtensions:A,remoteResource:this.remoteResource,remoteContent:O?this.format(O):null,previewResource:this.previewResource,previewResult:q,localChange:q.localChange,remoteChange:q.remoteChange,acceptedResource:this.acceptedResource}]}getPreviewContent(v,T,O,U){const W=[...T,...O],N=new Set,A=z=>{N.add(z.id.toLowerCase()),z.uuid&&N.add(z.uuid)};W.forEach(({identifier:z})=>A(z)),U.forEach(A);for(const z of v)N.has(z.identifier.id.toLowerCase())||z.identifier.uuid&&N.has(z.identifier.uuid)||W.push(z);return this.format(W)}async getMergeResult(v,T){return{...v.previewResult,hasConflicts:!1}}async getAcceptResult(v,T,O,U){if(this.extUri.isEqual(T,this.localResource))return this.acceptLocal(v);if(this.extUri.isEqual(T,this.remoteResource))return this.acceptRemote(v);if(this.extUri.isEqual(T,this.previewResource))return v.previewResult;throw new Error(`Invalid Resource: ${T.toString()}`)}async acceptLocal(v){const T=await this.extensionManagementService.getInstalled(),O=this.ignoredExtensionsManagementService.getIgnoredExtensions(T),U=(0,a.merge)(v.localExtensions,null,null,v.skippedExtensions,O),{local:W,remote:N}=U;return{content:v.localContent,local:W,remote:N,localChange:W.added.length>0||W.removed.length>0||W.updated.length>0?2:0,remoteChange:N!==null?2:0}}async acceptRemote(v){const T=await this.extensionManagementService.getInstalled(),O=this.ignoredExtensionsManagementService.getIgnoredExtensions(T),U=v.remoteContent?JSON.parse(v.remoteContent):null;if(U!==null){const W=(0,a.merge)(v.localExtensions,U,v.localExtensions,[],O),{local:N,remote:A}=W;return{content:v.remoteContent,local:N,remote:A,localChange:N.added.length>0||N.removed.length>0||N.updated.length>0?2:0,remoteChange:A!==null?2:0}}else return{content:v.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async applyResult(v,T,O,U){let{skippedExtensions:W,localExtensions:N}=O[0][0],{local:A,remote:z,localChange:_,remoteChange:M}=O[0][1];if(_===0&&M===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing extensions.`),_!==0&&(await this.backupLocal(JSON.stringify(N)),W=await this.updateLocalExtensions(A.added,A.removed,A.updated,W)),z){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote extensions...`);const q=JSON.stringify(z.all);v=await this.updateRemoteUserData(q,U?null:v.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote extensions.${z.added.length?` Added: ${JSON.stringify(z.added.map(B=>B.identifier.id))}.`:""}${z.updated.length?` Updated: ${JSON.stringify(z.updated.map(B=>B.identifier.id))}.`:""}${z.removed.length?` Removed: ${JSON.stringify(z.removed.map(B=>B.identifier.id))}.`:""}`)}T?.ref!==v.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized extensions...`),await this.updateLastSyncUserData(v,{skippedExtensions:W}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized extensions.${W.length?` Skipped: ${JSON.stringify(W.map(q=>q.identifier.id))}.`:""}`))}async getAssociatedResources({uri:v}){return[{resource:this.extUri.joinPath(v,"extensions.json"),comparableResource:mt.EXTENSIONS_DATA_URI}]}async resolveContent(v){if(this.extUri.isEqual(v,mt.EXTENSIONS_DATA_URI)){const O=await this.extensionManagementService.getInstalled(),U=this.ignoredExtensionsManagementService.getIgnoredExtensions(O),W=this.getLocalExtensions(O).filter(N=>!U.some(A=>(0,p.areSameExtensions)({id:A},N.identifier)));return this.format(W)}if(this.extUri.isEqual(this.remoteResource,v)||this.extUri.isEqual(this.localResource,v)||this.extUri.isEqual(this.acceptedResource,v))return this.resolvePreviewContent(v);let T=await super.resolveContent(v);if(T)return T;if(T=await super.resolveContent(this.extUri.dirname(v)),T){const O=this.parseSyncData(T);if(O)switch(this.extUri.basename(v)){case"extensions.json":return this.format(this.parseExtensions(O))}}return null}format(v){v.sort((U,W)=>!U.identifier.uuid&&W.identifier.uuid?-1:U.identifier.uuid&&!W.identifier.uuid?1:(0,S.compare)(U.identifier.id,W.identifier.id));const T=JSON.stringify(v),O=(0,P.format)(T,void 0,{});return(0,i.applyEdits)(T,O)}async hasLocalData(){try{const v=await this.extensionManagementService.getInstalled();if(this.getLocalExtensions(v).some(O=>O.installed||O.disabled))return!0}catch(v){}return!1}async updateLocalExtensions(v,T,O,U){const W=[],N=[],A=await this.extensionManagementService.getInstalled();if(T.length){const _=A.filter(({identifier:M,isBuiltin:q})=>!q&&T.some(B=>(0,p.areSameExtensions)(M,B)));await R.Promises.settled(_.map(async M=>{this.logService.trace(`${this.syncResourceLogLabel}: Uninstalling local extension...`,M.identifier.id),await this.extensionManagementService.uninstall(M,{donotIncludePack:!0,donotCheckDependents:!0}),this.logService.info(`${this.syncResourceLogLabel}: Uninstalled local extension.`,M.identifier.id),W.push(M.identifier)}))}(v.length||O.length)&&await R.Promises.settled([...v,...O].map(async _=>{const M=A.find(B=>(0,p.areSameExtensions)(B.identifier,_.identifier));if(M&&M.isBuiltin){_.state&&M.manifest.version===_.version&&this.updateExtensionState(_.state,M.manifest.publisher,M.manifest.name,M.manifest.version),_.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,_.identifier.id),await this.extensionEnablementService.disableExtension(_.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,_.identifier.id)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,_.identifier.id),await this.extensionEnablementService.enableExtension(_.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,_.identifier.id)),W.push(_.identifier);return}const q=(await this.extensionGalleryService.getExtensions([_.identifier],L.CancellationToken.None))[0];if(_.state&&(M?M.manifest.version===_.version:!!q)){const B=M?M.manifest.publisher:q.publisher,j=M?M.manifest.name:q.name;this.updateExtensionState(_.state,B,j,M?.manifest.version)}if(q)try{_.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,_.identifier.id,q.version),await this.extensionEnablementService.disableExtension(q.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,_.identifier.id,q.version)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,_.identifier.id,q.version),await this.extensionEnablementService.enableExtension(q.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,_.identifier.id,q.version)),M||(await this.extensionManagementService.canInstall(q)?(this.logService.trace(`${this.syncResourceLogLabel}: Installing extension...`,_.identifier.id,q.version),await this.extensionManagementService.installFromGallery(q,{isMachineScoped:!1,donotIncludePackAndDependencies:!0}),this.logService.info(`${this.syncResourceLogLabel}: Installed extension.`,_.identifier.id,q.version),W.push(q.identifier)):(this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because it cannot be installed.`,q.displayName||q.identifier.id),N.push(_)))}catch(B){N.push(_),B instanceof d.ExtensionManagementError&&B.code===d.ExtensionManagementErrorCode.Incompatible?this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the compatible extension is not found.`,q.displayName||q.identifier.id):(this.logService.error(B),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension`,q.displayName||q.identifier.id))}else N.push(_),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the extension is not found.`,_.identifier.id)}));const z=[];for(const _ of U)W.some(M=>(0,p.areSameExtensions)(M,_.identifier))||z.push(_);for(const _ of N)z.some(M=>(0,p.areSameExtensions)(M.identifier,_.identifier))||z.push(_);return z}updateExtensionState(v,T,O,U){const W=t(T,O,this.storageService),N=U?this.extensionsStorageSyncService.getKeysForSync({id:(0,p.getGalleryExtensionId)(T,O),version:U}):void 0;N?N.forEach(A=>{W[A]=v[A]}):Object.keys(v).forEach(A=>W[A]=v[A]),s(T,O,W,this.storageService)}parseExtensions(v){return JSON.parse(v.content)}getLocalExtensions(v){const T=this.extensionEnablementService.getDisabledExtensions();return v.map(({identifier:O,isBuiltin:U,manifest:W})=>{const N={identifier:O,version:W.version};T.some(A=>(0,p.areSameExtensions)(A,O))&&(N.disabled=!0),U||(N.installed=!0);try{const A=this.extensionsStorageSyncService.getKeysForSync({id:O.id,version:W.version});if(A){const z=t(W.publisher,W.name,this.storageService);N.state=Object.keys(z).reduce((_,M)=>(A.includes(M)&&(_[M]=z[M]),_),{})}}catch(A){this.logService.info(`${this.syncResourceLogLabel}: Error while parsing extension state`,(0,D.getErrorMessage)(A))}return N})}};c.EXTENSIONS_DATA_URI=C.URI.from({scheme:o.USER_DATA_SYNC_SCHEME,authority:"extensions",path:"/extensions.json"}),c=he([J(0,E.IEnvironmentService),J(1,h.IFileService),J(2,y.IStorageService),J(3,o.IUserDataSyncStoreService),J(4,o.IUserDataSyncBackupStoreService),J(5,d.IExtensionManagementService),J(6,d.IGlobalExtensionEnablementService),J(7,r.IIgnoredExtensionsManagementService),J(8,o.IUserDataSyncLogService),J(9,d.IExtensionGalleryService),J(10,I.IConfigurationService),J(11,o.IUserDataSyncResourceEnablementService),J(12,m.ITelemetryService),J(13,l.IExtensionsStorageSyncService),J(14,b.IUriIdentityService)],c),e.ExtensionsSynchroniser=c;let u=class extends g.AbstractInitializer{constructor(v,T,O,U,W,N){super("extensions",U,W,O,N);this.extensionManagementService=v,this.ignoredExtensionsManagementService=T}async parseExtensions(v){return v.syncData?await n(v.syncData,this.extensionManagementService):null}generatePreview(v,T){const O=[],U=[],W=[];for(const N of v){if(this.ignoredExtensionsManagementService.hasToNeverSyncExtension(N.identifier.id))continue;const A=T.find(z=>(0,p.areSameExtensions)(z.identifier,N.identifier));A?(O.push(A),N.disabled&&W.push(N.identifier)):N.installed&&(U.push(N.identifier),N.disabled&&W.push(N.identifier))}return{installedExtensions:O,newExtensions:U,disabledExtensions:W,remoteExtensions:v}}};u=he([J(0,d.IExtensionManagementService),J(1,r.IIgnoredExtensionsManagementService),J(2,h.IFileService),J(3,E.IEnvironmentService),J(4,w.ILogService),J(5,b.IUriIdentityService)],u),e.AbstractExtensionsInitializer=u}),define(te[222],ne([0,1,28,24]),function(X,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function D(P,S,C,I,E){if(!S)return{remote:Object.keys(P).length>0?P:null,local:{added:{},removed:[],updated:{}}};const d=k(P,S);if(d.added.size===0&&d.removed.size===0&&d.updated.size===0)return{remote:null,local:{added:{},removed:[],updated:{}}};const p=C?k(C,S):{added:Object.keys(S).reduce((b,g)=>(b.add(g),b),new Set),removed:new Set,updated:new Set},h=C?k(C,P):{added:Object.keys(P).reduce((b,g)=>(b.add(g),b),new Set),removed:new Set,updated:new Set},w={added:{},removed:[],updated:{}},y=R.deepClone(S),m=!C;for(const b of h.added.values())b!==L.SYNC_SERVICE_URL_TYPE&&m&&p.added.has(b)||(y[b]=P[b]);for(const b of h.updated.values())y[b]=P[b];for(const b of h.removed.values())I.unregistered.includes(b)||delete y[b];for(const b of p.added.values()){const g=S[b];if(I.machine.includes(b)){E.info(`GlobalState: Skipped adding ${b} in local storage because it is declared as machine scoped.`);continue}if(C&&h.added.has(b))continue;const a=P[b];a&&a.value===g.value||b===L.SYNC_SERVICE_URL_TYPE&&m&&h.added.has(b)||(a?w.updated[b]=g:w.added[b]=g)}for(const b of p.updated.values()){const g=S[b];if(I.machine.includes(b)){E.info(`GlobalState: Skipped updating ${b} in local storage because it is declared as machine scoped.`);continue}if(h.updated.has(b)||h.removed.has(b))continue;const a=P[b];a&&a.value===g.value||(w.updated[b]=g)}for(const b of p.removed.values()){if(I.machine.includes(b)){E.trace(`GlobalState: Skipped removing ${b} in local storage because it is declared as machine scoped.`);continue}h.updated.has(b)||h.removed.has(b)||w.removed.push(b)}return{local:w,remote:i(y,S)?null:y}}e.merge=D;function k(P,S){const C=Object.keys(P),I=Object.keys(S),E=I.filter(h=>C.indexOf(h)===-1).reduce((h,w)=>(h.add(w),h),new Set),d=C.filter(h=>I.indexOf(h)===-1).reduce((h,w)=>(h.add(w),h),new Set),p=new Set;for(const h of C){if(d.has(h))continue;const w=P[h],y=S[h];R.equals(w,y)||p.add(h)}return{added:E,removed:d,updated:p}}function i(P,S){const{added:C,removed:I,updated:E}=k(P,S);return C.size===0&&I.size===0&&E.size===0}}),define(te[223],ne([0,1,19,9,3,32,40,48,4,7,29,21,11,14,8,46,23,22,37,47,55,222,24]),function(X,e,R,L,D,k,i,P,S,C,I,E,d,p,h,w,y,m,b,g,a,l,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.GlobalStateInitializer=e.GlobalStateSynchroniser=void 0;const o="globalState.argv.",n=["locale"];function t(v){const T=v.storage?Object.keys(v.storage).sort():[],O={};T.forEach(N=>O[N]=v.storage[N]),v.storage=O;const U=JSON.stringify(v),W=(0,P.format)(U,void 0,{});return(0,i.applyEdits)(U,W)}const s=1;let c=class vt extends g.AbstractSynchroniser{constructor(T,O,U,W,N,A,z,_,M,q){super("globalState",T,N,M,O,U,A,z,W,_,q);this.storageService=M,this.version=s,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"globalState.json"),this.localResource=this.previewResource.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(T.watch(this.extUri.dirname(this.environmentService.argvResource))),this._register(D.Event.any(D.Event.filter(T.onDidFilesChange,B=>B.contains(this.environmentService.argvResource)),D.Event.filter(M.onDidChangeValue,B=>B.scope===0&&B.target!==void 0?B.target===0:M.keys(0,0).includes(B.key)),this.storageService.onDidChangeTarget)(()=>this.triggerLocalChange()))}async generateSyncPreview(T,O,U){const W=T.syncData?JSON.parse(T.syncData.content):null;O=O===null&&U?T:O;const N=O&&O.syncData?JSON.parse(O.syncData.content):null,A=await this.getLocalGlobalState();W?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote ui state with local ui state...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const z=this.getStorageKeys(N),{local:_,remote:M}=(0,l.merge)(A.storage,W?W.storage:null,N?N.storage:null,z,this.logService),q={content:null,local:_,remote:M,localChange:Object.keys(_.added).length>0||Object.keys(_.updated).length>0||_.removed.length>0?2:0,remoteChange:M!==null?2:0};return[{localResource:this.localResource,localContent:t(A),localUserData:A,remoteResource:this.remoteResource,remoteContent:W?t(W):null,previewResource:this.previewResource,previewResult:q,localChange:q.localChange,remoteChange:q.remoteChange,acceptedResource:this.acceptedResource,storageKeys:z}]}async getMergeResult(T,O){return{...T.previewResult,hasConflicts:!1}}async getAcceptResult(T,O,U,W){if(this.extUri.isEqual(O,this.localResource))return this.acceptLocal(T);if(this.extUri.isEqual(O,this.remoteResource))return this.acceptRemote(T);if(this.extUri.isEqual(O,this.previewResource))return T.previewResult;throw new Error(`Invalid Resource: ${O.toString()}`)}async acceptLocal(T){return{content:T.localContent,local:{added:{},removed:[],updated:{}},remote:T.localUserData.storage,localChange:0,remoteChange:2}}async acceptRemote(T){if(T.remoteContent!==null){const O=JSON.parse(T.remoteContent),{local:U,remote:W}=(0,l.merge)(T.localUserData.storage,O.storage,null,T.storageKeys,this.logService);return{content:T.remoteContent,local:U,remote:W,localChange:Object.keys(U.added).length>0||Object.keys(U.updated).length>0||U.removed.length>0?2:0,remoteChange:W!==null?2:0}}else return{content:T.remoteContent,local:{added:{},removed:[],updated:{}},remote:null,localChange:0,remoteChange:0}}async applyResult(T,O,U,W){let{localUserData:N}=U[0][0],{local:A,remote:z,localChange:_,remoteChange:M}=U[0][1];if(_===0&&M===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing ui state.`),_!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local ui state...`),await this.backupLocal(JSON.stringify(N)),await this.writeLocalGlobalState(A),this.logService.info(`${this.syncResourceLogLabel}: Updated local ui state`)),M!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote ui state...`);const q=JSON.stringify({storage:z});T=await this.updateRemoteUserData(q,W?null:T.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote ui state`)}O?.ref!==T.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized ui state...`),await this.updateLastSyncUserData(T),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized ui state`))}async getAssociatedResources({uri:T}){return[{resource:this.extUri.joinPath(T,"globalState.json"),comparableResource:vt.GLOBAL_STATE_DATA_URI}]}async resolveContent(T){if(this.extUri.isEqual(T,vt.GLOBAL_STATE_DATA_URI)){const U=await this.getLocalGlobalState();return t(U)}if(this.extUri.isEqual(this.remoteResource,T)||this.extUri.isEqual(this.localResource,T)||this.extUri.isEqual(this.acceptedResource,T))return this.resolvePreviewContent(T);let O=await super.resolveContent(T);if(O)return O;if(O=await super.resolveContent(this.extUri.dirname(T)),O){const U=this.parseSyncData(O);if(U)switch(this.extUri.basename(T)){case"globalState.json":return t(JSON.parse(U.content))}}return null}async hasLocalData(){try{const{storage:T}=await this.getLocalGlobalState();if(Object.keys(T).length>1||T[`${o}.locale`]?.value!=="en")return!0}catch(T){}return!1}async getLocalGlobalState(){const T={},O=await this.getLocalArgvContent(),U=(0,k.parse)(O);for(const W of n)U[W]!==void 0&&(T[`${o}${W}`]={version:1,value:U[W]});for(const W of this.storageService.keys(0,0)){const N=this.storageService.get(W,0);N&&(T[W]={version:1,value:N})}return{storage:T}}async getLocalArgvContent(){try{this.logService.debug("GlobalStateSync#getLocalArgvContent",this.environmentService.argvResource);const T=await this.fileService.readFile(this.environmentService.argvResource);return this.logService.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.environmentService.argvResource),T.value.toString()}catch(T){this.logService.debug((0,L.getErrorMessage)(T))}return"{}"}async writeLocalGlobalState({added:T,removed:O,updated:U}){const W={},N={},A=(_,M)=>{for(const q of _){if(q.startsWith(o)){W[q.substring(o.length)]=M?M[q].value:void 0;continue}if(M){const B=M[q];B.value!==String(this.storageService.get(q,0))&&(N[q]=B.value)}else this.storageService.get(q,0)!==void 0&&(N[q]=void 0)}};if(A(Object.keys(T),T),A(Object.keys(U),U),A(O),Object.keys(W).length&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.updateArgv(W),this.logService.info(`${this.syncResourceLogLabel}: Updated locale`)),Object.keys(N).length){this.logService.trace(`${this.syncResourceLogLabel}: Updating global state...`);for(const _ of Object.keys(N))this.storageService.store(_,N[_],0,0);this.logService.info(`${this.syncResourceLogLabel}: Updated global state`,Object.keys(N))}}async updateArgv(T){const O=await this.getLocalArgvContent();let U=O;for(const W of Object.keys(T))U=(0,a.edit)(U,[W],T[W],{});O!==U&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.fileService.writeFile(this.environmentService.argvResource,R.VSBuffer.fromString(U)),this.logService.info(`${this.syncResourceLogLabel}: Updated locale.`))}getStorageKeys(T){const O=this.storageService.keys(0,0),U=this.storageService.keys(0,1),W=[...O,...U],N=T?.storage?Object.keys(T.storage).filter(A=>!A.startsWith(o)&&!W.includes(A)&&this.storageService.get(A,0)!==void 0):[];if(!S.isWeb){const A=[...r.ALL_SYNC_RESOURCES.map(z=>(0,r.getEnablementKey)(z)),r.SYNC_SERVICE_URL_TYPE];N.push(...A),U.push(...A)}return{user:O,machine:U,unregistered:N}}};c.GLOBAL_STATE_DATA_URI=C.URI.from({scheme:r.USER_DATA_SYNC_SCHEME,authority:"globalState",path:"/globalState.json"}),c=he([J(0,p.IFileService),J(1,r.IUserDataSyncStoreService),J(2,r.IUserDataSyncBackupStoreService),J(3,r.IUserDataSyncLogService),J(4,d.IEnvironmentService),J(5,r.IUserDataSyncResourceEnablementService),J(6,m.ITelemetryService),J(7,E.IConfigurationService),J(8,y.IStorageService),J(9,b.IUriIdentityService)],c),e.GlobalStateSynchroniser=c;let u=class extends g.AbstractInitializer{constructor(T,O,U,W,N){super("globalState",U,W,O,N);this.storageService=T}async doInitialize(T){const O=T.syncData?JSON.parse(T.syncData.content):null;if(!O){this.logService.info("Skipping initializing global state because remote global state does not exist.");return}const U={},W={};for(const N of Object.keys(O.storage))N.startsWith(o)?U[N.substring(o.length)]=O.storage[N].value:this.storageService.get(N,0)===void 0&&(W[N]=O.storage[N].value);if(Object.keys(U).length){let N="{}";try{N=(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch(A){}for(const A of Object.keys(U))N=(0,a.edit)(N,[A],U[A],{});await this.fileService.writeFile(this.environmentService.argvResource,R.VSBuffer.fromString(N))}if(Object.keys(W).length)for(const N of Object.keys(W))this.storageService.store(N,W[N],0,0)}};u=he([J(0,y.IStorageService),J(1,p.IFileService),J(2,d.IEnvironmentService),J(3,r.IUserDataSyncLogService),J(4,b.IUriIdentityService)],u),e.GlobalStateInitializer=u;let f=class{constructor(T,O,U,W,N){this.userDataSyncStoreClient=T,this.storageService=O,this.environmentService=U,this.fileService=W,this.logService=N}getSyncStoreType(T){return this.parseGlobalState(T)?.storage[r.SYNC_SERVICE_URL_TYPE]?.value}async sync(T){const O=(0,r.createSyncHeaders)((0,I.generateUuid)());try{return await this.doSync(T,O)}catch(U){if(U instanceof r.UserDataSyncError)switch(U.code){case"PreconditionFailed":return this.logService.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.doSync(T,O)}throw U}}async doSync(T,O){const U=await this.userDataSyncStoreClient.read("globalState",null,O),W=this.parseGlobalState(U)||{storage:{}};W.storage[r.SYNC_SERVICE_URL_TYPE]={value:T,version:s};const N=await(0,w.getServiceMachineId)(this.environmentService,this.fileService,this.storageService),A={version:s,machineId:N,content:t(W)};await this.userDataSyncStoreClient.write("globalState",JSON.stringify(A),U.ref,O)}parseGlobalState({content:T}){if(!T)return null;const O=JSON.parse(T);if((0,g.isSyncData)(O))return O?JSON.parse(O.content):null;throw new Error("Invalid remote data")}};f=he([J(1,y.IStorageService),J(2,d.IEnvironmentService),J(3,p.IFileService),J(4,h.ILogService)],f),e.UserDataSyncStoreTypeSynchronizer=f}),define(te[224],ne([0,1,16,19,3,32,4,17,145,21,11,14,23,22,37,47,219,24]),function(X,e,R,L,D,k,i,P,S,C,I,E,d,p,h,w,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=e.getKeybindingsContentFromSyncContent=void 0;function b(l,r,o){try{const n=JSON.parse(l);if(!r)return(0,P.isUndefined)(n.all)?null:n.all;switch(i.OS){case 2:return(0,P.isUndefined)(n.mac)?null:n.mac;case 3:return(0,P.isUndefined)(n.linux)?null:n.linux;case 1:return(0,P.isUndefined)(n.windows)?null:n.windows}}catch(n){return o.error(n),null}}e.getKeybindingsContentFromSyncContent=b;let g=class extends w.AbstractJsonFileSynchroniser{constructor(r,o,n,t,s,c,u,f,v,T,O){super(u.keybindingsResource,"keybindings",c,u,f,r,o,s,T,n,v,t,O);this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"keybindings.json"),this.localResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(D.Event.filter(t.onDidChangeConfiguration,U=>U.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.triggerLocalChange()))}async generateSyncPreview(r,o,n,t){const s=r.syncData?b(r.syncData.content,t.keybindingsPerPlatform??this.syncKeybindingsPerPlatform(),this.logService):null;o=o===null&&n?r:o;const c=o?this.getKeybindingsContentFromLastSyncUserData(o):null,u=await this.getLocalFileContent(),f=await this.getFormattingOptions();let v=null,T=!1,O=!1,U=!1;if(s){let N=u?u.value.toString():"[]";if(N=N||"[]",this.hasErrors(N))throw new m.UserDataSyncError((0,S.localize)(0,null),"LocalInvalidContent",this.resource);if(!c||c!==N||c!==s){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote keybindings with local keybindings...`);const A=await(0,y.merge)(N,s,c,f,this.userDataSyncUtilService);A.hasChanges&&(v=A.mergeContent,U=A.hasConflicts,T=U||A.mergeContent!==N,O=U||A.mergeContent!==s)}}else u&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),v=u.value.toString(),O=!0);const W={content:v,localChange:T?u?2:1:0,remoteChange:O?2:0,hasConflicts:U};return[{fileContent:u,localResource:this.localResource,localContent:u?u.value.toString():null,localChange:W.localChange,remoteResource:this.remoteResource,remoteContent:s,remoteChange:W.remoteChange,previewResource:this.previewResource,previewResult:W,acceptedResource:this.acceptedResource}]}async getMergeResult(r,o){return r.previewResult}async getAcceptResult(r,o,n,t){if(this.extUri.isEqual(o,this.localResource))return{content:r.fileContent?r.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(o,this.remoteResource))return{content:r.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(o,this.previewResource))return n===void 0?{content:r.previewResult.content,localChange:r.previewResult.localChange,remoteChange:r.previewResult.remoteChange}:{content:n,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${o.toString()}`)}async applyResult(r,o,n,t){const{fileContent:s}=n[0][0];let{content:c,localChange:u,remoteChange:f}=n[0][1];if(u===0&&f===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing keybindings.`),c!==null&&(c=c.trim(),c=c||"[]",this.hasErrors(c)))throw new m.UserDataSyncError((0,S.localize)(1,null),"LocalInvalidContent",this.resource);if(u!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local keybindings...`),s&&await this.backupLocal(this.toSyncContent(s.value.toString())),await this.updateLocalFileContent(c||"[]",s,t),this.logService.info(`${this.syncResourceLogLabel}: Updated local keybindings`)),f!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote keybindings...`);const v=this.toSyncContent(c||"[]",r.syncData?.content);r=await this.updateRemoteUserData(v,t?null:r.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote keybindings`)}try{await this.fileService.del(this.previewResource)}catch(v){}o?.ref!==r.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized keybindings...`),await this.updateLastSyncUserData(r,{platformSpecific:this.syncKeybindingsPerPlatform()}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized keybindings`))}async hasLocalData(){try{const r=await this.getLocalFileContent();if(r){const o=(0,k.parse)(r.value.toString());if((0,R.isNonEmptyArray)(o))return!0}}catch(r){if(r.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:r}){const o=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(r,"keybindings.json"),comparableResource:o}]}async resolveContent(r){if(this.extUri.isEqual(this.remoteResource,r)||this.extUri.isEqual(this.localResource,r)||this.extUri.isEqual(this.acceptedResource,r))return this.resolvePreviewContent(r);let o=await super.resolveContent(r);if(o)return o;if(o=await super.resolveContent(this.extUri.dirname(r)),o){const n=this.parseSyncData(o);if(n)switch(this.extUri.basename(r)){case"keybindings.json":return b(n.content,this.syncKeybindingsPerPlatform(),this.logService)}}return null}getKeybindingsContentFromLastSyncUserData(r){return!r.syncData||r.platformSpecific!==void 0&&r.platformSpecific!==this.syncKeybindingsPerPlatform()?null:b(r.syncData.content,this.syncKeybindingsPerPlatform(),this.logService)}toSyncContent(r,o){let n={};try{n=JSON.parse(o||"{}")}catch(t){this.logService.error(t)}switch(this.syncKeybindingsPerPlatform()?delete n.all:n.all=r,i.OS){case 2:n.mac=r;break;case 3:n.linux=r;break;case 1:n.windows=r;break}return JSON.stringify(n)}syncKeybindingsPerPlatform(){return!!this.configurationService.getValue("settingsSync.keybindingsPerPlatform")}};g=he([J(0,m.IUserDataSyncStoreService),J(1,m.IUserDataSyncBackupStoreService),J(2,m.IUserDataSyncLogService),J(3,C.IConfigurationService),J(4,m.IUserDataSyncResourceEnablementService),J(5,E.IFileService),J(6,I.IEnvironmentService),J(7,d.IStorageService),J(8,m.IUserDataSyncUtilService),J(9,p.ITelemetryService),J(10,h.IUriIdentityService)],g),e.KeybindingsSynchroniser=g;let a=class extends w.AbstractInitializer{constructor(r,o,n,t){super("keybindings",o,n,r,t)}async doInitialize(r){const o=r.syncData?this.getKeybindingsContentFromSyncContent(r.syncData.content):null;if(!o){this.logService.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing keybindings because local keybindings exist.");return}await this.fileService.writeFile(this.environmentService.keybindingsResource,L.VSBuffer.fromString(o)),await this.updateLastSyncUserData(r)}async isEmpty(){try{const r=await this.fileService.readFile(this.environmentService.settingsResource),o=(0,k.parse)(r.value.toString());return!(0,R.isNonEmptyArray)(o)}catch(r){return r.fileOperationResult===1}}getKeybindingsContentFromSyncContent(r){try{return b(r,!0,this.logService)}catch(o){return this.logService.error(o),null}}};a=he([J(0,E.IFileService),J(1,I.IEnvironmentService),J(2,m.IUserDataSyncLogService),J(3,h.IUriIdentityService)],a),e.KeybindingsInitializer=a}),define(te[225],ne([0,1,16,32,40,48,28,55,24]),function(X,e,R,L,D,k,i,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.addSetting=e.isEmpty=e.areSame=e.merge=e.updateIgnoredSettings=e.getIgnoredSettings=void 0;function C(c,u,f){let v=[];f?v=E(f):v=I(u);const T=[],O=[...(0,S.getDisallowedIgnoredSettings)()];if(Array.isArray(v))for(const U of v)U.startsWith("-")?O.push(U.substring(1)):T.push(U);return(0,R.distinct)([...c,...T].filter(U=>O.indexOf(U)===-1))}e.getIgnoredSettings=C;function I(c){let u=c.inspect("settingsSync.ignoredSettings").userValue;return u!==void 0||(u=c.inspect("sync.ignoredSettings").userValue,u!==void 0)?u:c.getValue("settingsSync.ignoredSettings")||[]}function E(c){const u=(0,L.parse)(c);return u?u["settingsSync.ignoredSettings"]||u["sync.ignoredSettings"]||[]:[]}function d(c,u,f,v){if(f.length){const T=s(u),O=(0,L.parse)(u),U=(0,L.parse)(c),W=[];for(const N of f){const A=O[N],z=U[N];A===void 0?c=P.edit(c,[N],void 0,v):z!==void 0?c=P.edit(c,[N],A,v):W.push(l(N,T))}W.sort((N,A)=>N.startOffset-A.startOffset),W.forEach(N=>c=m(N.setting.key,u,c,v))}return c}e.updateIgnoredSettings=d;function p(c,u,f,v,T,O){const U=d(c,u,v,O),W=f!==U,N=f!==u;if(!W&&!N)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(W&&!N)return{conflictsSettings:[],localContent:null,remoteContent:U,hasConflicts:!1};if(N&&!W)return{conflictsSettings:[],localContent:d(u,c,v,O),remoteContent:null,hasConflicts:!1};if(f===null&&w(c)){const H=h(c,u,v)?null:d(u,c,v,O);return{conflictsSettings:[],localContent:H,remoteContent:null,hasConflicts:!1}}let A=c,z=u;const _=(0,L.parse)(c),M=(0,L.parse)(u),q=f?(0,L.parse)(f):null,B=v.reduce((H,re)=>(H.add(re),H),new Set),j=y(_,M,B),$=y(q,_,B),K=y(q,M,B),F=new Map,x=new Set,V=H=>{x.add(H);const re=T.filter(({key:ie})=>ie===H)[0];re?(A=P.edit(A,[H],re.value,O),z=P.edit(z,[H],re.value,O)):F.set(H,{key:H,localValue:_[H],remoteValue:M[H]})};for(const H of $.removed.values())K.updated.has(H)?V(H):z=P.edit(z,[H],void 0,O);for(const H of K.removed.values())x.has(H)||($.updated.has(H)?V(H):A=P.edit(A,[H],void 0,O));for(const H of $.updated.values())x.has(H)||(K.updated.has(H)?j.updated.has(H)&&V(H):z=P.edit(z,[H],_[H],O));for(const H of K.updated.values())x.has(H)||($.updated.has(H)?j.updated.has(H)&&V(H):A=P.edit(A,[H],M[H],O));for(const H of $.added.values())x.has(H)||(K.added.has(H)?j.updated.has(H)&&V(H):z=m(H,A,z,O));for(const H of K.added.values())x.has(H)||($.added.has(H)?j.updated.has(H)&&V(H):A=m(H,z,A,O));const Q=F.size>0||!h(A,z,v),Z=Q||!h(A,c,[]),G=Q||!h(z,u,[]);return{localContent:Z?A:null,remoteContent:G?z:null,conflictsSettings:[...F.values()],hasConflicts:Q}}e.merge=p;function h(c,u,f){if(c===u)return!0;const v=(0,L.parse)(c),T=(0,L.parse)(u),O=f.reduce((N,A)=>(N.add(A),N),new Set),U=s(c).filter(N=>!(N.setting&&O.has(N.setting.key))),W=s(u).filter(N=>!(N.setting&&O.has(N.setting.key)));if(U.length!==W.length)return!1;for(let N=0;N<U.length;N++){const A=U[N],z=W[N];if(A.setting&&z.setting){if(A.setting.key!==z.setting.key||!i.equals(v[A.setting.key],T[A.setting.key]))return!1}else if(!A.setting&&!z.setting){if(A.value!==z.value)return!1}else return!1}return!0}e.areSame=h;function w(c){return c?s(c).length===0:!0}e.isEmpty=w;function y(c,u,f){const v=c?Object.keys(c).filter(N=>!f.has(N)):[],T=Object.keys(u).filter(N=>!f.has(N)),O=T.filter(N=>v.indexOf(N)===-1).reduce((N,A)=>(N.add(A),N),new Set),U=v.filter(N=>T.indexOf(N)===-1).reduce((N,A)=>(N.add(A),N),new Set),W=new Set;if(c)for(const N of v){if(U.has(N))continue;const A=c[N],z=u[N];i.equals(A,z)||W.add(N)}return{added:O,removed:U,updated:W}}function m(c,u,f,v){const T=(0,L.parse)(u),O=s(u),U=s(f),W=b(c,O,U);return g(f,c,T[c],W,U,v)}e.addSetting=m;function b(c,u,f){const v=u.findIndex(O=>O.setting?.key===c),T=u[v-1];if(T){if(T.setting){const U=l(T.setting.key,f);if(U)return{index:f.indexOf(U),insertAfter:!0}}else{const U=r(v,u);if(U){const W=l(U.setting.key,f);if(W){const N=o(f.indexOf(W),f),A=n(u,U,u[v]);if(N){const z=n(f,W,N),_=t(A,z);return _?{index:f.indexOf(_),insertAfter:!0}:{index:f.indexOf(N),insertAfter:!1}}else{const z=n(f,W,f[f.length-1]),_=t(A,z);return _?{index:f.indexOf(_),insertAfter:!0}:{index:f.length-1,insertAfter:!0}}}}}const O=u[v+1];if(O)if(O.setting){const U=l(O.setting.key,f);if(U)return{index:f.indexOf(U),insertAfter:!1}}else{const U=o(v,u);if(U){const W=l(U.setting.key,f);if(W){const N=r(f.indexOf(W),f),A=n(u,u[v],U);if(N){const z=n(f,N,W),_=t(A.reverse(),z.reverse());return _?{index:f.indexOf(_),insertAfter:!1}:{index:f.indexOf(N),insertAfter:!0}}else{const z=n(f,f[0],W),_=t(A.reverse(),z.reverse());return _?{index:f.indexOf(_),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:f.length-1,insertAfter:!0}}function g(c,u,f,v,T,O){let U;return v.index===-1?U=(0,D.setProperty)(c,[u],f,O):U=a(c,u,f,v,T,O).map(W=>(0,D.withFormatting)(c,W,O)[0]),(0,D.applyEdits)(c,U)}function a(c,u,f,v,T,O){const U=`${JSON.stringify(u)}: ${JSON.stringify(f)}`,W=(0,k.getEOL)(O,c),N=T[v.index];if(v.insertAfter){const A=[];if(N.setting)A.push({offset:N.endOffset,length:0,content:","+U});else{const z=o(v.index,T),_=r(v.index,T),M=_?.setting?.commaOffset;_&&M===void 0&&A.push({offset:_.endOffset,length:0,content:","});const q=M!==void 0&&M>N.endOffset;A.push({offset:q?M+1:N.endOffset,length:0,content:z?W+U+",":W+U})}return A}else{if(N.setting)return[{offset:N.startOffset,length:0,content:U+","}];const A=(T[v.index-1]&&!T[v.index-1].setting?W:"")+U+(o(v.index,T)?",":"")+W;return[{offset:N.startOffset,length:0,content:A}]}}function l(c,u){return u.filter(f=>f.setting?.key===c)[0]}function r(c,u){for(let f=c-1;f>=0;f--)if(u[f].setting)return u[f]}function o(c,u){for(let f=c+1;f<u.length;f++)if(u[f].setting)return u[f]}function n(c,u,f){const v=c.indexOf(u),T=c.indexOf(f);return c.filter((O,U)=>v<U&&U<T)}function t(c,u){if(c.length&&u.length){let f=0;for(;f<u.length&&f<c.length;f++)if(c[f].value!==u[f].value)return u[f-1];return u[f-1]}}function s(c){const u=[];let f=-1,v,T;const O={onObjectBegin:U=>{f++},onObjectProperty:(U,W,N)=>{f===0&&(v=W,T=U)},onObjectEnd:(U,W)=>{f--,f===0&&u.push({startOffset:v,endOffset:U+W,value:c.substring(v,U+W),setting:{key:T,commaOffset:void 0}})},onArrayBegin:(U,W)=>{f++},onArrayEnd:(U,W)=>{f--,f===0&&u.push({startOffset:v,endOffset:U+W,value:c.substring(v,U+W),setting:{key:T,commaOffset:void 0}})},onLiteralValue:(U,W,N)=>{f===0&&u.push({startOffset:v,endOffset:W+N,value:c.substring(v,W+N),setting:{key:T,commaOffset:void 0}})},onSeparator:(U,W,N)=>{if(f===0&&U===","){let A=u.length-1;for(;A>=0&&!u[A].setting;A--);const z=u[A];z&&u.splice(A,1,{startOffset:z.startOffset,endOffset:z.endOffset,value:z.value,setting:{key:z.setting.key,commaOffset:W}})}},onComment:(U,W)=>{f===0&&u.push({startOffset:U,endOffset:U+W,value:c.substring(U,U+W)})}};return(0,L.visit)(c,O),u}}),define(te[226],ne([0,1,19,3,40,146,21,88,84,11,30,14,23,22,37,47,55,225,24]),function(X,e,R,L,D,k,i,P,S,C,I,E,d,p,h,w,y,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=e.parseSettingsSyncContent=void 0;function g(n){return n&&n.settings&&typeof n.settings=="string"&&Object.keys(n).length===1}function a(n){const t=JSON.parse(n);return g(t)?t:{settings:n}}e.parseSettingsSyncContent=a;let l=class extends w.AbstractJsonFileSynchroniser{constructor(t,s,c,u,f,v,T,O,U,W,N,A,z){super(s.settingsResource,"settings",t,s,c,u,f,U,W,v,T,O,z);this.extensionManagementService=N,this.userConfigurationFileService=A,this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"settings.json"),this.localResource=this.previewResource.with({scheme:b.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:b.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:b.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._defaultIgnoredSettings=void 0}async getRemoteUserDataSyncConfiguration(t){const s=await this.getLastSyncUserData(),c=await this.getLatestRemoteUserData(t,s),u=this.getSettingsSyncContent(c),f=new P.ConfigurationModelParser(b.USER_DATA_SYNC_CONFIGURATION_SCOPE);return u?.settings&&f.parse(u.settings),f.configurationModel.getValue(b.USER_DATA_SYNC_CONFIGURATION_SCOPE)||{}}async generateSyncPreview(t,s,c){const u=await this.getLocalFileContent(),f=await this.getFormattingOptions(),v=this.getSettingsSyncContent(t);s=s===null&&c?t:s;const T=s?this.getSettingsSyncContent(s):null,O=await this.getIgnoredSettings();let U=null,W=!1,N=!1,A=!1;if(v){let _=u?u.value.toString().trim():"{}";_=_||"{}",this.validateContent(_),this.logService.trace(`${this.syncResourceLogLabel}: Merging remote settings with local settings...`);const M=(0,m.merge)(_,v.settings,T?T.settings:null,O,[],f);U=M.localContent||M.remoteContent,W=M.localContent!==null,N=M.remoteContent!==null,A=M.hasConflicts}else u&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote settings does not exist. Synchronizing settings for the first time.`),U=u.value.toString(),N=!0);const z={content:U,localChange:W?2:0,remoteChange:N?2:0,hasConflicts:A};return[{fileContent:u,localResource:this.localResource,localContent:u?u.value.toString():null,localChange:z.localChange,remoteResource:this.remoteResource,remoteContent:v?v.settings:null,remoteChange:z.remoteChange,previewResource:this.previewResource,previewResult:z,acceptedResource:this.acceptedResource}]}async getMergeResult(t,s){const c=await this.getFormattingOptions(),u=await this.getIgnoredSettings();return{...t.previewResult,content:t.previewResult.content?(0,m.updateIgnoredSettings)(t.previewResult.content,"{}",u,c):null}}async getAcceptResult(t,s,c,u){const f=await this.getFormattingOptions(),v=await this.getIgnoredSettings();if(this.extUri.isEqual(s,this.localResource))return{content:t.fileContent?(0,m.updateIgnoredSettings)(t.fileContent.value.toString(),"{}",v,f):null,localChange:0,remoteChange:2};if(this.extUri.isEqual(s,this.remoteResource))return{content:t.remoteContent!==null?(0,m.updateIgnoredSettings)(t.remoteContent,t.fileContent?t.fileContent.value.toString():"{}",v,f):null,localChange:2,remoteChange:0};if(this.extUri.isEqual(s,this.previewResource))return c===void 0?{content:t.previewResult.content,localChange:t.previewResult.localChange,remoteChange:t.previewResult.remoteChange}:{content:c!==null?(0,m.updateIgnoredSettings)(c,t.fileContent?t.fileContent.value.toString():"{}",v,f):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${s.toString()}`)}async applyResult(t,s,c,u){const{fileContent:f}=c[0][0];let{content:v,localChange:T,remoteChange:O}=c[0][1];if(T===0&&O===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing settings.`),v=v?v.trim():"{}",v=v||"{}",this.validateContent(v),T!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local settings...`),f&&await this.backupLocal(JSON.stringify(this.toSettingsSyncContent(f.value.toString()))),await this.updateLocalFileContent(v,f,u),await this.configurationService.reloadConfiguration(2),this.logService.info(`${this.syncResourceLogLabel}: Updated local settings`)),O!==0){const U=await this.getFormattingOptions(),W=this.getSettingsSyncContent(t),N=await this.getIgnoredSettings(v);v=(0,m.updateIgnoredSettings)(v,W?W.settings:"{}",N,U),this.logService.trace(`${this.syncResourceLogLabel}: Updating remote settings...`),t=await this.updateRemoteUserData(JSON.stringify(this.toSettingsSyncContent(v)),u?null:t.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote settings`)}try{await this.fileService.del(this.previewResource)}catch(U){}s?.ref!==t.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized settings...`),await this.updateLastSyncUserData(t),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized settings`))}async hasLocalData(){try{const t=await this.getLocalFileContent();if(t){const s=await this.getFormattingOptions(),c=(0,y.edit)(t.value.toString(),[b.CONFIGURATION_SYNC_STORE_KEY],void 0,s);return!(0,m.isEmpty)(c)}}catch(t){if(t.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:t}){const s=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(t,"settings.json"),comparableResource:s}]}async resolveContent(t){if(this.extUri.isEqual(this.remoteResource,t)||this.extUri.isEqual(this.localResource,t)||this.extUri.isEqual(this.acceptedResource,t))return this.resolvePreviewContent(t);let s=await super.resolveContent(t);if(s)return s;if(s=await super.resolveContent(this.extUri.dirname(t)),s){const c=this.parseSyncData(s);if(c){const u=this.parseSettingsSyncContent(c.content);if(u)switch(this.extUri.basename(t)){case"settings.json":return u.settings}}}return null}async resolvePreviewContent(t){let s=await super.resolvePreviewContent(t);if(s){const c=await this.getFormattingOptions(),u=await this.getIgnoredSettings();s=(0,m.updateIgnoredSettings)(s,"{}",u,c)}return s}getSettingsSyncContent(t){return t.syncData?this.parseSettingsSyncContent(t.syncData.content):null}parseSettingsSyncContent(t){try{return a(t)}catch(s){this.logService.error(s)}return null}toSettingsSyncContent(t){return{settings:t}}async getIgnoredSettings(t){if(!this._defaultIgnoredSettings){this._defaultIgnoredSettings=this.userDataSyncUtilService.resolveDefaultIgnoredSettings();const c=L.Event.any(L.Event.filter(this.extensionManagementService.onDidInstallExtensions,u=>u.some(({local:f})=>!!f)),L.Event.filter(this.extensionManagementService.onDidUninstallExtension,u=>!u.error))(()=>{c.dispose(),this._defaultIgnoredSettings=void 0})}const s=await this._defaultIgnoredSettings;return(0,m.getIgnoredSettings)(s,this.configurationService,t)}async writeFileContent(t,s,c){await this.userConfigurationFileService.write(R.VSBuffer.fromString(t),c?void 0:{etag:s.etag,mtime:s.mtime})}validateContent(t){if(this.hasErrors(t))throw new b.UserDataSyncError((0,k.localize)(0,null),"LocalInvalidContent",this.resource)}async recoverSettings(){try{const t=await this.getLocalFileContent();if(!t)return;const s=JSON.parse(t.value.toString());if(!o(s))return;this.telemetryService.publicLog2("sync/settingsCorrupted");const c=this.parseSettingsSyncContent(s.content);if(!c||!c.settings)return;let u=c.settings;const f=await this.getFormattingOptions();for(const v in s)if(["version","content","machineId"].indexOf(v)===-1&&s[v]!==void 0){const T=(0,D.setProperty)(u,[v],s[v],f);T.length&&(u=(0,D.applyEdits)(u,T))}await this.fileService.writeFile(this.file,R.VSBuffer.fromString(u))}catch(t){}}};l=he([J(0,E.IFileService),J(1,C.IEnvironmentService),J(2,d.IStorageService),J(3,b.IUserDataSyncStoreService),J(4,b.IUserDataSyncBackupStoreService),J(5,b.IUserDataSyncLogService),J(6,b.IUserDataSyncUtilService),J(7,i.IConfigurationService),J(8,b.IUserDataSyncResourceEnablementService),J(9,p.ITelemetryService),J(10,I.IExtensionManagementService),J(11,S.IUserConfigurationFileService),J(12,h.IUriIdentityService)],l),e.SettingsSynchroniser=l;let r=class extends w.AbstractInitializer{constructor(t,s,c,u){super("settings",s,c,t,u)}async doInitialize(t){const s=t.syncData?this.parseSettingsSyncContent(t.syncData.content):null;if(!s){this.logService.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing settings because local settings exist.");return}await this.fileService.writeFile(this.environmentService.settingsResource,R.VSBuffer.fromString(s.settings)),await this.updateLastSyncUserData(t)}async isEmpty(){try{const t=await this.fileService.readFile(this.environmentService.settingsResource);return(0,m.isEmpty)(t.value.toString().trim())}catch(t){return t.fileOperationResult===1}}parseSettingsSyncContent(t){try{return a(t)}catch(s){this.logService.error(s)}return null}};r=he([J(0,E.IFileService),J(1,C.IEnvironmentService),J(2,b.IUserDataSyncLogService),J(3,h.IUriIdentityService)],r),e.SettingsInitializer=r;function o(n){return!!(n&&n.version!==void 0&&typeof n.version=="number"&&n.content!==void 0&&typeof n.content=="string"&&n.machineId!==void 0&&typeof n.machineId=="string")}}),define(te[227],ne([0,1,19,3,28,21,11,14,23,22,37,47,220,24]),function(X,e,R,L,D,k,i,P,S,C,I,E,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=void 0;let h=class extends E.AbstractSynchroniser{constructor(m,b,g,a,l,r,o,n,t,s){super("snippets",b,m,g,a,l,n,t,r,o,s);this.version=1,this.snippetsFolder=m.snippetsHome,this._register(this.fileService.watch(m.userRoamingDataHome)),this._register(this.fileService.watch(this.snippetsFolder)),this._register(L.Event.filter(this.fileService.onDidFilesChange,c=>c.affects(this.snippetsFolder))(()=>this.triggerLocalChange()))}async generateSyncPreview(m,b,g){const a=await this.getSnippetsFileContents(),l=this.toSnippetsContents(a),r=m.syncData?this.parseSnippets(m.syncData):null;b=b===null&&g?m:b;const o=b&&b.syncData?this.parseSnippets(b.syncData):null;r?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote snippets with local snippets...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const n=(0,d.merge)(l,r,o);return this.getResourcePreviews(n,a,r||{})}async getMergeResult(m,b){return m.previewResult}async getAcceptResult(m,b,g,a){if(this.extUri.isEqualOrParent(b,this.syncPreviewFolder.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:m.fileContent?m.fileContent.value.toString():null,localChange:0,remoteChange:m.fileContent?m.remoteContent!==null?2:1:3};if(this.extUri.isEqualOrParent(b,this.syncPreviewFolder.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:m.remoteContent,localChange:m.remoteContent!==null?m.fileContent?2:1:3,remoteChange:0};if(this.extUri.isEqualOrParent(b,this.syncPreviewFolder))return g===void 0?{content:m.previewResult.content,localChange:m.previewResult.localChange,remoteChange:m.previewResult.remoteChange}:{content:g,localChange:g===null?m.fileContent!==null?3:0:2,remoteChange:g===null?m.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${b.toString()}`)}async applyResult(m,b,g,a){const l=g.map(([r,o])=>({...r,acceptResult:o}));l.every(({localChange:r,remoteChange:o})=>r===0&&o===0)&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing snippets.`),l.some(({localChange:r})=>r!==0)&&(await this.updateLocalBackup(l),await this.updateLocalSnippets(l,a)),l.some(({remoteChange:r})=>r!==0)&&(m=await this.updateRemoteSnippets(l,m,a)),b?.ref!==m.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized snippets...`),await this.updateLastSyncUserData(m),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized snippets`));for(const{previewResource:r}of l)try{await this.fileService.del(r)}catch(o){}}getResourcePreviews(m,b,g){const a=new Map;for(const l of Object.keys(m.local.added)){const r={content:m.local.added[l],hasConflicts:!1,localChange:1,remoteChange:0};a.set(l,{fileContent:null,localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:g[l],previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of Object.keys(m.local.updated)){const r={content:m.local.updated[l],hasConflicts:!1,localChange:2,remoteChange:0};a.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:b[l],localContent:b[l].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:g[l],previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of m.local.removed){const r={content:null,hasConflicts:!1,localChange:3,remoteChange:0};a.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:b[l],localContent:b[l].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of Object.keys(m.remote.added)){const r={content:m.remote.added[l],hasConflicts:!1,localChange:0,remoteChange:1};a.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:b[l],localContent:b[l].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of Object.keys(m.remote.updated)){const r={content:m.remote.updated[l],hasConflicts:!1,localChange:0,remoteChange:2};a.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:b[l],localContent:b[l].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:g[l],previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of m.remote.removed){const r={content:null,hasConflicts:!1,localChange:0,remoteChange:3};a.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:g[l],previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of m.conflicts){const r={content:b[l]?b[l].value.toString():null,hasConflicts:!0,localChange:b[l]?2:1,remoteChange:g[l]?2:1};a.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:b[l]||null,localContent:b[l]?b[l].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:g[l]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of Object.keys(b))if(!a.has(l)){const r={content:b[l]?b[l].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0};a.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:b[l]||null,localContent:b[l]?b[l].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:g[l]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...a.values()]}async getAssociatedResources({uri:m}){let b=await super.resolveContent(m);if(b){const g=this.parseSyncData(b);if(g){const a=this.parseSnippets(g),l=[];for(const r of Object.keys(a)){const o=this.extUri.joinPath(m,r),n=this.extUri.joinPath(this.snippetsFolder,r),t=await this.fileService.exists(n);l.push({resource:o,comparableResource:t?n:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"})})}return l}}return[]}async resolveContent(m){if(this.extUri.isEqualOrParent(m,this.syncPreviewFolder.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.extUri.isEqualOrParent(m,this.syncPreviewFolder.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.extUri.isEqualOrParent(m,this.syncPreviewFolder.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})))return this.resolvePreviewContent(m);let b=await super.resolveContent(m);if(b)return b;if(b=await super.resolveContent(this.extUri.dirname(m)),b){const g=this.parseSyncData(b);if(g)return this.parseSnippets(g)[this.extUri.basename(m)]||null}return null}async hasLocalData(){try{const m=await this.getSnippetsFileContents();if(Object.keys(m).length)return!0}catch(m){}return!1}async updateLocalBackup(m){const b={};for(const g of m)g.fileContent&&(b[this.extUri.basename(g.localResource)]=g.fileContent);await this.backupLocal(JSON.stringify(this.toSnippetsContents(b)))}async updateLocalSnippets(m,b){for(const{fileContent:g,acceptResult:a,localResource:l,remoteResource:r,localChange:o}of m)if(o!==0){const n=r?this.extUri.basename(r):this.extUri.basename(l),t=this.extUri.joinPath(this.snippetsFolder,n);o===3?(this.logService.trace(`${this.syncResourceLogLabel}: Deleting snippet...`,this.extUri.basename(t)),await this.fileService.del(t),this.logService.info(`${this.syncResourceLogLabel}: Deleted snippet`,this.extUri.basename(t))):o===1?(this.logService.trace(`${this.syncResourceLogLabel}: Creating snippet...`,this.extUri.basename(t)),await this.fileService.createFile(t,R.VSBuffer.fromString(a.content),{overwrite:b}),this.logService.info(`${this.syncResourceLogLabel}: Created snippet`,this.extUri.basename(t))):(this.logService.trace(`${this.syncResourceLogLabel}: Updating snippet...`,this.extUri.basename(t)),await this.fileService.writeFile(t,R.VSBuffer.fromString(a.content),b?void 0:g),this.logService.info(`${this.syncResourceLogLabel}: Updated snippet`,this.extUri.basename(t)))}}async updateRemoteSnippets(m,b,g){const a=b.syncData?this.parseSnippets(b.syncData):{},l=(0,D.deepClone)(a);for(const{acceptResult:r,localResource:o,remoteResource:n,remoteChange:t}of m)if(t!==0){const s=o?this.extUri.basename(o):this.extUri.basename(n);t===3?delete l[s]:l[s]=r.content}return(0,d.areSame)(a,l)||(this.logService.trace(`${this.syncResourceLogLabel}: Updating remote snippets...`),b=await this.updateRemoteUserData(JSON.stringify(l),g?null:b.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote snippets`)),b}parseSnippets(m){return JSON.parse(m.content)}toSnippetsContents(m){const b={};for(const g of Object.keys(m))b[g]=m[g].value.toString();return b}async getSnippetsFileContents(){const m={};let b;try{b=await this.fileService.resolve(this.snippetsFolder)}catch(g){if(g instanceof P.FileOperationError&&g.fileOperationResult===1)return m;throw g}for(const g of b.children||[]){const a=g.resource,l=this.extUri.extname(a);if(l===".json"||l===".code-snippets"){const r=this.extUri.relativePath(this.snippetsFolder,a),o=await this.fileService.readFile(a);m[r]=o}}return m}};h=he([J(0,i.IEnvironmentService),J(1,P.IFileService),J(2,S.IStorageService),J(3,p.IUserDataSyncStoreService),J(4,p.IUserDataSyncBackupStoreService),J(5,p.IUserDataSyncLogService),J(6,k.IConfigurationService),J(7,p.IUserDataSyncResourceEnablementService),J(8,C.ITelemetryService),J(9,I.IUriIdentityService)],h),e.SnippetsSynchroniser=h;let w=class extends E.AbstractInitializer{constructor(m,b,g,a){super("snippets",b,g,m,a)}async doInitialize(m){const b=m.syncData?JSON.parse(m.syncData.content):null;if(!b){this.logService.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing snippets because local snippets exist.");return}for(const a of Object.keys(b)){const l=b[a];if(l){const r=this.extUri.joinPath(this.environmentService.snippetsHome,a);await this.fileService.createFile(r,R.VSBuffer.fromString(l)),this.logService.info("Created snippet",this.extUri.basename(r))}}await this.updateLastSyncUserData(m)}async isEmpty(){try{return!(await this.fileService.resolve(this.environmentService.snippetsHome)).children?.length}catch(m){return m.fileOperationResult===1}}};w=he([J(0,P.IFileService),J(1,i.IEnvironmentService),J(2,p.IUserDataSyncLogService),J(3,I.IUriIdentityService)],w),e.SnippetsInitializer=w}),define(te[63],ne([0,1,3,2,6,24]),function(X,e,R,L,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=(0,D.createDecorator)("IUserDataSyncAccountService");let i=class extends L.Disposable{constructor(S,C){super();this.userDataSyncStoreService=S,this.logService=C,this._onDidChangeAccount=this._register(new R.Emitter),this.onDidChangeAccount=this._onDidChangeAccount.event,this._onTokenFailed=this._register(new R.Emitter),this.onTokenFailed=this._onTokenFailed.event,this.wasTokenFailed=!1,this._register(S.onTokenFailed(()=>{this.logService.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.wasTokenFailed),this.updateAccount(void 0),this._onTokenFailed.fire(this.wasTokenFailed),this.wasTokenFailed=!0})),this._register(S.onTokenSucceed(()=>this.wasTokenFailed=!1))}get account(){return this._account}async updateAccount(S){(S&&this._account?S.token!==this._account.token||S.authenticationProviderId!==this._account.authenticationProviderId:S!==this._account)&&(this._account=S,this._account&&this.userDataSyncStoreService.setAuthToken(this._account.token,this._account.authenticationProviderId),this._onDidChangeAccount.fire(S))}};i=he([J(0,k.IUserDataSyncStoreService),J(1,k.IUserDataSyncLogService)],i),e.UserDataSyncAccountService=i}),define(te[228],ne([0,1,5,19,58,2,18,21,11,14,24]),function(X,e,R,L,D,k,i,P,S,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncBackupStoreService=void 0;let E=class extends k.Disposable{constructor(p,h,w,y){super();this.environmentService=p,this.fileService=h,this.configurationService=w,this.logService=y,I.ALL_SYNC_RESOURCES.forEach(m=>this.cleanUpBackup(m))}async getAllRefs(p){const h=(0,i.joinPath)(this.environmentService.userDataSyncHome,p),w=await this.fileService.resolve(h);return w.children?w.children.filter(m=>m.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(m.name)).sort().reverse().map(m=>({ref:m.name,created:this.getCreationTime(m)})):[]}async resolveContent(p,h){if(!h){const w=await this.getAllRefs(p);w.length&&(h=w[w.length-1].ref)}if(h){const w=(0,i.joinPath)(this.environmentService.userDataSyncHome,p,h);return(await this.fileService.readFile(w)).value.toString()}return null}async backup(p,h){const w=(0,i.joinPath)(this.environmentService.userDataSyncHome,p),y=(0,i.joinPath)(w,`${(0,D.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.fileService.writeFile(y,L.VSBuffer.fromString(h))}catch(m){this.logService.error(m)}try{this.cleanUpBackup(p)}catch(m){}}async cleanUpBackup(p){const h=(0,i.joinPath)(this.environmentService.userDataSyncHome,p);try{try{if(!await this.fileService.exists(h))return}catch(y){return}const w=await this.fileService.resolve(h);if(w.children){const y=w.children.filter(a=>a.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(a.name)).sort(),m=1e3*60*60*24*(this.configurationService.getValue("sync.localBackupDuration")||30);let b=y.filter(a=>Date.now()-this.getCreationTime(a)>m);const g=y.length-b.length;g<10&&(b=b.slice(10-g)),await R.Promises.settled(b.map(async a=>{this.logService.info("Deleting from backup",a.resource.path),await this.fileService.del(a.resource)}))}}catch(w){this.logService.error(w)}}getCreationTime(p){return p.ctime||new Date(parseInt(p.name.substring(0,4)),parseInt(p.name.substring(4,6))-1,parseInt(p.name.substring(6,8)),parseInt(p.name.substring(9,11)),parseInt(p.name.substring(11,13)),parseInt(p.name.substring(13,15))).getTime()}};E=he([J(0,S.IEnvironmentService),J(1,C.IFileService),J(2,P.IConfigurationService),J(3,I.IUserDataSyncLogService)],E),e.UserDataSyncBackupStoreService=E}),define(te[229],ne([0,1,2,7]),function(X,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannel=e.UserDataSyncMachinesServiceChannel=e.UserDataSyncUtilServiceClient=e.UserDataSycnUtilServiceChannel=e.UserDataAutoSyncChannel=void 0;class D{constructor(d){this.service=d}listen(d,p){switch(p){case"onError":return this.service.onError}throw new Error(`Event not found: ${p}`)}call(d,p,h){switch(p){case"triggerSync":return this.service.triggerSync(h[0],h[1],h[2]);case"turnOn":return this.service.turnOn();case"turnOff":return this.service.turnOff(h[0])}throw new Error("Invalid call")}}e.UserDataAutoSyncChannel=D;class k{constructor(d){this.service=d}listen(d,p){throw new Error(`Event not found: ${p}`)}call(d,p,h){switch(p){case"resolveDefaultIgnoredSettings":return this.service.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.service.resolveUserBindings(h[0]);case"resolveFormattingOptions":return this.service.resolveFormattingOptions(L.URI.revive(h[0]))}throw new Error("Invalid call")}}e.UserDataSycnUtilServiceChannel=k;class i{constructor(d){this.channel=d}async resolveDefaultIgnoredSettings(){return this.channel.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(d){return this.channel.call("resolveUserKeybindings",[d])}async resolveFormattingOptions(d){return this.channel.call("resolveFormattingOptions",[d])}}e.UserDataSyncUtilServiceClient=i;class P{constructor(d){this.service=d}listen(d,p){switch(p){case"onDidChange":return this.service.onDidChange}throw new Error(`Event not found: ${p}`)}async call(d,p,h){switch(p){case"getMachines":return this.service.getMachines();case"addCurrentMachine":return this.service.addCurrentMachine();case"removeCurrentMachine":return this.service.removeCurrentMachine();case"renameMachine":return this.service.renameMachine(h[0],h[1]);case"setEnablement":return this.service.setEnablement(h[0],h[1])}throw new Error("Invalid call")}}e.UserDataSyncMachinesServiceChannel=P;class S{constructor(d){this.service=d}listen(d,p){switch(p){case"onDidChangeAccount":return this.service.onDidChangeAccount;case"onTokenFailed":return this.service.onTokenFailed}throw new Error(`Event not found: ${p}`)}call(d,p,h){switch(p){case"_getInitialData":return Promise.resolve(this.service.account);case"updateAccount":return this.service.updateAccount(h)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=S;class C{constructor(d){this.service=d}listen(d,p){switch(p){case"onDidChangeUserDataSyncStore":return this.service.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${p}`)}call(d,p,h){switch(p){case"switch":return this.service.switch(h[0]);case"getPreviousUserDataSyncStore":return this.service.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=C;class I extends R.Disposable{constructor(d){super();this.channel=d,this.onDidChangeUserDataSyncStore=this.channel.listen("onDidChangeUserDataSyncStore")}async switch(d){return this.channel.call("switch",[d])}async getPreviousUserDataSyncStore(){const d=await this.channel.call("getPreviousUserDataSyncStore");return this.revive(d)}revive(d){return{url:L.URI.revive(d.url),type:d.type,defaultUrl:L.URI.revive(d.defaultUrl),insidersUrl:L.URI.revive(d.insidersUrl),stableUrl:L.URI.revive(d.stableUrl),canSwitch:d.canSwitch,authenticationProviders:d.authenticationProviders}}}e.UserDataSyncStoreManagementServiceChannelClient=I}),define(te[230],ne([0,1,11,8]),function(X,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let D=class extends L.AbstractLogger{constructor(i,P){super();this.logger=this._register(i.createLogger(P.userDataSyncLogResource,{name:"settingssync"}))}trace(i,...P){this.logger.trace(i,...P)}debug(i,...P){this.logger.debug(i,...P)}info(i,...P){this.logger.info(i,...P)}warn(i,...P){this.logger.warn(i,...P)}error(i,...P){this.logger.error(i,...P)}critical(i,...P){this.logger.critical(i,...P)}flush(){this.logger.flush()}};D=he([J(0,L.ILoggerService),J(1,R.IEnvironmentService)],D),e.UserDataSyncLogService=D}),define(te[64],ne([0,1,3,2,4,25,149,11,14,6,26,46,23,24]),function(X,e,R,L,D,k,i,P,S,C,I,E,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.IUserDataSyncMachinesService=void 0,e.IUserDataSyncMachinesService=(0,C.createDecorator)("IUserDataSyncMachinesService");const h="sync.currentMachineName";let w=class et extends L.Disposable{constructor(m,b,g,a,l,r){super();this.storageService=g,this.userDataSyncStoreService=a,this.logService=l,this.productService=r,this._onDidChange=this._register(new R.Emitter),this.onDidChange=this._onDidChange.event,this.userData=null,this.currentMachineIdPromise=(0,E.getServiceMachineId)(m,b,g)}async getMachines(m){const b=await this.currentMachineIdPromise;return(await this.readMachinesData(m)).machines.map(a=>({...a,isCurrent:a.id===b}))}async addCurrentMachine(m){const b=await this.currentMachineIdPromise,g=await this.readMachinesData(m);g.machines.some(({id:a})=>a===b)||(g.machines.push({id:b,name:this.computeCurrentMachineName(g.machines)}),await this.writeMachinesData(g))}async removeCurrentMachine(m){const b=await this.currentMachineIdPromise,g=await this.readMachinesData(m),a=g.machines.filter(({id:l})=>l!==b);a.length!==g.machines.length&&(g.machines=a,await this.writeMachinesData(g))}async renameMachine(m,b,g){const a=await this.currentMachineIdPromise,l=await this.readMachinesData(g),r=l.machines.find(({id:o})=>o===m);r&&(r.name=b,await this.writeMachinesData(l),l.machines.some(({id:o})=>o===a)&&this.storageService.store(h,b,0,1))}async setEnablement(m,b){const g=await this.readMachinesData(),a=g.machines.find(({id:l})=>l===m);a&&(a.disabled=b?void 0:!0,await this.writeMachinesData(g))}computeCurrentMachineName(m){const b=this.storageService.get(h,0);if(b)return b;const g=`${this.productService.nameLong} (${(0,D.PlatformToString)(D.isWeb?0:D.platform)})`,a=new RegExp(`${(0,k.escapeRegExpCharacters)(g)}\\s#(\\d+)`);let l=0;for(const r of m){const o=a.exec(r.name),n=o?parseInt(o[1]):0;l=n>l?n:l}return`${g} #${l+1}`}async readMachinesData(m){this.userData=await this.readUserData(m);const b=this.parse(this.userData);if(b.version!==et.VERSION)throw new Error((0,i.localize)(0,null,this.productService.nameLong));return b}async writeMachinesData(m){const b=JSON.stringify(m),g=await this.userDataSyncStoreService.write(et.RESOURCE,b,this.userData?.ref||null);this.userData={ref:g,content:b},this._onDidChange.fire()}async readUserData(m){if(this.userData){const b=m&&m.latest?m.latest[et.RESOURCE]:void 0;if(this.userData.ref===b)return this.userData;if(b===void 0&&this.userData.content===null)return this.userData}return this.userDataSyncStoreService.read(et.RESOURCE,this.userData)}parse(m){if(m.content!==null)try{return JSON.parse(m.content)}catch(b){this.logService.error(b)}return{version:et.VERSION,machines:[]}}};w.VERSION=1,w.RESOURCE="machines",w=he([J(0,P.IEnvironmentService),J(1,S.IFileService),J(2,d.IStorageService),J(3,p.IUserDataSyncStoreService),J(4,p.IUserDataSyncLogService),J(5,I.IProductService)],w),e.UserDataSyncMachinesService=w}),define(te[99],ne([0,1,5,58,38,9,3,2,4,18,7,147,11,26,23,22,24,63,64]),function(X,e,R,L,D,k,i,P,S,C,I,E,d,p,h,w,y,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=e.UserDataAutoSyncEnablementService=void 0;const g="sync.enable",a="sync.disableMachineEventually",l="sync.sessionId",r="sync.storeUrl",o="sync.productQuality";let n=class extends P.Disposable{constructor(u,f,v){super();this.storageService=u,this.environmentService=f,this.userDataSyncStoreManagementService=v,this._onDidChangeEnablement=new i.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this._register(u.onDidChangeValue(T=>this.onDidStorageChange(T)))}isEnabled(){switch(this.environmentService.sync){case"on":return!0;case"off":return!1}return this.storageService.getBoolean(g,0,!1)}canToggleEnablement(){return this.userDataSyncStoreManagementService.userDataSyncStore!==void 0&&this.environmentService.sync===void 0}setEnablement(u){u&&!this.canToggleEnablement()||this.storageService.store(g,u,0,1)}onDidStorageChange(u){if(u.scope===0&&g===u.key){this._onDidChangeEnablement.fire(this.isEnabled());return}}};n=he([J(0,h.IStorageService),J(1,d.IEnvironmentService),J(2,y.IUserDataSyncStoreManagementService)],n),e.UserDataAutoSyncEnablementService=n;let t=class extends P.Disposable{constructor(u,f,v,T,O,U,W,N,A,z,_){super();this.userDataSyncStoreManagementService=f,this.userDataSyncStoreService=v,this.userDataSyncResourceEnablementService=T,this.userDataSyncService=O,this.logService=U,this.userDataSyncAccountService=W,this.telemetryService=N,this.userDataSyncMachinesService=A,this.storageService=z,this.autoSync=this._register(new P.MutableDisposable),this.successiveFailures=0,this.lastSyncTriggerTime=void 0,this._onError=this._register(new i.Emitter),this.onError=this._onError.event,this.sources=[],this.userDataAutoSyncEnablementService=_,this.syncTriggerDelayer=this._register(new R.Delayer(0)),this.lastSyncUrl=this.syncUrl,this.syncUrl=f.userDataSyncStore?.url,this.previousProductQuality=this.productQuality,this.productQuality=u.quality,this.syncUrl&&(this.logService.info("Using settings sync service",this.syncUrl.toString()),this._register(f.onDidChangeUserDataSyncStore(()=>{(0,C.isEqual)(this.syncUrl,f.userDataSyncStore?.url)||(this.lastSyncUrl=this.syncUrl,this.syncUrl=f.userDataSyncStore?.url,this.syncUrl&&this.logService.info("Using settings sync service",this.syncUrl.toString()))})),this.userDataAutoSyncEnablementService.isEnabled()?this.logService.info("Auto Sync is enabled."):this.logService.info("Auto Sync is disabled."),this.updateAutoSync(),this.hasToDisableMachineEventually()&&this.disableMachineEventually(),this._register(W.onDidChangeAccount(()=>this.updateAutoSync())),this._register(v.onDidChangeDonotMakeRequestsUntil(()=>this.updateAutoSync())),this._register(i.Event.debounce(O.onDidChangeLocal,(M,q)=>M?[...M,q]:[q],1e3)(M=>this.triggerSync(M,!1,!1))),this._register(i.Event.filter(this.userDataSyncResourceEnablementService.onDidChangeResourceEnablement,([,M])=>M)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this._register(this.userDataSyncStoreManagementService.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}get syncUrl(){const u=this.storageService.get(r,0);return u?I.URI.parse(u):void 0}set syncUrl(u){u?this.storageService.store(r,u.toString(),0,1):this.storageService.remove(r,0)}get productQuality(){return this.storageService.get(o,0)}set productQuality(u){u?this.storageService.store(o,u,0,1):this.storageService.remove(o,0)}updateAutoSync(){const{enabled:u,message:f}=this.isAutoSyncEnabled();u?this.autoSync.value===void 0&&(this.autoSync.value=new s(this.lastSyncUrl,1e3*60*5,this.userDataSyncStoreManagementService,this.userDataSyncStoreService,this.userDataSyncService,this.userDataSyncMachinesService,this.logService,this.storageService),this.autoSync.value.register(this.autoSync.value.onDidStartSync(()=>this.lastSyncTriggerTime=new Date().getTime())),this.autoSync.value.register(this.autoSync.value.onDidFinishSync(v=>this.onDidFinishSync(v))),this.startAutoSync()&&this.autoSync.value.start()):(this.syncTriggerDelayer.cancel(),this.autoSync.value!==void 0?(f&&this.logService.info(f),this.autoSync.clear()):f&&this.userDataAutoSyncEnablementService.isEnabled()&&this.logService.info(f))}startAutoSync(){return!0}isAutoSyncEnabled(){return this.userDataAutoSyncEnablementService.isEnabled()?this.userDataSyncAccountService.account?this.userDataSyncStoreService.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,L.toLocalISOString)(this.userDataSyncStoreService.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.stopDisableMachineEventually(),this.lastSyncUrl=this.syncUrl,this.updateEnablement(!0)}async turnOff(u,f,v){try{this.userDataSyncAccountService.account&&!v&&await this.userDataSyncMachinesService.removeCurrentMachine(),this.updateEnablement(!1),this.storageService.remove(l,0),u?(this.telemetryService.publicLog2("sync/turnOffEveryWhere"),await this.userDataSyncService.reset()):await this.userDataSyncService.resetLocal()}catch(T){if(f)this.logService.error(T),this.updateEnablement(!1);else throw T}}updateEnablement(u){this.userDataAutoSyncEnablementService.isEnabled()!==u&&(this.telemetryService.publicLog2(g,{enabled:u}),this.userDataAutoSyncEnablementService.setEnablement(u),this.updateAutoSync())}hasProductQualityChanged(){return!!this.previousProductQuality&&!!this.productQuality&&this.previousProductQuality!==this.productQuality}async onDidFinishSync(u){if(!u){this.successiveFailures=0;return}const f=y.UserDataSyncError.toUserDataSyncError(u);f instanceof y.UserDataAutoSyncError&&this.telemetryService.publicLog2("autosync/error",{code:f.code,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()}),f.code==="SessionExpired"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current session is expired")):f.code==="TurnedOff"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):f.code==="LocalTooManyRequests"||f.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because of making too many requests to server")):f.code==="UpgradeRequired"||f.code==="Gone"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):f.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${f.resource} content with newer version than of client. Requires client upgrade.`)):f.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${f.resource} content with older version than of client. Requires server reset.`)):f.code==="ServiceChanged"||f.code==="DefaultServiceChanged"?S.isWeb&&f.code==="DefaultServiceChanged"&&!this.hasProductQualityChanged()?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.logService.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.logService.error(f),this.successiveFailures++),this._onError.fire(f)}async disableMachineEventually(){this.storageService.store(a,!0,0,1),await(0,R.timeout)(1e3*60*10),!!this.hasToDisableMachineEventually()&&(this.stopDisableMachineEventually(),!this.userDataAutoSyncEnablementService.isEnabled()&&this.userDataSyncAccountService.account&&await this.userDataSyncMachinesService.removeCurrentMachine())}hasToDisableMachineEventually(){return this.storageService.getBoolean(a,0,!1)}stopDisableMachineEventually(){this.storageService.remove(a,0)}async triggerSync(u,f,v){if(this.autoSync.value===void 0)return this.syncTriggerDelayer.cancel();if(f&&this.lastSyncTriggerTime&&Math.round((new Date().getTime()-this.lastSyncTriggerTime)/1e3)<10){this.logService.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.sources.push(...u),this.syncTriggerDelayer.trigger(async()=>{this.logService.trace("activity sources",...this.sources),this.telemetryService.publicLog2("sync/triggered",{sources:this.sources}),this.sources=[],this.autoSync.value&&await this.autoSync.value.sync("Activity",v)},this.successiveFailures?this.getSyncTriggerDelayTime()*1*Math.min(Math.pow(2,this.successiveFailures),60):this.getSyncTriggerDelayTime())}getSyncTriggerDelayTime(){return 1e3}};t=he([J(0,p.IProductService),J(1,y.IUserDataSyncStoreManagementService),J(2,y.IUserDataSyncStoreService),J(3,y.IUserDataSyncResourceEnablementService),J(4,y.IUserDataSyncService),J(5,y.IUserDataSyncLogService),J(6,m.IUserDataSyncAccountService),J(7,w.ITelemetryService),J(8,b.IUserDataSyncMachinesService),J(9,h.IStorageService),J(10,y.IUserDataAutoSyncEnablementService)],t),e.UserDataAutoSyncService=t;class s extends P.Disposable{constructor(u,f,v,T,O,U,W,N){super();this.lastSyncUrl=u,this.interval=f,this.userDataSyncStoreManagementService=v,this.userDataSyncStoreService=T,this.userDataSyncService=O,this.userDataSyncMachinesService=U,this.logService=W,this.storageService=N,this.intervalHandler=this._register(new P.MutableDisposable),this._onDidStartSync=this._register(new i.Emitter),this.onDidStartSync=this._onDidStartSync.event,this._onDidFinishSync=this._register(new i.Emitter),this.onDidFinishSync=this._onDidFinishSync.event,this.manifest=null}start(){this._register(this.onDidFinishSync(()=>this.waitUntilNextIntervalAndSync())),this._register((0,P.toDisposable)(()=>{this.syncPromise&&(this.syncPromise.cancel(),this.logService.info("Auto sync: Cancelled sync that is in progress"),this.syncPromise=void 0),this.syncTask&&this.syncTask.stop(),this.logService.info("Auto Sync: Stopped")})),this.logService.info("Auto Sync: Started"),this.sync(s.INTERVAL_SYNCING,!1)}waitUntilNextIntervalAndSync(){this.intervalHandler.value=(0,R.disposableTimeout)(()=>this.sync(s.INTERVAL_SYNCING,!1),this.interval)}sync(u,f){const v=(0,R.createCancelablePromise)(async T=>{if(this.syncPromise)try{this.logService.debug("Auto Sync: Waiting until sync is finished."),await this.syncPromise}catch(O){if((0,k.isPromiseCanceledError)(O))return}return this.doSync(u,f,T)});return this.syncPromise=v,this.syncPromise.finally(()=>this.syncPromise=void 0),this.syncPromise}hasSyncServiceChanged(){return this.lastSyncUrl!==void 0&&!(0,C.isEqual)(this.lastSyncUrl,this.userDataSyncStoreManagementService.userDataSyncStore?.url)}async hasDefaultServiceChanged(){const u=await this.userDataSyncStoreManagementService.getPreviousUserDataSyncStore(),f=this.userDataSyncStoreManagementService.userDataSyncStore;return!!f&&!!u&&(!(0,C.isEqual)(f.defaultUrl,u.defaultUrl)||!(0,C.isEqual)(f.insidersUrl,u.insidersUrl)||!(0,C.isEqual)(f.stableUrl,u.stableUrl))}async doSync(u,f,v){this.logService.info(`Auto Sync: Triggered by ${u}`),this._onDidStartSync.fire();let T;try{if(this.syncTask=await this.userDataSyncService.createSyncTask(this.manifest,f),v.isCancellationRequested)return;if(this.manifest=this.syncTask.manifest,this.manifest===null&&await this.userDataSyncService.hasPreviouslySynced())throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new y.UserDataAutoSyncError((0,E.localize)(0,null),"DefaultServiceChanged"):new y.UserDataAutoSyncError((0,E.localize)(1,null),"ServiceChanged"):new y.UserDataAutoSyncError((0,E.localize)(2,null),"TurnedOff");const O=this.storageService.get(l,0);if(O&&this.manifest&&O!==this.manifest.session)throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new y.UserDataAutoSyncError((0,E.localize)(3,null),"DefaultServiceChanged"):new y.UserDataAutoSyncError((0,E.localize)(4,null),"ServiceChanged"):new y.UserDataAutoSyncError((0,E.localize)(5,null),"SessionExpired");const U=await this.userDataSyncMachinesService.getMachines(this.manifest||void 0);if(v.isCancellationRequested)return;const W=U.find(N=>N.isCurrent);if(W?.disabled)throw new y.UserDataAutoSyncError((0,E.localize)(6,null),"TurnedOff");if(await this.syncTask.run(),this.manifest===null)try{this.manifest=await this.userDataSyncStoreService.manifest(null)}catch(N){throw new y.UserDataAutoSyncError((0,D.toErrorMessage)(N),N instanceof y.UserDataSyncError?N.code:"Unknown")}if(this.manifest&&this.manifest.session!==O&&this.storageService.store(l,this.manifest.session,0,1),v.isCancellationRequested)return;W||await this.userDataSyncMachinesService.addCurrentMachine(this.manifest||void 0)}catch(O){this.logService.error(O),T=O}this._onDidFinishSync.fire(T)}register(u){return super._register(u)}}s.INTERVAL_SYNCING="Interval"}),define(te[231],ne([0,1,3,2,4,23,22,24]),function(X,e,R,L,D,k,i,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncResourceEnablementService=void 0;let S=class extends L.Disposable{constructor(I,E){super();this.storageService=I,this.telemetryService=E,this._onDidChangeResourceEnablement=new R.Emitter,this.onDidChangeResourceEnablement=this._onDidChangeResourceEnablement.event,this._register(I.onDidChangeValue(d=>this.onDidStorageChange(d)))}isResourceEnabled(I){return this.storageService.getBoolean((0,P.getEnablementKey)(I),0,!0)}setResourceEnablement(I,E){if(this.isResourceEnabled(I)!==E){const d=(0,P.getEnablementKey)(I);this.telemetryService.publicLog2(d,{enabled:E}),this.storeResourceEnablement(d,E)}}getResourceSyncStateVersion(I){}storeResourceEnablement(I,E){this.storageService.store(I,E,0,D.isWeb?0:1)}onDidStorageChange(I){if(I.scope===0){const E=P.ALL_SYNC_RESOURCES.filter(d=>(0,P.getEnablementKey)(d)===I.key)[0];if(E){this._onDidChangeResourceEnablement.fire([E,this.isResourceEnabled(E)]);return}}}};S=he([J(0,k.IStorageService),J(1,i.ITelemetryService)],S),e.UserDataSyncResourceEnablementService=S}),define(te[232],ne([0,1,16,5,38,9,3,2,18,29,21,6,23,22,221,223,224,226,227,24]),function(X,e,R,L,D,k,i,P,S,C,I,E,d,p,h,w,y,m,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const a="sync.lastSyncTime";let l=class extends P.Disposable{constructor(t,s,c,u,f,v,T){super();this.userDataSyncStoreService=t,this.userDataSyncStoreManagementService=s,this.instantiationService=c,this.configurationService=u,this.logService=f,this.telemetryService=v,this.storageService=T,this._status="uninitialized",this._onDidChangeStatus=this._register(new i.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new i.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._syncErrors=[],this._onSyncErrors=this._register(new i.Emitter),this.onSyncErrors=this._onSyncErrors.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new i.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onDidResetLocal=this._register(new i.Emitter),this.onDidResetLocal=this._onDidResetLocal.event,this._onDidResetRemote=this._register(new i.Emitter),this.onDidResetRemote=this._onDidResetRemote.event,this.recoveredSettings=!1,this.settingsSynchroniser=this._register(this.instantiationService.createInstance(m.SettingsSynchroniser)),this.keybindingsSynchroniser=this._register(this.instantiationService.createInstance(y.KeybindingsSynchroniser)),this.snippetsSynchroniser=this._register(this.instantiationService.createInstance(b.SnippetsSynchroniser)),this.globalStateSynchroniser=this._register(this.instantiationService.createInstance(w.GlobalStateSynchroniser)),this.extensionsSynchroniser=this._register(this.instantiationService.createInstance(h.ExtensionsSynchroniser)),this.synchronisers=[this.settingsSynchroniser,this.keybindingsSynchroniser,this.snippetsSynchroniser,this.globalStateSynchroniser,this.extensionsSynchroniser],this.updateStatus(),this.userDataSyncStoreManagementService.userDataSyncStore&&(this._register(i.Event.any(...this.synchronisers.map(O=>i.Event.map(O.onDidChangeStatus,()=>{})))(()=>this.updateStatus())),this._register(i.Event.any(...this.synchronisers.map(O=>i.Event.map(O.onDidChangeConflicts,()=>{})))(()=>this.updateConflicts()))),this._lastSyncTime=this.storageService.getNumber(a,0,void 0),this.onDidChangeLocal=i.Event.any(...this.synchronisers.map(O=>i.Event.map(O.onDidChangeLocal,()=>O.resource)))}get status(){return this._status}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}async createSyncTask(t,s){await this.checkEnablement();const c=(0,C.generateUuid)();try{const T=(0,g.createSyncHeaders)(c);s&&(T["Cache-Control"]="no-cache"),t=await this.userDataSyncStoreService.manifest(t,T)}catch(T){const O=g.UserDataSyncError.toUserDataSyncError(T);throw this.reportUserDataSyncError(O,c),O}let u=!1;const f=this;let v;return{manifest:t,run(){if(u)throw new Error("Can run a task only once");return v=(0,L.createCancelablePromise)(T=>f.sync(t,c,T)),v.finally(()=>v=void 0)},async stop(){if(v&&v.cancel(),f.status!=="idle")return f.stop()}}}async createManualSyncTask(){await this.checkEnablement();const t=(0,C.generateUuid)(),s=(0,g.createSyncHeaders)(t);let c;try{c=await this.userDataSyncStoreService.manifest(null,s)}catch(u){const f=g.UserDataSyncError.toUserDataSyncError(u);throw this.reportUserDataSyncError(f,t),f}return new r(t,c,s,this.synchronisers,this.configurationService,this.logService)}async sync(t,s,c){if(this.recoveredSettings||(await this.settingsSynchroniser.recoverSettings(),this.recoveredSettings=!0),c.isCancellationRequested)return;const u=new Date().getTime();this._syncErrors=[];try{this.logService.trace("Sync started."),this.status!=="hasConflicts"&&this.setStatus("syncing");const f=(0,g.createSyncHeaders)(s);for(const v of this.synchronisers){if(c.isCancellationRequested)return;try{await v.sync(t,f)}catch(T){let O=!1;if(T instanceof g.UserDataSyncError)switch(T.code){case"TooLarge":T=new g.UserDataSyncError(T.message,T.code,v.resource),O=!0;break;case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":O=!0;break}const U=g.UserDataSyncError.toUserDataSyncError(T);if(this.reportUserDataSyncError(U,s),O)throw U;this.logService.error(T),this.logService.error(`${v.resource}: ${(0,D.toErrorMessage)(T)}`),this._syncErrors.push([v.resource,U])}}this.logService.info(`Sync done. Took ${new Date().getTime()-u}ms`),this.updateLastSyncTime()}catch(f){const v=g.UserDataSyncError.toUserDataSyncError(f);throw this.reportUserDataSyncError(v,s),v}finally{this.updateStatus(),this._onSyncErrors.fire(this._syncErrors)}}async stop(){if(this.status!=="idle")for(const t of this.synchronisers)try{t.status!=="idle"&&await t.stop()}catch(s){this.logService.error(s)}}async replace(t){await this.checkEnablement();for(const s of this.synchronisers)if(await s.replace(t))return}async accept(t,s,c,u){await this.checkEnablement();const f=this.getSynchroniser(t);await f.accept(s,c),u&&await f.apply(!1,(0,g.createSyncHeaders)((0,C.generateUuid)()))}async resolveContent(t){for(const s of this.synchronisers){const c=await s.resolveContent(t);if(c)return c}return null}getRemoteSyncResourceHandles(t){return this.getSynchroniser(t).getRemoteSyncResourceHandles()}getLocalSyncResourceHandles(t){return this.getSynchroniser(t).getLocalSyncResourceHandles()}getAssociatedResources(t,s){return this.getSynchroniser(t).getAssociatedResources(s)}getMachineId(t,s){return this.getSynchroniser(t).getMachineId(s)}async hasLocalData(){const t=[this.settingsSynchroniser,this.keybindingsSynchroniser,this.snippetsSynchroniser,this.extensionsSynchroniser];for(const s of t)if(await s.hasLocalData())return!0;return!1}async reset(){await this.checkEnablement(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){await this.checkEnablement();try{await this.userDataSyncStoreService.clear(),this.logService.info("Cleared data on server")}catch(t){this.logService.error(t)}this._onDidResetRemote.fire()}async resetLocal(){await this.checkEnablement(),this.storageService.remove(a,0);for(const t of this.synchronisers)try{await t.resetLocal()}catch(s){this.logService.error(`${t.resource}: ${(0,D.toErrorMessage)(s)}`),this.logService.error(s)}this._onDidResetLocal.fire(),this.logService.info("Did reset the local sync state.")}async hasPreviouslySynced(){for(const t of this.synchronisers)if(await t.hasPreviouslySynced())return!0;return!1}setStatus(t){const s=this._status;this._status!==t&&(this._status=t,this._onDidChangeStatus.fire(t),s==="hasConflicts"&&this.updateLastSyncTime())}updateStatus(){this.updateConflicts();const t=this.computeStatus();this.setStatus(t)}updateConflicts(){const t=this.computeConflicts();(0,R.equals)(this._conflicts,t,([s,c],[u,f])=>s===s&&(0,R.equals)(c,f,(v,T)=>(0,S.isEqual)(v.previewResource,T.previewResource)))||(this._conflicts=this.computeConflicts(),this._onDidChangeConflicts.fire(t))}computeStatus(){return this.userDataSyncStoreManagementService.userDataSyncStore?this.synchronisers.some(t=>t.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(t=>t.status==="syncing")?"syncing":"idle":"uninitialized"}updateLastSyncTime(){this.status==="idle"&&(this._lastSyncTime=new Date().getTime(),this.storageService.store(a,this._lastSyncTime,0,1),this._onDidChangeLastSyncTime.fire(this._lastSyncTime))}reportUserDataSyncError(t,s){this.telemetryService.publicLog2("sync/error",{code:t.code,serverCode:t instanceof g.UserDataSyncStoreError?String(t.serverCode):void 0,url:t instanceof g.UserDataSyncStoreError?t.url:void 0,resource:t.resource,executionId:s,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()})}computeConflicts(){return this.synchronisers.filter(t=>t.status==="hasConflicts").map(t=>[t.resource,t.conflicts.map(o)])}getSynchroniser(t){return this.synchronisers.find(s=>s.resource===t)}async checkEnablement(){if(!this.userDataSyncStoreManagementService.userDataSyncStore)throw new Error("Not enabled")}};l=he([J(0,g.IUserDataSyncStoreService),J(1,g.IUserDataSyncStoreManagementService),J(2,E.IInstantiationService),J(3,I.IConfigurationService),J(4,g.IUserDataSyncLogService),J(5,p.ITelemetryService),J(6,d.IStorageService)],l),e.UserDataSyncService=l;class r extends P.Disposable{constructor(t,s,c,u,f,v){super();this.id=t,this.manifest=s,this.syncHeaders=c,this.synchronisers=u,this.configurationService=f,this.logService=v,this.synchronizingResources=[],this._onSynchronizeResources=this._register(new i.Emitter),this.onSynchronizeResources=this._onSynchronizeResources.event,this.isDisposed=!1}get status(){return this.synchronisers.some(t=>t.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(t=>t.status==="syncing")?"syncing":"idle"}async preview(){try{if(this.isDisposed)throw new Error("Disposed");return this.previewsPromise||(this.previewsPromise=(0,L.createCancelablePromise)(t=>this.getPreviews(t))),this.previews||(this.previews=await this.previewsPromise),this.previews}catch(t){throw this.logService.error(t),t}}async accept(t,s){try{return await this.performAction(t,c=>c.accept(t,s))}catch(c){throw this.logService.error(c),c}}async merge(t){try{return t?await this.performAction(t,s=>s.merge(t)):await this.mergeAll()}catch(s){throw this.logService.error(s),s}}async discard(t){try{return await this.performAction(t,s=>s.discard(t))}catch(s){throw this.logService.error(s),s}}async discardConflicts(){try{if(!this.previews)throw new Error("Missing preview. Create preview and try again.");if(this.synchronizingResources.length)throw new Error("Cannot discard while synchronizing resources");const t=[];for(const[,s]of this.previews)for(const c of s.resourcePreviews)c.mergeState==="conflict"&&t.push(c.previewResource);for(const s of t)await this.discard(s);return this.previews}catch(t){throw this.logService.error(t),t}}async apply(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");const t=[];for(const[s,c]of this.previews){this.synchronizingResources.push([s,c.resourcePreviews.map(v=>v.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const u=this.synchronisers.find(v=>v.resource===s);for(const v of c.resourcePreviews)(v.localChange!==0||v.remoteChange!==0)&&v.mergeState==="preview"&&await u.merge(v.previewResource);const f=await u.apply(!1,this.syncHeaders);f&&t.push(this.toSyncResourcePreview(u.resource,f)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(v=>v[0]===s),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=t,this.previews}catch(t){throw this.logService.error(t),t}}async pull(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[t,s]of this.previews){this.synchronizingResources.push([t,s.resourcePreviews.map(u=>u.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const c=this.synchronisers.find(u=>u.resource===t);for(const u of s.resourcePreviews)await c.accept(u.remoteResource);await c.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(u=>u[0]===t),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(t){throw this.logService.error(t),t}}async push(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[t,s]of this.previews){this.synchronizingResources.push([t,s.resourcePreviews.map(u=>u.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const c=this.synchronisers.find(u=>u.resource===t);for(const u of s.resourcePreviews)await c.accept(u.localResource);await c.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(u=>u[0]===t),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(t){throw this.logService.error(t),t}}async stop(){for(const t of this.synchronisers)try{await t.stop()}catch(s){(0,k.isPromiseCanceledError)(s)||this.logService.error(s)}this.reset()}async performAction(t,s){if(!this.previews)throw new Error("Missing preview. Create preview and try again.");const c=this.previews.findIndex(([,N])=>N.resourcePreviews.some(({localResource:A,previewResource:z,remoteResource:_})=>(0,S.isEqual)(t,A)||(0,S.isEqual)(t,z)||(0,S.isEqual)(t,_)));if(c===-1)return this.previews;const[u,f]=this.previews[c],v=f.resourcePreviews.find(({localResource:N,remoteResource:A,previewResource:z})=>(0,S.isEqual)(N,t)||(0,S.isEqual)(A,t)||(0,S.isEqual)(z,t));if(!v)return this.previews;let T=this.synchronizingResources.find(N=>N[0]===u);T||(T=[u,[]],this.synchronizingResources.push(T)),T[1].some(N=>(0,S.isEqual)(N,v.localResource))||(T[1].push(v.localResource),this._onSynchronizeResources.fire(this.synchronizingResources));const O=this.synchronisers.find(N=>N.resource===this.previews[c][0]),U=await s(O);U?this.previews.splice(c,1,this.toSyncResourcePreview(O.resource,U)):this.previews.splice(c,1);const W=this.synchronizingResources.findIndex(N=>N[0]===u);return this.synchronizingResources[W][1].splice(T[1].findIndex(N=>(0,S.isEqual)(N,v.localResource)),1),T[1].length||(this.synchronizingResources.splice(W,1),this._onSynchronizeResources.fire(this.synchronizingResources)),this.previews}async mergeAll(){if(!this.previews)throw new Error("You need to create preview before merging or applying");if(this.synchronizingResources.length)throw new Error("Cannot merge or apply while synchronizing resources");const t=[];for(const[s,c]of this.previews){this.synchronizingResources.push([s,c.resourcePreviews.map(v=>v.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const u=this.synchronisers.find(v=>v.resource===s);let f=c;for(const v of c.resourcePreviews)(v.localChange!==0||v.remoteChange!==0)&&v.mergeState==="preview"&&(f=await u.merge(v.previewResource));f&&t.push(this.toSyncResourcePreview(u.resource,f)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(v=>v[0]===s),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=t,this.previews}async getPreviews(t){const s=[],c=await this.getUserDataSyncConfiguration();for(const u of this.synchronisers){if(t.isCancellationRequested)return[];const f=await u.preview(this.manifest,c,this.syncHeaders);f&&s.push(this.toSyncResourcePreview(u.resource,f))}return s}async getUserDataSyncConfiguration(){const t=this.configurationService.getValue(g.USER_DATA_SYNC_CONFIGURATION_SCOPE),s=await this.synchronisers.find(c=>c instanceof m.SettingsSynchroniser).getRemoteUserDataSyncConfiguration(this.manifest);return{...t,...s}}toSyncResourcePreview(t,s){return[t,{isLastSyncFromCurrentMachine:s.isLastSyncFromCurrentMachine,resourcePreviews:s.resourcePreviews.map(o)}]}reset(){this.previewsPromise&&(this.previewsPromise.cancel(),this.previewsPromise=void 0),this.previews=void 0,this.synchronizingResources=[]}dispose(){this.reset(),this.isDisposed=!0}}function o(n){return{localResource:n.localResource,previewResource:n.previewResource,remoteResource:n.remoteResource,acceptedResource:n.acceptedResource,localChange:n.localChange,remoteChange:n.remoteChange,mergeState:n.mergeState}}}),define(te[233],ne([0,1,3,2,17,7,24]),function(X,e,R,L,D,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncChannelClient=e.UserDataSyncChannel=void 0;class P{constructor(E,d){this.service=E,this.logService=d,this.manualSyncTasks=new Map,this.onManualSynchronizeResources=new R.Emitter}listen(E,d){switch(d){case"onDidChangeStatus":return this.service.onDidChangeStatus;case"onDidChangeConflicts":return this.service.onDidChangeConflicts;case"onDidChangeLocal":return this.service.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.service.onDidChangeLastSyncTime;case"onSyncErrors":return this.service.onSyncErrors;case"onDidResetLocal":return this.service.onDidResetLocal;case"onDidResetRemote":return this.service.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.onManualSynchronizeResources.event}throw new Error(`Event not found: ${d}`)}async call(E,d,p){try{return await this._call(E,d,p)}catch(h){throw this.logService.error(h),h}}async _call(E,d,p){switch(d){case"_getInitialData":return Promise.resolve([this.service.status,this.service.conflicts,this.service.lastSyncTime]);case"replace":return this.service.replace(k.URI.revive(p[0]));case"reset":return this.service.reset();case"resetRemote":return this.service.resetRemote();case"resetLocal":return this.service.resetLocal();case"hasPreviouslySynced":return this.service.hasPreviouslySynced();case"hasLocalData":return this.service.hasLocalData();case"accept":return this.service.accept(p[0],k.URI.revive(p[1]),p[2],p[3]);case"resolveContent":return this.service.resolveContent(k.URI.revive(p[0]));case"getLocalSyncResourceHandles":return this.service.getLocalSyncResourceHandles(p[0]);case"getRemoteSyncResourceHandles":return this.service.getRemoteSyncResourceHandles(p[0]);case"getAssociatedResources":return this.service.getAssociatedResources(p[0],{created:p[1].created,uri:k.URI.revive(p[1].uri)});case"getMachineId":return this.service.getMachineId(p[0],{created:p[1].created,uri:k.URI.revive(p[1].uri)});case"createManualSyncTask":return this.createManualSyncTask()}if(d.startsWith("manualSync/")){const h=d.substring("manualSync/".length),w=p[0],y=this.getManualSyncTask(w);switch(p=p.slice(1),h){case"preview":return y.preview();case"accept":return y.accept(k.URI.revive(p[0]),p[1]);case"merge":return y.merge(k.URI.revive(p[0]));case"discard":return y.discard(k.URI.revive(p[0]));case"discardConflicts":return y.discardConflicts();case"apply":return y.apply();case"pull":return y.pull();case"push":return y.push();case"stop":return y.stop();case"_getStatus":return y.status;case"dispose":return this.disposeManualSyncTask(y)}}throw new Error("Invalid call")}getManualSyncTask(E){const d=this.manualSyncTasks.get(this.createKey(E));if(!d)throw new Error(`Manual sync taks not found: ${E}`);return d.manualSyncTask}async createManualSyncTask(){const E=new L.DisposableStore,d=E.add(await this.service.createManualSyncTask());return E.add(d.onSynchronizeResources(p=>this.onManualSynchronizeResources.fire({manualSyncTaskId:d.id,data:p}))),this.manualSyncTasks.set(this.createKey(d.id),{manualSyncTask:d,disposables:E}),{id:d.id,manifest:d.manifest,status:d.status}}disposeManualSyncTask(E){E.dispose();const d=this.createKey(E.id);this.manualSyncTasks.get(d)?.disposables.dispose(),this.manualSyncTasks.delete(d)}createKey(E){return`manualSyncTask-${E}`}}e.UserDataSyncChannel=P;class S extends L.Disposable{constructor(E){super();this._status="uninitialized",this._onDidChangeStatus=this._register(new R.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new R.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new R.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onSyncErrors=this._register(new R.Emitter),this.onSyncErrors=this._onSyncErrors.event,this.channel={call(d,p,h){return E.call(d,p,h).then(null,w=>{throw i.UserDataSyncError.toUserDataSyncError(w)})},listen(d,p){return E.listen(d,p)}},this.channel.call("_getInitialData").then(([d,p,h])=>{this.updateStatus(d),this.updateConflicts(p),h&&this.updateLastSyncTime(h),this._register(this.channel.listen("onDidChangeStatus")(w=>this.updateStatus(w))),this._register(this.channel.listen("onDidChangeLastSyncTime")(w=>this.updateLastSyncTime(w)))}),this._register(this.channel.listen("onDidChangeConflicts")(d=>this.updateConflicts(d))),this._register(this.channel.listen("onSyncErrors")(d=>this._onSyncErrors.fire(d.map(([p,h])=>[p,i.UserDataSyncError.toUserDataSyncError(h)]))))}get status(){return this._status}get onDidChangeLocal(){return this.channel.listen("onDidChangeLocal")}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}get onDidResetLocal(){return this.channel.listen("onDidResetLocal")}get onDidResetRemote(){return this.channel.listen("onDidResetRemote")}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const{id:E,manifest:d,status:p}=await this.channel.call("createManualSyncTask"),h=this,w=new C(E,d,p,{async call(y,m,b){return h.channel.call(`manualSync/${y}`,[E,...(0,D.isArray)(m)?m:[m]],b)},listen(y,m){return R.Event.map(R.Event.filter(h.channel.listen(`manualSync/${y}`,m),b=>!w.isDiposed()&&b.manualSyncTaskId===E),b=>b.data)}});return w}replace(E){return this.channel.call("replace",[E])}reset(){return this.channel.call("reset")}resetRemote(){return this.channel.call("resetRemote")}resetLocal(){return this.channel.call("resetLocal")}hasPreviouslySynced(){return this.channel.call("hasPreviouslySynced")}hasLocalData(){return this.channel.call("hasLocalData")}accept(E,d,p,h){return this.channel.call("accept",[E,d,p,h])}resolveContent(E){return this.channel.call("resolveContent",[E])}async getLocalSyncResourceHandles(E){return(await this.channel.call("getLocalSyncResourceHandles",[E])).map(({created:p,uri:h})=>({created:p,uri:k.URI.revive(h)}))}async getRemoteSyncResourceHandles(E){return(await this.channel.call("getRemoteSyncResourceHandles",[E])).map(({created:p,uri:h})=>({created:p,uri:k.URI.revive(h)}))}async getAssociatedResources(E,d){return(await this.channel.call("getAssociatedResources",[E,d])).map(({resource:h,comparableResource:w})=>({resource:k.URI.revive(h),comparableResource:k.URI.revive(w)}))}async getMachineId(E,d){return this.channel.call("getMachineId",[E,d])}async updateStatus(E){this._status=E,this._onDidChangeStatus.fire(E)}async updateConflicts(E){this._conflicts=E.map(([d,p])=>[d,p.map(h=>({...h,localResource:k.URI.revive(h.localResource),remoteResource:k.URI.revive(h.remoteResource),previewResource:k.URI.revive(h.previewResource)}))]),this._onDidChangeConflicts.fire(this._conflicts)}updateLastSyncTime(E){this._lastSyncTime!==E&&(this._lastSyncTime=E,this._onDidChangeLastSyncTime.fire(E))}}e.UserDataSyncChannelClient=S;class C extends L.Disposable{constructor(E,d,p,h){super();this.id=E,this.manifest=d,this._disposed=!1,this._status=p;const w=this;this.channel={async call(y,m,b){try{const g=await h.call(y,m,b);return w.isDiposed()||(w._status=await h.call("_getStatus")),g}catch(g){throw i.UserDataSyncError.toUserDataSyncError(g)}},listen(y,m){return h.listen(y,m)}}}get onSynchronizeResources(){return this.channel.listen("onSynchronizeResources")}get status(){return this._status}async preview(){const E=await this.channel.call("preview");return this.deserializePreviews(E)}async accept(E,d){const p=await this.channel.call("accept",[E,d]);return this.deserializePreviews(p)}async merge(E){const d=await this.channel.call("merge",[E]);return this.deserializePreviews(d)}async discard(E){const d=await this.channel.call("discard",[E]);return this.deserializePreviews(d)}async discardConflicts(){const E=await this.channel.call("discardConflicts");return this.deserializePreviews(E)}async apply(){const E=await this.channel.call("apply");return this.deserializePreviews(E)}pull(){return this.channel.call("pull")}push(){return this.channel.call("push")}stop(){return this.channel.call("stop")}isDiposed(){return this._disposed}dispose(){this._disposed=!0,this.channel.call("dispose")}deserializePreviews(E){return E.map(([d,p])=>[d,{isLastSyncFromCurrentMachine:p.isLastSyncFromCurrentMachine,resourcePreviews:p.resourcePreviews.map(h=>({...h,localResource:k.URI.revive(h.localResource),remoteResource:k.URI.revive(h.remoteResource),previewResource:k.URI.revive(h.previewResource),acceptedResource:k.URI.revive(h.acceptedResource)}))}])}}}),define(te[234],ne([0,1,5,27,9,3,2,109,4,18,17,7,29,21,11,14,26,43,46,23,24]),function(X,e,R,L,D,k,i,P,S,C,I,E,d,p,h,w,y,m,b,g,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const l="sync.previous.store",r="sync.donot-make-requests-until",o="sync.user-session-id",n="sync.machine-session-id",t=100,s=1e3*60*5;let c=class extends i.Disposable{constructor(U,W,N){super();this.productService=U,this.configurationService=W,this.storageService=N,this._onDidChangeUserDataSyncStore=this._register(new k.Emitter),this.onDidChangeUserDataSyncStore=this._onDidChangeUserDataSyncStore.event,this.updateUserDataSyncStore(),this._register(k.Event.filter(N.onDidChangeValue,A=>A.key===a.SYNC_SERVICE_URL_TYPE&&A.scope===0&&this.userDataSyncStoreType!==this.userDataSyncStore?.type)(()=>this.updateUserDataSyncStore()))}get userDataSyncStore(){return this._userDataSyncStore}get userDataSyncStoreType(){return this.storageService.get(a.SYNC_SERVICE_URL_TYPE,0)}set userDataSyncStoreType(U){this.storageService.store(a.SYNC_SERVICE_URL_TYPE,U,0,S.isWeb?0:1)}updateUserDataSyncStore(){this._userDataSyncStore=this.toUserDataSyncStore(this.productService[a.CONFIGURATION_SYNC_STORE_KEY],this.configurationService.getValue(a.CONFIGURATION_SYNC_STORE_KEY)),this._onDidChangeUserDataSyncStore.fire()}toUserDataSyncStore(U,W){U=S.isWeb&&U?.web?{...U,...U.web}:U;const N={...U||{},...W||{}};if(N&&(0,I.isString)(N.url)&&(0,I.isObject)(N.authenticationProviders)&&Object.keys(N.authenticationProviders).every(A=>(0,I.isArray)(N.authenticationProviders[A].scopes))){const A=N,z=!!A.canSwitch&&!W?.url,_=A.url===A.insidersUrl?"insiders":"stable",M=(z?this.userDataSyncStoreType:void 0)||_,q=W?.url||(M==="insiders"?A.insidersUrl:M==="stable"?A.stableUrl:A.url);return{url:E.URI.parse(q),type:M,defaultType:_,defaultUrl:E.URI.parse(A.url),stableUrl:E.URI.parse(A.stableUrl),insidersUrl:E.URI.parse(A.insidersUrl),canSwitch:z,authenticationProviders:Object.keys(A.authenticationProviders).reduce((B,j)=>(B.push({id:j,scopes:A.authenticationProviders[j].scopes}),B),[])}}}};c=he([J(0,y.IProductService),J(1,p.IConfigurationService),J(2,g.IStorageService)],c),e.AbstractUserDataSyncStoreManagementService=c;let u=class extends c{constructor(U,W,N){super(U,W,N);const A=this.storageService.get(l,0);A&&(this.previousConfigurationSyncStore=JSON.parse(A));const z=this.productService[a.CONFIGURATION_SYNC_STORE_KEY];z?this.storageService.store(l,JSON.stringify(z),0,1):this.storageService.remove(l,0)}async switch(U){U!==this.userDataSyncStoreType&&(this.userDataSyncStoreType=U,this.updateUserDataSyncStore())}async getPreviousUserDataSyncStore(){return this.toUserDataSyncStore(this.previousConfigurationSyncStore)}};u=he([J(0,y.IProductService),J(1,p.IConfigurationService),J(2,g.IStorageService)],u),e.UserDataSyncStoreManagementService=u;let f=class extends i.Disposable{constructor(U,W,N,A,z,_,M){super();this.requestService=N,this.logService=A,this.storageService=M,this._onTokenFailed=this._register(new k.Emitter),this.onTokenFailed=this._onTokenFailed.event,this._onTokenSucceed=this._register(new k.Emitter),this.onTokenSucceed=this._onTokenSucceed.event,this._donotMakeRequestsUntil=void 0,this._onDidChangeDonotMakeRequestsUntil=this._register(new k.Emitter),this.onDidChangeDonotMakeRequestsUntil=this._onDidChangeDonotMakeRequestsUntil.event,this.resetDonotMakeRequestsUntilPromise=void 0,this.updateUserDataSyncStoreUrl(U),this.commonHeadersPromise=(0,b.getServiceMachineId)(z,_,M).then(q=>{const B={"X-Client-Name":`${W.applicationName}${S.isWeb?"-web":""}`,"X-Client-Version":W.version};return W.commit&&(B["X-Client-Commit"]=W.commit),B}),this.session=new T(t,s,this.requestService,this.logService),this.initDonotMakeRequestsUntil(),this._register((0,i.toDisposable)(()=>{this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0)}))}get donotMakeRequestsUntil(){return this._donotMakeRequestsUntil}setAuthToken(U,W){this.authToken={token:U,type:W}}updateUserDataSyncStoreUrl(U){this.userDataSyncStoreUrl=U?(0,C.joinPath)(U,"v1"):void 0}initDonotMakeRequestsUntil(){const U=this.storageService.getNumber(r,0);U&&Date.now()<U&&this.setDonotMakeRequestsUntil(new Date(U))}setDonotMakeRequestsUntil(U){this._donotMakeRequestsUntil?.getTime()!==U?.getTime()&&(this._donotMakeRequestsUntil=U,this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0),this._donotMakeRequestsUntil?(this.storageService.store(r,this._donotMakeRequestsUntil.getTime(),0,1),this.resetDonotMakeRequestsUntilPromise=(0,R.createCancelablePromise)(W=>(0,R.timeout)(this._donotMakeRequestsUntil.getTime()-Date.now(),W).then(()=>this.setDonotMakeRequestsUntil(void 0))),this.resetDonotMakeRequestsUntilPromise.then(null,W=>null)):this.storageService.remove(r,0),this._onDidChangeDonotMakeRequestsUntil.fire())}async getAllRefs(U){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const W=(0,C.joinPath)(this.userDataSyncStoreUrl,"resource",U),N={},A=await this.request(W.toString(),{type:"GET",headers:N},[],L.CancellationToken.None);return(await(0,m.asJson)(A)||[]).map(({url:_,created:M})=>({ref:(0,C.relativePath)(W,W.with({path:_})),created:M*1e3}))}async resolveContent(U,W){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const N=(0,C.joinPath)(this.userDataSyncStoreUrl,"resource",U,W).toString(),A={};A["Cache-Control"]="no-cache";const z=await this.request(N,{type:"GET",headers:A},[],L.CancellationToken.None);return await(0,m.asText)(z)}async delete(U){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const W=(0,C.joinPath)(this.userDataSyncStoreUrl,"resource",U).toString(),N={};await this.request(W,{type:"DELETE",headers:N},[],L.CancellationToken.None)}async read(U,W,N={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const A=(0,C.joinPath)(this.userDataSyncStoreUrl,"resource",U,"latest").toString();N={...N},N["Cache-Control"]="no-cache",W&&(N["If-None-Match"]=W.ref);const z=await this.request(A,{type:"GET",headers:N},[304],L.CancellationToken.None);let _=null;if(z.res.statusCode===304&&(_=W),_===null){const M=z.res.headers.etag;if(!M)throw new a.UserDataSyncStoreError("Server did not return the ref",A,"NoRef",z.res.statusCode,z.res.headers[a.HEADER_OPERATION_ID]);const q=await(0,m.asText)(z);if(!q&&z.res.statusCode===304)throw new a.UserDataSyncStoreError("Empty response",A,"EmptyResponse",z.res.statusCode,z.res.headers[a.HEADER_OPERATION_ID]);_={ref:M,content:q}}return _}async write(U,W,N,A={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const z=(0,C.joinPath)(this.userDataSyncStoreUrl,"resource",U).toString();A={...A},A["Content-Type"]=P.Mimes.text,N&&(A["If-Match"]=N);const _=await this.request(z,{type:"POST",data:W,headers:A},[],L.CancellationToken.None),M=_.res.headers.etag;if(!M)throw new a.UserDataSyncStoreError("Server did not return the ref",z,"NoRef",_.res.statusCode,_.res.headers[a.HEADER_OPERATION_ID]);return M}async manifest(U,W={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const N=(0,C.joinPath)(this.userDataSyncStoreUrl,"manifest").toString();W={...W},W["Content-Type"]="application/json",U&&(W["If-None-Match"]=U.ref);const A=await this.request(N,{type:"GET",headers:W},[304],L.CancellationToken.None);let z=null;if(A.res.statusCode===304&&(z=U),!z){const M=A.res.headers.etag;if(!M)throw new a.UserDataSyncStoreError("Server did not return the ref",N,"NoRef",A.res.statusCode,A.res.headers[a.HEADER_OPERATION_ID]);const q=await(0,m.asText)(A);if(!q&&A.res.statusCode===304)throw new a.UserDataSyncStoreError("Empty response",N,"EmptyResponse",A.res.statusCode,A.res.headers[a.HEADER_OPERATION_ID]);q&&(z={...JSON.parse(q),ref:M})}const _=this.storageService.get(o,0);return _&&z&&_!==z.session&&this.clearSession(),z===null&&_&&this.clearSession(),z&&this.storageService.store(o,z.session,0,1),z}async clear(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const U=(0,C.joinPath)(this.userDataSyncStoreUrl,"resource").toString(),W={"Content-Type":P.Mimes.text};await this.request(U,{type:"DELETE",headers:W},[],L.CancellationToken.None),this.clearSession()}clearSession(){this.storageService.remove(o,0),this.storageService.remove(n,0)}async request(U,W,N,A){if(!this.authToken)throw new a.UserDataSyncStoreError("No Auth Token Available",U,"Unauthorized",void 0,void 0);if(this._donotMakeRequestsUntil&&Date.now()<this._donotMakeRequestsUntil.getTime())throw new a.UserDataSyncStoreError(`${W.type} request '${U}' failed because of too many requests (429).`,U,"TooManyRequestsAndRetryAfter",void 0,void 0);this.setDonotMakeRequestsUntil(void 0);const z=await this.commonHeadersPromise;W.headers={...W.headers||{},...z,"X-Account-Type":this.authToken.type,authorization:`Bearer ${this.authToken.token}`},this.addSessionHeaders(W.headers),this.logService.trace("Sending request to server",{url:U,type:W.type,headers:{...W.headers,authorization:void 0}});let _;try{_=await this.session.request(U,W,A)}catch(j){if(!(j instanceof a.UserDataSyncStoreError)){let $="RequestFailed";const K=(0,D.getErrorMessage)(j).toLowerCase();K.includes("xhr timeout")?$="RequestTimeout":K.includes("protocol")&&K.includes("not supported")?$="RequestProtocolNotSupported":K.includes("request path contains unescaped characters")?$="RequestPathNotEscaped":K.includes("headers must be an object")?$="RequestHeadersNotObject":(0,D.isPromiseCanceledError)(j)&&($="RequestCanceled"),j=new a.UserDataSyncStoreError(`Connection refused for the request '${U}'.`,U,$,void 0,void 0)}throw this.logService.info("Request failed",U),j}const M=_.res.headers[a.HEADER_OPERATION_ID],q={url:U,status:_.res.statusCode,"execution-id":W.headers[a.HEADER_EXECUTION_ID],"operation-id":M},B=(0,m.isSuccess)(_)||_.res.statusCode&&N.indexOf(_.res.statusCode)!==-1;if(B?this.logService.trace("Request succeeded",q):this.logService.info("Request failed",q),_.res.statusCode===401)throw this.authToken=void 0,this._onTokenFailed.fire(),new a.UserDataSyncStoreError(`Request '${U}' failed because of Unauthorized (401).`,U,"Unauthorized",_.res.statusCode,M);if(this._onTokenSucceed.fire(),_.res.statusCode===409)throw new a.UserDataSyncStoreError(`${W.type} request '${U}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,U,"Conflict",_.res.statusCode,M);if(_.res.statusCode===410)throw new a.UserDataSyncStoreError(`${W.type} request '${U}' failed because the requested resource is not longer available (410).`,U,"Gone",_.res.statusCode,M);if(_.res.statusCode===412)throw new a.UserDataSyncStoreError(`${W.type} request '${U}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,U,"PreconditionFailed",_.res.statusCode,M);if(_.res.statusCode===413)throw new a.UserDataSyncStoreError(`${W.type} request '${U}' failed because of too large payload (413).`,U,"TooLarge",_.res.statusCode,M);if(_.res.statusCode===426)throw new a.UserDataSyncStoreError(`${W.type} request '${U}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,U,"UpgradeRequired",_.res.statusCode,M);if(_.res.statusCode===429){const j=_.res.headers["retry-after"];throw j?(this.setDonotMakeRequestsUntil(new Date(Date.now()+parseInt(j)*1e3)),new a.UserDataSyncStoreError(`${W.type} request '${U}' failed because of too many requests (429).`,U,"TooManyRequestsAndRetryAfter",_.res.statusCode,M)):new a.UserDataSyncStoreError(`${W.type} request '${U}' failed because of too many requests (429).`,U,"RemoteTooManyRequests",_.res.statusCode,M)}if(!B)throw new a.UserDataSyncStoreError("Server returned "+_.res.statusCode,U,"Unknown",_.res.statusCode,M);return _}addSessionHeaders(U){let W=this.storageService.get(n,0);W===void 0&&(W=(0,d.generateUuid)(),this.storageService.store(n,W,0,1)),U["X-Machine-Session-Id"]=W;const N=this.storageService.get(o,0);N!==void 0&&(U["X-User-Session-Id"]=N)}};f=he([J(1,y.IProductService),J(2,m.IRequestService),J(3,a.IUserDataSyncLogService),J(4,h.IEnvironmentService),J(5,w.IFileService),J(6,g.IStorageService)],f),e.UserDataSyncStoreClient=f;let v=class extends f{constructor(U,W,N,A,z,_,M){super(U.userDataSyncStore?.url,W,N,A,z,_,M);this._register(U.onDidChangeUserDataSyncStore(()=>this.updateUserDataSyncStoreUrl(U.userDataSyncStore?.url)))}};v=he([J(0,a.IUserDataSyncStoreManagementService),J(1,y.IProductService),J(2,m.IRequestService),J(3,a.IUserDataSyncLogService),J(4,h.IEnvironmentService),J(5,w.IFileService),J(6,g.IStorageService)],v),e.UserDataSyncStoreService=v;class T{constructor(U,W,N,A){this.limit=U,this.interval=W,this.requestService=N,this.logService=A,this.requests=[],this.startTime=void 0}request(U,W,N){if(this.isExpired()&&this.reset(),W.url=U,this.requests.length>=this.limit)throw this.logService.info("Too many requests",...this.requests),new a.UserDataSyncStoreError(`Too many requests. Only ${this.limit} requests allowed in ${this.interval/(1e3*60)} minutes.`,U,"LocalTooManyRequests",void 0,void 0);return this.startTime=this.startTime||new Date,this.requests.push(U),this.requestService.request(W,N)}isExpired(){return this.startTime!==void 0&&new Date().getTime()-this.startTime.getTime()>this.interval}reset(){this.requests=[],this.startTime=void 0}}e.RequestsSession=T}),define(te[235],ne([0,1,3,60,26,23,22,99,24,63,64]),function(X,e,R,L,D,k,i,P,S,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let E=class extends P.UserDataAutoSyncService{constructor(p,h,w,y,m,b,g,a,l,r,o,n){super(p,h,w,y,m,g,a,l,r,o,n);this._register(R.Event.debounce(R.Event.any(R.Event.map(b.onDidFocusWindow,()=>"windowFocus"),R.Event.map(b.onDidOpenWindow,()=>"windowOpen")),(t,s)=>t?[...t,s]:[s],1e3)(t=>this.triggerSync(t,!0,!1)))}};E=he([J(0,D.IProductService),J(1,S.IUserDataSyncStoreManagementService),J(2,S.IUserDataSyncStoreService),J(3,S.IUserDataSyncResourceEnablementService),J(4,S.IUserDataSyncService),J(5,L.INativeHostService),J(6,S.IUserDataSyncLogService),J(7,C.IUserDataSyncAccountService),J(8,i.ITelemetryService),J(9,I.IUserDataSyncMachinesService),J(10,k.IStorageService),J(11,S.IUserDataAutoSyncEnablementService)],E),e.UserDataAutoSyncService=E}),define(te[236],ne([0,1,5,3,2]),function(X,e,R,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class k extends D.Disposable{constructor({onDidOpenWindow:P,onDidFocusWindow:S,getActiveWindowId:C}){super();this.disposables=this._register(new D.DisposableStore),L.Event.latch(L.Event.any(P,S))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,R.createCancelablePromise)(()=>C()),(async()=>{try{const E=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:E}catch(E){}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(P){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=P}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=k}),define(te[65],ne([0,1,51,5,10,17,20,125,248,249]),function(X,e,R,L,D,k,i,P,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class I extends Error{constructor(r,o){let n=o.message;switch(r){case"CorruptZip":n=`Corrupt ZIP: ${n}`;break}super(n);this.type=r,this.cause=o}}e.ExtractError=I;function E(l){const r=l.externalFileAttributes>>16||33188;return[448,56,7].map(o=>r&o).reduce((o,n)=>o+n,r&61440)}function d(l){if(l instanceof I)return l;let r;return/end of central directory record signature not found/.test(l.message)&&(r="CorruptZip"),new I(r,l)}function p(l,r,o,n,t,s){const c=D.dirname(r),u=D.join(n,c);if(!u.startsWith(n))return Promise.reject(new Error(P.localize(0,null,r)));const f=D.join(n,r);let v;return s.onCancellationRequested(()=>{v&&v.destroy()}),Promise.resolve(i.Promises.mkdir(u,{recursive:!0})).then(()=>new Promise((T,O)=>{if(!s.isCancellationRequested)try{v=(0,R.createWriteStream)(f,{mode:o}),v.once("close",()=>T()),v.once("error",O),l.once("error",O),l.pipe(v)}catch(U){O(U)}}))}function h(l,r,o,n){let t=(0,L.createCancelablePromise)(()=>Promise.resolve()),s=0;return n.onCancellationRequested(()=>{t.cancel(),l.close()}),new Promise((c,u)=>{const f=new L.Sequencer,v=T=>{T.isCancellationRequested||(s++,l.readEntry())};l.once("error",u),l.once("close",()=>t.then(()=>{n.isCancellationRequested||l.entryCount===s?c():u(new I("Incomplete",new Error(P.localize(1,null,s,l.entryCount))))},u)),l.readEntry(),l.on("entry",T=>{if(n.isCancellationRequested)return;if(!o.sourcePathRegex.test(T.fileName)){v(n);return}const O=T.fileName.replace(o.sourcePathRegex,"");if(/\/$/.test(O)){const N=D.join(r,O);t=(0,L.createCancelablePromise)(A=>i.Promises.mkdir(N,{recursive:!0}).then(()=>v(A)).then(void 0,u));return}const U=y(l,T),W=E(T);t=(0,L.createCancelablePromise)(N=>f.queue(()=>U.then(A=>p(A,O,W,r,o,N).then(()=>v(N)))).then(null,u))})})}function w(l,r=!1){return new Promise((o,n)=>{(0,S.open)(l,r?{lazyEntries:!0}:void 0,(t,s)=>{t?n(d(t)):o((0,k.assertIsDefined)(s))})})}function y(l,r){return new Promise((o,n)=>{l.openReadStream(r,(t,s)=>{t?n(d(t)):o((0,k.assertIsDefined)(s))})})}function m(l,r){return new Promise((o,n)=>{const t=new C.ZipFile;r.forEach(c=>{c.contents?t.addBuffer(typeof c.contents=="string"?Buffer.from(c.contents,"utf8"):c.contents,c.path):c.localPath&&t.addFile(c.localPath,c.path)}),t.end();const s=(0,R.createWriteStream)(l);t.outputStream.pipe(s),t.outputStream.once("error",n),s.once("error",n),s.once("finish",()=>o(l))})}e.zip=m;function b(l,r,o={},n){const t=new RegExp(o.sourcePath?`^${o.sourcePath}`:"");let s=w(l,!0);return o.overwrite&&(s=s.then(c=>i.Promises.rm(r).then(()=>c))),s.then(c=>h(c,r,{sourcePathRegex:t},n))}e.extract=b;function g(l,r){return w(l).then(o=>new Promise((n,t)=>{o.on("entry",s=>{s.fileName===r&&y(o,s).then(c=>n(c),c=>t(c))}),o.once("close",()=>t(new Error(P.localize(2,null,r))))}))}function a(l,r){return g(l,r).then(o=>new Promise((n,t)=>{const s=[];o.once("error",t),o.on("data",c=>s.push(c)),o.on("end",()=>n(Buffer.concat(s)))}))}e.buffer=a}),define(te[237],ne([0,1,65,134]),function(X,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function D(k){return(0,R.buffer)(k,"extension/package.json").then(i=>{try{return JSON.parse(i.toString("utf8"))}catch(P){throw new Error((0,L.localize)(0,null))}})}e.getManifest=D}),define(te[238],ne([0,1,16,5,9,2,15,10,4,18,61,7,29,20,65,135,11,30,36,156,14,8,26]),function(X,e,R,L,D,k,i,P,S,C,I,E,d,p,h,w,y,m,b,g,a,l,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScanner=void 0;let o=class extends k.Disposable{constructor(t,s,c,u,f){super();this.beforeRemovingExtension=t,this.fileService=s,this.logService=c,this.environmentService=u,this.productService=f,this._devSystemExtensionsPath=null,this.systemExtensionsPath=u.builtinExtensionsPath,this.extensionsPath=u.extensionsPath,this.uninstalledPath=P.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new L.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(t){const s=[];(t===null||t===0)&&s.push(this.scanSystemExtensions().then(null,c=>Promise.reject(new m.ExtensionManagementError(this.joinErrors(c).message,m.ExtensionManagementErrorCode.Internal)))),(t===null||t===1)&&s.push(this.scanUserExtensions(!0).then(null,c=>Promise.reject(new m.ExtensionManagementError(this.joinErrors(c).message,m.ExtensionManagementErrorCode.Internal))));try{const c=await Promise.all(s);return(0,R.flatten)(c)}catch(c){throw this.joinErrors(c)}}async scanUserExtensions(t){this.logService.trace("Started scanning user extensions");let[s,c]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return c=c.filter(u=>!s[new b.ExtensionIdentifierWithVersion(u.identifier,u.manifest.version).key()]),t&&(c=(0,b.groupByExtension)(c,f=>f.identifier).map(f=>f.sort((v,T)=>I.rcompare(v.manifest.version,T.manifest.version))[0])),this.logService.trace("Scanned user extensions:",c.length),c}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(t,s,c,u){const f=t.key(),v=P.join(this.extensionsPath,`.${(0,d.generateUuid)()}`),T=P.join(this.extensionsPath,f);try{await p.Promises.rm(T)}catch(U){try{await p.Promises.rm(T)}catch(W){}throw new m.ExtensionManagementError((0,w.localize)(0,null,T,t.id),m.ExtensionManagementErrorCode.Delete)}await this.extractAtLocation(t,s,v,u);let O=await this.scanExtension(E.URI.file(v),1);if(!O)throw new Error((0,w.localize)(1,null,v));await this.storeMetadata(O,{...c,installedTimestamp:Date.now()});try{await this.rename(t,v,T,Date.now()+2*60*1e3),this.logService.info("Renamed to",T)}catch(U){try{await p.Promises.rm(v)}catch(W){}if(U.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",t.id);else throw this.logService.info(`Rename failed because of ${(0,D.getErrorMessage)(U)}. Deleted from extracted location`,v),U}try{O=await this.scanExtension(E.URI.file(T),1)}catch(U){}if(O)return O;throw new Error((0,w.localize)(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(t,s){return this.setMetadata(t,s),await this.storeMetadata(t,{...s,installedTimestamp:t.installedTimestamp}),t}async storeMetadata(t,s){s.isMachineScoped=s.isMachineScoped||void 0,s.isBuiltin=s.isBuiltin||void 0,s.installedTimestamp=s.installedTimestamp||void 0;const c=P.join(t.location.fsPath,"package.json"),u=await p.Promises.readFile(c,"utf8"),{manifest:f}=await this.parseManifest(u);return f.__metadata=s,await p.Promises.writeFile(c,JSON.stringify(f,null,"	")),t}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...t){const s=t.map(c=>new b.ExtensionIdentifierWithVersion(c.identifier,c.manifest.version));await this.withUninstalledExtensions(c=>{s.forEach(u=>c[u.key()]=!0)})}async setInstalled(t){await this.withUninstalledExtensions(u=>delete u[t.key()]);const c=(await this.scanExtensions(1)).find(u=>new b.ExtensionIdentifierWithVersion(u.identifier,u.manifest.version).equals(t))||null;return c?(await this.storeMetadata(c,{installedTimestamp:Date.now()}),this.scanExtension(c.location,1)):null}async withUninstalledExtensions(t){return this.uninstalledFileLimiter.queue(async()=>{let s;try{s=await p.Promises.readFile(this.uninstalledPath,"utf8")}catch(u){if(u.code!=="ENOENT")throw u}let c={};if(s)try{c=JSON.parse(s)}catch(u){}return t&&(t(c),Object.keys(c).length?await p.Promises.writeFile(this.uninstalledPath,JSON.stringify(c)):await p.Promises.rm(this.uninstalledPath)),c})}async removeExtension(t,s){this.logService.trace(`Deleting ${s} extension from disk`,t.identifier.id,t.location.fsPath),await p.Promises.rm(t.location.fsPath),this.logService.info("Deleted from disk",t.identifier.id,t.location.fsPath)}async removeUninstalledExtension(t){await this.removeExtension(t,"uninstalled"),await this.withUninstalledExtensions(s=>delete s[new b.ExtensionIdentifierWithVersion(t.identifier,t.manifest.version).key()])}async extractAtLocation(t,s,c,u){this.logService.trace(`Started extracting the extension from ${s} to ${c}`);try{await p.Promises.rm(c)}catch(f){throw new m.ExtensionManagementError(this.joinErrors(f).message,m.ExtensionManagementErrorCode.Delete)}try{await(0,h.extract)(s,c,{sourcePath:"extension",overwrite:!0},u),this.logService.info(`Extracted extension to ${c}:`,t.id)}catch(f){try{await p.Promises.rm(c)}catch(T){}let v=m.ExtensionManagementErrorCode.Extract;throw f instanceof h.ExtractError&&(f.type==="CorruptZip"?v=m.ExtensionManagementErrorCode.CorruptZip:f.type==="Incomplete"&&(v=m.ExtensionManagementErrorCode.IncompleteZip)),new m.ExtensionManagementError(f.message,v)}}async rename(t,s,c,u){try{await p.Promises.rename(s,c)}catch(f){if(S.isWindows&&f&&f.code==="EPERM"&&Date.now()<u)return this.logService.info(`Failed renaming ${s} to ${c} with 'EPERM' error. Trying again...`,t.id),this.rename(t,s,c,u);throw new m.ExtensionManagementError(f.message||(0,w.localize)(3,null,s,c),f.code||m.ExtensionManagementErrorCode.Rename)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const t=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return t;const s=this.scanDevSystemExtensions(),[c,u]=await Promise.all([t,s]);return[...c,...u]}async scanExtensionsInDir(t,s){const c=new L.Limiter(10),u=await this.fileService.resolve(E.URI.file(t));return u.children?(await Promise.all(u.children.filter(v=>v.isDirectory).map(v=>c.queue(async()=>s===1&&(0,C.basename)(v.resource).indexOf(".")===0?null:this.scanExtension(v.resource,s))))).filter(v=>v&&v.identifier):[]}async scanExtension(t,s){try{const c=await this.fileService.resolve(t);if(c.children){const{manifest:u,metadata:f}=await this.readManifest(t.fsPath),v=c.children.find(({name:W})=>/^readme(\.txt|\.md|)$/i.test(W))?.resource,T=c.children.find(({name:W})=>/^changelog(\.txt|\.md|)$/i.test(W))?.resource,O={id:(0,b.getGalleryExtensionId)(u.publisher,u.name)},U={type:s,identifier:O,manifest:u,location:t,readmeUrl:v,changelogUrl:T,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:s===0};return f&&(this.setMetadata(U,f),U.installedTimestamp=f.installedTimestamp),U}}catch(c){s!==0&&this.logService.trace(c)}return null}async scanDefaultSystemExtensions(){const t=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",t.length),t}async scanDevSystemExtensions(){const t=this.getDevSystemExtensionsList();if(t.length){const s=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",s.length),s.filter(c=>t.some(u=>(0,b.areSameExtensions)(c.identifier,{id:u})))}else return[]}setMetadata(t,s){t.publisherDisplayName=s.publisherDisplayName||null,t.publisherId=s.publisherId||null,t.identifier.uuid=s.id,t.isMachineScoped=!!s.isMachineScoped,t.isBuiltin=t.type===0||!!s.isBuiltin}async removeUninstalledExtensions(){const t=await this.getUninstalledExtensions(),s=await this.scanAllUserExtensions(),c=new Set;for(const v of s)t[new b.ExtensionIdentifierWithVersion(v.identifier,v.manifest.version).key()]||c.add(v.identifier.id.toLowerCase());const u=(0,b.groupByExtension)(s,v=>v.identifier);await L.Promises.settled(u.map(async v=>{const T=v.sort((O,U)=>I.rcompare(O.manifest.version,U.manifest.version))[0];c.has(T.identifier.id.toLowerCase())||await this.beforeRemovingExtension(T)}));const f=s.filter(v=>t[new b.ExtensionIdentifierWithVersion(v.identifier,v.manifest.version).key()]);await L.Promises.settled(f.map(v=>this.removeUninstalledExtension(v)))}async removeOutdatedExtensions(){const t=await this.scanAllUserExtensions(),s=[],c=(0,b.groupByExtension)(t,u=>u.identifier);s.push(...(0,R.flatten)(c.map(u=>u.sort((f,v)=>I.rcompare(f.manifest.version,v.manifest.version)).slice(1)))),await L.Promises.settled(s.map(u=>this.removeExtension(u,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(t=>t.name)}joinErrors(t){const s=Array.isArray(t)?t:[t];return s.length===1?s[0]instanceof Error?s[0]:new Error(s[0]):s.reduce((c,u)=>new Error(`${c.message}${c.message?",":""}${u instanceof Error?u.message:u}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=P.normalize(P.join(i.FileAccess.asFileUri("",X).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(t){const s=[p.Promises.readFile(P.join(t,"package.json"),"utf8").then(v=>this.parseManifest(v)),p.Promises.readFile(P.join(t,"package.nls.json"),"utf8").then(void 0,v=>v.code!=="ENOENT"?Promise.reject(v):"{}").then(v=>JSON.parse(v))],[{manifest:c,metadata:u},f]=await Promise.all(s);return{manifest:(0,g.localizeManifest)(c,f),metadata:u}}parseManifest(t){return new Promise((s,c)=>{try{const u=JSON.parse(t),f=u.__metadata||null;s({manifest:u,metadata:f})}catch(u){c(new Error((0,w.localize)(4,null)))}})}};o=he([J(1,a.IFileService),J(2,l.ILogService),J(3,y.INativeEnvironmentService),J(4,r.IProductService)],o),e.ExtensionsScanner=o}),define(te[239],ne([0,1,38,9,15,10,4,31,18,61,7,29,20,65,133,79,11,202,30,36,186,175,237,187,238,216,76,14,6,8,26,22,37]),function(X,e,R,L,D,k,i,P,S,C,I,E,d,p,h,w,y,m,b,g,a,l,r,o,n,t,s,c,u,f,v,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementService=void 0;let U=class extends m.AbstractExtensionManagementService{constructor(M,q,B,j,$,K,F,x,V){super(M,q,B,x);this.environmentService=j,this.downloadService=$,this.fileService=F;const Q=this._register(K.createInstance(l.ExtensionsLifecycle));this.extensionsScanner=this._register(K.createInstance(n.ExtensionsScanner,G=>Q.postUninstall(G))),this.manifestCache=this._register(new o.ExtensionsManifestCache(j,this)),this.extensionsDownloader=this._register(K.createInstance(a.ExtensionsDownloader));const Z=this._register(new t.ExtensionsWatcher(this,F,j,B,V));this._register(Z.onDidChangeExtensionsByAnotherSource(({added:G,removed:H})=>{G.length&&this._onDidInstallExtensions.fire(G.map(re=>({identifier:re.identifier,operation:0,local:re}))),H.forEach(re=>this._onDidUninstallExtension.fire({identifier:re}))}))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(async()=>{const M=await this.isAlpineLinux(),q=(0,b.getTargetPlatform)(M?"alpine":i.platform,P.arch);return this.logService.debug("ExtensionManagementService#TargetPlatform:",q),q})()),this._targetPlatformPromise}async isAlpineLinux(){if(!i.isLinux)return!1;let M;try{M=(await this.fileService.readFile(I.URI.file("/etc/os-release"))).value.toString()}catch(q){try{M=(await this.fileService.readFile(I.URI.file("/usr/lib/os-release"))).value.toString()}catch(B){this.logService.debug("Error while getting the os-release file.",(0,L.getErrorMessage)(B))}}return!!M&&(M.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async zip(M){this.logService.trace("ExtensionManagementService#zip",M.identifier.id);const q=await this.collectFiles(M),B=await(0,p.zip)((0,S.joinPath)(this.environmentService.tmpDir,(0,E.generateUuid)()).fsPath,q);return I.URI.file(B)}async unzip(M){return this.logService.trace("ExtensionManagementService#unzip",M.toString()),(await this.install(M)).identifier}async getManifest(M){const q=await this.downloadVsix(M),B=k.resolve(q.fsPath);return(0,r.getManifest)(B)}getInstalled(M=null){return this.extensionsScanner.scanExtensions(M)}async install(M,q={}){this.logService.trace("ExtensionManagementService#install",M.toString());const B=await this.downloadVsix(M),j=await(0,r.getManifest)(k.resolve(B.fsPath));if(j.engines&&j.engines.vscode&&!(0,s.isEngineValid)(j.engines.vscode,this.productService.version,this.productService.date))throw new Error(h.localize(0,null,(0,g.getGalleryExtensionId)(j.publisher,j.name),this.productService.version));return this.installExtension(j,B,q)}async updateMetadata(M,q){return this.logService.trace("ExtensionManagementService#updateMetadata",M.identifier.id),M=await this.extensionsScanner.saveMetadataForLocalExtension(M,{...M.manifest.__metadata||{},...q}),this.manifestCache.invalidate(),M}async updateExtensionScope(M,q){return this.logService.trace("ExtensionManagementService#updateExtensionScope",M.identifier.id),M=await this.extensionsScanner.saveMetadataForLocalExtension(M,{...M.manifest.__metadata||{},isMachineScoped:q}),this.manifestCache.invalidate(),M}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async downloadVsix(M){if(M.scheme===D.Schemas.file)return M;const q=(0,S.joinPath)(this.environmentService.tmpDir,(0,E.generateUuid)());return await this.downloadService.download(M,q),q}createInstallExtensionTask(M,q,B){return I.URI.isUri(q)?new A(M,q,B,this.galleryService,this.extensionsScanner,this.logService):new N(q,B,this.extensionsDownloader,this.extensionsScanner,this.logService)}createUninstallExtensionTask(M,q){return new z(M,q,this.extensionsScanner)}async collectFiles(M){const q=async j=>{let $=await d.Promises.readdir(j);$=$.map(x=>k.join(j,x));const K=await Promise.all($.map(x=>d.Promises.stat(x)));let F=Promise.resolve([]);return K.forEach((x,V)=>{const Q=$[V];x.isFile()&&(F=F.then(Z=>[...Z,Q])),x.isDirectory()&&(F=F.then(Z=>q(Q).then(G=>[...Z,...G])))}),F};return(await q(M.location.fsPath)).map(j=>({path:`extension/${k.relative(M.location.fsPath,j)}`,localPath:j}))}};U=he([J(0,b.IExtensionGalleryService),J(1,T.ITelemetryService),J(2,f.ILogService),J(3,y.INativeEnvironmentService),J(4,w.IDownloadService),J(5,u.IInstantiationService),J(6,c.IFileService),J(7,v.IProductService),J(8,O.IUriIdentityService)],U),e.ExtensionManagementService=U;class W extends m.AbstractExtensionTask{constructor(M,q,B,j){super();this.identifier=M,this.source=q,this.extensionsScanner=B,this.logService=j,this._operation=1}get operation(){return this._operation}async installExtension(M,q){try{const B=await this.unsetUninstalledAndGetLocal(M.identifierWithVersion);if(B)return M.metadata?this.extensionsScanner.saveMetadataForLocalExtension(B,M.metadata):B}catch(B){throw i.isMacintosh?new b.ExtensionManagementError(h.localize(1,null),b.ExtensionManagementErrorCode.Internal):new b.ExtensionManagementError(h.localize(2,null),b.ExtensionManagementErrorCode.Internal)}return this.extract(M,q)}async unsetUninstalledAndGetLocal(M){if(!await this.isUninstalled(M))return null;this.logService.trace("Removing the extension from uninstalled list:",M.id);const B=await this.extensionsScanner.setInstalled(M);return this.logService.info("Removed the extension from uninstalled list:",M.id),B}async isUninstalled(M){return!!(await this.extensionsScanner.getUninstalledExtensions())[M.key()]}async extract({zipPath:M,identifierWithVersion:q,metadata:B},j){let $=await this.extensionsScanner.extractUserExtension(q,M,B,j);return this.logService.info("Extracting completed.",q.id),$}}class N extends W{constructor(M,q,B,j,$){super(M.identifier,M,j,$);this.gallery=M,this.options=q,this.extensionsDownloader=B}async doRun(M){const B=(await this.extensionsScanner.scanExtensions(null)).find($=>(0,g.areSameExtensions)($.identifier,this.gallery.identifier));B&&(this._operation=2);const j=await this.downloadInstallableExtension(this.gallery,this._operation);j.metadata.isMachineScoped=this.options.isMachineScoped||B?.isMachineScoped,j.metadata.isBuiltin=this.options.isBuiltin||B?.isBuiltin;try{const $=await this.installExtension(j,M);return B&&C.neq(B.manifest.version,this.gallery.version)&&await this.extensionsScanner.setUninstalled(B),$}catch($){throw await this.deleteDownloadedVSIX(j.zipPath),$}}async deleteDownloadedVSIX(M){try{await this.extensionsDownloader.delete(I.URI.file(M))}catch(q){this.logService.warn("Error while deleting the downloaded vsix",M.toString(),(0,L.getErrorMessage)(q))}}async downloadInstallableExtension(M,q){const B={id:M.identifier.uuid,publisherId:M.publisherId,publisherDisplayName:M.publisherDisplayName};let j;try{this.logService.trace("Started downloading extension:",M.identifier.id),j=(await this.extensionsDownloader.downloadExtension(M,q)).fsPath,this.logService.info("Downloaded extension:",M.identifier.id,j)}catch($){throw new b.ExtensionManagementError((0,m.joinErrors)($).message,b.ExtensionManagementErrorCode.Download)}try{const $=await(0,r.getManifest)(j);return{zipPath:j,identifierWithVersion:new g.ExtensionIdentifierWithVersion(M.identifier,$.version),metadata:B}}catch($){throw await this.deleteDownloadedVSIX(j),new b.ExtensionManagementError((0,m.joinErrors)($).message,b.ExtensionManagementErrorCode.Invalid)}}}class A extends W{constructor(M,q,B,j,$,K){super({id:(0,g.getGalleryExtensionId)(M.publisher,M.name)},q,$,K);this.manifest=M,this.location=q,this.options=B,this.galleryService=j}async doRun(M){const q=new g.ExtensionIdentifierWithVersion(this.identifier,this.manifest.version),j=(await this.extensionsScanner.scanExtensions(1)).find(K=>(0,g.areSameExtensions)(this.identifier,K.identifier)),$=await this.getMetadata(this.identifier.id,M);if($.isMachineScoped=this.options.isMachineScoped||j?.isMachineScoped,$.isBuiltin=this.options.isBuiltin||j?.isBuiltin,j)if(this._operation=2,q.equals(new g.ExtensionIdentifierWithVersion(j.identifier,j.manifest.version)))try{await this.extensionsScanner.removeExtension(j,"existing")}catch(K){throw new Error(h.localize(3,null,this.manifest.displayName||this.manifest.name))}else C.gt(j.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(j);else{const K=await this.unsetUninstalledAndGetLocal(q);if(K)try{await this.extensionsScanner.removeExtension(K,"existing")}catch(F){throw new Error(h.localize(4,null,this.manifest.displayName||this.manifest.name))}}return this.installExtension({zipPath:k.resolve(this.location.fsPath),identifierWithVersion:q,metadata:$},M)}async getMetadata(M,q){try{const B=(await this.galleryService.query({names:[M],pageSize:1},q)).firstPage[0];if(B)return{id:B.identifier.uuid,publisherDisplayName:B.publisherDisplayName,publisherId:B.publisherId}}catch(B){}return{}}}class z extends m.AbstractExtensionTask{constructor(M,q,B){super();this.extension=M,this.options=q,this.extensionsScanner=B}async doRun(M){const q=[],B=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const j=new g.ExtensionIdentifierWithVersion(this.extension.identifier,this.extension.manifest.version);q.push(...B.filter($=>j.equals(new g.ExtensionIdentifierWithVersion($.identifier,$.manifest.version))))}else q.push(...B.filter(j=>(0,g.areSameExtensions)(j.identifier,this.extension.identifier)));if(!q.length)throw new Error(h.localize(5,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...q),this.options.remove)for(const j of q)try{M.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(j)}catch($){throw new Error(h.localize(6,null,(0,R.toErrorMessage)($)))}}}}),define(te[240],ne([0,1,81,57,33,19,9,3,2,10,4,29,34,71,250]),function(X,e,R,L,D,k,i,P,S,C,I,E,d,p,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class w{constructor(u){this.socket=u,this._errorListener=f=>{if(f){if(f.code==="EPIPE")return;(0,i.onUnexpectedError)(f)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(u){const f=v=>u(k.VSBuffer.wrap(v));return this.socket.on("data",f),{dispose:()=>this.socket.off("data",f)}}onClose(u){const f=v=>{u({type:0,hadError:v,error:void 0})};return this.socket.on("close",f),{dispose:()=>this.socket.off("close",f)}}onEnd(u){return this.socket.on("end",u),{dispose:()=>this.socket.off("end",u)}}write(u){if(!this.socket.destroyed)try{this.socket.write(u.buffer,f=>{if(f){if(f.code==="EPIPE")return;(0,i.onUnexpectedError)(f)}})}catch(f){if(f.code==="EPIPE")return;(0,i.onUnexpectedError)(f)}}end(){this.socket.end()}drain(){return new Promise((u,f)=>{if(this.socket.bufferSize===0){u();return}const v=()=>{this.socket.off("close",v),this.socket.off("end",v),this.socket.off("error",v),this.socket.off("timeout",v),this.socket.off("drain",v),u()};this.socket.on("close",v),this.socket.on("end",v),this.socket.on("error",v),this.socket.on("timeout",v),this.socket.on("drain",v)})}}e.NodeSocket=w;var y;(function(c){c[c.MinHeaderByteSize=2]="MinHeaderByteSize"})(y||(y={}));var m;(function(c){c[c.PeekHeader=1]="PeekHeader",c[c.ReadHeader=2]="ReadHeader",c[c.ReadBody=3]="ReadBody",c[c.Fin=4]="Fin"})(m||(m={}));class b extends S.Disposable{constructor(u,f,v,T){super();this._onDidZlibFlush=this._register(new P.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new P.Emitter),this._onClose=this._register(new P.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=u,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=f,this._recordInflateBytes=T,f?(this._zlibInflate=h.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",O=>{console.error(O),(0,i.onUnexpectedError)(O),this._onClose.fire({type:0,hadError:!0,error:O})}),this._zlibInflate.on("data",O=>{this._pendingInflateData.push(O)}),v&&(this._zlibInflate.write(v.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=h.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",O=>{console.error(O),(0,i.onUnexpectedError)(O),this._onClose.fire({type:0,hadError:!0,error:O})}),this._zlibDeflate.on("data",O=>{this._pendingDeflateData.push(O)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new p.ChunkStream,this._register(this.socket.onData(O=>this._acceptChunk(O))),this._register(this.socket.onClose(O=>this._onClose.fire(O)))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?k.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):k.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(u){return this._onData.event(u)}onClose(u){return this._onClose.event(u)}onEnd(u){return this.socket.onEnd(u)}write(u){this._totalOutgoingDataBytes+=u.byteLength,this._zlibDeflate?(this._zlibDeflate.write(u.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let f=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,f=f.slice(0,f.length-4),this._isEnded||this._write(k.VSBuffer.wrap(f),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(u,!1)}_write(u,f){let v=2;u.byteLength<126?v+=0:u.byteLength<2**16?v+=2:v+=8;const T=k.VSBuffer.alloc(v);if(f?T.writeUInt8(194,0):T.writeUInt8(130,0),u.byteLength<126)T.writeUInt8(u.byteLength,1);else if(u.byteLength<2**16){T.writeUInt8(126,1);let O=1;T.writeUInt8(u.byteLength>>>8&255,++O),T.writeUInt8(u.byteLength>>>0&255,++O)}else{T.writeUInt8(127,1);let O=1;T.writeUInt8(0,++O),T.writeUInt8(0,++O),T.writeUInt8(0,++O),T.writeUInt8(0,++O),T.writeUInt8(u.byteLength>>>24&255,++O),T.writeUInt8(u.byteLength>>>16&255,++O),T.writeUInt8(u.byteLength>>>8&255,++O),T.writeUInt8(u.byteLength>>>0&255,++O)}this._totalOutgoingWireBytes+=T.byteLength+u.byteLength,this.socket.write(k.VSBuffer.concat([T,u]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(u){if(u.byteLength!==0){for(this._totalIncomingWireBytes+=u.byteLength,this._incomingData.acceptChunk(u);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const f=this._incomingData.peek(this._state.readLen),v=f.readUInt8(0),T=(v&128)>>>7,O=(v&64)>>>6,U=f.readUInt8(1),W=(U&128)>>>7,N=U&127;this._state.state=2,this._state.readLen=2+(W?4:0)+(N===126?2:0)+(N===127?8:0),this._state.fin=T,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(O)),this._state.firstFrameOfMessage=Boolean(T),this._state.mask=0}else if(this._state.state===2){const f=this._incomingData.read(this._state.readLen),v=f.readUInt8(1),T=(v&128)>>>7;let O=v&127,U=1;O===126?O=f.readUInt8(++U)*2**8+f.readUInt8(++U):O===127&&(O=f.readUInt8(++U)*0+f.readUInt8(++U)*0+f.readUInt8(++U)*0+f.readUInt8(++U)*0+f.readUInt8(++U)*2**24+f.readUInt8(++U)*2**16+f.readUInt8(++U)*2**8+f.readUInt8(++U));let W=0;T&&(W=f.readUInt8(++U)*2**24+f.readUInt8(++U)*2**16+f.readUInt8(++U)*2**8+f.readUInt8(++U)),this._state.state=3,this._state.readLen=O,this._state.mask=W}else if(this._state.state===3){const f=this._incomingData.read(this._state.readLen);g(f,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate&&this._state.compressed?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(f.buffer)),this._zlibInflate.write(f.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const v=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=v.length,this._onData.fire(k.VSBuffer.wrap(v))})):(this._totalIncomingDataBytes+=f.byteLength,this._onData.fire(f))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await P.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=b;function g(c,u){if(u===0)return;let f=c.byteLength>>>2;for(let N=0;N<f;N++){const A=c.readUInt32BE(N*4);c.writeUInt32BE(A^u,N*4)}let v=f*4,T=c.byteLength-v;const O=u>>>24&255,U=u>>>16&255,W=u>>>8&255;T>=1&&c.writeUInt8(c.readUInt8(v)^O,v),T>=2&&c.writeUInt8(c.readUInt8(v+1)^U,v+1),T>=3&&c.writeUInt8(c.readUInt8(v+2)^W,v+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const a={[2]:107,[1]:103};function l(){const c=(0,E.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${c}-sock`;let u;return e.XDG_RUNTIME_DIR?u=(0,C.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${c}.sock`):u=(0,C.join)((0,D.tmpdir)(),`vscode-ipc-${c}.sock`),o(u),u}e.createRandomIPCHandle=l;function r(c,u,f){const v=(0,R.createHash)("md5").update(c).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${v}-${f}-${u}-sock`;let T;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?T=(0,C.join)(e.XDG_RUNTIME_DIR,`vscode-${v.substr(0,8)}-${f}-${u}.sock`):T=(0,C.join)(c,`${f}-${u}.sock`),o(T),T}e.createStaticIPCHandle=r;function o(c){const u=a[I.platform];typeof u=="number"&&c.length>=u&&console.warn(`WARNING: IPC handle "${c}" is longer than ${u} chars, try a shorter --user-data-dir`)}class n extends d.IPCServer{constructor(u){super(n.toClientConnectionEvent(u));this.server=u}static toClientConnectionEvent(u){const f=P.Event.fromNodeEventEmitter(u,"connection");return P.Event.map(f,v=>({protocol:new p.Protocol(new w(v)),onDidClientDisconnect:P.Event.once(P.Event.fromNodeEventEmitter(v,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=n;function t(c){return new Promise((u,f)=>{const v=(0,L.createServer)();v.on("error",f),v.listen(c,()=>{v.removeListener("error",f),u(new n(v))})})}e.serve=t;function s(c,u){return new Promise((f,v)=>{const T=(0,L.createConnection)(c,()=>{T.removeListener("error",v),f(p.Client.fromSocket(new w(T),u))});T.once("error",v)})}e.connect=s}),define(te[241],ne([0,1,57,240]),function(X,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(D,k,i,P){const S=I=>P(I,void 0),C=R.createConnection({host:D,port:k},()=>{C.removeListener("error",S);const I=Buffer.alloc(16);for(let h=0;h<16;h++)I[h]=Math.round(Math.random()*256);const E=I.toString("base64");let d=[`GET ws://${/:/.test(D)?`[${D}]`:D}:${k}/?${i}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${E}`];C.write(d.join(`\r
`)+`\r
\r
`);const p=h=>{h.toString().indexOf(`\r
\r
`)>=0&&(C.off("data",p),P(void 0,new L.NodeSocket(C)))};C.on("data",p)});C.once("error",S)}}}),define(te[242],ne([0,1,57,115,241,5,2,21,8,26,184,62,91]),function(X,e,R,L,D,k,i,P,S,C,I,E,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function p(b,g,a,l,r){let o;for(let n=3;n&&(o&&o.dispose(),o=await new h(b,g,a,l,r).waitForReady(),!(r&&L.BROWSER_RESTRICTED_PORTS[r]||!L.BROWSER_RESTRICTED_PORTS[o.tunnelLocalPort]));n--);return o}class h extends i.Disposable{constructor(g,a,l,r,o){super();this.defaultTunnelHost=a,this.suggestedLocalPort=o,this.privacy=E.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=g,this._server=R.createServer(),this._barrier=new k.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=n=>this._onConnection(n),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=r,this.tunnelRemoteHost=l}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(a=>{a()})}async waitForReady(){let g=await(0,L.findFreePortFaster)(this.suggestedLocalPort??this.tunnelRemotePort,2,1e3),a=null;return this._server.listen(g,this.defaultTunnelHost),await this._barrier.wait(),a=this._server.address(),a||(g=0,this._server.listen(g,this.defaultTunnelHost),await this._barrier.wait(),a=this._server.address()),this.tunnelLocalPort=a.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${a.port}`,this}async _onConnection(g){g.pause();const a=(0,E.isLocalhost)(this.tunnelRemoteHost)||(0,E.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,l=await(0,I.connectRemoteAgentTunnel)(this._options,a,this.tunnelRemotePort),r=l.getSocket().socket,o=l.readEntireBuffer();l.dispose(),o.byteLength>0&&g.write(o.buffer),g.on("end",()=>{this._socketsDispose.delete(g.localAddress),r.end()}),g.on("close",()=>r.end()),g.on("error",()=>{this._socketsDispose.delete(g.localAddress),r.destroy()}),r.on("end",()=>g.end()),r.on("close",()=>g.end()),r.on("error",()=>{g.destroy()}),g.pipe(r),r.pipe(g),this._socketsDispose.set(g.localAddress,()=>{g.end(),r.end()})}}let w=class extends E.AbstractTunnelService{constructor(g,a,l,r,o){super(a);this.socketFactory=g,this.signService=l,this.productService=r,this.configurationService=o}get defaultTunnelHost(){const g=this.configurationService.getValue("remote.localPortHost");return!g||g==="localhost"?"127.0.0.1":"0.0.0.0"}retainOrCreateTunnel(g,a,l,r,o,n,t){const s=this.getTunnelFromMap(a,l);if(s)return++s.refcount,s.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,a,l,r,o,n,t);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${a}:${l} on local port ${r}.`);const c={commit:this.productService.commit,socketFactory:this.socketFactory,addressProvider:g,signService:this.signService,logService:this.logService,ipcLogger:null},u=p(c,this.defaultTunnelHost,a,l,r);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(a,l,u),u}}};w=he([J(1,S.ILogService),J(2,d.ISignService),J(3,C.IProductService),J(4,P.IConfigurationService)],w),e.BaseTunnelService=w;let y=class extends w{constructor(g,a,l,r){super(D.nodeSocketFactory,g,a,l,r)}};y=he([J(0,S.ILogService),J(1,d.ISignService),J(2,C.IProductService),J(3,P.IConfigurationService)],y),e.TunnelService=y;let m=class extends i.Disposable{constructor(g,a,l,r){super();this.logService=g,this.productService=a,this.signService=l,this.configurationService=r,this._tunnelServices=new Map}async openTunnel(g,a,l,r,o,n,t,s){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${l}:${r} on local port ${o}.`),!this._tunnelServices.has(g)){const c=new y(this.logService,this.signService,this.productService,this.configurationService);this._register(c),this._tunnelServices.set(g,c),c.onTunnelClosed(async()=>{(await c.tunnels).length===0&&(c.dispose(),this._tunnelServices.delete(g))})}return this._tunnelServices.get(g).openTunnel(a,l,r,o,n,t,s)}};m=he([J(0,S.ILogService),J(1,C.IProductService),J(2,d.ISignService),J(3,P.IConfigurationService)],m),e.SharedTunnelsService=m}),define(te[251],ne([0,1,72,33,38,9,2,15,18,7,34,119,180,161,181,172,173,174,159,163,21,182,78,201,79,192,11,154,197,205,30,162,203,239,80,157,14,177,179,53,6,169,83,170,171,59,188,8,85,60,86,26,191,43,23,199,200,22,92,93,94,44,206,207,95,209,215,97,98,99,24,63,228,229,230,64,231,232,233,234,235,236,91,196,62,242,189,190,90,195,84,204,37,217]),function(X,e,R,L,D,k,i,P,S,C,I,E,d,p,h,w,y,m,b,g,a,l,r,o,n,t,s,c,u,f,v,T,O,U,W,N,A,z,_,M,q,B,j,$,K,F,x,V,Q,Z,G,H,re,ie,ce,le,de,pe,be,Ie,Se,ke,Pe,Ue,qe,Fe,ze,xe,ee,oe,ae,ve,we,_e,Re,Y,se,ue,fe,ge,Ce,Te,Le,ye,Ee,De,Ae,Me,Xe,Ke,Ve,Ct,It,Pt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class Dt extends i.Disposable{constructor(me){super();this.configuration=me,this.server=this._register(new E.Server),this.sharedProcessWorkerService=void 0,this.registerListeners()}registerListeners(){const me=()=>this.dispose();process.once("exit",me),R.ipcRenderer.once("vscode:electron-main->shared-process=exit",me);const Oe="vscode:electron-main->shared-process=disposeWorker",$e=(He,Ne)=>this.onDisposeWorker(Ne);R.ipcRenderer.on(Oe,$e),this._register((0,i.toDisposable)(()=>R.ipcRenderer.removeListener(Oe,$e)))}onDisposeWorker(me){this.sharedProcessWorkerService?.disposeWorker(me)}async open(){const me=await this.initServices();(0,ae.registerConfiguration)(),me.invokeFunction(Oe=>{const $e=Oe.get(V.ILogService);$e.trace("sharedProcess configuration",JSON.stringify(this.configuration)),this.initChannels(Oe),this.registerErrorHandler($e)}),this._register((0,i.combinedDisposable)(me.createInstance(d.CodeCacheCleaner,this.configuration.codeCachePath),me.createInstance(h.LanguagePackCachedDataCleaner),me.createInstance(m.StorageDataCleaner,this.configuration.backupWorkspacesPath),me.createInstance(y.LogsDataCleaner),me.createInstance(w.LocalizationsUpdater),me.createInstance(p.DeprecatedExtensionsCleaner)))}async initServices(){const me=new j.ServiceCollection,Oe={_serviceBrand:void 0,...G.default};me.set(H.IProductService,Oe);const $e=new I.StaticRouter(je=>je==="main"),He=new $.MessagePortMainProcessService(this.server,$e);me.set(K.IMainProcessService,He);const Ne=new c.NativeEnvironmentService(this.configuration.args,Oe);me.set(s.INativeEnvironmentService,Ne);const rt=new Q.LogLevelChannelClient(this.server.getChannel("logLevel",$e)),Qe=new Q.LoggerChannelClient(this.configuration.logLevel,rt.onDidChangeLogLevel,He.getChannel("logger"));me.set(V.ILoggerService,Qe);const at=this._register(new V.MultiplexLogService([this._register(new V.ConsoleLogger(this.configuration.logLevel)),this._register(Qe.createLogger((0,S.joinPath)(C.URI.file(Ne.logsPath),"sharedprocess.log"),{name:"sharedprocess"}))])),Ye=this._register(new Q.FollowerLogService(rt,at));me.set(V.ILogService,Ye),this.sharedProcessWorkerService=new Ke.SharedProcessWorkerService(Ye,Oe,Ne),me.set(Xe.ISharedProcessWorkerService,this.sharedProcessWorkerService);const Je=this._register(new z.FileService(Ye));me.set(A.IFileService,Je);const ct=this._register(new _.DiskFileSystemProvider(Ye));Je.registerProvider(P.Schemas.file,ct);const We=this._register(new l.ConfigurationService(Ne.settingsResource,Je));me.set(a.IConfigurationService,We);const tt=new le.NativeStorageService(void 0,He,Ne);me.set(ce.IStorageService,tt),this._register((0,i.toDisposable)(()=>tt.flush())),await Promise.all([We.initialize(),tt.initialize()]),me.set(Ve.IUserConfigurationFileService,I.ProxyChannel.toService(He.getChannel(Ve.UserConfigurationFileServiceId))),me.set(It.IUriIdentityService,new Pt.UriIdentityService(Je)),me.set(ie.IRequestService,new M.SyncDescriptor(re.RequestService)),me.set(b.IChecksumService,new M.SyncDescriptor(g.ChecksumService));const st=I.ProxyChannel.toService(He.getChannel("nativeHost"),{context:this.configuration.windowId});me.set(Z.INativeHostService,st),me.set(n.IDownloadService,new M.SyncDescriptor(t.DownloadService));const lt=this._register(new Te.ActiveWindowManager(st)),ut=new I.StaticRouter(je=>lt.getActiveClientId().then(dt=>je===dt));me.set(W.IExtensionRecommendationNotificationService,new N.ExtensionRecommendationNotificationServiceChannelClient(this.server.getChannel("extensionRecommendationNotification",ut)));const ht=new Ct.AssignmentService(this.configuration.machineId,We,Oe);let nt;const Ze=[];if((0,ke.supportsTelemetry)(Oe,Ne)){const je=new Ie.TelemetryLogAppender(Qe,Ne);Ze.push(je);const{appRoot:dt,extensionsPath:Tt,installSourcePath:Lt}=Ne;if(Oe.aiConfig&&Oe.aiConfig.asimovKey){const ot=await ht.getTreatment("telemetryMigration")??!1,ft=Oe.quality!=="stable";if(ft&&ot){const wt=new Pe.AppInsightsAppender("monacoworkbench",null,Oe.aiConfig.asimovKey,ot,!0);this._register((0,i.toDisposable)(()=>wt.flush())),Ze.push(wt)}const St=new Pe.AppInsightsAppender("monacoworkbench",null,Oe.aiConfig.asimovKey,ft?!1:ot,ot&&ft);this._register((0,i.toDisposable)(()=>St.flush())),Ze.push(St)}nt=new Se.TelemetryService({appenders:Ze,commonProperties:(0,de.resolveCommonProperties)(Je,(0,L.release)(),(0,L.hostname)(),process.arch,Oe.commit,Oe.version,this.configuration.machineId,Oe.msftInternalDomains,Lt),sendErrorTelemetry:!0,piiPaths:[dt,Tt]},We)}else{nt=ke.NullTelemetryService;const je=ke.NullAppender;Ze.push(je)}this.server.registerChannel("telemetryAppender",new be.TelemetryAppenderChannel(Ze)),me.set(pe.ITelemetryService,nt);const kt=new Ue.CustomEndpointTelemetryService(We,nt,Qe,Ne);me.set(pe.ICustomEndpointTelemetryService,kt),me.set(v.IExtensionManagementService,new M.SyncDescriptor(U.ExtensionManagementService)),me.set(v.IExtensionGalleryService,new M.SyncDescriptor(f.ExtensionGalleryService)),me.set(v.IExtensionTipsService,new M.SyncDescriptor(O.ExtensionTipsService)),me.set(F.ILocalizationsService,new M.SyncDescriptor(x.LocalizationsService)),me.set(r.IDiagnosticsService,new M.SyncDescriptor(o.DiagnosticsService)),me.set(ve.IUserDataSyncAccountService,new M.SyncDescriptor(ve.UserDataSyncAccountService)),me.set(ae.IUserDataSyncLogService,new M.SyncDescriptor(Re.UserDataSyncLogService)),me.set(ae.IUserDataSyncUtilService,new _e.UserDataSyncUtilServiceClient(this.server.getChannel("userDataSyncUtil",je=>je.ctx!=="main"))),me.set(v.IGlobalExtensionEnablementService,new M.SyncDescriptor(u.GlobalExtensionEnablementService)),me.set(ee.IIgnoredExtensionsManagementService,new M.SyncDescriptor(ee.IgnoredExtensionsManagementService)),me.set(xe.IExtensionsStorageSyncService,new M.SyncDescriptor(xe.ExtensionsStorageSyncService)),me.set(ae.IUserDataSyncStoreManagementService,new M.SyncDescriptor(ge.UserDataSyncStoreManagementService)),me.set(ae.IUserDataSyncStoreService,new M.SyncDescriptor(ge.UserDataSyncStoreService)),me.set(Y.IUserDataSyncMachinesService,new M.SyncDescriptor(Y.UserDataSyncMachinesService)),me.set(ae.IUserDataSyncBackupStoreService,new M.SyncDescriptor(we.UserDataSyncBackupStoreService)),me.set(ae.IUserDataAutoSyncEnablementService,new M.SyncDescriptor(oe.UserDataAutoSyncEnablementService)),me.set(ae.IUserDataSyncResourceEnablementService,new M.SyncDescriptor(se.UserDataSyncResourceEnablementService)),me.set(ae.IUserDataSyncService,new M.SyncDescriptor(ue.UserDataSyncService));const yt=new ze.PtyHostService({graceTime:6e4,shortGraceTime:6e3,scrollback:We.getValue("terminal.integrated.persistentSessionScrollback")??100},We,Ne,Ye,nt);return await yt.initialize(),me.set(Fe.ILocalPtyService,this._register(yt)),me.set(Le.ISignService,new M.SyncDescriptor(ye.SignService)),me.set(Ee.ISharedTunnelsService,new M.SyncDescriptor(De.SharedTunnelsService)),me.set(Ae.ISharedProcessTunnelService,new M.SyncDescriptor(Me.SharedProcessTunnelService)),new B.InstantiationService(me)}initChannels(me){const Oe=new T.ExtensionManagementChannel(me.get(v.IExtensionManagementService),()=>null);this.server.registerChannel("extensions",Oe);const $e=I.ProxyChannel.fromService(me.get(F.ILocalizationsService));this.server.registerChannel("localizations",$e);const He=I.ProxyChannel.fromService(me.get(r.IDiagnosticsService));this.server.registerChannel("diagnostics",He);const Ne=new T.ExtensionTipsChannel(me.get(v.IExtensionTipsService));this.server.registerChannel("extensionTipsService",Ne);const rt=I.ProxyChannel.fromService(me.get(b.IChecksumService));this.server.registerChannel("checksum",rt);const Qe=new _e.UserDataSyncMachinesServiceChannel(me.get(Y.IUserDataSyncMachinesService));this.server.registerChannel("userDataSyncMachines",Qe);const at=I.ProxyChannel.fromService(me.get(pe.ICustomEndpointTelemetryService));this.server.registerChannel("customEndpointTelemetry",at);const Ye=new _e.UserDataSyncAccountServiceChannel(me.get(ve.IUserDataSyncAccountService));this.server.registerChannel("userDataSyncAccount",Ye);const Je=new _e.UserDataSyncStoreManagementServiceChannel(me.get(ae.IUserDataSyncStoreManagementService));this.server.registerChannel("userDataSyncStoreManagement",Je);const ct=new fe.UserDataSyncChannel(me.get(ae.IUserDataSyncService),me.get(V.ILogService));this.server.registerChannel("userDataSync",ct);const We=this._register(me.get(q.IInstantiationService).createInstance(Ce.UserDataAutoSyncService)),tt=new _e.UserDataAutoSyncChannel(We);this.server.registerChannel("userDataAutoSync",tt);const st=me.get(Fe.ILocalPtyService),lt=I.ProxyChannel.fromService(st);this.server.registerChannel(qe.TerminalIpcChannels.LocalPty,lt);const ut=I.ProxyChannel.fromService(me.get(Ae.ISharedProcessTunnelService));this.server.registerChannel(Ae.ipcSharedProcessTunnelChannelName,ut);const ht=I.ProxyChannel.fromService(me.get(Xe.ISharedProcessWorkerService));this.server.registerChannel(Xe.ipcSharedProcessWorkerChannelName,ht)}registerErrorHandler(me){window.addEventListener("unhandledrejection",Oe=>{(0,k.onUnexpectedError)(Oe.reason),Oe.preventDefault()}),(0,k.setUnexpectedErrorHandler)(Oe=>{const $e=(0,D.toErrorMessage)(Oe,!0);!$e||me.error(`[uncaught exception in sharedProcess]: ${$e}`)})}}async function Rt(pt){const me=new Dt(pt);R.ipcRenderer.send("vscode:shared-process->electron-main=ipc-ready"),await me.open(),R.ipcRenderer.send("vscode:shared-process->electron-main=init-done")}e.main=Rt})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/4e303fcc52269ab578affa6cb1eb455eacab445f/core/vs/code/electron-browser/sharedProcess/sharedProcessMain.js.map
