/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var we=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/base/common/strings","vs/base/common/types","vs/base/common/network","vs/platform/log/common/log","vs/workbench/api/common/extHostRpcService","vs/base/common/async","vs/base/common/errors","vs/base/common/arrays","vs/base/common/path","vs/nls","vs/nls!vs/workbench/services/extensions/worker/extensionHostWorker","vs/base/common/cancellation","vs/base/common/map","vs/base/common/buffer","vs/base/common/resources","vs/base/common/platform","vs/base/common/objects","vs/platform/extensions/common/extensions","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/glob","vs/platform/registry/common/platform","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/severity","vs/base/common/uuid","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostTerminalService","vs/workbench/services/search/common/search","vs/base/common/assert","vs/base/common/extpath","vs/editor/common/core/range","vs/base/common/errorMessage","vs/platform/contextkey/common/contextkey","vs/platform/files/common/files","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostWebview","vs/base/common/decorators","vs/base/common/idGenerator","vs/base/common/codicons","vs/base/common/marshalling","vs/editor/common/modes/languageSelector","vs/platform/instantiation/common/extensions","vs/base/common/hash","vs/editor/common/modes","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/theme/common/themeService","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/shared/webview","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/collections","vs/base/common/numbers","vs/base/common/htmlContent","vs/base/common/labels","vs/base/common/mime","vs/editor/common/model","vs/editor/common/services/semanticTokensDto","vs/platform/instantiation/common/descriptors","vs/platform/markers/common/markers","vs/platform/configuration/common/configuration","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testCollection","vs/base/common/process","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/lazy","vs/base/common/stream","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/model/textModelSearch","vs/editor/common/core/position","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/tokenizationRegistry","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/model/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/opener/common/opener","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/remote/common/tunnel","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/shared/treeDataTransfer","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debugUtils","vs/base/common/iterator","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/output/common/output","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostLogService","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/base/common/stopwatch","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/editor/common/core/characterClassifier","vs/editor/common/model/mirrorTextModel","vs/editor/common/viewModel/prefixSumComputer","vs/base/common/marked/marked","vs/base/common/linkedList","vs/editor/common/modes/linkComputer","vs/editor/common/core/selection","vs/base/common/functional","vs/workbench/services/extensions/worker/extensionHostWorker"],Ee=function(re){for(var e=[],u=0,M=re.length;u<M;u++)e[u]=we[re[u]];return e};define(we[41],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function u(M,w){if(!M)throw new Error(w?`Assertion failed (${w})`:"Assertion Failed")}e.ok=u}),define(we[75],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const u=Object.prototype.hasOwnProperty;function M(F){const _=[];for(let n in F)u.call(F,n)&&_.push(F[n]);return _}e.values=M;function w(F,_){for(let n in F)if(u.call(F,n)&&_({key:n,value:F[n]},function(){delete F[n]})===!1)return}e.forEach=w;function A(F,_){const n=Object.create(null);for(const g of F){const a=_(g);let c=n[a];c||(c=n[a]=[]),c.push(g)}return n}e.groupBy=A;function t(F){const _=Object.create(null);return F&&F.forEach((n,g)=>{_[g]=n}),_}e.fromMap=t;function T(F,_){const n=[],g=[];for(let a of F)_.has(a)||n.push(a);for(let a of _)F.has(a)||g.push(a);return{removed:n,added:g}}e.diffSets=T;function C(F,_){const n=[],g=[];for(let[a,c]of F)_.has(a)||n.push(c);for(let[a,c]of _)F.has(a)||g.push(c);return{removed:n,added:g}}e.diffMaps=C;class k{constructor(){this.map=new Map}add(_,n){let g=this.map.get(_);g||(g=new Set,this.map.set(_,g)),g.add(n)}delete(_,n){const g=this.map.get(_);!g||(g.delete(n),g.size===0&&this.map.delete(_))}forEach(_,n){const g=this.map.get(_);!g||g.forEach(n)}}e.SetMap=k}),define(we[52],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function u(t){return(T,C,k)=>{let F=null,_=null;if(typeof k.value=="function"?(F="value",_=k.value):typeof k.get=="function"&&(F="get",_=k.get),!_)throw new Error("not supported");k[F]=t(_,C)}}e.createDecorator=u;function M(t,T,C){let k=null,F=null;if(typeof C.value=="function"?(k="value",F=C.value,F.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof C.get=="function"&&(k="get",F=C.get),!F)throw new Error("not supported");const _=`$memoize$${T}`;C[k]=function(...n){return this.hasOwnProperty(_)||Object.defineProperty(this,_,{configurable:!1,enumerable:!1,writable:!1,value:F.apply(this,n)}),this[_]}}e.memoize=M;function w(t,T,C){return u((k,F)=>{const _=`$debounce$${F}`,n=`$debounce$result$${F}`;return function(...g){this[n]||(this[n]=C?C():void 0),clearTimeout(this[_]),T&&(this[n]=T(this[n],...g),g=[this[n]]),this[_]=setTimeout(()=>{k.apply(this,g),this[n]=C?C():void 0},t)}})}e.debounce=w;function A(t,T,C){return u((k,F)=>{const _=`$throttle$timer$${F}`,n=`$throttle$result$${F}`,g=`$throttle$lastRun$${F}`,a=`$throttle$pending$${F}`;return function(...c){if(this[n]||(this[n]=C?C():void 0),(this[g]===null||this[g]===void 0)&&(this[g]=-Number.MAX_VALUE),T&&(this[n]=T(this[n],...c)),this[a])return;const p=this[g]+t;p<=Date.now()?(this[g]=Date.now(),k.apply(this,[this[n]]),this[n]=C?C():void 0):(this[a]=!0,this[_]=setTimeout(()=>{this[a]=!1,this[g]=Date.now(),k.apply(this,[this[n]]),this[n]=C?C():void 0},p-Date.now()))}})}e.throttle=A}),define(we[53],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class u{constructor(w){this._prefix=w,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=u,e.defaultGenerator=new u("id#")}),define(we[101],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var u;(function(s){s[s.None=0]="None",s[s.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=2]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",s[s.InvalidUnicode=4]="InvalidUnicode",s[s.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",s[s.InvalidCharacter=6]="InvalidCharacter"})(u=e.ScanError||(e.ScanError={}));var M;(function(s){s[s.OpenBraceToken=1]="OpenBraceToken",s[s.CloseBraceToken=2]="CloseBraceToken",s[s.OpenBracketToken=3]="OpenBracketToken",s[s.CloseBracketToken=4]="CloseBracketToken",s[s.CommaToken=5]="CommaToken",s[s.ColonToken=6]="ColonToken",s[s.NullKeyword=7]="NullKeyword",s[s.TrueKeyword=8]="TrueKeyword",s[s.FalseKeyword=9]="FalseKeyword",s[s.StringLiteral=10]="StringLiteral",s[s.NumericLiteral=11]="NumericLiteral",s[s.LineCommentTrivia=12]="LineCommentTrivia",s[s.BlockCommentTrivia=13]="BlockCommentTrivia",s[s.LineBreakTrivia=14]="LineBreakTrivia",s[s.Trivia=15]="Trivia",s[s.Unknown=16]="Unknown",s[s.EOF=17]="EOF"})(M=e.SyntaxKind||(e.SyntaxKind={}));var w;(function(s){s[s.InvalidSymbol=1]="InvalidSymbol",s[s.InvalidNumberFormat=2]="InvalidNumberFormat",s[s.PropertyNameExpected=3]="PropertyNameExpected",s[s.ValueExpected=4]="ValueExpected",s[s.ColonExpected=5]="ColonExpected",s[s.CommaExpected=6]="CommaExpected",s[s.CloseBraceExpected=7]="CloseBraceExpected",s[s.CloseBracketExpected=8]="CloseBracketExpected",s[s.EndOfFileExpected=9]="EndOfFileExpected",s[s.InvalidCommentToken=10]="InvalidCommentToken",s[s.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=12]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",s[s.InvalidUnicode=14]="InvalidUnicode",s[s.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",s[s.InvalidCharacter=16]="InvalidCharacter"})(w=e.ParseErrorCode||(e.ParseErrorCode={}));var A;(function(s){s.DEFAULT={allowTrailingComma:!0}})(A=e.ParseOptions||(e.ParseOptions={}));function t(s,I=!1){let r=0,i=s.length,v="",m=0,o=16,b=0;function d(x){let N=0,V=0;for(;N<x;){const B=s.charCodeAt(r);if(B>=48&&B<=57)V=V*16+B-48;else if(B>=65&&B<=70)V=V*16+B-65+10;else if(B>=97&&B<=102)V=V*16+B-97+10;else break;r++,N++}return N<x&&(V=-1),V}function E(x){r=x,v="",m=0,o=16,b=0}function R(){const x=r;if(s.charCodeAt(r)===48)r++;else for(r++;r<s.length&&k(s.charCodeAt(r));)r++;if(r<s.length&&s.charCodeAt(r)===46)if(r++,r<s.length&&k(s.charCodeAt(r)))for(r++;r<s.length&&k(s.charCodeAt(r));)r++;else return b=3,s.substring(x,r);let N=r;if(r<s.length&&(s.charCodeAt(r)===69||s.charCodeAt(r)===101))if(r++,(r<s.length&&s.charCodeAt(r)===43||s.charCodeAt(r)===45)&&r++,r<s.length&&k(s.charCodeAt(r))){for(r++;r<s.length&&k(s.charCodeAt(r));)r++;N=r}else b=3;return s.substring(x,N)}function P(){let x="",N=r;for(;;){if(r>=i){x+=s.substring(N,r),b=2;break}const V=s.charCodeAt(r);if(V===34){x+=s.substring(N,r),r++;break}if(V===92){if(x+=s.substring(N,r),r++,r>=i){b=2;break}switch(s.charCodeAt(r++)){case 34:x+='"';break;case 92:x+="\\";break;case 47:x+="/";break;case 98:x+="\b";break;case 102:x+="\f";break;case 110:x+=`
`;break;case 114:x+="\r";break;case 116:x+="	";break;case 117:const $=d(4);$>=0?x+=String.fromCharCode($):b=4;break;default:b=5}N=r;continue}if(V>=0&&V<=31)if(C(V)){x+=s.substring(N,r),b=2;break}else b=6;r++}return x}function z(){if(v="",b=0,m=r,r>=i)return m=i,o=17;let x=s.charCodeAt(r);if(T(x)){do r++,v+=String.fromCharCode(x),x=s.charCodeAt(r);while(T(x));return o=15}if(C(x))return r++,v+=String.fromCharCode(x),x===13&&s.charCodeAt(r)===10&&(r++,v+=`
`),o=14;switch(x){case 123:return r++,o=1;case 125:return r++,o=2;case 91:return r++,o=3;case 93:return r++,o=4;case 58:return r++,o=6;case 44:return r++,o=5;case 34:return r++,v=P(),o=10;case 47:const N=r-1;if(s.charCodeAt(r+1)===47){for(r+=2;r<i&&!C(s.charCodeAt(r));)r++;return v=s.substring(N,r),o=12}if(s.charCodeAt(r+1)===42){r+=2;const V=i-1;let B=!1;for(;r<V;){if(s.charCodeAt(r)===42&&s.charCodeAt(r+1)===47){r+=2,B=!0;break}r++}return B||(r++,b=1),v=s.substring(N,r),o=13}return v+=String.fromCharCode(x),r++,o=16;case 45:if(v+=String.fromCharCode(x),r++,r===i||!k(s.charCodeAt(r)))return o=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return v+=R(),o=11;default:for(;r<i&&O(x);)r++,x=s.charCodeAt(r);if(m!==r){switch(v=s.substring(m,r),v){case"true":return o=8;case"false":return o=9;case"null":return o=7}return o=16}return v+=String.fromCharCode(x),r++,o=16}}function O(x){if(T(x)||C(x))return!1;switch(x){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function S(){let x;do x=z();while(x>=12&&x<=15);return x}return{setPosition:E,getPosition:()=>r,scan:I?S:z,getToken:()=>o,getTokenValue:()=>v,getTokenOffset:()=>m,getTokenLength:()=>r-m,getTokenError:()=>b}}e.createScanner=t;function T(s){return s===32||s===9||s===11||s===12||s===160||s===5760||s>=8192&&s<=8203||s===8239||s===8287||s===12288||s===65279}function C(s){return s===10||s===13||s===8232||s===8233}function k(s){return s>=48&&s<=57}var F;(function(s){s[s.nullCharacter=0]="nullCharacter",s[s.maxAsciiCharacter=127]="maxAsciiCharacter",s[s.lineFeed=10]="lineFeed",s[s.carriageReturn=13]="carriageReturn",s[s.lineSeparator=8232]="lineSeparator",s[s.paragraphSeparator=8233]="paragraphSeparator",s[s.nextLine=133]="nextLine",s[s.space=32]="space",s[s.nonBreakingSpace=160]="nonBreakingSpace",s[s.enQuad=8192]="enQuad",s[s.emQuad=8193]="emQuad",s[s.enSpace=8194]="enSpace",s[s.emSpace=8195]="emSpace",s[s.threePerEmSpace=8196]="threePerEmSpace",s[s.fourPerEmSpace=8197]="fourPerEmSpace",s[s.sixPerEmSpace=8198]="sixPerEmSpace",s[s.figureSpace=8199]="figureSpace",s[s.punctuationSpace=8200]="punctuationSpace",s[s.thinSpace=8201]="thinSpace",s[s.hairSpace=8202]="hairSpace",s[s.zeroWidthSpace=8203]="zeroWidthSpace",s[s.narrowNoBreakSpace=8239]="narrowNoBreakSpace",s[s.ideographicSpace=12288]="ideographicSpace",s[s.mathematicalSpace=8287]="mathematicalSpace",s[s.ogham=5760]="ogham",s[s._=95]="_",s[s.$=36]="$",s[s._0=48]="_0",s[s._1=49]="_1",s[s._2=50]="_2",s[s._3=51]="_3",s[s._4=52]="_4",s[s._5=53]="_5",s[s._6=54]="_6",s[s._7=55]="_7",s[s._8=56]="_8",s[s._9=57]="_9",s[s.a=97]="a",s[s.b=98]="b",s[s.c=99]="c",s[s.d=100]="d",s[s.e=101]="e",s[s.f=102]="f",s[s.g=103]="g",s[s.h=104]="h",s[s.i=105]="i",s[s.j=106]="j",s[s.k=107]="k",s[s.l=108]="l",s[s.m=109]="m",s[s.n=110]="n",s[s.o=111]="o",s[s.p=112]="p",s[s.q=113]="q",s[s.r=114]="r",s[s.s=115]="s",s[s.t=116]="t",s[s.u=117]="u",s[s.v=118]="v",s[s.w=119]="w",s[s.x=120]="x",s[s.y=121]="y",s[s.z=122]="z",s[s.A=65]="A",s[s.B=66]="B",s[s.C=67]="C",s[s.D=68]="D",s[s.E=69]="E",s[s.F=70]="F",s[s.G=71]="G",s[s.H=72]="H",s[s.I=73]="I",s[s.J=74]="J",s[s.K=75]="K",s[s.L=76]="L",s[s.M=77]="M",s[s.N=78]="N",s[s.O=79]="O",s[s.P=80]="P",s[s.Q=81]="Q",s[s.R=82]="R",s[s.S=83]="S",s[s.T=84]="T",s[s.U=85]="U",s[s.V=86]="V",s[s.W=87]="W",s[s.X=88]="X",s[s.Y=89]="Y",s[s.Z=90]="Z",s[s.ampersand=38]="ampersand",s[s.asterisk=42]="asterisk",s[s.at=64]="at",s[s.backslash=92]="backslash",s[s.bar=124]="bar",s[s.caret=94]="caret",s[s.closeBrace=125]="closeBrace",s[s.closeBracket=93]="closeBracket",s[s.closeParen=41]="closeParen",s[s.colon=58]="colon",s[s.comma=44]="comma",s[s.dot=46]="dot",s[s.doubleQuote=34]="doubleQuote",s[s.equals=61]="equals",s[s.exclamation=33]="exclamation",s[s.greaterThan=62]="greaterThan",s[s.lessThan=60]="lessThan",s[s.minus=45]="minus",s[s.openBrace=123]="openBrace",s[s.openBracket=91]="openBracket",s[s.openParen=40]="openParen",s[s.percent=37]="percent",s[s.plus=43]="plus",s[s.question=63]="question",s[s.semicolon=59]="semicolon",s[s.singleQuote=39]="singleQuote",s[s.slash=47]="slash",s[s.tilde=126]="tilde",s[s.backspace=8]="backspace",s[s.formFeed=12]="formFeed",s[s.byteOrderMark=65279]="byteOrderMark",s[s.tab=9]="tab",s[s.verticalTab=11]="verticalTab"})(F||(F={}));function _(s,I){const r=[],i=new Object;let v;const m={value:{},offset:0,length:0,type:"object",parent:void 0};let o=!1;function b(d,E,R,P){m.value=d,m.offset=E,m.length=R,m.type=P,m.colonOffset=void 0,v=m}try{l(s,{onObjectBegin:(d,E)=>{if(I<=d)throw i;v=void 0,o=I>d,r.push("")},onObjectProperty:(d,E,R)=>{if(I<E||(b(d,E,R,"property"),r[r.length-1]=d,I<=E+R))throw i},onObjectEnd:(d,E)=>{if(I<=d)throw i;v=void 0,r.pop()},onArrayBegin:(d,E)=>{if(I<=d)throw i;v=void 0,r.push(0)},onArrayEnd:(d,E)=>{if(I<=d)throw i;v=void 0,r.pop()},onLiteralValue:(d,E,R)=>{if(I<E||(b(d,E,R,y(d)),I<=E+R))throw i},onSeparator:(d,E,R)=>{if(I<=E)throw i;if(d===":"&&v&&v.type==="property")v.colonOffset=E,o=!1,v=void 0;else if(d===","){const P=r[r.length-1];typeof P=="number"?r[r.length-1]=P+1:(o=!0,r[r.length-1]=""),v=void 0}}})}catch(d){if(d!==i)throw d}return{path:r,previousNode:v,isAtPropertyKey:o,matches:d=>{let E=0;for(let R=0;E<d.length&&R<r.length;R++)if(d[E]===r[R]||d[E]==="*")E++;else if(d[E]!=="**")return!1;return E===d.length}}}e.getLocation=_;function n(s,I=[],r=A.DEFAULT){let i=null,v=[];const m=[];function o(d){Array.isArray(v)?v.push(d):i!==null&&(v[i]=d)}return l(s,{onObjectBegin:()=>{const d={};o(d),m.push(v),v=d,i=null},onObjectProperty:d=>{i=d},onObjectEnd:()=>{v=m.pop()},onArrayBegin:()=>{const d=[];o(d),m.push(v),v=d,i=null},onArrayEnd:()=>{v=m.pop()},onLiteralValue:o,onError:(d,E,R)=>{I.push({error:d,offset:E,length:R})}},r),v[0]}e.parse=n;function g(s,I=[],r=A.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function v(d){i.type==="property"&&(i.length=d-i.offset,i=i.parent)}function m(d){return i.children.push(d),d}l(s,{onObjectBegin:d=>{i=m({type:"object",offset:d,length:-1,parent:i,children:[]})},onObjectProperty:(d,E,R)=>{i=m({type:"property",offset:E,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:d,offset:E,length:R,parent:i})},onObjectEnd:(d,E)=>{i.length=d+E-i.offset,i=i.parent,v(d+E)},onArrayBegin:(d,E)=>{i=m({type:"array",offset:d,length:-1,parent:i,children:[]})},onArrayEnd:(d,E)=>{i.length=d+E-i.offset,i=i.parent,v(d+E)},onLiteralValue:(d,E,R)=>{m({type:y(d),offset:E,length:R,parent:i,value:d}),v(E+R)},onSeparator:(d,E,R)=>{i.type==="property"&&(d===":"?i.colonOffset=E:d===","&&v(E))},onError:(d,E,R)=>{I.push({error:d,offset:E,length:R})}},r);const b=i.children[0];return b&&delete b.parent,b}e.parseTree=g;function a(s,I){if(!s)return;let r=s;for(let i of I)if(typeof i=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let v=!1;for(const m of r.children)if(Array.isArray(m.children)&&m.children[0].value===i){r=m.children[1],v=!0;break}if(!v)return}else{const v=i;if(r.type!=="array"||v<0||!Array.isArray(r.children)||v>=r.children.length)return;r=r.children[v]}return r}e.findNodeAtLocation=a;function c(s){if(!s.parent||!s.parent.children)return[];const I=c(s.parent);if(s.parent.type==="property"){const r=s.parent.children[0].value;I.push(r)}else if(s.parent.type==="array"){const r=s.parent.children.indexOf(s);r!==-1&&I.push(r)}return I}e.getNodePath=c;function p(s){switch(s.type){case"array":return s.children.map(p);case"object":const I=Object.create(null);for(let r of s.children){const i=r.children[1];i&&(I[r.children[0].value]=p(i))}return I;case"null":case"string":case"number":case"boolean":return s.value;default:return}}e.getNodeValue=p;function D(s,I,r=!1){return I>=s.offset&&I<s.offset+s.length||r&&I===s.offset+s.length}e.contains=D;function f(s,I,r=!1){if(D(s,I,r)){const i=s.children;if(Array.isArray(i))for(let v=0;v<i.length&&i[v].offset<=I;v++){const m=f(i[v],I,r);if(m)return m}return s}}e.findNodeAtOffset=f;function l(s,I,r=A.DEFAULT){const i=t(s,!1);function v(de){return de?()=>de(i.getTokenOffset(),i.getTokenLength()):()=>!0}function m(de){return de?Fe=>de(Fe,i.getTokenOffset(),i.getTokenLength()):()=>!0}const o=v(I.onObjectBegin),b=m(I.onObjectProperty),d=v(I.onObjectEnd),E=v(I.onArrayBegin),R=v(I.onArrayEnd),P=m(I.onLiteralValue),z=m(I.onSeparator),O=v(I.onComment),S=m(I.onError),x=r&&r.disallowComments,N=r&&r.allowTrailingComma;function V(){for(;;){const de=i.scan();switch(i.getTokenError()){case 4:B(14);break;case 5:B(15);break;case 3:B(13);break;case 1:x||B(11);break;case 2:B(12);break;case 6:B(16);break}switch(de){case 12:case 13:x?B(10):O();break;case 16:B(1);break;case 15:case 14:break;default:return de}}}function B(de,Fe=[],Ge=[]){if(S(de),Fe.length+Ge.length>0){let Le=i.getToken();for(;Le!==17;){if(Fe.indexOf(Le)!==-1){V();break}else if(Ge.indexOf(Le)!==-1)break;Le=V()}}}function $(de){const Fe=i.getTokenValue();return de?P(Fe):b(Fe),V(),!0}function J(){switch(i.getToken()){case 11:let de=0;try{de=JSON.parse(i.getTokenValue()),typeof de!="number"&&(B(2),de=0)}catch(Fe){B(2)}P(de);break;case 7:P(null);break;case 8:P(!0);break;case 9:P(!1);break;default:return!1}return V(),!0}function j(){return i.getToken()!==10?(B(3,[],[2,5]),!1):($(!1),i.getToken()===6?(z(":"),V(),be()||B(4,[],[2,5])):B(5,[],[2,5]),!0)}function Q(){o(),V();let de=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(de||B(4,[],[]),z(","),V(),i.getToken()===2&&N)break}else de&&B(6,[],[]);j()||B(4,[],[2,5]),de=!0}return d(),i.getToken()!==2?B(7,[2],[]):V(),!0}function le(){E(),V();let de=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(de||B(4,[],[]),z(","),V(),i.getToken()===4&&N)break}else de&&B(6,[],[]);be()||B(4,[],[4,5]),de=!0}return R(),i.getToken()!==4?B(8,[4],[]):V(),!0}function be(){switch(i.getToken()){case 3:return le();case 1:return Q();case 10:return $(!0);default:return J()}}return V(),i.getToken()===17?r.allowEmptyContent?!0:(B(4,[],[]),!1):be()?(i.getToken()!==17&&B(9,[],[]),!0):(B(4,[],[]),!1)}e.visit=l;function h(s,I){let r=t(s),i=[],v,m=0,o;do switch(o=r.getPosition(),v=r.scan(),v){case 12:case 13:case 17:m!==o&&i.push(s.substring(m,o)),I!==void 0&&i.push(r.getTokenValue().replace(/[^\r\n]/g,I)),m=r.getPosition();break}while(v!==17);return i.join("")}e.stripComments=h;function y(s){switch(typeof s){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(s){if(Array.isArray(s))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=y}),define(we[102],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class u{constructor(w){this.executor=w,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(w){this._error=w}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(w){return new u(()=>w(this.getValue()))}}e.Lazy=u}),function(re,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(re=typeof globalThis!="undefined"?globalThis:re||self,re.marked=e())}(this,function(){"use strict";function re(Ie,Se){for(var pe=0;pe<Se.length;pe++){var oe=Se[pe];oe.enumerable=oe.enumerable||!1,oe.configurable=!0,"value"in oe&&(oe.writable=!0),Object.defineProperty(Ie,oe.key,oe)}}function e(Ie,Se,pe){return Se&&re(Ie.prototype,Se),pe&&re(Ie,pe),Ie}function u(Ie,Se){if(!!Ie){if(typeof Ie=="string")return M(Ie,Se);var pe=Object.prototype.toString.call(Ie).slice(8,-1);if(pe==="Object"&&Ie.constructor&&(pe=Ie.constructor.name),pe==="Map"||pe==="Set")return Array.from(Ie);if(pe==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(pe))return M(Ie,Se)}}function M(Ie,Se){(Se==null||Se>Ie.length)&&(Se=Ie.length);for(var pe=0,oe=new Array(Se);pe<Se;pe++)oe[pe]=Ie[pe];return oe}function w(Ie,Se){var pe=typeof Symbol!="undefined"&&Ie[Symbol.iterator]||Ie["@@iterator"];if(pe)return(pe=pe.call(Ie)).next.bind(pe);if(Array.isArray(Ie)||(pe=u(Ie))||Se&&Ie&&typeof Ie.length=="number"){pe&&(Ie=pe);var oe=0;return function(){return oe>=Ie.length?{done:!0}:{done:!1,value:Ie[oe++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}var A={exports:{}};function t(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function T(Ie){A.exports.defaults=Ie}A.exports={defaults:t(),getDefaults:t,changeDefaults:T};var C=/[&<>"']/,k=/[&<>"']/g,F=/[<>"']|&(?!#?\w+;)/,_=/[<>"']|&(?!#?\w+;)/g,n={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},g=function(Se){return n[Se]};function a(Ie,Se){if(Se){if(C.test(Ie))return Ie.replace(k,g)}else if(F.test(Ie))return Ie.replace(_,g);return Ie}var c=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function p(Ie){return Ie.replace(c,function(Se,pe){return pe=pe.toLowerCase(),pe==="colon"?":":pe.charAt(0)==="#"?pe.charAt(1)==="x"?String.fromCharCode(parseInt(pe.substring(2),16)):String.fromCharCode(+pe.substring(1)):""})}var D=/(^|[^\[])\^/g;function f(Ie,Se){Ie=Ie.source||Ie,Se=Se||"";var pe={replace:function(ae,ue){return ue=ue.source||ue,ue=ue.replace(D,"$1"),Ie=Ie.replace(ae,ue),pe},getRegex:function(){return new RegExp(Ie,Se)}};return pe}var l=/[^\w:]/g,h=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function y(Ie,Se,pe){if(Ie){var oe;try{oe=decodeURIComponent(p(pe)).replace(l,"").toLowerCase()}catch(ae){return null}if(oe.indexOf("javascript:")===0||oe.indexOf("vbscript:")===0||oe.indexOf("data:")===0)return null}Se&&!h.test(pe)&&(pe=v(Se,pe));try{pe=encodeURI(pe).replace(/%25/g,"%")}catch(ae){return null}return pe}var s={},I=/^[^:]+:\/*[^/]*$/,r=/^([^:]+:)[\s\S]*$/,i=/^([^:]+:\/*[^/]*)[\s\S]*$/;function v(Ie,Se){s[" "+Ie]||(I.test(Ie)?s[" "+Ie]=Ie+"/":s[" "+Ie]=d(Ie,"/",!0)),Ie=s[" "+Ie];var pe=Ie.indexOf(":")===-1;return Se.substring(0,2)==="//"?pe?Se:Ie.replace(r,"$1")+Se:Se.charAt(0)==="/"?pe?Se:Ie.replace(i,"$1")+Se:Ie+Se}var m={exec:function(){}};function o(Ie){for(var Se=1,pe,oe;Se<arguments.length;Se++){pe=arguments[Se];for(oe in pe)Object.prototype.hasOwnProperty.call(pe,oe)&&(Ie[oe]=pe[oe])}return Ie}function b(Ie,Se){var pe=Ie.replace(/\|/g,function(ue,fe,ke){for(var $e=!1,Re=fe;--Re>=0&&ke[Re]==="\\";)$e=!$e;return $e?"|":" |"}),oe=pe.split(/ \|/),ae=0;if(oe[0].trim()||oe.shift(),oe[oe.length-1].trim()||oe.pop(),oe.length>Se)oe.splice(Se);else for(;oe.length<Se;)oe.push("");for(;ae<oe.length;ae++)oe[ae]=oe[ae].trim().replace(/\\\|/g,"|");return oe}function d(Ie,Se,pe){var oe=Ie.length;if(oe===0)return"";for(var ae=0;ae<oe;){var ue=Ie.charAt(oe-ae-1);if(ue===Se&&!pe)ae++;else if(ue!==Se&&pe)ae++;else break}return Ie.substr(0,oe-ae)}function E(Ie,Se){if(Ie.indexOf(Se[1])===-1)return-1;for(var pe=Ie.length,oe=0,ae=0;ae<pe;ae++)if(Ie[ae]==="\\")ae++;else if(Ie[ae]===Se[0])oe++;else if(Ie[ae]===Se[1]&&(oe--,oe<0))return ae;return-1}function R(Ie){Ie&&Ie.sanitize&&!Ie.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function P(Ie,Se){if(Se<1)return"";for(var pe="";Se>1;)Se&1&&(pe+=Ie),Se>>=1,Ie+=Ie;return pe+Ie}var z={escape:a,unescape:p,edit:f,cleanUrl:y,resolveUrl:v,noopTest:m,merge:o,splitCells:b,rtrim:d,findClosingBracket:E,checkSanitizeDeprecation:R,repeatString:P},O=A.exports.defaults,S=z.rtrim,x=z.splitCells,N=z.escape,V=z.findClosingBracket;function B(Ie,Se,pe,oe){var ae=Se.href,ue=Se.title?N(Se.title):null,fe=Ie[1].replace(/\\([\[\]])/g,"$1");if(Ie[0].charAt(0)!=="!"){oe.state.inLink=!0;var ke={type:"link",raw:pe,href:ae,title:ue,text:fe,tokens:oe.inlineTokens(fe,[])};return oe.state.inLink=!1,ke}else return{type:"image",raw:pe,href:ae,title:ue,text:N(fe)}}function $(Ie,Se){var pe=Ie.match(/^(\s+)(?:```)/);if(pe===null)return Se;var oe=pe[1];return Se.split(`
`).map(function(ae){var ue=ae.match(/^\s+/);if(ue===null)return ae;var fe=ue[0];return fe.length>=oe.length?ae.slice(oe.length):ae}).join(`
`)}var J=function(){function Ie(pe){this.options=pe||O}var Se=Ie.prototype;return Se.space=function(oe){var ae=this.rules.block.newline.exec(oe);if(ae)return ae[0].length>1?{type:"space",raw:ae[0]}:{raw:`
`}},Se.code=function(oe){var ae=this.rules.block.code.exec(oe);if(ae){var ue=ae[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ae[0],codeBlockStyle:"indented",text:this.options.pedantic?ue:S(ue,`
`)}}},Se.fences=function(oe){var ae=this.rules.block.fences.exec(oe);if(ae){var ue=ae[0],fe=$(ue,ae[3]||"");return{type:"code",raw:ue,lang:ae[2]?ae[2].trim():ae[2],text:fe}}},Se.heading=function(oe){var ae=this.rules.block.heading.exec(oe);if(ae){var ue=ae[2].trim();if(/#$/.test(ue)){var fe=S(ue,"#");(this.options.pedantic||!fe||/ $/.test(fe))&&(ue=fe.trim())}var ke={type:"heading",raw:ae[0],depth:ae[1].length,text:ue,tokens:[]};return this.lexer.inline(ke.text,ke.tokens),ke}},Se.hr=function(oe){var ae=this.rules.block.hr.exec(oe);if(ae)return{type:"hr",raw:ae[0]}},Se.blockquote=function(oe){var ae=this.rules.block.blockquote.exec(oe);if(ae){var ue=ae[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:ae[0],tokens:this.lexer.blockTokens(ue,[]),text:ue}}},Se.list=function(oe){var ae=this.rules.block.list.exec(oe);if(ae){var ue,fe,ke,$e,Re,ze,tt,rt,ne,me,ie=ae[1].trim(),H=ie.length>1,ve={type:"list",raw:"",ordered:H,start:H?+ie.slice(0,-1):"",loose:!1,items:[]};ie=H?"\\d{1,9}\\"+ie.slice(-1):"\\"+ie,this.options.pedantic&&(ie=H?ie:"[*+-]");for(var De=new RegExp("^( {0,3}"+ie+")((?: [^\\n]*| *)(?:\\n[^\\n]*)*(?:\\n|$))");oe&&!(this.rules.block.hr.test(oe)||!(ae=De.exec(oe)));){ne=ae[2].split(`
`),this.options.pedantic?($e=2,me=ne[0].trimLeft()):($e=ae[2].search(/[^ ]/),$e=ae[1].length+($e>4?1:$e),me=ne[0].slice($e-ae[1].length)),ze=!1,ue=ae[0],!ne[0]&&/^ *$/.test(ne[1])&&(ue=ae[1]+ne.slice(0,2).join(`
`)+`
`,ve.loose=!0,ne=[]);var je=new RegExp("^ {0,"+Math.min(3,$e-1)+"}(?:[*+-]|\\d{1,9}[.)])");for(Re=1;Re<ne.length;Re++){if(rt=ne[Re],this.options.pedantic&&(rt=rt.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),je.test(rt)){ue=ae[1]+ne.slice(0,Re).join(`
`)+`
`;break}if(!ze){rt.trim()||(ze=!0),rt.search(/[^ ]/)>=$e?me+=`
`+rt.slice($e):me+=`
`+rt;continue}if(rt.search(/[^ ]/)>=$e||!rt.trim()){me+=`
`+rt.slice($e);continue}else{ue=ae[1]+ne.slice(0,Re).join(`
`)+`
`;break}}ve.loose||(tt?ve.loose=!0:/\n *\n *$/.test(ue)&&(tt=!0)),this.options.gfm&&(fe=/^\[[ xX]\] /.exec(me),fe&&(ke=fe[0]!=="[ ] ",me=me.replace(/^\[[ xX]\] +/,""))),ve.items.push({type:"list_item",raw:ue,task:!!fe,checked:ke,loose:!1,text:me}),ve.raw+=ue,oe=oe.slice(ue.length)}ve.items[ve.items.length-1].raw=ue.trimRight(),ve.items[ve.items.length-1].text=me.trimRight(),ve.raw=ve.raw.trimRight();var Me=ve.items.length;for(Re=0;Re<Me;Re++)this.lexer.state.top=!1,ve.items[Re].tokens=this.lexer.blockTokens(ve.items[Re].text,[]),ve.items[Re].tokens.some(function(dt){return dt.type==="space"})&&(ve.loose=!0,ve.items[Re].loose=!0);return ve}},Se.html=function(oe){var ae=this.rules.block.html.exec(oe);if(ae){var ue={type:"html",raw:ae[0],pre:!this.options.sanitizer&&(ae[1]==="pre"||ae[1]==="script"||ae[1]==="style"),text:ae[0]};return this.options.sanitize&&(ue.type="paragraph",ue.text=this.options.sanitizer?this.options.sanitizer(ae[0]):N(ae[0]),ue.tokens=[],this.lexer.inline(ue.text,ue.tokens)),ue}},Se.def=function(oe){var ae=this.rules.block.def.exec(oe);if(ae){ae[3]&&(ae[3]=ae[3].substring(1,ae[3].length-1));var ue=ae[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:ue,raw:ae[0],href:ae[2],title:ae[3]}}},Se.table=function(oe){var ae=this.rules.block.table.exec(oe);if(ae){var ue={type:"table",header:x(ae[1]).map(function(tt){return{text:tt}}),align:ae[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ae[3]?ae[3].replace(/\n$/,"").split(`
`):[]};if(ue.header.length===ue.align.length){ue.raw=ae[0];var fe=ue.align.length,ke,$e,Re,ze;for(ke=0;ke<fe;ke++)/^ *-+: *$/.test(ue.align[ke])?ue.align[ke]="right":/^ *:-+: *$/.test(ue.align[ke])?ue.align[ke]="center":/^ *:-+ *$/.test(ue.align[ke])?ue.align[ke]="left":ue.align[ke]=null;for(fe=ue.rows.length,ke=0;ke<fe;ke++)ue.rows[ke]=x(ue.rows[ke],ue.header.length).map(function(tt){return{text:tt}});for(fe=ue.header.length,$e=0;$e<fe;$e++)ue.header[$e].tokens=[],this.lexer.inlineTokens(ue.header[$e].text,ue.header[$e].tokens);for(fe=ue.rows.length,$e=0;$e<fe;$e++)for(ze=ue.rows[$e],Re=0;Re<ze.length;Re++)ze[Re].tokens=[],this.lexer.inlineTokens(ze[Re].text,ze[Re].tokens);return ue}}},Se.lheading=function(oe){var ae=this.rules.block.lheading.exec(oe);if(ae){var ue={type:"heading",raw:ae[0],depth:ae[2].charAt(0)==="="?1:2,text:ae[1],tokens:[]};return this.lexer.inline(ue.text,ue.tokens),ue}},Se.paragraph=function(oe){var ae=this.rules.block.paragraph.exec(oe);if(ae){var ue={type:"paragraph",raw:ae[0],text:ae[1].charAt(ae[1].length-1)===`
`?ae[1].slice(0,-1):ae[1],tokens:[]};return this.lexer.inline(ue.text,ue.tokens),ue}},Se.text=function(oe){var ae=this.rules.block.text.exec(oe);if(ae){var ue={type:"text",raw:ae[0],text:ae[0],tokens:[]};return this.lexer.inline(ue.text,ue.tokens),ue}},Se.escape=function(oe){var ae=this.rules.inline.escape.exec(oe);if(ae)return{type:"escape",raw:ae[0],text:N(ae[1])}},Se.tag=function(oe){var ae=this.rules.inline.tag.exec(oe);if(ae)return!this.lexer.state.inLink&&/^<a /i.test(ae[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ae[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ae[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ae[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ae[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ae[0]):N(ae[0]):ae[0]}},Se.link=function(oe){var ae=this.rules.inline.link.exec(oe);if(ae){var ue=ae[2].trim();if(!this.options.pedantic&&/^</.test(ue)){if(!/>$/.test(ue))return;var fe=S(ue.slice(0,-1),"\\");if((ue.length-fe.length)%2==0)return}else{var ke=V(ae[2],"()");if(ke>-1){var $e=ae[0].indexOf("!")===0?5:4,Re=$e+ae[1].length+ke;ae[2]=ae[2].substring(0,ke),ae[0]=ae[0].substring(0,Re).trim(),ae[3]=""}}var ze=ae[2],tt="";if(this.options.pedantic){var rt=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(ze);rt&&(ze=rt[1],tt=rt[3])}else tt=ae[3]?ae[3].slice(1,-1):"";return ze=ze.trim(),/^</.test(ze)&&(this.options.pedantic&&!/>$/.test(ue)?ze=ze.slice(1):ze=ze.slice(1,-1)),B(ae,{href:ze&&ze.replace(this.rules.inline._escapes,"$1"),title:tt&&tt.replace(this.rules.inline._escapes,"$1")},ae[0],this.lexer)}},Se.reflink=function(oe,ae){var ue;if((ue=this.rules.inline.reflink.exec(oe))||(ue=this.rules.inline.nolink.exec(oe))){var fe=(ue[2]||ue[1]).replace(/\s+/g," ");if(fe=ae[fe.toLowerCase()],!fe||!fe.href){var ke=ue[0].charAt(0);return{type:"text",raw:ke,text:ke}}return B(ue,fe,ue[0],this.lexer)}},Se.emStrong=function(oe,ae,ue){ue===void 0&&(ue="");var fe=this.rules.inline.emStrong.lDelim.exec(oe);if(!!fe&&!(fe[3]&&ue.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var ke=fe[1]||fe[2]||"";if(!ke||ke&&(ue===""||this.rules.inline.punctuation.exec(ue))){var $e=fe[0].length-1,Re,ze,tt=$e,rt=0,ne=fe[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(ne.lastIndex=0,ae=ae.slice(-1*oe.length+$e);(fe=ne.exec(ae))!=null;)if(Re=fe[1]||fe[2]||fe[3]||fe[4]||fe[5]||fe[6],!!Re){if(ze=Re.length,fe[3]||fe[4]){tt+=ze;continue}else if((fe[5]||fe[6])&&$e%3&&!(($e+ze)%3)){rt+=ze;continue}if(tt-=ze,!(tt>0)){if(ze=Math.min(ze,ze+tt+rt),Math.min($e,ze)%2){var me=oe.slice(1,$e+fe.index+ze);return{type:"em",raw:oe.slice(0,$e+fe.index+ze+1),text:me,tokens:this.lexer.inlineTokens(me,[])}}var ie=oe.slice(2,$e+fe.index+ze-1);return{type:"strong",raw:oe.slice(0,$e+fe.index+ze+1),text:ie,tokens:this.lexer.inlineTokens(ie,[])}}}}}},Se.codespan=function(oe){var ae=this.rules.inline.code.exec(oe);if(ae){var ue=ae[2].replace(/\n/g," "),fe=/[^ ]/.test(ue),ke=/^ /.test(ue)&&/ $/.test(ue);return fe&&ke&&(ue=ue.substring(1,ue.length-1)),ue=N(ue,!0),{type:"codespan",raw:ae[0],text:ue}}},Se.br=function(oe){var ae=this.rules.inline.br.exec(oe);if(ae)return{type:"br",raw:ae[0]}},Se.del=function(oe){var ae=this.rules.inline.del.exec(oe);if(ae)return{type:"del",raw:ae[0],text:ae[2],tokens:this.lexer.inlineTokens(ae[2],[])}},Se.autolink=function(oe,ae){var ue=this.rules.inline.autolink.exec(oe);if(ue){var fe,ke;return ue[2]==="@"?(fe=N(this.options.mangle?ae(ue[1]):ue[1]),ke="mailto:"+fe):(fe=N(ue[1]),ke=fe),{type:"link",raw:ue[0],text:fe,href:ke,tokens:[{type:"text",raw:fe,text:fe}]}}},Se.url=function(oe,ae){var ue;if(ue=this.rules.inline.url.exec(oe)){var fe,ke;if(ue[2]==="@")fe=N(this.options.mangle?ae(ue[0]):ue[0]),ke="mailto:"+fe;else{var $e;do $e=ue[0],ue[0]=this.rules.inline._backpedal.exec(ue[0])[0];while($e!==ue[0]);fe=N(ue[0]),ue[1]==="www."?ke="http://"+fe:ke=fe}return{type:"link",raw:ue[0],text:fe,href:ke,tokens:[{type:"text",raw:fe,text:fe}]}}},Se.inlineText=function(oe,ae){var ue=this.rules.inline.text.exec(oe);if(ue){var fe;return this.lexer.state.inRawBlock?fe=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ue[0]):N(ue[0]):ue[0]:fe=N(this.options.smartypants?ae(ue[0]):ue[0]),{type:"text",raw:ue[0],text:fe}}},Ie}(),j=z.noopTest,Q=z.edit,le=z.merge,be={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)( [^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,table:j,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};be._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,be._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,be.def=Q(be.def).replace("label",be._label).replace("title",be._title).getRegex(),be.bullet=/(?:[*+-]|\d{1,9}[.)])/,be.listItemStart=Q(/^( *)(bull) */).replace("bull",be.bullet).getRegex(),be.list=Q(be.list).replace(/bull/g,be.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+be.def.source+")").getRegex(),be._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",be._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,be.html=Q(be.html,"i").replace("comment",be._comment).replace("tag",be._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),be.paragraph=Q(be._paragraph).replace("hr",be.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",be._tag).getRegex(),be.blockquote=Q(be.blockquote).replace("paragraph",be.paragraph).getRegex(),be.normal=le({},be),be.gfm=le({},be.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)\\|?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),be.gfm.table=Q(be.gfm.table).replace("hr",be.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",be._tag).getRegex(),be.pedantic=le({},be.normal,{html:Q(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",be._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:j,paragraph:Q(be.normal._paragraph).replace("hr",be.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",be.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var de={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:j,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_*]*?\*[^_*]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^_*]*?\_[^_*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:j,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};de._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",de.punctuation=Q(de.punctuation).replace(/punctuation/g,de._punctuation).getRegex(),de.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,de.escapedEmSt=/\\\*|\\_/g,de._comment=Q(be._comment).replace("(?:-->|$)","-->").getRegex(),de.emStrong.lDelim=Q(de.emStrong.lDelim).replace(/punct/g,de._punctuation).getRegex(),de.emStrong.rDelimAst=Q(de.emStrong.rDelimAst,"g").replace(/punct/g,de._punctuation).getRegex(),de.emStrong.rDelimUnd=Q(de.emStrong.rDelimUnd,"g").replace(/punct/g,de._punctuation).getRegex(),de._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,de._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,de._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,de.autolink=Q(de.autolink).replace("scheme",de._scheme).replace("email",de._email).getRegex(),de._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,de.tag=Q(de.tag).replace("comment",de._comment).replace("attribute",de._attribute).getRegex(),de._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,de._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,de._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,de.link=Q(de.link).replace("label",de._label).replace("href",de._href).replace("title",de._title).getRegex(),de.reflink=Q(de.reflink).replace("label",de._label).getRegex(),de.reflinkSearch=Q(de.reflinkSearch,"g").replace("reflink",de.reflink).replace("nolink",de.nolink).getRegex(),de.normal=le({},de),de.pedantic=le({},de.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:Q(/^!?\[(label)\]\((.*?)\)/).replace("label",de._label).getRegex(),reflink:Q(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",de._label).getRegex()}),de.gfm=le({},de.normal,{escape:Q(de.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),de.gfm.url=Q(de.gfm.url,"i").replace("email",de.gfm._extended_email).getRegex(),de.breaks=le({},de.gfm,{br:Q(de.br).replace("{2,}","*").getRegex(),text:Q(de.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var Fe={block:be,inline:de},Ge=J,Le=A.exports.defaults,We=Fe.block,Ye=Fe.inline,Qe=z.repeatString;function Ke(Ie){return Ie.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function W(Ie){var Se="",pe,oe,ae=Ie.length;for(pe=0;pe<ae;pe++)oe=Ie.charCodeAt(pe),Math.random()>.5&&(oe="x"+oe.toString(16)),Se+="&#"+oe+";";return Se}var K=function(){function Ie(pe){this.tokens=[],this.tokens.links=Object.create(null),this.options=pe||Le,this.options.tokenizer=this.options.tokenizer||new Ge,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var oe={block:We.normal,inline:Ye.normal};this.options.pedantic?(oe.block=We.pedantic,oe.inline=Ye.pedantic):this.options.gfm&&(oe.block=We.gfm,this.options.breaks?oe.inline=Ye.breaks:oe.inline=Ye.gfm),this.tokenizer.rules=oe}Ie.lex=function(oe,ae){var ue=new Ie(ae);return ue.lex(oe)},Ie.lexInline=function(oe,ae){var ue=new Ie(ae);return ue.inlineTokens(oe)};var Se=Ie.prototype;return Se.lex=function(oe){oe=oe.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(oe,this.tokens);for(var ae;ae=this.inlineQueue.shift();)this.inlineTokens(ae.src,ae.tokens);return this.tokens},Se.blockTokens=function(oe,ae){var ue=this;ae===void 0&&(ae=[]),this.options.pedantic&&(oe=oe.replace(/^ +$/gm,""));for(var fe,ke,$e,Re;oe;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(tt){return(fe=tt.call({lexer:ue},oe,ae))?(oe=oe.substring(fe.raw.length),ae.push(fe),!0):!1}))){if(fe=this.tokenizer.space(oe)){oe=oe.substring(fe.raw.length),fe.type&&ae.push(fe);continue}if(fe=this.tokenizer.code(oe)){oe=oe.substring(fe.raw.length),ke=ae[ae.length-1],ke&&(ke.type==="paragraph"||ke.type==="text")?(ke.raw+=`
`+fe.raw,ke.text+=`
`+fe.text,this.inlineQueue[this.inlineQueue.length-1].src=ke.text):ae.push(fe);continue}if(fe=this.tokenizer.fences(oe)){oe=oe.substring(fe.raw.length),ae.push(fe);continue}if(fe=this.tokenizer.heading(oe)){oe=oe.substring(fe.raw.length),ae.push(fe);continue}if(fe=this.tokenizer.hr(oe)){oe=oe.substring(fe.raw.length),ae.push(fe);continue}if(fe=this.tokenizer.blockquote(oe)){oe=oe.substring(fe.raw.length),ae.push(fe);continue}if(fe=this.tokenizer.list(oe)){oe=oe.substring(fe.raw.length),ae.push(fe);continue}if(fe=this.tokenizer.html(oe)){oe=oe.substring(fe.raw.length),ae.push(fe);continue}if(fe=this.tokenizer.def(oe)){oe=oe.substring(fe.raw.length),ke=ae[ae.length-1],ke&&(ke.type==="paragraph"||ke.type==="text")?(ke.raw+=`
`+fe.raw,ke.text+=`
`+fe.raw,this.inlineQueue[this.inlineQueue.length-1].src=ke.text):this.tokens.links[fe.tag]||(this.tokens.links[fe.tag]={href:fe.href,title:fe.title});continue}if(fe=this.tokenizer.table(oe)){oe=oe.substring(fe.raw.length),ae.push(fe);continue}if(fe=this.tokenizer.lheading(oe)){oe=oe.substring(fe.raw.length),ae.push(fe);continue}if($e=oe,this.options.extensions&&this.options.extensions.startBlock&&function(){var tt=Infinity,rt=oe.slice(1),ne=void 0;ue.options.extensions.startBlock.forEach(function(me){ne=me.call({lexer:this},rt),typeof ne=="number"&&ne>=0&&(tt=Math.min(tt,ne))}),tt<Infinity&&tt>=0&&($e=oe.substring(0,tt+1))}(),this.state.top&&(fe=this.tokenizer.paragraph($e))){ke=ae[ae.length-1],Re&&ke.type==="paragraph"?(ke.raw+=`
`+fe.raw,ke.text+=`
`+fe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=ke.text):ae.push(fe),Re=$e.length!==oe.length,oe=oe.substring(fe.raw.length);continue}if(fe=this.tokenizer.text(oe)){oe=oe.substring(fe.raw.length),ke=ae[ae.length-1],ke&&ke.type==="text"?(ke.raw+=`
`+fe.raw,ke.text+=`
`+fe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=ke.text):ae.push(fe);continue}if(oe){var ze="Infinite loop on byte: "+oe.charCodeAt(0);if(this.options.silent){console.error(ze);break}else throw new Error(ze)}}return this.state.top=!0,ae},Se.inline=function(oe,ae){this.inlineQueue.push({src:oe,tokens:ae})},Se.inlineTokens=function(oe,ae){var ue=this;ae===void 0&&(ae=[]);var fe,ke,$e,Re=oe,ze,tt,rt;if(this.tokens.links){var ne=Object.keys(this.tokens.links);if(ne.length>0)for(;(ze=this.tokenizer.rules.inline.reflinkSearch.exec(Re))!=null;)ne.includes(ze[0].slice(ze[0].lastIndexOf("[")+1,-1))&&(Re=Re.slice(0,ze.index)+"["+Qe("a",ze[0].length-2)+"]"+Re.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(ze=this.tokenizer.rules.inline.blockSkip.exec(Re))!=null;)Re=Re.slice(0,ze.index)+"["+Qe("a",ze[0].length-2)+"]"+Re.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(ze=this.tokenizer.rules.inline.escapedEmSt.exec(Re))!=null;)Re=Re.slice(0,ze.index)+"++"+Re.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;oe;)if(tt||(rt=""),tt=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ie){return(fe=ie.call({lexer:ue},oe,ae))?(oe=oe.substring(fe.raw.length),ae.push(fe),!0):!1}))){if(fe=this.tokenizer.escape(oe)){oe=oe.substring(fe.raw.length),ae.push(fe);continue}if(fe=this.tokenizer.tag(oe)){oe=oe.substring(fe.raw.length),ke=ae[ae.length-1],ke&&fe.type==="text"&&ke.type==="text"?(ke.raw+=fe.raw,ke.text+=fe.text):ae.push(fe);continue}if(fe=this.tokenizer.link(oe)){oe=oe.substring(fe.raw.length),ae.push(fe);continue}if(fe=this.tokenizer.reflink(oe,this.tokens.links)){oe=oe.substring(fe.raw.length),ke=ae[ae.length-1],ke&&fe.type==="text"&&ke.type==="text"?(ke.raw+=fe.raw,ke.text+=fe.text):ae.push(fe);continue}if(fe=this.tokenizer.emStrong(oe,Re,rt)){oe=oe.substring(fe.raw.length),ae.push(fe);continue}if(fe=this.tokenizer.codespan(oe)){oe=oe.substring(fe.raw.length),ae.push(fe);continue}if(fe=this.tokenizer.br(oe)){oe=oe.substring(fe.raw.length),ae.push(fe);continue}if(fe=this.tokenizer.del(oe)){oe=oe.substring(fe.raw.length),ae.push(fe);continue}if(fe=this.tokenizer.autolink(oe,W)){oe=oe.substring(fe.raw.length),ae.push(fe);continue}if(!this.state.inLink&&(fe=this.tokenizer.url(oe,W))){oe=oe.substring(fe.raw.length),ae.push(fe);continue}if($e=oe,this.options.extensions&&this.options.extensions.startInline&&function(){var ie=Infinity,H=oe.slice(1),ve=void 0;ue.options.extensions.startInline.forEach(function(De){ve=De.call({lexer:this},H),typeof ve=="number"&&ve>=0&&(ie=Math.min(ie,ve))}),ie<Infinity&&ie>=0&&($e=oe.substring(0,ie+1))}(),fe=this.tokenizer.inlineText($e,Ke)){oe=oe.substring(fe.raw.length),fe.raw.slice(-1)!=="_"&&(rt=fe.raw.slice(-1)),tt=!0,ke=ae[ae.length-1],ke&&ke.type==="text"?(ke.raw+=fe.raw,ke.text+=fe.text):ae.push(fe);continue}if(oe){var me="Infinite loop on byte: "+oe.charCodeAt(0);if(this.options.silent){console.error(me);break}else throw new Error(me)}}return ae},e(Ie,null,[{key:"rules",get:function(){return{block:We,inline:Ye}}}]),Ie}(),Z=A.exports.defaults,se=z.cleanUrl,G=z.escape,te=function(){function Ie(pe){this.options=pe||Z}var Se=Ie.prototype;return Se.code=function(oe,ae,ue){var fe=(ae||"").match(/\S*/)[0];if(this.options.highlight){var ke=this.options.highlight(oe,fe);ke!=null&&ke!==oe&&(ue=!0,oe=ke)}return oe=oe.replace(/\n$/,"")+`
`,fe?'<pre><code class="'+this.options.langPrefix+G(fe,!0)+'">'+(ue?oe:G(oe,!0))+`</code></pre>
`:"<pre><code>"+(ue?oe:G(oe,!0))+`</code></pre>
`},Se.blockquote=function(oe){return`<blockquote>
`+oe+`</blockquote>
`},Se.html=function(oe){return oe},Se.heading=function(oe,ae,ue,fe){return this.options.headerIds?"<h"+ae+' id="'+this.options.headerPrefix+fe.slug(ue)+'">'+oe+"</h"+ae+`>
`:"<h"+ae+">"+oe+"</h"+ae+`>
`},Se.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},Se.list=function(oe,ae,ue){var fe=ae?"ol":"ul",ke=ae&&ue!==1?' start="'+ue+'"':"";return"<"+fe+ke+`>
`+oe+"</"+fe+`>
`},Se.listitem=function(oe){return"<li>"+oe+`</li>
`},Se.checkbox=function(oe){return"<input "+(oe?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},Se.paragraph=function(oe){return"<p>"+oe+`</p>
`},Se.table=function(oe,ae){return ae&&(ae="<tbody>"+ae+"</tbody>"),`<table>
<thead>
`+oe+`</thead>
`+ae+`</table>
`},Se.tablerow=function(oe){return`<tr>
`+oe+`</tr>
`},Se.tablecell=function(oe,ae){var ue=ae.header?"th":"td",fe=ae.align?"<"+ue+' align="'+ae.align+'">':"<"+ue+">";return fe+oe+"</"+ue+`>
`},Se.strong=function(oe){return"<strong>"+oe+"</strong>"},Se.em=function(oe){return"<em>"+oe+"</em>"},Se.codespan=function(oe){return"<code>"+oe+"</code>"},Se.br=function(){return this.options.xhtml?"<br/>":"<br>"},Se.del=function(oe){return"<del>"+oe+"</del>"},Se.link=function(oe,ae,ue){if(oe=se(this.options.sanitize,this.options.baseUrl,oe),oe===null)return ue;var fe='<a href="'+G(oe)+'"';return ae&&(fe+=' title="'+ae+'"'),fe+=">"+ue+"</a>",fe},Se.image=function(oe,ae,ue){if(oe=se(this.options.sanitize,this.options.baseUrl,oe),oe===null)return ue;var fe='<img src="'+oe+'" alt="'+ue+'"';return ae&&(fe+=' title="'+ae+'"'),fe+=this.options.xhtml?"/>":">",fe},Se.text=function(oe){return oe},Ie}(),he=function(){function Ie(){}var Se=Ie.prototype;return Se.strong=function(oe){return oe},Se.em=function(oe){return oe},Se.codespan=function(oe){return oe},Se.del=function(oe){return oe},Se.html=function(oe){return oe},Se.text=function(oe){return oe},Se.link=function(oe,ae,ue){return""+ue},Se.image=function(oe,ae,ue){return""+ue},Se.br=function(){return""},Ie}(),Pe=function(){function Ie(){this.seen={}}var Se=Ie.prototype;return Se.serialize=function(oe){return oe.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},Se.getNextSafeSlug=function(oe,ae){var ue=oe,fe=0;if(this.seen.hasOwnProperty(ue)){fe=this.seen[oe];do fe++,ue=oe+"-"+fe;while(this.seen.hasOwnProperty(ue))}return ae||(this.seen[oe]=fe,this.seen[ue]=0),ue},Se.slug=function(oe,ae){ae===void 0&&(ae={});var ue=this.serialize(oe);return this.getNextSafeSlug(ue,ae.dryrun)},Ie}(),Oe=te,Be=he,Ve=Pe,Ze=A.exports.defaults,ot=z.unescape,ye=function(){function Ie(pe){this.options=pe||Ze,this.options.renderer=this.options.renderer||new Oe,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new Be,this.slugger=new Ve}Ie.parse=function(oe,ae){var ue=new Ie(ae);return ue.parse(oe)},Ie.parseInline=function(oe,ae){var ue=new Ie(ae);return ue.parseInline(oe)};var Se=Ie.prototype;return Se.parse=function(oe,ae){ae===void 0&&(ae=!0);var ue="",fe,ke,$e,Re,ze,tt,rt,ne,me,ie,H,ve,De,je,Me,dt,wt,Ct,pt,ut=oe.length;for(fe=0;fe<ut;fe++){if(ie=oe[fe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ie.type]&&(pt=this.options.extensions.renderers[ie.type].call({parser:this},ie),pt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ie.type))){ue+=pt||"";continue}switch(ie.type){case"space":continue;case"hr":{ue+=this.renderer.hr();continue}case"heading":{ue+=this.renderer.heading(this.parseInline(ie.tokens),ie.depth,ot(this.parseInline(ie.tokens,this.textRenderer)),this.slugger);continue}case"code":{ue+=this.renderer.code(ie.text,ie.lang,ie.escaped);continue}case"table":{for(ne="",rt="",Re=ie.header.length,ke=0;ke<Re;ke++)rt+=this.renderer.tablecell(this.parseInline(ie.header[ke].tokens),{header:!0,align:ie.align[ke]});for(ne+=this.renderer.tablerow(rt),me="",Re=ie.rows.length,ke=0;ke<Re;ke++){for(tt=ie.rows[ke],rt="",ze=tt.length,$e=0;$e<ze;$e++)rt+=this.renderer.tablecell(this.parseInline(tt[$e].tokens),{header:!1,align:ie.align[$e]});me+=this.renderer.tablerow(rt)}ue+=this.renderer.table(ne,me);continue}case"blockquote":{me=this.parse(ie.tokens),ue+=this.renderer.blockquote(me);continue}case"list":{for(H=ie.ordered,ve=ie.start,De=ie.loose,Re=ie.items.length,me="",ke=0;ke<Re;ke++)Me=ie.items[ke],dt=Me.checked,wt=Me.task,je="",Me.task&&(Ct=this.renderer.checkbox(dt),De?Me.tokens.length>0&&Me.tokens[0].type==="paragraph"?(Me.tokens[0].text=Ct+" "+Me.tokens[0].text,Me.tokens[0].tokens&&Me.tokens[0].tokens.length>0&&Me.tokens[0].tokens[0].type==="text"&&(Me.tokens[0].tokens[0].text=Ct+" "+Me.tokens[0].tokens[0].text)):Me.tokens.unshift({type:"text",text:Ct}):je+=Ct),je+=this.parse(Me.tokens,De),me+=this.renderer.listitem(je,wt,dt);ue+=this.renderer.list(me,H,ve);continue}case"html":{ue+=this.renderer.html(ie.text);continue}case"paragraph":{ue+=this.renderer.paragraph(this.parseInline(ie.tokens));continue}case"text":{for(me=ie.tokens?this.parseInline(ie.tokens):ie.text;fe+1<ut&&oe[fe+1].type==="text";)ie=oe[++fe],me+=`
`+(ie.tokens?this.parseInline(ie.tokens):ie.text);ue+=ae?this.renderer.paragraph(me):me;continue}default:{var ht='Token with "'+ie.type+'" type was not found.';if(this.options.silent){console.error(ht);return}else throw new Error(ht)}}}return ue},Se.parseInline=function(oe,ae){ae=ae||this.renderer;var ue="",fe,ke,$e,Re=oe.length;for(fe=0;fe<Re;fe++){if(ke=oe[fe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ke.type]&&($e=this.options.extensions.renderers[ke.type].call({parser:this},ke),$e!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(ke.type))){ue+=$e||"";continue}switch(ke.type){case"escape":{ue+=ae.text(ke.text);break}case"html":{ue+=ae.html(ke.text);break}case"link":{ue+=ae.link(ke.href,ke.title,this.parseInline(ke.tokens,ae));break}case"image":{ue+=ae.image(ke.href,ke.title,ke.text);break}case"strong":{ue+=ae.strong(this.parseInline(ke.tokens,ae));break}case"em":{ue+=ae.em(this.parseInline(ke.tokens,ae));break}case"codespan":{ue+=ae.codespan(ke.text);break}case"br":{ue+=ae.br();break}case"del":{ue+=ae.del(this.parseInline(ke.tokens,ae));break}case"text":{ue+=ae.text(ke.text);break}default:{var ze='Token with "'+ke.type+'" type was not found.';if(this.options.silent){console.error(ze);return}else throw new Error(ze)}}}return ue},Ie}(),it=K,q=ye,X=J,ge=te,Ue=he,qe=Pe,nt=z.merge,mt=z.checkSanitizeDeprecation,lt=z.escape,St=A.exports.getDefaults,kt=A.exports.changeDefaults,It=A.exports.defaults;function Je(Ie,Se,pe){if(typeof Ie=="undefined"||Ie===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Ie!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Ie)+", string expected");if(typeof Se=="function"&&(pe=Se,Se=null),Se=nt({},Je.defaults,Se||{}),mt(Se),pe){var oe=Se.highlight,ae;try{ae=it.lex(Ie,Se)}catch($e){return pe($e)}var ue=function(Re){var ze;if(!Re)try{Se.walkTokens&&Je.walkTokens(ae,Se.walkTokens),ze=q.parse(ae,Se)}catch(tt){Re=tt}return Se.highlight=oe,Re?pe(Re):pe(null,ze)};if(!oe||oe.length<3||(delete Se.highlight,!ae.length))return ue();var fe=0;Je.walkTokens(ae,function($e){$e.type==="code"&&(fe++,setTimeout(function(){oe($e.text,$e.lang,function(Re,ze){if(Re)return ue(Re);ze!=null&&ze!==$e.text&&($e.text=ze,$e.escaped=!0),fe--,fe===0&&ue()})},0))}),fe===0&&ue();return}try{var ke=it.lex(Ie,Se);return Se.walkTokens&&Je.walkTokens(ke,Se.walkTokens),q.parse(ke,Se)}catch($e){if($e.message+=`
Please report this to https://github.com/markedjs/marked.`,Se.silent)return"<p>An error occurred:</p><pre>"+lt($e.message+"",!0)+"</pre>";throw $e}}Je.options=Je.setOptions=function(Ie){return nt(Je.defaults,Ie),kt(Je.defaults),Je},Je.getDefaults=St,Je.defaults=It,Je.use=function(){for(var Ie=this,Se=arguments.length,pe=new Array(Se),oe=0;oe<Se;oe++)pe[oe]=arguments[oe];var ae=nt.apply(void 0,[{}].concat(pe)),ue=Je.defaults.extensions||{renderers:{},childTokens:{}},fe;pe.forEach(function(ke){if(ke.extensions&&(fe=!0,ke.extensions.forEach(function(Re){if(!Re.name)throw new Error("extension name required");if(Re.renderer){var ze=ue.renderers?ue.renderers[Re.name]:null;ze?ue.renderers[Re.name]=function(){for(var tt=arguments.length,rt=new Array(tt),ne=0;ne<tt;ne++)rt[ne]=arguments[ne];var me=Re.renderer.apply(this,rt);return me===!1&&(me=ze.apply(this,rt)),me}:ue.renderers[Re.name]=Re.renderer}if(Re.tokenizer){if(!Re.level||Re.level!=="block"&&Re.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ue[Re.level]?ue[Re.level].unshift(Re.tokenizer):ue[Re.level]=[Re.tokenizer],Re.start&&(Re.level==="block"?ue.startBlock?ue.startBlock.push(Re.start):ue.startBlock=[Re.start]:Re.level==="inline"&&(ue.startInline?ue.startInline.push(Re.start):ue.startInline=[Re.start]))}Re.childTokens&&(ue.childTokens[Re.name]=Re.childTokens)})),ke.renderer&&function(){var Re=Je.defaults.renderer||new ge,ze=function(ne){var me=Re[ne];Re[ne]=function(){for(var ie=arguments.length,H=new Array(ie),ve=0;ve<ie;ve++)H[ve]=arguments[ve];var De=ke.renderer[ne].apply(Re,H);return De===!1&&(De=me.apply(Re,H)),De}};for(var tt in ke.renderer)ze(tt);ae.renderer=Re}(),ke.tokenizer&&function(){var Re=Je.defaults.tokenizer||new X,ze=function(ne){var me=Re[ne];Re[ne]=function(){for(var ie=arguments.length,H=new Array(ie),ve=0;ve<ie;ve++)H[ve]=arguments[ve];var De=ke.tokenizer[ne].apply(Re,H);return De===!1&&(De=me.apply(Re,H)),De}};for(var tt in ke.tokenizer)ze(tt);ae.tokenizer=Re}(),ke.walkTokens){var $e=Je.defaults.walkTokens;ae.walkTokens=function(Re){ke.walkTokens.call(Ie,Re),$e&&$e(Re)}}fe&&(ae.extensions=ue),Je.setOptions(ae)})},Je.walkTokens=function(Ie,Se){for(var pe=function(){var fe=ae.value;switch(Se(fe),fe.type){case"table":{for(var ke=w(fe.header),$e;!($e=ke()).done;){var Re=$e.value;Je.walkTokens(Re.tokens,Se)}for(var ze=w(fe.rows),tt;!(tt=ze()).done;)for(var rt=tt.value,ne=w(rt),me;!(me=ne()).done;){var ie=me.value;Je.walkTokens(ie.tokens,Se)}break}case"list":{Je.walkTokens(fe.items,Se);break}default:Je.defaults.extensions&&Je.defaults.extensions.childTokens&&Je.defaults.extensions.childTokens[fe.type]?Je.defaults.extensions.childTokens[fe.type].forEach(function(H){Je.walkTokens(fe[H],Se)}):fe.tokens&&Je.walkTokens(fe.tokens,Se)}},oe=w(Ie),ae;!(ae=oe()).done;)pe()},Je.parseInline=function(Ie,Se){if(typeof Ie=="undefined"||Ie===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Ie!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Ie)+", string expected");Se=nt({},Je.defaults,Se||{}),mt(Se);try{var pe=it.lexInline(Ie,Se);return Se.walkTokens&&Je.walkTokens(pe,Se.walkTokens),q.parseInline(pe,Se)}catch(oe){if(oe.message+=`
Please report this to https://github.com/markedjs/marked.`,Se.silent)return"<p>An error occurred:</p><pre>"+lt(oe.message+"",!0)+"</pre>";throw oe}},Je.Parser=q,Je.parser=q.parse,Je.Renderer=ge,Je.TextRenderer=Ue,Je.Lexer=it,Je.lexer=it.lex,Je.Tokenizer=X,Je.Slugger=qe,Je.parse=Je;var bt=Je;return bt}),define(we[76],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function u(t,T,C){return Math.min(Math.max(t,T),C)}e.clamp=u;function M(t,T){return(T+t%T)%T}e.rot=M;class w{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=w;class A{constructor(){this._n=1,this._val=0}update(T){return this._val=this._val+(T-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=A}),function(){function re(w){const A=[];typeof w=="number"&&A.push("code/timeOrigin",w);function t(C){A.push(C,Date.now())}function T(){const C=[];for(let k=0;k<A.length;k+=2)C.push({name:A[k],startTime:A[k+1]});return C}return{mark:t,getMarks:T}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?re():{mark(w){performance.mark(w)},getMarks(){let w=performance.timeOrigin;typeof w!="number"&&(w=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(w)}];for(const t of performance.getEntriesByType("mark"))A.push({name:t.name,startTime:Math.round(w+t.startTime)});return A}};if(typeof process=="object"){const w=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return re(w)}else return console.trace("perf-util loaded in UNKNOWN environment"),re()}function u(w){return w.MonacoPerformanceMarks||(w.MonacoPerformanceMarks=e()),w.MonacoPerformanceMarks}var M;typeof global=="object"?M=global:typeof self=="object"?M=self:M={},typeof define=="function"?define("vs/base/common/performance",[],function(){return u(M)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=u(M):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),M.perf=u(M))}(),define(we[54],Ee([0,1,3]),function(re,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.iconRegistry=void 0;class M{constructor(){this._icons=new Map,this._onDidRegister=new u.Emitter}add(F){const _=this._icons.get(F.id);_?F.description?_.description=F.description:console.error(`Duplicate registration of codicon ${F.id}`):(this._icons.set(F.id,F),this._onDidRegister.fire(F))}get(F){return this._icons.get(F)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const w=new M;e.iconRegistry=w;function A(k){return k?k.replace(/\$\((.*?)\)/g,(F,_)=>` ${_} `).trim():""}e.getCodiconAriaLabel=A;class t{constructor(F,_,n){this.id=F,this.definition=_,this.description=n,w.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=t,t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",{fontCharacter:"\\ea71"}),t.closeDirty=new t("close-dirty",{fontCharacter:"\\ea71"}),t.debugBreakpoint=new t("debug-breakpoint",{fontCharacter:"\\ea71"}),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),t.debugHint=new t("debug-hint",{fontCharacter:"\\ea71"}),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circleOutline=new t("circle-outline",{fontCharacter:"\\eabc"}),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.debugStackframeDot=new t("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLargeOutline=new t("circle-large-outline",{fontCharacter:"\\ebb5"}),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"}),t.newLine=new t("newline",{fontCharacter:"\\ebea"}),t.dialogError=new t("dialog-error",t.error.definition),t.dialogWarning=new t("dialog-warning",t.warning.definition),t.dialogInfo=new t("dialog-info",t.info.definition),t.dialogClose=new t("dialog-close",t.close.definition),t.treeItemExpanded=new t("tree-item-expanded",t.chevronDown.definition),t.treeFilterOnTypeOn=new t("tree-filter-on-type-on",t.listFilter.definition),t.treeFilterOnTypeOff=new t("tree-filter-on-type-off",t.listSelection.definition),t.treeFilterClear=new t("tree-filter-clear",t.close.definition),t.treeItemLoading=new t("tree-item-loading",t.loading.definition),t.menuSelection=new t("menu-selection",t.check.definition),t.menuSubmenu=new t("menu-submenu",t.chevronRight.definition),t.menuBarMore=new t("menubar-more",t.more.definition),t.scrollbarButtonLeft=new t("scrollbar-button-left",t.triangleLeft.definition),t.scrollbarButtonRight=new t("scrollbar-button-right",t.triangleRight.definition),t.scrollbarButtonUp=new t("scrollbar-button-up",t.triangleUp.definition),t.scrollbarButtonDown=new t("scrollbar-button-down",t.triangleDown.definition),t.toolBarMore=new t("toolbar-more",t.more.definition),t.quickInputBack=new t("quick-input-back",t.arrowLeft.definition);function T(k,F){const _=["codicon","codicon-"+k];return F&&_.push("codicon-modifier-"+F),_}e.getClassNamesArray=T;var C;(function(k){k.iconNameSegment="[A-Za-z0-9]+",k.iconNameExpression="[A-Za-z0-9-]+",k.iconModifierExpression="~[A-Za-z]+",k.iconNameCharacter="[A-Za-z0-9~-]";const F=new RegExp(`^(${k.iconNameExpression})(${k.iconModifierExpression})?$`);function _(a){if(a instanceof t)return["codicon","codicon-"+a.id];const c=F.exec(a.id);if(!c)return _(t.error);let[,p,D]=c;const f=["codicon","codicon-"+p];return D&&f.push("codicon-modifier-"+D.substr(1)),f}k.asClassNameArray=_;function n(a){return _(a).join(" ")}k.asClassName=n;function g(a){return"."+_(a).join(".")}k.asCSSSelector=g})(C=e.CSSIcon||(e.CSSIcon={}))}),define(we[103],Ee([0,1,15,6]),function(re,e,u,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function w(l){const h=l;return h?[h.on,h.pause,h.resume,h.destroy].every(y=>typeof y=="function"):!1}e.isReadableStream=w;function A(l){const h=l;return h?w(h.stream)&&Array.isArray(h.buffer)&&typeof h.ended=="boolean":!1}e.isReadableBufferedStream=A;function t(l,h){return new T(l,h)}e.newWriteableStream=t;class T{constructor(h,y){this.reducer=h,this.options=y,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(h){if(!this.state.destroyed){if(this.state.flowing)this.emitData(h);else if(this.buffer.data.push(h),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(y=>this.pendingWritePromises.push(y))}}error(h){this.state.destroyed||(this.state.flowing?this.emitError(h):this.buffer.error.push(h))}end(h){this.state.destroyed||(typeof h!="undefined"&&this.write(h),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(h){this.listeners.data.slice(0).forEach(y=>y(h))}emitError(h){this.listeners.error.length===0?(0,u.onUnexpectedError)(h):this.listeners.error.slice(0).forEach(y=>y(h))}emitEnd(){this.listeners.end.slice(0).forEach(h=>h())}on(h,y){if(!this.state.destroyed)switch(h){case"data":this.listeners.data.push(y),this.resume();break;case"end":this.listeners.end.push(y),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(y),this.state.flowing&&this.flowErrors();break}}removeListener(h,y){if(this.state.destroyed)return;let s;switch(h){case"data":s=this.listeners.data;break;case"end":s=this.listeners.end;break;case"error":s=this.listeners.error;break}if(s){const I=s.indexOf(y);I>=0&&s.splice(I,1)}}flowData(){if(this.buffer.data.length>0){const h=this.reducer(this.buffer.data);this.emitData(h),this.buffer.data.length=0;const y=[...this.pendingWritePromises];this.pendingWritePromises.length=0,y.forEach(s=>s())}}flowErrors(){if(this.listeners.error.length>0){for(const h of this.buffer.error)this.emitError(h);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function C(l,h){const y=[];let s;for(;(s=l.read())!==null;)y.push(s);return h(y)}e.consumeReadable=C;function k(l,h,y){const s=[];let I;for(;(I=l.read())!==null&&s.length<y;)s.push(I);return I===null&&s.length>0?h(s):{read:()=>{if(s.length>0)return s.shift();if(typeof I!="undefined"){const r=I;return I=void 0,r}return l.read()}}}e.peekReadable=k;function F(l,h){return new Promise((y,s)=>{const I=[];_(l,{onData:r=>{h&&I.push(r)},onError:r=>{h?s(r):y(void 0)},onEnd:()=>{y(h?h(I):void 0)}})})}e.consumeStream=F;function _(l,h){l.on("error",y=>h.onError(y)),l.on("end",()=>h.onEnd()),l.on("data",y=>h.onData(y))}e.listenStream=_;function n(l,h){return new Promise((y,s)=>{const I=new M.DisposableStore,r=[],i=o=>{if(r.push(o),r.length>h)return I.dispose(),l.pause(),y({stream:l,buffer:r,ended:!1})},v=o=>s(o),m=()=>y({stream:l,buffer:r,ended:!0});I.add((0,M.toDisposable)(()=>l.removeListener("error",v))),l.on("error",v),I.add((0,M.toDisposable)(()=>l.removeListener("end",m))),l.on("end",m),I.add((0,M.toDisposable)(()=>l.removeListener("data",i))),l.on("data",i)})}e.peekStream=n;function g(l,h){const y=t(h);return y.end(l),y}e.toStream=g;function a(){const l=t(()=>{throw new Error("not supported")});return l.end(),l}e.emptyStream=a;function c(l){let h=!1;return{read:()=>h?null:(h=!0,l)}}e.toReadable=c;function p(l,h,y){const s=t(y);return _(l,{onData:I=>s.write(h.data(I)),onError:I=>s.error(h.error?h.error(I):I),onEnd:()=>s.end()}),s}e.transform=p;function D(l,h,y){let s=!1;return{read:()=>{const I=h.read();return s?I:(s=!0,I!==null?y([l,I]):l)}}}e.prefixedReadable=D;function f(l,h,y){let s=!1;const I=t(y);return _(h,{onData:r=>s?I.write(r):(s=!0,I.write(y([l,r]))),onError:r=>I.error(r),onEnd:()=>{s||(s=!0,I.write(l)),I.end()}}),I}e.prefixedStream=f}),define(we[22],Ee([0,1,103]),function(re,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const M=typeof Buffer!="undefined";let w,A;class t{constructor(i){this.buffer=i,this.byteLength=this.buffer.byteLength}static alloc(i){return M?new t(Buffer.allocUnsafe(i)):new t(new Uint8Array(i))}static wrap(i){return M&&!Buffer.isBuffer(i)&&(i=Buffer.from(i.buffer,i.byteOffset,i.byteLength)),new t(i)}static fromString(i,v){return!(v?.dontUseNodeBuffer||!1)&&M?new t(Buffer.from(i)):(w||(w=new TextEncoder),new t(w.encode(i)))}static concat(i,v){if(typeof v=="undefined"){v=0;for(let b=0,d=i.length;b<d;b++)v+=i[b].byteLength}const m=t.alloc(v);let o=0;for(let b=0,d=i.length;b<d;b++){const E=i[b];m.set(E,o),o+=E.byteLength}return m}toString(){return M?this.buffer.toString():(A||(A=new TextDecoder),A.decode(this.buffer))}slice(i,v){return new t(this.buffer.subarray(i,v))}set(i,v){i instanceof t?this.buffer.set(i.buffer,v):this.buffer.set(i,v)}readUInt32BE(i){return k(this.buffer,i)}writeUInt32BE(i,v){F(this.buffer,i,v)}readUInt32LE(i){return _(this.buffer,i)}writeUInt32LE(i,v){n(this.buffer,i,v)}readUInt8(i){return g(this.buffer,i)}writeUInt8(i,v){a(this.buffer,i,v)}}e.VSBuffer=t;function T(r,i){return r[i+0]<<0>>>0|r[i+1]<<8>>>0}e.readUInt16LE=T;function C(r,i,v){r[v+0]=i&255,i=i>>>8,r[v+1]=i&255}e.writeUInt16LE=C;function k(r,i){return r[i]*2**24+r[i+1]*2**16+r[i+2]*2**8+r[i+3]}e.readUInt32BE=k;function F(r,i,v){r[v+3]=i,i=i>>>8,r[v+2]=i,i=i>>>8,r[v+1]=i,i=i>>>8,r[v]=i}e.writeUInt32BE=F;function _(r,i){return r[i+0]<<0>>>0|r[i+1]<<8>>>0|r[i+2]<<16>>>0|r[i+3]<<24>>>0}e.readUInt32LE=_;function n(r,i,v){r[v+0]=i&255,i=i>>>8,r[v+1]=i&255,i=i>>>8,r[v+2]=i&255,i=i>>>8,r[v+3]=i&255}e.writeUInt32LE=n;function g(r,i){return r[i]}e.readUInt8=g;function a(r,i,v){r[v]=i}e.writeUInt8=a;function c(r){return u.consumeReadable(r,i=>t.concat(i))}e.readableToBuffer=c;function p(r){return u.toReadable(r)}e.bufferToReadable=p;function D(r){return u.consumeStream(r,i=>t.concat(i))}e.streamToBuffer=D;async function f(r){return r.ended?t.concat(r.buffer):t.concat([...r.buffer,await D(r.stream)])}e.bufferedStreamToBuffer=f;function l(r){return u.toStream(r,i=>t.concat(i))}e.bufferToStream=l;function h(r){return u.transform(r,{data:i=>typeof i=="string"?t.fromString(i):t.wrap(i)},i=>t.concat(i))}e.streamToBufferReadableStream=h;function y(r){return u.newWriteableStream(i=>t.concat(i),r)}e.newWriteableBufferStream=y;function s(r,i){return u.prefixedReadable(r,i,v=>t.concat(v))}e.prefixedBufferReadable=s;function I(r,i){return u.prefixedStream(r,i,v=>t.concat(v))}e.prefixedBufferStream=I});var Xe=this&&this.__classPrivateFieldSet||function(re,e,u,M,w){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!w:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?w.call(re,u):w?w.value=u:e.set(re,u),u},Te=this&&this.__classPrivateFieldGet||function(re,e,u,M){if(u==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?M:u==="a"?M.call(re):M?M.value:e.get(re)};define(we[21],Ee([0,1,16,9]),function(re,e,u,M){"use strict";var w,A,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function T(r,i,v){let m=r.get(i);return m===void 0&&(m=v,r.set(i,m)),m}e.getOrSet=T;function C(r){const i=[];return r.forEach((v,m)=>{i.push(`${m} => ${v}`)}),`Map(${r.size}) {${i.join(", ")}}`}e.mapToString=C;function k(r){const i=[];return r.forEach(v=>{i.push(v)}),`Set(${r.size}) {${i.join(", ")}}`}e.setToString=k;class F{constructor(){this._value="",this._pos=0}reset(i){return this._value=i,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(i){const v=i.charCodeAt(0),m=this._value.charCodeAt(this._pos);return v-m}value(){return this._value[this._pos]}}e.StringIterator=F;class _{constructor(i=!0){this._caseSensitive=i}reset(i){return this._value=i,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(i)this._from++;else break;else i=!1;return this}cmp(i){return this._caseSensitive?(0,M.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,M.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=_;class n{constructor(i=!0,v=!0){this._splitOnBackslash=i,this._caseSensitive=v}reset(i){return this._value=i.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++){const v=this._value.charCodeAt(this._to);if(v===47||this._splitOnBackslash&&v===92)if(i)this._from++;else break;else i=!1}return this}cmp(i){return this._caseSensitive?(0,M.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,M.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=n;var g;(function(r){r[r.Scheme=1]="Scheme",r[r.Authority=2]="Authority",r[r.Path=3]="Path",r[r.Query=4]="Query",r[r.Fragment=5]="Fragment"})(g||(g={}));class a{constructor(i){this._ignorePathCasing=i,this._states=[],this._stateIdx=0}reset(i){return this._value=i,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new n(!1,!this._ignorePathCasing(i)),this._pathIterator.reset(i.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(i){if(this._states[this._stateIdx]===1)return(0,M.compareIgnoreCase)(i,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,M.compareIgnoreCase)(i,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(i);if(this._states[this._stateIdx]===4)return(0,M.compare)(i,this._value.query);if(this._states[this._stateIdx]===5)return(0,M.compare)(i,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=a;class c{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const i=this.right;return this.right=i.left,i.left=this,this.updateHeight(),i.updateHeight(),i}rotateRight(){const i=this.left;return this.left=i.right,i.right=this,this.updateHeight(),i.updateHeight(),i}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var p;(function(r){r[r.Left=-1]="Left",r[r.Mid=0]="Mid",r[r.Right=1]="Right"})(p||(p={}));class D{constructor(i){this._iter=i}static forUris(i=()=>!1){return new D(new a(i))}static forPaths(){return new D(new n)}static forStrings(){return new D(new F)}static forConfigKeys(){return new D(new _)}clear(){this._root=void 0}fill(i,v){if(v){const m=v.slice(0);(0,u.shuffle)(m);for(let o of m)this.set(o,i)}else{const m=i.slice(0);(0,u.shuffle)(m);for(let o of m)this.set(o[0],o[1])}}set(i,v){const m=this._iter.reset(i);let o;this._root||(this._root=new c,this._root.segment=m.value());const b=[];for(o=this._root;;){const E=m.cmp(o.segment);if(E>0)o.left||(o.left=new c,o.left.segment=m.value()),b.push([-1,o]),o=o.left;else if(E<0)o.right||(o.right=new c,o.right.segment=m.value()),b.push([1,o]),o=o.right;else if(m.hasNext())m.next(),o.mid||(o.mid=new c,o.mid.segment=m.value()),b.push([0,o]),o=o.mid;else break}const d=o.value;o.value=v,o.key=i;for(let E=b.length-1;E>=0;E--){const R=b[E][1];R.updateHeight();const P=R.balanceFactor();if(P<-1||P>1){const z=b[E][0],O=b[E+1][0];if(z===1&&O===1)b[E][1]=R.rotateLeft();else if(z===-1&&O===-1)b[E][1]=R.rotateRight();else if(z===1&&O===-1)R.right=b[E+1][1]=b[E+1][1].rotateRight(),b[E][1]=R.rotateLeft();else if(z===-1&&O===1)R.left=b[E+1][1]=b[E+1][1].rotateLeft(),b[E][1]=R.rotateRight();else throw new Error;if(E>0)switch(b[E-1][0]){case-1:b[E-1][1].left=b[E][1];break;case 1:b[E-1][1].right=b[E][1];break;case 0:b[E-1][1].mid=b[E][1];break}else this._root=b[0][1]}}return d}get(i){return this._getNode(i)?.value}_getNode(i){const v=this._iter.reset(i);let m=this._root;for(;m;){const o=v.cmp(m.segment);if(o>0)m=m.left;else if(o<0)m=m.right;else if(v.hasNext())v.next(),m=m.mid;else break}return m}has(i){const v=this._getNode(i);return!(v?.value===void 0&&v?.mid===void 0)}delete(i){return this._delete(i,!1)}deleteSuperstr(i){return this._delete(i,!0)}_delete(i,v){const m=this._iter.reset(i),o=[];let b=this._root;for(;b;){const d=m.cmp(b.segment);if(d>0)o.push([-1,b]),b=b.left;else if(d<0)o.push([1,b]),b=b.right;else if(m.hasNext())m.next(),o.push([0,b]),b=b.mid;else break}if(!!b){if(v?(b.left=void 0,b.mid=void 0,b.right=void 0,b.height=1):(b.key=void 0,b.value=void 0),!b.mid&&!b.value)if(b.left&&b.right){const d=this._min(b.right),{key:E,value:R,segment:P}=d;this._delete(d.key,!1),b.key=E,b.value=R,b.segment=P}else{const d=b.left??b.right;if(o.length>0){const[E,R]=o[o.length-1];switch(E){case-1:R.left=d;break;case 0:R.mid=d;break;case 1:R.right=d;break}}else this._root=d}for(let d=o.length-1;d>=0;d--){const E=o[d][1];E.updateHeight();const R=E.balanceFactor();if(R>1?(E.right.balanceFactor()>=0||(E.right=o[d+1][1]=o[d+1][1].rotateRight()),o[d][1]=E.rotateLeft()):R<-1&&(E.left.balanceFactor()<=0||(E.left=o[d+1][1]=o[d+1][1].rotateLeft()),o[d][1]=E.rotateRight()),d>0)switch(o[d-1][0]){case-1:o[d-1][1].left=o[d][1];break;case 1:o[d-1][1].right=o[d][1];break;case 0:o[d-1][1].mid=o[d][1];break}else this._root=o[0][1]}}}_min(i){for(;i.left;)i=i.left;return i}findSubstr(i){const v=this._iter.reset(i);let m=this._root,o;for(;m;){const b=v.cmp(m.segment);if(b>0)m=m.left;else if(b<0)m=m.right;else if(v.hasNext())v.next(),o=m.value||o,m=m.mid;else break}return m&&m.value||o}findSuperstr(i){const v=this._iter.reset(i);let m=this._root;for(;m;){const o=v.cmp(m.segment);if(o>0)m=m.left;else if(o<0)m=m.right;else if(v.hasNext())v.next(),m=m.mid;else return m.mid?this._entries(m.mid):void 0}}forEach(i){for(const[v,m]of this)i(m,v)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(i){!i||(i.left&&(yield*this._entries(i.left)),i.value&&(yield[i.key,i.value]),i.mid&&(yield*this._entries(i.mid)),i.right&&(yield*this._entries(i.right)))}_isBalanced(){const i=v=>{if(!v)return!0;const m=v.balanceFactor();return m<-1||m>1?!1:i(v.left)&&i(v.right)};return i(this._root)}}e.TernarySearchTree=D;class f{constructor(i,v){this.uri=i,this.value=v}}class l{constructor(i,v){this[w]="ResourceMap",i instanceof l?(this.map=new Map(i.map),this.toKey=v??l.defaultToKey):(this.map=new Map,this.toKey=i??l.defaultToKey)}set(i,v){return this.map.set(this.toKey(i),new f(i,v)),this}get(i){return this.map.get(this.toKey(i))?.value}has(i){return this.map.has(this.toKey(i))}get size(){return this.map.size}clear(){this.map.clear()}delete(i){return this.map.delete(this.toKey(i))}forEach(i,v){typeof v!="undefined"&&(i=i.bind(v));for(let[m,o]of this.map)i(o.value,o.uri,this)}*values(){for(let i of this.map.values())yield i.value}*keys(){for(let i of this.map.values())yield i.uri}*entries(){for(let i of this.map.values())yield[i.uri,i.value]}*[(w=Symbol.toStringTag,Symbol.iterator)](){for(let[,i]of this.map)yield[i.uri,i.value]}}e.ResourceMap=l,l.defaultToKey=r=>r.toString();var h;(function(r){r[r.None=0]="None",r[r.AsOld=1]="AsOld",r[r.AsNew=2]="AsNew"})(h=e.Touch||(e.Touch={}));class y{constructor(){this[A]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(i){return this._map.has(i)}get(i,v=0){const m=this._map.get(i);if(!!m)return v!==0&&this.touch(m,v),m.value}set(i,v,m=0){let o=this._map.get(i);if(o)o.value=v,m!==0&&this.touch(o,m);else{switch(o={key:i,value:v,next:void 0,previous:void 0},m){case 0:this.addItemLast(o);break;case 1:this.addItemFirst(o);break;case 2:this.addItemLast(o);break;default:this.addItemLast(o);break}this._map.set(i,o),this._size++}return this}delete(i){return!!this.remove(i)}remove(i){const v=this._map.get(i);if(!!v)return this._map.delete(i),this.removeItem(v),this._size--,v.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const i=this._head;return this._map.delete(i.key),this.removeItem(i),this._size--,i.value}forEach(i,v){const m=this._state;let o=this._head;for(;o;){if(v?i.bind(v)(o.value,o.key,this):i(o.value,o.key,this),this._state!==m)throw new Error("LinkedMap got modified during iteration.");o=o.next}}keys(){const i=this,v=this._state;let m=this._head;const o={[Symbol.iterator](){return o},next(){if(i._state!==v)throw new Error("LinkedMap got modified during iteration.");if(m){const b={value:m.key,done:!1};return m=m.next,b}else return{value:void 0,done:!0}}};return o}values(){const i=this,v=this._state;let m=this._head;const o={[Symbol.iterator](){return o},next(){if(i._state!==v)throw new Error("LinkedMap got modified during iteration.");if(m){const b={value:m.value,done:!1};return m=m.next,b}else return{value:void 0,done:!0}}};return o}entries(){const i=this,v=this._state;let m=this._head;const o={[Symbol.iterator](){return o},next(){if(i._state!==v)throw new Error("LinkedMap got modified during iteration.");if(m){const b={value:[m.key,m.value],done:!1};return m=m.next,b}else return{value:void 0,done:!0}}};return o}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(i){if(i>=this.size)return;if(i===0){this.clear();return}let v=this._head,m=this.size;for(;v&&m>i;)this._map.delete(v.key),v=v.next,m--;this._head=v,this._size=m,v&&(v.previous=void 0),this._state++}addItemFirst(i){if(!this._head&&!this._tail)this._tail=i;else if(this._head)i.next=this._head,this._head.previous=i;else throw new Error("Invalid list");this._head=i,this._state++}addItemLast(i){if(!this._head&&!this._tail)this._head=i;else if(this._tail)i.previous=this._tail,this._tail.next=i;else throw new Error("Invalid list");this._tail=i,this._state++}removeItem(i){if(i===this._head&&i===this._tail)this._head=void 0,this._tail=void 0;else if(i===this._head){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this._head=i.next}else if(i===this._tail){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this._tail=i.previous}else{const v=i.next,m=i.previous;if(!v||!m)throw new Error("Invalid list");v.previous=m,m.next=v}i.next=void 0,i.previous=void 0,this._state++}touch(i,v){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(v!==1&&v!==2)){if(v===1){if(i===this._head)return;const m=i.next,o=i.previous;i===this._tail?(o.next=void 0,this._tail=o):(m.previous=o,o.next=m),i.previous=void 0,i.next=this._head,this._head.previous=i,this._head=i,this._state++}else if(v===2){if(i===this._tail)return;const m=i.next,o=i.previous;i===this._head?(m.previous=void 0,this._head=m):(m.previous=o,o.next=m),i.next=void 0,i.previous=this._tail,this._tail.next=i,this._tail=i,this._state++}}}toJSON(){const i=[];return this.forEach((v,m)=>{i.push([m,v])}),i}fromJSON(i){this.clear();for(const[v,m]of i)this.set(v,m)}}e.LinkedMap=y;class s extends y{constructor(i,v=1){super();this._limit=i,this._ratio=Math.min(Math.max(0,v),1)}get limit(){return this._limit}set limit(i){this._limit=i,this.checkTrim()}get ratio(){return this._ratio}set ratio(i){this._ratio=Math.min(Math.max(0,i),1),this.checkTrim()}get(i,v=2){return super.get(i,v)}peek(i){return super.get(i,0)}set(i,v){return super.set(i,v,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=s;class I{constructor(i){t.set(this,void 0),Xe(this,t,i,"f")}get size(){return Te(this,t,"f").size}forEach(i,v){Te(this,t,"f").forEach(i,v)}get(i){return Te(this,t,"f").get(i)}has(i){return Te(this,t,"f").has(i)}entries(){return Te(this,t,"f").entries()}keys(){return Te(this,t,"f").keys()}values(){return Te(this,t,"f").values()}[(t=new WeakMap,Symbol.iterator)](){return Te(this,t,"f").entries()}}e.ReadonlyMapView=I}),define(we[104],Ee([0,1,21,9]),function(re,e,u,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function w(...G){return function(te,he){for(let Pe=0,Oe=G.length;Pe<Oe;Pe++){const Be=G[Pe](te,he);if(Be)return Be}return null}}e.or=w,e.matchesStrictPrefix=A.bind(void 0,!1),e.matchesPrefix=A.bind(void 0,!0);function A(G,te,he){if(!he||he.length<te.length)return null;let Pe;return G?Pe=M.startsWithIgnoreCase(he,te):Pe=he.indexOf(te)===0,Pe?te.length>0?[{start:0,end:te.length}]:[]:null}function t(G,te){const he=te.toLowerCase().indexOf(G.toLowerCase());return he===-1?null:[{start:he,end:he+G.length}]}e.matchesContiguousSubString=t;function T(G,te){return C(G.toLowerCase(),te.toLowerCase(),0,0)}e.matchesSubString=T;function C(G,te,he,Pe){if(he===G.length)return[];if(Pe===te.length)return null;if(G[he]===te[Pe]){let Oe=null;return(Oe=C(G,te,he+1,Pe+1))?D({start:Pe,end:Pe+1},Oe):null}return C(G,te,he,Pe+1)}function k(G){return 97<=G&&G<=122}function F(G){return 65<=G&&G<=90}e.isUpper=F;function _(G){return 48<=G&&G<=57}function n(G){return G===32||G===9||G===10||G===13}const g=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(G=>g.add(G.charCodeAt(0)));function a(G){return n(G)||g.has(G)}function c(G,te){return G===te||a(G)&&a(te)}function p(G){return k(G)||F(G)||_(G)}function D(G,te){return te.length===0?te=[G]:G.end===te[0].start?te[0].start=G.start:te.unshift(G),te}function f(G,te){for(let he=te;he<G.length;he++){const Pe=G.charCodeAt(he);if(F(Pe)||_(Pe)||he>0&&!p(G.charCodeAt(he-1)))return he}return G.length}function l(G,te,he,Pe){if(he===G.length)return[];if(Pe===te.length)return null;if(G[he]!==te[Pe].toLowerCase())return null;{let Oe=null,Be=Pe+1;for(Oe=l(G,te,he+1,Pe+1);!Oe&&(Be=f(te,Be))<te.length;)Oe=l(G,te,he+1,Be),Be++;return Oe===null?null:D({start:Pe,end:Pe+1},Oe)}}function h(G){let te=0,he=0,Pe=0,Oe=0,Be=0;for(let it=0;it<G.length;it++)Be=G.charCodeAt(it),F(Be)&&te++,k(Be)&&he++,p(Be)&&Pe++,_(Be)&&Oe++;const Ve=te/G.length,Ze=he/G.length,ot=Pe/G.length,ye=Oe/G.length;return{upperPercent:Ve,lowerPercent:Ze,alphaPercent:ot,numericPercent:ye}}function y(G){const{upperPercent:te,lowerPercent:he}=G;return he===0&&te>.6}function s(G){const{upperPercent:te,lowerPercent:he,alphaPercent:Pe,numericPercent:Oe}=G;return he>.2&&te<.8&&Pe>.6&&Oe<.2}function I(G){let te=0,he=0,Pe=0,Oe=0;for(let Be=0;Be<G.length;Be++)Pe=G.charCodeAt(Be),F(Pe)&&te++,k(Pe)&&he++,n(Pe)&&Oe++;return(te===0||he===0)&&Oe===0?G.length<=30:te<=5}function r(G,te){if(!te||(te=te.trim(),te.length===0)||!I(G)||te.length>60)return null;const he=h(te);if(!s(he)){if(!y(he))return null;te=te.toLowerCase()}let Pe=null,Oe=0;for(G=G.toLowerCase();Oe<te.length&&(Pe=l(G,te,0,Oe))===null;)Oe=f(te,Oe+1);return Pe}e.matchesCamelCase=r;function i(G,te,he=!1){if(!te||te.length===0)return null;let Pe=null,Oe=0;for(G=G.toLowerCase(),te=te.toLowerCase();Oe<te.length&&(Pe=v(G,te,0,Oe,he))===null;)Oe=m(te,Oe+1);return Pe}e.matchesWords=i;function v(G,te,he,Pe,Oe){if(he===G.length)return[];if(Pe===te.length)return null;if(c(G.charCodeAt(he),te.charCodeAt(Pe))){let Be=null,Ve=Pe+1;if(Be=v(G,te,he+1,Pe+1,Oe),!Oe)for(;!Be&&(Ve=m(te,Ve))<te.length;)Be=v(G,te,he+1,Ve,Oe),Ve++;return Be===null?null:D({start:Pe,end:Pe+1},Be)}else return null}function m(G,te){for(let he=te;he<G.length;he++)if(a(G.charCodeAt(he))||he>0&&a(G.charCodeAt(he-1)))return he;return G.length}const o=w(e.matchesPrefix,r,t),b=w(e.matchesPrefix,r,T),d=new u.LRUCache(1e4);function E(G,te,he=!1){if(typeof G!="string"||typeof te!="string")return null;let Pe=d.get(G);Pe||(Pe=new RegExp(M.convertSimple2RegExpPattern(G),"i"),d.set(G,Pe));const Oe=Pe.exec(te);return Oe?[{start:Oe.index,end:Oe.index+Oe[0].length}]:he?b(G,te):o(G,te)}e.matchesFuzzy=E;function R(G,te){const he=Ye(G,G.toLowerCase(),0,te,te.toLowerCase(),0,!0);return he?z(he):null}e.matchesFuzzy2=R;function P(G,te,he,Pe,Oe,Be){const Ve=Math.min(13,G.length);for(;he<Ve;he++){const Ze=Ye(G,te,he,Pe,Oe,Be,!1);if(Ze)return Ze}return[0,Be]}e.anyScore=P;function z(G){if(typeof G=="undefined")return[];const te=[],he=G[1];for(let Pe=G.length-1;Pe>1;Pe--){const Oe=G[Pe]+he,Be=te[te.length-1];Be&&Be.end===Oe?Be.end=Oe+1:te.push({start:Oe,end:Oe+1})}return te}e.createMatches=z;const O=128;function S(){const G=[],te=[];for(let he=0;he<=O;he++)te[he]=0;for(let he=0;he<=O;he++)G.push(te.slice(0));return G}function x(G){const te=[];for(let he=0;he<=G;he++)te[he]=0;return te}const N=x(2*O),V=x(2*O),B=S(),$=S(),J=S(),j=!1;function Q(G,te,he,Pe,Oe){function Be(Ze,ot,ye=" "){for(;Ze.length<ot;)Ze=ye+Ze;return Ze}let Ve=` |   |${Pe.split("").map(Ze=>Be(Ze,3)).join("|")}
`;for(let Ze=0;Ze<=he;Ze++)Ze===0?Ve+=" |":Ve+=`${te[Ze-1]}|`,Ve+=G[Ze].slice(0,Oe+1).map(ot=>Be(ot.toString(),3)).join("|")+`
`;return Ve}function le(G,te,he,Pe){G=G.substr(te),he=he.substr(Pe),console.log(Q($,G,G.length,he,he.length)),console.log(Q(J,G,G.length,he,he.length)),console.log(Q(B,G,G.length,he,he.length))}function be(G,te){if(te<0||te>=G.length)return!1;const he=G.codePointAt(te);switch(he){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!M.isEmojiImprecise(he)}}function de(G,te){if(te<0||te>=G.length)return!1;switch(G.charCodeAt(te)){case 32:case 9:return!0;default:return!1}}function Fe(G,te,he){return te[G]!==he[G]}function Ge(G,te,he,Pe,Oe,Be,Ve=!1){for(;te<he&&Oe<Be;)G[te]===Pe[Oe]&&(Ve&&(N[te]=Oe),te+=1),Oe+=1;return te===he}e.isPatternInWord=Ge;var Le;(function(G){G[G.Diag=1]="Diag",G[G.Left=2]="Left",G[G.LeftLeft=3]="LeftLeft"})(Le||(Le={}));var We;(function(G){G.Default=[-100,0];function te(he){return!he||he.length===2&&he[0]===-100&&he[1]===0}G.isDefault=te})(We=e.FuzzyScore||(e.FuzzyScore={}));function Ye(G,te,he,Pe,Oe,Be,Ve){const Ze=G.length>O?O:G.length,ot=Pe.length>O?O:Pe.length;if(he>=Ze||Be>=ot||Ze-he>ot-Be||!Ge(te,he,Ze,Oe,Be,ot,!0))return;Qe(Ze,ot,he,Be,te,Oe);let ye=1,it=1,q=he,X=Be;const ge=[!1];for(ye=1,q=he;q<Ze;ye++,q++){const lt=N[q],St=V[q],kt=q+1<Ze?V[q+1]:ot;for(it=lt-Be+1,X=lt;X<kt;it++,X++){let It=Number.MIN_SAFE_INTEGER,Je=!1;X<=St&&(It=Ke(G,te,q,he,Pe,Oe,X,ot,Be,B[ye-1][it-1]===0,ge));let bt=0;It!==Number.MAX_SAFE_INTEGER&&(Je=!0,bt=It+$[ye-1][it-1]);const Ie=X>lt,Se=Ie?$[ye][it-1]+(B[ye][it-1]>0?-5:0):0,pe=X>lt+1&&B[ye][it-1]>0,oe=pe?$[ye][it-2]+(B[ye][it-2]>0?-5:0):0;if(pe&&(!Ie||oe>=Se)&&(!Je||oe>=bt))$[ye][it]=oe,J[ye][it]=3,B[ye][it]=0;else if(Ie&&(!Je||Se>=bt))$[ye][it]=Se,J[ye][it]=2,B[ye][it]=0;else if(Je)$[ye][it]=bt,J[ye][it]=1,B[ye][it]=B[ye-1][it-1]+1;else throw new Error("not possible")}}if(j&&le(G,he,Pe,Be),!ge[0]&&!Ve)return;ye--,it--;const Ue=[$[ye][it],Be];let qe=0,nt=0;for(;ye>=1;){let lt=it;do{const St=J[ye][lt];if(St===3)lt=lt-2;else if(St===2)lt=lt-1;else break}while(lt>=1);qe>1&&te[he+ye-1]===Oe[Be+it-1]&&!Fe(lt+Be-1,Pe,Oe)&&qe+1>B[ye][lt]&&(lt=it),lt===it?qe++:qe=1,nt||(nt=lt),ye--,it=lt-1,Ue.push(it)}ot===Ze&&(Ue[0]+=2);const mt=nt-Ze;return Ue[0]-=mt,Ue}e.fuzzyScore=Ye;function Qe(G,te,he,Pe,Oe,Be){let Ve=G-1,Ze=te-1;for(;Ve>=he&&Ze>=Pe;)Oe[Ve]===Be[Ze]&&(V[Ve]=Ze,Ve--),Ze--}function Ke(G,te,he,Pe,Oe,Be,Ve,Ze,ot,ye,it){if(te[he]!==Be[Ve])return Number.MIN_SAFE_INTEGER;let q=1,X=!1;return Ve===he-Pe?q=G[he]===Oe[Ve]?7:5:Fe(Ve,Oe,Be)&&(Ve===0||!Fe(Ve-1,Oe,Be))?(q=G[he]===Oe[Ve]?7:5,X=!0):be(Be,Ve)&&(Ve===0||!be(Be,Ve-1))?q=5:(be(Be,Ve-1)||de(Be,Ve-1))&&(q=5,X=!0),q>1&&he===Pe&&(it[0]=!0),X||(X=Fe(Ve,Oe,Be)||be(Be,Ve-1)||de(Be,Ve-1)),he===Pe?Ve>ot&&(q-=X?3:5):ye?q+=X?2:0:q+=X?0:1,Ve+1===Ze&&(q-=X?3:5),q}function W(G,te,he,Pe,Oe,Be,Ve){return Z(G,te,he,Pe,Oe,Be,!0,Ve)}e.fuzzyScoreGracefulAggressive=W;function K(G,te,he,Pe,Oe,Be,Ve){return Z(G,te,he,Pe,Oe,Be,!1,Ve)}e.fuzzyScoreGraceful=K;function Z(G,te,he,Pe,Oe,Be,Ve,Ze){let ot=Ye(G,te,he,Pe,Oe,Be,Ze);if(ot&&!Ve)return ot;if(G.length>=3){const ye=Math.min(7,G.length-1);for(let it=he+1;it<ye;it++){const q=se(G,it);if(q){const X=Ye(q,q.toLowerCase(),he,Pe,Oe,Be,Ze);X&&(X[0]-=3,(!ot||X[0]>ot[0])&&(ot=X))}}}return ot}function se(G,te){if(te+1>=G.length)return;const he=G[te],Pe=G[te+1];if(he!==Pe)return G.slice(0,te)+Pe+he+G.slice(te+2)}}),define(we[105],Ee([0,1,54,104,9]),function(re,e,u,M,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const A=new RegExp(`\\$\\(${u.CSSIcon.iconNameExpression}(?:${u.CSSIcon.iconModifierExpression})?\\)`,"g"),t=new RegExp(u.CSSIcon.iconNameCharacter),T=new RegExp(`(\\\\)?${A.source}`,"g");function C(p){return p.replace(T,(D,f)=>f?D:`\\${D}`)}e.escapeIcons=C;const k=new RegExp(`\\\\${A.source}`,"g");function F(p){return p.replace(k,D=>`\\${D}`)}e.markdownEscapeEscapedIcons=F;const _=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function n(p){return p.indexOf(e.iconStartMarker)===-1?p:p.replace(_,(D,f,l,h)=>l?D:f||h||"")}e.stripIcons=n;function g(p){const D=p.indexOf(e.iconStartMarker);return D===-1?{text:p}:a(p,D)}e.parseLabelWithIcons=g;function a(p,D){const f=[];let l="";function h(o){if(o){l+=o;for(const b of o)f.push(I)}}let y=-1,s="",I=0,r,i,v=D;const m=p.length;for(h(p.substr(0,D));v<m;)r=p[v],i=p[v+1],r===e.iconStartMarker[0]&&i===e.iconStartMarker[1]?(y=v,h(s),s=e.iconStartMarker,v++):r===")"&&y!==-1?(I+=v-y+1,y=-1,s=""):y!==-1?t.test(r)?s+=r:(h(s),y=-1,s=""):h(r),v++;return h(s),{text:l,iconOffsets:f}}function c(p,D,f=!1){const{text:l,iconOffsets:h}=D;if(!h||h.length===0)return(0,M.matchesFuzzy)(p,l,f);const y=(0,w.ltrim)(l," "),s=l.length-y.length,I=(0,M.matchesFuzzy)(p,y,f);if(I)for(const r of I){const i=h[r.start+s]+s;r.start+=i,r.end+=i}return I}e.matchesFuzzyIconAware=c}),define(we[77],Ee([0,1,15,105]),function(re,e,u,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var w;(function(n){n[n.Paragraph=0]="Paragraph",n[n.Break=1]="Break"})(w=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class A{constructor(g="",a=!1){if(this.value=g,typeof this.value!="string")throw(0,u.illegalArgument)("value");typeof a=="boolean"?(this.isTrusted=a,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=a.isTrusted??void 0,this.supportThemeIcons=a.supportThemeIcons??!1,this.supportHtml=a.supportHtml??!1)}appendText(g,a=0){return this.value+=k(this.supportThemeIcons?(0,M.escapeIcons)(g):g).replace(/([ \t]+)/g,(c,p)=>"&nbsp;".repeat(p.length)).replace(/\>/gm,"\\>").replace(/\n/g,a===1?`\\
`:`

`),this}appendMarkdown(g){return this.value+=g,this}appendCodeblock(g,a){return this.value+="\n```",this.value+=g,this.value+=`
`,this.value+=a,this.value+="\n```\n",this}}e.MarkdownString=A;function t(n){return T(n)?!n.value:Array.isArray(n)?n.every(t):!0}e.isEmptyMarkdownString=t;function T(n){return n instanceof A?!0:n&&typeof n=="object"?typeof n.value=="string"&&(typeof n.isTrusted=="boolean"||n.isTrusted===void 0)&&(typeof n.supportThemeIcons=="boolean"||n.supportThemeIcons===void 0):!1}e.isMarkdownString=T;function C(n,g){return n===g?!0:!n||!g?!1:n.value===g.value&&n.isTrusted===g.isTrusted&&n.supportThemeIcons===g.supportThemeIcons}e.markdownStringEqual=C;function k(n){return n.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=k;function F(n){return n&&n.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=F;function _(n){const g=[],a=n.split("|").map(p=>p.trim());n=a[0];const c=a[1];if(c){const p=/height=(\d+)/.exec(c),D=/width=(\d+)/.exec(c),f=p?p[1]:"",l=D?D[1]:"",h=isFinite(parseInt(l)),y=isFinite(parseInt(f));h&&g.push(`width="${l}"`),y&&g.push(`height="${f}"`)}return{href:n,dimensions:g}}e.parseHrefAndDimensions=_}),define(we[35],Ee([0,1,9]),function(re,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var M;(function(w){w[w.Ignore=0]="Ignore",w[w.Info=1]="Info",w[w.Warning=2]="Warning",w[w.Error=3]="Error"})(M||(M={})),function(w){const A="error",t="warning",T="warn",C="info",k="ignore";function F(n){return n?u.equalsIgnoreCase(A,n)?w.Error:u.equalsIgnoreCase(t,n)||u.equalsIgnoreCase(T,n)?w.Warning:u.equalsIgnoreCase(C,n)?w.Info:w.Ignore:w.Ignore}w.fromValue=F;function _(n){switch(n){case w.Error:return A;case w.Warning:return t;case w.Info:return C;default:return k}}w.toString=_}(M||(M={})),e.default=M}),define(we[42],Ee([0,1,17,24,9,10]),function(re,e,u,M,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function t(r){return r===47||r===92}e.isPathSeparator=t;function T(r){return r.replace(/[\\/]/g,u.posix.sep)}e.toSlashes=T;function C(r){return r.indexOf("/")===-1&&(r=T(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.toPosixPath=C;function k(r,i=u.posix.sep){if(!r)return"";const v=r.length,m=r.charCodeAt(0);if(t(m)){if(t(r.charCodeAt(1))&&!t(r.charCodeAt(2))){let b=3;const d=b;for(;b<v&&!t(r.charCodeAt(b));b++);if(d!==b&&!t(r.charCodeAt(b+1))){for(b+=1;b<v;b++)if(t(r.charCodeAt(b)))return r.slice(0,b+1).replace(/[\\/]/g,i)}}return i}else if(D(m)&&r.charCodeAt(1)===58)return t(r.charCodeAt(2))?r.slice(0,2)+i:r.slice(0,2);let o=r.indexOf("://");if(o!==-1){for(o+=3;o<v;o++)if(t(r.charCodeAt(o)))return r.slice(0,o+1)}return""}e.getRoot=k;function F(r){if(!M.isWindows||!r||r.length<5)return!1;let i=r.charCodeAt(0);if(i!==92||(i=r.charCodeAt(1),i!==92))return!1;let v=2;const m=v;for(;v<r.length&&(i=r.charCodeAt(v),i!==92);v++);return!(m===v||(i=r.charCodeAt(v+1),isNaN(i)||i===92))}e.isUNC=F;const _=/[\\/:\*\?"<>\|]/g,n=/[\\/]/g,g=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function a(r,i=M.isWindows){const v=i?_:n;return!(!r||r.length===0||/^\s+$/.test(r)||(v.lastIndex=0,v.test(r))||i&&g.test(r)||r==="."||r===".."||i&&r[r.length-1]==="."||i&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=a;function c(r,i,v){const m=r===i;return!v||m?m:!r||!i?!1:(0,w.equalsIgnoreCase)(r,i)}e.isEqual=c;function p(r,i,v,m=u.sep){if(r===i)return!0;if(!r||!i||i.length>r.length)return!1;if(v){if(!(0,w.startsWithIgnoreCase)(r,i))return!1;if(i.length===r.length)return!0;let b=i.length;return i.charAt(i.length-1)===m&&b--,r.charAt(b)===m}return i.charAt(i.length-1)!==m&&(i+=m),r.indexOf(i)===0}e.isEqualOrParent=p;function D(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=D;function f(r,i){return M.isWindows&&r.endsWith(":")&&(r+=u.sep),(0,u.isAbsolute)(r)||(r=(0,u.join)(i,r)),r=(0,u.normalize)(r),M.isWindows?(r=(0,w.rtrim)(r,u.sep),r.endsWith(":")&&(r+=u.sep)):(r=(0,w.rtrim)(r,u.sep),r||(r=u.sep)),r}e.sanitizeFilePath=f;function l(r){const i=(0,u.normalize)(r);return M.isWindows?r.length>3?!1:h(i)&&(r.length===2||i.charCodeAt(2)===92):i===u.posix.sep}e.isRootOrDriveLetter=l;function h(r,i){return(i!==void 0?i:M.isWindows)?D(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=h;function y(r){return h(r)?r[0]:void 0}e.getDriveLetter=y;function s(r,i,v){return i.length>r.length?-1:r===i?0:(v&&(r=r.toLowerCase(),i=i.toLowerCase()),r.indexOf(i))}e.indexOfPath=s;function I(r){const i=r.split(":");let v,m,o;if(i.forEach(b=>{const d=Number(b);(0,A.isNumber)(d)?m===void 0?m=d:o===void 0&&(o=d):v=v?[v,b].join(":"):b}),!v)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:v,line:m!==void 0?m:void 0,column:o!==void 0?o:m!==void 0?1:void 0}}e.parseLineAndColumnAware=I}),define(we[25],Ee([0,1,10]),function(re,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function M(c){if(!c||typeof c!="object"||c instanceof RegExp)return c;const p=Array.isArray(c)?[]:{};return Object.keys(c).forEach(D=>{c[D]&&typeof c[D]=="object"?p[D]=M(c[D]):p[D]=c[D]}),p}e.deepClone=M;function w(c){if(!c||typeof c!="object")return c;const p=[c];for(;p.length>0;){const D=p.shift();Object.freeze(D);for(const f in D)if(A.call(D,f)){const l=D[f];typeof l=="object"&&!Object.isFrozen(l)&&p.push(l)}}return c}e.deepFreeze=w;const A=Object.prototype.hasOwnProperty;function t(c,p){return T(c,p,new Set)}e.cloneAndChange=t;function T(c,p,D){if((0,u.isUndefinedOrNull)(c))return c;const f=p(c);if(typeof f!="undefined")return f;if((0,u.isArray)(c)){const l=[];for(const h of c)l.push(T(h,p,D));return l}if((0,u.isObject)(c)){if(D.has(c))throw new Error("Cannot clone recursive data-structure");D.add(c);const l={};for(let h in c)A.call(c,h)&&(l[h]=T(c[h],p,D));return D.delete(c),l}return c}function C(c,p,D=!0){return(0,u.isObject)(c)?((0,u.isObject)(p)&&Object.keys(p).forEach(f=>{f in c?D&&((0,u.isObject)(c[f])&&(0,u.isObject)(p[f])?C(c[f],p[f],D):c[f]=p[f]):c[f]=p[f]}),c):p}e.mixin=C;function k(c,p){if(c===p)return!0;if(c==null||p===null||p===void 0||typeof c!=typeof p||typeof c!="object"||Array.isArray(c)!==Array.isArray(p))return!1;let D,f;if(Array.isArray(c)){if(c.length!==p.length)return!1;for(D=0;D<c.length;D++)if(!k(c[D],p[D]))return!1}else{const l=[];for(f in c)l.push(f);l.sort();const h=[];for(f in p)h.push(f);if(h.sort(),!k(l,h))return!1;for(D=0;D<l.length;D++)if(!k(c[l[D]],p[l[D]]))return!1}return!0}e.equals=k;function F(c){const p=new Set;return JSON.stringify(c,(D,f)=>{if((0,u.isObject)(f)||Array.isArray(f)){if(p.has(f))return"[Circular]";p.add(f)}return f})}e.safeStringify=F;function _(c,p,D){const f=p(c);return typeof f=="undefined"?D:f}e.getOrDefault=_;function n(c,p){const D=Object.create(null);return!c||!p||Object.keys(p).forEach(l=>{const h=c[l],y=p[l];k(h,y)||(D[l]=y)}),D}e.distinct=n;function g(c,p){const D=p.toLowerCase(),f=Object.keys(c).find(l=>l.toLowerCase()===D);return f?c[f]:c[p]}e.getCaseInsensitive=g;function a(c,p){const D=Object.create(null);for(const[f,l]of Object.entries(c))p(f,l)&&(D[f]=l);return D}e.filter=a}),define(we[55],Ee([0,1,22,9,2]),function(re,e,u,M,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function A(F){return JSON.stringify(F,C)}e.stringify=A;function t(F){let _=JSON.parse(F);return _=k(_),_}e.parse=t;var T;(function(F){F[F.Uri=1]="Uri",F[F.Regexp=2]="Regexp",F[F.ScmResource=3]="ScmResource",F[F.ScmResourceGroup=4]="ScmResourceGroup",F[F.ScmProvider=5]="ScmProvider",F[F.CommentController=6]="CommentController",F[F.CommentThread=7]="CommentThread",F[F.CommentThreadReply=8]="CommentThreadReply",F[F.CommentNode=9]="CommentNode",F[F.CommentThreadNode=10]="CommentThreadNode",F[F.TimelineActionContext=11]="TimelineActionContext",F[F.NotebookCellActionContext=12]="NotebookCellActionContext",F[F.TestItemContext=13]="TestItemContext"})(T=e.MarshalledId||(e.MarshalledId={}));function C(F,_){return _ instanceof RegExp?{$mid:2,source:_.source,flags:(0,M.regExpFlags)(_)}:_}function k(F,_=0){if(!F||_>200)return F;if(typeof F=="object"){switch(F.$mid){case 1:return w.URI.revive(F);case 2:return new RegExp(F.source,F.flags)}if(F instanceof u.VSBuffer||F instanceof Uint8Array)return F;if(Array.isArray(F))for(let n=0;n<F.length;++n)F[n]=k(F[n],_+1);else for(const n in F)Object.hasOwnProperty.call(F,n)&&(F[n]=k(F[n],_+1))}return F}e.revive=k}),define(we[11],Ee([0,1,24,2]),function(re,e,u,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var w;(function(T){T.inMemory="inmemory",T.vscode="vscode",T.internal="private",T.walkThrough="walkThrough",T.walkThroughSnippet="walkThroughSnippet",T.http="http",T.https="https",T.file="file",T.mailto="mailto",T.untitled="untitled",T.data="data",T.command="command",T.vscodeRemote="vscode-remote",T.vscodeRemoteResource="vscode-remote-resource",T.userData="vscode-userdata",T.vscodeCustomEditor="vscode-custom-editor",T.vscodeNotebook="vscode-notebook",T.vscodeNotebookCell="vscode-notebook-cell",T.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",T.vscodeNotebookCellOutput="vscode-notebook-cell-output",T.vscodeInteractive="vscode-interactive",T.vscodeInteractiveInput="vscode-interactive-input",T.vscodeSettings="vscode-settings",T.vscodeWorkspaceTrust="vscode-workspace-trust",T.vscodeTerminal="vscode-terminal",T.webviewPanel="webview-panel",T.vscodeWebview="vscode-webview",T.extension="extension",T.vscodeFileResource="vscode-file",T.tmp="tmp",T.vsls="vsls"})(w=e.Schemas||(e.Schemas={}));class A{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(C){this._preferredWebSchema=C}setDelegate(C){this._delegate=C}set(C,k,F){this._hosts[C]=k,this._ports[C]=F}setConnectionToken(C,k){this._connectionTokens[C]=k}rewrite(C){if(this._delegate)return this._delegate(C);const k=C.authority;let F=this._hosts[k];F&&F.indexOf(":")!==-1&&(F=`[${F}]`);const _=this._ports[k],n=this._connectionTokens[k];let g=`path=${encodeURIComponent(C.path)}`;return typeof n=="string"&&(g+=`&tkn=${encodeURIComponent(n)}`),M.URI.from({scheme:u.isWeb?this._preferredWebSchema:w.vscodeRemoteResource,authority:`${F}:${_}`,path:"/vscode-remote-resource",query:g})}}e.RemoteAuthorities=new A;class t{asBrowserUri(C,k){const F=this.toUri(C,k);return F.scheme===w.vscodeRemote?e.RemoteAuthorities.rewrite(F):F.scheme===w.file&&(u.isNative||typeof u.globals.importScripts=="function"&&u.globals.origin===`${w.vscodeFileResource}://${t.FALLBACK_AUTHORITY}`)?F.with({scheme:w.vscodeFileResource,authority:F.authority||t.FALLBACK_AUTHORITY,query:null,fragment:null}):F}asFileUri(C,k){const F=this.toUri(C,k);return F.scheme===w.vscodeFileResource?F.with({scheme:w.file,authority:F.authority!==t.FALLBACK_AUTHORITY?F.authority:null,query:null,fragment:null}):F}toUri(C,k){return M.URI.isUri(C)?C:M.URI.parse(k.toUrl(C))}}t.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new t}),define(we[23],Ee([0,1,42,11,17,24,9,2]),function(re,e,u,M,w,A,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function C(g){return(0,T.uriToFsPath)(g,!0)}e.originalFSPath=C;class k{constructor(a){this._ignorePathCasing=a}compare(a,c,p=!1){return a===c?0:(0,t.compare)(this.getComparisonKey(a,p),this.getComparisonKey(c,p))}isEqual(a,c,p=!1){return a===c?!0:!a||!c?!1:this.getComparisonKey(a,p)===this.getComparisonKey(c,p)}getComparisonKey(a,c=!1){return a.with({path:this._ignorePathCasing(a)?a.path.toLowerCase():void 0,fragment:c?null:void 0}).toString()}ignorePathCasing(a){return this._ignorePathCasing(a)}isEqualOrParent(a,c,p=!1){if(a.scheme===c.scheme){if(a.scheme===M.Schemas.file)return u.isEqualOrParent(C(a),C(c),this._ignorePathCasing(a))&&a.query===c.query&&(p||a.fragment===c.fragment);if((0,e.isEqualAuthority)(a.authority,c.authority))return u.isEqualOrParent(a.path,c.path,this._ignorePathCasing(a),"/")&&a.query===c.query&&(p||a.fragment===c.fragment)}return!1}joinPath(a,...c){return T.URI.joinPath(a,...c)}basenameOrAuthority(a){return(0,e.basename)(a)||a.authority}basename(a){return w.posix.basename(a.path)}extname(a){return w.posix.extname(a.path)}dirname(a){if(a.path.length===0)return a;let c;return a.scheme===M.Schemas.file?c=T.URI.file(w.dirname(C(a))).path:(c=w.posix.dirname(a.path),a.authority&&c.length&&c.charCodeAt(0)!==47&&(console.error(`dirname("${a.toString})) resulted in a relative path`),c="/")),a.with({path:c})}normalizePath(a){if(!a.path.length)return a;let c;return a.scheme===M.Schemas.file?c=T.URI.file(w.normalize(C(a))).path:c=w.posix.normalize(a.path),a.with({path:c})}relativePath(a,c){if(a.scheme!==c.scheme||!(0,e.isEqualAuthority)(a.authority,c.authority))return;if(a.scheme===M.Schemas.file){const f=w.relative(C(a),C(c));return A.isWindows?u.toSlashes(f):f}let p=a.path||"/",D=c.path||"/";if(this._ignorePathCasing(a)){let f=0;for(const l=Math.min(p.length,D.length);f<l&&!(p.charCodeAt(f)!==D.charCodeAt(f)&&p.charAt(f).toLowerCase()!==D.charAt(f).toLowerCase());f++);p=D.substr(0,f)+p.substr(f)}return w.posix.relative(p,D)}resolvePath(a,c){if(a.scheme===M.Schemas.file){const p=T.URI.file(w.resolve(C(a),c));return a.with({authority:p.authority,path:p.path})}return c=u.toPosixPath(c),a.with({path:w.posix.resolve(a.path,c)})}isAbsolutePath(a){return!!a.path&&a.path[0]==="/"}isEqualAuthority(a,c){return a===c||a!==void 0&&c!==void 0&&(0,t.equalsIgnoreCase)(a,c)}hasTrailingPathSeparator(a,c=w.sep){if(a.scheme===M.Schemas.file){const p=C(a);return p.length>u.getRoot(p).length&&p[p.length-1]===c}else{const p=a.path;return p.length>1&&p.charCodeAt(p.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(a.fsPath)}}removeTrailingPathSeparator(a,c=w.sep){return(0,e.hasTrailingPathSeparator)(a,c)?a.with({path:a.path.substr(0,a.path.length-1)}):a}addTrailingPathSeparator(a,c=w.sep){let p=!1;if(a.scheme===M.Schemas.file){const D=C(a);p=D!==void 0&&D.length===u.getRoot(D).length&&D[D.length-1]===c}else{c="/";const D=a.path;p=D.length===1&&D.charCodeAt(D.length-1)===47}return!p&&!(0,e.hasTrailingPathSeparator)(a,c)?a.with({path:a.path+"/"}):a}}e.ExtUri=k,e.extUri=new k(()=>!1),e.extUriBiasedIgnorePathCase=new k(g=>g.scheme===M.Schemas.file?!A.isLinux:!0),e.extUriIgnorePathCase=new k(g=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function F(g,a){const c=[];for(let p=0;p<g.length;p++){const D=a(g[p]);g.some((f,l)=>l===p?!1:(0,e.isEqualOrParent)(D,a(f)))||c.push(g[p])}return c}e.distinctParents=F;var _;(function(g){g.META_DATA_LABEL="label",g.META_DATA_DESCRIPTION="description",g.META_DATA_SIZE="size",g.META_DATA_MIME="mime";function a(c){const p=new Map;c.path.substring(c.path.indexOf(";")+1,c.path.lastIndexOf(";")).split(";").forEach(l=>{const[h,y]=l.split(":");h&&y&&p.set(h,y)});const f=c.path.substring(0,c.path.indexOf(";"));return f&&p.set(g.META_DATA_MIME,f),p}g.parseMetaData=a})(_=e.DataUri||(e.DataUri={}));function n(g,a,c){if(a){let p=g.path;return p&&p[0]!==w.posix.sep&&(p=w.posix.sep+p),g.with({scheme:c,authority:a,path:p})}return g.with({scheme:c})}e.toLocalResource=n}),define(we[14],Ee([0,1,20,15,3,6,23]),function(re,e,u,M,w,A,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function T(B){return!!B&&typeof B.then=="function"}e.isThenable=T;function C(B){const $=new u.CancellationTokenSource,J=B($.token),j=new Promise((Q,le)=>{const be=$.token.onCancellationRequested(()=>{be.dispose(),$.dispose(),le((0,M.canceled)())});Promise.resolve(J).then(de=>{be.dispose(),$.dispose(),Q(de)},de=>{be.dispose(),$.dispose(),le(de)})});return new class{cancel(){$.cancel()}then(Q,le){return j.then(Q,le)}catch(Q){return this.then(void 0,Q)}finally(Q){return j.finally(Q)}}}e.createCancelablePromise=C;function k(B,$,J){return Promise.race([B,new Promise(j=>$.onCancellationRequested(()=>j(J)))])}e.raceCancellation=k;async function F(B){let $=-1;const J=B.map((Q,le)=>Q.then(be=>($=le,be))),j=await Promise.race(J);return B.forEach((Q,le)=>{le!==$&&Q.cancel()}),j}e.raceCancellablePromises=F;function _(B,$,J){let j;const Q=setTimeout(()=>{j?.(void 0),J?.()},$);return Promise.race([B.finally(()=>clearTimeout(Q)),new Promise(le=>j=le)])}e.raceTimeout=_;function n(B){return new Promise(($,J)=>{const j=B();T(j)?j.then($,J):$(j)})}e.asPromise=n;class g{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue($){if(this.activePromise){if(this.queuedPromiseFactory=$,!this.queuedPromise){const J=()=>{this.queuedPromise=null;const j=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,j};this.queuedPromise=new Promise(j=>{this.activePromise.then(J,J).then(j)})}return new Promise((J,j)=>{this.queuedPromise.then(J,j)})}return this.activePromise=$(),new Promise((J,j)=>{this.activePromise.then(Q=>{this.activePromise=null,J(Q)},Q=>{this.activePromise=null,j(Q)})})}}e.Throttler=g;class a{constructor(){this.current=Promise.resolve(null)}queue($){return this.current=this.current.then(()=>$(),()=>$())}}e.Sequencer=a;class c{constructor(){this.promiseMap=new Map}queue($,J){const Q=(this.promiseMap.get($)??Promise.resolve()).catch(()=>{}).then(J).finally(()=>{this.promiseMap.get($)===Q&&this.promiseMap.delete($)});return this.promiseMap.set($,Q),Q}}e.SequencerByKey=c;class p{constructor($){this.defaultDelay=$,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger($,J=this.defaultDelay){return this.task=$,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((j,Q)=>{this.doResolve=j,this.doReject=Q}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const j=this.task;return this.task=null,j()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},J),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,M.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=p;class D{constructor($){this.delayer=new p($),this.throttler=new g}trigger($,J){return this.delayer.trigger(()=>this.throttler.queue($),J)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=D;class f{constructor(){this._isOpen=!1,this._promise=new Promise(($,J)=>{this._completePromise=$})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=f;class l extends f{constructor($){super();this._timeout=setTimeout(()=>this.open(),$)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=l;function h(B,$){return $?new Promise((J,j)=>{const Q=setTimeout(()=>{le.dispose(),J()},B),le=$.onCancellationRequested(()=>{clearTimeout(Q),le.dispose(),j((0,M.canceled)())})}):C(J=>h(B,J))}e.timeout=h;function y(B,$=0){const J=setTimeout(B,$);return(0,A.toDisposable)(()=>clearTimeout(J))}e.disposableTimeout=y;function s(B){const $=[];let J=0;const j=B.length;function Q(){return J<j?B[J++]():null}function le(be){be!=null&&$.push(be);const de=Q();return de?de.then(le):Promise.resolve($)}return Promise.resolve(null).then(le)}e.sequence=s;function I(B,$=j=>!!j,J=null){let j=0;const Q=B.length,le=()=>{if(j>=Q)return Promise.resolve(J);const be=B[j++];return Promise.resolve(be()).then(Fe=>$(Fe)?Promise.resolve(Fe):le())};return le()}e.first=I;function r(B,$=j=>!!j,J=null){if(B.length===0)return Promise.resolve(J);let j=B.length;const Q=()=>{j=-1;for(const le of B)le.cancel?.()};return new Promise((le,be)=>{for(const de of B)de.then(Fe=>{--j>=0&&$(Fe)?(Q(),le(Fe)):j===0&&le(J)}).catch(Fe=>{--j>=0&&(Q(),be(Fe))})})}e.firstParallel=r;class i{constructor($){this._size=0,this.maxDegreeOfParalellism=$,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new w.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue($){return this._size++,new Promise((J,j)=>{this.outstandingPromises.push({factory:$,c:J,e:j}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const $=this.outstandingPromises.shift();this.runningPromises++;const J=$.factory();J.then($.c,$.e),J.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=i;class v extends i{constructor(){super(1)}}e.Queue=v;class m{constructor(){this.queues=new Map}queueFor($,J=t.extUri){const j=J.getComparisonKey($);let Q=this.queues.get(j);return Q||(Q=new v,w.Event.once(Q.onFinished)(()=>{Q?.dispose(),this.queues.delete(j)}),this.queues.set(j,Q)),Q}dispose(){this.queues.forEach($=>$.dispose()),this.queues.clear()}}e.ResourceQueue=m;class o{constructor($,J){this._token=-1,typeof $=="function"&&typeof J=="number"&&this.setIfNotSet($,J)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet($,J){this.cancel(),this._token=setTimeout(()=>{this._token=-1,$()},J)}setIfNotSet($,J){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,$()},J))}}e.TimeoutTimer=o;class b{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet($,J){this.cancel(),this._token=setInterval(()=>{$()},J)}}e.IntervalTimer=b;class d{constructor($,J){this.timeoutToken=-1,this.runner=$,this.timeout=J,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule($=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,$)}get delay(){return this.timeout}set delay($){this.timeout=$}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=d;class E{constructor($,J){J%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${J}ms is not a multiple of 1000ms.`),this.runner=$,this.timeout=J,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule($=this.timeout){$%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${$}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil($/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=E;class R extends d{constructor($,J){super($,J);this.units=[]}work($){this.units.push($),this.isScheduled()||this.schedule()}doRun(){const $=this.units;this.units=[],this.runner&&this.runner($)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=R;class P extends A.Disposable{constructor($,J,j,Q){super();this.maxWorkChunkSize=$,this.maxPendingWork=J,this.throttleDelay=j,this.handler=Q,this.pendingWork=[],this.throttler=this._register(new A.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work($){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+$.length>this.maxPendingWork)return!1}else if(this.pending+$.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...$),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new d(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=P,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=B=>{const $=setTimeout(()=>{const j=Date.now()+15;B(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,j-Date.now())}}))});let J=!1;return{dispose(){J||(J=!0,clearTimeout($))}}}:e.runWhenIdle=(B,$)=>{const J=requestIdleCallback(B,typeof $=="number"?{timeout:$}:void 0);let j=!1;return{dispose(){j||(j=!0,cancelIdleCallback(J))}}}}();class z{constructor($){this._didRun=!1,this._executor=()=>{try{this._value=$()}catch(J){this._error=J}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=z;async function O(B,$,J){let j;for(let Q=0;Q<J;Q++)try{return await B()}catch(le){j=le,await h($)}throw j}e.retry=O;class S{hasPending($){return this._pending?typeof $=="number"?this._pending.taskId===$:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending($,J,j){return this._pending={taskId:$,cancel:()=>j?.(),promise:J},J.then(()=>this.donePending($),()=>this.donePending($)),J}donePending($){this._pending&&$===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const $=this._next;this._next=void 0,$.run().then($.promiseResolve,$.promiseReject)}}setNext($){if(this._next)this._next.run=$;else{let J,j;const Q=new Promise((le,be)=>{J=le,j=be});this._next={run:$,promise:Q,promiseResolve:J,promiseReject:j}}return this._next.promise}}e.TaskSequentializer=S;class x{constructor($){this.interval=$,this.lastIncrementTime=0,this.value=0}increment(){const $=Date.now();return $-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=$,this.value=0),this.value++,this.value}}e.IntervalCounter=x;class N{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise(($,J)=>{this.completeCallback=$,this.errorCallback=J})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete($){return new Promise(J=>{this.completeCallback($),this.resolved=!0,J()})}error($){return new Promise(J=>{this.errorCallback($),this.rejected=!0,J()})}cancel(){new Promise($=>{this.errorCallback((0,M.canceled)()),this.rejected=!0,$()})}}e.DeferredPromise=N;var V;(function(B){async function $(j){let Q;const le=await Promise.all(j.map(be=>be.then(de=>de,de=>{Q||(Q=de)})));if(typeof Q!="undefined")throw Q;return le}B.settled=$;function J(j){return new Promise(async(Q,le)=>{try{await j(Q,le)}catch(be){le(be)}})}B.withAsyncBody=J})(V=e.Promises||(e.Promises={}))}),define(we[106],Ee([0,1,14,17]),function(re,e,u,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const w=new u.IdleValue(()=>{const d=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:d,collatorIsNumeric:d.resolvedOptions().numeric}}),A=new u.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),t=new u.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function T(d,E,R=!1){const P=d||"",z=E||"",O=w.value.collator.compare(P,z);return w.value.collatorIsNumeric&&O===0&&P!==z?P<z?-1:1:O}e.compareFileNames=T;function C(d,E){const R=A.value.collator;return d=d||"",E=E||"",y(R,d,E)}e.compareFileNamesDefault=C;function k(d,E){const R=A.value.collator;return d=d||"",E=E||"",i(d,E)||y(R,d,E)}e.compareFileNamesUpper=k;function F(d,E){const R=A.value.collator;return d=d||"",E=E||"",r(d,E)||y(R,d,E)}e.compareFileNamesLower=F;function _(d,E){return d=d||"",E=E||"",d===E?0:d<E?-1:1}e.compareFileNamesUnicode=_;function n(d,E,R=!1){R||(d=d&&d.toLowerCase(),E=E&&E.toLowerCase());const[P,z]=l(d),[O,S]=l(E);return P!==O?P<O?-1:1:z===S?0:z<S?-1:1}e.noIntlCompareFileNames=n;function g(d,E){const[R,P]=l(d),[z,O]=l(E);let S=w.value.collator.compare(P,O);if(S===0){if(w.value.collatorIsNumeric&&P!==O)return P<O?-1:1;if(S=w.value.collator.compare(R,z),w.value.collatorIsNumeric&&S===0&&R!==z)return R<z?-1:1}return S}e.compareFileExtensions=g;function a(d,E){d=d||"",E=E||"";const R=h(d),P=h(E),z=A.value.collator,O=t.value.collator;return y(O,R,P)||y(z,d,E)}e.compareFileExtensionsDefault=a;function c(d,E){d=d||"",E=E||"";const R=h(d),P=h(E),z=A.value.collator,O=t.value.collator;return y(O,R,P)||i(d,E)||y(z,d,E)}e.compareFileExtensionsUpper=c;function p(d,E){d=d||"",E=E||"";const R=h(d),P=h(E),z=A.value.collator,O=t.value.collator;return y(O,R,P)||r(d,E)||y(z,d,E)}e.compareFileExtensionsLower=p;function D(d,E){d=d||"",E=E||"";const R=h(d).toLowerCase(),P=h(E).toLowerCase();return R!==P?R<P?-1:1:d!==E?d<E?-1:1:0}e.compareFileExtensionsUnicode=D;const f=/^(.*?)(\.([^.]*))?$/;function l(d,E=!1){const R=d?f.exec(d):[];let P=[R&&R[1]||"",R&&R[3]||""];return E&&(!P[0]&&P[1]||P[0]&&P[0].charAt(0)===".")&&(P=[P[0]+"."+P[1],""]),P}function h(d){const E=d?f.exec(d):[];return E&&E[1]&&E[1].charAt(0)!=="."&&E[3]||""}function y(d,E,R){let P=d.compare(E,R);return P!==0?P:E.length!==R.length?E.length<R.length?-1:1:0}function s(d){const E=d.charAt(0);return E.toLocaleUpperCase()!==E}function I(d){const E=d.charAt(0);return E.toLocaleLowerCase()!==E}function r(d,E){return s(d)&&I(E)?-1:I(d)&&s(E)?1:0}function i(d,E){return I(d)&&s(E)?-1:s(d)&&I(E)?1:0}function v(d,E,R=!1){return R||(d=d&&d.toLowerCase(),E=E&&E.toLowerCase()),d===E?0:d<E?-1:1}function m(d,E,R=!1){const P=d.split(M.sep),z=E.split(M.sep),O=P.length-1,S=z.length-1;let x,N;for(let V=0;;V++){if(x=O===V,N=S===V,x&&N)return T(P[V],z[V],R);if(x)return-1;if(N)return 1;const B=v(P[V],z[V],R);if(B!==0)return B}}e.comparePaths=m;function o(d,E,R){const P=d.toLowerCase(),z=E.toLowerCase(),O=b(d,E,R);if(O)return O;const S=P.endsWith(R),x=z.endsWith(R);if(S!==x)return S?-1:1;const N=T(P,z);return N!==0?N:P.localeCompare(z)}e.compareAnything=o;function b(d,E,R){const P=d.toLowerCase(),z=E.toLowerCase(),O=P.startsWith(R),S=z.startsWith(R);if(O!==S)return O?-1:1;if(O&&S){if(P.length<z.length)return-1;if(P.length>z.length)return 1}return 0}e.compareByPrefix=b}),define(we[29],Ee([0,1,14,42,21,17,9]),function(re,e,u,M,w,A,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function T(){return Object.create(null)}e.getEmptyExpression=T;const C="**",k="/",F="[/\\\\]",_="[^/\\\\]",n=/\//g;function g(j){switch(j){case 0:return"";case 1:return`${_}*?`;default:return`(?:${F}|${_}+${F}|${F}${_}+)*?`}}function a(j,Q){if(!j)return[];const le=[];let be=!1,de=!1,Fe="";for(const Ge of j){switch(Ge){case Q:if(!be&&!de){le.push(Fe),Fe="";continue}break;case"{":be=!0;break;case"}":be=!1;break;case"[":de=!0;break;case"]":de=!1;break}Fe+=Ge}return Fe&&le.push(Fe),le}e.splitGlobAware=a;function c(j){if(!j)return"";let Q="";const le=a(j,k);if(le.every(be=>be===C))Q=".*";else{let be=!1;le.forEach((de,Fe)=>{if(de===C){be||(Q+=g(2),be=!0);return}let Ge=!1,Le="",We=!1,Ye="";for(const Qe of de){if(Qe!=="}"&&Ge){Le+=Qe;continue}if(We&&(Qe!=="]"||!Ye)){let Ke;Qe==="-"?Ke=Qe:(Qe==="^"||Qe==="!")&&!Ye?Ke="^":Qe===k?Ke="":Ke=t.escapeRegExpCharacters(Qe),Ye+=Ke;continue}switch(Qe){case"{":Ge=!0;continue;case"[":We=!0;continue;case"}":Q+=`(?:${a(Le,",").map(K=>c(K)).join("|")})`,Ge=!1,Le="";break;case"]":Q+="["+Ye+"]",We=!1,Ye="";break;case"?":Q+=_;continue;case"*":Q+=g(1);continue;default:Q+=t.escapeRegExpCharacters(Qe)}}Fe<le.length-1&&(le[Fe+1]!==C||Fe+2<le.length)&&(Q+=F),be=!1})}return Q}const p=/^\*\*\/\*\.[\w\.-]+$/,D=/^\*\*\/([\w\.-]+)\/?$/,f=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,l=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,h=/^\*\*((\/[\w\.-]+)+)\/?$/,y=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,s=new w.LRUCache(1e4),I=function(){return!1},r=function(){return null};function i(j,Q){if(!j)return r;let le;typeof j!="string"?le=j.pattern:le=j,le=le.trim();const be=`${le}_${!!Q.trimForExclusions}`;let de=s.get(be);if(de)return v(de,j);let Fe;if(p.test(le)){const Ge=le.substr(4);de=function(Le,We){return typeof Le=="string"&&Le.endsWith(Ge)?le:null}}else(Fe=D.exec(m(le,Q)))?de=o(Fe[1],le):(Q.trimForExclusions?l:f).test(le)?de=b(le,Q):(Fe=h.exec(m(le,Q)))?de=d(Fe[1].substr(1),le,!0):(Fe=y.exec(m(le,Q)))?de=d(Fe[1],le,!1):de=E(le);return s.set(be,de),v(de,j)}function v(j,Q){return typeof Q=="string"?j:function(le,be){return M.isEqualOrParent(le,Q.base)?j(A.relative(Q.base,le),be):null}}function m(j,Q){return Q.trimForExclusions&&j.endsWith("/**")?j.substr(0,j.length-2):j}function o(j,Q){const le=`/${j}`,be=`\\${j}`,de=function(Ge,Le){return typeof Ge!="string"?null:Le?Le===j?Q:null:Ge===j||Ge.endsWith(le)||Ge.endsWith(be)?Q:null},Fe=[j];return de.basenames=Fe,de.patterns=[Q],de.allBasenames=Fe,de}function b(j,Q){const le=J(j.slice(1,-1).split(",").map(Le=>i(Le,Q)).filter(Le=>Le!==r),j),be=le.length;if(!be)return r;if(be===1)return le[0];const de=function(Le,We){for(let Ye=0,Qe=le.length;Ye<Qe;Ye++)if(le[Ye](Le,We))return j;return null},Fe=le.find(Le=>!!Le.allBasenames);Fe&&(de.allBasenames=Fe.allBasenames);const Ge=le.reduce((Le,We)=>We.allPaths?Le.concat(We.allPaths):Le,[]);return Ge.length&&(de.allPaths=Ge),de}function d(j,Q,le){const be=A.sep===A.posix.sep,de=be?j:j.replace(n,A.sep),Fe=A.sep+de,Ge=A.posix.sep+j,Le=le?function(We,Ye){return typeof We=="string"&&(We===de||We.endsWith(Fe)||!be&&(We===j||We.endsWith(Ge)))?Q:null}:function(We,Ye){return typeof We=="string"&&(We===de||!be&&We===j)?Q:null};return Le.allPaths=[(le?"*/":"./")+j],Le}function E(j){try{const Q=new RegExp(`^${c(j)}$`);return function(le){return Q.lastIndex=0,typeof le=="string"&&Q.test(le)?j:null}}catch(Q){return r}}function R(j,Q,le){return!j||typeof Q!="string"?!1:P(j)(Q,void 0,le)}e.match=R;function P(j,Q={}){if(!j)return I;if(typeof j=="string"||x(j)){const le=i(j,Q);if(le===r)return I;const be=function(de,Fe){return!!le(de,Fe)};return le.allBasenames&&(be.allBasenames=le.allBasenames),le.allPaths&&(be.allPaths=le.allPaths),be}return B(j,Q)}e.parse=P;function z(j){if(!j)return;let Q;return le=>(Q||(Q=(j()||Promise.resolve([])).then(be=>be?S(be):{})),Q.then(be=>!!be[le]))}e.hasSiblingPromiseFn=z;function O(j){if(!j)return;let Q;return le=>{if(!Q){const be=j();Q=be?S(be):{}}return!!Q[le]}}e.hasSiblingFn=O;function S(j){const Q={};for(const le of j)Q[le]=!0;return Q}function x(j){const Q=j;return Q&&typeof Q.base=="string"&&typeof Q.pattern=="string"}e.isRelativePattern=x;function N(j){return j.allBasenames||[]}e.getBasenameTerms=N;function V(j){return j.allPaths||[]}e.getPathTerms=V;function B(j,Q){const le=J(Object.getOwnPropertyNames(j).map(Le=>$(Le,j[Le],Q)).filter(Le=>Le!==r)),be=le.length;if(!be)return r;if(!le.some(Le=>!!Le.requiresSiblings)){if(be===1)return le[0];const Le=function(Qe,Ke){for(let W=0,K=le.length;W<K;W++){const Z=le[W](Qe,Ke);if(Z)return Z}return null},We=le.find(Qe=>!!Qe.allBasenames);We&&(Le.allBasenames=We.allBasenames);const Ye=le.reduce((Qe,Ke)=>Ke.allPaths?Qe.concat(Ke.allPaths):Qe,[]);return Ye.length&&(Le.allPaths=Ye),Le}const de=function(Le,We,Ye){let Qe;for(let Ke=0,W=le.length;Ke<W;Ke++){const K=le[Ke];K.requiresSiblings&&Ye&&(We||(We=A.basename(Le)),Qe||(Qe=We.substr(0,We.length-A.extname(Le).length)));const Z=K(Le,We,Qe,Ye);if(Z)return Z}return null},Fe=le.find(Le=>!!Le.allBasenames);Fe&&(de.allBasenames=Fe.allBasenames);const Ge=le.reduce((Le,We)=>We.allPaths?Le.concat(We.allPaths):Le,[]);return Ge.length&&(de.allPaths=Ge),de}function $(j,Q,le){if(Q===!1)return r;const be=i(j,le);if(be===r)return r;if(typeof Q=="boolean")return be;if(Q){const de=Q.when;if(typeof de=="string"){const Fe=(Ge,Le,We,Ye)=>{if(!Ye||!be(Ge,Le))return null;const Qe=de.replace("$(basename)",We),Ke=Ye(Qe);return(0,u.isThenable)(Ke)?Ke.then(W=>W?j:null):Ke?j:null};return Fe.requiresSiblings=!0,Fe}}return be}function J(j,Q){const le=j.filter(Le=>!!Le.basenames);if(le.length<2)return j;const be=le.reduce((Le,We)=>{const Ye=We.basenames;return Ye?Le.concat(Ye):Le},[]);let de;if(Q){de=[];for(let Le=0,We=be.length;Le<We;Le++)de.push(Q)}else de=le.reduce((Le,We)=>{const Ye=We.patterns;return Ye?Le.concat(Ye):Le},[]);const Fe=function(Le,We){if(typeof Le!="string")return null;if(!We){let Qe;for(Qe=Le.length;Qe>0;Qe--){const Ke=Le.charCodeAt(Qe-1);if(Ke===47||Ke===92)break}We=Le.substr(Qe)}const Ye=be.indexOf(We);return Ye!==-1?de[Ye]:null};Fe.basenames=be,Fe.patterns=de,Fe.allBasenames=be;const Ge=j.filter(Le=>!Le.basenames);return Ge.push(Fe),Ge}}),define(we[78],Ee([0,1,42,11,17,24,23,9,2]),function(re,e,u,M,w,A,t,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function k(i,v,m){if(typeof i=="string"&&(i=C.URI.file(i)),m){const b=m.getWorkspaceFolder(i);if(b){const d=m.getWorkspace().folders.length>1;let E;if((0,t.isEqual)(b.uri,i)?E="":E=(0,t.relativePath)(b.uri,i),d){const R=b.name?b.name:(0,t.basename)(b.uri);E=E?R+" \u2022 "+E:R}return E}}if(i.scheme!==M.Schemas.file&&i.scheme!==M.Schemas.untitled)return i.with({query:null,fragment:null}).toString(!0);if((0,u.hasDriveLetter)(i.fsPath))return(0,w.normalize)(_(i.fsPath));let o=(0,w.normalize)(i.fsPath);return!A.isWindows&&v?.userHome&&(o=g(o,v.userHome.fsPath)),o}e.getPathLabel=k;function F(i){if(!i)return;typeof i=="string"&&(i=C.URI.file(i));const v=(0,t.basename)(i)||(i.scheme===M.Schemas.file?i.fsPath:i.path);return A.isWindows&&(0,u.isRootOrDriveLetter)(v)?_(v):v}e.getBaseLabel=F;function _(i,v){return(0,u.hasDriveLetter)(i,v)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=_;let n=Object.create(null);function g(i,v){if(A.isWindows||!i||!v)return i;let m=n.original===v?n.normalized:void 0;return m||(m=`${(0,T.rtrim)(v,w.posix.sep)}${w.posix.sep}`,n={original:v,normalized:m}),(A.isLinux?i.startsWith(m):(0,T.startsWithIgnoreCase)(i,m))&&(i=`~/${i.substr(m.length)}`),i}e.tildify=g;function a(i,v){return i.replace(/^~($|\/|\\)/,`${v}$1`)}e.untildify=a;const c="\u2026",p="\\\\",D="~";function f(i,v=w.sep){const m=new Array(i.length);let o=!1;for(let b=0;b<i.length;b++){let d=i[b];if(d===""){m[b]=`.${v}`;continue}if(!d){m[b]=d;continue}o=!0;let E="";d.indexOf(p)===0?(E=d.substr(0,d.indexOf(p)+p.length),d=d.substr(d.indexOf(p)+p.length)):d.indexOf(v)===0?(E=d.substr(0,d.indexOf(v)+v.length),d=d.substr(d.indexOf(v)+v.length)):d.indexOf(D)===0&&(E=d.substr(0,d.indexOf(D)+D.length),d=d.substr(d.indexOf(D)+D.length));const R=d.split(v);for(let P=1;o&&P<=R.length;P++)for(let z=R.length-P;o&&z>=0;z--){o=!1;let O=R.slice(z,z+P).join(v);for(let S=0;!o&&S<i.length;S++)if(S!==b&&i[S]&&i[S].indexOf(O)>-1){const x=z+P===R.length,N=z>0&&i[S].indexOf(v)>-1?v+O:O,V=i[S].endsWith(N);o=!x||V}if(!o){let S="";(R[0].endsWith(":")||E!=="")&&(z===1&&(z=0,P++,O=R[0]+v+O),z>0&&(S=R[0]+v),S=E+S),z>0&&(S=S+c+v),S=S+O,z+P<R.length&&(S=S+v+c),m[b]=S}}o&&(m[b]=d)}return m}e.shorten=f;var l;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(l||(l={}));function h(i,v=Object.create(null)){const m=[];let o=!1,b="";for(const d of i)if(d==="$"||o&&d==="{")b&&m.push({value:b,type:l.TEXT}),b="",o=!0;else if(d==="}"&&o){const E=v[b];if(typeof E=="string")E.length&&m.push({value:E,type:l.VARIABLE});else if(E){const R=m[m.length-1];(!R||R.type!==l.SEPARATOR)&&m.push({value:E.label,type:l.SEPARATOR})}b="",o=!1}else b+=d;return b&&!o&&m.push({value:b,type:l.TEXT}),m.filter((d,E)=>{if(d.type===l.SEPARATOR){const R=m[E-1],P=m[E+1];return[R,P].every(z=>z&&(z.type===l.VARIABLE||z.type===l.TEXT)&&z.value.length>0)}return!0}).map(d=>d.value).join("")}e.template=h;function y(i,v){return A.isMacintosh||v?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,A.isMacintosh?"&":"&&"):i.replace(/&&|&/g,m=>m==="&"?"&&":"&")}e.mnemonicMenuLabel=y;function s(i,v){return A.isMacintosh||v?i.replace(/\(&&\w\)|&&/g,""):A.isWindows?i.replace(/&&|&/g,m=>m==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=s;function I(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=I;function r(i){const v=i.indexOf("/")!==-1?w.posix:w.win32,m=v.basename(i),o=v.dirname(i);return m.length?{name:m,parentPath:o}:{name:o,parentPath:""}}e.splitName=r}),define(we[79],Ee([0,1,29,11,17,23,9]),function(re,e,u,M,w,A,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var T;(function(i){i.text="text/plain",i.binary="application/octet-stream",i.unknown="application/unknown",i.markdown="text/markdown",i.latex="text/latex"})(T=e.Mimes||(e.Mimes={}));let C=[],k=[],F=[];function _(i,v=!1){const m=n(i);C.push(m),m.userConfigured?F.push(m):k.push(m),v&&!m.userConfigured&&C.forEach(o=>{o.mime===m.mime||o.userConfigured||(m.extension&&o.extension===m.extension&&console.warn(`Overwriting extension <<${m.extension}>> to now point to mime <<${m.mime}>>`),m.filename&&o.filename===m.filename&&console.warn(`Overwriting filename <<${m.filename}>> to now point to mime <<${m.mime}>>`),m.filepattern&&o.filepattern===m.filepattern&&console.warn(`Overwriting filepattern <<${m.filepattern}>> to now point to mime <<${m.mime}>>`),m.firstline&&o.firstline===m.firstline&&console.warn(`Overwriting firstline <<${m.firstline}>> to now point to mime <<${m.mime}>>`))})}e.registerTextMime=_;function n(i){return{id:i.id,mime:i.mime,filename:i.filename,extension:i.extension,filepattern:i.filepattern,firstline:i.firstline,userConfigured:i.userConfigured,filenameLowercase:i.filename?i.filename.toLowerCase():void 0,extensionLowercase:i.extension?i.extension.toLowerCase():void 0,filepatternLowercase:i.filepattern?(0,u.parse)(i.filepattern.toLowerCase()):void 0,filepatternOnPath:i.filepattern?i.filepattern.indexOf(w.posix.sep)>=0:!1}}function g(i){i?(C=C.filter(v=>!v.userConfigured),F=[]):(C=[],k=[],F=[])}e.clearTextMimes=g;function a(i,v){let m;if(i)switch(i.scheme){case M.Schemas.file:m=i.fsPath;break;case M.Schemas.data:m=A.DataUri.parseMetaData(i).get(A.DataUri.META_DATA_LABEL);break;default:m=i.path}if(!m)return[T.unknown];m=m.toLowerCase();const o=(0,w.basename)(m),b=c(m,o,F);if(b)return[b,T.text];const d=c(m,o,k);if(d)return[d,T.text];if(v){const E=p(v);if(E)return[E,T.text]}return[T.unknown]}e.guessMimeTypes=a;function c(i,v,m){let o=null,b=null,d=null;for(let E=m.length-1;E>=0;E--){const R=m[E];if(v===R.filenameLowercase){o=R;break}if(R.filepattern&&(!b||R.filepattern.length>b.filepattern.length)){const P=R.filepatternOnPath?i:v;R.filepatternLowercase?.(P)&&(b=R)}R.extension&&(!d||R.extension.length>d.extension.length)&&v.endsWith(R.extensionLowercase)&&(d=R)}return o?o.mime:b?b.mime:d?d.mime:null}function p(i){if((0,t.startsWithUTF8BOM)(i)&&(i=i.substr(1)),i.length>0)for(let v=C.length-1;v>=0;v--){const m=C[v];if(!m.firstline)continue;const o=i.match(m.firstline);if(o&&o.length>0)return m.mime}return null}function D(i){return i?typeof i=="string"?i===T.binary||i===T.text||i===T.unknown:i.length===1&&D(i[0]):!0}e.isUnspecific=D;const f={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},l={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function h(i){const v=(0,w.extname)(i),m=f[v.toLowerCase()];return m!==void 0?m:y(i)}e.getMediaOrTextMime=h;function y(i){const v=(0,w.extname)(i);return l[v.toLowerCase()]}e.getMediaMime=y;function s(i){for(const v in l)if(l[v]===i)return v}e.getExtensionForMimeType=s;const I=/^(.+)\/(.+?)(;.+)?$/;function r(i,v){const m=I.exec(i);return m?`${m[1].toLowerCase()}/${m[2].toLowerCase()}${m[3]??""}`:v?void 0:i}e.normalizeMimeType=r}),define(we[107],Ee([0,1,2]),function(re,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function M(F){return F.toJSON()}class w{constructor(_){this._uriTransformer=_}transformIncoming(_){const n=this._uriTransformer.transformIncoming(_);return n===_?_:M(u.URI.from(n))}transformOutgoing(_){const n=this._uriTransformer.transformOutgoing(_);return n===_?_:M(u.URI.from(n))}transformOutgoingURI(_){const n=this._uriTransformer.transformOutgoing(_);return n===_?_:u.URI.from(n)}transformOutgoingScheme(_){return this._uriTransformer.transformOutgoingScheme(_)}}e.URITransformer=w,e.DefaultURITransformer=new class{transformIncoming(F){return F}transformOutgoing(F){return F}transformOutgoingURI(F){return F}transformOutgoingScheme(F){return F}};function A(F,_,n){if(!F||n>200)return null;if(typeof F=="object"){if(F instanceof u.URI)return _.transformOutgoing(F);for(let g in F)if(Object.hasOwnProperty.call(F,g)){const a=A(F[g],_,n+1);a!==null&&(F[g]=a)}}return null}function t(F,_){const n=A(F,_,0);return n===null?F:n}e.transformOutgoingURIs=t;function T(F,_,n,g){if(!F||g>200)return null;if(typeof F=="object"){if(F.$mid===1)return n?u.URI.revive(_.transformIncoming(F)):_.transformIncoming(F);for(let a in F)if(Object.hasOwnProperty.call(F,a)){const c=T(F[a],_,n,g+1);c!==null&&(F[a]=c)}}return null}function C(F,_){const n=T(F,_,!1,0);return n===null?F:n}e.transformIncomingURIs=C;function k(F,_){const n=T(F,_,!0,0);return n===null?F:n}e.transformAndReviveIncomingURIs=k}),define(we[36],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const u=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function M(C){return u.test(C)}e.isUUID=M;const w=new Uint8Array(16),A=[];for(let C=0;C<256;C++)A.push(C.toString(16).padStart(2,"0"));let t;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?t=crypto.getRandomValues.bind(crypto):t=function(C){for(let k=0;k<C.length;k++)C[k]=Math.floor(Math.random()*256);return C};function T(){t(w),w[6]=w[6]&15|64,w[8]=w[8]&63|128;let C=0,k="";return k+=A[w[C++]],k+=A[w[C++]],k+=A[w[C++]],k+=A[w[C++]],k+="-",k+=A[w[C++]],k+=A[w[C++]],k+="-",k+=A[w[C++]],k+=A[w[C++]],k+="-",k+=A[w[C++]],k+=A[w[C++]],k+="-",k+=A[w[C++]],k+=A[w[C++]],k+=A[w[C++]],k+=A[w[C++]],k+=A[w[C++]],k+=A[w[C++]],k}e.generateUuid=T}),define(we[108],Ee([0,1,227]),function(re,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var M;(function(t){t[t.Regular=0]="Regular",t[t.Whitespace=1]="Whitespace",t[t.WordSeparator=2]="WordSeparator"})(M=e.WordCharacterClass||(e.WordCharacterClass={}));class w extends u.CharacterClassifier{constructor(T){super(0);for(let C=0,k=T.length;C<k;C++)this.set(T.charCodeAt(C),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=w;function A(t){let T={};return C=>(T.hasOwnProperty(C)||(T[C]=t(C)),T[C])}e.getMapForWordSeparators=A(t=>new w(t))}),define(we[80],Ee([0,1,25]),function(re,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.IndentGuideHorizontalLine=e.IndentGuide=e.HorizontalGuidesState=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var M;(function(f){f[f.Left=1]="Left",f[f.Center=2]="Center",f[f.Right=4]="Right",f[f.Full=7]="Full"})(M=e.OverviewRulerLane||(e.OverviewRulerLane={}));var w;(function(f){f[f.Inline=1]="Inline",f[f.Gutter=2]="Gutter"})(w=e.MinimapPosition||(e.MinimapPosition={}));var A;(function(f){f[f.TextDefined=0]="TextDefined",f[f.LF=1]="LF",f[f.CRLF=2]="CRLF"})(A=e.EndOfLinePreference||(e.EndOfLinePreference={}));var t;(function(f){f[f.LF=1]="LF",f[f.CRLF=2]="CRLF"})(t=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var T;(function(f){f[f.LF=0]="LF",f[f.CRLF=1]="CRLF"})(T=e.EndOfLineSequence||(e.EndOfLineSequence={}));class C{constructor(l){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,l.tabSize|0),this.indentSize=l.tabSize|0,this.insertSpaces=Boolean(l.insertSpaces),this.defaultEOL=l.defaultEOL|0,this.trimAutoWhitespace=Boolean(l.trimAutoWhitespace),this.bracketPairColorizationOptions=l.bracketPairColorizationOptions}equals(l){return this.tabSize===l.tabSize&&this.indentSize===l.indentSize&&this.insertSpaces===l.insertSpaces&&this.defaultEOL===l.defaultEOL&&this.trimAutoWhitespace===l.trimAutoWhitespace&&(0,u.equals)(this.bracketPairColorizationOptions,l.bracketPairColorizationOptions)}createChangeEvent(l){return{tabSize:this.tabSize!==l.tabSize,indentSize:this.indentSize!==l.indentSize,insertSpaces:this.insertSpaces!==l.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==l.trimAutoWhitespace}}}e.TextModelResolvedOptions=C;class k{constructor(l,h){this._findMatchBrand=void 0,this.range=l,this.matches=h}}e.FindMatch=k;var F;(function(f){f[f.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",f[f.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",f[f.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",f[f.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(F=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var _;(function(f){f[f.Disabled=0]="Disabled",f[f.EnabledForActive=1]="EnabledForActive",f[f.Enabled=2]="Enabled"})(_=e.HorizontalGuidesState||(e.HorizontalGuidesState={}));class n{constructor(l,h,y){this.visibleColumn=l,this.className=h,this.horizontalLine=y}}e.IndentGuide=n;class g{constructor(l,h){this.top=l,this.endColumn=h}}e.IndentGuideHorizontalLine=g;var a;(function(f){f[f.Left=0]="Left",f[f.Right=1]="Right",f[f.None=2]="None"})(a=e.PositionAffinity||(e.PositionAffinity={}));var c;(function(f){f[f.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(c=e.ModelConstants||(e.ModelConstants={}));class p{constructor(l,h,y,s,I,r){this.identifier=l,this.range=h,this.text=y,this.forceMoveMarkers=s,this.isAutoWhitespaceEdit=I,this._isTracked=r}}e.ValidAnnotatedEditOperation=p;class D{constructor(l,h,y){this.reverseEdits=l,this.changes=h,this.trimAutoWhitespaceLineNumbers=y}}e.ApplyEditsResult=D}),define(we[109],Ee([0,1,9,108,110,43,80]),function(re,e,u,M,w,A,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const T=999;class C{constructor(l,h,y,s){this.searchString=l,this.isRegex=h,this.matchCase=y,this.wordSeparators=s}parseSearchRequest(){if(this.searchString==="")return null;let l;this.isRegex?l=k(this.searchString):l=this.searchString.indexOf(`
`)>=0;let h=null;try{h=u.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:l,global:!0,unicode:!0})}catch(s){return null}if(!h)return null;let y=!this.isRegex&&!l;return y&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(y=this.matchCase),new F(h,this.wordSeparators?(0,M.getMapForWordSeparators)(this.wordSeparators):null,y?this.searchString:null)}}e.SearchParams=C;function k(f){if(!f||f.length===0)return!1;for(let l=0,h=f.length;l<h;l++)if(f.charCodeAt(l)===92){if(l++,l>=h)break;const s=f.charCodeAt(l);if(s===110||s===114||s===87)return!0}return!1}e.isMultilineRegexSource=k;class F{constructor(l,h,y){this.regex=l,this.wordSeparators=h,this.simpleSearch=y}}e.SearchData=F;function _(f,l,h){if(!h)return new t.FindMatch(f,null);let y=[];for(let s=0,I=l.length;s<I;s++)y[s]=l[s];return new t.FindMatch(f,y)}e.createFindMatch=_;class n{constructor(l){let h=[],y=0;for(let s=0,I=l.length;s<I;s++)l.charCodeAt(s)===10&&(h[y++]=s);this._lineFeedsOffsets=h}findLineFeedCountBeforeOffset(l){const h=this._lineFeedsOffsets;let y=0,s=h.length-1;if(s===-1||l<=h[0])return 0;for(;y<s;){const I=y+((s-y)/2>>0);h[I]>=l?s=I-1:h[I+1]>=l?(y=I,s=I):y=I+1}return y+1}}class g{static findMatches(l,h,y,s,I){const r=h.parseSearchRequest();return r?r.regex.multiline?this._doFindMatchesMultiline(l,y,new D(r.wordSeparators,r.regex),s,I):this._doFindMatchesLineByLine(l,y,r,s,I):[]}static _getMultilineMatchRange(l,h,y,s,I,r){let i,v=0;s?(v=s.findLineFeedCountBeforeOffset(I),i=h+I+v):i=h+I;let m;if(s){let E=s.findLineFeedCountBeforeOffset(I+r.length)-v;m=i+r.length+E}else m=i+r.length;const o=l.getPositionAt(i),b=l.getPositionAt(m);return new A.Range(o.lineNumber,o.column,b.lineNumber,b.column)}static _doFindMatchesMultiline(l,h,y,s,I){const r=l.getOffsetAt(h.getStartPosition()),i=l.getValueInRange(h,1),v=l.getEOL()===`\r
`?new n(i):null,m=[];let o=0,b;for(y.reset(0);b=y.next(i);)if(m[o++]=_(this._getMultilineMatchRange(l,r,i,v,b.index,b[0]),b,s),o>=I)return m;return m}static _doFindMatchesLineByLine(l,h,y,s,I){const r=[];let i=0;if(h.startLineNumber===h.endLineNumber){const m=l.getLineContent(h.startLineNumber).substring(h.startColumn-1,h.endColumn-1);return i=this._findMatchesInLine(y,m,h.startLineNumber,h.startColumn-1,i,r,s,I),r}const v=l.getLineContent(h.startLineNumber).substring(h.startColumn-1);i=this._findMatchesInLine(y,v,h.startLineNumber,h.startColumn-1,i,r,s,I);for(let m=h.startLineNumber+1;m<h.endLineNumber&&i<I;m++)i=this._findMatchesInLine(y,l.getLineContent(m),m,0,i,r,s,I);if(i<I){const m=l.getLineContent(h.endLineNumber).substring(0,h.endColumn-1);i=this._findMatchesInLine(y,m,h.endLineNumber,0,i,r,s,I)}return r}static _findMatchesInLine(l,h,y,s,I,r,i,v){const m=l.wordSeparators;if(!i&&l.simpleSearch){const d=l.simpleSearch,E=d.length,R=h.length;let P=-E;for(;(P=h.indexOf(d,P+E))!==-1;)if((!m||p(m,h,R,P,E))&&(r[I++]=new t.FindMatch(new A.Range(y,P+1+s,y,P+1+E+s),null),I>=v))return I;return I}const o=new D(l.wordSeparators,l.regex);let b;o.reset(0);do if(b=o.next(h),b&&(r[I++]=_(new A.Range(y,b.index+1+s,y,b.index+1+b[0].length+s),b,i),I>=v))return I;while(b);return I}static findNextMatch(l,h,y,s){const I=h.parseSearchRequest();if(!I)return null;const r=new D(I.wordSeparators,I.regex);return I.regex.multiline?this._doFindNextMatchMultiline(l,y,r,s):this._doFindNextMatchLineByLine(l,y,r,s)}static _doFindNextMatchMultiline(l,h,y,s){const I=new w.Position(h.lineNumber,1),r=l.getOffsetAt(I),i=l.getLineCount(),v=l.getValueInRange(new A.Range(I.lineNumber,I.column,i,l.getLineMaxColumn(i)),1),m=l.getEOL()===`\r
`?new n(v):null;y.reset(h.column-1);let o=y.next(v);return o?_(this._getMultilineMatchRange(l,r,v,m,o.index,o[0]),o,s):h.lineNumber!==1||h.column!==1?this._doFindNextMatchMultiline(l,new w.Position(1,1),y,s):null}static _doFindNextMatchLineByLine(l,h,y,s){const I=l.getLineCount(),r=h.lineNumber,i=l.getLineContent(r),v=this._findFirstMatchInLine(y,i,r,h.column,s);if(v)return v;for(let m=1;m<=I;m++){const o=(r+m-1)%I,b=l.getLineContent(o+1),d=this._findFirstMatchInLine(y,b,o+1,1,s);if(d)return d}return null}static _findFirstMatchInLine(l,h,y,s,I){l.reset(s-1);const r=l.next(h);return r?_(new A.Range(y,r.index+1,y,r.index+1+r[0].length),r,I):null}static findPreviousMatch(l,h,y,s){const I=h.parseSearchRequest();if(!I)return null;const r=new D(I.wordSeparators,I.regex);return I.regex.multiline?this._doFindPreviousMatchMultiline(l,y,r,s):this._doFindPreviousMatchLineByLine(l,y,r,s)}static _doFindPreviousMatchMultiline(l,h,y,s){const I=this._doFindMatchesMultiline(l,new A.Range(1,1,h.lineNumber,h.column),y,s,10*T);if(I.length>0)return I[I.length-1];const r=l.getLineCount();return h.lineNumber!==r||h.column!==l.getLineMaxColumn(r)?this._doFindPreviousMatchMultiline(l,new w.Position(r,l.getLineMaxColumn(r)),y,s):null}static _doFindPreviousMatchLineByLine(l,h,y,s){const I=l.getLineCount(),r=h.lineNumber,i=l.getLineContent(r).substring(0,h.column-1),v=this._findLastMatchInLine(y,i,r,s);if(v)return v;for(let m=1;m<=I;m++){const o=(I+r-m-1)%I,b=l.getLineContent(o+1),d=this._findLastMatchInLine(y,b,o+1,s);if(d)return d}return null}static _findLastMatchInLine(l,h,y,s){let I=null,r;for(l.reset(0);r=l.next(h);)I=_(new A.Range(y,r.index+1,y,r.index+1+r[0].length),r,s);return I}}e.TextModelSearch=g;function a(f,l,h,y,s){if(y===0)return!0;const I=l.charCodeAt(y-1);if(f.get(I)!==0||I===13||I===10)return!0;if(s>0){const r=l.charCodeAt(y);if(f.get(r)!==0)return!0}return!1}function c(f,l,h,y,s){if(y+s===h)return!0;const I=l.charCodeAt(y+s);if(f.get(I)!==0||I===13||I===10)return!0;if(s>0){const r=l.charCodeAt(y+s-1);if(f.get(r)!==0)return!0}return!1}function p(f,l,h,y,s){return a(f,l,h,y,s)&&c(f,l,h,y,s)}e.isValidMatch=p;class D{constructor(l,h){this._wordSeparators=l,this._searchRegex=h,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(l){this._searchRegex.lastIndex=l,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(l){const h=l.length;let y;do{if(this._prevMatchStartIndex+this._prevMatchLength===h||(y=this._searchRegex.exec(l),!y))return null;const s=y.index,I=y[0].length;if(s===this._prevMatchStartIndex&&I===this._prevMatchLength){if(I===0){u.getNextCodePoint(l,h,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=s,this._prevMatchLength=I,!this._wordSeparators||p(this._wordSeparators,l,h,s,I))return y}while(y);return null}}e.Searcher=D}),define(we[111],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var u;(function(t){t[t.None=0]="None",t[t.Indent=1]="Indent",t[t.IndentOutdent=2]="IndentOutdent",t[t.Outdent=3]="Outdent"})(u=e.IndentAction||(e.IndentAction={}));class M{constructor(T){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=T.open,this.close=T.close,this._standardTokenMask=0,Array.isArray(T.notIn))for(let C=0,k=T.notIn.length;C<k;C++)switch(T.notIn[C]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(T){return(this._standardTokenMask&T)==0}shouldAutoClose(T,C){if(T.getTokenCount()===0)return!0;const k=T.findTokenIndexAtOffset(C-2),F=T.getStandardTokenType(k);return this.isOK(F)}_findNeutralCharacterInRange(T,C){for(let k=T;k<=C;k++){const F=String.fromCharCode(k);if(!this.open.includes(F)&&!this.close.includes(F))return F}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(48,57)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(97,122)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(65,90))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=M;class w{constructor(T){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const C of T)A(this.autoClosingPairsOpenByStart,C.open.charAt(0),C),A(this.autoClosingPairsOpenByEnd,C.open.charAt(C.open.length-1),C),A(this.autoClosingPairsCloseByStart,C.close.charAt(0),C),A(this.autoClosingPairsCloseByEnd,C.close.charAt(C.close.length-1),C),C.close.length===1&&C.open.length===1&&A(this.autoClosingPairsCloseSingleChar,C.close,C)}}e.AutoClosingPairs=w;function A(t,T,C){t.has(T)?t.get(T).push(C):t.set(T,[C])}}),define(we[56],Ee([0,1,29,17]),function(re,e,u,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function w(A,t,T,C){if(Array.isArray(A)){let k=0;for(const F of A){const _=w(F,t,T,C);if(_===10)return _;_>k&&(k=_)}return k}else{if(typeof A=="string")return C?A==="*"?5:A===T?10:0:0;if(A){const{language:k,pattern:F,scheme:_,hasAccessToAllModels:n}=A;if(!C&&!n)return 0;let g=0;if(_)if(_===t.scheme)g=10;else if(_==="*")g=5;else return 0;if(k)if(k===T)g=10;else if(k==="*")g=Math.max(g,5);else return 0;if(F){let a;if(typeof F=="string"?a=F:a={...F,base:(0,M.normalize)(F.base)},a===t.fsPath||(0,u.match)(a,t.fsPath))g=10;else return 0}return g}else return 0}}e.score=w}),define(we[112],Ee([0,1,3,6]),function(re,e,u,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class w{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new u.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(t){this._onDidChange.fire({changedLanguages:t,changedColorMap:!1})}register(t,T){return this._map.set(t,T),this.fire([t]),(0,M.toDisposable)(()=>{this._map.get(t)===T&&(this._map.delete(t),this.fire([t]))})}registerPromise(t,T){let C=null,k=!1;return this._promises.set(t,T.then(F=>{this._promises.delete(t),!(k||!F)&&(C=this.register(t,F))})),(0,M.toDisposable)(()=>{k=!0,C&&C.dispose()})}getPromise(t){const T=this.get(t);if(T)return Promise.resolve(T);const C=this._promises.get(t);return C?C.then(k=>this.get(t)):null}get(t){return this._map.get(t)||null}setColorMap(t){this._colorMap=t,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=w}),define(we[81],Ee([0,1,22,24]),function(re,e,u,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var w;(function(_){_[_.Full=1]="Full",_[_.Delta=2]="Delta"})(w||(w={}));function A(_){for(let n=0,g=_.length;n<g;n+=4){const a=_[n+0],c=_[n+1],p=_[n+2],D=_[n+3];_[n+0]=D,_[n+1]=p,_[n+2]=c,_[n+3]=a}}function t(_){const n=new Uint8Array(_.buffer,_.byteOffset,_.length*4);return M.isLittleEndian()||A(n),u.VSBuffer.wrap(n)}function T(_){const n=_.buffer;if(M.isLittleEndian()||A(n),n.byteOffset%4==0)return new Uint32Array(n.buffer,n.byteOffset,n.length/4);{const g=new Uint8Array(n.byteLength);return g.set(n),new Uint32Array(g.buffer,g.byteOffset,g.length/4)}}function C(_){const n=new Uint32Array(k(_));let g=0;if(n[g++]=_.id,_.type==="full")n[g++]=1,n[g++]=_.data.length,n.set(_.data,g),g+=_.data.length;else{n[g++]=2,n[g++]=_.deltas.length;for(const a of _.deltas)n[g++]=a.start,n[g++]=a.deleteCount,a.data?(n[g++]=a.data.length,n.set(a.data,g),g+=a.data.length):n[g++]=0}return t(n)}e.encodeSemanticTokensDto=C;function k(_){let n=0;if(n+=1+1,_.type==="full")n+=1+_.data.length;else{n+=1,n+=(1+1+1)*_.deltas.length;for(const g of _.deltas)g.data&&(n+=g.data.length)}return n}function F(_){const n=T(_);let g=0;const a=n[g++];if(n[g++]===1){const f=n[g++],l=n.subarray(g,g+f);return g+=f,{id:a,type:"full",data:l}}const p=n[g++];let D=[];for(let f=0;f<p;f++){const l=n[g++],h=n[g++],y=n[g++];let s;y>0&&(s=n.subarray(g,g+y),g+=y),D[f]={start:l,deleteCount:h,data:s}}return{id:a,type:"delta",deltas:D}}e.decodeSemanticTokensDto=F}),define(we[113],Ee([18,19]),function(re,e){return re.create("vs/base/common/date",e)}),define(we[114],Ee([0,1,113]),function(re,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const M=60,w=M*60,A=w*24,t=A*7,T=A*30,C=A*365;function k(_,n){typeof _!="number"&&(_=_.getTime());const g=Math.round((new Date().getTime()-_)/1e3);if(g<-30)return(0,u.localize)(0,null,k(new Date().getTime()+g*1e3,!1));if(g<30)return(0,u.localize)(1,null);let a;return g<M?(a=g,n?a===1?(0,u.localize)(2,null,a):(0,u.localize)(3,null,a):a===1?(0,u.localize)(4,null,a):(0,u.localize)(5,null,a)):g<w?(a=Math.floor(g/M),n?a===1?(0,u.localize)(6,null,a):(0,u.localize)(7,null,a):a===1?(0,u.localize)(8,null,a):(0,u.localize)(9,null,a)):g<A?(a=Math.floor(g/w),n?a===1?(0,u.localize)(10,null,a):(0,u.localize)(11,null,a):a===1?(0,u.localize)(12,null,a):(0,u.localize)(13,null,a)):g<t?(a=Math.floor(g/A),n?a===1?(0,u.localize)(14,null,a):(0,u.localize)(15,null,a):a===1?(0,u.localize)(16,null,a):(0,u.localize)(17,null,a)):g<T?(a=Math.floor(g/t),n?a===1?(0,u.localize)(18,null,a):(0,u.localize)(19,null,a):a===1?(0,u.localize)(20,null,a):(0,u.localize)(21,null,a)):g<C?(a=Math.floor(g/T),n?a===1?(0,u.localize)(22,null,a):(0,u.localize)(23,null,a):a===1?(0,u.localize)(24,null,a):(0,u.localize)(25,null,a)):(a=Math.floor(g/C),n?a===1?(0,u.localize)(26,null,a):(0,u.localize)(27,null,a):a===1?(0,u.localize)(28,null,a):(0,u.localize)(29,null,a))}e.fromNow=k;function F(_){return _.getFullYear()+"-"+String(_.getMonth()+1).padStart(2,"0")+"-"+String(_.getDate()).padStart(2,"0")+"T"+String(_.getHours()).padStart(2,"0")+":"+String(_.getMinutes()).padStart(2,"0")+":"+String(_.getSeconds()).padStart(2,"0")+"."+(_.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=F}),define(we[115],Ee([18,19]),function(re,e){return re.create("vs/base/common/errorMessage",e)}),define(we[44],Ee([0,1,16,10,115]),function(re,e,u,M,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function A(k,F){return F&&(k.stack||k.stacktrace)?w.localize(0,null,T(k),t(k.stack)||t(k.stacktrace)):T(k)}function t(k){return Array.isArray(k)?k.join(`
`):k}function T(k){return typeof k.code=="string"&&typeof k.errno=="number"&&typeof k.syscall=="string"?w.localize(1,null,k.message):k.message||w.localize(2,null)}function C(k=null,F=!1){if(!k)return w.localize(3,null);if(Array.isArray(k)){const _=u.coalesce(k),n=C(_[0],F);return _.length>1?w.localize(4,null,n,_.length):n}if(M.isString(k))return k;if(k.detail){const _=k.detail;if(_.error)return A(_.error,F);if(_.exception)return A(_.exception,F)}return k.stack?A(k,F):k.message?k.message:w.localize(5,null)}e.toErrorMessage=C}),define(we[116],Ee([18,19]),function(re,e){return re.create("vs/editor/common/config/editorOptions",e)}),define(we[117],Ee([0,1,116,24,118]),function(re,e,u,M,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var A;(function(q){q[q.None=0]="None",q[q.Keep=1]="Keep",q[q.Brackets=2]="Brackets",q[q.Advanced=3]="Advanced",q[q.Full=4]="Full"})(A=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class t{constructor(X){this._values=X}hasChanged(X){return this._values[X]}}e.ConfigurationChangedEvent=t;class T{constructor(){this._values=[]}_read(X){return this._values[X]}get(X){return this._values[X]}_write(X,ge){this._values[X]=ge}}e.ValidatedEditorOptions=T;class C{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=C;class k{constructor(X,ge,Ue,qe){this.id=X,this.name=ge,this.defaultValue=Ue,this.schema=qe}compute(X,ge,Ue){return Ue}}class F{constructor(X,ge=null){this.schema=void 0,this.id=X,this.name="_never_",this.defaultValue=void 0,this.deps=ge}validate(X){return this.defaultValue}}class _{constructor(X,ge,Ue,qe){this.id=X,this.name=ge,this.defaultValue=Ue,this.schema=qe}validate(X){return typeof X=="undefined"?this.defaultValue:X}compute(X,ge,Ue){return Ue}}function n(q,X){return typeof q=="undefined"?X:q==="false"?!1:Boolean(q)}e.boolean=n;class g extends _{constructor(X,ge,Ue,qe=void 0){typeof qe!="undefined"&&(qe.type="boolean",qe.default=Ue),super(X,ge,Ue,qe)}validate(X){return n(X,this.defaultValue)}}function a(q,X,ge,Ue){if(typeof q=="undefined")return X;let qe=parseInt(q,10);return isNaN(qe)?X:(qe=Math.max(ge,qe),qe=Math.min(Ue,qe),qe|0)}e.clampedInt=a;class c extends _{constructor(X,ge,Ue,qe,nt,mt=void 0){typeof mt!="undefined"&&(mt.type="integer",mt.default=Ue,mt.minimum=qe,mt.maximum=nt),super(X,ge,Ue,mt),this.minimum=qe,this.maximum=nt}static clampedInt(X,ge,Ue,qe){return a(X,ge,Ue,qe)}validate(X){return c.clampedInt(X,this.defaultValue,this.minimum,this.maximum)}}class p extends _{constructor(X,ge,Ue,qe,nt){typeof nt!="undefined"&&(nt.type="number",nt.default=Ue),super(X,ge,Ue,nt),this.validationFn=qe}static clamp(X,ge,Ue){return X<ge?ge:X>Ue?Ue:X}static float(X,ge){if(typeof X=="number")return X;if(typeof X=="undefined")return ge;const Ue=parseFloat(X);return isNaN(Ue)?ge:Ue}validate(X){return this.validationFn(p.float(X,this.defaultValue))}}class D extends _{static string(X,ge){return typeof X!="string"?ge:X}constructor(X,ge,Ue,qe=void 0){typeof qe!="undefined"&&(qe.type="string",qe.default=Ue),super(X,ge,Ue,qe)}validate(X){return D.string(X,this.defaultValue)}}function f(q,X,ge){return typeof q!="string"||ge.indexOf(q)===-1?X:q}e.stringSet=f;class l extends _{constructor(X,ge,Ue,qe,nt=void 0){typeof nt!="undefined"&&(nt.type="string",nt.enum=qe,nt.default=Ue),super(X,ge,Ue,nt),this._allowedValues=qe}validate(X){return f(X,this.defaultValue,this._allowedValues)}}class h extends k{constructor(X,ge,Ue,qe,nt,mt,lt=void 0){typeof lt!="undefined"&&(lt.type="string",lt.enum=nt,lt.default=qe),super(X,ge,Ue,lt),this._allowedValues=nt,this._convert=mt}validate(X){return typeof X!="string"?this.defaultValue:this._allowedValues.indexOf(X)===-1?this.defaultValue:this._convert(X)}}function y(q){switch(q){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class s extends k{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[u.localize(0,null),u.localize(1,null),u.localize(2,null)],default:"auto",description:u.localize(3,null)})}validate(X){switch(X){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(X,ge,Ue){return Ue===0?X.accessibilitySupport:Ue}}class I extends k{constructor(){const X={insertSpace:!0,ignoreEmptyLines:!0};super(19,"comments",X,{"editor.comments.insertSpace":{type:"boolean",default:X.insertSpace,description:u.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:X.ignoreEmptyLines,description:u.localize(5,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ge=X;return{insertSpace:n(ge.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:n(ge.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var r;(function(q){q[q.Hidden=0]="Hidden",q[q.Blink=1]="Blink",q[q.Smooth=2]="Smooth",q[q.Phase=3]="Phase",q[q.Expand=4]="Expand",q[q.Solid=5]="Solid"})(r=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function i(q){switch(q){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var v;(function(q){q[q.Line=1]="Line",q[q.Block=2]="Block",q[q.Underline=3]="Underline",q[q.LineThin=4]="LineThin",q[q.BlockOutline=5]="BlockOutline",q[q.UnderlineThin=6]="UnderlineThin"})(v=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function m(q){switch(q){case v.Line:return"line";case v.Block:return"block";case v.Underline:return"underline";case v.LineThin:return"line-thin";case v.BlockOutline:return"block-outline";case v.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=m;function o(q){switch(q){case"line":return v.Line;case"block":return v.Block;case"underline":return v.Underline;case"line-thin":return v.LineThin;case"block-outline":return v.BlockOutline;case"underline-thin":return v.UnderlineThin}}class b extends F{constructor(){super(126,[65,33])}compute(X,ge,Ue){const qe=["monaco-editor"];return ge.get(33)&&qe.push(ge.get(33)),X.extraEditorClassName&&qe.push(X.extraEditorClassName),ge.get(65)==="default"?qe.push("mouse-default"):ge.get(65)==="copy"&&qe.push("mouse-copy"),ge.get(99)&&qe.push("showUnused"),ge.get(124)&&qe.push("showDeprecated"),qe.join(" ")}}class d extends g{constructor(){super(32,"emptySelectionClipboard",!0,{description:u.localize(6,null)})}compute(X,ge,Ue){return Ue&&X.emptySelectionClipboard}}class E extends k{constructor(){const X={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(35,"find",X,{"editor.find.cursorMoveOnType":{type:"boolean",default:X.cursorMoveOnType,description:u.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:X.seedSearchStringFromSelection,enumDescriptions:[u.localize(8,null),u.localize(9,null),u.localize(10,null)],description:u.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:X.autoFindInSelection,enumDescriptions:[u.localize(12,null),u.localize(13,null),u.localize(14,null)],description:u.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:X.globalFindClipboard,description:u.localize(16,null),included:M.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:X.addExtraSpaceOnTop,description:u.localize(17,null)},"editor.find.loop":{type:"boolean",default:X.loop,description:u.localize(18,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ge=X;return{cursorMoveOnType:n(ge.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof X.seedSearchStringFromSelection=="boolean"?X.seedSearchStringFromSelection?"always":"never":f(ge.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof X.autoFindInSelection=="boolean"?X.autoFindInSelection?"always":"never":f(ge.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:n(ge.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:n(ge.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:n(ge.loop,this.defaultValue.loop)}}}class R extends k{constructor(){super(44,"fontLigatures",R.OFF,{anyOf:[{type:"boolean",description:u.localize(19,null)},{type:"string",description:u.localize(20,null)}],description:u.localize(21,null),default:!1})}validate(X){return typeof X=="undefined"?this.defaultValue:typeof X=="string"?X==="false"?R.OFF:X==="true"?R.ON:X:Boolean(X)?R.ON:R.OFF}}e.EditorFontLigatures=R,R.OFF='"liga" off, "calt" off',R.ON='"liga" on, "calt" on';class P extends F{constructor(){super(43)}compute(X,ge,Ue){return X.fontInfo}}class z extends _{constructor(){super(45,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:u.localize(22,null)})}validate(X){let ge=p.float(X,this.defaultValue);return ge===0?e.EDITOR_FONT_DEFAULTS.fontSize:p.clamp(ge,6,100)}compute(X,ge,Ue){return X.fontInfo.fontSize}}class O extends k{constructor(){super(46,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:O.MINIMUM_VALUE,maximum:O.MAXIMUM_VALUE,errorMessage:u.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:O.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:u.localize(24,null)})}validate(X){return X==="normal"||X==="bold"?X:String(c.clampedInt(X,e.EDITOR_FONT_DEFAULTS.fontWeight,O.MINIMUM_VALUE,O.MAXIMUM_VALUE))}}O.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],O.MINIMUM_VALUE=1,O.MAXIMUM_VALUE=1e3;class S extends k{constructor(){const X={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},ge={type:"string",enum:["peek","gotoAndPeek","goto"],default:X.multiple,enumDescriptions:[u.localize(25,null),u.localize(26,null),u.localize(27,null)]},Ue=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(50,"gotoLocation",X,{"editor.gotoLocation.multiple":{deprecationMessage:u.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:u.localize(29,null),...ge},"editor.gotoLocation.multipleTypeDefinitions":{description:u.localize(30,null),...ge},"editor.gotoLocation.multipleDeclarations":{description:u.localize(31,null),...ge},"editor.gotoLocation.multipleImplementations":{description:u.localize(32,null),...ge},"editor.gotoLocation.multipleReferences":{description:u.localize(33,null),...ge},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:X.alternativeDefinitionCommand,enum:Ue,description:u.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:X.alternativeTypeDefinitionCommand,enum:Ue,description:u.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:X.alternativeDeclarationCommand,enum:Ue,description:u.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:X.alternativeImplementationCommand,enum:Ue,description:u.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:X.alternativeReferenceCommand,enum:Ue,description:u.localize(38,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ge=X;return{multiple:f(ge.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:ge.multipleDefinitions??f(ge.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:ge.multipleTypeDefinitions??f(ge.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:ge.multipleDeclarations??f(ge.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:ge.multipleImplementations??f(ge.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:ge.multipleReferences??f(ge.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:D.string(ge.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:D.string(ge.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:D.string(ge.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:D.string(ge.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:D.string(ge.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class x extends k{constructor(){const X={enabled:!0,delay:300,sticky:!0,above:!0};super(52,"hover",X,{"editor.hover.enabled":{type:"boolean",default:X.enabled,description:u.localize(39,null)},"editor.hover.delay":{type:"number",default:X.delay,description:u.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:X.sticky,description:u.localize(41,null)},"editor.hover.above":{type:"boolean",default:X.above,description:u.localize(42,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ge=X;return{enabled:n(ge.enabled,this.defaultValue.enabled),delay:c.clampedInt(ge.delay,this.defaultValue.delay,0,1e4),sticky:n(ge.sticky,this.defaultValue.sticky),above:n(ge.above,this.defaultValue.above)}}}var N;(function(q){q[q.None=0]="None",q[q.Text=1]="Text",q[q.Blocks=2]="Blocks"})(N=e.RenderMinimap||(e.RenderMinimap={}));class V extends F{constructor(){super(129,[49,57,37,64,91,59,60,93,116,119,120,121,2])}compute(X,ge,Ue){return V.computeLayout(ge,{memory:X.memory,outerWidth:X.outerWidth,outerHeight:X.outerHeight,isDominatedByLongLines:X.isDominatedByLongLines,lineHeight:X.fontInfo.lineHeight,viewLineCount:X.viewLineCount,lineNumbersDigitCount:X.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:X.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:X.fontInfo.maxDigitWidth,pixelRatio:X.pixelRatio})}static computeContainedMinimapLineCount(X){const ge=X.height/X.lineHeight,Ue=X.scrollBeyondLastLine?ge-1:0,qe=(X.viewLineCount+Ue)/(X.pixelRatio*X.height),nt=Math.floor(X.viewLineCount/qe);return{typicalViewportLineCount:ge,extraLinesBeyondLastLine:Ue,desiredRatio:qe,minimapLineCount:nt}}static _computeMinimapLayout(X,ge){const Ue=X.outerWidth,qe=X.outerHeight,nt=X.pixelRatio;if(!X.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(nt*qe),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:qe};const mt=ge.stableMinimapLayoutInput,lt=mt&&X.outerHeight===mt.outerHeight&&X.lineHeight===mt.lineHeight&&X.typicalHalfwidthCharacterWidth===mt.typicalHalfwidthCharacterWidth&&X.pixelRatio===mt.pixelRatio&&X.scrollBeyondLastLine===mt.scrollBeyondLastLine&&X.minimap.enabled===mt.minimap.enabled&&X.minimap.side===mt.minimap.side&&X.minimap.size===mt.minimap.size&&X.minimap.showSlider===mt.minimap.showSlider&&X.minimap.renderCharacters===mt.minimap.renderCharacters&&X.minimap.maxColumn===mt.minimap.maxColumn&&X.minimap.scale===mt.minimap.scale&&X.verticalScrollbarWidth===mt.verticalScrollbarWidth&&X.isViewportWrapping===mt.isViewportWrapping,St=X.lineHeight,kt=X.typicalHalfwidthCharacterWidth,It=X.scrollBeyondLastLine,Je=X.minimap.renderCharacters;let bt=nt>=2?Math.round(X.minimap.scale*2):X.minimap.scale;const Ie=X.minimap.maxColumn,Se=X.minimap.size,pe=X.minimap.side,oe=X.verticalScrollbarWidth,ae=X.viewLineCount,ue=X.remainingWidth,fe=X.isViewportWrapping,ke=Je?2:3;let $e=Math.floor(nt*qe);const Re=$e/nt;let ze=!1,tt=!1,rt=ke*bt,ne=bt/nt,me=1;if(Se==="fill"||Se==="fit"){const{typicalViewportLineCount:dt,extraLinesBeyondLastLine:wt,desiredRatio:Ct,minimapLineCount:pt}=V.computeContainedMinimapLineCount({viewLineCount:ae,scrollBeyondLastLine:It,height:qe,lineHeight:St,pixelRatio:nt});if(ae/pt>1)ze=!0,tt=!0,bt=1,rt=1,ne=bt/nt;else{let ht=!1,vt=bt+1;if(Se==="fit"){const Ft=Math.ceil((ae+wt)*rt);fe&&lt&&ue<=ge.stableFitRemainingWidth?(ht=!0,vt=ge.stableFitMaxMinimapScale):ht=Ft>$e}if(Se==="fill"||ht){ze=!0;const Ft=bt;rt=Math.min(St*nt,Math.max(1,Math.floor(1/Ct))),fe&&lt&&ue<=ge.stableFitRemainingWidth&&(vt=ge.stableFitMaxMinimapScale),bt=Math.min(vt,Math.max(1,Math.floor(rt/ke))),bt>Ft&&(me=Math.min(2,bt/Ft)),ne=bt/nt/me,$e=Math.ceil(Math.max(dt,ae+wt)*rt),fe?(ge.stableMinimapLayoutInput=X,ge.stableFitRemainingWidth=ue,ge.stableFitMaxMinimapScale=bt):(ge.stableMinimapLayoutInput=null,ge.stableFitRemainingWidth=0)}}}const ie=Math.floor(Ie*ne),H=Math.min(ie,Math.max(0,Math.floor((ue-oe-2)*ne/(kt+ne)))+e.MINIMAP_GUTTER_WIDTH);let ve=Math.floor(nt*H);const De=ve/nt;ve=Math.floor(ve*me);const je=Je?1:2,Me=pe==="left"?0:Ue-H-oe;return{renderMinimap:je,minimapLeft:Me,minimapWidth:H,minimapHeightIsEditorHeight:ze,minimapIsSampling:tt,minimapScale:bt,minimapLineHeight:rt,minimapCanvasInnerWidth:ve,minimapCanvasInnerHeight:$e,minimapCanvasOuterWidth:De,minimapCanvasOuterHeight:Re}}static computeLayout(X,ge){const Ue=ge.outerWidth|0,qe=ge.outerHeight|0,nt=ge.lineHeight|0,mt=ge.lineNumbersDigitCount|0,lt=ge.typicalHalfwidthCharacterWidth,St=ge.maxDigitWidth,kt=ge.pixelRatio,It=ge.viewLineCount,Je=X.get(121),bt=Je==="inherit"?X.get(120):Je,Ie=bt==="inherit"?X.get(116):bt,Se=X.get(119),pe=X.get(2),oe=ge.isDominatedByLongLines,ae=X.get(49),ue=X.get(59).renderType!==0,fe=X.get(60),ke=X.get(93),$e=X.get(64),Re=X.get(91),ze=Re.verticalScrollbarSize,tt=Re.verticalHasArrows,rt=Re.arrowSize,ne=Re.horizontalScrollbarSize,me=X.get(57),ie=X.get(37);let H;if(typeof me=="string"&&/^\d+(\.\d+)?ch$/.test(me)){const xt=parseFloat(me.substr(0,me.length-2));H=c.clampedInt(xt*lt,0,0,1e3)}else H=c.clampedInt(me,0,0,1e3);ie&&(H+=16);let ve=0;if(ue){const xt=Math.max(mt,fe);ve=Math.round(xt*St)}let De=0;ae&&(De=nt);let je=0,Me=je+De,dt=Me+ve,wt=dt+H;const Ct=Ue-De-ve-H;let pt=!1,ut=!1,ht=-1;pe!==2&&(bt==="inherit"&&oe?(pt=!0,ut=!0):Ie==="on"||Ie==="bounded"?ut=!0:Ie==="wordWrapColumn"&&(ht=Se));const vt=V._computeMinimapLayout({outerWidth:Ue,outerHeight:qe,lineHeight:nt,typicalHalfwidthCharacterWidth:lt,pixelRatio:kt,scrollBeyondLastLine:ke,minimap:$e,verticalScrollbarWidth:ze,viewLineCount:It,remainingWidth:Ct,isViewportWrapping:ut},ge.memory||new C);vt.renderMinimap!==0&&vt.minimapLeft===0&&(je+=vt.minimapWidth,Me+=vt.minimapWidth,dt+=vt.minimapWidth,wt+=vt.minimapWidth);const Ft=Ct-vt.minimapWidth,Tt=Math.max(1,Math.floor((Ft-ze-2)/lt)),Mt=tt?rt:0;return ut&&(ht=Math.max(1,Tt),Ie==="bounded"&&(ht=Math.min(ht,Se))),{width:Ue,height:qe,glyphMarginLeft:je,glyphMarginWidth:De,lineNumbersLeft:Me,lineNumbersWidth:ve,decorationsLeft:dt,decorationsWidth:H,contentLeft:wt,contentWidth:Ft,minimap:vt,viewportColumn:Tt,isWordWrapMinified:pt,isViewportWrapping:ut,wrappingColumn:ht,verticalScrollbarWidth:ze,horizontalScrollbarHeight:ne,overviewRuler:{top:Mt,width:ze,height:qe-2*Mt,right:0}}}}e.EditorLayoutInfoComputer=V;class B extends k{constructor(){const X={enabled:!0};super(56,"lightbulb",X,{"editor.lightbulb.enabled":{type:"boolean",default:X.enabled,description:u.localize(43,null)}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{enabled:n(X.enabled,this.defaultValue.enabled)}}}class $ extends k{constructor(){const X={enabled:!0,fontSize:0,fontFamily:""};super(125,"inlayHints",X,{"editor.inlayHints.enabled":{type:"boolean",default:X.enabled,description:u.localize(44,null)},"editor.inlayHints.fontSize":{type:"number",default:X.fontSize,markdownDescription:u.localize(45,null)},"editor.inlayHints.fontFamily":{type:"string",default:X.fontFamily,markdownDescription:u.localize(46,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ge=X;return{enabled:n(ge.enabled,this.defaultValue.enabled),fontSize:c.clampedInt(ge.fontSize,this.defaultValue.fontSize,0,100),fontFamily:D.string(ge.fontFamily,this.defaultValue.fontFamily)}}}class J extends p{constructor(){super(58,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,X=>p.clamp(X,0,150),{markdownDescription:u.localize(47,null)})}compute(X,ge,Ue){return X.fontInfo.lineHeight}}class j extends k{constructor(){const X={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(64,"minimap",X,{"editor.minimap.enabled":{type:"boolean",default:X.enabled,description:u.localize(48,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[u.localize(49,null),u.localize(50,null),u.localize(51,null)],default:X.size,description:u.localize(52,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:X.side,description:u.localize(53,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:X.showSlider,description:u.localize(54,null)},"editor.minimap.scale":{type:"number",default:X.scale,minimum:1,maximum:3,enum:[1,2,3],description:u.localize(55,null)},"editor.minimap.renderCharacters":{type:"boolean",default:X.renderCharacters,description:u.localize(56,null)},"editor.minimap.maxColumn":{type:"number",default:X.maxColumn,description:u.localize(57,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ge=X;return{enabled:n(ge.enabled,this.defaultValue.enabled),size:f(ge.size,this.defaultValue.size,["proportional","fill","fit"]),side:f(ge.side,this.defaultValue.side,["right","left"]),showSlider:f(ge.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:n(ge.renderCharacters,this.defaultValue.renderCharacters),scale:c.clampedInt(ge.scale,1,1,3),maxColumn:c.clampedInt(ge.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function Q(q){return q==="ctrlCmd"?M.isMacintosh?"metaKey":"ctrlKey":"altKey"}class le extends k{constructor(){super(74,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:u.localize(58,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:u.localize(59,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ge=X;return{top:c.clampedInt(ge.top,0,0,1e3),bottom:c.clampedInt(ge.bottom,0,0,1e3)}}}class be extends k{constructor(){const X={enabled:!0,cycle:!1};super(75,"parameterHints",X,{"editor.parameterHints.enabled":{type:"boolean",default:X.enabled,description:u.localize(60,null)},"editor.parameterHints.cycle":{type:"boolean",default:X.cycle,description:u.localize(61,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ge=X;return{enabled:n(ge.enabled,this.defaultValue.enabled),cycle:n(ge.cycle,this.defaultValue.cycle)}}}class de extends F{constructor(){super(127)}compute(X,ge,Ue){return X.pixelRatio}}class Fe extends k{constructor(){const X={other:!0,comments:!1,strings:!1};super(78,"quickSuggestions",X,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:X.strings,description:u.localize(62,null)},comments:{type:"boolean",default:X.comments,description:u.localize(63,null)},other:{type:"boolean",default:X.other,description:u.localize(64,null)}}}],default:X,description:u.localize(65,null)});this.defaultValue=X}validate(X){if(typeof X=="boolean")return X;if(X&&typeof X=="object"){const ge=X,Ue={other:n(ge.other,this.defaultValue.other),comments:n(ge.comments,this.defaultValue.comments),strings:n(ge.strings,this.defaultValue.strings)};return Ue.other&&Ue.comments&&Ue.strings?!0:!Ue.other&&!Ue.comments&&!Ue.strings?!1:Ue}return this.defaultValue}}var Ge;(function(q){q[q.Off=0]="Off",q[q.On=1]="On",q[q.Relative=2]="Relative",q[q.Interval=3]="Interval",q[q.Custom=4]="Custom"})(Ge=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Le extends k{constructor(){super(59,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[u.localize(66,null),u.localize(67,null),u.localize(68,null),u.localize(69,null)],default:"on",description:u.localize(70,null)})}validate(X){let ge=this.defaultValue.renderType,Ue=this.defaultValue.renderFn;return typeof X!="undefined"&&(typeof X=="function"?(ge=4,Ue=X):X==="interval"?ge=3:X==="relative"?ge=2:X==="on"?ge=1:ge=0),{renderType:ge,renderFn:Ue}}}function We(q){const X=q.get(86);return X==="editable"?q.get(80):X!=="on"}e.filterValidationDecorations=We;class Ye extends k{constructor(){const X=[],ge={type:"number",description:u.localize(71,null)};super(90,"rulers",X,{type:"array",items:{anyOf:[ge,{type:["object"],properties:{column:ge,color:{type:"string",description:u.localize(72,null),format:"color-hex"}}}]},default:X,description:u.localize(73,null)})}validate(X){if(Array.isArray(X)){let ge=[];for(let Ue of X)if(typeof Ue=="number")ge.push({column:c.clampedInt(Ue,0,0,1e4),color:null});else if(Ue&&typeof Ue=="object"){const qe=Ue;ge.push({column:c.clampedInt(qe.column,0,0,1e4),color:qe.color})}return ge.sort((Ue,qe)=>Ue.column-qe.column),ge}return this.defaultValue}}function Qe(q,X){if(typeof q!="string")return X;switch(q){case"hidden":return 2;case"visible":return 3;default:return 1}}class Ke extends k{constructor(){const X={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(91,"scrollbar",X,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[u.localize(74,null),u.localize(75,null),u.localize(76,null)],default:"auto",description:u.localize(77,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[u.localize(78,null),u.localize(79,null),u.localize(80,null)],default:"auto",description:u.localize(81,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:X.verticalScrollbarSize,description:u.localize(82,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:X.horizontalScrollbarSize,description:u.localize(83,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:X.scrollByPage,description:u.localize(84,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ge=X,Ue=c.clampedInt(ge.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),qe=c.clampedInt(ge.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:c.clampedInt(ge.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Qe(ge.vertical,this.defaultValue.vertical),horizontal:Qe(ge.horizontal,this.defaultValue.horizontal),useShadows:n(ge.useShadows,this.defaultValue.useShadows),verticalHasArrows:n(ge.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:n(ge.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:n(ge.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:n(ge.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ue,horizontalSliderSize:c.clampedInt(ge.horizontalSliderSize,Ue,0,1e3),verticalScrollbarSize:qe,verticalSliderSize:c.clampedInt(ge.verticalSliderSize,qe,0,1e3),scrollByPage:n(ge.scrollByPage,this.defaultValue.scrollByPage)}}}class W extends k{constructor(){const X={enabled:!0,mode:"subwordSmart"};super(54,"inlineSuggest",X,{"editor.inlineSuggest.enabled":{type:"boolean",default:X.enabled,description:u.localize(85,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ge=X;return{enabled:n(ge.enabled,this.defaultValue.enabled),mode:f(ge.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class K extends k{constructor(){const X={enabled:e.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled};super(12,"bracketPairColorization",X,{"editor.bracketPairColorization.enabled":{type:"boolean",default:X.enabled,description:u.localize(86,null)}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{enabled:n(X.enabled,this.defaultValue.enabled)}}}class Z extends k{constructor(){const X={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",X,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[u.localize(87,null),u.localize(88,null),u.localize(89,null)],default:X.bracketPairs,description:u.localize(90,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[u.localize(91,null),u.localize(92,null),u.localize(93,null)],default:X.bracketPairsHorizontal,description:u.localize(94,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:X.highlightActiveBracketPair,description:u.localize(95,null)},"editor.guides.indentation":{type:"boolean",default:X.indentation,description:u.localize(96,null)},"editor.guides.highlightActiveIndentation":{type:"boolean",default:X.highlightActiveIndentation,description:u.localize(97,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ge=X;return{bracketPairs:se(ge.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:se(ge.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:n(ge.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:n(ge.indentation,this.defaultValue.indentation),highlightActiveIndentation:n(ge.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation)}}}function se(q,X,ge){const Ue=ge.indexOf(q);return Ue===-1?X:ge[Ue]}class G extends k{constructor(){const X={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(105,"suggest",X,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[u.localize(98,null),u.localize(99,null)],default:X.insertMode,description:u.localize(100,null)},"editor.suggest.filterGraceful":{type:"boolean",default:X.filterGraceful,description:u.localize(101,null)},"editor.suggest.localityBonus":{type:"boolean",default:X.localityBonus,description:u.localize(102,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:X.shareSuggestSelections,markdownDescription:u.localize(103,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:X.snippetsPreventQuickSuggestions,description:u.localize(104,null)},"editor.suggest.showIcons":{type:"boolean",default:X.showIcons,description:u.localize(105,null)},"editor.suggest.showStatusBar":{type:"boolean",default:X.showStatusBar,description:u.localize(106,null)},"editor.suggest.preview":{type:"boolean",default:X.preview,description:u.localize(107,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:X.showInlineDetails,description:u.localize(108,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:u.localize(109,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:u.localize(110,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:u.localize(111,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:u.localize(112,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:u.localize(113,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:u.localize(114,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:u.localize(115,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:u.localize(116,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:u.localize(117,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:u.localize(118,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:u.localize(119,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:u.localize(120,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:u.localize(121,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:u.localize(122,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:u.localize(123,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:u.localize(124,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:u.localize(125,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:u.localize(126,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:u.localize(127,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:u.localize(128,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:u.localize(129,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:u.localize(130,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:u.localize(131,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:u.localize(132,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:u.localize(133,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:u.localize(134,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:u.localize(135,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:u.localize(136,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:u.localize(137,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:u.localize(138,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:u.localize(139,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ge=X;return{insertMode:f(ge.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:n(ge.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:n(ge.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:n(ge.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:n(ge.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:n(ge.showIcons,this.defaultValue.showIcons),showStatusBar:n(ge.showStatusBar,this.defaultValue.showStatusBar),preview:n(ge.preview,this.defaultValue.preview),previewMode:f(ge.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:n(ge.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:n(ge.showMethods,this.defaultValue.showMethods),showFunctions:n(ge.showFunctions,this.defaultValue.showFunctions),showConstructors:n(ge.showConstructors,this.defaultValue.showConstructors),showDeprecated:n(ge.showDeprecated,this.defaultValue.showDeprecated),showFields:n(ge.showFields,this.defaultValue.showFields),showVariables:n(ge.showVariables,this.defaultValue.showVariables),showClasses:n(ge.showClasses,this.defaultValue.showClasses),showStructs:n(ge.showStructs,this.defaultValue.showStructs),showInterfaces:n(ge.showInterfaces,this.defaultValue.showInterfaces),showModules:n(ge.showModules,this.defaultValue.showModules),showProperties:n(ge.showProperties,this.defaultValue.showProperties),showEvents:n(ge.showEvents,this.defaultValue.showEvents),showOperators:n(ge.showOperators,this.defaultValue.showOperators),showUnits:n(ge.showUnits,this.defaultValue.showUnits),showValues:n(ge.showValues,this.defaultValue.showValues),showConstants:n(ge.showConstants,this.defaultValue.showConstants),showEnums:n(ge.showEnums,this.defaultValue.showEnums),showEnumMembers:n(ge.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:n(ge.showKeywords,this.defaultValue.showKeywords),showWords:n(ge.showWords,this.defaultValue.showWords),showColors:n(ge.showColors,this.defaultValue.showColors),showFiles:n(ge.showFiles,this.defaultValue.showFiles),showReferences:n(ge.showReferences,this.defaultValue.showReferences),showFolders:n(ge.showFolders,this.defaultValue.showFolders),showTypeParameters:n(ge.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:n(ge.showSnippets,this.defaultValue.showSnippets),showUsers:n(ge.showUsers,this.defaultValue.showUsers),showIssues:n(ge.showIssues,this.defaultValue.showIssues)}}}class te extends k{constructor(){super(101,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:u.localize(140,null),default:!0,type:"boolean"}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:n(X.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class he extends F{constructor(){super(128,[80])}compute(X,ge,Ue){return ge.get(80)?!0:X.tabFocusMode}}var Pe;(function(q){q[q.None=0]="None",q[q.Same=1]="Same",q[q.Indent=2]="Indent",q[q.DeepIndent=3]="DeepIndent"})(Pe=e.WrappingIndent||(e.WrappingIndent={}));function Oe(q){switch(q){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class Be extends F{constructor(){super(130,[129])}compute(X,ge,Ue){const qe=ge.get(129);return{isDominatedByLongLines:X.isDominatedByLongLines,isWordWrapMinified:qe.isWordWrapMinified,isViewportWrapping:qe.isViewportWrapping,wrappingColumn:qe.wrappingColumn}}}const Ve="Consolas, 'Courier New', monospace",Ze="Menlo, Monaco, 'Courier New', monospace",ot="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:M.isMacintosh?Ze:M.isLinux?ot:Ve,fontWeight:"normal",fontSize:M.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!1}},e.editorOptionsRegistry=[];function ye(q){return e.editorOptionsRegistry[q.id]=q,q}var it;(function(q){q[q.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",q[q.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",q[q.accessibilitySupport=2]="accessibilitySupport",q[q.accessibilityPageSize=3]="accessibilityPageSize",q[q.ariaLabel=4]="ariaLabel",q[q.autoClosingBrackets=5]="autoClosingBrackets",q[q.autoClosingDelete=6]="autoClosingDelete",q[q.autoClosingOvertype=7]="autoClosingOvertype",q[q.autoClosingQuotes=8]="autoClosingQuotes",q[q.autoIndent=9]="autoIndent",q[q.automaticLayout=10]="automaticLayout",q[q.autoSurround=11]="autoSurround",q[q.bracketPairColorization=12]="bracketPairColorization",q[q.guides=13]="guides",q[q.codeLens=14]="codeLens",q[q.codeLensFontFamily=15]="codeLensFontFamily",q[q.codeLensFontSize=16]="codeLensFontSize",q[q.colorDecorators=17]="colorDecorators",q[q.columnSelection=18]="columnSelection",q[q.comments=19]="comments",q[q.contextmenu=20]="contextmenu",q[q.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",q[q.cursorBlinking=22]="cursorBlinking",q[q.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",q[q.cursorStyle=24]="cursorStyle",q[q.cursorSurroundingLines=25]="cursorSurroundingLines",q[q.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",q[q.cursorWidth=27]="cursorWidth",q[q.disableLayerHinting=28]="disableLayerHinting",q[q.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",q[q.domReadOnly=30]="domReadOnly",q[q.dragAndDrop=31]="dragAndDrop",q[q.emptySelectionClipboard=32]="emptySelectionClipboard",q[q.extraEditorClassName=33]="extraEditorClassName",q[q.fastScrollSensitivity=34]="fastScrollSensitivity",q[q.find=35]="find",q[q.fixedOverflowWidgets=36]="fixedOverflowWidgets",q[q.folding=37]="folding",q[q.foldingStrategy=38]="foldingStrategy",q[q.foldingHighlight=39]="foldingHighlight",q[q.foldingImportsByDefault=40]="foldingImportsByDefault",q[q.unfoldOnClickAfterEndOfLine=41]="unfoldOnClickAfterEndOfLine",q[q.fontFamily=42]="fontFamily",q[q.fontInfo=43]="fontInfo",q[q.fontLigatures=44]="fontLigatures",q[q.fontSize=45]="fontSize",q[q.fontWeight=46]="fontWeight",q[q.formatOnPaste=47]="formatOnPaste",q[q.formatOnType=48]="formatOnType",q[q.glyphMargin=49]="glyphMargin",q[q.gotoLocation=50]="gotoLocation",q[q.hideCursorInOverviewRuler=51]="hideCursorInOverviewRuler",q[q.hover=52]="hover",q[q.inDiffEditor=53]="inDiffEditor",q[q.inlineSuggest=54]="inlineSuggest",q[q.letterSpacing=55]="letterSpacing",q[q.lightbulb=56]="lightbulb",q[q.lineDecorationsWidth=57]="lineDecorationsWidth",q[q.lineHeight=58]="lineHeight",q[q.lineNumbers=59]="lineNumbers",q[q.lineNumbersMinChars=60]="lineNumbersMinChars",q[q.linkedEditing=61]="linkedEditing",q[q.links=62]="links",q[q.matchBrackets=63]="matchBrackets",q[q.minimap=64]="minimap",q[q.mouseStyle=65]="mouseStyle",q[q.mouseWheelScrollSensitivity=66]="mouseWheelScrollSensitivity",q[q.mouseWheelZoom=67]="mouseWheelZoom",q[q.multiCursorMergeOverlapping=68]="multiCursorMergeOverlapping",q[q.multiCursorModifier=69]="multiCursorModifier",q[q.multiCursorPaste=70]="multiCursorPaste",q[q.occurrencesHighlight=71]="occurrencesHighlight",q[q.overviewRulerBorder=72]="overviewRulerBorder",q[q.overviewRulerLanes=73]="overviewRulerLanes",q[q.padding=74]="padding",q[q.parameterHints=75]="parameterHints",q[q.peekWidgetDefaultFocus=76]="peekWidgetDefaultFocus",q[q.definitionLinkOpensInPeek=77]="definitionLinkOpensInPeek",q[q.quickSuggestions=78]="quickSuggestions",q[q.quickSuggestionsDelay=79]="quickSuggestionsDelay",q[q.readOnly=80]="readOnly",q[q.renameOnType=81]="renameOnType",q[q.renderControlCharacters=82]="renderControlCharacters",q[q.renderFinalNewline=83]="renderFinalNewline",q[q.renderLineHighlight=84]="renderLineHighlight",q[q.renderLineHighlightOnlyWhenFocus=85]="renderLineHighlightOnlyWhenFocus",q[q.renderValidationDecorations=86]="renderValidationDecorations",q[q.renderWhitespace=87]="renderWhitespace",q[q.revealHorizontalRightPadding=88]="revealHorizontalRightPadding",q[q.roundedSelection=89]="roundedSelection",q[q.rulers=90]="rulers",q[q.scrollbar=91]="scrollbar",q[q.scrollBeyondLastColumn=92]="scrollBeyondLastColumn",q[q.scrollBeyondLastLine=93]="scrollBeyondLastLine",q[q.scrollPredominantAxis=94]="scrollPredominantAxis",q[q.selectionClipboard=95]="selectionClipboard",q[q.selectionHighlight=96]="selectionHighlight",q[q.selectOnLineNumbers=97]="selectOnLineNumbers",q[q.showFoldingControls=98]="showFoldingControls",q[q.showUnused=99]="showUnused",q[q.snippetSuggestions=100]="snippetSuggestions",q[q.smartSelect=101]="smartSelect",q[q.smoothScrolling=102]="smoothScrolling",q[q.stickyTabStops=103]="stickyTabStops",q[q.stopRenderingLineAfter=104]="stopRenderingLineAfter",q[q.suggest=105]="suggest",q[q.suggestFontSize=106]="suggestFontSize",q[q.suggestLineHeight=107]="suggestLineHeight",q[q.suggestOnTriggerCharacters=108]="suggestOnTriggerCharacters",q[q.suggestSelection=109]="suggestSelection",q[q.tabCompletion=110]="tabCompletion",q[q.tabIndex=111]="tabIndex",q[q.unusualLineTerminators=112]="unusualLineTerminators",q[q.useShadowDOM=113]="useShadowDOM",q[q.useTabStops=114]="useTabStops",q[q.wordSeparators=115]="wordSeparators",q[q.wordWrap=116]="wordWrap",q[q.wordWrapBreakAfterCharacters=117]="wordWrapBreakAfterCharacters",q[q.wordWrapBreakBeforeCharacters=118]="wordWrapBreakBeforeCharacters",q[q.wordWrapColumn=119]="wordWrapColumn",q[q.wordWrapOverride1=120]="wordWrapOverride1",q[q.wordWrapOverride2=121]="wordWrapOverride2",q[q.wrappingIndent=122]="wrappingIndent",q[q.wrappingStrategy=123]="wrappingStrategy",q[q.showDeprecated=124]="showDeprecated",q[q.inlayHints=125]="inlayHints",q[q.editorClassName=126]="editorClassName",q[q.pixelRatio=127]="pixelRatio",q[q.tabFocusMode=128]="tabFocusMode",q[q.layoutInfo=129]="layoutInfo",q[q.wrappingInfo=130]="wrappingInfo"})(it=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:ye(new g(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:u.localize(141,null)})),acceptSuggestionOnEnter:ye(new l(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",u.localize(142,null),""],markdownDescription:u.localize(143,null)})),accessibilitySupport:ye(new s),accessibilityPageSize:ye(new c(3,"accessibilityPageSize",10,1,1073741824,{description:u.localize(144,null)})),ariaLabel:ye(new D(4,"ariaLabel",u.localize(145,null))),autoClosingBrackets:ye(new l(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",u.localize(146,null),u.localize(147,null),""],description:u.localize(148,null)})),autoClosingDelete:ye(new l(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",u.localize(149,null),""],description:u.localize(150,null)})),autoClosingOvertype:ye(new l(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",u.localize(151,null),""],description:u.localize(152,null)})),autoClosingQuotes:ye(new l(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",u.localize(153,null),u.localize(154,null),""],description:u.localize(155,null)})),autoIndent:ye(new h(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],y,{enumDescriptions:[u.localize(156,null),u.localize(157,null),u.localize(158,null),u.localize(159,null),u.localize(160,null)],description:u.localize(161,null)})),automaticLayout:ye(new g(10,"automaticLayout",!1)),autoSurround:ye(new l(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[u.localize(162,null),u.localize(163,null),u.localize(164,null),""],description:u.localize(165,null)})),bracketPairColorization:ye(new K),bracketPairGuides:ye(new Z),stickyTabStops:ye(new g(103,"stickyTabStops",!1,{description:u.localize(166,null)})),codeLens:ye(new g(14,"codeLens",!0,{description:u.localize(167,null)})),codeLensFontFamily:ye(new D(15,"codeLensFontFamily","",{description:u.localize(168,null)})),codeLensFontSize:ye(new c(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:u.localize(169,null)})),colorDecorators:ye(new g(17,"colorDecorators",!0,{description:u.localize(170,null)})),columnSelection:ye(new g(18,"columnSelection",!1,{description:u.localize(171,null)})),comments:ye(new I),contextmenu:ye(new g(20,"contextmenu",!0)),copyWithSyntaxHighlighting:ye(new g(21,"copyWithSyntaxHighlighting",!0,{description:u.localize(172,null)})),cursorBlinking:ye(new h(22,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],i,{description:u.localize(173,null)})),cursorSmoothCaretAnimation:ye(new g(23,"cursorSmoothCaretAnimation",!1,{description:u.localize(174,null)})),cursorStyle:ye(new h(24,"cursorStyle",v.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],o,{description:u.localize(175,null)})),cursorSurroundingLines:ye(new c(25,"cursorSurroundingLines",0,0,1073741824,{description:u.localize(176,null)})),cursorSurroundingLinesStyle:ye(new l(26,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[u.localize(177,null),u.localize(178,null)],description:u.localize(179,null)})),cursorWidth:ye(new c(27,"cursorWidth",0,0,1073741824,{markdownDescription:u.localize(180,null)})),disableLayerHinting:ye(new g(28,"disableLayerHinting",!1)),disableMonospaceOptimizations:ye(new g(29,"disableMonospaceOptimizations",!1)),domReadOnly:ye(new g(30,"domReadOnly",!1)),dragAndDrop:ye(new g(31,"dragAndDrop",!0,{description:u.localize(181,null)})),emptySelectionClipboard:ye(new d),extraEditorClassName:ye(new D(33,"extraEditorClassName","")),fastScrollSensitivity:ye(new p(34,"fastScrollSensitivity",5,q=>q<=0?5:q,{markdownDescription:u.localize(182,null)})),find:ye(new E),fixedOverflowWidgets:ye(new g(36,"fixedOverflowWidgets",!1)),folding:ye(new g(37,"folding",!0,{description:u.localize(183,null)})),foldingStrategy:ye(new l(38,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[u.localize(184,null),u.localize(185,null)],description:u.localize(186,null)})),foldingHighlight:ye(new g(39,"foldingHighlight",!0,{description:u.localize(187,null)})),foldingImportsByDefault:ye(new g(40,"foldingImportsByDefault",!1,{description:u.localize(188,null)})),unfoldOnClickAfterEndOfLine:ye(new g(41,"unfoldOnClickAfterEndOfLine",!1,{description:u.localize(189,null)})),fontFamily:ye(new D(42,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:u.localize(190,null)})),fontInfo:ye(new P),fontLigatures2:ye(new R),fontSize:ye(new z),fontWeight:ye(new O),formatOnPaste:ye(new g(47,"formatOnPaste",!1,{description:u.localize(191,null)})),formatOnType:ye(new g(48,"formatOnType",!1,{description:u.localize(192,null)})),glyphMargin:ye(new g(49,"glyphMargin",!0,{description:u.localize(193,null)})),gotoLocation:ye(new S),hideCursorInOverviewRuler:ye(new g(51,"hideCursorInOverviewRuler",!1,{description:u.localize(194,null)})),hover:ye(new x),inDiffEditor:ye(new g(53,"inDiffEditor",!1)),letterSpacing:ye(new p(55,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,q=>p.clamp(q,-5,20),{description:u.localize(195,null)})),lightbulb:ye(new B),lineDecorationsWidth:ye(new _(57,"lineDecorationsWidth",10)),lineHeight:ye(new J),lineNumbers:ye(new Le),lineNumbersMinChars:ye(new c(60,"lineNumbersMinChars",5,1,300)),linkedEditing:ye(new g(61,"linkedEditing",!1,{description:u.localize(196,null)})),links:ye(new g(62,"links",!0,{description:u.localize(197,null)})),matchBrackets:ye(new l(63,"matchBrackets","always",["always","near","never"],{description:u.localize(198,null)})),minimap:ye(new j),mouseStyle:ye(new l(65,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:ye(new p(66,"mouseWheelScrollSensitivity",1,q=>q===0?1:q,{markdownDescription:u.localize(199,null)})),mouseWheelZoom:ye(new g(67,"mouseWheelZoom",!1,{markdownDescription:u.localize(200,null)})),multiCursorMergeOverlapping:ye(new g(68,"multiCursorMergeOverlapping",!0,{description:u.localize(201,null)})),multiCursorModifier:ye(new h(69,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Q,{markdownEnumDescriptions:[u.localize(202,null),u.localize(203,null)],markdownDescription:u.localize(204,null)})),multiCursorPaste:ye(new l(70,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[u.localize(205,null),u.localize(206,null)],markdownDescription:u.localize(207,null)})),occurrencesHighlight:ye(new g(71,"occurrencesHighlight",!0,{description:u.localize(208,null)})),overviewRulerBorder:ye(new g(72,"overviewRulerBorder",!0,{description:u.localize(209,null)})),overviewRulerLanes:ye(new c(73,"overviewRulerLanes",3,0,3)),padding:ye(new le),parameterHints:ye(new be),peekWidgetDefaultFocus:ye(new l(76,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[u.localize(210,null),u.localize(211,null)],description:u.localize(212,null)})),definitionLinkOpensInPeek:ye(new g(77,"definitionLinkOpensInPeek",!1,{description:u.localize(213,null)})),quickSuggestions:ye(new Fe),quickSuggestionsDelay:ye(new c(79,"quickSuggestionsDelay",10,0,1073741824,{description:u.localize(214,null)})),readOnly:ye(new g(80,"readOnly",!1)),renameOnType:ye(new g(81,"renameOnType",!1,{description:u.localize(215,null),markdownDeprecationMessage:u.localize(216,null)})),renderControlCharacters:ye(new g(82,"renderControlCharacters",!0,{description:u.localize(217,null),restricted:!0})),renderFinalNewline:ye(new g(83,"renderFinalNewline",!0,{description:u.localize(218,null)})),renderLineHighlight:ye(new l(84,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",u.localize(219,null)],description:u.localize(220,null)})),renderLineHighlightOnlyWhenFocus:ye(new g(85,"renderLineHighlightOnlyWhenFocus",!1,{description:u.localize(221,null)})),renderValidationDecorations:ye(new l(86,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:ye(new l(87,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",u.localize(222,null),u.localize(223,null),u.localize(224,null),""],description:u.localize(225,null)})),revealHorizontalRightPadding:ye(new c(88,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:ye(new g(89,"roundedSelection",!0,{description:u.localize(226,null)})),rulers:ye(new Ye),scrollbar:ye(new Ke),scrollBeyondLastColumn:ye(new c(92,"scrollBeyondLastColumn",5,0,1073741824,{description:u.localize(227,null)})),scrollBeyondLastLine:ye(new g(93,"scrollBeyondLastLine",!0,{description:u.localize(228,null)})),scrollPredominantAxis:ye(new g(94,"scrollPredominantAxis",!0,{description:u.localize(229,null)})),selectionClipboard:ye(new g(95,"selectionClipboard",!0,{description:u.localize(230,null),included:M.isLinux})),selectionHighlight:ye(new g(96,"selectionHighlight",!0,{description:u.localize(231,null)})),selectOnLineNumbers:ye(new g(97,"selectOnLineNumbers",!0)),showFoldingControls:ye(new l(98,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[u.localize(232,null),u.localize(233,null)],description:u.localize(234,null)})),showUnused:ye(new g(99,"showUnused",!0,{description:u.localize(235,null)})),showDeprecated:ye(new g(124,"showDeprecated",!0,{description:u.localize(236,null)})),inlayHints:ye(new $),snippetSuggestions:ye(new l(100,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[u.localize(237,null),u.localize(238,null),u.localize(239,null),u.localize(240,null)],description:u.localize(241,null)})),smartSelect:ye(new te),smoothScrolling:ye(new g(102,"smoothScrolling",!1,{description:u.localize(242,null)})),stopRenderingLineAfter:ye(new c(104,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:ye(new G),inlineSuggest:ye(new W),suggestFontSize:ye(new c(106,"suggestFontSize",0,0,1e3,{markdownDescription:u.localize(243,null)})),suggestLineHeight:ye(new c(107,"suggestLineHeight",0,0,1e3,{markdownDescription:u.localize(244,null)})),suggestOnTriggerCharacters:ye(new g(108,"suggestOnTriggerCharacters",!0,{description:u.localize(245,null)})),suggestSelection:ye(new l(109,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[u.localize(246,null),u.localize(247,null),u.localize(248,null)],description:u.localize(249,null)})),tabCompletion:ye(new l(110,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[u.localize(250,null),u.localize(251,null),u.localize(252,null)],description:u.localize(253,null)})),tabIndex:ye(new c(111,"tabIndex",0,-1,1073741824)),unusualLineTerminators:ye(new l(112,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[u.localize(254,null),u.localize(255,null),u.localize(256,null)],description:u.localize(257,null)})),useShadowDOM:ye(new g(113,"useShadowDOM",!0)),useTabStops:ye(new g(114,"useTabStops",!0,{description:u.localize(258,null)})),wordSeparators:ye(new D(115,"wordSeparators",w.USUAL_WORD_SEPARATORS,{description:u.localize(259,null)})),wordWrap:ye(new l(116,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[u.localize(260,null),u.localize(261,null),u.localize(262,null),u.localize(263,null)],description:u.localize(264,null)})),wordWrapBreakAfterCharacters:ye(new D(117,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:ye(new D(118,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:ye(new c(119,"wordWrapColumn",80,1,1073741824,{markdownDescription:u.localize(265,null)})),wordWrapOverride1:ye(new l(120,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:ye(new l(121,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:ye(new h(122,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],Oe,{enumDescriptions:[u.localize(266,null),u.localize(267,null),u.localize(268,null),u.localize(269,null)],description:u.localize(270,null)})),wrappingStrategy:ye(new l(123,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[u.localize(271,null),u.localize(272,null)],description:u.localize(273,null)})),editorClassName:ye(new b),pixelRatio:ye(new de),tabFocusMode:ye(new he),layoutInfo:ye(new V),wrappingInfo:ye(new Be)}}),define(we[119],Ee([18,19]),function(re,e){return re.create("vs/platform/configuration/common/configurationRegistry",e)}),define(we[120],Ee([18,19]),function(re,e){return re.create("vs/platform/extensions/common/extensionValidator",e)}),define(we[121],Ee([18,19]),function(re,e){return re.create("vs/platform/files/common/files",e)}),define(we[122],Ee([18,19]),function(re,e){return re.create("vs/platform/markers/common/markers",e)}),define(we[123],Ee([18,19]),function(re,e){return re.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(we[124],Ee([18,19]),function(re,e){return re.create("vs/workbench/api/common/extHostExtensionService",e)}),define(we[125],Ee([18,19]),function(re,e){return re.create("vs/workbench/api/common/extHostProgress",e)}),define(we[126],Ee([18,19]),function(re,e){return re.create("vs/workbench/api/common/extHostStatusBar",e)}),define(we[127],Ee([18,19]),function(re,e){return re.create("vs/workbench/api/common/extHostTerminalService",e)}),define(we[128],Ee([18,19]),function(re,e){return re.create("vs/workbench/api/common/extHostTreeViews",e)}),define(we[129],Ee([18,19]),function(re,e){return re.create("vs/workbench/api/common/extHostWorkspace",e)}),define(we[130],Ee([18,19]),function(re,e){return re.create("vs/workbench/common/editor",e)}),define(we[131],Ee([18,19]),function(re,e){return re.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(we[132],Ee([18,19]),function(re,e){return re.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(we[133],Ee([18,19]),function(re,e){return re.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(we[134],Ee([18,19]),function(re,e){return re.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(we[135],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorResolution=e.EditorActivation=void 0;var u;(function(t){t[t.ACTIVATE=1]="ACTIVATE",t[t.RESTORE=2]="RESTORE",t[t.PRESERVE=3]="PRESERVE"})(u=e.EditorActivation||(e.EditorActivation={}));var M;(function(t){t[t.PICK=0]="PICK",t[t.DISABLED=1]="DISABLED",t[t.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(M=e.EditorResolution||(e.EditorResolution={}));var w;(function(t){t[t.API=0]="API",t[t.USER=1]="USER"})(w=e.EditorOpenContext||(e.EditorOpenContext={}));var A;(function(t){t[t.Center=0]="Center",t[t.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",t[t.NearTop=2]="NearTop",t[t.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(A=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(we[136],Ee([0,1,120]),function(re,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const M=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,w=/^-(\d{4})(\d{2})(\d{2})$/;function A(n){return n=n.trim(),n==="*"||M.test(n)}e.isValidVersionStr=A;function t(n){if(!A(n))return null;if(n=n.trim(),n==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let g=n.match(M);return g?{hasCaret:g[1]==="^",hasGreaterEquals:g[1]===">=",majorBase:g[2]==="x"?0:parseInt(g[2],10),majorMustEqual:g[2]!=="x",minorBase:g[4]==="x"?0:parseInt(g[4],10),minorMustEqual:g[4]!=="x",patchBase:g[6]==="x"?0:parseInt(g[6],10),patchMustEqual:g[6]!=="x",preRelease:g[8]||null}:null}e.parseVersion=t;function T(n){if(!n)return null;let g=n.majorBase,a=n.majorMustEqual,c=n.minorBase,p=n.minorMustEqual,D=n.patchBase,f=n.patchMustEqual;n.hasCaret&&(g===0||(p=!1),f=!1);let l=0;if(n.preRelease){const h=w.exec(n.preRelease);if(h){const[,y,s,I]=h;l=Date.UTC(Number(y),Number(s)-1,Number(I))}}return{majorBase:g,majorMustEqual:a,minorBase:c,minorMustEqual:p,patchBase:D,patchMustEqual:f,isMinimum:n.hasGreaterEquals,notBefore:l}}e.normalizeVersion=T;function C(n,g,a){let c;typeof n=="string"?c=T(t(n)):c=n;let p;g instanceof Date?p=g.getTime():typeof g=="string"&&(p=new Date(g).getTime());let D;if(typeof a=="string"?D=T(t(a)):D=a,!c||!D)return!1;let f=c.majorBase,l=c.minorBase,h=c.patchBase,y=D.majorBase,s=D.minorBase,I=D.patchBase,r=D.notBefore,i=D.majorMustEqual,v=D.minorMustEqual,m=D.patchMustEqual;return D.isMinimum?f>y?!0:f<y?!1:l>s?!0:l<s||p&&p<r?!1:h>=I:(f===1&&y===0&&(!i||!v||!m)&&(y=1,s=0,I=0,i=!0,v=!1,m=!1),f<y?!1:f>y?!i:l<s?!1:l>s?!v:h<I?!1:h>I?!m:!(p&&p<r))}e.isValidVersion=C;function k(n,g,a,c){return a.isBuiltin||typeof a.main=="undefined"?!0:_(n,g,a.engines.vscode,c)}e.isValidExtensionVersion=k;function F(n,g,a){return n==="*"||_(g,a,n)}e.isEngineValid=F;function _(n,g,a,c=[]){let p=T(t(a));if(!p)return c.push(u.localize(0,null,a)),!1;if(p.majorBase===0){if(!p.majorMustEqual||!p.minorMustEqual)return c.push(u.localize(1,null,a)),!1}else if(!p.majorMustEqual)return c.push(u.localize(2,null,a)),!1;return C(n,g,p)?!0:(c.push(u.localize(3,null,n,a)),!1)}}),define(we[82],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class u{constructor(w,A=[],t=!1){this.ctor=w,this.staticArguments=A,this.supportsDelayedInstantiation=t}}e.SyncDescriptor=u}),define(we[57],Ee([0,1,82]),function(re,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const M=[];function w(t,T,C){T instanceof u.SyncDescriptor||(T=new u.SyncDescriptor(T,[],C)),M.push([t,T])}e.registerSingleton=w;function A(){return M}e.getSingletonServiceDescriptors=A}),define(we[137],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class u{constructor(A){this.incoming=new Map,this.outgoing=new Map,this.data=A}}e.Node=u;class M{constructor(A){this._hashFn=A,this._nodes=new Map}roots(){const A=[];for(let t of this._nodes.values())t.outgoing.size===0&&A.push(t);return A}insertEdge(A,t){const T=this.lookupOrInsertNode(A),C=this.lookupOrInsertNode(t);T.outgoing.set(this._hashFn(t),C),C.incoming.set(this._hashFn(A),T)}removeNode(A){const t=this._hashFn(A);this._nodes.delete(t);for(let T of this._nodes.values())T.outgoing.delete(t),T.incoming.delete(t)}lookupOrInsertNode(A){const t=this._hashFn(A);let T=this._nodes.get(t);return T||(T=new u(A),this._nodes.set(t,T)),T}lookup(A){return this._nodes.get(this._hashFn(A))}isEmpty(){return this._nodes.size===0}toString(){let A=[];for(let[t,T]of this._nodes)A.push(`${t}, (incoming)[${[...T.incoming.keys()].join(", ")}], (outgoing)[${[...T.outgoing.keys()].join(",")}]`);return A.join(`
`)}findCycleSlow(){for(let[A,t]of this._nodes){const T=new Set([A]),C=this._findCycle(t,T);if(C)return C}}_findCycle(A,t){for(let[T,C]of A.outgoing){if(t.has(T))return[...t,T].join(" -> ");t.add(T);const k=this._findCycle(C,t);if(k)return k;t.delete(T)}}}e.Graph=M}),define(we[4],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var u;(function(t){t.serviceIds=new Map,t.DI_TARGET="$di$target",t.DI_DEPENDENCIES="$di$dependencies";function T(C){return C[t.DI_DEPENDENCIES]||[]}t.getServiceDependencies=T})(u=e._util||(e._util={})),e.IInstantiationService=w("instantiationService");function M(t,T,C,k){T[u.DI_TARGET]===T?T[u.DI_DEPENDENCIES].push({id:t,index:C,optional:k}):(T[u.DI_DEPENDENCIES]=[{id:t,index:C,optional:k}],T[u.DI_TARGET]=T)}function w(t){if(u.serviceIds.has(t))return u.serviceIds.get(t);const T=function(C,k,F){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");M(T,C,F,!1)};return T.toString=()=>t,u.serviceIds.set(t,T),T}e.createDecorator=w;function A(t){return t}e.refineServiceDecorator=A}),define(we[138],Ee([0,1,4]),function(re,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,u.createDecorator)("modelService");function M(w){return!w.isTooLargeForSyncing()&&!w.isForSimpleWidget}e.shouldSynchronizeModel=M}),define(we[139],Ee([0,1,3,58,6,21,76,56,138]),function(re,e,u,M,w,A,t,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function k(c){return typeof c=="string"?!1:Array.isArray(c)?c.every(k):!!c.exclusive}class F{constructor(){this._clock=0,this._entries=[],this._onDidChange=new u.Emitter}get onDidChange(){return this._onDidChange.event}register(p,D){let f={selector:p,provider:D,_score:-1,_time:this._clock++};return this._entries.push(f),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,w.toDisposable)(()=>{if(f){let l=this._entries.indexOf(f);l>=0&&(this._entries.splice(l,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),f=void 0)}})}has(p){return this.all(p).length>0}all(p){if(!p)return[];this._updateScores(p);const D=[];for(let f of this._entries)f._score>0&&D.push(f.provider);return D}ordered(p){const D=[];return this._orderedForEach(p,f=>D.push(f.provider)),D}orderedGroups(p){const D=[];let f,l;return this._orderedForEach(p,h=>{f&&l===h._score?f.push(h.provider):(l=h._score,f=[h.provider],D.push(f))}),D}_orderedForEach(p,D){if(!!p){this._updateScores(p);for(const f of this._entries)f._score>0&&D(f)}}_updateScores(p){let D={uri:p.uri.toString(),language:p.getLanguageId()};if(!(this._lastCandidate&&this._lastCandidate.language===D.language&&this._lastCandidate.uri===D.uri)){this._lastCandidate=D;for(let f of this._entries)if(f._score=(0,T.score)(f.selector,p.uri,p.getLanguageId(),(0,C.shouldSynchronizeModel)(p)),k(f.selector)&&f._score>0){for(let l of this._entries)l._score=0;f._score=1e3;break}this._entries.sort(F._compareByScoreAndTime)}}static _compareByScoreAndTime(p,D){return p._score<D._score?1:p._score>D._score?-1:p._time<D._time?1:p._time>D._time?-1:0}}e.LanguageFeatureRegistry=F;const _=new WeakMap;let n=0;function g(c){let p=_.get(c);return p===void 0&&(p=++n,_.set(c,p)),p}class a{constructor(p,D,f=Number.MAX_SAFE_INTEGER){this._registry=p,this.min=D,this.max=f,this._cache=new A.LRUCache(50,.7)}_key(p){return p.id+this._registry.all(p).reduce((D,f)=>(0,M.doHash)(g(f),D),0)}_clamp(p){return p===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(p*1.3)))}get(p){const D=this._key(p),f=this._cache.get(D);return this._clamp(f?.value)}update(p,D){const f=this._key(p);let l=this._cache.get(f);return l||(l=new t.MovingAverage,this._cache.set(f,l)),l.update(D),this.get(p)}}e.LanguageFeatureRequestDelays=a}),define(we[59],Ee([0,1,2,43,139,112,54]),function(re,e,u,M,w,A,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.InlineCompletionsProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var T;(function(d){d[d.Null=0]="Null",d[d.PlainText=1]="PlainText"})(T=e.LanguageId||(e.LanguageId={}));var C;(function(d){d[d.NotSet=-1]="NotSet",d[d.None=0]="None",d[d.Italic=1]="Italic",d[d.Bold=2]="Bold",d[d.Underline=4]="Underline"})(C=e.FontStyle||(e.FontStyle={}));var k;(function(d){d[d.None=0]="None",d[d.DefaultForeground=1]="DefaultForeground",d[d.DefaultBackground=2]="DefaultBackground"})(k=e.ColorId||(e.ColorId={}));var F;(function(d){d[d.Other=0]="Other",d[d.Comment=1]="Comment",d[d.String=2]="String",d[d.RegEx=4]="RegEx"})(F=e.StandardTokenType||(e.StandardTokenType={}));var _;(function(d){d[d.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",d[d.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",d[d.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",d[d.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",d[d.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",d[d.ITALIC_MASK=2048]="ITALIC_MASK",d[d.BOLD_MASK=4096]="BOLD_MASK",d[d.UNDERLINE_MASK=8192]="UNDERLINE_MASK",d[d.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",d[d.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",d[d.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",d[d.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",d[d.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",d[d.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",d[d.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",d[d.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",d[d.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",d[d.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(_=e.MetadataConsts||(e.MetadataConsts={}));class n{static getLanguageId(E){return(E&255)>>>0}static getTokenType(E){return(E&1792)>>>8}static getFontStyle(E){return(E&14336)>>>11}static getForeground(E){return(E&8372224)>>>14}static getBackground(E){return(E&4286578688)>>>23}static getClassNameFromMetadata(E){let R=this.getForeground(E),P="mtk"+R,z=this.getFontStyle(E);return z&1&&(P+=" mtki"),z&2&&(P+=" mtkb"),z&4&&(P+=" mtku"),P}static getInlineStyleFromMetadata(E,R){const P=this.getForeground(E),z=this.getFontStyle(E);let O=`color: ${R[P]};`;return z&1&&(O+="font-style: italic;"),z&2&&(O+="font-weight: bold;"),z&4&&(O+="text-decoration: underline;"),O}}e.TokenMetadata=n;var g;(function(d){d[d.Method=0]="Method",d[d.Function=1]="Function",d[d.Constructor=2]="Constructor",d[d.Field=3]="Field",d[d.Variable=4]="Variable",d[d.Class=5]="Class",d[d.Struct=6]="Struct",d[d.Interface=7]="Interface",d[d.Module=8]="Module",d[d.Property=9]="Property",d[d.Event=10]="Event",d[d.Operator=11]="Operator",d[d.Unit=12]="Unit",d[d.Value=13]="Value",d[d.Constant=14]="Constant",d[d.Enum=15]="Enum",d[d.EnumMember=16]="EnumMember",d[d.Keyword=17]="Keyword",d[d.Text=18]="Text",d[d.Color=19]="Color",d[d.File=20]="File",d[d.Reference=21]="Reference",d[d.Customcolor=22]="Customcolor",d[d.Folder=23]="Folder",d[d.TypeParameter=24]="TypeParameter",d[d.User=25]="User",d[d.Issue=26]="Issue",d[d.Snippet=27]="Snippet"})(g=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let d=Object.create(null);return d[0]="symbol-method",d[1]="symbol-function",d[2]="symbol-constructor",d[3]="symbol-field",d[4]="symbol-variable",d[5]="symbol-class",d[6]="symbol-struct",d[7]="symbol-interface",d[8]="symbol-module",d[9]="symbol-property",d[10]="symbol-event",d[11]="symbol-operator",d[12]="symbol-unit",d[13]="symbol-value",d[14]="symbol-constant",d[15]="symbol-enum",d[16]="symbol-enum-member",d[17]="symbol-keyword",d[27]="symbol-snippet",d[18]="symbol-text",d[19]="symbol-color",d[20]="symbol-file",d[21]="symbol-reference",d[22]="symbol-customcolor",d[23]="symbol-folder",d[24]="symbol-type-parameter",d[25]="account",d[26]="issues",function(E){const R=d[E];let P=R&&t.iconRegistry.get(R);return P||(console.info("No codicon found for CompletionItemKind "+E),P=t.Codicon.symbolProperty),P.classNames}}(),e.completionKindFromString=function(){let d=Object.create(null);return d.method=0,d.function=1,d.constructor=2,d.field=3,d.variable=4,d.class=5,d.struct=6,d.interface=7,d.module=8,d.property=9,d.event=10,d.operator=11,d.unit=12,d.value=13,d.constant=14,d.enum=15,d["enum-member"]=16,d.enumMember=16,d.keyword=17,d.snippet=27,d.text=18,d.color=19,d.file=20,d.reference=21,d.customcolor=22,d.folder=23,d["type-parameter"]=24,d.typeParameter=24,d.account=25,d.issue=26,function(E,R){let P=d[E];return typeof P=="undefined"&&!R&&(P=9),P}}();var a;(function(d){d[d.Deprecated=1]="Deprecated"})(a=e.CompletionItemTag||(e.CompletionItemTag={}));var c;(function(d){d[d.KeepWhitespace=1]="KeepWhitespace",d[d.InsertAsSnippet=4]="InsertAsSnippet"})(c=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var p;(function(d){d[d.Invoke=0]="Invoke",d[d.TriggerCharacter=1]="TriggerCharacter",d[d.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(p=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var D;(function(d){d[d.Automatic=0]="Automatic",d[d.Explicit=1]="Explicit"})(D=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var f;(function(d){d[d.Invoke=1]="Invoke",d[d.Auto=2]="Auto"})(f=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var l;(function(d){d[d.Invoke=1]="Invoke",d[d.TriggerCharacter=2]="TriggerCharacter",d[d.ContentChange=3]="ContentChange"})(l=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var h;(function(d){d[d.Text=0]="Text",d[d.Read=1]="Read",d[d.Write=2]="Write"})(h=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function y(d){return d&&u.URI.isUri(d.uri)&&M.Range.isIRange(d.range)&&(M.Range.isIRange(d.originSelectionRange)||M.Range.isIRange(d.targetSelectionRange))}e.isLocationLink=y;var s;(function(d){d[d.File=0]="File",d[d.Module=1]="Module",d[d.Namespace=2]="Namespace",d[d.Package=3]="Package",d[d.Class=4]="Class",d[d.Method=5]="Method",d[d.Property=6]="Property",d[d.Field=7]="Field",d[d.Constructor=8]="Constructor",d[d.Enum=9]="Enum",d[d.Interface=10]="Interface",d[d.Function=11]="Function",d[d.Variable=12]="Variable",d[d.Constant=13]="Constant",d[d.String=14]="String",d[d.Number=15]="Number",d[d.Boolean=16]="Boolean",d[d.Array=17]="Array",d[d.Object=18]="Object",d[d.Key=19]="Key",d[d.Null=20]="Null",d[d.EnumMember=21]="EnumMember",d[d.Struct=22]="Struct",d[d.Event=23]="Event",d[d.Operator=24]="Operator",d[d.TypeParameter=25]="TypeParameter"})(s=e.SymbolKind||(e.SymbolKind={}));var I;(function(d){d[d.Deprecated=1]="Deprecated"})(I=e.SymbolTag||(e.SymbolTag={}));var r;(function(d){const E=new Map;E.set("file",0),E.set("module",1),E.set("namespace",2),E.set("package",3),E.set("class",4),E.set("method",5),E.set("property",6),E.set("field",7),E.set("constructor",8),E.set("enum",9),E.set("interface",10),E.set("function",11),E.set("variable",12),E.set("constant",13),E.set("string",14),E.set("number",15),E.set("boolean",16),E.set("array",17),E.set("object",18),E.set("key",19),E.set("null",20),E.set("enum-member",21),E.set("struct",22),E.set("event",23),E.set("operator",24),E.set("type-parameter",25);const R=new Map;R.set(0,"file"),R.set(1,"module"),R.set(2,"namespace"),R.set(3,"package"),R.set(4,"class"),R.set(5,"method"),R.set(6,"property"),R.set(7,"field"),R.set(8,"constructor"),R.set(9,"enum"),R.set(10,"interface"),R.set(11,"function"),R.set(12,"variable"),R.set(13,"constant"),R.set(14,"string"),R.set(15,"number"),R.set(16,"boolean"),R.set(17,"array"),R.set(18,"object"),R.set(19,"key"),R.set(20,"null"),R.set(21,"enum-member"),R.set(22,"struct"),R.set(23,"event"),R.set(24,"operator"),R.set(25,"type-parameter");function P(S){return E.get(S)}d.fromString=P;function z(S){return R.get(S)}d.toString=z;function O(S,x){const N=R.get(S);let V=N&&t.iconRegistry.get("symbol-"+N);return V||(console.info("No codicon found for SymbolKind "+S),V=t.Codicon.symbolProperty),`${x?"inline":"block"} ${V.classNames}`}d.toCssClassName=O})(r=e.SymbolKinds||(e.SymbolKinds={}));class i{constructor(E){this.value=E}}e.FoldingRangeKind=i,i.Comment=new i("comment"),i.Imports=new i("imports"),i.Region=new i("region");var v;(function(d){d[d.Collapsed=0]="Collapsed",d[d.Expanded=1]="Expanded"})(v=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var m;(function(d){d[d.Editing=0]="Editing",d[d.Preview=1]="Preview"})(m=e.CommentMode||(e.CommentMode={}));var o;(function(d){d[d.Other=0]="Other",d[d.Type=1]="Type",d[d.Parameter=2]="Parameter"})(o=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new w.LanguageFeatureRegistry,e.RenameProviderRegistry=new w.LanguageFeatureRegistry,e.CompletionProviderRegistry=new w.LanguageFeatureRegistry,e.InlineCompletionsProviderRegistry=new w.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new w.LanguageFeatureRegistry,e.HoverProviderRegistry=new w.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new w.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new w.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new w.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new w.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new w.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new w.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new w.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new w.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new w.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new w.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new w.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new w.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new w.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new w.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new w.LanguageFeatureRegistry,e.LinkProviderRegistry=new w.LanguageFeatureRegistry,e.ColorProviderRegistry=new w.LanguageFeatureRegistry,e.SelectionRangeRegistry=new w.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new w.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new w.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new w.LanguageFeatureRegistry,e.TokenizationRegistry=new A.TokenizationRegistryImpl;var b;(function(d){d[d.None=0]="None",d[d.Option=1]="Option",d[d.Default=2]="Default",d[d.Preferred=3]="Preferred"})(b=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(we[45],Ee([0,1,24,9,4]),function(re,e,u,M,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let A=u.userAgent||"";const t=new Map;t.set("false",!1),t.set("true",!0),t.set("isMac",u.isMacintosh),t.set("isLinux",u.isLinux),t.set("isWindows",u.isWindows),t.set("isWeb",u.isWeb),t.set("isMacNative",u.isMacintosh&&!u.isWeb),t.set("isEdge",A.indexOf("Edg/")>=0),t.set("isFirefox",A.indexOf("Firefox")>=0),t.set("isChrome",A.indexOf("Chrome")>=0),t.set("isSafari",A.indexOf("Safari")>=0);const T=Object.prototype.hasOwnProperty;var C;(function(O){O[O.False=0]="False",O[O.True=1]="True",O[O.Defined=2]="Defined",O[O.Not=3]="Not",O[O.Equals=4]="Equals",O[O.NotEquals=5]="NotEquals",O[O.And=6]="And",O[O.Regex=7]="Regex",O[O.NotRegex=8]="NotRegex",O[O.Or=9]="Or",O[O.In=10]="In",O[O.NotIn=11]="NotIn",O[O.Greater=12]="Greater",O[O.GreaterEquals=13]="GreaterEquals",O[O.Smaller=14]="Smaller",O[O.SmallerEquals=15]="SmallerEquals"})(C=e.ContextKeyExprType||(e.ContextKeyExprType={}));class k{static false(){return n.INSTANCE}static true(){return g.INSTANCE}static has(S){return a.create(S)}static equals(S,x){return c.create(S,x)}static notEquals(S,x){return f.create(S,x)}static regex(S,x){return i.create(S,x)}static in(S,x){return p.create(S,x)}static not(S){return l.create(S)}static and(...S){return o.create(S,null)}static or(...S){return b.create(S,null,!0)}static greater(S,x){return y.create(S,x)}static greaterEquals(S,x){return s.create(S,x)}static smaller(S,x){return I.create(S,x)}static smallerEquals(S,x){return r.create(S,x)}static deserialize(S,x=!1){if(!!S)return this._deserializeOrExpression(S,x)}static _deserializeOrExpression(S,x){let N=S.split("||");return b.create(N.map(V=>this._deserializeAndExpression(V,x)),null,!0)}static _deserializeAndExpression(S,x){let N=S.split("&&");return o.create(N.map(V=>this._deserializeOne(V,x)),null)}static _deserializeOne(S,x){if(S=S.trim(),S.indexOf("!=")>=0){let N=S.split("!=");return f.create(N[0].trim(),this._deserializeValue(N[1],x))}if(S.indexOf("==")>=0){let N=S.split("==");return c.create(N[0].trim(),this._deserializeValue(N[1],x))}if(S.indexOf("=~")>=0){let N=S.split("=~");return i.create(N[0].trim(),this._deserializeRegexValue(N[1],x))}if(S.indexOf(" in ")>=0){let N=S.split(" in ");return p.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(S)){const N=S.split(">=");return s.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(S)){const N=S.split(">");return y.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(S)){const N=S.split("<=");return r.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(S)){const N=S.split("<");return I.create(N[0].trim(),N[1].trim())}return/^\!\s*/.test(S)?l.create(S.substr(1).trim()):a.create(S)}static _deserializeValue(S,x){if(S=S.trim(),S==="true")return!0;if(S==="false")return!1;let N=/^'([^']*)'$/.exec(S);return N?N[1].trim():S}static _deserializeRegexValue(S,x){if((0,M.isFalsyOrWhitespace)(S)){if(x)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let N=S.indexOf("/"),V=S.lastIndexOf("/");if(N===V||N<0){if(x)throw new Error(`bad regexp-value '${S}', missing /-enclosure`);return console.warn(`bad regexp-value '${S}', missing /-enclosure`),null}let B=S.slice(N+1,V),$=S[V+1]==="i"?"i":"";try{return new RegExp(B,$)}catch(J){if(x)throw new Error(`bad regexp-value '${S}', parse error: ${J}`);return console.warn(`bad regexp-value '${S}', parse error: ${J}`),null}}}e.ContextKeyExpr=k;function F(O,S){const x=O?O.substituteConstants():void 0,N=S?S.substituteConstants():void 0;return!x&&!N?!0:!x||!N?!1:x.equals(N)}e.expressionsAreEqualWithConstantSubstitution=F;function _(O,S){return O.cmp(S)}class n{constructor(){this.type=0}cmp(S){return this.type-S.type}equals(S){return S.type===this.type}substituteConstants(){return this}evaluate(S){return!1}serialize(){return"false"}keys(){return[]}map(S){return this}negate(){return g.INSTANCE}}e.ContextKeyFalseExpr=n,n.INSTANCE=new n;class g{constructor(){this.type=1}cmp(S){return this.type-S.type}equals(S){return S.type===this.type}substituteConstants(){return this}evaluate(S){return!0}serialize(){return"true"}keys(){return[]}map(S){return this}negate(){return n.INSTANCE}}e.ContextKeyTrueExpr=g,g.INSTANCE=new g;class a{constructor(S,x){this.key=S,this.negated=x,this.type=2}static create(S,x=null){const N=t.get(S);return typeof N=="boolean"?N?g.INSTANCE:n.INSTANCE:new a(S,x)}cmp(S){return S.type!==this.type?this.type-S.type:E(this.key,S.key)}equals(S){return S.type===this.type?this.key===S.key:!1}substituteConstants(){const S=t.get(this.key);return typeof S=="boolean"?S?g.INSTANCE:n.INSTANCE:this}evaluate(S){return!!S.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(S){return S.mapDefined(this.key)}negate(){return this.negated||(this.negated=l.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=a;class c{constructor(S,x,N){this.key=S,this.value=x,this.negated=N,this.type=4}static create(S,x,N=null){if(typeof x=="boolean")return x?a.create(S,N):l.create(S,N);const V=t.get(S);return typeof V=="boolean"?x===(V?"true":"false")?g.INSTANCE:n.INSTANCE:new c(S,x,N)}cmp(S){return S.type!==this.type?this.type-S.type:R(this.key,this.value,S.key,S.value)}equals(S){return S.type===this.type?this.key===S.key&&this.value===S.value:!1}substituteConstants(){const S=t.get(this.key);if(typeof S=="boolean"){const x=S?"true":"false";return this.value===x?g.INSTANCE:n.INSTANCE}return this}evaluate(S){return S.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(S){return S.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=f.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=c;class p{constructor(S,x){this.key=S,this.valueKey=x,this.type=10,this.negated=null}static create(S,x){return new p(S,x)}cmp(S){return S.type!==this.type?this.type-S.type:R(this.key,this.valueKey,S.key,S.valueKey)}equals(S){return S.type===this.type?this.key===S.key&&this.valueKey===S.valueKey:!1}substituteConstants(){return this}evaluate(S){const x=S.getValue(this.valueKey),N=S.getValue(this.key);return Array.isArray(x)?x.indexOf(N)>=0:typeof N=="string"&&typeof x=="object"&&x!==null?T.call(x,N):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(S){return S.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=D.create(this)),this.negated}}e.ContextKeyInExpr=p;class D{constructor(S){this._actual=S,this.type=11}static create(S){return new D(S)}cmp(S){return S.type!==this.type?this.type-S.type:this._actual.cmp(S._actual)}equals(S){return S.type===this.type?this._actual.equals(S._actual):!1}substituteConstants(){return this}evaluate(S){return!this._actual.evaluate(S)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(S){return new D(this._actual.map(S))}negate(){return this._actual}}e.ContextKeyNotInExpr=D;class f{constructor(S,x,N){this.key=S,this.value=x,this.negated=N,this.type=5}static create(S,x,N=null){if(typeof x=="boolean")return x?l.create(S,N):a.create(S,N);const V=t.get(S);return typeof V=="boolean"?x===(V?"true":"false")?n.INSTANCE:g.INSTANCE:new f(S,x,N)}cmp(S){return S.type!==this.type?this.type-S.type:R(this.key,this.value,S.key,S.value)}equals(S){return S.type===this.type?this.key===S.key&&this.value===S.value:!1}substituteConstants(){const S=t.get(this.key);if(typeof S=="boolean"){const x=S?"true":"false";return this.value===x?n.INSTANCE:g.INSTANCE}return this}evaluate(S){return S.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(S){return S.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=c.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=f;class l{constructor(S,x){this.key=S,this.negated=x,this.type=3}static create(S,x=null){const N=t.get(S);return typeof N=="boolean"?N?n.INSTANCE:g.INSTANCE:new l(S,x)}cmp(S){return S.type!==this.type?this.type-S.type:E(this.key,S.key)}equals(S){return S.type===this.type?this.key===S.key:!1}substituteConstants(){const S=t.get(this.key);return typeof S=="boolean"?S?n.INSTANCE:g.INSTANCE:this}evaluate(S){return!S.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(S){return S.mapNot(this.key)}negate(){return this.negated||(this.negated=a.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=l;function h(O,S){if(typeof O=="string"){const x=parseFloat(O);isNaN(x)||(O=x)}return typeof O=="string"||typeof O=="number"?S(O):n.INSTANCE}class y{constructor(S,x,N){this.key=S,this.value=x,this.negated=N,this.type=12}static create(S,x,N=null){return h(x,V=>new y(S,V,N))}cmp(S){return S.type!==this.type?this.type-S.type:R(this.key,this.value,S.key,S.value)}equals(S){return S.type===this.type?this.key===S.key&&this.value===S.value:!1}substituteConstants(){return this}evaluate(S){return typeof this.value=="string"?!1:parseFloat(S.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(S){return S.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=r.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=y;class s{constructor(S,x,N){this.key=S,this.value=x,this.negated=N,this.type=13}static create(S,x,N=null){return h(x,V=>new s(S,V,N))}cmp(S){return S.type!==this.type?this.type-S.type:R(this.key,this.value,S.key,S.value)}equals(S){return S.type===this.type?this.key===S.key&&this.value===S.value:!1}substituteConstants(){return this}evaluate(S){return typeof this.value=="string"?!1:parseFloat(S.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(S){return S.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=I.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=s;class I{constructor(S,x,N){this.key=S,this.value=x,this.negated=N,this.type=14}static create(S,x,N=null){return h(x,V=>new I(S,V,N))}cmp(S){return S.type!==this.type?this.type-S.type:R(this.key,this.value,S.key,S.value)}equals(S){return S.type===this.type?this.key===S.key&&this.value===S.value:!1}substituteConstants(){return this}evaluate(S){return typeof this.value=="string"?!1:parseFloat(S.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(S){return S.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=s.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=I;class r{constructor(S,x,N){this.key=S,this.value=x,this.negated=N,this.type=15}static create(S,x,N=null){return h(x,V=>new r(S,V,N))}cmp(S){return S.type!==this.type?this.type-S.type:R(this.key,this.value,S.key,S.value)}equals(S){return S.type===this.type?this.key===S.key&&this.value===S.value:!1}substituteConstants(){return this}evaluate(S){return typeof this.value=="string"?!1:parseFloat(S.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(S){return S.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=y.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=r;class i{constructor(S,x){this.key=S,this.regexp=x,this.type=7,this.negated=null}static create(S,x){return new i(S,x)}cmp(S){if(S.type!==this.type)return this.type-S.type;if(this.key<S.key)return-1;if(this.key>S.key)return 1;const x=this.regexp?this.regexp.source:"",N=S.regexp?S.regexp.source:"";return x<N?-1:x>N?1:0}equals(S){if(S.type===this.type){const x=this.regexp?this.regexp.source:"",N=S.regexp?S.regexp.source:"";return this.key===S.key&&x===N}return!1}substituteConstants(){return this}evaluate(S){let x=S.getValue(this.key);return this.regexp?this.regexp.test(x):!1}serialize(){const S=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${S}`}keys(){return[this.key]}map(S){return S.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=v.create(this)),this.negated}}e.ContextKeyRegexExpr=i;class v{constructor(S){this._actual=S,this.type=8}static create(S){return new v(S)}cmp(S){return S.type!==this.type?this.type-S.type:this._actual.cmp(S._actual)}equals(S){return S.type===this.type?this._actual.equals(S._actual):!1}substituteConstants(){return this}evaluate(S){return!this._actual.evaluate(S)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(S){return new v(this._actual.map(S))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=v;function m(O){let S=null;for(let x=0,N=O.length;x<N;x++){const V=O[x].substituteConstants();if(O[x]!==V&&S===null){S=[];for(let B=0;B<x;B++)S[B]=O[B]}S!==null&&(S[x]=V)}return S===null?O:S}class o{constructor(S,x){this.expr=S,this.negated=x,this.type=6}static create(S,x){return o._normalizeArr(S,x)}cmp(S){if(S.type!==this.type)return this.type-S.type;if(this.expr.length<S.expr.length)return-1;if(this.expr.length>S.expr.length)return 1;for(let x=0,N=this.expr.length;x<N;x++){const V=_(this.expr[x],S.expr[x]);if(V!==0)return V}return 0}equals(S){if(S.type===this.type){if(this.expr.length!==S.expr.length)return!1;for(let x=0,N=this.expr.length;x<N;x++)if(!this.expr[x].equals(S.expr[x]))return!1;return!0}return!1}substituteConstants(){const S=m(this.expr);return S===this.expr?this:o.create(S,this.negated)}evaluate(S){for(let x=0,N=this.expr.length;x<N;x++)if(!this.expr[x].evaluate(S))return!1;return!0}static _normalizeArr(S,x){const N=[];let V=!1;for(const B of S)if(!!B){if(B.type===1){V=!0;continue}if(B.type===0)return n.INSTANCE;if(B.type===6){N.push(...B.expr);continue}N.push(B)}if(N.length===0&&V)return g.INSTANCE;if(N.length!==0){if(N.length===1)return N[0];N.sort(_);for(let B=1;B<N.length;B++)N[B-1].equals(N[B])&&(N.splice(B,1),B--);if(N.length===1)return N[0];for(;N.length>1;){const B=N[N.length-1];if(B.type!==9)break;N.pop();const $=N.pop(),J=N.length===0,j=b.create(B.expr.map(Q=>o.create([Q,$],null)),null,J);j&&(N.push(j),N.sort(_))}return N.length===1?N[0]:new o(N,x)}}serialize(){return this.expr.map(S=>S.serialize()).join(" && ")}keys(){const S=[];for(let x of this.expr)S.push(...x.keys());return S}map(S){return new o(this.expr.map(x=>x.map(S)),null)}negate(){if(!this.negated){const S=[];for(let x of this.expr)S.push(x.negate());this.negated=b.create(S,this,!0)}return this.negated}}class b{constructor(S,x){this.expr=S,this.negated=x,this.type=9}static create(S,x,N){return b._normalizeArr(S,x,N)}cmp(S){if(S.type!==this.type)return this.type-S.type;if(this.expr.length<S.expr.length)return-1;if(this.expr.length>S.expr.length)return 1;for(let x=0,N=this.expr.length;x<N;x++){const V=_(this.expr[x],S.expr[x]);if(V!==0)return V}return 0}equals(S){if(S.type===this.type){if(this.expr.length!==S.expr.length)return!1;for(let x=0,N=this.expr.length;x<N;x++)if(!this.expr[x].equals(S.expr[x]))return!1;return!0}return!1}substituteConstants(){const S=m(this.expr);return S===this.expr?this:b.create(S,this.negated,!1)}evaluate(S){for(let x=0,N=this.expr.length;x<N;x++)if(this.expr[x].evaluate(S))return!0;return!1}static _normalizeArr(S,x,N){let V=[],B=!1;if(S){for(let $=0,J=S.length;$<J;$++){const j=S[$];if(!!j){if(j.type===0){B=!0;continue}if(j.type===1)return g.INSTANCE;if(j.type===9){V=V.concat(j.expr);continue}V.push(j)}}if(V.length===0&&B)return n.INSTANCE;V.sort(_)}if(V.length!==0){if(V.length===1)return V[0];for(let $=1;$<V.length;$++)V[$-1].equals(V[$])&&(V.splice($,1),$--);if(V.length===1)return V[0];if(N){for(let $=0;$<V.length;$++)for(let J=$+1;J<V.length;J++)P(V[$],V[J])&&(V.splice(J,1),J--);if(V.length===1)return V[0]}return new b(V,x)}}serialize(){return this.expr.map(S=>S.serialize()).join(" || ")}keys(){const S=[];for(let x of this.expr)S.push(...x.keys());return S}map(S){return new b(this.expr.map(x=>x.map(S)),null)}negate(){if(!this.negated){let S=[];for(let x of this.expr)S.push(x.negate());for(;S.length>1;){const x=S.shift(),N=S.shift(),V=[];for(const $ of z(x))for(const J of z(N))V.push(o.create([$,J],null));const B=S.length===0;S.unshift(b.create(V,null,B))}this.negated=S[0]}return this.negated}}class d extends a{constructor(S,x,N){super(S,null);this._defaultValue=x,typeof N=="object"?d._info.push({...N,key:S}):N!==!0&&d._info.push({key:S,description:N,type:x!=null?typeof x:void 0})}static all(){return d._info.values()}bindTo(S){return S.createKey(this.key,this._defaultValue)}getValue(S){return S.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(S){return c.create(this.key,S)}notEqualsTo(S){return f.create(this.key,S)}}e.RawContextKey=d,d._info=[],e.IContextKeyService=(0,w.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function E(O,S){return O<S?-1:O>S?1:0}function R(O,S,x,N){return O<x?-1:O>x?1:S<N?-1:S>N?1:0}function P(O,S){if(S.type===6&&O.type!==9&&O.type!==6){for(const V of S.expr)if(O.equals(V))return!0}const x=O.negate(),N=z(x).concat(z(S));N.sort(_);for(let V=0;V<N.length;V++){const $=N[V].negate();for(let J=V+1;J<N.length;J++){const j=N[J];if($.equals(j))return!0}}return!1}e.implies=P;function z(O){return O.type===9?O.expr:[O]}}),define(we[140],Ee([0,1,4]),function(re,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,u.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,u.refineServiceDecorator)(e.IEnvironmentService)}),define(we[46],Ee([0,1,21,17,9,10,2,121,4]),function(re,e,u,M,w,A,t,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,C.createDecorator)("fileService");function k(N){return N.create===!0}e.isFileOpenForWriteOptions=k;var F;(function(N){N[N.Unknown=0]="Unknown",N[N.File=1]="File",N[N.Directory=2]="Directory",N[N.SymbolicLink=64]="SymbolicLink"})(F=e.FileType||(e.FileType={}));var _;(function(N){N[N.Readonly=1]="Readonly"})(_=e.FilePermission||(e.FilePermission={}));var n;(function(N){N[N.FileReadWrite=2]="FileReadWrite",N[N.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",N[N.FileReadStream=16]="FileReadStream",N[N.FileFolderCopy=8]="FileFolderCopy",N[N.PathCaseSensitive=1024]="PathCaseSensitive",N[N.Readonly=2048]="Readonly",N[N.Trash=4096]="Trash",N[N.FileWriteUnlock=8192]="FileWriteUnlock"})(n=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function g(N){return!!(N.capabilities&2)}e.hasReadWriteCapability=g;function a(N){return!!(N.capabilities&8)}e.hasFileFolderCopyCapability=a;function c(N){return!!(N.capabilities&4)}e.hasOpenReadWriteCloseCapability=c;function p(N){return!!(N.capabilities&16)}e.hasFileReadStreamCapability=p;var D;(function(N){N.FileExists="EntryExists",N.FileNotFound="EntryNotFound",N.FileNotADirectory="EntryNotADirectory",N.FileIsADirectory="EntryIsADirectory",N.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",N.FileTooLarge="EntryTooLarge",N.FileWriteLocked="EntryWriteLocked",N.NoPermissions="NoPermissions",N.Unavailable="Unavailable",N.Unknown="Unknown"})(D=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class f extends Error{constructor(V,B){super(V);this.code=B}}e.FileSystemProviderError=f;function l(N,V){const B=new f(N.toString(),V);return y(B,V),B}e.createFileSystemProviderError=l;function h(N){return N||l((0,T.localize)(0,null),D.Unknown)}e.ensureFileSystemProviderError=h;function y(N,V){return N.name=V?`${V} (FileSystemError)`:"FileSystemError",N}e.markAsFileSystemProviderError=y;function s(N){if(!N)return D.Unknown;if(N instanceof f)return N.code;const V=/^(.+) \(FileSystemError\)$/.exec(N.name);if(!V)return D.Unknown;switch(V[1]){case D.FileExists:return D.FileExists;case D.FileIsADirectory:return D.FileIsADirectory;case D.FileNotADirectory:return D.FileNotADirectory;case D.FileNotFound:return D.FileNotFound;case D.FileExceedsMemoryLimit:return D.FileExceedsMemoryLimit;case D.FileTooLarge:return D.FileTooLarge;case D.FileWriteLocked:return D.FileWriteLocked;case D.NoPermissions:return D.NoPermissions;case D.Unavailable:return D.Unavailable}return D.Unknown}e.toFileSystemProviderErrorCode=s;function I(N){if(N instanceof b)return N.fileOperationResult;switch(s(N)){case D.FileNotFound:return 1;case D.FileIsADirectory:return 0;case D.FileNotADirectory:return 10;case D.FileWriteLocked:return 5;case D.NoPermissions:return 6;case D.FileExists:return 4;case D.FileExceedsMemoryLimit:return 9;case D.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=I;var r;(function(N){N[N.CREATE=0]="CREATE",N[N.DELETE=1]="DELETE",N[N.MOVE=2]="MOVE",N[N.COPY=3]="COPY"})(r=e.FileOperation||(e.FileOperation={}));class i{constructor(V,B,$){this.resource=V,this.operation=B,this.target=$}isOperation(V){return this.operation===V}}e.FileOperationEvent=i;var v;(function(N){N[N.UPDATED=0]="UPDATED",N[N.ADDED=1]="ADDED",N[N.DELETED=2]="DELETED"})(v=e.FileChangeType||(e.FileChangeType={}));class m{constructor(V,B){this.added=void 0,this.updated=void 0,this.deleted=void 0;const $=new Map;for(const J of V){const j=$.get(J.type);j?j.push([J.resource,J]):$.set(J.type,[[J.resource,J]])}for(const[J,j]of $)switch(J){case 1:this.added=u.TernarySearchTree.forUris(()=>B),this.added.fill(j);break;case 0:this.updated=u.TernarySearchTree.forUris(()=>B),this.updated.fill(j);break;case 2:this.deleted=u.TernarySearchTree.forUris(()=>B),this.deleted.fill(j);break}}contains(V,...B){return this.doContains(V,{includeChildren:!1},...B)}affects(V,...B){return this.doContains(V,{includeChildren:!0},...B)}doContains(V,B,...$){if(!V)return!1;const J=$.length>0;return!!((!J||$.includes(1))&&(this.added?.get(V)||B.includeChildren&&this.added?.findSuperstr(V))||(!J||$.includes(0))&&(this.updated?.get(V)||B.includeChildren&&this.updated?.findSuperstr(V))||(!J||$.includes(2))&&(this.deleted?.findSubstr(V)||B.includeChildren&&this.deleted?.findSuperstr(V)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=m;function o(N,V,B){return!N||!V||N===V||V.length>N.length?!1:(V.charAt(V.length-1)!==M.sep&&(V+=M.sep),B?(0,w.startsWithIgnoreCase)(N,V):N.indexOf(V)===0)}e.isParent=o;class b extends Error{constructor(V,B,$){super(V);this.fileOperationResult=B,this.options=$}}e.FileOperationError=b;class d extends b{constructor(V,B,$){super(V,2,$);this.stat=B}}e.NotModifiedSinceFileOperationError=d;var E;(function(N){N[N.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",N[N.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",N[N.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",N[N.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",N[N.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",N[N.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",N[N.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",N[N.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",N[N.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",N[N.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",N[N.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",N[N.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(E=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var R;(function(N){N[N.FILE=0]="FILE",N[N.FOLDER=1]="FOLDER",N[N.ROOT_FOLDER=2]="ROOT_FOLDER"})(R=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function P(N){if(!(typeof N.size!="number"||typeof N.mtime!="number"))return N.mtime.toString(29)+N.size.toString(31)}e.etag=P;async function z(N,V){if(!V.hasProvider(t.URI.from({scheme:N.scheme})))return new Promise(B=>{const $=V.onDidChangeFileSystemProviderRegistrations(J=>{J.scheme===N.scheme&&J.added&&($.dispose(),B())})})}e.whenProviderRegistered=z,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class O{static formatSize(V){return(0,A.isNumber)(V)||(V=0),V<O.KB?(0,T.localize)(1,null,V.toFixed(0)):V<O.MB?(0,T.localize)(2,null,(V/O.KB).toFixed(2)):V<O.GB?(0,T.localize)(3,null,(V/O.MB).toFixed(2)):V<O.TB?(0,T.localize)(4,null,(V/O.GB).toFixed(2)):(0,T.localize)(5,null,(V/O.TB).toFixed(2))}}e.ByteSize=O,O.KB=1024,O.MB=O.KB*O.KB,O.GB=O.MB*O.KB,O.TB=O.GB*O.KB;var S;(function(N){N[N.IA32=0]="IA32",N[N.OTHER=1]="OTHER"})(S=e.Arch||(e.Arch={}));function x(N){return{maxFileSize:N===0?300*O.MB:16*O.GB,maxHeapSize:N===0?700*O.MB:2*700*O.MB}}e.getPlatformLimits=x}),define(we[60],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class u{constructor(...w){this._entries=new Map;for(let[A,t]of w)this.set(A,t)}set(w,A){const t=this._entries.get(w);return this._entries.set(w,A),t}has(w){return this._entries.has(w)}get(w){return this._entries.get(w)}}e.ServiceCollection=u}),define(we[141],Ee([0,1,14,15,82,137,4,60]),function(re,e,u,M,w,A,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const C=!1;class k extends Error{constructor(a){super("cyclic dependency between services");this.message=a.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${a.toString()}`}}class F{constructor(a=new T.ServiceCollection,c=!1,p){this._activeInstantiations=new Set,this._services=a,this._strict=c,this._parent=p,this._services.set(t.IInstantiationService,this)}createChild(a){return new F(a,this._strict,this)}invokeFunction(a,...c){let p=n.traceInvocation(a),D=!1;try{return a({get:l=>{if(D)throw(0,M.illegalState)("service accessor is only valid during the invocation of its target method");const h=this._getOrCreateServiceInstance(l,p);if(!h)throw new Error(`[invokeFunction] unknown service '${l}'`);return h}},...c)}finally{D=!0,p.stop()}}createInstance(a,...c){let p,D;return a instanceof w.SyncDescriptor?(p=n.traceCreation(a.ctor),D=this._createInstance(a.ctor,a.staticArguments.concat(c),p)):(p=n.traceCreation(a),D=this._createInstance(a,c,p)),p.stop(),D}_createInstance(a,c=[],p){let D=t._util.getServiceDependencies(a).sort((h,y)=>h.index-y.index),f=[];for(const h of D){let y=this._getOrCreateServiceInstance(h.id,p);if(!y&&this._strict&&!h.optional)throw new Error(`[createInstance] ${a.name} depends on UNKNOWN service ${h.id}.`);f.push(y)}let l=D.length>0?D[0].index:c.length;if(c.length!==l){console.warn(`[createInstance] First service dependency of ${a.name} at position ${l+1} conflicts with ${c.length} static arguments`);let h=l-c.length;h>0?c=c.concat(new Array(h)):c=c.slice(0,l)}return new a(...[...c,...f])}_setServiceInstance(a,c){if(this._services.get(a)instanceof w.SyncDescriptor)this._services.set(a,c);else if(this._parent)this._parent._setServiceInstance(a,c);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(a){let c=this._services.get(a);return!c&&this._parent?this._parent._getServiceInstanceOrDescriptor(a):c}_getOrCreateServiceInstance(a,c){let p=this._getServiceInstanceOrDescriptor(a);return p instanceof w.SyncDescriptor?this._safeCreateAndCacheServiceInstance(a,p,c.branch(a,!0)):(c.branch(a,!1),p)}_safeCreateAndCacheServiceInstance(a,c,p){if(this._activeInstantiations.has(a))throw new Error(`illegal state - RECURSIVELY instantiating service '${a}'`);this._activeInstantiations.add(a);try{return this._createAndCacheServiceInstance(a,c,p)}finally{this._activeInstantiations.delete(a)}}_createAndCacheServiceInstance(a,c,p){const D=new A.Graph(h=>h.id.toString());let f=0;const l=[{id:a,desc:c,_trace:p}];for(;l.length;){const h=l.pop();if(D.lookupOrInsertNode(h),f++>1e3)throw new k(D);for(let y of t._util.getServiceDependencies(h.desc.ctor)){let s=this._getServiceInstanceOrDescriptor(y.id);if(!s&&!y.optional&&console.warn(`[createInstance] ${a} depends on ${y.id} which is NOT registered.`),s instanceof w.SyncDescriptor){const I={id:y.id,desc:s,_trace:h._trace.branch(y.id,!0)};D.insertEdge(h,I),l.push(I)}}}for(;;){const h=D.roots();if(h.length===0){if(!D.isEmpty())throw new k(D);break}for(const{data:y}of h){if(this._getServiceInstanceOrDescriptor(y.id)instanceof w.SyncDescriptor){const I=this._createServiceInstanceWithOwner(y.id,y.desc.ctor,y.desc.staticArguments,y.desc.supportsDelayedInstantiation,y._trace);this._setServiceInstance(y.id,I)}D.removeNode(y)}}return this._getServiceInstanceOrDescriptor(a)}_createServiceInstanceWithOwner(a,c,p=[],D,f){if(this._services.get(a)instanceof w.SyncDescriptor)return this._createServiceInstance(c,p,D,f);if(this._parent)return this._parent._createServiceInstanceWithOwner(a,c,p,D,f);throw new Error(`illegalState - creating UNKNOWN service instance ${c.name}`)}_createServiceInstance(a,c=[],p,D){if(p){const f=new u.IdleValue(()=>this._createInstance(a,c,D));return new Proxy(Object.create(null),{get(l,h){if(h in l)return l[h];let y=f.value,s=y[h];return typeof s!="function"||(s=s.bind(y),l[h]=s),s},set(l,h,y){return f.value[h]=y,!0}})}else return this._createInstance(a,c,D)}}e.InstantiationService=F;var _;(function(g){g[g.Creation=0]="Creation",g[g.Invocation=1]="Invocation",g[g.Branch=2]="Branch"})(_||(_={}));class n{constructor(a,c){this.type=a,this.name=c,this._start=Date.now(),this._dep=[]}static traceInvocation(a){return C?new n(1,a.name||a.toString().substring(0,42).replace(/\n/g,"")):n._None}static traceCreation(a){return C?new n(0,a.name):n._None}branch(a,c){let p=new n(2,a.toString());return this._dep.push([a,c,p]),p}stop(){let a=Date.now()-this._start;n._totals+=a;let c=!1;function p(f,l){let h=[],y=new Array(f+1).join("	");for(const[s,I,r]of l._dep)if(I&&r){c=!0,h.push(`${y}CREATES -> ${s}`);let i=p(f+1,r);i&&h.push(i)}else h.push(`${y}uses -> ${s}`);return h.join(`
`)}let D=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${p(1,this)}`,`DONE, took ${a.toFixed(2)}ms (grand total ${n._totals.toFixed(2)}ms)`];(a>2||c)&&console.log(D.join(`
`))}}n._None=new class extends n{constructor(){super(-1,null)}stop(){}branch(){return this}},n._totals=0}),define(we[12],Ee([0,1,44,3,6,24,4]),function(re,e,u,M,w,A,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,t.createDecorator)("logService"),e.ILoggerService=(0,t.createDecorator)("loggerService");function T(){return new Date().toISOString()}var C;(function(I){I[I.Trace=0]="Trace",I[I.Debug=1]="Debug",I[I.Info=2]="Info",I[I.Warning=3]="Warning",I[I.Error=4]="Error",I[I.Critical=5]="Critical",I[I.Off=6]="Off"})(C=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=C.Info;function k(I,r,i){switch(r){case C.Trace:I.trace(i);break;case C.Debug:I.debug(i);break;case C.Info:I.info(i);break;case C.Warning:I.warn(i);break;case C.Error:I.error(i);break;case C.Critical:I.critical(i);break;default:throw new Error("Invalid log level")}}e.log=k;function F(I){let r="";for(let i=0;i<I.length;i++){let v=I[i];if(typeof v=="object")try{v=JSON.stringify(v)}catch(m){}r+=(i>0?" ":"")+v}return r}e.format=F;class _ extends w.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new M.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(r){this.level!==r&&(this.level=r,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=_;class n extends _{constructor(r){super();this.logAlways=r}checkLogLevel(r){return this.logAlways||this.getLevel()<=r}trace(r,...i){this.checkLogLevel(C.Trace)&&this.log(C.Trace,F([r,...i]))}debug(r,...i){this.checkLogLevel(C.Debug)&&this.log(C.Debug,F([r,...i]))}info(r,...i){this.checkLogLevel(C.Info)&&this.log(C.Info,F([r,...i]))}warn(r,...i){this.checkLogLevel(C.Warning)&&this.log(C.Warning,F([r,...i]))}error(r,...i){if(this.checkLogLevel(C.Error))if(r instanceof Error){const v=Array.prototype.slice.call(arguments);v[0]=r.stack,this.log(C.Error,F(v))}else this.log(C.Error,F([r,...i]))}critical(r,...i){this.checkLogLevel(C.Critical)&&this.log(C.Critical,F([r,...i]))}flush(){}}e.AbstractMessageLogger=n;class g extends _{constructor(r=e.DEFAULT_LOG_LEVEL){super();this.setLevel(r),this.useColors=!A.isWindows}trace(r,...i){this.getLevel()<=C.Trace&&(this.useColors?console.log(`[90m[main ${T()}][0m`,r,...i):console.log(`[main ${T()}]`,r,...i))}debug(r,...i){this.getLevel()<=C.Debug&&(this.useColors?console.log(`[90m[main ${T()}][0m`,r,...i):console.log(`[main ${T()}]`,r,...i))}info(r,...i){this.getLevel()<=C.Info&&(this.useColors?console.log(`[90m[main ${T()}][0m`,r,...i):console.log(`[main ${T()}]`,r,...i))}warn(r,...i){this.getLevel()<=C.Warning&&(this.useColors?console.warn(`[93m[main ${T()}][0m`,r,...i):console.warn(`[main ${T()}]`,r,...i))}error(r,...i){this.getLevel()<=C.Error&&(this.useColors?console.error(`[91m[main ${T()}][0m`,r,...i):console.error(`[main ${T()}]`,r,...i))}critical(r,...i){this.getLevel()<=C.Critical&&(this.useColors?console.error(`[90m[main ${T()}][0m`,r,...i):console.error(`[main ${T()}]`,r,...i))}dispose(){}flush(){}}e.ConsoleMainLogger=g;class a extends _{constructor(r=e.DEFAULT_LOG_LEVEL){super();this.setLevel(r)}trace(r,...i){this.getLevel()<=C.Trace&&console.log("%cTRACE","color: #888",r,...i)}debug(r,...i){this.getLevel()<=C.Debug&&console.log("%cDEBUG","background: #eee; color: #888",r,...i)}info(r,...i){this.getLevel()<=C.Info&&console.log("%c INFO","color: #33f",r,...i)}warn(r,...i){this.getLevel()<=C.Warning&&console.log("%c WARN","color: #993",r,...i)}error(r,...i){this.getLevel()<=C.Error&&console.log("%c  ERR","color: #f33",r,...i)}critical(r,...i){this.getLevel()<=C.Critical&&console.log("%cCRITI","background: #f33; color: white",r,...i)}dispose(){}flush(){}}e.ConsoleLogger=a;class c extends _{constructor(r,i=e.DEFAULT_LOG_LEVEL){super();this.adapter=r,this.setLevel(i)}trace(r,...i){this.getLevel()<=C.Trace&&this.adapter.log(C.Trace,[this.extractMessage(r),...i])}debug(r,...i){this.getLevel()<=C.Debug&&this.adapter.log(C.Debug,[this.extractMessage(r),...i])}info(r,...i){this.getLevel()<=C.Info&&this.adapter.log(C.Info,[this.extractMessage(r),...i])}warn(r,...i){this.getLevel()<=C.Warning&&this.adapter.log(C.Warning,[this.extractMessage(r),...i])}error(r,...i){this.getLevel()<=C.Error&&this.adapter.log(C.Error,[this.extractMessage(r),...i])}critical(r,...i){this.getLevel()<=C.Critical&&this.adapter.log(C.Critical,[this.extractMessage(r),...i])}extractMessage(r){return typeof r=="string"?r:(0,u.toErrorMessage)(r,this.getLevel()<=C.Trace)}dispose(){}flush(){}}e.AdapterLogger=c;class p extends _{constructor(r){super();this.logServices=r,r.length&&this.setLevel(r[0].getLevel())}setLevel(r){for(const i of this.logServices)i.setLevel(r);super.setLevel(r)}trace(r,...i){for(const v of this.logServices)v.trace(r,...i)}debug(r,...i){for(const v of this.logServices)v.debug(r,...i)}info(r,...i){for(const v of this.logServices)v.info(r,...i)}warn(r,...i){for(const v of this.logServices)v.warn(r,...i)}error(r,...i){for(const v of this.logServices)v.error(r,...i)}critical(r,...i){for(const v of this.logServices)v.critical(r,...i)}flush(){for(const r of this.logServices)r.flush()}dispose(){for(const r of this.logServices)r.dispose()}}e.MultiplexLogService=p;class D extends w.Disposable{constructor(r){super();this.logger=r,this._register(r)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(r){this.logger.setLevel(r)}getLevel(){return this.logger.getLevel()}trace(r,...i){this.logger.trace(r,...i)}debug(r,...i){this.logger.debug(r,...i)}info(r,...i){this.logger.info(r,...i)}warn(r,...i){this.logger.warn(r,...i)}error(r,...i){this.logger.error(r,...i)}critical(r,...i){this.logger.critical(r,...i)}flush(){this.logger.flush()}}e.LogService=D;class f extends w.Disposable{constructor(r,i){super();this.logLevel=r,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(i(v=>{this.logLevel=v,this.logLevelChangeableLoggers.forEach(m=>m.setLevel(v))}))}getLogger(r){return this.loggers.get(r.toString())}createLogger(r,i){let v=this.loggers.get(r.toString());return v||(v=this.doCreateLogger(r,i?.always?C.Trace:this.logLevel,i),this.loggers.set(r.toString(),v),i?.always||this.logLevelChangeableLoggers.push(v)),v}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(r=>r.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=f;class l{constructor(){this.onDidChangeLogLevel=new M.Emitter().event}setLevel(r){}getLevel(){return C.Info}trace(r,...i){}debug(r,...i){}info(r,...i){}warn(r,...i){}error(r,...i){}critical(r,...i){}dispose(){}flush(){}}e.NullLogService=l;function h(I){if(I.verbose)return C.Trace;if(typeof I.logLevel=="string"){const r=y(I.logLevel.toLowerCase());if(r!==void 0)return r}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=h;function y(I){switch(I){case"trace":return C.Trace;case"debug":return C.Debug;case"info":return C.Info;case"warn":return C.Warning;case"error":return C.Error;case"critical":return C.Critical;case"off":return C.Off}}e.parseLogLevel=y;function s(I){switch(I){case C.Trace:return"trace";case C.Debug:return"debug";case C.Info:return"info";case C.Warning:return"warn";case C.Error:return"error";case C.Critical:return"critical";case C.Off:return"off"}}e.LogLevelToString=s}),define(we[83],Ee([0,1,35,122,4]),function(re,e,u,M,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var A;(function(C){C[C.Unnecessary=1]="Unnecessary",C[C.Deprecated=2]="Deprecated"})(A=e.MarkerTag||(e.MarkerTag={}));var t;(function(C){C[C.Hint=1]="Hint",C[C.Info=2]="Info",C[C.Warning=4]="Warning",C[C.Error=8]="Error"})(t=e.MarkerSeverity||(e.MarkerSeverity={})),function(C){function k(a,c){return c-a}C.compare=k;const F=Object.create(null);F[C.Error]=(0,M.localize)(0,null),F[C.Warning]=(0,M.localize)(1,null),F[C.Info]=(0,M.localize)(2,null);function _(a){return F[a]||""}C.toString=_;function n(a){switch(a){case u.default.Error:return C.Error;case u.default.Warning:return C.Warning;case u.default.Info:return C.Info;case u.default.Ignore:return C.Hint}}C.fromSeverity=n;function g(a){switch(a){case C.Error:return u.default.Error;case C.Warning:return u.default.Warning;case C.Info:return u.default.Info;case C.Hint:return u.default.Ignore}}C.toSeverity=g}(t=e.MarkerSeverity||(e.MarkerSeverity={}));var T;(function(C){const k="";function F(n){return _(n,!0)}C.makeKey=F;function _(n,g){let a=[k];return n.source?a.push(n.source.replace("\xA6","\\\xA6")):a.push(k),n.code?typeof n.code=="string"?a.push(n.code.replace("\xA6","\\\xA6")):a.push(n.code.value.replace("\xA6","\\\xA6")):a.push(k),n.severity!==void 0&&n.severity!==null?a.push(t.toString(n.severity)):a.push(k),n.message&&g?a.push(n.message.replace("\xA6","\\\xA6")):a.push(k),n.startLineNumber!==void 0&&n.startLineNumber!==null?a.push(n.startLineNumber.toString()):a.push(k),n.startColumn!==void 0&&n.startColumn!==null?a.push(n.startColumn.toString()):a.push(k),n.endLineNumber!==void 0&&n.endLineNumber!==null?a.push(n.endLineNumber.toString()):a.push(k),n.endColumn!==void 0&&n.endColumn!==null?a.push(n.endColumn.toString()):a.push(k),a.push(k),a.join("\xA6")}C.makeKeyOptionalMessage=_})(T=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,w.createDecorator)("markerService")}),define(we[142],Ee([0,1,3,35,4]),function(re,e,u,M,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=M.default,e.INotificationService=(0,w.createDecorator)("notificationService");var A;(function(k){k[k.WORKSPACE=0]="WORKSPACE",k[k.GLOBAL=1]="GLOBAL"})(A=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var t;(function(k){k[k.OFF=0]="OFF",k[k.SILENT=1]="SILENT",k[k.ERROR=2]="ERROR"})(t=e.NotificationsFilter||(e.NotificationsFilter={}));class T{constructor(){this.progress=new C,this.onDidClose=u.Event.None,this.onDidChangeVisibility=u.Event.None}updateSeverity(F){}updateMessage(F){}updateActions(F){}close(){}}e.NoOpNotification=T;class C{infinite(){}done(){}total(F){}worked(F){}}e.NoOpProgress=C}),define(we[143],Ee([0,1,6,9,2,4]),function(re,e,u,M,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesSomeScheme=e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,A.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return u.Disposable.None},registerValidator(){return u.Disposable.None},registerExternalUriResolver(){return u.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return u.Disposable.None},async open(){return!1},async resolveExternalUri(C){return{resolved:C,dispose(){}}}});function t(C,k){return w.URI.isUri(C)?(0,M.equalsIgnoreCase)(C.scheme,k):(0,M.startsWithIgnoreCase)(C,k+":")}e.matchesScheme=t;function T(C,...k){return k.some(F=>t(C,F))}e.matchesSomeScheme=T});var Ne=this&&this.__decorate||function(re,e,u,M){var w=arguments.length,A=w<3?e:M===null?M=Object.getOwnPropertyDescriptor(e,u):M,t;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(re,e,u,M);else for(var T=re.length-1;T>=0;T--)(t=re[T])&&(A=(w<3?t(A):w>3?t(e,u,A):t(e,u))||A);return w>3&&A&&Object.defineProperty(e,u,A),A},xe=this&&this.__param||function(re,e){return function(u,M){e(u,M,re)}};define(we[144],Ee([0,1,14,20,6,4]),function(re,e,u,M,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,A.createDecorator)("progressService");var t;(function(F){F[F.Explorer=1]="Explorer",F[F.Scm=3]="Scm",F[F.Extensions=5]="Extensions",F[F.Window=10]="Window",F[F.Notification=15]="Notification",F[F.Dialog=20]="Dialog"})(t=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class T{constructor(_){this.callback=_}get value(){return this._value}report(_){this._value=_,this.callback(this._value)}}e.Progress=T,T.None=Object.freeze({report(){}});let C=class extends w.Disposable{constructor(_,n){super();this.deferred=new u.DeferredPromise,n.withProgress(_,g=>(this.reporter=g,this.lastStep&&g.report(this.lastStep),this.deferred.p)),this._register((0,w.toDisposable)(()=>this.deferred.complete()))}report(_){this.reporter?this.reporter.report(_):this.lastStep=_}};C=Ne([xe(1,e.IProgressService)],C),e.UnmanagedProgress=C;class k extends w.Disposable{constructor(_){super();this.progressIndicator=_,this.currentOperationId=0,this.currentOperationDisposables=this._register(new w.DisposableStore)}start(_){this.stop();const n=++this.currentOperationId,g=new M.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{n===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},_),this.currentOperationDisposables.add((0,w.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,w.toDisposable)(()=>g.cancel())),this.currentOperationDisposables.add((0,w.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:n,token:g.token,stop:()=>this.doStop(n),isCurrent:()=>this.currentOperationId===n}}stop(){this.doStop(this.currentOperationId)}doStop(_){this.currentOperationId===_&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=k,e.IEditorProgressService=(0,A.createDecorator)("editorProgressService")}),define(we[30],Ee([0,1,41,10]),function(re,e,u,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class w{constructor(){this.data=new Map}add(t,T){u.ok(M.isString(t)),u.ok(M.isObject(T)),u.ok(!this.data.has(t),"There is already an extension with this id"),this.data.set(t,T)}knows(t){return this.data.has(t)}as(t){return this.data.get(t)||null}}e.Registry=new w}),define(we[145],Ee([0,1,3,30]),function(re,e,u,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function w(T){return T.length>0&&T.charAt(T.length-1)==="#"?T.substring(0,T.length-1):T}class A{constructor(){this._onDidChangeSchema=new u.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(C,k){this.schemasById[w(C)]=k,this._onDidChangeSchema.fire(C)}notifySchemaChanged(C){this._onDidChangeSchema.fire(C)}getSchemaContributions(){return{schemas:this.schemasById}}}const t=new A;M.Registry.add(e.Extensions.JSONContribution,t)}),define(we[61],Ee([0,1,16,3,10,119,145,30]),function(re,e,u,M,w,A,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var C;(function(h){h.Multiline="multilineText",h.Singleline="singlelineText"})(C=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var k;(function(h){h[h.APPLICATION=1]="APPLICATION",h[h.MACHINE=2]="MACHINE",h[h.WINDOW=3]="WINDOW",h[h.RESOURCE=4]="RESOURCE",h[h.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",h[h.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(k=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const F=T.Registry.as(t.Extensions.JSONContribution);class _{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new M.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new M.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:A.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},F.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(y,s=!0){this.registerConfigurations([y],s)}registerConfigurations(y,s=!0){const I=this.doRegisterConfigurations(y,s);F.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(I)}deregisterConfigurations(y){const s=this.doDeregisterConfigurations(y);F.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(s)}updateConfigurations({add:y,remove:s}){const I=[];I.push(...this.doDeregisterConfigurations(s)),I.push(...this.doRegisterConfigurations(y,!1)),F.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire((0,u.distinct)(I))}registerDefaultConfigurations(y){const s=[],I=[];for(const r of y)for(const i in r)if(s.push(i),e.OVERRIDE_PROPERTY_REGEX.test(i)){this.defaultValues[i]={...this.defaultValues[i]||{},...r[i]};const v={type:"object",default:this.defaultValues[i],description:A.localize(1,null,i),$ref:e.resourceLanguageSettingsSchemaId};I.push(...a(i)),this.configurationProperties[i]=v,this.defaultLanguageConfigurationOverridesNode.properties[i]=v}else{this.defaultValues[i]=r[i];const v=this.configurationProperties[i];v&&(this.updatePropertyDefaultValue(i,v),this.updateSchema(i,v))}this.registerOverrideIdentifiers(I),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(s)}deregisterDefaultConfigurations(y){const s=[];for(const I of y)for(const r in I)if(s.push(r),delete this.defaultValues[r],e.OVERRIDE_PROPERTY_REGEX.test(r))delete this.configurationProperties[r],delete this.defaultLanguageConfigurationOverridesNode.properties[r];else{const i=this.configurationProperties[r];i&&(this.updatePropertyDefaultValue(r,i),this.updateSchema(r,i))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(s)}notifyConfigurationSchemaUpdated(...y){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(y){for(const s of y)this.overrideIdentifiers.add(s);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(y,s){const I=[];return y.forEach(r=>{I.push(...this.validateAndRegisterProperties(r,s,r.extensionInfo)),this.configurationContributors.push(r),this.registerJSONConfiguration(r)}),I}doDeregisterConfigurations(y){const s=[],I=r=>{if(r.properties)for(const i in r.properties)s.push(i),delete this.configurationProperties[i],this.removeFromSchema(i,r.properties[i]);r.allOf&&r.allOf.forEach(i=>I(i))};for(const r of y){I(r);const i=this.configurationContributors.indexOf(r);i!==-1&&this.configurationContributors.splice(i,1)}return s}validateAndRegisterProperties(y,s=!0,I,r=3){r=w.isUndefinedOrNull(y.scope)?r:y.scope;let i=[],v=y.properties;if(v)for(let o in v){if(s&&f(o)){delete v[o];continue}const b=v[o];if(this.updatePropertyDefaultValue(o,b),e.OVERRIDE_PROPERTY_REGEX.test(o)?b.scope=void 0:(b.scope=w.isUndefinedOrNull(b.scope)?r:b.scope,b.restricted=w.isUndefinedOrNull(b.restricted)?!!I?.restrictedConfigurations?.includes(o):b.restricted),v[o].hasOwnProperty("included")&&!v[o].included){this.excludedConfigurationProperties[o]=v[o],delete v[o];continue}else this.configurationProperties[o]=v[o];!v[o].deprecationMessage&&v[o].markdownDeprecationMessage&&(v[o].deprecationMessage=v[o].markdownDeprecationMessage),i.push(o)}let m=y.allOf;if(m)for(let o of m)i.push(...this.validateAndRegisterProperties(o,s,I,r));return i}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(y){const s=I=>{let r=I.properties;if(r)for(const v in r)this.updateSchema(v,r[v]);let i=I.allOf;i&&i.forEach(s)};s(y)}updateSchema(y,s){switch(e.allSettings.properties[y]=s,s.scope){case 1:e.applicationSettings.properties[y]=s;break;case 2:e.machineSettings.properties[y]=s;break;case 6:e.machineOverridableSettings.properties[y]=s;break;case 3:e.windowSettings.properties[y]=s;break;case 4:e.resourceSettings.properties[y]=s;break;case 5:e.resourceSettings.properties[y]=s,this.resourceLanguageSettingsSchema.properties[y]=s;break}}removeFromSchema(y,s){switch(delete e.allSettings.properties[y],s.scope){case 1:delete e.applicationSettings.properties[y];break;case 2:delete e.machineSettings.properties[y];break;case 6:delete e.machineOverridableSettings.properties[y];break;case 3:delete e.windowSettings.properties[y];break;case 4:case 5:delete e.resourceSettings.properties[y];break}}updateOverridePropertyPatternKey(){for(const y of this.overrideIdentifiers.values()){const s=`[${y}]`,I={type:"object",description:A.localize(2,null),errorMessage:A.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(s,I),e.allSettings.properties[s]=I,e.applicationSettings.properties[s]=I,e.machineSettings.properties[s]=I,e.machineOverridableSettings.properties[s]=I,e.windowSettings.properties[s]=I,e.resourceSettings.properties[s]=I}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const y={type:"object",description:A.localize(4,null),errorMessage:A.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=y,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=y,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=y,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=y,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=y,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=y,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(y,s){let I=this.defaultValues[y];w.isUndefined(I)&&(I=s.default),w.isUndefined(I)&&(I=p(s.type)),s.default=I}}const n="\\[([^\\]]+)\\]",g=new RegExp(n,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${n})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function a(h){const y=[];if(e.OVERRIDE_PROPERTY_REGEX.test(h)){let s=g.exec(h);for(;s?.length;){const I=s[1].trim();I&&y.push(I),s=g.exec(h)}}return(0,u.distinct)(y)}e.overrideIdentifiersFromKey=a;function c(h){return h.reduce((y,s)=>`${y}[${s}]`,"")}e.keyFromOverrideIdentifiers=c;function p(h){switch(Array.isArray(h)?h[0]:h){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=p;const D=new _;T.Registry.add(e.Extensions.Configuration,D);function f(h){return h.trim()?e.OVERRIDE_PROPERTY_REGEX.test(h)?A.localize(7,null,h):D.getConfigurationProperties()[h]!==void 0?A.localize(8,null,h):null:A.localize(6,null)}e.validateProperty=f;function l(){const h=[],y=D.getConfigurationProperties();for(const s of Object.keys(y))h.push([s,y[s].scope]);return h.push(["launch",4]),h.push(["task",4]),h}e.getScopes=l}),define(we[84],Ee([0,1,10,2,61,4,30]),function(re,e,u,M,w,A,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,A.createDecorator)("configurationService");function T(h){return h&&typeof h=="object"&&(!h.overrideIdentifier||typeof h.overrideIdentifier=="string")&&(!h.resource||h.resource instanceof M.URI)}e.isConfigurationOverrides=T;function C(h){return h&&typeof h=="object"&&(!h.overrideIdentifiers||u.isArray(h.overrideIdentifiers))&&!h.overrideIdentifier&&(!h.resource||h.resource instanceof M.URI)}e.isConfigurationUpdateOverrides=C;var k;(function(h){h[h.USER=1]="USER",h[h.USER_LOCAL=2]="USER_LOCAL",h[h.USER_REMOTE=3]="USER_REMOTE",h[h.WORKSPACE=4]="WORKSPACE",h[h.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",h[h.DEFAULT=6]="DEFAULT",h[h.MEMORY=7]="MEMORY"})(k=e.ConfigurationTarget||(e.ConfigurationTarget={}));function F(h){switch(h){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=F;function _(h,y){const s=Object.create(null);for(let I in h)n(s,I,h[I],y);return s}e.toValuesTree=_;function n(h,y,s,I){const r=y.split("."),i=r.pop();let v=h;for(let m=0;m<r.length;m++){let o=r[m],b=v[o];switch(typeof b){case"undefined":b=v[o]=Object.create(null);break;case"object":break;default:I(`Ignoring ${y} as ${r.slice(0,m+1).join(".")} is ${JSON.stringify(b)}`);return}v=b}if(typeof v=="object"&&v!==null)try{v[i]=s}catch(m){I(`Ignoring ${y} as ${r.join(".")} is ${JSON.stringify(v)}`)}else I(`Ignoring ${y} as ${r.join(".")} is ${JSON.stringify(v)}`)}e.addToValueTree=n;function g(h,y){const s=y.split(".");a(h,s)}e.removeFromValueTree=g;function a(h,y){const s=y.shift();if(y.length===0){delete h[s];return}if(Object.keys(h).indexOf(s)!==-1){const I=h[s];typeof I=="object"&&!Array.isArray(I)&&(a(I,y),Object.keys(I).length===0&&delete h[s])}}function c(h,y,s){function I(v,m){let o=v;for(const b of m){if(typeof o!="object"||o===null)return;o=o[b]}return o}const r=y.split("."),i=I(h,r);return typeof i=="undefined"?s:i}e.getConfigurationValue=c;function p(h,y,s){Object.keys(y).forEach(I=>{I!=="__proto__"&&(I in h?u.isObject(h[I])&&u.isObject(y[I])?p(h[I],y[I],s):s&&(h[I]=y[I]):h[I]=y[I])})}e.merge=p;function D(){const h=t.Registry.as(w.Extensions.Configuration).getConfigurationProperties();return Object.keys(h)}e.getConfigurationKeys=D;function f(){const h=Object.create(null),y=t.Registry.as(w.Extensions.Configuration).getConfigurationProperties();for(let s in y){let I=y[s].default;n(h,s,I,r=>console.error(`Conflict in default settings: ${r}`))}return h}e.getDefaultValues=f;function l(h,y,s){const I=h.inspect(y),r=h.inspect(s);return typeof I.userValue!="undefined"||typeof I.workspaceValue!="undefined"||typeof I.workspaceFolderValue!="undefined"?I.value:typeof r.userValue!="undefined"||typeof r.workspaceValue!="undefined"||typeof r.workspaceFolderValue!="undefined"?r.value:I.defaultValue}e.getMigratedSettingValue=l}),define(we[146],Ee([0,1,16,3,101,6,21,25,10,2,84,61,30]),function(re,e,u,M,w,A,t,T,C,k,F,_,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class g{constructor(r={},i=[],v=[]){this._contents=r,this._keys=i,this._overrides=v,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(r){return r?(0,F.getConfigurationValue)(this.contents,r):this.contents}getOverrideValue(r,i){const v=this.getContentsForOverrideIdentifer(i);return v?r?(0,F.getConfigurationValue)(v,r):v:void 0}getKeysForOverrideIdentifier(r){const i=[];for(const v of this.overrides)v.identifiers.includes(r)&&i.push(...v.keys);return u.distinct(i)}getAllOverrideIdentifiers(){const r=[];for(const i of this.overrides)r.push(...i.identifiers);return u.distinct(r)}override(r){let i=this.overrideConfigurations.get(r);return i||(i=this.createOverrideConfigurationModel(r),this.overrideConfigurations.set(r,i)),i}merge(...r){const i=T.deepClone(this.contents),v=T.deepClone(this.overrides),m=[...this.keys];for(const o of r){this.mergeContents(i,o.contents);for(const b of o.overrides){const[d]=v.filter(E=>u.equals(E.identifiers,b.identifiers));d?(this.mergeContents(d.contents,b.contents),d.keys.push(...b.keys),d.keys=u.distinct(d.keys)):v.push(T.deepClone(b))}for(const b of o.keys)m.indexOf(b)===-1&&m.push(b)}return new g(i,m,v)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(r){const i=this.getContentsForOverrideIdentifer(r);if(!i||typeof i!="object"||!Object.keys(i).length)return this;let v={};for(const m of u.distinct([...Object.keys(this.contents),...Object.keys(i)])){let o=this.contents[m],b=i[m];b&&(typeof o=="object"&&typeof b=="object"?(o=T.deepClone(o),this.mergeContents(o,b)):o=b),v[m]=o}return new g(v,this.keys,this.overrides)}mergeContents(r,i){for(const v of Object.keys(i)){if(v in r&&C.isObject(r[v])&&C.isObject(i[v])){this.mergeContents(r[v],i[v]);continue}r[v]=T.deepClone(i[v])}}checkAndFreeze(r){return this.isFrozen&&!Object.isFrozen(r)?T.deepFreeze(r):r}getContentsForOverrideIdentifer(r){let i=null,v=null;const m=o=>{o&&(v?this.mergeContents(v,o):v=T.deepClone(o))};for(const o of this.overrides)u.equals(o.identifiers,[r])?i=o.contents:o.identifiers.includes(r)&&m(o.contents);return m(i),v}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(r,i){this.addKey(r),(0,F.addToValueTree)(this.contents,r,i,v=>{throw new Error(v)})}removeValue(r){this.removeKey(r)&&(0,F.removeFromValueTree)(this.contents,r)}addKey(r){let i=this.keys.length;for(let v=0;v<i;v++)r.indexOf(this.keys[v])===0&&(i=v);this.keys.splice(i,1,r)}removeKey(r){let i=this.keys.indexOf(r);return i!==-1?(this.keys.splice(i,1),!0):!1}}e.ConfigurationModel=g;class a extends g{constructor(){const r=(0,F.getDefaultValues)(),i=(0,F.getConfigurationKeys)(),v=[];for(const m of Object.keys(r))_.OVERRIDE_PROPERTY_REGEX.test(m)&&v.push({identifiers:(0,_.overrideIdentifiersFromKey)(m),keys:Object.keys(r[m]),contents:(0,F.toValuesTree)(r[m],o=>console.error(`Conflict in default settings file: ${o}`))});super(r,i,v)}}e.DefaultConfigurationModel=a;class c{constructor(r){this._name=r,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new g}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(r,i){if(!C.isUndefinedOrNull(r)){const v=this.doParseContent(r);this.parseRaw(v,i)}}reparse(r){this._raw&&this.parseRaw(this._raw,r)}parseRaw(r,i){this._raw=r;const{contents:v,keys:m,overrides:o,restricted:b}=this.doParseRaw(r,i);this._configurationModel=new g(v,m,o),this._restrictedConfigurations=b||[]}doParseContent(r){let i={},v=null,m=[],o=[],b=[];function d(R){Array.isArray(m)?m.push(R):v!==null&&(m[v]=R)}let E={onObjectBegin:()=>{let R={};d(R),o.push(m),m=R,v=null},onObjectProperty:R=>{v=R},onObjectEnd:()=>{m=o.pop()},onArrayBegin:()=>{let R=[];d(R),o.push(m),m=R,v=null},onArrayEnd:()=>{m=o.pop()},onLiteralValue:d,onError:(R,P,z)=>{b.push({error:R,offset:P,length:z})}};if(r)try{w.visit(r,E),i=m[0]||{}}catch(R){console.error(`Error while parsing settings file ${this._name}: ${R}`),this._parseErrors=[R]}return i}doParseRaw(r,i){const v=n.Registry.as(_.Extensions.Configuration).getConfigurationProperties(),m=this.filter(r,v,!0,i);r=m.raw;const o=(0,F.toValuesTree)(r,E=>console.error(`Conflict in settings file ${this._name}: ${E}`)),b=Object.keys(r),d=this.toOverrides(r,E=>console.error(`Conflict in settings file ${this._name}: ${E}`));return{contents:o,keys:b,overrides:d,restricted:m.restricted}}filter(r,i,v,m){if(!m?.scopes&&!m?.skipRestricted)return{raw:r,restricted:[]};const o={},b=[];for(let d in r)if(_.OVERRIDE_PROPERTY_REGEX.test(d)&&v){const E=this.filter(r[d],i,!1,m);o[d]=E.raw,b.push(...E.restricted)}else{const E=i[d],R=E?typeof E.scope!="undefined"?E.scope:3:void 0;E?.restricted&&b.push(d),(R===void 0||m.scopes===void 0||m.scopes.includes(R))&&(m.skipRestricted&&E?.restricted||(o[d]=r[d]))}return{raw:o,restricted:b}}toOverrides(r,i){const v=[];for(const m of Object.keys(r))if(_.OVERRIDE_PROPERTY_REGEX.test(m)){const o={};for(const b in r[m])o[b]=r[m][b];v.push({identifiers:(0,_.overrideIdentifiersFromKey)(m),keys:Object.keys(o),contents:(0,F.toValuesTree)(o,i)})}return v}}e.ConfigurationModelParser=c;class p extends A.Disposable{constructor(r,i,v,m){super();this.userSettingsResource=r,this.scopes=i,this.fileService=m,this._onDidChange=this._register(new M.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new c(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(v.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(M.Event.filter(this.fileService.onDidFilesChange,o=>o.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const r=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(r.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(r){return new g}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=p;class D{constructor(r,i,v=new g,m=new g,o=new t.ResourceMap,b=new g,d=new t.ResourceMap,E=!0){this._defaultConfiguration=r,this._localUserConfiguration=i,this._remoteUserConfiguration=v,this._workspaceConfiguration=m,this._folderConfigurations=o,this._memoryConfiguration=b,this._memoryConfigurationByResource=d,this._freeze=E,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new t.ResourceMap,this._userConfiguration=null}getValue(r,i,v){return this.getConsolidateConfigurationModel(i,v).getValue(r)}updateValue(r,i,v={}){let m;v.resource?(m=this._memoryConfigurationByResource.get(v.resource),m||(m=new g,this._memoryConfigurationByResource.set(v.resource,m))):m=this._memoryConfiguration,i===void 0?m.removeValue(r):m.setValue(r,i),v.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(r,i,v){const m=this.getConsolidateConfigurationModel(i,v),o=this.getFolderConfigurationModelForResource(i.resource,v),b=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,d=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this._defaultConfiguration.freeze().getValue(r),E=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this.userConfiguration.freeze().getValue(r),R=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this.localUserConfiguration.freeze().getValue(r),P=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this.remoteUserConfiguration.freeze().getValue(r),z=v?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this._workspaceConfiguration.freeze().getValue(r):void 0,O=o?i.overrideIdentifier?o.freeze().override(i.overrideIdentifier).getValue(r):o.freeze().getValue(r):void 0,S=i.overrideIdentifier?b.override(i.overrideIdentifier).getValue(r):b.getValue(r),x=m.getValue(r),N=u.distinct(u.flatten(m.overrides.map(V=>V.identifiers))).filter(V=>m.getOverrideValue(r,V)!==void 0);return{defaultValue:d,userValue:E,userLocalValue:R,userRemoteValue:P,workspaceValue:z,workspaceFolderValue:O,memoryValue:S,value:x,default:d!==void 0?{value:this._defaultConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,user:E!==void 0?{value:this.userConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,userLocal:R!==void 0?{value:this.localUserConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,userRemote:P!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,workspace:z!==void 0?{value:this._workspaceConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,workspaceFolder:O!==void 0?{value:o?.freeze().getValue(r),override:i.overrideIdentifier?o?.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,memory:S!==void 0?{value:b.getValue(r),override:i.overrideIdentifier?b.getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:N.length?N:void 0}}keys(r){const i=this.getFolderConfigurationModelForResource(void 0,r);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(r){this._defaultConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(r){this._localUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(r){this._remoteUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(r){this._workspaceConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(r,i){this._folderConfigurations.set(r,i),this._foldersConsolidatedConfigurations.delete(r)}deleteFolderConfiguration(r){this.folderConfigurations.delete(r),this._foldersConsolidatedConfigurations.delete(r)}compareAndUpdateDefaultConfiguration(r,i){const v=[];for(const m of i)for(const o of(0,_.overrideIdentifiersFromKey)(m)){const b=this._defaultConfiguration.getKeysForOverrideIdentifier(o),d=r.getKeysForOverrideIdentifier(o),E=[...d.filter(R=>b.indexOf(R)===-1),...b.filter(R=>d.indexOf(R)===-1),...b.filter(R=>!T.equals(this._defaultConfiguration.override(o).getValue(R),r.override(o).getValue(R)))];v.push([o,E])}return this.updateDefaultConfiguration(r),{keys:i,overrides:v}}compareAndUpdateLocalUserConfiguration(r){const{added:i,updated:v,removed:m,overrides:o}=y(this.localUserConfiguration,r),b=[...i,...v,...m];return b.length&&this.updateLocalUserConfiguration(r),{keys:b,overrides:o}}compareAndUpdateRemoteUserConfiguration(r){const{added:i,updated:v,removed:m,overrides:o}=y(this.remoteUserConfiguration,r);let b=[...i,...v,...m];return b.length&&this.updateRemoteUserConfiguration(r),{keys:b,overrides:o}}compareAndUpdateWorkspaceConfiguration(r){const{added:i,updated:v,removed:m,overrides:o}=y(this.workspaceConfiguration,r);let b=[...i,...v,...m];return b.length&&this.updateWorkspaceConfiguration(r),{keys:b,overrides:o}}compareAndUpdateFolderConfiguration(r,i){const v=this.folderConfigurations.get(r),{added:m,updated:o,removed:b,overrides:d}=y(v,i);let E=[...m,...o,...b];return(E.length||!v)&&this.updateFolderConfiguration(r,i),{keys:E,overrides:d}}compareAndDeleteFolderConfiguration(r){const i=this.folderConfigurations.get(r);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:v,updated:m,removed:o,overrides:b}=y(i,void 0);return{keys:[...v,...m,...o],overrides:b}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(r,i){let v=this.getConsolidatedConfigurationModelForResource(r,i);return r.overrideIdentifier?v.override(r.overrideIdentifier):v}getConsolidatedConfigurationModelForResource({resource:r},i){let v=this.getWorkspaceConsolidatedConfiguration();if(i&&r){const m=i.getFolder(r);m&&(v=this.getFolderConsolidatedConfiguration(m.uri)||v);const o=this._memoryConfigurationByResource.get(r);o&&(v=v.merge(o))}return v}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(r){let i=this._foldersConsolidatedConfigurations.get(r);if(!i){const v=this.getWorkspaceConsolidatedConfiguration(),m=this._folderConfigurations.get(r);m?(i=v.merge(m),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(r,i)):i=v}return i}getFolderConfigurationModelForResource(r,i){if(i&&r){const v=i.getFolder(r);if(v)return this._folderConfigurations.get(v.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((r,i)=>{const{contents:v,overrides:m,keys:o}=this._folderConfigurations.get(i);return r.push([i,{contents:v,overrides:m,keys:o}]),r},[])}}allKeys(){const r=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>r.add(i)),this.userConfiguration.freeze().keys.forEach(i=>r.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>r.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(v=>r.add(v))),[...r.values()]}allOverrideIdentifiers(){const r=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>r.add(i)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>r.add(i)),this._folderConfigurations.forEach(i=>i.freeze().getAllOverrideIdentifiers().forEach(v=>r.add(v))),[...r.values()]}getAllKeysForOverrideIdentifier(r){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(r).forEach(v=>i.add(v)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(v=>i.add(v)),this._workspaceConfiguration.getKeysForOverrideIdentifier(r).forEach(v=>i.add(v)),this._folderConfigurations.forEach(v=>v.getKeysForOverrideIdentifier(r).forEach(m=>i.add(m))),[...i.values()]}static parse(r){const i=this.parseConfigurationModel(r.defaults),v=this.parseConfigurationModel(r.user),m=this.parseConfigurationModel(r.workspace),o=r.folders.reduce((b,d)=>(b.set(k.URI.revive(d[0]),this.parseConfigurationModel(d[1])),b),new t.ResourceMap);return new D(i,v,new g,m,o,new g,new t.ResourceMap,!1)}static parseConfigurationModel(r){return new g(r.contents,r.keys,r.overrides).freeze()}}e.Configuration=D;function f(...I){if(I.length===0)return{keys:[],overrides:[]};if(I.length===1)return I[0];const r=new Set,i=new Map;for(const m of I)m.keys.forEach(o=>r.add(o)),m.overrides.forEach(([o,b])=>{const d=(0,t.getOrSet)(i,o,new Set);b.forEach(E=>d.add(E))});const v=[];return i.forEach((m,o)=>v.push([o,[...m.values()]])),{keys:[...r.values()],overrides:v}}e.mergeChanges=f;class l{constructor(r,i,v,m){this.change=r,this.previous=i,this.currentConfiguraiton=v,this.currentWorkspace=m,this._previousConfiguration=void 0;const o=new Set;r.keys.forEach(d=>o.add(d)),r.overrides.forEach(([,d])=>d.forEach(E=>o.add(E))),this.affectedKeys=[...o.values()];const b=new g;this.affectedKeys.forEach(d=>b.setValue(d,{})),this.affectedKeysTree=b.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=D.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(r,i){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,r)){if(i){const v=this.previousConfiguration?this.previousConfiguration.getValue(r,i,this.previous?.workspace):void 0,m=this.currentConfiguraiton.getValue(r,i,this.currentWorkspace);return!T.equals(v,m)}return!0}return!1}doesAffectedKeysTreeContains(r,i){let v=(0,F.toValuesTree)({[i]:!0},()=>{}),m;for(;typeof v=="object"&&(m=Object.keys(v)[0]);){if(r=r[m],!r)return!1;v=v[m]}return!0}}e.ConfigurationChangeEvent=l;class h extends l{constructor(r,i,v,m){super({keys:r.allKeys(),overrides:[]},void 0,r,i);this.source=v,this.sourceConfig=m}}e.AllKeysConfigurationChangeEvent=h;function y(I,r){const{added:i,removed:v,updated:m}=s(r,I),o=[],b=I?.getAllOverrideIdentifiers()||[],d=r?.getAllOverrideIdentifiers()||[];if(r){const E=d.filter(R=>!b.includes(R));for(const R of E)o.push([R,r.getKeysForOverrideIdentifier(R)])}if(I){const E=b.filter(R=>!d.includes(R));for(const R of E)o.push([R,I.getKeysForOverrideIdentifier(R)])}if(r&&I){for(const E of b)if(d.includes(E)){const R=s({contents:I.getOverrideValue(void 0,E)||{},keys:I.getKeysForOverrideIdentifier(E)},{contents:r.getOverrideValue(void 0,E)||{},keys:r.getKeysForOverrideIdentifier(E)});o.push([E,[...R.added,...R.removed,...R.updated]])}}return{added:i,removed:v,updated:m,overrides:o}}function s(I,r){const i=I?r?I.keys.filter(o=>r.keys.indexOf(o)===-1):[...I.keys]:[],v=r?I?r.keys.filter(o=>I.keys.indexOf(o)===-1):[...r.keys]:[],m=[];if(I&&r){for(const o of r.keys)if(I.keys.indexOf(o)!==-1){const b=(0,F.getConfigurationValue)(r.contents,o),d=(0,F.getConfigurationValue)(I.contents,o);T.equals(b,d)||m.push(o)}}return{added:i,removed:v,updated:m}}}),define(we[85],Ee([0,1,4]),function(re,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,u.createDecorator)("remoteAuthorityResolverService");var M;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound"})(M=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class w extends Error{constructor(t,T=M.Unknown,C){super(t);this._message=t,this._code=T,this._detail=C,this.isHandled=T===M.NotAvailable&&C===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,w.prototype)}static isTemporarilyNotAvailable(t){return t instanceof w&&t._code===M.TemporarilyNotAvailable}static isNoResolverFound(t){return t instanceof w&&t._code===M.NoResolverFound}static isHandled(t){return t instanceof w&&t.isHandled}}e.RemoteAuthorityResolverError=w}),define(we[62],Ee([0,1,11]),function(re,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function M(k){return k.scheme===u.Schemas.vscodeRemote?k.authority:void 0}e.getRemoteAuthority=M;function w(k){if(!k)return;const F=k.indexOf("+");return F<0?k:k.substr(0,F)}e.getRemoteName=w;function A(k){return k.scheme!==u.Schemas.file&&k.scheme!==u.Schemas.vscodeRemote}e.isVirtualResource=A;function t(k){if(k.folders.length)return k.folders.every(F=>A(F.uri))?k.folders[0].uri:void 0;if(k.configuration&&A(k.configuration))return k.configuration}e.getVirtualWorkspaceLocation=t;function T(k){return t(k)?.scheme}e.getVirtualWorkspaceScheme=T;function C(k){return t(k)!==void 0}e.isVirtualWorkspace=C}),define(we[26],Ee([0,1,9,4,62]),function(re,e,u,M,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function A(n){if(typeof n=="object"&&n!==null&&n.supported!==!0)return n.description}e.getWorkspaceSupportTypeMessage=A;function t(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(!n.uuid||typeof n.uuid=="string")}e.isIExtensionIdentifier=t,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var T;(function(n){n[n.System=0]="System",n[n.User=1]="User"})(T=e.ExtensionType||(e.ExtensionType={}));class C{constructor(g){this.value=g,this._lower=g.toLowerCase()}static equals(g,a){if(typeof g=="undefined"||g===null)return typeof a=="undefined"||a===null;if(typeof a=="undefined"||a===null)return!1;if(typeof g=="string"||typeof a=="string"){let c=typeof g=="string"?g:g.value,p=typeof a=="string"?a:a.value;return u.equalsIgnoreCase(c,p)}return g._lower===a._lower}static toKey(g){return typeof g=="string"?g.toLowerCase():g._lower}}e.ExtensionIdentifier=C;function k(n){return n.contributes&&n.contributes.localizations?n.contributes.localizations.length>0:!1}e.isLanguagePackExtension=k;function F(n){return n.contributes&&n.contributes.authentication?n.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=F;function _(n,g){if(g){const a=`onResolveRemoteAuthority:${(0,w.getRemoteName)(g)}`;return n.activationEvents?.indexOf(a)!==-1}return!1}e.isResolverExtension=_,e.IBuiltinExtensionsScannerService=(0,M.createDecorator)("IBuiltinExtensionsScannerService")}),define(we[147],Ee([0,1,9,26]),function(re,e,u,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function w(a,c){return a.uuid&&c.uuid?a.uuid===c.uuid:a.id===c.id?!0:(0,u.compareIgnoreCase)(a.id,c.id)===0}e.areSameExtensions=w;class A{constructor(c,p){this.version=p,this.id=c.id,this.uuid=c.uuid}key(){return`${this.id}-${this.version}`}equals(c){return c instanceof A?w(this,c)&&this.version===c.version:!1}}e.ExtensionIdentifierWithVersion=A;function t(a,c){return`${a}.${c}`}e.getExtensionId=t;function T(a){return a.toLocaleLowerCase()}e.adoptToGalleryExtensionId=T;function C(a,c){return T(t(a,c))}e.getGalleryExtensionId=C;function k(a,c){const p=[],D=f=>{for(const l of p)if(l.some(h=>w(c(h),c(f))))return l;return null};for(const f of a){const l=D(f);l?l.push(f):p.push([f])}return p}e.groupByExtension=k;function F(a){return{id:a.identifier.id,name:a.manifest.name,galleryId:null,publisherId:a.publisherId,publisherName:a.manifest.publisher,publisherDisplayName:a.publisherDisplayName,dependencies:a.manifest.extensionDependencies&&a.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=F;function _(a){return{id:a.identifier.id,name:a.name,galleryId:a.identifier.uuid,publisherId:a.publisherId,publisherName:a.publisher,publisherDisplayName:a.publisherDisplayName,dependencies:!!(a.properties.dependencies&&a.properties.dependencies.length>0),...a.telemetryData}}e.getGalleryExtensionTelemetryData=_,e.BetterMergeId=new M.ExtensionIdentifier("pprice.better-merge");function n(a){const c=new Set;for(const p of a)p.malicious&&c.add(p.id.id);return c}e.getMaliciousExtensionsSet=n;function g(a,c){const p=[],D=c.manifest.extensionDependencies?.slice(0)??[];for(;D.length;){const f=D.shift();if(f&&p.every(l=>!w(l.identifier,{id:f}))){const l=a.filter(h=>w(h.identifier,{id:f}));l.length===1&&(p.push(l[0]),D.push(...l[0].manifest.extensionDependencies?.slice(0)??[]))}}return p}e.getExtensionDependencies=g}),define(we[148],Ee([0,1,3,24,4,12]),function(re,e,u,M,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,w.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,w.createDecorator)("sharedTunnelsService");var t;(function(a){a.Http="http",a.Https="https"})(t=e.TunnelProtocol||(e.TunnelProtocol={}));var T;(function(a){a.ConstantPrivate="constantPrivate",a.Private="private",a.Public="public"})(T=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var C;(function(a){a[a.Notify=1]="Notify",a[a.OpenBrowser=2]="OpenBrowser",a[a.OpenPreview=3]="OpenPreview",a[a.Silent=4]="Silent",a[a.Ignore=5]="Ignore",a[a.OpenBrowserOnce=6]="OpenBrowserOnce"})(C=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function k(a){if(a.scheme!=="http"&&a.scheme!=="https")return;const c=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(a.authority);if(!!c)return{address:c[1],port:+c[2]}}e.extractLocalHostUriMetaDataForPortMapping=k,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function F(a){return e.LOCALHOST_ADDRESSES.indexOf(a)>=0}e.isLocalhost=F,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function _(a){return e.ALL_INTERFACES_ADDRESSES.indexOf(a)>=0}e.isAllInterfaces=_;function n(a,c){return c?c!==1&&a<1024:!M.isWindows&&a<1024}e.isPortPrivileged=n;let g=class{constructor(c){this.logService=c,this._onTunnelOpened=new u.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new u.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new u.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(c,p){return this._tunnelProvider=c,c?(this._canElevate=p.elevation,this._privacyOptions=p.privacyOptions,this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const c=[],p=Array.from(this._tunnels.values());for(let D of p){const f=Array.from(D.values());for(let l of f){const h=await l.value;h&&c.push(h)}}return c}async dispose(){for(const c of this._tunnels.values()){for(const{value:p}of c.values())await p.then(D=>D?.dispose());c.clear()}this._tunnels.clear()}openTunnel(c,p,D,f,l=!1,h=T.Private,y){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${p}:${D} on local port ${f}.`),!c)return;p||(p="localhost");const s=this.retainOrCreateTunnel(c,p,D,f,l,h,y);return s?s.then(I=>{if(!I){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(p,D);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const r=this.makeTunnel(I);return(I.tunnelRemoteHost!==p||I.tunnelRemotePort!==D)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(r),r}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),s)}makeTunnel(c){return{tunnelRemotePort:c.tunnelRemotePort,tunnelRemoteHost:c.tunnelRemoteHost,tunnelLocalPort:c.tunnelLocalPort,localAddress:c.localAddress,privacy:c.privacy,protocol:c.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${c.tunnelRemoteHost}:${c.tunnelRemotePort} `);const p=this._tunnels.get(c.tunnelRemoteHost);if(p){const D=p.get(c.tunnelRemotePort);D&&(D.refcount--,await this.tryDisposeTunnel(c.tunnelRemoteHost,c.tunnelRemotePort,D))}}}}async tryDisposeTunnel(c,p,D){if(D.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${c}:${p}.`);const f=D.value.then(async l=>{l&&(await l.dispose(!0),this._onTunnelClosed.fire({host:l.tunnelRemoteHost,port:l.tunnelRemotePort}))});return this._tunnels.has(c)&&this._tunnels.get(c).delete(p),f}}async closeTunnel(c,p){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${c}:${p} `);const D=this._tunnels.get(c);if(D&&D.has(p)){const f=D.get(p);f.refcount=0,await this.tryDisposeTunnel(c,p,f)}}addTunnelToMap(c,p,D){this._tunnels.has(c)||this._tunnels.set(c,new Map),this._tunnels.get(c).set(p,{refcount:1,value:D})}async removeEmptyTunnelFromMap(c,p){const D=this._tunnels.get(c);D&&(await D.get(p)||D.delete(p),D.size===0&&this._tunnels.delete(c))}getTunnelFromMap(c,p){let D=[c];F(c)?(D.push(...e.LOCALHOST_ADDRESSES),D.push(...e.ALL_INTERFACES_ADDRESSES)):_(c)&&D.push(...e.ALL_INTERFACES_ADDRESSES);const f=D.map(l=>this._tunnels.get(l));for(const l of f){const h=l?.get(p);if(h)return h}}canTunnel(c){return!!k(c)}createWithProvider(c,p,D,f,l,h,y){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${p}:${D} on local port ${f}.`);const I={elevationRequired:l?n(f===void 0?D:f):!1},r={remoteAddress:{host:p,port:D},localAddressPort:f,privacy:h,public:h!==T.Private,protocol:y},i=c.forwardPort(r,I);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),i&&this.addTunnelToMap(p,D,i),i}};g=Ne([xe(0,A.ILogService)],g),e.AbstractTunnelService=g}),define(we[149],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class u{constructor(w){this._callback=w,this._terminalBufferMap=new Map}dispose(){for(const w of this._terminalBufferMap.values())w.dispose()}startBuffering(w,A,t=5){let T;return T=A(C=>{const k=typeof C=="string"?C:C.data;let F=this._terminalBufferMap.get(w);if(F){F.data.push(k);return}const _=setTimeout(()=>this.flushBuffer(w),t);F={data:[k],timeoutId:_,dispose:()=>{clearTimeout(_),this.flushBuffer(w),T.dispose()}},this._terminalBufferMap.set(w,F)}),T}stopBuffering(w){const A=this._terminalBufferMap.get(w);A&&A.dispose()}flushBuffer(w){const A=this._terminalBufferMap.get(w);A&&(this._terminalBufferMap.delete(w),this._callback(w,A.data.join("")))}}e.TerminalDataBufferer=u}),define(we[150],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var u;(function(M){M.DARK="dark",M.LIGHT="light",M.HIGH_CONTRAST="hc"})(u=e.ColorScheme||(e.ColorScheme={}))}),define(we[63],Ee([0,1,54,3,6,4,30,150]),function(re,e,u,M,w,A,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,A.createDecorator)("themeService");var C;(function(p){function D(f){return f&&typeof f=="object"&&typeof f.id=="string"}p.isThemeColor=D})(C=e.ThemeColor||(e.ThemeColor={}));function k(p){return{id:p}}e.themeColorFromId=k;var F;(function(p){function D(r){return r&&typeof r=="object"&&typeof r.id=="string"&&(typeof r.color=="undefined"||C.isThemeColor(r.color))}p.isThemeIcon=D;const f=new RegExp(`^\\$\\((${u.CSSIcon.iconNameExpression}(?:${u.CSSIcon.iconModifierExpression})?)\\)$`);function l(r){const i=f.exec(r);if(!i)return;let[,v]=i;return{id:v}}p.fromString=l;function h(r,i){let v=r.id;const m=v.lastIndexOf("~");return m!==-1&&(v=v.substring(0,m)),i&&(v=`${v}~${i}`),{id:v}}p.modify=h;function y(r){const i=r.id.lastIndexOf("~");if(i!==-1)return r.id.substring(i+1)}p.getModifier=y;function s(r,i){return r.id===i.id&&r.color?.id===i.color?.id}p.isEqual=s;function I(r,i){return{id:r.id,color:i?k(i):void 0}}p.asThemeIcon=I,p.asClassNameArray=u.CSSIcon.asClassNameArray,p.asClassName=u.CSSIcon.asClassName,p.asCSSSelector=u.CSSIcon.asCSSSelector})(F=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=u.Codicon.file,e.FolderThemeIcon=u.Codicon.folder;function _(p){switch(p){case T.ColorScheme.DARK:return"vs-dark";case T.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=_,e.Extensions={ThemingContribution:"base.contributions.theming"};class n{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new M.Emitter}onColorThemeChange(D){return this.themingParticipants.push(D),this.onThemingParticipantAddedEmitter.fire(D),(0,w.toDisposable)(()=>{const f=this.themingParticipants.indexOf(D);this.themingParticipants.splice(f,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let g=new n;t.Registry.add(e.Extensions.ThemingContribution,g);function a(p){return g.onColorThemeChange(p)}e.registerThemingParticipant=a;class c extends w.Disposable{constructor(D){super();this.themeService=D,this.theme=D.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(f=>this.onThemeChange(f)))}onThemeChange(D){this.theme=D,this.updateStyles()}updateStyles(){}getColor(D,f){let l=this.theme.getColor(D);return l&&f&&(l=f(l,this.theme)),l?l.toString():null}}e.Themable=c}),define(we[47],Ee([0,1,21,23,2,4]),function(re,e,u,M,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,A.createDecorator)("contextService");var t;(function(n){n[n.EMPTY=1]="EMPTY",n[n.FOLDER=2]="FOLDER",n[n.WORKSPACE=3]="WORKSPACE"})(t=e.WorkbenchState||(e.WorkbenchState={}));function T(n){const g=n;return!!(g&&typeof g=="object"&&typeof g.id=="string"&&Array.isArray(g.folders))}e.isWorkspace=T;function C(n){const g=n;return!!(g&&typeof g=="object"&&w.URI.isUri(g.uri)&&typeof g.name=="string"&&typeof g.toResource=="function")}e.isWorkspaceFolder=C;class k{constructor(g,a,c,p,D){this._id=g,this._transient=c,this._configuration=p,this._ignorePathCasing=D,this._foldersMap=u.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=a}update(g){this._id=g.id,this._configuration=g.configuration,this._transient=g.transient,this._ignorePathCasing=g._ignorePathCasing,this.folders=g.folders}get folders(){return this._folders}set folders(g){this._folders=g,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(g){this._configuration=g}getFolder(g){return g&&this._foldersMap.findSubstr(g.with({scheme:g.scheme,authority:g.authority,path:g.path}))||null}updateFoldersMap(){this._foldersMap=u.TernarySearchTree.forUris(this._ignorePathCasing);for(const g of this.folders)this._foldersMap.set(g.uri,g)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=k;class F{constructor(g,a){this.raw=a,this.uri=g.uri,this.index=g.index,this.name=g.name}toResource(g){return(0,M.joinPath)(this.uri,g)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=F;function _(n){return new F({uri:n,index:0,name:(0,M.basenameOrAuthority)(n)},{uri:n.toString()})}e.toWorkspaceFolder=_}),define(we[64],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class u{constructor(w){this.id=w,this._data=new Map,this._idPool=1}add(w){const A=this._idPool++;return this._data.set(A,w),this.logDebugInfo(),A}get(w,A){return this._data.has(w)?this._data.get(w)[A]:void 0}delete(w){this._data.delete(w),this.logDebugInfo()}logDebugInfo(){!u.enableDebugLogging||console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=u,u.enableDebugLogging=!1}),define(we[31],Ee([0,1,11,23,4]),function(re,e,u,M,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class A{constructor(){this._systemSchemes=new Set(Object.keys(u.Schemas)),this._providerInfo=new Map,this.extUri=new M.ExtUri(T=>{const C=this._providerInfo.get(T.scheme);return!(C===void 0||C&1024)})}$acceptProviderInfos(T,C){C===null?this._providerInfo.delete(T):this._providerInfo.set(T,C)}isFreeScheme(T){return!this._providerInfo.has(T)&&!this._systemSchemes.has(T)}getCapabilities(T){return this._providerInfo.get(T)}}e.ExtHostFileSystemInfo=A,e.IExtHostFileSystemInfo=(0,w.createDecorator)("IExtHostFileSystemInfo")}),define(we[28],Ee([0,1,4]),function(re,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,u.createDecorator)("IExtHostInitDataService")}),define(we[151],Ee([0,1,14]),function(re,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class M{constructor(t,T,C){this._deferredPromises=new Map,this._id=t,this._shared=T,this._storage=C,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(k=>(this._value=k,this)),this._storageListener=this._storage.onDidChangeStorage(k=>{k.shared===this._shared&&k.key===this._id&&(this._value=k.value)}),this._scheduler=new u.RunOnceScheduler(()=>{const k=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const F of k.values())F.complete()}catch(F){for(const _ of k.values())_.error(F)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,t])=>t!==void 0).map(([t])=>t)}get whenReady(){return this._init}get(t,T){let C=this._value[t];return typeof C=="undefined"&&(C=T),C}update(t,T){this._value[t]=T;let C=this._deferredPromises.get(t);if(C!==void 0)return C.p;const k=new u.DeferredPromise;return this._deferredPromises.set(t,k),this._scheduler.isScheduled()||this._scheduler.schedule(),k.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=M;class w extends M{constructor(t,T){super(t.identifier.value,!0,T);this._extension=t}setKeysForSync(t){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},t)}}e.ExtensionGlobalMemento=w}),define(we[152],Ee([0,1,3,2,12]),function(re,e,u,M,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;let A=class{constructor(T,C){this._logService=T,this._notebooksAndEditors=C,this._onDidChangeNotebookDocumentMetadata=new u.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidSaveNotebookDocument=new u.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event}$acceptModelChanged(T,C,k){this._notebooksAndEditors.getNotebookDocument(M.URI.revive(T)).acceptModelChanged(C.value,k)}$acceptDirtyStateChanged(T,C){this._notebooksAndEditors.getNotebookDocument(M.URI.revive(T)).acceptDirty(C)}$acceptModelSaved(T){const C=this._notebooksAndEditors.getNotebookDocument(M.URI.revive(T));this._onDidSaveNotebookDocument.fire(C.apiNotebook)}$acceptDocumentPropertiesChanged(T,C){this._logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",T.path,C);const k=this._notebooksAndEditors.getNotebookDocument(M.URI.revive(T));k.acceptDocumentPropertiesChanged(C),C.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:k.apiNotebook})}};A=Ne([xe(0,w.ILogService)],A),e.ExtHostNotebookDocuments=A}),define(we[13],Ee([0,1,4]),function(re,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,u.createDecorator)("IExtHostRpcService");class M{constructor(A){this.getProxy=A.getProxy.bind(A),this.set=A.set.bind(A),this.assertRegistered=A.assertRegistered.bind(A),this.drain=A.drain.bind(A)}}e.ExtHostRpcService=M});var Xe=this&&this.__classPrivateFieldSet||function(re,e,u,M,w){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!w:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?w.call(re,u):w?w.value=u:e.set(re,u),u},Te=this&&this.__classPrivateFieldGet||function(re,e,u,M){if(u==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?M:u==="a"?M.call(re):M?M.value:e.get(re)};define(we[153],Ee([0,1,26,3]),function(re,e,u,M){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class A{constructor(T,C){w.set(this,void 0),this._onDidChange=new M.Emitter,this.onDidChange=this._onDidChange.event,this._id=u.ExtensionIdentifier.toKey(T.identifier),Xe(this,w,C,"f"),Te(this,w,"f").onDidChangePassword(k=>{k.extensionId===this._id&&this._onDidChange.fire({key:k.key})})}get(T){return Te(this,w,"f").get(this._id,T)}store(T,C){return Te(this,w,"f").store(this._id,T,C)}delete(T){return Te(this,w,"f").delete(this._id,T)}}e.ExtensionSecrets=A,w=new WeakMap}),define(we[86],Ee([0,1,4,3]),function(re,e,u,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class w{constructor(){this._onDidChangeTelemetryEnabled=new M.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(t){this._enabled=t}$onDidChangeTelemetryEnabled(t){this._enabled=t,this._onDidChangeTelemetryEnabled.fire(t)}}e.ExtHostTelemetry=w,e.IExtHostTelemetry=(0,u.createDecorator)("IExtHostTelemetry")}),define(we[48],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestItemRootImpl=e.TestItemImpl=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.diffTestItems=e.getPrivateApiFor=e.createPrivateApiFor=e.ExtHostTestItemEventOp=void 0;var u;(function(f){f[f.Upsert=0]="Upsert",f[f.RemoveChild=1]="RemoveChild",f[f.Invalidated=2]="Invalidated",f[f.SetProp=3]="SetProp",f[f.Bulk=4]="Bulk"})(u=e.ExtHostTestItemEventOp||(e.ExtHostTestItemEventOp={}));const M=new WeakMap,w=(f,l)=>{const h={controllerId:l};return M.set(f,h),h};e.createPrivateApiFor=w;const A=f=>M.get(f);e.getPrivateApiFor=A;const t=(f,l,h,y)=>{let s=h;return{enumerable:!0,configurable:!1,get(){return s},set(I){if(!y(s,I)){const r=s;s=I,f.listener?.({op:3,key:l,value:I,previous:r})}}}},T=(f,l)=>f===l,C={range:(f,l)=>f===l?!0:!f||!l?!1:f.isEqual(l),label:T,description:T,busy:T,error:T,canResolveChildren:T,tags:(f,l)=>!(f.length!==l.length||f.some(h=>!l.find(y=>h.id===y.id)))},k=Object.keys(C),F=(f,l)=>({range:t(f,"range",void 0,C.range),label:t(f,"label",l,C.label),description:t(f,"description",void 0,C.description),canResolveChildren:t(f,"canResolveChildren",!1,C.canResolveChildren),busy:t(f,"busy",!1,C.busy),error:t(f,"error",void 0,C.error),tags:t(f,"tags",[],C.tags)}),_=(f,l)=>{const h=new Map;for(const y of k)C[y](f[y],l[y])||h.set(y,l[y]);return h};e.diffTestItems=_;class n extends Error{constructor(l){super(`Attempted to insert a duplicate test item ID ${l}`)}}e.DuplicateTestItemError=n;class g extends Error{constructor(l){super(`TestItem with ID "${l}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=g;class a extends Error{constructor(l,h,y){super(`TestItem with ID "${l}" is from controller "${h}" and cannot be added as a child of an item from controller "${y}".`)}}e.MixedTestItemController=a;const c=f=>{const l=(0,e.getPrivateApiFor)(f);let h=new Map;return{get size(){return h.size},forEach(y,s){for(const I of h.values())y.call(s,I,this)},replace(y){const s=new Map,I=new Set(h.keys()),r={op:4,ops:[]};for(const i of y){if(!(i instanceof p))throw new g(i.id);const v=(0,e.getPrivateApiFor)(i).controllerId;if(v!==l.controllerId)throw new a(i.id,v,l.controllerId);if(s.has(i.id))throw new n(i.id);s.set(i.id,i),I.delete(i.id),r.ops.push({op:0,item:i})}for(const i of I.keys())r.ops.push({op:1,id:i});l.listener?.(r),h=s},add(y){if(!(y instanceof p))throw new g(y.id);h.set(y.id,y),l.listener?.({op:0,item:y})},delete(y){h.delete(y)&&l.listener?.({op:1,id:y})},get(y){return h.get(y)},toJSON(){return Array.from(h.values())},[Symbol.iterator](){return h.values()}}};class p{constructor(l,h,y,s){if(h.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(h)} symbol`);const I=(0,e.createPrivateApiFor)(this,l);Object.defineProperties(this,{id:{value:h,enumerable:!0,writable:!1},uri:{value:s,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return I.parent instanceof D?void 0:I.parent}},children:{value:c(this),enumerable:!0,writable:!1},...F(I,y)})}invalidateResults(){(0,e.getPrivateApiFor)(this).listener?.({op:2})}}e.TestItemImpl=p;class D extends p{constructor(l,h){super(l,l,h,void 0)}}e.TestItemRootImpl=D}),define(we[65],Ee([0,1,4,148,3,13]),function(re,e,u,M,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var t;(function(C){function k(_){return{remoteAddress:_.remoteAddress,localAddress:_.localAddress,public:!!_.public,privacy:_.privacy??(_.public?M.TunnelPrivacyId.Public:M.TunnelPrivacyId.Private),protocol:_.protocol}}C.fromApiTunnel=k;function F(_){return{remoteAddress:{host:_.tunnelRemoteHost,port:_.tunnelRemotePort},localAddress:_.localAddress,public:_.privacy!==M.TunnelPrivacyId.ConstantPrivate&&_.privacy!==M.TunnelPrivacyId.ConstantPrivate,privacy:_.privacy,protocol:_.protocol}}C.fromServiceTunnel=F})(t=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,u.createDecorator)("IExtHostTunnelService");let T=class{constructor(k){this.onDidChangeTunnels=new w.Emitter().event}async $applyCandidateFilter(k){return k}async openTunnel(k,F){}async getTunnels(){return[]}async setTunnelExtensionFunctions(k){return{dispose:()=>{}}}registerPortsAttributesProvider(k,F){return{dispose:()=>{}}}async $providePortAttributes(k,F,_,n,g){return[]}async $forwardPort(k,F){}async $closeTunnel(k){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};T=Ne([xe(0,A.IExtHostRpcService)],T),e.ExtHostTunnelService=T});var Xe=this&&this.__classPrivateFieldSet||function(re,e,u,M,w){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!w:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?w.call(re,u):w?w.value=u:e.set(re,u),u},Te=this&&this.__classPrivateFieldGet||function(re,e,u,M){if(u==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?M:u==="a"?M.call(re):M?M.value:e.get(re)};define(we[7],Ee([0,1,16,15,77,21,79,9,10,2,36,46,85]),function(re,e,u,M,w,A,t,T,C,k,F,_,n){"use strict";var g,a,c,p,D,f,l,h,y,s,I,r,i,v,m,o,b,d,E,R;Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeDataTransfer=e.TreeDataTransferItem=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function P(U){function L(){return Reflect.construct(U,arguments,this.constructor)}return Object.defineProperty(L,"name",Object.getOwnPropertyDescriptor(U,"name")),Object.setPrototypeOf(L,U),Object.setPrototypeOf(L.prototype,U.prototype),L}let z=D=class{constructor(L){g.set(this,void 0),Xe(this,g,L,"f")}static from(...L){let ee=L;return new D(function(){if(ee){for(const _e of ee)_e&&typeof _e.dispose=="function"&&_e.dispose();ee=void 0}})}dispose(){typeof Te(this,g,"f")=="function"&&(Te(this,g,"f").call(this),Xe(this,g,void 0,"f"))}};g=new WeakMap,z=D=Ne([P],z),e.Disposable=z;let O=f=class{constructor(L,ee){if(L<0)throw(0,M.illegalArgument)("line must be non-negative");if(ee<0)throw(0,M.illegalArgument)("character must be non-negative");this._line=L,this._character=ee}static Min(...L){if(L.length===0)throw new TypeError;let ee=L[0];for(let _e=1;_e<L.length;_e++){const He=L[_e];He.isBefore(ee)&&(ee=He)}return ee}static Max(...L){if(L.length===0)throw new TypeError;let ee=L[0];for(let _e=1;_e<L.length;_e++){const He=L[_e];He.isAfter(ee)&&(ee=He)}return ee}static isPosition(L){if(!L)return!1;if(L instanceof f)return!0;let{line:ee,character:_e}=L;return typeof ee=="number"&&typeof _e=="number"}get line(){return this._line}get character(){return this._character}isBefore(L){return this._line<L._line?!0:L._line<this._line?!1:this._character<L._character}isBeforeOrEqual(L){return this._line<L._line?!0:L._line<this._line?!1:this._character<=L._character}isAfter(L){return!this.isBeforeOrEqual(L)}isAfterOrEqual(L){return!this.isBefore(L)}isEqual(L){return this._line===L._line&&this._character===L._character}compareTo(L){return this._line<L._line?-1:this._line>L.line?1:this._character<L._character?-1:this._character>L._character?1:0}translate(L,ee=0){if(L===null||ee===null)throw(0,M.illegalArgument)();let _e;return typeof L=="undefined"?_e=0:typeof L=="number"?_e=L:(_e=typeof L.lineDelta=="number"?L.lineDelta:0,ee=typeof L.characterDelta=="number"?L.characterDelta:0),_e===0&&ee===0?this:new f(this.line+_e,this.character+ee)}with(L,ee=this.character){if(L===null||ee===null)throw(0,M.illegalArgument)();let _e;return typeof L=="undefined"?_e=this.line:typeof L=="number"?_e=L:(_e=typeof L.line=="number"?L.line:this.line,ee=typeof L.character=="number"?L.character:this.character),_e===this.line&&ee===this.character?this:new f(_e,ee)}toJSON(){return{line:this.line,character:this.character}}};O=f=Ne([P],O),e.Position=O;let S=l=class{constructor(L,ee,_e,He){let et,st;if(typeof L=="number"&&typeof ee=="number"&&typeof _e=="number"&&typeof He=="number"?(et=new O(L,ee),st=new O(_e,He)):L instanceof O&&ee instanceof O&&(et=L,st=ee),!et||!st)throw new Error("Invalid arguments");et.isBefore(st)?(this._start=et,this._end=st):(this._start=st,this._end=et)}static isRange(L){return L instanceof l?!0:L?O.isPosition(L.start)&&O.isPosition(L.end):!1}get start(){return this._start}get end(){return this._end}contains(L){return L instanceof l?this.contains(L._start)&&this.contains(L._end):L instanceof O?!(L.isBefore(this._start)||this._end.isBefore(L)):!1}isEqual(L){return this._start.isEqual(L._start)&&this._end.isEqual(L._end)}intersection(L){const ee=O.Max(L.start,this._start),_e=O.Min(L.end,this._end);if(!ee.isAfter(_e))return new l(ee,_e)}union(L){if(this.contains(L))return this;if(L.contains(this))return L;const ee=O.Min(L.start,this._start),_e=O.Max(L.end,this.end);return new l(ee,_e)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(L,ee=this.end){if(L===null||ee===null)throw(0,M.illegalArgument)();let _e;return L?O.isPosition(L)?_e=L:(_e=L.start||this.start,ee=L.end||this.end):_e=this.start,_e.isEqual(this._start)&&ee.isEqual(this.end)?this:new l(_e,ee)}toJSON(){return[this.start,this.end]}};S=l=Ne([P],S),e.Range=S;let x=h=class extends S{constructor(L,ee,_e,He){let et,st;if(typeof L=="number"&&typeof ee=="number"&&typeof _e=="number"&&typeof He=="number"?(et=new O(L,ee),st=new O(_e,He)):L instanceof O&&ee instanceof O&&(et=L,st=ee),!et||!st)throw new Error("Invalid arguments");super(et,st);this._anchor=et,this._active=st}static isSelection(L){return L instanceof h?!0:L?S.isRange(L)&&O.isPosition(L.anchor)&&O.isPosition(L.active)&&typeof L.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};x=h=Ne([P],x),e.Selection=x;class N{constructor(L,ee,_e){if(typeof L!="string"||L.length===0)throw(0,M.illegalArgument)("host");if(typeof ee!="number"||ee===0||Math.round(ee)!==ee)throw(0,M.illegalArgument)("port");if(typeof _e!="undefined"&&(typeof _e!="string"||_e.length===0||!/^[0-9A-Za-z\-]+$/.test(_e)))throw(0,M.illegalArgument)("connectionToken");this.host=L,this.port=Math.round(ee),this.connectionToken=_e}}e.ResolvedAuthority=N;class V extends Error{constructor(L,ee=n.RemoteAuthorityResolverErrorCode.Unknown,_e){super(L);this._message=L,this._code=ee,this._detail=_e,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,V.prototype)}static NotAvailable(L,ee){return new V(L,n.RemoteAuthorityResolverErrorCode.NotAvailable,ee)}static TemporarilyNotAvailable(L){return new V(L,n.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=V;var B;(function(U){U[U.LF=1]="LF",U[U.CRLF=2]="CRLF"})(B=e.EndOfLine||(e.EndOfLine={}));var $;(function(U){U[U.Replace=1]="Replace",U[U.Append=2]="Append",U[U.Prepend=3]="Prepend"})($=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let J=y=class{constructor(L,ee){this._range=L,this._newText=ee}static isTextEdit(L){return L instanceof y?!0:L?S.isRange(L)&&typeof L.newText=="string":!1}static replace(L,ee){return new y(L,ee)}static insert(L,ee){return y.replace(new S(L,L),ee)}static delete(L){return y.replace(L,"")}static setEndOfLine(L){const ee=new y(new S(new O(0,0),new O(0,0)),"");return ee.newEol=L,ee}get range(){return this._range}set range(L){if(L&&!S.isRange(L))throw(0,M.illegalArgument)("range");this._range=L}get newText(){return this._newText||""}set newText(L){if(L&&typeof L!="string")throw(0,M.illegalArgument)("newText");this._newText=L}get newEol(){return this._newEol}set newEol(L){if(L&&typeof L!="number")throw(0,M.illegalArgument)("newEol");this._newEol=L}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};J=y=Ne([P],J),e.TextEdit=J;var j;(function(U){U[U.File=1]="File",U[U.Text=2]="Text",U[U.Cell=3]="Cell",U[U.CellReplace=5]="CellReplace"})(j=e.FileEditType||(e.FileEditType={}));let Q=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(L,ee,_e,He){this._edits.push({_type:1,from:L,to:ee,options:_e,metadata:He})}createFile(L,ee,_e){this._edits.push({_type:1,from:void 0,to:L,options:ee,metadata:_e})}deleteFile(L,ee,_e){this._edits.push({_type:1,from:L,to:void 0,options:ee,metadata:_e})}replaceNotebookMetadata(L,ee,_e){this._edits.push({_type:3,metadata:_e,uri:L,edit:{editType:5,metadata:ee},notebookMetadata:ee})}replaceNotebookCells(L,ee,_e,He,et){let st,ct,Dt=[],Rt;if(Ae.isNotebookRange(ee)&&Ot.isNotebookCellDataArray(_e)&&!Ot.isNotebookCellDataArray(He)?(st=ee.start,ct=ee.end,Dt=_e,Rt=He):typeof ee=="number"&&typeof _e=="number"&&Ot.isNotebookCellDataArray(He)&&(st=ee,ct=_e,Dt=He,Rt=et),st===void 0||ct===void 0)throw new Error("Invalid arguments");(st!==ct||Dt.length>0)&&this._edits.push({_type:5,uri:L,index:st,count:ct-st,cells:Dt,metadata:Rt})}replaceNotebookCellMetadata(L,ee,_e,He){this._edits.push({_type:3,metadata:He,uri:L,edit:{editType:8,index:ee,metadata:_e}})}replace(L,ee,_e,He){this._edits.push({_type:2,uri:L,edit:new J(ee,_e),metadata:He})}insert(L,ee,_e,He){this.replace(L,new S(ee,ee),_e,He)}delete(L,ee,_e){this.replace(L,ee,"",_e)}has(L){return this._edits.some(ee=>ee._type===2&&ee.uri.toString()===L.toString())}set(L,ee){if(ee)for(const _e of ee)_e&&this._edits.push({_type:2,uri:L,edit:_e});else{for(let _e=0;_e<this._edits.length;_e++){const He=this._edits[_e];He._type===2&&He.uri.toString()===L.toString()&&(this._edits[_e]=void 0)}(0,u.coalesceInPlace)(this._edits)}}get(L){const ee=[];for(let _e of this._edits)_e._type===2&&_e.uri.toString()===L.toString()&&ee.push(_e.edit);return ee}entries(){const L=new A.ResourceMap;for(let ee of this._edits)if(ee._type===2){let _e=L.get(ee.uri);_e||(_e=[ee.uri,[]],L.set(ee.uri,_e)),_e[1].push(ee.edit)}return[...L.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};Q=Ne([P],Q),e.WorkspaceEdit=Q;let le=s=class{constructor(L){this._tabstop=1,this.value=L||""}static isSnippetString(L){return L instanceof s?!0:L?typeof L.value=="string":!1}static _escape(L){return L.replace(/\$|}|\\/g,"\\$&")}appendText(L){return this.value+=s._escape(L),this}appendTabstop(L=this._tabstop++){return this.value+="$",this.value+=L,this}appendPlaceholder(L,ee=this._tabstop++){if(typeof L=="function"){const _e=new s;_e._tabstop=this._tabstop,L(_e),this._tabstop=_e._tabstop,L=_e.value}else L=s._escape(L);return this.value+="${",this.value+=ee,this.value+=":",this.value+=L,this.value+="}",this}appendChoice(L,ee=this._tabstop++){const _e=L.map(He=>He.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ee,this.value+="|",this.value+=_e,this.value+="|}",this}appendVariable(L,ee){if(typeof ee=="function"){const _e=new s;_e._tabstop=this._tabstop,ee(_e),this._tabstop=_e._tabstop,ee=_e.value}else typeof ee=="string"&&(ee=ee.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=L,ee&&(this.value+=":",this.value+=ee),this.value+="}",this}};le=s=Ne([P],le),e.SnippetString=le;var be;(function(U){U[U.Unnecessary=1]="Unnecessary",U[U.Deprecated=2]="Deprecated"})(be=e.DiagnosticTag||(e.DiagnosticTag={}));var de;(function(U){U[U.Hint=3]="Hint",U[U.Information=2]="Information",U[U.Warning=1]="Warning",U[U.Error=0]="Error"})(de=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let Fe=I=class{constructor(L,ee){if(this.uri=L,ee)if(ee instanceof S)this.range=ee;else if(ee instanceof O)this.range=new S(ee,ee);else throw new Error("Illegal argument")}static isLocation(L){return L instanceof I?!0:L?S.isRange(L.range)&&k.URI.isUri(L.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};Fe=I=Ne([P],Fe),e.Location=Fe;let Ge=class{constructor(L,ee){this.location=L,this.message=ee}static is(L){return L?typeof L.message=="string"&&L.location&&S.isRange(L.location.range)&&k.URI.isUri(L.location.uri):!1}static isEqual(L,ee){return L===ee?!0:!L||!ee?!1:L.message===ee.message&&L.location.range.isEqual(ee.location.range)&&L.location.uri.toString()===ee.location.uri.toString()}};Ge=Ne([P],Ge),e.DiagnosticRelatedInformation=Ge;let Le=class{constructor(L,ee,_e=de.Error){if(!S.isRange(L))throw new TypeError("range must be set");if(!ee)throw new TypeError("message must be set");this.range=L,this.message=ee,this.severity=_e}toJSON(){return{severity:de[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(L,ee){return L===ee?!0:!L||!ee?!1:L.message===ee.message&&L.severity===ee.severity&&L.code===ee.code&&L.severity===ee.severity&&L.source===ee.source&&L.range.isEqual(ee.range)&&(0,u.equals)(L.tags,ee.tags)&&(0,u.equals)(L.relatedInformation,ee.relatedInformation,Ge.isEqual)}};Le=Ne([P],Le),e.Diagnostic=Le;let We=class{constructor(L,ee){if(!L)throw new Error("Illegal argument, contents must be defined");Array.isArray(L)?this.contents=L:this.contents=[L],this.range=ee}};We=Ne([P],We),e.Hover=We;var Ye;(function(U){U[U.Text=0]="Text",U[U.Read=1]="Read",U[U.Write=2]="Write"})(Ye=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let Qe=class{constructor(L,ee=Ye.Text){this.range=L,this.kind=ee}toJSON(){return{range:this.range,kind:Ye[this.kind]}}};Qe=Ne([P],Qe),e.DocumentHighlight=Qe;var Ke;(function(U){U[U.File=0]="File",U[U.Module=1]="Module",U[U.Namespace=2]="Namespace",U[U.Package=3]="Package",U[U.Class=4]="Class",U[U.Method=5]="Method",U[U.Property=6]="Property",U[U.Field=7]="Field",U[U.Constructor=8]="Constructor",U[U.Enum=9]="Enum",U[U.Interface=10]="Interface",U[U.Function=11]="Function",U[U.Variable=12]="Variable",U[U.Constant=13]="Constant",U[U.String=14]="String",U[U.Number=15]="Number",U[U.Boolean=16]="Boolean",U[U.Array=17]="Array",U[U.Object=18]="Object",U[U.Key=19]="Key",U[U.Null=20]="Null",U[U.EnumMember=21]="EnumMember",U[U.Struct=22]="Struct",U[U.Event=23]="Event",U[U.Operator=24]="Operator",U[U.TypeParameter=25]="TypeParameter"})(Ke=e.SymbolKind||(e.SymbolKind={}));var W;(function(U){U[U.Deprecated=1]="Deprecated"})(W=e.SymbolTag||(e.SymbolTag={}));let K=r=class{constructor(L,ee,_e,He,et){this.name=L,this.kind=ee,this.containerName=et,typeof _e=="string"&&(this.containerName=_e),He instanceof Fe?this.location=He:_e instanceof S&&(this.location=new Fe(He,_e)),r.validate(this)}static validate(L){if(!L.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:Ke[this.kind],location:this.location,containerName:this.containerName}}};K=r=Ne([P],K),e.SymbolInformation=K;let Z=i=class{constructor(L,ee,_e,He,et){this.name=L,this.detail=ee,this.kind=_e,this.range=He,this.selectionRange=et,this.children=[],i.validate(this)}static validate(L){if(!L.name)throw new Error("name must not be falsy");if(!L.range.contains(L.selectionRange))throw new Error("selectionRange must be contained in fullRange");L.children&&L.children.forEach(i.validate)}};Z=i=Ne([P],Z),e.DocumentSymbol=Z;var se;(function(U){U[U.Invoke=1]="Invoke",U[U.Automatic=2]="Automatic"})(se=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let G=class{constructor(L,ee){this.title=L,this.kind=ee}};G=Ne([P],G),e.CodeAction=G;let te=v=class{constructor(L){this.value=L}append(L){return new v(this.value?this.value+v.sep+L:L)}intersects(L){return this.contains(L)||L.contains(this)}contains(L){return this.value===L.value||L.value.startsWith(this.value+v.sep)}};te.sep=".",te=v=Ne([P],te),e.CodeActionKind=te,te.Empty=new te(""),te.QuickFix=te.Empty.append("quickfix"),te.Refactor=te.Empty.append("refactor"),te.RefactorExtract=te.Refactor.append("extract"),te.RefactorInline=te.Refactor.append("inline"),te.RefactorRewrite=te.Refactor.append("rewrite"),te.Source=te.Empty.append("source"),te.SourceOrganizeImports=te.Source.append("organizeImports"),te.SourceFixAll=te.Source.append("fixAll");let he=class{constructor(L,ee){if(this.range=L,this.parent=ee,ee&&!ee.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};he=Ne([P],he),e.SelectionRange=he;class Pe{constructor(L,ee,_e,He,et,st){this.kind=L,this.name=ee,this.detail=_e,this.uri=He,this.range=et,this.selectionRange=st}}e.CallHierarchyItem=Pe;class Oe{constructor(L,ee){this.fromRanges=ee,this.from=L}}e.CallHierarchyIncomingCall=Oe;class Be{constructor(L,ee){this.fromRanges=ee,this.to=L}}e.CallHierarchyOutgoingCall=Be;var Ve;(function(U){U[U.Information=0]="Information",U[U.Warning=1]="Warning",U[U.Error=2]="Error"})(Ve=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let Ze=class{constructor(L,ee){this.range=L,this.command=ee}get isResolved(){return!!this.command}};Ze=Ne([P],Ze),e.CodeLens=Ze;let ot=m=class{constructor(L,ee=!1){a.set(this,void 0),Xe(this,a,new w.MarkdownString(L,{supportThemeIcons:ee}),"f")}static isMarkdownString(L){return L instanceof m?!0:L&&L.appendCodeblock&&L.appendMarkdown&&L.appendText&&L.value!==void 0}get value(){return Te(this,a,"f").value}set value(L){Te(this,a,"f").value=L}get isTrusted(){return Te(this,a,"f").isTrusted}set isTrusted(L){Te(this,a,"f").isTrusted=L}get supportThemeIcons(){return Te(this,a,"f").supportThemeIcons}set supportThemeIcons(L){Te(this,a,"f").supportThemeIcons=L}get supportHtml(){return Te(this,a,"f").supportHtml}set supportHtml(L){Te(this,a,"f").supportHtml=L}appendText(L){return Te(this,a,"f").appendText(L),this}appendMarkdown(L){return Te(this,a,"f").appendMarkdown(L),this}appendCodeblock(L,ee){return Te(this,a,"f").appendCodeblock(ee??"",L),this}};a=new WeakMap,ot=m=Ne([P],ot),e.MarkdownString=ot;let ye=class{constructor(L,ee){this.label=L,this.documentation=ee}};ye=Ne([P],ye),e.ParameterInformation=ye;let it=class{constructor(L,ee){this.label=L,this.documentation=ee,this.parameters=[]}};it=Ne([P],it),e.SignatureInformation=it;let q=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};q=Ne([P],q),e.SignatureHelp=q;var X;(function(U){U[U.Invoke=1]="Invoke",U[U.TriggerCharacter=2]="TriggerCharacter",U[U.ContentChange=3]="ContentChange"})(X=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var ge;(function(U){U[U.Other=0]="Other",U[U.Type=1]="Type",U[U.Parameter=2]="Parameter"})(ge=e.InlayHintKind||(e.InlayHintKind={}));let Ue=class{constructor(L,ee,_e){this.text=L,this.position=ee,this.kind=_e}};Ue=Ne([P],Ue),e.InlayHint=Ue;var qe;(function(U){U[U.Invoke=0]="Invoke",U[U.TriggerCharacter=1]="TriggerCharacter",U[U.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(qe=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var nt;(function(U){U[U.Text=0]="Text",U[U.Method=1]="Method",U[U.Function=2]="Function",U[U.Constructor=3]="Constructor",U[U.Field=4]="Field",U[U.Variable=5]="Variable",U[U.Class=6]="Class",U[U.Interface=7]="Interface",U[U.Module=8]="Module",U[U.Property=9]="Property",U[U.Unit=10]="Unit",U[U.Value=11]="Value",U[U.Enum=12]="Enum",U[U.Keyword=13]="Keyword",U[U.Snippet=14]="Snippet",U[U.Color=15]="Color",U[U.File=16]="File",U[U.Reference=17]="Reference",U[U.Folder=18]="Folder",U[U.EnumMember=19]="EnumMember",U[U.Constant=20]="Constant",U[U.Struct=21]="Struct",U[U.Event=22]="Event",U[U.Operator=23]="Operator",U[U.TypeParameter=24]="TypeParameter",U[U.User=25]="User",U[U.Issue=26]="Issue"})(nt=e.CompletionItemKind||(e.CompletionItemKind={}));var mt;(function(U){U[U.Deprecated=1]="Deprecated"})(mt=e.CompletionItemTag||(e.CompletionItemTag={}));let lt=class{constructor(L,ee){this.label=L,this.kind=ee}toJSON(){return{label:this.label,kind:this.kind&&nt[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};lt=Ne([P],lt),e.CompletionItem=lt;let St=class{constructor(L=[],ee=!1){this.items=L,this.isIncomplete=ee}};St=Ne([P],St),e.CompletionList=St;let kt=class{constructor(L,ee,_e){this.text=L,this.range=ee,this.command=_e}};kt=Ne([P],kt),e.InlineSuggestion=kt;let It=class{constructor(L){this.items=L}};It=Ne([P],It),e.InlineSuggestions=It;var Je;(function(U){U[U.Active=-1]="Active",U[U.Beside=-2]="Beside",U[U.One=1]="One",U[U.Two=2]="Two",U[U.Three=3]="Three",U[U.Four=4]="Four",U[U.Five=5]="Five",U[U.Six=6]="Six",U[U.Seven=7]="Seven",U[U.Eight=8]="Eight",U[U.Nine=9]="Nine"})(Je=e.ViewColumn||(e.ViewColumn={}));var bt;(function(U){U[U.Left=1]="Left",U[U.Right=2]="Right"})(bt=e.StatusBarAlignment||(e.StatusBarAlignment={}));var Ie;(function(U){U[U.Off=0]="Off",U[U.On=1]="On",U[U.Relative=2]="Relative"})(Ie=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Se;(function(U){U[U.Manual=1]="Manual",U[U.AfterDelay=2]="AfterDelay",U[U.FocusOut=3]="FocusOut"})(Se=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var pe;(function(U){U[U.Default=0]="Default",U[U.InCenter=1]="InCenter",U[U.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",U[U.AtTop=3]="AtTop"})(pe=e.TextEditorRevealType||(e.TextEditorRevealType={}));var oe;(function(U){U[U.Keyboard=1]="Keyboard",U[U.Mouse=2]="Mouse",U[U.Command=3]="Command"})(oe=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var ae;(function(U){U[U.Undo=1]="Undo",U[U.Redo=2]="Redo"})(ae=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var ue;(function(U){U[U.OpenOpen=0]="OpenOpen",U[U.ClosedClosed=1]="ClosedClosed",U[U.OpenClosed=2]="OpenClosed",U[U.ClosedOpen=3]="ClosedOpen"})(ue=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(U){function L(ee){switch(ee){case"keyboard":return U.Keyboard;case"mouse":return U.Mouse;case"api":return U.Command}}U.fromValue=L}(oe=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let fe=class{constructor(L,ee){if(ee&&!k.URI.isUri(ee))throw(0,M.illegalArgument)("target");if(!S.isRange(L)||L.isEmpty)throw(0,M.illegalArgument)("range");this.range=L,this.target=ee}};fe=Ne([P],fe),e.DocumentLink=fe;let ke=class{constructor(L,ee,_e,He){this.red=L,this.green=ee,this.blue=_e,this.alpha=He}};ke=Ne([P],ke),e.Color=ke;let $e=class{constructor(L,ee){if(ee&&!(ee instanceof ke))throw(0,M.illegalArgument)("color");if(!S.isRange(L)||L.isEmpty)throw(0,M.illegalArgument)("range");this.range=L,this.color=ee}};$e=Ne([P],$e),e.ColorInformation=$e;let Re=class{constructor(L){if(!L||typeof L!="string")throw(0,M.illegalArgument)("label");this.label=L}};Re=Ne([P],Re),e.ColorPresentation=Re;var ze;(function(U){U[U.RGB=0]="RGB",U[U.HEX=1]="HEX",U[U.HSL=2]="HSL"})(ze=e.ColorFormat||(e.ColorFormat={}));var tt;(function(U){U[U.Error=0]="Error",U[U.Warning=1]="Warning",U[U.Information=2]="Information"})(tt=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class rt{constructor(L,ee,_e){if(this.startIndex=L,this.length=ee,this.tooltip=_e,typeof L!="number"||L<0)throw(0,M.illegalArgument)("startIndex");if(typeof ee!="number"||ee<1)throw(0,M.illegalArgument)("length");if(_e!==void 0&&typeof _e!="string")throw(0,M.illegalArgument)("tooltip")}}e.TerminalLink=rt;var ne;(function(U){U[U.Panel=1]="Panel",U[U.Editor=2]="Editor"})(ne=e.TerminalLocation||(e.TerminalLocation={}));class me{constructor(L){this.options=L,typeof L!="object"&&(0,M.illegalArgument)("options")}}e.TerminalProfile=me;var ie;(function(U){U[U.Always=1]="Always",U[U.Silent=2]="Silent",U[U.Never=3]="Never"})(ie=e.TaskRevealKind||(e.TaskRevealKind={}));var H;(function(U){U[U.Shared=1]="Shared",U[U.Dedicated=2]="Dedicated",U[U.New=3]="New"})(H=e.TaskPanelKind||(e.TaskPanelKind={}));let ve=o=class{constructor(L,ee){if(this.label=ee,typeof L!="string"||typeof ee!="string")throw(0,M.illegalArgument)("name");this._id=L}static from(L){switch(L){case"clean":return o.Clean;case"build":return o.Build;case"rebuild":return o.Rebuild;case"test":return o.Test;default:return}}get id(){return this._id}};ve.Clean=new o("clean","Clean"),ve.Build=new o("build","Build"),ve.Rebuild=new o("rebuild","Rebuild"),ve.Test=new o("test","Test"),ve=o=Ne([P],ve),e.TaskGroup=ve;function De(U){let L="";for(let ee=0;ee<U.length;ee++)L+=U[ee].replace(/,/g,",,")+",";return L}let je=class{constructor(L,ee,_e){if(typeof L!="string")throw(0,M.illegalArgument)("process");this._args=[],this._process=L,ee!==void 0&&(Array.isArray(ee)?(this._args=ee,this._options=_e):this._options=ee)}get process(){return this._process}set process(L){if(typeof L!="string")throw(0,M.illegalArgument)("process");this._process=L}get args(){return this._args}set args(L){Array.isArray(L)||(L=[]),this._args=L}get options(){return this._options}set options(L){this._options=L}computeId(){const L=[];if(L.push("process"),this._process!==void 0&&L.push(this._process),this._args&&this._args.length>0)for(let ee of this._args)L.push(ee);return De(L)}};je=Ne([P],je),e.ProcessExecution=je;let Me=class{constructor(L,ee,_e){if(this._args=[],Array.isArray(ee)){if(!L)throw(0,M.illegalArgument)("command can't be undefined or null");if(typeof L!="string"&&typeof L.value!="string")throw(0,M.illegalArgument)("command");this._command=L,this._args=ee,this._options=_e}else{if(typeof L!="string")throw(0,M.illegalArgument)("commandLine");this._commandLine=L,this._options=ee}}get commandLine(){return this._commandLine}set commandLine(L){if(typeof L!="string")throw(0,M.illegalArgument)("commandLine");this._commandLine=L}get command(){return this._command?this._command:""}set command(L){if(typeof L!="string"&&typeof L.value!="string")throw(0,M.illegalArgument)("command");this._command=L}get args(){return this._args}set args(L){this._args=L||[]}get options(){return this._options}set options(L){this._options=L}computeId(){const L=[];if(L.push("shell"),this._commandLine!==void 0&&L.push(this._commandLine),this._command!==void 0&&L.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let ee of this._args)L.push(typeof ee=="string"?ee:ee.value);return De(L)}};Me=Ne([P],Me),e.ShellExecution=Me;var dt;(function(U){U[U.Escape=1]="Escape",U[U.Strong=2]="Strong",U[U.Weak=3]="Weak"})(dt=e.ShellQuoting||(e.ShellQuoting={}));var wt;(function(U){U[U.Global=1]="Global",U[U.Workspace=2]="Workspace"})(wt=e.TaskScope||(e.TaskScope={}));class Ct{constructor(L){this._callback=L}computeId(){return"customExecution"+(0,F.generateUuid)()}set callback(L){this._callback=L}get callback(){return this._callback}}e.CustomExecution=Ct;let pt=b=class{constructor(L,ee,_e,He,et,st){this.__deprecated=!1,this._definition=this.definition=L;let ct;typeof ee=="string"?(this._name=this.name=ee,this._source=this.source=_e,this.execution=He,ct=et,this.__deprecated=!0):ee===wt.Global||ee===wt.Workspace?(this.target=ee,this._name=this.name=_e,this._source=this.source=He,this.execution=et,ct=st):(this.target=ee,this._name=this.name=_e,this._source=this.source=He,this.execution=et,ct=st),typeof ct=="string"?(this._problemMatchers=[ct],this._hasDefinedMatchers=!0):Array.isArray(ct)?(this._problemMatchers=ct,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(L){this.__id=L}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof je?this._definition={type:b.ProcessType,id:this._execution.computeId()}:this._execution instanceof Me?this._definition={type:b.ShellType,id:this._execution.computeId()}:this._execution instanceof Ct?this._definition={type:b.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:b.EmptyType,id:(0,F.generateUuid)()}}get definition(){return this._definition}set definition(L){if(L==null)throw(0,M.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=L}get scope(){return this._scope}set target(L){this.clear(),this._scope=L}get name(){return this._name}set name(L){if(typeof L!="string")throw(0,M.illegalArgument)("name");this.clear(),this._name=L}get execution(){return this._execution}set execution(L){L===null&&(L=void 0),this.clear(),this._execution=L;const ee=this._definition.type;(b.EmptyType===ee||b.ProcessType===ee||b.ShellType===ee||b.ExtensionCallbackType===ee)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(L){if(Array.isArray(L))this.clear(),this._problemMatchers=L,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(L){L!==!0&&L!==!1&&(L=!1),this.clear(),this._isBackground=L}get source(){return this._source}set source(L){if(typeof L!="string"||L.length===0)throw(0,M.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=L}get group(){return this._group}set group(L){L===null&&(L=void 0),this.clear(),this._group=L}get detail(){return this._detail}set detail(L){L===null&&(L=void 0),this._detail=L}get presentationOptions(){return this._presentationOptions}set presentationOptions(L){L==null&&(L=Object.create(null)),this.clear(),this._presentationOptions=L}get runOptions(){return this._runOptions}set runOptions(L){L==null&&(L=Object.create(null)),this.clear(),this._runOptions=L}};pt.ExtensionCallbackType="customExecution",pt.ProcessType="process",pt.ShellType="shell",pt.EmptyType="$empty",pt=b=Ne([P],pt),e.Task=pt;var ut;(function(U){U[U.SourceControl=1]="SourceControl",U[U.Window=10]="Window",U[U.Notification=15]="Notification"})(ut=e.ProgressLocation||(e.ProgressLocation={}));let ht=class{constructor(L,ee=vt.None){this.collapsibleState=ee,k.URI.isUri(L)?this.resourceUri=L:this.label=L}};ht=Ne([P],ht),e.TreeItem=ht;var vt;(function(U){U[U.None=0]="None",U[U.Collapsed=1]="Collapsed",U[U.Expanded=2]="Expanded"})(vt=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let Ft=class{constructor(L){this._value=L}async asString(){return JSON.stringify(this._value)}};Ft=Ne([P],Ft),e.TreeDataTransferItem=Ft;let Tt=class{constructor(){this._items=new Map}get(L){return this._items.get(L)}set(L,ee){this._items.set(L,ee)}forEach(L){this._items.forEach(L)}};Tt=Ne([P],Tt),e.TreeDataTransfer=Tt;let Mt=class{constructor(L,ee){this.id=L,this.color=ee}};Mt=Ne([P],Mt),e.ThemeIcon=Mt,Mt.File=new Mt("file"),Mt.Folder=new Mt("folder");let xt=class{constructor(L){this.id=L}};xt=Ne([P],xt),e.ThemeColor=xt;var At;(function(U){U[U.Global=1]="Global",U[U.Workspace=2]="Workspace",U[U.WorkspaceFolder=3]="WorkspaceFolder"})(At=e.ConfigurationTarget||(e.ConfigurationTarget={}));let ri=class{constructor(L,ee){if(typeof L!="string"&&(!L||!k.URI.isUri(L)&&!k.URI.isUri(L.uri)))throw(0,M.illegalArgument)("base");if(typeof ee!="string")throw(0,M.illegalArgument)("pattern");typeof L=="string"?(this.baseFolder=k.URI.file(L),this.base=L):k.URI.isUri(L)?(this.baseFolder=L,this.base=L.fsPath):(this.baseFolder=L.uri,this.base=L.uri.fsPath),this.pattern=ee}};ri=Ne([P],ri),e.RelativePattern=ri;let zt=class{constructor(L,ee,_e,He){this.enabled=typeof L=="boolean"?L:!0,typeof ee=="string"&&(this.condition=ee),typeof _e=="string"&&(this.hitCondition=_e),typeof He=="string"&&(this.logMessage=He)}get id(){return this._id||(this._id=(0,F.generateUuid)()),this._id}};zt=Ne([P],zt),e.Breakpoint=zt;let Et=class extends zt{constructor(L,ee,_e,He,et){super(ee,_e,He,et);if(L===null)throw(0,M.illegalArgument)("location");this.location=L}};Et=Ne([P],Et),e.SourceBreakpoint=Et;let Kt=class extends zt{constructor(L,ee,_e,He,et){super(ee,_e,He,et);this.functionName=L}};Kt=Ne([P],Kt),e.FunctionBreakpoint=Kt;let Ht=class extends zt{constructor(L,ee,_e,He,et,st,ct){super(He,et,st,ct);if(!ee)throw(0,M.illegalArgument)("dataId");this.label=L,this.dataId=ee,this.canPersist=_e}};Ht=Ne([P],Ht),e.DataBreakpoint=Ht;let oi=class{constructor(L,ee,_e){this.command=L,this.args=ee||[],this.options=_e}};oi=Ne([P],oi),e.DebugAdapterExecutable=oi;let si=class{constructor(L,ee){this.port=L,this.host=ee}};si=Ne([P],si),e.DebugAdapterServer=si;let Pt=class{constructor(L){this.path=L}};Pt=Ne([P],Pt),e.DebugAdapterNamedPipeServer=Pt;let Qt=class{constructor(L){this.implementation=L}};Qt=Ne([P],Qt),e.DebugAdapterInlineImplementation=Qt;let ai=class{constructor(L,ee){this.range=L,this.expression=ee}};ai=Ne([P],ai),e.EvaluatableExpression=ai;var Yt;(function(U){U[U.Automatic=0]="Automatic",U[U.Explicit=1]="Explicit"})(Yt=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let Wt=class{constructor(L,ee){this.range=L,this.text=ee}};Wt=Ne([P],Wt),e.InlineValueText=Wt;let gt=class{constructor(L,ee,_e=!0){this.range=L,this.variableName=ee,this.caseSensitiveLookup=_e}};gt=Ne([P],gt),e.InlineValueVariableLookup=gt;let ci=class{constructor(L,ee){this.range=L,this.expression=ee}};ci=Ne([P],ci),e.InlineValueEvaluatableExpression=ci;let Lt=class{constructor(L,ee){this.frameId=L,this.stoppedLocation=ee}};Lt=Ne([P],Lt),e.InlineValueContext=Lt;var Vt;(function(U){U[U.Changed=1]="Changed",U[U.Created=2]="Created",U[U.Deleted=3]="Deleted"})(Vt=e.FileChangeType||(e.FileChangeType={}));let Xt=d=class extends Error{constructor(L,ee=_.FileSystemProviderErrorCode.Unknown,_e){super(k.URI.isUri(L)?L.toString(!0):L);this.code=_e?.name??"Unknown",(0,_.markAsFileSystemProviderError)(this,ee),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,d.prototype),typeof Error.captureStackTrace=="function"&&typeof _e=="function"&&Error.captureStackTrace(this,_e)}static FileExists(L){return new d(L,_.FileSystemProviderErrorCode.FileExists,d.FileExists)}static FileNotFound(L){return new d(L,_.FileSystemProviderErrorCode.FileNotFound,d.FileNotFound)}static FileNotADirectory(L){return new d(L,_.FileSystemProviderErrorCode.FileNotADirectory,d.FileNotADirectory)}static FileIsADirectory(L){return new d(L,_.FileSystemProviderErrorCode.FileIsADirectory,d.FileIsADirectory)}static NoPermissions(L){return new d(L,_.FileSystemProviderErrorCode.NoPermissions,d.NoPermissions)}static Unavailable(L){return new d(L,_.FileSystemProviderErrorCode.Unavailable,d.Unavailable)}};Xt=d=Ne([P],Xt),e.FileSystemError=Xt;let li=class{constructor(L,ee,_e){this.start=L,this.end=ee,this.kind=_e}};li=Ne([P],li),e.FoldingRange=li;var fi;(function(U){U[U.Comment=1]="Comment",U[U.Imports=2]="Imports",U[U.Region=3]="Region"})(fi=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Ei;(function(U){U[U.Collapsed=0]="Collapsed",U[U.Expanded=1]="Expanded"})(Ei=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var mi;(function(U){U[U.Editing=0]="Editing",U[U.Preview=1]="Preview"})(mi=e.CommentMode||(e.CommentMode={}));class Jt{constructor(L,ee=[]){this.tokenTypes=L,this.tokenModifiers=ee}}e.SemanticTokensLegend=Jt;function _i(U){return typeof U=="undefined"||(0,C.isStringArray)(U)}class jt{constructor(L){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,L){this._hasLegend=!0;for(let ee=0,_e=L.tokenTypes.length;ee<_e;ee++)this._tokenTypeStrToInt.set(L.tokenTypes[ee],ee);for(let ee=0,_e=L.tokenModifiers.length;ee<_e;ee++)this._tokenModifierStrToInt.set(L.tokenModifiers[ee],ee)}}push(L,ee,_e,He,et){if(typeof L=="number"&&typeof ee=="number"&&typeof _e=="number"&&typeof He=="number"&&(typeof et=="number"||typeof et=="undefined"))return typeof et=="undefined"&&(et=0),this._pushEncoded(L,ee,_e,He,et);if(S.isRange(L)&&typeof ee=="string"&&_i(_e))return this._push(L,ee,_e);throw(0,M.illegalArgument)()}_push(L,ee,_e){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(L.start.line!==L.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(ee))throw new Error("`tokenType` is not in the provided legend");const He=L.start.line,et=L.start.character,st=L.end.character-L.start.character,ct=this._tokenTypeStrToInt.get(ee);let Dt=0;if(_e)for(const Rt of _e){if(!this._tokenModifierStrToInt.has(Rt))throw new Error("`tokenModifier` is not in the provided legend");const Nt=this._tokenModifierStrToInt.get(Rt);Dt|=1<<Nt>>>0}this._pushEncoded(He,et,st,ct,Dt)}_pushEncoded(L,ee,_e,He,et){if(this._dataIsSortedAndDeltaEncoded&&(L<this._prevLine||L===this._prevLine&&ee<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const Dt=this._data.length/5|0;let Rt=0,Nt=0;for(let Ut=0;Ut<Dt;Ut++){let Bt=this._data[5*Ut],di=this._data[5*Ut+1];Bt===0?(Bt=Rt,di+=Nt):Bt+=Rt,this._data[5*Ut]=Bt,this._data[5*Ut+1]=di,Rt=Bt,Nt=di}}let st=L,ct=ee;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(st-=this._prevLine,st===0&&(ct-=this._prevChar)),this._data[this._dataLen++]=st,this._data[this._dataLen++]=ct,this._data[this._dataLen++]=_e,this._data[this._dataLen++]=He,this._data[this._dataLen++]=et,this._prevLine=L,this._prevChar=ee}static _sortAndDeltaEncode(L){let ee=[];const _e=L.length/5|0;for(let ct=0;ct<_e;ct++)ee[ct]=ct;ee.sort((ct,Dt)=>{const Rt=L[5*ct],Nt=L[5*Dt];if(Rt===Nt){const Ut=L[5*ct+1],Bt=L[5*Dt+1];return Ut-Bt}return Rt-Nt});const He=new Uint32Array(L.length);let et=0,st=0;for(let ct=0;ct<_e;ct++){const Dt=5*ee[ct],Rt=L[Dt+0],Nt=L[Dt+1],Ut=L[Dt+2],Bt=L[Dt+3],di=L[Dt+4],zi=Rt-et,Yi=zi===0?Nt-st:Nt,hi=5*ct;He[hi+0]=zi,He[hi+1]=Yi,He[hi+2]=Ut,He[hi+3]=Bt,He[hi+4]=di,et=Rt,st=Nt}return He}build(L){return this._dataIsSortedAndDeltaEncoded?new qt(new Uint32Array(this._data),L):new qt(jt._sortAndDeltaEncode(this._data),L)}}e.SemanticTokensBuilder=jt;class qt{constructor(L,ee){this.resultId=ee,this.data=L}}e.SemanticTokens=qt;class yi{constructor(L,ee,_e){this.start=L,this.deleteCount=ee,this.data=_e}}e.SemanticTokensEdit=yi;class Si{constructor(L,ee){this.resultId=ee,this.edits=L}}e.SemanticTokensEdits=Si;var Gt;(function(U){U[U.Separate=0]="Separate",U[U.MergeWithParent=1]="MergeWithParent"})(Gt=e.DebugConsoleMode||(e.DebugConsoleMode={}));var Ci;(function(U){U[U.Initial=1]="Initial",U[U.Dynamic=2]="Dynamic"})(Ci=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let Zt=class{constructor(){}};Zt.Back={iconPath:new Mt("arrow-left")},Zt=Ne([P],Zt),e.QuickInputButtons=Zt;var Di;(function(U){U[U.Default=1]="Default",U[U.Separator=2]="Separator"})(Di=e.QuickPickItemKind||(e.QuickPickItemKind={}));var ki;(function(U){U[U.UI=1]="UI",U[U.Workspace=2]="Workspace"})(ki=e.ExtensionKind||(e.ExtensionKind={}));class ui{constructor(L,ee,_e){this.badge=L,this.tooltip=ee,this.color=_e}static validate(L){if(L.badge){let ee=(0,T.nextCharLength)(L.badge,0);if(ee<L.badge.length&&(ee+=(0,T.nextCharLength)(L.badge,ee)),L.badge.length>ee)throw new Error("The 'badge'-property must be undefined or a short character")}if(!L.color&&!L.badge&&!L.tooltip)throw new Error("The decoration is empty");return!0}}e.FileDecoration=ui;let ei=class{constructor(L){this.kind=L}};ei=Ne([P],ei),e.ColorTheme=ei;var gi;(function(U){U[U.Light=1]="Light",U[U.Dark=2]="Dark",U[U.HighContrast=3]="HighContrast"})(gi=e.ColorThemeKind||(e.ColorThemeKind={}));class Ae{constructor(L,ee){if(L<0)throw(0,M.illegalArgument)("start must be positive");if(ee<0)throw(0,M.illegalArgument)("end must be positive");L<=ee?(this._start=L,this._end=ee):(this._start=ee,this._end=L)}static isNotebookRange(L){return L instanceof Ae?!0:L?typeof L.start=="number"&&typeof L.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(L){let ee=this._start,_e=this._end;return L.start!==void 0&&(ee=L.start),L.end!==void 0&&(_e=L.end),ee===this._start&&_e===this._end?this:new Ae(ee,_e)}}e.NotebookRange=Ae;class Ot{constructor(L,ee,_e,He,et,st,ct){this.kind=L,this.value=ee,this.languageId=_e,this.mime=He,this.outputs=et??[],this.metadata=st,this.executionSummary=ct,Ot.validate(this)}static validate(L){if(typeof L.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof L.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof L.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(L){return Array.isArray(L)&&L.every(ee=>Ot.isNotebookCellData(ee))}static isNotebookCellData(L){return!0}}e.NotebookCellData=Ot;class pi{constructor(L){this.cells=L}}e.NotebookData=pi;class ft{constructor(L,ee){this.data=L,this.mime=ee;const _e=(0,t.normalizeMimeType)(ee,!0);if(!_e)throw new Error(`INVALID mime type: ${ee}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=_e}static isNotebookCellOutputItem(L){return L instanceof ft?!0:L?typeof L.mime=="string"&&L.data instanceof Uint8Array:!1}static error(L){const ee={name:L.name,message:L.message,stack:L.stack};return ft.json(ee,"application/vnd.code.notebook.error")}static stdout(L){return ft.text(L,"application/vnd.code.notebook.stdout")}static stderr(L){return ft.text(L,"application/vnd.code.notebook.stderr")}static bytes(L,ee="application/octet-stream"){return new ft(L,ee)}static text(L,ee=t.Mimes.text){const _e=Te(ft,c,"f",p).encode(String(L));return new ft(_e,ee)}static json(L,ee="application/json"){const _e=JSON.stringify(L,void 0,"	");return ft.text(_e,ee)}}e.NotebookCellOutputItem=ft,c=ft,p={value:new TextEncoder};class ti{constructor(L,ee,_e){this.items=ti.ensureUniqueMimeTypes(L,!0),typeof ee=="string"?(this.id=ee,this.metadata=_e):(this.id=(0,F.generateUuid)(),this.metadata=ee??_e)}static isNotebookCellOutput(L){return L instanceof ti?!0:!L||typeof L!="object"?!1:typeof L.id=="string"&&(0,C.isArray)(L.items)}static ensureUniqueMimeTypes(L,ee=!1){const _e=new Set,He=new Set;for(let et=0;et<L.length;et++){const st=L[et],ct=(0,t.normalizeMimeType)(st.mime);if(!_e.has(ct)){_e.add(ct);continue}He.add(et),ee&&console.warn(`DUPLICATED mime type '${st.mime}' will be dropped`)}return He.size===0?L:L.filter((et,st)=>!He.has(st))}}e.NotebookCellOutput=ti;var Ii;(function(U){U[U.Markup=1]="Markup",U[U.Code=2]="Code"})(Ii=e.NotebookCellKind||(e.NotebookCellKind={}));var vi;(function(U){U[U.Idle=1]="Idle",U[U.Pending=2]="Pending",U[U.Executing=3]="Executing"})(vi=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var bi;(function(U){U[U.Left=1]="Left",U[U.Right=2]="Right"})(bi=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var Pi;(function(U){U[U.Default=0]="Default",U[U.InCenter=1]="InCenter",U[U.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",U[U.AtTop=3]="AtTop"})(Pi=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Ti{constructor(L,ee){this.text=L,this.alignment=ee}}e.NotebookCellStatusBarItem=Ti;var Ai;(function(U){U[U.Default=1]="Default",U[U.Preferred=2]="Preferred"})(Ai=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class Ri{constructor(L,ee=[]){this.uri=L,this.provides=(0,u.asArray)(ee)}}e.NotebookRendererScript=Ri;let ii=class{constructor(L,ee){this.label=L,this.timestamp=ee}};ii=Ne([P],ii),e.TimelineItem=ii;var Fi;(function(U){U[U.Production=1]="Production",U[U.Development=2]="Development",U[U.Test=3]="Test"})(Fi=e.ExtensionMode||(e.ExtensionMode={}));var Mi;(function(U){U[U.Node=1]="Node",U[U.Webworker=2]="Webworker"})(Mi=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Li;(function(U){U[U.Other=0]="Other",U[U.Comment=1]="Comment",U[U.String=2]="String",U[U.RegEx=4]="RegEx"})(Li=e.StandardTokenType||(e.StandardTokenType={}));class Oi{constructor(L,ee){this.ranges=L,this.wordPattern=ee}}e.LinkedEditingRanges=Oi;class Ni{constructor(L,ee){this._port=L,this._autoForwardAction=ee}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Ni;var Y;(function(U){U[U.Queued=1]="Queued",U[U.Running=2]="Running",U[U.Passed=3]="Passed",U[U.Failed=4]="Failed",U[U.Skipped=5]="Skipped",U[U.Errored=6]="Errored"})(Y=e.TestResultState||(e.TestResultState={}));var ce;(function(U){U[U.Run=1]="Run",U[U.Debug=2]="Debug",U[U.Coverage=3]="Coverage"})(ce=e.TestRunProfileKind||(e.TestRunProfileKind={}));let Ce=class{constructor(L=void 0,ee=void 0,_e=void 0){this.include=L,this.exclude=ee,this.profile=_e}};Ce=Ne([P],Ce),e.TestRunRequest=Ce;let at=E=class{constructor(L){this.message=L}static diff(L,ee,_e){const He=new E(L);return He.expectedOutput=ee,He.actualOutput=_e,He}};at=E=Ne([P],at),e.TestMessage=at;let _t=class{constructor(L){this.id=L}};_t=Ne([P],_t),e.TestTag=_t;let yt=class{constructor(L,ee){this.covered=L,this.total=ee}};yt=Ne([P],yt),e.CoveredCount=yt;let xi=R=class{constructor(L,ee,_e,He){this.uri=L,this.statementCoverage=ee,this.branchCoverage=_e,this.functionCoverage=He}static fromDetails(L,ee){const _e=new yt(0,0),He=new yt(0,0),et=new yt(0,0);for(const ct of ee)if("branches"in ct){_e.total+=1,_e.covered+=ct.executionCount>0?1:0;for(const Dt of ct.branches)He.total+=1,He.covered+=Dt.executionCount>0?1:0}else et.total+=1,et.covered+=ct.executionCount>0?1:0;const st=new R(L,_e,He.total>0?He:void 0,et.total>0?et:void 0);return st.detailedCoverage=ee,st}};xi=R=Ne([P],xi),e.FileCoverage=xi;let Ui=class{constructor(L,ee,_e=[]){this.executionCount=L,this.location=ee,this.branches=_e}};Ui=Ne([P],Ui),e.StatementCoverage=Ui;let Bi=class{constructor(L,ee){this.executionCount=L,this.location=ee}};Bi=Ne([P],Bi),e.BranchCoverage=Bi;let $i=class{constructor(L,ee){this.executionCount=L,this.location=ee}};$i=Ne([P],$i),e.FunctionCoverage=$i;var qi;(function(U){U[U.None=0]="None",U[U.Option=1]="Option",U[U.Default=2]="Default",U[U.Preferred=3]="Preferred"})(qi=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var Gi;(function(U){U[U.Untrusted=0]="Untrusted",U[U.Trusted=1]="Trusted",U[U.Unspecified=2]="Unspecified"})(Gi=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var Ki;(function(U){U[U.Notify=1]="Notify",U[U.OpenBrowser=2]="OpenBrowser",U[U.OpenPreview=3]="OpenPreview",U[U.Silent=4]="Silent",U[U.Ignore=5]="Ignore",U[U.OpenBrowserOnce=6]="OpenBrowserOnce"})(Ki=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class Qi{constructor(L,ee,_e,He,et,st){this.kind=L,this.name=ee,this.detail=_e,this.uri=He,this.range=et,this.selectionRange=st}}e.TypeHierarchyItem=Qi}),define(we[87],Ee([0,1,41,11,9,228,118,7,16]),function(re,e,u,M,w,A,t,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const k=new Map;function F(a,c){c?k.set(a,c):k.delete(a)}e.setWordDefinitionFor=F;function _(a){return k.get(a)}e.getWordDefinitionFor=_;class n extends A.MirrorTextModel{constructor(c,p,D,f,l,h,y,s){super(p,D,f,l);this._proxy=c,this._languageId=h,this._isDirty=y,this._notebook=s,this._isDisposed=!1}dispose(){(0,u.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(c){return(0,C.equals)(this._lines,c)}get document(){if(!this._document){const c=this;this._document={get uri(){return c._uri},get fileName(){return c._uri.fsPath},get isUntitled(){return c._uri.scheme===M.Schemas.untitled},get languageId(){return c._languageId},get version(){return c._versionId},get isClosed(){return c._isDisposed},get isDirty(){return c._isDirty},get notebook(){return c._notebook},save(){return c._save()},getText(p){return p?c._getTextInRange(p):c.getText()},get eol(){return c._eol===`
`?T.EndOfLine.LF:T.EndOfLine.CRLF},get lineCount(){return c._lines.length},lineAt(p){return c._lineAt(p)},offsetAt(p){return c._offsetAt(p)},positionAt(p){return c._positionAt(p)},validateRange(p){return c._validateRange(p)},validatePosition(p){return c._validatePosition(p)},getWordRangeAtPosition(p,D){return c._getWordRangeAtPosition(p,D)}}}return Object.freeze(this._document)}_acceptLanguageId(c){(0,u.ok)(!this._isDisposed),this._languageId=c}_acceptIsDirty(c){(0,u.ok)(!this._isDisposed),this._isDirty=c}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(c){const p=this._validateRange(c);if(p.isEmpty)return"";if(p.isSingleLine)return this._lines[p.start.line].substring(p.start.character,p.end.character);const D=this._eol,f=p.start.line,l=p.end.line,h=[];h.push(this._lines[f].substring(p.start.character));for(let y=f+1;y<l;y++)h.push(this._lines[y]);return h.push(this._lines[l].substring(0,p.end.character)),h.join(D)}_lineAt(c){let p;if(c instanceof T.Position?p=c.line:typeof c=="number"&&(p=c),typeof p!="number"||p<0||p>=this._lines.length||Math.floor(p)!==p)throw new Error("Illegal value for `line`");return new g(p,this._lines[p],p===this._lines.length-1)}_offsetAt(c){return c=this._validatePosition(c),this._ensureLineStarts(),this._lineStarts.getPrefixSum(c.line-1)+c.character}_positionAt(c){c=Math.floor(c),c=Math.max(0,c),this._ensureLineStarts();const p=this._lineStarts.getIndexOf(c),D=this._lines[p.index].length;return new T.Position(p.index,Math.min(p.remainder,D))}_validateRange(c){if(!(c instanceof T.Range))throw new Error("Invalid argument");const p=this._validatePosition(c.start),D=this._validatePosition(c.end);return p===c.start&&D===c.end?c:new T.Range(p.line,p.character,D.line,D.character)}_validatePosition(c){if(!(c instanceof T.Position))throw new Error("Invalid argument");if(this._lines.length===0)return c.with(0,0);let{line:p,character:D}=c,f=!1;if(p<0)p=0,D=0,f=!0;else if(p>=this._lines.length)p=this._lines.length-1,D=this._lines[p].length,f=!0;else{const l=this._lines[p].length;D<0?(D=0,f=!0):D>l&&(D=l,f=!0)}return f?new T.Position(p,D):c}_getWordRangeAtPosition(c,p){const D=this._validatePosition(c);if(!p)p=_(this._languageId);else if((0,w.regExpLeadsToEndlessLoop)(p))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${p.source}' because it matches the empty string.`);const f=(0,t.getWordAtText)(D.character+1,(0,t.ensureValidWordDefinition)(p),this._lines[D.line],0);if(f)return new T.Range(D.line,f.startColumn-1,D.line,f.endColumn-1)}}e.ExtHostDocumentData=n;class g{constructor(c,p,D){this._line=c,this._text=p,this._isLastLine=D}get lineNumber(){return this._line}get text(){return this._text}get range(){return new T.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new T.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=g}),define(we[154],Ee([0,1,7,3,229,6,56,21,2,36]),function(re,e,u,M,w,A,t,T,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class F{constructor(n,g,a,c){this._notebook=a,this._selector=c,this._disposables=new A.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new M.Emitter,this.onDidChange=this._onDidChange.event,this.uri=C.URI.from({scheme:"vscode-concat-doc",path:(0,k.generateUuid)()}),this._init(),this._disposables.add(g.onDidChangeDocument(D=>{const f=this._cellUris.get(D.document.uri);f!==void 0&&(this._cellLengths.setValue(f,this._cells[f].document.getText().length+1),this._cellLines.setValue(f,this._cells[f].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const p=D=>{D===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(n.onDidChangeNotebookCells(D=>p(D.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new T.ResourceMap;const n=[],g=[];for(const a of this._notebook.getCells())a.kind===u.NotebookCellKind.Code&&(!this._selector||(0,t.score)(this._selector,a.document.uri,a.document.languageId,!0))&&(this._cellUris.set(a.document.uri,this._cells.length),this._cells.push(a),n.push(a.document.getText().length+1),g.push(a.document.lineCount));this._cellLengths=new w.PrefixSumComputer(new Uint32Array(n)),this._cellLines=new w.PrefixSumComputer(new Uint32Array(g))}get version(){return this._versionId}getText(n){if(!n){let f="";for(const l of this._cells)f+=l.document.getText()+`
`;return f=f.slice(0,-1),f}if(n.isEmpty)return"";const g=this.locationAt(n.start),a=this.locationAt(n.end),c=this._cellUris.get(g.uri),p=this._cellUris.get(a.uri);if(c===void 0||p===void 0)return"";if(c===p)return this._cells[c].document.getText(new u.Range(g.range.start,a.range.end));const D=[this._cells[c].document.getText(new u.Range(g.range.start,new u.Position(this._cells[c].document.lineCount,0)))];for(let f=c+1;f<p;f++)D.push(this._cells[f].document.getText());return D.push(this._cells[p].document.getText(new u.Range(new u.Position(0,0),a.range.end))),D.join(`
`)}offsetAt(n){const g=this._cellLines.getIndexOf(n.line),a=this._cellLengths.getPrefixSum(g.index-1),c=this._cells[g.index].document.offsetAt(n.with(g.remainder));return a+c}positionAt(n){if(typeof n=="number"){const a=this._cellLengths.getIndexOf(n),c=this._cellLines.getPrefixSum(a.index-1);return this._cells[a.index].document.positionAt(a.remainder).translate(c)}const g=this._cellUris.get(n.uri);if(g!==void 0){const a=this._cellLines.getPrefixSum(g-1);return new u.Position(a+n.range.start.line,n.range.start.character)}return new u.Position(0,0)}locationAt(n){u.Range.isRange(n)||(n=new u.Range(n,n));const g=this._cellLines.getIndexOf(n.start.line);let a=g;n.isEmpty||(a=this._cellLines.getIndexOf(n.end.line));const c=new u.Position(g.remainder,n.start.character),p=new u.Position(a.remainder,n.end.character),D=new u.Range(c,p),f=this._cells[g.index];return new u.Location(f.document.uri,f.document.validateRange(D))}contains(n){return this._cellUris.has(n)}validateRange(n){const g=this.validatePosition(n.start),a=this.validatePosition(n.end);return n.with(g,a)}validatePosition(n){const g=this._cellLines.getIndexOf(n.line),a=new u.Position(g.remainder,n.character),c=this._cells[g.index].document.validatePosition(a),p=this._cellLines.getPrefixSum(g.index-1);return new u.Position(p+c.line,c.character)}}e.ExtHostNotebookConcatDocument=F}),define(we[155],Ee([0,1,7,13,3]),function(re,e,u,M,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let A=class{constructor(T){this._actual=new u.ColorTheme(u.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new w.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(T){let C=T==="light"?u.ColorThemeKind.Light:T==="dark"?u.ColorThemeKind.Dark:u.ColorThemeKind.HighContrast;this._actual=new u.ColorTheme(C),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};A=Ne([xe(0,M.IExtHostRpcService)],A),e.ExtHostTheming=A}),define(we[66],Ee([0,1,4]),function(re,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,u.createDecorator)("IURITransformerService");class M{constructor(A){A?(this.transformIncoming=A.transformIncoming.bind(A),this.transformOutgoing=A.transformOutgoing.bind(A),this.transformOutgoingURI=A.transformOutgoingURI.bind(A),this.transformOutgoingScheme=A.transformOutgoingScheme.bind(A)):(this.transformIncoming=t=>t,this.transformOutgoing=t=>t,this.transformOutgoingURI=t=>t,this.transformOutgoingScheme=t=>t)}}e.URITransformerService=M}),define(we[156],Ee([0,1,22]),function(re,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class M{constructor(){this.buffers=[]}add(C){let k=this.buffers.indexOf(C);return k<0&&(k=this.buffers.length,this.buffers.push(C)),k}}function w(T,C){if(C.serializeBuffersForPostMessage){const k=new M,F=(g,a)=>{if(a instanceof ArrayBuffer){const c=k.add(a);return{$$vscode_array_buffer_reference$$:!0,index:c}}else if(ArrayBuffer.isView(a)){const c=A(a);if(c){const p=k.add(a.buffer);return{$$vscode_array_buffer_reference$$:!0,index:p,view:{type:c,byteLength:a.byteLength,byteOffset:a.byteOffset}}}}return a},_=JSON.stringify(T,F),n=k.buffers.map(g=>{const a=new Uint8Array(g);return u.VSBuffer.wrap(a)});return{message:_,buffers:n}}else return{message:JSON.stringify(T),buffers:[]}}e.serializeWebviewMessage=w;function A(T){switch(T.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function t(T,C){const k=C.map(n=>{const g=new ArrayBuffer(n.byteLength);return new Uint8Array(g).set(n.buffer),g}),F=C.length?(n,g)=>{if(typeof g=="object"&&g.$$vscode_array_buffer_reference$$){const a=g,{index:c}=a,p=k[c];if(a.view)switch(a.view.type){case 1:return new Int8Array(p,a.view.byteOffset,a.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(p,a.view.byteOffset,a.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(p,a.view.byteOffset,a.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(p,a.view.byteOffset,a.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(p,a.view.byteOffset,a.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(p,a.view.byteOffset,a.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(p,a.view.byteOffset,a.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(p,a.view.byteOffset,a.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(p,a.view.byteOffset,a.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(p,a.view.byteOffset,a.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(p,a.view.byteOffset,a.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return p}return g}:void 0;return{message:JSON.parse(T,F),arrayBuffers:k}}e.deserializeWebviewMessage=t}),define(we[157],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeDataTransferConverter=void 0;var u;(function(M){function w(t){const T=new Map;return t.types.forEach((C,k)=>{T.set(C,{asString:async()=>t.items[k].asString})}),T}M.toITreeDataTransfer=w;async function A(t){const T={types:[],items:[]},C=Array.from(t.entries());for(const k of C)T.types.push(k[0]),T.items.push({asString:await k[1].asString()});return T}M.toTreeDataTransferDTO=A})(u=e.TreeDataTransferConverter||(e.TreeDataTransferConverter={}))}),define(we[67],Ee([0,1,11,2]),function(re,e,u,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function w(T,C){return T.scheme===u.Schemas.http||T.scheme===u.Schemas.https?T:(C&&C.authority&&C.isRemote&&T.scheme===u.Schemas.file&&(T=M.URI.from({scheme:u.Schemas.vscodeRemote,authority:C.authority,path:T.path})),M.URI.from({scheme:u.Schemas.https,authority:`${T.scheme}+${A(T.authority)}.${e.webviewRootResourceAuthority}`,path:T.path,fragment:T.fragment,query:T.query}))}e.asWebviewUri=w;function A(T){return T.replace(/./g,C=>{const k=C.charCodeAt(0);return k>=97&&k<=122||k>=65&&k<=90||k>=48&&k<=57?C:"-"+k.toString(16).padStart(4,"0")})}function t(T){return T.replace(/-([0-9a-f]{4})/g,(C,k)=>String.fromCharCode(parseInt(k,16)))}e.decodeAuthority=t}),define(we[158],Ee([0,1,3,6,67]),function(re,e,u,M,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class A{constructor(T,C,k){this._proxy=T,this._editors=C,this._initData=k,this._handlePool=0,this._disposables=new M.DisposableStore,this._insets=new Map,this._disposables.add(C.onDidChangeVisibleTextEditors(()=>{const F=C.getVisibleTextEditors();for(const _ of this._insets.values())F.indexOf(_.editor)<0&&_.inset.dispose()}))}dispose(){this._insets.forEach(T=>T.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(T,C,k,F,_){let n;for(const l of this._editors.getVisibleTextEditors(!0))if(l.value===T){n=l;break}if(!n)throw new Error("not a visible editor");const g=this,a=this._handlePool++,c=new u.Emitter,p=new u.Emitter,D=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(l){return(0,w.asWebviewUri)(l,g._initData.remote)}get cspSource(){return w.webviewGenericCspSource}set options(l){this._options=l,g._proxy.$setOptions(a,l)}get options(){return this._options}set html(l){this._html=l,g._proxy.$setHtml(a,l)}get html(){return this._html}get onDidReceiveMessage(){return c.event}postMessage(l){return g._proxy.$postMessage(a,l)}},f=new class{constructor(){this.editor=T,this.line=C,this.height=k,this.webview=D,this.onDidDispose=p.event}dispose(){g._insets.has(a)&&(g._insets.delete(a),g._proxy.$disposeEditorInset(a),p.fire(),p.dispose(),c.dispose())}};return this._proxy.$createEditorInset(a,n.id,n.value.document.uri,C+1,k,F||{},_.identifier,_.extensionLocation),this._insets.set(a,{editor:T,inset:f,onDidReceiveMessage:c}),f}$onDidDispose(T){const C=this._insets.get(T);C&&C.inset.dispose()}$onDidReceiveMessage(T,C){const k=this._insets.get(T);k&&k.onDidReceiveMessage.fire(C)}}e.ExtHostEditorInsets=A}),define(we[159],Ee([0,1,130,10,2,6,4,45,30,46,16,11]),function(re,e,u,M,w,A,t,T,C,k,F,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.EditorAreaVisibleContext=e.SplitEditorsVertically=e.IsCenteredLayoutContext=e.InEditorZenModeContext=e.EditorsVisibleContext=e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext=e.ActiveEditorGroupLockedContext=e.ActiveEditorGroupLastContext=e.ActiveEditorGroupIndexContext=e.ActiveEditorGroupEmptyContext=e.EditorGroupEditorsCountContext=e.SideBySideEditorActiveContext=e.TextCompareEditorActiveContext=e.TextCompareEditorVisibleContext=e.ActiveEditorAvailableEditorIdsContext=e.ActiveEditorContext=e.ActiveEditorCanSplitInGroupContext=e.ActiveEditorCanRevertContext=e.ActiveEditorReadonlyContext=e.ActiveEditorStickyContext=e.ActiveEditorPinnedContext=e.ActiveEditorDirtyContext=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,u.localize)(0,null),providerDisplayName:(0,u.localize)(1,null)},e.ActiveEditorDirtyContext=new T.RawContextKey("activeEditorIsDirty",!1,(0,u.localize)(2,null)),e.ActiveEditorPinnedContext=new T.RawContextKey("activeEditorIsNotPreview",!1,(0,u.localize)(3,null)),e.ActiveEditorStickyContext=new T.RawContextKey("activeEditorIsPinned",!1,(0,u.localize)(4,null)),e.ActiveEditorReadonlyContext=new T.RawContextKey("activeEditorIsReadonly",!1,(0,u.localize)(5,null)),e.ActiveEditorCanRevertContext=new T.RawContextKey("activeEditorCanRevert",!1,(0,u.localize)(6,null)),e.ActiveEditorCanSplitInGroupContext=new T.RawContextKey("activeEditorCanSplitInGroup",!0),e.ActiveEditorContext=new T.RawContextKey("activeEditor",null,{type:"string",description:(0,u.localize)(7,null)}),e.ActiveEditorAvailableEditorIdsContext=new T.RawContextKey("activeEditorAvailableEditorIds","",(0,u.localize)(8,null)),e.TextCompareEditorVisibleContext=new T.RawContextKey("textCompareEditorVisible",!1,(0,u.localize)(9,null)),e.TextCompareEditorActiveContext=new T.RawContextKey("textCompareEditorActive",!1,(0,u.localize)(10,null)),e.SideBySideEditorActiveContext=new T.RawContextKey("sideBySideEditorActive",!1,(0,u.localize)(11,null)),e.EditorGroupEditorsCountContext=new T.RawContextKey("groupEditorsCount",0,(0,u.localize)(12,null)),e.ActiveEditorGroupEmptyContext=new T.RawContextKey("activeEditorGroupEmpty",!1,(0,u.localize)(13,null)),e.ActiveEditorGroupIndexContext=new T.RawContextKey("activeEditorGroupIndex",0,(0,u.localize)(14,null)),e.ActiveEditorGroupLastContext=new T.RawContextKey("activeEditorGroupLast",!1,(0,u.localize)(15,null)),e.ActiveEditorGroupLockedContext=new T.RawContextKey("activeEditorGroupLocked",!1,(0,u.localize)(16,null)),e.MultipleEditorGroupsContext=new T.RawContextKey("multipleEditorGroups",!1,(0,u.localize)(17,null)),e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext.toNegated(),e.EditorsVisibleContext=new T.RawContextKey("editorIsOpen",!1,(0,u.localize)(18,null)),e.InEditorZenModeContext=new T.RawContextKey("inZenMode",!1,(0,u.localize)(19,null)),e.IsCenteredLayoutContext=new T.RawContextKey("isCenteredLayout",!1,(0,u.localize)(20,null)),e.SplitEditorsVertically=new T.RawContextKey("splitEditorsVertically",!1,(0,u.localize)(21,null)),e.EditorAreaVisibleContext=new T.RawContextKey("editorAreaVisible",!0,(0,u.localize)(22,null)),e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";function n(O,S,x){for(const N of x.visibleEditorPanes)if(N.group.id===S&&O.matches(N.input))return N.getViewState()}e.findViewStateForEditor=n;function g(O){if(y(O))return!1;const S=O;return w.URI.isUri(S?.resource)}e.isResourceEditorInput=g;function a(O){if(y(O))return!1;const S=O;return S?.original!==void 0&&S.modified!==void 0}e.isResourceDiffEditorInput=a;function c(O){if(y(O)||a(O))return!1;const S=O;return S?.primary!==void 0&&S.secondary!==void 0}e.isResourceSideBySideEditorInput=c;function p(O){if(y(O))return!1;const S=O;return S?S.resource===void 0||S.resource.scheme===_.Schemas.untitled||S.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=p;var D;(function(O){O[O.SHORT=0]="SHORT",O[O.MEDIUM=1]="MEDIUM",O[O.LONG=2]="LONG"})(D=e.Verbosity||(e.Verbosity={}));var f;(function(O){O[O.EXPLICIT=1]="EXPLICIT",O[O.AUTO=2]="AUTO",O[O.FOCUS_CHANGE=3]="FOCUS_CHANGE",O[O.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(f=e.SaveReason||(e.SaveReason={}));var l;(function(O){O[O.None=0]="None",O[O.Readonly=2]="Readonly",O[O.Untitled=4]="Untitled",O[O.Singleton=8]="Singleton",O[O.RequiresTrust=16]="RequiresTrust",O[O.CanSplitInGroup=32]="CanSplitInGroup",O[O.ForceDescription=64]="ForceDescription"})(l=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class h extends A.Disposable{}e.AbstractEditorInput=h;function y(O){return O instanceof h}e.isEditorInput=y;function s(O){const S=O;return w.URI.isUri(S?.preferredResource)}function I(O){const S=O;return y(S?.primary)&&y(S?.secondary)}e.isSideBySideEditorInput=I;function r(O){const S=O;return y(S?.modified)&&y(S?.original)}e.isDiffEditorInput=r;function i(O){return y(O?.editor)}e.isEditorInputWithOptions=i;function v(O){const S=O;return i(O)&&S?.group!==void 0}e.isEditorInputWithOptionsAndGroup=v;function m(O){const S=O;return typeof S?.groupId=="number"&&y(S.editor)}e.isEditorIdentifier=m;var o;(function(O){O[O.UNKNOWN=0]="UNKNOWN",O[O.REPLACE=1]="REPLACE",O[O.MOVE=2]="MOVE",O[O.UNPIN=3]="UNPIN"})(o=e.EditorCloseContext||(e.EditorCloseContext={}));var b;(function(O){O[O.PRIMARY=1]="PRIMARY",O[O.SECONDARY=2]="SECONDARY",O[O.BOTH=3]="BOTH",O[O.ANY=4]="ANY"})(b=e.SideBySideEditor||(e.SideBySideEditor={}));class d{getOriginalUri(S,x){if(!S)return;if(x?.supportSideBySide){const{primary:V,secondary:B}=this.getSideEditors(S);if(V&&B){if(x?.supportSideBySide===b.BOTH)return{primary:this.getOriginalUri(V,{filterByScheme:x.filterByScheme}),secondary:this.getOriginalUri(B,{filterByScheme:x.filterByScheme})};if(x?.supportSideBySide===b.ANY)return this.getOriginalUri(V,{filterByScheme:x.filterByScheme})??this.getOriginalUri(B,{filterByScheme:x.filterByScheme});S=x.supportSideBySide===b.PRIMARY?V:B}}if(a(S)||c(S))return;const N=s(S)?S.preferredResource:S.resource;return!N||!x||!x.filterByScheme?N:this.filterUri(N,x.filterByScheme)}getSideEditors(S){return I(S)||c(S)?{primary:S.primary,secondary:S.secondary}:r(S)||a(S)?{primary:S.modified,secondary:S.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(S,x){if(!S)return;if(x?.supportSideBySide){const{primary:V,secondary:B}=this.getSideEditors(S);if(V&&B){if(x?.supportSideBySide===b.BOTH)return{primary:this.getCanonicalUri(V,{filterByScheme:x.filterByScheme}),secondary:this.getCanonicalUri(B,{filterByScheme:x.filterByScheme})};if(x?.supportSideBySide===b.ANY)return this.getCanonicalUri(V,{filterByScheme:x.filterByScheme})??this.getCanonicalUri(B,{filterByScheme:x.filterByScheme});S=x.supportSideBySide===b.PRIMARY?V:B}}if(a(S)||c(S))return;const N=S.resource;return!N||!x||!x.filterByScheme?N:this.filterUri(N,x.filterByScheme)}filterUri(S,x){if(Array.isArray(x)){if(x.some(N=>S.scheme===N))return S}else if(x===S.scheme)return S}}e.EditorResourceAccessor=new d;var E;(function(O){O[O.LEFT=0]="LEFT",O[O.RIGHT=1]="RIGHT"})(E=e.CloseDirection||(e.CloseDirection={}));class R{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(S){const x=this.instantiationService=S.get(t.IInstantiationService);for(const[N,V]of this.editorSerializerConstructors)this.createEditorSerializer(N,V,x);this.editorSerializerConstructors.clear()}createEditorSerializer(S,x,N){const V=N.createInstance(x);this.editorSerializerInstances.set(S,V)}registerFileEditorFactory(S){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=S}getFileEditorFactory(){return(0,M.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(S,x){if(this.editorSerializerConstructors.has(S)||this.editorSerializerInstances.has(S))throw new Error(`A editor serializer with type ID '${S}' was already registered.`);return this.instantiationService?this.createEditorSerializer(S,x,this.instantiationService):this.editorSerializerConstructors.set(S,x),(0,A.toDisposable)(()=>{this.editorSerializerConstructors.delete(S),this.editorSerializerInstances.delete(S)})}getEditorSerializer(S){return this.editorSerializerInstances.get(typeof S=="string"?S:S.typeId)}}C.Registry.add(e.EditorExtensions.EditorFactory,new R);async function P(O,S){if(!O||!O.length)return[];const x=await Promise.all(O.map(async N=>{const V=w.URI.revive(N.fileUri);if(!V||!await S.canHandleResource(V))return;let $=N.exists,J=N.type;if(typeof $!="boolean"||typeof J!="number")try{J=(await S.resolve(V)).isFile?k.FileType.File:k.FileType.Unknown,$=!0}catch{$=!1}if(!$&&N.openOnlyIfExists||J!==k.FileType.File)return;const j={selection:$?N.selection:void 0,pinned:!0,override:N.editorOverrideId};let Q;return $?Q={resource:V,options:j}:Q={resource:V,options:j,forceUntitled:!0},Q}));return(0,F.coalesce)(x)}e.pathsToEditors=P;var z;(function(O){O[O.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",O[O.SEQUENTIAL=1]="SEQUENTIAL"})(z=e.EditorsOrder||(e.EditorsOrder={}))}),define(we[160],Ee([0,1,3,14,131]),function(re,e,u,M,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class A{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new u.Emitter,this._onExit=new u.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(T){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=T}onEvent(T){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=T}onRequest(T){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=T}sendResponse(T){T.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${T.command}`)):this.internalSend("response",T)}sendRequest(T,C,k,F){const _={command:T};if(C&&Object.keys(C).length>0&&(_.arguments=C),this.internalSend("request",_),typeof F=="number"){const n=setTimeout(()=>{clearTimeout(n);const g=this.pendingRequests.get(_.seq);if(g){this.pendingRequests.delete(_.seq);const a={type:"response",seq:0,request_seq:_.seq,success:!1,command:T,message:(0,w.localize)(0,null,F,T)};g(a)}},F)}return k&&this.pendingRequests.set(_.seq,k),_.seq}acceptMessage(T){this.messageCallback?this.messageCallback(T):(this.queue.push(T),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(T,C){return T.type!=="event"||C.type!=="event"}async processQueue(){let T;for(;this.queue.length;){if((!T||this.needsTaskBoundaryBetween(this.queue[0],T))&&await(0,M.timeout)(0),T=this.queue.shift(),!T)return;switch(T.type){case"event":this.eventCallback&&this.eventCallback(T);break;case"request":this.requestCallback&&this.requestCallback(T);break;case"response":const C=T,k=this.pendingRequests.get(C.request_seq);k&&(this.pendingRequests.delete(C.request_seq),k(C));break}}}internalSend(T,C){C.type=T,C.seq=this.sequence++,this.sendMessage(C)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const T=new Map;this.pendingRequests.forEach((C,k)=>T.set(k,C)),await(0,M.timeout)(500),T.forEach((C,k)=>{C({type:"response",seq:0,request_seq:k,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(k)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=A}),define(we[161],Ee([0,1,9,2,17,25,11]),function(re,e,u,M,w,A,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const T=/{([^}]+)}/g;function C(r,i,v){return r.replace(T,function(m,o){return i&&o.length>0&&o[0]!=="_"?m:v&&v.hasOwnProperty(o)?v[o]:m})}e.formatPII=C;function k(r){const i={};for(const v of Object.keys(r))v.startsWith("!")||(i[v]=r[v]);return i}e.filterExceptionsFromTelemetry=k;function F(r){return r.configuration.request==="attach"&&!_(r)&&(!r.parentSession||F(r.parentSession))}e.isSessionAttach=F;function _(r){let i=r.configuration.type;if(!!i)return i==="vslsShare"&&(i=r.configuration.adapterProxy.configuration.type),(0,u.equalsIgnoreCase)(i,"extensionhost")||(0,u.equalsIgnoreCase)(i,"pwa-extensionhost")?r:r.parentSession?_(r.parentSession):void 0}e.getExtensionHostDebugSession=_;function n(r){return r.type&&(r.label||r.program||r.runtime)}e.isDebuggerMainContribution=n;function g(r,i,v){let m,o=0,b=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,d=null;for(;d=b.exec(r);){let E=d.index+1,R=E+d[0].length;if(E<=i&&R>=v){m=d[0],o=E;break}}if(m){let E=/\w+/g,R=null;for(;(R=E.exec(m))&&!(R.index+1+o+R[0].length>=v););R&&(m=m.substring(0,E.lastIndex))}return m?{start:o,end:o+m.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=g;const a=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function c(r){return!!(r&&r.match(a))}e.isUri=c;function p(r){if(typeof r.path=="string"&&!(typeof r.sourceReference=="number"&&r.sourceReference>0)){if(c(r.path))return M.URI.parse(r.path);if((0,w.isAbsolute)(r.path))return M.URI.file(r.path)}return r.path}function D(r){if(typeof r.path=="object"){const i=M.URI.revive(r.path);if(i)return i.scheme===t.Schemas.file?i.fsPath:i.toString()}return r.path}function f(r,i){const v=i?p:D,m=(0,A.deepClone)(r);return h(m,(o,b)=>{o&&b&&(b.path=v(b))}),m}e.convertToDAPaths=f;function l(r,i){const v=i?p:D,m=(0,A.deepClone)(r);return h(m,(o,b)=>{!o&&b&&(b.path=v(b))}),m}e.convertToVSCPaths=l;function h(r,i){switch(r.type){case"event":const v=r;switch(v.event){case"output":i(!1,v.body.source);break;case"loadedSource":i(!1,v.body.source);break;case"breakpoint":i(!1,v.body.breakpoint.source);break;default:break}break;case"request":const m=r;switch(m.command){case"setBreakpoints":i(!0,m.arguments.source);break;case"breakpointLocations":i(!0,m.arguments.source);break;case"source":i(!0,m.arguments.source);break;case"gotoTargets":i(!0,m.arguments.source);break;case"launchVSCode":m.arguments.args.forEach(b=>i(!1,b));break;default:break}break;case"response":const o=r;if(o.success&&o.body)switch(o.command){case"stackTrace":o.body.stackFrames.forEach(b=>i(!1,b.source));break;case"loadedSources":o.body.sources.forEach(b=>i(!1,b));break;case"scopes":o.body.scopes.forEach(b=>i(!1,b.source));break;case"setFunctionBreakpoints":o.body.breakpoints.forEach(b=>i(!1,b.source));break;case"setBreakpoints":o.body.breakpoints.forEach(b=>i(!1,b.source));break;default:break}break}}function y(r){return r.filter(i=>!i.presentation?.hidden).sort((i,v)=>i.presentation?v.presentation?i.presentation.group?v.presentation.group?i.presentation.group!==v.presentation.group?i.presentation.group.localeCompare(v.presentation.group):s(i.presentation.order,v.presentation.order):-1:v.presentation.group?1:s(i.presentation.order,v.presentation.order):-1:v.presentation?1:0)}e.getVisibleAndSorted=y;function s(r,i){return typeof r!="number"?typeof i!="number"?0:1:typeof i!="number"?-1:r-i}async function I(r,i){const v=r.getValue("debug.saveBeforeStart",{overrideIdentifier:i.activeTextEditorMode});if(v!=="none"&&(await i.saveAll(),v==="allEditorsInActiveGroup")){const m=i.activeEditorPane;m&&await i.save({editor:m.input,groupId:m.group.id})}await r.reloadConfiguration()}e.saveAllBeforeDebugStart=I}),define(we[88],Ee([0,1,29,162,79,11,17,24,45]),function(re,e,u,M,w,A,t,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var k;(function(E){E[E.Markup=1]="Markup",E[E.Code=2]="Code"})(k=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",w.Mimes.latex,w.Mimes.markdown,"image/png","image/jpeg",w.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[w.Mimes.latex,w.Mimes.markdown,"application/json",w.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var F;(function(E){E[E.Running=1]="Running",E[E.Idle=2]="Idle"})(F=e.NotebookRunState||(e.NotebookRunState={}));var _;(function(E){E[E.Pending=2]="Pending",E[E.Executing=3]="Executing"})(_=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var n;(function(E){E[E.WithHardKernelDependency=0]="WithHardKernelDependency",E[E.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",E[E.Pure=2]="Pure",E[E.Never=3]="Never"})(n=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var g;(function(E){E.Always="always",E.Never="never",E.Optional="optional"})(g=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var a;(function(E){E[E.ModelChange=1]="ModelChange",E[E.Move=2]="Move",E[E.ChangeLanguage=5]="ChangeLanguage",E[E.Initialize=6]="Initialize",E[E.ChangeCellMetadata=7]="ChangeCellMetadata",E[E.Output=8]="Output",E[E.OutputItem=9]="OutputItem",E[E.ChangeCellContent=10]="ChangeCellContent",E[E.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",E[E.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",E[E.ChangeCellMime=13]="ChangeCellMime",E[E.Unknown=100]="Unknown"})(a=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var c;(function(E){E[E.Handle=0]="Handle",E[E.Index=1]="Index"})(c=e.SelectionStateType||(e.SelectionStateType={}));var p;(function(E){E[E.Replace=1]="Replace",E[E.Output=2]="Output",E[E.Metadata=3]="Metadata",E[E.CellLanguage=4]="CellLanguage",E[E.DocumentMetadata=5]="DocumentMetadata",E[E.Move=6]="Move",E[E.OutputItems=7]="OutputItems",E[E.PartialMetadata=8]="PartialMetadata",E[E.PartialInternalMetadata=9]="PartialInternalMetadata"})(p=e.CellEditType||(e.CellEditType={}));var D;(function(E){E.scheme=A.Schemas.vscodeNotebookCell;const R=/^ch(\d{7,})/;function P(V,B){return V.with({scheme:E.scheme,fragment:`ch${B.toString().padStart(7,"0")}${V.scheme!==A.Schemas.file?V.scheme:""}`})}E.generate=P;function z(V){if(V.scheme!==E.scheme)return;const B=R.exec(V.fragment);return B?{handle:Number(B[1]),notebook:V.with({scheme:V.fragment.substr(B[0].length)||A.Schemas.file,fragment:null})}:void 0}E.parse=z;function O(V,B,$){return V.with({scheme:A.Schemas.vscodeNotebookCellOutput,fragment:`ch${B.toString().padStart(7,"0")},${$??""},${V.scheme!==A.Schemas.file?V.scheme:""}`})}E.generateCellOutputUri=O;function S(V){if(V.scheme!==A.Schemas.vscodeNotebookCellOutput)return;const B=/^ch(\d{7,})\,([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(V.fragment);if(!B)return;const $=Number(B[1]),J=B[2]&&B[2]!==""?B[2]:void 0,j=B[3];return{handle:$,outputId:J,notebook:V.with({scheme:j||A.Schemas.file,fragment:null})}}E.parseCellOutputUri=S;function x(V,B,$){return V.with({scheme:$,fragment:`ch${B.toString().padStart(7,"0")}${V.scheme!==A.Schemas.file?V.scheme:""}`})}E.generateCellUri=x;function N(V,B){if(V.scheme!==B)return;const $=R.exec(V.fragment);return $?{handle:Number($[1]),notebook:V.with({scheme:V.fragment.substr($[0].length)||A.Schemas.file,fragment:null})}:void 0}E.parseCellUri=N})(D=e.CellUri||(e.CellUri={}));const f=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],[w.Mimes.latex,{alwaysSecure:!0,supportedByCore:!0}],[w.Mimes.text,{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function l(E){return f.get(E)?.alwaysSecure??!1}e.mimeTypeIsAlwaysSecure=l;function h(E){return f.get(E)?.supportedByCore??!1}e.mimeTypeSupportedByCore=h;function y(E){return f.get(E)?.mergeable??!1}e.mimeTypeIsMergeable=y;const s=E=>T.isWindows?E.replace(/\//g,"\\"):E;class I{constructor(R=[],P=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=P,this.order=[...new Set(R)].map(z=>({pattern:z,matches:u.parse(s(z))}))}sort(R){const P=new Map(M.Iterable.map(R,O=>[O,s(O)]));let z=[];for(const{matches:O}of this.order)for(const[S,x]of P)if(O(x)){z.push(S),P.delete(S);break}return P.size&&(z=z.concat([...P.keys()].sort((O,S)=>this.defaultOrder.indexOf(O)-this.defaultOrder.indexOf(S)))),z}prioritize(R,P){const z=this.findIndex(R);if(z===-1){this.order.unshift({pattern:R,matches:u.parse(s(R))});return}const O=new Set(P.map(x=>this.findIndex(x,z)));O.delete(-1);const S=Array.from(O).sort();this.order.splice(z+1,0,...S.map(x=>this.order[x]));for(let x=S.length-1;x>=0;x--)this.order.splice(S[x],1)}toArray(){return this.order.map(R=>R.pattern)}findIndex(R,P=this.order.length){const z=s(R);for(let O=0;O<P;O++)if(this.order[O].matches(z))return O;return-1}}e.MimeTypeDisplayOrder=I;function r(E,R,P,z=(O,S)=>O===S){const O=[];function S(V,B,$){if(B===0&&$.length===0)return;const J=O[O.length-1];J&&J.start+J.deleteCount===V?(J.deleteCount+=B,J.toInsert.push(...$)):O.push({start:V,deleteCount:B,toInsert:$})}let x=0,N=0;for(;;){if(x===E.length){S(x,0,R.slice(N));break}if(N===R.length){S(x,E.length-x,[]);break}const V=E[x],B=R[N];if(z(V,B)){x+=1,N+=1;continue}P(B)?(S(x,1,[]),x+=1):(S(x,0,[B]),N+=1)}return O}e.diff=r,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new C.RawContextKey("notebookEditorCursorAtBoundary","none");var i;(function(E){E.default="default",E.option="option"})(i=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function v(E){const R=E;return!!((typeof R.include=="string"||u.isRelativePattern(R.include))&&(typeof R.exclude=="string"||u.isRelativePattern(R.exclude)))}e.isDocumentExcludePattern=v;function m(E,R,P){if(Array.isArray(E.viewType)&&E.viewType.indexOf(R)>=0||E.viewType===R)return!0;if(E.filenamePattern){let z=v(E.filenamePattern)?E.filenamePattern.include:E.filenamePattern,O=v(E.filenamePattern)?E.filenamePattern.exclude:void 0;if(u.match(z,(0,t.basename)(P.fsPath).toLowerCase()))return!(O&&u.match(O,(0,t.basename)(P.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=m;class o{constructor(R){this.textModel=R}getElements(){const R=new Int32Array(this.textModel.cells.length);for(let P=0;P<this.textModel.cells.length;P++)R[P]=this.textModel.cells[P].getHashValue();return R}}e.CellSequence=o,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize"};var b;(function(E){E[E.Left=1]="Left",E[E.Right=2]="Right"})(b=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class d{static create(R){return`${d._prefix}${R}`}static parse(R){if(R.startsWith(d._prefix))return R.substr(d._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=d,d._prefix="notebook/"}),define(we[163],Ee([0,1,4]),function(re,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var M;(function(w){w[w.Output=1]="Output",w[w.OutputItems=2]="OutputItems",w[w.ExecutionState=3]="ExecutionState",w[w.Complete=4]="Complete"})(M=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,u.createDecorator)("INotebookExecutionService")}),define(we[164],Ee([0,1,4,45]),function(re,e,u,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new M.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new M.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new M.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,u.createDecorator)(e.OUTPUT_SERVICE_ID);var w;(function(A){A[A.Append=1]="Append",A[A.Replace=2]="Replace",A[A.Clear=3]="Clear"})(w=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={}))}),define(we[165],Ee([0,1,133,4,45]),function(re,e,u,M,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new w.RawContextKey("customExecutionSupported",!0,u.localize(0,null)),e.ShellExecutionSupportedContext=new w.RawContextKey("shellExecutionSupported",!1,u.localize(1,null)),e.ProcessExecutionSupportedContext=new w.RawContextKey("processExecutionSupported",!1,u.localize(2,null)),e.ITaskService=(0,M.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(we[166],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function u(w){return[...w.entries()]}e.serializeEnvironmentVariableCollection=u;function M(w){return new Map(w)}e.deserializeEnvironmentVariableCollection=M}),define(we[89],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestDiffOpType=e.DetailType=e.applyTestItemUpdate=e.TestItemExpandState=e.TestMessageType=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var u;(function(_){_[_.Unset=0]="Unset",_[_.Queued=1]="Queued",_[_.Running=2]="Running",_[_.Passed=3]="Passed",_[_.Failed=4]="Failed",_[_.Skipped=5]="Skipped",_[_.Errored=6]="Errored"})(u=e.TestResultState||(e.TestResultState={}));var M;(function(_){_[_.Run=2]="Run",_[_.Debug=4]="Debug",_[_.Coverage=8]="Coverage",_[_.HasNonDefaultProfile=16]="HasNonDefaultProfile",_[_.HasConfigurable=32]="HasConfigurable"})(M=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var w;(function(_){_[_.Error=0]="Error",_[_.Info=1]="Info"})(w=e.TestMessageType||(e.TestMessageType={}));var A;(function(_){_[_.NotExpandable=0]="NotExpandable",_[_.Expandable=1]="Expandable",_[_.BusyExpanding=2]="BusyExpanding",_[_.Expanded=3]="Expanded"})(A=e.TestItemExpandState||(e.TestItemExpandState={}));const t=(_,n)=>{n.expand!==void 0&&(_.expand=n.expand),n.item!==void 0&&(_.item=_.item?Object.assign(_.item,n.item):n.item)};e.applyTestItemUpdate=t;var T;(function(_){_[_.Function=0]="Function",_[_.Statement=1]="Statement"})(T=e.DetailType||(e.DetailType={}));var C;(function(_){_[_.Add=0]="Add",_[_.Update=1]="Update",_[_.Remove=2]="Remove",_[_.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",_[_.Retire=4]="Retire",_[_.AddTag=5]="AddTag",_[_.RemoveTag=6]="RemoveTag"})(C=e.TestDiffOpType||(e.TestDiffOpType={}));class k{add(n){}update(n){}remove(n,g){}complete(){}}e.IncrementalChangeCollector=k;class F{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(n){const g=this.createChangeCollector();for(const a of n)switch(a[0]){case 0:{const c=a[1];if(c.parent){if(this.items.has(c.parent)){const p=this.items.get(c.parent);p.children.add(c.item.extId);const D=this.createItem(c,p);this.items.set(c.item.extId,D),g.add(D)}}else{const p=this.createItem(c);this.roots.add(p),this.items.set(c.item.extId,p),g.add(p)}c.expand===2&&this.busyControllerCount++;break}case 1:{const c=a[1],p=this.items.get(c.extId);if(!p)break;c.expand!==void 0&&(p.expand===2&&this.busyControllerCount--,c.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(p,c),g.update(p);break}case 2:{const c=this.items.get(a[1]);if(!c)break;c.parent?this.items.get(c.parent).children.delete(c.item.extId):this.roots.delete(c);const p=[[a[1]]];for(;p.length;)for(const D of p.pop()){const f=this.items.get(D);f&&(p.push(f.children),this.items.delete(D),g.remove(f,f!==c),f.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(a[1]);break;case 3:this.updatePendingRoots(a[1]);break;case 5:this._tags.set(a[1].id,a[1]);break;case 6:this._tags.delete(a[1]);break}g.complete()}retireTest(n){}updatePendingRoots(n){this.pendingRootCount+=n}createChangeCollector(){return new k}}e.AbstractIncrementalTestCollection=F}),define(we[68],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var u;(function(A){A.Delimiter="\0"})(u=e.TestIdPathParts||(e.TestIdPathParts={}));var M;(function(A){A[A.IsSame=0]="IsSame",A[A.Disconnected=1]="Disconnected",A[A.IsChild=2]="IsChild",A[A.IsParent=3]="IsParent"})(M=e.TestPosition||(e.TestPosition={}));class w{constructor(t,T=t.length){if(this.path=t,this.viewEnd=T,t.length===0||T<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(t,T,C=t.parent){if(t.id===T)return new w([T]);let k=[t.id];for(let F=C;F&&F.id!==T;F=F.parent)k.push(F.id);return k.push(T),new w(k.reverse())}static isRoot(t){return!t.includes("\0")}static fromString(t){return new w(t.split("\0"))}static join(t,T){return new w([...t.path,T])}static joinToString(t,T){return t.toString()+"\0"+T}static compare(t,T){return t===T?0:T.startsWith(t+"\0")?2:t.startsWith(T+"\0")?3:1}get parentId(){return this.viewEnd>1?new w(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let t=1;t<=this.viewEnd;t++)yield new w(this.path,t)}compare(t){if(typeof t=="string")return w.compare(this.toString(),t);for(let T=0;T<t.viewEnd&&T<this.viewEnd;T++)if(t.path[T]!==this.path[T])return 1;return t.viewEnd>this.viewEnd?2:t.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let t=1;t<this.viewEnd;t++)this.stringifed+="\0",this.stringifed+=this.path[t]}return this.stringifed}}e.TestId=w}),define(we[167],Ee([0,1,17,90,10,25,24,78,134]),function(re,e,u,M,w,A,t,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class k{constructor(_,n,g){this._contributedVariables=new Map,this._context=_,this._labelService=n,g&&(this._envVariablesPromise=g.then(a=>this.prepareEnv(a)))}prepareEnv(_){if(t.isWindows){const n=Object.create(null);return Object.keys(_).forEach(g=>{n[g.toLowerCase()]=_[g]}),n}return _}resolveWithEnvironment(_,n,g){return this.recursiveResolve(this.prepareEnv(_),n?n.uri:void 0,g)}async resolveAsync(_,n){return this.recursiveResolve(await this._envVariablesPromise,_?_.uri:void 0,n)}async resolveAnyBase(_,n,g,a){const c=A.deepClone(n);return t.isWindows&&c.windows?Object.keys(c.windows).forEach(p=>c[p]=c.windows[p]):t.isMacintosh&&c.osx?Object.keys(c.osx).forEach(p=>c[p]=c.osx[p]):t.isLinux&&c.linux&&Object.keys(c.linux).forEach(p=>c[p]=c.linux[p]),delete c.windows,delete c.osx,delete c.linux,this.recursiveResolve(await this._envVariablesPromise,_?_.uri:void 0,c,g,a)}async resolveAnyAsync(_,n,g){return this.resolveAnyBase(_,n,g)}async resolveAnyMap(_,n,g){const a=new Map;return{newConfig:await this.resolveAnyBase(_,n,g,a),resolvedVariables:a}}resolveWithInteractionReplace(_,n,g,a){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(_,n,g,a){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(_,n){if(this._contributedVariables.has(_))throw new Error("Variable "+_+" is contributed twice.");this._contributedVariables.set(_,n)}recursiveResolve(_,n,g,a,c){if(w.isString(g))return this.resolveString(_,n,g,a,c);if(w.isArray(g))return g.map(p=>this.recursiveResolve(_,n,p,a,c));if(w.isObject(g)){let p=Object.create(null);return Object.keys(g).forEach(D=>{const f=this.resolveString(_,n,D,a,c);p[f]=this.recursiveResolve(_,n,g[D],a,c)}),p}return g}resolveString(_,n,g,a,c){return g.replace(k.VARIABLE_REGEXP,(D,f)=>{if(f.includes(k.VARIABLE_LHS))return D;let l=this.evaluateSingleVariable(_,D,f,n,a);return c&&c.set(f,l),l!==D&&w.isString(l)&&l.match(k.VARIABLE_REGEXP)&&(l=this.resolveString(_,n,l,a,c)),l})}fsPath(_){return this._labelService?this._labelService.getUriLabel(_,{noPrefix:!0}):_.fsPath}evaluateSingleVariable(_,n,g,a,c){let p;const D=g.split(":");D.length>1&&(g=D[0],p=D[1]);const f=()=>{const y=this._context.getFilePath();if(y)return y;throw new Error((0,C.localize)(0,null,n))},l=()=>{const y=f();if(this._context.getWorkspaceFolderPathForFile){const s=this._context.getWorkspaceFolderPathForFile();if(s)return s}throw new Error((0,C.localize)(1,null,n,u.basename(y)))},h=()=>{if(p){const y=this._context.getFolderUri(p);if(y)return y;throw new Error((0,C.localize)(2,null,n,p))}if(a)return a;throw this._context.getWorkspaceFolderCount()>1?new Error((0,C.localize)(3,null,n)):new Error((0,C.localize)(4,null,n))};switch(g){case"env":if(p){if(_){const y=_[t.isWindows?p.toLowerCase():p];if(w.isString(y))return y}return""}throw new Error((0,C.localize)(5,null,n));case"config":if(p){const y=this._context.getConfigurationValue(a,p);if(w.isUndefinedOrNull(y))throw new Error((0,C.localize)(6,null,n,p));if(w.isObject(y))throw new Error((0,C.localize)(7,null,n,p));return y}throw new Error((0,C.localize)(8,null,n));case"command":return this.resolveFromMap(n,p,c,"command");case"input":return this.resolveFromMap(n,p,c,"input");default:switch(g){case"workspaceRoot":case"workspaceFolder":return(0,T.normalizeDriveLetter)(this.fsPath(h()));case"cwd":return a||p?(0,T.normalizeDriveLetter)(this.fsPath(h())):M.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return u.basename(this.fsPath(h()));case"lineNumber":const y=this._context.getLineNumber();if(y)return y;throw new Error((0,C.localize)(9,null,n));case"selectedText":const s=this._context.getSelectedText();if(s)return s;throw new Error((0,C.localize)(10,null,n));case"file":return f();case"fileWorkspaceFolder":return l();case"relativeFile":return a||p?u.relative(this.fsPath(h()),f()):f();case"relativeFileDirname":const I=u.dirname(f());if(a||p){const m=u.relative(this.fsPath(h()),I);return m.length===0?".":m}return I;case"fileDirname":return u.dirname(f());case"fileExtname":return u.extname(f());case"fileBasename":return u.basename(f());case"fileBasenameNoExtension":const r=u.basename(f());return r.slice(0,r.length-u.extname(r).length);case"fileDirnameBasename":return u.basename(u.dirname(f()));case"execPath":const i=this._context.getExecPath();return i||n;case"execInstallFolder":const v=this._context.getAppRoot();return v||n;case"pathSeparator":return u.sep;default:try{const m=p?`${g}:${p}`:g;return this.resolveFromMap(n,m,c,void 0)}catch(m){return n}}}}resolveFromMap(_,n,g,a){if(n&&g){const c=a===void 0?g[n]:g[a+":"+n];if(typeof c=="string")return c;throw new Error((0,C.localize)(11,null,_))}return _}}e.AbstractVariableResolverService=k,k.VARIABLE_LHS="${",k.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(we[91],Ee([0,1,4,159]),function(re,e,u,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,u.createDecorator)("editorGroupsService");var w;(function(c){c[c.UP=0]="UP",c[c.DOWN=1]="DOWN",c[c.LEFT=2]="LEFT",c[c.RIGHT=3]="RIGHT"})(w=e.GroupDirection||(e.GroupDirection={}));var A;(function(c){c[c.HORIZONTAL=0]="HORIZONTAL",c[c.VERTICAL=1]="VERTICAL"})(A=e.GroupOrientation||(e.GroupOrientation={}));var t;(function(c){c[c.FIRST=0]="FIRST",c[c.LAST=1]="LAST",c[c.NEXT=2]="NEXT",c[c.PREVIOUS=3]="PREVIOUS"})(t=e.GroupLocation||(e.GroupLocation={}));var T;(function(c){c[c.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",c[c.EVEN=1]="EVEN",c[c.TOGGLE=2]="TOGGLE"})(T=e.GroupsArrangement||(e.GroupsArrangement={}));var C;(function(c){c[c.COPY_EDITORS=0]="COPY_EDITORS",c[c.MOVE_EDITORS=1]="MOVE_EDITORS"})(C=e.MergeGroupMode||(e.MergeGroupMode={}));function k(c){const p=c;return(0,M.isEditorInput)(p?.editor)&&(0,M.isEditorInput)(p?.replacement)}e.isEditorReplacement=k;var F;(function(c){c[c.CREATION_TIME=0]="CREATION_TIME",c[c.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",c[c.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(F=e.GroupsOrder||(e.GroupsOrder={}));var _;(function(c){c[c.GROUP_ACTIVE=0]="GROUP_ACTIVE",c[c.GROUP_INDEX=1]="GROUP_INDEX",c[c.GROUP_LOCKED=2]="GROUP_LOCKED",c[c.EDITOR_OPEN=3]="EDITOR_OPEN",c[c.EDITOR_CLOSE=4]="EDITOR_CLOSE",c[c.EDITOR_MOVE=5]="EDITOR_MOVE",c[c.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",c[c.EDITOR_LABEL=7]="EDITOR_LABEL",c[c.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",c[c.EDITOR_PIN=9]="EDITOR_PIN",c[c.EDITOR_STICKY=10]="EDITOR_STICKY",c[c.EDITOR_DIRTY=11]="EDITOR_DIRTY"})(_=e.GroupChangeKind||(e.GroupChangeKind={}));var n;(function(c){c[c.NEW_EDITOR=1]="NEW_EDITOR",c[c.MOVE_EDITOR=2]="MOVE_EDITOR",c[c.COPY_EDITOR=3]="COPY_EDITOR"})(n=e.OpenEditorContext||(e.OpenEditorContext={}));function g(c){const p=c;return!!p&&typeof p.id=="number"&&Array.isArray(p.editors)}e.isEditorGroup=g;function a(c){return c.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=a}),define(we[168],Ee([0,1,4,91]),function(re,e,u,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,u.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function w(A){const t=A;return typeof A=="number"||(0,M.isEditorGroup)(t)}e.isPreferredGroup=w}),define(we[8],Ee([0,1,16,22,77,230,55,25,10,2,43,59,135,83,48,88,68,168,7]),function(re,e,u,M,w,A,t,T,C,k,F,_,n,g,a,c,p,D,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var l;(function(ne){function me(H){const{selectionStartLineNumber:ve,selectionStartColumn:De,positionLineNumber:je,positionColumn:Me}=H,dt=new f.Position(ve-1,De-1),wt=new f.Position(je-1,Me-1);return new f.Selection(dt,wt)}ne.to=me;function ie(H){const{anchor:ve,active:De}=H;return{selectionStartLineNumber:ve.line+1,selectionStartColumn:ve.character+1,positionLineNumber:De.line+1,positionColumn:De.character+1}}ne.from=ie})(l=e.Selection||(e.Selection={}));var h;(function(ne){function me(H){if(!H)return;const{start:ve,end:De}=H;return{startLineNumber:ve.line+1,startColumn:ve.character+1,endLineNumber:De.line+1,endColumn:De.character+1}}ne.from=me;function ie(H){if(!H)return;const{startLineNumber:ve,startColumn:De,endLineNumber:je,endColumn:Me}=H;return new f.Range(ve-1,De-1,je-1,Me-1)}ne.to=ie})(h=e.Range||(e.Range={}));var y;(function(ne){function me(ie){switch(ie){case 1:return f.StandardTokenType.Comment;case 0:return f.StandardTokenType.Other;case 4:return f.StandardTokenType.RegEx;case 2:return f.StandardTokenType.String}}ne.to=me})(y=e.TokenType||(e.TokenType={}));var s;(function(ne){function me(H){return new f.Position(H.lineNumber-1,H.column-1)}ne.to=me;function ie(H){return{lineNumber:H.line+1,column:H.character+1}}ne.from=ie})(s=e.Position||(e.Position={}));var I;(function(ne){function me(ve,De){return(0,u.coalesce)((0,u.asArray)(ve).map(je=>ie(je,De)))}ne.from=me;function ie(ve,De){if(typeof ve=="string")return{$serialized:!0,language:ve};if(ve)return{$serialized:!0,language:ve.language,scheme:H(ve.scheme,De),pattern:typeof ve.pattern=="undefined"?void 0:nt.from(ve.pattern),exclusive:ve.exclusive}}function H(ve,De){return De&&typeof ve=="string"?De.transformOutgoingScheme(ve):ve}})(I=e.DocumentSelector||(e.DocumentSelector={}));var r;(function(ne){function me(H){switch(H){case f.DiagnosticTag.Unnecessary:return 1;case f.DiagnosticTag.Deprecated:return 2}}ne.from=me;function ie(H){switch(H){case 1:return f.DiagnosticTag.Unnecessary;case 2:return f.DiagnosticTag.Deprecated;default:return}}ne.to=ie})(r=e.DiagnosticTag||(e.DiagnosticTag={}));var i;(function(ne){function me(H){let ve;return H.code&&((0,C.isString)(H.code)||(0,C.isNumber)(H.code)?ve=String(H.code):ve={value:String(H.code.value),target:H.code.target}),{...h.from(H.range),message:H.message,source:H.source,code:ve,severity:m.from(H.severity),relatedInformation:H.relatedInformation&&H.relatedInformation.map(v.from),tags:Array.isArray(H.tags)?(0,u.coalesce)(H.tags.map(r.from)):void 0}}ne.from=me;function ie(H){const ve=new f.Diagnostic(h.to(H),H.message,m.to(H.severity));return ve.source=H.source,ve.code=(0,C.isString)(H.code)?H.code:H.code?.value,ve.relatedInformation=H.relatedInformation&&H.relatedInformation.map(v.to),ve.tags=H.tags&&(0,u.coalesce)(H.tags.map(r.to)),ve}ne.to=ie})(i=e.Diagnostic||(e.Diagnostic={}));var v;(function(ne){function me(H){return{...h.from(H.location.range),message:H.message,resource:H.location.uri}}ne.from=me;function ie(H){return new f.DiagnosticRelatedInformation(new f.Location(H.resource,h.to(H)),H.message)}ne.to=ie})(v=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var m;(function(ne){function me(H){switch(H){case f.DiagnosticSeverity.Error:return g.MarkerSeverity.Error;case f.DiagnosticSeverity.Warning:return g.MarkerSeverity.Warning;case f.DiagnosticSeverity.Information:return g.MarkerSeverity.Info;case f.DiagnosticSeverity.Hint:return g.MarkerSeverity.Hint}return g.MarkerSeverity.Error}ne.from=me;function ie(H){switch(H){case g.MarkerSeverity.Info:return f.DiagnosticSeverity.Information;case g.MarkerSeverity.Warning:return f.DiagnosticSeverity.Warning;case g.MarkerSeverity.Error:return f.DiagnosticSeverity.Error;case g.MarkerSeverity.Hint:return f.DiagnosticSeverity.Hint;default:return f.DiagnosticSeverity.Error}}ne.to=ie})(m=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var o;(function(ne){function me(H){return typeof H=="number"&&H>=f.ViewColumn.One?H-1:H===f.ViewColumn.Beside?D.SIDE_GROUP:D.ACTIVE_GROUP}ne.from=me;function ie(H){if(typeof H=="number"&&H>=0)return H+1;throw new Error("invalid 'EditorGroupColumn'")}ne.to=ie})(o=e.ViewColumn||(e.ViewColumn={}));function b(ne){return typeof ne.range!="undefined"}function d(ne){return ne.length===0?!0:!!b(ne[0])}e.isDecorationOptionsArr=d;var E;(function(ne){function me(Me){return Me.map(ne.from)}ne.fromMany=me;function ie(Me){return Me&&typeof Me=="object"&&typeof Me.language=="string"&&typeof Me.value=="string"}function H(Me){let dt;if(ie(Me)){const{language:ut,value:ht}=Me;dt={value:"```"+ut+`
`+ht+"\n```\n"}}else f.MarkdownString.isMarkdownString(Me)?dt={value:Me.value,isTrusted:Me.isTrusted,supportThemeIcons:Me.supportThemeIcons,supportHtml:Me.supportHtml}:typeof Me=="string"?dt={value:Me}:dt={value:""};const wt=Object.create(null);dt.uris=wt;const Ct=ut=>{try{let ht=k.URI.parse(ut,!0);ht=ht.with({query:ve(ht.query,wt)}),wt[ut]=ht}catch(ht){}return""},pt=new A.Renderer;return pt.link=Ct,pt.image=ut=>Ct(w.parseHrefAndDimensions(ut).href),A(dt.value,{renderer:pt}),dt}ne.from=H;function ve(Me,dt){if(!Me)return Me;let wt;try{wt=(0,t.parse)(Me)}catch(pt){}if(!wt)return Me;let Ct=!1;return wt=(0,T.cloneAndChange)(wt,pt=>{if(k.URI.isUri(pt)){const ut=`__uri_${Math.random().toString(16).slice(2,8)}`;return dt[ut]=pt,Ct=!0,ut}else return}),Ct?JSON.stringify(wt):Me}function De(Me){const dt=new f.MarkdownString(Me.value,Me.supportThemeIcons);return dt.isTrusted=Me.isTrusted,dt.supportHtml=Me.supportHtml,dt}ne.to=De;function je(Me){if(!!Me)return typeof Me=="string"?Me:ne.from(Me)}ne.fromStrict=je})(E=e.MarkdownString||(e.MarkdownString={}));function R(ne){return d(ne)?ne.map(me=>({range:h.from(me.range),hoverMessage:Array.isArray(me.hoverMessage)?E.fromMany(me.hoverMessage):me.hoverMessage?E.from(me.hoverMessage):void 0,renderOptions:me.renderOptions})):ne.map(me=>({range:h.from(me)}))}e.fromRangeOrRangeWithMessage=R;function P(ne){return typeof ne=="undefined"?ne:typeof ne=="string"?k.URI.file(ne):ne}e.pathOrURIToURI=P;var z;(function(ne){function me(ie){return typeof ie=="undefined"?ie:{contentText:ie.contentText,contentIconPath:ie.contentIconPath?P(ie.contentIconPath):void 0,border:ie.border,borderColor:ie.borderColor,fontStyle:ie.fontStyle,fontWeight:ie.fontWeight,textDecoration:ie.textDecoration,color:ie.color,backgroundColor:ie.backgroundColor,margin:ie.margin,width:ie.width,height:ie.height}}ne.from=me})(z=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var O;(function(ne){function me(ie){return typeof ie=="undefined"?ie:{backgroundColor:ie.backgroundColor,outline:ie.outline,outlineColor:ie.outlineColor,outlineStyle:ie.outlineStyle,outlineWidth:ie.outlineWidth,border:ie.border,borderColor:ie.borderColor,borderRadius:ie.borderRadius,borderSpacing:ie.borderSpacing,borderStyle:ie.borderStyle,borderWidth:ie.borderWidth,fontStyle:ie.fontStyle,fontWeight:ie.fontWeight,textDecoration:ie.textDecoration,cursor:ie.cursor,color:ie.color,opacity:ie.opacity,letterSpacing:ie.letterSpacing,gutterIconPath:ie.gutterIconPath?P(ie.gutterIconPath):void 0,gutterIconSize:ie.gutterIconSize,overviewRulerColor:ie.overviewRulerColor,before:ie.before?z.from(ie.before):void 0,after:ie.after?z.from(ie.after):void 0}}ne.from=me})(O=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var S;(function(ne){function me(ie){if(typeof ie=="undefined")return ie;switch(ie){case f.DecorationRangeBehavior.OpenOpen:return 0;case f.DecorationRangeBehavior.ClosedClosed:return 1;case f.DecorationRangeBehavior.OpenClosed:return 2;case f.DecorationRangeBehavior.ClosedOpen:return 3}}ne.from=me})(S=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var x;(function(ne){function me(ie){return{isWholeLine:ie.isWholeLine,rangeBehavior:ie.rangeBehavior?S.from(ie.rangeBehavior):void 0,overviewRulerLane:ie.overviewRulerLane,light:ie.light?O.from(ie.light):void 0,dark:ie.dark?O.from(ie.dark):void 0,backgroundColor:ie.backgroundColor,outline:ie.outline,outlineColor:ie.outlineColor,outlineStyle:ie.outlineStyle,outlineWidth:ie.outlineWidth,border:ie.border,borderColor:ie.borderColor,borderRadius:ie.borderRadius,borderSpacing:ie.borderSpacing,borderStyle:ie.borderStyle,borderWidth:ie.borderWidth,fontStyle:ie.fontStyle,fontWeight:ie.fontWeight,textDecoration:ie.textDecoration,cursor:ie.cursor,color:ie.color,opacity:ie.opacity,letterSpacing:ie.letterSpacing,gutterIconPath:ie.gutterIconPath?P(ie.gutterIconPath):void 0,gutterIconSize:ie.gutterIconSize,overviewRulerColor:ie.overviewRulerColor,before:ie.before?z.from(ie.before):void 0,after:ie.after?z.from(ie.after):void 0}}ne.from=me})(x=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var N;(function(ne){function me(H){return{text:H.newText,eol:H.newEol&&q.from(H.newEol),range:h.from(H.range)}}ne.from=me;function ie(H){const ve=new f.TextEdit(h.to(H.range),H.text);return ve.newEol=typeof H.eol=="undefined"?void 0:q.to(H.eol),ve}ne.to=ie})(N=e.TextEdit||(e.TextEdit={}));var V;(function(ne){function me(H,ve,De){const je={edits:[]};if(H instanceof f.WorkspaceEdit)for(let Me of H._allEntries())if(Me._type===1)je.edits.push({_type:1,oldUri:Me.from,newUri:Me.to,options:Me.options,metadata:Me.metadata});else if(Me._type===2){const dt=ve?.getDocument(Me.uri);je.edits.push({_type:2,resource:Me.uri,edit:N.from(Me.edit),modelVersionId:dt?.version,metadata:Me.metadata})}else Me._type===3?je.edits.push({_type:3,metadata:Me.metadata,resource:Me.uri,edit:Me.edit,notebookMetadata:Me.notebookMetadata,notebookVersionId:De?.getNotebookDocument(Me.uri,!0)?.apiNotebook.version}):Me._type===5&&je.edits.push({_type:3,metadata:Me.metadata,resource:Me.uri,notebookVersionId:De?.getNotebookDocument(Me.uri,!0)?.apiNotebook.version,edit:{editType:1,index:Me.index,count:Me.count,cells:Me.cells.map(Je.from)}});return je}ne.from=me;function ie(H){const ve=new f.WorkspaceEdit;for(const De of H.edits)De.edit?ve.replace(k.URI.revive(De.resource),h.to(De.edit.range),De.edit.text):ve.renameFile(k.URI.revive(De.oldUri),k.URI.revive(De.newUri),De.options);return ve}ne.to=ie})(V=e.WorkspaceEdit||(e.WorkspaceEdit={}));var B;(function(ne){const me=Object.create(null);me[f.SymbolKind.File]=0,me[f.SymbolKind.Module]=1,me[f.SymbolKind.Namespace]=2,me[f.SymbolKind.Package]=3,me[f.SymbolKind.Class]=4,me[f.SymbolKind.Method]=5,me[f.SymbolKind.Property]=6,me[f.SymbolKind.Field]=7,me[f.SymbolKind.Constructor]=8,me[f.SymbolKind.Enum]=9,me[f.SymbolKind.Interface]=10,me[f.SymbolKind.Function]=11,me[f.SymbolKind.Variable]=12,me[f.SymbolKind.Constant]=13,me[f.SymbolKind.String]=14,me[f.SymbolKind.Number]=15,me[f.SymbolKind.Boolean]=16,me[f.SymbolKind.Array]=17,me[f.SymbolKind.Object]=18,me[f.SymbolKind.Key]=19,me[f.SymbolKind.Null]=20,me[f.SymbolKind.EnumMember]=21,me[f.SymbolKind.Struct]=22,me[f.SymbolKind.Event]=23,me[f.SymbolKind.Operator]=24,me[f.SymbolKind.TypeParameter]=25;function ie(ve){return typeof me[ve]=="number"?me[ve]:6}ne.from=ie;function H(ve){for(const De in me)if(me[De]===ve)return Number(De);return f.SymbolKind.Property}ne.to=H})(B=e.SymbolKind||(e.SymbolKind={}));var $;(function(ne){function me(H){switch(H){case f.SymbolTag.Deprecated:return 1}}ne.from=me;function ie(H){switch(H){case 1:return f.SymbolTag.Deprecated}}ne.to=ie})($=e.SymbolTag||(e.SymbolTag={}));var J;(function(ne){function me(H){return{name:H.name,kind:B.from(H.kind),tags:H.tags&&H.tags.map($.from),containerName:H.containerName,location:de.from(H.location)}}ne.from=me;function ie(H){const ve=new f.SymbolInformation(H.name,B.to(H.kind),H.containerName,de.to(H.location));return ve.tags=H.tags&&H.tags.map($.to),ve}ne.to=ie})(J=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var j;(function(ne){function me(H){const ve={name:H.name||"!!MISSING: name!!",detail:H.detail,range:h.from(H.range),selectionRange:h.from(H.selectionRange),kind:B.from(H.kind),tags:H.tags?.map($.from)??[]};return H.children&&(ve.children=H.children.map(me)),ve}ne.from=me;function ie(H){const ve=new f.DocumentSymbol(H.name,H.detail,B.to(H.kind),h.to(H.range),h.to(H.selectionRange));return(0,u.isNonEmptyArray)(H.tags)&&(ve.tags=H.tags.map($.to)),H.children&&(ve.children=H.children.map(ie)),ve}ne.to=ie})(j=e.DocumentSymbol||(e.DocumentSymbol={}));var Q;(function(ne){function me(H){const ve=new f.CallHierarchyItem(B.to(H.kind),H.name,H.detail||"",k.URI.revive(H.uri),h.to(H.range),h.to(H.selectionRange));return ve._sessionId=H._sessionId,ve._itemId=H._itemId,ve}ne.to=me;function ie(H,ve,De){if(ve=ve??H._sessionId,De=De??H._itemId,ve===void 0||De===void 0)throw new Error("invalid item");return{_sessionId:ve,_itemId:De,name:H.name,detail:H.detail,kind:B.from(H.kind),uri:H.uri,range:h.from(H.range),selectionRange:h.from(H.selectionRange),tags:H.tags?.map($.from)}}ne.from=ie})(Q=e.CallHierarchyItem||(e.CallHierarchyItem={}));var le;(function(ne){function me(ie){return new f.CallHierarchyIncomingCall(Q.to(ie.from),ie.fromRanges.map(H=>h.to(H)))}ne.to=me})(le=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var be;(function(ne){function me(ie){return new f.CallHierarchyOutgoingCall(Q.to(ie.to),ie.fromRanges.map(H=>h.to(H)))}ne.to=me})(be=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var de;(function(ne){function me(H){return{range:H.range&&h.from(H.range),uri:H.uri}}ne.from=me;function ie(H){return new f.Location(k.URI.revive(H.uri),h.to(H.range))}ne.to=ie})(de=e.location||(e.location={}));var Fe;(function(ne){function me(H){const ve=H,De=H;return{originSelectionRange:ve.originSelectionRange?h.from(ve.originSelectionRange):void 0,uri:ve.targetUri?ve.targetUri:De.uri,range:h.from(ve.targetRange?ve.targetRange:De.range),targetSelectionRange:ve.targetSelectionRange?h.from(ve.targetSelectionRange):void 0}}ne.from=me;function ie(H){return{targetUri:k.URI.revive(H.uri),targetRange:h.to(H.range),targetSelectionRange:H.targetSelectionRange?h.to(H.targetSelectionRange):void 0,originSelectionRange:H.originSelectionRange?h.to(H.originSelectionRange):void 0}}ne.to=ie})(Fe=e.DefinitionLink||(e.DefinitionLink={}));var Ge;(function(ne){function me(H){return{range:h.from(H.range),contents:E.fromMany(H.contents)}}ne.from=me;function ie(H){return new f.Hover(H.contents.map(E.to),h.to(H.range))}ne.to=ie})(Ge=e.Hover||(e.Hover={}));var Le;(function(ne){function me(H){return{range:h.from(H.range),expression:H.expression}}ne.from=me;function ie(H){return new f.EvaluatableExpression(h.to(H.range),H.expression)}ne.to=ie})(Le=e.EvaluatableExpression||(e.EvaluatableExpression={}));var We;(function(ne){function me(H){if(H instanceof f.InlineValueText)return{type:"text",range:h.from(H.range),text:H.text};if(H instanceof f.InlineValueVariableLookup)return{type:"variable",range:h.from(H.range),variableName:H.variableName,caseSensitiveLookup:H.caseSensitiveLookup};if(H instanceof f.InlineValueEvaluatableExpression)return{type:"expression",range:h.from(H.range),expression:H.expression};throw new Error("Unknown 'InlineValue' type")}ne.from=me;function ie(H){switch(H.type){case"text":return{range:h.to(H.range),text:H.text};case"variable":return{range:h.to(H.range),variableName:H.variableName,caseSensitiveLookup:H.caseSensitiveLookup};case"expression":return{range:h.to(H.range),expression:H.expression}}}ne.to=ie})(We=e.InlineValue||(e.InlineValue={}));var Ye;(function(ne){function me(H){return{frameId:H.frameId,stoppedLocation:h.from(H.stoppedLocation)}}ne.from=me;function ie(H){return new f.InlineValueContext(H.frameId,h.to(H.stoppedLocation))}ne.to=ie})(Ye=e.InlineValueContext||(e.InlineValueContext={}));var Qe;(function(ne){function me(H){return{range:h.from(H.range),kind:H.kind}}ne.from=me;function ie(H){return new f.DocumentHighlight(h.to(H.range),H.kind)}ne.to=ie})(Qe=e.DocumentHighlight||(e.DocumentHighlight={}));var Ke;(function(ne){function me(ie){switch(ie){case 1:return f.CompletionTriggerKind.TriggerCharacter;case 2:return f.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return f.CompletionTriggerKind.Invoke}}ne.to=me})(Ke=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var W;(function(ne){function me(ie){return{triggerKind:Ke.to(ie.triggerKind),triggerCharacter:ie.triggerCharacter}}ne.to=me})(W=e.CompletionContext||(e.CompletionContext={}));var K;(function(ne){function me(H){switch(H){case f.CompletionItemTag.Deprecated:return 1}}ne.from=me;function ie(H){switch(H){case 1:return f.CompletionItemTag.Deprecated}}ne.to=ie})(K=e.CompletionItemTag||(e.CompletionItemTag={}));var Z;(function(ne){const me=new Map([[f.CompletionItemKind.Method,0],[f.CompletionItemKind.Function,1],[f.CompletionItemKind.Constructor,2],[f.CompletionItemKind.Field,3],[f.CompletionItemKind.Variable,4],[f.CompletionItemKind.Class,5],[f.CompletionItemKind.Interface,7],[f.CompletionItemKind.Struct,6],[f.CompletionItemKind.Module,8],[f.CompletionItemKind.Property,9],[f.CompletionItemKind.Unit,12],[f.CompletionItemKind.Value,13],[f.CompletionItemKind.Constant,14],[f.CompletionItemKind.Enum,15],[f.CompletionItemKind.EnumMember,16],[f.CompletionItemKind.Keyword,17],[f.CompletionItemKind.Snippet,27],[f.CompletionItemKind.Text,18],[f.CompletionItemKind.Color,19],[f.CompletionItemKind.File,20],[f.CompletionItemKind.Reference,21],[f.CompletionItemKind.Folder,23],[f.CompletionItemKind.Event,10],[f.CompletionItemKind.Operator,11],[f.CompletionItemKind.TypeParameter,24],[f.CompletionItemKind.Issue,26],[f.CompletionItemKind.User,25]]);function ie(De){return me.get(De)??9}ne.from=ie;const H=new Map([[0,f.CompletionItemKind.Method],[1,f.CompletionItemKind.Function],[2,f.CompletionItemKind.Constructor],[3,f.CompletionItemKind.Field],[4,f.CompletionItemKind.Variable],[5,f.CompletionItemKind.Class],[7,f.CompletionItemKind.Interface],[6,f.CompletionItemKind.Struct],[8,f.CompletionItemKind.Module],[9,f.CompletionItemKind.Property],[12,f.CompletionItemKind.Unit],[13,f.CompletionItemKind.Value],[14,f.CompletionItemKind.Constant],[15,f.CompletionItemKind.Enum],[16,f.CompletionItemKind.EnumMember],[17,f.CompletionItemKind.Keyword],[27,f.CompletionItemKind.Snippet],[18,f.CompletionItemKind.Text],[19,f.CompletionItemKind.Color],[20,f.CompletionItemKind.File],[21,f.CompletionItemKind.Reference],[23,f.CompletionItemKind.Folder],[10,f.CompletionItemKind.Event],[11,f.CompletionItemKind.Operator],[24,f.CompletionItemKind.TypeParameter],[25,f.CompletionItemKind.User],[26,f.CompletionItemKind.Issue]]);function ve(De){return H.get(De)??f.CompletionItemKind.Property}ne.to=ve})(Z=e.CompletionItemKind||(e.CompletionItemKind={}));var se;(function(ne){function me(ie,H){const ve=new f.CompletionItem(ie.label);return ve.insertText=ie.insertText,ve.kind=Z.to(ie.kind),ve.tags=ie.tags?.map(K.to),ve.detail=ie.detail,ve.documentation=w.isMarkdownString(ie.documentation)?E.to(ie.documentation):ie.documentation,ve.sortText=ie.sortText,ve.filterText=ie.filterText,ve.preselect=ie.preselect,ve.commitCharacters=ie.commitCharacters,F.Range.isIRange(ie.range)?ve.range=h.to(ie.range):typeof ie.range=="object"&&(ve.range={inserting:h.to(ie.range.insert),replacing:h.to(ie.range.replace)}),ve.keepWhitespace=typeof ie.insertTextRules=="undefined"?!1:Boolean(ie.insertTextRules&1),typeof ie.insertTextRules!="undefined"&&ie.insertTextRules&4?ve.insertText=new f.SnippetString(ie.insertText):(ve.insertText=ie.insertText,ve.textEdit=ve.range instanceof f.Range?new f.TextEdit(ve.range,ve.insertText):void 0),ie.additionalTextEdits&&ie.additionalTextEdits.length>0&&(ve.additionalTextEdits=ie.additionalTextEdits.map(De=>N.to(De))),ve.command=H&&ie.command?H.fromInternal(ie.command):void 0,ve}ne.to=me})(se=e.CompletionItem||(e.CompletionItem={}));var G;(function(ne){function me(H){return{label:H.label,documentation:H.documentation?E.fromStrict(H.documentation):void 0}}ne.from=me;function ie(H){return{label:H.label,documentation:w.isMarkdownString(H.documentation)?E.to(H.documentation):H.documentation}}ne.to=ie})(G=e.ParameterInformation||(e.ParameterInformation={}));var te;(function(ne){function me(H){return{label:H.label,documentation:H.documentation?E.fromStrict(H.documentation):void 0,parameters:Array.isArray(H.parameters)?H.parameters.map(G.from):[],activeParameter:H.activeParameter}}ne.from=me;function ie(H){return{label:H.label,documentation:w.isMarkdownString(H.documentation)?E.to(H.documentation):H.documentation,parameters:Array.isArray(H.parameters)?H.parameters.map(G.to):[],activeParameter:H.activeParameter}}ne.to=ie})(te=e.SignatureInformation||(e.SignatureInformation={}));var he;(function(ne){function me(H){return{activeSignature:H.activeSignature,activeParameter:H.activeParameter,signatures:Array.isArray(H.signatures)?H.signatures.map(te.from):[]}}ne.from=me;function ie(H){return{activeSignature:H.activeSignature,activeParameter:H.activeParameter,signatures:Array.isArray(H.signatures)?H.signatures.map(te.to):[]}}ne.to=ie})(he=e.SignatureHelp||(e.SignatureHelp={}));var Pe;(function(ne){function me(H){return{text:H.text,position:s.from(H.position),kind:Oe.from(H.kind??f.InlayHintKind.Other),whitespaceBefore:H.whitespaceBefore,whitespaceAfter:H.whitespaceAfter}}ne.from=me;function ie(H){const ve=new f.InlayHint(H.text,s.to(H.position),Oe.to(H.kind));return ve.whitespaceAfter=H.whitespaceAfter,ve.whitespaceBefore=H.whitespaceBefore,ve}ne.to=ie})(Pe=e.InlayHint||(e.InlayHint={}));var Oe;(function(ne){function me(H){return H}ne.from=me;function ie(H){return H}ne.to=ie})(Oe=e.InlayHintKind||(e.InlayHintKind={}));var Be;(function(ne){function me(H){return{range:h.from(H.range),url:H.target,tooltip:H.tooltip}}ne.from=me;function ie(H){let ve;if(H.url)try{ve=typeof H.url=="string"?k.URI.parse(H.url,!0):k.URI.revive(H.url)}catch(De){}return new f.DocumentLink(h.to(H.range),ve)}ne.to=ie})(Be=e.DocumentLink||(e.DocumentLink={}));var Ve;(function(ne){function me(H){const ve=new f.ColorPresentation(H.label);return H.textEdit&&(ve.textEdit=N.to(H.textEdit)),H.additionalTextEdits&&(ve.additionalTextEdits=H.additionalTextEdits.map(De=>N.to(De))),ve}ne.to=me;function ie(H){return{label:H.label,textEdit:H.textEdit?N.from(H.textEdit):void 0,additionalTextEdits:H.additionalTextEdits?H.additionalTextEdits.map(ve=>N.from(ve)):void 0}}ne.from=ie})(Ve=e.ColorPresentation||(e.ColorPresentation={}));var Ze;(function(ne){function me(H){return new f.Color(H[0],H[1],H[2],H[3])}ne.to=me;function ie(H){return[H.red,H.green,H.blue,H.alpha]}ne.from=ie})(Ze=e.Color||(e.Color={}));var ot;(function(ne){function me(H){return{range:h.from(H.range)}}ne.from=me;function ie(H){return new f.SelectionRange(h.to(H.range))}ne.to=ie})(ot=e.SelectionRange||(e.SelectionRange={}));var ye;(function(ne){function me(ie){switch(ie){case 2:return f.TextDocumentSaveReason.AfterDelay;case 1:return f.TextDocumentSaveReason.Manual;case 3:case 4:return f.TextDocumentSaveReason.FocusOut}}ne.to=me})(ye=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var it;(function(ne){function me(H){switch(H){case f.TextEditorLineNumbersStyle.Off:return 0;case f.TextEditorLineNumbersStyle.Relative:return 2;case f.TextEditorLineNumbersStyle.On:default:return 1}}ne.from=me;function ie(H){switch(H){case 0:return f.TextEditorLineNumbersStyle.Off;case 2:return f.TextEditorLineNumbersStyle.Relative;case 1:default:return f.TextEditorLineNumbersStyle.On}}ne.to=ie})(it=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var q;(function(ne){function me(H){if(H===f.EndOfLine.CRLF)return 1;if(H===f.EndOfLine.LF)return 0}ne.from=me;function ie(H){if(H===1)return f.EndOfLine.CRLF;if(H===0)return f.EndOfLine.LF}ne.to=ie})(q=e.EndOfLine||(e.EndOfLine={}));var X;(function(ne){function me(ie){if(typeof ie=="object")return ie.viewId;switch(ie){case f.ProgressLocation.SourceControl:return 3;case f.ProgressLocation.Window:return 10;case f.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}ne.from=me})(X=e.ProgressLocation||(e.ProgressLocation={}));var ge;(function(ne){function me(ie){const H={start:ie.start+1,end:ie.end+1};return ie.kind&&(H.kind=Ue.from(ie.kind)),H}ne.from=me})(ge=e.FoldingRange||(e.FoldingRange={}));var Ue;(function(ne){function me(ie){if(ie)switch(ie){case f.FoldingRangeKind.Comment:return _.FoldingRangeKind.Comment;case f.FoldingRangeKind.Imports:return _.FoldingRangeKind.Imports;case f.FoldingRangeKind.Region:return _.FoldingRangeKind.Region}}ne.from=me})(Ue=e.FoldingRangeKind||(e.FoldingRangeKind={}));var qe;(function(ne){function me(ie){if(ie)return{pinned:typeof ie.preview=="boolean"?!ie.preview:void 0,inactive:ie.background,preserveFocus:ie.preserveFocus,selection:typeof ie.selection=="object"?h.from(ie.selection):void 0,override:typeof ie.override=="boolean"?n.EditorResolution.DISABLED:void 0}}ne.from=me})(qe=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var nt;(function(ne){function me(H){return H instanceof f.RelativePattern||typeof H=="string"?H:ie(H)?new f.RelativePattern(H.base,H.pattern):H}ne.from=me;function ie(H){const ve=H;return ve&&typeof ve.base=="string"&&typeof ve.pattern=="string"}})(nt=e.GlobPattern||(e.GlobPattern={}));var mt;(function(ne){function me(ie){if(ie){if(Array.isArray(ie))return ie.map(me);if(typeof ie=="string")return ie;{const H=ie;return{language:H.language,scheme:H.scheme,pattern:typeof H.pattern=="undefined"?void 0:nt.from(H.pattern),exclusive:H.exclusive}}}else return}ne.from=me})(mt=e.LanguageSelector||(e.LanguageSelector={}));var lt;(function(ne){function me(H){return{start:H.start,end:H.end}}ne.from=me;function ie(H){return new f.NotebookRange(H.start,H.end)}ne.to=ie})(lt=e.NotebookRange||(e.NotebookRange={}));var St;(function(ne){function me(H){return{timing:typeof H.runStartTime=="number"&&typeof H.runEndTime=="number"?{startTime:H.runStartTime,endTime:H.runEndTime}:void 0,executionOrder:H.executionOrder,success:H.lastRunSuccess}}ne.to=me;function ie(H){return{lastRunSuccess:H.success,runStartTime:H.timing?.startTime,runEndTime:H.timing?.endTime,executionOrder:H.executionOrder}}ne.from=ie})(St=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var kt;(function(ne){function me(H){switch(H){case f.NotebookCellKind.Markup:return c.CellKind.Markup;case f.NotebookCellKind.Code:default:return c.CellKind.Code}}ne.from=me;function ie(H){switch(H){case c.CellKind.Markup:return f.NotebookCellKind.Markup;case c.CellKind.Code:default:return f.NotebookCellKind.Code}}ne.to=ie})(kt=e.NotebookCellKind||(e.NotebookCellKind={}));var It;(function(ne){function me(H){const ve={metadata:H.metadata??Object.create(null),cells:[]};for(let De of H.cells)f.NotebookCellData.validate(De),ve.cells.push(Je.from(De));return ve}ne.from=me;function ie(H){const ve=new f.NotebookData(H.cells.map(Je.to));return(0,C.isEmptyObject)(H.metadata)||(ve.metadata=H.metadata),ve}ne.to=ie})(It=e.NotebookData||(e.NotebookData={}));var Je;(function(ne){function me(H){return{cellKind:kt.from(H.kind),language:H.languageId,mime:H.mime,source:H.value,metadata:H.metadata,internalMetadata:St.from(H.executionSummary??{}),outputs:H.outputs?H.outputs.map(Ie.from):[]}}ne.from=me;function ie(H){return new f.NotebookCellData(kt.to(H.cellKind),H.source,H.language,H.mime,H.outputs?H.outputs.map(Ie.to):void 0,H.metadata,H.internalMetadata?St.to(H.internalMetadata):void 0)}ne.to=ie})(Je=e.NotebookCellData||(e.NotebookCellData={}));var bt;(function(ne){function me(H){return{mime:H.mime,valueBytes:M.VSBuffer.wrap(H.data)}}ne.from=me;function ie(H){return new f.NotebookCellOutputItem(H.valueBytes.buffer,H.mime)}ne.to=ie})(bt=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var Ie;(function(ne){function me(H){return{outputId:H.id,items:H.items.map(bt.from),metadata:H.metadata}}ne.from=me;function ie(H){const ve=H.items.map(bt.to);return new f.NotebookCellOutput(ve,H.outputId,H.metadata)}ne.to=ie})(Ie=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Se;(function(ne){function me(De){if(De!=null){if(De instanceof f.RelativePattern||typeof De=="string")return De;if(ve(De))return new f.RelativePattern(De.base,De.pattern);if(H(De))return{include:nt.from(De.include)||void 0,exclude:nt.from(De.exclude)||void 0}}}ne.from=me;function ie(De){return typeof De=="string"?De:ve(De)?{base:De.base,pattern:De.pattern}:{include:De.include,exclude:De.exclude}}ne.to=ie;function H(De){const je=De,Me=nt.from(je.include);if(!(Me&&Me instanceof f.RelativePattern||typeof Me=="string"))return!1;const dt=nt.from(je.exclude);return!!(dt&&dt instanceof f.RelativePattern||typeof dt=="string")}function ve(De){const je=De;return je&&typeof je.base=="string"&&typeof je.pattern=="string"}})(Se=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var pe;(function(ne){function me(ie){return{backgroundColor:ie.backgroundColor,borderColor:ie.borderColor,top:ie.top?z.from(ie.top):void 0}}ne.from=me})(pe=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var oe;(function(ne){function me(ie,H,ve){const De=typeof ie.command=="string"?{title:"",command:ie.command}:ie.command;return{alignment:ie.alignment===f.NotebookCellStatusBarAlignment.Left?1:2,command:H.toInternal(De,ve),text:ie.text,tooltip:ie.tooltip,accessibilityInformation:ie.accessibilityInformation,priority:ie.priority}}ne.from=me})(oe=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var ae;(function(ne){function me(ie){return{transientOutputs:ie?.transientOutputs??!1,transientCellMetadata:ie?.transientCellMetadata??{},transientDocumentMetadata:ie?.transientDocumentMetadata??{}}}ne.from=me})(ae=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var ue;(function(ne){function me(H){return{uri:H.uri,provides:H.provides}}ne.from=me;function ie(H){return new f.NotebookRendererScript(k.URI.revive(H.uri),H.provides)}ne.to=ie})(ue=e.NotebookRendererScript||(e.NotebookRendererScript={}));var fe;(function(ne){function me(H){return{message:E.fromStrict(H.message)||"",type:0,expected:H.expectedOutput,actual:H.actualOutput,location:H.location?de.from(H.location):void 0}}ne.from=me;function ie(H){const ve=new f.TestMessage(typeof H.message=="string"?H.message:E.to(H.message));return ve.actualOutput=H.actual,ve.expectedOutput=H.expected,ve.location=H.location?de.to(H.location):void 0,ve}ne.to=ie})(fe=e.TestMessage||(e.TestMessage={}));var ke;(function(ne){let me;(function(ie){ie.Delimiter="\0"})(me||(me={})),ne.namespace=(ie,H)=>ie+"\0"+H,ne.denamespace=ie=>{const H=ie.indexOf("\0");return{ctrlId:ie.slice(0,H),tagId:ie.slice(H+1)}}})(ke=e.TestTag||(e.TestTag={}));var $e;(function(ne){function me(De){const je=(0,a.getPrivateApiFor)(De).controllerId;return{extId:p.TestId.fromExtHostTestItem(De,je).toString(),label:De.label,uri:De.uri,tags:De.tags.map(Me=>ke.namespace(je,Me.id)),range:h.from(De.range)||null,description:De.description||null,error:De.error&&E.fromStrict(De.error)||null}}ne.from=me;function ie(De){return{parent:void 0,error:void 0,id:p.TestId.fromString(De.extId).localId,label:De.label,uri:k.URI.revive(De.uri),tags:(De.tags||[]).map(je=>{const{tagId:Me}=ke.denamespace(je);return new f.TestTag(Me)}),range:h.to(De.range||void 0),invalidateResults:()=>{},canResolveChildren:!1,busy:!1,description:De.description||void 0}}ne.toPlain=ie;function H(De){const je=p.TestId.fromString(De.extId),Me=new a.TestItemImpl(je.controllerId,je.localId,De.label,k.URI.revive(De.uri));return Me.range=h.to(De.range||void 0),Me.description=De.description||void 0,Me}function ve(De){let je;for(const Me of De.tests){const dt=H(Me.item);(0,a.getPrivateApiFor)(dt).parent=je,je=dt}return je}ne.toItemFromContext=ve})($e=e.TestItem||(e.TestItem={})),function(ne){function me(H){return{id:H.id}}ne.from=me;function ie(H){return new f.TestTag(H.id)}ne.to=ie}(ke=e.TestTag||(e.TestTag={}));var Re;(function(ne){const me=(H,ve)=>{const De={...$e.toPlain(H.item),parent:void 0,taskStates:H.tasks.map(je=>({state:je.state,duration:je.duration,messages:je.messages.filter(Me=>Me.type===0).map(fe.to)})),children:H.children.map(je=>ve.get(je)).filter(C.isDefined).map(je=>me(je,ve))};for(const je of De.children)je.parent=De;return De};function ie(H){const ve=[],De=new Map;for(const je of H.items)De.set(je.item.extId,je),H.request.targets.some(Me=>Me.controllerId===je.controllerId&&Me.testIds.includes(je.item.extId))&&ve.push(je);return{completedAt:H.completedAt,results:ve.map(je=>me(je,De))}}ne.to=ie})(Re=e.TestResults||(e.TestResults={}));var ze;(function(ne){function me(De){return{covered:De.covered,total:De.covered}}function ie(De){return"line"in De?s.from(De):h.from(De)}function H(De){return"branches"in De?{count:De.executionCount,location:ie(De.location),type:1,branches:De.branches.length?De.branches.map(je=>({count:je.executionCount,location:je.location&&ie(je.location)})):void 0}:{type:0,count:De.executionCount,location:ie(De.location)}}ne.fromDetailed=H;function ve(De){return{uri:De.uri,statement:me(De.statementCoverage),branch:De.branchCoverage&&me(De.branchCoverage),function:De.functionCoverage&&me(De.functionCoverage),details:De.detailedCoverage?.map(H)}}ne.fromFile=ve})(ze=e.TestCoverage||(e.TestCoverage={}));var tt;(function(ne){function me(ie){switch(ie){case 1:return f.CodeActionTriggerKind.Invoke;case 2:return f.CodeActionTriggerKind.Automatic}}ne.to=me})(tt=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var rt;(function(ne){function me(H){const ve=new f.TypeHierarchyItem(B.to(H.kind),H.name,H.detail||"",k.URI.revive(H.uri),h.to(H.range),h.to(H.selectionRange));return ve._sessionId=H._sessionId,ve._itemId=H._itemId,ve}ne.to=me;function ie(H,ve,De){if(ve=ve??H._sessionId,De=De??H._itemId,ve===void 0||De===void 0)throw new Error("invalid item");return{_sessionId:ve,_itemId:De,kind:B.from(H.kind),name:H.name,detail:H.detail??"",uri:H.uri,range:h.from(H.range),selectionRange:h.from(H.selectionRange),tags:H.tags?.map($.from)}}ne.from=ie})(rt=e.TypeHierarchyItem||(e.TypeHierarchyItem={}))}),define(we[169],Ee([0,1,2,15,7,8,231]),function(re,e,u,M,w,A,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class T{constructor(k,F,_,n={timeout:1500,errors:3}){this._logService=k,this._documents=F,this._mainThreadBulkEdits=_,this._thresholds=n,this._callbacks=new t.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(k){return(F,_,n)=>{const a={dispose:this._callbacks.push([F,_,k])};return Array.isArray(n)&&n.push(a),a}}async $participateInSave(k,F){const _=u.URI.revive(k);let n=!1;const g=setTimeout(()=>n=!0,this._thresholds.timeout),a=[];try{for(let c of[...this._callbacks]){if(n)break;const p=this._documents.getDocument(_),D=await this._deliverEventAsyncAndBlameBadListeners(c,{document:p,reason:A.TextDocumentSaveReason.to(F)});a.push(D)}}finally{clearTimeout(g)}return a}_deliverEventAsyncAndBlameBadListeners([k,F,_],n){const g=this._badListeners.get(k);return typeof g=="number"&&g>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(_,k,F,n).then(()=>!0,a=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${_.identifier.value}' threw ERROR`),this._logService.error(a),!(a instanceof Error)||a.message!=="concurrent_edits"){const c=this._badListeners.get(k);this._badListeners.set(k,c?c+1:1),typeof c=="number"&&c>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${_.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(k,F,_,n){const g=[],a=Date.now(),{document:c,reason:p}=n,{version:D}=c,f=Object.freeze({document:c,reason:p,waitUntil(l){if(Object.isFrozen(g))throw(0,M.illegalState)("waitUntil can not be called async");g.push(Promise.resolve(l))}});try{F.apply(_,[f])}catch(l){return Promise.reject(l)}return Object.freeze(g),new Promise((l,h)=>{const y=setTimeout(()=>h(new Error("timeout")),this._thresholds.timeout);return Promise.all(g).then(s=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' finished after ${Date.now()-a}ms`),clearTimeout(y),l(s)}).catch(s=>{clearTimeout(y),h(s)})}).then(l=>{const h={edits:[]};for(const y of l)if(Array.isArray(y)&&y.every(s=>s instanceof w.TextEdit))for(const{newText:s,newEol:I,range:r}of y)h.edits.push({_type:2,resource:c.uri,edit:{range:r&&A.Range.from(r),text:s,eol:I&&A.EndOfLine.from(I)}});if(h.edits.length!==0)return D===c.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(h):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=T}),define(we[170],Ee([0,1,3,29,2,8,7]),function(re,e,u,M,w,A,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class T{constructor(F,_,n,g,a){this._onDidCreate=new u.Emitter,this._onDidChange=new u.Emitter,this._onDidDelete=new u.Emitter,this._config=0,n&&(this._config+=1),g&&(this._config+=2),a&&(this._config+=4);const c=(0,M.parse)(_),p=F(D=>{if(!n)for(let f of D.created){const l=w.URI.revive(f);c(l.fsPath)&&this._onDidCreate.fire(l)}if(!g)for(let f of D.changed){const l=w.URI.revive(f);c(l.fsPath)&&this._onDidChange.fire(l)}if(!a)for(let f of D.deleted){const l=w.URI.revive(f);c(l.fsPath)&&this._onDidDelete.fire(l)}});this._disposable=t.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,p)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class C{constructor(F,_,n){this._logService=_,this._extHostDocumentsAndEditors=n,this._onFileSystemEvent=new u.Emitter,this._onDidRenameFile=new u.Emitter,this._onDidCreateFile=new u.Emitter,this._onDidDeleteFile=new u.Emitter,this._onWillRenameFile=new u.AsyncEmitter,this._onWillCreateFile=new u.AsyncEmitter,this._onWillDeleteFile=new u.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(F,_,n,g){return new T(this._onFileSystemEvent.event,F,_,n,g)}$onFileEvent(F){this._onFileSystemEvent.fire(F)}$onDidRunFileOperation(F,_){switch(F){case 2:this._onDidRenameFile.fire(Object.freeze({files:_.map(n=>({oldUri:w.URI.revive(n.source),newUri:w.URI.revive(n.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:_.map(n=>w.URI.revive(n.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:_.map(n=>w.URI.revive(n.target))}));break;default:}}getOnWillRenameFileEvent(F){return this._createWillExecuteEvent(F,this._onWillRenameFile)}getOnWillCreateFileEvent(F){return this._createWillExecuteEvent(F,this._onWillCreateFile)}getOnWillDeleteFileEvent(F){return this._createWillExecuteEvent(F,this._onWillDeleteFile)}_createWillExecuteEvent(F,_){return(n,g,a)=>{const c=function(D){n.call(g,D)};return c.extension=F,_.event(c,void 0,a)}}async $onWillRunFileOperation(F,_,n,g){switch(F){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:_.map(a=>({oldUri:w.URI.revive(a.source),newUri:w.URI.revive(a.target)}))},n,g);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:_.map(a=>w.URI.revive(a.target))},n,g);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:_.map(a=>w.URI.revive(a.target))},n,g)}}async _fireWillEvent(F,_,n,g){const a=new Set,c=[];if(await F.fireAsync(_,g,async(D,f)=>{const l=Date.now(),h=await Promise.resolve(D);h instanceof t.WorkspaceEdit&&(c.push(h),a.add(f.extension.displayName??f.extension.identifier.value)),Date.now()-l>n&&this._logService.warn("SLOW file-participant",f.extension.identifier)}),g.isCancellationRequested||c.length===0)return;const p={edits:[]};for(let D of c){let{edits:f}=A.WorkspaceEdit.from(D,this._extHostDocumentsAndEditors);p.edits=p.edits.concat(f)}return{edit:p,extensionNames:Array.from(a)}}}e.ExtHostFileSystemEventService=C}),define(we[171],Ee([0,1,11,25,2,8,7,88]),function(re,e,u,M,w,A,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class C{constructor(n,g,a,c){this.start=n,this.deletedCount=g,this.deletedItems=a,this.items=c}static asApiEvents(n){return n.map(g=>({start:g.start,deletedCount:g.deletedCount,deletedItems:g.deletedItems,items:g.items.map(a=>a.apiCell)}))}}class k{constructor(n,g,a){this.notebook=n,this._extHostDocument=g,this._cellData=a,this.handle=a.handle,this.uri=w.URI.revive(a.uri),this.cellKind=a.cellKind,this._outputs=a.outputs.map(A.NotebookCellOutput.to),this._internalMetadata=a.internalMetadata??{},this._metadata=Object.freeze(a.metadata??{}),this._previousResult=Object.freeze(A.NotebookCellExecutionSummary.to(a.internalMetadata??{}))}static asModelAddData(n,g){return{EOL:g.eol,lines:g.source,languageId:g.language,uri:g.uri,isDirty:!1,versionId:1,notebook:n}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const n=this,g=this._extHostDocument.getDocument(this.uri);if(!g)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return n.notebook.getCellIndex(n)},notebook:n.notebook.apiNotebook,kind:A.NotebookCellKind.to(this._cellData.cellKind),document:g.document,get mime(){return n._mime},set mime(a){n._mime=a},get outputs(){return n._outputs.slice(0)},get metadata(){return n._metadata},get executionSummary(){return n._previousResult}})}return this._apiCell}setOutputs(n){this._outputs=n.map(A.NotebookCellOutput.to)}setOutputItems(n,g,a){const c=a.map(A.NotebookCellOutputItem.to),p=this._outputs.find(D=>D.id===n);p&&(g||(p.items.length=0),p.items.push(...c))}setMetadata(n){this._metadata=Object.freeze(n)}setInternalMetadata(n){this._internalMetadata=n,this._previousResult=Object.freeze(A.NotebookCellExecutionSummary.to(n))}setMime(n){}}e.ExtHostCell=k;class F{constructor(n,g,a,c,p,D){this._proxy=n,this._textDocumentsAndEditors=g,this._textDocuments=a,this._emitter=c,this.uri=p,this.handle=F._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=D.viewType,this._metadata=Object.freeze(D.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,D.cells]],!0),this._versionId=D.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const n=this;this._notebook={get uri(){return n.uri},get version(){return n._versionId},get notebookType(){return n._notebookType},get isDirty(){return n._isDirty},get isUntitled(){return n.uri.scheme===u.Schemas.untitled},get isClosed(){return n._disposed},get metadata(){return n._metadata},get cellCount(){return n._cells.length},cellAt(g){return g=n._validateIndex(g),n._cells[g].apiCell},getCells(g){return(g?n._getCells(g):n._cells).map(c=>c.apiCell)},save(){return n._save()}}}return this._notebook}updateBackup(n){this._backup?.delete(),this._backup=n}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(n){n.metadata&&(this._metadata=Object.freeze({...this._metadata,...n.metadata}))}acceptDirty(n){this._isDirty=n}acceptModelChanged(n,g){this._versionId=n.versionId,this._isDirty=g;for(const a of n.rawEvents)a.kind===T.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(a.changes,!1):a.kind===T.NotebookCellsChangeType.Move?this._moveCell(a.index,a.newIdx):a.kind===T.NotebookCellsChangeType.Output?this._setCellOutputs(a.index,a.outputs):a.kind===T.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(a.index,a.outputId,a.append,a.outputItems):a.kind===T.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(a.index,a.language):a.kind===T.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(a.index,a.mime):a.kind===T.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(a.index,a.metadata):a.kind===T.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(a.index,a.internalMetadata)}_validateIndex(n){return n=n|0,n<0?0:n>=this._cells.length?this._cells.length-1:n}_validateRange(n){let g=n.start|0,a=n.end|0;return g<0&&(g=0),a>this._cells.length&&(a=this._cells.length),n.with({start:g,end:a})}_getCells(n){n=this._validateRange(n);const g=[];for(let a=n.start;a<n.end;a++)g.push(this._cells[a]);return g}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(n,g){if(this._disposed)return;const a=[],c=[],p=[];n.reverse().forEach(D=>{const l=D[2].map(s=>{const I=new k(this,this._textDocumentsAndEditors,s);return g||c.push(k.asModelAddData(this.apiNotebook,s)),I}),h=new C(D[0],D[1],[],l),y=this._cells.splice(D[0],D[1],...l);for(const s of y)p.push(s.uri),h.deletedItems.push(s.apiCell);a.push(h)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:c,removedDocuments:p}),g||this._emitter.emitModelChange((0,M.deepFreeze)({document:this.apiNotebook,changes:C.asApiEvents(a)}))}_moveCell(n,g){const a=this._cells.splice(n,1);this._cells.splice(g,0,...a);const c=[new C(n,1,a.map(p=>p.apiCell),[]),new C(g,0,[],a)];this._emitter.emitModelChange((0,M.deepFreeze)({document:this.apiNotebook,changes:C.asApiEvents(c)}))}_setCellOutputs(n,g){const a=this._cells[n];a.setOutputs(g),this._emitter.emitCellOutputsChange((0,M.deepFreeze)({document:this.apiNotebook,cells:[a.apiCell]}))}_setCellOutputItems(n,g,a,c){const p=this._cells[n];p.setOutputItems(g,a,c),this._emitter.emitCellOutputsChange((0,M.deepFreeze)({document:this.apiNotebook,cells:[p.apiCell]}))}_changeCellLanguage(n,g){const a=this._cells[n];a.apiCell.document.languageId!==g&&this._textDocuments.$acceptModelModeChanged(a.uri,g)}_changeCellMime(n,g){const a=this._cells[n];a.apiCell.mime=g}_changeCellMetadata(n,g){const a=this._cells[n],c=a.apiCell.metadata;a.setMetadata(g);const p=a.apiCell.metadata;(0,M.equals)(c,p)||this._emitter.emitCellMetadataChange((0,M.deepFreeze)({document:this.apiNotebook,cell:a.apiCell}))}_changeCellInternalMetadata(n,g){const a=this._cells[n],c=a.internalMetadata;if(a.setInternalMetadata(g),c.runState!==g.runState){const p=g.runState??t.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange((0,M.deepFreeze)({document:this.apiNotebook,cell:a.apiCell,state:p}))}}getCellFromApiCell(n){return this._cells.find(g=>g.apiCell===n)}getCellFromIndex(n){return this._cells[n]}getCell(n){return this._cells.find(g=>g.handle===n)}getCellIndex(n){return this._cells.indexOf(n)}}e.ExtHostNotebookDocument=F,F._handlePool=0}),define(we[92],Ee([0,1,7,8,15]),function(re,e,u,M,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class A{constructor(C){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=C}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(C){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:C})}replaceCellMetadata(C,k){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:C,metadata:k})}replaceCells(C,k,F){this._throwIfFinalized(),!(C===k&&F.length===0)&&this._collectedEdits.push({editType:1,index:C,count:k-C,cells:F.map(M.NotebookCellData.from)})}}class t{constructor(C,k,F,_,n,g){this.id=C,this._proxy=k,this.notebookData=F,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=n,this._visibleRanges=_,this._viewColumn=g}get apiEditor(){if(!this._editor){const C=this;this._editor={get document(){return C.notebookData.apiNotebook},get selections(){return C._selections},set selections(k){if(!Array.isArray(k)||!k.every(u.NotebookRange.isNotebookRange))throw(0,w.illegalArgument)("selections");C._selections=k,C._trySetSelections(k)},get visibleRanges(){return C._visibleRanges},revealRange(k,F){C._proxy.$tryRevealRange(C.id,M.NotebookRange.from(k),F??u.NotebookEditorRevealType.Default)},get viewColumn(){return C._viewColumn},edit(k){const F=new A(this.document.version);return k(F),C._applyEdit(F.finalize())},setDecorations(k,F){return C.setDecorations(k,F)}},t.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(C){this._visible=C}_acceptVisibleRanges(C){this._visibleRanges=C}_acceptSelections(C){this._selections=C}_trySetSelections(C){this._proxy.$trySetSelections(this.id,C.map(M.NotebookRange.from))}_acceptViewColumn(C){this._viewColumn=C}_applyEdit(C){if(C.cellEdits.length===0)return Promise.resolve(!0);const k=[];let F=-1;for(let _=0;_<C.cellEdits.length;_++){if(F<0){k.push(C.cellEdits[_]),F++;continue}const g=k[F],a=C.cellEdits[_];if(g.editType===1&&a.editType===1&&g.index===a.index){g.cells.push(...C.cellEdits[_].cells),g.count+=C.cellEdits[_].count;continue}k.push(C.cellEdits[_]),F++}return this._proxy.$tryApplyEdits(this.id,C.documentVersionId,k)}setDecorations(C,k){if(!(k.isEmpty&&!this._hasDecorationsForKey.has(C.key)))return k.isEmpty?this._hasDecorationsForKey.delete(C.key):this._hasDecorationsForKey.add(C.key),this._proxy.$trySetDecorations(this.id,M.NotebookRange.from(k),C.key)}}e.ExtHostNotebookEditor=t,t.apiEditorsToExtHost=new WeakMap}),define(we[172],Ee([0,1,8,144,125,20,52,15]),function(re,e,u,M,w,A,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class C{constructor(n){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=n}async withProgress(n,g,a){const c=this._handles++,{title:p,location:D,cancellable:f}=g,l={label:(0,w.localize)(0,null,n.displayName||n.name),id:n.identifier.value};return this._proxy.$startProgress(c,{location:u.ProgressLocation.from(D),title:p,source:l,cancellable:f},n).catch(T.onUnexpectedExternalError),this._withProgress(c,a,!!f)}_withProgress(n,g,a){let c;a&&(c=new A.CancellationTokenSource,this._mapHandleToCancellationSource.set(n,c));const p=f=>{this._proxy.$progressEnd(f),this._mapHandleToCancellationSource.delete(f),c&&c.dispose()};let D;try{D=g(new F(this._proxy,n),a&&c?c.token:A.CancellationToken.None)}catch(f){throw p(n),f}return D.then(f=>p(n),f=>p(n)),D}$acceptProgressCanceled(n){const g=this._mapHandleToCancellationSource.get(n);g&&(g.cancel(),this._mapHandleToCancellationSource.delete(n))}}e.ExtHostProgress=C;function k(_,n){return _.message=n.message,typeof n.increment=="number"&&(typeof _.increment=="number"?_.increment+=n.increment:_.increment=n.increment),_}class F extends M.Progress{constructor(n,g){super(a=>this.throttledReport(a));this._proxy=n,this._handle=g}throttledReport(n){this._proxy.$progressReport(this._handle,n)}}Ne([(0,t.throttle)(100,(_,n)=>k(_,n),()=>Object.create(null))],F.prototype,"throttledReport",null)}),define(we[93],Ee([0,1,41,15,53,8,7]),function(re,e,u,M,w,A,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class T{constructor(n,g,a){const c=T._Keys.nextId();n.$registerTextEditorDecorationType(g.identifier,c,A.DecorationRenderOptions.from(a)),this.value=Object.freeze({key:c,dispose(){n.$removeTextEditorDecorationType(c)}})}}e.TextEditorDecorationType=T,T._Keys=new w.IdGenerator("TextEditorDecorationType");class C{constructor(n,g){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=n,this._documentVersionId=n.version,this._undoStopBefore=g.undoStopBefore,this._undoStopAfter=g.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(n,g){this._throwIfFinalized();let a=null;if(n instanceof t.Position)a=new t.Range(n,n);else if(n instanceof t.Range)a=n;else throw new Error("Unrecognized location");this._pushEdit(a,g,!1)}insert(n,g){this._throwIfFinalized(),this._pushEdit(new t.Range(n,n),g,!0)}delete(n){this._throwIfFinalized();let g=null;if(n instanceof t.Range)g=n;else throw new Error("Unrecognized location");this._pushEdit(g,null,!0)}_pushEdit(n,g,a){const c=this._document.validateRange(n);this._collectedEdits.push({range:c,text:g,forceMoveMarkers:a})}setEndOfLine(n){if(this._throwIfFinalized(),n!==t.EndOfLine.LF&&n!==t.EndOfLine.CRLF)throw(0,M.illegalArgument)("endOfLine");this._setEndOfLine=n}}e.TextEditorEdit=C;class k{constructor(n,g,a,c){this._proxy=n,this._id=g,this._accept(a),this._logService=c;const p=this;this.value={get tabSize(){return p._tabSize},set tabSize(D){p._setTabSize(D)},get insertSpaces(){return p._insertSpaces},set insertSpaces(D){p._setInsertSpaces(D)},get cursorStyle(){return p._cursorStyle},set cursorStyle(D){p._setCursorStyle(D)},get lineNumbers(){return p._lineNumbers},set lineNumbers(D){p._setLineNumbers(D)}}}_accept(n){this._tabSize=n.tabSize,this._insertSpaces=n.insertSpaces,this._cursorStyle=n.cursorStyle,this._lineNumbers=A.TextEditorLineNumbersStyle.to(n.lineNumbers)}_validateTabSize(n){if(n==="auto")return"auto";if(typeof n=="number"){const g=Math.floor(n);return g>0?g:null}if(typeof n=="string"){const g=parseInt(n,10);return isNaN(g)?null:g>0?g:null}return null}_setTabSize(n){const g=this._validateTabSize(n);if(g!==null){if(typeof g=="number"){if(this._tabSize===g)return;this._tabSize=g}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:g}))}}_validateInsertSpaces(n){return n==="auto"?"auto":n==="false"?!1:Boolean(n)}_setInsertSpaces(n){const g=this._validateInsertSpaces(n);if(typeof g=="boolean"){if(this._insertSpaces===g)return;this._insertSpaces=g}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:g}))}_setCursorStyle(n){this._cursorStyle!==n&&(this._cursorStyle=n,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:n})))}_setLineNumbers(n){this._lineNumbers!==n&&(this._lineNumbers=n,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:A.TextEditorLineNumbersStyle.from(n)})))}assign(n){const g={};let a=!1;if(typeof n.tabSize!="undefined"){const c=this._validateTabSize(n.tabSize);c==="auto"?(a=!0,g.tabSize=c):typeof c=="number"&&this._tabSize!==c&&(this._tabSize=c,a=!0,g.tabSize=c)}if(typeof n.insertSpaces!="undefined"){const c=this._validateInsertSpaces(n.insertSpaces);c==="auto"?(a=!0,g.insertSpaces=c):this._insertSpaces!==c&&(this._insertSpaces=c,a=!0,g.insertSpaces=c)}typeof n.cursorStyle!="undefined"&&this._cursorStyle!==n.cursorStyle&&(this._cursorStyle=n.cursorStyle,a=!0,g.cursorStyle=n.cursorStyle),typeof n.lineNumbers!="undefined"&&this._lineNumbers!==n.lineNumbers&&(this._lineNumbers=n.lineNumbers,a=!0,g.lineNumbers=A.TextEditorLineNumbersStyle.from(n.lineNumbers)),a&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,g))}_warnOnError(n,g){g.catch(a=>{this._logService.warn(`ExtHostTextEditorOptions '${n}' failed:'`),this._logService.warn(a)})}}e.ExtHostTextEditorOptions=k;class F{constructor(n,g,a,c,p,D,f,l){this.id=n,this._proxy=g,this._logService=a,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=p,this._options=new k(this._proxy,this.id,D,a),this._visibleRanges=f,this._viewColumn=l;const h=this;this.value=Object.freeze({get document(){return c.getValue()},set document(y){throw(0,M.readonly)("document")},get selection(){return h._selections&&h._selections[0]},set selection(y){if(!(y instanceof t.Selection))throw(0,M.illegalArgument)("selection");h._selections=[y],h._trySetSelection()},get selections(){return h._selections},set selections(y){if(!Array.isArray(y)||y.some(s=>!(s instanceof t.Selection)))throw(0,M.illegalArgument)("selections");h._selections=y,h._trySetSelection()},get visibleRanges(){return h._visibleRanges},set visibleRanges(y){throw(0,M.readonly)("visibleRanges")},get options(){return h._options.value},set options(y){h._disposed||h._options.assign(y)},get viewColumn(){return h._viewColumn},set viewColumn(y){throw(0,M.readonly)("viewColumn")},edit(y,s={undoStopBefore:!0,undoStopAfter:!0}){if(h._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const I=new C(c.getValue(),s);return y(I),h._applyEdit(I)},insertSnippet(y,s,I={undoStopBefore:!0,undoStopAfter:!0}){if(h._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let r;if(!s||Array.isArray(s)&&s.length===0)r=h._selections.map(i=>A.Range.from(i));else if(s instanceof t.Position){const{lineNumber:i,column:v}=A.Position.from(s);r=[{startLineNumber:i,startColumn:v,endLineNumber:i,endColumn:v}]}else if(s instanceof t.Range)r=[A.Range.from(s)];else{r=[];for(const i of s)if(i instanceof t.Range)r.push(A.Range.from(i));else{const{lineNumber:v,column:m}=A.Position.from(i);r.push({startLineNumber:v,startColumn:m,endLineNumber:v,endColumn:m})}}return g.$tryInsertSnippet(n,y.value,r,I)},setDecorations(y,s){const I=s.length===0;I&&!h._hasDecorationsForKey.has(y.key)||(I?h._hasDecorationsForKey.delete(y.key):h._hasDecorationsForKey.add(y.key),h._runOnProxy(()=>{if(A.isDecorationOptionsArr(s))return g.$trySetDecorations(n,y.key,A.fromRangeOrRangeWithMessage(s));{const r=new Array(4*s.length);for(let i=0,v=s.length;i<v;i++){const m=s[i];r[4*i]=m.start.line+1,r[4*i+1]=m.start.character+1,r[4*i+2]=m.end.line+1,r[4*i+3]=m.end.character+1}return g.$trySetDecorationsFast(n,y.key,r)}}))},revealRange(y,s){h._runOnProxy(()=>g.$tryRevealRange(n,A.Range.from(y),s||t.TextEditorRevealType.Default))},show(y){g.$tryShowEditor(n,A.ViewColumn.from(y))},hide(){g.$tryHideEditor(n)}})}dispose(){(0,u.ok)(!this._disposed),this._disposed=!0}_acceptOptions(n){(0,u.ok)(!this._disposed),this._options._accept(n)}_acceptVisibleRanges(n){(0,u.ok)(!this._disposed),this._visibleRanges=n}_acceptViewColumn(n){(0,u.ok)(!this._disposed),this._viewColumn=n}_acceptSelections(n){(0,u.ok)(!this._disposed),this._selections=n}async _trySetSelection(){const n=this._selections.map(A.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,n)),this.value}_applyEdit(n){const g=n.finalize();if(g.edits.length===0&&!g.setEndOfLine)return Promise.resolve(!0);const a=g.edits.map(p=>p.range);a.sort((p,D)=>p.end.line===D.end.line?p.end.character===D.end.character?p.start.line===D.start.line?p.start.character-D.start.character:p.start.line-D.start.line:p.end.character-D.end.character:p.end.line-D.end.line);for(let p=0,D=a.length-1;p<D;p++){const f=a[p].end;if(a[p+1].start.isBefore(f))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const c=g.edits.map(p=>({range:A.Range.from(p.range),text:p.text,forceMoveMarkers:p.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,g.documentVersionId,c,{setEndOfLine:typeof g.setEndOfLine=="number"?A.EndOfLine.from(g.setEndOfLine):void 0,undoStopBefore:g.undoStopBefore,undoStopAfter:g.undoStopAfter})}_runOnProxy(n){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):n().then(()=>this,g=>(g instanceof Error&&g.name==="DISPOSED"||this._logService.warn(g),null))}}e.ExtHostTextEditor=F}),define(we[173],Ee([0,1,128,23,2,3,6,14,7,10,16,8,20,157]),function(re,e,u,M,w,A,t,T,C,k,F,_,n,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function a(D,f){if((0,k.isString)(D))return{label:D};if(D&&typeof D=="object"&&typeof D.label=="string"){let l;return Array.isArray(D.highlights)&&(l=D.highlights.filter(h=>h.length===2&&typeof h[0]=="number"&&typeof h[1]=="number"),l=l.length?l:void 0),{label:D.label,highlights:l}}}class c{constructor(f,l,h){this._proxy=f,this.commands=l,this.logService=h,this.treeViews=new Map;function y(s){return s&&s.$treeViewId&&s.$treeItemHandle}l.registerArgumentProcessor({processArgument:s=>y(s)?this.convertArgument(s):Array.isArray(s)&&s.length>0?s.map(I=>y(I)?this.convertArgument(I):I):s})}registerTreeDataProvider(f,l,h){const y=this.createTreeView(f,{treeDataProvider:l},h);return{dispose:()=>y.dispose()}}createTreeView(f,l,h){if(!l||!l.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const y=l.dragAndDropController?.supportedMimeTypes,s=this._proxy.$registerTreeViewDataProvider(f,{showCollapseAll:!!l.showCollapseAll,canSelectMany:!!l.canSelectMany,dragAndDropMimeTypes:y}),I=this.createExtHostTreeView(f,l,h);return{get onDidCollapseElement(){return I.onDidCollapseElement},get onDidExpandElement(){return I.onDidExpandElement},get selection(){return I.selectedElements},get onDidChangeSelection(){return I.onDidChangeSelection},get visible(){return I.visible},get onDidChangeVisibility(){return I.onDidChangeVisibility},get message(){return I.message},set message(r){I.message=r},get title(){return I.title},set title(r){I.title=r},get description(){return I.description},set description(r){I.description=r},reveal:(r,i)=>I.reveal(r,i),dispose:async()=>{await s,this.treeViews.delete(f),I.dispose()}}}$getChildren(f,l){const h=this.treeViews.get(f);return h?h.getChildren(l):Promise.reject(new Error((0,u.localize)(0,null,f)))}async $onDrop(f,l,h,y,s){const I=this.treeViews.get(f);if(!I)return Promise.reject(new Error((0,u.localize)(1,null,f)));const r=g.TreeDataTransferConverter.toITreeDataTransfer(l);if(y===f&&s){const i=await I.onWillDrop(s);i&&i.forEach((v,m)=>{v&&r.set(m,v)})}return I.onDrop(r,h)}async $hasResolve(f){const l=this.treeViews.get(f);if(!l)throw new Error((0,u.localize)(2,null,f));return l.hasResolve}$resolve(f,l,h){const y=this.treeViews.get(f);if(!y)throw new Error((0,u.localize)(3,null,f));return y.resolveTreeItem(l,h)}$setExpanded(f,l,h){const y=this.treeViews.get(f);if(!y)throw new Error((0,u.localize)(4,null,f));y.setExpanded(l,h)}$setSelection(f,l){const h=this.treeViews.get(f);if(!h)throw new Error((0,u.localize)(5,null,f));h.setSelection(l)}$setVisible(f,l){const h=this.treeViews.get(f);if(!h)throw new Error((0,u.localize)(6,null,f));h.setVisible(l)}createExtHostTreeView(f,l,h){const y=new p(f,l,this._proxy,this.commands.converter,this.logService,h);return this.treeViews.set(f,y),y}convertArgument(f){const l=this.treeViews.get(f.$treeViewId);return l?l.getExtensionElement(f.$treeItemHandle):null}}e.ExtHostTreeViews=c;class p extends t.Disposable{constructor(f,l,h,y,s,I){super();if(this.viewId=f,this.proxy=h,this.commands=y,this.logService=s,this.extension=I,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new A.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new A.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new A.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new A.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new A.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new n.CancellationTokenSource,I.contributes&&I.contributes.views)for(const v in I.contributes.views)for(const m of I.contributes.views[v])m.id===f&&(this._title=m.name);this.dataProvider=l.treeDataProvider,this.dndController=l.dragAndDropController,this.dataProvider.onDidChangeTreeData2?this._register(this.dataProvider.onDidChangeTreeData2(v=>this._onDidChangeData.fire({message:!1,element:v}))):this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(v=>this._onDidChangeData.fire({message:!1,element:v})));let r,i;this._register(A.Event.debounce(this._onDidChangeData.event,(v,m)=>(v||(v={message:!1,elements:[]}),m.element!==!1&&(r||(r=new Promise(o=>i=o),this.refreshPromise=this.refreshPromise.then(()=>r)),Array.isArray(m.element)?v.elements.push(...m.element):v.elements.push(m.element)),m.message&&(v.message=!0),v),200,!0)(({message:v,elements:m})=>{m.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const o=i;return r=null,this.refresh(m).then(()=>o())})),v&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(f=>this.getExtensionElement(f)).filter(f=>!(0,k.isUndefinedOrNull)(f))}async getChildren(f){const l=f?this.getExtensionElement(f):void 0;if(f&&!l)return this.logService.error(`No tree item with id '${f}' found.`),Promise.resolve([]);let h=this.getChildrenNodes(f);return h||(h=await this.fetchChildrenNodes(l)),h?h.map(y=>y.item):void 0}getExtensionElement(f){return this.elements.get(f)}reveal(f,l){l=l||{select:!0,focus:!1};const h=(0,k.isUndefinedOrNull)(l.select)?!0:l.select,y=(0,k.isUndefinedOrNull)(l.focus)?!1:l.focus,s=(0,k.isUndefinedOrNull)(l.expand)?!1:l.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):f?this.refreshPromise.then(()=>this.resolveUnknownParentChain(f)).then(I=>this.resolveTreeNode(f,I[I.length-1]).then(r=>this.proxy.$reveal(this.viewId,{item:r.item,parentChain:I.map(i=>i.item)},{select:h,focus:y,expand:s})),I=>this.logService.error(I)):this.proxy.$reveal(this.viewId,void 0,{select:h,focus:y,expand:s})}get message(){return this._message}set message(f){this._message=f,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(f){this._title=f,this.proxy.$setTitle(this.viewId,f,this._description)}get description(){return this._description}set description(f){this._description=f,this.proxy.$setTitle(this.viewId,this._title,f)}setExpanded(f,l){const h=this.getExtensionElement(f);h&&(l?this._onDidExpandElement.fire(Object.freeze({element:h})):this._onDidCollapseElement.fire(Object.freeze({element:h})))}setSelection(f){(0,F.equals)(this._selectedHandles,f)||(this._selectedHandles=f,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(f){f!==this._visible&&(this._visible=f,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async onWillDrop(f){const l=[];for(const h of f){const y=this.getExtensionElement(h);y&&l.push(y)}if(!(!this.dndController?.onWillDrop||l.length===0))return this.dndController.onWillDrop(l)}async onDrop(f,l){const h=this.getExtensionElement(l);if(!!h)return(0,T.asPromise)(()=>this.dndController?.onDrop(f,h))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(f,l){if(!this.dataProvider.resolveTreeItem)return;const h=this.elements.get(f);if(h){const y=this.nodes.get(h);if(y){const s=await this.dataProvider.resolveTreeItem(y.extensionItem,h,l)??y.extensionItem;return y.item.tooltip=this.getTooltip(s.tooltip),y.item.command=this.getCommand(y.disposableStore,s.command),y.item}}}resolveUnknownParentChain(f){return this.resolveParent(f).then(l=>l?this.resolveUnknownParentChain(l).then(h=>this.resolveTreeNode(l,h[h.length-1]).then(y=>(h.push(y),h))):Promise.resolve([]))}resolveParent(f){const l=this.nodes.get(f);return l?Promise.resolve(l.parent?this.elements.get(l.parent.item.handle):void 0):(0,T.asPromise)(()=>this.dataProvider.getParent(f))}resolveTreeNode(f,l){const h=this.nodes.get(f);return h?Promise.resolve(h):(0,T.asPromise)(()=>this.dataProvider.getTreeItem(f)).then(y=>this.createHandle(f,y,l,!0)).then(y=>this.getChildren(l?l.item.handle:void 0).then(()=>{const s=this.getExtensionElement(y);if(s){const I=this.nodes.get(s);if(I)return Promise.resolve(I)}throw new Error(`Cannot resolve tree item for element ${y}`)}))}getChildrenNodes(f){if(f){let l;if(typeof f=="string"){const h=this.getExtensionElement(f);l=h?this.nodes.get(h):void 0}else l=f;return l&&l.children||void 0}return this.roots}async fetchChildrenNodes(f){this.clearChildren(f);const l=new n.CancellationTokenSource(this._refreshCancellationSource.token);try{const h=f?this.nodes.get(f):void 0,y=await this.dataProvider.getChildren(f);if(l.token.isCancellationRequested)return;const s=await Promise.all((0,F.coalesce)(y||[]).map(async I=>{const r=await this.dataProvider.getTreeItem(I);return r&&!l.token.isCancellationRequested?this.createAndRegisterTreeNode(I,r,h):null}));return l.token.isCancellationRequested?void 0:(0,F.coalesce)(s)}finally{l.dispose()}}refresh(f){if(f.some(h=>!h))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new n.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const h=this.getHandlesToRefresh(f);if(h.length)return this.refreshHandles(h)}return Promise.resolve(void 0)}getHandlesToRefresh(f){const l=new Set,h=f.map(s=>this.nodes.get(s));for(const s of h)if(s&&!l.has(s.item.handle)){let I=s;for(;I&&I.parent&&h.findIndex(r=>I&&I.parent&&r&&r.item.handle===I.parent.item.handle)===-1;){const r=this.elements.get(I.parent.item.handle);I=r?this.nodes.get(r):void 0}I&&!I.parent&&l.add(s.item.handle)}const y=[];return l.forEach(s=>{const I=this.elements.get(s);if(I){const r=this.nodes.get(I);r&&(!r.parent||!l.has(r.parent.item.handle))&&y.push(s)}}),y}refreshHandles(f){const l={};return Promise.all(f.map(h=>this.refreshNode(h).then(y=>{y&&(l[h]=y.item)}))).then(()=>Object.keys(l).length?this.proxy.$refresh(this.viewId,l):void 0)}refreshNode(f){const l=this.getExtensionElement(f);if(l){const h=this.nodes.get(l);if(h)return this.clearChildren(l),(0,T.asPromise)(()=>this.dataProvider.getTreeItem(l)).then(y=>{if(y){const s=this.createTreeNode(l,y,h.parent);return this.updateNodeCache(l,s,h,h.parent),h.dispose(),s}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(f,l,h){const y=this.createTreeNode(f,l,h);if(l.id&&this.elements.has(y.item.handle))throw new Error((0,u.localize)(7,null,l.id));return this.addNodeToCache(f,y),this.addNodeToParentCache(y,h),y}getTooltip(f){return C.MarkdownString.isMarkdownString(f)?_.MarkdownString.from(f):f}getCommand(f,l){return l?this.commands.toInternal(l,f):void 0}createTreeNode(f,l,h){const y=new t.DisposableStore,s=this.createHandle(f,l,h),I=this.getLightIconPath(l);return{item:{handle:s,parentHandle:h?h.item.handle:void 0,label:a(l.label,this.extension),description:l.description,resourceUri:l.resourceUri,tooltip:this.getTooltip(l.tooltip),command:this.getCommand(y,l.command),contextValue:l.contextValue,icon:I,iconDark:this.getDarkIconPath(l)||I,themeIcon:this.getThemeIcon(l),collapsibleState:(0,k.isUndefinedOrNull)(l.collapsibleState)?C.TreeItemCollapsibleState.None:l.collapsibleState,accessibilityInformation:l.accessibilityInformation},extensionItem:l,parent:h,children:void 0,disposableStore:y,dispose(){y.dispose()}}}getThemeIcon(f){return f.iconPath instanceof C.ThemeIcon?f.iconPath:void 0}createHandle(f,{id:l,label:h,resourceUri:y},s,I){if(l)return`${p.ID_HANDLE_PREFIX}/${l}`;const r=a(h,this.extension),i=s?s.item.handle:p.LABEL_HANDLE_PREFIX;let v=r?r.label:y?(0,M.basename)(y):"";v=v.indexOf("/")!==-1?v.replace("/","//"):v;const m=this.nodes.has(f)?this.nodes.get(f).item.handle:void 0,o=this.getChildrenNodes(s)||[];let b,d=0;do{if(b=`${i}/${d}:${v}`,I||!this.elements.has(b)||m===b)break;d++}while(d<=o.length);return b}getLightIconPath(f){if(f.iconPath&&!(f.iconPath instanceof C.ThemeIcon))return typeof f.iconPath=="string"||w.URI.isUri(f.iconPath)?this.getIconPath(f.iconPath):this.getIconPath(f.iconPath.light)}getDarkIconPath(f){if(f.iconPath&&!(f.iconPath instanceof C.ThemeIcon)&&f.iconPath.dark)return this.getIconPath(f.iconPath.dark)}getIconPath(f){return w.URI.isUri(f)?f:w.URI.file(f)}addNodeToCache(f,l){this.elements.set(l.item.handle,f),this.nodes.set(f,l)}updateNodeCache(f,l,h,y){this.elements.delete(l.item.handle),this.nodes.delete(f),l.item.handle!==h.item.handle&&this.elements.delete(h.item.handle),this.addNodeToCache(f,l);const s=this.getChildrenNodes(y)||[],I=s.filter(r=>r.item.handle===h.item.handle)[0];I&&s.splice(s.indexOf(I),1,l)}addNodeToParentCache(f,l){l?(l.children||(l.children=[]),l.children.push(f)):(this.roots||(this.roots=[]),this.roots.push(f))}clearChildren(f){if(f){const l=this.nodes.get(f);if(l){if(l.children)for(const h of l.children){const y=this.elements.get(h.item.handle);y&&this.clear(y)}l.children=void 0}}else this.clearAll()}clear(f){const l=this.nodes.get(f);if(l){if(l.children)for(const h of l.children){const y=this.elements.get(h.item.handle);y&&this.clear(y)}this.nodes.delete(f),this.elements.delete(l.item.handle),l.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(f=>f.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}p.LABEL_HANDLE_PREFIX="0",p.ID_HANDLE_PREFIX="1"}),define(we[174],Ee([0,1,14,3,6,10,48,8,89,68]),function(re,e,u,M,w,A,t,T,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=void 0;class F extends w.Disposable{constructor(n){super();this.controllerId=n,this.debounceSendDiff=this._register(new u.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new M.Emitter),this.root=new t.TestItemRootImpl(this.controllerId,this.controllerId),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(n){this._resolveHandler=n;for(const g of this.tree.values())this.updateExpandability(g)}collectDiff(){const n=this.diff;return this.diff=[],n}pushDiff(n){const g=this.diff[this.diff.length-1];if(g&&n[0]===1){if(g[0]===1&&g[1].extId===n[1].extId){(0,C.applyTestItemUpdate)(g[1],n[1]);return}if(g[0]===0&&g[1].item.extId===n[1].extId){(0,C.applyTestItemUpdate)(g[1],n[1]);return}}this.diff.push(n),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(n,g){const a=this.tree.get(n);if(!!a){if((a.expandLevels===void 0||g>a.expandLevels)&&(a.expandLevels=g),a.expand===1){const c=this.resolveChildren(a);return c.isOpen()?this.expandChildren(a,g-1):c.wait().then(()=>this.expandChildren(a,g-1))}else if(a.expand===3)return a.resolveBarrier?.isOpen()===!1?a.resolveBarrier.wait().then(()=>this.expandChildren(a,g-1)):this.expandChildren(a,g-1)}}dispose(){for(const n of this.tree.values())(0,t.getPrivateApiFor)(n.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(n,g){switch(g.op){case 2:this.pushDiff([4,n.fullId.toString()]);break;case 1:this.removeItem(k.TestId.joinToString(n.fullId,g.id));break;case 0:this.upsertItem(g.item,n);break;case 4:for(const f of g.ops)this.onTestItemEvent(n,f);break;case 3:const{key:a,value:c,previous:p}=g,D=n.fullId.toString();switch(a){case"canResolveChildren":this.updateExpandability(n);break;case"tags":this.diffTagRefs(c,p,D);break;case"range":this.pushDiff([1,{extId:D,item:{range:T.Range.from(c)}}]);break;case"error":this.pushDiff([1,{extId:D,item:{error:T.MarkdownString.fromStrict(c)||null}}]);break;default:this.pushDiff([1,{extId:D,item:{[a]:c??null}}]);break}break;default:(0,A.assertNever)(g)}}upsertItem(n,g){if(!(n instanceof t.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${n.id} did not`);const a=k.TestId.fromExtHostTestItem(n,this.root.id,g?.actual),c=(0,t.getPrivateApiFor)(n);c.parent&&c.parent!==g?.actual&&c.parent.children.delete(n.id);let p=this.tree.get(a.toString());if(!p){p={fullId:a,actual:n,parent:g?a.parentId:null,expandLevels:g?.expandLevels?g.expandLevels-1:void 0,expand:0},n.tags.forEach(this.incrementTagRefs,this),this.tree.set(p.fullId.toString(),p),this.setItemParent(n,g),this.pushDiff([0,{parent:p.parent&&p.parent.toString(),controllerId:this.controllerId,expand:p.expand,item:T.TestItem.from(n)}]),this.connectItemAndChildren(n,p,g);return}if(p.actual===n){this.connectItem(n,p,g);return}const D=p.actual.children,f=p.actual,l=(0,t.diffTestItems)(f,n);(0,t.getPrivateApiFor)(f).listener=void 0,p.actual=n,p.expand=0;for(const[h,y]of l)this.onTestItemEvent(p,{op:3,key:h,value:y,previous:f[h]});this.connectItemAndChildren(n,p,g);for(const h of D)n.children.get(h.id)||this.removeItem(k.TestId.joinToString(a,h.id))}diffTagRefs(n,g,a){const c=new Set(g.map(p=>p.id));for(const p of n)c.delete(p.id)||this.incrementTagRefs(p);this.pushDiff([1,{extId:a,item:{tags:n.map(p=>T.TestTag.namespace(this.controllerId,p.id))}}]),c.forEach(this.decrementTagRefs,this)}incrementTagRefs(n){const g=this.tags.get(n.id);g?g.refCount++:(this.tags.set(n.id,{refCount:1}),this.pushDiff([5,{id:T.TestTag.namespace(this.controllerId,n.id),ctrlLabel:this.root.label}]))}decrementTagRefs(n){const g=this.tags.get(n);g&&!--g.refCount&&(this.tags.delete(n),this.pushDiff([6,T.TestTag.namespace(this.controllerId,n)]))}setItemParent(n,g){(0,t.getPrivateApiFor)(n).parent=g&&g.actual!==this.root?g.actual:void 0}connectItem(n,g,a){this.setItemParent(n,a);const c=(0,t.getPrivateApiFor)(n);c.parent=a?.actual,c.listener=p=>this.onTestItemEvent(g,p),this.updateExpandability(g)}connectItemAndChildren(n,g,a){this.connectItem(n,g,a);for(const c of n.children)this.upsertItem(c,g)}updateExpandability(n){let g;this._resolveHandler?n.resolveBarrier?g=n.resolveBarrier.isOpen()?3:2:g=n.actual.canResolveChildren?1:0:g=0,g!==n.expand&&(n.expand=g,this.pushDiff([1,{extId:n.fullId.toString(),expand:g}]),g===1&&n.expandLevels!==void 0&&this.resolveChildren(n))}expandChildren(n,g){if(g<0)return;const a=[];for(const c of n.actual.children){const p=this.expand(k.TestId.joinToString(n.fullId,c.id),g);(0,u.isThenable)(p)&&a.push(p)}if(a.length)return Promise.all(a).then(()=>{})}resolveChildren(n){if(n.resolveBarrier)return n.resolveBarrier;if(!this._resolveHandler){const p=new u.Barrier;return p.open(),p}n.expand=2,this.pushExpandStateUpdate(n);const g=n.resolveBarrier=new u.Barrier,a=p=>{console.error(`Unhandled error in resolveHandler of test controller "${this.controllerId}"`),n.actual!==this.root&&(n.actual.error=p.stack||p.message||String(p))};let c;try{c=this._resolveHandler(n.actual===this.root?void 0:n.actual)}catch(p){a(p)}return(0,u.isThenable)(c)?c.catch(a).then(()=>{g.open(),this.updateExpandability(n)}):(g.open(),this.updateExpandability(n)),n.resolveBarrier}pushExpandStateUpdate(n){this.pushDiff([1,{extId:n.fullId.toString(),expand:n.expand}])}removeItem(n){const g=this.tree.get(n);if(!g)throw new Error("attempting to remove non-existent child");this.pushDiff([2,n]);const a=[g];for(;a.length;){const c=a.pop();if(!!c){(0,t.getPrivateApiFor)(c.actual).listener=void 0;for(const p of c.actual.tags)this.decrementTagRefs(p.id);this.tree.delete(c.fullId.toString());for(const p of c.actual.children)a.push(this.tree.get(k.TestId.joinToString(c.fullId,p.id)))}}}flushDiff(){const n=this.collectDiff();n.length&&this.diffOpEmitter.fire(n)}}e.SingleUseTestCollection=F}),define(we[175],Ee([0,1,4,140]),function(re,e,u,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,u.refineServiceDecorator)(M.IEnvironmentService)}),define(we[176],Ee([0,1,26,3,17]),function(re,e,u,M,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class A{constructor(F){this.removedDueToLooping=F}}e.DeltaExtensionsResult=A;class t{constructor(F){this._onDidChange=new M.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=F,this._initialize()}_initialize(){this._extensionDescriptions.sort(C),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const F of this._extensionDescriptions){if(this._extensionsMap.has(u.ExtensionIdentifier.toKey(F.identifier))){console.error("Extension `"+F.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(u.ExtensionIdentifier.toKey(F.identifier),F),this._extensionsArr.push(F),Array.isArray(F.activationEvents))for(let _ of F.activationEvents)_==="onUri"&&(_=`onUri:${u.ExtensionIdentifier.toKey(F.identifier)}`),this._activationMap.has(_)||this._activationMap.set(_,[]),this._activationMap.get(_).push(F)}}keepOnly(F){const _=new Set;F.forEach(n=>_.add(u.ExtensionIdentifier.toKey(n))),this._extensionDescriptions=this._extensionDescriptions.filter(n=>_.has(u.ExtensionIdentifier.toKey(n.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(F,_){F.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(F));const n=t._findLoopingExtensions(this._extensionDescriptions);if(_=_.concat(n.map(g=>g.identifier)),_.length>0){const g=new Set;_.forEach(a=>g.add(u.ExtensionIdentifier.toKey(a))),this._extensionDescriptions=this._extensionDescriptions.filter(a=>!g.has(u.ExtensionIdentifier.toKey(a.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new A(n)}static _findLoopingExtensions(F){const _=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(p){this._nodesSet.has(p)||(this._nodesSet.add(p),this._nodesArr.push(p))}addArc(p,D){this.addNode(p),this.addNode(D),this._arcs.has(p)?this._arcs.get(p).push(D):this._arcs.set(p,[D])}getArcs(p){return this._arcs.has(p)?this._arcs.get(p):[]}hasOnlyGoodArcs(p,D){const f=_.getArcs(p);for(let l=0;l<f.length;l++)if(!D.has(f[l]))return!1;return!0}getNodes(){return this._nodesArr}};let n=new Map;for(let p of F){const D=u.ExtensionIdentifier.toKey(p.identifier);if(n.set(D,p),p.extensionDependencies)for(let f of p.extensionDependencies){const l=u.ExtensionIdentifier.toKey(f);_.addArc(D,l)}}let g=new Set;_.getNodes().filter(p=>_.getArcs(p).length===0).forEach(p=>g.add(p));let a=_.getNodes().filter(p=>!g.has(p)),c;do{c=!1;for(let p=0;p<a.length;p++){const D=a[p];_.hasOnlyGoodArcs(D,g)&&(a.splice(p,1),p--,g.add(D),c=!0)}}while(c);return a.map(p=>n.get(p))}containsActivationEvent(F){return this._activationMap.has(F)}containsExtension(F){return this._extensionsMap.has(u.ExtensionIdentifier.toKey(F))}getExtensionDescriptionsForActivationEvent(F){const _=this._activationMap.get(F);return _?_.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(F){const _=this._extensionsMap.get(u.ExtensionIdentifier.toKey(F));return _||void 0}}e.ExtensionDescriptionRegistry=t;var T;(function(k){k[k.Builtin=0]="Builtin",k[k.User=1]="User",k[k.Dev=2]="Dev"})(T||(T={}));function C(k,F){const _=k.isBuiltin?0:k.isUnderDevelopment?2:1,n=F.isBuiltin?0:F.isUnderDevelopment?2:1;if(_!==n)return _-n;const g=w.posix.basename(k.extensionLocation.path),a=w.posix.basename(F.extensionLocation.path);return g<a?-1:g>a?1:0}}),define(we[177],Ee([0,1,22]),function(re,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var M;(function(T){T[T.VersionMismatch=55]="VersionMismatch",T[T.UnexpectedError=81]="UnexpectedError"})(M=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var w;(function(T){T[T.Initialized=0]="Initialized",T[T.Ready=1]="Ready",T[T.Terminate=2]="Terminate"})(w=e.MessageType||(e.MessageType={}));function A(T){const C=u.VSBuffer.alloc(1);switch(T){case 0:C.writeUInt8(1,0);break;case 1:C.writeUInt8(2,0);break;case 2:C.writeUInt8(3,0);break}return C}e.createMessageOfType=A;function t(T,C){if(T.byteLength!==1)return!1;switch(T.readUInt8(0)){case 1:return C===0;case 2:return C===1;case 3:return C===2;default:return!1}}e.isMessageOfType=t}),define(we[27],Ee([0,1,3,2,4,26,147]),function(re,e,u,M,w,A,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.extensionRunningLocationToString=e.ExtensionRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new A.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:M.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,w.createDecorator)("extensionService");var T;(function(h){h[h.None=0]="None",h[h.LocalProcess=1]="LocalProcess",h[h.LocalWebWorker=2]="LocalWebWorker",h[h.Remote=3]="Remote"})(T=e.ExtensionRunningLocation||(e.ExtensionRunningLocation={}));function C(h){switch(h){case 0:return"None";case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionRunningLocationToString=C;class k{constructor(y){this.dependency=y}}e.MissingExtensionDependency=k;var F;(function(h){h[h.LocalProcess=0]="LocalProcess",h[h.LocalWebWorker=1]="LocalWebWorker",h[h.Remote=2]="Remote"})(F=e.ExtensionHostKind||(e.ExtensionHostKind={}));function _(h){switch(h){case 0:return"LocalProcess";case 1:return"LocalWebWorker";case 2:return"Remote"}}e.extensionHostKindToString=_;function n(h,y){return h.enabledApiProposals?.includes(y)?!0:Boolean(h.enableProposedApi)}e.isProposedApiEnabled=n;function g(h,y){if(!n(h,y))throw new Error(`Extension '${h.identifier.value}' CANNOT use API proposal: ${y}.
According to its package.json#enabledApiProposals-property it wants: ${h.enabledApiProposals?.join(", ")??"<none>"}.
 You MUST start in extension development mode or use the following command line switch: --enable-proposed-api ${h.identifier.value}`)}e.checkProposedApiEnabled=g;class a{constructor(y,s,I,r){this.codeLoadingTime=y,this.activateCallTime=s,this.activateResolvedTime=I,this.activationReason=r}}e.ActivationTimes=a;class c{constructor(y,s){this.description=y,this.value=s}}e.ExtensionPointContribution=c,e.ExtensionHostLogFileName="exthost";var p;(function(h){h[h.Normal=0]="Normal",h[h.Immediate=1]="Immediate"})(p=e.ActivationKind||(e.ActivationKind={}));function D(h){return{type:h.isBuiltin?0:1,isBuiltin:h.isBuiltin||h.isUserBuiltin,identifier:{id:(0,t.getGalleryExtensionId)(h.publisher,h.name),uuid:h.uuid},manifest:h,location:h.extensionLocation}}e.toExtension=D;function f(h,y){return{identifier:new A.ExtensionIdentifier(h.identifier.id),isBuiltin:h.type===0,isUserBuiltin:h.type===1&&h.isBuiltin,isUnderDevelopment:!!y,extensionLocation:h.location,...h.manifest,uuid:h.identifier.uuid}}e.toExtensionDescription=f;class l{constructor(){this.onDidRegisterExtensions=u.Event.None,this.onDidChangeExtensionsStatus=u.Event.None,this.onDidChangeExtensions=u.Event.None,this.onWillActivateByEvent=u.Event.None,this.onDidChangeResponsiveChange=u.Event.None}activateByEvent(y){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(y){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(y){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(y){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(y,s){return Promise.resolve()}_onWillActivateExtension(y){}_onDidActivateExtension(y,s,I,r,i){}_onDidActivateExtensionError(y,s){}_onExtensionRuntimeError(y,s){}_onExtensionHostExit(y){}}e.NullExtensionService=l}),define(we[178],Ee([0,1,15,26,27,12]),function(re,e,u,M,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const t=Promise.resolve(void 0);class T{constructor(c,p,D,f){this.startup=c,this.codeLoadingTime=p,this.activateCallTime=D,this.activateResolvedTime=f}}e.ExtensionActivationTimes=T,T.NONE=new T(!1,-1,-1,-1);class C{constructor(c){this._startup=c,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(c,p){return c===-1||p===-1?-1:p-c}build(){return new T(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=C;class k{constructor(c,p,D,f,l,h){this.activationFailed=c,this.activationFailedError=p,this.activationTimes=D,this.module=f,this.exports=l,this.subscriptions=h}}e.ActivatedExtension=k;class F extends k{constructor(c){super(!1,null,c,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=F;class _ extends k{constructor(){super(!1,null,T.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=_;class n extends k{constructor(c){super(!0,c,T.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=n;let g=class{constructor(c,p,D,f,l){this._logService=l,this._isDisposed=!1,this._registry=c,this._resolvedExtensionsSet=new Set,p.forEach(h=>this._resolvedExtensionsSet.add(M.ExtensionIdentifier.toKey(h))),this._hostExtensionsMap=new Map,D.forEach(h=>this._hostExtensionsMap.set(M.ExtensionIdentifier.toKey(h),h)),this._host=f,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}dispose(){this._isDisposed=!0}isActivated(c){const p=M.ExtensionIdentifier.toKey(c);return this._activatedExtensions.has(p)}getActivatedExtension(c){const p=M.ExtensionIdentifier.toKey(c),D=this._activatedExtensions.get(p);if(!D)throw new Error("Extension `"+c.value+"` is not known or not activated");return D}activateByEvent(c,p){if(this._alreadyActivatedEvents[c])return t;const D=this._registry.getExtensionDescriptionsForActivationEvent(c);return this._activateExtensions(D.map(f=>({id:f.identifier,reason:{startup:p,extensionId:f.identifier,activationEvent:c}}))).then(()=>{this._alreadyActivatedEvents[c]=!0})}activateById(c,p){const D=this._registry.getExtensionDescription(c);if(!D)throw new Error("Extension `"+c+"` is not known");return this._activateExtensions([{id:D.identifier,reason:p}])}_handleActivateRequest(c,p,D){if(this._hostExtensionsMap.has(M.ExtensionIdentifier.toKey(c.id))){p[M.ExtensionIdentifier.toKey(c.id)]=c;return}const f=this._registry.getExtensionDescription(c.id);if(!f){const y=new Error(`Cannot activate unknown extension '${c.id.value}'`);this._host.onExtensionActivationError(c.id,y,new w.MissingExtensionDependency(c.id.value)),this._activatedExtensions.set(M.ExtensionIdentifier.toKey(c.id),new n(y));return}const l=typeof f.extensionDependencies=="undefined"?[]:f.extensionDependencies;let h=!0;for(let y=0,s=l.length;y<s;y++){const I=l[y];if(this._resolvedExtensionsSet.has(M.ExtensionIdentifier.toKey(I)))continue;const r=this._activatedExtensions.get(M.ExtensionIdentifier.toKey(I));if(r&&!r.activationFailed)continue;if(r&&r.activationFailed){const o=f.displayName||f.identifier.value,b=this._registry.getExtensionDescription(I),d=b&&b.displayName||I,E=new Error(`Cannot activate the '${o}' extension because its dependency '${d}' failed to activate`);E.detail=r.activationFailedError,this._host.onExtensionActivationError(f.identifier,E,null),this._activatedExtensions.set(M.ExtensionIdentifier.toKey(f.identifier),new n(E));return}if(this._hostExtensionsMap.has(M.ExtensionIdentifier.toKey(I))){h=!1,p[M.ExtensionIdentifier.toKey(I)]={id:this._hostExtensionsMap.get(M.ExtensionIdentifier.toKey(I)),reason:c.reason};continue}const i=this._registry.getExtensionDescription(I);if(i){if(!i.main&&!i.browser)continue;h=!1,p[M.ExtensionIdentifier.toKey(I)]={id:i.identifier,reason:c.reason};continue}const v=f.displayName||f.identifier.value,m=new Error(`Cannot activate the '${v}' extension because it depends on unknown extension '${I}'`);this._host.onExtensionActivationError(f.identifier,m,new w.MissingExtensionDependency(I)),this._activatedExtensions.set(M.ExtensionIdentifier.toKey(f.identifier),new n(m));return}h?p[M.ExtensionIdentifier.toKey(f.identifier)]=c:D.push(c)}_activateExtensions(c){if(c.length===0||(c=c.filter(l=>!this._activatedExtensions.has(M.ExtensionIdentifier.toKey(l.id))),c.length===0))return Promise.resolve(void 0);const p=Object.create(null),D=[];for(let l=0,h=c.length;l<h;l++)this._handleActivateRequest(c[l],p,D);for(let l=0,h=D.length;l<h;l++){const y=M.ExtensionIdentifier.toKey(D[l].id);p[y]&&delete p[y]}const f=Object.keys(p).map(l=>p[l]);return D.length===0?Promise.all(f.map(l=>this._activateExtension(l.id,l.reason))).then(l=>{}):this._activateExtensions(f).then(l=>this._activateExtensions(D))}_activateExtension(c,p){const D=M.ExtensionIdentifier.toKey(c);if(this._activatedExtensions.has(D))return Promise.resolve(void 0);const f=this._activatingExtensions.get(D);if(f)return f;const l=this._host.actualActivateExtension(c,p).then(void 0,h=>{const y=new Error;return h&&h.name&&(y.name=h.name),h&&h.message?y.message=`Activating extension '${c.value}' failed: ${h.message}.`:y.message=`Activating extension '${c.value}' failed: ${h}.`,h&&h.stack&&(y.stack=h.stack),this._isDisposed&&u.isPromiseCanceledError(h)?new n(h):(this._host.onExtensionActivationError(c,y,null),this._logService.error(`Activating extension ${c.value} failed due to an error:`),this._logService.error(h),new n(h))}).then(h=>{this._activatedExtensions.set(D,h),this._activatingExtensions.delete(D)});return this._activatingExtensions.set(D,l),l}};g=Ne([xe(4,A.ILogService)],g),e.ExtensionsActivator=g}),define(we[179],Ee([0,1,12,28,27]),function(re,e,u,M,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let A=class extends u.LogService{constructor(T,C){super(T.createLogger(C.logFile,{name:w.ExtensionHostLogFileName}))}};A=Ne([xe(0,u.ILoggerService),xe(1,M.IExtHostInitDataService)],A),e.ExtHostLogService=A}),define(we[180],Ee([0,1,15]),function(re,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class M{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((A,t)=>{this._actualOk=A,this._actualErr=t,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(A){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=A,this._actual&&this._actualOk(A))}resolveErr(A){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=A,this._actual?this._actualErr(A):(0,u.onUnexpectedError)(A))}then(A,t){return this._ensureActual().then(A,t)}catch(A){return this._ensureActual().then(void 0,A)}finally(A){return this._ensureActual().finally(A)}}e.LazyPromise=M}),define(we[37],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class u{constructor(k,F){this._proxyIdentifierBrand=void 0,this.isMain=k,this.sid=F,this.nid=++u.count}}e.ProxyIdentifier=u,u.count=0;const M=[];function w(C){const k=new u(!0,C);return M[k.nid]=k,k}e.createMainContextProxyIdentifier=w;function A(C){const k=new u(!1,C);return M[k.nid]=k,k}e.createExtHostContextProxyIdentifier=A;function t(C){return M[C].sid}e.getStringIdentifierForProxy=t;class T{constructor(k){this.value=k}}e.SerializableObjectWithBuffers=T}),define(we[5],Ee([0,1,55,2,37]),function(re,e,u,M,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var A;(function(l){l[l.Desktop=1]="Desktop",l[l.Web=2]="Web"})(A=e.UIKind||(e.UIKind={}));var t;(function(l){l[l.Default=0]="Default",l[l.InCenter=1]="InCenter",l[l.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",l[l.AtTop=3]="AtTop"})(t=e.TextEditorRevealType||(e.TextEditorRevealType={}));var T;(function(l){l[l.Editable=0]="Editable",l[l.SupportsHotExit=1]="SupportsHotExit"})(T=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var C;(function(l){l[l.Int8Array=1]="Int8Array",l[l.Uint8Array=2]="Uint8Array",l[l.Uint8ClampedArray=3]="Uint8ClampedArray",l[l.Int16Array=4]="Int16Array",l[l.Uint16Array=5]="Uint16Array",l[l.Int32Array=6]="Int32Array",l[l.Uint32Array=7]="Uint32Array",l[l.Float32Array=8]="Float32Array",l[l.Float64Array=9]="Float64Array",l[l.BigInt64Array=10]="BigInt64Array",l[l.BigUint64Array=11]="BigUint64Array"})(C=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var k;(function(l){l[l.Text=1]="Text",l[l.Error=2]="Error",l[l.Rich=3]="Rich"})(k=e.CellOutputKind||(e.CellOutputKind={}));var F;(function(l){l[l.Default=0]="Default",l[l.InCenter=1]="InCenter",l[l.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",l[l.AtTop=3]="AtTop"})(F=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var _;(function(l){l[l.None=0]="None",l[l.Process=1]="Process",l[l.Output=2]="Output"})(_=e.CandidatePortSource||(e.CandidatePortSource={}));var n;(function(l){l.name="$ident";function h(s,I){return Object.defineProperty(s,l.name,{value:I,enumerable:!0}),s}l.mixin=h;function y(s){return s[l.name]}l.of=y})(n=e.ObjectIdentifier||(e.ObjectIdentifier={}));class g{static mixin(h){return h._id=g._n++,h}}e.IdObject=g,g._n=0;var a;(function(l){l.label="a",l.kind="b",l.detail="c",l.documentation="d",l.sortText="e",l.filterText="f",l.preselect="g",l.insertText="h",l.insertTextRules="i",l.range="j",l.commitCharacters="k",l.additionalTextEdits="l",l.command="m",l.kindModifier="n"})(a=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var c;(function(l){l.defaultRanges="a",l.completions="b",l.isIncomplete="c",l.duration="d"})(c=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var p;(function(l){l[l.File=1]="File",l[l.Text=2]="Text",l[l.Cell=3]="Cell"})(p=e.WorkspaceEditType||(e.WorkspaceEditType={}));function D(l){if(l&&l.edits)for(const h of l.edits)typeof h.resource=="object"?h.resource=M.URI.revive(h.resource):(h.newUri=M.URI.revive(h.newUri),h.oldUri=M.URI.revive(h.oldUri)),h.metadata&&h.metadata.iconPath&&(h.metadata=(0,u.revive)(h.metadata));return l}e.reviveWorkspaceEditDto=D;var f;(function(l){l[l.Workspace=0]="Workspace",l[l.TextDocument=1]="TextDocument"})(f=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,w.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,w.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,w.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,w.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,w.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,w.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,w.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,w.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,w.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,w.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,w.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,w.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,w.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,w.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,w.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,w.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,w.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,w.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,w.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,w.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,w.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,w.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,w.createMainContextProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,w.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,w.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,w.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,w.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,w.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,w.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,w.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,w.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,w.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,w.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,w.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,w.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,w.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,w.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,w.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,w.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,w.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,w.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,w.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,w.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,w.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,w.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,w.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,w.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,w.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,w.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,w.createMainContextProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,w.createMainContextProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,w.createMainContextProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,w.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,w.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,w.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,w.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,w.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,w.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,w.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,w.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,w.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,w.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,w.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,w.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,w.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,w.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,w.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,w.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,w.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,w.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,w.createExtHostContextProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,w.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,w.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,w.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,w.createExtHostContextProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,w.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,w.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,w.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,w.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,w.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,w.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,w.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,w.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,w.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,w.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,w.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,w.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,w.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,w.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,w.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,w.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,w.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,w.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,w.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,w.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,w.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,w.createMainContextProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,w.createMainContextProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,w.createMainContextProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,w.createMainContextProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,w.createMainContextProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,w.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,w.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,w.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,w.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,w.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,w.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(we[69],Ee([0,1,5,3,4]),function(re,e,u,M,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class A{constructor(T){this._onDidChangePassword=new M.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=T.getProxy(u.MainContext.MainThreadSecretState)}async $onDidChangePassword(T){this._onDidChangePassword.fire(T)}get(T,C){return this._proxy.$getPassword(T,C)}store(T,C,k){return this._proxy.$setPassword(T,C,k)}delete(T,C){return this._proxy.$deletePassword(T,C)}}e.ExtHostSecretState=A,e.IExtHostSecretState=(0,w.createDecorator)("IExtHostSecretState")}),define(we[70],Ee([0,1,4,12,5,13]),function(re,e,u,M,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,u.createDecorator)("IExtHostApiDeprecationService");let t=class{constructor(C,k){this._extHostLogService=k,this._reportedUsages=new Set,this._telemetryShape=C.getProxy(w.MainContext.MainThreadTelemetry)}report(C,k,F){const _=this.getUsageKey(C,k);this._reportedUsages.has(_)||(this._reportedUsages.add(_),k.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${C}' is deprecated. ${F}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:k.identifier.value,apiId:C}))}getUsageKey(C,k){return`${C}-${k.identifier.value}`}};t=Ne([xe(0,A.IExtHostRpcService),xe(1,M.ILogService)],t),e.ExtHostApiDeprecationService=t,e.NullApiDeprecationService=Object.freeze(new class{report(T,C,k){}})}),define(we[181],Ee([0,1,3,5,7,26]),function(re,e,u,M,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class t{constructor(C){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new u.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=C.getProxy(M.MainContext.MainThreadAuthentication)}$setProviders(C){return this._providers=C,Promise.resolve()}async getSession(C,k,F,_={}){const n=A.ExtensionIdentifier.toKey(C.identifier),g=this._inFlightRequests.get(n)||[],a=[...F].sort().join(" ");let c=g.find(p=>p.scopes===a);if(c)return c.result;{const p=this._getSession(C,n,k,F,_);c={scopes:a,result:p},g.push(c),this._inFlightRequests.set(n,g);try{await p}finally{const D=g.findIndex(f=>f.scopes===a);D>-1&&(g.splice(D),this._inFlightRequests.set(n,g))}return p}}async _getSession(C,k,F,_,n={}){await this._proxy.$ensureProvider(F);const g=C.displayName||C.name;return this._proxy.$getSession(F,_,k,g,n)}async removeSession(C,k){const F=this._authenticationProviders.get(C);return F?F.provider.removeSession(k):this._proxy.$removeSession(C,k)}registerAuthenticationProvider(C,k,F,_){if(this._authenticationProviders.get(C))throw new Error(`An authentication provider with id '${C}' is already registered.`);this._authenticationProviders.set(C,{label:k,provider:F,options:_??{supportsMultipleAccounts:!1}}),this._providers.find(g=>g.id===C)||this._providers.push({id:C,label:k});const n=F.onDidChangeSessions(g=>{this._proxy.$sendDidChangeSessions(C,{added:g.added??[],changed:g.changed??[],removed:g.removed??[]})});return this._proxy.$registerAuthenticationProvider(C,k,_?.supportsMultipleAccounts??!1),new w.Disposable(()=>{n.dispose(),this._authenticationProviders.delete(C);const g=this._providers.findIndex(a=>a.id===C);g>-1&&this._providers.splice(g),this._proxy.$unregisterAuthenticationProvider(C)})}$createSession(C,k){const F=this._authenticationProviders.get(C);if(F)return Promise.resolve(F.provider.createSession(k));throw new Error(`Unable to find authentication provider with handle: ${C}`)}$removeSession(C,k){const F=this._authenticationProviders.get(C);if(F)return Promise.resolve(F.provider.removeSession(k));throw new Error(`Unable to find authentication provider with handle: ${C}`)}$getSessions(C,k){const F=this._authenticationProviders.get(C);if(F)return Promise.resolve(F.provider.getSessions(k));throw new Error(`Unable to find authentication provider with handle: ${C}`)}$onDidChangeAuthenticationSessions(C,k){return this._onDidChangeSessions.fire({provider:{id:C,label:k}}),Promise.resolve()}}e.ExtHostAuthentication=t}),define(we[182],Ee([0,1,5,13,8]),function(re,e,u,M,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let A=class{constructor(T,C){this._extHostDocumentsAndEditors=C,this._proxy=T.getProxy(u.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(T){const C=w.WorkspaceEdit.from(T,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(C)}};A=Ne([xe(0,M.IExtHostRpcService)],A),e.ExtHostBulkEdits=A}),define(we[183],Ee([0,1,5]),function(re,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class M{constructor(A){const t=A.getProxy(u.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return t.$readText()},writeText(T){return t.$writeText(T)}})}}e.ExtHostClipboard=M}),define(we[38],Ee([0,1,10,7,8,25,5,16,12,55,43,110,2,6,4,13,48,22,37,44]),function(re,e,u,M,w,A,t,T,C,k,F,_,n,g,a,c,p,D,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let h=class{constructor(v,m){this._commands=new Map,this._apiCommands=new Map,this._proxy=v.getProxy(t.MainContext.MainThreadCommands),this._logService=m,this.converter=new y(this,o=>{const b=this._apiCommands.get(o);return b?.result===I.Void?b:void 0},m),this._argumentProcessors=[{processArgument(o){return(0,k.revive)(o)}},{processArgument(o){return(0,A.cloneAndChange)(o,function(b){if(F.Range.isIRange(b))return w.Range.to(b);if(_.Position.isIPosition(b))return w.Position.to(b);if(F.Range.isIRange(b.range)&&n.URI.isUri(b.uri))return w.location.to(b);if(b instanceof D.VSBuffer)return b.buffer.buffer;if(!Array.isArray(b))return b})}}]}registerArgumentProcessor(v){this._argumentProcessors.push(v)}registerApiCommand(v){const m=this.registerCommand(!1,v.id,async(...o)=>{const b=v.args.map((E,R)=>{if(!E.validate(o[R]))throw new Error(`Invalid argument '${E.name}' when running '${v.id}', received: ${o[R]}`);return E.convert(o[R])}),d=await this.executeCommand(v.internalId,...b);return v.result.convert(d,o,this.converter)},void 0,{description:v.description,args:v.args,returns:v.result.description});return this._apiCommands.set(v.id,v),new M.Disposable(()=>{m.dispose(),this._apiCommands.delete(v.id)})}registerCommand(v,m,o,b,d,E){if(this._logService.trace("ExtHostCommands#registerCommand",m),!m.trim().length)throw new Error("invalid id");if(this._commands.has(m))throw new Error(`command '${m}' already exists`);return this._commands.set(m,{callback:o,thisArg:b,description:d,extension:E}),v&&this._proxy.$registerCommand(m),new M.Disposable(()=>{this._commands.delete(m)&&v&&this._proxy.$unregisterCommand(m)})}executeCommand(v,...m){return this._logService.trace("ExtHostCommands#executeCommand",v),this._doExecuteCommand(v,m,!0)}async _doExecuteCommand(v,m,o){if(this._commands.has(v))return this._executeContributedCommand(v,m,!1);{let b=!1;const d=(0,A.cloneAndChange)(m,function(E){if(E instanceof M.Position)return w.Position.from(E);if(E instanceof M.Range)return w.Range.from(E);if(E instanceof M.Location)return w.location.from(E);if(M.NotebookRange.isNotebookRange(E))return w.NotebookRange.from(E);if(E instanceof ArrayBuffer)return b=!0,D.VSBuffer.wrap(new Uint8Array(E));if(E instanceof Uint8Array)return b=!0,D.VSBuffer.wrap(E);if(!Array.isArray(E))return E});try{const E=await this._proxy.$executeCommand(v,b?new f.SerializableObjectWithBuffers(d):d,o);return(0,k.revive)(E)}catch(E){if(E instanceof Error&&E.message==="$executeCommand:retry")return this._doExecuteCommand(v,m,!1);throw E}}}async _executeContributedCommand(v,m,o){const b=this._commands.get(v);if(!b)throw new Error("Unknown command");let{callback:d,thisArg:E,description:R}=b;if(R)for(let P=0;P<R.args.length;P++)try{(0,u.validateConstraint)(m[P],R.args[P].constraint)}catch(z){throw new Error(`Running the contributed command: '${v}' failed. Illegal argument '${R.args[P].name}' - ${R.args[P].description}`)}try{return await d.apply(E,m)}catch(P){if(v===this.converter.delegatingCommandId){const z=this.converter.getActualCommand(...m);z&&(v=z.command)}throw this._logService.error(P,v,b.extension?.identifier),o?new class extends Error{constructor(){super((0,l.toErrorMessage)(P));this.id=v,this.source=b.extension?.displayName??b.extension?.name}}:P}}$executeContributedCommand(v,...m){return this._logService.trace("ExtHostCommands#$executeContributedCommand",v),this._commands.has(v)?(m=m.map(o=>this._argumentProcessors.reduce((b,d)=>d.processArgument(b),o)),this._executeContributedCommand(v,m,!0)):Promise.reject(new Error(`Contributed command '${v}' does not exist.`))}getCommands(v=!1){return this._logService.trace("ExtHostCommands#getCommands",v),this._proxy.$getCommands().then(m=>(v&&(m=m.filter(o=>o[0]!=="_")),m))}$getContributedCommandHandlerDescriptions(){const v=Object.create(null);for(let[m,o]of this._commands){let{description:b}=o;b&&(v[m]=b)}return Promise.resolve(v)}};h=Ne([xe(0,c.IExtHostRpcService),xe(1,C.ILogService)],h),e.ExtHostCommands=h,e.IExtHostCommands=(0,a.createDecorator)("IExtHostCommands");class y{constructor(v,m,o){this._commands=v,this._lookupApiCommand=m,this._logService=o,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(v,m){if(!v)return;const o={$ident:void 0,id:v.command,title:v.title,tooltip:v.tooltip};if(!v.command)return o;const b=this._lookupApiCommand(v.command);if(b)o.id=b.internalId,o.arguments=b.args.map((d,E)=>d.convert(v.arguments&&v.arguments[E]));else if((0,T.isNonEmptyArray)(v.arguments)){const d=++this._cachIdPool;this._cache.set(d,v),m.add((0,g.toDisposable)(()=>{this._cache.delete(d),this._logService.trace("CommandsConverter#DISPOSE",d)})),o.$ident=d,o.id=this.delegatingCommandId,o.arguments=[d],this._logService.trace("CommandsConverter#CREATE",v.command,d)}return o}fromInternal(v){const m=t.ObjectIdentifier.of(v);return typeof m=="number"?this._cache.get(m):{command:v.id,title:v.title,arguments:v.arguments}}getActualCommand(...v){return this._cache.get(v[0])}_executeConvertedCommand(...v){const m=this.getActualCommand(...v);return this._logService.trace("CommandsConverter#EXECUTE",v[0],m?m.command:"MISSING"),m?this._commands.executeCommand(m.command,...m.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=y;class s{constructor(v,m,o,b){this.name=v,this.description=m,this.validate=o,this.convert=b}optional(){return new s(this.name,`(optional) ${this.description}`,v=>v==null||this.validate(v),v=>v===void 0?void 0:v===null?null:this.convert(v))}with(v,m){return new s(v??this.name,m??this.description,this.validate,this.convert)}}e.ApiCommandArgument=s,s.Uri=new s("uri","Uri of a text document",i=>n.URI.isUri(i),i=>i),s.Position=new s("position","A position in a text document",i=>M.Position.isPosition(i),w.Position.from),s.Range=new s("range","A range in a text document",i=>M.Range.isRange(i),w.Range.from),s.Selection=new s("selection","A selection in a text document",i=>M.Selection.isSelection(i),w.Selection.from),s.Number=new s("number","",i=>typeof i=="number",i=>i),s.String=new s("string","",i=>typeof i=="string",i=>i),s.CallHierarchyItem=new s("item","A call hierarchy item",i=>i instanceof M.CallHierarchyItem,w.CallHierarchyItem.from),s.TypeHierarchyItem=new s("item","A type hierarchy item",i=>i instanceof M.TypeHierarchyItem,w.TypeHierarchyItem.from),s.TestItem=new s("testItem","A VS Code TestItem",i=>i instanceof p.TestItemImpl,w.TestItem.from);class I{constructor(v,m){this.description=v,this.convert=m}}e.ApiCommandResult=I,I.Void=new I("no result",i=>i);class r{constructor(v,m,o,b,d){this.id=v,this.internalId=m,this.description=o,this.args=b,this.result=d}}e.ApiCommand=r}),define(we[184],Ee([0,1,8,7,59,38,16,81]),function(re,e,u,M,w,A,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const C=[new A.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",F(u.DocumentHighlight.to))),new A.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[A.ApiCommandArgument.Uri],new A.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(n,g)=>{if((0,t.isFalsyOrEmpty)(n))return;class a extends M.SymbolInformation{static to(p){const D=new a(p.name,u.SymbolKind.to(p.kind),p.containerName||"",new M.Location(g[0],u.Range.to(p.range)));return D.detail=p.detail,D.range=D.location.range,D.selectionRange=u.Range.to(p.selectionRange),D.children=p.children?p.children.map(a.to):[],D}}return n.map(a.to)})),new A.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[A.ApiCommandArgument.Uri,new A.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new A.ApiCommandResult("A promise that resolves to an array of TextEdits.",F(u.TextEdit.to))),new A.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Range,new A.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new A.ApiCommandResult("A promise that resolves to an array of TextEdits.",F(u.TextEdit.to))),new A.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position,new A.ApiCommandArgument("ch","Trigger character",n=>typeof n=="string",n=>n),new A.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new A.ApiCommandResult("A promise that resolves to an array of TextEdits.",F(u.TextEdit.to))),new A.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",_)),new A.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",_)),new A.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",_)),new A.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",_)),new A.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to an array of Location-instances.",F(u.location.to))),new A.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to an array of Hover-instances.",F(u.Hover.to))),new A.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[A.ApiCommandArgument.Uri,new A.ApiCommandArgument("position","A position in a text document",n=>Array.isArray(n)&&n.every(g=>M.Position.isPosition(g)),n=>n.map(u.Position.from))],new A.ApiCommandResult("A promise that resolves to an array of ranges.",n=>n.map(g=>{let a;for(const c of g.reverse())a=new M.SelectionRange(u.Range.to(c),a);return a}))),new A.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[A.ApiCommandArgument.String.with("query","Search string")],new A.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",n=>n.map(u.WorkspaceSymbol.to))),new A.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A CallHierarchyItem or undefined",n=>n.map(u.CallHierarchyItem.to))),new A.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[A.ApiCommandArgument.CallHierarchyItem],new A.ApiCommandResult("A CallHierarchyItem or undefined",n=>n.map(u.CallHierarchyIncomingCall.to))),new A.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[A.ApiCommandArgument.CallHierarchyItem],new A.ApiCommandResult("A CallHierarchyItem or undefined",n=>n.map(u.CallHierarchyOutgoingCall.to))),new A.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to a range and placeholder text.",n=>{if(!!n)return{range:u.Range.to(n.range),placeholder:n.text}})),new A.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position,A.ApiCommandArgument.String.with("newName","The new symbol name")],new A.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",n=>{if(!!n){if(n.rejectReason)throw new Error(n.rejectReason);return u.WorkspaceEdit.to(n)}})),new A.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new A.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",n=>n.map(u.DocumentLink.to))),new A.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[A.ApiCommandArgument.Uri],new A.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",n=>{if(!!n)return new M.SemanticTokensLegend(n.tokenTypes,n.tokenModifiers)})),new A.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[A.ApiCommandArgument.Uri],new A.ApiCommandResult("A promise that resolves to SemanticTokens.",n=>{if(!n)return;const g=(0,T.decodeSemanticTokensDto)(n);if(g.type==="full")return new M.SemanticTokens(g.data,void 0)})),new A.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Range.optional()],new A.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",n=>{if(!!n)return new M.SemanticTokensLegend(n.tokenTypes,n.tokenModifiers)})),new A.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Range],new A.ApiCommandResult("A promise that resolves to SemanticTokens.",n=>{if(!n)return;const g=(0,T.decodeSemanticTokensDto)(n);if(g.type==="full")return new M.SemanticTokens(g.data,void 0)})),new A.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position,A.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),A.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new A.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(n,g,a)=>{if(!n)return new M.CompletionList([]);const c=n.suggestions.map(p=>u.CompletionItem.to(p,a));return new M.CompletionList(c,n.incomplete)})),new A.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position,A.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new A.ApiCommandResult("A promise that resolves to SignatureHelp.",n=>{if(n)return u.SignatureHelp.to(n)})),new A.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new A.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(n,g,a)=>F(c=>new M.CodeLens(u.Range.to(c.range),c.command&&a.fromInternal(c.command)))(n))),new A.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[A.ApiCommandArgument.Uri,new A.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",n=>M.Range.isRange(n),n=>M.Selection.isSelection(n)?u.Selection.from(n):u.Range.from(n)),A.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),A.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new A.ApiCommandResult("A promise that resolves to an array of Command-instances.",(n,g,a)=>F(c=>{if(c._isSynthetic){if(!c.command)throw new Error("Synthetic code actions must have a command");return a.fromInternal(c.command)}else{const p=new M.CodeAction(c.title,c.kind?new M.CodeActionKind(c.kind):void 0);return c.edit&&(p.edit=u.WorkspaceEdit.to(c.edit)),c.command&&(p.command=a.fromInternal(c.command)),p.isPreferred=c.isPreferred,p}})(n))),new A.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[A.ApiCommandArgument.Uri],new A.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",n=>n?n.map(g=>new M.ColorInformation(u.Range.to(g.range),u.Color.to(g.color))):[])),new A.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new A.ApiCommandArgument("color","The color to show and insert",n=>n instanceof M.Color,u.Color.from),new A.ApiCommandArgument("context","Context object with uri and range",n=>!0,n=>({uri:n.uri,range:u.Range.from(n.range)}))],new A.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",n=>n?n.map(u.ColorPresentation.to):[])),new A.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Range],new A.ApiCommandResult("A promise that resolves to an array of Inlay objects",n=>n.map(u.InlayHint.to))),new A.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new A.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",F(n=>({viewType:n.viewType,displayName:n.displayName,options:{transientOutputs:n.options.transientOutputs,transientCellMetadata:n.options.transientCellMetadata,transientDocumentMetadata:n.options.transientDocumentMetadata},filenamePattern:n.filenamePattern.map(g=>u.NotebookExclusiveDocumentPattern.to(g))})))),new A.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Range],new A.ApiCommandResult("A promise that resolves to an array of InlineValue objects",n=>n.map(u.InlineValue.to))),new A.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[A.ApiCommandArgument.Uri,new A.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="number"||typeof n=="object",n=>n&&(typeof n=="number"?[n,void 0]:[u.ViewColumn.from(n.viewColumn),u.TextEditorOpenOptions.from(n)])).optional(),A.ApiCommandArgument.String.with("label","").optional()],A.ApiCommandResult.Void),new A.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[A.ApiCommandArgument.Uri.with("resource","Resource to open"),A.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new A.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="number"||typeof n=="object",n=>n&&(typeof n=="number"?[n,void 0]:[u.ViewColumn.from(n.viewColumn),u.TextEditorOpenOptions.from(n)])).optional()],A.ApiCommandResult.Void),new A.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[A.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),A.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),A.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new A.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="object",n=>n&&[u.ViewColumn.from(n.viewColumn),u.TextEditorOpenOptions.from(n)]).optional()],A.ApiCommandResult.Void),new A.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A TypeHierarchyItem or undefined",n=>n.map(u.TypeHierarchyItem.to))),new A.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[A.ApiCommandArgument.TypeHierarchyItem],new A.ApiCommandResult("A TypeHierarchyItem or undefined",n=>n.map(u.TypeHierarchyItem.to))),new A.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[A.ApiCommandArgument.TypeHierarchyItem],new A.ApiCommandResult("A TypeHierarchyItem or undefined",n=>n.map(u.TypeHierarchyItem.to))),new A.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[A.ApiCommandArgument.TestItem],A.ApiCommandResult.Void)];class k{static register(g){C.forEach(g.registerApiCommand,g)}}e.ExtHostApiCommands=k;function F(n){return g=>{if(Array.isArray(g))return g.map(n)}}function _(n){if(!Array.isArray(n))return;const g=[];for(const a of n)w.isLocationLink(a)?g.push(u.DefinitionLink.to(a)):g.push(u.location.to(a));return g}}),define(we[185],Ee([0,1,14,52,3,6,2,59,26,8,7,5]),function(re,e,u,M,w,A,t,T,C,k,F,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function n(g,a,c){const p=g.getProxy(_.MainContext.MainThreadComments);class D{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,a.registerArgumentProcessor({processArgument:i=>{if(i&&i.$mid===6){const v=this._commentControllers.get(i.handle);return v||i}else if(i&&i.$mid===7){const v=this._commentControllers.get(i.commentControlHandle);if(!v)return i;const m=v.getCommentThread(i.commentThreadHandle);return m||i}else if(i&&i.$mid===8){const v=this._commentControllers.get(i.thread.commentControlHandle);if(!v)return i;const m=v.getCommentThread(i.thread.commentThreadHandle);return m?{thread:m,text:i.text}:i}else if(i&&i.$mid===9){const v=this._commentControllers.get(i.thread.commentControlHandle);if(!v)return i;const m=v.getCommentThread(i.thread.commentThreadHandle);if(!m)return i;let o=i.commentUniqueId,b=m.getCommentByUniqueId(o);return b||i}else if(i&&i.$mid===10){const v=this._commentControllers.get(i.thread.commentControlHandle);if(!v)return i;const m=v.getCommentThread(i.thread.commentThreadHandle);if(!m)return i;let o=i.text,b=i.commentUniqueId,d=m.getCommentByUniqueId(b);return d?(d.body=o,d):i}return i}})}createCommentController(i,v,m){const o=D.handlePool++,b=new l(i,o,v,m);this._commentControllers.set(b.handle,b);const d=this._commentControllersByExtension.get(C.ExtensionIdentifier.toKey(i.identifier))||[];return d.push(b),this._commentControllersByExtension.set(C.ExtensionIdentifier.toKey(i.identifier),d),b.value}$createCommentThreadTemplate(i,v,m){const o=this._commentControllers.get(i);!o||o.$createCommentThreadTemplate(v,m)}async $updateCommentThreadTemplate(i,v,m){const o=this._commentControllers.get(i);!o||o.$updateCommentThreadTemplate(v,m)}$deleteCommentThread(i,v){const m=this._commentControllers.get(i);m&&m.$deleteCommentThread(v)}$provideCommentingRanges(i,v,m){const o=this._commentControllers.get(i);if(!o||!o.commentingRangeProvider)return Promise.resolve(void 0);const b=c.getDocument(t.URI.revive(v));return(0,u.asPromise)(()=>o.commentingRangeProvider.provideCommentingRanges(b,m)).then(d=>d?d.map(E=>k.Range.from(E)):void 0)}$toggleReaction(i,v,m,o,b){const d=this._commentControllers.get(i);return!d||!d.reactionHandler?Promise.resolve(void 0):(0,u.asPromise)(()=>{const E=d.getCommentThread(v);if(E){const R=E.getCommentByUniqueId(o.uniqueIdInThread);if(d!==void 0&&R&&d.reactionHandler)return d.reactionHandler(R,s(b))}return Promise.resolve(void 0)})}dispose(){}}D.handlePool=0;class f{constructor(i,v,m,o,b,d,E){this._commentControllerHandle=v,this._id=m,this._uri=o,this._range=b,this._comments=d,this.handle=f._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new w.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new A.MutableDisposable,this._acceptInputDisposables.value=new A.DisposableStore,this._id===void 0&&(this._id=`${i}.${this.handle}`),p.$createCommentThread(v,this.handle,this._id,this._uri,k.Range.from(this._range),E),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=d,this._localDisposables.push({dispose:()=>{p.$deleteCommentThread(v,this.handle)}});const R=this;this.value={get uri(){return R.uri},get range(){return R.range},set range(P){R.range=P},get comments(){return R.comments},set comments(P){R.comments=P},get collapsibleState(){return R.collapsibleState},set collapsibleState(P){R.collapsibleState=P},get canReply(){return R.canReply},set canReply(P){R.canReply=P},get contextValue(){return R.contextValue},set contextValue(P){R.contextValue=P},get label(){return R.label},set label(P){R.label=P},dispose:()=>{R.dispose()}}}set threadId(i){this._id=i}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(i){i.isEqual(this._range)||(this._range=i,this.modifications.range=i,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(i){this._canReply!==i&&(this._canReply=i,this.modifications.canReply=i,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(i){this._label=i,this.modifications.label=i,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(i){this._contextValue=i,this.modifications.contextValue=i,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(i){this._comments=i,this.modifications.comments=i,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(i){this._collapseState=i,this.modifications.collapsibleState=i,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new A.DisposableStore);const i=m=>Object.prototype.hasOwnProperty.call(this.modifications,m),v={};i("range")&&(v.range=k.Range.from(this._range)),i("label")&&(v.label=this.label),i("contextValue")&&(v.contextValue=this.contextValue??null),i("comments")&&(v.comments=this._comments.map(m=>h(this,m,this._commentsMap))),i("collapsibleState")&&(v.collapseState=I(this._collapseState)),i("canReply")&&(v.canReply=this.canReply),this.modifications={},p.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,v)}getCommentByUniqueId(i){for(let v of this._commentsMap){let m=v[0],o=v[1];if(i===o)return m}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(i=>i.dispose())}}f._handlePool=0,Ne([(0,M.debounce)(100)],f.prototype,"eventuallyUpdateCommentThread",null);class l{constructor(i,v,m,o){this._extension=i,this._handle=v,this._id=m,this._label=o,this._threads=new Map,p.$registerCommentController(this.handle,m,o);const b=this;this.value=Object.freeze({id:b.id,label:b.label,get options(){return b.options},set options(d){b.options=d},get commentingRangeProvider(){return b.commentingRangeProvider},set commentingRangeProvider(d){b.commentingRangeProvider=d},get reactionHandler(){return b.reactionHandler},set reactionHandler(d){b.reactionHandler=d},createCommentThread(d,E,R){return b.createCommentThread(d,E,R).value},dispose:()=>{b.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{p.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(i){this._commentingRangeProvider=i,p.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(i){this._reactionHandler=i,p.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!i})}get options(){return this._options}set options(i){this._options=i,p.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(i,v,m,o){if(typeof i=="string"){const b=new f(this.id,this.handle,i,v,m,o,this._extension.identifier);return this._threads.set(b.handle,b),b}else{const b=new f(this.id,this.handle,void 0,i,v,m,this._extension.identifier);return this._threads.set(b.handle,b),b}}$createCommentThreadTemplate(i,v){const m=new f(this.id,this.handle,void 0,t.URI.revive(i),k.Range.to(v),[],this._extension.identifier);return m.collapsibleState=T.CommentThreadCollapsibleState.Expanded,this._threads.set(m.handle,m),m}$updateCommentThreadTemplate(i,v){let m=this._threads.get(i);m&&(m.range=k.Range.to(v))}$deleteCommentThread(i){let v=this._threads.get(i);v&&v.dispose(),this._threads.delete(i)}getCommentThread(i){return this._threads.get(i)}dispose(){this._threads.forEach(i=>{i.dispose()}),this._localDisposables.forEach(i=>i.dispose())}}function h(r,i,v){let m=v.get(i);m||(m=++r.commentHandle,v.set(i,m));const o=i.author&&i.author.iconPath?i.author.iconPath.toString():void 0;return{mode:i.mode,contextValue:i.contextValue,uniqueIdInThread:m,body:k.MarkdownString.from(i.body),userName:i.author.name,userIconPath:o,label:i.label,commentReactions:i.reactions?i.reactions.map(b=>y(b)):void 0}}function y(r){return{label:r.label,iconPath:r.iconPath?k.pathOrURIToURI(r.iconPath):void 0,count:r.count,hasReacted:r.authorHasReacted}}function s(r){return{label:r.label||"",count:r.count||0,iconPath:r.iconPath?t.URI.revive(r.iconPath):"",authorHasReacted:r.hasReacted||!1}}function I(r){if(r!==void 0)switch(r){case F.CommentThreadCollapsibleState.Expanded:return T.CommentThreadCollapsibleState.Expanded;case F.CommentThreadCollapsibleState.Collapsed:return T.CommentThreadCollapsibleState.Collapsed}return T.CommentThreadCollapsibleState.Collapsed}return new D}e.createExtHostComments=n}),define(we[94],Ee([0,1,2,5,7,4,13,12,16,9,17]),function(re,e,u,M,w,A,t,T,C,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let _=class wi{constructor(g,a){this._logService=a,this._provider=new Map,this._proxy=g.getProxy(M.MainContext.MainThreadDecorations)}registerFileDecorationProvider(g,a){const c=wi._handlePool++;this._provider.set(c,{provider:g,extensionId:a}),this._proxy.$registerDecorationProvider(c,a.value);const p=g.onDidChangeFileDecorations&&g.onDidChangeFileDecorations(D=>{if(!D){this._proxy.$onDidChange(c,null);return}let f=(0,C.asArray)(D);if(f.length<=wi._maxEventSize){this._proxy.$onDidChange(c,f);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",a.value,f.length);const l=f.map(s=>({uri:s,rank:(0,k.count)(s.path,"/")})),h=(0,C.groupBy)(l,(s,I)=>s.rank-I.rank||(0,k.compare)(s.uri.path,I.uri.path));let y=[];e:for(let s of h){let I;for(let r of s){let i=(0,F.dirname)(r.uri.path);if(I!==i&&(I=i,y.push(r.uri)>=wi._maxEventSize))break e}}this._proxy.$onDidChange(c,y)});return new w.Disposable(()=>{p?.dispose(),this._proxy.$unregisterDecorationProvider(c),this._provider.delete(c)})}async $provideDecorations(g,a,c){if(!this._provider.has(g))return Object.create(null);const p=Object.create(null),{provider:D,extensionId:f}=this._provider.get(g);return await Promise.all(a.map(async l=>{try{const{uri:h,id:y}=l,s=await Promise.resolve(D.provideFileDecoration(u.URI.revive(h),c));if(!s)return;try{w.FileDecoration.validate(s),p[y]=[s.propagate,s.tooltip,s.badge,s.color]}catch(I){this._logService.warn(`INVALID decoration from extension '${f.value}': ${I}`)}}catch(h){this._logService.error(h)}})),p}};_._handlePool=0,_._maxEventSize=250,_=Ne([xe(0,t.IExtHostRpcService),xe(1,T.ILogService)],_),e.ExtHostDecorations=_,e.IExtHostDecorations=(0,A.createDecorator)("IExtHostDecorations")});var Xe=this&&this.__classPrivateFieldSet||function(re,e,u,M,w){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!w:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?w.call(re,u):w?w.value=u:e.set(re,u),u},Te=this&&this.__classPrivateFieldGet||function(re,e,u,M){if(u==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?M:u==="a"?M.call(re):M?M.value:e.get(re)};define(we[186],Ee([0,1,123,83,2,5,7,8,3,12,21,31]),function(re,e,u,M,w,A,t,T,C,k,F,_){"use strict";var n,g,a;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class c{constructor(f,l,h,y,s,I){this._name=f,this._owner=l,this._maxDiagnosticsPerFile=h,n.set(this,void 0),g.set(this,void 0),a.set(this,void 0),this._isDisposed=!1,Xe(this,a,new F.ResourceMap(r=>y.getComparisonKey(r)),"f"),Xe(this,n,s,"f"),Xe(this,g,I,"f")}dispose(){this._isDisposed||(Te(this,g,"f").fire([...Te(this,a,"f").keys()]),Te(this,n,"f")&&Te(this,n,"f").$clear(this._owner),Te(this,a,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(f,l){if(!f){this.clear();return}this._checkDisposed();let h=[];if(w.URI.isUri(f)){if(!l){this.delete(f);return}Te(this,a,"f").set(f,l.slice()),h=[f]}else if(Array.isArray(f)){h=[];let s;f=[...f].sort(c._compareIndexedTuplesByUri);for(const I of f){const[r,i]=I;if((!s||r.toString()!==s.toString())&&(s&&Te(this,a,"f").get(s).length===0&&Te(this,a,"f").delete(s),s=r,h.push(r),Te(this,a,"f").set(r,[])),i){const v=Te(this,a,"f").get(r);v&&v.push(...i)}else{const v=Te(this,a,"f").get(r);v&&(v.length=0)}}}if(Te(this,g,"f").fire(h),!Te(this,n,"f"))return;const y=[];for(let s of h){let I=[];const r=Te(this,a,"f").get(s);if(r)if(r.length>this._maxDiagnosticsPerFile){I=[];const i=[t.DiagnosticSeverity.Error,t.DiagnosticSeverity.Warning,t.DiagnosticSeverity.Information,t.DiagnosticSeverity.Hint];e:for(let v=0;v<4;v++)for(let m of r)if(m.severity===i[v]&&I.push(T.Diagnostic.from(m))===this._maxDiagnosticsPerFile)break e;I.push({severity:M.MarkerSeverity.Info,message:(0,u.localize)(0,null,r.length-this._maxDiagnosticsPerFile),startLineNumber:I[I.length-1].startLineNumber,startColumn:I[I.length-1].startColumn,endLineNumber:I[I.length-1].endLineNumber,endColumn:I[I.length-1].endColumn})}else I=r.map(i=>T.Diagnostic.from(i));y.push([s,I])}Te(this,n,"f").$changeMany(this._owner,y)}delete(f){this._checkDisposed(),Te(this,g,"f").fire([f]),Te(this,a,"f").delete(f),Te(this,n,"f")&&Te(this,n,"f").$changeMany(this._owner,[[f,void 0]])}clear(){this._checkDisposed(),Te(this,g,"f").fire([...Te(this,a,"f").keys()]),Te(this,a,"f").clear(),Te(this,n,"f")&&Te(this,n,"f").$clear(this._owner)}forEach(f,l){this._checkDisposed();for(let h of Te(this,a,"f").keys())f.apply(l,[h,this.get(h),this])}get(f){this._checkDisposed();const l=Te(this,a,"f").get(f);return Array.isArray(l)?Object.freeze(l.slice(0)):[]}has(f){return this._checkDisposed(),Array.isArray(Te(this,a,"f").get(f))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(f,l){return f[0].toString()<l[0].toString()?-1:f[0].toString()>l[0].toString()?1:0}}e.DiagnosticCollection=c,n=new WeakMap,g=new WeakMap,a=new WeakMap;let p=class ni{constructor(f,l,h){this._logService=l,this._fileSystemInfoService=h,this._collections=new Map,this._onDidChangeDiagnostics=new C.DebounceEmitter({merge:y=>y.flat(),delay:50}),this.onDidChangeDiagnostics=C.Event.map(this._onDidChangeDiagnostics.event,ni._mapper),this._proxy=f.getProxy(A.MainContext.MainThreadDiagnostics)}static _mapper(f){const l=new F.ResourceMap;for(const h of f)l.set(h,h);return{uris:Object.freeze(Array.from(l.values()))}}createDiagnosticCollection(f,l){const{_collections:h,_proxy:y,_onDidChangeDiagnostics:s,_logService:I,_fileSystemInfoService:r}=this,i=new class{$changeMany(o,b){y.$changeMany(o,b),I.trace("[DiagnosticCollection] change many (extension, owner, uris)",f.value,o,b.length===0?"CLEARING":b)}$clear(o){y.$clear(o),I.trace("[DiagnosticCollection] remove all (extension, owner)",f.value,o)}dispose(){y.dispose()}};let v;if(!l)l="_generated_diagnostic_collection_name_#"+ni._idPool++,v=l;else if(!h.has(l))v=l;else{this._logService.warn(`DiagnosticCollection with name '${l}' does already exist.`);do v=l+ni._idPool++;while(h.has(v))}return new class extends c{constructor(){super(l,v,ni._maxDiagnosticsPerFile,r.extUri,i,s);h.set(v,this)}dispose(){super.dispose(),h.delete(v)}}}getDiagnostics(f){if(f)return this._getDiagnostics(f);{const l=new Map,h=[];for(const y of this._collections.values())y.forEach((s,I)=>{let r=l.get(s.toString());typeof r=="undefined"&&(r=h.length,l.set(s.toString(),r),h.push([s,[]])),h[r][1]=h[r][1].concat(...I)});return h}}_getDiagnostics(f){let l=[];for(let h of this._collections.values())h.has(f)&&(l=l.concat(h.get(f)));return l}$acceptMarkersChange(f){if(!this._mirrorCollection){const l="_generated_mirror",h=new c(l,l,ni._maxDiagnosticsPerFile,this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(l,h),this._mirrorCollection=h}for(const[l,h]of f)this._mirrorCollection.set(w.URI.revive(l),h.map(T.Diagnostic.to))}};p._idPool=0,p._maxDiagnosticsPerFile=1e3,p=Ne([xe(1,k.ILogService),xe(2,_.IExtHostFileSystemInfo)],p),e.ExtHostDiagnostics=p}),define(we[187],Ee([0,1,2,5]),function(re,e,u,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class w{constructor(t){this._proxy=t.getProxy(M.MainContext.MainThreadDialogs)}showOpenDialog(t){return this._proxy.$showOpenDialog(t).then(T=>T?T.map(C=>u.URI.revive(C)):void 0)}showSaveDialog(t){return this._proxy.$showSaveDialog(t).then(T=>T?u.URI.revive(T):void 0)}}e.ExtHostDialogs=w}),define(we[188],Ee([0,1,15,2,7,5,11,20,9]),function(re,e,u,M,w,A,t,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class k{constructor(_,n,g){this._documentsAndEditors=n,this._logService=g,this._documentContentProviders=new Map,this._proxy=_.getProxy(A.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(_,n){if(Object.keys(t.Schemas).indexOf(_)>=0)throw new Error(`scheme '${_}' already registered`);const g=k._handlePool++;this._documentContentProviders.set(g,n),this._proxy.$registerTextContentProvider(g,_);let a;return typeof n.onDidChange=="function"&&(a=n.onDidChange(c=>{if(c.scheme!==_){this._logService.warn(`Provider for scheme '${_}' is firing event for schema '${c.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(c)&&this.$provideTextDocumentContent(g,c).then(p=>{if(!p&&typeof p!="string")return;const D=this._documentsAndEditors.getDocument(c);if(!D)return;const f=(0,C.splitLines)(p);if(!D.equalLines(f))return this._proxy.$onVirtualDocumentChange(c,p)},u.onUnexpectedError)})),new w.Disposable(()=>{this._documentContentProviders.delete(g)&&this._proxy.$unregisterTextContentProvider(g),a&&(a.dispose(),a=void 0)})}$provideTextDocumentContent(_,n){const g=this._documentContentProviders.get(_);return g?Promise.resolve(g.provideTextDocumentContent(M.URI.revive(n),T.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${n.scheme}`))}}e.ExtHostDocumentContentProvider=k,k._handlePool=0}),define(we[189],Ee([0,1,3,6,2,5,87,8,10,25,7]),function(re,e,u,M,w,A,t,T,C,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class _{constructor(g,a){this._onDidAddDocument=new u.Emitter,this._onDidRemoveDocument=new u.Emitter,this._onDidChangeDocument=new u.Emitter,this._onDidSaveDocument=new u.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new M.DisposableStore,this._documentLoader=new Map,this._proxy=g.getProxy(A.MainContext.MainThreadDocuments),this._documentsAndEditors=a,this._documentsAndEditors.onDidRemoveDocuments(c=>{for(const p of c)this._onDidRemoveDocument.fire(p.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(c=>{for(const p of c)this._onDidAddDocument.fire(p.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(g){if(!g)return;const a=this._documentsAndEditors.getDocument(g);if(a)return a}getDocument(g){const a=this.getDocumentData(g);if(!a?.document)throw new Error(`Unable to retrieve document from URI '${g}'`);return a.document}ensureDocumentData(g){const a=this._documentsAndEditors.getDocument(g);if(a)return Promise.resolve(a);let c=this._documentLoader.get(g.toString());return c||(c=this._proxy.$tryOpenDocument(g).then(p=>{this._documentLoader.delete(g.toString());const D=w.URI.revive(p);return(0,C.assertIsDefined)(this._documentsAndEditors.getDocument(D))},p=>(this._documentLoader.delete(g.toString()),Promise.reject(p))),this._documentLoader.set(g.toString(),c)),c}createDocumentData(g){return this._proxy.$tryCreateDocument(g).then(a=>w.URI.revive(a))}$acceptModelModeChanged(g,a){const c=w.URI.revive(g),p=this._documentsAndEditors.getDocument(c);if(!p)throw new Error("unknown document");this._onDidRemoveDocument.fire(p.document),p._acceptLanguageId(a),this._onDidAddDocument.fire(p.document)}$acceptModelSaved(g){const a=w.URI.revive(g),c=this._documentsAndEditors.getDocument(a);if(!c)throw new Error("unknown document");this.$acceptDirtyStateChanged(g,!1),this._onDidSaveDocument.fire(c.document)}$acceptDirtyStateChanged(g,a){const c=w.URI.revive(g),p=this._documentsAndEditors.getDocument(c);if(!p)throw new Error("unknown document");p._acceptIsDirty(a),this._onDidChangeDocument.fire({document:p.document,contentChanges:[],reason:void 0})}$acceptModelChanged(g,a,c){const p=w.URI.revive(g),D=this._documentsAndEditors.getDocument(p);if(!D)throw new Error("unknown document");D._acceptIsDirty(c),D.onEvents(a);let f;a.isUndoing?f=F.TextDocumentChangeReason.Undo:a.isRedoing&&(f=F.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,k.deepFreeze)({document:D.document,contentChanges:a.changes.map(l=>({range:T.Range.to(l.range),rangeOffset:l.rangeOffset,rangeLength:l.rangeLength,text:l.text})),reason:f}))}setWordDefinitionFor(g,a){(0,t.setWordDefinitionFor)(g,a)}}e.ExtHostDocuments=_}),define(we[49],Ee([0,1,41,3,6,2,4,5,87,13,93,8,12,21,11,162,102]),function(re,e,u,M,w,A,t,T,C,k,F,_,n,g,a,c,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class D{constructor(h){this.value=h,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let f=class{constructor(h,y){this._extHostRpc=h,this._logService=y,this._activeEditorId=null,this._editors=new Map,this._documents=new g.ResourceMap,this._onDidAddDocuments=new M.Emitter,this._onDidRemoveDocuments=new M.Emitter,this._onDidChangeVisibleTextEditors=new M.Emitter,this._onDidChangeActiveTextEditor=new M.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(h){this.acceptDocumentsAndEditorsDelta(h)}acceptDocumentsAndEditorsDelta(h){const y=[],s=[],I=[];if(h.removedDocuments)for(const r of h.removedDocuments){const i=A.URI.revive(r),v=this._documents.get(i);v?.unref()&&(this._documents.delete(i),y.push(v.value))}if(h.addedDocuments)for(const r of h.addedDocuments){const i=A.URI.revive(r.uri);let v=this._documents.get(i);if(v&&i.scheme!==a.Schemas.vscodeNotebookCell&&i.scheme!==a.Schemas.vscodeInteractiveInput)throw new Error(`document '${i} already exists!'`);v||(v=new D(new C.ExtHostDocumentData(this._extHostRpc.getProxy(T.MainContext.MainThreadDocuments),i,r.lines,r.EOL,r.versionId,r.languageId,r.isDirty,r.notebook)),this._documents.set(i,v),s.push(v.value)),v.ref()}if(h.removedEditors)for(const r of h.removedEditors){const i=this._editors.get(r);this._editors.delete(r),i&&I.push(i)}if(h.addedEditors)for(const r of h.addedEditors){const i=A.URI.revive(r.documentUri);u.ok(this._documents.has(i),`document '${i}' does not exist`),u.ok(!this._editors.has(r.id),`editor '${r.id}' already exists!`);const v=this._documents.get(i).value,m=new F.ExtHostTextEditor(r.id,this._extHostRpc.getProxy(T.MainContext.MainThreadTextEditors),this._logService,new p.Lazy(()=>v.document),r.selections.map(_.Selection.to),r.options,r.visibleRanges.map(o=>_.Range.to(o)),typeof r.editorPosition=="number"?_.ViewColumn.to(r.editorPosition):void 0);this._editors.set(r.id,m)}h.newActiveEditor!==void 0&&(u.ok(h.newActiveEditor===null||this._editors.has(h.newActiveEditor),`active editor '${h.newActiveEditor}' does not exist`),this._activeEditorId=h.newActiveEditor),(0,w.dispose)(y),(0,w.dispose)(I),h.removedDocuments&&this._onDidRemoveDocuments.fire(y),h.addedDocuments&&this._onDidAddDocuments.fire(s),(h.removedEditors||h.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(r=>r.value)),h.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(h){return this._documents.get(h)?.value}allDocuments(){return c.Iterable.map(this._documents.values(),h=>h.value)}getEditor(h){return this._editors.get(h)}activeEditor(h){if(!this._activeEditorId)return;const y=this._editors.get(this._activeEditorId);return h?y:y?.value}allEditors(){return[...this._editors.values()]}};f=Ne([xe(0,k.IExtHostRpcService),xe(1,n.ILogService)],f),e.ExtHostDocumentsAndEditors=f,e.IExtHostDocumentsAndEditors=(0,t.createDecorator)("IExtHostDocumentsAndEditors")}),define(we[71],Ee([0,1,8,5,2,3,4,13,14]),function(re,e,u,M,w,A,t,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,t.createDecorator)("IExtHostEditorTabs");let k=class{constructor(_){this._onDidChangeTabs=new A.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._onDidChangeActiveTab=new A.Emitter,this.onDidChangeActiveTab=this._onDidChangeActiveTab.event,this._tabs=[],this._proxy=_.getProxy(M.MainContext.MainThreadEditorTabs)}get tabs(){return this._tabs}get activeTab(){return this._activeTab}$acceptEditorTabs(_){let n=-1;this._tabs=_.map((a,c)=>(a.isActive&&(n=c),Object.freeze({label:a.label,viewColumn:u.ViewColumn.to(a.viewColumn),index:c,resource:w.URI.revive(a.resource),additionalResourcesAndViewIds:a.additionalResourcesAndViewIds.map(({resource:p,viewId:D})=>({resource:w.URI.revive(p),viewId:D})),viewId:a.editorId,isActive:a.isActive,move:async(p,D)=>{this._proxy.$moveTab(a,p,u.ViewColumn.from(D)),await(0,C.raceTimeout)(A.Event.toPromise(this._onDidChangeTabs.event),1e3)},close:async()=>{await this._proxy.$closeTab(a),await(0,C.raceTimeout)(A.Event.toPromise(this._onDidChangeTabs.event),1e3)}}))),this._tabs=this._tabs.sort((a,c)=>a.viewColumn===c.viewColumn?a.index-c.index:a.viewColumn-c.viewColumn);const g=this._activeTab;this._activeTab=n===-1?void 0:this._tabs[n],this._activeTab!==g&&this._onDidChangeActiveTab.fire(this._activeTab),this._onDidChangeTabs.fire(this._tabs)}};k=Ne([xe(0,T.IExtHostRpcService)],k),e.ExtHostEditorTabs=k}),define(we[190],Ee([0,1,2,5,6,7,8,232,9,22,27]),function(re,e,u,M,w,A,t,T,C,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class _{constructor(){this._schemes=[]}add(a){this._stateMachine=void 0,this._schemes.push(a)}delete(a){const c=this._schemes.indexOf(a);c>=0&&(this._schemes.splice(c,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const a=this._schemes.sort(),c=[];let p,D,f=14,l=14;for(const h of a){let y=p?(0,C.commonPrefixLength)(p,h):0;for(y===0?D=1:D=l;y<h.length;y++)y+1===h.length?(f=l,l=9):l+=1,c.push([D,h.toUpperCase().charCodeAt(y),l]),c.push([D,h.toLowerCase().charCodeAt(y),l]),D=l;p=h,l=f}c.push([9,58,10]),c.push([10,47,12]),this._stateMachine=new T.StateMachine(c)}}provideDocumentLinks(a){this._initStateMachine();const c=[],p=T.LinkComputer.computeLinks({getLineContent(D){return a.lineAt(D-1).text},getLineCount(){return a.lineCount}},this._stateMachine);for(const D of p){const f=t.DocumentLink.to(D);f.target&&c.push(f)}return c}}class n{constructor(a,c){this._extHostLanguageFeatures=c,this._linkProvider=new _,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=a.getProxy(M.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(a,c,p,D={}){if(this._registeredSchemes.has(c))throw new Error(`a provider for the scheme '${c}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const f=this._handlePool++;this._linkProvider.add(c),this._registeredSchemes.add(c),this._fsProvider.set(f,p);let l=2;D.isCaseSensitive&&(l+=1024),D.isReadonly&&(l+=2048),typeof p.copy=="function"&&(l+=8),typeof p.open=="function"&&typeof p.close=="function"&&typeof p.read=="function"&&typeof p.write=="function"&&((0,F.checkProposedApiEnabled)(a,"fsChunks"),l+=4),this._proxy.$registerFileSystemProvider(f,c,l).catch(y=>{console.error(`FAILED to register filesystem provider of ${a.identifier.value}-extension for the scheme ${c}`),console.error(y)});const h=p.onDidChangeFile(y=>{const s=[];for(const I of y){let{uri:r,type:i}=I;if(r.scheme!==c)continue;let v;switch(i){case A.FileChangeType.Changed:v=0;break;case A.FileChangeType.Created:v=1;break;case A.FileChangeType.Deleted:v=2;break;default:throw new Error("Unknown FileChangeType")}s.push({resource:r,type:v})}this._proxy.$onFileSystemChange(f,s)});return(0,w.toDisposable)(()=>{h.dispose(),this._linkProvider.delete(c),this._registeredSchemes.delete(c),this._fsProvider.delete(f),this._proxy.$unregisterProvider(f)})}static _asIStat(a){const{type:c,ctime:p,mtime:D,size:f,permissions:l}=a;return{type:c,ctime:p,mtime:D,size:f,permissions:l}}$stat(a,c){return Promise.resolve(this._getFsProvider(a).stat(u.URI.revive(c))).then(p=>n._asIStat(p))}$readdir(a,c){return Promise.resolve(this._getFsProvider(a).readDirectory(u.URI.revive(c)))}$readFile(a,c){return Promise.resolve(this._getFsProvider(a).readFile(u.URI.revive(c))).then(p=>k.VSBuffer.wrap(p))}$writeFile(a,c,p,D){return Promise.resolve(this._getFsProvider(a).writeFile(u.URI.revive(c),p.buffer,D))}$delete(a,c,p){return Promise.resolve(this._getFsProvider(a).delete(u.URI.revive(c),p))}$rename(a,c,p,D){return Promise.resolve(this._getFsProvider(a).rename(u.URI.revive(c),u.URI.revive(p),D))}$copy(a,c,p,D){const f=this._getFsProvider(a);if(!f.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(f.copy(u.URI.revive(c),u.URI.revive(p),D))}$mkdir(a,c){return Promise.resolve(this._getFsProvider(a).createDirectory(u.URI.revive(c)))}$watch(a,c,p,D){const f=this._getFsProvider(a).watch(u.URI.revive(p),D);this._watches.set(c,f)}$unwatch(a,c){const p=this._watches.get(c);p&&(p.dispose(),this._watches.delete(c))}$open(a,c,p){const D=this._getFsProvider(a);if(!D.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(D.open(u.URI.revive(c),p))}$close(a,c){const p=this._getFsProvider(a);if(!p.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(p.close(c))}$read(a,c,p,D){const f=this._getFsProvider(a);if(!f.read)throw new Error('FileSystemProvider does not implement "read"');const l=k.VSBuffer.alloc(D);return Promise.resolve(f.read(c,p,l.buffer,0,D)).then(h=>l.slice(0,h))}$write(a,c,p,D){const f=this._getFsProvider(a);if(!f.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(f.write(c,p,D.buffer,0,D.byteLength))}_getFsProvider(a){const c=this._fsProvider.get(a);if(!c){const p=new Error;throw p.name="ENOPRO",p.message="no provider",p}return c}}e.ExtHostFileSystem=n}),define(we[50],Ee([0,1,5,46,7,22,4,13,31,6]),function(re,e,u,M,w,A,t,T,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let F=class $t{constructor(n,g){this._fileSystemProvider=new Map,this._proxy=n.getProxy(u.MainContext.MainThreadFileSystem);const a=this;this.value=Object.freeze({async stat(c){try{const p=a._fileSystemProvider.get(c.scheme);if(!p)return await a._proxy.$stat(c);await a._proxy.$ensureActivation(c.scheme);const D=await p.stat(c);return{type:D.type,ctime:D.ctime,mtime:D.mtime,size:D.size,permissions:D.permissions}}catch(p){$t._handleError(p)}},async readDirectory(c){try{const p=a._fileSystemProvider.get(c.scheme);return p?(await a._proxy.$ensureActivation(c.scheme),(await p.readDirectory(c)).slice()):await a._proxy.$readdir(c)}catch(p){return $t._handleError(p)}},async createDirectory(c){try{return await a._proxy.$mkdir(c)}catch(p){return $t._handleError(p)}},async readFile(c){try{const p=a._fileSystemProvider.get(c.scheme);return p?(await a._proxy.$ensureActivation(c.scheme),(await p.readFile(c)).slice()):a._proxy.$readFile(c).then(D=>D.buffer)}catch(p){return $t._handleError(p)}},async writeFile(c,p){try{return await a._proxy.$writeFile(c,A.VSBuffer.wrap(p))}catch(D){return $t._handleError(D)}},async delete(c,p){try{const D=a._fileSystemProvider.get(c.scheme);return D?(await a._proxy.$ensureActivation(c.scheme),await D.delete(c,{recursive:!1,...p})):await a._proxy.$delete(c,{recursive:!1,useTrash:!1,...p})}catch(D){return $t._handleError(D)}},async rename(c,p,D){try{return await a._proxy.$rename(c,p,{overwrite:!1,...D})}catch(f){return $t._handleError(f)}},async copy(c,p,D){try{return await a._proxy.$copy(c,p,{overwrite:!1,...D})}catch(f){return $t._handleError(f)}},isWritableFileSystem(c){const p=g.getCapabilities(c);if(typeof p=="number")return!(p&2048)}})}static _handleError(n){if(n instanceof w.FileSystemError)throw n;if(!(n instanceof Error))throw new w.FileSystemError(String(n));if(n.name==="ENOPRO")throw w.FileSystemError.Unavailable(n.message);switch(n.name){case M.FileSystemProviderErrorCode.FileExists:throw w.FileSystemError.FileExists(n.message);case M.FileSystemProviderErrorCode.FileNotFound:throw w.FileSystemError.FileNotFound(n.message);case M.FileSystemProviderErrorCode.FileNotADirectory:throw w.FileSystemError.FileNotADirectory(n.message);case M.FileSystemProviderErrorCode.FileIsADirectory:throw w.FileSystemError.FileIsADirectory(n.message);case M.FileSystemProviderErrorCode.NoPermissions:throw w.FileSystemError.NoPermissions(n.message);case M.FileSystemProviderErrorCode.Unavailable:throw w.FileSystemError.Unavailable(n.message);default:throw new w.FileSystemError(n.message,n.name)}}addFileSystemProvider(n,g){return this._fileSystemProvider.set(n,g),(0,k.toDisposable)(()=>this._fileSystemProvider.delete(n))}};F=Ne([xe(0,T.IExtHostRpcService),xe(1,C.IExtHostFileSystemInfo)],F),e.ExtHostConsumerFileSystem=F,e.IExtHostConsumerFileSystem=(0,t.createDecorator)("IExtHostConsumerFileSystem")}),define(we[191],Ee([0,1,2,38]),function(re,e,u,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class w{constructor(t,T,C,k){this._extHostNotebooks=T,this._textDocumentsAndEditors=C,this._commands=k;const F=new M.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new M.ApiCommandArgument("showOptions","Show Options",_=>!0,_=>_),new M.ApiCommandArgument("resource","Interactive resource Uri",_=>!0,_=>_),new M.ApiCommandArgument("controllerId","Notebook controller Id",_=>!0,_=>_),new M.ApiCommandArgument("title","Interactive editor title",_=>!0,_=>_)],new M.ApiCommandResult("Notebook and input URI",_=>{if(_.notebookEditorId!==void 0){const n=this._extHostNotebooks.getEditorById(_.notebookEditorId);return{notebookUri:u.URI.revive(_.notebookUri),inputUri:u.URI.revive(_.inputUri),notebookEditor:n.apiEditor}}return{notebookUri:u.URI.revive(_.notebookUri),inputUri:u.URI.revive(_.inputUri)}}));this._commands.registerApiCommand(F)}$willAddInteractiveDocument(t,T,C,k){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:T,lines:[""],languageId:C,uri:t,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(u.URI.revive(k))?.apiNotebook}]})}$willRemoveInteractiveDocument(t,T){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[t]})}}e.ExtHostInteractive=w}),define(we[192],Ee([0,1,6,5]),function(re,e,u,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class w{constructor(t){this._handlePool=0,this._proxy=t.getProxy(M.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(t){const T=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(T,t),(0,u.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(T)})}}e.ExtHostLabelService=w}),define(we[193],Ee([0,1,2,25,8,7,5,9,43,16,10,233,6,81,53,64,194,15,3]),function(re,e,u,M,w,A,t,T,C,k,F,_,n,g,a,c,p,D,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class l{constructor(W,K){this._documents=W,this._provider=K}async provideDocumentSymbols(W,K){const Z=this._documents.getDocument(W),se=await this._provider.provideDocumentSymbols(Z,K);if(!(0,k.isFalsyOrEmpty)(se))return se[0]instanceof A.DocumentSymbol?se.map(w.DocumentSymbol.from):l._asDocumentSymbolTree(se)}static _asDocumentSymbolTree(W){W=W.slice(0).sort((se,G)=>{let te=se.location.range.start.compareTo(G.location.range.start);return te===0&&(te=G.location.range.end.compareTo(se.location.range.end)),te});const K=[],Z=[];for(const se of W){const G={name:se.name||"!!MISSING: name!!",kind:w.SymbolKind.from(se.kind),tags:se.tags?.map(w.SymbolTag.from)||[],detail:"",containerName:se.containerName,range:w.Range.from(se.location.range),selectionRange:w.Range.from(se.location.range),children:[]};for(;;){if(Z.length===0){Z.push(G),K.push(G);break}const te=Z[Z.length-1];if(C.Range.containsRange(te.range,G.range)&&!C.Range.equalsRange(te.range,G.range)){te.children&&te.children.push(G),Z.push(G);break}Z.pop()}}return K}}class h{constructor(W,K,Z){this._documents=W,this._commands=K,this._provider=Z,this._cache=new c.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(W,K){const Z=this._documents.getDocument(W),se=await this._provider.provideCodeLenses(Z,K);if(!se||K.isCancellationRequested)return;const G=this._cache.add(se),te=new n.DisposableStore;this._disposables.set(G,te);const he={cacheId:G,lenses:[]};for(let Pe=0;Pe<se.length;Pe++)he.lenses.push({cacheId:[G,Pe],range:w.Range.from(se[Pe].range),command:this._commands.toInternal(se[Pe].command,te)});return he}async resolveCodeLens(W,K){const Z=W.cacheId&&this._cache.get(...W.cacheId);if(!Z)return;let se;if(typeof this._provider.resolveCodeLens!="function"||Z.isResolved?se=Z:se=await this._provider.resolveCodeLens(Z,K),se||(se=Z),K.isCancellationRequested)return;const G=W.cacheId&&this._disposables.get(W.cacheId[0]);if(!!G)return W.command=this._commands.toInternal(se.command??h._badCmd,G),W}releaseCodeLenses(W){this._disposables.get(W)?.dispose(),this._disposables.delete(W),this._cache.delete(W)}}h._badCmd={command:"missing",title:"!!MISSING: command!!"};function y(Ke){return Array.isArray(Ke)?Ke.map(w.DefinitionLink.from):Ke?[w.DefinitionLink.from(Ke)]:[]}class s{constructor(W,K){this._documents=W,this._provider=K}async provideDefinition(W,K,Z){const se=this._documents.getDocument(W),G=w.Position.to(K),te=await this._provider.provideDefinition(se,G,Z);return y(te)}}class I{constructor(W,K){this._documents=W,this._provider=K}async provideDeclaration(W,K,Z){const se=this._documents.getDocument(W),G=w.Position.to(K),te=await this._provider.provideDeclaration(se,G,Z);return y(te)}}class r{constructor(W,K){this._documents=W,this._provider=K}async provideImplementation(W,K,Z){const se=this._documents.getDocument(W),G=w.Position.to(K),te=await this._provider.provideImplementation(se,G,Z);return y(te)}}class i{constructor(W,K){this._documents=W,this._provider=K}async provideTypeDefinition(W,K,Z){const se=this._documents.getDocument(W),G=w.Position.to(K),te=await this._provider.provideTypeDefinition(se,G,Z);return y(te)}}class v{constructor(W,K){this._documents=W,this._provider=K}async provideHover(W,K,Z){const se=this._documents.getDocument(W),G=w.Position.to(K),te=await this._provider.provideHover(se,G,Z);if(!(!te||(0,k.isFalsyOrEmpty)(te.contents)))return te.range||(te.range=se.getWordRangeAtPosition(G)),te.range||(te.range=new A.Range(G,G)),w.Hover.from(te)}}class m{constructor(W,K){this._documents=W,this._provider=K}async provideEvaluatableExpression(W,K,Z){const se=this._documents.getDocument(W),G=w.Position.to(K),te=await this._provider.provideEvaluatableExpression(se,G,Z);if(te)return w.EvaluatableExpression.from(te)}}class o{constructor(W,K){this._documents=W,this._provider=K}async provideInlineValues(W,K,Z,se){const G=this._documents.getDocument(W),te=await this._provider.provideInlineValues(G,w.Range.to(K),w.InlineValueContext.to(Z),se);if(Array.isArray(te))return te.map(he=>w.InlineValue.from(he))}}class b{constructor(W,K){this._documents=W,this._provider=K}async provideDocumentHighlights(W,K,Z){const se=this._documents.getDocument(W),G=w.Position.to(K),te=await this._provider.provideDocumentHighlights(se,G,Z);if(Array.isArray(te))return te.map(w.DocumentHighlight.from)}}class d{constructor(W,K){this._documents=W,this._provider=K}async provideLinkedEditingRanges(W,K,Z){const se=this._documents.getDocument(W),G=w.Position.to(K),te=await this._provider.provideLinkedEditingRanges(se,G,Z);if(te&&Array.isArray(te.ranges))return{ranges:(0,k.coalesce)(te.ranges.map(w.Range.from)),wordPattern:te.wordPattern}}}class E{constructor(W,K){this._documents=W,this._provider=K}async provideReferences(W,K,Z,se){const G=this._documents.getDocument(W),te=w.Position.to(K),he=await this._provider.provideReferences(G,te,Z,se);if(Array.isArray(he))return he.map(w.location.from)}}class R{constructor(W,K,Z,se,G,te,he){this._documents=W,this._commands=K,this._diagnostics=Z,this._provider=se,this._logService=G,this._extension=te,this._apiDeprecation=he,this._cache=new c.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(W,K,Z,se){const G=this._documents.getDocument(W),te=_.Selection.isISelection(K)?w.Selection.to(K):w.Range.to(K),he=[];for(const ot of this._diagnostics.getDiagnostics(W))if(te.intersection(ot.range)&&he.push(ot)>R._maxCodeActionsPerFile)break;const Pe={diagnostics:he,only:Z.only?new A.CodeActionKind(Z.only):void 0,triggerKind:w.CodeActionTriggerKind.to(Z.trigger)},Oe=await this._provider.provideCodeActions(G,te,Pe,se);if(!(0,k.isNonEmptyArray)(Oe)||se.isCancellationRequested)return;const Be=this._cache.add(Oe),Ve=new n.DisposableStore;this._disposables.set(Be,Ve);const Ze=[];for(let ot=0;ot<Oe.length;ot++){const ye=Oe[ot];!ye||(R._isCommand(ye)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),Ze.push({_isSynthetic:!0,title:ye.title,command:this._commands.toInternal(ye,Ve)})):(Pe.only&&(ye.kind?Pe.only.contains(ye.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Pe.only.value} 'requested but returned code action is of kind '${ye.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Pe.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),Ze.push({cacheId:[Be,ot],title:ye.title,command:ye.command&&this._commands.toInternal(ye.command,Ve),diagnostics:ye.diagnostics&&ye.diagnostics.map(w.Diagnostic.from),edit:ye.edit&&w.WorkspaceEdit.from(ye.edit),kind:ye.kind&&ye.kind.value,isPreferred:ye.isPreferred,disabled:ye.disabled?.reason})))}return{cacheId:Be,actions:Ze}}async resolveCodeAction(W,K){const[Z,se]=W,G=this._cache.get(Z,se);if(!G||R._isCommand(G)||!this._provider.resolveCodeAction)return;const te=await this._provider.resolveCodeAction(G,K)??G;return te?.edit?w.WorkspaceEdit.from(te.edit):void 0}releaseCodeActions(W){this._disposables.get(W)?.dispose(),this._disposables.delete(W),this._cache.delete(W)}static _isCommand(W){return typeof W.command=="string"&&typeof W.title=="string"}}R._maxCodeActionsPerFile=1e3;class P{constructor(W,K){this._documents=W,this._provider=K}async provideDocumentFormattingEdits(W,K,Z){const se=this._documents.getDocument(W),G=await this._provider.provideDocumentFormattingEdits(se,K,Z);if(Array.isArray(G))return G.map(w.TextEdit.from)}}class z{constructor(W,K){this._documents=W,this._provider=K}async provideDocumentRangeFormattingEdits(W,K,Z,se){const G=this._documents.getDocument(W),te=w.Range.to(K),he=await this._provider.provideDocumentRangeFormattingEdits(G,te,Z,se);if(Array.isArray(he))return he.map(w.TextEdit.from)}}class O{constructor(W,K){this._documents=W,this._provider=K,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(W,K,Z,se,G){const te=this._documents.getDocument(W),he=w.Position.to(K),Pe=await this._provider.provideOnTypeFormattingEdits(te,he,Z,se,G);if(Array.isArray(Pe))return Pe.map(w.TextEdit.from)}}class S{constructor(W,K){this._provider=W,this._logService=K,this._symbolCache=new Map,this._resultCache=new Map}async provideWorkspaceSymbols(W,K){const Z=t.IdObject.mixin({symbols:[]}),se=await this._provider.provideWorkspaceSymbols(W,K);if((0,k.isNonEmptyArray)(se))for(const G of se){if(!G)continue;if(!G.name){this._logService.warn("INVALID SymbolInformation, lacks name",G);continue}const te=t.IdObject.mixin(w.WorkspaceSymbol.from(G));this._symbolCache.set(te._id,G),Z.symbols.push(te)}return Z.symbols.length>0&&this._resultCache.set(Z._id,[Z.symbols[0]._id,Z.symbols[Z.symbols.length-1]._id]),Z}async resolveWorkspaceSymbol(W,K){if(typeof this._provider.resolveWorkspaceSymbol!="function")return W;const Z=this._symbolCache.get(W._id);if(Z){const se=await this._provider.resolveWorkspaceSymbol(Z,K);return se&&(0,M.mixin)(W,w.WorkspaceSymbol.from(se),!0)}}releaseWorkspaceSymbols(W){const K=this._resultCache.get(W);if(K){for(let[Z,se]=K;Z<=se;Z++)this._symbolCache.delete(Z);this._resultCache.delete(W)}}}class x{constructor(W,K,Z){this._documents=W,this._provider=K,this._logService=Z}static supportsResolving(W){return typeof W.prepareRename=="function"}async provideRenameEdits(W,K,Z,se){const G=this._documents.getDocument(W),te=w.Position.to(K);try{const he=await this._provider.provideRenameEdits(G,te,Z,se);return he?w.WorkspaceEdit.from(he):void 0}catch(he){const Pe=x._asMessage(he);return Pe?{rejectReason:Pe,edits:void 0}:Promise.reject(he)}}async resolveRenameLocation(W,K,Z){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const se=this._documents.getDocument(W),G=w.Position.to(K);try{const te=await this._provider.prepareRename(se,G,Z);let he,Pe;if(A.Range.isRange(te)?(he=te,Pe=se.getText(te)):(0,F.isObject)(te)&&(he=te.range,Pe=te.placeholder),!he||!Pe)return;if(he.start.line>G.line||he.end.line<G.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:w.Range.from(he),text:Pe}}catch(te){const he=x._asMessage(te);return he?{rejectReason:he,range:void 0,text:void 0}:Promise.reject(te)}}static _asMessage(W){return typeof W=="string"?W:W instanceof Error&&typeof W.message=="string"?W.message:void 0}}class N{constructor(W,K){this.resultId=W,this.tokens=K}}class V{constructor(W,K){this._documents=W,this._provider=K,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(W,K,Z){const se=this._documents.getDocument(W),G=K!==0?this._previousResults.get(K):null;let te=typeof G?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(se,G.resultId,Z):await this._provider.provideDocumentSemanticTokens(se,Z);return G&&this._previousResults.delete(K),te?(te=V._fixProvidedSemanticTokens(te),this._send(V._convertToEdits(G,te),te)):null}async releaseDocumentSemanticColoring(W){this._previousResults.delete(W)}static _fixProvidedSemanticTokens(W){return V._isSemanticTokens(W)?V._isCorrectSemanticTokens(W)?W:new A.SemanticTokens(new Uint32Array(W.data),W.resultId):V._isSemanticTokensEdits(W)?V._isCorrectSemanticTokensEdits(W)?W:new A.SemanticTokensEdits(W.edits.map(K=>new A.SemanticTokensEdit(K.start,K.deleteCount,K.data?new Uint32Array(K.data):K.data)),W.resultId):W}static _isSemanticTokens(W){return W&&!!W.data}static _isCorrectSemanticTokens(W){return W.data instanceof Uint32Array}static _isSemanticTokensEdits(W){return W&&Array.isArray(W.edits)}static _isCorrectSemanticTokensEdits(W){for(const K of W.edits)if(!(K.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(W,K){if(!V._isSemanticTokens(K)||!W||!W.tokens)return K;const Z=W.tokens,se=Z.length,G=K.data,te=G.length;let he=0;const Pe=Math.min(se,te);for(;he<Pe&&Z[he]===G[he];)he++;if(he===se&&he===te)return new A.SemanticTokensEdits([],K.resultId);let Oe=0;const Be=Pe-he;for(;Oe<Be&&Z[se-Oe-1]===G[te-Oe-1];)Oe++;return new A.SemanticTokensEdits([{start:he,deleteCount:se-he-Oe,data:G.subarray(he,te-Oe)}],K.resultId)}_send(W,K){if(V._isSemanticTokens(W)){const Z=this._nextResultId++;return this._previousResults.set(Z,new N(W.resultId,W.data)),(0,g.encodeSemanticTokensDto)({id:Z,type:"full",data:W.data})}if(V._isSemanticTokensEdits(W)){const Z=this._nextResultId++;return V._isSemanticTokens(K)?this._previousResults.set(Z,new N(K.resultId,K.data)):this._previousResults.set(Z,new N(W.resultId)),(0,g.encodeSemanticTokensDto)({id:Z,type:"delta",deltas:(W.edits||[]).map(se=>({start:se.start,deleteCount:se.deleteCount,data:se.data}))})}return null}}e.DocumentSemanticTokensAdapter=V;class B{constructor(W,K){this._documents=W,this._provider=K}async provideDocumentRangeSemanticTokens(W,K,Z){const se=this._documents.getDocument(W),G=await this._provider.provideDocumentRangeSemanticTokens(se,w.Range.to(K),Z);return G?this._send(G):null}_send(W){return(0,g.encodeSemanticTokensDto)({id:0,type:"full",data:W.data})}}e.DocumentRangeSemanticTokensAdapter=B;class ${constructor(W,K,Z,se,G){this._documents=W,this._commands=K,this._provider=Z,this._apiDeprecation=se,this._extension=G,this._cache=new c.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(W){return typeof W.resolveCompletionItem=="function"}async provideCompletionItems(W,K,Z,se){const G=this._documents.getDocument(W),te=w.Position.to(K),he=G.getWordRangeAtPosition(te)||new A.Range(te,te),Pe=he.with({end:te}),Oe=new p.StopWatch(!0),Be=await this._provider.provideCompletionItems(G,te,se,w.CompletionContext.to(Z));if(!Be||se.isCancellationRequested)return;const Ve=Array.isArray(Be)?new A.CompletionList(Be):Be,Ze=$.supportsResolving(this._provider)?this._cache.add(Ve.items):this._cache.add([]),ot=new n.DisposableStore;this._disposables.set(Ze,ot);const ye=[],it={x:Ze,b:ye,a:{replace:w.Range.from(he),insert:w.Range.from(Pe)},c:Ve.isIncomplete||void 0,d:Oe.elapsed()};for(let q=0;q<Ve.items.length;q++){const X=Ve.items[q],ge=this._convertCompletionItem(X,[Ze,q],Pe,he);ye.push(ge)}return it}async resolveCompletionItem(W,K){if(typeof this._provider.resolveCompletionItem!="function")return;const Z=this._cache.get(...W);if(!Z)return;const se=await this._provider.resolveCompletionItem(Z,K);if(!!se)return this._convertCompletionItem(se,W)}releaseCompletionItems(W){this._disposables.get(W)?.dispose(),this._disposables.delete(W),this._cache.delete(W)}_convertCompletionItem(W,K,Z,se){const G=this._disposables.get(K[0]);if(!G)throw Error("DisposableStore is missing...");const te={x:K,a:W.label,b:W.kind!==void 0?w.CompletionItemKind.from(W.kind):void 0,n:W.tags&&W.tags.map(w.CompletionItemTag.from),c:W.detail,d:typeof W.documentation=="undefined"?void 0:w.MarkdownString.fromStrict(W.documentation),e:W.sortText!==W.label?W.sortText:void 0,f:W.filterText!==W.label?W.filterText:void 0,g:W.preselect||void 0,i:W.keepWhitespace?1:0,k:W.commitCharacters,l:W.additionalTextEdits&&W.additionalTextEdits.map(w.TextEdit.from),m:this._commands.toInternal(W.command,G)};W.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),te.h=W.textEdit.newText):typeof W.insertText=="string"?te.h=W.insertText:W.insertText instanceof A.SnippetString&&(te.h=W.insertText.value,te.i|=4);let he;return W.textEdit?he=W.textEdit.range:W.range&&(he=W.range),A.Range.isRange(he)?te.j=w.Range.from(he):he&&(!Z?.isEqual(he.inserting)||!se?.isEqual(he.replacing))&&(te.j={insert:w.Range.from(he.inserting),replace:w.Range.from(he.replacing)}),te}}class J{constructor(W,K,Z){this._documents=W,this._provider=K,this._commands=Z,this._cache=new c.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions(W,K,Z,se){const G=this._documents.getDocument(W),te=w.Position.to(K),he=await this._provider.provideInlineCompletionItems(G,te,{selectedCompletionInfo:Z.selectedSuggestionInfo?{range:w.Range.to(Z.selectedSuggestionInfo.range),text:Z.selectedSuggestionInfo.text}:void 0,triggerKind:Z.triggerKind},se);if(!he||se.isCancellationRequested)return;const Pe=(0,F.isArray)(he)?{items:he}:he,Oe=this._cache.add(Pe.items);let Be;return{pid:Oe,items:Pe.items.map((Ve,Ze)=>{let ot;return Ve.command&&(Be||(Be=new n.DisposableStore,this._disposables.set(Oe,Be)),ot=this._commands.toInternal(Ve.command,Be)),{text:Ve.text,range:Ve.range?w.Range.from(Ve.range):void 0,command:ot,idx:Ze}})}}disposeCompletions(W){this._cache.delete(W);const K=this._disposables.get(W);K&&K.clear(),this._disposables.delete(W)}handleDidShowCompletionItem(W,K){const Z=this._cache.get(W,K);Z&&j.get(this._provider).fireOnDidShowCompletionItem({completionItem:Z})}}class j{constructor(){this._onDidShowCompletionItemEmitter=new f.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get(W){let K=j.map.get(W);return K||(K=new j,j.map.set(W,K)),K}fireOnDidShowCompletionItem(W){this._onDidShowCompletionItemEmitter.fire(W)}}e.InlineCompletionController=j,j.map=new WeakMap;class Q{constructor(W,K){this._documents=W,this._provider=K,this._cache=new c.Cache("SignatureHelp")}async provideSignatureHelp(W,K,Z,se){const G=this._documents.getDocument(W),te=w.Position.to(K),he=this.reviveContext(Z),Pe=await this._provider.provideSignatureHelp(G,te,se,he);if(Pe){const Oe=this._cache.add([Pe]);return{...w.SignatureHelp.from(Pe),id:Oe}}}reviveContext(W){let K;if(W.activeSignatureHelp){const Z=w.SignatureHelp.to(W.activeSignatureHelp),se=this._cache.get(W.activeSignatureHelp.id,0);se?(K=se,K.activeSignature=Z.activeSignature,K.activeParameter=Z.activeParameter):K=Z}return{...W,activeSignatureHelp:K}}releaseSignatureHelp(W){this._cache.delete(W)}}class le{constructor(W,K){this._documents=W,this._provider=K}async provideInlayHints(W,K,Z){const se=this._documents.getDocument(W),G=await this._provider.provideInlayHints(se,w.Range.to(K),Z);return G?{hints:G.map(w.InlayHint.from)}:void 0}}class be{constructor(W,K){this._documents=W,this._provider=K,this._cache=new c.Cache("DocumentLink")}async provideLinks(W,K){const Z=this._documents.getDocument(W),se=await this._provider.provideDocumentLinks(Z,K);if(!(!Array.isArray(se)||se.length===0)&&!K.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:se.filter(be._validateLink).map(w.DocumentLink.from)};{const G=this._cache.add(se),te={links:[],id:G};for(let he=0;he<se.length;he++){if(!be._validateLink(se[he]))continue;const Pe=w.DocumentLink.from(se[he]);Pe.cacheId=[G,he],te.links.push(Pe)}return te}}}static _validateLink(W){return W.target&&W.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(W,K){if(typeof this._provider.resolveDocumentLink!="function")return;const Z=this._cache.get(...W);if(!Z)return;const se=await this._provider.resolveDocumentLink(Z,K);if(!(!se||!be._validateLink(se)))return w.DocumentLink.from(se)}releaseLinks(W){this._cache.delete(W)}}class de{constructor(W,K){this._documents=W,this._provider=K}async provideColors(W,K){const Z=this._documents.getDocument(W),se=await this._provider.provideDocumentColors(Z,K);return Array.isArray(se)?se.map(te=>({color:w.Color.from(te.color),range:w.Range.from(te.range)})):[]}async provideColorPresentations(W,K,Z){const se=this._documents.getDocument(W),G=w.Range.to(K.range),te=w.Color.to(K.color),he=await this._provider.provideColorPresentations(te,{document:se,range:G},Z);if(!!Array.isArray(he))return he.map(w.ColorPresentation.from)}}class Fe{constructor(W,K){this._documents=W,this._provider=K}async provideFoldingRanges(W,K,Z){const se=this._documents.getDocument(W),G=await this._provider.provideFoldingRanges(se,K,Z);if(!!Array.isArray(G))return G.map(w.FoldingRange.from)}}class Ge{constructor(W,K,Z){this._documents=W,this._provider=K,this._logService=Z}async provideSelectionRanges(W,K,Z){const se=this._documents.getDocument(W),G=K.map(w.Position.to),te=await this._provider.provideSelectionRanges(se,G,Z);if(!(0,k.isNonEmptyArray)(te))return[];if(te.length!==G.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const he=[];for(let Pe=0;Pe<G.length;Pe++){const Oe=[];he.push(Oe);let Be=G[Pe],Ve=te[Pe];for(;;){if(!Ve.range.contains(Be))throw new Error("INVALID selection range, must contain the previous range");if(Oe.push(w.SelectionRange.from(Ve)),!Ve.parent)break;Be=Ve.range,Ve=Ve.parent}}return he}}class Le{constructor(W,K){this._documents=W,this._provider=K,this._idPool=new a.IdGenerator(""),this._cache=new Map}async prepareSession(W,K,Z){const se=this._documents.getDocument(W),G=w.Position.to(K),te=await this._provider.prepareCallHierarchy(se,G,Z);if(!te)return;const he=this._idPool.nextId();return this._cache.set(he,new Map),Array.isArray(te)?te.map(Pe=>this._cacheAndConvertItem(he,Pe)):[this._cacheAndConvertItem(he,te)]}async provideCallsTo(W,K,Z){const se=this._itemFromCache(W,K);if(!se)throw new Error("missing call hierarchy item");const G=await this._provider.provideCallHierarchyIncomingCalls(se,Z);if(!!G)return G.map(te=>({from:this._cacheAndConvertItem(W,te.from),fromRanges:te.fromRanges.map(he=>w.Range.from(he))}))}async provideCallsFrom(W,K,Z){const se=this._itemFromCache(W,K);if(!se)throw new Error("missing call hierarchy item");const G=await this._provider.provideCallHierarchyOutgoingCalls(se,Z);if(!!G)return G.map(te=>({to:this._cacheAndConvertItem(W,te.to),fromRanges:te.fromRanges.map(he=>w.Range.from(he))}))}releaseSession(W){this._cache.delete(W)}_cacheAndConvertItem(W,K){const Z=this._cache.get(W),se=w.CallHierarchyItem.from(K,W,Z.size.toString(36));return Z.set(se._itemId,K),se}_itemFromCache(W,K){return this._cache.get(W)?.get(K)}}class We{constructor(W,K){this._documents=W,this._provider=K,this._idPool=new a.IdGenerator(""),this._cache=new Map}async prepareSession(W,K,Z){const se=this._documents.getDocument(W),G=w.Position.to(K),te=await this._provider.prepareTypeHierarchy(se,G,Z);if(!te)return;const he=this._idPool.nextId();return this._cache.set(he,new Map),Array.isArray(te)?te.map(Pe=>this._cacheAndConvertItem(he,Pe)):[this._cacheAndConvertItem(he,te)]}async provideSupertypes(W,K,Z){const se=this._itemFromCache(W,K);if(!se)throw new Error("missing type hierarchy item");const G=await this._provider.provideTypeHierarchySupertypes(se,Z);if(!!G)return G.map(te=>this._cacheAndConvertItem(W,te))}async provideSubtypes(W,K,Z){const se=this._itemFromCache(W,K);if(!se)throw new Error("missing type hierarchy item");const G=await this._provider.provideTypeHierarchySubtypes(se,Z);if(!!G)return G.map(te=>this._cacheAndConvertItem(W,te))}releaseSession(W){this._cache.delete(W)}_cacheAndConvertItem(W,K){const Z=this._cache.get(W),se=w.TypeHierarchyItem.from(K,W,Z.size.toString(36));return Z.set(se._itemId,K),se}_itemFromCache(W,K){return this._cache.get(W)?.get(K)}}class Ye{constructor(W,K){this.adapter=W,this.extension=K}}class Qe{constructor(W,K,Z,se,G,te,he){this._adapter=new Map,this._uriTransformer=K,this._proxy=W.getProxy(t.MainContext.MainThreadLanguageFeatures),this._documents=Z,this._commands=se,this._diagnostics=G,this._logService=te,this._apiDeprecation=he}_transformDocumentSelector(W){return w.DocumentSelector.from(W,this._uriTransformer)}_createDisposable(W){return new A.Disposable(()=>{this._adapter.delete(W),this._proxy.$unregister(W)})}_nextHandle(){return Qe._handlePool++}_withAdapter(W,K,Z,se,G=!1){const te=this._adapter.get(W);if(!te)return Promise.resolve(se);if(te.adapter instanceof K){let he;te.extension&&(he=Date.now(),this._logService.trace(`[${te.extension.identifier.value}] INVOKE provider '${K.name}'`));const Pe=Z(te.adapter,te.extension),Oe=te.extension;return Oe&&Promise.resolve(Pe).then(()=>this._logService.trace(`[${Oe.identifier.value}] provider DONE after ${Date.now()-he}ms`),Be=>{G&&Be instanceof D.CancellationError||(this._logService.error(`[${Oe.identifier.value}] provider FAILED`),this._logService.error(Be))}),Pe}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(W,K){const Z=this._nextHandle();return this._adapter.set(Z,new Ye(W,K)),Z}static _extLabel(W){return W.displayName||W.name}registerDocumentSymbolProvider(W,K,Z,se){const G=this._addNewAdapter(new l(this._documents,Z),W),te=se&&se.label||Qe._extLabel(W);return this._proxy.$registerDocumentSymbolProvider(G,this._transformDocumentSelector(K),te),this._createDisposable(G)}$provideDocumentSymbols(W,K,Z){return this._withAdapter(W,l,se=>se.provideDocumentSymbols(u.URI.revive(K),Z),void 0)}registerCodeLensProvider(W,K,Z){const se=this._nextHandle(),G=typeof Z.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(se,new Ye(new h(this._documents,this._commands.converter,Z),W)),this._proxy.$registerCodeLensSupport(se,this._transformDocumentSelector(K),G);let te=this._createDisposable(se);if(G!==void 0){const he=Z.onDidChangeCodeLenses(Pe=>this._proxy.$emitCodeLensEvent(G));te=A.Disposable.from(te,he)}return te}$provideCodeLenses(W,K,Z){return this._withAdapter(W,h,se=>se.provideCodeLenses(u.URI.revive(K),Z),void 0)}$resolveCodeLens(W,K,Z){return this._withAdapter(W,h,se=>se.resolveCodeLens(K,Z),void 0)}$releaseCodeLenses(W,K){this._withAdapter(W,h,Z=>Promise.resolve(Z.releaseCodeLenses(K)),void 0)}registerDefinitionProvider(W,K,Z){const se=this._addNewAdapter(new s(this._documents,Z),W);return this._proxy.$registerDefinitionSupport(se,this._transformDocumentSelector(K)),this._createDisposable(se)}$provideDefinition(W,K,Z,se){return this._withAdapter(W,s,G=>G.provideDefinition(u.URI.revive(K),Z,se),[])}registerDeclarationProvider(W,K,Z){const se=this._addNewAdapter(new I(this._documents,Z),W);return this._proxy.$registerDeclarationSupport(se,this._transformDocumentSelector(K)),this._createDisposable(se)}$provideDeclaration(W,K,Z,se){return this._withAdapter(W,I,G=>G.provideDeclaration(u.URI.revive(K),Z,se),[])}registerImplementationProvider(W,K,Z){const se=this._addNewAdapter(new r(this._documents,Z),W);return this._proxy.$registerImplementationSupport(se,this._transformDocumentSelector(K)),this._createDisposable(se)}$provideImplementation(W,K,Z,se){return this._withAdapter(W,r,G=>G.provideImplementation(u.URI.revive(K),Z,se),[])}registerTypeDefinitionProvider(W,K,Z){const se=this._addNewAdapter(new i(this._documents,Z),W);return this._proxy.$registerTypeDefinitionSupport(se,this._transformDocumentSelector(K)),this._createDisposable(se)}$provideTypeDefinition(W,K,Z,se){return this._withAdapter(W,i,G=>G.provideTypeDefinition(u.URI.revive(K),Z,se),[])}registerHoverProvider(W,K,Z,se){const G=this._addNewAdapter(new v(this._documents,Z),W);return this._proxy.$registerHoverProvider(G,this._transformDocumentSelector(K)),this._createDisposable(G)}$provideHover(W,K,Z,se){return this._withAdapter(W,v,G=>G.provideHover(u.URI.revive(K),Z,se),void 0)}registerEvaluatableExpressionProvider(W,K,Z,se){const G=this._addNewAdapter(new m(this._documents,Z),W);return this._proxy.$registerEvaluatableExpressionProvider(G,this._transformDocumentSelector(K)),this._createDisposable(G)}$provideEvaluatableExpression(W,K,Z,se){return this._withAdapter(W,m,G=>G.provideEvaluatableExpression(u.URI.revive(K),Z,se),void 0)}registerInlineValuesProvider(W,K,Z,se){const G=typeof Z.onDidChangeInlineValues=="function"?this._nextHandle():void 0,te=this._addNewAdapter(new o(this._documents,Z),W);this._proxy.$registerInlineValuesProvider(te,this._transformDocumentSelector(K),G);let he=this._createDisposable(te);if(G!==void 0){const Pe=Z.onDidChangeInlineValues(Oe=>this._proxy.$emitInlineValuesEvent(G));he=A.Disposable.from(he,Pe)}return he}$provideInlineValues(W,K,Z,se,G){return this._withAdapter(W,o,te=>te.provideInlineValues(u.URI.revive(K),Z,se,G),void 0)}registerDocumentHighlightProvider(W,K,Z){const se=this._addNewAdapter(new b(this._documents,Z),W);return this._proxy.$registerDocumentHighlightProvider(se,this._transformDocumentSelector(K)),this._createDisposable(se)}$provideDocumentHighlights(W,K,Z,se){return this._withAdapter(W,b,G=>G.provideDocumentHighlights(u.URI.revive(K),Z,se),void 0)}registerLinkedEditingRangeProvider(W,K,Z){const se=this._addNewAdapter(new d(this._documents,Z),W);return this._proxy.$registerLinkedEditingRangeProvider(se,this._transformDocumentSelector(K)),this._createDisposable(se)}$provideLinkedEditingRanges(W,K,Z,se){return this._withAdapter(W,d,async G=>{const te=await G.provideLinkedEditingRanges(u.URI.revive(K),Z,se);if(te)return{ranges:te.ranges,wordPattern:te.wordPattern?Qe._serializeRegExp(te.wordPattern):void 0}},void 0)}registerReferenceProvider(W,K,Z){const se=this._addNewAdapter(new E(this._documents,Z),W);return this._proxy.$registerReferenceSupport(se,this._transformDocumentSelector(K)),this._createDisposable(se)}$provideReferences(W,K,Z,se,G){return this._withAdapter(W,E,te=>te.provideReferences(u.URI.revive(K),Z,se,G),void 0)}registerCodeActionProvider(W,K,Z,se){const G=new n.DisposableStore,te=this._addNewAdapter(new R(this._documents,this._commands.converter,this._diagnostics,Z,this._logService,W,this._apiDeprecation),W);return this._proxy.$registerQuickFixSupport(te,this._transformDocumentSelector(K),{providedKinds:se?.providedCodeActionKinds?.map(he=>he.value),documentation:se?.documentation?.map(he=>({kind:he.kind.value,command:this._commands.converter.toInternal(he.command,G)}))},Qe._extLabel(W),Boolean(Z.resolveCodeAction)),G.add(this._createDisposable(te)),G}$provideCodeActions(W,K,Z,se,G){return this._withAdapter(W,R,te=>te.provideCodeActions(u.URI.revive(K),Z,se,G),void 0)}$resolveCodeAction(W,K,Z){return this._withAdapter(W,R,se=>se.resolveCodeAction(K,Z),void 0)}$releaseCodeActions(W,K){this._withAdapter(W,R,Z=>Promise.resolve(Z.releaseCodeActions(K)),void 0)}registerDocumentFormattingEditProvider(W,K,Z){const se=this._addNewAdapter(new P(this._documents,Z),W);return this._proxy.$registerDocumentFormattingSupport(se,this._transformDocumentSelector(K),W.identifier,W.displayName||W.name),this._createDisposable(se)}$provideDocumentFormattingEdits(W,K,Z,se){return this._withAdapter(W,P,G=>G.provideDocumentFormattingEdits(u.URI.revive(K),Z,se),void 0)}registerDocumentRangeFormattingEditProvider(W,K,Z){const se=this._addNewAdapter(new z(this._documents,Z),W);return this._proxy.$registerRangeFormattingSupport(se,this._transformDocumentSelector(K),W.identifier,W.displayName||W.name),this._createDisposable(se)}$provideDocumentRangeFormattingEdits(W,K,Z,se,G){return this._withAdapter(W,z,te=>te.provideDocumentRangeFormattingEdits(u.URI.revive(K),Z,se,G),void 0)}registerOnTypeFormattingEditProvider(W,K,Z,se){const G=this._addNewAdapter(new O(this._documents,Z),W);return this._proxy.$registerOnTypeFormattingSupport(G,this._transformDocumentSelector(K),se,W.identifier),this._createDisposable(G)}$provideOnTypeFormattingEdits(W,K,Z,se,G,te){return this._withAdapter(W,O,he=>he.provideOnTypeFormattingEdits(u.URI.revive(K),Z,se,G,te),void 0)}registerWorkspaceSymbolProvider(W,K){const Z=this._addNewAdapter(new S(K,this._logService),W);return this._proxy.$registerNavigateTypeSupport(Z,typeof K.resolveWorkspaceSymbol=="function"),this._createDisposable(Z)}$provideWorkspaceSymbols(W,K,Z){return this._withAdapter(W,S,se=>se.provideWorkspaceSymbols(K,Z),{symbols:[]})}$resolveWorkspaceSymbol(W,K,Z){return this._withAdapter(W,S,se=>se.resolveWorkspaceSymbol(K,Z),void 0)}$releaseWorkspaceSymbols(W,K){this._withAdapter(W,S,Z=>Z.releaseWorkspaceSymbols(K),void 0)}registerRenameProvider(W,K,Z){const se=this._addNewAdapter(new x(this._documents,Z,this._logService),W);return this._proxy.$registerRenameSupport(se,this._transformDocumentSelector(K),x.supportsResolving(Z)),this._createDisposable(se)}$provideRenameEdits(W,K,Z,se,G){return this._withAdapter(W,x,te=>te.provideRenameEdits(u.URI.revive(K),Z,se,G),void 0)}$resolveRenameLocation(W,K,Z,se){return this._withAdapter(W,x,G=>G.resolveRenameLocation(u.URI.revive(K),Z,se),void 0)}registerDocumentSemanticTokensProvider(W,K,Z,se){const G=this._nextHandle(),te=typeof Z.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(G,new Ye(new V(this._documents,Z),W)),this._proxy.$registerDocumentSemanticTokensProvider(G,this._transformDocumentSelector(K),se,te);let he=this._createDisposable(G);if(te){const Pe=Z.onDidChangeSemanticTokens(Oe=>this._proxy.$emitDocumentSemanticTokensEvent(te));he=A.Disposable.from(he,Pe)}return he}$provideDocumentSemanticTokens(W,K,Z,se){return this._withAdapter(W,V,G=>G.provideDocumentSemanticTokens(u.URI.revive(K),Z,se),null,!0)}$releaseDocumentSemanticTokens(W,K){this._withAdapter(W,V,Z=>Z.releaseDocumentSemanticColoring(K),void 0)}registerDocumentRangeSemanticTokensProvider(W,K,Z,se){const G=this._addNewAdapter(new B(this._documents,Z),W);return this._proxy.$registerDocumentRangeSemanticTokensProvider(G,this._transformDocumentSelector(K),se),this._createDisposable(G)}$provideDocumentRangeSemanticTokens(W,K,Z,se){return this._withAdapter(W,B,G=>G.provideDocumentRangeSemanticTokens(u.URI.revive(K),Z,se),null,!0)}registerCompletionItemProvider(W,K,Z,se){const G=this._addNewAdapter(new $(this._documents,this._commands.converter,Z,this._apiDeprecation,W),W);return this._proxy.$registerSuggestSupport(G,this._transformDocumentSelector(K),se,$.supportsResolving(Z),`${W.identifier.value}(${se.join("")})`),this._createDisposable(G)}$provideCompletionItems(W,K,Z,se,G){return this._withAdapter(W,$,te=>te.provideCompletionItems(u.URI.revive(K),Z,se,G),void 0)}$resolveCompletionItem(W,K,Z){return this._withAdapter(W,$,se=>se.resolveCompletionItem(K,Z),void 0)}$releaseCompletionItems(W,K){this._withAdapter(W,$,Z=>Z.releaseCompletionItems(K),void 0)}registerInlineCompletionsProvider(W,K,Z){const se=this._addNewAdapter(new J(this._documents,Z,this._commands.converter),W);return this._proxy.$registerInlineCompletionsSupport(se,this._transformDocumentSelector(K)),this._createDisposable(se)}$provideInlineCompletions(W,K,Z,se,G){return this._withAdapter(W,J,te=>te.provideInlineCompletions(u.URI.revive(K),Z,se,G),void 0)}$handleInlineCompletionDidShow(W,K,Z){this._withAdapter(W,J,async se=>{se.handleDidShowCompletionItem(K,Z)},void 0)}$freeInlineCompletionsList(W,K){this._withAdapter(W,J,async Z=>{Z.disposeCompletions(K)},void 0)}registerSignatureHelpProvider(W,K,Z,se){const G=Array.isArray(se)?{triggerCharacters:se,retriggerCharacters:[]}:se,te=this._addNewAdapter(new Q(this._documents,Z),W);return this._proxy.$registerSignatureHelpProvider(te,this._transformDocumentSelector(K),G),this._createDisposable(te)}$provideSignatureHelp(W,K,Z,se,G){return this._withAdapter(W,Q,te=>te.provideSignatureHelp(u.URI.revive(K),Z,se,G),void 0)}$releaseSignatureHelp(W,K){this._withAdapter(W,Q,Z=>Z.releaseSignatureHelp(K),void 0)}registerInlayHintsProvider(W,K,Z){const se=typeof Z.onDidChangeInlayHints=="function"?this._nextHandle():void 0,G=this._addNewAdapter(new le(this._documents,Z),W);this._proxy.$registerInlayHintsProvider(G,this._transformDocumentSelector(K),se);let te=this._createDisposable(G);if(se!==void 0){const he=Z.onDidChangeInlayHints(Pe=>this._proxy.$emitInlayHintsEvent(se));te=A.Disposable.from(te,he)}return te}$provideInlayHints(W,K,Z,se){return this._withAdapter(W,le,G=>G.provideInlayHints(u.URI.revive(K),Z,se),void 0)}registerDocumentLinkProvider(W,K,Z){const se=this._addNewAdapter(new be(this._documents,Z),W);return this._proxy.$registerDocumentLinkProvider(se,this._transformDocumentSelector(K),typeof Z.resolveDocumentLink=="function"),this._createDisposable(se)}$provideDocumentLinks(W,K,Z){return this._withAdapter(W,be,se=>se.provideLinks(u.URI.revive(K),Z),void 0)}$resolveDocumentLink(W,K,Z){return this._withAdapter(W,be,se=>se.resolveLink(K,Z),void 0)}$releaseDocumentLinks(W,K){this._withAdapter(W,be,Z=>Z.releaseLinks(K),void 0)}registerColorProvider(W,K,Z){const se=this._addNewAdapter(new de(this._documents,Z),W);return this._proxy.$registerDocumentColorProvider(se,this._transformDocumentSelector(K)),this._createDisposable(se)}$provideDocumentColors(W,K,Z){return this._withAdapter(W,de,se=>se.provideColors(u.URI.revive(K),Z),[])}$provideColorPresentations(W,K,Z,se){return this._withAdapter(W,de,G=>G.provideColorPresentations(u.URI.revive(K),Z,se),void 0)}registerFoldingRangeProvider(W,K,Z){const se=this._nextHandle(),G=typeof Z.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(se,new Ye(new Fe(this._documents,Z),W)),this._proxy.$registerFoldingRangeProvider(se,this._transformDocumentSelector(K),G);let te=this._createDisposable(se);if(G!==void 0){const he=Z.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(G));te=A.Disposable.from(te,he)}return te}$provideFoldingRanges(W,K,Z,se){return this._withAdapter(W,Fe,G=>G.provideFoldingRanges(u.URI.revive(K),Z,se),void 0)}registerSelectionRangeProvider(W,K,Z){const se=this._addNewAdapter(new Ge(this._documents,Z,this._logService),W);return this._proxy.$registerSelectionRangeProvider(se,this._transformDocumentSelector(K)),this._createDisposable(se)}$provideSelectionRanges(W,K,Z,se){return this._withAdapter(W,Ge,G=>G.provideSelectionRanges(u.URI.revive(K),Z,se),[])}registerCallHierarchyProvider(W,K,Z){const se=this._addNewAdapter(new Le(this._documents,Z),W);return this._proxy.$registerCallHierarchyProvider(se,this._transformDocumentSelector(K)),this._createDisposable(se)}$prepareCallHierarchy(W,K,Z,se){return this._withAdapter(W,Le,G=>Promise.resolve(G.prepareSession(u.URI.revive(K),Z,se)),void 0)}$provideCallHierarchyIncomingCalls(W,K,Z,se){return this._withAdapter(W,Le,G=>G.provideCallsTo(K,Z,se),void 0)}$provideCallHierarchyOutgoingCalls(W,K,Z,se){return this._withAdapter(W,Le,G=>G.provideCallsFrom(K,Z,se),void 0)}$releaseCallHierarchy(W,K){this._withAdapter(W,Le,Z=>Promise.resolve(Z.releaseSession(K)),void 0)}registerTypeHierarchyProvider(W,K,Z){const se=this._addNewAdapter(new We(this._documents,Z),W);return this._proxy.$registerTypeHierarchyProvider(se,this._transformDocumentSelector(K)),this._createDisposable(se)}$prepareTypeHierarchy(W,K,Z,se){return this._withAdapter(W,We,G=>Promise.resolve(G.prepareSession(u.URI.revive(K),Z,se)),void 0)}$provideTypeHierarchySupertypes(W,K,Z,se){return this._withAdapter(W,We,G=>G.provideSupertypes(K,Z,se),void 0)}$provideTypeHierarchySubtypes(W,K,Z,se){return this._withAdapter(W,We,G=>G.provideSubtypes(K,Z,se),void 0)}$releaseTypeHierarchy(W,K){this._withAdapter(W,We,Z=>Promise.resolve(Z.releaseSession(K)),void 0)}static _serializeRegExp(W){return{pattern:W.source,flags:(0,T.regExpFlags)(W)}}static _serializeIndentationRule(W){return{decreaseIndentPattern:Qe._serializeRegExp(W.decreaseIndentPattern),increaseIndentPattern:Qe._serializeRegExp(W.increaseIndentPattern),indentNextLinePattern:W.indentNextLinePattern?Qe._serializeRegExp(W.indentNextLinePattern):void 0,unIndentedLinePattern:W.unIndentedLinePattern?Qe._serializeRegExp(W.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(W){return{beforeText:Qe._serializeRegExp(W.beforeText),afterText:W.afterText?Qe._serializeRegExp(W.afterText):void 0,previousLineText:W.previousLineText?Qe._serializeRegExp(W.previousLineText):void 0,action:W.action}}static _serializeOnEnterRules(W){return W.map(Qe._serializeOnEnterRule)}setLanguageConfiguration(W,K,Z){let{wordPattern:se}=Z;if(se&&(0,T.regExpLeadsToEndlessLoop)(se))throw new Error(`Invalid language configuration: wordPattern '${se}' is not allowed to match the empty string.`);se?this._documents.setWordDefinitionFor(K,se):this._documents.setWordDefinitionFor(K,void 0),Z.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",W,"Do not use."),Z.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",W,"Do not use.");const G=this._nextHandle(),te={comments:Z.comments,brackets:Z.brackets,wordPattern:Z.wordPattern?Qe._serializeRegExp(Z.wordPattern):void 0,indentationRules:Z.indentationRules?Qe._serializeIndentationRule(Z.indentationRules):void 0,onEnterRules:Z.onEnterRules?Qe._serializeOnEnterRules(Z.onEnterRules):void 0,__electricCharacterSupport:Z.__electricCharacterSupport,__characterPairSupport:Z.__characterPairSupport};return this._proxy.$setLanguageConfiguration(G,K,te),this._createDisposable(G)}$setWordDefinitions(W){for(const K of W)this._documents.setWordDefinitionFor(K.languageId,new RegExp(K.regexSource,K.regexFlags))}}e.ExtHostLanguageFeatures=Qe,Qe._handlePool=0}),define(we[195],Ee([0,1,5,8,7,35,14,6]),function(re,e,u,M,w,A,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class C{constructor(F,_,n,g){this._documents=_,this._commands=n,this._uriTransformer=g,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=F.getProxy(u.MainContext.MainThreadLanguages)}$acceptLanguageIds(F){this._languageIds=F}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(F,_){await this._proxy.$changeLanguage(F,_);const n=this._documents.getDocumentData(F);if(!n)throw new Error(`document '${F.toString}' NOT found`);return n.document}async tokenAtPosition(F,_){const n=F.version,g=M.Position.from(_),a=await this._proxy.$tokensAtPosition(F.uri,g),c={type:w.StandardTokenType.Other,range:F.getWordRangeAtPosition(_)??new w.Range(_.line,_.character,_.line,_.character)};if(!a)return c;const p={range:M.Range.to(a.range),type:M.TokenType.to(a.type)};return!p.range.contains(_)||n!==F.version?c:p}createLanguageStatusItem(F,_,n){const g=this._handlePool++,a=this._proxy,c=this._ids,p=`${F.identifier.value}/${_}`;if(c.has(p))throw new Error(`LanguageStatusItem with id '${_}' ALREADY exists`);c.add(p);const D={selector:n,id:_,name:F.displayName??F.name,severity:w.LanguageStatusSeverity.Information,command:void 0,text:"",detail:""};let f,l=new T.DisposableStore;const h=()=>{f?.dispose(),f=(0,t.disposableTimeout)(()=>{l.clear(),this._proxy.$setLanguageStatus(g,{id:p,name:D.name??F.displayName??F.name,source:F.displayName??F.name,selector:M.DocumentSelector.from(D.selector,this._uriTransformer),label:D.text,detail:D.detail??"",severity:D.severity===w.LanguageStatusSeverity.Error?A.default.Error:D.severity===w.LanguageStatusSeverity.Warning?A.default.Warning:A.default.Info,command:D.command&&this._commands.toInternal(D.command,l),accessibilityInfo:D.accessibilityInformation})},0)},y={dispose(){l.dispose(),f?.dispose(),a.$removeLanguageStatus(g),c.delete(p)},get id(){return D.id},get name(){return D.name},set name(s){D.name=s,h()},get selector(){return D.selector},set selector(s){D.selector=s,h()},get text(){return D.text},set text(s){D.text=s,h()},get detail(){return D.detail},set detail(s){D.detail=s,h()},get severity(){return D.severity},set severity(s){D.severity=s,h()},get accessibilityInformation(){return D.accessibilityInformation},set accessibilityInformation(s){D.accessibilityInformation=s,h()},get command(){return D.command},set command(s){D.command=s,h()}};return h(),y}}e.ExtHostLanguages=C}),define(we[196],Ee([0,1,12,5,28,13,3]),function(re,e,u,M,w,A,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let T=class extends u.AbstractLoggerService{constructor(F,_){const n=new t.Emitter;super(_.logLevel,n.event);this._proxy=F.getProxy(M.MainContext.MainThreadLogger),this._onDidChangeLogLevel=this._register(n)}$setLevel(F){this._onDidChangeLogLevel.fire(F)}doCreateLogger(F,_,n){return new C(this._proxy,F,_,n)}};T=Ne([xe(0,A.IExtHostRpcService),xe(1,w.IExtHostInitDataService)],T),e.ExtHostLoggerService=T;class C extends u.AbstractMessageLogger{constructor(F,_,n,g){super(g?.always);this.proxy=F,this.file=_,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(n),this.proxy.$createLogger(_,g).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(F,_){const n=[[F,_]];this.isLoggerCreated?this.doLog(n):this.buffer.push(...n)}doLog(F){this.proxy.$log(this.file,F)}}}),define(we[197],Ee([0,1,5,12,27]),function(re,e,u,M,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function A(T){return T&&T.title}let t=class{constructor(C,k){this._logService=k,this._proxy=C.getProxy(u.MainContext.MainThreadMessageService)}showMessage(C,k,F,_,n){const g={extension:C};let a;typeof _=="string"||A(_)?a=[_,...n]:(g.modal=_?.modal,g.useCustom=_?.useCustom,g.detail=_?.detail,a=n),g.useCustom&&(0,w.checkProposedApiEnabled)(C,"resolvers");const c=[];for(let p=0;p<a.length;p++){const D=a[p];if(typeof D=="string")c.push({title:D,handle:p,isCloseAffordance:!1});else if(typeof D=="object"){let{title:f,isCloseAffordance:l}=D;c.push({title:f,isCloseAffordance:!!l,handle:p})}else this._logService.warn("Invalid message item:",D)}return this._proxy.$showMessage(k,F,g,c).then(p=>{if(typeof p=="number")return a[p]})}};t=Ne([xe(1,M.ILogService)],t),e.ExtHostMessageService=t}),define(we[198],Ee([0,1,22,3,58,6,21,9,10,2,64,5,8,7,37,171,92]),function(re,e,u,M,w,A,t,T,C,k,F,_,n,g,a,c,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class D{constructor(l,h,y,s,I){this._textDocumentsAndEditors=y,this._textDocuments=s,this._extensionStoragePaths=I,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new t.ResourceMap,this._editors=new Map,this._onDidChangeNotebookCells=new M.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new M.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new M.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new M.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new M.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new M.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new M.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new M.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new F.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=l.getProxy(_.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=l.getProxy(_.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=l.getProxy(_.MainContext.MainThreadNotebookEditors),this._commandsConverter=h.converter,h.registerArgumentProcessor({processArgument:r=>{if(r&&r.$mid===12){const i=r.notebookEditor?.notebookUri,v=r.cell.handle,o=this._documents.get(i)?.getCell(v);if(o)return o.apiCell}return r}})}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(l=>l.apiEditor)}getEditorById(l){const h=this._editors.get(l);if(!h)throw new Error(`unknown text editor: ${l}. known editors: ${[...this._editors.keys()]} `);return h}getIdByEditor(l){for(const[h,y]of this._editors)if(y.apiEditor===l)return h}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(l,h){const y=this._documents.get(l);if(!y&&!h)throw new Error(`NO notebook document for '${l}'`);return y}_getProviderData(l){const h=this._notebookContentProviders.get(l);if(!h)throw new Error(`NO provider for '${l}'`);return h}registerNotebookContentProvider(l,h,y,s,I){if((0,T.isFalsyOrWhitespace)(h))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(h))throw new Error(`Notebook provider for '${h}' already registered`);this._notebookContentProviders.set(h,{extension:l,provider:y});let r;return y.onDidChangeNotebookContentOptions&&(r=y.onDidChangeNotebookContentOptions(()=>{const i=n.NotebookDocumentContentOptions.from(y.options);this._notebookProxy.$updateNotebookProviderOptions(h,i)})),this._notebookProxy.$registerNotebookProvider({id:l.identifier,location:l.extensionLocation},h,n.NotebookDocumentContentOptions.from(s),D._convertNotebookRegistrationData(l,I)),new g.Disposable(()=>{r?.dispose(),this._notebookContentProviders.delete(h),this._notebookProxy.$unregisterNotebookProvider(h)})}static _convertNotebookRegistrationData(l,h){if(!h)return;const y=h.filenamePattern.map(s=>n.NotebookExclusiveDocumentPattern.from(s)).filter(s=>s!==void 0);if(h.filenamePattern&&!y){console.warn(`Notebook content provider view options file name pattern is invalid ${h.filenamePattern}`);return}return{extension:l.identifier,providerDisplayName:l.displayName||l.name,displayName:h.displayName,filenamePattern:y,exclusive:h.exclusive||!1}}registerNotebookCellStatusBarItemProvider(l,h,y){const s=D._notebookStatusBarItemProviderHandlePool++,I=typeof y.onDidChangeCellStatusBarItems=="function"?D._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(s,y),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(s,I,h);let r;return I!==void 0&&(r=y.onDidChangeCellStatusBarItems(i=>this._notebookProxy.$emitCellStatusBarEvent(I))),new g.Disposable(()=>{this._notebookStatusBarItemProviders.delete(s),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(s,I),r&&r.dispose()})}async createNotebookDocument(l){const h=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:l.viewType,content:l.content&&n.NotebookData.from(l.content)});return k.URI.revive(h)}async openNotebookDocument(l){const h=this._documents.get(l);if(h)return h.apiNotebook;const y=await this._notebookDocumentsProxy.$tryOpenNotebook(l),s=this._documents.get(k.URI.revive(y));return(0,C.assertIsDefined)(s?.apiNotebook)}async showNotebookDocument(l,h){k.URI.isUri(l)&&(l=await this.openNotebookDocument(l));let y;typeof h=="object"?y={position:n.ViewColumn.from(h.viewColumn),preserveFocus:h.preserveFocus,selections:h.selections&&h.selections.map(n.NotebookRange.from),pinned:typeof h.preview=="boolean"?!h.preview:void 0}:y={preserveFocus:!1};const s=await this._notebookEditorsProxy.$tryShowNotebookDocument(l.uri,l.notebookType,y),I=s&&this._editors.get(s)?.apiEditor;if(I)return I;throw s?new Error(`Could NOT open editor for "${l.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${l.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(l,h,y,s){const I=this._notebookStatusBarItemProviders.get(l),r=k.URI.revive(h),i=this._documents.get(r);if(!i||!I)return;const v=i.getCellFromIndex(y);if(!v)return;const m=await I.provideCellStatusBarItems(v.apiCell,s);if(!m)return;const o=new A.DisposableStore,b=this._statusBarCache.add([o]),E=(Array.isArray(m)?m:[m]).map(R=>n.NotebookStatusBarItem.from(R,this._commandsConverter,o));return{cacheId:b,items:E}}$releaseNotebookCellStatusBarItems(l){this._statusBarCache.delete(l)}registerNotebookSerializer(l,h,y,s,I){if((0,T.isFalsyOrWhitespace)(h))throw new Error("viewType cannot be empty or just whitespace");const r=this._handlePool++;return this._notebookSerializer.set(r,y),this._notebookProxy.$registerNotebookSerializer(r,{id:l.identifier,location:l.extensionLocation},h,n.NotebookDocumentContentOptions.from(s),D._convertNotebookRegistrationData(l,I)),(0,A.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(r)})}async $dataToNotebook(l,h,y){const s=this._notebookSerializer.get(l);if(!s)throw new Error("NO serializer found");const I=await s.deserializeNotebook(h.buffer,y);return new a.SerializableObjectWithBuffers(n.NotebookData.from(I))}async $notebookToData(l,h,y){const s=this._notebookSerializer.get(l);if(!s)throw new Error("NO serializer found");const I=await s.serializeNotebook(n.NotebookData.to(h.value),y);return u.VSBuffer.wrap(I)}async $openNotebook(l,h,y,s,I){const{provider:r}=this._getProviderData(l),i=await r.openNotebook(k.URI.revive(h),{backupId:y,untitledDocumentData:s?.buffer},I);return new a.SerializableObjectWithBuffers({metadata:i.metadata??Object.create(null),cells:i.cells.map(n.NotebookCellData.from)})}async $saveNotebook(l,h,y){const s=this.getNotebookDocument(k.URI.revive(h)),{provider:I}=this._getProviderData(l);return await I.saveNotebook(s.apiNotebook,y),!0}async $saveNotebookAs(l,h,y,s){const I=this.getNotebookDocument(k.URI.revive(h)),{provider:r}=this._getProviderData(l);return await r.saveNotebookAs(k.URI.revive(y),I.apiNotebook,s),!0}async $backupNotebook(l,h,y){const s=this.getNotebookDocument(k.URI.revive(h)),I=this._getProviderData(l),r=this._extensionStoragePaths.workspaceValue(I.extension)??this._extensionStoragePaths.globalValue(I.extension),i=String((0,w.hash)([s.uri.toString(),this._backupIdPool++])),v=k.URI.joinPath(r,i),m=await I.provider.backupNotebook(s.apiNotebook,{destination:v},y);return s.updateBackup(m),m.id}_createExtHostEditor(l,h,y){if(this._editors.has(h))throw new Error(`editor with id ALREADY EXSIST: ${h}`);const s=new p.ExtHostNotebookEditor(h,this._notebookEditorsProxy,l,y.visibleRanges.map(n.NotebookRange.to),y.selections.map(n.NotebookRange.to),typeof y.viewColumn=="number"?n.ViewColumn.to(y.viewColumn):void 0);this._editors.set(h,s)}$acceptDocumentAndEditorsDelta(l){if(l.value.removedDocuments)for(const y of l.value.removedDocuments){const s=k.URI.revive(y),I=this._documents.get(s);I&&(I.dispose(),this._documents.delete(s),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:I.apiNotebook.getCells().map(r=>r.document.uri)}),this._onDidCloseNotebookDocument.fire(I.apiNotebook));for(const r of this._editors.values())r.notebookData.uri.toString()===s.toString()&&this._editors.delete(r.id)}if(l.value.addedDocuments){const y=[];for(const s of l.value.addedDocuments){const I=k.URI.revive(s.uri);if(this._documents.has(I))throw new Error(`adding EXISTING notebook ${I} `);const r=this,i=new c.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(v){r._onDidChangeNotebookCells.fire(v)},emitCellOutputsChange(v){r._onDidChangeCellOutputs.fire(v)},emitCellMetadataChange(v){r._onDidChangeCellMetadata.fire(v)},emitCellExecutionStateChange(v){r._onDidChangeCellExecutionState.fire(v)}},I,s);y.push(...s.cells.map(v=>c.ExtHostCell.asModelAddData(i.apiNotebook,v))),this._documents.get(I)?.dispose(),this._documents.set(I,i),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:y}),this._onDidOpenNotebookDocument.fire(i.apiNotebook)}}if(l.value.addedEditors)for(const y of l.value.addedEditors){if(this._editors.has(y.id))return;const s=k.URI.revive(y.documentUri),I=this._documents.get(s);I&&this._createExtHostEditor(I,y.id,y)}const h=[];if(l.value.removedEditors)for(const y of l.value.removedEditors){const s=this._editors.get(y);s&&(this._editors.delete(y),this._activeNotebookEditor?.id===s.id&&(this._activeNotebookEditor=void 0),h.push(s))}if(l.value.visibleEditors){this._visibleNotebookEditors=l.value.visibleEditors.map(s=>this._editors.get(s)).filter(s=>!!s);const y=new Set;this._visibleNotebookEditors.forEach(s=>y.add(s.id));for(const s of this._editors.values()){const I=y.has(s.id);s._acceptVisibility(I)}this._visibleNotebookEditors=[...this._editors.values()].map(s=>s).filter(s=>s.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}l.value.newActiveEditor===null?this._activeNotebookEditor=void 0:l.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(l.value.newActiveEditor)),l.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}}e.ExtHostNotebookController=D,D._notebookStatusBarItemProviderHandlePool=0}),define(we[199],Ee([0,1,3,53,12,5,13,8]),function(re,e,u,M,w,A,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class C{constructor(_,n){const g=C._Keys.nextId();_.$registerNotebookEditorDecorationType(g,T.NotebookDecorationRenderOptions.from(n)),this.value={key:g,dispose(){_.$removeNotebookEditorDecorationType(g)}}}}C._Keys=new M.IdGenerator("NotebookEditorDecorationType");let k=class{constructor(_,n,g){this._logService=_,this._extHostRpc=n,this._notebooksAndEditors=g,this._onDidChangeNotebookEditorSelection=new u.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new u.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(_){return new C(this._extHostRpc.getProxy(A.MainContext.MainThreadNotebookEditors),_).value}$acceptEditorPropertiesChanged(_,n){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",_,n);const g=this._notebooksAndEditors.getEditorById(_);n.visibleRanges&&g._acceptVisibleRanges(n.visibleRanges.ranges.map(T.NotebookRange.to)),n.selections&&g._acceptSelections(n.selections.selections.map(T.NotebookRange.to)),n.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:g.apiEditor,visibleRanges:g.apiEditor.visibleRanges}),n.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:g.apiEditor,selections:g.apiEditor.selections}))}$acceptEditorViewColumns(_){for(const n in _)this._notebooksAndEditors.getEditorById(n)._acceptViewColumn(T.ViewColumn.to(_[n]))}};k=Ne([xe(0,w.ILogService),xe(1,t.IExtHostRpcService)],k),e.ExtHostNotebookEditors=k}),define(we[200],Ee([0,1,16,14,20,3,6,21,2,26,12,5,38,8,7,67,163,27,37]),function(re,e,u,M,w,A,t,T,C,k,F,_,n,g,a,c,p,D,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let l=class{constructor(r,i,v,m,o){this._initData=i,this._extHostNotebook=v,this._commands=m,this._logService=o,this._activeExecutions=new T.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._proxy=r.getProxy(_.MainContext.MainThreadNotebookKernels);const b=new n.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new n.ApiCommandArgument("options","Select kernel options",d=>!0,d=>{if(d&&"notebookEditor"in d&&"id"in d){const E=this._extHostNotebook.getIdByEditor(d.notebookEditor);return{id:d.id,extension:d.extension,notebookEditorId:E}}else if(d&&"notebookEditor"in d){const E=this._extHostNotebook.getIdByEditor(d.notebookEditor);if(E===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${d.notebookEditor.document.uri.toString()}`);return{notebookEditorId:E}}return d})],n.ApiCommandResult.Void);this._commands.registerApiCommand(b)}createNotebookController(r,i,v,m,o,b){for(let Q of this._kernelData.values())if(Q.controller.id===i&&k.ExtensionIdentifier.equals(r.identifier,Q.extensionId))throw new Error(`notebook controller with id '${i}' ALREADY exist`);const d=this._handlePool++,E=this;this._logService.trace(`NotebookController[${d}], CREATED by ${r.identifier.value}, ${i}`);const R=()=>console.warn(`NO execute handler from notebook controller '${x.id}' of extension: '${r.identifier}'`);let P=!1;const z=new t.DisposableStore,O=new A.Emitter,S=new A.Emitter,x={id:`${r.identifier.value}/${i}`,notebookType:v,extensionId:r.identifier,extensionLocation:r.extensionLocation,label:m||r.identifier.value,preloads:b?b.map(g.NotebookRendererScript.from):[]};let N=o??R,V;this._proxy.$addKernel(d,x).catch(Q=>{console.log(Q),P=!0});let B=0;const $=()=>{if(P)return;const Q=++B;Promise.resolve().then(()=>{Q===B&&this._proxy.$updateKernel(d,x)})},J=new T.ResourceMap,j={get id(){return i},get notebookType(){return x.notebookType},onDidChangeSelectedNotebooks:O.event,get label(){return x.label},set label(Q){x.label=Q??r.displayName??r.name,$()},get detail(){return x.detail??""},set detail(Q){x.detail=Q,$()},get description(){return x.description??""},set description(Q){x.description=Q,$()},get kind(){return(0,D.checkProposedApiEnabled)(r,"notebookControllerKind"),x.kind??""},set kind(Q){(0,D.checkProposedApiEnabled)(r,"notebookControllerKind"),x.kind=Q,$()},get supportedLanguages(){return x.supportedLanguages},set supportedLanguages(Q){x.supportedLanguages=Q,$()},get supportsExecutionOrder(){return x.supportsExecutionOrder??!1},set supportsExecutionOrder(Q){x.supportsExecutionOrder=Q,$()},get rendererScripts(){return x.preloads?x.preloads.map(g.NotebookRendererScript.to):[]},get executeHandler(){return N},set executeHandler(Q){N=Q??R},get interruptHandler(){return V},set interruptHandler(Q){V=Q,x.supportsInterrupt=Boolean(Q),$()},createNotebookCellExecution(Q){if(P)throw new Error("notebook controller is DISPOSED");if(!J.has(Q.notebook.uri))throw E._logService.trace(`NotebookController[${d}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(J.keys()).map(le=>le.toString())),new Error(`notebook controller is NOT associated to notebook: ${Q.notebook.uri.toString()}`);return E._createNotebookCellExecution(Q)},dispose:()=>{P||(this._logService.trace(`NotebookController[${d}], DISPOSED`),P=!0,this._kernelData.delete(d),z.dispose(),O.dispose(),S.dispose(),this._proxy.$removeKernel(d))},updateNotebookAffinity(Q,le){E._proxy.$updateNotebookPriority(d,Q.uri,le)},onDidReceiveMessage:S.event,postMessage(Q,le){return(0,D.checkProposedApiEnabled)(r,"notebookMessaging"),E._proxy.$postMessage(d,le&&E._extHostNotebook.getIdByEditor(le),Q)},asWebviewUri(Q){return(0,D.checkProposedApiEnabled)(r,"notebookMessaging"),(0,c.asWebviewUri)(Q,E._initData.remote)}};return this._kernelData.set(d,{extensionId:r.identifier,controller:j,onDidReceiveMessage:S,onDidChangeSelection:O,associatedNotebooks:J}),j}$acceptNotebookAssociation(r,i,v){const m=this._kernelData.get(r);if(m){const o=this._extHostNotebook.getNotebookDocument(C.URI.revive(i));v?m.associatedNotebooks.set(o.uri,!0):m.associatedNotebooks.delete(o.uri),this._logService.trace(`NotebookController[${r}] ASSOCIATE notebook`,o.uri.toString(),v),m.onDidChangeSelection.fire({selected:v,notebook:o.apiNotebook})}}async $executeCells(r,i,v){const m=this._kernelData.get(r);if(!m)return;const o=this._extHostNotebook.getNotebookDocument(C.URI.revive(i)),b=[];for(let d of v){const E=o.getCell(d);E&&b.push(E.apiCell)}try{this._logService.trace(`NotebookController[${r}] EXECUTE cells`,o.uri.toString(),b.length),await m.controller.executeHandler.call(m.controller,b,o.apiNotebook,m.controller)}catch(d){this._logService.error(`NotebookController[${r}] execute cells FAILED`,d),console.error(d)}}async $cancelCells(r,i,v){const m=this._kernelData.get(r);if(!m)return;const o=this._extHostNotebook.getNotebookDocument(C.URI.revive(i));if(m.controller.interruptHandler)await m.controller.interruptHandler.call(m.controller,o.apiNotebook);else for(let b of v){const d=o.getCell(b);d&&this._activeExecutions.get(d.uri)?.cancel()}}$acceptKernelMessageFromRenderer(r,i,v){const m=this._kernelData.get(r);if(!m)return;const o=this._extHostNotebook.getEditorById(i);m.onDidReceiveMessage.fire(Object.freeze({editor:o.apiEditor,message:v}))}_createNotebookCellExecution(r){if(r.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const v=this._extHostNotebook.getNotebookDocument(r.notebook.uri).getCellFromApiCell(r);if(!v)throw new Error("invalid cell");if(this._activeExecutions.has(v.uri))throw new Error(`duplicate execution for ${v.uri}`);const m=new y(v.notebook,v,this._proxy);this._activeExecutions.set(v.uri,m);const o=m.onDidChangeState(()=>{m.state===h.Resolved&&(m.dispose(),o.dispose(),this._activeExecutions.delete(v.uri))});return m.asApiObject()}};l=Ne([xe(4,F.ILogService)],l),e.ExtHostNotebookKernels=l;var h;(function(I){I[I.Init=0]="Init",I[I.Started=1]="Started",I[I.Resolved=2]="Resolved"})(h||(h={}));class y extends t.Disposable{constructor(r,i,v){super();this._document=r,this._cell=i,this._proxy=v,this._handle=y.HANDLE++,this._onDidChangeState=new A.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=h.Init,this._tokenSource=this._register(new w.CancellationTokenSource),this._collector=new s(10,m=>this.update(m)),this._executionOrder=i.internalMetadata.executionOrder,this._proxy.$addExecution(this._handle,this._cell.notebook.uri,this._cell.handle)}get state(){return this._state}cancel(){this._tokenSource.cancel()}async updateSoon(r){await this._collector.addItem(r)}async update(r){const i=Array.isArray(r)?r:[r];return this._proxy.$updateExecutions(new f.SerializableObjectWithBuffers(i))}verifyStateForOutput(){if(this._state===h.Init)throw new Error("Must call start before modifying cell output");if(this._state===h.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(r){let i=this._cell;if(r&&(i=this._document.getCellFromApiCell(r)),!i)throw new Error("INVALID cell");return i.handle}validateAndConvertOutputs(r){return r.map(i=>{const v=a.NotebookCellOutput.ensureUniqueMimeTypes(i.items,!0);return v===i.items?g.NotebookCellOutput.from(i):g.NotebookCellOutput.from({items:v,id:i.id,metadata:i.metadata})})}async updateOutputs(r,i,v){const m=this.cellIndexToHandle(i),o=this.validateAndConvertOutputs((0,u.asArray)(r));return this.updateSoon({editType:p.CellExecutionUpdateType.Output,executionHandle:this._handle,cellHandle:m,append:v,outputs:o})}async updateOutputItems(r,i,v){return r=a.NotebookCellOutput.ensureUniqueMimeTypes((0,u.asArray)(r),!0),this.updateSoon({editType:p.CellExecutionUpdateType.OutputItems,executionHandle:this._handle,items:r.map(g.NotebookCellOutputItem.from),outputId:i.id,append:v})}asApiObject(){const r=this;return Object.freeze({get token(){return r._tokenSource.token},get cell(){return r._cell.apiCell},get executionOrder(){return r._executionOrder},set executionOrder(v){r._executionOrder=v,r.update([{editType:p.CellExecutionUpdateType.ExecutionState,executionHandle:r._handle,executionOrder:r._executionOrder}])},start(v){if(r._state===h.Resolved||r._state===h.Started)throw new Error("Cannot call start again");r._state=h.Started,r._onDidChangeState.fire(),r.update({editType:p.CellExecutionUpdateType.ExecutionState,executionHandle:r._handle,runStartTime:v})},end(v,m){if(r._state===h.Resolved)throw new Error("Cannot call resolve twice");r._state=h.Resolved,r._onDidChangeState.fire(),r.updateSoon({editType:p.CellExecutionUpdateType.Complete,executionHandle:r._handle,runEndTime:m,lastRunSuccess:v}),r._collector.flush(),r._proxy.$removeExecution(r._handle)},clearOutput(v){return r.verifyStateForOutput(),r.updateOutputs([],v,!1)},appendOutput(v,m){return r.verifyStateForOutput(),r.updateOutputs(v,m,!0)},replaceOutput(v,m){return r.verifyStateForOutput(),r.updateOutputs(v,m,!1)},appendOutputItems(v,m){return r.verifyStateForOutput(),r.updateOutputItems(v,m,!0)},replaceOutputItems(v,m){return r.verifyStateForOutput(),r.updateOutputItems(v,m,!1)}})}}y.HANDLE=0;class s{constructor(r,i){this.delay=r,this.callback=i,this.batch=[],this.startedTimer=Date.now()}addItem(r){return this.batch.push(r),this.currentDeferred||(this.currentDeferred=new M.DeferredPromise,this.startedTimer=Date.now(),(0,M.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const r=this.currentDeferred;this.currentDeferred=void 0;const i=this.batch;return this.batch=[],this.callback(i).finally(()=>r.complete())}}}),define(we[201],Ee([0,1,3,5,92,27]),function(re,e,u,M,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class t{constructor(C,k){this._extHostNotebook=k,this._rendererMessageEmitters=new Map,this.proxy=C.getProxy(M.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(C,k,F){const _=this._extHostNotebook.getEditorById(C);this._rendererMessageEmitters.get(k)?.fire({editor:_.apiEditor,message:F})}createRendererMessaging(C,k){if(!C.contributes?.notebookRenderer?.some(g=>g.id===k))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${k})`);const F=(0,A.isProposedApiEnabled)(C,"notebookEditor"),_=new WeakMap;return{onDidReceiveMessage:(g,a,c)=>{const p=F?g:D=>{const f={};_.set(f,D.editor),g({editor:f,message:D.message})};return this.getOrCreateEmitterFor(k).event(p,a,c)},postMessage:(g,a)=>{w.ExtHostNotebookEditor.apiEditorsToExtHost.has(g)&&([g,a]=[a,g]);const c=F?a:_.get(a),p=c&&w.ExtHostNotebookEditor.apiEditorsToExtHost.get(c);return this.proxy.$postMessage(p?.id,k,g)}}}getOrCreateEmitterFor(C){let k=this._rendererMessageEmitters.get(C);return k||(k=new u.Emitter({onLastListenerRemove:()=>{k?.dispose(),this._rendererMessageEmitters.delete(C)}}),this._rendererMessageEmitters.set(C,k),k)}}e.ExtHostNotebookRenderers=t}),define(we[95],Ee([0,1,5,6,4,13,12,164,50,28,31,114,22]),function(re,e,u,M,w,A,t,T,C,k,F,_,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.ExtHostOutputChannel=void 0;class g extends M.Disposable{constructor(p,D,f,l){super();this.id=p,this.name=D,this.logger=f,this.proxy=l,this.offset=0,this.visible=!1,this._disposed=!1}get disposed(){return this._disposed}appendLine(p){this.append(p+`
`)}append(p){this.write(p),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,T.OutputChannelUpdateMode.Append))}clear(){const p=this.offset;this.logger.flush(),this.proxy.$update(this.id,T.OutputChannelUpdateMode.Clear,p)}replace(p){const D=this.offset;this.write(p),this.proxy.$update(this.id,T.OutputChannelUpdateMode.Replace,D),this.visible&&this.logger.flush()}show(p,D){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof p=="boolean"?p:D))}hide(){this.proxy.$close(this.id)}write(p){this.offset+=n.VSBuffer.fromString(p).byteLength,this.logger.info(p)}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}e.ExtHostOutputChannel=g;let a=class{constructor(p,D,f,l,h){this.extHostFileSystem=f,this.extHostFileSystemInfo=l,this.loggerService=h,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=p.getProxy(u.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(D.logsLocation,`output_logging_${(0,_.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(p){this.visibleChannelId=p;for(const[D,f]of this.channels)f.visible=D===this.visibleChannelId}createOutputChannel(p,D){if(p=p.trim(),!p)throw new Error("illegal argument `name`. must not be falsy");const f=this.doCreateOutputChannel(p,D);return f.then(l=>{this.channels.set(l.id,l),l.visible=l.id===this.visibleChannelId}),this.createExtHostOutputChannel(p,f)}async doCreateOutputChannel(p,D){const f=await this.createOutputDirectory(),l=this.extHostFileSystemInfo.extUri.joinPath(f,`${this.namePool++}-${p.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),h=this.loggerService.createLogger(l,{always:!0,donotRotate:!0,donotUseFormatters:!0}),y=await this.proxy.$register(p,!1,l,D.identifier.value);return new g(y,p,h,this.proxy)}createOutputDirectory(){return this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation)),this.outputDirectoryPromise}createExtHostOutputChannel(p,D){let f=!1;const l=()=>{if(f)throw new Error("Channel has been closed")};return{get name(){return p},append(h){l(),D.then(y=>y.append(h))},appendLine(h){l(),D.then(y=>y.appendLine(h))},clear(){l(),D.then(h=>h.clear())},replace(h){l(),D.then(y=>y.replace(h))},show(h,y){l(),D.then(s=>s.show(h,y))},hide(){l(),D.then(h=>h.hide())},dispose(){f=!0,D.then(h=>h.dispose())}}}};a=Ne([xe(0,A.IExtHostRpcService),xe(1,k.IExtHostInitDataService),xe(2,C.IExtHostConsumerFileSystem),xe(3,F.IExtHostFileSystemInfo),xe(4,t.ILoggerService)],a),e.ExtHostOutputService=a,e.IExtHostOutputService=(0,w.createDecorator)("IExtHostOutputService")}),define(we[202],Ee([0,1,14,20,3,6,5,2,7,15,16,35,63,27]),function(re,e,u,M,w,A,t,T,C,k,F,_,n,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function a(c,p,D){const f=c.getProxy(t.MainContext.MainThreadQuickOpen);class l{constructor(o,b){this._sessions=new Map,this._instances=0,this._workspace=o,this._commands=b}showQuickPick(o,b,d=M.CancellationToken.None){this._onDidSelectItem=void 0;const E=Promise.resolve(o),R=++this._instances,P=f.$show(R,{title:b?.title,placeHolder:b?.placeHolder,matchOnDescription:b?.matchOnDescription,matchOnDetail:b?.matchOnDetail,ignoreFocusLost:b?.ignoreFocusOut,canPickMany:b?.canPickMany},d),z={},O=P.then(()=>z);return Promise.race([O,E]).then(S=>{if(S!==z)return E.then(x=>{const N=[];for(let V=0;V<x.length;V++){const B=x[V];typeof B=="string"?N.push({label:B,handle:V}):B.kind===C.QuickPickItemKind.Separator?N.push({type:"separator",label:B.label}):N.push({label:B.label,description:B.description,detail:B.detail,picked:B.picked,alwaysShow:B.alwaysShow,handle:V})}return b&&typeof b.onDidSelectItem=="function"&&(this._onDidSelectItem=V=>{b.onDidSelectItem(x[V])}),f.$setItems(R,N),P.then(V=>{if(typeof V=="number")return x[V];if(Array.isArray(V))return V.map(B=>x[B])})})}).then(void 0,S=>{if(!(0,k.isPromiseCanceledError)(S))return f.$setError(R,S),Promise.reject(S)})}$onItemSelected(o){this._onDidSelectItem&&this._onDidSelectItem(o)}showInput(o,b=M.CancellationToken.None){return this._validateInput=o?o.validateInput:void 0,f.$input(o,typeof this._validateInput=="function",b).then(void 0,d=>{if(!(0,k.isPromiseCanceledError)(d))return Promise.reject(d)})}$validateInput(o){return this._validateInput?(0,u.asPromise)(()=>this._validateInput(o)):Promise.resolve(void 0)}async showWorkspaceFolderPick(o,b=M.CancellationToken.None){const d=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[o]);if(!d)return;const E=await this._workspace.getWorkspaceFolders2();if(!!E)return E.find(R=>R.uri.toString()===d.uri.toString())}createQuickPick(o){const b=new i(o,()=>this._sessions.delete(b._id));return this._sessions.set(b._id,b),b}createInputBox(o){const b=new v(o,()=>this._sessions.delete(b._id));return this._sessions.set(b._id,b),b}$onDidChangeValue(o,b){const d=this._sessions.get(o);d&&d._fireDidChangeValue(b)}$onDidAccept(o){const b=this._sessions.get(o);b&&b._fireDidAccept()}$onDidChangeActive(o,b){const d=this._sessions.get(o);d instanceof i&&d._fireDidChangeActive(b)}$onDidChangeSelection(o,b){const d=this._sessions.get(o);d instanceof i&&d._fireDidChangeSelection(b)}$onDidTriggerButton(o,b){const d=this._sessions.get(o);d&&d._fireDidTriggerButton(b)}$onDidTriggerItemButton(o,b,d){const E=this._sessions.get(o);E instanceof i&&E._fireDidTriggerItemButton(b,d)}$onDidHide(o){const b=this._sessions.get(o);b&&b._fireDidHide()}}class h{constructor(o,b){this._extensionId=o,this._onDidDispose=b,this._id=i._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new w.Emitter,this._onDidChangeValueEmitter=new w.Emitter,this._onDidTriggerButtonEmitter=new w.Emitter,this._onDidHideEmitter=new w.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(o){this._title=o,this.update({title:o})}get step(){return this._steps}set step(o){this._steps=o,this.update({step:o})}get totalSteps(){return this._totalSteps}set totalSteps(o){this._totalSteps=o,this.update({totalSteps:o})}get enabled(){return this._enabled}set enabled(o){this._enabled=o,this.update({enabled:o})}get busy(){return this._busy}set busy(o){this._busy=o,this.update({busy:o})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(o){this._ignoreFocusOut=o,this.update({ignoreFocusOut:o})}get value(){return this._value}set value(o){this._value=o,this.update({value:o})}get placeholder(){return this._placeholder}set placeholder(o){this._placeholder=o,this.update({placeholder:o})}get buttons(){return this._buttons}set buttons(o){this._buttons=o.slice(),this._handlesToButtons.clear(),o.forEach((b,d)=>{const E=b===C.QuickInputButtons.Back?-1:d;this._handlesToButtons.set(E,b)}),this.update({buttons:o.map((b,d)=>({...r(b),tooltip:b.tooltip,handle:b===C.QuickInputButtons.Back?-1:d}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(o){this._value=o,this._onDidChangeValueEmitter.fire(o)}_fireDidTriggerButton(o){const b=this._handlesToButtons.get(o);b&&this._onDidTriggerButtonEmitter.fire(b)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,A.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),f.$dispose(this._id))}update(o){if(!this._disposed){for(const b of Object.keys(o)){const d=o[b];this._pendingUpdate[b]=d===void 0?null:d}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){f.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}h._nextId=1;function y(m){if(m instanceof C.ThemeIcon)return{id:m.id};const o=I(m),b=s(m);return{dark:typeof o=="string"?T.URI.file(o):o,light:typeof b=="string"?T.URI.file(b):b}}function s(m){return typeof m=="object"&&"light"in m?m.light:m}function I(m){return typeof m=="object"&&"dark"in m?m.dark:m}function r(m){const o=y(m.iconPath);let b,d;return"id"in o?d=n.ThemeIcon.asClassName(o):b=o,{iconPath:b,iconClass:d}}class i extends h{constructor(o,b){super(o.identifier,b);this.extension=o,this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new w.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new w.Emitter,this._onDidTriggerItemButtonEmitter=new w.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(o){o.some(d=>d.kind!==void 0)&&(0,g.checkProposedApiEnabled)(this.extension,"quickPickSeparators"),this._items=o.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),o.forEach((d,E)=>{this._handlesToItems.set(E,d),this._itemsToHandles.set(d,E)});const b=[];for(let d=0;d<o.length;d++){const E=o[d];E.kind===C.QuickPickItemKind.Separator?b.push({type:"separator",label:E.label}):b.push({handle:d,label:E.label,description:E.description,detail:E.detail,picked:E.picked,alwaysShow:E.alwaysShow,buttons:E.buttons?.map((R,P)=>({...r(R),tooltip:R.tooltip,handle:P}))})}this.update({items:b})}get canSelectMany(){return this._canSelectMany}set canSelectMany(o){this._canSelectMany=o,this.update({canSelectMany:o})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(o){this._matchOnDescription=o,this.update({matchOnDescription:o})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(o){this._matchOnDetail=o,this.update({matchOnDetail:o})}get sortByLabel(){return this._sortByLabel}set sortByLabel(o){this._sortByLabel=o,this.update({sortByLabel:o})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(o){this._keepScrollPosition=o,this.update({keepScrollPosition:o})}get activeItems(){return this._activeItems}set activeItems(o){this._activeItems=o.filter(b=>this._itemsToHandles.has(b)),this.update({activeItems:this._activeItems.map(b=>this._itemsToHandles.get(b))})}get selectedItems(){return this._selectedItems}set selectedItems(o){this._selectedItems=o.filter(b=>this._itemsToHandles.has(b)),this.update({selectedItems:this._selectedItems.map(b=>this._itemsToHandles.get(b))})}_fireDidChangeActive(o){const b=(0,F.coalesce)(o.map(d=>this._handlesToItems.get(d)));this._activeItems=b,this._onDidChangeActiveEmitter.fire(b)}_fireDidChangeSelection(o){const b=(0,F.coalesce)(o.map(d=>this._handlesToItems.get(d)));this._selectedItems=b,this._onDidChangeSelectionEmitter.fire(b)}_fireDidTriggerItemButton(o,b){const d=this._handlesToItems.get(o);if(!d||!d.buttons||!d.buttons.length)return;const E=d.buttons[b];E&&this._onDidTriggerItemButtonEmitter.fire({button:E,item:d})}}class v extends h{constructor(o,b){super(o,b);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(o){this._password=o,this.update({password:o})}get prompt(){return this._prompt}set prompt(o){this._prompt=o,this.update({prompt:o})}get validationMessage(){return this._validationMessage}set validationMessage(o){this._validationMessage=o,this.update({validationMessage:o,severity:o?_.default.Error:_.default.Ignore})}}return new l(p,D)}e.createExtHostQuickOpen=a}),define(we[203],Ee([0,1,2,3,52,6,14,5,16,106,12,26,63,8,27]),function(re,e,u,M,w,A,t,T,C,k,F,_,n,g,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function c(m){if(m)return typeof m.iconPath=="string"?u.URI.file(m.iconPath):u.URI.isUri(m.iconPath)||n.ThemeIcon.isThemeIcon(m.iconPath)?m.iconPath:void 0}function p(m,o){if(!m.iconPath&&!o.iconPath)return 0;if(m.iconPath){if(!o.iconPath)return 1}else return-1;const b=typeof m.iconPath=="string"?m.iconPath:u.URI.isUri(m.iconPath)?m.iconPath.fsPath:m.iconPath.id,d=typeof o.iconPath=="string"?o.iconPath:u.URI.isUri(o.iconPath)?o.iconPath.fsPath:o.iconPath.id;return(0,k.comparePaths)(b,d)}function D(m,o){let b=0;if(m.strikeThrough!==o.strikeThrough)return m.strikeThrough?1:-1;if(m.faded!==o.faded)return m.faded?1:-1;if(m.tooltip!==o.tooltip)return(m.tooltip||"").localeCompare(o.tooltip||"");if(b=p(m,o),b!==0)return b;if(m.light&&o.light)b=p(m.light,o.light);else{if(m.light)return 1;if(o.light)return-1}if(b!==0)return b;if(m.dark&&o.dark)b=p(m.dark,o.dark);else{if(m.dark)return 1;if(o.dark)return-1}return b}function f(m,o){if(m.command!==o.command)return m.command<o.command?-1:1;if(m.title!==o.title)return m.title<o.title?-1:1;if(m.tooltip!==o.tooltip){if(m.tooltip!==void 0&&o.tooltip!==void 0)return m.tooltip<o.tooltip?-1:1;if(m.tooltip!==void 0)return 1;if(o.tooltip!==void 0)return-1}if(m.arguments===o.arguments)return 0;if(m.arguments)if(o.arguments){if(m.arguments.length!==o.arguments.length)return m.arguments.length-o.arguments.length}else return 1;else return-1;for(let b=0;b<m.arguments.length;b++){const d=m.arguments[b],E=o.arguments[b];if(d!==E)return d<E?-1:1}return 0}function l(m,o){let b=(0,k.comparePaths)(m.resourceUri.fsPath,o.resourceUri.fsPath,!0);if(b!==0)return b;if(m.command&&o.command)b=f(m.command,o.command);else{if(m.command)return 1;if(o.command)return-1}if(b!==0)return b;if(m.decorations&&o.decorations)b=D(m.decorations,o.decorations);else{if(m.decorations)return 1;if(o.decorations)return-1}return b}function h(m,o){for(let b=0;b<m.length;b++)if(m[b]!==o[b])return!1;return!0}function y(m,o){return m.command===o.command&&m.title===o.title&&m.tooltip===o.tooltip&&(m.arguments&&o.arguments?h(m.arguments,o.arguments):m.arguments===o.arguments)}function s(m,o){return(0,C.equals)(m,o,y)}class I{constructor(o,b,d){this._extension=o,this._proxy=b,this._sourceControlHandle=d,this._value="",this._onDidChange=new M.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(o){this._proxy.$setInputBoxValue(this._sourceControlHandle,o),this.updateValue(o)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(o){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,o),this._placeholder=o}get validateInput(){return(0,a.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(o){if((0,a.checkProposedApiEnabled)(this._extension,"scmValidation"),o&&typeof o!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=o,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!o)}get visible(){return this._visible}set visible(o){o=!!o,this._visible!==o&&(this._visible=o,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,o))}showValidationMessage(o,b){(0,a.checkProposedApiEnabled)(this._extension,"scmValidation"),this._proxy.$showValidationMessage(this._sourceControlHandle,o,b)}$onInputBoxValueChange(o){this.updateValue(o)}updateValue(o){this._value=o,this._onDidChange.fire(o)}}e.ExtHostSCMInputBox=I;class r{constructor(o,b,d,E,R){this._proxy=o,this._commands=b,this._sourceControlHandle=d,this._id=E,this._label=R,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new M.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new M.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=r._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(o){this._label=o,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,o)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(o){this._hideWhenEmpty=o,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(o){this._resourceStates=[...o],this._onDidUpdateResourceStates.fire()}getResourceState(o){return this._resourceStatesMap.get(o)}$executeResourceCommand(o,b){const d=this._resourceStatesCommandsMap.get(o);return d?(0,t.asPromise)(()=>this._commands.executeCommand(d.command,...d.arguments||[],b)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const o=[...this._resourceStates].sort(l),d=(0,C.sortedDiff)(this._resourceSnapshot,o,l).map(P=>{const z=P.toInsert.map(O=>{const S=this._resourceHandlePool++;this._resourceStatesMap.set(S,O);const x=O.resourceUri;let N;if(O.command)if(O.command.command==="vscode.open"||O.command.command==="vscode.diff"){const Fe=new A.DisposableStore;N=this._commands.converter.toInternal(O.command,Fe),this._resourceStatesDisposablesMap.set(S,Fe)}else this._resourceStatesCommandsMap.set(S,O.command);const V=c(O.decorations),B=O.decorations&&c(O.decorations.light)||V,$=O.decorations&&c(O.decorations.dark)||V,J=[B,$],j=O.decorations&&O.decorations.tooltip||"",Q=O.decorations&&!!O.decorations.strikeThrough,le=O.decorations&&!!O.decorations.faded,be=O.contextValue||"";return{rawResource:[S,x,J,j,Q,le,be,N],handle:S}});return{start:P.start,deleteCount:P.deleteCount,toInsert:z}}),E=d.map(({start:P,deleteCount:z,toInsert:O})=>[P,z,O.map(S=>S.rawResource)]),R=d.reverse();for(const{start:P,deleteCount:z,toInsert:O}of R){const S=O.map(N=>N.handle),x=this._handlesSnapshot.splice(P,z,...S);for(const N of x)this._resourceStatesMap.delete(N),this._resourceStatesCommandsMap.delete(N),this._resourceStatesDisposablesMap.get(N)?.dispose(),this._resourceStatesDisposablesMap.delete(N)}return this._resourceSnapshot=o,E}dispose(){this._disposed=!0,this._onDidDispose.fire()}}r._handlePool=0;class i{constructor(o,b,d,E,R,P){this._extension=o,this._proxy=b,this._commands=d,this._id=E,this._label=R,this._rootUri=P,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new A.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new A.MutableDisposable,this._statusBarDisposables=new A.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new M.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=i._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new I(o,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,E,R,P)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(o){this._count!==o&&(this._count=o,this._proxy.$updateSourceControl(this.handle,{count:o}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(o){this._quickDiffProvider=o,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!o})}get commitTemplate(){return this._commitTemplate}set commitTemplate(o){o!==this._commitTemplate&&(this._commitTemplate=o,this._proxy.$updateSourceControl(this.handle,{commitTemplate:o}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(o){this._acceptInputDisposables.value=new A.DisposableStore,this._acceptInputCommand=o;const b=this._commands.converter.toInternal(o,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:b})}get actionButton(){return(0,a.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(o){(0,a.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new A.DisposableStore,this._actionButton=o;const b=o!==void 0?this._commands.converter.toInternal(this._actionButton,this._actionButtonDisposables.value):void 0;this._proxy.$updateSourceControl(this.handle,{actionButton:b??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(o){if(this._statusBarCommands&&o&&s(this._statusBarCommands,o))return;this._statusBarDisposables.value=new A.DisposableStore,this._statusBarCommands=o;const b=(o||[]).map(d=>this._commands.converter.toInternal(d,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:b})}get selected(){return this._selected}createResourceGroup(o,b){const d=new r(this._proxy,this._commands,this.handle,o,b),E=M.Event.once(d.onDidDispose)(()=>this.createdResourceGroups.delete(d));return this.createdResourceGroups.set(d,E),this.eventuallyAddResourceGroups(),d}eventuallyAddResourceGroups(){const o=[],b=[];for(const[d,E]of this.createdResourceGroups){E.dispose();const R=d.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(d),this.eventuallyUpdateResourceStates()});M.Event.once(d.onDidDispose)(()=>{this.updatedResourceGroups.delete(d),R.dispose(),this._groups.delete(d.handle),this._proxy.$unregisterGroup(this.handle,d.handle)}),o.push([d.handle,d.id,d.label,d.features]);const P=d._takeResourceStateSnapshot();P.length>0&&b.push([d.handle,P]),this._groups.set(d.handle,d)}this._proxy.$registerGroups(this.handle,o,b),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const o=[];this.updatedResourceGroups.forEach(b=>{const d=b._takeResourceStateSnapshot();d.length!==0&&o.push([b.handle,d])}),o.length>0&&this._proxy.$spliceResourceStates(this.handle,o),this.updatedResourceGroups.clear()}getResourceGroup(o){return this._groups.get(o)}setSelectionState(o){this._selected=o,this._onDidChangeSelection.fire(o)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(o=>o.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}i._handlePool=0,Ne([(0,w.debounce)(100)],i.prototype,"eventuallyAddResourceGroups",null),Ne([(0,w.debounce)(100)],i.prototype,"eventuallyUpdateResourceStates",null);let v=class Wi{constructor(o,b,d){this._commands=b,this.logService=d,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new M.Emitter,this._proxy=o.getProxy(T.MainContext.MainThreadSCM),this._telemetry=o.getProxy(T.MainContext.MainThreadTelemetry),b.registerArgumentProcessor({processArgument:E=>{if(E&&E.$mid===3){const R=this._sourceControls.get(E.sourceControlHandle);if(!R)return E;const P=R.getResourceGroup(E.groupHandle);return P?P.getResourceState(E.handle):E}else if(E&&E.$mid===4){const R=this._sourceControls.get(E.sourceControlHandle);return R?R.getResourceGroup(E.groupHandle):E}else if(E&&E.$mid===5){const R=this._sourceControls.get(E.handle);return R||E}return E}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(o,b,d,E){this.logService.trace("ExtHostSCM#createSourceControl",o.identifier.value,b,d,E),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:o.identifier.value});const R=Wi._handlePool++,P=new i(o,this._proxy,this._commands,b,d,E);this._sourceControls.set(R,P);const z=this._sourceControlsByExtension.get(_.ExtensionIdentifier.toKey(o.identifier))||[];return z.push(P),this._sourceControlsByExtension.set(_.ExtensionIdentifier.toKey(o.identifier),z),P}getLastInputBox(o){this.logService.trace("ExtHostSCM#getLastInputBox",o.identifier.value);const b=this._sourceControlsByExtension.get(_.ExtensionIdentifier.toKey(o.identifier)),d=b&&b[b.length-1];return d&&d.inputBox}$provideOriginalResource(o,b,d){const E=u.URI.revive(b);this.logService.trace("ExtHostSCM#$provideOriginalResource",o,E.toString());const R=this._sourceControls.get(o);return!R||!R.quickDiffProvider||!R.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,t.asPromise)(()=>R.quickDiffProvider.provideOriginalResource(E,d)).then(P=>P||null)}$onInputBoxValueChange(o,b){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",o);const d=this._sourceControls.get(o);return d&&d.inputBox.$onInputBoxValueChange(b),Promise.resolve(void 0)}$executeResourceCommand(o,b,d,E){this.logService.trace("ExtHostSCM#$executeResourceCommand",o,b,d);const R=this._sourceControls.get(o);if(!R)return Promise.resolve(void 0);const P=R.getResourceGroup(b);return P?P.$executeResourceCommand(d,E):Promise.resolve(void 0)}$validateInput(o,b,d){this.logService.trace("ExtHostSCM#$validateInput",o);const E=this._sourceControls.get(o);return!E||!E.inputBox.validateInput?Promise.resolve(void 0):(0,t.asPromise)(()=>E.inputBox.validateInput(b,d)).then(R=>{if(!R)return Promise.resolve(void 0);const P=g.MarkdownString.fromStrict(R.message);return P?Promise.resolve([P,R.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(o){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",o),o!==void 0&&this._sourceControls.get(o)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=o,Promise.resolve(void 0)}};v._handlePool=0,v=Ne([xe(2,F.ILogService)],v),e.ExtHostSCM=v});var Xe=this&&this.__classPrivateFieldSet||function(re,e,u,M,w){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!w:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?w.call(re,u):w?w.value=u:e.set(re,u),u},Te=this&&this.__classPrivateFieldGet||function(re,e,u,M){if(u==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?M:u==="a"?M.call(re):M?M.value:e.get(re)};define(we[204],Ee([0,1,7,5,126,6,8,10]),function(re,e,u,M,w,A,t,T){"use strict";var C,k;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class F{constructor(a,c,p,D,f=u.StatusBarAlignment.Left,l){C.set(this,void 0),k.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new A.DisposableStore,Xe(this,C,a,"f"),Xe(this,k,c,"f"),this._entryId=F.ID_GEN++,this._extension=p,this._id=D,this._alignment=f,this._priority=this.validatePriority(l)}validatePriority(a){if(!!(0,T.isNumber)(a))return a===Number.POSITIVE_INFINITY?Number.MAX_VALUE:a===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:a}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(a){this._text=a,this.update()}set name(a){this._name=a,this.update()}set tooltip(a){this._tooltip=a,this.update()}set color(a){this._color=a,this.update()}set backgroundColor(a){a&&!F.ALLOWED_BACKGROUND_COLORS.has(a.id)&&(a=void 0),this._backgroundColor=a,this.update()}set command(a){this._command?.fromApi!==a&&(this._internalCommandRegistration.clear(),typeof a=="string"?this._command={fromApi:a,internal:Te(this,k,"f").toInternal({title:"",command:a},this._internalCommandRegistration)}:a?this._command={fromApi:a,internal:Te(this,k,"f").toInternal(a,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(a){this._accessibilityInformation=a,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Te(this,C,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let a;this._extension?this._id?a=`${this._extension.identifier.value}.${this._id}`:a=this._extension.identifier.value:a=this._id;let c;this._name?c=this._name:c=(0,w.localize)(0,null,this._extension.displayName||this._extension.name);let p=this._color;this._backgroundColor&&(p=F.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const D=this._tooltip?t.MarkdownString.fromStrict(this._tooltip):void 0;Te(this,C,"f").$setEntry(this._entryId,a,c,this._text,D,this._command?.internal,p,this._backgroundColor,this._alignment===u.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=F,C=new WeakMap,k=new WeakMap,F.ID_GEN=0,F.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new u.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new u.ThemeColor("statusBarItem.warningForeground")]]);class _{constructor(a){this._messages=[],this._item=a.createStatusBarEntry(void 0,"status.extensionMessage",u.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,w.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(a){const c={message:a};return this._messages.unshift(c),this._update(),new u.Disposable(()=>{const p=this._messages.indexOf(c);p>=0&&(this._messages.splice(p,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class n{constructor(a,c){this._proxy=a.getProxy(M.MainContext.MainThreadStatusBar),this._commands=c,this._statusMessage=new _(this)}createStatusBarEntry(a,c,p,D){return new F(this._proxy,this._commands,a,c,p,D)}setStatusBarMessage(a,c){const p=this._statusMessage.setMessage(a);let D;return typeof c=="number"?D=setTimeout(()=>p.dispose(),c):typeof c!="undefined"&&c.then(()=>p.dispose(),()=>p.dispose()),new u.Disposable(()=>{p.dispose(),clearTimeout(D)})}}e.ExtHostStatusBar=n}),define(we[72],Ee([0,1,5,3,4]),function(re,e,u,M,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class A{constructor(T){this._onDidChangeStorage=new M.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=T.getProxy(u.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(T,C){this._proxy.$registerExtensionStorageKeysToSync(T,C)}getValue(T,C,k){return this._proxy.$getValue(T,C).then(F=>F||k)}setValue(T,C,k){return this._proxy.$setValue(T,C,k)}$acceptValue(T,C,k){this._onDidChangeStorage.fire({shared:T,key:C,value:k})}}e.ExtHostStorage=A,e.IExtHostStorage=(0,w.createDecorator)("IExtHostStorage")}),define(we[73],Ee([0,1,4,28,12,50,2]),function(re,e,u,M,w,A,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,u.createDecorator)("IExtensionStoragePaths");let T=class{constructor(k,F,_){this._logService=F,this._extHostFileSystem=_,this._workspace=k.workspace??void 0,this._environment=k.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(n=>this._value=n)}async _getWorkspaceStorageURI(k){return t.URI.joinPath(this._environment.workspaceStorageHome,k)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const k=this._workspace.id,F=await this._getWorkspaceStorageURI(k);try{return await this._extHostFileSystem.value.stat(F),this._logService.trace("[ExtHostStorage] storage dir already exists",F),F}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",F),await this._extHostFileSystem.value.createDirectory(F),await this._extHostFileSystem.value.writeFile(t.URI.joinPath(F,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:t.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),F}catch(_){this._logService.error("[ExtHostStorage]",_);return}}workspaceValue(k){if(this._value)return t.URI.joinPath(this._value,k.identifier.value)}globalValue(k){return t.URI.joinPath(this._environment.globalStorageHome,k.identifier.value.toLowerCase())}onWillDeactivateAll(){}};T=Ne([xe(0,M.IExtHostInitDataService),xe(1,w.ILogService),xe(2,A.IExtHostConsumerFileSystem)],T),e.ExtensionStoragePaths=T}),define(we[39],Ee([0,1,3,5,4,2,13,6,7,127,15,166,20,36,149,63,10,14]),function(re,e,u,M,w,A,t,T,C,k,F,_,n,g,a,c,p,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,w.createDecorator)("IExtHostTerminalService");class f{constructor(m,o,b,d){this._proxy=m,this._id=o,this._creationOptions=b,this._name=d,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(R=>this._pidPromiseComplete=R);const E=this;this.value={get name(){return E._name||""},get processId(){return E._pidPromise},get creationOptions(){return E._creationOptions},get exitStatus(){return E._exitStatus},get state(){return E._state},sendText(R,P=!0){E._checkDisposed(),E._proxy.$sendText(E._id,R,P)},show(R){E._checkDisposed(),E._proxy.$show(E._id,R)},hide(){E._checkDisposed(),E._proxy.$hide(E._id)},dispose(){E._disposed||(E._disposed=!0,E._proxy.$dispose(E._id))},get dimensions(){if(!(E._cols===void 0||E._rows===void 0))return{columns:E._cols,rows:E._rows}}}}async create(m,o){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:m.name,shellPath:(0,p.withNullAsUndefined)(m.shellPath),shellArgs:(0,p.withNullAsUndefined)(m.shellArgs),cwd:(0,p.withNullAsUndefined)(m.cwd),env:(0,p.withNullAsUndefined)(m.env),icon:(0,p.withNullAsUndefined)(r(m.iconPath)),color:c.ThemeColor.isThemeColor(m.color)?m.color.id:void 0,initialText:(0,p.withNullAsUndefined)(m.message),strictEnv:(0,p.withNullAsUndefined)(m.strictEnv),hideFromUser:(0,p.withNullAsUndefined)(m.hideFromUser),isFeatureTerminal:(0,p.withNullAsUndefined)(o?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,p.withNullAsUndefined)(o?.useShellEnvironment),location:o?.location||this._serializeParentTerminal(m.location,o?.resolvedExtHostIdentifier)})}async createExtensionTerminal(m,o,b,d){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:b,color:c.ThemeColor.isThemeColor(d)?d.id:void 0,location:this._serializeParentTerminal(m,o)}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(m,o){return typeof m=="object"?"parentTerminal"in m&&m.parentTerminal&&o?{parentTerminal:o}:"viewColumn"in m?{viewColumn:m.viewColumn,preserveFocus:m.preserveFocus}:void 0:m}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(m){this._name=m}setExitCode(m){this._exitStatus=Object.freeze({code:m})}setDimensions(m,o){return m===this._cols&&o===this._rows||m===0||o===0?!1:(this._cols=m,this._rows=o,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(m){this._pidPromiseComplete?(this._pidPromiseComplete(m),this._pidPromiseComplete=void 0):this._pidPromise.then(o=>{o!==m&&(this._pidPromise=Promise.resolve(m))})}}e.ExtHostTerminal=f;class l{constructor(m){this._pty=m,this.id=0,this.shouldPersist=!1,this._capabilities=[],this._onProcessData=new u.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new u.Emitter,this._onDidChangeProperty=new u.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new u.Emitter,this.onProcessExit=this._onProcessExit.event}get capabilities(){return this._capabilities}get onProcessReady(){return this._onProcessReady.event}refreshProperty(m){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${m}`)}updateProperty(m,o){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${m}, value: ${o}`)}async start(){}shutdown(){this._pty.close()}input(m){this._pty.handleInput?.(m)}resize(m,o){this._pty.setDimensions?.({columns:m,rows:o})}async processBinary(m){}acknowledgeDataEvent(m){}async setUnicodeVersion(m){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(m){this._pty.onDidWrite(o=>this._onProcessData.fire(o)),this._pty.onDidClose?.((o=void 0)=>{this._onProcessExit.fire(o===void 0?void 0:o)}),this._pty.onDidOverrideDimensions?.(o=>{o&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:o.columns,rows:o.rows}})}),this._pty.onDidChangeName?.(o=>{this._onDidChangeProperty.fire({type:"title",value:o})}),this._pty.open(m||void 0),m&&this._pty.setDimensions?.(m),this._onProcessReady.fire({pid:-1,cwd:"",capabilities:this._capabilities})}}e.ExtHostPseudoterminal=l;let h=1,y=class extends T.Disposable{constructor(m,o){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new u.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new u.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new u.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new u.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new u.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._proxy=o.getProxy(M.MainContext.MainThreadTerminalService),this._bufferer=new a.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new u.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(m),this._register({dispose:()=>{for(const[b,d]of this._terminalProcesses)d.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(m=>m.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}getDefaultShell(m){return(m?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(m){return(m?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(m,o){const b=new f(this._proxy,(0,g.generateUuid)(),m,m.name),d=new l(m.pty);return b.createExtensionTerminal(m.location,this._serializeParentTerminal(m,o).resolvedExtHostIdentifier,r(m.iconPath),i(m.color)).then(E=>{const R=this._setupExtHostProcessListeners(E,d);this._terminalProcessDisposables[E]=R}),this._terminals.push(b),b.value}_serializeParentTerminal(m,o){if(o=o||{},m.location&&typeof m.location=="object"&&"parentTerminal"in m.location){const b=m.location.parentTerminal;if(b){const d=this._terminals.find(E=>E.value===b);d&&(o.resolvedExtHostIdentifier=d._id)}}else m.location&&typeof m.location!="object"?o.location=m.location:o.location&&typeof o.location=="object"&&"splitActiveTerminal"in o.location&&(o.location={splitActiveTerminal:!0});return o}attachPtyToTerminal(m,o){if(!this._getTerminalById(m))throw new Error(`Cannot resolve terminal with id ${m} for virtual process`);const d=new l(o),E=this._setupExtHostProcessListeners(m,d);this._terminalProcessDisposables[m]=E}async $acceptActiveTerminalChanged(m){const o=this._activeTerminal;if(m===null){this._activeTerminal=void 0,o!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const b=this._getTerminalById(m);b&&(this._activeTerminal=b,o!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(m,o){const b=this._getTerminalById(m);b&&this._onDidWriteTerminalData.fire({terminal:b.value,data:o})}async $acceptTerminalDimensions(m,o,b){const d=this._getTerminalById(m);d&&d.setDimensions(o,b)&&this._onDidChangeTerminalDimensions.fire({terminal:d.value,dimensions:d.value.dimensions})}async $acceptTerminalMaximumDimensions(m,o,b){this._terminalProcesses.get(m)?.resize(o,b)}async $acceptTerminalTitleChange(m,o){const b=this._getTerminalById(m);b&&(b.name=o)}async $acceptTerminalClosed(m,o){const b=this._getTerminalObjectIndexById(this._terminals,m);if(b!==null){const d=this._terminals.splice(b,1)[0];d.setExitCode(o),this._onDidCloseTerminal.fire(d.value)}}$acceptTerminalOpened(m,o,b,d){if(o){const P=this._getTerminalObjectIndexById(this._terminals,o);if(P!==null){this._terminals[P]._id=m,this._onDidOpenTerminal.fire(this.terminals[P]),this._terminals[P].isOpen=!0;return}}const E={name:d.name,shellPath:d.executable,shellArgs:d.args,cwd:typeof d.cwd=="string"?d.cwd:A.URI.revive(d.cwd),env:d.env,hideFromUser:d.hideFromUser},R=new f(this._proxy,m,E,b);this._terminals.push(R),this._onDidOpenTerminal.fire(R.value),R.isOpen=!0}async $acceptTerminalProcessId(m,o){const b=this._getTerminalById(m);b&&b._setProcessId(o)}async $startExtensionTerminal(m,o){const b=this._getTerminalById(m);if(!b)return{message:(0,k.localize)(0,null,m)};b.isOpen||await new Promise(E=>{const R=this.onDidOpenTerminal(async P=>{P===b.value&&(R.dispose(),E())})});const d=this._terminalProcesses.get(m);d?d.startSendingEvents(o):this._extensionTerminalAwaitingStart[m]={initialDimensions:o}}_setupExtHostProcessListeners(m,o){const b=new T.DisposableStore;b.add(o.onProcessReady(E=>this._proxy.$sendProcessReady(m,E.pid,E.cwd))),b.add(o.onDidChangeProperty(E=>this._proxy.$sendProcessProperty(m,E))),this._bufferer.startBuffering(m,o.onProcessData),b.add(o.onProcessExit(E=>this._onProcessExit(m,E))),this._terminalProcesses.set(m,o);const d=this._extensionTerminalAwaitingStart[m];return d&&o instanceof l&&(o.startSendingEvents(d.initialDimensions),delete this._extensionTerminalAwaitingStart[m]),b}$acceptProcessAckDataEvent(m,o){this._terminalProcesses.get(m)?.acknowledgeDataEvent(o)}$acceptProcessInput(m,o){this._terminalProcesses.get(m)?.input(o)}$acceptTerminalInteraction(m){const o=this._getTerminalById(m);o?.setInteractedWith()&&this._onDidChangeTerminalState.fire(o.value)}$acceptProcessResize(m,o,b){try{this._terminalProcesses.get(m)?.resize(o,b)}catch(d){if(d.code!=="EPIPE"&&d.code!=="ERR_IPC_CHANNEL_CLOSED")throw d}}$acceptProcessShutdown(m,o){this._terminalProcesses.get(m)?.shutdown(o)}$acceptProcessRequestInitialCwd(m){this._terminalProcesses.get(m)?.getInitialCwd().then(o=>this._proxy.$sendProcessProperty(m,{type:"initialCwd",value:o}))}$acceptProcessRequestCwd(m){this._terminalProcesses.get(m)?.getCwd().then(o=>this._proxy.$sendProcessProperty(m,{type:"cwd",value:o}))}$acceptProcessRequestLatency(m){return m}registerLinkProvider(m){return this._linkProviders.add(m),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new C.Disposable(()=>{this._linkProviders.delete(m),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(m,o,b){if(this._profileProviders.has(o))throw new Error(`Terminal profile provider "${o}" already registered`);return this._profileProviders.set(o,b),this._proxy.$registerProfileProvider(o,m.identifier.value),new C.Disposable(()=>{this._profileProviders.delete(o),this._proxy.$unregisterProfileProvider(o)})}async $createContributedProfileTerminal(m,o){const b=new n.CancellationTokenSource().token;let d=await this._profileProviders.get(m)?.provideTerminalProfile(b);if(!b.isCancellationRequested){if(d&&!("options"in d)&&(d={options:d}),!d||!("options"in d))throw new Error(`No terminal profile options provided for id "${m}"`);if("pty"in d.options){this.createExtensionTerminal(d.options,o);return}this.createTerminalFromOptions(d.options,o)}}async $provideLinks(m,o){const b=this._getTerminalById(m);if(!b)return[];this._terminalLinkCache.delete(m);const d=this._terminalLinkCancellationSource.get(m);d&&d.dispose(!0);const E=new n.CancellationTokenSource;this._terminalLinkCancellationSource.set(m,E);const R=[],P={terminal:b.value,line:o},z=[];for(const x of this._linkProviders)z.push(D.Promises.withAsyncBody(async N=>{E.token.onCancellationRequested(()=>N({provider:x,links:[]}));const V=await x.provideTerminalLinks(P,E.token)||[];E.token.isCancellationRequested||N({provider:x,links:V})}));const O=await Promise.all(z);if(E.token.isCancellationRequested)return[];const S=new Map;for(const x of O)x&&x.links.length>0&&R.push(...x.links.map(N=>{const V={id:h++,startIndex:N.startIndex,length:N.length,label:N.tooltip};return S.set(V.id,{provider:x.provider,link:N}),V}));return this._terminalLinkCache.set(m,S),R}$activateLink(m,o){const b=this._terminalLinkCache.get(m)?.get(o);!b||b.provider.handleTerminalLink(b.link)}_onProcessExit(m,o){this._bufferer.stopBuffering(m),this._terminalProcesses.delete(m),delete this._extensionTerminalAwaitingStart[m];const b=this._terminalProcessDisposables[m];b&&(b.dispose(),delete this._terminalProcessDisposables[m]),this._proxy.$sendProcessExit(m,o)}_getTerminalById(m){return this._getTerminalObjectById(this._terminals,m)}_getTerminalObjectById(m,o){const b=this._getTerminalObjectIndexById(m,o);return b!==null?m[b]:null}_getTerminalObjectIndexById(m,o){let b=null;return m.some((d,E)=>d._id===o?(b=E,!0):!1),b}getEnvironmentVariableCollection(m){let o=this._environmentVariableCollections.get(m.identifier.value);return o||(o=new s,this._setEnvironmentVariableCollection(m.identifier.value,o)),o}_syncEnvironmentVariableCollection(m,o){const b=(0,_.serializeEnvironmentVariableCollection)(o.map);this._proxy.$setEnvironmentVariableCollection(m,o.persistent,b.length===0?void 0:b)}$initEnvironmentVariableCollections(m){m.forEach(o=>{const b=o[0],d=new s(o[1]);this._setEnvironmentVariableCollection(b,d)})}$acceptDefaultProfile(m,o){this._defaultProfile=m,this._defaultAutomationProfile=o}_setEnvironmentVariableCollection(m,o){this._environmentVariableCollections.set(m,o),o.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(m,o)})}};y=Ne([xe(1,t.IExtHostRpcService)],y),e.BaseExtHostTerminalService=y;class s{constructor(m){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new u.Emitter,this.map=new Map(m)}get persistent(){return this._persistent}set persistent(m){this._persistent=m,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(m,o){this._setIfDiffers(m,{value:o,type:C.EnvironmentVariableMutatorType.Replace})}append(m,o){this._setIfDiffers(m,{value:o,type:C.EnvironmentVariableMutatorType.Append})}prepend(m,o){this._setIfDiffers(m,{value:o,type:C.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(m,o){const b=this.map.get(m);(!b||b.value!==o.value||b.type!==o.type)&&(this.map.set(m,o),this._onDidChangeCollection.fire())}get(m){return this.map.get(m)}forEach(m,o){this.map.forEach((b,d)=>m.call(o,d,b,this))}delete(m){this.map.delete(m),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=s;let I=class extends y{constructor(m){super(!1,m)}createTerminal(m,o,b){throw new F.NotSupportedError}createTerminalFromOptions(m,o){throw new F.NotSupportedError}};I=Ne([xe(0,t.IExtHostRpcService)],I),e.WorkerExtHostTerminalService=I;function r(v){if(!(!v||typeof v=="string"))return"id"in v?{id:v.id,color:v.color}:v}function i(v){return c.ThemeColor.isThemeColor(v)?v:void 0}});var Xe=this&&this.__classPrivateFieldSet||function(re,e,u,M,w){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!w:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?w.call(re,u):w?w.value=u:e.set(re,u),u},Te=this&&this.__classPrivateFieldGet||function(re,e,u,M){if(u==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?M:u==="a"?M.call(re):M?M.value:e.get(re)};define(we[205],Ee([0,1,16,22,20,3,234,58,6,25,10,36,5,13,48,8,7,174,89,68]),function(re,e,u,M,w,A,t,T,C,k,F,_,n,g,a,c,p,D,f,l){"use strict";var h;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let y=class{constructor(P,z){this.resultsChangedEmitter=new A.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=P.getProxy(n.MainContext.MainThreadTesting),this.observer=new b(this.proxy),this.runTracker=new I(this.proxy),z.registerArgumentProcessor({processArgument:O=>O?.$mid===13?c.TestItem.toItemFromContext(O):O})}createTestController(P,z){if(this.controllers.has(P))throw new Error(`Attempt to insert a duplicate controller with ID "${P}"`);const O=new C.DisposableStore,S=O.add(new D.SingleUseTestCollection(P));S.root.label=z;const x=new Map,N=this.proxy,V={items:S.root.children,get label(){return z},set label($){z=$,S.root.label=$,N.$updateControllerLabel(P,z)},get id(){return P},createRunProfile:($,J,j,Q,le)=>{let be=(0,T.hash)($);for(;x.has(be);)be++;const de=new d(this.proxy,P,be,$,J,j,Q,le);return x.set(be,de),de},createTestItem($,J,j){return new a.TestItemImpl(P,$,J,j)},createTestRun:($,J,j=!0)=>this.runTracker.createTestRun(P,S,$,J,j),set resolveHandler($){S.resolveHandler=$},get resolveHandler(){return S.resolveHandler},dispose:()=>{O.dispose()}};V.createRunConfiguration=V.createRunProfile,N.$registerTestController(P,z),O.add((0,C.toDisposable)(()=>N.$unregisterTestController(P)));const B={controller:V,collection:S,profiles:x};return this.controllers.set(P,B),O.add((0,C.toDisposable)(()=>this.controllers.delete(P))),O.add(S.onDidGenerateDiff($=>N.$publishDiff(P,$))),V}createTestObserver(){return this.observer.checkout()}async runTests(P,z=w.CancellationToken.None){const O=r(P);if(!O)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const S=this.controllers.get(O.controllerId);if(!S)throw new Error("Controller not found");await this.proxy.$runTests({targets:[{testIds:P.include?.map(x=>x.id)??[S.collection.root.id],profileGroup:E[O.kind],profileId:O.profileId,controllerId:O.controllerId}],exclude:P.exclude?.map(x=>x.id)},z)}$provideFileCoverage(P,z,O){return(0,u.mapFind)(this.runTracker.trackers,x=>x.id===P?x.getCoverage(z):void 0)?.provideFileCoverage(O)??Promise.resolve([])}$resolveFileCoverage(P,z,O,S){return(0,u.mapFind)(this.runTracker.trackers,N=>N.id===P?N.getCoverage(z):void 0)?.resolveFileCoverage(O,S)??Promise.resolve([])}$configureRunProfile(P,z){this.controllers.get(P)?.profiles.get(z)?.configureHandler?.()}$publishTestResults(P){this.results=Object.freeze(P.map(z=>(0,k.deepFreeze)(c.TestResults.to(z))).concat(this.results).sort((z,O)=>O.completedAt-z.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(P,z){const O=this.controllers.get(l.TestId.fromString(P).controllerId)?.collection;O&&(await O.expand(P,z<0?Infinity:z),O.flushDiff())}$acceptDiff(P){this.observer.applyDiff(P)}async $runControllerTests(P,z){const O=this.controllers.get(P.controllerId);if(!O)return;const{collection:S,profiles:x}=O,N=x.get(P.profileId);if(!N)return;const V=P.testIds.map(j=>S.tree.get(j)).filter(F.isDefined),B=P.excludeExtIds.map(j=>O.collection.tree.get(j)).filter(F.isDefined).filter(j=>V.some(Q=>Q.fullId.compare(j.fullId)===2));if(!V.length)return;const $=new p.TestRunRequest(V.some(j=>j.actual instanceof a.TestItemRootImpl)?void 0:V.map(j=>j.actual),B.map(j=>j.actual),N),J=this.runTracker.prepareForMainThreadTestRun($,i.fromInternal(P,O.collection),z);try{await N.runHandler($,z)}finally{J.isRunning&&!z.isCancellationRequested&&await A.Event.toPromise(J.onEnd),J.dispose()}}$cancelExtensionTestRun(P){P===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(P)}};y=Ne([xe(0,g.IExtHostRpcService)],y),e.ExtHostTesting=y;class s extends C.Disposable{constructor(P,z,O){super();this.dto=P,this.proxy=z,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new A.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new w.CancellationTokenSource(O)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:S}of this.tasks.values())S.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(P){return this.tasks.get(P)?.coverage}createRun(P){const z=this.dto.id,O=this.dto.controllerId,S=(0,_.generateUuid)(),x=new v(this.proxy,z,S),N=J=>(j,...Q)=>{if(B){console.warn(`Setting the state of test "${j.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(j)||(this.ensureTestIsKnown(j),J(j,...Q))},V=(J,j)=>{const Q=j instanceof Array?j.map(c.TestMessage.from):[c.TestMessage.from(j)];if(J.uri&&J.range){const le={range:c.Range.from(J.range),uri:J.uri};for(const be of Q)be.location=be.location||le}this.proxy.$appendTestMessagesInRun(z,S,l.TestId.fromExtHostTestItem(J,O).toString(),Q)};let B=!1;const $={isPersisted:this.dto.isPersisted,token:this.cts.token,name:P,get coverageProvider(){return x.coverageProvider},set coverageProvider(J){x.coverageProvider=J},enqueued:N(J=>{this.proxy.$updateTestStateInRun(z,S,l.TestId.fromExtHostTestItem(J,O).toString(),1)}),skipped:N(J=>{this.proxy.$updateTestStateInRun(z,S,l.TestId.fromExtHostTestItem(J,O).toString(),5)}),started:N(J=>{this.proxy.$updateTestStateInRun(z,S,l.TestId.fromExtHostTestItem(J,O).toString(),2)}),errored:N((J,j,Q)=>{V(J,j),this.proxy.$updateTestStateInRun(z,S,l.TestId.fromExtHostTestItem(J,O).toString(),6,Q)}),failed:N((J,j,Q)=>{V(J,j),this.proxy.$updateTestStateInRun(z,S,l.TestId.fromExtHostTestItem(J,O).toString(),4,Q)}),passed:N((J,j)=>{this.proxy.$updateTestStateInRun(z,S,l.TestId.fromExtHostTestItem(J,this.dto.controllerId).toString(),3,j)}),appendOutput:(J,j,Q)=>{B||(Q&&(this.dto.isIncluded(Q)?this.ensureTestIsKnown(Q):Q=void 0),this.proxy.$appendOutputToRun(z,S,M.VSBuffer.fromString(J),j&&c.location.from(j),Q&&l.TestId.fromExtHostTestItem(Q,O).toString()))},end:()=>{B||(B=!0,this.proxy.$finishedTestRunTask(z,S),this.tasks.delete(S),this.isRunning||this.dispose())}};return this.tasks.set(S,{run:$,coverage:x}),this.proxy.$startedTestRunTask(z,{id:S,name:P,running:!0}),$}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(P){if(!(P instanceof a.TestItemImpl))throw new a.InvalidTestItemError(P.id);if(this.sharedTestIds.has(l.TestId.fromExtHostTestItem(P,this.dto.controllerId).toString()))return;const z=[],O=this.dto.colllection.root;for(;;){const S=c.TestItem.from(P);if(z.unshift(S),this.sharedTestIds.has(S.extId)||(this.sharedTestIds.add(S.extId),P===O))break;P=P.parent||O}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,z)}}class I{constructor(P){this.proxy=P,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(P,z,O){return this.getTracker(P,z,O)}cancelRunById(P){for(const z of this.tracked.values())if(z.id===P){z.dispose();return}}cancelAllRuns(){for(const P of this.tracked.values())P.dispose()}createTestRun(P,z,O,S,x){const N=this.tracked.get(O);if(N)return N.createRun(S);const V=i.fromPublic(P,z,O,x),B=r(O);this.proxy.$startedExtensionTestRun({controllerId:P,profile:B&&{group:E[B.kind],id:B.profileId},exclude:O.exclude?.map(J=>J.id)??[],id:V.id,include:O.include?.map(J=>J.id)??[z.root.id],persist:x});const $=this.getTracker(O,V);return $.onEnd(()=>this.proxy.$finishedExtensionTestRun(V.id)),$.createRun(S)}getTracker(P,z,O){const S=new s(z,this.proxy,O);return this.tracked.set(P,S),S.onEnd(()=>this.tracked.delete(P)),S}}e.TestRunCoordinator=I;const r=R=>{if(!!R.profile){if(!(R.profile instanceof d))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return R.profile}};class i{constructor(P,z,O,S,x,N){this.controllerId=P,this.id=z,this.isPersisted=x,this.colllection=N,this.includePrefix=O.map(V=>V+"\0"),this.excludePrefix=S.map(V=>V+"\0")}static fromPublic(P,z,O,S){return new i(P,(0,_.generateUuid)(),O.include?.map(x=>l.TestId.fromExtHostTestItem(x,P).toString())??[P],O.exclude?.map(x=>l.TestId.fromExtHostTestItem(x,P).toString())??[],S,z)}static fromInternal(P,z){return new i(P.controllerId,P.runId,P.testIds,P.excludeExtIds,!0,z)}isIncluded(P){const z=l.TestId.fromExtHostTestItem(P,this.controllerId).toString()+"\0";for(const O of this.excludePrefix)if(z===O||z.startsWith(O))return!1;for(const O of this.includePrefix)if(z===O||z.startsWith(O))return!0;return!1}}e.TestRunDto=i;class v{constructor(P,z,O){this.proxy=P,this.runId=z,this.taskId=O}set coverageProvider(P){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!P||(this._coverageProvider=P,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(P){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(P))());try{return(await this.fileCoverage)?.map(c.TestCoverage.fromFile)??[]}catch(z){throw this.fileCoverage=void 0,z}}async resolveFileCoverage(P,z){const O=await this.fileCoverage;let S=O?.[P];return!this._coverageProvider||!O||!S?[]:(S.detailedCoverage||(S=O[P]=await this._coverageProvider.resolveFileCoverage?.(S,z)??S),S.detailedCoverage?.map(c.TestCoverage.fromDetailed)??[])}}class m extends f.IncrementalChangeCollector{constructor(P){super();this.emitter=P,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(P){this.added.add(P)}update(P){Object.assign(P.revived,c.TestItem.toPlain(P.item)),this.added.has(P)||this.updated.add(P)}remove(P){if(this.added.has(P)){this.added.delete(P);return}if(this.updated.delete(P),P.parent&&this.alreadyRemoved.has(P.parent)){this.alreadyRemoved.add(P.item.extId);return}this.removed.add(P)}getChangeEvent(){const{added:P,updated:z,removed:O}=this;return{get added(){return[...P].map(S=>S.revived)},get updated(){return[...z].map(S=>S.revived)},get removed(){return[...O].map(S=>S.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class o extends f.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new A.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(P){return this.items.get(P)}getMirroredTestDataByReference(P){return this.items.get(P.id)}createItem(P,z){return{...P,revived:c.TestItem.toPlain(P.item),depth:z?z.depth+1:0,children:new Set}}createChangeCollector(){return new m(this.changeEmitter)}}e.MirroredTestCollection=o;class b{constructor(P){this.proxy=P}checkout(){this.current||(this.current=this.createObserverData());const P=this.current;return P.observers++,{onDidChangeTest:P.tests.onDidChangeTests,get tests(){return[...P.tests.rootTests].map(z=>z.revived)},dispose:(0,t.once)(()=>{--P.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(P){return this.current?.tests.getMirroredTestDataByReference(P)}applyDiff(P){this.current?.tests.apply(P)}createObserverData(){const P=new o;return this.proxy.$subscribeToDiffs(),{observers:0,tests:P}}}class d{constructor(P,z,O,S,x,N,V=!1,B=void 0){this.controllerId=z,this.profileId=O,this._label=S,this.kind=x,this.runHandler=N,this._isDefault=V,this._tag=B,h.set(this,void 0),Xe(this,h,P,"f");const $=E[x];if(typeof $!="number")throw new Error(`Unknown TestRunProfile.group ${x}`);Te(this,h,"f").$publishTestRunProfile({profileId:O,controllerId:z,tag:B?c.TestTag.namespace(this.controllerId,B.id):null,label:S,group:$,isDefault:V,hasConfigurationHandler:!1})}get label(){return this._label}set label(P){P!==this._label&&(this._label=P,Te(this,h,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:P}))}get isDefault(){return this._isDefault}set isDefault(P){P!==this._isDefault&&(this._isDefault=P,Te(this,h,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:P}))}get tag(){return this._tag}set tag(P){P?.id!==this._tag?.id&&(this._tag=P,Te(this,h,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:P?c.TestTag.namespace(this.controllerId,P.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(P){P!==this._configureHandler&&(this._configureHandler=P,Te(this,h,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!P}))}dispose(){Te(this,h,"f").$removeTestProfile(this.controllerId,this.profileId)}}e.TestRunProfileImpl=d,h=new WeakMap;const E={[p.TestRunProfileKind.Coverage]:8,[p.TestRunProfileKind.Debug]:4,[p.TestRunProfileKind.Run]:2}}),define(we[206],Ee([0,1,3,16,5,93,8,7]),function(re,e,u,M,w,A,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class C{constructor(F,_){this._extHostDocumentsAndEditors=_,this._onDidChangeTextEditorSelection=new u.Emitter,this._onDidChangeTextEditorOptions=new u.Emitter,this._onDidChangeTextEditorVisibleRanges=new u.Emitter,this._onDidChangeTextEditorViewColumn=new u.Emitter,this._onDidChangeActiveTextEditor=new u.Emitter,this._onDidChangeVisibleTextEditors=new u.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=F.getProxy(w.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(n=>this._onDidChangeVisibleTextEditors.fire(n)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(n=>this._onDidChangeActiveTextEditor.fire(n))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(F){const _=this._extHostDocumentsAndEditors.allEditors();return F?_:_.map(n=>n.value)}async showTextDocument(F,_,n){let g;typeof _=="number"?g={position:t.ViewColumn.from(_),preserveFocus:n}:typeof _=="object"?g={position:t.ViewColumn.from(_.viewColumn),preserveFocus:_.preserveFocus,selection:typeof _.selection=="object"?t.Range.from(_.selection):void 0,pinned:typeof _.preview=="boolean"?!_.preview:void 0}:g={preserveFocus:!1};const a=await this._proxy.$tryShowTextDocument(F.uri,g),c=a&&this._extHostDocumentsAndEditors.getEditor(a);if(c)return c.value;throw a?new Error(`Could NOT open editor for "${F.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${F.uri.toString()}".`)}createTextEditorDecorationType(F,_){return new A.TextEditorDecorationType(this._proxy,F,_).value}$acceptEditorPropertiesChanged(F,_){const n=this._extHostDocumentsAndEditors.getEditor(F);if(!n)throw new Error("unknown text editor");if(_.options&&n._acceptOptions(_.options),_.selections){const g=_.selections.selections.map(t.Selection.to);n._acceptSelections(g)}if(_.visibleRanges){const g=M.coalesce(_.visibleRanges.map(t.Range.to));n._acceptVisibleRanges(g)}if(_.options&&this._onDidChangeTextEditorOptions.fire({textEditor:n.value,options:{..._.options,lineNumbers:t.TextEditorLineNumbersStyle.to(_.options.lineNumbers)}}),_.selections){const g=T.TextEditorSelectionChangeKind.fromValue(_.selections.source),a=_.selections.selections.map(t.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:n.value,selections:a,kind:g})}if(_.visibleRanges){const g=M.coalesce(_.visibleRanges.map(t.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:n.value,visibleRanges:g})}}$acceptEditorPositionData(F){for(const _ in F){const n=this._extHostDocumentsAndEditors.getEditor(_);if(!n)throw new Error("Unknown text editor");const g=t.ViewColumn.to(F[_]);n.value.viewColumn!==g&&(n._acceptViewColumn(g),this._onDidChangeTextEditorViewColumn.fire({textEditor:n.value,viewColumn:g}))}}getDiffInformation(F){return Promise.resolve(this._proxy.$getDiffInformation(F))}}e.ExtHostEditors=C}),define(we[207],Ee([0,1,2,4,5,6,7]),function(re,e,u,M,w,A,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,M.createDecorator)("IExtHostTimeline");class T{constructor(F,_){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=F.getProxy(w.MainContext.MainThreadTimeline),_.registerArgumentProcessor({processArgument:n=>{if(n&&n.$mid===11){const g=n.uri===void 0?void 0:u.URI.revive(n.uri);return this._itemsBySourceAndUriMap.get(n.source)?.get(C(g))?.get(n.handle)}return n}})}async $getTimeline(F,_,n,g,a){return this._providers.get(F)?.provideTimeline(u.URI.revive(_),n,g,a)}registerTimelineProvider(F,_,n,g){const a=new A.DisposableStore,c=this.convertTimelineItem(_.id,g,a).bind(this);let p;_.onDidChange&&(p=_.onDidChange(f=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...f,id:_.id}),this));const D=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({..._,scheme:F,onDidChange:void 0,async provideTimeline(f,l,h,y){y?.resetCache&&(a.clear(),D.get(_.id)?.clear());const s=await _.provideTimeline(f,l,h);if(s==null)return;const I=c(f,y);return{...s,source:_.id,items:s.items.map(I)}},dispose(){for(const f of D.values())f.get(_.id)?.clear();p?.dispose(),a.dispose()}})}convertTimelineItem(F,_,n){return(g,a)=>{let c;if(a?.cacheResults){let p=this._itemsBySourceAndUriMap.get(F);p===void 0&&(p=new Map,this._itemsBySourceAndUriMap.set(F,p));const D=C(g);c=p.get(D),c===void 0&&(c=new Map,p.set(D,c))}return p=>{const{iconPath:D,...f}=p,l=`${F}|${p.id??p.timestamp}`;c?.set(l,p);let h,y,s;return p.iconPath&&(D instanceof t.ThemeIcon?s={id:D.id,color:D.color}:u.URI.isUri(D)?(h=D,y=D):{light:h,dark:y}=D),{...f,id:f.id??void 0,handle:l,source:F,command:p.command?_.toInternal(p.command,n):void 0,icon:h,iconDark:y,themeIcon:s,accessibilityInformation:p.accessibilityInformation}}}}registerTimelineProviderCore(F){if(this._providers.get(F.id))throw new Error(`Timeline Provider ${F.id} already exists.`);return this._proxy.$registerTimelineProvider({id:F.id,label:F.label,scheme:F.scheme}),this._providers.set(F.id,F),(0,A.toDisposable)(()=>{for(const n of this._itemsBySourceAndUriMap.values())n.get(F.id)?.clear();this._providers.delete(F.id),this._proxy.$unregisterTimelineProvider(F.id),F.dispose()})}}e.ExtHostTimeline=T;function C(k){return k?.toString()}}),define(we[208],Ee([0,1,6,11,2,5]),function(re,e,u,M,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class t{constructor(C){this._openers=new Map,this._proxy=C.getProxy(A.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(C,k,F,_){if(this._openers.has(k))throw new Error(`Opener with id '${k}' already registered`);const n=_.schemes.find(g=>!t.supportedSchemes.has(g));if(n)throw new Error(`Scheme '${n}' is not supported. Only http and https are currently supported.`);return this._openers.set(k,F),this._proxy.$registerUriOpener(k,_.schemes,C,_.label),(0,u.toDisposable)(()=>{this._openers.delete(k),this._proxy.$unregisterUriOpener(k)})}async $canOpenUri(C,k,F){const _=this._openers.get(C);if(!_)throw new Error(`Unknown opener with id: ${C}`);const n=w.URI.revive(k);return _.canOpenExternalUri(n,F)}async $openUri(C,k,F){const _=this._openers.get(C);if(!_)throw new Error(`Unknown opener id: '${C}'`);return _.openExternalUri(w.URI.revive(k.resolvedUri),{sourceUri:w.URI.revive(k.sourceUri)},F)}}e.ExtHostUriOpeners=t,t.supportedSchemes=new Set([M.Schemas.http,M.Schemas.https])}),define(we[209],Ee([0,1,5,2,6,15,26]),function(re,e,u,M,w,A,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class T{constructor(k){this.handles=new Set,this.handlers=new Map,this._proxy=k.getProxy(u.MainContext.MainThreadUrls)}registerUriHandler(k,F){if(this.handles.has(t.ExtensionIdentifier.toKey(k)))throw new Error(`Protocol handler already registered for extension ${k}`);const _=T.HandlePool++;return this.handles.add(t.ExtensionIdentifier.toKey(k)),this.handlers.set(_,F),this._proxy.$registerUriHandler(_,k),(0,w.toDisposable)(()=>{this.handles.delete(t.ExtensionIdentifier.toKey(k)),this.handlers.delete(_),this._proxy.$unregisterUriHandler(_)})}$handleExternalUri(k,F){const _=this.handlers.get(k);if(!_)return Promise.resolve(void 0);try{_.handleUri(M.URI.revive(F))}catch(n){(0,A.onUnexpectedError)(n)}return Promise.resolve(void 0)}async createAppUri(k){return M.URI.revive(await this._proxy.$createAppUri(k))}}e.ExtHostUrls=T,T.HandlePool=0});var Xe=this&&this.__classPrivateFieldSet||function(re,e,u,M,w){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!w:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?w.call(re,u):w?w.value=u:e.set(re,u),u},Te=this&&this.__classPrivateFieldGet||function(re,e,u,M){if(u==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?M:u==="a"?M.call(re):M?M.value:e.get(re)};define(we[51],Ee([0,1,3,11,2,136,156,67,5]),function(re,e,u,M,w,A,t,T,C){"use strict";var k,F,_,n,g,a,c,p,D,f,l,h;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class y{constructor(b,d,E,R,P,z,O){k.set(this,void 0),F.set(this,void 0),_.set(this,void 0),n.set(this,void 0),g.set(this,void 0),a.set(this,void 0),c.set(this,""),p.set(this,void 0),D.set(this,!1),f.set(this,!1),l.set(this,!1),this._onMessageEmitter=new u.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,h.set(this,new u.Emitter),this._onDidDispose=Te(this,h,"f").event,Xe(this,k,b,"f"),Xe(this,F,d,"f"),Xe(this,p,E,"f"),Xe(this,n,R,"f"),Xe(this,g,P,"f"),Xe(this,a,z,"f"),Xe(this,l,s(z),"f"),Xe(this,_,O,"f")}dispose(){Xe(this,D,!0,"f"),Te(this,h,"f").fire(),Te(this,h,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(b){return Xe(this,f,!0,"f"),(0,T.asWebviewUri)(b,Te(this,n,"f").remote)}get cspSource(){const b=Te(this,a,"f").extensionLocation;if(b.scheme===M.Schemas.https||b.scheme===M.Schemas.http){let d=b.toString();return d.endsWith("/")||(d+="/"),d+" "+T.webviewGenericCspSource}return T.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Te(this,c,"f")}set html(b){this.assertNotDisposed(),Te(this,c,"f")!==b&&(Xe(this,c,b,"f"),!Te(this,f,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(b)&&(Xe(this,f,!0,"f"),Te(this,_,"f").report("Webview vscode-resource: uris",Te(this,a,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Te(this,F,"f").$setHtml(Te(this,k,"f"),b))}get options(){return this.assertNotDisposed(),Te(this,p,"f")}set options(b){this.assertNotDisposed(),Te(this,F,"f").$setOptions(Te(this,k,"f"),i(Te(this,a,"f"),Te(this,g,"f"),b)),Xe(this,p,b,"f")}async postMessage(b){if(Te(this,D,"f"))return!1;const d=(0,t.serializeWebviewMessage)(b,{serializeBuffersForPostMessage:Te(this,l,"f")});return Te(this,F,"f").$postMessage(Te(this,k,"f"),d.message,...d.buffers)}assertNotDisposed(){if(Te(this,D,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=y,k=new WeakMap,F=new WeakMap,_=new WeakMap,n=new WeakMap,g=new WeakMap,a=new WeakMap,c=new WeakMap,p=new WeakMap,D=new WeakMap,f=new WeakMap,l=new WeakMap,h=new WeakMap;function s(o){try{const b=(0,A.normalizeVersion)((0,A.parseVersion)(o.engines.vscode));return!!b&&b.majorBase>=1&&b.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=s;class I{constructor(b,d,E,R,P){this.initData=d,this.workspace=E,this._logService=R,this._deprecationService=P,this._webviews=new Map,this._webviewProxy=b.getProxy(C.MainContext.MainThreadWebviews)}$onMessage(b,d,...E){const R=this.getWebview(b);if(R){const{message:P}=(0,t.deserializeWebviewMessage)(d,E);R._onMessageEmitter.fire(P)}}$onMissingCsp(b,d){this._logService.warn(`${d} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(b,d,E){const R=new y(b,this._webviewProxy,v(d),this.initData,this.workspace,E,this._deprecationService);return this._webviews.set(b,R),R._onDidDispose(()=>{this._webviews.delete(b)}),R}deleteWebview(b){this._webviews.delete(b)}getWebview(b){return this._webviews.get(b)}}e.ExtHostWebviews=I;function r(o){return{id:o.identifier,location:o.extensionLocation}}e.toExtensionData=r;function i(o,b,d){return{enableCommandUris:d.enableCommandUris,enableScripts:d.enableScripts,enableForms:d.enableForms,portMapping:d.portMapping,localResourceRoots:d.localResourceRoots||m(o,b)}}e.serializeWebviewOptions=i;function v(o){return{enableCommandUris:o.enableCommandUris,enableScripts:o.enableScripts,enableForms:o.enableForms,portMapping:o.portMapping,localResourceRoots:o.localResourceRoots?.map(b=>w.URI.from(b))}}e.reviveOptions=v;function m(o,b){return[...(b?.getWorkspaceFolders()||[]).map(d=>d.uri),o.extensionLocation]}}),define(we[210],Ee([0,1,20,58,6,11,23,2,8,51,64,5,7]),function(re,e,u,M,w,A,t,T,C,k,F,_,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class g{constructor(s,I){this.document=s,this._storagePath=I,this._backupCounter=1,this._edits=new F.Cache("custom documents")}addEdit(s){return this._edits.add([s])}async undo(s,I){await this.getEdit(s).undo(),I||this.disposeBackup()}async redo(s,I){await this.getEdit(s).redo(),I||this.disposeBackup()}disposeEdits(s){for(const I of s)this._edits.delete(I)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const s=h(this.document.uri)+this._backupCounter++;return(0,t.joinPath)(this._storagePath,s)}updateBackup(s){this._backup?.delete(),this._backup=s}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(s){const I=this._edits.get(s,0);if(!I)throw new Error("No edit found");return I}}class a{constructor(){this._documents=new Map}get(s,I){return this._documents.get(this.key(s,I))}add(s,I,r){const i=this.key(s,I.uri);if(this._documents.has(i))throw new Error(`Document already exists for viewType:${s} resource:${I.uri}`);const v=new g(I,r);return this._documents.set(i,v),v}delete(s,I){const r=this.key(s,I.uri);this._documents.delete(r)}key(s,I){return`${s}@@@${I}`}}var c;(function(y){y[y.Text=0]="Text",y[y.Custom=1]="Custom"})(c||(c={}));class p{constructor(){this._providers=new Map}addTextProvider(s,I,r){return this.add(0,s,I,r)}addCustomProvider(s,I,r){return this.add(1,s,I,r)}get(s){return this._providers.get(s)}add(s,I,r,i){if(this._providers.has(I))throw new Error(`Provider for viewType:${I} already registered`);return this._providers.set(I,{type:s,extension:r,provider:i}),new n.Disposable(()=>this._providers.delete(I))}}class D{constructor(s,I,r,i,v){this._extHostDocuments=I,this._extensionStoragePaths=r,this._extHostWebview=i,this._extHostWebviewPanels=v,this._editorProviders=new p,this._documents=new a,this._proxy=s.getProxy(_.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(s,I,r,i){const v=new w.DisposableStore;return f(r)?(v.add(this._editorProviders.addTextProvider(I,s,r)),this._proxy.$registerTextEditorProvider((0,k.toExtensionData)(s),I,i.webviewOptions||{},{supportsMove:!!r.moveCustomTextEditor},(0,k.shouldSerializeBuffersForPostMessage)(s))):(v.add(this._editorProviders.addCustomProvider(I,s,r)),this.supportEditing(r)&&v.add(r.onDidChangeCustomDocument(m=>{const o=this.getCustomDocumentEntry(I,m.document.uri);if(l(m)){const b=o.addEdit(m);this._proxy.$onDidEdit(m.document.uri,I,b,m.label)}else this._proxy.$onContentChange(m.document.uri,I)})),this._proxy.$registerCustomEditorProvider((0,k.toExtensionData)(s),I,i.webviewOptions||{},!!i.supportsMultipleEditorsPerDocument,(0,k.shouldSerializeBuffersForPostMessage)(s))),n.Disposable.from(v,new n.Disposable(()=>{this._proxy.$unregisterEditorProvider(I)}))}async $createCustomDocument(s,I,r,i,v){const m=this._editorProviders.get(I);if(!m)throw new Error(`No provider found for '${I}'`);if(m.type!==1)throw new Error(`Invalid provide type for '${I}'`);const o=T.URI.revive(s),b=await m.provider.openCustomDocument(o,{backupId:r,untitledDocumentData:i?.buffer},v);let d;return this.supportEditing(m.provider)&&this._extensionStoragePaths&&(d=this._extensionStoragePaths.workspaceValue(m.extension)??this._extensionStoragePaths.globalValue(m.extension)),this._documents.add(I,b,d),{editable:this.supportEditing(m.provider)}}async $disposeCustomDocument(s,I){const r=this._editorProviders.get(I);if(!r)throw new Error(`No provider found for '${I}'`);if(r.type!==1)throw new Error(`Invalid provider type for '${I}'`);const i=T.URI.revive(s),{document:v}=this.getCustomDocumentEntry(I,i);this._documents.delete(I,v),v.dispose()}async $resolveWebviewEditor(s,I,r,i,v,m){const o=this._editorProviders.get(r);if(!o)throw new Error(`No provider found for '${r}'`);const b=C.ViewColumn.to(v),d=this._extHostWebview.createNewWebview(I,i.webviewOptions,o.extension),E=this._extHostWebviewPanels.createNewWebviewPanel(I,r,i.title,b,i.panelOptions,d),R=T.URI.revive(s);switch(o.type){case 1:{const{document:P}=this.getCustomDocumentEntry(r,R);return o.provider.resolveCustomEditor(P,E,m)}case 0:{const P=this._extHostDocuments.getDocument(R);return o.provider.resolveCustomTextEditor(P,E,m)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(s,I,r){this.getCustomDocumentEntry(I,s).disposeEdits(r)}async $onMoveCustomEditor(s,I,r){const i=this._editorProviders.get(r);if(!i)throw new Error(`No provider found for '${r}'`);if(!i.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${r}'`);const v=this._extHostWebviewPanels.getWebviewPanel(s);if(!v)throw new Error("No webview found");const m=T.URI.revive(I),o=this._extHostDocuments.getDocument(m);await i.provider.moveCustomTextEditor(o,v,u.CancellationToken.None)}async $undo(s,I,r,i){return this.getCustomDocumentEntry(I,s).undo(r,i)}async $redo(s,I,r,i){return this.getCustomDocumentEntry(I,s).redo(r,i)}async $revert(s,I,r){const i=this.getCustomDocumentEntry(I,s);await this.getCustomEditorProvider(I).revertCustomDocument(i.document,r),i.disposeBackup()}async $onSave(s,I,r){const i=this.getCustomDocumentEntry(I,s);await this.getCustomEditorProvider(I).saveCustomDocument(i.document,r),i.disposeBackup()}async $onSaveAs(s,I,r,i){const v=this.getCustomDocumentEntry(I,s);return this.getCustomEditorProvider(I).saveCustomDocumentAs(v.document,T.URI.revive(r),i)}async $backup(s,I,r){const i=this.getCustomDocumentEntry(I,s),m=await this.getCustomEditorProvider(I).backupCustomDocument(i.document,{destination:i.getNewBackupUri()},r);return i.updateBackup(m),m.id}getCustomDocumentEntry(s,I){const r=this._documents.get(s,T.URI.revive(I));if(!r)throw new Error("No custom document found");return r}getCustomEditorProvider(s){const r=this._editorProviders.get(s)?.provider;if(!r||!this.supportEditing(r))throw new Error("Custom document is not editable");return r}supportEditing(s){return!!s.onDidChangeCustomDocument}}e.ExtHostCustomEditors=D;function f(y){return typeof y.resolveCustomTextEditor=="function"}function l(y){return typeof y.undo=="function"&&typeof y.redo=="function"}function h(y){const s=y.scheme===A.Schemas.file||y.scheme===A.Schemas.untitled?y.fsPath:y.toString();return(0,M.hash)(s)+""}});var Xe=this&&this.__classPrivateFieldSet||function(re,e,u,M,w){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!w:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?w.call(re,u):w?w.value=u:e.set(re,u),u},Te=this&&this.__classPrivateFieldGet||function(re,e,u,M){if(u==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?M:u==="a"?M.call(re):M?M.value:e.get(re)};define(we[211],Ee([0,1,3,6,2,36,8,51,5,7]),function(re,e,u,M,w,A,t,T,C,k){"use strict";var F,_,n,g,a,c,p,D,f,l,h,y,s;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class I extends M.Disposable{constructor(m,o,b,d,E,R,P){super();F.set(this,void 0),_.set(this,void 0),n.set(this,void 0),g.set(this,void 0),a.set(this,void 0),c.set(this,void 0),p.set(this,void 0),D.set(this,void 0),f.set(this,!0),l.set(this,!0),h.set(this,!1),y.set(this,this._register(new u.Emitter)),this.onDidDispose=Te(this,y,"f").event,s.set(this,this._register(new u.Emitter)),this.onDidChangeViewState=Te(this,s,"f").event,Xe(this,F,m,"f"),Xe(this,_,o,"f"),Xe(this,n,b,"f"),Xe(this,a,R,"f"),Xe(this,D,E,"f"),Xe(this,c,d,"f"),Xe(this,g,P,"f")}dispose(){Te(this,h,"f")||(Xe(this,h,!0,"f"),Te(this,y,"f").fire(),Te(this,_,"f").$disposeWebview(Te(this,F,"f")),Te(this,g,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Te(this,g,"f")}get viewType(){return this.assertNotDisposed(),Te(this,n,"f")}get title(){return this.assertNotDisposed(),Te(this,c,"f")}set title(m){this.assertNotDisposed(),Te(this,c,"f")!==m&&(Xe(this,c,m,"f"),Te(this,_,"f").$setTitle(Te(this,F,"f"),m))}get iconPath(){return this.assertNotDisposed(),Te(this,p,"f")}set iconPath(m){this.assertNotDisposed(),Te(this,p,"f")!==m&&(Xe(this,p,m,"f"),Te(this,_,"f").$setIconPath(Te(this,F,"f"),w.URI.isUri(m)?{light:m,dark:m}:m))}get options(){return Te(this,a,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Te(this,D,"f")=="number"&&Te(this,D,"f")<0))return Te(this,D,"f")}get active(){return this.assertNotDisposed(),Te(this,l,"f")}get visible(){return this.assertNotDisposed(),Te(this,f,"f")}_updateViewState(m){Te(this,h,"f")||(this.active!==m.active||this.visible!==m.visible||this.viewColumn!==m.viewColumn)&&(Xe(this,l,m.active,"f"),Xe(this,f,m.visible,"f"),Xe(this,D,m.viewColumn,"f"),Te(this,s,"f").fire({webviewPanel:this}))}reveal(m,o){this.assertNotDisposed(),Te(this,_,"f").$reveal(Te(this,F,"f"),{viewColumn:m?t.ViewColumn.from(m):void 0,preserveFocus:!!o})}assertNotDisposed(){if(Te(this,h,"f"))throw new Error("Webview is disposed")}}F=new WeakMap,_=new WeakMap,n=new WeakMap,g=new WeakMap,a=new WeakMap,c=new WeakMap,p=new WeakMap,D=new WeakMap,f=new WeakMap,l=new WeakMap,h=new WeakMap,y=new WeakMap,s=new WeakMap;class r{constructor(m,o,b){this.webviews=o,this.workspace=b,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=m.getProxy(C.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,A.generateUuid)()}createWebviewPanel(m,o,b,d,E={}){const R=typeof d=="object"?d.viewColumn:d,P={viewColumn:t.ViewColumn.from(R),preserveFocus:typeof d=="object"&&!!d.preserveFocus},z=(0,T.shouldSerializeBuffersForPostMessage)(m),O=r.newHandle();this._proxy.$createWebviewPanel((0,T.toExtensionData)(m),O,o,{title:b,panelOptions:i(E),webviewOptions:(0,T.serializeWebviewOptions)(m,this.workspace,E),serializeBuffersForPostMessage:z},P);const S=this.webviews.createNewWebview(O,E,m);return this.createNewWebviewPanel(O,o,b,R,E,S)}$onDidChangeWebviewPanelViewStates(m){const o=Object.keys(m);o.sort((b,d)=>{const E=m[b],R=m[d];return E.active?1:R.active?-1:+E.visible-+R.visible});for(const b of o){const d=this.getWebviewPanel(b);if(!d)continue;const E=m[b];d._updateViewState({active:E.active,visible:E.visible,viewColumn:t.ViewColumn.to(E.position)})}}async $onDidDisposeWebviewPanel(m){this.getWebviewPanel(m)?.dispose(),this._webviewPanels.delete(m),this.webviews.deleteWebview(m)}registerWebviewPanelSerializer(m,o,b){if(this._serializers.has(o))throw new Error(`Serializer for '${o}' already registered`);return this._serializers.set(o,{serializer:b,extension:m}),this._proxy.$registerSerializer(o,{serializeBuffersForPostMessage:(0,T.shouldSerializeBuffersForPostMessage)(m)}),new k.Disposable(()=>{this._serializers.delete(o),this._proxy.$unregisterSerializer(o)})}async $deserializeWebviewPanel(m,o,b,d){const E=this._serializers.get(o);if(!E)throw new Error(`No serializer found for '${o}'`);const{serializer:R,extension:P}=E,z=this.webviews.createNewWebview(m,b.webviewOptions,P),O=this.createNewWebviewPanel(m,o,b.title,d,b.panelOptions,z);await R.deserializeWebviewPanel(O,b.state)}createNewWebviewPanel(m,o,b,d,E,R){const P=new I(m,this._proxy,o,b,d,E,R);return this._webviewPanels.set(m,P),P}getWebviewPanel(m){return this._webviewPanels.get(m)}}e.ExtHostWebviewPanels=r;function i(v){return{enableFindWidget:v.enableFindWidget,retainContextWhenHidden:v.retainContextWhenHidden}}});var Xe=this&&this.__classPrivateFieldSet||function(re,e,u,M,w){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!w:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?w.call(re,u):w?w.value=u:e.set(re,u),u},Te=this&&this.__classPrivateFieldGet||function(re,e,u,M){if(u==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?M:u==="a"?M.call(re):M?M.value:e.get(re)};define(we[212],Ee([0,1,3,6,51,5,7]),function(re,e,u,M,w,A,t){"use strict";var T,C,k,F,_,n,g,a,c,p;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class D extends M.Disposable{constructor(h,y,s,I,r,i){super();T.set(this,void 0),C.set(this,void 0),k.set(this,void 0),F.set(this,void 0),_.set(this,!1),n.set(this,void 0),g.set(this,void 0),a.set(this,void 0),c.set(this,this._register(new u.Emitter)),this.onDidChangeVisibility=Te(this,c,"f").event,p.set(this,this._register(new u.Emitter)),this.onDidDispose=Te(this,p,"f").event,Xe(this,k,s,"f"),Xe(this,g,I,"f"),Xe(this,T,h,"f"),Xe(this,C,y,"f"),Xe(this,F,r,"f"),Xe(this,n,i,"f")}dispose(){Te(this,_,"f")||(Xe(this,_,!0,"f"),Te(this,p,"f").fire(),Te(this,F,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Te(this,g,"f")}set title(h){this.assertNotDisposed(),Te(this,g,"f")!==h&&(Xe(this,g,h,"f"),Te(this,C,"f").$setWebviewViewTitle(Te(this,T,"f"),h))}get description(){return this.assertNotDisposed(),Te(this,a,"f")}set description(h){this.assertNotDisposed(),Te(this,a,"f")!==h&&(Xe(this,a,h,"f"),Te(this,C,"f").$setWebviewViewDescription(Te(this,T,"f"),h))}get visible(){return Te(this,n,"f")}get webview(){return Te(this,F,"f")}get viewType(){return Te(this,k,"f")}_setVisible(h){h===Te(this,n,"f")||Te(this,_,"f")||(Xe(this,n,h,"f"),Te(this,c,"f").fire())}show(h){this.assertNotDisposed(),Te(this,C,"f").$show(Te(this,T,"f"),!!h)}assertNotDisposed(){if(Te(this,_,"f"))throw new Error("Webview is disposed")}}T=new WeakMap,C=new WeakMap,k=new WeakMap,F=new WeakMap,_=new WeakMap,n=new WeakMap,g=new WeakMap,a=new WeakMap,c=new WeakMap,p=new WeakMap;class f{constructor(h,y){this._extHostWebview=y,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=h.getProxy(A.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(h,y,s,I){if(this._viewProviders.has(y))throw new Error(`View provider for '${y}' already registered`);return this._viewProviders.set(y,{provider:s,extension:h}),this._proxy.$registerWebviewViewProvider((0,w.toExtensionData)(h),y,{retainContextWhenHidden:I?.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new t.Disposable(()=>{this._viewProviders.delete(y),this._proxy.$unregisterWebviewViewProvider(y)})}async $resolveWebviewView(h,y,s,I,r){const i=this._viewProviders.get(y);if(!i)throw new Error(`No view provider found for '${y}'`);const{provider:v,extension:m}=i,o=this._extHostWebview.createNewWebview(h,{},m),b=new D(h,this._proxy,y,s,o,!0);this._webviewViews.set(h,b),await v.resolveWebviewView(b,{state:I},r)}async $onDidChangeWebviewViewVisibility(h,y){this.getWebviewView(h)._setVisible(y)}async $disposeWebviewView(h){const y=this.getWebviewView(h);this._webviewViews.delete(h),y.dispose(),this._extHostWebview.deleteWebview(h)}getWebviewView(h){const y=this._webviewViews.get(h);if(!y)throw new Error("No webview found");return y}}e.ExtHostWebviewViews=f}),define(we[96],Ee([0,1,3,5,2,11,9,4,13]),function(re,e,u,M,w,A,t,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let k=class Hi{constructor(_){this._onDidChangeWindowState=new u.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Hi.InitialState,this._proxy=_.getProxy(M.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(n=>this.$onDidChangeWindowFocus(n))}get state(){return this._state}$onDidChangeWindowFocus(_){_!==this._state.focused&&(this._state={...this._state,focused:_},this._onDidChangeWindowState.fire(this._state))}openUri(_,n){let g;if(typeof _=="string"){g=_;try{_=w.URI.parse(_)}catch(a){return Promise.reject(`Invalid uri - '${_}'`)}}return(0,t.isFalsyOrWhitespace)(_.scheme)?Promise.reject("Invalid scheme - cannot be empty"):_.scheme===A.Schemas.command?Promise.reject(`Invalid scheme '${_.scheme}'`):this._proxy.$openUri(_,g,n)}async asExternalUri(_,n){if((0,t.isFalsyOrWhitespace)(_.scheme))return Promise.reject("Invalid scheme - cannot be empty");const g=await this._proxy.$asExternalUri(_,n);return w.URI.from(g)}};k.InitialState={focused:!0},k=Ne([xe(0,C.IExtHostRpcService)],k),e.ExtHostWindow=k,e.IExtHostWindow=(0,T.createDecorator)("IExtHostWindow")}),define(we[213],Ee([0,1,14,22,20,15,3,6,107,180,37]),function(re,e,u,M,w,A,t,T,C,k,F){"use strict";var _;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function n(E,R){try{return JSON.stringify(E,R)}catch(P){return"null"}}const g="$$ref$$",a={[g]:-1};class c{constructor(R,P){this.jsonString=R,this.referencedBuffers=P}}function p(E,R=null,P=!1){const z=[];return{jsonString:(P?n:JSON.stringify)(E,(S,x)=>{if(typeof x=="undefined")return a;if(typeof x=="object"){if(x instanceof M.VSBuffer){const N=z.push(x)-1;return{[g]:N}}if(R)return R(S,x)}return x}),referencedBuffers:z}}e.stringifyJsonWithBufferRefs=p;function D(E,R,P){return JSON.parse(E,(z,O)=>{if(O){const S=O[g];if(typeof S=="number")return R[S];if(P&&O.$mid===1)return P.transformIncoming(O)}return O})}e.parseJsonAndRestoreBufferRefs=D;function f(E,R){return JSON.stringify(E,R)}function l(E){return E?(R,P)=>P&&P.$mid===1?E.transformOutgoing(P):P:null}var h;(function(E){E[E.LocalSide=0]="LocalSide",E[E.OtherSide=1]="OtherSide"})(h=e.RequestInitiator||(e.RequestInitiator={}));var y;(function(E){E[E.Responsive=0]="Responsive",E[E.Unresponsive=1]="Unresponsive"})(y=e.ResponsiveState||(e.ResponsiveState={}));const s=()=>{},I=Symbol.for("rpcProtocol"),r=Symbol.for("rpcProxy");class i extends T.Disposable{constructor(R,P=null,z=null){super();this[_]=!0,this._onDidChangeResponsiveState=this._register(new t.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=R,this._logger=P,this._uriTransformer=z,this._uriReplacer=l(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let O=0,S=F.ProxyIdentifier.count;O<S;O++)this._locals[O]=null,this._proxies[O]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new u.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(O=>this._receiveOneMessage(O))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(R=>{this._pendingRPCReplies[R].resolveErr(A.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(R){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+i.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(R){this._unresponsiveTime=Date.now()+i.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(R){this._responsiveState!==R&&(this._responsiveState=R,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(R){return this._uriTransformer?(0,C.transformIncomingURIs)(R,this._uriTransformer):R}getProxy(R){const{nid:P,sid:z}=R;return this._proxies[P]||(this._proxies[P]=this._createProxy(P,z)),this._proxies[P]}_createProxy(R,P){let z={get:(O,S)=>(typeof S=="string"&&!O[S]&&S.charCodeAt(0)===36&&(O[S]=(...x)=>this._remoteCall(R,S,x)),S===r?P:O[S])};return new Proxy(Object.create(null),z)}set(R,P){return this._locals[R.nid]=P,P}assertRegistered(R){for(let P=0,z=R.length;P<z;P++){const O=R[P];if(!this._locals[O.nid])throw new Error(`Missing actor ${O.sid} (isMain: ${O.isMain})`)}}_receiveOneMessage(R){if(this._isDisposed)return;const P=R.byteLength,z=v.read(R,0),O=z.readUInt8(),S=z.readUInt32();switch(O){case 1:case 2:{let{rpcId:x,method:N,args:V}=o.deserializeRequestJSONArgs(z);this._uriTransformer&&(V=(0,C.transformIncomingURIs)(V,this._uriTransformer)),this._receiveRequest(P,S,x,N,V,O===2);break}case 3:case 4:{let{rpcId:x,method:N,args:V}=o.deserializeRequestMixedArgs(z);this._uriTransformer&&(V=(0,C.transformIncomingURIs)(V,this._uriTransformer)),this._receiveRequest(P,S,x,N,V,O===4);break}case 5:{this._logger&&this._logger.logIncoming(P,S,0,"ack"),this._onDidReceiveAcknowledge(S);break}case 6:{this._receiveCancel(P,S);break}case 7:{this._receiveReply(P,S,void 0);break}case 9:{let x=o.deserializeReplyOKJSON(z);this._uriTransformer&&(x=(0,C.transformIncomingURIs)(x,this._uriTransformer)),this._receiveReply(P,S,x);break}case 10:{const x=o.deserializeReplyOKJSONWithBuffers(z,this._uriTransformer);this._receiveReply(P,S,x);break}case 8:{let x=o.deserializeReplyOKVSBuffer(z);this._receiveReply(P,S,x);break}case 11:{let x=o.deserializeReplyErrError(z);this._uriTransformer&&(x=(0,C.transformIncomingURIs)(x,this._uriTransformer)),this._receiveReplyErr(P,S,x);break}case 12:{this._receiveReplyErr(P,S,void 0);break}default:console.error("received unexpected message"),console.error(R)}}_receiveRequest(R,P,z,O,S,x){this._logger&&this._logger.logIncoming(R,P,1,`receiveRequest ${(0,F.getStringIdentifierForProxy)(z)}.${O}(`,S);const N=String(P);let V,B;if(x){const J=new w.CancellationTokenSource;S.push(J.token),V=this._invokeHandler(z,O,S),B=()=>J.cancel()}else V=this._invokeHandler(z,O,S),B=s;this._cancelInvokedHandlers[N]=B;const $=o.serializeAcknowledged(P);this._logger&&this._logger.logOutgoing($.byteLength,P,1,"ack"),this._protocol.send($),V.then(J=>{delete this._cancelInvokedHandlers[N];const j=o.serializeReplyOK(P,J,this._uriReplacer);this._logger&&this._logger.logOutgoing(j.byteLength,P,1,"reply:",J),this._protocol.send(j)},J=>{delete this._cancelInvokedHandlers[N];const j=o.serializeReplyErr(P,J);this._logger&&this._logger.logOutgoing(j.byteLength,P,1,"replyErr:",J),this._protocol.send(j)})}_receiveCancel(R,P){this._logger&&this._logger.logIncoming(R,P,1,"receiveCancel");const z=String(P);this._cancelInvokedHandlers[z]&&this._cancelInvokedHandlers[z]()}_receiveReply(R,P,z){this._logger&&this._logger.logIncoming(R,P,0,"receiveReply:",z);const O=String(P);if(!this._pendingRPCReplies.hasOwnProperty(O))return;const S=this._pendingRPCReplies[O];delete this._pendingRPCReplies[O],S.resolveOk(z)}_receiveReplyErr(R,P,z){this._logger&&this._logger.logIncoming(R,P,0,"receiveReplyErr:",z);const O=String(P);if(!this._pendingRPCReplies.hasOwnProperty(O))return;const S=this._pendingRPCReplies[O];delete this._pendingRPCReplies[O];let x;z&&(z.$isError?(x=new Error,x.name=z.name,x.message=z.message,x.stack=z.stack):x=z),S.resolveErr(x)}_invokeHandler(R,P,z){try{return Promise.resolve(this._doInvokeHandler(R,P,z))}catch(O){return Promise.reject(O)}}_doInvokeHandler(R,P,z){const O=this._locals[R];if(!O)throw new Error("Unknown actor "+(0,F.getStringIdentifierForProxy)(R));let S=O[P];if(typeof S!="function")throw new Error("Unknown method "+P+" on actor "+(0,F.getStringIdentifierForProxy)(R));return S.apply(O,z)}_remoteCall(R,P,z){if(this._isDisposed)return Promise.reject(A.canceled());let O=null;if(z.length>0&&w.CancellationToken.isCancellationToken(z[z.length-1])&&(O=z.pop()),O&&O.isCancellationRequested)return Promise.reject(A.canceled());const S=o.serializeRequestArguments(z,this._uriReplacer),x=++this._lastMessageId,N=String(x),V=new k.LazyPromise;O&&O.onCancellationRequested(()=>{const $=o.serializeCancel(x);this._logger&&this._logger.logOutgoing($.byteLength,x,0,"cancel"),this._protocol.send(o.serializeCancel(x))}),this._pendingRPCReplies[N]=V,this._onWillSendRequest(x);const B=o.serializeRequest(x,R,P,S,!!O);return this._logger&&this._logger.logOutgoing(B.byteLength,x,0,`request: ${(0,F.getStringIdentifierForProxy)(R)}.${P}(`,z),this._protocol.send(B),V}}e.RPCProtocol=i,_=I,i.UNRESPONSIVE_TIME=3*1e3;class v{constructor(R,P){this._buff=R,this._offset=P}static alloc(R,P,z){let O=new v(M.VSBuffer.alloc(z+1+4),0);return O.writeUInt8(R),O.writeUInt32(P),O}static read(R,P){return new v(R,P)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(R){this._buff.writeUInt8(R,this._offset),this._offset+=1}readUInt8(){const R=this._buff.readUInt8(this._offset);return this._offset+=1,R}writeUInt32(R){this._buff.writeUInt32BE(R,this._offset),this._offset+=4}readUInt32(){const R=this._buff.readUInt32BE(this._offset);return this._offset+=4,R}static sizeShortString(R){return 1+R.byteLength}writeShortString(R){this._buff.writeUInt8(R.byteLength,this._offset),this._offset+=1,this._buff.set(R,this._offset),this._offset+=R.byteLength}readShortString(){const R=this._buff.readUInt8(this._offset);this._offset+=1;const z=this._buff.slice(this._offset,this._offset+R).toString();return this._offset+=R,z}static sizeLongString(R){return 4+R.byteLength}writeLongString(R){this._buff.writeUInt32BE(R.byteLength,this._offset),this._offset+=4,this._buff.set(R,this._offset),this._offset+=R.byteLength}readLongString(){const R=this._buff.readUInt32BE(this._offset);this._offset+=4;const z=this._buff.slice(this._offset,this._offset+R).toString();return this._offset+=R,z}writeBuffer(R){this._buff.writeUInt32BE(R.byteLength,this._offset),this._offset+=4,this._buff.set(R,this._offset),this._offset+=R.byteLength}static sizeVSBuffer(R){return 4+R.byteLength}writeVSBuffer(R){this._buff.writeUInt32BE(R.byteLength,this._offset),this._offset+=4,this._buff.set(R,this._offset),this._offset+=R.byteLength}readVSBuffer(){const R=this._buff.readUInt32BE(this._offset);this._offset+=4;const P=this._buff.slice(this._offset,this._offset+R);return this._offset+=R,P}static sizeMixedArray(R){let P=0;P+=1;for(let z=0,O=R.length;z<O;z++){const S=R[z];switch(P+=1,S.type){case 1:P+=this.sizeLongString(S.value);break;case 2:P+=this.sizeVSBuffer(S.value);break;case 3:P+=this.sizeUInt32,P+=this.sizeLongString(S.value);for(let x=0;x<S.buffers.length;++x)P+=this.sizeVSBuffer(S.buffers[x]);break;case 4:break}}return P}writeMixedArray(R){this._buff.writeUInt8(R.length,this._offset),this._offset+=1;for(let P=0,z=R.length;P<z;P++){const O=R[P];switch(O.type){case 1:this.writeUInt8(1),this.writeLongString(O.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(O.value);break;case 3:this.writeUInt8(3),this.writeUInt32(O.buffers.length),this.writeLongString(O.value);for(let S=0;S<O.buffers.length;++S)this.writeBuffer(O.buffers[S]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const R=this._buff.readUInt8(this._offset);this._offset+=1;let P=new Array(R);for(let z=0;z<R;z++)switch(this.readUInt8()){case 1:P[z]=this.readLongString();break;case 2:P[z]=this.readVSBuffer();break;case 3:const S=this.readUInt32(),x=this.readLongString(),N=[];for(let V=0;V<S;++V)N.push(this.readVSBuffer());P[z]=new F.SerializableObjectWithBuffers(D(x,N,null));break;case 4:P[z]=void 0;break}return P}}v.sizeUInt32=4;var m;(function(E){E[E.Simple=0]="Simple",E[E.Mixed=1]="Mixed"})(m||(m={}));class o{static _useMixedArgSerialization(R){for(let P=0,z=R.length;P<z;P++)if(R[P]instanceof M.VSBuffer||R[P]instanceof F.SerializableObjectWithBuffers||typeof R[P]=="undefined")return!0;return!1}static serializeRequestArguments(R,P){if(this._useMixedArgSerialization(R)){const z=[];for(let O=0,S=R.length;O<S;O++){const x=R[O];if(x instanceof M.VSBuffer)z[O]={type:2,value:x};else if(typeof x=="undefined")z[O]={type:4};else if(x instanceof F.SerializableObjectWithBuffers){const{jsonString:N,referencedBuffers:V}=p(x.value,P);z[O]={type:3,value:M.VSBuffer.fromString(N),buffers:V}}else z[O]={type:1,value:M.VSBuffer.fromString(f(x,P))}}return{type:1,args:z}}return{type:0,args:f(R,P)}}static serializeRequest(R,P,z,O,S){switch(O.type){case 0:return this._requestJSONArgs(R,P,z,O.args,S);case 1:return this._requestMixedArgs(R,P,z,O.args,S)}}static _requestJSONArgs(R,P,z,O,S){const x=M.VSBuffer.fromString(z),N=M.VSBuffer.fromString(O);let V=0;V+=v.sizeUInt8(),V+=v.sizeShortString(x),V+=v.sizeLongString(N);let B=v.alloc(S?2:1,R,V);return B.writeUInt8(P),B.writeShortString(x),B.writeLongString(N),B.buffer}static deserializeRequestJSONArgs(R){const P=R.readUInt8(),z=R.readShortString(),O=R.readLongString();return{rpcId:P,method:z,args:JSON.parse(O)}}static _requestMixedArgs(R,P,z,O,S){const x=M.VSBuffer.fromString(z);let N=0;N+=v.sizeUInt8(),N+=v.sizeShortString(x),N+=v.sizeMixedArray(O);let V=v.alloc(S?4:3,R,N);return V.writeUInt8(P),V.writeShortString(x),V.writeMixedArray(O),V.buffer}static deserializeRequestMixedArgs(R){const P=R.readUInt8(),z=R.readShortString(),O=R.readMixedArray(),S=new Array(O.length);for(let x=0,N=O.length;x<N;x++){const V=O[x];typeof V=="string"?S[x]=JSON.parse(V):S[x]=V}return{rpcId:P,method:z,args:S}}static serializeAcknowledged(R){return v.alloc(5,R,0).buffer}static serializeCancel(R){return v.alloc(6,R,0).buffer}static serializeReplyOK(R,P,z){if(typeof P=="undefined")return this._serializeReplyOKEmpty(R);if(P instanceof M.VSBuffer)return this._serializeReplyOKVSBuffer(R,P);if(P instanceof F.SerializableObjectWithBuffers){const{jsonString:O,referencedBuffers:S}=p(P.value,z,!0);return this._serializeReplyOKJSONWithBuffers(R,O,S)}else return this._serializeReplyOKJSON(R,n(P,z))}static _serializeReplyOKEmpty(R){return v.alloc(7,R,0).buffer}static _serializeReplyOKVSBuffer(R,P){let z=0;z+=v.sizeVSBuffer(P);let O=v.alloc(8,R,z);return O.writeVSBuffer(P),O.buffer}static deserializeReplyOKVSBuffer(R){return R.readVSBuffer()}static _serializeReplyOKJSON(R,P){const z=M.VSBuffer.fromString(P);let O=0;O+=v.sizeLongString(z);let S=v.alloc(9,R,O);return S.writeLongString(z),S.buffer}static _serializeReplyOKJSONWithBuffers(R,P,z){const O=M.VSBuffer.fromString(P);let S=0;S+=v.sizeUInt32,S+=v.sizeLongString(O);for(const N of z)S+=v.sizeVSBuffer(N);let x=v.alloc(10,R,S);x.writeUInt32(z.length),x.writeLongString(O);for(const N of z)x.writeBuffer(N);return x.buffer}static deserializeReplyOKJSON(R){const P=R.readLongString();return JSON.parse(P)}static deserializeReplyOKJSONWithBuffers(R,P){const z=R.readUInt32(),O=R.readLongString(),S=[];for(let x=0;x<z;++x)S.push(R.readVSBuffer());return new F.SerializableObjectWithBuffers(D(O,S,P))}static serializeReplyErr(R,P){return P?this._serializeReplyErrEror(R,P):this._serializeReplyErrEmpty(R)}static _serializeReplyErrEror(R,P){const z=M.VSBuffer.fromString(n(A.transformErrorForSerialization(P),null));let O=0;O+=v.sizeLongString(z);let S=v.alloc(11,R,O);return S.writeLongString(z),S.buffer}static deserializeReplyErrError(R){const P=R.readLongString();return JSON.parse(P)}static _serializeReplyErrEmpty(R){return v.alloc(12,R,0).buffer}}var b;(function(E){E[E.RequestJSONArgs=1]="RequestJSONArgs",E[E.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",E[E.RequestMixedArgs=3]="RequestMixedArgs",E[E.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",E[E.Acknowledged=5]="Acknowledged",E[E.Cancel=6]="Cancel",E[E.ReplyOKEmpty=7]="ReplyOKEmpty",E[E.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",E[E.ReplyOKJSON=9]="ReplyOKJSON",E[E.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",E[E.ReplyErrError=11]="ReplyErrError",E[E.ReplyErrEmpty=12]="ReplyErrEmpty"})(b||(b={}));var d;(function(E){E[E.String=1]="String",E[E.VSBuffer=2]="VSBuffer",E[E.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",E[E.Undefined=4]="Undefined"})(d||(d={}))}),define(we[214],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const u=function(A){const t=T=>{self.removeEventListener("message",t);const C=T.data;Object.defineProperties(self,{postMessage:{value(k,F){C.postMessage(k,F)}},onmessage:{get(){return C.onmessage},set(k){C.onmessage=k}}}),C.addEventListener("message",k=>{self.dispatchEvent(new MessageEvent("message",{data:k.data}))}),C.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(A)};self.addEventListener("message",t)}.toString();class M extends EventTarget{constructor(A,t,T){super();this.onmessage=null,this.onmessageerror=null,this.onerror=null;const C=`((${u})('${t}'))`,k=new Blob([C],{type:"application/javascript"}),F=URL.createObjectURL(k),_=new MessageChannel,n=F,g={type:"_newWorker",id:n,port:_.port2,url:F,options:T};A(g,[_.port2]),this.postMessage=_.port1.postMessage.bind(_.port1),this.terminate=()=>{const a={type:"_terminateWorker",id:n};_.port1.postMessage(a),URL.revokeObjectURL(F),_.port1.close(),_.port2.close()},Object.defineProperties(this,{onmessage:{get(){return _.port1.onmessage},set(a){_.port1.onmessage=a}},onmessageerror:{get(){return _.port1.onmessageerror},set(a){_.port1.onmessageerror=a}}}),_.port1.addEventListener("messageerror",a=>{const c=new MessageEvent("messageerror",{data:a.data});this.dispatchEvent(c)}),_.port1.addEventListener("message",a=>{const c=new MessageEvent("message",{data:a.data});this.dispatchEvent(c)}),_.port1.start()}}e.NestedWorker=M}),define(we[215],Ee([0,1,4]),function(re,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,u.createDecorator)("remoteAgentService")}),define(we[216],Ee([0,1,11,17,24,2,4,62,47,175,215]),function(re,e,u,M,w,A,t,T,C,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,t.createDecorator)("pathService");let _=class Vi{constructor(g,a,c,p){this.localUserHome=g,this.remoteAgentService=a,this.environmentService=c,this.contextService=p,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||w.OS)(),this.resolveUserHome=(async()=>{const D=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=D?.userHome||g})()}get defaultUriScheme(){return Vi.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(g,a){if(g.remoteAuthority)return u.Schemas.vscodeRemote;const c=(0,T.getVirtualWorkspaceScheme)(a.getWorkspace());if(c)return c;const p=a.getWorkspace().folders[0];if(p)return p.uri.scheme;const D=a.getWorkspace().configuration;return D?D.scheme:u.Schemas.file}async userHome(g){return g?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(g=>g===1?M.win32:M.posix)}async fileURI(g){let a="";if(await this.resolveOS===1&&(g=g.replace(/\\/g,"/")),g[0]==="/"&&g[1]==="/"){const p=g.indexOf("/",2);p===-1?(a=g.substring(2),g="/"):(a=g.substring(2,p),g=g.substring(p)||"/")}return A.URI.from({scheme:u.Schemas.file,authority:a,path:g,query:"",fragment:""})}};_=Ne([xe(1,F.IRemoteAgentService),xe(2,k.IWorkbenchEnvironmentService),xe(3,C.IWorkspaceContextService)],_),e.AbstractPathService=_}),define(we[97],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class u{constructor(t,T){this.line=t,this.character=T}isBefore(t){return!1}isBeforeOrEqual(t){return!1}isAfter(t){return!1}isAfterOrEqual(t){return!1}isEqual(t){return!1}compareTo(t){return 0}translate(t,T){return new u(0,0)}with(t){return new u(0,0)}}e.Position=u;class M{constructor(t,T,C,k){this.isEmpty=!1,this.isSingleLine=!1,this.start=new u(t,T),this.end=new u(C,k)}contains(t){return!1}isEqual(t){return!1}intersection(t){}union(t){return new M(0,0,0,0)}with(t){return new M(0,0,0,0)}}e.Range=M;var w;(function(A){A[A.Information=1]="Information",A[A.Warning=2]="Warning"})(w=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(we[40],Ee([0,1,16,29,25,42,9,4,17,15,97,10]),function(re,e,u,M,w,A,t,T,C,k,F,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return F.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const n="\u27EA ",g=" characters skipped \u27EB",a=(n.length+g.length+5)*2;e.ISearchService=(0,T.createDecorator)("searchService");var c;(function($){$[$.file=0]="file",$[$.text=1]="text"})(c=e.SearchProviderType||(e.SearchProviderType={}));var p;(function($){$[$.File=1]="File",$[$.Text=2]="Text"})(p=e.QueryType||(e.QueryType={}));function D($){return!!$.preview}e.resultIsMatch=D;function f($){return!!$.resource}e.isFileMatch=f;function l($){return!!$.message}e.isProgressMessage=l;var h;(function($){$[$.Normal=0]="Normal",$[$.NewSearchStarted=1]="NewSearchStarted"})(h=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class y{constructor(J){this.resource=J,this.results=[]}}e.FileMatch=y;class s{constructor(J,j,Q){this.ranges=j;const le=Array.isArray(j)?j:[j];if(Q&&Q.matchLines===1&&I(le)){J=(0,t.getNLines)(J,Q.matchLines);let be="",de=0,Fe=0;const Ge=Math.floor(Q.charsPerLine/5),Le=[];for(const We of le){const Ye=Math.max(We.startColumn-Ge,0),Qe=We.startColumn+Q.charsPerLine;if(Ye>Fe+Ge+a){const Ke=n+(Ye-Fe)+g;be+=Ke+J.slice(Ye,Qe),de+=Ye-(Fe+Ke.length)}else be+=J.slice(Fe,Qe);Le.push(new i(0,We.startColumn-de,We.endColumn-de)),Fe=Qe}this.preview={text:be,matches:Array.isArray(this.ranges)?Le:Le[0]}}else{const be=Array.isArray(j)?j[0].startLineNumber:j.startLineNumber;this.preview={text:J,matches:(0,u.mapArrayOrNot)(j,de=>new r(de.startLineNumber-be,de.startColumn,de.endLineNumber-be,de.endColumn))}}}}e.TextSearchMatch=s;function I($){const J=$[0].startLineNumber;for(const j of $)if(j.startLineNumber!==J||j.endLineNumber!==J)return!1;return!0}class r{constructor(J,j,Q,le){this.startLineNumber=J,this.startColumn=j,this.endLineNumber=Q,this.endColumn=le}}e.SearchRange=r;class i extends r{constructor(J,j,Q){super(J,j,J,Q)}}e.OneLineRange=i;var v;(function($){$.Default="default",$.FileNames="fileNames",$.Type="type",$.Modified="modified",$.CountDescending="countDescending",$.CountAscending="countAscending"})(v=e.SearchSortOrder||(e.SearchSortOrder={}));function m($,J=!0){const j=$&&$.files&&$.files.exclude,Q=J&&$&&$.search&&$.search.exclude;if(!j&&!Q)return;if(!j||!Q)return j||Q;let le=Object.create(null);return le=w.mixin(le,w.deepClone(j)),le=w.mixin(le,w.deepClone(Q),!0),le}e.getExcludes=m;function o($,J){return $.excludePattern&&M.match($.excludePattern,J)?!1:$.includePattern||$.usingSearchPaths?$.includePattern&&M.match($.includePattern,J)?!0:$.usingSearchPaths?!!$.folderQueries&&$.folderQueries.some(j=>{const Q=j.folder.fsPath;if(A.isEqualOrParent(J,Q)){const le=C.relative(Q,J);return!j.includePattern||!!M.match(j.includePattern,le)}else return!1}):!1:!0}e.pathIncludedInQuery=o;var b;(function($){$[$.unknownEncoding=1]="unknownEncoding",$[$.regexParseError=2]="regexParseError",$[$.globParseError=3]="globParseError",$[$.invalidLiteral=4]="invalidLiteral",$[$.rgProcessError=5]="rgProcessError",$[$.other=6]="other",$[$.canceled=7]="canceled"})(b=e.SearchErrorCode||(e.SearchErrorCode={}));class d extends Error{constructor(J,j){super(J);this.code=j}}e.SearchError=d;function E($){const J=$.message;if((0,k.isPromiseCanceledError)($))return new d(J,b.canceled);try{const j=JSON.parse(J);return new d(j.message,j.code)}catch(j){return new d(J,b.other)}}e.deserializeSearchError=E;function R($){const J={message:$.message,code:$.code};return new Error(JSON.stringify(J))}e.serializeSearchError=R;function P($){return $.type==="error"?!0:$.type==="success"}e.isSerializedSearchComplete=P;function z($){return $.type==="success"}e.isSerializedSearchSuccess=z;function O($){return!!$.path}e.isSerializedFileMatch=O;function S($,J){const j=$.searchPath?$.searchPath:$.relativePath;return(0,t.fuzzyContains)(j,J)}e.isFilePatternMatch=S;class x{constructor(J){this.path=J,this.results=[]}addMatch(J){this.results.push(J)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=x;function N($,J){const j={...$||{},...J||{}};return Object.keys(j).filter(Q=>{const le=j[Q];return typeof le=="boolean"&&le})}e.resolvePatternsForProvider=N;class V{constructor(J,j){this._parsedIncludeExpression=null,this._excludeExpression={...J.excludePattern||{},...j.excludePattern||{}},this._parsedExcludeExpression=M.parse(this._excludeExpression);let Q=J.includePattern;j.includePattern&&(Q?Q={...Q,...j.includePattern}:Q=j.includePattern),Q&&(this._parsedIncludeExpression=M.parse(Q))}matchesExcludesSync(J,j,Q){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(J,j,Q))}includedInQuerySync(J,j,Q){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(J,j,Q)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(J,j,Q))}includedInQuery(J,j,Q){const le=this._parsedExcludeExpression(J,j,Q),be=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(J,j,Q):!0;return(0,_.isPromise)(le)?le.then(de=>de?!1:be()):be()}hasSiblingExcludeClauses(){return B(this._excludeExpression)}}e.QueryGlobTester=V;function B($){for(const J in $)if(typeof $[J]!="boolean")return!0;return!1}}),define(we[32],Ee([0,1,16,14,20,3,21,11,76,23,9,10,2,129,4,12,142,47,31,28,13,7,40,5]),function(re,e,u,M,w,A,t,T,C,k,F,_,n,g,a,c,p,D,f,l,h,y,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function r(R,P,z){return new k.ExtUri(O=>o(O,z)).isEqual(R,P)}function i(R,P,z){return r(R.uri,P.uri,z)?0:(0,F.compare)(R.uri.toString(),P.uri.toString())}function v(R,P,z){return R.index!==P.index?R.index<P.index?-1:1:r(R.uri,P.uri,z)?(0,F.compare)(R.name,P.name):(0,F.compare)(R.uri.toString(),P.uri.toString())}function m(R,P,z,O){const S=R.slice(0).sort((N,V)=>z(N,V,O)),x=P.slice(0).sort((N,V)=>z(N,V,O));return(0,u.delta)(S,x,(N,V)=>z(N,V,O))}function o(R,P){const z=P.getCapabilities(R.scheme);return!(z&&z&1024)}class b extends D.Workspace{constructor(P,z,O,S,x,N,V){super(P,O.map(B=>new D.WorkspaceFolder(B)),S,x,V);this._name=z,this._isUntitled=N,this._workspaceFolders=[],this._structure=t.TernarySearchTree.forUris(V),O.forEach(B=>{this._workspaceFolders.push(B),this._structure.set(B.uri,B)})}static toExtHostWorkspace(P,z,O,S){if(!P)return{workspace:null,added:[],removed:[]};const{id:x,name:N,folders:V,configuration:B,transient:$,isUntitled:J}=P,j=[],Q=z;z?V.forEach((Fe,Ge)=>{const Le=n.URI.revive(Fe.uri),We=b._findFolder(O||z,Le,S);We?(We.name=Fe.name,We.index=Fe.index,j.push(We)):j.push({uri:Le,name:Fe.name,index:Ge})}):j.push(...V.map(({uri:Fe,name:Ge,index:Le})=>({uri:n.URI.revive(Fe),name:Ge,index:Le}))),j.sort((Fe,Ge)=>Fe.index<Ge.index?-1:1);const le=new b(x,N,j,!!$,B?n.URI.revive(B):null,!!J,Fe=>o(Fe,S)),{added:be,removed:de}=m(Q?Q.workspaceFolders:[],le.workspaceFolders,i,S);return{workspace:le,added:be,removed:de}}static _findFolder(P,z,O){for(let S=0;S<P.folders.length;S++){const x=P.workspaceFolders[S];if(r(x.uri,z,O))return x}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(P,z){return z&&this._structure.get(P)&&(P=(0,k.dirname)(P)),this._structure.findSubstr(P)}resolveWorkspaceFolder(P){return this._structure.get(P)}}let d=class{constructor(P,z,O,S){this._onDidChangeWorkspace=new A.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new A.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=S,this._extHostFileSystemInfo=O,this._requestIdProvider=new C.Counter,this._barrier=new M.Barrier,this._proxy=P.getProxy(I.MainContext.MainThreadWorkspace),this._messageService=P.getProxy(I.MainContext.MainThreadMessageService);const x=z.workspace;this._confirmedWorkspace=x?new b(x.id,x.name,[],!!x.transient,x.configuration?n.URI.revive(x.configuration):null,!!x.isUntitled,N=>o(N,O)):void 0}$initializeWorkspace(P,z){this._trusted=z,this.$acceptWorkspaceData(P),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?n.URI.from({scheme:T.Schemas.untitled,path:(0,k.basename)((0,k.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(P,z,O,...S){const x=[];if(Array.isArray(S)&&S.forEach(J=>{n.URI.isUri(J.uri)&&!x.some(j=>r(j.uri,J.uri,this._extHostFileSystemInfo))&&x.push({uri:J.uri,name:J.name||(0,k.basenameOrAuthority)(J.uri)})}),this._unconfirmedWorkspace||[z,O].some(J=>typeof J!="number"||J<0)||O===0&&x.length===0)return!1;const N=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(z+O>N.length)return!1;const V=N.slice(0);V.splice(z,O,...x.map(J=>({uri:J.uri,name:J.name||(0,k.basenameOrAuthority)(J.uri),index:void 0})));for(let J=0;J<V.length;J++){const j=V[J];if(V.some((Q,le)=>le!==J&&r(j.uri,Q.uri,this._extHostFileSystemInfo)))return!1}V.forEach((J,j)=>J.index=j);const{added:B,removed:$}=m(N,V,v,this._extHostFileSystemInfo);if(B.length===0&&$.length===0)return!1;if(this._proxy){const J=P.displayName||P.name;this._proxy.$updateWorkspaceFolders(J,z,O,x).then(void 0,j=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(p.Severity.Error,(0,g.localize)(0,null,J,j.toString()),{extension:P},[])})}return this.trySetWorkspaceFolders(V),!0}getWorkspaceFolder(P,z){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(P,z)}async getWorkspaceFolder2(P,z){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(P,z)}async resolveWorkspaceFolder(P){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(P)}getPath(){if(!this._actualWorkspace)return;const{folders:P}=this._actualWorkspace;if(P.length!==0)return P[0].uri.fsPath}getRelativePath(P,z){let O,S="";if(typeof P=="string"?(O=n.URI.file(P),S=P):typeof P!="undefined"&&(O=P,S=P.fsPath),!O)return S;const x=this.getWorkspaceFolder(O,!0);if(!x)return S;typeof z=="undefined"&&this._actualWorkspace&&(z=this._actualWorkspace.folders.length>1);let N=(0,k.relativePath)(x.uri,O);return z&&x.name&&(N=`${x.name}/${N}`),N}trySetWorkspaceFolders(P){this._actualWorkspace&&(this._unconfirmedWorkspace=b.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:P,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(P){const{workspace:z,added:O,removed:S}=b.toExtHostWorkspace(P,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=z||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:O,removed:S}))}findFiles(P,z,O,S,x=w.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${S.value}, entryPoint: findFiles`);let N;if(z===null?N=!1:z&&(typeof z=="string"?N=z:N=z.pattern),x&&x.isCancellationRequested)return Promise.resolve([]);const{includePattern:V,folder:B}=E(P);return this._proxy.$startFileSearch((0,_.withUndefinedAsNull)(V),(0,_.withUndefinedAsNull)(B),(0,_.withUndefinedAsNull)(N),(0,_.withUndefinedAsNull)(O),x).then($=>Array.isArray($)?$.map(J=>n.URI.revive(J)):[])}async findTextInFiles(P,z,O,S,x=w.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${S.value}, entryPoint: findTextInFiles`);const N=this._requestIdProvider.getNext(),V=typeof z.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:z.previewOptions,{includePattern:B,folder:$}=E(z.include),J=typeof z.exclude=="string"?z.exclude:z.exclude?z.exclude.pattern:void 0,j={ignoreSymlinks:typeof z.followSymlinks=="boolean"?!z.followSymlinks:void 0,disregardIgnoreFiles:typeof z.useIgnoreFiles=="boolean"?!z.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof z.useGlobalIgnoreFiles=="boolean"?!z.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof z.useDefaultExcludes=="boolean"?!z.useDefaultExcludes:!0,fileEncoding:z.encoding,maxResults:z.maxResults,previewOptions:V,afterContext:z.afterContext,beforeContext:z.beforeContext,includePattern:B,excludePattern:J},Q=!1;if(this._activeSearchCallbacks[N]=le=>{if(Q)return;const be=n.URI.revive(le.resource);le.results.forEach(de=>{(0,s.resultIsMatch)(de)?O({uri:be,preview:{text:de.preview.text,matches:(0,u.mapArrayOrNot)(de.preview.matches,Fe=>new y.Range(Fe.startLineNumber,Fe.startColumn,Fe.endLineNumber,Fe.endColumn))},ranges:(0,u.mapArrayOrNot)(de.ranges,Fe=>new y.Range(Fe.startLineNumber,Fe.startColumn,Fe.endLineNumber,Fe.endColumn))}):O({uri:be,text:de.text,lineNumber:de.lineNumber})})},x.isCancellationRequested)return{};try{const le=await this._proxy.$startTextSearch(P,(0,_.withUndefinedAsNull)($),j,N,x);return delete this._activeSearchCallbacks[N],le||{}}catch(le){throw delete this._activeSearchCallbacks[N],le}}$handleTextSearchResult(P,z){this._activeSearchCallbacks[z]&&this._activeSearchCallbacks[z](P)}saveAll(P){return this._proxy.$saveAll(P)}resolveProxy(P){return this._proxy.$resolveProxy(P)}get trusted(){return this._trusted}requestWorkspaceTrust(P){return this._proxy.$requestWorkspaceTrust(P)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};d=Ne([xe(0,h.IExtHostRpcService),xe(1,l.IExtHostInitDataService),xe(2,f.IExtHostFileSystemInfo),xe(3,c.ILogService)],d),e.ExtHostWorkspace=d,e.IExtHostWorkspace=(0,a.createDecorator)("IExtHostWorkspace");function E(R){let P,z;return R&&(typeof R=="string"?P=R:(P=R.pattern,z=R.baseFolder||n.URI.file(R.base))),{includePattern:P,folder:z}}}),define(we[33],Ee([0,1,25,3,32,5,7,146,61,10,14,4,13,12,2]),function(re,e,u,M,w,A,t,T,C,k,F,_,n,g,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function c(I,r){if(r){const i=r.split(".");let v=I;for(let m=0;v&&m<i.length;m++)v=v[i[m]];return v}}function p(I){return I instanceof a.URI}function D(I){return I&&I.uri instanceof a.URI&&I.languageId&&typeof I.languageId=="string"}function f(I){return I&&!I.uri&&I.languageId&&typeof I.languageId=="string"}function l(I){return I&&I.uri instanceof a.URI&&(!I.name||typeof I.name=="string")&&(!I.index||typeof I.index=="number")}function h(I){if(p(I))return{resource:I};if(D(I))return{resource:I.uri,overrideIdentifier:I.languageId};if(f(I))return{overrideIdentifier:I.languageId};if(l(I))return{resource:I.uri};if(I===null)return{resource:null}}let y=class{constructor(r,i,v){this._proxy=r.getProxy(A.MainContext.MainThreadConfiguration),this._extHostWorkspace=i,this._logService=v,this._barrier=new F.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(r=>this._actual)}$initializeConfiguration(r){this._actual=new s(this._proxy,this._extHostWorkspace,r,this._logService),this._barrier.open()}$acceptConfigurationChanged(r,i){this.getConfigProvider().then(v=>v.$acceptConfigurationChanged(r,i))}};y=Ne([xe(0,n.IExtHostRpcService),xe(1,w.IExtHostWorkspace),xe(2,g.ILogService)],y),e.ExtHostConfiguration=y;class s{constructor(r,i,v,m){this._onDidChangeConfiguration=new M.Emitter,this._proxy=r,this._logService=m,this._extHostWorkspace=i,this._configuration=T.Configuration.parse(v),this._configurationScopes=this._toMap(v.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(r,i){const v={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=T.Configuration.parse(r),this._configurationScopes=this._toMap(r.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(i,v))}getConfiguration(r,i,v){const m=h(i)||{},o=this._toReadonlyValue(r?c(this._configuration.getValue(void 0,m,this._extHostWorkspace.workspace),r):this._configuration.getValue(void 0,m,this._extHostWorkspace.workspace));r&&this._validateConfigurationAccess(r,m,v?.identifier);function b(E){if(E==null)return null;if(typeof E=="boolean")return E?1:4;switch(E){case t.ConfigurationTarget.Global:return 1;case t.ConfigurationTarget.Workspace:return 4;case t.ConfigurationTarget.WorkspaceFolder:return 5}}const d={has(E){return typeof c(o,E)!="undefined"},get:(E,R)=>{this._validateConfigurationAccess(r?`${r}.${E}`:E,m,v?.identifier);let P=c(o,E);if(typeof P=="undefined")P=R;else{let z;const O=(S,x)=>{let N;const V=()=>{z=z||(0,u.deepClone)(o),N=N||c(z,x)};return(0,k.isObject)(S)?new Proxy(S,{get:(B,$)=>{if(typeof $=="string"&&$.toLowerCase()==="tojson")return V(),()=>N;if(z)return N=N||c(z,x),N[$];const J=B[$];return typeof $=="string"?O(J,`${x}.${$}`):J},set:(B,$,J)=>(V(),N&&(N[$]=J),!0),deleteProperty:(B,$)=>(V(),N&&delete N[$],!0),defineProperty:(B,$,J)=>(V(),N&&Object.defineProperty(N,$,J),!0)}):S};P=O(P,E)}return P},update:(E,R,P,z)=>{E=r?`${r}.${E}`:E;const O=b(P);return R!==void 0?this._proxy.$updateConfigurationOption(O,E,R,m,z):this._proxy.$removeConfigurationOption(O,E,m,z)},inspect:E=>{E=r?`${r}.${E}`:E;const R=(0,u.deepClone)(this._configuration.inspect(E,m,this._extHostWorkspace.workspace));if(R)return{key:E,defaultValue:R.default?.value,globalValue:R.user?.value,workspaceValue:R.workspace?.value,workspaceFolderValue:R.workspaceFolder?.value,defaultLanguageValue:R.default?.override,globalLanguageValue:R.user?.override,workspaceLanguageValue:R.workspace?.override,workspaceFolderLanguageValue:R.workspaceFolder?.override,languageIds:R.overrideIdentifiers}}};return typeof o=="object"&&(0,u.mixin)(d,o,!1),Object.freeze(d)}_toReadonlyValue(r){const i=v=>(0,k.isObject)(v)?new Proxy(v,{get:(m,o)=>i(m[o]),set:(m,o,b)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(o)}' of object`)},deleteProperty:(m,o)=>{throw new Error(`TypeError: Cannot delete read only property '${String(o)}' of object`)},defineProperty:(m,o)=>{throw new Error(`TypeError: Cannot define property '${String(o)}' for a readonly object`)},setPrototypeOf:m=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):v;return i(r)}_validateConfigurationAccess(r,i,v){const m=C.OVERRIDE_PROPERTY_REGEX.test(r)?4:this._configurationScopes.get(r),o=v?`[${v.value}] `:"";if(m===4){typeof i?.resource=="undefined"&&this._logService.warn(`${o}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${r}', provide the URI of a resource or 'null' for any resource.`);return}if(m===3){i?.resource&&this._logService.warn(`${o}Accessing a window scoped configuration for a resource is not expected. To associate '${r}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(r,i){const v=new T.ConfigurationChangeEvent(r,i,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(m,o)=>v.affectsConfiguration(m,h(o))})}_toMap(r){return r.reduce((i,v)=>(i.set(v[0],v[1]),i),new Map)}}e.ExtHostConfigProvider=s,e.IExtHostConfiguration=(0,_.createDecorator)("IExtHostConfiguration")});var Xe=this&&this.__classPrivateFieldSet||function(re,e,u,M,w){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!w:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?w.call(re,u):w?w.value=u:e.set(re,u),u},Te=this&&this.__classPrivateFieldGet||function(re,e,u,M){if(u==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?M:u==="a"?M.call(re):M?M.value:e.get(re)};define(we[98],Ee([0,1,2,14,3,5,7,32,49,33,20,39,13,28,4,11,24,12,70,165,15]),function(re,e,u,M,w,A,t,T,C,k,F,_,n,g,a,c,p,D,f,l,h){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var s;(function(x){function N(B){if(B!=null)return B}x.from=N;function V(B){if(B!=null)return B}x.to=V})(s=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var I;(function(x){function N(B){if(B!=null)return B}x.from=N;function V(B){if(B!=null)return B}x.to=V})(I=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var r;(function(x){function N(B){if(B!=null)return B}x.from=N;function V(B){if(B!=null)return B}x.to=V})(r=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var i;(function(x){function N($){if($){const J=$;return J&&!!J.process}else return!1}x.is=N;function V($){if($==null)return;const J={process:$.process,args:$.args};return $.options&&(J.options=r.from($.options)),J}x.from=V;function B($){if($!=null)return new t.ProcessExecution($.process,$.args,$.options)}x.to=B})(i=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var v;(function(x){function N(B){if(B!=null)return B}x.from=N;function V(B){if(B!=null)return B}x.to=V})(v=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var m;(function(x){function N($){if($){const J=$;return J&&(!!J.commandLine||!!J.command)}else return!1}x.is=N;function V($){if($==null)return;const J={};return $.commandLine!==void 0?J.commandLine=$.commandLine:(J.command=$.command,J.args=$.args),$.options&&(J.options=v.from($.options)),J}x.from=V;function B($){if(!($==null||$.command===void 0&&$.commandLine===void 0))return $.commandLine?new t.ShellExecution($.commandLine,$.options):new t.ShellExecution($.command,$.args?$.args:[],$.options)}x.to=B})(m=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var o;(function(x){function N($){if($){let J=$;return J&&J.customExecution==="customExecution"}else return!1}x.is=N;function V($){return{customExecution:"customExecution"}}x.from=V;function B($,J){return J.get($)}x.to=B})(o=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var b;(function(x){function N(V,B){let $;return V.scope!==void 0&&typeof V.scope!="number"?$=V.scope.uri:V.scope!==void 0&&typeof V.scope=="number"&&(V.scope===t.TaskScope.Workspace&&B&&B.workspaceFile?$=B.workspaceFile:$=l.USER_TASKS_GROUP_KEY),{id:V._id,workspaceFolder:$}}x.from=N})(b=e.TaskHandleDTO||(e.TaskHandleDTO={}));var d;(function(x){function N(V){if(V!=null)return{_id:V.id,isDefault:V.isDefault}}x.from=N})(d=e.TaskGroupDTO||(e.TaskGroupDTO={}));var E;(function(x){function N($,J){if($==null)return[];const j=[];for(let Q of $){const le=V(Q,J);le&&j.push(le)}return j}x.fromMany=N;function V($,J){if($==null)return;let j;$.execution instanceof t.ProcessExecution?j=i.from($.execution):$.execution instanceof t.ShellExecution?j=m.from($.execution):$.execution&&$.execution instanceof t.CustomExecution&&(j=o.from($.execution));const Q=s.from($.definition);let le;return $.scope?typeof $.scope=="number"?le=$.scope:le=$.scope.uri:le=t.TaskScope.Workspace,!Q||!le?void 0:{_id:$._id,definition:Q,name:$.name,source:{extensionId:J.identifier.value,label:$.source,scope:le},execution:j,isBackground:$.isBackground,group:d.from($.group),presentationOptions:I.from($.presentationOptions),problemMatchers:$.problemMatchers,hasDefinedMatchers:$.hasDefinedMatchers,runOptions:$.runOptions?$.runOptions:{reevaluateOnRerun:!0},detail:$.detail}}x.from=V;async function B($,J,j){if($==null)return;let Q;i.is($.execution)?Q=i.to($.execution):m.is($.execution)?Q=m.to($.execution):o.is($.execution)&&(Q=o.to($._id,j));const le=s.to($.definition);let be;if($.source&&($.source.scope!==void 0?typeof $.source.scope=="number"?be=$.source.scope:be=await J.resolveWorkspaceFolder(u.URI.revive($.source.scope)):be=t.TaskScope.Workspace),!le||!be)return;const de=new t.Task(le,be,$.name,$.source.label,Q,$.problemMatchers);return $.isBackground!==void 0&&(de.isBackground=$.isBackground),$.group!==void 0&&(de.group=t.TaskGroup.from($.group._id),de.group&&$.group.isDefault&&(de.group=new t.TaskGroup(de.group.id,de.group.label),$.group.isDefault&&(de.group.isDefault=$.group.isDefault))),$.presentationOptions&&(de.presentationOptions=I.to($.presentationOptions)),$._id&&(de._id=$._id),$.detail&&(de.detail=$.detail),de}x.to=B})(E=e.TaskDTO||(e.TaskDTO={}));var R;(function(x){function N(B){return B}x.from=N;function V(B){if(!!B)return Object.assign(Object.create(null),B)}x.to=V})(R=e.TaskFilterDTO||(e.TaskFilterDTO={}));class P{constructor(N,V,B){this._id=V,this._task=B,y.set(this,void 0),Xe(this,y,N,"f")}get task(){return this._task}terminate(){Te(this,y,"f").terminateTask(this)}fireDidStartProcess(N){}fireDidEndProcess(N){}}y=new WeakMap;var z;(function(x){function N(V){return{id:V._id,task:void 0}}x.from=N})(z=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let O=class{constructor(N,V,B,$,J,j,Q,le){this._onDidExecuteTask=new w.Emitter,this._onDidTerminateTask=new w.Emitter,this._onDidTaskProcessStarted=new w.Emitter,this._onDidTaskProcessEnded=new w.Emitter,this._proxy=N.getProxy(A.MainContext.MainThreadTask),this._workspaceProvider=B,this._editorService=$,this._configurationService=J,this._terminalService=j,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=Q,this._deprecationService=le,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(N,V,B){if(!B)return new t.Disposable(()=>{});const $=this.nextHandle();return this._handlers.set($,{type:V,provider:B,extension:N}),this._proxy.$registerTaskProvider($,V),new t.Disposable(()=>{this._handlers.delete($),this._proxy.$unregisterTaskProvider($)})}registerTaskSystem(N,V){this._proxy.$registerTaskSystem(N,V)}fetchTasks(N){return this._proxy.$fetchTasks(R.from(N)).then(async V=>{const B=[];for(let $ of V){const J=await E.to($,this._workspaceProvider,this._providedCustomExecutions2);J&&B.push(J)}return B})}get taskExecutions(){const N=[];return this._taskExecutions.forEach(V=>N.push(V)),N}terminateTask(N){if(!(N instanceof P))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(N._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(N,V,B){const $=this._providedCustomExecutions2.get(N.id);$&&(this._activeCustomExecutions2.set(N.id,$),this._terminalService.attachPtyToTerminal(V,await $.callback(B))),this._lastStartedTask=N.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(N)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(N){const V=await this.getTaskExecution(N);this._taskExecutionPromises.delete(N.id),this._taskExecutions.delete(N.id),this.customExecutionComplete(N),this._onDidTerminateTask.fire({execution:V})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(N){const V=await this.getTaskExecution(N.id);this._onDidTaskProcessStarted.fire({execution:V,processId:N.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(N){const V=await this.getTaskExecution(N.id);this._onDidTaskProcessEnded.fire({execution:V,exitCode:N.exitCode})}$provideTasks(N,V){const B=this._handlers.get(N);if(!B)return Promise.reject(new Error("no handler found"));const $=[],J=(0,M.asPromise)(()=>B.provider.provideTasks(F.CancellationToken.None)).then(j=>this.provideTasksInternal(V,$,B,j));return new Promise(j=>{J.then(Q=>{Promise.all($).then(()=>{j(Q)})})})}async $resolveTask(N,V){const B=this._handlers.get(N);if(!B)return Promise.reject(new Error("no handler found"));if(V.definition.type!==B.type)throw new Error(`Unexpected: Task of type [${V.definition.type}] cannot be resolved by provider of type [${B.type}].`);const $=await E.to(V,this._workspaceProvider,this._providedCustomExecutions2);if(!$)throw new Error("Unexpected: Task cannot be resolved.");const J=await B.provider.resolveTask($,F.CancellationToken.None);if(!J)return;this.checkDeprecation(J,B);const j=E.from(J,B.extension);if(!j)throw new Error("Unexpected: Task cannot be resolved.");if(J.definition!==$.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return o.is(j.execution)&&await this.addCustomExecution(j,J,!0),await this.resolveTaskInternal(j)}nextHandle(){return this._handleCounter++}async addCustomExecution(N,V,B){const $=await this._proxy.$createTaskId(N);!B&&!this._providedCustomExecutions2.has($)&&(this._notProvidedCustomExecutions.add($),this._activeCustomExecutions2.set($,V.execution)),this._providedCustomExecutions2.set($,V.execution)}async getTaskExecution(N,V){if(typeof N=="string"){const J=this._taskExecutionPromises.get(N);if(!J)throw new Error("Unexpected: The specified task is missing an execution");return J}let B=this._taskExecutionPromises.get(N.id);if(B)return B;const $=new Promise((J,j)=>{function Q(le,be,de){de?J(new P(le,be.id,de)):j("Unexpected: Task does not exist.")}V?Q(this,N,V):E.to(N.task,this._workspaceProvider,this._providedCustomExecutions2).then(le=>Q(this,N,le))});return this._taskExecutionPromises.set(N.id,$),$.then(J=>(this._taskExecutions.set(N.id,J),J),J=>Promise.reject(J))}checkDeprecation(N,V){N._deprecated&&this._deprecationService.report("Task.constructor",V.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(N){this._activeCustomExecutions2.get(N.id)&&this._activeCustomExecutions2.delete(N.id),this._notProvidedCustomExecutions.has(N.id)&&this._lastStartedTask!==N.id&&(this._providedCustomExecutions2.delete(N.id),this._notProvidedCustomExecutions.delete(N.id));let B=this._notProvidedCustomExecutions.values(),$=B.next();for(;!$.done;)!this._activeCustomExecutions2.has($.value)&&this._lastStartedTask!==$.value&&(this._providedCustomExecutions2.delete($.value),this._notProvidedCustomExecutions.delete($.value)),$=B.next()}};O=Ne([xe(0,n.IExtHostRpcService),xe(1,g.IExtHostInitDataService),xe(2,T.IExtHostWorkspace),xe(3,C.IExtHostDocumentsAndEditors),xe(4,k.IExtHostConfiguration),xe(5,_.IExtHostTerminalService),xe(6,D.ILogService),xe(7,f.IExtHostApiDeprecationService)],O),e.ExtHostTaskBase=O;let S=class extends O{constructor(N,V,B,$,J,j,Q,le){super(N,V,B,$,J,j,Q,le);this.registerTaskSystem(c.Schemas.vscodeRemote,{scheme:c.Schemas.vscodeRemote,authority:"",platform:p.PlatformToString(0)})}async executeTask(N,V){if(!V.execution)throw new Error("Tasks to execute must include an execution");const B=E.from(V,N);if(B===void 0)throw new Error("Task is not valid");if(o.is(B.execution))await this.addCustomExecution(B,V,!1);else throw new h.NotSupportedError;const $=await this.getTaskExecution(await this._proxy.$getTaskExecution(B),V);return this._proxy.$executeTask(B).catch(J=>{throw new Error(J)}),$}provideTasksInternal(N,V,B,$){const J=[];if($)for(let j of $){this.checkDeprecation(j,B),(!j.definition||!N[j.definition.type])&&this._logService.warn(`The task [${j.source}, ${j.name}] uses an undefined task type. The task will be ignored in the future.`);const Q=E.from(j,B.extension);Q&&o.is(Q.execution)?(J.push(Q),V.push(this.addCustomExecution(Q,j,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:J,extension:B.extension}}async resolveTaskInternal(N){if(o.is(N.execution))return N;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(N,V){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(N,V,B){}};S=Ne([xe(0,n.IExtHostRpcService),xe(1,g.IExtHostInitDataService),xe(2,T.IExtHostWorkspace),xe(3,C.IExtHostDocumentsAndEditors),xe(4,k.IExtHostConfiguration),xe(5,_.IExtHostTerminalService),xe(6,D.ILogService),xe(7,f.IExtHostApiDeprecationService)],S),e.WorkerExtHostTask=S,e.IExtHostTask=(0,a.createDecorator)("IExtHostTask")}),define(we[217],Ee([0,1,16,75,29,78,21,11,17,23,9,10,2,109,132,84,47,91,216,40]),function(re,e,u,M,w,A,t,T,C,k,F,_,n,g,a,c,p,D,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let h=class{constructor(b,d,E,R){this.configurationService=b,this.workspaceContextService=d,this.editorGroupsService=E,this.pathService=R}text(b,d,E={}){b=this.getContentPattern(b,E);const R=this.configurationService.getValue(),P=d&&d.some(O=>!this.configurationService.getValue({resource:O}).search.useRipgrep);return{...this.commonQuery(d?.map(p.toWorkspaceFolder),E),type:2,contentPattern:b,previewOptions:E.previewOptions,maxFileSize:E.maxFileSize,usePCRE2:R.search.usePCRE2||P||!1,beforeContext:E.beforeContext,afterContext:E.afterContext,userDisabledExcludesAndIgnoreFiles:E.disregardExcludeSettings&&E.disregardIgnoreFiles}}getContentPattern(b,d){const E=this.configurationService.getValue();b.isRegExp&&(b.pattern=b.pattern.replace(/\r?\n/g,"\\n"));const R={...b,wordSeparators:E.editor.wordSeparators};return this.isCaseSensitive(b,d)&&(R.isCaseSensitive=!0),this.isMultiline(b)&&(R.isMultiline=!0),R}file(b,d={}){return{...this.commonQuery(b,d),type:1,filePattern:d.filePattern?d.filePattern.trim():d.filePattern,exists:d.exists,sortByScore:d.sortByScore,cacheKey:d.cacheKey}}handleIncludeExclude(b,d){return b?(b=Array.isArray(b)?b.map(i):i(b),d?this.parseSearchPaths(b):{pattern:s(...Array.isArray(b)?b:[b])}):{}}commonQuery(b=[],d={}){const E=this.handleIncludeExclude(d.includePattern,d.expandPatterns),R=this.handleIncludeExclude(d.excludePattern,d.expandPatterns),P=b.length>1,z=(E.searchPaths&&E.searchPaths.length?E.searchPaths.map(x=>this.getFolderQueryForSearchPath(x,d,R)):b.map(x=>this.getFolderQueryForRoot(x,d,R,P))).filter(x=>!!x),O={_reason:d._reason,folderQueries:z,usingSearchPaths:!!(E.searchPaths&&E.searchPaths.length),extraFileResources:d.extraFileResources,excludePattern:R.pattern,includePattern:E.pattern,onlyOpenEditors:d.onlyOpenEditors,maxResults:d.maxResults};if(d.onlyOpenEditors){const N=u.coalesce(u.flatten(this.editorGroupsService.groups.map(B=>B.editors.map($=>$.resource)))).filter(B=>(0,l.pathIncludedInQuery)(O,B.fsPath)),V=this.commonQueryFromFileList(N);return{...O,...V}}const S=d.extraFileResources&&d.extraFileResources.filter(x=>(0,l.pathIncludedInQuery)(O,x.fsPath));return O.extraFileResources=S&&S.length?S:void 0,O}commonQueryFromFileList(b){const d=[],E=new t.ResourceMap,R={};let P=!1;return b.forEach(z=>{if(z.scheme===T.Schemas.walkThrough)return;if((0,k.isAbsolutePath)(z)){const S=this.workspaceContextService.getWorkspaceFolder(z)?.uri??z.with({path:C.dirname(z.fsPath)});let x=E.get(S);x||(P=!0,x={folder:S,includePattern:{}},d.push(x),E.set(S,x));const N=C.relative(S.fsPath,z.fsPath);(0,_.assertIsDefined)(x.includePattern)[N.replace(/\\/g,"/")]=!0}else z.fsPath&&(P=!0,R[z.fsPath]=!0)}),{folderQueries:d,includePattern:R,usingSearchPaths:!0,excludePattern:P?void 0:{"**/*":!0}}}isCaseSensitive(b,d){if(d.isSmartCase){if(b.isRegExp){if(F.containsUppercaseCharacter(b.pattern,!0))return!0}else if(F.containsUppercaseCharacter(b.pattern))return!0}return!!b.isCaseSensitive}isMultiline(b){return b.isMultiline||b.isRegExp&&(0,g.isMultilineRegexSource)(b.pattern)||b.pattern.indexOf(`
`)>=0?!0:!!b.isMultiline}parseSearchPaths(b){const d=V=>C.isAbsolute(V)||/^\.\.?([\/\\]|$)/.test(V),R=(Array.isArray(b)?b:I(b)).map(V=>{const B=this.pathService.resolvedUserHome;return B?(0,A.untildify)(V,B.scheme===T.Schemas.file?B.fsPath:B.path):V}),P=M.groupBy(R,V=>d(V)?"searchPaths":"exprSegments"),z=(P.exprSegments||[]).map(V=>F.rtrim(V,"/")).map(V=>F.rtrim(V,"\\")).map(V=>(V[0]==="."&&(V="*"+V),r(V))),O={},S=this.expandSearchPathPatterns(P.searchPaths||[]);S&&S.length&&(O.searchPaths=S);const x=u.flatten(z),N=s(...x);return N&&(O.pattern=N),O}getExcludesForFolder(b,d){return d.disregardExcludeSettings?void 0:(0,l.getExcludes)(b,!d.disregardSearchExcludeSettings)}expandSearchPathPatterns(b){if(!b||!b.length)return[];const d=u.flatten(b.map(R=>{let{pathPortion:P,globPortion:z}=y(R);z&&(z=v(z));const O=this.expandOneSearchPath(P);return u.flatten(O.map(S=>this.resolveOneSearchPathPattern(S,z)))})),E=new Map;return d.forEach(R=>{const P=R.searchPath.toString(),z=E.get(P);z?R.pattern&&(z.pattern=z.pattern||{},z.pattern[R.pattern]=!0):E.set(P,{searchPath:R.searchPath,pattern:R.pattern?s(R.pattern):void 0})}),Array.from(E.values())}expandOneSearchPath(b){if(C.isAbsolute(b)){const d=this.workspaceContextService.getWorkspace().folders;return d[0]&&d[0].uri.scheme!==T.Schemas.file?[{searchPath:d[0].uri.with({path:b})}]:[{searchPath:n.URI.file(C.normalize(b))}]}if(this.workspaceContextService.getWorkbenchState()===2){const d=this.workspaceContextService.getWorkspace().folders[0].uri;if(b=i(b),b.startsWith("../")||b===".."){const R=C.posix.resolve(d.path,b);return[{searchPath:d.with({path:R})}]}const E=v(b);return[{searchPath:d,pattern:E}]}else{if(b==="./"||b===".\\")return[];{const d=b.replace(/^\.[\/\\]/,""),R=this.workspaceContextService.getWorkspace().folders.map(P=>{const z=d.match(new RegExp(`^${F.escapeRegExpCharacters(P.name)}(?:/(.*)|$)`));return z?{match:z,folder:P}:null}).filter(_.isDefined);if(R.length)return R.map(P=>{const z=P.match[1];return{searchPath:P.folder.uri,pattern:z&&v(z)}});{const P=b.match(/\.[\/\\](.+)[\/\\]?/),z=P?P[1]:b,O=a.localize(0,null,z);throw new Error(O)}}}}resolveOneSearchPathPattern(b,d){const E=b.pattern&&d?`${b.pattern}/${d}`:b.pattern||d,R=[{searchPath:b.searchPath,pattern:E}];return E&&!E.endsWith("**")&&R.push({searchPath:b.searchPath,pattern:E+"/**"}),R}getFolderQueryForSearchPath(b,d,E){const R=this.getFolderQueryForRoot((0,p.toWorkspaceFolder)(b.searchPath),d,E,!1);return R?{...R,includePattern:b.pattern}:null}getFolderQueryForRoot(b,d,E,R){let P;const z=n.URI.isUri(b)?b:b.uri;if(E.searchPaths){const V=E.searchPaths.filter(B=>(0,k.isEqual)(B.searchPath,z))[0];if(V&&!V.pattern)return null;V&&(P=V.pattern)}const O=this.configurationService.getValue({resource:z}),x={...this.getExcludesForFolder(O,d)||{},...P||{}},N=n.URI.isUri(b)?(0,k.basename)(b):b.name;return{folder:z,folderName:R?N:void 0,excludePattern:Object.keys(x).length>0?x:void 0,fileEncoding:O.files&&O.files.encoding,disregardIgnoreFiles:typeof d.disregardIgnoreFiles=="boolean"?d.disregardIgnoreFiles:!O.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof d.disregardGlobalIgnoreFiles=="boolean"?d.disregardGlobalIgnoreFiles:!O.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof d.ignoreSymlinks=="boolean"?d.ignoreSymlinks:!O.search.followSymlinks}}};h=Ne([xe(0,c.IConfigurationService),xe(1,p.IWorkspaceContextService),xe(2,D.IEditorGroupsService),xe(3,f.IPathService)],h),e.QueryBuilder=h;function y(o){const b=o.match(/[\*\{\}\(\)\[\]\?]/);if(b){const d=b.index,E=o.substr(0,d).match(/[/|\\][^/\\]*$/);if(E){let R=o.substr(0,E.index);return R.match(/[/\\]/)||(R+="/"),{pathPortion:R,globPortion:o.substr((E.index||0)+1)}}}return{pathPortion:o}}function s(...o){return o.length?o.reduce((b,d)=>(b[d]=!0,b),Object.create(null)):void 0}function I(o){return w.splitGlobAware(o,",").map(b=>b.trim()).filter(b=>!!b.length)}function r(o){return[`**/${o}/**`,`**/${o}`].map(d=>d.replace(/\*\*\/\*\*/g,"**"))}function i(o){return o.replace(/\\/g,"/")}function v(o){return i(o).replace(/^\.\//,"").replace(/\/+$/g,"")}function m(o,b){o=u.distinct(o,R=>R.toString());const d=[],E=b.getWorkspace();return o&&o.forEach(R=>{let P;if(b.getWorkbenchState()===2)P=(0,k.relativePath)(E.folders[0].uri,R),P&&P!=="."&&(P="./"+P);else{const z=b.getWorkspaceFolder(R);if(z){const O=z.name;if(E.folders.filter(x=>x.name===O).length===1){const x=(0,k.relativePath)(z.uri,R);x===""?P=`./${z.name}`:P=`./${z.name}/${x}`}else P=R.fsPath}}P&&d.push(P)}),d}e.resolveResourcesForSearchIncludes=m}),define(we[218],Ee([0,1,23,2,20,15,4,217,40,47]),function(re,e,u,M,w,A,t,T,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const F=7e3;function _(c,p){const D=p.activationEvents;if(!D)return Promise.resolve(void 0);const f=[],l=[];for(const i of D)if(/^workspaceContains:/.test(i)){const v=i.substr("workspaceContains:".length);v.indexOf("*")>=0||v.indexOf("?")>=0||c.forceUsingSearch?l.push(v):f.push(v)}if(f.length===0&&l.length===0)return Promise.resolve(void 0);let h;const y=new Promise((i,v)=>{h=i}),s=i=>h({activationEvent:i}),I=Promise.all(f.map(i=>n(c,i,s))).then(()=>{}),r=g(c,p.identifier,l,s);return Promise.all([I,r]).then(()=>{h(void 0)}),y}e.checkActivateWorkspaceContainsExtension=_;async function n(c,p,D){for(const f of c.folders)if(await c.exists(u.joinPath(M.URI.revive(f),p))){D(`workspaceContains:${p}`);return}}async function g(c,p,D,f){if(D.length===0)return Promise.resolve(void 0);const l=new w.CancellationTokenSource,h=c.checkExists(c.folders,D,l.token),y=setTimeout(async()=>{l.cancel(),c.logService.info(`Not activating extension '${p.value}': Timed out while searching for 'workspaceContains' pattern ${D.join(",")}`)},F);let s=!1;try{s=await h}catch(I){A.isPromiseCanceledError(I)||A.onUnexpectedError(I)}l.dispose(),clearTimeout(y),s&&f(`workspaceContains:${D.join(",")}`)}function a(c,p,D,f){const l=c.get(t.IInstantiationService),h=c.get(C.ISearchService),s=l.createInstance(T.QueryBuilder).file(p.map(I=>(0,k.toWorkspaceFolder)(M.URI.revive(I))),{_reason:"checkExists",includePattern:D,exists:!0});return h.fileSearch(s,f).then(I=>!!I.limitHit,I=>A.isPromiseCanceledError(I)?!1:Promise.reject(I))}e.checkGlobFileExists=a});var Xe=this&&this.__classPrivateFieldSet||function(re,e,u,M,w){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!w:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?w.call(re,u):w?w.value=u:e.set(re,u),u},Te=this&&this.__classPrivateFieldGet||function(re,e,u,M){if(u==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?M:u==="a"?M.call(re):M?M.value:e.get(re)};define(we[34],Ee([0,1,124,17,74,23,14,6,21,2,12,5,33,178,72,32,27,176,15,26,22,151,7,85,4,28,73,13,60,65,39,3,218,69,153,11]),function(re,e,u,M,w,A,t,T,C,k,F,_,n,g,a,c,p,D,f,l,h,y,s,I,r,i,v,m,o,b,d,E,R,P,z,O){"use strict";var S,x,N;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,r.createDecorator)("IHostUtils");let V=class ji extends T.Disposable{constructor(j,Q,le,be,de,Fe,Ge,Le,We,Ye){super();this._onDidChangeRemoteConnectionData=this._register(new E.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=Q,this._extHostContext=le,this._initData=Ge,this._extHostWorkspace=be,this._extHostConfiguration=de,this._logService=Fe,this._extHostTunnelService=We,this._extHostTerminalService=Ye,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(_.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(_.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(_.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new t.Barrier,this._readyToStartExtensionHost=new t.Barrier,this._readyToRunExtensions=new t.Barrier,this._eagerExtensionsActivated=new t.Barrier,this._registry=new D.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new a.ExtHostStorage(this._extHostContext),this._secretState=new P.ExtHostSecretState(this._extHostContext),this._storagePath=Le,this._instaService=j.createChild(new o.ServiceCollection([a.IExtHostStorage,this._storage],[P.IExtHostSecretState,this._secretState]));const Qe=new Set;this._initData.hostExtensions.forEach(Ke=>Qe.add(l.ExtensionIdentifier.toKey(Ke))),this._activator=this._register(new g.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(Ke,W,K)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(Ke,f.transformErrorForSerialization(W),K)},actualActivateExtension:async(Ke,W)=>{if(Qe.has(l.ExtensionIdentifier.toKey(Ke)))return await this._mainThreadExtensionsProxy.$activateExtension(Ke,W),new g.HostExtension;const K=this._registry.getExtensionDescription(Ke);return this._activateExtension(K,W)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),w.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(j){f.onUnexpectedError(j)}}async deactivateAll(){this._storagePath.onWillDeactivateAll();let j=[];try{j=this._registry.getAllExtensionDescriptions().map(de=>de.identifier).filter(de=>this.isActivated(de)).map(de=>this._deactivate(de))}catch(Q){}await Promise.all(j)}isActivated(j){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(j):!1}_activateByEvent(j,Q){return this._activator.activateByEvent(j,Q)}_activateById(j,Q){return this._activator.activateById(j,Q)}activateByIdWithErrors(j,Q){return this._activateById(j,Q).then(()=>{const le=this._activator.getActivatedExtension(j);if(le.activationFailed)return Promise.reject(le.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(j=>this._registry)}getExtensionExports(j){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(j).exports:null}async _realPathExtensionUri(j){if(j.scheme!==O.Schemas.file)return j;const Q=await this._hostUtils.realpath(j.fsPath);return k.URI.file(Q)}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=(async()=>{const j=C.TernarySearchTree.forUris(Q=>A.extUriBiasedIgnorePathCase.ignorePathCasing(Q));for(const Q of this._registry.getAllExtensionDescriptions())if(this._getEntryPoint(Q)){const le=await this._realPathExtensionUri(Q.extensionLocation);j.set(le,Q)}return j})()),this._extensionPathIndex}_deactivate(j){let Q=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(j))return Q;const le=this._activator.getActivatedExtension(j);if(!le)return Q;try{typeof le.module.deactivate=="function"&&(Q=Promise.resolve(le.module.deactivate()).then(void 0,be=>(this._logService.error(be),Promise.resolve(void 0))))}catch(be){this._logService.error(be)}try{(0,T.dispose)(le.subscriptions)}catch(be){this._logService.error(be)}return Q}async _activateExtension(j,Q){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(j.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(j.identifier),this._doActivateExtension(j,Q).then(le=>{const be=le.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(j.identifier,be.codeLoadingTime,be.activateCallTime,be.activateResolvedTime,Q),this._logExtensionActivationTimes(j,Q,"success",be),le},le=>{throw this._logExtensionActivationTimes(j,Q,"failure"),le})}_logExtensionActivationTimes(j,Q,le,be){const de=B(j,Q);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...de,...be||{},outcome:le})}_doActivateExtension(j,Q){const le=B(j,Q);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",le);const be=this._getEntryPoint(j);if(!be)return Promise.resolve(new g.EmptyExtension(g.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${j.identifier.value}, startup: ${Q.startup}, activationEvent: '${Q.activationEvent}'${j.identifier.value!==Q.extensionId.value?`, root cause: ${Q.extensionId.value}`:""}`),this._logService.flush();const de=new g.ExtensionActivationTimesBuilder(Q.startup);return Promise.all([this._loadCommonJSModule(j.identifier,(0,A.joinPath)(j.extensionLocation,be),de),this._loadExtensionContext(j)]).then(Fe=>(w.mark(`code/extHost/willActivateExtension/${j.identifier.value}`),ji._callActivate(this._logService,j.identifier,Fe[0],Fe[1],de))).then(Fe=>(w.mark(`code/extHost/didActivateExtension/${j.identifier.value}`),Fe))}_loadExtensionContext(j){const Q=new y.ExtensionGlobalMemento(j,this._storage),le=new y.ExtensionMemento(j.identifier.value,!1,this._storage),be=new z.ExtensionSecrets(j,this._secretState),de=j.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?s.ExtensionMode.Test:s.ExtensionMode.Development:s.ExtensionMode.Production,Fe=this._initData.remote.isRemote?s.ExtensionKind.Workspace:s.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${j.identifier.value}`),Promise.all([Q.whenReady,le.whenReady,this._storagePath.whenReady]).then(()=>{const Ge=this;let Le;return Object.freeze({globalState:Q,workspaceState:le,secrets:be,subscriptions:[],get extensionUri(){return j.extensionLocation},get extensionPath(){return j.extensionLocation.fsPath},asAbsolutePath(We){return M.join(j.extensionLocation.fsPath,We)},get storagePath(){return Ge._storagePath.workspaceValue(j)?.fsPath},get globalStoragePath(){return Ge._storagePath.globalValue(j).fsPath},get logPath(){return M.join(Ge._initData.logsLocation.fsPath,j.identifier.value)},get logUri(){return k.URI.joinPath(Ge._initData.logsLocation,j.identifier.value)},get storageUri(){return Ge._storagePath.workspaceValue(j)},get globalStorageUri(){return Ge._storagePath.globalValue(j)},get extensionMode(){return de},get extension(){return Le===void 0&&(Le=new $(Ge,j.identifier,j,Fe)),Le},get extensionRuntime(){return(0,p.checkProposedApiEnabled)(j,"extensionRuntime"),Ge.extensionRuntime},get environmentVariableCollection(){return Ge._extHostTerminalService.getEnvironmentVariableCollection(j)}})})}static _callActivate(j,Q,le,be,de){return le=le||{activate:void 0,deactivate:void 0},this._callActivateOptional(j,Q,le,be,de).then(Fe=>new g.ActivatedExtension(!1,null,de.build(),le,Fe,be.subscriptions))}static _callActivateOptional(j,Q,le,be,de){if(typeof le.activate=="function")try{de.activateCallStart(),j.trace(`ExtensionService#_callActivateOptional ${Q.value}`);const Fe=typeof global=="object"?global:self,Ge=le.activate.apply(Fe,[be]);return de.activateCallStop(),de.activateResolveStart(),Promise.resolve(Ge).then(Le=>(de.activateResolveStop(),Le))}catch(Fe){return Promise.reject(Fe)}else return Promise.resolve(le)}_activateOneStartupFinished(j,Q){this._activateById(j.identifier,{startup:!1,extensionId:j.identifier,activationEvent:Q}).then(void 0,le=>{this._logService.error(le)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(w.getMarks());for(const j of this._registry.getAllExtensionDescriptions())if(j.activationEvents)for(const Q of j.activationEvents)Q==="onStartupFinished"&&this._activateOneStartupFinished(j,Q)}_handleEagerExtensions(){const j=this._activateByEvent("*",!0).then(void 0,de=>{this._logService.error(de)});this._register(this._extHostWorkspace.onDidChangeWorkspace(de=>this._handleWorkspaceContainsEagerExtensions(de.added)));const Q=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],le=this._handleWorkspaceContainsEagerExtensions(Q),be=Promise.all([j,le]).then(()=>{});return Promise.race([be,(0,t.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),be}_handleWorkspaceContainsEagerExtensions(j){return j.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(Q=>this._handleWorkspaceContainsEagerExtension(j,Q))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(j,Q){if(this.isActivated(Q.identifier))return;const le=!this._initData.remote.isRemote&&!!this._initData.remote.authority,be={logService:this._logService,folders:j.map(Fe=>Fe.uri),forceUsingSearch:le,exists:Fe=>this._hostUtils.exists(Fe.fsPath),checkExists:(Fe,Ge,Le)=>this._mainThreadWorkspaceProxy.$checkExists(Fe,Ge,Le)},de=await(0,R.checkActivateWorkspaceContainsExtension)(be,Q);if(!!de)return this._activateById(Q.identifier,{startup:!0,extensionId:Q.identifier,activationEvent:de.activationEvent}).then(void 0,Fe=>this._logService.error(Fe))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(j){throw console.error(j),j}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:j,extensionTestsLocationURI:Q}=this._initData.environment;if(!j||!Q)throw new Error(u.localize(0,null));const le=await this._loadCommonJSModule(null,Q,new g.ExtensionActivationTimesBuilder(!1));if(!le||typeof le.run!="function")throw new Error(u.localize(1,null,Q.toString()));return new Promise((be,de)=>{const Fe=(We,Ye)=>{We?de(We):be(typeof Ye=="number"&&Ye>0?1:0)},Ge=(0,A.originalFSPath)(Q),Le=le.run(Ge,Fe);Le&&Le.then&&Le.then(()=>{be(0)}).catch(We=>{de(We.toString())})})}async $extensionTestsExit(j){this._logService.info(`Extension host terminating: test runner requested exit with code ${j}`),this._hostUtils.pid&&this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${j}`),this._logService.flush(),this._hostUtils.exit(j)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(j,Q){return this._resolvers[j]=Q,(0,T.toDisposable)(()=>{delete this._resolvers[j]})}async _activateAndGetResolver(j){const Q=j.indexOf("+");if(Q===-1)throw new Error("Not an authority that can be resolved!");const le=j.substr(0,Q);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${le}`,!1),{authorityPrefix:le,resolver:this._resolvers[le]}}async $resolveAuthority(j,Q){const{authorityPrefix:le,resolver:be}=await this._activateAndGetResolver(j);if(!be)return{type:"error",error:{code:I.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${le}.`,detail:void 0}};try{this._register(await this._extHostTunnelService.setTunnelExtensionFunctions(be)),w.mark(`code/extHost/willResolveAuthority/${le}`);const de=await be.resolve(j,{resolveAttempt:Q});w.mark(`code/extHost/didResolveAuthorityOK/${le}`);const Fe={authority:j,host:de.host,port:de.port,connectionToken:de.connectionToken},Ge={extensionHostEnv:de.extensionHostEnv,isTrusted:de.isTrusted,authenticationSession:de.authenticationSessionForInitializingExtensions?{id:de.authenticationSessionForInitializingExtensions.id,providerId:de.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:Fe,options:Ge,tunnelInformation:{environmentTunnels:de.environmentTunnels}}}}catch(de){if(w.mark(`code/extHost/didResolveAuthorityError/${le}`),de instanceof s.RemoteAuthorityResolverError)return{type:"error",error:{code:de._code,message:de._message,detail:de._detail}};throw de}}async $getCanonicalURI(j,Q){const{authorityPrefix:le,resolver:be}=await this._activateAndGetResolver(j);if(!be)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${le}`);const de=k.URI.revive(Q);if(typeof be.getCanonicalURI=="undefined")return de;const Fe=await(0,t.asPromise)(()=>be.getCanonicalURI(de));return Fe||de}$startExtensionHost(j){return this._registry.keepOnly(j),this._startExtensionHost()}$activateByEvent(j,Q){return Q===1?this._activateByEvent(j,!1):this._readyToRunExtensions.wait().then(le=>this._activateByEvent(j,!1))}async $activate(j,Q){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(j)?(await this._activateById(j,Q),!0):!1}async $deltaExtensions(j,Q){j.forEach(be=>be.extensionLocation=k.URI.revive(be.extensionLocation));const le=await this.getExtensionPathIndex();return await Promise.all(Q.map(async be=>{const de=this._registry.getExtensionDescription(be);de&&le.delete(await this._realPathExtensionUri(de.extensionLocation))})),await Promise.all(j.map(async be=>{const de=await this._realPathExtensionUri(be.extensionLocation);le.set(de,be)})),this._registry.deltaExtensions(j,Q),Promise.resolve(void 0)}async $test_latency(j){return j}async $test_up(j){return j.byteLength}async $test_down(j){let Q=h.VSBuffer.alloc(j),le=Math.random()%256;for(let be=0;be<j;be++)Q.writeUInt8(le,be);return Q}async $updateRemoteConnectionData(j){this._remoteConnectionData=j,this._onDidChangeRemoteConnectionData.fire()}};V=Ne([xe(0,r.IInstantiationService),xe(1,e.IHostUtils),xe(2,m.IExtHostRpcService),xe(3,c.IExtHostWorkspace),xe(4,n.IExtHostConfiguration),xe(5,F.ILogService),xe(6,i.IExtHostInitDataService),xe(7,v.IExtensionStoragePaths),xe(8,b.IExtHostTunnelService),xe(9,d.IExtHostTerminalService)],V),e.AbstractExtHostExtensionService=V;function B(J,j){return{id:J.identifier.value,name:J.name,extensionVersion:J.version,publisherDisplayName:J.publisher,activationEvents:J.activationEvents?J.activationEvents.join(","):null,isBuiltin:J.isBuiltin,reason:j.activationEvent,reasonId:j.extensionId.value}}e.IExtHostExtensionService=(0,r.createDecorator)("IExtHostExtensionService");class ${constructor(j,Q,le,be){S.set(this,void 0),x.set(this,void 0),N.set(this,void 0),Xe(this,S,j,"f"),Xe(this,x,Q,"f"),Xe(this,N,le.identifier,"f"),this.id=le.identifier.value,this.extensionUri=le.extensionLocation,this.extensionPath=M.normalize((0,A.originalFSPath)(le.extensionLocation)),this.packageJSON=le,this.extensionKind=be}get isActive(){return Te(this,S,"f").isActivated(Te(this,N,"f"))}get exports(){if(this.packageJSON.api!=="none")return Te(this,S,"f").getExtensionExports(Te(this,N,"f"))}activate(){return Te(this,S,"f").activateByIdWithErrors(Te(this,N,"f"),{startup:!1,extensionId:Te(this,x,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=$,S=new WeakMap,x=new WeakMap,N=new WeakMap}),define(we[99],Ee([0,1,17,2,3,14,5,7,160,32,34,49,167,33,161,13,4,10,90,71]),function(re,e,u,M,w,A,t,T,C,k,F,_,n,g,a,c,p,D,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,p.createDecorator)("IExtHostDebugService");let h=class{constructor(o,b,d,E,R,P){this._workspaceService=b,this._extensionService=d,this._editorsService=E,this._configurationService=R,this._editorTabs=P,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new w.Emitter,this._onDidTerminateDebugSession=new w.Emitter,this._onDidChangeActiveDebugSession=new w.Emitter,this._onDidReceiveDebugSessionCustomEvent=new w.Emitter,this._debugServiceProxy=o.getProxy(t.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new w.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new s(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(z=>{z.onDidChange(O=>{this.registerAllDebugTypes(z)}),this.registerAllDebugTypes(z)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(o,b){const d=o;if(typeof d.sourceReference=="number"&&d.sourceReference>0){let E=`debug:${encodeURIComponent(d.path||"")}`,R="?";return b&&(E+=`${R}session=${encodeURIComponent(b.id)}`,R="&"),E+=`${R}ref=${d.sourceReference}`,M.URI.parse(E)}else{if(d.path)return M.URI.file(d.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(o){const b=[];for(const d of o.getAllExtensionDescriptions())if(d.contributes){const E=d.contributes.debuggers;if(E&&E.length>0)for(const R of E)(0,a.isDebuggerMainContribution)(R)&&b.push(R.type)}this._debugServiceProxy.$registerDebugTypes(b)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const o=[];return this._breakpoints.forEach(b=>o.push(b)),o}addBreakpoints(o){this.startBreakpoints();const b=o.filter(R=>{const P=R.id;return this._breakpoints.has(P)?!1:(this._breakpoints.set(P,R),!0)});this.fireBreakpointChanges(b,[],[]);const d=[],E=new Map;for(const R of b)if(R instanceof T.SourceBreakpoint){let P=E.get(R.location.uri.toString());P||(P={type:"sourceMulti",uri:R.location.uri,lines:[]},E.set(R.location.uri.toString(),P),d.push(P)),P.lines.push({id:R.id,enabled:R.enabled,condition:R.condition,hitCondition:R.hitCondition,logMessage:R.logMessage,line:R.location.range.start.line,character:R.location.range.start.character})}else R instanceof T.FunctionBreakpoint&&d.push({type:"function",id:R.id,enabled:R.enabled,hitCondition:R.hitCondition,logMessage:R.logMessage,condition:R.condition,functionName:R.functionName});return this._debugServiceProxy.$registerBreakpoints(d)}removeBreakpoints(o){this.startBreakpoints();const b=o.filter(P=>this._breakpoints.delete(P.id));this.fireBreakpointChanges([],b,[]);const d=b.filter(P=>P instanceof T.SourceBreakpoint).map(P=>P.id),E=b.filter(P=>P instanceof T.FunctionBreakpoint).map(P=>P.id),R=b.filter(P=>P instanceof T.DataBreakpoint).map(P=>P.id);return this._debugServiceProxy.$unregisterBreakpoints(d,E,R)}startDebugging(o,b,d){return this._debugServiceProxy.$startDebugging(o?o.uri:void 0,b,{parentSessionID:d.parentSession?d.parentSession.id:void 0,lifecycleManagedByParent:d.lifecycleManagedByParent,repl:d.consoleMode===T.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:d.noDebug,compact:d.compact,debugUI:d.debugUI,suppressSaveBeforeStart:d.suppressSaveBeforeStart})}stopDebugging(o){return this._debugServiceProxy.$stopDebugging(o?o.id:void 0)}registerDebugConfigurationProvider(o,b,d){if(!b)return new T.Disposable(()=>{});const E=this._configProviderHandleCounter++;return this._configProviders.push({type:o,handle:E,provider:b}),this._debugServiceProxy.$registerDebugConfigurationProvider(o,d,!!b.provideDebugConfigurations,!!b.resolveDebugConfiguration,!!b.resolveDebugConfigurationWithSubstitutedVariables,E),new T.Disposable(()=>{this._configProviders=this._configProviders.filter(R=>R.provider!==b),this._debugServiceProxy.$unregisterDebugConfigurationProvider(E)})}registerDebugAdapterDescriptorFactory(o,b,d){if(!d)return new T.Disposable(()=>{});if(!this.definesDebugType(o,b))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${b}' debugger.`);if(this.getAdapterDescriptorFactoryByType(b))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const E=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:b,handle:E,factory:d}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(b,E),new T.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(R=>R.factory!==d),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(E)})}registerDebugAdapterTrackerFactory(o,b){if(!b)return new T.Disposable(()=>{});const d=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:o,handle:d,factory:b}),new T.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(E=>E.factory!==b)})}async $runInTerminal(o,b){return Promise.resolve(void 0)}async $substituteVariables(o,b){if(!this._variableResolver){const[R,P]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(R||[],this._editorsService,P)}let d;const E=await this.getFolder(o);return E&&(d={uri:E.uri,name:E.name,index:E.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(d,b)}createDebugAdapter(o,b){if(o.type==="implementation")return new i(o.implementation)}createSignService(){}async $startDASession(o,b){const d=this,E=await this.getSession(b);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(E.type),E).then(R=>{if(!R)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${E.type}' (extension might have failed to activate)`);const P=this.convertToDto(R),z=this.createDebugAdapter(P,E);if(!z)throw new Error(`Couldn't create a debug adapter for type '${E.type}'.`);const O=z;return this._debugAdapters.set(o,O),this.getDebugAdapterTrackers(E).then(S=>(S&&this._debugAdaptersTrackers.set(o,S),O.onMessage(async x=>{if(x.type==="request"&&x.command==="handshake"){const N=x,V={type:"response",seq:0,command:N.command,request_seq:N.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const B=await this._signService.sign(N.arguments.value);V.body={signature:B},O.sendResponse(V)}else throw new Error("no signer")}catch(B){V.success=!1,V.message=B.message,O.sendResponse(V)}}else S&&S.onDidSendMessage&&S.onDidSendMessage(x),x=(0,a.convertToVSCPaths)(x,!0),d._debugServiceProxy.$acceptDAMessage(o,x)}),O.onError(x=>{S&&S.onError&&S.onError(x),this._debugServiceProxy.$acceptDAError(o,x.name,x.message,x.stack)}),O.onExit(x=>{S&&S.onExit&&S.onExit((0,D.withNullAsUndefined)(x),void 0),this._debugServiceProxy.$acceptDAExit(o,(0,D.withNullAsUndefined)(x),void 0)}),S&&S.onWillStartSession&&S.onWillStartSession(),O.startSession()))})}$sendDAMessage(o,b){b=(0,a.convertToDAPaths)(b,!1);const d=this._debugAdaptersTrackers.get(o);d&&d.onWillReceiveMessage&&d.onWillReceiveMessage(b);const E=this._debugAdapters.get(o);E&&E.sendMessage(b)}$stopDASession(o){const b=this._debugAdaptersTrackers.get(o);this._debugAdaptersTrackers.delete(o),b&&b.onWillStopSession&&b.onWillStopSession();const d=this._debugAdapters.get(o);return this._debugAdapters.delete(o),d?d.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(o){const b=[],d=[],E=[];if(o.added)for(const R of o.added){const P=R.id;if(P&&!this._breakpoints.has(P)){let z;if(R.type==="function")z=new T.FunctionBreakpoint(R.functionName,R.enabled,R.condition,R.hitCondition,R.logMessage);else if(R.type==="data")z=new T.DataBreakpoint(R.label,R.dataId,R.canPersist,R.enabled,R.hitCondition,R.condition,R.logMessage);else{const O=M.URI.revive(R.uri);z=new T.SourceBreakpoint(new T.Location(O,new T.Position(R.line,R.character)),R.enabled,R.condition,R.hitCondition,R.logMessage)}z._id=P,this._breakpoints.set(P,z),b.push(z)}}if(o.removed)for(const R of o.removed){const P=this._breakpoints.get(R);P&&(this._breakpoints.delete(R),d.push(P))}if(o.changed){for(const R of o.changed)if(R.id){const P=this._breakpoints.get(R.id);if(P){if(P instanceof T.FunctionBreakpoint&&R.type==="function"){const z=P;z.enabled=R.enabled,z.condition=R.condition,z.hitCondition=R.hitCondition,z.logMessage=R.logMessage,z.functionName=R.functionName}else if(P instanceof T.SourceBreakpoint&&R.type==="source"){const z=P;z.enabled=R.enabled,z.condition=R.condition,z.hitCondition=R.hitCondition,z.logMessage=R.logMessage,z.location=new T.Location(M.URI.revive(R.uri),new T.Position(R.line,R.character))}E.push(P)}}}this.fireBreakpointChanges(b,d,E)}$provideDebugConfigurations(o,b,d){return(0,A.asPromise)(async()=>{const E=this.getConfigProviderByHandle(o);if(!E)throw new Error("no DebugConfigurationProvider found");if(!E.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const R=await this.getFolder(b);return E.provideDebugConfigurations(R,d)}).then(E=>{if(!E)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return E})}$resolveDebugConfiguration(o,b,d,E){return(0,A.asPromise)(async()=>{const R=this.getConfigProviderByHandle(o);if(!R)throw new Error("no DebugConfigurationProvider found");if(!R.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const P=await this.getFolder(b);return R.resolveDebugConfiguration(P,d,E)})}$resolveDebugConfigurationWithSubstitutedVariables(o,b,d,E){return(0,A.asPromise)(async()=>{const R=this.getConfigProviderByHandle(o);if(!R)throw new Error("no DebugConfigurationProvider found");if(!R.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const P=await this.getFolder(b);return R.resolveDebugConfigurationWithSubstitutedVariables(P,d,E)})}async $provideDebugAdapter(o,b){const d=this.getAdapterDescriptorFactoryByHandle(o);if(!d)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const E=await this.getSession(b);return this.getAdapterDescriptor(d,E).then(R=>{if(!R)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${E.type}'`);return this.convertToDto(R)})}async $acceptDebugSessionStarted(o){const b=await this.getSession(o);this._onDidStartDebugSession.fire(b)}async $acceptDebugSessionTerminated(o){const b=await this.getSession(o);b&&(this._onDidTerminateDebugSession.fire(b),this._debugSessions.delete(b.id))}async $acceptDebugSessionActiveChanged(o){this._activeDebugSession=o?await this.getSession(o):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(o,b){const d=await this.getSession(o);d&&d._acceptNameChanged(b)}async $acceptDebugSessionCustomEvent(o,b){const E={session:await this.getSession(o),event:b.event,body:b.body};this._onDidReceiveDebugSessionCustomEvent.fire(E)}convertToDto(o){if(o instanceof T.DebugAdapterExecutable)return{type:"executable",command:o.command,args:o.args,options:o.options};if(o instanceof T.DebugAdapterServer)return{type:"server",port:o.port,host:o.host};if(o instanceof T.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:o.path};if(o instanceof T.DebugAdapterInlineImplementation)return{type:"implementation",implementation:o.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(o){const b=this._adapterFactories.filter(d=>d.type===o);if(b.length>0)return b[0].factory}getAdapterDescriptorFactoryByHandle(o){const b=this._adapterFactories.filter(d=>d.handle===o);if(b.length>0)return b[0].factory}getConfigProviderByHandle(o){const b=this._configProviders.filter(d=>d.handle===o);if(b.length>0)return b[0].provider}definesDebugType(o,b){if(o.contributes){const d=o.contributes.debuggers;if(d&&d.length>0){for(const E of d)if(E.label&&E.type&&E.type===b)return!0}}return!1}getDebugAdapterTrackers(o){const d=o.configuration.type,E=this._trackerFactories.filter(R=>R.type===d||R.type==="*").map(R=>(0,A.asPromise)(()=>R.factory.createDebugAdapterTracker(o)).then(P=>P,P=>null));return Promise.race([Promise.all(E).then(R=>{const P=R.filter(z=>!!z);if(P.length>0)return new r(P)}),new Promise((R,P)=>{const z=setTimeout(()=>{clearTimeout(z),P(new Error("timeout"))},1e3)})]).catch(R=>{})}async getAdapterDescriptor(o,b){const d=b.configuration.debugServer;if(typeof d=="number")return Promise.resolve(new T.DebugAdapterServer(d));if(o){const R=await this._extensionService.getExtensionRegistry();return(0,A.asPromise)(()=>o.createDebugAdapterDescriptor(b,this.daExecutableFromPackage(b,R))).then(P=>{if(P)return P})}const E=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(b,E))}daExecutableFromPackage(o,b){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(o,b,d){(o.length>0||b.length>0||d.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:o,removed:b,changed:d}))}async getSession(o){if(o)if(typeof o=="string"){const b=this._debugSessions.get(o);if(b)return b}else{let b=this._debugSessions.get(o.id);if(!b){const d=await this.getFolder(o.folderUri),E=o.parent?this._debugSessions.get(o.parent):void 0;b=new y(this._debugServiceProxy,o.id,o.type,o.name,d,o.configuration,E),this._debugSessions.set(b.id,b),this._debugServiceProxy.$sessionCached(b.id)}return b}throw new Error("cannot find session")}getFolder(o){if(o){const b=M.URI.revive(o);return this._workspaceService.resolveWorkspaceFolder(b)}return Promise.resolve(void 0)}};h=Ne([xe(0,c.IExtHostRpcService),xe(1,k.IExtHostWorkspace),xe(2,F.IExtHostExtensionService),xe(3,_.IExtHostDocumentsAndEditors),xe(4,g.IExtHostConfiguration),xe(5,l.IExtHostEditorTabs)],h),e.ExtHostDebugServiceBase=h;class y{constructor(o,b,d,E,R,P,z){this._debugServiceProxy=o,this._id=b,this._type=d,this._name=E,this._workspaceFolder=R,this._configuration=P,this._parentSession=z}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(o){this._name=o,this._debugServiceProxy.$setDebugSessionName(this._id,o)}get parentSession(){return this._parentSession}_acceptNameChanged(o){this._name=o}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(o,b){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,o,b)}getDebugProtocolBreakpoint(o){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,o.id)}}e.ExtHostDebugSession=y;class s{constructor(o){this.value=Object.freeze({append(b){o.$appendDebugConsole(b)},appendLine(b){this.append(b+`
`)}})}}e.ExtHostDebugConsole=s;class I extends n.AbstractVariableResolverService{constructor(o,b,d,E,R){function P(){if(b){const z=b.activeEditor();if(z)return z.document.uri;const O=E.tabs.filter(S=>S.isActive);if(O.length>0){const S=O[0].resource;return S&&(S.primary||S.secondary)?S.primary??S.secondary:O[0].resource}}}super({getFolderUri:z=>{const O=o.filter(S=>S.name===z);if(O&&O.length>0)return O[0].uri},getWorkspaceFolderCount:()=>o.length,getConfigurationValue:(z,O)=>d.getConfiguration(void 0,z).get(O),getAppRoot:()=>f.cwd(),getExecPath:()=>f.env.VSCODE_EXEC_PATH,getFilePath:()=>{const z=P();if(z)return u.normalize(z.fsPath)},getWorkspaceFolderPathForFile:()=>{if(R){const z=P();if(z){const O=R.getWorkspaceFolder(z);if(O)return u.normalize(O.uri.fsPath)}}},getSelectedText:()=>{if(b){const z=b.activeEditor();if(z&&!z.selection.isEmpty)return z.document.getText(z.selection)}},getLineNumber:()=>{if(b){const z=b.activeEditor();if(z)return String(z.selection.end.line+1)}}},void 0,Promise.resolve(f.env))}}e.ExtHostVariableResolverService=I;class r{constructor(o){this.trackers=o}onWillStartSession(){this.trackers.forEach(o=>o.onWillStartSession?o.onWillStartSession():void 0)}onWillReceiveMessage(o){this.trackers.forEach(b=>b.onWillReceiveMessage?b.onWillReceiveMessage(o):void 0)}onDidSendMessage(o){this.trackers.forEach(b=>b.onDidSendMessage?b.onDidSendMessage(o):void 0)}onWillStopSession(){this.trackers.forEach(o=>o.onWillStopSession?o.onWillStopSession():void 0)}onError(o){this.trackers.forEach(b=>b.onError?b.onError(o):void 0)}onExit(o,b){this.trackers.forEach(d=>d.onExit?d.onExit(o,b):void 0)}}class i extends C.AbstractDebugAdapter{constructor(o){super();this.implementation=o,o.onDidSendMessage(b=>{this.acceptMessage(b)})}startSession(){return Promise.resolve(void 0)}sendMessage(o){this.implementation.handleMessage(o)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let v=class extends h{constructor(o,b,d,E,R,P){super(o,b,d,E,R,P)}createVariableResolver(o,b,d){return new I(o,b,d,this._editorTabs)}};v=Ne([xe(0,c.IExtHostRpcService),xe(1,k.IExtHostWorkspace),xe(2,F.IExtHostExtensionService),xe(3,_.IExtHostDocumentsAndEditors),xe(4,g.IExtHostConfiguration),xe(5,l.IExtHostEditorTabs)],v),e.WorkerExtHostDebugService=v}),define(we[219],Ee([0,1,74,2,5,33,27,26,13,28,4,34,90,12]),function(re,e,u,M,w,A,t,T,C,k,F,_,n,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let a=class{constructor(l,h,y,s,I,r,i){this._apiFactory=l,this._extensionRegistry=h,this._instaService=y,this._extHostConfiguration=s,this._extHostExtensionService=I,this._initData=r,this._logService=i,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),u.mark("code/extHost/willWaitForConfig");const l=await this._extHostConfiguration.getConfigProvider();u.mark("code/extHost/didWaitForConfig");const h=await this._extHostExtensionService.getExtensionPathIndex();this.register(new c(this._apiFactory,h,this._extensionRegistry,l,this._logService)),this.register(this._instaService.createInstance(p,h)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(D,h,this._initData.environment.appUriScheme))}register(l){if(Array.isArray(l.nodeModuleName))for(let h of l.nodeModuleName)this._factories.set(h,l);else this._factories.set(l.nodeModuleName,l);typeof l.alternativeModuleName=="function"&&this._alternatives.push(h=>l.alternativeModuleName(h))}};a=Ne([xe(2,F.IInstantiationService),xe(3,A.IExtHostConfiguration),xe(4,_.IExtHostExtensionService),xe(5,k.IExtHostInitDataService),xe(6,g.ILogService)],a),e.RequireInterceptor=a;class c{constructor(l,h,y,s,I){this._apiFactory=l,this._extensionPaths=h,this._extensionRegistry=y,this._configProvider=s,this._logService=I,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(l,h){const y=this._extensionPaths.findSubstr(h);if(y){let s=this._extApiImpl.get(T.ExtensionIdentifier.toKey(y.identifier));return s||(s=this._apiFactory(y,this._extensionRegistry,this._configProvider),this._extApiImpl.set(T.ExtensionIdentifier.toKey(y.identifier),s)),s}if(!this._defaultApiImpl){let s="";this._extensionPaths.forEach((I,r)=>s+=`	${r} -> ${I.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${h}. These are the extension path mappings: 
${s}`),this._defaultApiImpl=this._apiFactory(t.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let p=class{constructor(l,h,y){this._extensionPaths=l,this.nodeModuleName="keytar",this._mainThreadTelemetry=h.getProxy(w.MainContext.MainThreadTelemetry);const{environment:s}=y,I=h.getProxy(w.MainContext.MainThreadKeytar);if(s.appRoot){let r=s.appRoot.fsPath;n.platform==="win32"&&(r=r.replace(/\\/g,"/")),r[r.length-1]==="/"&&(r=r.substr(0,r.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${r}/node_modules.asar/keytar`),this.alternativeNames.add(`${r}/node_modules/keytar`)}this._impl={getPassword:(r,i)=>I.$getPassword(r,i),setPassword:(r,i,v)=>I.$setPassword(r,i,v),deletePassword:(r,i)=>I.$deletePassword(r,i),findPassword:r=>I.$findPassword(r),findCredentials(r){return I.$findCredentials(r)}}}load(l,h){const y=this._extensionPaths.findSubstr(h);return this._mainThreadTelemetry.$publicLog2("shimming.keytar",{extension:y?.identifier.value??"unknown_extension"}),this._impl}alternativeModuleName(l){const h=l.length;if(h<=7||!this.alternativeNames)return;const y=h-7;if((l.charAt(y)==="/"||l.charAt(y)==="\\")&&l.endsWith("keytar")&&(l=l.replace(/\\/g,"/"),this.alternativeNames.has(l)))return"keytar"}};p=Ne([xe(1,C.IExtHostRpcService),xe(2,k.IExtHostInitDataService)],p);let D=class{constructor(l,h,y){this._extensionPaths=l,this._appUriScheme=h,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=y.getProxy(w.MainContext.MainThreadTelemetry);const s=y.getProxy(w.MainContext.MainThreadWindow);this._impl=(I,r)=>{const i=M.URI.parse(I);return r?this.callOriginal(I,r):i.scheme==="http"||i.scheme==="https"?s.$openUri(i,I,{allowTunneling:!0}):i.scheme==="mailto"||i.scheme===this._appUriScheme?s.$openUri(i,I,{}):this.callOriginal(I,r)}}load(l,h,y){const s=this._extensionPaths.findSubstr(h);return s&&(this._extensionId=s.identifier.value,this.sendShimmingTelemetry()),this._original=y(l),this._impl}callOriginal(l,h){return this.sendNoForwardTelemetry(),this._original(l,h)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};D=Ne([xe(2,C.IExtHostRpcService)],D)}),define(we[220],Ee([0,1,14,15,74,6,2,5,213,12,57,60,28,141,13,66,34,39]),function(re,e,u,M,w,A,t,T,C,k,F,_,n,g,a,c,p,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class f{constructor(h,y,s,I){this._disposables=new A.DisposableStore,this._isTerminating=!1,this._hostUtils=s,this._rpcProtocol=new C.RPCProtocol(h,null,I),y=f._transform(y,this._rpcProtocol);const r=new _.ServiceCollection(...(0,F.getSingletonServiceDescriptors)());r.set(n.IExtHostInitDataService,{_serviceBrand:void 0,...y}),r.set(a.IExtHostRpcService,new a.ExtHostRpcService(this._rpcProtocol)),r.set(c.IURITransformerService,new c.URITransformerService(I)),r.set(p.IHostUtils,s);const i=new g.InstantiationService(r,!0);this._disposables.add(i.invokeFunction(b=>b.get(D.IExtHostTerminalService))),this._disposables.add(i.invokeFunction(b=>b.get(p.IExtHostExtensionService))),this._logService=i.invokeFunction(b=>b.get(k.ILogService)),w.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",y),this._extensionService=i.invokeFunction(b=>b.get(p.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const v=new WeakMap;this._extensionService.getExtensionPathIndex().then(b=>{Error.prepareStackTrace=(d,E)=>{let R="",P,z;for(const O of E)R+=`
	at ${O.toString()}`,z=O.getFileName(),!P&&z&&(P=b.findSubstr(t.URI.file(z)));return v.set(d,P),`${d.name||"Error"}: ${d.message||""}${R}`}});const m=this._rpcProtocol.getProxy(T.MainContext.MainThreadExtensionService),o=this._rpcProtocol.getProxy(T.MainContext.MainThreadErrors);M.setUnexpectedErrorHandler(b=>{const d=M.transformErrorForSerialization(b),E=v.get(b);E?m.$onExtensionRuntimeError(E.identifier,d):o.$onUnexpectedError(d)})}terminate(h){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${h}`),this._logService.flush(),this._disposables.dispose(),M.setUnexpectedErrorHandler(s=>{this._logService.error(s)}),this._rpcProtocol.dispose();const y=this._extensionService.deactivateAll();Promise.race([(0,u.timeout)(5e3),y]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code 0`):this._logService.info("Extension host exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})}static _transform(h,y){h.extensions.forEach(I=>I.extensionLocation=t.URI.revive(y.transformIncomingURIs(I.extensionLocation))),h.environment.appRoot=t.URI.revive(y.transformIncomingURIs(h.environment.appRoot));const s=h.environment.extensionDevelopmentLocationURI;return s&&(h.environment.extensionDevelopmentLocationURI=s.map(I=>t.URI.revive(y.transformIncomingURIs(I)))),h.environment.extensionTestsLocationURI=t.URI.revive(y.transformIncomingURIs(h.environment.extensionTestsLocationURI)),h.environment.globalStorageHome=t.URI.revive(y.transformIncomingURIs(h.environment.globalStorageHome)),h.environment.workspaceStorageHome=t.URI.revive(y.transformIncomingURIs(h.environment.workspaceStorageHome)),h.logsLocation=t.URI.revive(y.transformIncomingURIs(h.logsLocation)),h.logFile=t.URI.revive(y.transformIncomingURIs(h.logFile)),h.workspace=y.transformIncomingURIs(h.workspace),h}}e.ExtensionHostMain=f}),define(we[221],Ee([0,1,17,20,44,29,23,194,40]),function(re,e,u,M,w,A,t,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class k{constructor(n,g,a){this.config=n,this.provider=g,this.sessionToken=a,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=n.filePattern,this.includePattern=n.includePattern&&A.parse(n.includePattern),this.maxResults=n.maxResults||void 0,this.exists=n.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=n.excludePattern&&A.parse(n.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(n=>n.cancel()),this.activeCancellationTokens=new Set}search(n){const g=this.config.folderQueries||[];return new Promise((a,c)=>{const p=D=>{this.resultCount++,n(D)};if(this.isCanceled)return a({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(D=>{const f=D.toString(),l=u.basename(f);this.globalExcludePattern&&this.globalExcludePattern(f,l)||this.matchFile(p,{base:D,basename:l})}),Promise.all(g.map(D=>this.searchInFolder(D,p))).then(D=>{a({limitHit:this.isLimitHit,stats:D[0]||void 0})},D=>{c(new Error((0,w.toErrorMessage)(D)))})})}async searchInFolder(n,g){const a=new M.CancellationTokenSource,c=this.getSearchOptionsForFolder(n),p=this.initDirectoryTree(),D=new C.QueryGlobTester(this.config,n),f=!D.hasSiblingExcludeClauses();let l;try{this.activeCancellationTokens.add(a),l=T.StopWatch.create();const h=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},c,a.token),y=l.elapsed(),s=T.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(h&&h.forEach(I=>{const r=u.posix.relative(n.folder.path,I.path);if(f){const i=u.basename(I.path);this.matchFile(g,{base:n.folder,relativePath:r,basename:i});return}this.addDirectoryEntries(p,n.folder,r,g)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(p,D,g),{providerTime:y,postProcessTime:s.elapsed()})}finally{a.dispose(),this.activeCancellationTokens.delete(a)}}getSearchOptionsForFolder(n){const g=(0,C.resolvePatternsForProvider)(this.config.includePattern,n.includePattern),a=(0,C.resolvePatternsForProvider)(this.config.excludePattern,n.excludePattern);return{folder:n.folder,excludes:a,includes:g,useIgnoreFiles:!n.disregardIgnoreFiles,useGlobalIgnoreFiles:!n.disregardGlobalIgnoreFiles,followSymlinks:!n.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const n={rootEntries:[],pathToEntries:Object.create(null)};return n.pathToEntries["."]=n.rootEntries,n}addDirectoryEntries({pathToEntries:n},g,a,c){if(a===this.filePattern){const D=u.basename(this.filePattern);this.matchFile(c,{base:g,relativePath:this.filePattern,basename:D})}function p(D){const f=u.basename(D),l=u.dirname(D);let h=n[l];h||(h=n[l]=[],p(l)),h.push({base:g,relativePath:D,basename:f})}p(a)}matchDirectoryTree({rootEntries:n,pathToEntries:g},a,c){const p=this,D=this.filePattern;function f(l){const h=A.hasSiblingFn(()=>l.map(y=>y.basename));for(let y=0,s=l.length;y<s;y++){const I=l[y],{relativePath:r,basename:i}=I;if(a.matchesExcludesSync(r,i,D!==i?h:void 0))continue;const v=g[r];if(v)f(v);else{if(r===D)continue;p.matchFile(c,I)}if(p.isLimitHit)break}}f(n)}matchFile(n,g){(!this.includePattern||g.relativePath&&this.includePattern(g.relativePath,g.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||n(g))}}class F{constructor(){this.sessions=new Map}fileSearch(n,g,a,c){const p=this.getSessionTokenSource(n.cacheKey),D=new k(n,g,p&&p.token);let f=0;const l=h=>{f+=h.length,a(h.map(y=>this.rawMatchToSearchItem(y)))};return this.doSearch(D,F.BATCH_SIZE,l,c).then(h=>({limitHit:h.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:f,detailStats:h.stats}}))}clearCache(n){const g=this.getSessionTokenSource(n);g&&g.cancel()}getSessionTokenSource(n){if(!!n)return this.sessions.has(n)||this.sessions.set(n,new M.CancellationTokenSource),this.sessions.get(n)}rawMatchToSearchItem(n){return n.relativePath?{resource:t.joinPath(n.base,n.relativePath)}:{resource:n.base}}doSearch(n,g,a,c){c.onCancellationRequested(()=>{n.cancel()});const p=f=>{f&&(D.push(f),g>0&&D.length>=g&&(a(D),D=[]))};let D=[];return n.search(p).then(f=>(D.length&&a(D),f),f=>(D.length&&a(D),Promise.reject(f)))}}e.FileSearchManager=F,F.BATCH_SIZE=512}),define(we[222],Ee([0,1,16,20,44,29,11,17,23,10,2,40]),function(re,e,u,M,w,A,t,T,C,k,F,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class n{constructor(l,h,y,s){this.query=l,this.provider=h,this.fileUtils=y,this.processType=s,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(l,h){const y=this.query.folderQueries||[],s=new M.CancellationTokenSource;return h.onCancellationRequested(()=>s.cancel()),new Promise((I,r)=>{this.collector=new a(l);let i=!1;const v=(m,o)=>{if(!i&&!this.isLimitHit){const b=this.resultSize(m);p(m)&&typeof this.query.maxResults=="number"&&this.resultCount+b>this.query.maxResults&&(this.isLimitHit=!0,i=!0,s.cancel(),m=this.trimResultToSize(m,this.query.maxResults-this.resultCount));const d=this.resultSize(m);this.resultCount+=d,(d>0||!p(m))&&this.collector.add(m,o)}};Promise.all(y.map((m,o)=>this.searchInFolder(m,b=>v(b,o),s.token))).then(m=>{s.dispose(),this.collector.flush();const o=m.some(b=>!!b&&!!b.limitHit);I({limitHit:this.isLimitHit||o,messages:(0,u.flatten)(m.map(b=>b?.message?(0,k.isArray)(b.message)?b.message:[b.message]:[])),stats:{type:this.processType}})},m=>{s.dispose();const o=(0,w.toErrorMessage)(m);r(new Error(o))})})}resultSize(l){return p(l)?Array.isArray(l.ranges)?l.ranges.length:1:0}trimResultToSize(l,h){const y=Array.isArray(l.ranges)?l.ranges:[l.ranges],s=Array.isArray(l.preview.matches)?l.preview.matches:[l.preview.matches];return{ranges:y.slice(0,h),preview:{matches:s.slice(0,h),text:l.preview.text},uri:l.uri}}async searchInFolder(l,h,y){const s=new _.QueryGlobTester(this.query,l),I=[],r={report:m=>{if(!this.validateProviderResult(m))return;const o=l.folder.scheme===t.Schemas.file?A.hasSiblingPromiseFn(()=>this.fileUtils.readdir(C.dirname(m.uri))):void 0,b=C.relativePath(l.folder,m.uri);if(b){const d=s.includedInQuery(b,T.basename(b),o);(0,k.isPromise)(d)?I.push(d.then(E=>{E&&h(m)})):d&&h(m)}}},i=this.getSearchOptionsForFolder(l),v=await this.provider.provideTextSearchResults(g(this.query.contentPattern),i,r,y);return I.length&&await Promise.all(I),v}validateProviderResult(l){if(p(l)){if(Array.isArray(l.ranges)){if(!Array.isArray(l.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(l.preview.matches.length!==l.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(l.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(l){const h=(0,_.resolvePatternsForProvider)(this.query.includePattern,l.includePattern),y=(0,_.resolvePatternsForProvider)(this.query.excludePattern,l.excludePattern),s={folder:F.URI.from(l.folder),excludes:y,includes:h,useIgnoreFiles:!l.disregardIgnoreFiles,useGlobalIgnoreFiles:!l.disregardGlobalIgnoreFiles,followSymlinks:!l.ignoreSymlinks,encoding:l.fileEncoding&&this.fileUtils.toCanonicalName(l.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return s.usePCRE2=this.query.usePCRE2,s}}e.TextSearchManager=n;function g(f){return{isCaseSensitive:f.isCaseSensitive||!1,isRegExp:f.isRegExp||!1,isWordMatch:f.isWordMatch||!1,isMultiline:f.isMultiline||!1,pattern:f.pattern}}class a{constructor(l){this._onResult=l,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new D(512,h=>this.sendItems(h))}add(l,h){this._currentFileMatch&&(this._currentFolderIdx!==h||!C.isEqual(this._currentUri,l.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=h,this._currentFileMatch={resource:l.uri,results:[]}),this._currentFileMatch.results.push(c(l))}pushToCollector(){const l=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,l)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(l){this._onResult(l)}}e.TextSearchResultsCollector=a;function c(f){return p(f)?{preview:{matches:(0,u.mapArrayOrNot)(f.preview.matches,l=>({startLineNumber:l.start.line,startColumn:l.start.character,endLineNumber:l.end.line,endColumn:l.end.character})),text:f.preview.text},ranges:(0,u.mapArrayOrNot)(f.ranges,l=>({startLineNumber:l.start.line,startColumn:l.start.character,endLineNumber:l.end.line,endColumn:l.end.character}))}:{text:f.text,lineNumber:f.lineNumber}}function p(f){return!!f.preview}e.extensionResultIsMatch=p;class D{constructor(l,h){this.maxBatchSize=l,this.cb=h,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(l,h){!l||this.addItemToBatch(l,h)}addItems(l,h){!l||this.addItemsToBatch(l,h)}addItemToBatch(l,h){this.batch.push(l),this.batchSize+=h,this.onUpdate()}addItemsToBatch(l,h){this.batch=this.batch.concat(l),this.batchSize+=h,this.onUpdate()}onUpdate(){this.totalNumberCompleted<D.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},D.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=D,D.TIMEOUT=4e3,D.START_BATCH_AFTER_COUNT=50}),define(we[100],Ee([0,1,6,5,4,221,13,66,12,2,222]),function(re,e,u,M,w,A,t,T,C,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,w.createDecorator)("IExtHostSearch");let _=class{constructor(c,p,D){this.extHostRpc=c,this._uriTransformer=p,this._logService=D,this._proxy=this.extHostRpc.getProxy(M.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new A.FileSearchManager}_transformScheme(c){return this._uriTransformer.transformOutgoingScheme(c)}registerTextSearchProvider(c,p){if(this._textSearchUsedSchemes.has(c))throw new Error(`a text search provider for the scheme '${c}' is already registered`);this._textSearchUsedSchemes.add(c);const D=this._handlePool++;return this._textSearchProvider.set(D,p),this._proxy.$registerTextSearchProvider(D,this._transformScheme(c)),(0,u.toDisposable)(()=>{this._textSearchUsedSchemes.delete(c),this._textSearchProvider.delete(D),this._proxy.$unregisterProvider(D)})}registerFileSearchProvider(c,p){if(this._fileSearchUsedSchemes.has(c))throw new Error(`a file search provider for the scheme '${c}' is already registered`);this._fileSearchUsedSchemes.add(c);const D=this._handlePool++;return this._fileSearchProvider.set(D,p),this._proxy.$registerFileSearchProvider(D,this._transformScheme(c)),(0,u.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(c),this._fileSearchProvider.delete(D),this._proxy.$unregisterProvider(D)})}$provideFileSearchResults(c,p,D,f){const l=n(D),h=this._fileSearchProvider.get(c);if(h)return this._fileSearchManager.fileSearch(l,h,y=>{this._proxy.$handleFileMatch(c,p,y.map(s=>s.resource))},f);throw new Error("unknown provider: "+c)}$clearCache(c){return this._fileSearchManager.clearCache(c),Promise.resolve(void 0)}$provideTextSearchResults(c,p,D,f){const l=this._textSearchProvider.get(c);if(!l||!l.provideTextSearchResults)throw new Error(`Unknown provider ${c}`);const h=n(D);return this.createTextSearchManager(h,l).search(s=>this._proxy.$handleTextMatch(c,p,s),f)}$enableExtensionHostSearch(){}createTextSearchManager(c,p){return new F.TextSearchManager(c,p,{readdir:D=>Promise.resolve([]),toCanonicalName:D=>D},"textSearchProvider")}};_=Ne([xe(0,t.IExtHostRpcService),xe(1,T.IURITransformerService),xe(2,C.ILogService)],_),e.ExtHostSearch=_;function n(a){return{...a,folderQueries:a.folderQueries&&a.folderQueries.map(g),extraFileResources:a.extraFileResources&&a.extraFileResources.map(c=>k.URI.revive(c))}}e.reviveQuery=n;function g(a){return{...a,folder:k.URI.revive(a.folder)}}}),define(we[223],Ee([0,1,20,15,3,35,2,117,80,111,56,46,5,184,183,38,185,33,186,187,188,169,189,49,34,190,170,193,195,197,95,172,202,203,204,72,39,206,173,8,7,209,51,96,32,75,158,192,62,94,98,99,100,12,66,13,28,198,155,65,70,181,207,154,73,50,212,210,211,182,31,205,208,69,71,86,200,97,201,11,143,199,152,191,6,27]),function(re,e,u,M,w,A,t,T,C,k,F,_,n,g,a,c,p,D,f,l,h,y,s,I,r,i,v,m,o,b,d,E,R,P,z,O,S,x,N,V,B,$,J,j,Q,le,be,de,Fe,Ge,Le,We,Ye,Qe,Ke,W,K,Z,se,G,te,he,Pe,Oe,Be,Ve,Ze,ot,ye,it,q,X,ge,Ue,qe,nt,mt,lt,St,kt,It,Je,bt,Ie,Se,pe){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function oe(ae){const ue=ae.get(K.IExtHostInitDataService),fe=ae.get(q.IExtHostFileSystemInfo),ke=ae.get(Ve.IExtHostConsumerFileSystem),$e=ae.get(r.IExtHostExtensionService),Re=ae.get(Q.IExtHostWorkspace),ze=ae.get(nt.IExtHostTelemetry),tt=ae.get(D.IExtHostConfiguration),rt=ae.get(Ke.IURITransformerService),ne=ae.get(W.IExtHostRpcService),me=ae.get(O.IExtHostStorage),ie=ae.get(Be.IExtensionStoragePaths),H=ae.get(Qe.ILoggerService),ve=ae.get(Qe.ILogService),De=ae.get(G.IExtHostTunnelService),je=ae.get(te.IExtHostApiDeprecationService),Me=ae.get(j.IExtHostWindow),dt=ae.get(Ue.IExtHostSecretState),wt=ae.get(qe.IExtHostEditorTabs);ne.set(n.ExtHostContext.ExtHostFileSystemInfo,fe),ne.set(n.ExtHostContext.ExtHostLogLevelServiceShape,H),ne.set(n.ExtHostContext.ExtHostWorkspace,Re),ne.set(n.ExtHostContext.ExtHostConfiguration,tt),ne.set(n.ExtHostContext.ExtHostExtensionService,$e),ne.set(n.ExtHostContext.ExtHostStorage,me),ne.set(n.ExtHostContext.ExtHostTunnelService,De),ne.set(n.ExtHostContext.ExtHostWindow,Me),ne.set(n.ExtHostContext.ExtHostSecretState,dt),ne.set(n.ExtHostContext.ExtHostTelemetry,ze),ne.set(n.ExtHostContext.ExtHostEditorTabs,wt);const Ct=ne.set(n.ExtHostContext.ExtHostDecorations,ae.get(Ge.IExtHostDecorations)),pt=ne.set(n.ExtHostContext.ExtHostDocumentsAndEditors,ae.get(I.IExtHostDocumentsAndEditors)),ut=ne.set(n.ExtHostContext.ExtHostCommands,ae.get(c.IExtHostCommands)),ht=ne.set(n.ExtHostContext.ExtHostTerminalService,ae.get(S.IExtHostTerminalService)),vt=ne.set(n.ExtHostContext.ExtHostDebugService,ae.get(We.IExtHostDebugService)),Ft=ne.set(n.ExtHostContext.ExtHostSearch,ae.get(Ye.IExtHostSearch)),Tt=ne.set(n.ExtHostContext.ExtHostTask,ae.get(Le.IExtHostTask)),Mt=ne.set(n.ExtHostContext.ExtHostOutputService,ae.get(d.IExtHostOutputService)),xt=ne.set(n.ExtHostContext.ExtHostUrls,new $.ExtHostUrls(ne)),At=ne.set(n.ExtHostContext.ExtHostDocuments,new s.ExtHostDocuments(ne,pt)),ri=ne.set(n.ExtHostContext.ExtHostDocumentContentProviders,new h.ExtHostDocumentContentProvider(ne,pt,ve)),zt=ne.set(n.ExtHostContext.ExtHostDocumentSaveParticipant,new y.ExtHostDocumentSaveParticipant(ve,At,ne.getProxy(n.MainContext.MainThreadBulkEdits))),Et=ne.set(n.ExtHostContext.ExtHostNotebook,new Z.ExtHostNotebookController(ne,ut,pt,At,ie)),Kt=ne.set(n.ExtHostContext.ExtHostNotebookDocuments,new bt.ExtHostNotebookDocuments(ve,Et)),Ht=ne.set(n.ExtHostContext.ExtHostNotebookEditors,new Je.ExtHostNotebookEditors(ve,ne,Et)),oi=ne.set(n.ExtHostContext.ExtHostNotebookKernels,new mt.ExtHostNotebookKernels(ne,ue,Et,ut,ve)),si=ne.set(n.ExtHostContext.ExtHostNotebookRenderers,new St.ExtHostNotebookRenderers(ne,Et)),Pt=ne.set(n.ExtHostContext.ExtHostEditors,new x.ExtHostEditors(ne,pt)),Qt=ne.set(n.ExtHostContext.ExtHostTreeViews,new N.ExtHostTreeViews(ne.getProxy(n.MainContext.MainThreadTreeViews),ut,ve)),ai=ne.set(n.ExtHostContext.ExtHostEditorInsets,new be.ExtHostEditorInsets(ne.getProxy(n.MainContext.MainThreadEditorInsets),Pt,ue)),Yt=ne.set(n.ExtHostContext.ExtHostDiagnostics,new f.ExtHostDiagnostics(ne,ve,fe)),Wt=ne.set(n.ExtHostContext.ExtHostLanguages,new o.ExtHostLanguages(ne,At,ut.converter,rt)),gt=ne.set(n.ExtHostContext.ExtHostLanguageFeatures,new m.ExtHostLanguageFeatures(ne,rt,At,ut,Yt,ve,je)),ci=ne.set(n.ExtHostContext.ExtHostFileSystem,new i.ExtHostFileSystem(ne,gt)),Lt=ne.set(n.ExtHostContext.ExtHostFileSystemEventService,new v.ExtHostFileSystemEventService(ne,ve,pt)),Vt=ne.set(n.ExtHostContext.ExtHostQuickOpen,(0,R.createExtHostQuickOpen)(ne,Re,ut)),Xt=ne.set(n.ExtHostContext.ExtHostSCM,new P.ExtHostSCM(ne,ut,ve)),li=ne.set(n.ExtHostContext.ExtHostComments,(0,p.createExtHostComments)(ne,ut,At)),fi=ne.set(n.ExtHostContext.ExtHostProgress,new E.ExtHostProgress(ne.getProxy(n.MainContext.MainThreadProgress))),Ei=ne.set(n.ExtHostContext.ExtHosLabelService,new de.ExtHostLabelService(ne)),mi=ne.set(n.ExtHostContext.ExtHostTheming,new se.ExtHostTheming(ne)),Jt=ne.set(n.ExtHostContext.ExtHostAuthentication,new he.ExtHostAuthentication(ne)),_i=ne.set(n.ExtHostContext.ExtHostTimeline,new Pe.ExtHostTimeline(ne,ut)),jt=ne.set(n.ExtHostContext.ExtHostWebviews,new J.ExtHostWebviews(ne,{remote:ue.remote},Re,ve,je)),qt=ne.set(n.ExtHostContext.ExtHostWebviewPanels,new ye.ExtHostWebviewPanels(ne,jt,Re)),yi=ne.set(n.ExtHostContext.ExtHostCustomEditors,new ot.ExtHostCustomEditors(ne,At,ie,jt,qt)),Si=ne.set(n.ExtHostContext.ExtHostWebviewViews,new Ze.ExtHostWebviewViews(ne,jt)),Gt=ne.set(n.ExtHostContext.ExtHostTesting,new X.ExtHostTesting(ne,ut)),Ci=ne.set(n.ExtHostContext.ExtHostUriOpeners,new ge.ExtHostUriOpeners(ne));ne.set(n.ExtHostContext.ExtHostInteractive,new Ie.ExtHostInteractive(ne,Et,pt,ut));const Zt=(0,le.values)(n.ExtHostContext);ne.assertRegistered(Zt);const Di=new it.ExtHostBulkEdits(ne,pt),ki=new a.ExtHostClipboard(ne),ui=new b.ExtHostMessageService(ne,ve),ei=new l.ExtHostDialogs(ne),gi=new z.ExtHostStatusBar(ne,ut.converter);return g.ExtHostApiCommands.register(ut),function(Ae,Ot,pi){const ft=function(){let Y=!Ae.isUnderDevelopment;function ce(){Y||(ve.info(`Extension '${Ae.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),Y=!0)}return function Ce(at){if(Array.isArray(at))at.forEach(Ce);else if(typeof at=="string")ce();else{const _t=at;typeof _t.scheme=="undefined"&&ce(),typeof _t.exclusive=="boolean"&&(0,pe.checkProposedApiEnabled)(Ae,"documentFiltersExclusive")}return at}}(),ti={getSession(Y,ce,Ce){return Jt.getSession(Ae,Y,ce,Ce)},async hasSession(Y,ce){return(0,pe.checkProposedApiEnabled)(Ae,"authSession"),!!await Jt.getSession(Ae,Y,ce,{silent:!0})},get onDidChangeSessions(){return Jt.onDidChangeSessions},registerAuthenticationProvider(Y,ce,Ce,at){return Jt.registerAuthenticationProvider(Y,ce,Ce,at)}},Ii={registerCommand(Y,ce,Ce){return ut.registerCommand(!0,Y,ce,Ce,void 0,Ae)},registerTextEditorCommand(Y,ce,Ce){return ut.registerCommand(!0,Y,(...at)=>{const _t=Pt.getActiveTextEditor();if(!_t){ve.warn("Cannot execute "+Y+" because there is no active text editor.");return}return _t.edit(yt=>{ce.apply(Ce,[_t,yt,...at])}).then(yt=>{yt||ve.warn("Edits from command "+Y+" were not applied.")},yt=>{ve.warn("An error occurred while running command "+Y,yt)})},void 0,void 0,Ae)},registerDiffInformationCommand:(Y,ce,Ce)=>((0,pe.checkProposedApiEnabled)(Ae,"diffCommand"),ut.registerCommand(!0,Y,async(...at)=>{const _t=pt.activeEditor(!0);if(!_t){ve.warn("Cannot execute "+Y+" because there is no active text editor.");return}const yt=await Pt.getDiffInformation(_t.id);ce.apply(Ce,[yt,...at])},void 0,void 0,Ae)),executeCommand(Y,...ce){return ut.executeCommand(Y,...ce)},getCommands(Y=!1){return ut.getCommands(Y)}},vi={get machineId(){return ue.telemetryInfo.machineId},get sessionId(){return ue.telemetryInfo.sessionId},get language(){return ue.environment.appLanguage},get appName(){return ue.environment.appName},get appRoot(){return ue.environment.appRoot?.fsPath??""},get appHost(){return ue.environment.appHost},get uriScheme(){return ue.environment.appUriScheme},get clipboard(){return ki.value},get shell(){return ht.getDefaultShell(!1)},get isTelemetryEnabled(){return ze.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return ze.onDidChangeTelemetryEnabled},get isNewAppInstall(){const Y=Date.now()-new Date(ue.telemetryInfo.firstSessionDate).getTime();return isNaN(Y)?!1:Y<1e3*60*60*24},openExternal(Y,ce){return Me.openUri(Y,{allowTunneling:!!ue.remote.authority,allowContributedOpeners:ce?.allowContributedOpeners})},async asExternalUri(Y){if(Y.scheme===ue.environment.appUriScheme)return xt.createAppUri(Y);try{return await Me.asExternalUri(Y,{allowTunneling:!!ue.remote.authority})}catch(ce){if((0,It.matchesScheme)(Y,kt.Schemas.http)||(0,It.matchesScheme)(Y,kt.Schemas.https))return Y;throw ce}},get remoteName(){return(0,Fe.getRemoteName)(ue.remote.authority)},get remoteAuthority(){return(0,pe.checkProposedApiEnabled)(Ae,"resolvers"),ue.remote.authority},get uiKind(){return ue.uiKind}};ue.environment.extensionTestsLocationURI||Object.freeze(vi);const bi=ue.remote.isRemote?B.ExtensionKind.Workspace:B.ExtensionKind.UI,Pi={createTestController(Y,ce){return Gt.createTestController(Y,ce)},createTestObserver(){return(0,pe.checkProposedApiEnabled)(Ae,"testObserver"),Gt.createTestObserver()},runTests(Y){return(0,pe.checkProposedApiEnabled)(Ae,"testObserver"),Gt.runTests(Y)},get onDidChangeTestResults(){return(0,pe.checkProposedApiEnabled)(Ae,"testObserver"),Gt.onResultsChanged},get testResults(){return(0,pe.checkProposedApiEnabled)(Ae,"testObserver"),Gt.results}},Ti={getExtension(Y){const ce=Ot.getExtensionDescription(Y);if(ce)return new r.Extension($e,Ae.identifier,ce,bi)},get all(){return Ot.getAllExtensionDescriptions().map(Y=>new r.Extension($e,Ae.identifier,Y,bi))},get onDidChange(){return Ot.onDidChange}},Ai={createDiagnosticCollection(Y){return Yt.createDiagnosticCollection(Ae.identifier,Y)},get onDidChangeDiagnostics(){return Yt.onDidChangeDiagnostics},getDiagnostics:Y=>Yt.getDiagnostics(Y),getLanguages(){return Wt.getLanguages()},setTextDocumentLanguage(Y,ce){return Wt.changeLanguage(Y.uri,ce)},match(Y,ce){return(0,F.score)(V.LanguageSelector.from(Y),ce.uri,ce.languageId,!0)},registerCodeActionsProvider(Y,ce,Ce){return gt.registerCodeActionProvider(Ae,ft(Y),ce,Ce)},registerCodeLensProvider(Y,ce){return gt.registerCodeLensProvider(Ae,ft(Y),ce)},registerDefinitionProvider(Y,ce){return gt.registerDefinitionProvider(Ae,ft(Y),ce)},registerDeclarationProvider(Y,ce){return gt.registerDeclarationProvider(Ae,ft(Y),ce)},registerImplementationProvider(Y,ce){return gt.registerImplementationProvider(Ae,ft(Y),ce)},registerTypeDefinitionProvider(Y,ce){return gt.registerTypeDefinitionProvider(Ae,ft(Y),ce)},registerHoverProvider(Y,ce){return gt.registerHoverProvider(Ae,ft(Y),ce,Ae.identifier)},registerEvaluatableExpressionProvider(Y,ce){return gt.registerEvaluatableExpressionProvider(Ae,ft(Y),ce,Ae.identifier)},registerInlineValuesProvider(Y,ce){return gt.registerInlineValuesProvider(Ae,ft(Y),ce,Ae.identifier)},registerDocumentHighlightProvider(Y,ce){return gt.registerDocumentHighlightProvider(Ae,ft(Y),ce)},registerLinkedEditingRangeProvider(Y,ce){return gt.registerLinkedEditingRangeProvider(Ae,ft(Y),ce)},registerReferenceProvider(Y,ce){return gt.registerReferenceProvider(Ae,ft(Y),ce)},registerRenameProvider(Y,ce){return gt.registerRenameProvider(Ae,ft(Y),ce)},registerDocumentSymbolProvider(Y,ce,Ce){return gt.registerDocumentSymbolProvider(Ae,ft(Y),ce,Ce)},registerWorkspaceSymbolProvider(Y){return gt.registerWorkspaceSymbolProvider(Ae,Y)},registerDocumentFormattingEditProvider(Y,ce){return gt.registerDocumentFormattingEditProvider(Ae,ft(Y),ce)},registerDocumentRangeFormattingEditProvider(Y,ce){return gt.registerDocumentRangeFormattingEditProvider(Ae,ft(Y),ce)},registerOnTypeFormattingEditProvider(Y,ce,Ce,...at){return gt.registerOnTypeFormattingEditProvider(Ae,ft(Y),ce,[Ce].concat(at))},registerDocumentSemanticTokensProvider(Y,ce,Ce){return gt.registerDocumentSemanticTokensProvider(Ae,ft(Y),ce,Ce)},registerDocumentRangeSemanticTokensProvider(Y,ce,Ce){return gt.registerDocumentRangeSemanticTokensProvider(Ae,ft(Y),ce,Ce)},registerSignatureHelpProvider(Y,ce,Ce,...at){return typeof Ce=="object"?gt.registerSignatureHelpProvider(Ae,ft(Y),ce,Ce):gt.registerSignatureHelpProvider(Ae,ft(Y),ce,typeof Ce=="undefined"?[]:[Ce,...at])},registerCompletionItemProvider(Y,ce,...Ce){return gt.registerCompletionItemProvider(Ae,ft(Y),ce,Ce)},registerInlineCompletionItemProvider(Y,ce){return(0,pe.checkProposedApiEnabled)(Ae,"inlineCompletions"),gt.registerInlineCompletionsProvider(Ae,ft(Y),ce)},registerDocumentLinkProvider(Y,ce){return gt.registerDocumentLinkProvider(Ae,ft(Y),ce)},registerColorProvider(Y,ce){return gt.registerColorProvider(Ae,ft(Y),ce)},registerFoldingRangeProvider(Y,ce){return gt.registerFoldingRangeProvider(Ae,ft(Y),ce)},registerSelectionRangeProvider(Y,ce){return gt.registerSelectionRangeProvider(Ae,Y,ce)},registerCallHierarchyProvider(Y,ce){return gt.registerCallHierarchyProvider(Ae,Y,ce)},registerTypeHierarchyProvider(Y,ce){return gt.registerTypeHierarchyProvider(Ae,Y,ce)},setLanguageConfiguration:(Y,ce)=>gt.setLanguageConfiguration(Ae,Y,ce),getTokenInformationAtPosition(Y,ce){return(0,pe.checkProposedApiEnabled)(Ae,"tokenInformation"),Wt.tokenAtPosition(Y,ce)},registerInlayHintsProvider(Y,ce){return(0,pe.checkProposedApiEnabled)(Ae,"inlayHints"),gt.registerInlayHintsProvider(Ae,Y,ce)},createLanguageStatusItem(Y,ce){return(0,pe.checkProposedApiEnabled)(Ae,"languageStatus"),Wt.createLanguageStatusItem(Ae,Y,ce)}},Ri={get activeTextEditor(){return Pt.getActiveTextEditor()},get visibleTextEditors(){return Pt.getVisibleTextEditors()},get activeTerminal(){return ht.activeTerminal},get terminals(){return ht.terminals},async showTextDocument(Y,ce,Ce){const at=await(t.URI.isUri(Y)?Promise.resolve(ii.openTextDocument(Y)):Promise.resolve(Y));return Pt.showTextDocument(at,ce,Ce)},createTextEditorDecorationType(Y){return Pt.createTextEditorDecorationType(Ae,Y)},onDidChangeActiveTextEditor(Y,ce,Ce){return Pt.onDidChangeActiveTextEditor(Y,ce,Ce)},onDidChangeVisibleTextEditors(Y,ce,Ce){return Pt.onDidChangeVisibleTextEditors(Y,ce,Ce)},onDidChangeTextEditorSelection(Y,ce,Ce){return Pt.onDidChangeTextEditorSelection(Y,ce,Ce)},onDidChangeTextEditorOptions(Y,ce,Ce){return Pt.onDidChangeTextEditorOptions(Y,ce,Ce)},onDidChangeTextEditorVisibleRanges(Y,ce,Ce){return Pt.onDidChangeTextEditorVisibleRanges(Y,ce,Ce)},onDidChangeTextEditorViewColumn(Y,ce,Ce){return Pt.onDidChangeTextEditorViewColumn(Y,ce,Ce)},onDidCloseTerminal(Y,ce,Ce){return ht.onDidCloseTerminal(Y,ce,Ce)},onDidOpenTerminal(Y,ce,Ce){return ht.onDidOpenTerminal(Y,ce,Ce)},onDidChangeActiveTerminal(Y,ce,Ce){return ht.onDidChangeActiveTerminal(Y,ce,Ce)},onDidChangeTerminalDimensions(Y,ce,Ce){return(0,pe.checkProposedApiEnabled)(Ae,"terminalDimensions"),ht.onDidChangeTerminalDimensions(Y,ce,Ce)},onDidChangeTerminalState(Y,ce,Ce){return ht.onDidChangeTerminalState(Y,ce,Ce)},onDidWriteTerminalData(Y,ce,Ce){return(0,pe.checkProposedApiEnabled)(Ae,"terminalDataWriteEvent"),ht.onDidWriteTerminalData(Y,ce,Ce)},get state(){return Me.state},onDidChangeWindowState(Y,ce,Ce){return Me.onDidChangeWindowState(Y,ce,Ce)},showInformationMessage(Y,...ce){return ui.showMessage(Ae,A.default.Info,Y,ce[0],ce.slice(1))},showWarningMessage(Y,...ce){return ui.showMessage(Ae,A.default.Warning,Y,ce[0],ce.slice(1))},showErrorMessage(Y,...ce){return ui.showMessage(Ae,A.default.Error,Y,ce[0],ce.slice(1))},showQuickPick(Y,ce,Ce){return Array.isArray(Y)&&Y.some(at=>at.kind!==void 0)&&(0,pe.checkProposedApiEnabled)(Ae,"quickPickSeparators"),Vt.showQuickPick(Y,ce,Ce)},showWorkspaceFolderPick(Y){return Vt.showWorkspaceFolderPick(Y)},showInputBox(Y,ce){return Vt.showInput(Y,ce)},showOpenDialog(Y){return ei.showOpenDialog(Y)},showSaveDialog(Y){return ei.showSaveDialog(Y)},createStatusBarItem(Y,ce,Ce){let at,_t,yt;return typeof Y=="string"?(at=Y,_t=ce,yt=Ce):(_t=Y,yt=ce),gi.createStatusBarEntry(Ae,at,_t,yt)},setStatusBarMessage(Y,ce){return gi.setStatusBarMessage(Y,ce)},withScmProgress(Y){return je.report("window.withScmProgress",Ae,"Use 'withProgress' instead."),fi.withProgress(Ae,{location:B.ProgressLocation.SourceControl},(ce,Ce)=>Y({report(at){}}))},withProgress(Y,ce){return fi.withProgress(Ae,Y,ce)},createOutputChannel(Y){return Mt.createOutputChannel(Y,Ae)},createWebviewPanel(Y,ce,Ce,at){return qt.createWebviewPanel(Ae,Y,ce,Ce,at)},createWebviewTextEditorInset(Y,ce,Ce,at){return(0,pe.checkProposedApiEnabled)(Ae,"editorInsets"),ai.createWebviewEditorInset(Y,ce,Ce,at,Ae)},createTerminal(Y,ce,Ce){return typeof Y=="object"?("location"in Y&&(0,pe.checkProposedApiEnabled)(Ae,"terminalLocation"),"pty"in Y?ht.createExtensionTerminal(Y):ht.createTerminalFromOptions(Y)):ht.createTerminal(Y,ce,Ce)},registerTerminalLinkProvider(Y){return ht.registerLinkProvider(Y)},registerTerminalProfileProvider(Y,ce){return ht.registerProfileProvider(Ae,Y,ce)},registerTreeDataProvider(Y,ce){return Qt.registerTreeDataProvider(Y,ce,Ae)},createTreeView(Y,ce){return Qt.createTreeView(Y,ce,Ae)},registerWebviewPanelSerializer:(Y,ce)=>qt.registerWebviewPanelSerializer(Ae,Y,ce),registerCustomEditorProvider:(Y,ce,Ce={})=>yi.registerCustomEditorProvider(Ae,Y,ce,Ce),registerFileDecorationProvider(Y){return Ct.registerFileDecorationProvider(Y,Ae.identifier)},registerUriHandler(Y){return xt.registerUriHandler(Ae.identifier,Y)},createQuickPick(){return Vt.createQuickPick(Ae)},createInputBox(){return Vt.createInputBox(Ae.identifier)},get activeColorTheme(){return mi.activeColorTheme},onDidChangeActiveColorTheme(Y,ce,Ce){return mi.onDidChangeActiveColorTheme(Y,ce,Ce)},registerWebviewViewProvider(Y,ce,Ce){return Si.registerWebviewViewProvider(Ae,Y,ce,Ce?.webviewOptions)},get activeNotebookEditor(){return(0,pe.checkProposedApiEnabled)(Ae,"notebookEditor"),Et.activeNotebookEditor},onDidChangeActiveNotebookEditor(Y,ce,Ce){return(0,pe.checkProposedApiEnabled)(Ae,"notebookEditor"),Et.onDidChangeActiveNotebookEditor(Y,ce,Ce)},get visibleNotebookEditors(){return(0,pe.checkProposedApiEnabled)(Ae,"notebookEditor"),Et.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,pe.checkProposedApiEnabled)(Ae,"notebookEditor"),Et.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(Y,ce,Ce){return(0,pe.checkProposedApiEnabled)(Ae,"notebookEditor"),Ht.onDidChangeNotebookEditorSelection(Y,ce,Ce)},onDidChangeNotebookEditorVisibleRanges(Y,ce,Ce){return(0,pe.checkProposedApiEnabled)(Ae,"notebookEditor"),Ht.onDidChangeNotebookEditorVisibleRanges(Y,ce,Ce)},showNotebookDocument(Y,ce){return(0,pe.checkProposedApiEnabled)(Ae,"notebookEditor"),Et.showNotebookDocument(Y,ce)},registerExternalUriOpener(Y,ce,Ce){return(0,pe.checkProposedApiEnabled)(Ae,"externalUriOpener"),Ci.registerExternalUriOpener(Ae.identifier,Y,ce,Ce)},get tabs(){return(0,pe.checkProposedApiEnabled)(Ae,"tabs"),wt.tabs},get activeTab(){return(0,pe.checkProposedApiEnabled)(Ae,"tabs"),wt.activeTab},get onDidChangeTabs(){return(0,pe.checkProposedApiEnabled)(Ae,"tabs"),wt.onDidChangeTabs},get onDidChangeActiveTab(){return(0,pe.checkProposedApiEnabled)(Ae,"tabs"),wt.onDidChangeActiveTab},getInlineCompletionItemController(Y){return(0,pe.checkProposedApiEnabled)(Ae,"inlineCompletions"),m.InlineCompletionController.get(Y)}},ii={get rootPath(){return je.report("workspace.rootPath",Ae,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),Re.getPath()},set rootPath(Y){throw M.readonly()},getWorkspaceFolder(Y){return Re.getWorkspaceFolder(Y)},get workspaceFolders(){return Re.getWorkspaceFolders()},get name(){return Re.name},set name(Y){throw M.readonly()},get workspaceFile(){return Re.workspaceFile},set workspaceFile(Y){throw M.readonly()},updateWorkspaceFolders:(Y,ce,...Ce)=>Re.updateWorkspaceFolders(Ae,Y,ce||0,...Ce),onDidChangeWorkspaceFolders:function(Y,ce,Ce){return Re.onDidChangeWorkspace(Y,ce,Ce)},asRelativePath:(Y,ce)=>Re.getRelativePath(Y,ce),findFiles:(Y,ce,Ce,at)=>Re.findFiles(V.GlobPattern.from(Y),V.GlobPattern.from(ce),Ce,Ae.identifier,at),findTextInFiles:(Y,ce,Ce,at)=>{(0,pe.checkProposedApiEnabled)(Ae,"findTextInFiles");let _t,yt;return typeof ce=="object"?(_t=ce,yt=Ce):(_t={},yt=ce,at=Ce),Re.findTextInFiles(Y,_t||{},yt,Ae.identifier,at)},saveAll:Y=>Re.saveAll(Y),applyEdit(Y){return Di.applyWorkspaceEdit(Y)},createFileSystemWatcher:(Y,ce,Ce,at)=>Lt.createFileSystemWatcher(V.GlobPattern.from(Y),ce,Ce,at),get textDocuments(){return At.getAllDocumentData().map(Y=>Y.document)},set textDocuments(Y){throw M.readonly()},openTextDocument(Y){let ce;const Ce=Y;if(typeof Y=="string")ce=Promise.resolve(t.URI.file(Y));else if(t.URI.isUri(Y))ce=Promise.resolve(Y);else if(!Ce||typeof Ce=="object")ce=At.createDocumentData(Ce);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ce.then(at=>At.ensureDocumentData(at).then(_t=>_t.document))},onDidOpenTextDocument:(Y,ce,Ce)=>At.onDidAddDocument(Y,ce,Ce),onDidCloseTextDocument:(Y,ce,Ce)=>At.onDidRemoveDocument(Y,ce,Ce),onDidChangeTextDocument:(Y,ce,Ce)=>At.onDidChangeDocument(Y,ce,Ce),onDidSaveTextDocument:(Y,ce,Ce)=>At.onDidSaveDocument(Y,ce,Ce),onWillSaveTextDocument:(Y,ce,Ce)=>zt.getOnWillSaveTextDocumentEvent(Ae)(Y,ce,Ce),get notebookDocuments(){return Et.notebookDocuments.map(Y=>Y.apiNotebook)},async openNotebookDocument(Y,ce){let Ce;if(t.URI.isUri(Y))Ce=Y,await Et.openNotebookDocument(Y);else if(typeof Y=="string")Ce=t.URI.revive(await Et.createNotebookDocument({viewType:Y,content:ce}));else throw new Error("Invalid arguments");return Et.getNotebookDocument(Ce).apiNotebook},get onDidOpenNotebookDocument(){return Et.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return Et.onDidCloseNotebookDocument},registerNotebookSerializer(Y,ce,Ce,at){return Et.registerNotebookSerializer(Ae,Y,ce,Ce,(0,pe.isProposedApiEnabled)(Ae,"notebookLiveShare")?at:void 0)},registerNotebookContentProvider:(Y,ce,Ce,at)=>((0,pe.checkProposedApiEnabled)(Ae,"notebookContentProvider"),Et.registerNotebookContentProvider(Ae,Y,ce,Ce,(0,pe.isProposedApiEnabled)(Ae,"notebookLiveShare")?at:void 0)),onDidChangeConfiguration:(Y,ce,Ce)=>pi.onDidChangeConfiguration(Y,ce,Ce),getConfiguration(Y,ce){return ce=arguments.length===1?void 0:ce,pi.getConfiguration(Y,ce,Ae)},registerTextDocumentContentProvider(Y,ce){return ri.registerTextDocumentContentProvider(Y,ce)},registerTaskProvider:(Y,ce)=>(je.report("window.registerTaskProvider",Ae,"Use the corresponding function on the 'tasks' namespace instead"),Tt.registerTaskProvider(Ae,Y,ce)),registerFileSystemProvider(Y,ce,Ce){return(0,Se.combinedDisposable)(ci.registerFileSystemProvider(Ae,Y,ce,Ce),ke.addFileSystemProvider(Y,ce))},get fs(){return ke.value},registerFileSearchProvider:(Y,ce)=>((0,pe.checkProposedApiEnabled)(Ae,"fileSearchProvider"),Ft.registerFileSearchProvider(Y,ce)),registerTextSearchProvider:(Y,ce)=>((0,pe.checkProposedApiEnabled)(Ae,"textSearchProvider"),Ft.registerTextSearchProvider(Y,ce)),registerRemoteAuthorityResolver:(Y,ce)=>((0,pe.checkProposedApiEnabled)(Ae,"resolvers"),$e.registerRemoteAuthorityResolver(Y,ce)),registerResourceLabelFormatter:Y=>((0,pe.checkProposedApiEnabled)(Ae,"resolvers"),Ei.$registerResourceLabelFormatter(Y)),onDidCreateFiles:(Y,ce,Ce)=>Lt.onDidCreateFile(Y,ce,Ce),onDidDeleteFiles:(Y,ce,Ce)=>Lt.onDidDeleteFile(Y,ce,Ce),onDidRenameFiles:(Y,ce,Ce)=>Lt.onDidRenameFile(Y,ce,Ce),onWillCreateFiles:(Y,ce,Ce)=>Lt.getOnWillCreateFileEvent(Ae)(Y,ce,Ce),onWillDeleteFiles:(Y,ce,Ce)=>Lt.getOnWillDeleteFileEvent(Ae)(Y,ce,Ce),onWillRenameFiles:(Y,ce,Ce)=>Lt.getOnWillRenameFileEvent(Ae)(Y,ce,Ce),openTunnel:Y=>((0,pe.checkProposedApiEnabled)(Ae,"resolvers"),De.openTunnel(Ae,Y).then(ce=>{if(!ce)throw new Error("cannot open tunnel");return ce})),get tunnels(){return(0,pe.checkProposedApiEnabled)(Ae,"resolvers"),De.getTunnels()},onDidChangeTunnels:(Y,ce,Ce)=>((0,pe.checkProposedApiEnabled)(Ae,"resolvers"),De.onDidChangeTunnels(Y,ce,Ce)),registerPortAttributesProvider:(Y,ce)=>((0,pe.checkProposedApiEnabled)(Ae,"portsAttributes"),De.registerPortsAttributesProvider(Y,ce)),registerTimelineProvider:(Y,ce)=>((0,pe.checkProposedApiEnabled)(Ae,"timeline"),_i.registerTimelineProvider(Y,ce,Ae.identifier,ut.converter)),get isTrusted(){return Re.trusted},requestWorkspaceTrust:Y=>((0,pe.checkProposedApiEnabled)(Ae,"workspaceTrust"),Re.requestWorkspaceTrust(Y)),onDidGrantWorkspaceTrust:(Y,ce,Ce)=>Re.onDidGrantWorkspaceTrust(Y,ce,Ce)},Fi={get inputBox(){return je.report("scm.inputBox",Ae,"Use 'SourceControl.inputBox' instead"),Xt.getLastInputBox(Ae)},createSourceControl(Y,ce,Ce){return Xt.createSourceControl(Ae,Y,ce,Ce)}},Mi={createCommentController(Y,ce){return li.createCommentController(Ae,Y,ce)}},Li={get activeDebugSession(){return vt.activeDebugSession},get activeDebugConsole(){return vt.activeDebugConsole},get breakpoints(){return vt.breakpoints},onDidStartDebugSession(Y,ce,Ce){return vt.onDidStartDebugSession(Y,ce,Ce)},onDidTerminateDebugSession(Y,ce,Ce){return vt.onDidTerminateDebugSession(Y,ce,Ce)},onDidChangeActiveDebugSession(Y,ce,Ce){return vt.onDidChangeActiveDebugSession(Y,ce,Ce)},onDidReceiveDebugSessionCustomEvent(Y,ce,Ce){return vt.onDidReceiveDebugSessionCustomEvent(Y,ce,Ce)},onDidChangeBreakpoints(Y,ce,Ce){return vt.onDidChangeBreakpoints(Y,ce,Ce)},registerDebugConfigurationProvider(Y,ce,Ce){return vt.registerDebugConfigurationProvider(Y,ce,Ce||B.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(Y,ce){return vt.registerDebugAdapterDescriptorFactory(Ae,Y,ce)},registerDebugAdapterTrackerFactory(Y,ce){return vt.registerDebugAdapterTrackerFactory(Y,ce)},startDebugging(Y,ce,Ce){return!Ce||typeof Ce=="object"&&"configuration"in Ce?vt.startDebugging(Y,ce,{parentSession:Ce}):vt.startDebugging(Y,ce,Ce||{})},stopDebugging(Y){return vt.stopDebugging(Y)},addBreakpoints(Y){return vt.addBreakpoints(Y)},removeBreakpoints(Y){return vt.removeBreakpoints(Y)},asDebugSourceUri(Y,ce){return vt.asDebugSourceUri(Y,ce)}},Oi={registerTaskProvider:(Y,ce)=>Tt.registerTaskProvider(Ae,Y,ce),fetchTasks:Y=>Tt.fetchTasks(Y),executeTask:Y=>Tt.executeTask(Ae,Y),get taskExecutions(){return Tt.taskExecutions},onDidStartTask:(Y,ce,Ce)=>Tt.onDidStartTask(Y,ce,Ce),onDidEndTask:(Y,ce,Ce)=>Tt.onDidEndTask(Y,ce,Ce),onDidStartTaskProcess:(Y,ce,Ce)=>Tt.onDidStartTaskProcess(Y,ce,Ce),onDidEndTaskProcess:(Y,ce,Ce)=>Tt.onDidEndTaskProcess(Y,ce,Ce)},Ni={createNotebookController(Y,ce,Ce,at,_t){return oi.createNotebookController(Ae,Y,ce,Ce,at,(0,pe.isProposedApiEnabled)(Ae,"notebookMessaging")?_t:void 0)},registerNotebookCellStatusBarItemProvider:(Y,ce)=>Et.registerNotebookCellStatusBarItemProvider(Ae,Y,ce),get onDidSaveNotebookDocument(){return(0,pe.checkProposedApiEnabled)(Ae,"notebookEditor"),Kt.onDidSaveNotebookDocument},createNotebookEditorDecorationType(Y){return(0,pe.checkProposedApiEnabled)(Ae,"notebookEditorDecorationType"),Ht.createNotebookEditorDecorationType(Y)},createRendererMessaging(Y){return si.createRendererMessaging(Ae,Y)},onDidChangeNotebookDocumentMetadata(Y,ce,Ce){return(0,pe.checkProposedApiEnabled)(Ae,"notebookEditor"),Kt.onDidChangeNotebookDocumentMetadata(Y,ce,Ce)},onDidChangeNotebookCells(Y,ce,Ce){return(0,pe.checkProposedApiEnabled)(Ae,"notebookEditor"),Et.onDidChangeNotebookCells(Y,ce,Ce)},onDidChangeNotebookCellExecutionState(Y,ce,Ce){return(0,pe.checkProposedApiEnabled)(Ae,"notebookCellExecutionState"),Et.onDidChangeNotebookCellExecutionState(Y,ce,Ce)},onDidChangeCellOutputs(Y,ce,Ce){return(0,pe.checkProposedApiEnabled)(Ae,"notebookEditor"),Et.onDidChangeCellOutputs(Y,ce,Ce)},onDidChangeCellMetadata(Y,ce,Ce){return(0,pe.checkProposedApiEnabled)(Ae,"notebookEditor"),Et.onDidChangeCellMetadata(Y,ce,Ce)},createConcatTextDocument(Y,ce){return(0,pe.checkProposedApiEnabled)(Ae,"notebookConcatTextDocument"),new Oe.ExtHostNotebookConcatDocument(Et,At,Y,ce)}};return{version:ue.version,authentication:ti,commands:Ii,comments:Mi,debug:Li,env:vi,extensions:Ti,languages:Ai,notebooks:Ni,scm:Fi,tasks:Oi,tests:Pi,window:Ri,workspace:ii,Breakpoint:B.Breakpoint,CallHierarchyIncomingCall:B.CallHierarchyIncomingCall,CallHierarchyItem:B.CallHierarchyItem,CallHierarchyOutgoingCall:B.CallHierarchyOutgoingCall,CancellationError:M.CancellationError,CancellationTokenSource:u.CancellationTokenSource,CandidatePortSource:n.CandidatePortSource,CodeAction:B.CodeAction,CodeActionKind:B.CodeActionKind,CodeActionTriggerKind:B.CodeActionTriggerKind,CodeLens:B.CodeLens,Color:B.Color,ColorInformation:B.ColorInformation,ColorPresentation:B.ColorPresentation,ColorThemeKind:B.ColorThemeKind,CommentMode:B.CommentMode,CommentThreadCollapsibleState:B.CommentThreadCollapsibleState,CompletionItem:B.CompletionItem,CompletionItemKind:B.CompletionItemKind,CompletionItemTag:B.CompletionItemTag,CompletionList:B.CompletionList,CompletionTriggerKind:B.CompletionTriggerKind,ConfigurationTarget:B.ConfigurationTarget,CustomExecution:B.CustomExecution,DebugAdapterExecutable:B.DebugAdapterExecutable,DebugAdapterInlineImplementation:B.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:B.DebugAdapterNamedPipeServer,DebugAdapterServer:B.DebugAdapterServer,DebugConfigurationProviderTriggerKind:B.DebugConfigurationProviderTriggerKind,DebugConsoleMode:B.DebugConsoleMode,DecorationRangeBehavior:B.DecorationRangeBehavior,Diagnostic:B.Diagnostic,DiagnosticRelatedInformation:B.DiagnosticRelatedInformation,DiagnosticSeverity:B.DiagnosticSeverity,DiagnosticTag:B.DiagnosticTag,Disposable:B.Disposable,DocumentHighlight:B.DocumentHighlight,DocumentHighlightKind:B.DocumentHighlightKind,DocumentLink:B.DocumentLink,DocumentSymbol:B.DocumentSymbol,EndOfLine:B.EndOfLine,EnvironmentVariableMutatorType:B.EnvironmentVariableMutatorType,EvaluatableExpression:B.EvaluatableExpression,InlineValueText:B.InlineValueText,InlineValueVariableLookup:B.InlineValueVariableLookup,InlineValueEvaluatableExpression:B.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:B.InlineCompletionTriggerKind,EventEmitter:w.Emitter,ExtensionKind:B.ExtensionKind,ExtensionMode:B.ExtensionMode,ExternalUriOpenerPriority:B.ExternalUriOpenerPriority,FileChangeType:B.FileChangeType,FileDecoration:B.FileDecoration,FileSystemError:B.FileSystemError,FileType:_.FileType,FilePermission:_.FilePermission,FoldingRange:B.FoldingRange,FoldingRangeKind:B.FoldingRangeKind,FunctionBreakpoint:B.FunctionBreakpoint,InlineCompletionItem:B.InlineSuggestion,InlineCompletionList:B.InlineSuggestions,Hover:B.Hover,IndentAction:k.IndentAction,Location:B.Location,MarkdownString:B.MarkdownString,OverviewRulerLane:C.OverviewRulerLane,ParameterInformation:B.ParameterInformation,PortAutoForwardAction:B.PortAutoForwardAction,Position:B.Position,ProcessExecution:B.ProcessExecution,ProgressLocation:B.ProgressLocation,QuickInputButtons:B.QuickInputButtons,Range:B.Range,RelativePattern:B.RelativePattern,Selection:B.Selection,SelectionRange:B.SelectionRange,SemanticTokens:B.SemanticTokens,SemanticTokensBuilder:B.SemanticTokensBuilder,SemanticTokensEdit:B.SemanticTokensEdit,SemanticTokensEdits:B.SemanticTokensEdits,SemanticTokensLegend:B.SemanticTokensLegend,ShellExecution:B.ShellExecution,ShellQuoting:B.ShellQuoting,SignatureHelp:B.SignatureHelp,SignatureHelpTriggerKind:B.SignatureHelpTriggerKind,SignatureInformation:B.SignatureInformation,SnippetString:B.SnippetString,SourceBreakpoint:B.SourceBreakpoint,StandardTokenType:B.StandardTokenType,StatusBarAlignment:B.StatusBarAlignment,SymbolInformation:B.SymbolInformation,SymbolKind:B.SymbolKind,SymbolTag:B.SymbolTag,Task:B.Task,TaskGroup:B.TaskGroup,TaskPanelKind:B.TaskPanelKind,TaskRevealKind:B.TaskRevealKind,TaskScope:B.TaskScope,TerminalLink:B.TerminalLink,TerminalLocation:B.TerminalLocation,TerminalProfile:B.TerminalProfile,TextDocumentSaveReason:B.TextDocumentSaveReason,TextEdit:B.TextEdit,TextEditorCursorStyle:T.TextEditorCursorStyle,TextEditorLineNumbersStyle:B.TextEditorLineNumbersStyle,TextEditorRevealType:B.TextEditorRevealType,TextEditorSelectionChangeKind:B.TextEditorSelectionChangeKind,TextDocumentChangeReason:B.TextDocumentChangeReason,ThemeColor:B.ThemeColor,ThemeIcon:B.ThemeIcon,TreeItem:B.TreeItem,TreeItemCollapsibleState:B.TreeItemCollapsibleState,TypeHierarchyItem:B.TypeHierarchyItem,UIKind:n.UIKind,Uri:t.URI,ViewColumn:B.ViewColumn,WorkspaceEdit:B.WorkspaceEdit,InlayHint:B.InlayHint,InlayHintKind:B.InlayHintKind,RemoteAuthorityResolverError:B.RemoteAuthorityResolverError,ResolvedAuthority:B.ResolvedAuthority,SourceControlInputBoxValidationType:B.SourceControlInputBoxValidationType,ExtensionRuntime:B.ExtensionRuntime,TimelineItem:B.TimelineItem,NotebookRange:B.NotebookRange,NotebookCellKind:B.NotebookCellKind,NotebookCellExecutionState:B.NotebookCellExecutionState,NotebookCellData:B.NotebookCellData,NotebookData:B.NotebookData,NotebookRendererScript:B.NotebookRendererScript,NotebookCellStatusBarAlignment:B.NotebookCellStatusBarAlignment,NotebookEditorRevealType:B.NotebookEditorRevealType,NotebookCellOutput:B.NotebookCellOutput,NotebookCellOutputItem:B.NotebookCellOutputItem,NotebookCellStatusBarItem:B.NotebookCellStatusBarItem,NotebookControllerAffinity:B.NotebookControllerAffinity,PortAttributes:B.PortAttributes,LinkedEditingRanges:B.LinkedEditingRanges,TestResultState:B.TestResultState,TestRunRequest:B.TestRunRequest,TestMessage:B.TestMessage,TestTag:B.TestTag,TestRunProfileKind:B.TestRunProfileKind,TextSearchCompleteMessageType:lt.TextSearchCompleteMessageType,TreeDataTransfer:B.TreeDataTransfer,TreeDataTransferItem:B.TreeDataTransferItem,CoveredCount:B.CoveredCount,FileCoverage:B.FileCoverage,StatementCoverage:B.StatementCoverage,BranchCoverage:B.BranchCoverage,FunctionCoverage:B.FunctionCoverage,WorkspaceTrustState:B.WorkspaceTrustState,LanguageStatusSeverity:B.LanguageStatusSeverity,QuickPickItemKind:B.QuickPickItemKind}}}e.createApiFactoryAndRegisterActors=oe}),define(we[224],Ee([0,1,57,95,32,94,33,38,49,39,98,99,100,72,65,70,96,50,31,69,86,71,196,12,179]),function(re,e,u,M,w,A,t,T,C,k,F,_,n,g,a,c,p,D,f,l,h,y,s,I,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,u.registerSingleton)(I.ILoggerService,s.ExtHostLoggerService),(0,u.registerSingleton)(I.ILogService,r.ExtHostLogService),(0,u.registerSingleton)(c.IExtHostApiDeprecationService,c.ExtHostApiDeprecationService),(0,u.registerSingleton)(T.IExtHostCommands,T.ExtHostCommands),(0,u.registerSingleton)(t.IExtHostConfiguration,t.ExtHostConfiguration),(0,u.registerSingleton)(D.IExtHostConsumerFileSystem,D.ExtHostConsumerFileSystem),(0,u.registerSingleton)(_.IExtHostDebugService,_.WorkerExtHostDebugService),(0,u.registerSingleton)(A.IExtHostDecorations,A.ExtHostDecorations),(0,u.registerSingleton)(C.IExtHostDocumentsAndEditors,C.ExtHostDocumentsAndEditors),(0,u.registerSingleton)(f.IExtHostFileSystemInfo,f.ExtHostFileSystemInfo),(0,u.registerSingleton)(M.IExtHostOutputService,M.ExtHostOutputService),(0,u.registerSingleton)(n.IExtHostSearch,n.ExtHostSearch),(0,u.registerSingleton)(g.IExtHostStorage,g.ExtHostStorage),(0,u.registerSingleton)(F.IExtHostTask,F.WorkerExtHostTask),(0,u.registerSingleton)(k.IExtHostTerminalService,k.WorkerExtHostTerminalService),(0,u.registerSingleton)(a.IExtHostTunnelService,a.ExtHostTunnelService),(0,u.registerSingleton)(p.IExtHostWindow,p.ExtHostWindow),(0,u.registerSingleton)(w.IExtHostWorkspace,w.ExtHostWorkspace),(0,u.registerSingleton)(l.IExtHostSecretState,l.ExtHostSecretState),(0,u.registerSingleton)(h.IExtHostTelemetry,h.ExtHostTelemetry),(0,u.registerSingleton)(y.IExtHostEditorTabs,y.ExtHostEditorTabs)}),define(we[225],Ee([0,1,223,34,219,7,14,5,11]),function(re,e,u,M,w,A,t,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;var k;(function(a){const c=self.trustedTypes?.createPolicy("TrustedFunctionWorkaround",{createScript:(D,...f)=>{f.forEach(s=>{if(!self.trustedTypes?.isScript(s))throw new Error("TrustedScripts only, please")});const l=f.slice(0,-1).join(","),h=f.pop().toString();return`(function anonymous(${l}) {${h}
})`}});function p(...D){return c?self.eval(c.createScript("",...D)):new Function(...D)}a.create=p})(k||(k={}));class F extends w.RequireInterceptor{_installInterceptor(){}getModule(c,p){for(let D of this._alternatives){let f=D(c);if(f){c=f;break}}if(this._factories.has(c))return this._factories.get(c).load(c,p,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class _ extends M.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=A.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){const c=this._extHostContext.getProxy(T.MainContext.MainThreadConsole);g(c,this._initData.environment.isExtensionDevelopmentDebug);const p=this._instaService.invokeFunction(u.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(F,p,this._registry),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(c){return c.browser}async _loadCommonJSModule(c,p,D){p=p.with({path:n(p.path,".js")}),c&&performance.mark(`code/extHost/willFetchExtensionCode/${c.value}`);const f=await fetch(C.FileAccess.asBrowserUri(p).toString(!0));if(c&&performance.mark(`code/extHost/didFetchExtensionCode/${c.value}`),f.status!==200)throw new Error(f.statusText);const l=await f.text(),h=`${p.toString(!0)}#vscode-extension`,y=`${l}
//# sourceURL=${h}`;let s;try{s=k.create(_._ttpExtensionScripts?.createScript("module")??"module",_._ttpExtensionScripts?.createScript("exports")??"exports",_._ttpExtensionScripts?.createScript("require")??"require",_._ttpExtensionScripts?.createScript(y)??y)}catch(v){throw console.error(c?`Loading code for extension ${c.value} failed: ${v.message}`:`Loading code failed: ${v.message}`),console.error(`${p.toString(!0)}${typeof v.line=="number"?` line ${v.line}`:""}${typeof v.column=="number"?` column ${v.column}`:""}`),console.error(v),v}const I={},r={exports:I},i=v=>{const m=this._fakeModules.getModule(v,p);if(m===void 0)throw new Error(`Cannot load module '${v}'`);return m};try{return D.codeLoadingStart(),c&&performance.mark(`code/extHost/willLoadExtensionCode/${c.value}`),s(r,I,i),r.exports!==I?r.exports:I}finally{c&&performance.mark(`code/extHost/didLoadExtensionCode/${c.value}`),D.codeLoadingStop()}}async $setRemoteEnvironment(c){}async _waitForDebuggerAttachment(c=5e3){if(!this._initData.environment.isExtensionDevelopmentDebug)return;const p=Date.now()+c;for(;Date.now()<p&&!("__jsDebugIsReady"in globalThis);)await(0,t.timeout)(10)}}e.ExtHostExtensionService=_,_._ttpExtensionScripts=self.trustedTypes?.createPolicy("ExtensionScripts",{createScript:a=>a});function n(a,c){return a.endsWith(c)?a:a+c}function g(a,c){p("info","log"),p("log","log"),p("warn","warn"),p("error","error");function p(l,h){const y=console[l];console[l]=function(){a.$logExtensionHostMessage({type:"__$console",severity:h,arguments:f(arguments)}),c&&y.apply(console,arguments)}}const D=1e5;function f(l){const h=[],y=[];if(l.length)for(let s=0;s<l.length;s++){if(typeof l[s]=="undefined")l[s]="undefined";else if(l[s]instanceof Error){const I=l[s];I.stack?l[s]=I.stack:l[s]=I.toString()}y.push(l[s])}try{const s=JSON.stringify(y,function(I,r){if(r&&typeof r=="object"){if(h.indexOf(r)!==-1)return"[Circular]";h.push(r)}return r});return s.length>D?"Output omitted for a large object that exceeds the limits":s}catch(s){return`Output omitted for an object that cannot be inspected ('${s.toString()}')`}}}}),define(we[226],Ee([0,1,57,34,73,225]),function(re,e,u,M,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,u.registerSingleton)(M.IExtHostExtensionService,A.ExtHostExtensionService),(0,u.registerSingleton)(w.IExtensionStoragePaths,w.ExtensionStoragePaths)}),define(we[235],Ee([0,1,22,3,177,220,214,17,74,11,2,224,226]),function(re,e,u,M,w,A,t,T,C,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const _=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const n=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");const g=fetch.bind(self);if(self.fetch=function(l,h){return l instanceof Request||/^file:/i.test(String(l))&&(l=k.FileAccess.asBrowserUri(F.URI.parse(String(l))).toString(!0)),g(l,h)},self.XMLHttpRequest=class extends XMLHttpRequest{open(l,h,y,s,I){return/^file:/i.test(h.toString())&&(h=k.FileAccess.asBrowserUri(F.URI.parse(h.toString())).toString(!0)),super.open(l,h,y??!0,s,I)}},self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const l=self.trustedTypes?.createPolicy("extensionHostWorker",{createScriptURL:y=>y}),h=self.Worker;Worker=function(y,s){/^file:/i.test(y.toString())&&(y=k.FileAccess.asBrowserUri(F.URI.parse(y.toString())).toString(!0));const r=`(${function(o){function b(P){return typeof P=="string"||P instanceof URL?String(P).replace(/^file:\/\//i,"vscode-file://vscode-app"):P}const d=fetch.bind(self);self.fetch=function(P,z){return P instanceof Request?d(P,z):d(b(P),z)},self.XMLHttpRequest=class extends XMLHttpRequest{open(P,z,O,S,x){return super.open(P,b(z),O??!0,S,x)}};const E=importScripts.bind(self);self.importScripts=(...P)=>{E(...P.map(b))};const R=self.trustedTypes?self.trustedTypes.createPolicy("extensionHostWorker",{createScriptURL:P=>P}):void 0;E(R?R.createScriptURL(o):o)}.toString()}('${y}'))`;s=s||{},s.name=s.name||T.basename(y.toString());const i=new Blob([r],{type:"application/javascript"}),v=URL.createObjectURL(i);return new h(l?l.createScriptURL(v):v,s)}}else self.Worker=class extends t.NestedWorker{constructor(l,h){super(n,l,{name:T.basename(l.toString()),...h})}};const a=new class{constructor(){this.pid=void 0}exit(l){_()}async exists(l){return!0}async realpath(l){return l}};class c{constructor(){const h=new MessageChannel,y=new M.Emitter;let s=!1;n(h.port2,[h.port2]),h.port1.onmessage=I=>{const{data:r}=I;if(!(r instanceof ArrayBuffer)){console.warn("UNKNOWN data received",r);return}const i=u.VSBuffer.wrap(new Uint8Array(r,0,r.byteLength));if((0,w.isMessageOfType)(i,2)){s=!0,D("received terminate message from renderer");return}y.fire(i)},this.protocol={onMessage:y.event,send:I=>{if(!s){const r=I.buffer.buffer.slice(I.buffer.byteOffset,I.buffer.byteOffset+I.buffer.byteLength);h.port1.postMessage(r,[r])}}}}}function p(l){return new Promise(h=>{const y=l.onMessage(s=>{y.dispose();const I=JSON.parse(s.toString());l.send((0,w.createMessageOfType)(0)),h({protocol:l,initData:I})});l.send((0,w.createMessageOfType)(1))})}let D=l=>_();function f(){const l=new c;C.mark("code/extHost/willConnectToRenderer"),p(l.protocol).then(h=>{C.mark("code/extHost/didWaitForInitData");const y=new A.ExtensionHostMain(h.protocol,h.initData,a,null);D=s=>y.terminate(s)})}e.create=f})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/4e303fcc52269ab578affa6cb1eb455eacab445f/core/vs/workbench/services/extensions/worker/extensionHostWorker.js.map
